(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@0) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@0))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $DiemConfig_DisableReconfiguration_$memory () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$DiemConfig_DisableReconfiguration_pack$0$$struct@1 () T@$Value)
(declare-fun dr_account () T@$Value)
(declare-fun inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t8@1 () T@$Value)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_code@4 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t9@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 98637) (let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon37_Else_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon37_Then_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon36_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 71037) 71053) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 71037) 71043) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon40_Else_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon40_Then_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon39_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 71013) 71029) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 71013) 71019) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon44_Else_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon44_Then_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon43_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 70993) 71009) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 70993) 70999) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon47_Else_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon47_Then_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon46_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 70969) 70985) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 70969) 70975) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon51_Else_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon51_Then_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon50_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 70949) 70965) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 70949) 70955) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon50_Else_correct true))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@5 true) (and (=> (= (ControlFlow 0 70923) 70949) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 70923) 70945) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 70921) 70923)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$DiemConfig_DisableReconfiguration_pack$0$$struct@1))) (= $abort_flag@5 $abort_flag@4)) (and (=> (= (ControlFlow 0 70871) 70949) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 70871) 70945) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon50_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 70929) 70921) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 70929) 70871) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 70717) (- 0 100324)) true) (=> (= (ControlFlow 0 70717) 70929) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$DiemConfig_DisableReconfiguration_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 70603) 70717)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemConfig_DisableReconfiguration_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 70609) 70717) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemConfig_DisableReconfiguration_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 70597) 70609) inline$$DiemConfig_DisableReconfiguration_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 70597) 70603) inline$$DiemConfig_DisableReconfiguration_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemConfig_DisableReconfiguration_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 70589) 70717)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemConfig_DisableReconfiguration_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t14@1) (= inline$$DiemConfig_DisableReconfiguration_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t14@1) 1)))) (and (=> (= (ControlFlow 0 70581) 70597) inline$$DiemConfig_DisableReconfiguration_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 70581) 70589) inline$$DiemConfig_DisableReconfiguration_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon48_Then_correct  (=> (|b#$Boolean| inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2) (=> (and (= inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t14@1 ($Boolean false)) (= (ControlFlow 0 70615) 70581)) inline$$DiemConfig_DisableReconfiguration_pack$0$anon0_correct))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon49_Else_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon49_Then_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon48_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2)) (= $abort_code@6 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 70431) 70447) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 70431) 70437) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon46_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 70419) 70615) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 70419) 70431) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon45_Else_correct  (=> (not $abort_flag@3) (=> (and (and (and (= inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 70413) 70969) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 70413) 70419) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon46_Else_correct))))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon45_Then_correct true))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon4_correct  (=> (and (= $abort_flag@3 $abort_flag@2) (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2 inline$$Not$0$dst@1)) (and (=> (= (ControlFlow 0 70371) 70989) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 70371) 70413) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 70369) 70371)) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon4_correct)))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 70379) 70371) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon4_correct)))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemConfig_reconfiguration_enabled_$def$0$$t1@1)))) (and (=> (= (ControlFlow 0 70353) 70379) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 70353) 70369) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 70343) (- 0 100075)) true) (=> (= (ControlFlow 0 70343) 70353) inline$$Not$0$anon0_correct))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Else_correct  (=> (not $abort_flag@2) (=> (and (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1)))) (= (ControlFlow 0 70359) 70343)) inline$$Not$0$Entry_correct))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Then_correct  (=> (and (and $abort_flag@2 (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@1 $Error)) (and (= $abort_flag@3 true) (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2 inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 70387) 70989) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 70387) 70413) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 70271) 70387) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 70271) 70359) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 70281) 70387) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 70281) 70359) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@2) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 70265) 70281) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 70265) 70271) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon0_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 70295) 70265)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon43_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 70401) 70295)) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon0_correct)))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon41_Then_correct  (=> (|b#$Boolean| inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t8@1) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@2)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@2)) (and (=> $abort_flag@2 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@2 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@3 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@3 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 70030) 70993) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 70030) 70401) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon43_Else_correct)))))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon42_Else_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon42_Then_correct true))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t8@1)) (= $abort_code@4 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 70004) 70024) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 70004) 70010) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon39_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 69992) 70030) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 69992) 70004) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon38_Else_correct  (=> (and (not $abort_flag@0) (= inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t8@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)))) (=> (and (and (and (= inline$$DiemConfig_disable_reconfiguration_$def_verify$0$$t9@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 2))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 69986) 71013) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 69986) 69992) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon38_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 69942) 71033) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 69942) 69986) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 69952) 71033) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 69952) 69986) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon38_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@0) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 69936) 69952) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 69936) 69942) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 69966) 69936)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 69831) 71037) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 69831) 69966) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 69795) 69831)) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 71061) 69831) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 69789) 71061) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 69789) 69795) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon35_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (= (ControlFlow 0 71065) 69789)) inline$$DiemConfig_disable_reconfiguration_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 69214) 71065)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 98637) 69214) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$Event_emit_event$0$t@0 () T@$TypeValue)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$DiemConfig_NewEpochEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun |inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$tmp#$5@2| () T@$Value)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t17@1 () T@$Value)
(declare-fun |inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$tmp#$5@1| () T@$Value)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0 () T@$Value)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(declare-fun inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 100492) (let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon41_Else_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon41_Then_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon40_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 74755) 74771) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 74755) 74761) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon46_Else_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon46_Then_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon45_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 74731) 74747) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 74731) 74737) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon51_Else_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon51_Then_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon50_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 74463) 74479) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 74463) 74469) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon56_Else_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon56_Then_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon55_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 74433) 74449) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 74433) 74439) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon38$2_correct  (=> (= (ControlFlow 0 74419) (- 0 102571)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $DiemConfig_Configuration_$memory) (= (ControlFlow 0 74339) 74419)) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon38$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $DiemConfig_Configuration_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 74393) 74419))) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon38$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (and (=> (= (ControlFlow 0 74329) 74393) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 74329) 74339) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$0$dst'@2|) (= (ControlFlow 0 74151) 74329)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 74207) 74329))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (and (=> (= (ControlFlow 0 74115) 74207) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 74115) 74151) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 73978) 74115)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon57_Then_correct  (=> (and (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 74429) 74115)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1) (|p#$Mutation| inline$$BorrowField$2$dst@1) inline$$ReadRef$2$v@1)) (and (=> (= (ControlFlow 0 73964) 74429) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 73964) 73978) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon55_Else_correct  (=> (and (not $abort_flag@2@@0) (= (ControlFlow 0 73970) 73964)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$Event_emit_event$0$Entry_correct  (=> (= inline$$Event_emit_event$0$t@0 $DiemConfig_NewEpochEvent_type_value) (and (=> (= (ControlFlow 0 73895) 74433) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 73895) 73970) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon32$5_correct  (and (=> (= (ControlFlow 0 73905) (- 0 102275)) true) (=> (= (ControlFlow 0 73905) 73895) inline$$Event_emit_event$0$Entry_correct))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 73847) 73905)) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon32$5_correct)))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 73803) 73847)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 73809) 73847) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 73797) 73809) inline$$DiemConfig_NewEpochEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 73797) 73803) inline$$DiemConfig_NewEpochEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 73789) 73847)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$ReadRef$1$v@1) (>= (|i#$Integer| inline$$ReadRef$1$v@1) 0)) (<= (|i#$Integer| inline$$ReadRef$1$v@1) $MAX_U64)) (= inline$$DiemConfig_NewEpochEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$ReadRef$1$v@1) 1)))) (and (=> (= (ControlFlow 0 73781) 73797) inline$$DiemConfig_NewEpochEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 73781) 73789) inline$$DiemConfig_NewEpochEvent_pack$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$3$dst@1)) (= (ControlFlow 0 73641) 73781)) inline$$DiemConfig_NewEpochEvent_pack$0$anon0_correct)))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $DiemConfig_Configuration_epoch) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) $DiemConfig_Configuration_epoch))) (= (ControlFlow 0 73603) 73641))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $DiemConfig_Configuration_events) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) $DiemConfig_Configuration_events))) (= (ControlFlow 0 73443) 73603))) inline$$BorrowField$3$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 73263) 73443)) inline$$BorrowField$2$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 73319) 73443))) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 73227) 73319) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 73227) 73263) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 73090) 73227)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon54_Then_correct  (=> (and (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 74459) 73227)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t19@1)) (and (=> (= (ControlFlow 0 73076) 74459) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 73076) 73090) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $DiemConfig_Configuration_epoch) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemConfig_Configuration_epoch))) (= (ControlFlow 0 73017) 73076))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon52_Then_correct  (=> (|b#$Boolean| |inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$tmp#$5@2|) (=> (and (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t19@1 ($Integer 1)) (= (ControlFlow 0 73023) 73017)) inline$$BorrowField$1$anon0_correct))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon53_Else_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon53_Then_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon52_Else_correct  (=> (and (not (|b#$Boolean| |inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$tmp#$5@2|)) (= $abort_code@4@@0 (|i#$Integer| call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 72875) 72891) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 72875) 72881) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon50_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 72863) 73023) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 72863) 72875) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$L5_correct  (=> (and (and (and (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t17@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@0)) (and (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 72857) 74463) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 72857) 72863) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon20_correct  (=> (and (= |inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$tmp#$5@2| |inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$tmp#$5@1|) (= (ControlFlow 0 74719) 72857)) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$L5_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 74717) 74719)) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon20_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 74727) 74719) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon20_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon47_Then$1_correct  (=> (and (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t15@1 ($Integer 0)) (= |inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$tmp#$5@1| ($Boolean ($IsEqual_stratified inline$$ReadRef$3$v@1 inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t15@1)))) (and (=> (= (ControlFlow 0 74711) 74727) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 74711) 74717) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$4$dst@1)) (= (ControlFlow 0 74683) 74711)) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon47_Then$1_correct)))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $DiemConfig_Configuration_last_reconfiguration_time) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemConfig_Configuration_last_reconfiguration_time))) (= (ControlFlow 0 74645) 74683))) inline$$ReadRef$3$anon0_correct))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon47_Then_correct  (=> (and (|b#$Boolean| inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t13@1) (= (ControlFlow 0 74697) 74645)) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon22_correct  (=> (and (= |inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$tmp#$5@2| inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t16@1) (= (ControlFlow 0 72851) 72857)) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$L5_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 72849) 72851)) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon22_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 74487) 72851) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon22_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon47_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t13@1)) (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t16@1 ($Boolean false))) (and (=> (= (ControlFlow 0 72841) 74487) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 72841) 72849) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon45_Else$1_correct  (=> (and (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t12@1 ($Integer 0)) (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t13@1 ($Boolean ($IsEqual_stratified inline$$ReadRef$0$v@1 inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t12@1)))) (and (=> (= (ControlFlow 0 72797) 74697) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 72797) 72841) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 72769) 72797)) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon45_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemConfig_Configuration_epoch) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemConfig_Configuration_epoch))) (= (ControlFlow 0 72731) 72769))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon45_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 72783) 72731)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@0 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 72565) 74731) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 72565) 72783) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 72563) 72565)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)))) (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 72511) 74731) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 72511) 72783) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0)) (and (=> (= (ControlFlow 0 72481) 72563) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 72481) 72511) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 72475) (- 0 101299)) true) (=> (= (ControlFlow 0 72475) 72481) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon44_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 72571) 72475)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon44_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 72344) 74751) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 72344) 72571) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 72354) 74751) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 72354) 72571) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon44_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@0  (=> (and (not $abort_flag@0@@0) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 72338) 72354) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 72338) 72344) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@0)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon42_Then_correct  (=> (and (|b#$Boolean| inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t7@1) (= (ControlFlow 0 72368) 72338)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@0)))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon43_Else_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon43_Then_correct true))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon42_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t7@1)) (= $abort_code@2 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 72213) 72233) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 72213) 72219) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon40_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 72201) 72368) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 72201) 72213) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon39_Else_correct  (=> (and (not false) (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0))))) (=> (and (and (and (= inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0)) (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 72195) 74755) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 72195) 72201) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon39_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 72151) 74775) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 72151) 72195) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 72161) 74775) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 72161) 72195) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon39_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 72145) 72161) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 72145) 72151) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 72175) 72145)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0)))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@12 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 74779) 72175)) inline$$DiemConfig_emit_genesis_reconfiguration_event_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (= (ControlFlow 0 100492) 74779) anon0$1_correct@@0)))
anon0_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_flag@6 () Bool)
(declare-fun inline$$MoveFrom$0$dst@2 () T@$Value)
(declare-fun inline$$MoveFrom$0$dst@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$a@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1| () T@$Memory)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun dr_account@@0 () T@$Value)
(declare-fun $abort_code@7 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$DiemConfig_enable_reconfiguration_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def$0$$t1@1@@0 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@1 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun inline$$DiemConfig_enable_reconfiguration_$def_verify$0$$t8@1 () T@$Value)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1 () T@$Value)
(declare-fun inline$$DiemConfig_enable_reconfiguration_$def_verify$0$$t9@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 102641) (let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon41_Else_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon41_Then_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon40_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 77080) 77096) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 77080) 77086) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon44_Else_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon44_Then_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon43_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 77056) 77072) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 77056) 77062) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon48_Else_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon48_Then_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon47_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 77036) 77052) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 77036) 77042) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon51_Else_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon51_Then_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon50_Then_correct  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 77012) 77028) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 77012) 77018) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon55_Else_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon55_Then_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon54_Then_correct  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 76992) 77008) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 76992) 76998) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon57_Else_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon57_Then_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon56_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 76972) 76988) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 76972) 76978) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DiemConfig_DisableReconfiguration_unpack$0$anon0_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon56_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 76966) 76960)) inline$$DiemConfig_DisableReconfiguration_unpack$0$anon0_correct)))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct  (=> (and (= $abort_flag@6 true) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@0)) (and (=> (= (ControlFlow 0 76894) 76972) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 76894) 76966) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1)) (= (ControlFlow 0 76892) 76894)) inline$$MoveFrom$0$anon3_Then$1_correct)))
(let ((inline$$MoveFrom$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1) (=> (and (and (= inline$$MoveFrom$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1)) (= |inline$$MoveFrom$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray inline$$MoveFrom$0$a@1 $Error)))) (and (= $abort_flag@6 $abort_flag@5@@0) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@1))) (and (=> (= (ControlFlow 0 76840) 76972) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 76840) 76966) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon56_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct  (=> (= inline$$MoveFrom$0$a@1 (|a#$Address| call3formal@$ret0@0@@4)) (and (=> (= (ControlFlow 0 76794) 76892) inline$$MoveFrom$0$anon3_Then_correct) (=> (= (ControlFlow 0 76794) 76840) inline$$MoveFrom$0$anon3_Else_correct)))))
(let ((inline$$MoveFrom$0$Entry_correct  (and (=> (= (ControlFlow 0 76788) (- 0 104380)) true) (=> (= (ControlFlow 0 76788) 76794) inline$$MoveFrom$0$anon0_correct))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon54_Else_correct  (=> (and (not $abort_flag@5@@0) (= (ControlFlow 0 76902) 76788)) inline$$MoveFrom$0$Entry_correct)))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon52_Then_correct  (=> (|b#$Boolean| inline$$Not$1$dst@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@0) (=> $abort_flag@5@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 dr_account@@0)))) ((_ is $Address) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 76664) 76992) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 76664) 76902) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon54_Else_correct))))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon53_Else_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon53_Then_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon52_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= $abort_code@7 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 76642) 76658) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 76642) 76648) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon50_Else_correct  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 76630) 76664) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 76630) 76642) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon49_Else$1_correct  (=> (and (and (and (= inline$$DiemConfig_enable_reconfiguration_$def_verify$0$$t13@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@0)) (and (=> $abort_flag@4@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 76624) 77012) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 76624) 76630) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$Not$1$anon0_correct  (=> (and (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2@@0)))) (= (ControlFlow 0 76612) 76624)) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon49_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 76602) (- 0 104199)) true) (=> (= (ControlFlow 0 76602) 76612) inline$$Not$1$anon0_correct))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon49_Else_correct  (=> (and (not $abort_flag@3@@0) (= (ControlFlow 0 76618) 76602)) inline$$Not$1$Entry_correct)))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon49_Then_correct true))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon4_correct@@0  (=> (and (= $abort_flag@3@@0 $abort_flag@2@@1) (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2@@0 inline$$Not$0$dst@1@@0)) (and (=> (= (ControlFlow 0 76532) 77032) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 76532) 76618) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 76530) 76532)) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon4_correct@@0)))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Then_correct@@0  (=> (= (ControlFlow 0 76540) 76532) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon4_correct@@0)))
(let ((inline$$Not$0$anon0_correct@@0  (=> (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$DiemConfig_reconfiguration_enabled_$def$0$$t1@1@@0)))) (and (=> (= (ControlFlow 0 76514) 76540) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 76514) 76530) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 76504) (- 0 104138)) true) (=> (= (ControlFlow 0 76504) 76514) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Else_correct@@0  (=> (not $abort_flag@2@@1) (=> (and (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$t1@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@1)))) (= (ControlFlow 0 76520) 76504)) inline$$Not$0$Entry_correct@@0))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Then_correct@@0  (=> (and (and $abort_flag@2@@1 (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@1@@0 $Error)) (and (= $abort_flag@3@@0 true) (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2@@0 inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@1@@0))) (and (=> (= (ControlFlow 0 76548) 77032) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 76548) 76618) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 76432) 76548) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 76432) 76520) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@1  (and (=> (= (ControlFlow 0 76442) 76548) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 76442) 76520) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Else_correct@@0))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@1  (=> (and (not $abort_flag@2@@1) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 76426) 76442) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 76426) 76432) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@1)))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 76456) 76426)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@1)))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon47_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 76562) 76456)) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon0_correct@@0)))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon45_Then_correct  (=> (|b#$Boolean| inline$$DiemConfig_enable_reconfiguration_$def_verify$0$$t8@1) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@2@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@2@@1)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@2@@1)) (and (=> $abort_flag@2@@1 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))))) (=> $abort_flag@2@@1 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 76191) 77036) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 76191) 76562) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon47_Else_correct)))))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon46_Else_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon46_Then_correct true))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_enable_reconfiguration_$def_verify$0$$t8@1)) (= $abort_code@4@@1 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 76165) 76185) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 76165) 76171) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon43_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 76153) 76191) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 76153) 76165) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon42_Else_correct  (=> (and (not $abort_flag@0@@1) (= inline$$DiemConfig_enable_reconfiguration_$def_verify$0$$t8@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1)))) (=> (and (and (and (= inline$$DiemConfig_enable_reconfiguration_$def_verify$0$$t9@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 2))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 76147) 77056) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 76147) 76153) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon42_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 76103) 77076) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 76103) 76147) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@1  (and (=> (= (ControlFlow 0 76113) 77076) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 76113) 76147) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon42_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@1  (=> (and (not $abort_flag@0@@1) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 76097) 76113) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 76097) 76103) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@1)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon40_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 76127) 76097)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@1)))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 dr_account@@0)))) ((_ is $Address) call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 75992) 77080) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 75992) 76127) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 75956) 75992)) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 77104) 75992) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 75950) 77104) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 75950) 75956) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon39_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (=> (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (= (ControlFlow 0 77108) 75950)) inline$$DiemConfig_enable_reconfiguration_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) dr_account@@0) (= (ControlFlow 0 75335) 77108)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 102641) 75335) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $tv0@@2 () T@$TypeValue)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun inline$$DiemConfig_get_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$DiemConfig_get_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2 () T@$Value)
(declare-fun inline$$DiemConfig_get_$def_verify$0$$t3@1 () T@$Value)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$DiemConfig_get_$def_verify$0$$t4@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 104591) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 78283) (- 0 105430)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@2) (and (=> (= (ControlFlow 0 78283) (- 0 105461)) (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 78283) (- 0 105492)) (=> $abort_flag@2@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (=> (= (ControlFlow 0 78283) (- 0 105534)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemConfig_get_$def_verify$0$$ret0@2 (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)))))))))))))))
(let ((inline$$DiemConfig_get_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@5 $abort_code@3@@1) (= inline$$DiemConfig_get_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1)) (and (= $abort_flag@2@@2 $abort_flag@1@@2) (= (ControlFlow 0 78223) 78283))) anon0$2_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 78221) 78223)) inline$$DiemConfig_get_$def_verify$0$anon16_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 78231) 78223) inline$$DiemConfig_get_$def_verify$0$anon16_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $DiemConfig_DiemConfig_payload)) (and (=> (= (ControlFlow 0 78205) 78231) inline$$DiemConfig_get_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 78205) 78221) inline$$DiemConfig_get_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$DiemConfig_get_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 78211) 78205)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$Abort_correct  (=> (= inline$$DiemConfig_get_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@5 $abort_code@4@@2) (= inline$$DiemConfig_get_$def_verify$0$$ret0@2 inline$$DiemConfig_get_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@2 true) (= (ControlFlow 0 77958) 78283))) anon0$2_correct))))
(let ((inline$$DiemConfig_get_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@2 $abort_code@1) (= (ControlFlow 0 78263) 77958)) inline$$DiemConfig_get_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 78261) 78263)) inline$$DiemConfig_get_$def_verify$0$anon5_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 78271) 78263) inline$$DiemConfig_get_$def_verify$0$anon5_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 78255) 78271) inline$$DiemConfig_get_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 78255) 78261) inline$$DiemConfig_get_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$DiemConfig_get_$def_verify$0$anon13_correct  (=> (and (= $abort_code@4@@2 $abort_code@3@@1) (= (ControlFlow 0 78243) 77958)) inline$$DiemConfig_get_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 78241) 78243)) inline$$DiemConfig_get_$def_verify$0$anon13_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 78251) 78243) inline$$DiemConfig_get_$def_verify$0$anon13_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 78235) 78251) inline$$DiemConfig_get_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 78235) 78241) inline$$DiemConfig_get_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@1@@2 true) (=> (and (= $abort_code@3@@1 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 78151) 78235) inline$$DiemConfig_get_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 78151) 78211) inline$$DiemConfig_get_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 78149) 78151)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) inline$$GetGlobal$0$ta@0 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2))) (= $abort_flag@1@@2 $abort_flag@0@@2)) (and (= $abort_code@3@@1 $abort_code@1) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 78097) 78235) inline$$DiemConfig_get_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 78097) 78211) inline$$DiemConfig_get_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2)) (and (=> (= (ControlFlow 0 78079) 78149) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 78079) 78097) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (=> (= inline$$GetGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1)) (and (=> (= (ControlFlow 0 78073) (- 0 105233)) true) (=> (= (ControlFlow 0 78073) 78079) inline$$GetGlobal$0$anon0_correct)))))
(let ((inline$$DiemConfig_get_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| inline$$DiemConfig_get_$def_verify$0$$t3@1) (= (ControlFlow 0 78157) 78073)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon10_correct  (=> (and (= $abort_code@4@@2 $abort_code@2@@0) (= (ControlFlow 0 77952) 77958)) inline$$DiemConfig_get_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 77950) 77952)) inline$$DiemConfig_get_$def_verify$0$anon10_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 77966) 77952) inline$$DiemConfig_get_$def_verify$0$anon10_correct)))
(let ((inline$$DiemConfig_get_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_get_$def_verify$0$$t3@1)) (= $abort_code@2@@0 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 77944) 77966) inline$$DiemConfig_get_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 77944) 77950) inline$$DiemConfig_get_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DiemConfig_get_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 77932) 78157) inline$$DiemConfig_get_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 77932) 77944) inline$$DiemConfig_get_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DiemConfig_get_$def_verify$0$anon17_Else_correct  (=> (and (not false) (= inline$$DiemConfig_get_$def_verify$0$$t3@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1) (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2))))) (=> (and (and (and (= inline$$DiemConfig_get_$def_verify$0$$t4@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2)) (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 77926) 78255) inline$$DiemConfig_get_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 77926) 77932) inline$$DiemConfig_get_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$DiemConfig_get_$def_verify$0$anon17_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 77870) 78275) inline$$DiemConfig_get_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 77870) 77926) inline$$DiemConfig_get_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@2  (and (=> (= (ControlFlow 0 77880) 78275) inline$$DiemConfig_get_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 77880) 77926) inline$$DiemConfig_get_$def_verify$0$anon17_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@2  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2 ($Address 173345816))) (and (=> (= (ControlFlow 0 77864) 77880) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 77864) 77870) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@2)))))
(let ((inline$$DiemConfig_get_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 77894) 77864)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@2)))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@4 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((config_address T@$Value) )  (=> ((_ is $Address) config_address) (|b#$Boolean| ($Boolean (forall ((config_type T@$Value) )  (=> ((_ is $Type) config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type)) 1) (|a#$Address| config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address ($Address 173345816))))))))))))))) (= (ControlFlow 0 78281) 77894)) inline$$DiemConfig_get_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (= (ControlFlow 0 104591) 78281) anon0$1_correct@@2)))
anon0_correct@@2)))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun dr_account@@1 () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun $DiemConfig_Configuration_$memory@1 () T@$Memory)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $DiemConfig_Configuration_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$DiemConfig_Configuration_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DiemConfig_initialize_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemConfig_initialize_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$DiemConfig_initialize_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun inline$$Not$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$DiemConfig_initialize_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$DiemConfig_initialize_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@3 () T@$Value)
(declare-fun $DiemConfig_Configuration_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 105558) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 80082) (- 0 107138)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4@@1)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4@@1) (and (=> (= (ControlFlow 0 80082) (- 0 107146)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@1) (and (=> (= (ControlFlow 0 80082) (- 0 107161)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@4@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@4@@1) (and (=> (= (ControlFlow 0 80082) (- 0 107178)) (=> $abort_flag@4@@1 (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))))) (=> (=> $abort_flag@4@@1 (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))))) (and (=> (= (ControlFlow 0 80082) (- 0 107216)) (=> $abort_flag@4@@1 (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@4@@1 (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 80082) (- 0 107287)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 80082) (- 0 107297)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch) ($Integer 0)))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch) ($Integer 0))))) (=> (= (ControlFlow 0 80082) (- 0 107319)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) ($Integer 0))))))))))))))))))))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon41_Else_correct  (=> (not $abort_flag@3@@1) (and (=> (= (ControlFlow 0 79964) (- 0 106982)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (and (and (= $abort_code@7@@0 $abort_code@5@@0) (= $abort_flag@4@@1 $abort_flag@3@@1)) (and (= $DiemConfig_Configuration_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 79964) 80082))) anon0$2_correct@@0))))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@7@@0 $abort_code@6@@0) (= $abort_flag@4@@1 true)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 79330) 80082))) anon0$2_correct@@0)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon5_correct  (=> (= $abort_code@6@@0 $abort_code@1@@0) (=> (and (= $DiemConfig_Configuration_$memory@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 80060) 79330)) inline$$DiemConfig_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 80058) 80060)) inline$$DiemConfig_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 80068) 80060) inline$$DiemConfig_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon30_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 80052) 80068) inline$$DiemConfig_initialize_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 80052) 80058) inline$$DiemConfig_initialize_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon9_correct  (=> (= $abort_code@6@@0 $abort_code@2@@1) (=> (and (= $DiemConfig_Configuration_$memory@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 80040) 79330)) inline$$DiemConfig_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 80038) 80040)) inline$$DiemConfig_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 80048) 80040) inline$$DiemConfig_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon32_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 80032) 80048) inline$$DiemConfig_initialize_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 80032) 80038) inline$$DiemConfig_initialize_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon15_correct  (=> (= $abort_code@6@@0 $abort_code@3@@2) (=> (and (= $DiemConfig_Configuration_$memory@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 80016) 79330)) inline$$DiemConfig_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 80014) 80016)) inline$$DiemConfig_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 80024) 80016) inline$$DiemConfig_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon35_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 80008) 80024) inline$$DiemConfig_initialize_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 80008) 80014) inline$$DiemConfig_initialize_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon23_correct  (=> (= $abort_code@6@@0 $abort_code@3@@2) (=> (and (= $DiemConfig_Configuration_$memory@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 79996) 79330)) inline$$DiemConfig_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 79994) 79996)) inline$$DiemConfig_initialize_$def_verify$0$anon23_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 80004) 79996) inline$$DiemConfig_initialize_$def_verify$0$anon23_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon39_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 79988) 80004) inline$$DiemConfig_initialize_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 79988) 79994) inline$$DiemConfig_initialize_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon27_correct  (=> (= $abort_code@6@@0 $abort_code@5@@0) (=> (and (= $DiemConfig_Configuration_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 79976) 79330)) inline$$DiemConfig_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 79974) 79976)) inline$$DiemConfig_initialize_$def_verify$0$anon27_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 79984) 79976) inline$$DiemConfig_initialize_$def_verify$0$anon27_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon41_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 79968) 79984) inline$$DiemConfig_initialize_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 79968) 79974) inline$$DiemConfig_initialize_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@3@@1 true) (=> (and (= $abort_code@5@@0 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 79924) 79968) inline$$DiemConfig_initialize_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 79924) 79964) inline$$DiemConfig_initialize_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 79922) 79924)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 inline$$DiemConfig_Configuration_pack$0$$struct@1))) (= $abort_flag@3@@1 $abort_flag@2@@3)) (and (= $abort_code@5@@0 $abort_code@3@@2) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 79872) 79968) inline$$DiemConfig_initialize_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 79872) 79964) inline$$DiemConfig_initialize_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| dr_account@@1)) (and (=> (= (ControlFlow 0 79930) 79922) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 79930) 79872) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 79718) (- 0 106867)) true) (=> (= (ControlFlow 0 79718) 79930) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon39_Else$1_correct  (and (=> (= (ControlFlow 0 79938) (- 0 106832)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_initialize_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| dr_account@@1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_initialize_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| dr_account@@1)) (=> (= (ControlFlow 0 79938) 79718) inline$$Signer_borrow_address$0$Entry_correct@@0)))))
(let ((inline$$DiemConfig_Configuration_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 79592) 79938)) inline$$DiemConfig_initialize_$def_verify$0$anon39_Else$1_correct)))
(let ((inline$$DiemConfig_Configuration_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 79598) 79938) inline$$DiemConfig_initialize_$def_verify$0$anon39_Else$1_correct)))
(let ((inline$$DiemConfig_Configuration_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 79586) 79598) inline$$DiemConfig_Configuration_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 79586) 79592) inline$$DiemConfig_Configuration_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemConfig_Configuration_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 79578) 79938)) inline$$DiemConfig_initialize_$def_verify$0$anon39_Else$1_correct)))
(let ((inline$$DiemConfig_Configuration_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$DiemConfig_initialize_$def_verify$0$$t9@1) (>= (|i#$Integer| inline$$DiemConfig_initialize_$def_verify$0$$t9@1) 0)) (<= (|i#$Integer| inline$$DiemConfig_initialize_$def_verify$0$$t9@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$DiemConfig_initialize_$def_verify$0$$t10@1) (>= (|i#$Integer| inline$$DiemConfig_initialize_$def_verify$0$$t10@1) 0)) (<= (|i#$Integer| inline$$DiemConfig_initialize_$def_verify$0$$t10@1) $MAX_U64))) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@16 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@0))
))) true) (= inline$$DiemConfig_Configuration_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemConfig_initialize_$def_verify$0$$t9@1) 1 inline$$DiemConfig_initialize_$def_verify$0$$t10@1) 2 inline$$Event_new_event_handle$0$res@0) 3)))) (and (=> (= (ControlFlow 0 79570) 79586) inline$$DiemConfig_Configuration_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 79570) 79578) inline$$DiemConfig_Configuration_pack$0$anon3_Else_correct))))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@2@@3) (= (ControlFlow 0 79604) 79570)) inline$$DiemConfig_Configuration_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $DiemConfig_NewEpochEvent_type_value) (and (=> (= (ControlFlow 0 79378) 79988) inline$$DiemConfig_initialize_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 79378) 79604) inline$$DiemConfig_initialize_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon37_Then_correct  (=> (and (and (|b#$Boolean| inline$$Not$0$dst@1@@1) (= inline$$DiemConfig_initialize_$def_verify$0$$t9@1 ($Integer 0))) (and (= inline$$DiemConfig_initialize_$def_verify$0$$t10@1 ($Integer 0)) (= (ControlFlow 0 79386) 79378))) inline$$Event_new_event_handle$0$Entry_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon20_correct  (=> (= $abort_code@6@@0 $abort_code@4@@3) (=> (and (= $DiemConfig_Configuration_$memory@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 79326) 79330)) inline$$DiemConfig_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 79324) 79326)) inline$$DiemConfig_initialize_$def_verify$0$anon20_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 79338) 79326) inline$$DiemConfig_initialize_$def_verify$0$anon20_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@1)) (= $abort_code@4@@3 (|i#$Integer| call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 79318) 79338) inline$$DiemConfig_initialize_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 79318) 79324) inline$$DiemConfig_initialize_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@2@@3) (and (=> (= (ControlFlow 0 79306) 79386) inline$$DiemConfig_initialize_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 79306) 79318) inline$$DiemConfig_initialize_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon34_Else$1_correct  (=> (and (and (and (= inline$$DiemConfig_initialize_$def_verify$0$$t7@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@3)) (and (=> $abort_flag@2@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 79300) 80008) inline$$DiemConfig_initialize_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 79300) 79306) inline$$DiemConfig_initialize_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@1  (=> (and (= inline$$Not$0$dst@1@@1 ($Boolean  (not (|b#$Boolean| inline$$DiemConfig_initialize_$def_verify$0$$t5@1)))) (= (ControlFlow 0 79288) 79300)) inline$$DiemConfig_initialize_$def_verify$0$anon34_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 79278) (- 0 106598)) true) (=> (= (ControlFlow 0 79278) 79288) inline$$Not$0$anon0_correct@@1))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon34_Else_correct  (=> (not $abort_flag@1@@3) (=> (and (= inline$$DiemConfig_initialize_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@3)))) (= (ControlFlow 0 79294) 79278)) inline$$Not$0$Entry_correct@@1))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon34_Then_correct  (=> (and (and $abort_flag@1@@3 (= $abort_code@6@@0 $abort_code@2@@1)) (and (= $DiemConfig_Configuration_$memory@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 80028) 79330))) inline$$DiemConfig_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 79206) 80028) inline$$DiemConfig_initialize_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 79206) 79294) inline$$DiemConfig_initialize_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@3  (and (=> (= (ControlFlow 0 79216) 80028) inline$$DiemConfig_initialize_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 79216) 79294) inline$$DiemConfig_initialize_$def_verify$0$anon34_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@3  (=> (and (not $abort_flag@1@@3) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@3 ($Address 173345816))) (and (=> (= (ControlFlow 0 79200) 79216) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 79200) 79206) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@3)))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon32_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 79230) 79200)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@3)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon30_Else_correct  (=> (and (and (not $abort_flag@0@@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@1@@3)) (and (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (=> $abort_flag@1@@3 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 79095) 80032) inline$$DiemConfig_initialize_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 79095) 79230) inline$$DiemConfig_initialize_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0@@3) (=> (and (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 79089) 80052) inline$$DiemConfig_initialize_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 79089) 79095) inline$$DiemConfig_initialize_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon2_correct  (=> (and (= inline$$DiemConfig_initialize_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 79087) 79089)) inline$$DiemConfig_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 79039) 79087)) inline$$DiemConfig_initialize_$def_verify$0$anon2_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 80076) 79087) inline$$DiemConfig_initialize_$def_verify$0$anon2_correct)))
(let ((inline$$DiemConfig_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 79033) 80076) inline$$DiemConfig_initialize_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 79033) 79039) inline$$DiemConfig_initialize_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@18 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (=> (and (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@19 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@1))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 80080) 79033))) inline$$DiemConfig_initialize_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@3  (=> (and ((_ is $Address) dr_account@@1) (= (ControlFlow 0 78427) 80080)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_Configuration_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 105558) 78427)) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@3 () T@$TypeValue)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory () T@$Memory)
(declare-fun dr_account@@2 () T@$Value)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@1 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@0 () T@$Memory)
(declare-fun payload () T@$Value)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1@@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@1| () T@$Memory)
(declare-fun call7formal@$ret0@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@2 () T@$Value)
(declare-fun inline$$DiemConfig_publish_new_config_$def_verify$0$$DiemConfig_ModifyConfigCapability_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$DiemConfig_publish_new_config_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$DiemConfig_publish_new_config_$def_verify$0$$t8@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$DiemConfig_publish_new_config_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemConfig_DiemConfig_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemConfig_ModifyConfigCapability_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 107349) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 81993) (- 0 110352)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 81993) (- 0 110362)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2)))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2)))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 81993) (- 0 110388)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 81993) (- 0 110403)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 81993) (- 0 110424)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 81993) (- 0 110453)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 81993) (- 0 110470)) (=> $abort_flag@4@@2 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816)))))))) (=> (=> $abort_flag@4@@2 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))))) (and (=> (= (ControlFlow 0 81993) (- 0 110583)) (=> $abort_flag@4@@2 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@4@@2 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 81993) (- 0 110740)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2)))))) (=> (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2))))) (and (=> (= (ControlFlow 0 81993) (- 0 110768)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 81993) (- 0 110780)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)) payload))))) (=> (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)) payload)))) (=> (= (ControlFlow 0 81993) (- 0 110798)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))))))))))))))))))))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@3@@2) (and (=> (= (ControlFlow 0 81891) (- 0 110173)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_$def_verify$0$config_type T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_publish_new_config_$def_verify$0$config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_$def_verify$0$config_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_$def_verify$0$config_type)) 1) (|a#$Address| ($Address 173345816))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_$def_verify$0$config_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_publish_new_config_$def_verify$0$config_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_$def_verify$0$config_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_$def_verify$0$config_type@@0)) 1) (|a#$Address| ($Address 173345816)))))))))))) (=> (and (and (= $abort_code@7@@1 $abort_code@5@@1) (= $abort_flag@4@@2 $abort_flag@3@@2)) (and (= $DiemConfig_ModifyConfigCapability_$memory@1 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 81891) 81993))) anon0$2_correct@@1))))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@7@@1 $abort_code@6@@1) (= $abort_flag@4@@2 true)) (and (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory@0) (= (ControlFlow 0 81444) 81993))) anon0$2_correct@@1)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon7_correct  (=> (= $abort_code@6@@1 $abort_code@1@@1) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@0 $DiemConfig_ModifyConfigCapability_$memory) (= (ControlFlow 0 81963) 81444)) inline$$DiemConfig_publish_new_config_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 81961) 81963)) inline$$DiemConfig_publish_new_config_$def_verify$0$anon7_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 81971) 81963) inline$$DiemConfig_publish_new_config_$def_verify$0$anon7_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon27_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 81955) 81971) inline$$DiemConfig_publish_new_config_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 81955) 81961) inline$$DiemConfig_publish_new_config_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon11_correct  (=> (= $abort_code@6@@1 $abort_code@2@@2) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@0 $DiemConfig_ModifyConfigCapability_$memory) (= (ControlFlow 0 81943) 81444)) inline$$DiemConfig_publish_new_config_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 81941) 81943)) inline$$DiemConfig_publish_new_config_$def_verify$0$anon11_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 81951) 81943) inline$$DiemConfig_publish_new_config_$def_verify$0$anon11_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon29_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 81935) 81951) inline$$DiemConfig_publish_new_config_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 81935) 81941) inline$$DiemConfig_publish_new_config_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon15_correct  (=> (= $abort_code@6@@1 $abort_code@3@@3) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@0 $DiemConfig_ModifyConfigCapability_$memory) (= (ControlFlow 0 81923) 81444)) inline$$DiemConfig_publish_new_config_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 81921) 81923)) inline$$DiemConfig_publish_new_config_$def_verify$0$anon15_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 81931) 81923) inline$$DiemConfig_publish_new_config_$def_verify$0$anon15_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon31_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 81915) 81931) inline$$DiemConfig_publish_new_config_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 81915) 81921) inline$$DiemConfig_publish_new_config_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon23_correct  (=> (= $abort_code@6@@1 $abort_code@5@@1) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@0 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 81903) 81444)) inline$$DiemConfig_publish_new_config_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 81901) 81903)) inline$$DiemConfig_publish_new_config_$def_verify$0$anon23_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 81911) 81903) inline$$DiemConfig_publish_new_config_$def_verify$0$anon23_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon35_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 81895) 81911) inline$$DiemConfig_publish_new_config_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 81895) 81901) inline$$DiemConfig_publish_new_config_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@3@@2 true) (=> (and (= $abort_code@5@@1 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 81802) 81895) inline$$DiemConfig_publish_new_config_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 81802) 81891) inline$$DiemConfig_publish_new_config_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@1  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1@@1) (= (ControlFlow 0 81800) 81802)) inline$$MoveToRaw$0$anon3_Then$1_correct@@1)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@1  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1@@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1@@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1@@1 call7formal@$ret0@0))) (= $abort_flag@3@@2 $abort_flag@2@@4)) (and (= $abort_code@5@@1 $abort_code@3@@3) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@1|))) (and (=> (= (ControlFlow 0 81750) 81895) inline$$DiemConfig_publish_new_config_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 81750) 81891) inline$$DiemConfig_publish_new_config_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@1  (=> (= inline$$MoveTo$0$a@1@@1 (|a#$Address| dr_account@@2)) (and (=> (= (ControlFlow 0 81808) 81800) inline$$MoveToRaw$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 81808) 81750) inline$$MoveToRaw$0$anon3_Else_correct@@1)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 81596) (- 0 110058)) true) (=> (= (ControlFlow 0 81596) 81808) inline$$MoveTo$0$anon0$1_correct@@1))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1)) (= (ControlFlow 0 81568) 81596)) inline$$Signer_borrow_address$0$Entry_correct@@1)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon33_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1@@2) (and (=> (= (ControlFlow 0 81816) (- 0 109971)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_publish_new_config_$def_verify$0$$DiemConfig_ModifyConfigCapability_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_publish_new_config_$def_verify$0$$DiemConfig_ModifyConfigCapability_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| dr_account@@2)) (=> (= (ControlFlow 0 81816) 81568) inline$$MoveTo$0$Entry_correct))))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon20_correct  (=> (= $abort_code@6@@1 $abort_code@4@@4) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@0 $DiemConfig_ModifyConfigCapability_$memory) (= (ControlFlow 0 81440) 81444)) inline$$DiemConfig_publish_new_config_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 81438) 81440)) inline$$DiemConfig_publish_new_config_$def_verify$0$anon20_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 81452) 81440) inline$$DiemConfig_publish_new_config_$def_verify$0$anon20_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon33_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@2)) (= $abort_code@4@@4 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 81432) 81452) inline$$DiemConfig_publish_new_config_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 81432) 81438) inline$$DiemConfig_publish_new_config_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon31_Else_correct  (=> (not $abort_flag@2@@4) (and (=> (= (ControlFlow 0 81420) 81816) inline$$DiemConfig_publish_new_config_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 81420) 81432) inline$$DiemConfig_publish_new_config_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon29_Else$1_correct  (=> (and (and (and (= inline$$DiemConfig_publish_new_config_$def_verify$0$$t10@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@4)) (and (=> $abort_flag@2@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 81414) 81915) inline$$DiemConfig_publish_new_config_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 81414) 81420) inline$$DiemConfig_publish_new_config_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@2  (=> (and (= inline$$Not$0$dst@1@@2 ($Boolean  (not (|b#$Boolean| inline$$DiemConfig_publish_new_config_$def_verify$0$$t8@1)))) (= (ControlFlow 0 81402) 81414)) inline$$DiemConfig_publish_new_config_$def_verify$0$anon29_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 81392) (- 0 109877)) true) (=> (= (ControlFlow 0 81392) 81402) inline$$Not$0$anon0_correct@@2))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon29_Else_correct  (=> (not $abort_flag@1@@4) (=> (and (= inline$$DiemConfig_publish_new_config_$def_verify$0$$t8@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| call3formal@$ret0@0@@11)))) (= (ControlFlow 0 81408) 81392)) inline$$Not$0$Entry_correct@@2))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon27_Else_correct  (=> (not $abort_flag@0@@4) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@4) (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 dr_account@@2)))) ((_ is $Address) call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 81334) 81935) inline$$DiemConfig_publish_new_config_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 81334) 81408) inline$$DiemConfig_publish_new_config_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon4$2_correct  (and (=> (= (ControlFlow 0 81328) (- 0 109249)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_publish_new_config_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_publish_new_config_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0@@4) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) $abort_flag@0@@4)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@0@@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) $abort_flag@0@@4)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@0@@4) (=> $abort_flag@0@@4 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))))))) (and (and (=> $abort_flag@0@@4 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 6)))))) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)) payload)))) (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (and (and (and (and (and ((_ is $Vector) call7formal@$ret0@0) (let ((va@@22 (|v#$Vector| call7formal@$ret0@0)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $DiemConfig_ModifyConfigCapability_dummy_field))) true) (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (= (ControlFlow 0 81328) 81955) inline$$DiemConfig_publish_new_config_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 81328) 81334) inline$$DiemConfig_publish_new_config_$def_verify$0$anon27_Else_correct)))))))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon4_correct  (=> (= inline$$DiemConfig_publish_new_config_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816)) true)) (=> (and (= inline$$DiemConfig_publish_new_config_$def_verify$0$$DiemConfig_ModifyConfigCapability_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 81292) 81328)) inline$$DiemConfig_publish_new_config_$def_verify$0$anon4$2_correct))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 81206) 81292)) inline$$DiemConfig_publish_new_config_$def_verify$0$anon4_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 81979) 81292) inline$$DiemConfig_publish_new_config_$def_verify$0$anon4_correct)))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 81198) 81979) inline$$DiemConfig_publish_new_config_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 81198) 81206) inline$$DiemConfig_publish_new_config_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 81987) 81979) inline$$DiemConfig_publish_new_config_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 81987) 81206) inline$$DiemConfig_publish_new_config_$def_verify$0$anon26_Else_correct))))
(let ((inline$$DiemConfig_publish_new_config_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 81192) 81987) inline$$DiemConfig_publish_new_config_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 81192) 81198) inline$$DiemConfig_publish_new_config_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (and (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))
))) (and (forall (($inv_addr@@9 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))
)) (forall (($inv_addr@@10 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))
)))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((config_address@@0 T@$Value) )  (=> ((_ is $Address) config_address@@0) (|b#$Boolean| ($Boolean (forall ((config_type@@0 T@$Value) )  (=> ((_ is $Type) config_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@0)) 1) (|a#$Address| config_address@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@0 ($Address 173345816))))))))))))))) (= (ControlFlow 0 81991) 81192)))) inline$$DiemConfig_publish_new_config_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) dr_account@@2) (= (ControlFlow 0 80317) 81991)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_DiemConfig_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))) (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_ModifyConfigCapability_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1) (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 107349) 80317)) anon0_correct@@4))))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun dr_account@@3 () T@$Value)
(declare-fun $tv0@@4 () T@$TypeValue)
(declare-fun $abort_code@8 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1 () T@$Memory)
(declare-fun payload@@0 () T@$Value)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_flag@4@@3 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@1| () T@$Memory)
(declare-fun inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$DiemConfig_ModifyConfigCapability_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun $abort_flag@2@@5 () Bool)
(declare-fun $abort_code@4@@5 () Int)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@1| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1@@2 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@2| () T@$Memory)
(declare-fun inline$$DiemConfig_DiemConfig_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$Not$0$dst@1@@3 () T@$Value)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun $DiemConfig_DiemConfig_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 110825) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 84477) (- 0 113547)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@1) (and (=> (= (ControlFlow 0 84477) (- 0 113562)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3))))))) $abort_flag@5@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3))))))) $abort_flag@5@@1) (and (=> (= (ControlFlow 0 84477) (- 0 113583)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@5@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@5@@1) (and (=> (= (ControlFlow 0 84477) (- 0 113612)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))) $abort_flag@5@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))) $abort_flag@5@@1) (and (=> (= (ControlFlow 0 84477) (- 0 113629)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@5@@1)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@5@@1) (and (=> (= (ControlFlow 0 84477) (- 0 113653)) (=> $abort_flag@5@@1 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816)))))))) (=> (=> $abort_flag@5@@1 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (= (ControlFlow 0 84477) (- 0 113755)) (=> $abort_flag@5@@1 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@8 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3))))))) (= $abort_code@8 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@8 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))) (= $abort_code@8 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816))))) (= $abort_code@8 (|i#$Integer| ($Integer 6))))))) (=> (=> $abort_flag@5@@1 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@8 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3))))))) (= $abort_code@8 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@8 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))) (= $abort_code@8 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816))))) (= $abort_code@8 (|i#$Integer| ($Integer 6)))))) (and (=> (= (ControlFlow 0 84477) (- 0 113912)) (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 84477) (- 0 113924)) (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@2 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| addr@@2)))) $DiemConfig_DiemConfig_payload)) payload@@0))))) (=> (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@2 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| addr@@2)))) $DiemConfig_DiemConfig_payload)) payload@@0)))) (=> (= (ControlFlow 0 84477) (- 0 113942)) (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))))))))))))))))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon30_correct  (=> (and (and (= $abort_code@8 $abort_code@6@@2) (= $abort_flag@5@@1 $abort_flag@4@@3)) (and (= $DiemConfig_DiemConfig_$memory@1 |inline$$MoveToRaw$0$m'@2@@1|) (= (ControlFlow 0 84345) 84477))) anon0$2_correct@@2)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 84343) 84345)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon30_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 84353) 84345) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon30_correct)))
(let ((inline$$DiemConfig_ModifyConfigCapability_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 84321) 84353) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 84321) 84343) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$DiemConfig_ModifyConfigCapability_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 84327) 84353) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 84327) 84343) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon45_Else_correct))))
(let ((inline$$DiemConfig_ModifyConfigCapability_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 84315) 84327) inline$$DiemConfig_ModifyConfigCapability_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 84315) 84321) inline$$DiemConfig_ModifyConfigCapability_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemConfig_ModifyConfigCapability_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 84307) 84353) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 84307) 84343) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$DiemConfig_ModifyConfigCapability_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$t12@1) (= inline$$DiemConfig_ModifyConfigCapability_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$t12@1) 1)))) (and (=> (= (ControlFlow 0 84299) 84315) inline$$DiemConfig_ModifyConfigCapability_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 84299) 84307) inline$$DiemConfig_ModifyConfigCapability_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon43_Else_correct  (=> (not $abort_flag@4@@3) (and (=> (= (ControlFlow 0 84333) (- 0 113169)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_address T@$Value) )  (=> ((_ is $Address) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_address) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type)) 1) (|a#$Address| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_address ($Address 173345816)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_address@@0 T@$Value) )  (=> ((_ is $Address) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_address@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@0)) 1) (|a#$Address| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_address@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_address@@0 ($Address 173345816))))))))))))))) (and (=> (= (ControlFlow 0 84333) (- 0 113234)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@1)) 1) (|a#$Address| ($Address 173345816)))))))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@2)) 1) (|a#$Address| ($Address 173345816))))))))))))))) (and (=> (= (ControlFlow 0 84333) (- 0 113283)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@3)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@3)) 1) (|a#$Address| ($Address 173345816))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@4)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$config_type@@4)) 1) (|a#$Address| ($Address 173345816)))))))))))) (=> (and (= inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$t12@1 ($Boolean false)) (= (ControlFlow 0 84333) 84299)) inline$$DiemConfig_ModifyConfigCapability_pack$0$anon0_correct))))))))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$Abort_correct  (=> (= inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@8 $abort_code@7@@2) (= $abort_flag@5@@1 true)) (and (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory@0@@0) (= (ControlFlow 0 83467) 84477))) anon0$2_correct@@2))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon7_correct  (=> (= $abort_code@7@@2 $abort_code@1@@2) (=> (and (= $DiemConfig_DiemConfig_$memory@0@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 84445) 83467)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 84443) 84445)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon7_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 84453) 84445) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon7_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon33_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 84437) 84453) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 84437) 84443) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon11_correct  (=> (= $abort_code@7@@2 $abort_code@2@@3) (=> (and (= $DiemConfig_DiemConfig_$memory@0@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 84425) 83467)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 84423) 84425)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon11_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 84433) 84425) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon11_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon35_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 84417) 84433) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 84417) 84423) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon15_correct  (=> (= $abort_code@7@@2 $abort_code@3@@4) (=> (and (= $DiemConfig_DiemConfig_$memory@0@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 84405) 83467)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 84403) 84405)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon15_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 84413) 84405) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon15_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon37_Then_correct  (=> $abort_flag@2@@5 (and (=> (= (ControlFlow 0 84397) 84413) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 84397) 84403) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon19_correct  (=> (= $abort_code@7@@2 $abort_code@4@@5) (=> (and (= $DiemConfig_DiemConfig_$memory@0@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 84385) 83467)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 84383) 84385)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon19_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 84393) 84385) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon19_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon39_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 84377) 84393) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 84377) 84383) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon27_correct  (=> (= $abort_code@7@@2 $abort_code@6@@2) (=> (and (= $DiemConfig_DiemConfig_$memory@0@@0 |inline$$MoveToRaw$0$m'@2@@1|) (= (ControlFlow 0 84365) 83467)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 84363) 84365)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon27_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 84373) 84365) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon27_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon43_Then_correct  (=> $abort_flag@4@@3 (and (=> (= (ControlFlow 0 84357) 84373) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 84357) 84363) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@4@@3 true) (=> (and (= $abort_code@6@@2 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@1| |inline$$MoveToRaw$0$m'@0@@1|)) (and (=> (= (ControlFlow 0 83986) 84357) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 83986) 84333) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@2  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@2) (= (ControlFlow 0 83984) 83986)) inline$$MoveToRaw$0$anon3_Then$1_correct@@2)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@2  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@2)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@2| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@2 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@2 inline$$DiemConfig_DiemConfig_pack$0$$struct@1))) (= $abort_flag@4@@3 $abort_flag@3@@3)) (and (= $abort_code@6@@2 $abort_code@4@@5) (= |inline$$MoveToRaw$0$m'@2@@1| |inline$$MoveToRaw$0$m'@1@@2|))) (and (=> (= (ControlFlow 0 83934) 84357) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 83934) 84333) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@2  (=> (= inline$$MoveTo$0$a@1@@2 (|a#$Address| dr_account@@3)) (and (=> (= (ControlFlow 0 83992) 83984) inline$$MoveToRaw$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 83992) 83934) inline$$MoveToRaw$0$anon3_Else_correct@@2)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 83780) (- 0 113054)) true) (=> (= (ControlFlow 0 83780) 83992) inline$$MoveTo$0$anon0$1_correct@@2))))
(let ((inline$$MoveTo$0$Entry_correct@@0  (=> (and (= inline$$MoveTo$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1)) (= (ControlFlow 0 83752) 83780)) inline$$Signer_borrow_address$0$Entry_correct@@2)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon41_Then$1_correct  (and (=> (= (ControlFlow 0 84000) (- 0 112992)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| dr_account@@3))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| dr_account@@3)) (=> (= (ControlFlow 0 84000) 83752) inline$$MoveTo$0$Entry_correct@@0)))))
(let ((inline$$DiemConfig_DiemConfig_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 83626) 84000)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon41_Then$1_correct)))
(let ((inline$$DiemConfig_DiemConfig_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 83632) 84000) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon41_Then$1_correct)))
(let ((inline$$DiemConfig_DiemConfig_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 83620) 83632) inline$$DiemConfig_DiemConfig_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 83620) 83626) inline$$DiemConfig_DiemConfig_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemConfig_DiemConfig_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 83612) 84000)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon41_Then$1_correct)))
(let ((inline$$DiemConfig_DiemConfig_pack$0$anon0_correct  (=> (= inline$$DiemConfig_DiemConfig_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 payload@@0) 1))) (and (=> (= (ControlFlow 0 83604) 83620) inline$$DiemConfig_DiemConfig_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 83604) 83612) inline$$DiemConfig_DiemConfig_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon41_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@3) (= (ControlFlow 0 83638) 83604)) inline$$DiemConfig_DiemConfig_pack$0$anon0_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon24_correct  (=> (= $abort_code@7@@2 $abort_code@5@@2) (=> (and (= $DiemConfig_DiemConfig_$memory@0@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 83461) 83467)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 83459) 83461)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon24_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 83475) 83461) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon24_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@3)) (= $abort_code@5@@2 (|i#$Integer| call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 83453) 83475) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 83453) 83459) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon39_Else_correct  (=> (not $abort_flag@3@@3) (and (=> (= (ControlFlow 0 83441) 83638) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 83441) 83453) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon37_Else$1_correct  (=> (and (and (and (= inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$t9@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@3)) (and (=> $abort_flag@3@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 83435) 84377) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 83435) 83441) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@3  (=> (and (= inline$$Not$0$dst@1@@3 ($Boolean  (not (|b#$Boolean| inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$t7@1)))) (= (ControlFlow 0 83423) 83435)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon37_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 83413) (- 0 112812)) true) (=> (= (ControlFlow 0 83413) 83423) inline$$Not$0$anon0_correct@@3))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon37_Else_correct  (=> (not $abort_flag@2@@5) (=> (and (= inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| call3formal@$ret0@0@@13)))) (= (ControlFlow 0 83429) 83413)) inline$$Not$0$Entry_correct@@3))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@1@@5) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@5) (=> $abort_flag@2@@5 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 dr_account@@3)))) ((_ is $Address) call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 83355) 84397) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 83355) 83429) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon37_Else_correct))))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon33_Else_correct  (=> (not $abort_flag@0@@5) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))) $abort_flag@1@@5) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3))))))) $abort_flag@1@@5)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@1@@5) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))) $abort_flag@1@@5)) (and (=> $abort_flag@1@@5 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))))) (=> $abort_flag@1@@5 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))) (= $abort_code@2@@3 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3))))))) (= $abort_code@2@@3 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@2@@3 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@3 ($Address 173345816))))) (= $abort_code@2@@3 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 83349) 84417) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 83349) 83355) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon35_Else_correct)))))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0@@5) (=> (and (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 83343) 84437) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 83343) 83349) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon4_correct  (=> (and (= inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 83307) 83343)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 83247) 83307)) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon4_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 84461) 83307) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon4_correct)))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon31_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 83239) 84461) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 83239) 83247) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon31_Then_correct  (and (=> (= (ControlFlow 0 84469) 84461) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 84469) 83247) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon32_Else_correct))))
(let ((inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 83233) 84469) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 83233) 83239) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon31_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@27 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@11))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@11))
)) (=> (and (forall (($inv_addr@@12 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12)) (let ((va@@28 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))
)) (forall (($inv_addr@@13 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@13)) (let ((va@@29 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@13))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@13))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@13))
))) (=> (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((config_address@@1 T@$Value) )  (=> ((_ is $Address) config_address@@1) (|b#$Boolean| ($Boolean (forall ((config_type@@1 T@$Value) )  (=> ((_ is $Type) config_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@1)) 1) (|a#$Address| config_address@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@1 ($Address 173345816))))))))))))))) (= (ControlFlow 0 84475) 83233))) inline$$DiemConfig_publish_new_config_and_get_capability_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@5  (=> (and ((_ is $Address) dr_account@@3) (= (ControlFlow 0 82239) 84475)) anon0$1_correct@@5)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_DiemConfig_$CallerDomain@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1) (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 110825) 82239)) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$Not$0$dst@1@@4 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@4 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 113965) (let ((inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon6_Else_correct true))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon6_Then_correct true))
(let ((inline$$Not$0$anon0_correct@@4  (=> (= inline$$Not$0$dst@1@@4 ($Boolean  (not (|b#$Boolean| inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$$t1@1)))) (and (=> (= (ControlFlow 0 85082) 85108) inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 85082) 85098) inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 85072) (- 0 114140)) true) (=> (= (ControlFlow 0 85072) 85082) inline$$Not$0$anon0_correct@@4))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon5_Else_correct  (=> (not false) (=> (and (= inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@4)))) (= (ControlFlow 0 85088) 85072)) inline$$Not$0$Entry_correct@@4))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@4  (=> (not true) (and (=> (= (ControlFlow 0 85000) 85116) inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 85000) 85088) inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@4  (and (=> (= (ControlFlow 0 85010) 85116) inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 85010) 85088) inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@4  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@4 ($Address 173345816))) (and (=> (= (ControlFlow 0 84994) 85010) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 84994) 85000) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@4)))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 85024) 84994)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@4)))
(let ((anon0$1_correct@@6  (=> (and (forall (($inv_addr@@14 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@14)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@14))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@14))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@14))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@14))
)) (= (ControlFlow 0 85122) 85024)) inline$$DiemConfig_reconfiguration_enabled_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@6  (=> (= (ControlFlow 0 113965) 85122) anon0$1_correct@@6)))
anon0_correct@@6)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun dr_account@@4 () T@$Value)
(declare-fun $abort_flag@2@@6 () Bool)
(declare-fun $abort_code@4@@6 () Int)
(declare-fun $abort_code@3@@5 () Int)
(declare-fun $DiemConfig_Configuration_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1@@0 () T@$Memory)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun $DiemConfig_Configuration_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@2@@4 () Int)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun inline$$DiemConfig_reconfigure_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemConfig_Configuration_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 114182) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 85697) (- 0 117093)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4))))))) $abort_flag@2@@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4))))))) $abort_flag@2@@6) (and (=> (= (ControlFlow 0 85697) (- 0 117114)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@6) (and (=> (= (ControlFlow 0 85697) (- 0 117143)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816))))) $abort_flag@2@@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816))))) $abort_flag@2@@6) (and (=> (= (ControlFlow 0 85697) (- 0 117160)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@2@@6)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@2@@6) (and (=> (= (ControlFlow 0 85697) (- 0 117259)) (=> $abort_flag@2@@6 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (=> (=> $abort_flag@2@@6 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))) (=> (= (ControlFlow 0 85697) (- 0 117422)) (=> $abort_flag@2@@6 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4))))))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816))))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@4@@6 (|i#$Integer| ($Integer 1)))))))))))))))))))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@4@@6 $abort_code@3@@5) (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@1@@0)) (and (= $abort_flag@2@@6 true) (= (ControlFlow 0 85655) 85697))) anon0$2_correct@@3)))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon5_correct  (=> (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (=> (and (= $abort_code@3@@5 $abort_code@1@@3) (= (ControlFlow 0 85675) 85655)) inline$$DiemConfig_reconfigure_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 85673) 85675)) inline$$DiemConfig_reconfigure_$def_verify$0$anon5_correct)))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 85683) 85675) inline$$DiemConfig_reconfigure_$def_verify$0$anon5_correct)))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon12_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 85667) 85683) inline$$DiemConfig_reconfigure_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 85667) 85673) inline$$DiemConfig_reconfigure_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon9_correct  (=> (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory@0@@0) (=> (and (= $abort_code@3@@5 $abort_code@2@@4) (= (ControlFlow 0 85651) 85655)) inline$$DiemConfig_reconfigure_$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 85649) 85651)) inline$$DiemConfig_reconfigure_$def_verify$0$anon9_correct)))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 85663) 85651) inline$$DiemConfig_reconfigure_$def_verify$0$anon9_correct)))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon14_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 85643) 85663) inline$$DiemConfig_reconfigure_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 85643) 85649) inline$$DiemConfig_reconfigure_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon14_Else_correct  (=> (not $abort_flag@1@@6) (=> (and (and (= $abort_code@4@@6 $abort_code@2@@4) (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0@@0)) (and (= $abort_flag@2@@6 $abort_flag@1@@6) (= (ControlFlow 0 85639) 85697))) anon0$2_correct@@3))))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon12_Else_correct  (=> (not $abort_flag@0@@6) (and (=> (= (ControlFlow 0 85633) (- 0 116340)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_reconfigure_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_reconfigure_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) $abort_flag@1@@6) (=> $abort_flag@1@@6 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))))) (and (=> $abort_flag@1@@6 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (= $abort_code@2@@4 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) $DiemConfig_Configuration_last_reconfiguration_time (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 85633) 85643) inline$$DiemConfig_reconfigure_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 85633) 85639) inline$$DiemConfig_reconfigure_$def_verify$0$anon14_Else_correct))))))))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon2$1_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816))))) $abort_flag@0@@6) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4))))))) $abort_flag@0@@6)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@0@@6) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816))))) $abort_flag@0@@6)) (and (=> $abort_flag@0@@6 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816))))))) (=> $abort_flag@0@@6 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4))))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@4)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@4 ($Address 173345816))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 85627) 85667) inline$$DiemConfig_reconfigure_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 85627) 85633) inline$$DiemConfig_reconfigure_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon2_correct  (=> (and (= inline$$DiemConfig_reconfigure_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 85625) 85627)) inline$$DiemConfig_reconfigure_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 85577) 85625)) inline$$DiemConfig_reconfigure_$def_verify$0$anon2_correct)))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 85691) 85625) inline$$DiemConfig_reconfigure_$def_verify$0$anon2_correct)))
(let ((inline$$DiemConfig_reconfigure_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 85571) 85691) inline$$DiemConfig_reconfigure_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 85571) 85577) inline$$DiemConfig_reconfigure_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct@@7  (=> (forall (($inv_addr@@15 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))
)) (=> (and (forall (($inv_addr@@16 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))
)) (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@33 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@2))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@17))
))) (=> (and (and (forall (($inv_addr@@18 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@18)) (let ((va@@36 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@18))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@18))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@18))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 85695) 85571))) inline$$DiemConfig_reconfigure_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@7  (=> (and ((_ is $Address) dr_account@@4) (= (ControlFlow 0 85219) 85695)) anon0$1_correct@@7)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_Configuration_$CallerDomain@@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 114182) 85219)) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun $DiemConfig_Configuration_$memory@0@@1 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@7@@3 () Int)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun $abort_code@3@@6 () Int)
(declare-fun $abort_flag@5@@2 () Bool)
(declare-fun $abort_code@4@@7 () Int)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@0 () T@$TypeValue)
(declare-fun inline$$ReadRef$3$v@1@@0 () T@$Value)
(declare-fun inline$$DiemConfig_NewEpochEvent_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$6$p@1 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1 () Int)
(declare-fun inline$$BorrowField$6$p@2 () T@$Path)
(declare-fun inline$$BorrowField$5$p@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1 () Int)
(declare-fun inline$$BorrowField$5$p@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@0 () Int)
(declare-fun inline$$BorrowField$4$p@2@@0 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@0 () T@$Value)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@0 () Int)
(declare-fun inline$$BorrowField$3$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@0 () T@$Mutation)
(declare-fun call2formal@$ret0@0 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@0 () Int)
(declare-fun inline$$BorrowField$2$p@2@@0 () T@$Path)
(declare-fun inline$$Gt$0$dst@1 () T@$Value)
(declare-fun $abort_code@6@@3 () Int)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$t14@1 () T@$Value)
(declare-fun $abort_flag@4@@4 () Bool)
(declare-fun $abort_code@2@@5 () Int)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun $abort_code@0 () Int)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$$t0@1 () T@$Value)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$3@1| () T@$Value)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$t10@1 () T@$Value)
(declare-fun $abort_flag@2@@7 () Bool)
(declare-fun |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$2@2| () T@$Value)
(declare-fun inline$$Not$2$dst@1 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2@@1 () T@$Value)
(declare-fun inline$$Not$1$dst@1@@0 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def$0$$t1@1@@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@2 () T@$Value)
(declare-fun inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@1@@1 () T@$Value)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2 () T@$Value)
(declare-fun |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$2@1| () T@$Value)
(declare-fun inline$$DiemConfig_reconfigure__$def_verify$0$$t9@1 () T@$Value)
(declare-fun call2formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@5 () T@$Value)
(declare-fun inline$$DiemTimestamp_is_genesis_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@5 () T@$Value)
(declare-fun $DiemConfig_Configuration_$CallerDomain@@1 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 117633) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 91291) (- 0 122402)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@9)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@9) (and (=> (= (ControlFlow 0 91291) (- 0 122469)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch) ($Integer 18446744073709551615)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) $abort_flag@9)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch) ($Integer 18446744073709551615)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) $abort_flag@9) (and (=> (= (ControlFlow 0 91291) (- 0 122557)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) $abort_flag@9)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) $abort_flag@9) (and (=> (= (ControlFlow 0 91291) (- 0 122699)) (=> $abort_flag@9 (or (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch) ($Integer 18446744073709551615)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))))))) (=> (=> $abort_flag@9 (or (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch) ($Integer 18446744073709551615)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))))) (and (=> (= (ControlFlow 0 91291) (- 0 122994)) (=> $abort_flag@9 (or (or (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch) ($Integer 18446744073709551615)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer (- 0 1)))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@9 (or (or (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch) ($Integer 18446744073709551615)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer (- 0 1)))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 91291) (- 0 123324)) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 91291) (- 0 123341)) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (= (ControlFlow 0 91291) (- 0 123395)) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) $DiemConfig_Configuration_last_reconfiguration_time (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))))))))))))))))))))))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon56$2_correct  (and (=> (= (ControlFlow 0 90975) (- 0 122246)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (and (and (= $abort_flag@9 $abort_flag@8) (= $abort_code@9 $abort_code@7@@3)) (and (= $DiemConfig_Configuration_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 90975) 91291))) anon0$2_correct@@4)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $DiemConfig_Configuration_$memory) (= (ControlFlow 0 90895) 90975)) inline$$DiemConfig_reconfigure__$def_verify$0$anon56$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $DiemConfig_Configuration_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 90949) 90975))) inline$$DiemConfig_reconfigure__$def_verify$0$anon56$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (and (=> (= (ControlFlow 0 90885) 90949) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 90885) 90895) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$1$dst'@2@@0|) (= (ControlFlow 0 90707) 90885)) inline$$WritebackToGlobal$0$anon0_correct@@0))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))))) (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|) (= (ControlFlow 0 90763) 90885))) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (and (=> (= (ControlFlow 0 90671) 90763) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 90671) 90707) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 90534) 90671)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon84_Then_correct  (=> (and (= inline$$DiemConfig_reconfigure__$def_verify$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (= (ControlFlow 0 90985) 90671)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1) (|p#$Mutation| inline$$BorrowField$5$dst@1) inline$$ReadRef$4$v@1)) (and (=> (= (ControlFlow 0 90520) 90985) inline$$DiemConfig_reconfigure__$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 90520) 90534) inline$$DiemConfig_reconfigure__$def_verify$0$anon84_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon82_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 90526) 90520)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@9 true) (= $abort_code@9 $abort_code@8@@0)) (and (= $DiemConfig_Configuration_$memory@0@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 88614) 91291))) anon0$2_correct@@4)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon9_correct  (=> (and (= $abort_code@8@@0 $abort_code@1@@4) (= (ControlFlow 0 91213) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 91211) 91213)) inline$$DiemConfig_reconfigure__$def_verify$0$anon9_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon61_Then_correct  (=> (= (ControlFlow 0 91221) 91213) inline$$DiemConfig_reconfigure__$def_verify$0$anon9_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon60_Then_correct  (=> $abort_flag@1@@7 (and (=> (= (ControlFlow 0 91205) 91221) inline$$DiemConfig_reconfigure__$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 91205) 91211) inline$$DiemConfig_reconfigure__$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon27_correct  (=> (and (= $abort_code@8@@0 $abort_code@3@@6) (= (ControlFlow 0 91103) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 91101) 91103)) inline$$DiemConfig_reconfigure__$def_verify$0$anon27_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 91111) 91103) inline$$DiemConfig_reconfigure__$def_verify$0$anon27_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon69_Then_correct  (=> $abort_flag@5@@2 (and (=> (= (ControlFlow 0 91095) 91111) inline$$DiemConfig_reconfigure__$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 91095) 91101) inline$$DiemConfig_reconfigure__$def_verify$0$anon70_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon31_correct  (=> (and (= $abort_code@8@@0 $abort_code@4@@7) (= (ControlFlow 0 91083) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 91081) 91083)) inline$$DiemConfig_reconfigure__$def_verify$0$anon31_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 91091) 91083) inline$$DiemConfig_reconfigure__$def_verify$0$anon31_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon71_Then_correct  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 91075) 91091) inline$$DiemConfig_reconfigure__$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 91075) 91081) inline$$DiemConfig_reconfigure__$def_verify$0$anon72_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon37_correct  (=> (and (= $abort_code@8@@0 $abort_code@5@@3) (= (ControlFlow 0 91057) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 91055) 91057)) inline$$DiemConfig_reconfigure__$def_verify$0$anon37_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon75_Then_correct  (=> (= (ControlFlow 0 91065) 91057) inline$$DiemConfig_reconfigure__$def_verify$0$anon37_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon74_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 91049) 91065) inline$$DiemConfig_reconfigure__$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 91049) 91055) inline$$DiemConfig_reconfigure__$def_verify$0$anon75_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon47_correct  (=> (and (= $abort_code@8@@0 $abort_code@7@@3) (= (ControlFlow 0 91027) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 91025) 91027)) inline$$DiemConfig_reconfigure__$def_verify$0$anon47_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon80_Then_correct  (=> (= (ControlFlow 0 91035) 91027) inline$$DiemConfig_reconfigure__$def_verify$0$anon47_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon79_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 91019) 91035) inline$$DiemConfig_reconfigure__$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 91019) 91025) inline$$DiemConfig_reconfigure__$def_verify$0$anon80_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon53_correct  (=> (and (= $abort_code@8@@0 $abort_code@7@@3) (= (ControlFlow 0 90997) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 90995) 90997)) inline$$DiemConfig_reconfigure__$def_verify$0$anon53_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon83_Then_correct  (=> (= (ControlFlow 0 91005) 90997) inline$$DiemConfig_reconfigure__$def_verify$0$anon53_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon82_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 90989) 91005) inline$$DiemConfig_reconfigure__$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 90989) 90995) inline$$DiemConfig_reconfigure__$def_verify$0$anon83_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@0  (=> (= inline$$Event_emit_event$0$t@0@@0 $DiemConfig_NewEpochEvent_type_value) (and (=> (= (ControlFlow 0 90451) 90989) inline$$DiemConfig_reconfigure__$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 90451) 90526) inline$$DiemConfig_reconfigure__$def_verify$0$anon82_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon50$5_correct  (and (=> (= (ControlFlow 0 90461) (- 0 121950)) true) (=> (= (ControlFlow 0 90461) 90451) inline$$Event_emit_event$0$Entry_correct@@0))))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowField$5$dst@1)) (= (ControlFlow 0 90403) 90461)) inline$$DiemConfig_reconfigure__$def_verify$0$anon50$5_correct)))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 90359) 90403)) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 90365) 90403) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 90353) 90365) inline$$DiemConfig_NewEpochEvent_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 90353) 90359) inline$$DiemConfig_NewEpochEvent_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 90345) 90403)) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$DiemConfig_NewEpochEvent_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$ReadRef$3$v@1@@0) (>= (|i#$Integer| inline$$ReadRef$3$v@1@@0) 0)) (<= (|i#$Integer| inline$$ReadRef$3$v@1@@0) $MAX_U64)) (= inline$$DiemConfig_NewEpochEvent_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$ReadRef$3$v@1@@0) 1)))) (and (=> (= (ControlFlow 0 90337) 90353) inline$$DiemConfig_NewEpochEvent_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 90337) 90345) inline$$DiemConfig_NewEpochEvent_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$3$anon0_correct@@0  (=> (and (= inline$$ReadRef$3$v@1@@0 (|v#$Mutation| inline$$BorrowField$6$dst@1)) (= (ControlFlow 0 90197) 90337)) inline$$DiemConfig_NewEpochEvent_pack$0$anon0_correct@@0)))
(let ((inline$$BorrowField$6$anon0_correct  (=> (= inline$$BorrowField$6$p@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$6$size@1 (|size#$Path| inline$$BorrowField$6$p@1)) (= inline$$BorrowField$6$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1) inline$$BorrowField$6$size@1 $DiemConfig_Configuration_epoch) (+ inline$$BorrowField$6$size@1 1)))) (and (= inline$$BorrowField$6$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) inline$$BorrowField$6$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) $DiemConfig_Configuration_epoch))) (= (ControlFlow 0 90159) 90197))) inline$$ReadRef$3$anon0_correct@@0))))
(let ((inline$$BorrowField$5$anon0_correct  (=> (= inline$$BorrowField$5$p@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$5$size@1 (|size#$Path| inline$$BorrowField$5$p@1)) (= inline$$BorrowField$5$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1) inline$$BorrowField$5$size@1 $DiemConfig_Configuration_events) (+ inline$$BorrowField$5$size@1 1)))) (and (= inline$$BorrowField$5$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) inline$$BorrowField$5$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) $DiemConfig_Configuration_events))) (= (ControlFlow 0 89999) 90159))) inline$$BorrowField$6$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$0$dst'@2@@0|) (= (ControlFlow 0 89819) 89999)) inline$$BorrowField$5$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|) (= (ControlFlow 0 89875) 89999))) inline$$BorrowField$5$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (and (=> (= (ControlFlow 0 89783) 89875) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 89783) 89819) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 89646) 89783)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon81_Then_correct  (=> (and (= inline$$DiemConfig_reconfigure__$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 91015) 89783)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1@@0) (|p#$Mutation| inline$$BorrowField$4$dst@1@@0) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 89632) 91015) inline$$DiemConfig_reconfigure__$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 89632) 89646) inline$$DiemConfig_reconfigure__$def_verify$0$anon81_Else_correct)))))
(let ((inline$$BorrowField$4$anon0_correct@@0  (=> (= inline$$BorrowField$4$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$4$size@1@@0 (|size#$Path| inline$$BorrowField$4$p@1@@0)) (= inline$$BorrowField$4$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@0) inline$$BorrowField$4$size@1@@0 $DiemConfig_Configuration_epoch) (+ inline$$BorrowField$4$size@1@@0 1)))) (and (= inline$$BorrowField$4$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$BorrowField$4$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) $DiemConfig_Configuration_epoch))) (= (ControlFlow 0 89573) 89632))) inline$$WriteRef$1$anon0_correct@@0))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon79_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 89579) 89573)) inline$$BorrowField$4$anon0_correct@@0)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_code@7@@3 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@8 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 89443) 91019) inline$$DiemConfig_reconfigure__$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 89443) 89579) inline$$DiemConfig_reconfigure__$def_verify$0$anon79_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$DiemConfig_reconfigure__$def_verify$0$$t21@1)) $MAX_U64) (= (ControlFlow 0 89441) 89443)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$DiemConfig_reconfigure__$def_verify$0$$t21@1))) (=> (and (and (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$DiemConfig_reconfigure__$def_verify$0$$t21@1)))) (= $abort_code@7@@3 $abort_code@5@@3)) (and (= $abort_flag@8 $abort_flag@7) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 89385) 91019) inline$$DiemConfig_reconfigure__$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 89385) 89579) inline$$DiemConfig_reconfigure__$def_verify$0$anon79_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 89355) (- 0 121379)) true) (and (=> (= (ControlFlow 0 89355) 89441) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 89355) 89385) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon44$2_correct  (=> (and (= inline$$DiemConfig_reconfigure__$def_verify$0$$t21@1 ($Integer 1)) (= (ControlFlow 0 89449) 89355)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$ReadRef$2$anon0_correct@@0  (=> (and (= inline$$ReadRef$2$v@1@@0 (|v#$Mutation| inline$$BorrowField$3$dst@1@@0)) (= (ControlFlow 0 89244) 89449)) inline$$DiemConfig_reconfigure__$def_verify$0$anon44$2_correct)))
(let ((inline$$BorrowField$3$anon0_correct@@0  (=> (= inline$$BorrowField$3$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$3$size@1@@0 (|size#$Path| inline$$BorrowField$3$p@1@@0)) (= inline$$BorrowField$3$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@0) inline$$BorrowField$3$size@1@@0 $DiemConfig_Configuration_epoch) (+ inline$$BorrowField$3$size@1@@0 1)))) (and (= inline$$BorrowField$3$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$BorrowField$3$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) $DiemConfig_Configuration_epoch))) (= (ControlFlow 0 89206) 89244))) inline$$ReadRef$2$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 88990) 89206)) inline$$BorrowField$3$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 89046) 89206))) inline$$BorrowField$3$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 88954) 89046) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 88954) 88990) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 88817) 88954)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon78_Then_correct  (=> (and (= inline$$DiemConfig_reconfigure__$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 91045) 88954)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@0) (|p#$Mutation| inline$$BorrowField$2$dst@1@@0) call2formal@$ret0@0)) (and (=> (= (ControlFlow 0 88803) 91045) inline$$DiemConfig_reconfigure__$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 88803) 88817) inline$$DiemConfig_reconfigure__$def_verify$0$anon78_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct@@0  (=> (= inline$$BorrowField$2$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$2$size@1@@0 (|size#$Path| inline$$BorrowField$2$p@1@@0)) (= inline$$BorrowField$2$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@0) inline$$BorrowField$2$size@1@@0 $DiemConfig_Configuration_last_reconfiguration_time) (+ inline$$BorrowField$2$size@1@@0 1)))) (and (= inline$$BorrowField$2$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$2$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $DiemConfig_Configuration_last_reconfiguration_time))) (= (ControlFlow 0 88744) 88803))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon76_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1) (= (ControlFlow 0 88750) 88744)) inline$$BorrowField$2$anon0_correct@@0)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon42_correct  (=> (and (= $abort_code@8@@0 $abort_code@6@@3) (= (ControlFlow 0 88610) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon77_Else_correct  (=> (and (not true) (= (ControlFlow 0 88608) 88610)) inline$$DiemConfig_reconfigure__$def_verify$0$anon42_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon77_Then_correct  (=> (= (ControlFlow 0 88622) 88610) inline$$DiemConfig_reconfigure__$def_verify$0$anon42_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon76_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1)) (= $abort_code@6@@3 (|i#$Integer| call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 88602) 88622) inline$$DiemConfig_reconfigure__$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 88602) 88608) inline$$DiemConfig_reconfigure__$def_verify$0$anon77_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon74_Else_correct  (=> (not $abort_flag@7) (and (=> (= (ControlFlow 0 88590) 88750) inline$$DiemConfig_reconfigure__$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 88590) 88602) inline$$DiemConfig_reconfigure__$def_verify$0$anon76_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon73_Else$2_correct  (=> (and (and (and (= inline$$DiemConfig_reconfigure__$def_verify$0$$t17@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7)) (and (=> $abort_flag@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@14) (>= (|i#$Integer| call3formal@$ret0@0@@14) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@14) $MAX_U64))) (and (=> (= (ControlFlow 0 88584) 91049) inline$$DiemConfig_reconfigure__$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 88584) 88590) inline$$DiemConfig_reconfigure__$def_verify$0$anon74_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct  (=> (and (= inline$$Gt$0$dst@1 ($Boolean (> (|i#$Integer| call2formal@$ret0@0) (|i#$Integer| inline$$ReadRef$1$v@1@@0)))) (= (ControlFlow 0 88572) 88584)) inline$$DiemConfig_reconfigure__$def_verify$0$anon73_Else$2_correct)))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 88558) (- 0 120914)) true) (=> (= (ControlFlow 0 88558) 88572) inline$$Gt$0$anon0_correct))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1@@0)) (= (ControlFlow 0 88500) 88558)) inline$$Gt$0$Entry_correct)))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $DiemConfig_Configuration_last_reconfiguration_time) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $DiemConfig_Configuration_last_reconfiguration_time))) (= (ControlFlow 0 88462) 88500))) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon73_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_reconfigure__$def_verify$0$$t14@1)) (= (ControlFlow 0 88514) 88462)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon68_Then_correct  (=> $abort_flag@4@@4 (=> (and (= $abort_code@8@@0 $abort_code@2@@5) (= (ControlFlow 0 91115) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon65_Then_correct  (=> $abort_flag@3@@4 (=> (and (= $abort_code@8@@0 $abort_code@2@@5) (= (ControlFlow 0 91133) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon57_Then_correct  (=> $abort_flag@0@@7 (=> (and (= $abort_code@8@@0 $abort_code@0) (= (ControlFlow 0 91285) 88614)) inline$$DiemConfig_reconfigure__$def_verify$0$Abort_correct))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon73_Then_correct  (=> (|b#$Boolean| inline$$DiemConfig_reconfigure__$def_verify$0$$t14@1) (=> (and (and (= $abort_flag@9 $abort_flag@6@@0) (= $abort_code@9 $abort_code@4@@7)) (and (= $DiemConfig_Configuration_$memory@0@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 91071) 91291))) anon0$2_correct@@4))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon71_Else$1_correct  (=> (= inline$$DiemConfig_reconfigure__$def_verify$0$$t14@1 ($Boolean ($IsEqual_stratified call2formal@$ret0@0 inline$$ReadRef$0$v@1@@0))) (and (=> (= (ControlFlow 0 88302) 91071) inline$$DiemConfig_reconfigure__$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 88302) 88514) inline$$DiemConfig_reconfigure__$def_verify$0$anon73_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 88278) 88302)) inline$$DiemConfig_reconfigure__$def_verify$0$anon71_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $DiemConfig_Configuration_last_reconfiguration_time) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $DiemConfig_Configuration_last_reconfiguration_time))) (= (ControlFlow 0 88240) 88278))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon71_Else_correct  (=> (and (not $abort_flag@6@@0) (= (ControlFlow 0 88292) 88240)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon69_Else_correct  (=> (not $abort_flag@5@@2) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@0) (=> $abort_flag@6@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@6@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@7 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (and (and ((_ is $Integer) call2formal@$ret0@0) (>= (|i#$Integer| call2formal@$ret0@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 88082) 91075) inline$$DiemConfig_reconfigure__$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 88082) 88292) inline$$DiemConfig_reconfigure__$def_verify$0$anon71_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@5@@2 true) (=> (and (= $abort_code@3@@6 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 88068) 91095) inline$$DiemConfig_reconfigure__$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 88068) 88082) inline$$DiemConfig_reconfigure__$def_verify$0$anon69_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 88066) 88068)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0))) (= $abort_flag@5@@2 $abort_flag@4@@4)) (and (= $abort_code@3@@6 $abort_code@2@@5) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 88014) 91095) inline$$DiemConfig_reconfigure__$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 88014) 88082) inline$$DiemConfig_reconfigure__$def_verify$0$anon69_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$$t0@1)) (and (=> (= (ControlFlow 0 87984) 88066) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 87984) 88014) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 87978) (- 0 120499)) true) (=> (= (ControlFlow 0 87978) 87984) inline$$BorrowGlobal$0$anon0_correct@@0))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon68_Else_correct  (=> (not $abort_flag@4@@4) (and (=> (= (ControlFlow 0 88074) (- 0 120483)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_reconfigure__$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$$t0@1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_reconfigure__$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$$t0@1)) (=> (= (ControlFlow 0 88074) 87978) inline$$BorrowGlobal$0$Entry_correct@@0))))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 87837) 91115) inline$$DiemConfig_reconfigure__$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 87837) 88074) inline$$DiemConfig_reconfigure__$def_verify$0$anon68_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon3_Then_correct  (and (=> (= (ControlFlow 0 87847) 91115) inline$$DiemConfig_reconfigure__$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 87847) 88074) inline$$DiemConfig_reconfigure__$def_verify$0$anon68_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon0_correct  (=> (and (not $abort_flag@4@@4) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 87831) 87847) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon3_Then_correct) (=> (= (ControlFlow 0 87831) 87837) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon3_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon67_Else_correct  (=> (and (not (|b#$Boolean| |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$3@1|)) (= (ControlFlow 0 87861) 87831)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon0_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon67_Then_correct  (=> (|b#$Boolean| |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$3@1|) (=> (and (and (= $abort_flag@9 $abort_flag@4@@4) (= $abort_code@9 $abort_code@2@@5)) (and (= $DiemConfig_Configuration_$memory@0@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 91121) 91291))) anon0$2_correct@@4))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon16_correct  (=> (and (= |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$3@1| inline$$DiemConfig_reconfigure__$def_verify$0$$t10@1) (= $abort_flag@4@@4 $abort_flag@2@@7)) (and (=> (= (ControlFlow 0 91185) 91121) inline$$DiemConfig_reconfigure__$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 91185) 87861) inline$$DiemConfig_reconfigure__$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 91183) 91185)) inline$$DiemConfig_reconfigure__$def_verify$0$anon16_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 91193) 91185) inline$$DiemConfig_reconfigure__$def_verify$0$anon16_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon63_Then_correct  (=> (and (|b#$Boolean| |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$2@2|) (= inline$$DiemConfig_reconfigure__$def_verify$0$$t10@1 ($Boolean true))) (and (=> (= (ControlFlow 0 91175) 91193) inline$$DiemConfig_reconfigure__$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 91175) 91183) inline$$DiemConfig_reconfigure__$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon20_correct  (=> (and (= |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$3@1| inline$$Not$2$dst@1) (= $abort_flag@4@@4 $abort_flag@3@@4)) (and (=> (= (ControlFlow 0 87722) 91121) inline$$DiemConfig_reconfigure__$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 87722) 87861) inline$$DiemConfig_reconfigure__$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 87720) 87722)) inline$$DiemConfig_reconfigure__$def_verify$0$anon20_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 91129) 87722) inline$$DiemConfig_reconfigure__$def_verify$0$anon20_correct)))
(let ((inline$$Not$2$anon0_correct  (=> (= inline$$Not$2$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2@@1)))) (and (=> (= (ControlFlow 0 87706) 91129) inline$$DiemConfig_reconfigure__$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 87706) 87720) inline$$DiemConfig_reconfigure__$def_verify$0$anon66_Else_correct)))))
(let ((inline$$Not$2$Entry_correct  (and (=> (= (ControlFlow 0 87696) (- 0 120356)) true) (=> (= (ControlFlow 0 87696) 87706) inline$$Not$2$anon0_correct))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon65_Else_correct  (=> (and (not $abort_flag@3@@4) (= (ControlFlow 0 87712) 87696)) inline$$Not$2$Entry_correct)))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon4_correct@@1  (=> (and (= $abort_flag@3@@4 $abort_flag@2@@7) (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2@@1 inline$$Not$1$dst@1@@0)) (and (=> (= (ControlFlow 0 87626) 91133) inline$$DiemConfig_reconfigure__$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 87626) 87712) inline$$DiemConfig_reconfigure__$def_verify$0$anon65_Else_correct)))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 87624) 87626)) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon4_correct@@1)))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Then_correct@@1  (=> (= (ControlFlow 0 87634) 87626) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon4_correct@@1)))
(let ((inline$$Not$1$anon0_correct@@0  (=> (= inline$$Not$1$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$DiemConfig_reconfiguration_enabled_$def$0$$t1@1@@1)))) (and (=> (= (ControlFlow 0 87608) 87634) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Then_correct@@1) (=> (= (ControlFlow 0 87608) 87624) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon6_Else_correct@@1)))))
(let ((inline$$Not$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 87598) (- 0 120295)) true) (=> (= (ControlFlow 0 87598) 87608) inline$$Not$1$anon0_correct@@0))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Else_correct@@1  (=> (not $abort_flag@2@@7) (=> (and (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$t1@1@@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@2)))) (= (ControlFlow 0 87614) 87598)) inline$$Not$1$Entry_correct@@0))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Then_correct@@1  (=> (and (and $abort_flag@2@@7 (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@1@@1 $Error)) (and (= $abort_flag@3@@4 true) (= inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@2@@1 inline$$DiemConfig_reconfiguration_enabled_$def$0$$ret0@1@@1))) (and (=> (= (ControlFlow 0 87642) 91133) inline$$DiemConfig_reconfigure__$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 87642) 87712) inline$$DiemConfig_reconfigure__$def_verify$0$anon65_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 87526) 87642) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 87526) 87614) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Else_correct@@1)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@2  (and (=> (= (ControlFlow 0 87536) 87642) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 87536) 87614) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon5_Else_correct@@1))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@2  (=> (and (not $abort_flag@2@@7) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@2 ($Address 173345816))) (and (=> (= (ControlFlow 0 87520) 87536) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 87520) 87526) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@2)))))
(let ((inline$$DiemConfig_reconfiguration_enabled_$def$0$anon0_correct@@1  (=> (and (not $abort_flag@2@@7) (= (ControlFlow 0 87550) 87520)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@2)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon63_Else_correct  (=> (and (not (|b#$Boolean| |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$2@2|)) (= (ControlFlow 0 87656) 87550)) inline$$DiemConfig_reconfiguration_enabled_$def$0$anon0_correct@@1)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon6_correct  (=> (= $abort_code@2@@5 $abort_code@0) (=> (and (= |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$2@2| inline$$DiemConfig_reconfigure__$def_verify$0$$t7@1) (= $abort_flag@2@@7 $abort_flag@0@@7)) (and (=> (= (ControlFlow 0 91273) 91175) inline$$DiemConfig_reconfigure__$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 91273) 87656) inline$$DiemConfig_reconfigure__$def_verify$0$anon63_Else_correct))))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 91271) 91273)) inline$$DiemConfig_reconfigure__$def_verify$0$anon6_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 91281) 91273) inline$$DiemConfig_reconfigure__$def_verify$0$anon6_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon58_Then_correct  (=> (and (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2) (= inline$$DiemConfig_reconfigure__$def_verify$0$$t7@1 ($Boolean true))) (and (=> (= (ControlFlow 0 91263) 91281) inline$$DiemConfig_reconfigure__$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 91263) 91271) inline$$DiemConfig_reconfigure__$def_verify$0$anon59_Else_correct)))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon12_correct  (=> (= $abort_code@2@@5 $abort_code@1@@4) (=> (and (= |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$2@2| |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$2@1|) (= $abort_flag@2@@7 $abort_flag@1@@7)) (and (=> (= (ControlFlow 0 87281) 91175) inline$$DiemConfig_reconfigure__$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 87281) 87656) inline$$DiemConfig_reconfigure__$def_verify$0$anon63_Else_correct))))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 87279) 87281)) inline$$DiemConfig_reconfigure__$def_verify$0$anon12_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 91201) 87281) inline$$DiemConfig_reconfigure__$def_verify$0$anon12_correct)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon60_Else_correct  (=> (not $abort_flag@1@@7) (=> (and (= inline$$DiemConfig_reconfigure__$def_verify$0$$t9@1 ($Integer 0)) (= |inline$$DiemConfig_reconfigure__$def_verify$0$tmp#$2@1| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@0 inline$$DiemConfig_reconfigure__$def_verify$0$$t9@1)))) (and (=> (= (ControlFlow 0 87273) 91201) inline$$DiemConfig_reconfigure__$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 87273) 87279) inline$$DiemConfig_reconfigure__$def_verify$0$anon62_Else_correct))))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon58_Else_correct  (=> (not (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@7) (=> $abort_flag@1@@7 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@1@@7 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@1@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (and (and ((_ is $Integer) call2formal@$ret0@0@@0) (>= (|i#$Integer| call2formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 87255) 91205) inline$$DiemConfig_reconfigure__$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 87255) 87273) inline$$DiemConfig_reconfigure__$def_verify$0$anon60_Else_correct))))))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon57_Else_correct  (=> (not $abort_flag@0@@7) (and (=> (= (ControlFlow 0 87247) 91263) inline$$DiemConfig_reconfigure__$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 87247) 87255) inline$$DiemConfig_reconfigure__$def_verify$0$anon58_Else_correct)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct  (=> (and (= $abort_flag@0@@7 false) (= inline$$DiemTimestamp_is_genesis_$def$0$$ret0@2 inline$$Not$0$dst@1@@5)) (and (=> (= (ControlFlow 0 87209) 91285) inline$$DiemConfig_reconfigure__$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 87209) 87247) inline$$DiemConfig_reconfigure__$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 87207) 87209)) inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct)))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 87217) 87209) inline$$DiemTimestamp_is_genesis_$def$0$anon4_correct)))
(let ((inline$$Not$0$anon0_correct@@5  (=> (= inline$$Not$0$dst@1@@5 ($Boolean  (not (|b#$Boolean| inline$$DiemTimestamp_is_genesis_$def$0$$t1@1)))) (and (=> (= (ControlFlow 0 87191) 87217) inline$$DiemTimestamp_is_genesis_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 87191) 87207) inline$$DiemTimestamp_is_genesis_$def$0$anon6_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@5  (and (=> (= (ControlFlow 0 87181) (- 0 119914)) true) (=> (= (ControlFlow 0 87181) 87191) inline$$Not$0$anon0_correct@@5))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct  (=> (not false) (=> (and (= inline$$DiemTimestamp_is_genesis_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@5)))) (= (ControlFlow 0 87197) 87181)) inline$$Not$0$Entry_correct@@5))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@5  (=> (not true) (and (=> (= (ControlFlow 0 87109) 87225) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 87109) 87197) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@5  (and (=> (= (ControlFlow 0 87119) 87225) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 87119) 87197) inline$$DiemTimestamp_is_genesis_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@5  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@5 ($Address 173345816))) (and (=> (= (ControlFlow 0 87103) 87119) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 87103) 87109) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@5)))))
(let ((inline$$DiemTimestamp_is_genesis_$def$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 87133) 87103)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@5)))
(let ((inline$$DiemConfig_reconfigure__$def_verify$0$anon0_correct  (=> (not false) (=> (and (= inline$$DiemConfig_reconfigure__$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 87239) 87133)) inline$$DiemTimestamp_is_genesis_$def$0$anon0_correct))))
(let ((anon0$1_correct@@8  (=> (and (forall (($inv_addr@@19 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@19)) (let ((va@@37 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@19))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@19))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@19))
)) (forall (($inv_addr@@20 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20)) (let ((va@@38 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@3))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@20))
))) (=> (and (and (forall (($inv_addr@@21 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@21)) (let ((va@@41 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@21))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@21))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@21))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@21))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 91289) 87239))) inline$$DiemConfig_reconfigure__$def_verify$0$anon0_correct))))
(let ((anon0_correct@@8  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_Configuration_$CallerDomain@@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 117633) 91289)) anon0$1_correct@@8)))
anon0_correct@@8)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@5 () T@$TypeValue)
(declare-fun account () T@$Value)
(declare-fun $abort_flag@5@@3 () Bool)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@0 () T@$Memory)
(declare-fun payload@@1 () T@$Value)
(declare-fun $DiemConfig_Configuration_$memory@2@@0 () T@$Memory)
(declare-fun $abort_flag@4@@5 () Bool)
(declare-fun $abort_code@7@@4 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0@@2 () T@$Memory)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1@@1 () T@$Memory)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun $abort_code@2@@6 () Int)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun $abort_code@4@@8 () Int)
(declare-fun $abort_flag@2@@8 () Bool)
(declare-fun $abort_code@6@@4 () Int)
(declare-fun $abort_flag@3@@5 () Bool)
(declare-fun inline$$DiemConfig_set_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$DiemConfig_set_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@6 () T@$Value)
(declare-fun inline$$DiemConfig_set_$def_verify$0$$t14@1 () T@$Value)
(declare-fun $abort_code@5@@4 () Int)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$DiemConfig_set_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$DiemConfig_set_$def_verify$0$$t11@1 () T@$Value)
(declare-fun $abort_code@3@@7 () Int)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$DiemConfig_set_$def_verify$0$$t12@1 () T@$Value)
(declare-fun $DiemConfig_Configuration_$CallerDomain@@2 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 123494) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 94772) (- 0 127476)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| account))))))) $abort_flag@5@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| account))))))) $abort_flag@5@@3) (and (=> (= (ControlFlow 0 94772) (- 0 127509)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@3) (and (=> (= (ControlFlow 0 94772) (- 0 127539)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@5@@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@5@@3) (and (=> (= (ControlFlow 0 94772) (- 0 127638)) (=> $abort_flag@5@@3 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (=> (=> $abort_flag@5@@3 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))) (and (=> (= (ControlFlow 0 94772) (- 0 127798)) (=> $abort_flag@5@@3 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| account))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@5@@3 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| account))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 94772) (- 0 127991)) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 94772) (- 0 128003)) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)) payload@@1))))) (=> (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)) payload@@1)))) (=> (= (ControlFlow 0 94772) (- 0 128021)) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))))))))))))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon53_Else_correct  (=> (and (not $abort_flag@4@@5) (= $abort_code@9@@0 $abort_code@7@@4)) (=> (and (and (= $abort_flag@5@@3 $abort_flag@4@@5) (= $DiemConfig_DiemConfig_$memory@1@@0 |inline$$WritebackToGlobal$0$m'@2@@1|)) (and (= $DiemConfig_Configuration_$memory@2@@0 $DiemConfig_Configuration_$memory@0@@2) (= (ControlFlow 0 94636) 94772))) anon0$2_correct@@5))))
(let ((inline$$DiemConfig_set_$def_verify$0$Abort_correct  (=> (= $abort_code@9@@0 $abort_code@8@@1) (=> (and (and (= $abort_flag@5@@3 true) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory@0@@1)) (and (= $DiemConfig_Configuration_$memory@2@@0 $DiemConfig_Configuration_$memory@1@@1) (= (ControlFlow 0 93428) 94772))) anon0$2_correct@@5))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon7_correct  (=> (and (and (= $abort_code@8@@1 $abort_code@1@@5) (= $DiemConfig_DiemConfig_$memory@0@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 94742) 93428))) inline$$DiemConfig_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 94740) 94742)) inline$$DiemConfig_set_$def_verify$0$anon7_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 94750) 94742) inline$$DiemConfig_set_$def_verify$0$anon7_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon39_Then_correct  (=> $abort_flag@0@@8 (and (=> (= (ControlFlow 0 94734) 94750) inline$$DiemConfig_set_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 94734) 94740) inline$$DiemConfig_set_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon11_correct  (=> (and (and (= $abort_code@8@@1 $abort_code@2@@6) (= $DiemConfig_DiemConfig_$memory@0@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 94722) 93428))) inline$$DiemConfig_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 94720) 94722)) inline$$DiemConfig_set_$def_verify$0$anon11_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 94730) 94722) inline$$DiemConfig_set_$def_verify$0$anon11_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon41_Then_correct  (=> $abort_flag@1@@8 (and (=> (= (ControlFlow 0 94714) 94730) inline$$DiemConfig_set_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 94714) 94720) inline$$DiemConfig_set_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon21_correct  (=> (and (and (= $abort_code@8@@1 $abort_code@4@@8) (= $DiemConfig_DiemConfig_$memory@0@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 94698) 93428))) inline$$DiemConfig_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 94696) 94698)) inline$$DiemConfig_set_$def_verify$0$anon21_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 94706) 94698) inline$$DiemConfig_set_$def_verify$0$anon21_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon46_Then_correct  (=> $abort_flag@2@@8 (and (=> (= (ControlFlow 0 94690) 94706) inline$$DiemConfig_set_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 94690) 94696) inline$$DiemConfig_set_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon29_correct  (=> (and (and (= $abort_code@8@@1 $abort_code@6@@4) (= $DiemConfig_DiemConfig_$memory@0@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 94678) 93428))) inline$$DiemConfig_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 94676) 94678)) inline$$DiemConfig_set_$def_verify$0$anon29_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 94686) 94678) inline$$DiemConfig_set_$def_verify$0$anon29_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon50_Then_correct  (=> $abort_flag@3@@5 (and (=> (= (ControlFlow 0 94670) 94686) inline$$DiemConfig_set_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 94670) 94676) inline$$DiemConfig_set_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon35_correct  (=> (and (and (= $abort_code@8@@1 $abort_code@7@@4) (= $DiemConfig_DiemConfig_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@1|)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory@0@@2) (= (ControlFlow 0 94648) 93428))) inline$$DiemConfig_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 94646) 94648)) inline$$DiemConfig_set_$def_verify$0$anon35_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 94656) 94648) inline$$DiemConfig_set_$def_verify$0$anon35_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon53_Then_correct  (=> $abort_flag@4@@5 (and (=> (= (ControlFlow 0 94640) 94656) inline$$DiemConfig_set_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 94640) 94646) inline$$DiemConfig_set_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon32$2_correct  (and (=> (= (ControlFlow 0 94630) (- 0 126452)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_$def_verify$0$config_address T@$Value) )  (=> ((_ is $Address) inline$$DiemConfig_set_$def_verify$0$config_address) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_$def_verify$0$config_type T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_$def_verify$0$config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type)) 1) (|a#$Address| inline$$DiemConfig_set_$def_verify$0$config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemConfig_set_$def_verify$0$config_address ($Address 173345816)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_$def_verify$0$config_address@@0 T@$Value) )  (=> ((_ is $Address) inline$$DiemConfig_set_$def_verify$0$config_address@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_$def_verify$0$config_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_$def_verify$0$config_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type@@0)) 1) (|a#$Address| inline$$DiemConfig_set_$def_verify$0$config_address@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemConfig_set_$def_verify$0$config_address@@0 ($Address 173345816))))))))))))))) (and (=> (= (ControlFlow 0 94630) (- 0 126517)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_$def_verify$0$config_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_$def_verify$0$config_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type@@1)) 1) (|a#$Address| ($Address 173345816)))))))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_$def_verify$0$config_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_$def_verify$0$config_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type@@2)) 1) (|a#$Address| ($Address 173345816))))))))))))))) (and (=> (= (ControlFlow 0 94630) (- 0 126566)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_$def_verify$0$config_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_$def_verify$0$config_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type@@3)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type@@3)) 1) (|a#$Address| ($Address 173345816))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_$def_verify$0$config_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_$def_verify$0$config_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type@@4)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_$def_verify$0$config_type@@4)) 1) (|a#$Address| ($Address 173345816)))))))))))) (and (=> (= (ControlFlow 0 94630) (- 0 126605)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_set_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_set_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) $abort_flag@4@@5) (=> $abort_flag@4@@5 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))))) (and (=> $abort_flag@4@@5 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (= $abort_code@7@@4 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) $DiemConfig_Configuration_last_reconfiguration_time (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@2) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@2) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 94630) 94640) inline$$DiemConfig_set_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 94630) 94636) inline$$DiemConfig_set_$def_verify$0$anon53_Else_correct)))))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@1| $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 94412) 94630)) inline$$DiemConfig_set_$def_verify$0$anon32$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $DiemConfig_DiemConfig_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@1|) (= (ControlFlow 0 94466) 94630))) inline$$DiemConfig_set_$def_verify$0$anon32$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 94402) 94466) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 94402) 94412) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 94220) 94402)) inline$$WritebackToGlobal$0$anon0_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 94276) 94402))) inline$$WritebackToGlobal$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) (and (=> (= (ControlFlow 0 94184) 94276) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 94184) 94220) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 94047) 94184)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon52_Then_correct  (=> (and (= inline$$DiemConfig_set_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 94666) 94184)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@1) (|p#$Mutation| inline$$BorrowField$0$dst@1@@1) payload@@1)) (and (=> (= (ControlFlow 0 94033) 94666) inline$$DiemConfig_set_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 94033) 94047) inline$$DiemConfig_set_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $DiemConfig_DiemConfig_payload) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $DiemConfig_DiemConfig_payload))) (= (ControlFlow 0 93974) 94033))) inline$$WriteRef$0$anon0_correct@@1))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon50_Else_correct  (=> (and (not $abort_flag@3@@5) (= (ControlFlow 0 93980) 93974)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@3@@5 true) (=> (and (= $abort_code@6@@4 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 93844) 94670) inline$$DiemConfig_set_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 93844) 93980) inline$$DiemConfig_set_$def_verify$0$anon50_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 93842) 93844)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1@@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1@@1))) (= $abort_flag@3@@5 $abort_flag@2@@8)) (and (= $abort_code@6@@4 $abort_code@4@@8) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 93790) 94670) inline$$DiemConfig_set_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 93790) 93980) inline$$DiemConfig_set_$def_verify$0$anon50_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@6)) (and (=> (= (ControlFlow 0 93760) 93842) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 93760) 93790) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (=> (= inline$$BorrowGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1)) (and (=> (= (ControlFlow 0 93754) (- 0 126007)) true) (=> (= (ControlFlow 0 93754) 93760) inline$$BorrowGlobal$0$anon0_correct@@1)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon48_Then_correct  (=> (and (|b#$Boolean| inline$$DiemConfig_set_$def_verify$0$$t14@1) (= (ControlFlow 0 93850) 93754)) inline$$BorrowGlobal$0$Entry_correct@@1)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon26_correct  (=> (and (and (= $abort_code@8@@1 $abort_code@5@@4) (= $DiemConfig_DiemConfig_$memory@0@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 93629) 93428))) inline$$DiemConfig_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 93627) 93629)) inline$$DiemConfig_set_$def_verify$0$anon26_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 93637) 93629) inline$$DiemConfig_set_$def_verify$0$anon26_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon48_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_set_$def_verify$0$$t14@1)) (= $abort_code@5@@4 (|i#$Integer| call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 93621) 93637) inline$$DiemConfig_set_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 93621) 93627) inline$$DiemConfig_set_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon46_Else_correct  (=> (not $abort_flag@2@@8) (and (=> (= (ControlFlow 0 93609) 93850) inline$$DiemConfig_set_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 93609) 93621) inline$$DiemConfig_set_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon45_Else_correct  (=> (and (not $abort_flag@1@@8) (= inline$$DiemConfig_set_$def_verify$0$$t14@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@6))))) (=> (and (and (and (= inline$$DiemConfig_set_$def_verify$0$$t15@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@8)) (and (=> $abort_flag@2@@8 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@15) (>= (|i#$Integer| call3formal@$ret0@0@@15) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@15) $MAX_U64))) (and (=> (= (ControlFlow 0 93603) 94690) inline$$DiemConfig_set_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 93603) 93609) inline$$DiemConfig_set_$def_verify$0$anon46_Else_correct))))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon45_Then_correct  (=> $abort_flag@1@@8 (=> (and (and (= $abort_code@8@@1 $abort_code@2@@6) (= $DiemConfig_DiemConfig_$memory@0@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 94710) 93428))) inline$$DiemConfig_set_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@6  (=> (not true) (and (=> (= (ControlFlow 0 93547) 94710) inline$$DiemConfig_set_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 93547) 93603) inline$$DiemConfig_set_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@6  (and (=> (= (ControlFlow 0 93557) 94710) inline$$DiemConfig_set_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 93557) 93603) inline$$DiemConfig_set_$def_verify$0$anon45_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@6  (=> (and (not $abort_flag@1@@8) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@6 ($Address 173345816))) (and (=> (= (ControlFlow 0 93541) 93557) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 93541) 93547) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@6)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon43_Then_correct  (=> (and (|b#$Boolean| inline$$DiemConfig_set_$def_verify$0$$t11@1) (= (ControlFlow 0 93571) 93541)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@6)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@8@@1 $abort_code@3@@7) (= $DiemConfig_DiemConfig_$memory@0@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 93424) 93428))) inline$$DiemConfig_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 93422) 93424)) inline$$DiemConfig_set_$def_verify$0$anon16_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 93436) 93424) inline$$DiemConfig_set_$def_verify$0$anon16_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon43_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_set_$def_verify$0$$t11@1)) (= $abort_code@3@@7 (|i#$Integer| call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 93416) 93436) inline$$DiemConfig_set_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 93416) 93422) inline$$DiemConfig_set_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon41_Else_correct  (=> (not $abort_flag@1@@8) (and (=> (= (ControlFlow 0 93404) 93571) inline$$DiemConfig_set_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 93404) 93416) inline$$DiemConfig_set_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@0@@8) (= inline$$DiemConfig_set_$def_verify$0$$t11@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1) (|a#$Address| call3formal@$ret0@0@@17))))) (=> (and (and (and (= inline$$DiemConfig_set_$def_verify$0$$t12@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@8)) (and (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 ($Integer 4))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@16) (>= (|i#$Integer| call3formal@$ret0@0@@16) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@16) $MAX_U64))) (and (=> (= (ControlFlow 0 93398) 94714) inline$$DiemConfig_set_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 93398) 93404) inline$$DiemConfig_set_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@8) (=> $abort_flag@0@@8 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 account)))) ((_ is $Address) call3formal@$ret0@0@@17))) (and (=> (= (ControlFlow 0 93368) 94734) inline$$DiemConfig_set_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 93368) 93398) inline$$DiemConfig_set_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon4_correct  (=> (and (= inline$$DiemConfig_set_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 93332) 93368)) inline$$DiemConfig_set_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 93284) 93332)) inline$$DiemConfig_set_$def_verify$0$anon4_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 94758) 93332) inline$$DiemConfig_set_$def_verify$0$anon4_correct)))
(let ((inline$$DiemConfig_set_$def_verify$0$anon37_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 93276) 94758) inline$$DiemConfig_set_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 93276) 93284) inline$$DiemConfig_set_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon37_Then_correct  (and (=> (= (ControlFlow 0 94766) 94758) inline$$DiemConfig_set_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 94766) 93284) inline$$DiemConfig_set_$def_verify$0$anon38_Else_correct))))
(let ((inline$$DiemConfig_set_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 93270) 94766) inline$$DiemConfig_set_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 93270) 93276) inline$$DiemConfig_set_$def_verify$0$anon37_Else_correct)))))
(let ((anon0$1_correct@@9  (=> (forall (($inv_addr@@22 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22)) (let ((va@@42 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))
)) (=> (and (and (and (forall (($inv_addr@@23 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@23)) (let ((va@@43 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@23))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@23))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@23))
)) (forall (($inv_addr@@24 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24)) (let ((va@@44 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@46 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@4))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@24))
))) (and (forall (($inv_addr@@25 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@25)) (let ((va@@47 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@25))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@25))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@25))
)) (forall (($inv_addr@@26 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@26)) (let ((va@@48 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@26))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@26))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@26))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@26))
)))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((config_address@@2 T@$Value) )  (=> ((_ is $Address) config_address@@2) (|b#$Boolean| ($Boolean (forall ((config_type@@2 T@$Value) )  (=> ((_ is $Type) config_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@2)) 1) (|a#$Address| config_address@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@2 ($Address 173345816))))))))))))))) (= (ControlFlow 0 94770) 93270)))) inline$$DiemConfig_set_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@9  (=> (and ((_ is $Address) account) (= (ControlFlow 0 92148) 94770)) anon0$1_correct@@9)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_Configuration_$CallerDomain@@2 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 123494) 92148)) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@5)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@6 () T@$TypeValue)
(declare-fun $abort_flag@3@@6 () Bool)
(declare-fun $abort_code@6@@5 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@1 () T@$Memory)
(declare-fun payload@@2 () T@$Value)
(declare-fun $DiemConfig_Configuration_$memory@2@@1 () T@$Memory)
(declare-fun $abort_flag@2@@9 () Bool)
(declare-fun $abort_code@4@@9 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@2| () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0@@3 () T@$Memory)
(declare-fun $abort_code@5@@5 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@2 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1@@2 () T@$Memory)
(declare-fun $abort_code@1@@6 () Int)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun $abort_code@3@@8 () Int)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$WritebackToGlobal$0$l@1@@2 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@2 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@2 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@2| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@2 () Int)
(declare-fun inline$$BorrowField$0$p@2@@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@2 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@2 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@7 () T@$Value)
(declare-fun inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@2@@7 () Int)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$t8@1 () T@$Value)
(declare-fun _cap () T@$Value)
(declare-fun $DiemConfig_DiemConfig_$CallerDomain@@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemConfig_Configuration_$CallerDomain@@3 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 128046) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 97485) (- 0 131555)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@6) (and (=> (= (ControlFlow 0 97485) (- 0 131585)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@3@@6)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@3@@6) (and (=> (= (ControlFlow 0 97485) (- 0 131684)) (=> $abort_flag@3@@6 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (=> (=> $abort_flag@3@@6 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))) (and (=> (= (ControlFlow 0 97485) (- 0 131812)) (=> $abort_flag@3@@6 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@3@@6 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@6@@5 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 97485) (- 0 131962)) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 97485) (- 0 131974)) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)) payload@@2))))) (=> (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)) payload@@2)))) (=> (= (ControlFlow 0 97485) (- 0 131992)) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))))))))))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon35_Else_correct  (=> (and (not $abort_flag@2@@9) (= $abort_code@6@@5 $abort_code@4@@9)) (=> (and (and (= $abort_flag@3@@6 $abort_flag@2@@9) (= $DiemConfig_DiemConfig_$memory@1@@1 |inline$$WritebackToGlobal$0$m'@2@@2|)) (and (= $DiemConfig_Configuration_$memory@2@@1 $DiemConfig_Configuration_$memory@0@@3) (= (ControlFlow 0 97389) 97485))) anon0$2_correct@@6))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$Abort_correct  (=> (= $abort_code@6@@5 $abort_code@5@@5) (=> (and (and (= $abort_flag@3@@6 true) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory@0@@2)) (and (= $DiemConfig_Configuration_$memory@2@@1 $DiemConfig_Configuration_$memory@1@@2) (= (ControlFlow 0 96360) 97485))) anon0$2_correct@@6))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon9_correct  (=> (and (and (= $abort_code@5@@5 $abort_code@1@@6) (= $DiemConfig_DiemConfig_$memory@0@@2 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@2 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 97451) 96360))) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 97449) 97451)) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon9_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 97459) 97451) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon9_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 97443) 97459) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 97443) 97449) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon17_correct  (=> (and (and (= $abort_code@5@@5 $abort_code@3@@8) (= $DiemConfig_DiemConfig_$memory@0@@2 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@2 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 97431) 96360))) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 97429) 97431)) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon17_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 97439) 97431) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon17_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon32_Then_correct  (=> $abort_flag@1@@9 (and (=> (= (ControlFlow 0 97423) 97439) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 97423) 97429) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon23_correct  (=> (and (and (= $abort_code@5@@5 $abort_code@4@@9) (= $DiemConfig_DiemConfig_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@2|)) (and (= $DiemConfig_Configuration_$memory@1@@2 $DiemConfig_Configuration_$memory@0@@3) (= (ControlFlow 0 97401) 96360))) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 97399) 97401)) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon23_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 97409) 97401) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon23_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon35_Then_correct  (=> $abort_flag@2@@9 (and (=> (= (ControlFlow 0 97393) 97409) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 97393) 97399) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon20$2_correct  (and (=> (= (ControlFlow 0 97383) (- 0 130586)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_address T@$Value) )  (=> ((_ is $Address) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_address) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type)) 1) (|a#$Address| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_address ($Address 173345816)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_address@@0 T@$Value) )  (=> ((_ is $Address) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_address@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@0)) 1) (|a#$Address| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_address@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_address@@0 ($Address 173345816))))))))))))))) (and (=> (= (ControlFlow 0 97383) (- 0 130651)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@1)) 1) (|a#$Address| ($Address 173345816)))))))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@2)) 1) (|a#$Address| ($Address 173345816))))))))))))))) (and (=> (= (ControlFlow 0 97383) (- 0 130700)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@3)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@3)) 1) (|a#$Address| ($Address 173345816))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@4)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$config_type@@4)) 1) (|a#$Address| ($Address 173345816)))))))))))) (and (=> (= (ControlFlow 0 97383) (- 0 130739)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) $abort_flag@2@@9) (=> $abort_flag@2@@9 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))))) (and (=> $abort_flag@2@@9 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (= $abort_code@4@@9 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) $DiemConfig_Configuration_last_reconfiguration_time (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@3) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@3) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 97383) 97393) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 97383) 97389) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon35_Else_correct)))))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@2  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@2| $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 97165) 97383)) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon20$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@2  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@2 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@2)) (= inline$$WritebackToGlobal$0$a@1@@2 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@2))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@2 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|))) (= |inline$$WritebackToGlobal$0$m'@1@@2| ($Memory (|domain#$Memory| $DiemConfig_DiemConfig_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2 inline$$WritebackToGlobal$0$v@1@@2)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@2| |inline$$WritebackToGlobal$0$m'@1@@2|) (= (ControlFlow 0 97219) 97383))) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon20$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@2  (=> (= inline$$WritebackToGlobal$0$l@1@@2 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|)) (and (=> (= (ControlFlow 0 97155) 97219) inline$$WritebackToGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 97155) 97165) inline$$WritebackToGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@2| inline$$BorrowGlobal$0$dst@2@@2) (= (ControlFlow 0 96973) 97155)) inline$$WritebackToGlobal$0$anon0_correct@@2))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2)) (= |inline$$WritebackToReference$0$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$WritebackToReference$0$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@2| |inline$$WritebackToReference$0$dst'@1@@2|) (= (ControlFlow 0 97029) 97155))) inline$$WritebackToGlobal$0$anon0_correct@@2)))
(let ((inline$$WritebackToReference$0$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= inline$$WritebackToReference$0$dstPath@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) (and (=> (= (ControlFlow 0 96937) 97029) inline$$WritebackToReference$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 96937) 96973) inline$$WritebackToReference$0$anon3_Else_correct@@2)))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 96800) 96937)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon34_Then_correct  (=> (and (= inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (= (ControlFlow 0 97419) 96937)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@2) (|p#$Mutation| inline$$BorrowField$0$dst@1@@2) payload@@2)) (and (=> (= (ControlFlow 0 96786) 97419) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 96786) 96800) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@2  (=> (= inline$$BorrowField$0$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@2 (|size#$Path| inline$$BorrowField$0$p@1@@2)) (= inline$$BorrowField$0$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@2) inline$$BorrowField$0$size@1@@2 $DiemConfig_DiemConfig_payload) (+ inline$$BorrowField$0$size@1@@2 1)))) (and (= inline$$BorrowField$0$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$BorrowField$0$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) $DiemConfig_DiemConfig_payload))) (= (ControlFlow 0 96727) 96786))) inline$$WriteRef$0$anon0_correct@@2))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon32_Else_correct  (=> (and (not $abort_flag@1@@9) (= (ControlFlow 0 96733) 96727)) inline$$BorrowField$0$anon0_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@1@@9 true) (=> (and (= $abort_code@3@@8 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 96597) 97423) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 96597) 96733) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@2)) (= (ControlFlow 0 96595) 96597)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@2  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@2) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@2 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@2) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@2))) (= $abort_flag@1@@9 $abort_flag@0@@9)) (and (= $abort_code@3@@8 $abort_code@1@@6) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 96543) 97423) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 96543) 96733) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@2  (=> (= inline$$BorrowGlobal$0$a@1@@2 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@7)) (and (=> (= (ControlFlow 0 96513) 96595) inline$$BorrowGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 96513) 96543) inline$$BorrowGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@2  (=> (= inline$$BorrowGlobal$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1)) (and (=> (= (ControlFlow 0 96507) (- 0 130141)) true) (=> (= (ControlFlow 0 96507) 96513) inline$$BorrowGlobal$0$anon0_correct@@2)))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon30_Then_correct  (=> (|b#$Boolean| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$t7@1) (and (=> (= (ControlFlow 0 96603) (- 0 130073)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@7))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@7)) (=> (= (ControlFlow 0 96603) 96507) inline$$BorrowGlobal$0$Entry_correct@@2))))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon14_correct  (=> (and (and (= $abort_code@5@@5 $abort_code@2@@7) (= $DiemConfig_DiemConfig_$memory@0@@2 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@2 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 96356) 96360))) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$Abort_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 96354) 96356)) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon14_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 96368) 96356) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon14_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon30_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$t7@1)) (= $abort_code@2@@7 (|i#$Integer| call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 96348) 96368) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 96348) 96354) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon28_Else_correct  (=> (not $abort_flag@0@@9) (and (=> (= (ControlFlow 0 96336) 96603) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 96336) 96348) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon27_Else_correct  (=> (and (not false) (= inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@7))))) (=> (and (and (and (= inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$t8@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@9)) (and (=> $abort_flag@0@@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@18) (>= (|i#$Integer| call3formal@$ret0@0@@18) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@18) $MAX_U64))) (and (=> (= (ControlFlow 0 96330) 97443) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 96330) 96336) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon27_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@7  (=> (not true) (and (=> (= (ControlFlow 0 96274) 97463) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 96274) 96330) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@7  (and (=> (= (ControlFlow 0 96284) 97463) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 96284) 96330) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon27_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@7  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@7 ($Address 173345816))) (and (=> (= (ControlFlow 0 96268) 96284) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 96268) 96274) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@7)))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon4_correct  (=> (= inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816)) true)) (=> (and (= inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 96167) 96268)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@7))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 96093) 96167)) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon4_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 97471) 96167) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon4_correct)))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 96085) 97471) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 96085) 96093) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 97479) 97471) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 97479) 96093) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon26_Else_correct))))
(let ((inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 96079) 97479) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 96079) 96085) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@10  (=> (and (and (and (forall (($inv_addr@@27 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27)) (let ((va@@49 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))
)) (forall (($inv_addr@@28 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@28)) (let ((va@@50 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@28))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@28))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@28))
))) (and (forall (($inv_addr@@29 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29)) (let ((va@@51 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@53 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@5))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@29))
)) (forall (($inv_addr@@30 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@30)) (let ((va@@54 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@30))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@30))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@30))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@30))
)))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((config_address@@3 T@$Value) )  (=> ((_ is $Address) config_address@@3) (|b#$Boolean| ($Boolean (forall ((config_type@@3 T@$Value) )  (=> ((_ is $Type) config_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@3)) 1) (|a#$Address| config_address@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@3 ($Address 173345816))))))))))))))) (= (ControlFlow 0 97483) 96079)))) inline$$DiemConfig_set_with_capability_and_reconfigure_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@10  (=> (and (and (and (and (and ((_ is $Vector) _cap) (let ((va@@55 (|v#$Vector| _cap)))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))) (= (|l#$ValueArray| (|v#$Vector| _cap)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _cap)) $DiemConfig_ModifyConfigCapability_dummy_field))) true) (= (ControlFlow 0 95134) 97483)) anon0$1_correct@@10)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_DiemConfig_$CallerDomain@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1) (|a#$Address| ($Address 173345816))) (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_Configuration_$CallerDomain@@3 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 128046) 95134)) anon0_correct@@10))))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
