(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $DiemSystem_DiemSystem () T@$TypeName)
(declare-fun $DiemSystem_CapabilityHolder () T@$TypeName)
(declare-fun $DiemSystem_ValidatorInfo () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $DiemSystem_DiemSystem_scheme () Int)
(declare-fun $DiemSystem_DiemSystem_validators () Int)
(declare-fun $DiemSystem_DiemSystem_type_value () T@$TypeValue)
(declare-fun $DiemSystem_CapabilityHolder_cap () Int)
(declare-fun $DiemSystem_CapabilityHolder_type_value () T@$TypeValue)
(declare-fun $DiemSystem_ValidatorInfo_addr () Int)
(declare-fun $DiemSystem_ValidatorInfo_consensus_voting_power () Int)
(declare-fun $DiemSystem_ValidatorInfo_config () Int)
(declare-fun $DiemSystem_ValidatorInfo_last_config_update_time () Int)
(declare-fun $DiemSystem_ValidatorInfo_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_Config $ValidatorConfig_ValidatorConfig $DiemSystem_DiemSystem $DiemSystem_CapabilityHolder $DiemSystem_ValidatorInfo)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@0) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@0))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@2) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($Option_Option_type_value $tv0@@2))
)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $DiemSystem_DiemSystem_scheme 0))
(assert (= $DiemSystem_DiemSystem_validators 1))
(assert (= $DiemSystem_DiemSystem_type_value ($StructType $DiemSystem_DiemSystem $EmptyTypeValueArray)))
(assert (= $DiemSystem_CapabilityHolder_cap 0))
(assert (= $DiemSystem_CapabilityHolder_type_value ($StructType $DiemSystem_CapabilityHolder $EmptyTypeValueArray)))
(assert (= $DiemSystem_ValidatorInfo_addr 0))
(assert (= $DiemSystem_ValidatorInfo_consensus_voting_power 1))
(assert (= $DiemSystem_ValidatorInfo_config 2))
(assert (= $DiemSystem_ValidatorInfo_last_config_update_time 3))
(assert (= $DiemSystem_ValidatorInfo_type_value ($StructType $DiemSystem_ValidatorInfo $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory () T@$Memory)
(declare-fun validator_addr () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun dr_account () T@$Value)
(declare-fun $DiemConfig_DisableReconfiguration_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $abort_code@14 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@2 () T@$Memory)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0 () T@$Memory)
(declare-fun $abort_code@13 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1 () T@$Memory)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun call2formal@$DiemConfig_Configuration_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemSystem_add_validator_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun call2formal@$ret0@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$DiemSystem_ValidatorInfo_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0 () T@$TypeValue)
(declare-fun inline$$DiemSystem_add_validator_$def_verify$0$$t26@1 () T@$Value)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun call2formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@10 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$DiemSystem_add_validator_$def_verify$0$$t21@1 () T@$Value)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$DiemSystem_add_validator_$def_verify$0$$t16@1 () T@$Value)
(declare-fun $Option_Option_$memory () T@$Memory)
(declare-fun $DiemSystem_DiemSystem_$memory () T@$Memory)
(declare-fun $DiemSystem_CapabilityHolder_$memory () T@$Memory)
(declare-fun $DiemSystem_ValidatorInfo_$memory () T@$Memory)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 133091) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 110050) (- 0 139855)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 139872)) (=> (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0 Int) )  (and (and (>= $i_0 0) (< $i_0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((v@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@14)) $DiemSystem_ValidatorInfo_addr) validator_addr))))))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@0 Int) )  (and (and (>= $i_0@@0 0) (< $i_0@@0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((v@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@14)) $DiemSystem_ValidatorInfo_addr) validator_addr))))))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 139882)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 139897)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 139918)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 139947)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 139964)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 140063)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 140084)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 140113)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@10)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@10) (and (=> (= (ControlFlow 0 110050) (- 0 140130)) (=> $abort_flag@10 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@1 Int) )  (and (and (>= $i_0@@1 0) (< $i_0@@1 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((v@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) $DiemSystem_ValidatorInfo_addr) validator_addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))))) (=> (=> $abort_flag@10 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@2 Int) )  (and (and (>= $i_0@@2 0) (< $i_0@@2 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((v@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) $DiemSystem_ValidatorInfo_addr) validator_addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (and (=> (= (ControlFlow 0 110050) (- 0 140396)) (=> $abort_flag@10 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))) (= $abort_code@14 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (let (($range_1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@3 Int) )  (and (and (>= $i_0@@3 0) (< $i_0@@3 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((v@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) $DiemSystem_ValidatorInfo_addr) validator_addr))))))))) (= $abort_code@14 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@14 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@14 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@14 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@14 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@14 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@14 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@14 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@14 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@10 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))) (= $abort_code@14 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (let (($range_1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@4 Int) )  (and (and (>= $i_0@@4 0) (< $i_0@@4 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((v@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) $DiemSystem_ValidatorInfo_addr) validator_addr))))))))) (= $abort_code@14 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@14 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@14 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@14 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@14 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@14 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@14 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@14 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@14 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 110050) (- 0 140772)) (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $Roles_RoleId_role_id) ($Integer 3))))))))) (=> (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $Roles_RoleId_role_id) ($Integer 3)))))))) (and (=> (= (ControlFlow 0 110050) (- 0 140785)) (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))))) (=> (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))) (and (=> (= (ControlFlow 0 110050) (- 0 140798)) (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean (let (($range_1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@2 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@2)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@5 Int) )  (and (and (>= $i_0@@5 0) (< $i_0@@5 (|l#$ValueArray| (|v#$Vector| $range_1@@2)))) (let ((v@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@2)) $i_0@@5)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@17)) $DiemSystem_ValidatorInfo_addr) validator_addr))))))))))) (=> (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean (let (($range_1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@2 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@2)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@6 Int) )  (and (and (>= $i_0@@6 0) (< $i_0@@6 (|l#$ValueArray| (|v#$Vector| $range_1@@2)))) (let ((v@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@2)) $i_0@@6)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@17)) $DiemSystem_ValidatorInfo_addr) validator_addr)))))))))) (=> (= (ControlFlow 0 110050) (- 0 140810)) (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))) ($Integer (+ (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) (|i#$Integer| ($Integer 1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) (|i#$Integer| ($Integer 1)))))) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 validator_addr) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 validator_addr) (+ len@@3 1)))) len@@2 ($Integer 1)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 validator_addr) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 validator_addr) (+ len@@3 1)))) len@@2 ($Integer 1)) (+ len@@2 1)))) len@@1 ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0))) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 validator_addr) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 validator_addr) (+ len@@3 1)))) len@@2 ($Integer 1)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 validator_addr) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 validator_addr) (+ len@@3 1)))) len@@2 ($Integer 1)) (+ len@@2 1)))) len@@1 ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0))) (+ len@@1 1)))) len@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@0 1)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) (|i#$Integer| ($Integer 1)))))))) (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) (|i#$Integer| ($Integer 1))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) (|i#$Integer| ($Integer 1)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) (|i#$Integer| ($Integer 1))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (- (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) (|i#$Integer| ($Integer 1))))))))))) ($Vector ($ValueArray (|lambda#4| 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))) (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) $Error) (ite (< (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))) 0) 0 (- (|i#$Integer| (|ub#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (|i#$Integer| (|lb#$Range| ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon83_Else_correct  (=> (and (not $abort_flag@9) (= $abort_flag@10 $abort_flag@9)) (=> (and (and (= $abort_code@14 $abort_code@12) (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@0)) (and (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 109808) 110050))) anon0$2_correct))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct  (=> (= $abort_flag@10 true) (=> (and (and (= $abort_code@14 $abort_code@13) (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@1)) (and (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@1) (= (ControlFlow 0 108331) 110050))) anon0$2_correct))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon7_correct  (=> (and (and (= $abort_code@13 $abort_code@1) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 110020) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 110018) 110020)) inline$$DiemSystem_add_validator_$def_verify$0$anon7_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 110028) 110020) inline$$DiemSystem_add_validator_$def_verify$0$anon7_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon59_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 110012) 110028) inline$$DiemSystem_add_validator_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 110012) 110018) inline$$DiemSystem_add_validator_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon11_correct  (=> (and (and (= $abort_code@13 $abort_code@2) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 110000) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 109998) 110000)) inline$$DiemSystem_add_validator_$def_verify$0$anon11_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 110008) 110000) inline$$DiemSystem_add_validator_$def_verify$0$anon11_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon61_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 109992) 110008) inline$$DiemSystem_add_validator_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 109992) 109998) inline$$DiemSystem_add_validator_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon15_correct  (=> (and (and (= $abort_code@13 $abort_code@3) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 109980) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 109978) 109980)) inline$$DiemSystem_add_validator_$def_verify$0$anon15_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 109988) 109980) inline$$DiemSystem_add_validator_$def_verify$0$anon15_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon63_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 109972) 109988) inline$$DiemSystem_add_validator_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 109972) 109978) inline$$DiemSystem_add_validator_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon19_correct  (=> (and (and (= $abort_code@13 $abort_code@4) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 109960) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 109958) 109960)) inline$$DiemSystem_add_validator_$def_verify$0$anon19_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 109968) 109960) inline$$DiemSystem_add_validator_$def_verify$0$anon19_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon65_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 109952) 109968) inline$$DiemSystem_add_validator_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 109952) 109958) inline$$DiemSystem_add_validator_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon27_correct  (=> (and (and (= $abort_code@13 $abort_code@5) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 109940) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 109938) 109940)) inline$$DiemSystem_add_validator_$def_verify$0$anon27_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 109948) 109940) inline$$DiemSystem_add_validator_$def_verify$0$anon27_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon69_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 109932) 109948) inline$$DiemSystem_add_validator_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 109932) 109938) inline$$DiemSystem_add_validator_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon31_correct  (=> (and (and (= $abort_code@13 $abort_code@7) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 109920) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 109918) 109920)) inline$$DiemSystem_add_validator_$def_verify$0$anon31_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 109928) 109920) inline$$DiemSystem_add_validator_$def_verify$0$anon31_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon71_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 109912) 109928) inline$$DiemSystem_add_validator_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 109912) 109918) inline$$DiemSystem_add_validator_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon35_correct  (=> (and (and (= $abort_code@13 $abort_code@8) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 109900) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 109898) 109900)) inline$$DiemSystem_add_validator_$def_verify$0$anon35_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 109908) 109900) inline$$DiemSystem_add_validator_$def_verify$0$anon35_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon73_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 109892) 109908) inline$$DiemSystem_add_validator_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 109892) 109898) inline$$DiemSystem_add_validator_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon43_correct  (=> (and (and (= $abort_code@13 $abort_code@9) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 109880) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 109878) 109880)) inline$$DiemSystem_add_validator_$def_verify$0$anon43_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon78_Then_correct  (=> (= (ControlFlow 0 109888) 109880) inline$$DiemSystem_add_validator_$def_verify$0$anon43_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon77_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 109872) 109888) inline$$DiemSystem_add_validator_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 109872) 109878) inline$$DiemSystem_add_validator_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon47_correct  (=> (and (and (= $abort_code@13 $abort_code@11) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 109860) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 109858) 109860)) inline$$DiemSystem_add_validator_$def_verify$0$anon47_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon80_Then_correct  (=> (= (ControlFlow 0 109868) 109860) inline$$DiemSystem_add_validator_$def_verify$0$anon47_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon79_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 109852) 109868) inline$$DiemSystem_add_validator_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 109852) 109858) inline$$DiemSystem_add_validator_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon51_correct  (=> (and (and (= $abort_code@13 $abort_code@11) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 109840) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 109838) 109840)) inline$$DiemSystem_add_validator_$def_verify$0$anon51_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon82_Then_correct  (=> (= (ControlFlow 0 109848) 109840) inline$$DiemSystem_add_validator_$def_verify$0$anon51_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon81_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 109832) 109848) inline$$DiemSystem_add_validator_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 109832) 109838) inline$$DiemSystem_add_validator_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon55_correct  (=> (and (and (= $abort_code@13 $abort_code@12) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory@0)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 109820) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 109818) 109820)) inline$$DiemSystem_add_validator_$def_verify$0$anon55_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon84_Then_correct  (=> (= (ControlFlow 0 109828) 109820) inline$$DiemSystem_add_validator_$def_verify$0$anon55_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon83_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 109812) 109828) inline$$DiemSystem_add_validator_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 109812) 109818) inline$$DiemSystem_add_validator_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon81_Else$4_correct  (=> (= call2formal@$DiemConfig_Configuration_$CallerDomain@0 ($ConstMemoryDomain true)) (and (=> (= (ControlFlow 0 109802) (- 0 138936)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_add_validator_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_add_validator_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 109802) (- 0 138957)) (|Select_[$TypeValueArray,$int]$bool| call2formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call2formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@9) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@9) (=> $abort_flag@9 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@9 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@12 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@12 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) $DiemConfig_DiemConfig_payload) |inline$$WritebackToValue$0$vdst'@2|)))))) (and (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 109802) 109812) inline$$DiemSystem_add_validator_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 109802) 109808) inline$$DiemSystem_add_validator_$def_verify$0$anon83_Else_correct)))))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| call2formal@$ret0@0) (= (ControlFlow 0 109768) 109802)) inline$$DiemSystem_add_validator_$def_verify$0$anon81_Else$4_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 3)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 call2formal@$ret0@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 109794) 109802))) inline$$DiemSystem_add_validator_$def_verify$0$anon81_Else$4_correct)))
(let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 109671) (- 0 138746)) (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9)) inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8) (< inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9)))) (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$i ($Integer inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8)))
(|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11)) inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10) (< inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11)))) (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$j ($Integer inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_$pack_ref$0$i)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_$pack_ref$0$j)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_DiemSystem_$pack_ref$0$i inline$$DiemSystem_DiemSystem_$pack_ref$0$j))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9)) inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@0) (< inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9)))) (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$i ($Integer inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@0)))
(|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11)) inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@0) (< inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11)))) (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$j ($Integer inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_$pack_ref$0$i)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_$pack_ref$0$j)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_DiemSystem_$pack_ref$0$i inline$$DiemSystem_DiemSystem_$pack_ref$0$j)))))))))))))))))) (and (=> (= (ControlFlow 0 109671) 109794) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 109671) 109768) inline$$WritebackToValue$0$anon3_Else_correct))))))
(let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$Entry_correct  (=> (and (= inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 109545) 109671)) inline$$DiemSystem_DiemSystem_$pack_ref$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1) (= (ControlFlow 0 109337) 109545)) inline$$DiemSystem_DiemSystem_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 109393) 109545))) inline$$DiemSystem_DiemSystem_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 109301) 109393) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 109301) 109337) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) |inline$$Vector_push_back$0$v'@1|)) (= (ControlFlow 0 109158) 109301)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon81_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 109164) 109158)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@4 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) len@@4 inline$$DiemSystem_ValidatorInfo_pack$0$$struct@1) (+ len@@4 1)))))) (and (=> (= (ControlFlow 0 109093) 109832) inline$$DiemSystem_add_validator_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 109093) 109164) inline$$DiemSystem_add_validator_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct  (=> (and (= inline$$Vector_push_back$0$ta@0 $DiemSystem_ValidatorInfo_type_value) (= (ControlFlow 0 109081) 109093)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon79_Else$2_correct  (and (=> (= (ControlFlow 0 109099) (- 0 138528)) (forall ((inline$$DiemSystem_add_validator_$def_verify$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemSystem_add_validator_$def_verify$0$$$0 0) (< inline$$DiemSystem_add_validator_$def_verify$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) inline$$DiemSystem_add_validator_$def_verify$0$$$0))
))) (=> (forall ((inline$$DiemSystem_add_validator_$def_verify$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemSystem_add_validator_$def_verify$0$$$0@@0 0) (< inline$$DiemSystem_add_validator_$def_verify$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) inline$$DiemSystem_add_validator_$def_verify$0$$$0@@0))
)) (=> (= (ControlFlow 0 109099) 109081) inline$$Vector_push_back$0$Entry_correct)))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 108994) 109099)) inline$$DiemSystem_add_validator_$def_verify$0$anon79_Else$2_correct)))
(let ((inline$$DiemSystem_ValidatorInfo_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 108950) 108994)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$DiemSystem_ValidatorInfo_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 108956) 108994) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$DiemSystem_ValidatorInfo_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 108944) 108956) inline$$DiemSystem_ValidatorInfo_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 108944) 108950) inline$$DiemSystem_ValidatorInfo_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemSystem_ValidatorInfo_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 108936) 108994)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$DiemSystem_ValidatorInfo_pack$0$anon0_correct  (=> ((_ is $Address) validator_addr) (=> (and (and ((_ is $Integer) inline$$DiemSystem_add_validator_$def_verify$0$$t26@1) (>= (|i#$Integer| inline$$DiemSystem_add_validator_$def_verify$0$$t26@1) 0)) (<= (|i#$Integer| inline$$DiemSystem_add_validator_$def_verify$0$$t26@1) $MAX_U64)) (=> (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) call3formal@$ret0@0) (let ((va@@8 (|v#$Vector| call3formal@$ret0@0)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@9 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@10 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@0))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@1))
))) true) (and (and (and ((_ is $Integer) call2formal@$ret0@0@@0) (>= (|i#$Integer| call2formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@0) $MAX_U64)) (= inline$$DiemSystem_ValidatorInfo_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 validator_addr) 1 inline$$DiemSystem_add_validator_$def_verify$0$$t26@1) 2 call3formal@$ret0@0) 3 call2formal@$ret0@0@@0) 4))))) (and (=> (= (ControlFlow 0 108928) 108944) inline$$DiemSystem_ValidatorInfo_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 108928) 108936) inline$$DiemSystem_ValidatorInfo_pack$0$anon3_Else_correct)))))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon79_Else_correct  (=> (not $abort_flag@8) (=> (and (= inline$$DiemSystem_add_validator_$def_verify$0$$t26@1 ($Integer 1)) (= (ControlFlow 0 108962) 108928)) inline$$DiemSystem_ValidatorInfo_pack$0$anon0_correct))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon77_Else$3_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@8) (=> $abort_flag@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@11 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))))))) (and (and ((_ is $Integer) call2formal@$ret0@0@@0) (>= (|i#$Integer| call2formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 108716) 109852) inline$$DiemSystem_add_validator_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 108716) 108962) inline$$DiemSystem_add_validator_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemSystem_DiemSystem_validators) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $DiemSystem_DiemSystem_validators))) (= (ControlFlow 0 108708) 108716))) inline$$DiemSystem_add_validator_$def_verify$0$anon77_Else$3_correct))))
(let ((inline$$DiemSystem_DiemSystem_$unpack_ref$0$anon0_correct  (=> (and (and (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0)) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0)) $DiemSystem_DiemSystem_validators))) $$0@@2))
)) (|b#$Boolean| ($Boolean (let (($range_1@@3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@7 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@3)) $i_0@@7) (< $i_0@@7 (|i#$Integer| (|ub#$Range| $range_1@@3)))) (let ((i@@10 ($Integer $i_0@@7)))
(|b#$Boolean| ($Boolean (let (($range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3)) $i_2) (< $i_2 (|i#$Integer| (|ub#$Range| $range_3)))) (let ((j@@1 ($Integer $i_2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@10)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@1)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@10 j@@1))))))))))))))))))) (= (ControlFlow 0 108586) 108708)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$DiemSystem_DiemSystem_$unpack_ref$0$Entry_correct  (=> (and (= inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 108580) 108586)) inline$$DiemSystem_DiemSystem_$unpack_ref$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 3) $EmptyPath call2formal@$ret0@0)) (= (ControlFlow 0 108553) 108580)) inline$$DiemSystem_DiemSystem_$unpack_ref$0$Entry_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon77_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 108559) 108553)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon75_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))) $abort_flag@7)) (=> (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@7) (=> $abort_flag@7 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))) (and (=> $abort_flag@7 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@9 (|i#$Integer| ($Integer 7)))))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0)))))))) (=> (and (and (and (and (and (and (and (and (and ((_ is $Vector) call3formal@$ret0@0) (let ((va@@12 (|v#$Vector| call3formal@$ret0@0)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@3))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@4))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@5))
))) true) (and (=> (= (ControlFlow 0 108499) 109872) inline$$DiemSystem_add_validator_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 108499) 108559) inline$$DiemSystem_add_validator_$def_verify$0$anon77_Else_correct)))))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon40_correct  (=> (and (and (= $abort_code@13 $abort_code@10) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 108485) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 108483) 108485)) inline$$DiemSystem_add_validator_$def_verify$0$anon40_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 108493) 108485) inline$$DiemSystem_add_validator_$def_verify$0$anon40_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon75_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@10 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 108477) 108493) inline$$DiemSystem_add_validator_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 108477) 108483) inline$$DiemSystem_add_validator_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon73_Else_correct  (=> (not $abort_flag@6) (and (=> (= (ControlFlow 0 108465) 108499) inline$$DiemSystem_add_validator_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 108465) 108477) inline$$DiemSystem_add_validator_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon71_Else$1_correct  (=> (and (and (and (= inline$$DiemSystem_add_validator_$def_verify$0$$t21@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6)) (and (=> $abort_flag@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 108459) 109892) inline$$DiemSystem_add_validator_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 108459) 108465) inline$$DiemSystem_add_validator_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| call4formal@$ret0@0)))) (= (ControlFlow 0 108447) 108459)) inline$$DiemSystem_add_validator_$def_verify$0$anon71_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 108437) (- 0 137926)) true) (=> (= (ControlFlow 0 108437) 108447) inline$$Not$0$anon0_correct))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon71_Else_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 108453) 108437)) inline$$Not$0$Entry_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon69_Else$1_correct  (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5) (=> (and (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 ($Boolean (let (($range_1@@4 inline$$GetFieldFromValue$0$dst@1))
(exists (($i_0@@8 Int) )  (and (and (>= $i_0@@8 0) (< $i_0@@8 (|l#$ValueArray| (|v#$Vector| $range_1@@4)))) (let ((v@@18 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@4)) $i_0@@8)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@18)) $DiemSystem_ValidatorInfo_addr) validator_addr))))))))))))) (and (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@5 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@5)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@6 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@6)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) ((_ is $Boolean) call4formal@$ret0@0))) (and (=> (= (ControlFlow 0 108399) 109912) inline$$DiemSystem_add_validator_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 108399) 108453) inline$$DiemSystem_add_validator_$def_verify$0$anon71_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators)) (= (ControlFlow 0 108391) 108399)) inline$$DiemSystem_add_validator_$def_verify$0$anon69_Else$1_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon69_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 108397) 108391)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon67_Then_correct  (=> (and (|b#$Boolean| call3formal@$ret0@0@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4)) (=> (and (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@4 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0 (let ((addr@@7 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@7)))) $DiemConfig_DiemConfig_payload)))))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@8 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@8)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@9 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@9)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (=> (and (and (and (and (and (and ((_ is $Vector) call2formal@$ret0@0) (let ((va@@16 (|v#$Vector| call2formal@$ret0@0)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@7))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@8))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@9))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@6))
))) (and (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) $$0@@10))
)) (|b#$Boolean| ($Boolean (let (($range_1@@5 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@9 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@5)) $i_0@@9) (< $i_0@@9 (|i#$Integer| (|ub#$Range| $range_1@@5)))) (let ((i@@11 ($Integer $i_0@@9)))
(|b#$Boolean| ($Boolean (let (($range_3@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@0)) $i_2@@0) (< $i_2@@0 (|i#$Integer| (|ub#$Range| $range_3@@0)))) (let ((j@@2 ($Integer $i_2@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@11)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@2)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@11 j@@2)))))))))))))))))))) (and (=> (= (ControlFlow 0 108345) 109932) inline$$DiemSystem_add_validator_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 108345) 108397) inline$$DiemSystem_add_validator_$def_verify$0$anon69_Else_correct)))))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon24_correct  (=> (and (and (= $abort_code@13 $abort_code@6) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 108327) 108331))) inline$$DiemSystem_add_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 108325) 108327)) inline$$DiemSystem_add_validator_$def_verify$0$anon24_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon68_Then_correct  (=> (= (ControlFlow 0 108339) 108327) inline$$DiemSystem_add_validator_$def_verify$0$anon24_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon67_Else_correct  (=> (and (not (|b#$Boolean| call3formal@$ret0@0@@1)) (= $abort_code@6 (|i#$Integer| call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 108319) 108339) inline$$DiemSystem_add_validator_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 108319) 108325) inline$$DiemSystem_add_validator_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon65_Else_correct  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 108307) 108345) inline$$DiemSystem_add_validator_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 108307) 108319) inline$$DiemSystem_add_validator_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon63_Else_correct  (=> (not $abort_flag@2) (=> (and (and (and (= inline$$DiemSystem_add_validator_$def_verify$0$$t16@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3)) (and (=> $abort_flag@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 108301) 109952) inline$$DiemSystem_add_validator_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 108301) 108307) inline$$DiemSystem_add_validator_$def_verify$0$anon65_Else_correct))))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon61_Else_correct  (=> (not $abort_flag@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2) (=> $abort_flag@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 108291) 109972) inline$$DiemSystem_add_validator_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 108291) 108301) inline$$DiemSystem_add_validator_$def_verify$0$anon63_Else_correct))))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon59_Else_correct  (=> (not $abort_flag@0) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@1)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1)) (and (=> $abort_flag@1 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@1 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 108285) 109992) inline$$DiemSystem_add_validator_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 108285) 108291) inline$$DiemSystem_add_validator_$def_verify$0$anon61_Else_correct)))))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 108279) 110012) inline$$DiemSystem_add_validator_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 108279) 108285) inline$$DiemSystem_add_validator_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon4_correct  (=> (and (= inline$$DiemSystem_add_validator_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 108243) 108279)) inline$$DiemSystem_add_validator_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon58_Else_correct  (=> (and (not true) (= (ControlFlow 0 108183) 108243)) inline$$DiemSystem_add_validator_$def_verify$0$anon4_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon58_Then_correct  (=> (= (ControlFlow 0 110036) 108243) inline$$DiemSystem_add_validator_$def_verify$0$anon4_correct)))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon57_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 108175) 110036) inline$$DiemSystem_add_validator_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 108175) 108183) inline$$DiemSystem_add_validator_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon57_Then_correct  (and (=> (= (ControlFlow 0 110044) 110036) inline$$DiemSystem_add_validator_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 110044) 108183) inline$$DiemSystem_add_validator_$def_verify$0$anon58_Else_correct))))
(let ((inline$$DiemSystem_add_validator_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 108169) 110044) inline$$DiemSystem_add_validator_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 108169) 108175) inline$$DiemSystem_add_validator_$def_verify$0$anon57_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (forall (($inv_addr@@1 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))
))) (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@11))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@29 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@3))
)))) (=> (and (and (and (and (forall (($inv_addr@@4 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))) $Option_Option_vec)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))) $Option_Option_vec))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@4))
)) (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@12))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))
))) (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@38 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@14))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@15))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@16))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@13))
))) (and (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) $$0@@17))
)) (|b#$Boolean| ($Boolean (let (($range_1@@6 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@6)) $i_0@@10) (< $i_0@@10 (|i#$Integer| (|ub#$Range| $range_1@@6)))) (let ((i@@12 ($Integer $i_0@@10)))
(|b#$Boolean| ($Boolean (let (($range_3@@1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@1)) $i_2@@1) (< $i_2@@1 (|i#$Integer| (|ub#$Range| $range_3@@1)))) (let ((j@@3 ($Integer $i_2@@1)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@12)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@3)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@12 j@@3)))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@45 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemSystem_CapabilityHolder_cap)) (let ((va@@46 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemSystem_CapabilityHolder_cap))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemSystem_CapabilityHolder_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemSystem_CapabilityHolder_cap))) $DiemConfig_ModifyConfigCapability_dummy_field)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@7))
)))) (and (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@47 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@49 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
))))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@18))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@50 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
))))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@19))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
))))))) (forall (($$0@@20 Int) ) (!  (=> (and (>= $$0@@20 0) (< $$0@@20 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@20))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address T@$Value) )  (=> ((_ is $Address) config_address) (|b#$Boolean| ($Boolean (forall ((config_type T@$Value) )  (=> ((_ is $Type) config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type)) 1) (|a#$Address| config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address ($Address 173345816)))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((addr@@10 T@$Value) )  (=> ((_ is $Address) addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@11 T@$Value) )  (=> ((_ is $Address) addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@12 T@$Value) )  (=> ((_ is $Address) addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@13 T@$Value) )  (=> ((_ is $Address) addr@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@7 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@14 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@14)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@11 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@7)) $i_0@@11) (< $i_0@@11 (|i#$Integer| (|ub#$Range| $range_1@@7)))) (let ((i1 ($Integer $i_0@@11)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@15 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@15)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@15 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@15)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@8 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@16 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@16)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@12 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@8)) $i_0@@12) (< $i_0@@12 (|i#$Integer| (|ub#$Range| $range_1@@8)))) (let ((i1@@0 ($Integer $i_0@@12)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@17 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@17)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@0)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 110048) 108169))))) inline$$DiemSystem_add_validator_$def_verify$0$anon0_correct)))))
(let ((anon0_correct  (=> ((_ is $Address) dr_account) (=> (and ((_ is $Address) validator_addr) (= (ControlFlow 0 106546) 110048)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_DiemConfig_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 133091) 106546)) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun inline$$DiemSystem_get_diem_system_config_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$DiemSystem_get_diem_system_config_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 140867) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 110943) (- 0 141694)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@0) (and (=> (= (ControlFlow 0 110943) (- 0 141725)) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 110943) (- 0 141756)) (=> $abort_flag@1@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@1@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 110943) (- 0 141798)) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_get_diem_system_config_$def_verify$0$$ret0@2 (let ((addr@@18 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@18)))) $DiemConfig_DiemConfig_payload))))))) (=> (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_get_diem_system_config_$def_verify$0$$ret0@2 (let ((addr@@18 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@18)))) $DiemConfig_DiemConfig_payload)))))) (=> (= (ControlFlow 0 110943) (- 0 141816)) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@19 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@19)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@20 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@20)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))))))))))
(let ((inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon3_correct  (=> (and (and (= inline$$DiemSystem_get_diem_system_config_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@0 true)) (and (= inline$$DiemSystem_get_diem_system_config_$def_verify$0$$ret0@2 inline$$DiemSystem_get_diem_system_config_$def_verify$0$$ret0@1) (= (ControlFlow 0 110927) 110943))) anon0$2_correct@@0)))
(let ((inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 110921) 110927)) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon3_correct)))
(let ((inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 110935) 110927) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon3_correct)))
(let ((inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon7_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 110915) 110935) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 110915) 110921) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon6_correct  (=> (= $abort_flag@1@@0 $abort_flag@0@@0) (=> (and (= inline$$DiemSystem_get_diem_system_config_$def_verify$0$$ret0@2 call3formal@$ret0@0@@3) (= (ControlFlow 0 110903) 110943)) anon0$2_correct@@0))))
(let ((inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 110901) 110903)) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon6_correct)))
(let ((inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 110911) 110903) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon6_correct)))
(let ((inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon7_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 110895) 110911) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 110895) 110901) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon0_correct  (=> (and (not false) (= call0formal@$tv0@0 $DiemSystem_DiemSystem_type_value)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@0) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@0@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 (let ((addr@@21 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@21)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 110887) 110915) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 110887) 110895) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon7_Else_correct))))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@9 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@9)) (let ((va@@52 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@9))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@9))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@9))
)) (|b#$Boolean| ($Boolean (forall ((config_address@@0 T@$Value) )  (=> ((_ is $Address) config_address@@0) (|b#$Boolean| ($Boolean (forall ((config_type@@0 T@$Value) )  (=> ((_ is $Type) config_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@0)) 1) (|a#$Address| config_address@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@0 ($Address 173345816)))))))))))))))) (=> (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@22 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@22)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@13 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@9)) $i_0@@13) (< $i_0@@13 (|i#$Integer| (|ub#$Range| $range_1@@9)))) (let ((i1@@1 ($Integer $i_0@@13)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@23 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@23)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@1)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@23 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@23)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@1)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@10 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@24 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@24)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@14 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@10)) $i_0@@14) (< $i_0@@14 (|i#$Integer| (|ub#$Range| $range_1@@10)))) (let ((i1@@2 ($Integer $i_0@@14)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@25 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@25)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@2)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 110941) 110887))) inline$$DiemSystem_get_diem_system_config_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (= (ControlFlow 0 140867) 110941) anon0$1_correct@@0)))
anon0_correct@@0)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun i@@13 () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun inline$$Vector_borrow$0$dst@2 () T@$Value)
(declare-fun inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun inline$$Vector_borrow$0$dst@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0 () T@$TypeValue)
(declare-fun call2formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$t7@1 () T@$Value)
(declare-fun call2formal@$ret0@0@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 141840) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 112341) (- 0 143707)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 112341) (- 0 143738)) (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@13) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@26 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@26)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@13) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@26 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@26)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 112341) (- 0 143759)) (=> $abort_flag@4@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@13) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@27 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@27)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))))) (=> (=> $abort_flag@4@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@13) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@27 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@27)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))))) (and (=> (= (ControlFlow 0 112341) (- 0 143810)) (=> $abort_flag@4@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@13) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@28 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@28)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@4@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| i@@13) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@28 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@28)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 7)))))) (and (=> (= (ControlFlow 0 112341) (- 0 143883)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@29 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@29)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@13)))) $DiemSystem_ValidatorInfo_addr)))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@29 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@29)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@13)))) $DiemSystem_ValidatorInfo_addr))))) (=> (= (ControlFlow 0 112341) (- 0 143907)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@30 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@30)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@31 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@31)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))))))))))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon24_correct  (=> (and (and (= $abort_code@7@@0 $abort_code@5@@0) (= inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$1$dst@1)) (and (= $abort_flag@4@@0 $abort_flag@3@@0) (= (ControlFlow 0 112237) 112341))) anon0$2_correct@@1)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 112235) 112237)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon24_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 112245) 112237) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon24_correct)))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_borrow$0$dst@2)) $DiemSystem_ValidatorInfo_addr)) (and (=> (= (ControlFlow 0 112219) 112245) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 112219) 112235) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@3@@0) (= (ControlFlow 0 112225) 112219)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$Abort_correct  (=> (= inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@7@@0 $abort_code@6@@0) (= inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$ret0@2 inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$ret0@1)) (and (= $abort_flag@4@@0 true) (= (ControlFlow 0 111889) 112341))) anon0$2_correct@@1))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon5_correct  (=> (and (= $abort_code@6@@0 $abort_code@1@@1) (= (ControlFlow 0 112317) 111889)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 112315) 112317)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 112325) 112317) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon26_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 112309) 112325) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 112309) 112315) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon9_correct  (=> (and (= $abort_code@6@@0 $abort_code@2@@0) (= (ControlFlow 0 112297) 111889)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 112295) 112297)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon9_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 112305) 112297) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon9_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon28_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 112289) 112305) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 112289) 112295) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon17_correct  (=> (and (= $abort_code@6@@0 $abort_code@3@@0) (= (ControlFlow 0 112277) 111889)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 112275) 112277)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon17_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 112285) 112277) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon17_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon32_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 112269) 112285) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 112269) 112275) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon21_correct  (=> (and (= $abort_code@6@@0 $abort_code@5@@0) (= (ControlFlow 0 112257) 111889)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 112255) 112257)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon21_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 112265) 112257) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon21_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon34_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 112249) 112265) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 112249) 112255) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct  (=> (= $abort_flag@3@@0 true) (=> (and (= $abort_code@5@@0 $EXEC_FAILURE_CODE) (= inline$$Vector_borrow$0$dst@2 inline$$Vector_borrow$0$dst@0)) (and (=> (= (ControlFlow 0 112165) 112249) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 112165) 112225) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@0)))) (= (ControlFlow 0 112163) 112165)) inline$$Vector_borrow$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct  (=> (not (or (< inline$$Vector_borrow$0$i_ind@1 0) (>= inline$$Vector_borrow$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@0))))) (=> (and (and (= inline$$Vector_borrow$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@0)) inline$$Vector_borrow$0$i_ind@1)) (= $abort_flag@3@@0 $abort_flag@2@@0)) (and (= $abort_code@5@@0 $abort_code@3@@0) (= inline$$Vector_borrow$0$dst@2 inline$$Vector_borrow$0$dst@1))) (and (=> (= (ControlFlow 0 112105) 112249) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 112105) 112225) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon0_correct  (=> ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1@@0) (=> (and ((_ is $Integer) i@@13) (= inline$$Vector_borrow$0$i_ind@1 (|i#$Integer| i@@13))) (and (=> (= (ControlFlow 0 112079) 112163) inline$$Vector_borrow$0$anon3_Then_correct) (=> (= (ControlFlow 0 112079) 112105) inline$$Vector_borrow$0$anon3_Else_correct))))))
(let ((inline$$Vector_borrow$0$Entry_correct  (=> (and (= inline$$Vector_borrow$0$ta@0 $DiemSystem_ValidatorInfo_type_value) (= (ControlFlow 0 112065) 112079)) inline$$Vector_borrow$0$anon0_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators)) (= (ControlFlow 0 111949) 112065)) inline$$Vector_borrow$0$Entry_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon32_Else_correct  (=> (and (not $abort_flag@2@@0) (= (ControlFlow 0 111955) 111949)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon30_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@0)) (=> (and (and (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@2@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@1 (let ((addr@@32 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@32)))) $DiemConfig_DiemConfig_payload)))))) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@33 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@33)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@34 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@34)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (=> (and (and (and (and (and (and ((_ is $Vector) call2formal@$ret0@0@@1) (let ((va@@53 (|v#$Vector| call2formal@$ret0@0@@1)))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
)))))) (= (|l#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators)) (let ((va@@54 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
))))))) (forall (($$0@@21 Int) ) (!  (=> (and (>= $$0@@21 0) (< $$0@@21 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21)) (let ((va@@55 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config)) (let ((va@@56 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@57 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
))))))) (forall (($$0@@22 Int) ) (!  (=> (and (>= $$0@@22 0) (< $$0@@22 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@22)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@22)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@22)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@22))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
))))))) (forall (($$0@@23 Int) ) (!  (=> (and (>= $$0@@23 0) (< $$0@@23 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@23)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@23)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@23)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@23))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
))))))) (forall (($$0@@24 Int) ) (!  (=> (and (>= $$0@@24 0) (< $$0@@24 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@24)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@24)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@24)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@24))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@21))
))) (and (forall (($$0@@25 Int) ) (!  (=> (and (>= $$0@@25 0) (< $$0@@25 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) $$0@@25))
)) (|b#$Boolean| ($Boolean (let (($range_1@@11 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@15 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@11)) $i_0@@15) (< $i_0@@15 (|i#$Integer| (|ub#$Range| $range_1@@11)))) (let ((i@@14 ($Integer $i_0@@15)))
(|b#$Boolean| ($Boolean (let (($range_3@@2 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@2)) $i_2@@2) (< $i_2@@2 (|i#$Integer| (|ub#$Range| $range_3@@2)))) (let ((j@@4 ($Integer $i_2@@2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@14)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@4)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@14 j@@4)))))))))))))))))))) (and (=> (= (ControlFlow 0 111903) 112269) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 111903) 111955) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon32_Else_correct)))))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon14_correct  (=> (and (= $abort_code@6@@0 $abort_code@4@@0) (= (ControlFlow 0 111883) 111889)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 111881) 111883)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon14_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 111897) 111883) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon14_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon30_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= $abort_code@4@@0 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 111875) 111897) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 111875) 111881) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon28_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 111863) 111903) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 111863) 111875) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon26_Else$1_correct  (=> (and (and (and (= inline$$DiemSystem_get_ith_validator_address_$def_verify$0$$t7@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 111857) 112289) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 111857) 111863) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct  (=> (and (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| i@@13) (|i#$Integer| call2formal@$ret0@0@@2)))) (= (ControlFlow 0 111845) 111857)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon26_Else$1_correct)))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 111831) (- 0 143152)) true) (=> (= (ControlFlow 0 111831) 111845) inline$$Lt$0$anon0_correct))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 111851) 111831)) inline$$Lt$0$Entry_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@1) (=> (and (and (and (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@2 ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@35 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@35)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@36 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@36)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@37 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@37)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (and (and ((_ is $Integer) call2formal@$ret0@0@@2) (>= (|i#$Integer| call2formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 111783) 112309) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 111783) 111851) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 111747) 111783)) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 112333) 111783) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 111741) 112333) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 111741) 111747) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (and (and (forall (($inv_addr@@10 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10)) (let ((va@@60 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))
)) (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@61 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators)) (let ((va@@62 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
))))))) (forall (($$0@@26 Int) ) (!  (=> (and (>= $$0@@26 0) (< $$0@@26 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26)) (let ((va@@63 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config)) (let ((va@@64 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@65 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
))))))) (forall (($$0@@27 Int) ) (!  (=> (and (>= $$0@@27 0) (< $$0@@27 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@27)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@27)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@27)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@27))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@66 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
))))))) (forall (($$0@@28 Int) ) (!  (=> (and (>= $$0@@28 0) (< $$0@@28 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@28)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@28)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@28)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@28))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@67 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
))))))) (forall (($$0@@29 Int) ) (!  (=> (and (>= $$0@@29 0) (< $$0@@29 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@29)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@29)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@29)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@29))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@26))
))) (and (forall (($$0@@30 Int) ) (!  (=> (and (>= $$0@@30 0) (< $$0@@30 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) $$0@@30))
)) (|b#$Boolean| ($Boolean (let (($range_1@@12 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@16 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@12)) $i_0@@16) (< $i_0@@16 (|i#$Integer| (|ub#$Range| $range_1@@12)))) (let ((i@@15 ($Integer $i_0@@16)))
(|b#$Boolean| ($Boolean (let (($range_3@@3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@3)) $i_2@@3) (< $i_2@@3 (|i#$Integer| (|ub#$Range| $range_3@@3)))) (let ((j@@5 ($Integer $i_2@@3)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@15)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@5)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@15 j@@5)))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@11))
))) (and (forall (($inv_addr@@12 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12)) (let ((va@@68 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config)) (let ((va@@69 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@70 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
))))))) (forall (($$0@@31 Int) ) (!  (=> (and (>= $$0@@31 0) (< $$0@@31 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@31)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@31)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@31)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@31))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@71 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
))))))) (forall (($$0@@32 Int) ) (!  (=> (and (>= $$0@@32 0) (< $$0@@32 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@32)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@32)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@32)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@32))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@72 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
))))))) (forall (($$0@@33 Int) ) (!  (=> (and (>= $$0@@33 0) (< $$0@@33 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@33)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@33)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@33)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@33))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@12))
)) (|b#$Boolean| ($Boolean (forall ((config_address@@1 T@$Value) )  (=> ((_ is $Address) config_address@@1) (|b#$Boolean| ($Boolean (forall ((config_type@@1 T@$Value) )  (=> ((_ is $Type) config_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@1)) 1) (|a#$Address| config_address@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@1 ($Address 173345816))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@13 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@38 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@38)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@17 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@13)) $i_0@@17) (< $i_0@@17 (|i#$Integer| (|ub#$Range| $range_1@@13)))) (let ((i1@@3 ($Integer $i_0@@17)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@39 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@39)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@3)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@39 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@39)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@3)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@14 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@40 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@40)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@18 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@14)) $i_0@@18) (< $i_0@@18 (|i#$Integer| (|ub#$Range| $range_1@@14)))) (let ((i1@@4 ($Integer $i_0@@18)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@41 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@41)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@4)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 112339) 111741)))) inline$$DiemSystem_get_ith_validator_address_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and (and (and ((_ is $Integer) i@@13) (>= (|i#$Integer| i@@13) 0)) (<= (|i#$Integer| i@@13) $MAX_U64)) (= (ControlFlow 0 111031) 112339)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 141840) 111031) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun addr@@42 () T@$Value)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun inline$$DiemSystem_get_validator_config_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun inline$$Vector_borrow$0$dst@2@@0 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_config_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun inline$$Vector_borrow$0$dst@0@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@1@@0 () Int)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1@@0 () T@$Value)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Vector_borrow$0$ta@0@@0 () T@$TypeValue)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun call4formal@$ret0@0@@1 () T@$Value)
(declare-fun call2formal@$ret0@0@@3 () T@$Value)
(declare-fun call4formal@$ret0@0@@2 () T@$Value)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_config_$def_verify$0$$t8@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@1 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 143931) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 114031) (- 0 146467)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 114031) (- 0 146498)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@43 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@43)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@19 Int) )  (and (and (>= $i_0@@19 0) (< $i_0@@19 (|l#$ValueArray| (|v#$Vector| $range_1@@15)))) (let ((v@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@15)) $i_0@@19)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@19)) $DiemSystem_ValidatorInfo_addr) addr@@42)))))))))))) $abort_flag@6@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@43 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@43)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@20 Int) )  (and (and (>= $i_0@@20 0) (< $i_0@@20 (|l#$ValueArray| (|v#$Vector| $range_1@@15)))) (let ((v@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@15)) $i_0@@20)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@19)) $DiemSystem_ValidatorInfo_addr) addr@@42)))))))))))) $abort_flag@6@@0) (and (=> (= (ControlFlow 0 114031) (- 0 146515)) (=> $abort_flag@6@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@44 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@44)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@21 Int) )  (and (and (>= $i_0@@21 0) (< $i_0@@21 (|l#$ValueArray| (|v#$Vector| $range_1@@16)))) (let ((v@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@16)) $i_0@@21)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@20)) $DiemSystem_ValidatorInfo_addr) addr@@42))))))))))))))) (=> (=> $abort_flag@6@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@44 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@44)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@22 Int) )  (and (and (>= $i_0@@22 0) (< $i_0@@22 (|l#$ValueArray| (|v#$Vector| $range_1@@16)))) (let ((v@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@16)) $i_0@@22)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@20)) $DiemSystem_ValidatorInfo_addr) addr@@42)))))))))))))) (and (=> (= (ControlFlow 0 114031) (- 0 146562)) (=> $abort_flag@6@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@45 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@45)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@23 Int) )  (and (and (>= $i_0@@23 0) (< $i_0@@23 (|l#$ValueArray| (|v#$Vector| $range_1@@17)))) (let ((v@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@17)) $i_0@@23)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@21)) $DiemSystem_ValidatorInfo_addr) addr@@42)))))))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@6@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@45 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@45)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@24 Int) )  (and (and (>= $i_0@@24 0) (< $i_0@@24 (|l#$ValueArray| (|v#$Vector| $range_1@@17)))) (let ((v@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@17)) $i_0@@24)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@21)) $DiemSystem_ValidatorInfo_addr) addr@@42)))))))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 7)))))) (and (=> (= (ControlFlow 0 114031) (- 0 146631)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (let (($range_1@@18 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@46 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@46)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@25 Int) )  (and (and (>= $i_0@@25 0) (< $i_0@@25 (|l#$ValueArray| (|v#$Vector| $range_1@@18)))) (let ((info (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@18)) $i_0@@25)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| info)) $DiemSystem_ValidatorInfo_addr) addr@@42))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_get_validator_config_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| info)) $DiemSystem_ValidatorInfo_config))))))))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (let (($range_1@@18 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@46 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@46)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@26 Int) )  (and (and (>= $i_0@@26 0) (< $i_0@@26 (|l#$ValueArray| (|v#$Vector| $range_1@@18)))) (let ((info (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@18)) $i_0@@26)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| info)) $DiemSystem_ValidatorInfo_addr) addr@@42))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_get_validator_config_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| info)) $DiemSystem_ValidatorInfo_config)))))))))))))) (=> (= (ControlFlow 0 114031) (- 0 146704)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@47 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@47)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@48 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@48)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))))))))))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon32_correct  (=> (and (and (= $abort_code@9@@0 $abort_code@7@@1) (= inline$$DiemSystem_get_validator_config_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$2$dst@1)) (and (= $abort_flag@6@@0 $abort_flag@5@@0) (= (ControlFlow 0 113887) 114031))) anon0$2_correct@@2)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 113885) 113887)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon32_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 113895) 113887) inline$$DiemSystem_get_validator_config_$def_verify$0$anon32_correct)))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_borrow$0$dst@2@@0)) $DiemSystem_ValidatorInfo_config)) (and (=> (= (ControlFlow 0 113869) 113895) inline$$DiemSystem_get_validator_config_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 113869) 113885) inline$$DiemSystem_get_validator_config_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon46_Else_correct  (=> (and (not $abort_flag@5@@0) (= (ControlFlow 0 113875) 113869)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$Abort_correct  (=> (= inline$$DiemSystem_get_validator_config_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@9@@0 $abort_code@8@@0) (= inline$$DiemSystem_get_validator_config_$def_verify$0$$ret0@2 inline$$DiemSystem_get_validator_config_$def_verify$0$$ret0@1)) (and (= $abort_flag@6@@0 true) (= (ControlFlow 0 113539) 114031))) anon0$2_correct@@2))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon5_correct  (=> (and (= $abort_code@8@@0 $abort_code@1@@2) (= (ControlFlow 0 114007) 113539)) inline$$DiemSystem_get_validator_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 114005) 114007)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 114015) 114007) inline$$DiemSystem_get_validator_config_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon34_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 113999) 114015) inline$$DiemSystem_get_validator_config_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 113999) 114005) inline$$DiemSystem_get_validator_config_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon9_correct  (=> (and (= $abort_code@8@@0 $abort_code@2@@1) (= (ControlFlow 0 113987) 113539)) inline$$DiemSystem_get_validator_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 113985) 113987)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon9_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 113995) 113987) inline$$DiemSystem_get_validator_config_$def_verify$0$anon9_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon36_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 113979) 113995) inline$$DiemSystem_get_validator_config_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 113979) 113985) inline$$DiemSystem_get_validator_config_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon13_correct  (=> (and (= $abort_code@8@@0 $abort_code@3@@1) (= (ControlFlow 0 113967) 113539)) inline$$DiemSystem_get_validator_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 113965) 113967)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon13_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 113975) 113967) inline$$DiemSystem_get_validator_config_$def_verify$0$anon13_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon38_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 113959) 113975) inline$$DiemSystem_get_validator_config_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 113959) 113965) inline$$DiemSystem_get_validator_config_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon17_correct  (=> (and (= $abort_code@8@@0 $abort_code@4@@1) (= (ControlFlow 0 113947) 113539)) inline$$DiemSystem_get_validator_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 113945) 113947)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon17_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 113955) 113947) inline$$DiemSystem_get_validator_config_$def_verify$0$anon17_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon40_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 113939) 113955) inline$$DiemSystem_get_validator_config_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 113939) 113945) inline$$DiemSystem_get_validator_config_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon25_correct  (=> (and (= $abort_code@8@@0 $abort_code@6@@1) (= (ControlFlow 0 113927) 113539)) inline$$DiemSystem_get_validator_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 113925) 113927)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon25_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 113935) 113927) inline$$DiemSystem_get_validator_config_$def_verify$0$anon25_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon44_Then_correct  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 113919) 113935) inline$$DiemSystem_get_validator_config_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 113919) 113925) inline$$DiemSystem_get_validator_config_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon29_correct  (=> (and (= $abort_code@8@@0 $abort_code@7@@1) (= (ControlFlow 0 113907) 113539)) inline$$DiemSystem_get_validator_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 113905) 113907)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon29_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 113915) 113907) inline$$DiemSystem_get_validator_config_$def_verify$0$anon29_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon46_Then_correct  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 113899) 113915) inline$$DiemSystem_get_validator_config_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 113899) 113905) inline$$DiemSystem_get_validator_config_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@5@@0 true) (=> (and (= $abort_code@7@@1 $EXEC_FAILURE_CODE) (= inline$$Vector_borrow$0$dst@2@@0 inline$$Vector_borrow$0$dst@0@@0)) (and (=> (= (ControlFlow 0 113815) 113899) inline$$DiemSystem_get_validator_config_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 113815) 113875) inline$$DiemSystem_get_validator_config_$def_verify$0$anon46_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@0  (=> (and (or (< inline$$Vector_borrow$0$i_ind@1@@0 0) (>= inline$$Vector_borrow$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1@@0)))) (= (ControlFlow 0 113813) 113815)) inline$$Vector_borrow$0$anon3_Then$1_correct@@0)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@0  (=> (not (or (< inline$$Vector_borrow$0$i_ind@1@@0 0) (>= inline$$Vector_borrow$0$i_ind@1@@0 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1@@0))))) (=> (and (and (= inline$$Vector_borrow$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1@@0)) inline$$Vector_borrow$0$i_ind@1@@0)) (= $abort_flag@5@@0 $abort_flag@4@@1)) (and (= $abort_code@7@@1 $abort_code@6@@1) (= inline$$Vector_borrow$0$dst@2@@0 inline$$Vector_borrow$0$dst@1@@0))) (and (=> (= (ControlFlow 0 113755) 113899) inline$$DiemSystem_get_validator_config_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 113755) 113875) inline$$DiemSystem_get_validator_config_$def_verify$0$anon46_Else_correct))))))
(let ((inline$$Vector_borrow$0$anon0_correct@@0  (=> ((_ is $Vector) inline$$GetFieldFromValue$1$dst@1@@0) (=> (and ((_ is $Integer) call4formal@$ret0@0@@0) (= inline$$Vector_borrow$0$i_ind@1@@0 (|i#$Integer| call4formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 113729) 113813) inline$$Vector_borrow$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 113729) 113755) inline$$Vector_borrow$0$anon3_Else_correct@@0))))))
(let ((inline$$Vector_borrow$0$Entry_correct@@0  (=> (and (= inline$$Vector_borrow$0$ta@0@@0 $DiemSystem_ValidatorInfo_type_value) (= (ControlFlow 0 113715) 113729)) inline$$Vector_borrow$0$anon0_correct@@0)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon44_Else_correct  (=> (and (not $abort_flag@4@@1) (= (ControlFlow 0 113821) 113715)) inline$$Vector_borrow$0$Entry_correct@@0)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon42_Then$1_correct  (=> (= call0formal@$tv0@0@@0 $IntegerType) (=> (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec)) ($Integer 0)))) $abort_flag@4@@1) (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec)) ($Integer 0)))))) (and (=> $abort_flag@4@@1 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@6@@1 (|i#$Integer| ($Integer 7))))) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 ($Vector_$borrow call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec) ($Integer 0)))))))) (and (=> (= (ControlFlow 0 113601) 113919) inline$$DiemSystem_get_validator_config_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 113601) 113821) inline$$DiemSystem_get_validator_config_$def_verify$0$anon44_Else_correct))))))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$1$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators)) (= (ControlFlow 0 113593) 113601)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon42_Then$1_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon42_Then_correct  (=> (and (|b#$Boolean| call4formal@$ret0@0@@2) (= (ControlFlow 0 113599) 113593)) inline$$GetFieldFromValue$1$anon0_correct@@0)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon22_correct  (=> (and (= $abort_code@8@@0 $abort_code@5@@1) (= (ControlFlow 0 113533) 113539)) inline$$DiemSystem_get_validator_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 113531) 113533)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon22_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 113547) 113533) inline$$DiemSystem_get_validator_config_$def_verify$0$anon22_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon42_Else_correct  (=> (and (not (|b#$Boolean| call4formal@$ret0@0@@2)) (= $abort_code@5@@1 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 113525) 113547) inline$$DiemSystem_get_validator_config_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 113525) 113531) inline$$DiemSystem_get_validator_config_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon40_Else_correct  (=> (not $abort_flag@3@@1) (and (=> (= (ControlFlow 0 113513) 113599) inline$$DiemSystem_get_validator_config_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 113513) 113525) inline$$DiemSystem_get_validator_config_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon38_Else_correct  (=> (not $abort_flag@2@@1) (=> (and (and (and (= inline$$DiemSystem_get_validator_config_$def_verify$0$$t8@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@1)) (and (=> $abort_flag@3@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 113507) 113939) inline$$DiemSystem_get_validator_config_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 113507) 113513) inline$$DiemSystem_get_validator_config_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@1@@2) (= call0formal@$tv0@0@@1 $IntegerType)) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@1) (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@2 ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec)) ($Integer 0)))))))))) ((_ is $Boolean) call4formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 113497) 113959) inline$$DiemSystem_get_validator_config_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 113497) 113507) inline$$DiemSystem_get_validator_config_$def_verify$0$anon38_Else_correct))))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon34_Else$1_correct  (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@2) (=> (and (and (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@19 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1))))))
(forall (($i_0@@27 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@19)) $i_0@@27) (< $i_0@@27 (|i#$Integer| (|ub#$Range| $range_1@@19)))) (let ((i@@16 ($Integer $i_0@@27)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1)) (|i#$Integer| i@@16)))) $DiemSystem_ValidatorInfo_addr) addr@@42)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec)) ($Integer 0))))))))) (and (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@4 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1))))))
(exists (($i_2@@4 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@4)) $i_2@@4) (< $i_2@@4 (|i#$Integer| (|ub#$Range| $range_3@@4)))) (let ((i@@17 ($Integer $i_2@@4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1)) (|i#$Integer| i@@17)))) $DiemSystem_ValidatorInfo_addr) addr@@42))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| (let ((at ($Vector_$borrow $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec) ($Integer 0))))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| at)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| at) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1)) (|i#$Integer| at)))) $DiemSystem_ValidatorInfo_addr) addr@@42)))))))))))))) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@49 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@49)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@50 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@50)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@1) (let ((va@@73 (|v#$Vector| call4formal@$ret0@0@@1)))
(let ((l@@73 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec)) (let ((va@@74 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec))))
(let ((l@@74 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 113491) 113979) inline$$DiemSystem_get_validator_config_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 113491) 113497) inline$$DiemSystem_get_validator_config_$def_verify$0$anon36_Else_correct)))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators)) (= (ControlFlow 0 113483) 113491)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon34_Else$1_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 113489) 113483)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@2) (=> (and (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@3 (let ((addr@@51 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@51)))) $DiemConfig_DiemConfig_payload)))))) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@52 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@52)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@53 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@53)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (=> (and (and (and (and (and (and ((_ is $Vector) call2formal@$ret0@0@@3) (let ((va@@75 (|v#$Vector| call2formal@$ret0@0@@3)))
(let ((l@@75 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75))
)))))) (= (|l#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators)) (let ((va@@76 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))))
(let ((l@@76 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@76) (<= l@@76 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@76)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76))
))))))) (forall (($$0@@34 Int) ) (!  (=> (and (>= $$0@@34 0) (< $$0@@34 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34)) (let ((va@@77 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))))
(let ((l@@77 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config)) (let ((va@@78 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@78 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@79 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@79 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79))
))))))) (forall (($$0@@35 Int) ) (!  (=> (and (>= $$0@@35 0) (< $$0@@35 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@35)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@35)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@35)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@35))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@80 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@80 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@80) (<= l@@80 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@80)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80))
))))))) (forall (($$0@@36 Int) ) (!  (=> (and (>= $$0@@36 0) (< $$0@@36 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@36)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@36)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@36)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@36))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@81 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@81 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81))
))))))) (forall (($$0@@37 Int) ) (!  (=> (and (>= $$0@@37 0) (< $$0@@37 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@37)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@37)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@37)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@37))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@34))
))) (and (forall (($$0@@38 Int) ) (!  (=> (and (>= $$0@@38 0) (< $$0@@38 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) $$0@@38))
)) (|b#$Boolean| ($Boolean (let (($range_1@@20 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@28 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@20)) $i_0@@28) (< $i_0@@28 (|i#$Integer| (|ub#$Range| $range_1@@20)))) (let ((i@@18 ($Integer $i_0@@28)))
(|b#$Boolean| ($Boolean (let (($range_3@@5 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@5 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@5)) $i_2@@5) (< $i_2@@5 (|i#$Integer| (|ub#$Range| $range_3@@5)))) (let ((j@@6 ($Integer $i_2@@5)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@18)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@3)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@6)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@18 j@@6)))))))))))))))))))) (and (=> (= (ControlFlow 0 113437) 113999) inline$$DiemSystem_get_validator_config_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 113437) 113489) inline$$DiemSystem_get_validator_config_$def_verify$0$anon34_Else_correct)))))))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 113401) 113437)) inline$$DiemSystem_get_validator_config_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 114023) 113437) inline$$DiemSystem_get_validator_config_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemSystem_get_validator_config_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 113395) 114023) inline$$DiemSystem_get_validator_config_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 113395) 113401) inline$$DiemSystem_get_validator_config_$def_verify$0$anon33_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@13 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13)) (let ((va@@82 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))))
(let ((l@@82 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))
)) (=> (and (and (and (forall (($inv_addr@@14 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14)) (let ((va@@83 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14))))
(let ((l@@83 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14))) $Option_Option_vec)) (let ((va@@84 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14))) $Option_Option_vec))))
(let ((l@@84 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14))
)) (forall (($inv_addr@@15 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15)) (let ((va@@85 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))))
(let ((l@@85 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators)) (let ((va@@86 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))))
(let ((l@@86 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86))
))))))) (forall (($$0@@39 Int) ) (!  (=> (and (>= $$0@@39 0) (< $$0@@39 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39)) (let ((va@@87 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))))
(let ((l@@87 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config)) (let ((va@@88 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@88 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@89 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@89 (|l#$ValueArray| va@@89)))
 (and (and (<= 0 l@@89) (<= l@@89 $MAX_U64)) (forall ((x@@89 Int) ) (!  (=> (or (< x@@89 0) (>= x@@89 l@@89)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89))
))))))) (forall (($$0@@40 Int) ) (!  (=> (and (>= $$0@@40 0) (< $$0@@40 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@40)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@40)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@40)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@40))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@90 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@90 (|l#$ValueArray| va@@90)))
 (and (and (<= 0 l@@90) (<= l@@90 $MAX_U64)) (forall ((x@@90 Int) ) (!  (=> (or (< x@@90 0) (>= x@@90 l@@90)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90))
))))))) (forall (($$0@@41 Int) ) (!  (=> (and (>= $$0@@41 0) (< $$0@@41 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@41)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@41)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@41)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@41))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@91 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@91 (|l#$ValueArray| va@@91)))
 (and (and (<= 0 l@@91) (<= l@@91 $MAX_U64)) (forall ((x@@91 Int) ) (!  (=> (or (< x@@91 0) (>= x@@91 l@@91)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91))
))))))) (forall (($$0@@42 Int) ) (!  (=> (and (>= $$0@@42 0) (< $$0@@42 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@42)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@42)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@42)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@42))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@39))
))) (and (forall (($$0@@43 Int) ) (!  (=> (and (>= $$0@@43 0) (< $$0@@43 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) $$0@@43))
)) (|b#$Boolean| ($Boolean (let (($range_1@@21 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@29 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@21)) $i_0@@29) (< $i_0@@29 (|i#$Integer| (|ub#$Range| $range_1@@21)))) (let ((i@@19 ($Integer $i_0@@29)))
(|b#$Boolean| ($Boolean (let (($range_3@@6 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@6)) $i_2@@6) (< $i_2@@6 (|i#$Integer| (|ub#$Range| $range_3@@6)))) (let ((j@@7 ($Integer $i_2@@6)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@19)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@7)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@19 j@@7)))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@15))
))) (and (forall (($inv_addr@@16 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16)) (let ((va@@92 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))))
(let ((l@@92 (|l#$ValueArray| va@@92)))
 (and (and (<= 0 l@@92) (<= l@@92 $MAX_U64)) (forall ((x@@92 Int) ) (!  (=> (or (< x@@92 0) (>= x@@92 l@@92)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config)) (let ((va@@93 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@93 (|l#$ValueArray| va@@93)))
 (and (and (<= 0 l@@93) (<= l@@93 $MAX_U64)) (forall ((x@@93 Int) ) (!  (=> (or (< x@@93 0) (>= x@@93 l@@93)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@94 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@94 (|l#$ValueArray| va@@94)))
 (and (and (<= 0 l@@94) (<= l@@94 $MAX_U64)) (forall ((x@@94 Int) ) (!  (=> (or (< x@@94 0) (>= x@@94 l@@94)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94))
))))))) (forall (($$0@@44 Int) ) (!  (=> (and (>= $$0@@44 0) (< $$0@@44 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@44)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@44)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@44)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@44))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@95 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@95 (|l#$ValueArray| va@@95)))
 (and (and (<= 0 l@@95) (<= l@@95 $MAX_U64)) (forall ((x@@95 Int) ) (!  (=> (or (< x@@95 0) (>= x@@95 l@@95)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95))
))))))) (forall (($$0@@45 Int) ) (!  (=> (and (>= $$0@@45 0) (< $$0@@45 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@45)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@45)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@45)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@45))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@96 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@96 (|l#$ValueArray| va@@96)))
 (and (and (<= 0 l@@96) (<= l@@96 $MAX_U64)) (forall ((x@@96 Int) ) (!  (=> (or (< x@@96 0) (>= x@@96 l@@96)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96))
))))))) (forall (($$0@@46 Int) ) (!  (=> (and (>= $$0@@46 0) (< $$0@@46 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@46)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@46)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@46)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@46))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@16))
)) (|b#$Boolean| ($Boolean (forall ((config_address@@2 T@$Value) )  (=> ((_ is $Address) config_address@@2) (|b#$Boolean| ($Boolean (forall ((config_type@@2 T@$Value) )  (=> ((_ is $Type) config_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@2)) 1) (|a#$Address| config_address@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@2 ($Address 173345816))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@22 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@54 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@54)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@30 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@22)) $i_0@@30) (< $i_0@@30 (|i#$Integer| (|ub#$Range| $range_1@@22)))) (let ((i1@@5 ($Integer $i_0@@30)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@55 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@55)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@5)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@55 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@55)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@5)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@23 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@56 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@56)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@31 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@23)) $i_0@@31) (< $i_0@@31 (|i#$Integer| (|ub#$Range| $range_1@@23)))) (let ((i1@@6 ($Integer $i_0@@31)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@57 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@57)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@6)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 114029) 113395)))) inline$$DiemSystem_get_validator_config_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (and ((_ is $Address) addr@@42) (= (ControlFlow 0 112532) 114029)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 143931) 112532) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$AddU64$0$dst@3 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun validators () T@$Value)
(declare-fun addr@@58 () T@$Value)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun $ret0@0 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun call4formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun call0formal@$tv0@0@@2 () T@$TypeValue)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$i@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t18@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t22@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@2 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@3 () T@$Value)
(declare-fun inline$$Vector_borrow$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Vector_borrow$0$i_ind@2 () Int)
(declare-fun inline$$Vector_borrow$0$dst@2@@1 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun inline$$Vector_borrow$0$ta@1 () T@$TypeValue)
(declare-fun inline$$Lt$0$dst@2 () T@$Value)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun call0formal@$tv0@0@@3 () T@$TypeValue)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$DiemSystem_get_validator_index__$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 146808) (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon30_correct  (and (=> (= (ControlFlow 0 116460) (- 0 148557)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$AddU64$0$dst@3) (|i#$Integer| inline$$Vector_length$0$l@1))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$AddU64$0$dst@3) (|i#$Integer| inline$$Vector_length$0$l@1)))) (=> (= (ControlFlow 0 116460) (- 0 148569)) (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1 ($Range ($Integer 0) inline$$AddU64$0$dst@3)))
(forall ((inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0) (< inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1)))) (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$j ($Integer inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$j)))) $DiemSystem_ValidatorInfo_addr) addr@@58)))))))))))))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 116458) 116460)) inline$$DiemSystem_get_validator_index__$def_verify$0$anon30_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 116468) 116460) inline$$DiemSystem_get_validator_index__$def_verify$0$anon30_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@3@@2) (and (=> (= (ControlFlow 0 116452) 116468) inline$$DiemSystem_get_validator_index__$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 116452) 116458) inline$$DiemSystem_get_validator_index__$def_verify$0$anon51_Else_correct)))))
(let ((GeneratedUnifiedExit_correct  (and (=> (= (ControlFlow 0 146801) (- 0 148810)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 146801) (- 0 148819)) (=> $abort_flag@6@@1 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@6@@1 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 146801) (- 0 148828)) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@24 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| validators))))))
(forall (($i_0@@32 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@24)) $i_0@@32) (< $i_0@@32 (|i#$Integer| (|ub#$Range| $range_1@@24)))) (let ((i@@20 ($Integer $i_0@@32)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| i@@20)))) $DiemSystem_ValidatorInfo_addr) addr@@58)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $ret0@0)) $Option_Option_vec)) ($Integer 0))))))))) (=> (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@24 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| validators))))))
(forall (($i_0@@33 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@24)) $i_0@@33) (< $i_0@@33 (|i#$Integer| (|ub#$Range| $range_1@@24)))) (let ((i@@20 ($Integer $i_0@@33)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| i@@20)))) $DiemSystem_ValidatorInfo_addr) addr@@58)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $ret0@0)) $Option_Option_vec)) ($Integer 0)))))))) (and (=> (= (ControlFlow 0 146801) (- 0 148899)) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@7 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| validators))))))
(exists (($i_2@@7 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@7)) $i_2@@7) (< $i_2@@7 (|i#$Integer| (|ub#$Range| $range_3@@7)))) (let ((i@@21 ($Integer $i_2@@7)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| i@@21)))) $DiemSystem_ValidatorInfo_addr) addr@@58))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $ret0@0)) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| (let ((at@@0 ($Vector_$borrow $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $ret0@0)) $Option_Option_vec) ($Integer 0))))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| at@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| at@@0) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| validators)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| at@@0)))) $DiemSystem_ValidatorInfo_addr) addr@@58))))))))))))))) (=> (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@7 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| validators))))))
(exists (($i_2@@8 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@7)) $i_2@@8) (< $i_2@@8 (|i#$Integer| (|ub#$Range| $range_3@@7)))) (let ((i@@21 ($Integer $i_2@@8)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| i@@21)))) $DiemSystem_ValidatorInfo_addr) addr@@58))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $ret0@0)) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| (let ((at@@0 ($Vector_$borrow $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $ret0@0)) $Option_Option_vec) ($Integer 0))))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| at@@0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| at@@0) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| validators)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| at@@0)))) $DiemSystem_ValidatorInfo_addr) addr@@58)))))))))))))) (=> (= (ControlFlow 0 146801) (- 0 149043)) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@59 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@59)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@60 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@60)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))))))))))
(let ((anon0$2_correct@@3  (=> (= $ret0@0 inline$$DiemSystem_get_validator_index__$def_verify$0$$ret0@2) (=> (and (= $abort_flag@6@@1 $abort_flag@5@@1) (= (ControlFlow 0 116662) 146801)) GeneratedUnifiedExit_correct))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon24_correct  (=> (= $abort_flag@5@@1 $abort_flag@4@@2) (=> (and (= inline$$DiemSystem_get_validator_index__$def_verify$0$$ret0@2 call4formal@$ret0@0@@3) (= (ControlFlow 0 116562) 116662)) anon0$2_correct@@3))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 116560) 116562)) inline$$DiemSystem_get_validator_index__$def_verify$0$anon24_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 116570) 116562) inline$$DiemSystem_get_validator_index__$def_verify$0$anon24_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon46_Else_correct  (=> (not $abort_flag@4@@2) (and (=> (= (ControlFlow 0 116554) 116570) inline$$DiemSystem_get_validator_index__$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 116554) 116560) inline$$DiemSystem_get_validator_index__$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$Abort_correct  (=> (and (and (= inline$$DiemSystem_get_validator_index__$def_verify$0$$ret0@1 $Error) (= $abort_flag@5@@1 true)) (and (= inline$$DiemSystem_get_validator_index__$def_verify$0$$ret0@2 inline$$DiemSystem_get_validator_index__$def_verify$0$$ret0@1) (= (ControlFlow 0 115785) 116662))) anon0$2_correct@@3)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 116600) 115785)) inline$$DiemSystem_get_validator_index__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 116610) 115785) inline$$DiemSystem_get_validator_index__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon43_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 116594) 116610) inline$$DiemSystem_get_validator_index__$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 116594) 116600) inline$$DiemSystem_get_validator_index__$def_verify$0$anon44_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 116580) 115785)) inline$$DiemSystem_get_validator_index__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 116590) 115785) inline$$DiemSystem_get_validator_index__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon46_Then_correct  (=> $abort_flag@4@@2 (and (=> (= (ControlFlow 0 116574) 116590) inline$$DiemSystem_get_validator_index__$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 116574) 116580) inline$$DiemSystem_get_validator_index__$def_verify$0$anon47_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon45_Then$1_correct  (=> (and (and (= call0formal@$tv0@0@@2 $IntegerType) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@2)) (and (=> $abort_flag@4@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@3 ($Vector (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) 1))) (+ len@@5 1)))))))))) (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@3) (let ((va@@97 (|v#$Vector| call4formal@$ret0@0@@3)))
(let ((l@@97 (|l#$ValueArray| va@@97)))
 (and (and (<= 0 l@@97) (<= l@@97 $MAX_U64)) (forall ((x@@97 Int) ) (!  (=> (or (< x@@97 0) (>= x@@97 l@@97)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $Option_Option_vec)) (let ((va@@98 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $Option_Option_vec))))
(let ((l@@98 (|l#$ValueArray| va@@98)))
 (and (and (<= 0 l@@98) (<= l@@98 $MAX_U64)) (forall ((x@@98 Int) ) (!  (=> (or (< x@@98 0) (>= x@@98 l@@98)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 116546) 116574) inline$$DiemSystem_get_validator_index__$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 116546) 116554) inline$$DiemSystem_get_validator_index__$def_verify$0$anon46_Else_correct))))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon45_Then_correct  (=> (|b#$Boolean| inline$$DiemSystem_get_validator_index__$def_verify$0$$t18@2) (and (=> (= (ControlFlow 0 116544) (- 0 148418)) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1)))) $DiemSystem_ValidatorInfo_addr) addr@@58)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1)))) $DiemSystem_ValidatorInfo_addr) addr@@58))) (=> (= (ControlFlow 0 116544) 116546) inline$$DiemSystem_get_validator_index__$def_verify$0$anon45_Then$1_correct))))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 116478) 115785)) inline$$DiemSystem_get_validator_index__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 116488) 115785) inline$$DiemSystem_get_validator_index__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon49_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 116472) 116488) inline$$DiemSystem_get_validator_index__$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 116472) 116478) inline$$DiemSystem_get_validator_index__$def_verify$0$anon50_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= inline$$AddU64$0$dst@3 inline$$AddU64$0$dst@1) (= $abort_flag@3@@2 true)) (and (=> (= (ControlFlow 0 116438) 116472) inline$$DiemSystem_get_validator_index__$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 116438) 116452) inline$$DiemSystem_get_validator_index__$def_verify$0$anon49_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t22@2)) $MAX_U64) (= (ControlFlow 0 116436) 116438)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t22@2))) (= inline$$AddU64$0$dst@2 ($Integer (+ (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t22@2))))) (and (= inline$$AddU64$0$dst@3 inline$$AddU64$0$dst@2) (= $abort_flag@3@@2 $abort_flag@2@@2))) (and (=> (= (ControlFlow 0 116380) 116472) inline$$DiemSystem_get_validator_index__$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 116380) 116452) inline$$DiemSystem_get_validator_index__$def_verify$0$anon49_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 116350) (- 0 148461)) true) (and (=> (= (ControlFlow 0 116350) 116436) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 116350) 116380) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon45_Else$1_correct  (=> (and (= inline$$DiemSystem_get_validator_index__$def_verify$0$$t22@2 ($Integer 1)) (= (ControlFlow 0 116444) 116350)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemSystem_get_validator_index__$def_verify$0$$t18@2)) (= (ControlFlow 0 116253) 116444)) inline$$DiemSystem_get_validator_index__$def_verify$0$anon45_Else$1_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon43_Else$3_correct  (=> (= inline$$DiemSystem_get_validator_index__$def_verify$0$$t18@2 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@2 addr@@58))) (and (=> (= (ControlFlow 0 116213) 116544) inline$$DiemSystem_get_validator_index__$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 116213) 116253) inline$$DiemSystem_get_validator_index__$def_verify$0$anon45_Else_correct)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@2  (=> (and (= inline$$GetFieldFromValue$0$dst@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_borrow$0$dst@3)) $DiemSystem_ValidatorInfo_addr)) (= (ControlFlow 0 116163) 116213)) inline$$DiemSystem_get_validator_index__$def_verify$0$anon43_Else$3_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon43_Else_correct  (=> (and (not $abort_flag@2@@2) (= (ControlFlow 0 116121) 116163)) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$Vector_borrow$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@2@@2 true) (= inline$$Vector_borrow$0$dst@3 inline$$Vector_borrow$0$dst@1@@1)) (and (=> (= (ControlFlow 0 116075) 116594) inline$$DiemSystem_get_validator_index__$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 116075) 116121) inline$$DiemSystem_get_validator_index__$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon3_Then_correct@@1  (=> (and (or (< inline$$Vector_borrow$0$i_ind@2 0) (>= inline$$Vector_borrow$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| validators)))) (= (ControlFlow 0 116073) 116075)) inline$$Vector_borrow$0$anon3_Then$1_correct@@1)))
(let ((inline$$Vector_borrow$0$anon3_Else_correct@@1  (=> (and (and (not (or (< inline$$Vector_borrow$0$i_ind@2 0) (>= inline$$Vector_borrow$0$i_ind@2 (|l#$ValueArray| (|v#$Vector| validators))))) (= inline$$Vector_borrow$0$dst@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) inline$$Vector_borrow$0$i_ind@2))) (and (= $abort_flag@2@@2 $abort_flag@0@@3) (= inline$$Vector_borrow$0$dst@3 inline$$Vector_borrow$0$dst@2@@1))) (and (=> (= (ControlFlow 0 116015) 116594) inline$$DiemSystem_get_validator_index__$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 116015) 116121) inline$$DiemSystem_get_validator_index__$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Vector_borrow$0$anon0_correct@@1  (=> ((_ is $Vector) validators) (=> (and ((_ is $Integer) inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) (= inline$$Vector_borrow$0$i_ind@2 (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1))) (and (=> (= (ControlFlow 0 115989) 116073) inline$$Vector_borrow$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 115989) 116015) inline$$Vector_borrow$0$anon3_Else_correct@@1))))))
(let ((inline$$Vector_borrow$0$Entry_correct@@1  (=> (and (= inline$$Vector_borrow$0$ta@1 $DiemSystem_ValidatorInfo_type_value) (= (ControlFlow 0 115975) 115989)) inline$$Vector_borrow$0$anon0_correct@@1)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon42_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@2) (= (ControlFlow 0 115831) 115975)) inline$$Vector_borrow$0$Entry_correct@@1)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 115777) 115785)) inline$$DiemSystem_get_validator_index__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 115793) 115785) inline$$DiemSystem_get_validator_index__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon52_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 115771) 115793) inline$$DiemSystem_get_validator_index__$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 115771) 115777) inline$$DiemSystem_get_validator_index__$def_verify$0$anon53_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon36_correct  (=> (= $abort_flag@5@@1 $abort_flag@1@@3) (=> (and (= inline$$DiemSystem_get_validator_index__$def_verify$0$$ret0@2 call3formal@$ret0@0@@6) (= (ControlFlow 0 115759) 116662)) anon0$2_correct@@3))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 115757) 115759)) inline$$DiemSystem_get_validator_index__$def_verify$0$anon36_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 115767) 115759) inline$$DiemSystem_get_validator_index__$def_verify$0$anon36_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@1@@3) (and (=> (= (ControlFlow 0 115751) 115767) inline$$DiemSystem_get_validator_index__$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 115751) 115757) inline$$DiemSystem_get_validator_index__$def_verify$0$anon54_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon42_Else_correct  (=> (not (|b#$Boolean| inline$$Lt$0$dst@2)) (and (=> (= (ControlFlow 0 115743) (- 0 148095)) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_get_validator_index__$def_verify$0$i@1 inline$$Vector_length$0$l@1)))) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_get_validator_index__$def_verify$0$i@1 inline$$Vector_length$0$l@1))) (and (=> (= (ControlFlow 0 115743) (- 0 148103)) (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@0 ($Range ($Integer 0) inline$$Vector_length$0$l@1)))
(forall ((inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@0)) inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@0) (< inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@0)))) (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$j@@0 ($Integer inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@0)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$j@@0)))) $DiemSystem_ValidatorInfo_addr) addr@@58))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@0 ($Range ($Integer 0) inline$$Vector_length$0$l@1)))
(forall ((inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@0)) inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@1) (< inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@1 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@0)))) (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$j@@0 ($Integer inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@1)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$j@@0)))) $DiemSystem_ValidatorInfo_addr) addr@@58)))))))))) (=> (and (and (= call0formal@$tv0@0@@3 $IntegerType) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3)) (and (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Vector (let ((len@@6 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@6 ($Vector $EmptyValueArray)) (+ len@@6 1)))))))))) (=> (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@6) (let ((va@@99 (|v#$Vector| call3formal@$ret0@0@@6)))
(let ((l@@99 (|l#$ValueArray| va@@99)))
 (and (and (<= 0 l@@99) (<= l@@99 $MAX_U64)) (forall ((x@@99 Int) ) (!  (=> (or (< x@@99 0) (>= x@@99 l@@99)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99))
)))))) (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@6)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@6)) $Option_Option_vec)) (let ((va@@100 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@6)) $Option_Option_vec))))
(let ((l@@100 (|l#$ValueArray| va@@100)))
 (and (and (<= 0 l@@100) (<= l@@100 $MAX_U64)) (forall ((x@@100 Int) ) (!  (=> (or (< x@@100 0) (>= x@@100 l@@100)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@6)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 115743) 115771) inline$$DiemSystem_get_validator_index__$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 115743) 115751) inline$$DiemSystem_get_validator_index__$def_verify$0$anon52_Else_correct)))))))))))
(let ((inline$$Lt$0$anon0_correct@@0  (=> (= inline$$Lt$0$dst@2 ($Boolean (< (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) (|i#$Integer| inline$$Vector_length$0$l@1)))) (and (=> (= (ControlFlow 0 115666) 115831) inline$$DiemSystem_get_validator_index__$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 115666) 115743) inline$$DiemSystem_get_validator_index__$def_verify$0$anon42_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 115652) (- 0 148064)) true) (=> (= (ControlFlow 0 115652) 115666) inline$$Lt$0$anon0_correct@@0))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$L6_correct  (=> (not $abort_flag@0@@3) (=> (and (and ((_ is $Integer) inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) (>= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) 0)) (<= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) $MAX_U64)) (=> (and (and (and (and (and (and (and (and (and ((_ is $Vector) inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1) (let ((va@@101 (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)))
(let ((l@@101 (|l#$ValueArray| va@@101)))
 (and (and (<= 0 l@@101) (<= l@@101 $MAX_U64)) (forall ((x@@101 Int) ) (!  (=> (or (< x@@101 0) (>= x@@101 l@@101)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config)) (let ((va@@102 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))))
(let ((l@@102 (|l#$ValueArray| va@@102)))
 (and (and (<= 0 l@@102) (<= l@@102 $MAX_U64)) (forall ((x@@102 Int) ) (!  (=> (or (< x@@102 0) (>= x@@102 l@@102)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@103 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@103 (|l#$ValueArray| va@@103)))
 (and (and (<= 0 l@@103) (<= l@@103 $MAX_U64)) (forall ((x@@103 Int) ) (!  (=> (or (< x@@103 0) (>= x@@103 l@@103)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103))
))))))) (forall (($$0@@47 Int) ) (!  (=> (and (>= $$0@@47 0) (< $$0@@47 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@47)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@47)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@47)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@47))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@104 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@104 (|l#$ValueArray| va@@104)))
 (and (and (<= 0 l@@104) (<= l@@104 $MAX_U64)) (forall ((x@@104 Int) ) (!  (=> (or (< x@@104 0) (>= x@@104 l@@104)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104))
))))))) (forall (($$0@@48 Int) ) (!  (=> (and (>= $$0@@48 0) (< $$0@@48 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@48)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@48)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@48)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@48))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@105 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@105 (|l#$ValueArray| va@@105)))
 (and (and (<= 0 l@@105) (<= l@@105 $MAX_U64)) (forall ((x@@105 Int) ) (!  (=> (or (< x@@105 0) (>= x@@105 l@@105)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105))
))))))) (forall (($$0@@49 Int) ) (!  (=> (and (>= $$0@@49 0) (< $$0@@49 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@49)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@49)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@49)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@49))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$validator_info_ref@1)) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) (and (and ((_ is $Integer) inline$$DiemSystem_get_validator_index__$def_verify$0$$t8@1) (>= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t8@1) 0)) (<= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t8@1) $MAX_U64))) (and (and (and (and ((_ is $Integer) inline$$DiemSystem_get_validator_index__$def_verify$0$$t9@1) (>= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t9@1) 0)) (<= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t9@1) $MAX_U64)) ((_ is $Boolean) inline$$DiemSystem_get_validator_index__$def_verify$0$$t10@1)) (and (and (and ((_ is $Vector) inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1) (let ((va@@106 (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)))
(let ((l@@106 (|l#$ValueArray| va@@106)))
 (and (and (<= 0 l@@106) (<= l@@106 $MAX_U64)) (forall ((x@@106 Int) ) (!  (=> (or (< x@@106 0) (>= x@@106 l@@106)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106))
)))))) (forall ((inline$$DiemSystem_get_validator_index__$def_verify$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemSystem_get_validator_index__$def_verify$0$$$0 0) (< inline$$DiemSystem_get_validator_index__$def_verify$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)))) (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0)) (let ((va@@107 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))))
(let ((l@@107 (|l#$ValueArray| va@@107)))
 (and (and (<= 0 l@@107) (<= l@@107 $MAX_U64)) (forall ((x@@107 Int) ) (!  (=> (or (< x@@107 0) (>= x@@107 l@@107)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config)) (let ((va@@108 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@108 (|l#$ValueArray| va@@108)))
 (and (and (<= 0 l@@108) (<= l@@108 $MAX_U64)) (forall ((x@@108 Int) ) (!  (=> (or (< x@@108 0) (>= x@@108 l@@108)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@109 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@109 (|l#$ValueArray| va@@109)))
 (and (and (<= 0 l@@109) (<= l@@109 $MAX_U64)) (forall ((x@@109 Int) ) (!  (=> (or (< x@@109 0) (>= x@@109 l@@109)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109))
))))))) (forall (($$0@@50 Int) ) (!  (=> (and (>= $$0@@50 0) (< $$0@@50 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@50)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@50)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@50)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@50))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@110 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@110 (|l#$ValueArray| va@@110)))
 (and (and (<= 0 l@@110) (<= l@@110 $MAX_U64)) (forall ((x@@110 Int) ) (!  (=> (or (< x@@110 0) (>= x@@110 l@@110)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110))
))))))) (forall (($$0@@51 Int) ) (!  (=> (and (>= $$0@@51 0) (< $$0@@51 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@51)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@51)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@51)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@51))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@111 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@111 (|l#$ValueArray| va@@111)))
 (and (and (<= 0 l@@111) (<= l@@111 $MAX_U64)) (forall ((x@@111 Int) ) (!  (=> (or (< x@@111 0) (>= x@@111 l@@111)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111))
))))))) (forall (($$0@@52 Int) ) (!  (=> (and (>= $$0@@52 0) (< $$0@@52 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@52)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@52)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@52)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@52))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t11@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$$0))
))) (and (and ((_ is $Integer) inline$$DiemSystem_get_validator_index__$def_verify$0$$t12@1) (>= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t12@1) 0)) (<= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t12@1) $MAX_U64))))) (=> (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1) (let ((va@@112 (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)))
(let ((l@@112 (|l#$ValueArray| va@@112)))
 (and (and (<= 0 l@@112) (<= l@@112 $MAX_U64)) (forall ((x@@112 Int) ) (!  (=> (or (< x@@112 0) (>= x@@112 l@@112)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config)) (let ((va@@113 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))))
(let ((l@@113 (|l#$ValueArray| va@@113)))
 (and (and (<= 0 l@@113) (<= l@@113 $MAX_U64)) (forall ((x@@113 Int) ) (!  (=> (or (< x@@113 0) (>= x@@113 l@@113)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@114 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@114 (|l#$ValueArray| va@@114)))
 (and (and (<= 0 l@@114) (<= l@@114 $MAX_U64)) (forall ((x@@114 Int) ) (!  (=> (or (< x@@114 0) (>= x@@114 l@@114)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114))
))))))) (forall (($$0@@53 Int) ) (!  (=> (and (>= $$0@@53 0) (< $$0@@53 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@53)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@53)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@53)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@53))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@115 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@115 (|l#$ValueArray| va@@115)))
 (and (and (<= 0 l@@115) (<= l@@115 $MAX_U64)) (forall ((x@@115 Int) ) (!  (=> (or (< x@@115 0) (>= x@@115 l@@115)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115))
))))))) (forall (($$0@@54 Int) ) (!  (=> (and (>= $$0@@54 0) (< $$0@@54 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@54)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@54)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@54)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@54))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@116 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@116 (|l#$ValueArray| va@@116)))
 (and (and (<= 0 l@@116) (<= l@@116 $MAX_U64)) (forall ((x@@116 Int) ) (!  (=> (or (< x@@116 0) (>= x@@116 l@@116)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116))
))))))) (forall (($$0@@55 Int) ) (!  (=> (and (>= $$0@@55 0) (< $$0@@55 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@55)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@55)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@55)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@55))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_get_validator_index__$def_verify$0$$t14@1)) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) ((_ is $Address) inline$$DiemSystem_get_validator_index__$def_verify$0$$t16@1)) (and ((_ is $Address) inline$$DiemSystem_get_validator_index__$def_verify$0$$t17@1) ((_ is $Boolean) inline$$DiemSystem_get_validator_index__$def_verify$0$$t18@1))) (and (and ((_ is $Integer) inline$$DiemSystem_get_validator_index__$def_verify$0$$t21@1) (>= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t21@1) 0)) (<= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t21@1) $MAX_U64))) (and (and (and (and ((_ is $Integer) inline$$DiemSystem_get_validator_index__$def_verify$0$$t22@1) (>= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t22@1) 0)) (<= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t22@1) $MAX_U64)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$i@1) (|i#$Integer| inline$$Vector_length$0$l@1))))) (and (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@1 ($Range ($Integer 0) inline$$DiemSystem_get_validator_index__$def_verify$0$i@1)))
(forall ((inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@1)) inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@2) (< inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@2 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@1)))) (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$j@@1 ($Integer inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@2)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$j@@1)))) $DiemSystem_ValidatorInfo_addr) addr@@58)))))))))) (= (ControlFlow 0 115574) 115652)))) inline$$Lt$0$Entry_correct@@0))))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon10_correct  (and (=> (= (ControlFlow 0 115381) (- 0 147689)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t7@1) (|i#$Integer| inline$$Vector_length$0$l@1))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$$t7@1) (|i#$Integer| inline$$Vector_length$0$l@1)))) (and (=> (= (ControlFlow 0 115381) (- 0 147701)) (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@2 ($Range ($Integer 0) inline$$DiemSystem_get_validator_index__$def_verify$0$$t7@1)))
(forall ((inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@3 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@2)) inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@3) (< inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@3 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@2)))) (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$j@@2 ($Integer inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@3)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$j@@2)))) $DiemSystem_ValidatorInfo_addr) addr@@58))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@2 ($Range ($Integer 0) inline$$DiemSystem_get_validator_index__$def_verify$0$$t7@1)))
(forall ((inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@4 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@2)) inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@4) (< inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@4 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_get_validator_index__$def_verify$0$$range_1@@2)))) (let ((inline$$DiemSystem_get_validator_index__$def_verify$0$j@@2 ($Integer inline$$DiemSystem_get_validator_index__$def_verify$0$$i_0@@4)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) (|i#$Integer| inline$$DiemSystem_get_validator_index__$def_verify$0$j@@2)))) $DiemSystem_ValidatorInfo_addr) addr@@58)))))))))) (=> (= (ControlFlow 0 115381) 115574) inline$$DiemSystem_get_validator_index__$def_verify$0$L6_correct)))))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 115379) 115381)) inline$$DiemSystem_get_validator_index__$def_verify$0$anon10_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 116618) 115381) inline$$DiemSystem_get_validator_index__$def_verify$0$anon10_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon39_Else_correct  (=> (and (not false) (= inline$$DiemSystem_get_validator_index__$def_verify$0$$t7@1 ($Integer 0))) (and (=> (= (ControlFlow 0 115371) 116618) inline$$DiemSystem_get_validator_index__$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 115371) 115379) inline$$DiemSystem_get_validator_index__$def_verify$0$anon41_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon39_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) validators) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| validators))))) (and (=> (= (ControlFlow 0 115321) 116622) inline$$DiemSystem_get_validator_index__$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 115321) 115371) inline$$DiemSystem_get_validator_index__$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $DiemSystem_ValidatorInfo_type_value) (= (ControlFlow 0 115309) 115321)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 115168) 115309)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 116646) 115309) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon37_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 115160) 116646) inline$$DiemSystem_get_validator_index__$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 115160) 115168) inline$$DiemSystem_get_validator_index__$def_verify$0$anon38_Else_correct)))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon37_Then_correct  (and (=> (= (ControlFlow 0 116654) 116646) inline$$DiemSystem_get_validator_index__$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 116654) 115168) inline$$DiemSystem_get_validator_index__$def_verify$0$anon38_Else_correct))))
(let ((inline$$DiemSystem_get_validator_index__$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 115154) 116654) inline$$DiemSystem_get_validator_index__$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 115154) 115160) inline$$DiemSystem_get_validator_index__$def_verify$0$anon37_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@117 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@117 (|l#$ValueArray| va@@117)))
 (and (and (<= 0 l@@117) (<= l@@117 $MAX_U64)) (forall ((x@@117 Int) ) (!  (=> (or (< x@@117 0) (>= x@@117 l@@117)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config)) (let ((va@@118 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@118 (|l#$ValueArray| va@@118)))
 (and (and (<= 0 l@@118) (<= l@@118 $MAX_U64)) (forall ((x@@118 Int) ) (!  (=> (or (< x@@118 0) (>= x@@118 l@@118)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@119 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@119 (|l#$ValueArray| va@@119)))
 (and (and (<= 0 l@@119) (<= l@@119 $MAX_U64)) (forall ((x@@119 Int) ) (!  (=> (or (< x@@119 0) (>= x@@119 l@@119)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119))
))))))) (forall (($$0@@56 Int) ) (!  (=> (and (>= $$0@@56 0) (< $$0@@56 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@56)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@56)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@56)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@56))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@120 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@120 (|l#$ValueArray| va@@120)))
 (and (and (<= 0 l@@120) (<= l@@120 $MAX_U64)) (forall ((x@@120 Int) ) (!  (=> (or (< x@@120 0) (>= x@@120 l@@120)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120))
))))))) (forall (($$0@@57 Int) ) (!  (=> (and (>= $$0@@57 0) (< $$0@@57 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@57)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@57)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@57)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@57))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@121 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@121 (|l#$ValueArray| va@@121)))
 (and (and (<= 0 l@@121) (<= l@@121 $MAX_U64)) (forall ((x@@121 Int) ) (!  (=> (or (< x@@121 0) (>= x@@121 l@@121)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121))
))))))) (forall (($$0@@58 Int) ) (!  (=> (and (>= $$0@@58 0) (< $$0@@58 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@58)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@58)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@58)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@58))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@17))
)) (= (ControlFlow 0 116660) 115154)) inline$$DiemSystem_get_validator_index__$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and (and ((_ is $Vector) validators) (let ((va@@122 (|v#$Vector| validators)))
(let ((l@@122 (|l#$ValueArray| va@@122)))
 (and (and (<= 0 l@@122) (<= l@@122 $MAX_U64)) (forall ((x@@122 Int) ) (!  (=> (or (< x@@122 0) (>= x@@122 l@@122)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122))
)))))) (forall (($$0@@59 Int) ) (!  (=> (and (>= $$0@@59 0) (< $$0@@59 (|l#$ValueArray| (|v#$Vector| validators)))) (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59)) (let ((va@@123 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))))
(let ((l@@123 (|l#$ValueArray| va@@123)))
 (and (and (<= 0 l@@123) (<= l@@123 $MAX_U64)) (forall ((x@@123 Int) ) (!  (=> (or (< x@@123 0) (>= x@@123 l@@123)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config)) (let ((va@@124 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@124 (|l#$ValueArray| va@@124)))
 (and (and (<= 0 l@@124) (<= l@@124 $MAX_U64)) (forall ((x@@124 Int) ) (!  (=> (or (< x@@124 0) (>= x@@124 l@@124)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@125 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@125 (|l#$ValueArray| va@@125)))
 (and (and (<= 0 l@@125) (<= l@@125 $MAX_U64)) (forall ((x@@125 Int) ) (!  (=> (or (< x@@125 0) (>= x@@125 l@@125)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125))
))))))) (forall (($$0@@60 Int) ) (!  (=> (and (>= $$0@@60 0) (< $$0@@60 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@60)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@60)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@60)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@60))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@126 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@126 (|l#$ValueArray| va@@126)))
 (and (and (<= 0 l@@126) (<= l@@126 $MAX_U64)) (forall ((x@@126 Int) ) (!  (=> (or (< x@@126 0) (>= x@@126 l@@126)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126))
))))))) (forall (($$0@@61 Int) ) (!  (=> (and (>= $$0@@61 0) (< $$0@@61 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@61)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@61)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@61)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@61))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@127 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@127 (|l#$ValueArray| va@@127)))
 (and (and (<= 0 l@@127) (<= l@@127 $MAX_U64)) (forall ((x@@127 Int) ) (!  (=> (or (< x@@127 0) (>= x@@127 l@@127)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127))
))))))) (forall (($$0@@62 Int) ) (!  (=> (and (>= $$0@@62 0) (< $$0@@62 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@62)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@62)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@62)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@62))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators)) $$0@@59))
))) (and ((_ is $Address) addr@@58) (= (ControlFlow 0 114273) 116660))) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 146808) 114273) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@5@@2 () Bool)
(declare-fun dr_account@@0 () T@$Value)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $DiemSystem_CapabilityHolder_$memory@1 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@2@@0 () T@$Memory)
(declare-fun $abort_flag@4@@3 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@0 () T@$Memory)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@0 () T@$Memory)
(declare-fun $DiemSystem_CapabilityHolder_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$DiemSystem_CapabilityHolder_pack$0$$struct@1 () T@$Value)
(declare-fun call7formal@$ret0@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@4 () T@$TypeValue)
(declare-fun inline$$DiemSystem_initialize_validator_set_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemSystem_DiemSystem_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 149069) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 119686) (- 0 153233)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 119686) (- 0 153248)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 119686) (- 0 153269)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 119686) (- 0 153298)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 119686) (- 0 153315)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 119686) (- 0 153325)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 119686) (- 0 153339)) (=> $abort_flag@5@@2 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (=> (=> $abort_flag@5@@2 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))) (and (=> (= (ControlFlow 0 119686) (- 0 153440)) (=> $abort_flag@5@@2 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 6))))))) (=> (=> $abort_flag@5@@2 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 6)))))) (and (=> (= (ControlFlow 0 119686) (- 0 153607)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory@1) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))) (=> (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory@1) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))) (and (=> (= (ControlFlow 0 119686) (- 0 153623)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@2@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@2@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))) (=> (= (ControlFlow 0 119686) (- 0 153635)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@61 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@61)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))) ($Integer 0))))))))))))))))))))))))))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon47_Else_correct  (=> (not $abort_flag@4@@3) (and (=> (= (ControlFlow 0 119548) (- 0 153003)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (= $abort_code@8@@1 $abort_code@6@@2) (=> (and (and (= $DiemConfig_DiemConfig_$memory@2@@0 $DiemConfig_DiemConfig_$memory@0@@0) (= $abort_flag@5@@2 $abort_flag@4@@3)) (and (= $DiemSystem_CapabilityHolder_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 119548) 119686))) anon0$2_correct@@4)))))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$Abort_correct  (=> (= $abort_code@8@@1 $abort_code@7@@2) (=> (and (and (= $DiemConfig_DiemConfig_$memory@2@@0 $DiemConfig_DiemConfig_$memory@1@@0) (= $abort_flag@5@@2 true)) (and (= $DiemSystem_CapabilityHolder_$memory@1 $DiemSystem_CapabilityHolder_$memory@0) (= (ControlFlow 0 119010) 119686))) anon0$2_correct@@4))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon5_correct  (=> (and (and (= $abort_code@7@@2 $abort_code@1@@3) (= $DiemSystem_CapabilityHolder_$memory@0 $DiemSystem_CapabilityHolder_$memory)) (and (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 119664) 119010))) inline$$DiemSystem_initialize_validator_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 119662) 119664)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 119672) 119664) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon34_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 119656) 119672) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 119656) 119662) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon9_correct  (=> (and (and (= $abort_code@7@@2 $abort_code@2@@2) (= $DiemSystem_CapabilityHolder_$memory@0 $DiemSystem_CapabilityHolder_$memory)) (and (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 119644) 119010))) inline$$DiemSystem_initialize_validator_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 119642) 119644)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon9_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 119652) 119644) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon9_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon36_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 119636) 119652) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 119636) 119642) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon13_correct  (=> (and (and (= $abort_code@7@@2 $abort_code@2@@2) (= $DiemSystem_CapabilityHolder_$memory@0 $DiemSystem_CapabilityHolder_$memory)) (and (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 119624) 119010))) inline$$DiemSystem_initialize_validator_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 119622) 119624)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon13_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 119632) 119624) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon13_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon38_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 119616) 119632) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 119616) 119622) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon17_correct  (=> (and (and (= $abort_code@7@@2 $abort_code@3@@2) (= $DiemSystem_CapabilityHolder_$memory@0 $DiemSystem_CapabilityHolder_$memory)) (and (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory@0@@0) (= (ControlFlow 0 119604) 119010))) inline$$DiemSystem_initialize_validator_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 119602) 119604)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon17_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 119612) 119604) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon17_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon40_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 119596) 119612) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 119596) 119602) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon23_correct  (=> (and (and (= $abort_code@7@@2 $abort_code@4@@2) (= $DiemSystem_CapabilityHolder_$memory@0 $DiemSystem_CapabilityHolder_$memory)) (and (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory@0@@0) (= (ControlFlow 0 119580) 119010))) inline$$DiemSystem_initialize_validator_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 119578) 119580)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon23_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 119588) 119580) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon23_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon43_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 119572) 119588) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 119572) 119578) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon31_correct  (=> (and (and (= $abort_code@7@@2 $abort_code@6@@2) (= $DiemSystem_CapabilityHolder_$memory@0 |inline$$MoveToRaw$0$m'@2|)) (and (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory@0@@0) (= (ControlFlow 0 119560) 119010))) inline$$DiemSystem_initialize_validator_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 119558) 119560)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon31_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 119568) 119560) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon31_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon47_Then_correct  (=> $abort_flag@4@@3 (and (=> (= (ControlFlow 0 119552) 119568) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 119552) 119558) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@4@@3 true) (=> (and (= $abort_code@6@@2 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 119490) 119552) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 119490) 119548) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 119488) 119490)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$DiemSystem_CapabilityHolder_pack$0$$struct@1))) (= $abort_flag@4@@3 $abort_flag@3@@3)) (and (= $abort_code@6@@2 $abort_code@4@@2) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 119438) 119552) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 119438) 119548) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| dr_account@@0)) (and (=> (= (ControlFlow 0 119496) 119488) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 119496) 119438) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 119284) (- 0 152888)) true) (=> (= (ControlFlow 0 119284) 119496) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 119170) 119284)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 119176) 119284) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 119164) 119176) inline$$DiemSystem_CapabilityHolder_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 119164) 119170) inline$$DiemSystem_CapabilityHolder_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 119156) 119284)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) call7formal@$ret0@0) (let ((va@@128 (|v#$Vector| call7formal@$ret0@0)))
(let ((l@@128 (|l#$ValueArray| va@@128)))
 (and (and (<= 0 l@@128) (<= l@@128 $MAX_U64)) (forall ((x@@128 Int) ) (!  (=> (or (< x@@128 0) (>= x@@128 l@@128)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128))
)))))) (= (|l#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $DiemConfig_ModifyConfigCapability_dummy_field))) true) (= inline$$DiemSystem_CapabilityHolder_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 call7formal@$ret0@0) 1)))) (and (=> (= (ControlFlow 0 119148) 119164) inline$$DiemSystem_CapabilityHolder_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 119148) 119156) inline$$DiemSystem_CapabilityHolder_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@0) (= (ControlFlow 0 119182) 119148)) inline$$DiemSystem_CapabilityHolder_pack$0$anon0_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon28_correct  (=> (and (and (= $abort_code@7@@2 $abort_code@5@@2) (= $DiemSystem_CapabilityHolder_$memory@0 $DiemSystem_CapabilityHolder_$memory)) (and (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory@0@@0) (= (ControlFlow 0 119006) 119010))) inline$$DiemSystem_initialize_validator_set_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 119004) 119006)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon28_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 119018) 119006) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon28_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (= $abort_code@5@@2 (|i#$Integer| call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 118998) 119018) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 118998) 119004) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon43_Else_correct  (=> (not $abort_flag@3@@3) (and (=> (= (ControlFlow 0 118986) 119182) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 118986) 118998) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon42_Else$1_correct  (=> (and (and (and (= inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@3)) (and (=> $abort_flag@3@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 118980) 119572) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 118980) 118986) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@0  (=> (and (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t9@1)))) (= (ControlFlow 0 118968) 118980)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon42_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 118958) (- 0 152688)) true) (=> (= (ControlFlow 0 118958) 118968) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon42_Else_correct  (=> (not $abort_flag@2@@3) (=> (and (= inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)))) (= (ControlFlow 0 118974) 118958)) inline$$Not$0$Entry_correct@@0))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon42_Then_correct  (=> $abort_flag@2@@3 (=> (and (and (= $abort_code@7@@2 $abort_code@3@@2) (= $DiemSystem_CapabilityHolder_$memory@0 $DiemSystem_CapabilityHolder_$memory)) (and (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory@0@@0) (= (ControlFlow 0 119592) 119010))) inline$$DiemSystem_initialize_validator_set_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 118886) 119592) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 118886) 118974) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 118896) 119592) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 118896) 118974) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon42_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@2@@3) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 118880) 118896) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 118880) 118886) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon40_Else_correct  (=> (and (not $abort_flag@2@@3) (= (ControlFlow 0 118910) 118880)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon38_Else$1_correct  (=> (= call0formal@$tv0@0@@4 $DiemSystem_DiemSystem_type_value) (and (=> (= (ControlFlow 0 118775) (- 0 152078)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_initialize_validator_set_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_initialize_validator_set_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2@@3) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@2@@3)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@2@@3)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@2@@3) (=> $abort_flag@2@@3 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816))))))))) (and (and (=> $abort_flag@2@@3 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@3@@2 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@3@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@3@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@3@@2 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816))))) (= $abort_code@3@@2 (|i#$Integer| ($Integer 6)))))) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@62 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| addr@@62)))) $DiemConfig_DiemConfig_payload)) inline$$DiemSystem_DiemSystem_pack$0$$struct@1)))) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (and (and (and (and (and ((_ is $Vector) call7formal@$ret0@0) (let ((va@@129 (|v#$Vector| call7formal@$ret0@0)))
(let ((l@@129 (|l#$ValueArray| va@@129)))
 (and (and (<= 0 l@@129) (<= l@@129 $MAX_U64)) (forall ((x@@129 Int) ) (!  (=> (or (< x@@129 0) (>= x@@129 l@@129)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129))
)))))) (= (|l#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $DiemConfig_ModifyConfigCapability_dummy_field))) true) (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (= (ControlFlow 0 118775) 119596) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 118775) 118910) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon40_Else_correct))))))))))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 118747) (- 0 151942)) (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_pack$0$$range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_pack$0$$i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_1)) inline$$DiemSystem_DiemSystem_pack$0$$i_0) (< inline$$DiemSystem_DiemSystem_pack$0$$i_0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_1)))) (let ((inline$$DiemSystem_DiemSystem_pack$0$i ($Integer inline$$DiemSystem_DiemSystem_pack$0$$i_0)))
(|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_pack$0$$range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_pack$0$$i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_3)) inline$$DiemSystem_DiemSystem_pack$0$$i_2) (< inline$$DiemSystem_DiemSystem_pack$0$$i_2 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_3)))) (let ((inline$$DiemSystem_DiemSystem_pack$0$j ($Integer inline$$DiemSystem_DiemSystem_pack$0$$i_2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_pack$0$i)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_pack$0$j)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_DiemSystem_pack$0$i inline$$DiemSystem_DiemSystem_pack$0$j))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_pack$0$$range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_pack$0$$i_0@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_1)) inline$$DiemSystem_DiemSystem_pack$0$$i_0@@0) (< inline$$DiemSystem_DiemSystem_pack$0$$i_0@@0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_1)))) (let ((inline$$DiemSystem_DiemSystem_pack$0$i ($Integer inline$$DiemSystem_DiemSystem_pack$0$$i_0@@0)))
(|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_pack$0$$range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_pack$0$$i_2@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_3)) inline$$DiemSystem_DiemSystem_pack$0$$i_2@@0) (< inline$$DiemSystem_DiemSystem_pack$0$$i_2@@0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_3)))) (let ((inline$$DiemSystem_DiemSystem_pack$0$j ($Integer inline$$DiemSystem_DiemSystem_pack$0$$i_2@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_pack$0$i)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_pack$0$j)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_DiemSystem_pack$0$i inline$$DiemSystem_DiemSystem_pack$0$j)))))))))))))))))) (=> (= (ControlFlow 0 118747) 118775) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon38_Else$1_correct)))))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 118761) 118747)) inline$$DiemSystem_DiemSystem_pack$0$anon3_correct)))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 118767) 118747) inline$$DiemSystem_DiemSystem_pack$0$anon3_correct)))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 118755) 118767) inline$$DiemSystem_DiemSystem_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 118755) 118761) inline$$DiemSystem_DiemSystem_pack$0$anon5_Else_correct)))))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 118621) 118747)) inline$$DiemSystem_DiemSystem_pack$0$anon3_correct)))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t5@1) (>= (|i#$Integer| inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t5@1) 0)) (<= (|i#$Integer| inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t5@1) $MAX_U8)) (=> (and (and (and ((_ is $Vector) inline$$Vector_empty$0$v@1) (let ((va@@130 (|v#$Vector| inline$$Vector_empty$0$v@1)))
(let ((l@@130 (|l#$ValueArray| va@@130)))
 (and (and (<= 0 l@@130) (<= l@@130 $MAX_U64)) (forall ((x@@130 Int) ) (!  (=> (or (< x@@130 0) (>= x@@130 l@@130)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130))
)))))) (forall ((inline$$DiemSystem_DiemSystem_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemSystem_DiemSystem_pack$0$$$0 0) (< inline$$DiemSystem_DiemSystem_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)))) (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0)) (let ((va@@131 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))))
(let ((l@@131 (|l#$ValueArray| va@@131)))
 (and (and (<= 0 l@@131) (<= l@@131 $MAX_U64)) (forall ((x@@131 Int) ) (!  (=> (or (< x@@131 0) (>= x@@131 l@@131)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config)) (let ((va@@132 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@132 (|l#$ValueArray| va@@132)))
 (and (and (<= 0 l@@132) (<= l@@132 $MAX_U64)) (forall ((x@@132 Int) ) (!  (=> (or (< x@@132 0) (>= x@@132 l@@132)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@133 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@133 (|l#$ValueArray| va@@133)))
 (and (and (<= 0 l@@133) (<= l@@133 $MAX_U64)) (forall ((x@@133 Int) ) (!  (=> (or (< x@@133 0) (>= x@@133 l@@133)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133))
))))))) (forall (($$0@@63 Int) ) (!  (=> (and (>= $$0@@63 0) (< $$0@@63 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@63)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@63)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@63)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@63))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@134 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@134 (|l#$ValueArray| va@@134)))
 (and (and (<= 0 l@@134) (<= l@@134 $MAX_U64)) (forall ((x@@134 Int) ) (!  (=> (or (< x@@134 0) (>= x@@134 l@@134)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134))
))))))) (forall (($$0@@64 Int) ) (!  (=> (and (>= $$0@@64 0) (< $$0@@64 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@64)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@64)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@64)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@64))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@135 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@135 (|l#$ValueArray| va@@135)))
 (and (and (<= 0 l@@135) (<= l@@135 $MAX_U64)) (forall ((x@@135 Int) ) (!  (=> (or (< x@@135 0) (>= x@@135 l@@135)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135))
))))))) (forall (($$0@@65 Int) ) (!  (=> (and (>= $$0@@65 0) (< $$0@@65 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@65)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@65)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@65)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@65))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))
))) (= inline$$DiemSystem_DiemSystem_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t5@1) 1 inline$$Vector_empty$0$v@1) 2)))) (and (=> (= (ControlFlow 0 118613) 118755) inline$$DiemSystem_DiemSystem_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 118613) 118621) inline$$DiemSystem_DiemSystem_pack$0$anon4_Else_correct))))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon38_Else_correct  (=> (and (not $abort_flag@1@@4) (= (ControlFlow 0 118773) 118613)) inline$$DiemSystem_DiemSystem_pack$0$anon0_correct)))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 118246) 119616) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 118246) 118773) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 $DiemSystem_ValidatorInfo_type_value) (= (ControlFlow 0 118242) 118246)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@1@@4) (=> (and (= inline$$DiemSystem_initialize_validator_set_$def_verify$0$$t5@1 ($Integer 0)) (= (ControlFlow 0 118252) 118242)) inline$$Vector_empty$0$Entry_correct))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon34_Else_correct  (=> (not $abort_flag@0@@4) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@1@@4) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@1@@4)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@1@@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@1@@4)) (and (=> $abort_flag@1@@4 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))))) (=> $abort_flag@1@@4 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 118209) 119636) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 118209) 118252) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon36_Else_correct)))))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0@@4) (=> (and (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0@@4 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 118203) 119656) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 118203) 118209) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon2_correct  (=> (and (= inline$$DiemSystem_initialize_validator_set_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 118201) 118203)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 118141) 118201)) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon2_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 119680) 118201) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon2_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 118135) 119680) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 118135) 118141) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon33_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (forall (($inv_addr@@18 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@18)) (let ((va@@136 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@18))))
(let ((l@@136 (|l#$ValueArray| va@@136)))
 (and (and (<= 0 l@@136) (<= l@@136 $MAX_U64)) (forall ((x@@136 Int) ) (!  (=> (or (< x@@136 0) (>= x@@136 l@@136)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@18))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@18))
)) (=> (and (forall (($inv_addr@@19 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19)) (let ((va@@137 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))))
(let ((l@@137 (|l#$ValueArray| va@@137)))
 (and (and (<= 0 l@@137) (<= l@@137 $MAX_U64)) (forall ((x@@137 Int) ) (!  (=> (or (< x@@137 0) (>= x@@137 l@@137)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))
)) (forall (($inv_addr@@20 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@20)) (let ((va@@138 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@20))))
(let ((l@@138 (|l#$ValueArray| va@@138)))
 (and (and (<= 0 l@@138) (<= l@@138 $MAX_U64)) (forall ((x@@138 Int) ) (!  (=> (or (< x@@138 0) (>= x@@138 l@@138)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@20))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@20))
))) (=> (and (and (forall (($inv_addr@@21 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@21)) (let ((va@@139 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@21))))
(let ((l@@139 (|l#$ValueArray| va@@139)))
 (and (and (<= 0 l@@139) (<= l@@139 $MAX_U64)) (forall ((x@@139 Int) ) (!  (=> (or (< x@@139 0) (>= x@@139 l@@139)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@21))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@21))) $DiemSystem_CapabilityHolder_cap)) (let ((va@@140 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@21))) $DiemSystem_CapabilityHolder_cap))))
(let ((l@@140 (|l#$ValueArray| va@@140)))
 (and (and (<= 0 l@@140) (<= l@@140 $MAX_U64)) (forall ((x@@140 Int) ) (!  (=> (or (< x@@140 0) (>= x@@140 l@@140)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@21))) $DiemSystem_CapabilityHolder_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@21))) $DiemSystem_CapabilityHolder_cap))) $DiemConfig_ModifyConfigCapability_dummy_field)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@21))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address@@3 T@$Value) )  (=> ((_ is $Address) config_address@@3) (|b#$Boolean| ($Boolean (forall ((config_type@@3 T@$Value) )  (=> ((_ is $Type) config_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@3)) 1) (|a#$Address| config_address@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@3 ($Address 173345816))))))))))))))))) (=> (and (and (and (|b#$Boolean| ($Boolean (forall ((addr@@63 T@$Value) )  (=> ((_ is $Address) addr@@63) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@63)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@63)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@63)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@64 T@$Value) )  (=> ((_ is $Address) addr@@64) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@64)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@64)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@65 T@$Value) )  (=> ((_ is $Address) addr@@65) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@65)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@65)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@65)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@66 T@$Value) )  (=> ((_ is $Address) addr@@66) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@66)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@66)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@66)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@66)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@25 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@67 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@67)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@34 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@25)) $i_0@@34) (< $i_0@@34 (|i#$Integer| (|ub#$Range| $range_1@@25)))) (let ((i1@@7 ($Integer $i_0@@34)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@68 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@68)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@7)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@68 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@68)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@7)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@26 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@69 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@69)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@35 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@26)) $i_0@@35) (< $i_0@@35 (|i#$Integer| (|ub#$Range| $range_1@@26)))) (let ((i1@@8 ($Integer $i_0@@35)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@70 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@70)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@8)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 119684) 118135)))) inline$$DiemSystem_initialize_validator_set_$def_verify$0$anon0_correct))))))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) dr_account@@0) (= (ControlFlow 0 117023) 119684)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_DiemConfig_$CallerDomain@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 149069) 117023)) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun inline$$DiemSystem_is_validator_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun addr@@71 () T@$Value)
(declare-fun inline$$DiemSystem_is_validator_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun call4formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@2 () T@$Value)
(declare-fun call2formal@$ret0@0@@4 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 153660) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 120781) (- 0 154975)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@4) (and (=> (= (ControlFlow 0 120781) (- 0 155006)) (=> $abort_flag@2@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@2@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 120781) (- 0 155037)) (=> $abort_flag@2@@4 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@3 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2@@4 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@3 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 120781) (- 0 155079)) (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_is_validator_$def_verify$0$$ret0@2 ($Boolean (let (($range_1@@27 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@72 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@72)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@36 Int) )  (and (and (>= $i_0@@36 0) (< $i_0@@36 (|l#$ValueArray| (|v#$Vector| $range_1@@27)))) (let ((v@@22 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@27)) $i_0@@36)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) $DiemSystem_ValidatorInfo_addr) addr@@71))))))))))))) (=> (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_is_validator_$def_verify$0$$ret0@2 ($Boolean (let (($range_1@@27 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@72 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@72)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@37 Int) )  (and (and (>= $i_0@@37 0) (< $i_0@@37 (|l#$ValueArray| (|v#$Vector| $range_1@@27)))) (let ((v@@22 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@27)) $i_0@@37)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@22)) $DiemSystem_ValidatorInfo_addr) addr@@71)))))))))))) (=> (= (ControlFlow 0 120781) (- 0 155097)) (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@73 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@73)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@74 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@74)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))))))))))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$Abort_correct  (=> (= inline$$DiemSystem_is_validator_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_flag@2@@4 true) (= $abort_code@4@@3 $abort_code@3@@3)) (and (= inline$$DiemSystem_is_validator_$def_verify$0$$ret0@2 inline$$DiemSystem_is_validator_$def_verify$0$$ret0@1) (= (ControlFlow 0 120737) 120781))) anon0$2_correct@@5))))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon5_correct  (=> (and (= $abort_code@3@@3 $abort_code@1@@4) (= (ControlFlow 0 120757) 120737)) inline$$DiemSystem_is_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 120755) 120757)) inline$$DiemSystem_is_validator_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 120765) 120757) inline$$DiemSystem_is_validator_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 120749) 120765) inline$$DiemSystem_is_validator_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 120749) 120755) inline$$DiemSystem_is_validator_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon9_correct  (=> (and (= $abort_code@3@@3 $abort_code@2@@3) (= (ControlFlow 0 120731) 120737)) inline$$DiemSystem_is_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 120729) 120731)) inline$$DiemSystem_is_validator_$def_verify$0$anon9_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 120745) 120731) inline$$DiemSystem_is_validator_$def_verify$0$anon9_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 120723) 120745) inline$$DiemSystem_is_validator_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 120723) 120729) inline$$DiemSystem_is_validator_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon12_correct  (=> (and (and (= $abort_flag@2@@4 $abort_flag@1@@5) (= $abort_code@4@@3 $abort_code@2@@3)) (and (= inline$$DiemSystem_is_validator_$def_verify$0$$ret0@2 call4formal@$ret0@0@@4) (= (ControlFlow 0 120711) 120781))) anon0$2_correct@@5)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 120709) 120711)) inline$$DiemSystem_is_validator_$def_verify$0$anon12_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 120719) 120711) inline$$DiemSystem_is_validator_$def_verify$0$anon12_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon16_Else_correct  (=> (not $abort_flag@1@@5) (and (=> (= (ControlFlow 0 120703) 120719) inline$$DiemSystem_is_validator_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 120703) 120709) inline$$DiemSystem_is_validator_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon14_Else$1_correct  (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@5) (=> (and (and (=> $abort_flag@1@@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@4 ($Boolean (let (($range_1@@28 inline$$GetFieldFromValue$0$dst@1@@2))
(exists (($i_0@@38 Int) )  (and (and (>= $i_0@@38 0) (< $i_0@@38 (|l#$ValueArray| (|v#$Vector| $range_1@@28)))) (let ((v@@23 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@28)) $i_0@@38)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@23)) $DiemSystem_ValidatorInfo_addr) addr@@71))))))))))))) (and (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@75 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@75)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@76 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@76)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))) ((_ is $Boolean) call4formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 120695) 120723) inline$$DiemSystem_is_validator_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 120695) 120703) inline$$DiemSystem_is_validator_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@3  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators)) (= (ControlFlow 0 120687) 120695)) inline$$DiemSystem_is_validator_$def_verify$0$anon14_Else$1_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon14_Else_correct  (=> (and (not $abort_flag@0@@5) (= (ControlFlow 0 120693) 120687)) inline$$GetFieldFromValue$0$anon0_correct@@3)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@5) (=> (and (and (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@4 (let ((addr@@77 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@77)))) $DiemConfig_DiemConfig_payload)))))) (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@78 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@78)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@79 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@79)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (=> (and (and (and (and (and (and ((_ is $Vector) call2formal@$ret0@0@@4) (let ((va@@141 (|v#$Vector| call2formal@$ret0@0@@4)))
(let ((l@@141 (|l#$ValueArray| va@@141)))
 (and (and (<= 0 l@@141) (<= l@@141 $MAX_U64)) (forall ((x@@141 Int) ) (!  (=> (or (< x@@141 0) (>= x@@141 l@@141)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141))
)))))) (= (|l#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators)) (let ((va@@142 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))))
(let ((l@@142 (|l#$ValueArray| va@@142)))
 (and (and (<= 0 l@@142) (<= l@@142 $MAX_U64)) (forall ((x@@142 Int) ) (!  (=> (or (< x@@142 0) (>= x@@142 l@@142)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142))
))))))) (forall (($$0@@66 Int) ) (!  (=> (and (>= $$0@@66 0) (< $$0@@66 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66)) (let ((va@@143 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))))
(let ((l@@143 (|l#$ValueArray| va@@143)))
 (and (and (<= 0 l@@143) (<= l@@143 $MAX_U64)) (forall ((x@@143 Int) ) (!  (=> (or (< x@@143 0) (>= x@@143 l@@143)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config)) (let ((va@@144 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@144 (|l#$ValueArray| va@@144)))
 (and (and (<= 0 l@@144) (<= l@@144 $MAX_U64)) (forall ((x@@144 Int) ) (!  (=> (or (< x@@144 0) (>= x@@144 l@@144)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@145 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@145 (|l#$ValueArray| va@@145)))
 (and (and (<= 0 l@@145) (<= l@@145 $MAX_U64)) (forall ((x@@145 Int) ) (!  (=> (or (< x@@145 0) (>= x@@145 l@@145)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145))
))))))) (forall (($$0@@67 Int) ) (!  (=> (and (>= $$0@@67 0) (< $$0@@67 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@67)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@67)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@67)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@67))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@146 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@146 (|l#$ValueArray| va@@146)))
 (and (and (<= 0 l@@146) (<= l@@146 $MAX_U64)) (forall ((x@@146 Int) ) (!  (=> (or (< x@@146 0) (>= x@@146 l@@146)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146))
))))))) (forall (($$0@@68 Int) ) (!  (=> (and (>= $$0@@68 0) (< $$0@@68 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@68)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@68)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@68)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@68))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@147 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@147 (|l#$ValueArray| va@@147)))
 (and (and (<= 0 l@@147) (<= l@@147 $MAX_U64)) (forall ((x@@147 Int) ) (!  (=> (or (< x@@147 0) (>= x@@147 l@@147)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147))
))))))) (forall (($$0@@69 Int) ) (!  (=> (and (>= $$0@@69 0) (< $$0@@69 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@69)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@69)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@69)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@69))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@66))
))) (and (forall (($$0@@70 Int) ) (!  (=> (and (>= $$0@@70 0) (< $$0@@70 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) $$0@@70))
)) (|b#$Boolean| ($Boolean (let (($range_1@@29 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@39 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@29)) $i_0@@39) (< $i_0@@39 (|i#$Integer| (|ub#$Range| $range_1@@29)))) (let ((i@@22 ($Integer $i_0@@39)))
(|b#$Boolean| ($Boolean (let (($range_3@@8 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@9 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@8)) $i_2@@9) (< $i_2@@9 (|i#$Integer| (|ub#$Range| $range_3@@8)))) (let ((j@@8 ($Integer $i_2@@9)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@22)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@4)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@8)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@22 j@@8)))))))))))))))))))) (and (=> (= (ControlFlow 0 120641) 120749) inline$$DiemSystem_is_validator_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 120641) 120693) inline$$DiemSystem_is_validator_$def_verify$0$anon14_Else_correct)))))))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 120605) 120641)) inline$$DiemSystem_is_validator_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 120773) 120641) inline$$DiemSystem_is_validator_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemSystem_is_validator_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 120599) 120773) inline$$DiemSystem_is_validator_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 120599) 120605) inline$$DiemSystem_is_validator_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (forall (($inv_addr@@22 Int) ($inv_tv0@@6 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@22)) (let ((va@@148 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@22))))
(let ((l@@148 (|l#$ValueArray| va@@148)))
 (and (and (<= 0 l@@148) (<= l@@148 $MAX_U64)) (forall ((x@@148 Int) ) (!  (=> (or (< x@@148 0) (>= x@@148 l@@148)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@22))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@22))
)) (=> (and (and (and (forall (($inv_addr@@23 Int) ($inv_tv0@@7 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@23)) (let ((va@@149 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@23))))
(let ((l@@149 (|l#$ValueArray| va@@149)))
 (and (and (<= 0 l@@149) (<= l@@149 $MAX_U64)) (forall ((x@@149 Int) ) (!  (=> (or (< x@@149 0) (>= x@@149 l@@149)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@23))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@23))) $Option_Option_vec)) (let ((va@@150 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@23))) $Option_Option_vec))))
(let ((l@@150 (|l#$ValueArray| va@@150)))
 (and (and (<= 0 l@@150) (<= l@@150 $MAX_U64)) (forall ((x@@150 Int) ) (!  (=> (or (< x@@150 0) (>= x@@150 l@@150)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@23))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@23))
)) (forall (($inv_addr@@24 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24)) (let ((va@@151 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))))
(let ((l@@151 (|l#$ValueArray| va@@151)))
 (and (and (<= 0 l@@151) (<= l@@151 $MAX_U64)) (forall ((x@@151 Int) ) (!  (=> (or (< x@@151 0) (>= x@@151 l@@151)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators)) (let ((va@@152 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))))
(let ((l@@152 (|l#$ValueArray| va@@152)))
 (and (and (<= 0 l@@152) (<= l@@152 $MAX_U64)) (forall ((x@@152 Int) ) (!  (=> (or (< x@@152 0) (>= x@@152 l@@152)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152))
))))))) (forall (($$0@@71 Int) ) (!  (=> (and (>= $$0@@71 0) (< $$0@@71 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71)) (let ((va@@153 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))))
(let ((l@@153 (|l#$ValueArray| va@@153)))
 (and (and (<= 0 l@@153) (<= l@@153 $MAX_U64)) (forall ((x@@153 Int) ) (!  (=> (or (< x@@153 0) (>= x@@153 l@@153)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config)) (let ((va@@154 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@154 (|l#$ValueArray| va@@154)))
 (and (and (<= 0 l@@154) (<= l@@154 $MAX_U64)) (forall ((x@@154 Int) ) (!  (=> (or (< x@@154 0) (>= x@@154 l@@154)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@155 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@155 (|l#$ValueArray| va@@155)))
 (and (and (<= 0 l@@155) (<= l@@155 $MAX_U64)) (forall ((x@@155 Int) ) (!  (=> (or (< x@@155 0) (>= x@@155 l@@155)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155))
))))))) (forall (($$0@@72 Int) ) (!  (=> (and (>= $$0@@72 0) (< $$0@@72 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@72)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@72)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@72)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@72))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@156 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@156 (|l#$ValueArray| va@@156)))
 (and (and (<= 0 l@@156) (<= l@@156 $MAX_U64)) (forall ((x@@156 Int) ) (!  (=> (or (< x@@156 0) (>= x@@156 l@@156)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156))
))))))) (forall (($$0@@73 Int) ) (!  (=> (and (>= $$0@@73 0) (< $$0@@73 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@73)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@73)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@73)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@73))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@157 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@157 (|l#$ValueArray| va@@157)))
 (and (and (<= 0 l@@157) (<= l@@157 $MAX_U64)) (forall ((x@@157 Int) ) (!  (=> (or (< x@@157 0) (>= x@@157 l@@157)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157))
))))))) (forall (($$0@@74 Int) ) (!  (=> (and (>= $$0@@74 0) (< $$0@@74 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@74)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@74)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@74)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@74))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@71))
))) (and (forall (($$0@@75 Int) ) (!  (=> (and (>= $$0@@75 0) (< $$0@@75 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) $$0@@75))
)) (|b#$Boolean| ($Boolean (let (($range_1@@30 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@40 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@30)) $i_0@@40) (< $i_0@@40 (|i#$Integer| (|ub#$Range| $range_1@@30)))) (let ((i@@23 ($Integer $i_0@@40)))
(|b#$Boolean| ($Boolean (let (($range_3@@9 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@10 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@9)) $i_2@@10) (< $i_2@@10 (|i#$Integer| (|ub#$Range| $range_3@@9)))) (let ((j@@9 ($Integer $i_2@@10)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@23)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@9)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@23 j@@9)))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@24))
))) (and (forall (($inv_addr@@25 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25)) (let ((va@@158 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))))
(let ((l@@158 (|l#$ValueArray| va@@158)))
 (and (and (<= 0 l@@158) (<= l@@158 $MAX_U64)) (forall ((x@@158 Int) ) (!  (=> (or (< x@@158 0) (>= x@@158 l@@158)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config)) (let ((va@@159 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@159 (|l#$ValueArray| va@@159)))
 (and (and (<= 0 l@@159) (<= l@@159 $MAX_U64)) (forall ((x@@159 Int) ) (!  (=> (or (< x@@159 0) (>= x@@159 l@@159)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@160 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@160 (|l#$ValueArray| va@@160)))
 (and (and (<= 0 l@@160) (<= l@@160 $MAX_U64)) (forall ((x@@160 Int) ) (!  (=> (or (< x@@160 0) (>= x@@160 l@@160)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160))
))))))) (forall (($$0@@76 Int) ) (!  (=> (and (>= $$0@@76 0) (< $$0@@76 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@76)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@76)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@76)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@76))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@161 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@161 (|l#$ValueArray| va@@161)))
 (and (and (<= 0 l@@161) (<= l@@161 $MAX_U64)) (forall ((x@@161 Int) ) (!  (=> (or (< x@@161 0) (>= x@@161 l@@161)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161))
))))))) (forall (($$0@@77 Int) ) (!  (=> (and (>= $$0@@77 0) (< $$0@@77 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@77)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@77)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@77)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@77))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@162 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@162 (|l#$ValueArray| va@@162)))
 (and (and (<= 0 l@@162) (<= l@@162 $MAX_U64)) (forall ((x@@162 Int) ) (!  (=> (or (< x@@162 0) (>= x@@162 l@@162)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@162) x@@162) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@162) x@@162))
))))))) (forall (($$0@@78 Int) ) (!  (=> (and (>= $$0@@78 0) (< $$0@@78 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@78)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@78)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@78)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@78))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@25))
)) (|b#$Boolean| ($Boolean (forall ((config_address@@4 T@$Value) )  (=> ((_ is $Address) config_address@@4) (|b#$Boolean| ($Boolean (forall ((config_type@@4 T@$Value) )  (=> ((_ is $Type) config_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@4)) 1) (|a#$Address| config_address@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@4 ($Address 173345816))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@31 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@80 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@80)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@41 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@31)) $i_0@@41) (< $i_0@@41 (|i#$Integer| (|ub#$Range| $range_1@@31)))) (let ((i1@@9 ($Integer $i_0@@41)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@81 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@81)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@9)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@81 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@81)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@9)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@32 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@82 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@82)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@42 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@32)) $i_0@@42) (< $i_0@@42 (|i#$Integer| (|ub#$Range| $range_1@@32)))) (let ((i1@@10 ($Integer $i_0@@42)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@83 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@83)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@10)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 120779) 120599)))) inline$$DiemSystem_is_validator_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@5  (=> (and ((_ is $Address) addr@@71) (= (ControlFlow 0 120009) 120779)) anon0$1_correct@@5)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 153660) 120009) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@5 () Bool)
(declare-fun inline$$DiemSystem_is_validator__$def_verify$0$$ret0@2 () T@$Value)
(declare-fun validators_vec_ref () T@$Value)
(declare-fun addr@@84 () T@$Value)
(declare-fun inline$$DiemSystem_is_validator__$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun call4formal@$ret0@0@@5 () T@$Value)
(declare-fun call0formal@$tv0@0@@5 () T@$TypeValue)
(declare-fun call4formal@$ret0@0@@6 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 155122) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 121480) (- 0 156244)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@5)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@5) (and (=> (= (ControlFlow 0 121480) (- 0 156253)) (=> $abort_flag@2@@5 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@2@@5 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 121480) (- 0 156262)) (=> (not $abort_flag@2@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_is_validator__$def_verify$0$$ret0@2 ($Boolean (let (($range_1@@33 validators_vec_ref))
(exists (($i_0@@43 Int) )  (and (and (>= $i_0@@43 0) (< $i_0@@43 (|l#$ValueArray| (|v#$Vector| $range_1@@33)))) (let ((v@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@33)) $i_0@@43)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@24)) $DiemSystem_ValidatorInfo_addr) addr@@84))))))))))))) (=> (=> (not $abort_flag@2@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_is_validator__$def_verify$0$$ret0@2 ($Boolean (let (($range_1@@33 validators_vec_ref))
(exists (($i_0@@44 Int) )  (and (and (>= $i_0@@44 0) (< $i_0@@44 (|l#$ValueArray| (|v#$Vector| $range_1@@33)))) (let ((v@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@33)) $i_0@@44)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@24)) $DiemSystem_ValidatorInfo_addr) addr@@84)))))))))))) (=> (= (ControlFlow 0 121480) (- 0 156313)) (=> (not $abort_flag@2@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@85 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@85)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@86 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@86)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))))))))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$Abort_correct  (=> (and (and (= inline$$DiemSystem_is_validator__$def_verify$0$$ret0@1 $Error) (= $abort_flag@2@@5 true)) (and (= inline$$DiemSystem_is_validator__$def_verify$0$$ret0@2 inline$$DiemSystem_is_validator__$def_verify$0$$ret0@1) (= (ControlFlow 0 121428) 121480))) anon0$2_correct@@6)))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 121446) 121428)) inline$$DiemSystem_is_validator__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 121456) 121428) inline$$DiemSystem_is_validator__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon17_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 121440) 121456) inline$$DiemSystem_is_validator__$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 121440) 121446) inline$$DiemSystem_is_validator__$def_verify$0$anon18_Else_correct)))))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 121420) 121428)) inline$$DiemSystem_is_validator__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 121436) 121428) inline$$DiemSystem_is_validator__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon19_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 121414) 121436) inline$$DiemSystem_is_validator__$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 121414) 121420) inline$$DiemSystem_is_validator__$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon14_correct  (=> (= $abort_flag@2@@5 $abort_flag@1@@6) (=> (and (= inline$$DiemSystem_is_validator__$def_verify$0$$ret0@2 call4formal@$ret0@0@@5) (= (ControlFlow 0 121402) 121480)) anon0$2_correct@@6))))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 121400) 121402)) inline$$DiemSystem_is_validator__$def_verify$0$anon14_correct)))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 121410) 121402) inline$$DiemSystem_is_validator__$def_verify$0$anon14_correct)))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon19_Else_correct  (=> (not $abort_flag@1@@6) (and (=> (= (ControlFlow 0 121394) 121410) inline$$DiemSystem_is_validator__$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 121394) 121400) inline$$DiemSystem_is_validator__$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon17_Else_correct  (=> (and (not $abort_flag@0@@6) (= call0formal@$tv0@0@@5 $IntegerType)) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@6) (=> $abort_flag@1@@6 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@5 ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Option_Option_vec)) ($Integer 0)))))))))) ((_ is $Boolean) call4formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 121386) 121414) inline$$DiemSystem_is_validator__$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 121386) 121394) inline$$DiemSystem_is_validator__$def_verify$0$anon19_Else_correct))))))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@6) (=> (and (and (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@34 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| validators_vec_ref))))))
(forall (($i_0@@45 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@34)) $i_0@@45) (< $i_0@@45 (|i#$Integer| (|ub#$Range| $range_1@@34)))) (let ((i@@24 ($Integer $i_0@@45)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) (|i#$Integer| i@@24)))) $DiemSystem_ValidatorInfo_addr) addr@@84)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Option_Option_vec)) ($Integer 0))))))))) (and (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@10 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| validators_vec_ref))))))
(exists (($i_2@@11 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@10)) $i_2@@11) (< $i_2@@11 (|i#$Integer| (|ub#$Range| $range_3@@10)))) (let ((i@@25 ($Integer $i_2@@11)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) (|i#$Integer| i@@25)))) $DiemSystem_ValidatorInfo_addr) addr@@84))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| (let ((at@@1 ($Vector_$borrow $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Option_Option_vec) ($Integer 0))))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| at@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| at@@1) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| validators_vec_ref)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) (|i#$Integer| at@@1)))) $DiemSystem_ValidatorInfo_addr) addr@@84)))))))))))))) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@87 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@87)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@88 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@88)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@6) (let ((va@@163 (|v#$Vector| call4formal@$ret0@0@@6)))
(let ((l@@163 (|l#$ValueArray| va@@163)))
 (and (and (<= 0 l@@163) (<= l@@163 $MAX_U64)) (forall ((x@@163 Int) ) (!  (=> (or (< x@@163 0) (>= x@@163 l@@163)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@163) x@@163) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@163) x@@163))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Option_Option_vec)) (let ((va@@164 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Option_Option_vec))))
(let ((l@@164 (|l#$ValueArray| va@@164)))
 (and (and (<= 0 l@@164) (<= l@@164 $MAX_U64)) (forall ((x@@164 Int) ) (!  (=> (or (< x@@164 0) (>= x@@164 l@@164)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@164) x@@164) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@164) x@@164))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 121380) 121440) inline$$DiemSystem_is_validator__$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 121380) 121386) inline$$DiemSystem_is_validator__$def_verify$0$anon17_Else_correct)))))))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 121310) 121380)) inline$$DiemSystem_is_validator__$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 121464) 121380) inline$$DiemSystem_is_validator__$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 121302) 121464) inline$$DiemSystem_is_validator__$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 121302) 121310) inline$$DiemSystem_is_validator__$def_verify$0$anon16_Else_correct)))))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 121472) 121464) inline$$DiemSystem_is_validator__$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 121472) 121310) inline$$DiemSystem_is_validator__$def_verify$0$anon16_Else_correct))))
(let ((inline$$DiemSystem_is_validator__$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 121296) 121472) inline$$DiemSystem_is_validator__$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 121296) 121302) inline$$DiemSystem_is_validator__$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (forall (($inv_addr@@26 Int) ($inv_tv0@@8 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26)) (let ((va@@165 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))))
(let ((l@@165 (|l#$ValueArray| va@@165)))
 (and (and (<= 0 l@@165) (<= l@@165 $MAX_U64)) (forall ((x@@165 Int) ) (!  (=> (or (< x@@165 0) (>= x@@165 l@@165)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@165) x@@165) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@165) x@@165))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))) $Option_Option_vec)) (let ((va@@166 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))) $Option_Option_vec))))
(let ((l@@166 (|l#$ValueArray| va@@166)))
 (and (and (<= 0 l@@166) (<= l@@166 $MAX_U64)) (forall ((x@@166 Int) ) (!  (=> (or (< x@@166 0) (>= x@@166 l@@166)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@166) x@@166) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@166) x@@166))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))
)) (=> (and (forall (($inv_addr@@27 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27)) (let ((va@@167 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))))
(let ((l@@167 (|l#$ValueArray| va@@167)))
 (and (and (<= 0 l@@167) (<= l@@167 $MAX_U64)) (forall ((x@@167 Int) ) (!  (=> (or (< x@@167 0) (>= x@@167 l@@167)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@167) x@@167) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@167) x@@167))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config)) (let ((va@@168 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@168 (|l#$ValueArray| va@@168)))
 (and (and (<= 0 l@@168) (<= l@@168 $MAX_U64)) (forall ((x@@168 Int) ) (!  (=> (or (< x@@168 0) (>= x@@168 l@@168)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@168) x@@168) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@168) x@@168))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@169 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@169 (|l#$ValueArray| va@@169)))
 (and (and (<= 0 l@@169) (<= l@@169 $MAX_U64)) (forall ((x@@169 Int) ) (!  (=> (or (< x@@169 0) (>= x@@169 l@@169)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@169) x@@169) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@169) x@@169))
))))))) (forall (($$0@@79 Int) ) (!  (=> (and (>= $$0@@79 0) (< $$0@@79 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@79)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@79)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@79)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@79))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@170 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@170 (|l#$ValueArray| va@@170)))
 (and (and (<= 0 l@@170) (<= l@@170 $MAX_U64)) (forall ((x@@170 Int) ) (!  (=> (or (< x@@170 0) (>= x@@170 l@@170)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@170) x@@170) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@170) x@@170))
))))))) (forall (($$0@@80 Int) ) (!  (=> (and (>= $$0@@80 0) (< $$0@@80 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@80)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@80)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@80)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@80))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@171 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@171 (|l#$ValueArray| va@@171)))
 (and (and (<= 0 l@@171) (<= l@@171 $MAX_U64)) (forall ((x@@171 Int) ) (!  (=> (or (< x@@171 0) (>= x@@171 l@@171)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@171) x@@171) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@171) x@@171))
))))))) (forall (($$0@@81 Int) ) (!  (=> (and (>= $$0@@81 0) (< $$0@@81 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@81)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@81)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@81)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@81))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@27))
)) (= (ControlFlow 0 121478) 121296)) inline$$DiemSystem_is_validator__$def_verify$0$anon0_correct))))
(let ((anon0_correct@@6  (=> ((_ is $Address) addr@@84) (=> (and (and (and ((_ is $Vector) validators_vec_ref) (let ((va@@172 (|v#$Vector| validators_vec_ref)))
(let ((l@@172 (|l#$ValueArray| va@@172)))
 (and (and (<= 0 l@@172) (<= l@@172 $MAX_U64)) (forall ((x@@172 Int) ) (!  (=> (or (< x@@172 0) (>= x@@172 l@@172)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@172) x@@172) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@172) x@@172))
)))))) (forall (($$0@@82 Int) ) (!  (=> (and (>= $$0@@82 0) (< $$0@@82 (|l#$ValueArray| (|v#$Vector| validators_vec_ref)))) (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82)) (let ((va@@173 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))))
(let ((l@@173 (|l#$ValueArray| va@@173)))
 (and (and (<= 0 l@@173) (<= l@@173 $MAX_U64)) (forall ((x@@173 Int) ) (!  (=> (or (< x@@173 0) (>= x@@173 l@@173)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@173) x@@173) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@173) x@@173))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config)) (let ((va@@174 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@174 (|l#$ValueArray| va@@174)))
 (and (and (<= 0 l@@174) (<= l@@174 $MAX_U64)) (forall ((x@@174 Int) ) (!  (=> (or (< x@@174 0) (>= x@@174 l@@174)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@174) x@@174) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@174) x@@174))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@175 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@175 (|l#$ValueArray| va@@175)))
 (and (and (<= 0 l@@175) (<= l@@175 $MAX_U64)) (forall ((x@@175 Int) ) (!  (=> (or (< x@@175 0) (>= x@@175 l@@175)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@175) x@@175) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@175) x@@175))
))))))) (forall (($$0@@83 Int) ) (!  (=> (and (>= $$0@@83 0) (< $$0@@83 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@83)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@83)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@83)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@83))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@176 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@176 (|l#$ValueArray| va@@176)))
 (and (and (<= 0 l@@176) (<= l@@176 $MAX_U64)) (forall ((x@@176 Int) ) (!  (=> (or (< x@@176 0) (>= x@@176 l@@176)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@176) x@@176) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@176) x@@176))
))))))) (forall (($$0@@84 Int) ) (!  (=> (and (>= $$0@@84 0) (< $$0@@84 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@84)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@84)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@84)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@84))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@177 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@177 (|l#$ValueArray| va@@177)))
 (and (and (<= 0 l@@177) (<= l@@177 $MAX_U64)) (forall ((x@@177 Int) ) (!  (=> (or (< x@@177 0) (>= x@@177 l@@177)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@177) x@@177) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@177) x@@177))
))))))) (forall (($$0@@85 Int) ) (!  (=> (and (>= $$0@@85 0) (< $$0@@85 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@85)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@85)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@85)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@85))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators_vec_ref)) $$0@@82))
))) (= (ControlFlow 0 120960) 121478)) anon0$1_correct@@6))))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 155122) 120960) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@5)))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun validator_addr@@0 () T@$Value)
(declare-fun $abort_flag@9@@0 () Bool)
(declare-fun dr_account@@1 () T@$Value)
(declare-fun $abort_code@12@@0 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@2@@1 () T@$Memory)
(declare-fun $abort_flag@8@@0 () Bool)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@2@@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@11@@0 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1@@0 () T@$Memory)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun $abort_code@2@@4 () Int)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun $abort_flag@2@@6 () Bool)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun $abort_flag@4@@4 () Bool)
(declare-fun $abort_code@6@@3 () Int)
(declare-fun $abort_flag@5@@3 () Bool)
(declare-fun $abort_code@7@@3 () Int)
(declare-fun $abort_flag@6@@2 () Bool)
(declare-fun $abort_code@9@@1 () Int)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun call2formal@$DiemConfig_Configuration_$CallerDomain@0@@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemSystem_remove_validator_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun call2formal@$ret0@0@@5 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$Vector_swap_remove$0$v'@2| () T@$Value)
(declare-fun |inline$$Vector_swap_remove$0$v'@0| () T@$Value)
(declare-fun inline$$Vector_swap_remove$0$i_ind@1 () Int)
(declare-fun inline$$Vector_swap_remove$0$len@1 () Int)
(declare-fun inline$$Vector_swap_remove$0$e@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun |inline$$Vector_swap_remove$0$v'@1| () T@$Value)
(declare-fun call4formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$Vector_swap_remove$0$ta@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun call4formal@$ret0@0@@8 () T@$Value)
(declare-fun call0formal@$tv0@0@@6 () T@$TypeValue)
(declare-fun call4formal@$ret0@0@@9 () T@$Value)
(declare-fun $abort_code@8@@2 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$DiemSystem_remove_validator_$def_verify$0$$t11@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@7 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@3 () T@$Value)
(declare-fun $DiemConfig_DiemConfig_$CallerDomain@@1 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 156338) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 124780) (- 0 162785)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@35 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@89 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@89)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@46 Int) )  (and (and (>= $i_0@@46 0) (< $i_0@@46 (|l#$ValueArray| (|v#$Vector| $range_1@@35)))) (let ((v@@25 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@35)) $i_0@@46)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@25)) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))))))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@35 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@89 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@89)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@47 Int) )  (and (and (>= $i_0@@47 0) (< $i_0@@47 (|l#$ValueArray| (|v#$Vector| $range_1@@35)))) (let ((v@@25 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@35)) $i_0@@47)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@25)) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))))))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 124780) (- 0 162801)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 124780) (- 0 162822)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 124780) (- 0 162851)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 124780) (- 0 162868)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 124780) (- 0 162883)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 124780) (- 0 162982)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 124780) (- 0 163003)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 124780) (- 0 163032)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 124780) (- 0 163049)) (=> $abort_flag@9@@0 (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@90 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@90)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@48 Int) )  (and (and (>= $i_0@@48 0) (< $i_0@@48 (|l#$ValueArray| (|v#$Vector| $range_1@@36)))) (let ((v@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@36)) $i_0@@48)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@26)) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))))) (=> (=> $abort_flag@9@@0 (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@90 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@90)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@49 Int) )  (and (and (>= $i_0@@49 0) (< $i_0@@49 (|l#$ValueArray| (|v#$Vector| $range_1@@36)))) (let ((v@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@36)) $i_0@@49)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@26)) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))))) (and (=> (= (ControlFlow 0 124780) (- 0 163305)) (=> $abort_flag@9@@0 (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@37 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@91 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@91)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@50 Int) )  (and (and (>= $i_0@@50 0) (< $i_0@@50 (|l#$ValueArray| (|v#$Vector| $range_1@@37)))) (let ((v@@27 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@37)) $i_0@@50)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@27)) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))))))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@9@@0 (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@37 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@91 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@91)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@51 Int) )  (and (and (>= $i_0@@51 0) (< $i_0@@51 (|l#$ValueArray| (|v#$Vector| $range_1@@37)))) (let ((v@@27 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@37)) $i_0@@51)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@27)) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))))))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@12@@0 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 124780) (- 0 163660)) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (let (($range_1@@38 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@92 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@92)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(forall (($i_0@@52 Int) )  (=> (and (>= $i_0@@52 0) (< $i_0@@52 (|l#$ValueArray| (|v#$Vector| $range_1@@38)))) (let ((vi (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@38)) $i_0@@52)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| vi)) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))) (|b#$Boolean| ($Boolean (let (($range_3@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@93 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@93)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_2@@12 Int) )  (and (and (>= $i_2@@12 0) (< $i_2@@12 (|l#$ValueArray| (|v#$Vector| $range_3@@11)))) (let ((ovi (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_3@@11)) $i_2@@12)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified vi ovi)))))))))))))))))))) (=> (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (let (($range_1@@38 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@92 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@92)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(forall (($i_0@@53 Int) )  (=> (and (>= $i_0@@53 0) (< $i_0@@53 (|l#$ValueArray| (|v#$Vector| $range_1@@38)))) (let ((vi (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@38)) $i_0@@53)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| vi)) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))) (|b#$Boolean| ($Boolean (let (($range_3@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@93 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@93)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_2@@13 Int) )  (and (and (>= $i_2@@13 0) (< $i_2@@13 (|l#$ValueArray| (|v#$Vector| $range_3@@11)))) (let ((ovi (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_3@@11)) $i_2@@13)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified vi ovi))))))))))))))))))) (=> (= (ControlFlow 0 124780) (- 0 163753)) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@94 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@94)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@54 Int) )  (and (and (>= $i_0@@54 0) (< $i_0@@54 (|l#$ValueArray| (|v#$Vector| $range_1@@39)))) (let ((v@@28 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@39)) $i_0@@54)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@28)) $DiemSystem_ValidatorInfo_addr) validator_addr@@0))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon68_Else_correct  (=> (and (not $abort_flag@8@@0) (= $abort_code@12@@0 $abort_code@10@@0)) (=> (and (and (= $abort_flag@9@@0 $abort_flag@8@@0) (= $DiemConfig_DiemConfig_$memory@2@@1 $DiemConfig_DiemConfig_$memory@0@@1)) (and (= $DiemConfig_Configuration_$memory@2@@0 $DiemConfig_Configuration_$memory@0@@0) (= (ControlFlow 0 124570) 124780))) anon0$2_correct@@7))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct  (=> (= $abort_code@12@@0 $abort_code@11@@0) (=> (and (and (= $abort_flag@9@@0 true) (= $DiemConfig_DiemConfig_$memory@2@@1 $DiemConfig_DiemConfig_$memory@1@@1)) (and (= $DiemConfig_Configuration_$memory@2@@0 $DiemConfig_Configuration_$memory@1@@0) (= (ControlFlow 0 123266) 124780))) anon0$2_correct@@7))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon7_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@1@@5) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 124750) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 124748) 124750)) inline$$DiemSystem_remove_validator_$def_verify$0$anon7_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 124758) 124750) inline$$DiemSystem_remove_validator_$def_verify$0$anon7_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon49_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 124742) 124758) inline$$DiemSystem_remove_validator_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 124742) 124748) inline$$DiemSystem_remove_validator_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon11_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@2@@4) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 124730) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 124728) 124730)) inline$$DiemSystem_remove_validator_$def_verify$0$anon11_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 124738) 124730) inline$$DiemSystem_remove_validator_$def_verify$0$anon11_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon51_Then_correct  (=> $abort_flag@1@@7 (and (=> (= (ControlFlow 0 124722) 124738) inline$$DiemSystem_remove_validator_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 124722) 124728) inline$$DiemSystem_remove_validator_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon15_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@3@@4) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 124710) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 124708) 124710)) inline$$DiemSystem_remove_validator_$def_verify$0$anon15_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 124718) 124710) inline$$DiemSystem_remove_validator_$def_verify$0$anon15_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon53_Then_correct  (=> $abort_flag@2@@6 (and (=> (= (ControlFlow 0 124702) 124718) inline$$DiemSystem_remove_validator_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 124702) 124708) inline$$DiemSystem_remove_validator_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon19_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@4@@4) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 124690) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 124688) 124690)) inline$$DiemSystem_remove_validator_$def_verify$0$anon19_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon56_Then_correct  (=> (= (ControlFlow 0 124698) 124690) inline$$DiemSystem_remove_validator_$def_verify$0$anon19_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon55_Then_correct  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 124682) 124698) inline$$DiemSystem_remove_validator_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 124682) 124688) inline$$DiemSystem_remove_validator_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon23_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@5@@3) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 124670) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon58_Else_correct  (=> (and (not true) (= (ControlFlow 0 124668) 124670)) inline$$DiemSystem_remove_validator_$def_verify$0$anon23_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon58_Then_correct  (=> (= (ControlFlow 0 124678) 124670) inline$$DiemSystem_remove_validator_$def_verify$0$anon23_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon57_Then_correct  (=> $abort_flag@4@@4 (and (=> (= (ControlFlow 0 124662) 124678) inline$$DiemSystem_remove_validator_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 124662) 124668) inline$$DiemSystem_remove_validator_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon27_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@6@@3) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 124650) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 124648) 124650)) inline$$DiemSystem_remove_validator_$def_verify$0$anon27_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 124658) 124650) inline$$DiemSystem_remove_validator_$def_verify$0$anon27_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon59_Then_correct  (=> $abort_flag@5@@3 (and (=> (= (ControlFlow 0 124642) 124658) inline$$DiemSystem_remove_validator_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 124642) 124648) inline$$DiemSystem_remove_validator_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon35_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@7@@3) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 124630) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 124628) 124630)) inline$$DiemSystem_remove_validator_$def_verify$0$anon35_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 124638) 124630) inline$$DiemSystem_remove_validator_$def_verify$0$anon35_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon63_Then_correct  (=> $abort_flag@6@@2 (and (=> (= (ControlFlow 0 124622) 124638) inline$$DiemSystem_remove_validator_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 124622) 124628) inline$$DiemSystem_remove_validator_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon41_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@9@@1) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 124602) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 124600) 124602)) inline$$DiemSystem_remove_validator_$def_verify$0$anon41_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon67_Then_correct  (=> (= (ControlFlow 0 124610) 124602) inline$$DiemSystem_remove_validator_$def_verify$0$anon41_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon66_Then_correct  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 124594) 124610) inline$$DiemSystem_remove_validator_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 124594) 124600) inline$$DiemSystem_remove_validator_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon45_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@10@@0) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory@0@@1)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory@0@@0) (= (ControlFlow 0 124582) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 124580) 124582)) inline$$DiemSystem_remove_validator_$def_verify$0$anon45_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 124590) 124582) inline$$DiemSystem_remove_validator_$def_verify$0$anon45_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon68_Then_correct  (=> $abort_flag@8@@0 (and (=> (= (ControlFlow 0 124574) 124590) inline$$DiemSystem_remove_validator_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 124574) 124580) inline$$DiemSystem_remove_validator_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon66_Else$4_correct  (=> (= call2formal@$DiemConfig_Configuration_$CallerDomain@0@@0 ($ConstMemoryDomain true)) (and (=> (= (ControlFlow 0 124564) (- 0 161921)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_remove_validator_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_remove_validator_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 124564) (- 0 161942)) (|Select_[$TypeValueArray,$int]$bool| call2formal@$DiemConfig_Configuration_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call2formal@$DiemConfig_Configuration_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@8@@0) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@8@@0) (=> $abort_flag@8@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@8@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@8@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) $DiemConfig_DiemConfig_payload) |inline$$WritebackToValue$0$vdst'@2@@0|)))))) (and (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 124564) 124574) inline$$DiemSystem_remove_validator_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 124564) 124570) inline$$DiemSystem_remove_validator_$def_verify$0$anon68_Else_correct)))))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@0| call2formal@$ret0@0@@5) (= (ControlFlow 0 124530) 124564)) inline$$DiemSystem_remove_validator_$def_verify$0$anon66_Else$4_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 call2formal@$ret0@0@@5 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@0|) (= (ControlFlow 0 124556) 124564))) inline$$DiemSystem_remove_validator_$def_verify$0$anon66_Else$4_correct)))
(let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$anon0_correct@@0  (and (=> (= (ControlFlow 0 124433) (- 0 161731)) (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9@@0)) inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@1) (< inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@1 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9@@0)))) (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$i@@0 ($Integer inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@1)))
(|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@1 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11@@0)) inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@1) (< inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@1 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11@@0)))) (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$j@@0 ($Integer inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@1)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_$pack_ref$0$i@@0)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_$pack_ref$0$j@@0)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_DiemSystem_$pack_ref$0$i@@0 inline$$DiemSystem_DiemSystem_$pack_ref$0$j@@0))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9@@0)) inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@2) (< inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@2 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_9@@0)))) (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$i@@0 ($Integer inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_8@@2)))
(|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11@@0)) inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@2) (< inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@2 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_$pack_ref$0$$range_11@@0)))) (let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$j@@0 ($Integer inline$$DiemSystem_DiemSystem_$pack_ref$0$$i_10@@2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_$pack_ref$0$i@@0)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_$pack_ref$0$j@@0)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_DiemSystem_$pack_ref$0$i@@0 inline$$DiemSystem_DiemSystem_$pack_ref$0$j@@0)))))))))))))))))) (and (=> (= (ControlFlow 0 124433) 124556) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 124433) 124530) inline$$WritebackToValue$0$anon3_Else_correct@@0))))))
(let ((inline$$DiemSystem_DiemSystem_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$DiemSystem_DiemSystem_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 124307) 124433)) inline$$DiemSystem_DiemSystem_$pack_ref$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowLoc$0$dst@1@@0) (= (ControlFlow 0 124099) 124307)) inline$$DiemSystem_DiemSystem_$pack_ref$0$Entry_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 124155) 124307))) inline$$DiemSystem_DiemSystem_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) (and (=> (= (ControlFlow 0 124063) 124155) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 124063) 124099) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (and (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) |inline$$Vector_swap_remove$0$v'@2|)) (= (ControlFlow 0 123920) 124063)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon66_Else_correct  (=> (and (not $abort_flag@7@@0) (= (ControlFlow 0 123926) 123920)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$Vector_swap_remove$0$anon3_Then$1_correct  (=> (= $abort_flag@7@@0 true) (=> (and (= $abort_code@9@@1 $EXEC_FAILURE_CODE) (= |inline$$Vector_swap_remove$0$v'@2| |inline$$Vector_swap_remove$0$v'@0|)) (and (=> (= (ControlFlow 0 123853) 124594) inline$$DiemSystem_remove_validator_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 123853) 123926) inline$$DiemSystem_remove_validator_$def_verify$0$anon66_Else_correct))))))
(let ((inline$$Vector_swap_remove$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_swap_remove$0$i_ind@1 0) (>= inline$$Vector_swap_remove$0$i_ind@1 inline$$Vector_swap_remove$0$len@1)) (= (ControlFlow 0 123851) 123853)) inline$$Vector_swap_remove$0$anon3_Then$1_correct)))
(let ((inline$$Vector_swap_remove$0$anon3_Else_correct  (=> (and (not (or (< inline$$Vector_swap_remove$0$i_ind@1 0) (>= inline$$Vector_swap_remove$0$i_ind@1 inline$$Vector_swap_remove$0$len@1))) (= inline$$Vector_swap_remove$0$e@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) inline$$Vector_swap_remove$0$i_ind@1))) (=> (and (and (= |inline$$Vector_swap_remove$0$v'@1| ($Vector (let ((l@@178 (- (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) inline$$Vector_swap_remove$0$i_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) (- inline$$Vector_swap_remove$0$len@1 1))) (- inline$$Vector_swap_remove$0$len@1 1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) inline$$Vector_swap_remove$0$i_ind@1)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)))))) 1)))
($ValueArray (|lambda#0| 0 l@@178 (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) inline$$Vector_swap_remove$0$i_ind@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) (- inline$$Vector_swap_remove$0$len@1 1))) (- inline$$Vector_swap_remove$0$len@1 1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) inline$$Vector_swap_remove$0$i_ind@1)) (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)))))) $Error) l@@178)))) (= $abort_flag@7@@0 $abort_flag@6@@2)) (and (= $abort_code@9@@1 $abort_code@7@@3) (= |inline$$Vector_swap_remove$0$v'@2| |inline$$Vector_swap_remove$0$v'@1|))) (and (=> (= (ControlFlow 0 123795) 124594) inline$$DiemSystem_remove_validator_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 123795) 123926) inline$$DiemSystem_remove_validator_$def_verify$0$anon66_Else_correct))))))
(let ((inline$$Vector_swap_remove$0$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$0$v@1@@0) (=> (and (= inline$$Vector_swap_remove$0$i_ind@1 (|i#$Integer| call4formal@$ret0@0@@7)) (= inline$$Vector_swap_remove$0$len@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)))) (and (=> (= (ControlFlow 0 123757) 123851) inline$$Vector_swap_remove$0$anon3_Then_correct) (=> (= (ControlFlow 0 123757) 123795) inline$$Vector_swap_remove$0$anon3_Else_correct))))))
(let ((inline$$Vector_swap_remove$0$Entry_correct  (=> (= inline$$Vector_swap_remove$0$ta@0 $DiemSystem_ValidatorInfo_type_value) (and (=> (= (ControlFlow 0 123743) (- 0 161444)) true) (=> (= (ControlFlow 0 123743) 123757) inline$$Vector_swap_remove$0$anon0_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon38$4_correct  (and (=> (= (ControlFlow 0 123861) (- 0 161399)) (forall ((inline$$DiemSystem_remove_validator_$def_verify$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemSystem_remove_validator_$def_verify$0$$$0 0) (< inline$$DiemSystem_remove_validator_$def_verify$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) inline$$DiemSystem_remove_validator_$def_verify$0$$$0))
))) (=> (forall ((inline$$DiemSystem_remove_validator_$def_verify$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemSystem_remove_validator_$def_verify$0$$$0@@0 0) (< inline$$DiemSystem_remove_validator_$def_verify$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) inline$$DiemSystem_remove_validator_$def_verify$0$$$0@@0))
)) (=> (= (ControlFlow 0 123861) 123743) inline$$Vector_swap_remove$0$Entry_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 123569) 123861)) inline$$DiemSystem_remove_validator_$def_verify$0$anon38$4_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $DiemSystem_DiemSystem_validators) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $DiemSystem_DiemSystem_validators))) (= (ControlFlow 0 123531) 123569))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$DiemSystem_DiemSystem_$unpack_ref$0$anon0_correct@@0  (=> (and (and (forall (($$0@@86 Int) ) (!  (=> (and (>= $$0@@86 0) (< $$0@@86 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0@@0)) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0@@0)) $DiemSystem_DiemSystem_validators))) $$0@@86))
)) (|b#$Boolean| ($Boolean (let (($range_1@@40 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0@@0)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@55 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@40)) $i_0@@55) (< $i_0@@55 (|i#$Integer| (|ub#$Range| $range_1@@40)))) (let ((i@@26 ($Integer $i_0@@55)))
(|b#$Boolean| ($Boolean (let (($range_3@@12 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0@@0)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@14 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@12)) $i_2@@14) (< $i_2@@14 (|i#$Integer| (|ub#$Range| $range_3@@12)))) (let ((j@@10 ($Integer $i_2@@14)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0@@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@26)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0@@0)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@10)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@26 j@@10))))))))))))))))))) (= (ControlFlow 0 123409) 123531)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$DiemSystem_DiemSystem_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$DiemSystem_DiemSystem_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 123403) 123409)) inline$$DiemSystem_DiemSystem_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 2) $EmptyPath call2formal@$ret0@0@@5)) (= (ControlFlow 0 123376) 123403)) inline$$DiemSystem_DiemSystem_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 123326) 123376)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon65_Then_correct  (=> (= (ControlFlow 0 124618) 123376) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon63_Else_correct  (=> (not $abort_flag@6@@2) (and (=> (= (ControlFlow 0 123318) 124618) inline$$DiemSystem_remove_validator_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 123318) 123326) inline$$DiemSystem_remove_validator_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon61_Then_correct  (=> (and (|b#$Boolean| call4formal@$ret0@0@@8) (= call0formal@$tv0@0@@6 $IntegerType)) (=> (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec)) ($Integer 0)))) $abort_flag@6@@2) (=> $abort_flag@6@@2 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec)) ($Integer 0)))))) (and (=> $abort_flag@6@@2 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@7@@3 (|i#$Integer| ($Integer 7))))) (=> (not $abort_flag@6@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@7 ($Vector_$borrow call0formal@$tv0@0@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec) ($Integer 0)))))))) (and (=> (= (ControlFlow 0 123280) 124622) inline$$DiemSystem_remove_validator_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 123280) 123318) inline$$DiemSystem_remove_validator_$def_verify$0$anon63_Else_correct))))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon32_correct  (=> (and (and (= $abort_code@11@@0 $abort_code@8@@2) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 123262) 123266))) inline$$DiemSystem_remove_validator_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 123260) 123262)) inline$$DiemSystem_remove_validator_$def_verify$0$anon32_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 123274) 123262) inline$$DiemSystem_remove_validator_$def_verify$0$anon32_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon61_Else_correct  (=> (and (not (|b#$Boolean| call4formal@$ret0@0@@8)) (= $abort_code@8@@2 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 123254) 123274) inline$$DiemSystem_remove_validator_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 123254) 123260) inline$$DiemSystem_remove_validator_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon59_Else_correct  (=> (not $abort_flag@5@@3) (and (=> (= (ControlFlow 0 123242) 123280) inline$$DiemSystem_remove_validator_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 123242) 123254) inline$$DiemSystem_remove_validator_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon57_Else_correct  (=> (not $abort_flag@4@@4) (=> (and (and (and (= inline$$DiemSystem_remove_validator_$def_verify$0$$t11@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@3)) (and (=> $abort_flag@5@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 123236) 124642) inline$$DiemSystem_remove_validator_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 123236) 123242) inline$$DiemSystem_remove_validator_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon55_Else_correct  (=> (and (not $abort_flag@3@@4) (= call0formal@$tv0@0@@7 $IntegerType)) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@4) (=> $abort_flag@4@@4 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@8 ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec)) ($Integer 0)))))))))) ((_ is $Boolean) call4formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 123226) 124662) inline$$DiemSystem_remove_validator_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 123226) 123236) inline$$DiemSystem_remove_validator_$def_verify$0$anon57_Else_correct))))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon53_Else$1_correct  (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@4) (=> (and (and (=> $abort_flag@3@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_1@@41 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@3))))))
(forall (($i_0@@56 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@41)) $i_0@@56) (< $i_0@@56 (|i#$Integer| (|ub#$Range| $range_1@@41)))) (let ((i@@27 ($Integer $i_0@@56)))
(|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@3)) (|i#$Integer| i@@27)))) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec)) ($Integer 0))))))))) (and (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (let (($range_3@@13 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@3))))))
(exists (($i_2@@15 Int) )  (and (and (<= (|i#$Integer| (|lb#$Range| $range_3@@13)) $i_2@@15) (< $i_2@@15 (|i#$Integer| (|ub#$Range| $range_3@@13)))) (let ((i@@28 ($Integer $i_2@@15)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@3)) (|i#$Integer| i@@28)))) $DiemSystem_ValidatorInfo_addr) validator_addr@@0))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| (let ((at@@2 ($Vector_$borrow $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec) ($Integer 0))))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| at@@2)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| at@@2) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@3)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@3)) (|i#$Integer| at@@2)))) $DiemSystem_ValidatorInfo_addr) validator_addr@@0)))))))))))))) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@95 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@95)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@96 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@96)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@9) (let ((va@@178 (|v#$Vector| call4formal@$ret0@0@@9)))
(let ((l@@179 (|l#$ValueArray| va@@178)))
 (and (and (<= 0 l@@179) (<= l@@179 $MAX_U64)) (forall ((x@@178 Int) ) (!  (=> (or (< x@@178 0) (>= x@@178 l@@179)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@178) x@@178) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@178) x@@178))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec)) (let ((va@@179 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec))))
(let ((l@@180 (|l#$ValueArray| va@@179)))
 (and (and (<= 0 l@@180) (<= l@@180 $MAX_U64)) (forall ((x@@179 Int) ) (!  (=> (or (< x@@179 0) (>= x@@179 l@@180)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@179) x@@179) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@179) x@@179))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@9)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 123220) 124682) inline$$DiemSystem_remove_validator_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 123220) 123226) inline$$DiemSystem_remove_validator_$def_verify$0$anon55_Else_correct)))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@4  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators)) (= (ControlFlow 0 123212) 123220)) inline$$DiemSystem_remove_validator_$def_verify$0$anon53_Else$1_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon53_Else_correct  (=> (and (not $abort_flag@2@@6) (= (ControlFlow 0 123218) 123212)) inline$$GetFieldFromValue$0$anon0_correct@@4)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon51_Else_correct  (=> (and (not $abort_flag@1@@7) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@6)) (=> (and (and (=> $abort_flag@2@@6 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@2@@6 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@3@@4 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@5 (let ((addr@@97 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@97)))) $DiemConfig_DiemConfig_payload)))))) (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@98 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@98)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@99 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@99)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (=> (and (and (and (and (and (and ((_ is $Vector) call2formal@$ret0@0@@5) (let ((va@@180 (|v#$Vector| call2formal@$ret0@0@@5)))
(let ((l@@181 (|l#$ValueArray| va@@180)))
 (and (and (<= 0 l@@181) (<= l@@181 $MAX_U64)) (forall ((x@@180 Int) ) (!  (=> (or (< x@@180 0) (>= x@@180 l@@181)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@180) x@@180) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@180) x@@180))
)))))) (= (|l#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators)) (let ((va@@181 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))))
(let ((l@@182 (|l#$ValueArray| va@@181)))
 (and (and (<= 0 l@@182) (<= l@@182 $MAX_U64)) (forall ((x@@181 Int) ) (!  (=> (or (< x@@181 0) (>= x@@181 l@@182)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@181) x@@181) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@181) x@@181))
))))))) (forall (($$0@@87 Int) ) (!  (=> (and (>= $$0@@87 0) (< $$0@@87 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87)) (let ((va@@182 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))))
(let ((l@@183 (|l#$ValueArray| va@@182)))
 (and (and (<= 0 l@@183) (<= l@@183 $MAX_U64)) (forall ((x@@182 Int) ) (!  (=> (or (< x@@182 0) (>= x@@182 l@@183)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@182) x@@182) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@182) x@@182))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config)) (let ((va@@183 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@184 (|l#$ValueArray| va@@183)))
 (and (and (<= 0 l@@184) (<= l@@184 $MAX_U64)) (forall ((x@@183 Int) ) (!  (=> (or (< x@@183 0) (>= x@@183 l@@184)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@183) x@@183) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@183) x@@183))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@184 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@185 (|l#$ValueArray| va@@184)))
 (and (and (<= 0 l@@185) (<= l@@185 $MAX_U64)) (forall ((x@@184 Int) ) (!  (=> (or (< x@@184 0) (>= x@@184 l@@185)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@184) x@@184) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@184) x@@184))
))))))) (forall (($$0@@88 Int) ) (!  (=> (and (>= $$0@@88 0) (< $$0@@88 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@88)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@88)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@88)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@88))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@185 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@186 (|l#$ValueArray| va@@185)))
 (and (and (<= 0 l@@186) (<= l@@186 $MAX_U64)) (forall ((x@@185 Int) ) (!  (=> (or (< x@@185 0) (>= x@@185 l@@186)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@185) x@@185) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@185) x@@185))
))))))) (forall (($$0@@89 Int) ) (!  (=> (and (>= $$0@@89 0) (< $$0@@89 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@89)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@89)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@89)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@89))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@186 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@187 (|l#$ValueArray| va@@186)))
 (and (and (<= 0 l@@187) (<= l@@187 $MAX_U64)) (forall ((x@@186 Int) ) (!  (=> (or (< x@@186 0) (>= x@@186 l@@187)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@186) x@@186) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@186) x@@186))
))))))) (forall (($$0@@90 Int) ) (!  (=> (and (>= $$0@@90 0) (< $$0@@90 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@90)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@90)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@90)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@90))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@87))
))) (and (forall (($$0@@91 Int) ) (!  (=> (and (>= $$0@@91 0) (< $$0@@91 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) $$0@@91))
)) (|b#$Boolean| ($Boolean (let (($range_1@@42 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@57 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@42)) $i_0@@57) (< $i_0@@57 (|i#$Integer| (|ub#$Range| $range_1@@42)))) (let ((i@@29 ($Integer $i_0@@57)))
(|b#$Boolean| ($Boolean (let (($range_3@@14 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@16 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@14)) $i_2@@16) (< $i_2@@16 (|i#$Integer| (|ub#$Range| $range_3@@14)))) (let ((j@@11 ($Integer $i_2@@16)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@29)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@5)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@11)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@29 j@@11)))))))))))))))))))) (and (=> (= (ControlFlow 0 123166) 124702) inline$$DiemSystem_remove_validator_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 123166) 123218) inline$$DiemSystem_remove_validator_$def_verify$0$anon53_Else_correct)))))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@0@@7) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@1@@7) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@1@@7)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@1@@7) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@1@@7)) (and (=> $abort_flag@1@@7 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))))) (=> $abort_flag@1@@7 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@2@@4 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@2@@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@2@@4 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@2@@4 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 123160) 124722) inline$$DiemSystem_remove_validator_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 123160) 123166) inline$$DiemSystem_remove_validator_$def_verify$0$anon51_Else_correct)))))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@7) (=> (and (=> $abort_flag@0@@7 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@7 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@5 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 123154) 124742) inline$$DiemSystem_remove_validator_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 123154) 123160) inline$$DiemSystem_remove_validator_$def_verify$0$anon49_Else_correct))))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon4_correct  (=> (and (= inline$$DiemSystem_remove_validator_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 123118) 123154)) inline$$DiemSystem_remove_validator_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 123058) 123118)) inline$$DiemSystem_remove_validator_$def_verify$0$anon4_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 124766) 123118) inline$$DiemSystem_remove_validator_$def_verify$0$anon4_correct)))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon47_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 123050) 124766) inline$$DiemSystem_remove_validator_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 123050) 123058) inline$$DiemSystem_remove_validator_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon47_Then_correct  (and (=> (= (ControlFlow 0 124774) 124766) inline$$DiemSystem_remove_validator_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 124774) 123058) inline$$DiemSystem_remove_validator_$def_verify$0$anon48_Else_correct))))
(let ((inline$$DiemSystem_remove_validator_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 123044) 124774) inline$$DiemSystem_remove_validator_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 123044) 123050) inline$$DiemSystem_remove_validator_$def_verify$0$anon47_Else_correct)))))
(let ((anon0$1_correct@@7  (=> (and (and (forall (($inv_addr@@28 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28)) (let ((va@@187 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))))
(let ((l@@188 (|l#$ValueArray| va@@187)))
 (and (and (<= 0 l@@188) (<= l@@188 $MAX_U64)) (forall ((x@@187 Int) ) (!  (=> (or (< x@@187 0) (>= x@@187 l@@188)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@187) x@@187) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@187) x@@187))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@28))
)) (forall (($inv_addr@@29 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29)) (let ((va@@188 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))))
(let ((l@@189 (|l#$ValueArray| va@@188)))
 (and (and (<= 0 l@@189) (<= l@@189 $MAX_U64)) (forall ((x@@188 Int) ) (!  (=> (or (< x@@188 0) (>= x@@188 l@@189)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@188) x@@188) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@188) x@@188))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))
))) (and (forall (($inv_addr@@30 Int) ($inv_tv0@@9 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@30)) (let ((va@@189 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@30))))
(let ((l@@190 (|l#$ValueArray| va@@189)))
 (and (and (<= 0 l@@190) (<= l@@190 $MAX_U64)) (forall ((x@@189 Int) ) (!  (=> (or (< x@@189 0) (>= x@@189 l@@190)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@189) x@@189) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@189) x@@189))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@30))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@30))
)) (forall (($inv_addr@@31 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31)) (let ((va@@190 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))))
(let ((l@@191 (|l#$ValueArray| va@@190)))
 (and (and (<= 0 l@@191) (<= l@@191 $MAX_U64)) (forall ((x@@190 Int) ) (!  (=> (or (< x@@190 0) (>= x@@190 l@@191)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@190) x@@190) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@190) x@@190))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events)) (let ((va@@191 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))))
(let ((l@@192 (|l#$ValueArray| va@@191)))
 (and (and (<= 0 l@@192) (<= l@@192 $MAX_U64)) (forall ((x@@191 Int) ) (!  (=> (or (< x@@191 0) (>= x@@191 l@@192)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@191) x@@191) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@191) x@@191))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@192 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@193 (|l#$ValueArray| va@@192)))
 (and (and (<= 0 l@@193) (<= l@@193 $MAX_U64)) (forall ((x@@192 Int) ) (!  (=> (or (< x@@192 0) (>= x@@192 l@@193)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@192) x@@192) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@192) x@@192))
))))))) (forall (($$0@@92 Int) ) (!  (=> (and (>= $$0@@92 0) (< $$0@@92 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@92)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@92)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@92)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@92))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@31))
)))) (=> (and (and (and (and (forall (($inv_addr@@32 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@32)) (let ((va@@193 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@32))))
(let ((l@@194 (|l#$ValueArray| va@@193)))
 (and (and (<= 0 l@@194) (<= l@@194 $MAX_U64)) (forall ((x@@193 Int) ) (!  (=> (or (< x@@193 0) (>= x@@193 l@@194)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@193) x@@193) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@193) x@@193))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@32))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@32))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@32))
)) (forall (($inv_addr@@33 Int) ($inv_tv0@@10 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@33)) (let ((va@@194 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@33))))
(let ((l@@195 (|l#$ValueArray| va@@194)))
 (and (and (<= 0 l@@195) (<= l@@195 $MAX_U64)) (forall ((x@@194 Int) ) (!  (=> (or (< x@@194 0) (>= x@@194 l@@195)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@194) x@@194) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@194) x@@194))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@33))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@33))) $Option_Option_vec)) (let ((va@@195 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@33))) $Option_Option_vec))))
(let ((l@@196 (|l#$ValueArray| va@@195)))
 (and (and (<= 0 l@@196) (<= l@@196 $MAX_U64)) (forall ((x@@195 Int) ) (!  (=> (or (< x@@195 0) (>= x@@195 l@@196)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@195) x@@195) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@195) x@@195))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@33))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@33))
))) (and (forall (($inv_addr@@34 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34)) (let ((va@@196 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))))
(let ((l@@197 (|l#$ValueArray| va@@196)))
 (and (and (<= 0 l@@197) (<= l@@197 $MAX_U64)) (forall ((x@@196 Int) ) (!  (=> (or (< x@@196 0) (>= x@@196 l@@197)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@196) x@@196) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@196) x@@196))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators)) (let ((va@@197 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))))
(let ((l@@198 (|l#$ValueArray| va@@197)))
 (and (and (<= 0 l@@198) (<= l@@198 $MAX_U64)) (forall ((x@@197 Int) ) (!  (=> (or (< x@@197 0) (>= x@@197 l@@198)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@197) x@@197) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@197) x@@197))
))))))) (forall (($$0@@93 Int) ) (!  (=> (and (>= $$0@@93 0) (< $$0@@93 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93)) (let ((va@@198 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))))
(let ((l@@199 (|l#$ValueArray| va@@198)))
 (and (and (<= 0 l@@199) (<= l@@199 $MAX_U64)) (forall ((x@@198 Int) ) (!  (=> (or (< x@@198 0) (>= x@@198 l@@199)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@198) x@@198) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@198) x@@198))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config)) (let ((va@@199 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@200 (|l#$ValueArray| va@@199)))
 (and (and (<= 0 l@@200) (<= l@@200 $MAX_U64)) (forall ((x@@199 Int) ) (!  (=> (or (< x@@199 0) (>= x@@199 l@@200)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@199) x@@199) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@199) x@@199))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@200 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@201 (|l#$ValueArray| va@@200)))
 (and (and (<= 0 l@@201) (<= l@@201 $MAX_U64)) (forall ((x@@200 Int) ) (!  (=> (or (< x@@200 0) (>= x@@200 l@@201)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@200) x@@200) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@200) x@@200))
))))))) (forall (($$0@@94 Int) ) (!  (=> (and (>= $$0@@94 0) (< $$0@@94 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@94)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@94)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@94)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@94))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@201 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@202 (|l#$ValueArray| va@@201)))
 (and (and (<= 0 l@@202) (<= l@@202 $MAX_U64)) (forall ((x@@201 Int) ) (!  (=> (or (< x@@201 0) (>= x@@201 l@@202)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@201) x@@201) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@201) x@@201))
))))))) (forall (($$0@@95 Int) ) (!  (=> (and (>= $$0@@95 0) (< $$0@@95 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@95)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@95)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@95)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@95))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@202 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@203 (|l#$ValueArray| va@@202)))
 (and (and (<= 0 l@@203) (<= l@@203 $MAX_U64)) (forall ((x@@202 Int) ) (!  (=> (or (< x@@202 0) (>= x@@202 l@@203)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@202) x@@202) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@202) x@@202))
))))))) (forall (($$0@@96 Int) ) (!  (=> (and (>= $$0@@96 0) (< $$0@@96 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@96)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@96)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@96)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@96))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@93))
))) (and (forall (($$0@@97 Int) ) (!  (=> (and (>= $$0@@97 0) (< $$0@@97 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) $$0@@97))
)) (|b#$Boolean| ($Boolean (let (($range_1@@43 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@58 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@43)) $i_0@@58) (< $i_0@@58 (|i#$Integer| (|ub#$Range| $range_1@@43)))) (let ((i@@30 ($Integer $i_0@@58)))
(|b#$Boolean| ($Boolean (let (($range_3@@15 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@17 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@15)) $i_2@@17) (< $i_2@@17 (|i#$Integer| (|ub#$Range| $range_3@@15)))) (let ((j@@12 ($Integer $i_2@@17)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@30)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@12)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@30 j@@12)))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@34))
)) (forall (($inv_addr@@35 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@35)) (let ((va@@203 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@35))))
(let ((l@@204 (|l#$ValueArray| va@@203)))
 (and (and (<= 0 l@@204) (<= l@@204 $MAX_U64)) (forall ((x@@203 Int) ) (!  (=> (or (< x@@203 0) (>= x@@203 l@@204)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@203) x@@203) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@203) x@@203))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@35))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@35))) $DiemSystem_CapabilityHolder_cap)) (let ((va@@204 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@35))) $DiemSystem_CapabilityHolder_cap))))
(let ((l@@205 (|l#$ValueArray| va@@204)))
 (and (and (<= 0 l@@205) (<= l@@205 $MAX_U64)) (forall ((x@@204 Int) ) (!  (=> (or (< x@@204 0) (>= x@@204 l@@205)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@204) x@@204) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@204) x@@204))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@35))) $DiemSystem_CapabilityHolder_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@35))) $DiemSystem_CapabilityHolder_cap))) $DiemConfig_ModifyConfigCapability_dummy_field)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@35))
)))) (and (and (forall (($inv_addr@@36 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36)) (let ((va@@205 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))))
(let ((l@@206 (|l#$ValueArray| va@@205)))
 (and (and (<= 0 l@@206) (<= l@@206 $MAX_U64)) (forall ((x@@205 Int) ) (!  (=> (or (< x@@205 0) (>= x@@205 l@@206)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@205) x@@205) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@205) x@@205))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config)) (let ((va@@206 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@207 (|l#$ValueArray| va@@206)))
 (and (and (<= 0 l@@207) (<= l@@207 $MAX_U64)) (forall ((x@@206 Int) ) (!  (=> (or (< x@@206 0) (>= x@@206 l@@207)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@206) x@@206) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@206) x@@206))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@207 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@208 (|l#$ValueArray| va@@207)))
 (and (and (<= 0 l@@208) (<= l@@208 $MAX_U64)) (forall ((x@@207 Int) ) (!  (=> (or (< x@@207 0) (>= x@@207 l@@208)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@207) x@@207) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@207) x@@207))
))))))) (forall (($$0@@98 Int) ) (!  (=> (and (>= $$0@@98 0) (< $$0@@98 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@98)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@98)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@98)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@98))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@208 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@209 (|l#$ValueArray| va@@208)))
 (and (and (<= 0 l@@209) (<= l@@209 $MAX_U64)) (forall ((x@@208 Int) ) (!  (=> (or (< x@@208 0) (>= x@@208 l@@209)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@208) x@@208) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@208) x@@208))
))))))) (forall (($$0@@99 Int) ) (!  (=> (and (>= $$0@@99 0) (< $$0@@99 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@99)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@99)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@99)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@99))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@209 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@210 (|l#$ValueArray| va@@209)))
 (and (and (<= 0 l@@210) (<= l@@210 $MAX_U64)) (forall ((x@@209 Int) ) (!  (=> (or (< x@@209 0) (>= x@@209 l@@210)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@209) x@@209) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@209) x@@209))
))))))) (forall (($$0@@100 Int) ) (!  (=> (and (>= $$0@@100 0) (< $$0@@100 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@100)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@100)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@100)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@100))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@36))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address@@5 T@$Value) )  (=> ((_ is $Address) config_address@@5) (|b#$Boolean| ($Boolean (forall ((config_type@@5 T@$Value) )  (=> ((_ is $Type) config_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@5)) 1) (|a#$Address| config_address@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@5 ($Address 173345816)))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((addr@@100 T@$Value) )  (=> ((_ is $Address) addr@@100) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@100)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@100)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@100)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@101 T@$Value) )  (=> ((_ is $Address) addr@@101) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@101)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@101)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@101)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@102 T@$Value) )  (=> ((_ is $Address) addr@@102) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@102)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@102)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@102)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@103 T@$Value) )  (=> ((_ is $Address) addr@@103) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@103)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@103)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@103)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@103)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@44 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@104 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@104)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@59 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@44)) $i_0@@59) (< $i_0@@59 (|i#$Integer| (|ub#$Range| $range_1@@44)))) (let ((i1@@11 ($Integer $i_0@@59)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@105 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@105)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@11)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@105 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@105)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@11)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@45 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@106 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@106)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@60 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@45)) $i_0@@60) (< $i_0@@60 (|i#$Integer| (|ub#$Range| $range_1@@45)))) (let ((i1@@12 ($Integer $i_0@@60)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@107 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@107)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@12)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 124778) 123044))))) inline$$DiemSystem_remove_validator_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@7  (=> ((_ is $Address) dr_account@@1) (=> (and ((_ is $Address) validator_addr@@0) (= (ControlFlow 0 121592) 124778)) anon0$1_correct@@7))))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_DiemConfig_$CallerDomain@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 156338) 121592)) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@5 () Bool)
(declare-fun $abort_code@7@@4 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@2@@2 () T@$Memory)
(declare-fun value () T@$Value)
(declare-fun $abort_flag@3@@5 () Bool)
(declare-fun $abort_code@5@@4 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@2 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@2@@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0@@1 () T@$Memory)
(declare-fun $abort_code@6@@4 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@2 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1@@1 () T@$Memory)
(declare-fun $abort_code@1@@6 () Int)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun $abort_code@2@@5 () Int)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun $abort_code@4@@5 () Int)
(declare-fun $abort_flag@2@@7 () Bool)
(declare-fun call0formal@$tv0@0@@8 () T@$TypeValue)
(declare-fun inline$$DiemSystem_set_diem_system_config_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemSystem_set_diem_system_config_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@4 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$DiemSystem_set_diem_system_config_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_code@3@@5 () Int)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(declare-fun inline$$DiemSystem_set_diem_system_config_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $DiemConfig_DiemConfig_$CallerDomain@@2 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemConfig_Configuration_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 163777) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 126831) (- 0 167017)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@5)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@5) (and (=> (= (ControlFlow 0 126831) (- 0 167032)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@4@@5)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@4@@5) (and (=> (= (ControlFlow 0 126831) (- 0 167131)) (=> $abort_flag@4@@5 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (=> (=> $abort_flag@4@@5 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))) (and (=> (= (ControlFlow 0 126831) (- 0 167244)) (=> $abort_flag@4@@5 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@4 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@7@@4 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@4@@5 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@4 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@7@@4 (|i#$Integer| ($Integer 1)))))) (=> (= (ControlFlow 0 126831) (- 0 167379)) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) $DiemConfig_DiemConfig_payload) value)))))))))))))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon38_Else_correct  (=> (and (not $abort_flag@3@@5) (= $abort_code@7@@4 $abort_code@5@@4)) (=> (and (and (= $abort_flag@4@@5 $abort_flag@3@@5) (= $DiemConfig_DiemConfig_$memory@2@@2 $DiemConfig_DiemConfig_$memory@0@@2)) (and (= $DiemConfig_Configuration_$memory@2@@1 $DiemConfig_Configuration_$memory@0@@1) (= (ControlFlow 0 126729) 126831))) anon0$2_correct@@8))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$Abort_correct  (=> (= $abort_code@7@@4 $abort_code@6@@4) (=> (and (and (= $abort_flag@4@@5 true) (= $DiemConfig_DiemConfig_$memory@2@@2 $DiemConfig_DiemConfig_$memory@1@@2)) (and (= $DiemConfig_Configuration_$memory@2@@1 $DiemConfig_Configuration_$memory@1@@1) (= (ControlFlow 0 126343) 126831))) anon0$2_correct@@8))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon5_correct  (=> (and (and (= $abort_code@6@@4 $abort_code@1@@6) (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 126809) 126343))) inline$$DiemSystem_set_diem_system_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 126807) 126809)) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 126817) 126809) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon5_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@8 (and (=> (= (ControlFlow 0 126801) 126817) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 126801) 126807) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon11_correct  (=> (and (and (= $abort_code@6@@4 $abort_code@2@@5) (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 126785) 126343))) inline$$DiemSystem_set_diem_system_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 126783) 126785)) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon11_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 126793) 126785) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon11_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon31_Then_correct  (=> $abort_flag@1@@8 (and (=> (= (ControlFlow 0 126777) 126793) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 126777) 126783) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon21_correct  (=> (and (and (= $abort_code@6@@4 $abort_code@4@@5) (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 126761) 126343))) inline$$DiemSystem_set_diem_system_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 126759) 126761)) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon21_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 126769) 126761) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon21_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon36_Then_correct  (=> $abort_flag@2@@7 (and (=> (= (ControlFlow 0 126753) 126769) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 126753) 126759) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon25_correct  (=> (and (and (= $abort_code@6@@4 $abort_code@5@@4) (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory@0@@2)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory@0@@1) (= (ControlFlow 0 126741) 126343))) inline$$DiemSystem_set_diem_system_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 126739) 126741)) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon25_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 126749) 126741) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon25_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon38_Then_correct  (=> $abort_flag@3@@5 (and (=> (= (ControlFlow 0 126733) 126749) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 126733) 126739) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon36_Else$1_correct  (=> (= call0formal@$tv0@0@@8 $DiemSystem_DiemSystem_type_value) (and (=> (= (ControlFlow 0 126723) (- 0 166195)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_set_diem_system_config_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_set_diem_system_config_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 126723) (- 0 166215)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_set_diem_system_config_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_set_diem_system_config_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@5) (=> (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@3@@5) (=> $abort_flag@3@@5 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (=> (and (and (and (=> $abort_flag@3@@5 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@108 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| addr@@108)))) $DiemConfig_DiemConfig_payload)) value)))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@2) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@2) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 126723) 126733) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 126723) 126729) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon38_Else_correct))))))))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@5  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst)) $DiemSystem_CapabilityHolder_cap)) (= (ControlFlow 0 126715) 126723)) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon36_Else$1_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@2@@7) (= (ControlFlow 0 126721) 126715)) inline$$GetFieldFromValue$0$anon0_correct@@5)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@2@@7 true) (= $abort_code@4@@5 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 126661) 126753) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 126661) 126721) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 126659) 126661)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1)))) (and (= $abort_flag@2@@7 $abort_flag@1@@8) (= $abort_code@4@@5 $abort_code@2@@5))) (and (=> (= (ControlFlow 0 126607) 126753) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 126607) 126721) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 126589) 126659) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 126589) 126607) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 126583) (- 0 166080)) true) (=> (= (ControlFlow 0 126583) 126589) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon35_Else_correct  (=> (and (not $abort_flag@1@@8) (= (ControlFlow 0 126667) 126583)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon35_Then_correct  (=> $abort_flag@1@@8 (=> (and (and (= $abort_code@6@@4 $abort_code@2@@5) (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 126773) 126343))) inline$$DiemSystem_set_diem_system_config_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 126462) 126773) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 126462) 126667) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 126472) 126773) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 126472) 126667) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon35_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@1@@8) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 126456) 126472) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 126456) 126462) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon33_Then_correct  (=> (and (|b#$Boolean| inline$$DiemSystem_set_diem_system_config_$def_verify$0$$t5@1) (= (ControlFlow 0 126486) 126456)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@6@@4 $abort_code@3@@5) (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 126339) 126343))) inline$$DiemSystem_set_diem_system_config_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 126337) 126339)) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon16_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 126351) 126339) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon16_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon33_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemSystem_set_diem_system_config_$def_verify$0$$t5@1)) (= $abort_code@3@@5 (|i#$Integer| call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 126331) 126351) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 126331) 126337) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon31_Else_correct  (=> (not $abort_flag@1@@8) (and (=> (= (ControlFlow 0 126319) 126486) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 126319) 126331) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon30_Else_correct  (=> (and (not $abort_flag@0@@8) (= inline$$DiemSystem_set_diem_system_config_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0))))) (=> (and (and (and (= inline$$DiemSystem_set_diem_system_config_$def_verify$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@8)) (and (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 126313) 126777) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 126313) 126319) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon30_Then_correct  (=> $abort_flag@0@@8 (=> (and (and (= $abort_code@6@@4 $abort_code@1@@6) (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 126797) 126343))) inline$$DiemSystem_set_diem_system_config_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 126269) 126797) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 126269) 126313) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 126279) 126797) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 126279) 126313) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon30_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@0@@8) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 126263) 126279) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 126263) 126269) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@0@@8) (= (ControlFlow 0 126293) 126263)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@8) (=> (and (=> $abort_flag@0@@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@6 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 126158) 126801) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 126158) 126293) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon2_correct  (=> (= inline$$DiemSystem_set_diem_system_config_$def_verify$0$$DiemConfig_DiemConfig_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)) true)) (=> (and (= inline$$DiemSystem_set_diem_system_config_$def_verify$0$$DiemConfig_Configuration_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 126156) 126158)) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon2$1_correct))))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 126082) 126156)) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon2_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 126825) 126156) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon2_correct)))
(let ((inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 126076) 126825) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 126076) 126082) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon27_Else_correct)))))
(let ((anon0$1_correct@@8  (=> (and (and (forall (($inv_addr@@37 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@37)) (let ((va@@210 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@37))))
(let ((l@@211 (|l#$ValueArray| va@@210)))
 (and (and (<= 0 l@@211) (<= l@@211 $MAX_U64)) (forall ((x@@210 Int) ) (!  (=> (or (< x@@210 0) (>= x@@210 l@@211)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@210) x@@210) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@210) x@@210))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@37))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@37))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@37))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@37))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@37))
)) (forall (($inv_addr@@38 Int) ($inv_tv0@@11 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@38)) (let ((va@@211 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@38))))
(let ((l@@212 (|l#$ValueArray| va@@211)))
 (and (and (<= 0 l@@212) (<= l@@212 $MAX_U64)) (forall ((x@@211 Int) ) (!  (=> (or (< x@@211 0) (>= x@@211 l@@212)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@211) x@@211) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@211) x@@211))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@38))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@38))
))) (and (forall (($inv_addr@@39 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39)) (let ((va@@212 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))))
(let ((l@@213 (|l#$ValueArray| va@@212)))
 (and (and (<= 0 l@@213) (<= l@@213 $MAX_U64)) (forall ((x@@212 Int) ) (!  (=> (or (< x@@212 0) (>= x@@212 l@@213)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@212) x@@212) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@212) x@@212))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events)) (let ((va@@213 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))))
(let ((l@@214 (|l#$ValueArray| va@@213)))
 (and (and (<= 0 l@@214) (<= l@@214 $MAX_U64)) (forall ((x@@213 Int) ) (!  (=> (or (< x@@213 0) (>= x@@213 l@@214)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@213) x@@213) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@213) x@@213))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@214 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@215 (|l#$ValueArray| va@@214)))
 (and (and (<= 0 l@@215) (<= l@@215 $MAX_U64)) (forall ((x@@214 Int) ) (!  (=> (or (< x@@214 0) (>= x@@214 l@@215)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@214) x@@214) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@214) x@@214))
))))))) (forall (($$0@@101 Int) ) (!  (=> (and (>= $$0@@101 0) (< $$0@@101 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@101)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@101)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@101)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@101))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@39))
)) (forall (($inv_addr@@40 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@40)) (let ((va@@215 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@40))))
(let ((l@@216 (|l#$ValueArray| va@@215)))
 (and (and (<= 0 l@@216) (<= l@@216 $MAX_U64)) (forall ((x@@215 Int) ) (!  (=> (or (< x@@215 0) (>= x@@215 l@@216)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@215) x@@215) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@215) x@@215))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@40))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@40))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@40))
)))) (=> (and (and (and (forall (($inv_addr@@41 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@41)) (let ((va@@216 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@41))))
(let ((l@@217 (|l#$ValueArray| va@@216)))
 (and (and (<= 0 l@@217) (<= l@@217 $MAX_U64)) (forall ((x@@216 Int) ) (!  (=> (or (< x@@216 0) (>= x@@216 l@@217)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@216) x@@216) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@216) x@@216))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@41))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@41))) $DiemSystem_CapabilityHolder_cap)) (let ((va@@217 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@41))) $DiemSystem_CapabilityHolder_cap))))
(let ((l@@218 (|l#$ValueArray| va@@217)))
 (and (and (<= 0 l@@218) (<= l@@218 $MAX_U64)) (forall ((x@@217 Int) ) (!  (=> (or (< x@@217 0) (>= x@@217 l@@218)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@217) x@@217) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@217) x@@217))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@41))) $DiemSystem_CapabilityHolder_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@41))) $DiemSystem_CapabilityHolder_cap))) $DiemConfig_ModifyConfigCapability_dummy_field)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@41))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address@@6 T@$Value) )  (=> ((_ is $Address) config_address@@6) (|b#$Boolean| ($Boolean (forall ((config_type@@6 T@$Value) )  (=> ((_ is $Type) config_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@6)) 1) (|a#$Address| config_address@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@6 ($Address 173345816))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@46 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@109 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@109)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@61 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@46)) $i_0@@61) (< $i_0@@61 (|i#$Integer| (|ub#$Range| $range_1@@46)))) (let ((i1@@13 ($Integer $i_0@@61)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@110 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@110)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@13)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@110 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@110)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@13)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@47 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@111 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@111)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@62 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@47)) $i_0@@62) (< $i_0@@62 (|i#$Integer| (|ub#$Range| $range_1@@47)))) (let ((i1@@14 ($Integer $i_0@@62)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@112 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@112)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@14)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 126829) 126076)))) inline$$DiemSystem_set_diem_system_config_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@8  (=> (and (and (and (and (and (and (and ((_ is $Vector) value) (let ((va@@218 (|v#$Vector| value)))
(let ((l@@219 (|l#$ValueArray| va@@218)))
 (and (and (<= 0 l@@219) (<= l@@219 $MAX_U64)) (forall ((x@@218 Int) ) (!  (=> (or (< x@@218 0) (>= x@@218 l@@219)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@218) x@@218) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@218) x@@218))
)))))) (= (|l#$ValueArray| (|v#$Vector| value)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators)) (let ((va@@219 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))))
(let ((l@@220 (|l#$ValueArray| va@@219)))
 (and (and (<= 0 l@@220) (<= l@@220 $MAX_U64)) (forall ((x@@219 Int) ) (!  (=> (or (< x@@219 0) (>= x@@219 l@@220)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@219) x@@219) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@219) x@@219))
))))))) (forall (($$0@@102 Int) ) (!  (=> (and (>= $$0@@102 0) (< $$0@@102 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102)) (let ((va@@220 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))))
(let ((l@@221 (|l#$ValueArray| va@@220)))
 (and (and (<= 0 l@@221) (<= l@@221 $MAX_U64)) (forall ((x@@220 Int) ) (!  (=> (or (< x@@220 0) (>= x@@220 l@@221)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@220) x@@220) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@220) x@@220))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config)) (let ((va@@221 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@222 (|l#$ValueArray| va@@221)))
 (and (and (<= 0 l@@222) (<= l@@222 $MAX_U64)) (forall ((x@@221 Int) ) (!  (=> (or (< x@@221 0) (>= x@@221 l@@222)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@221) x@@221) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@221) x@@221))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@222 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@223 (|l#$ValueArray| va@@222)))
 (and (and (<= 0 l@@223) (<= l@@223 $MAX_U64)) (forall ((x@@222 Int) ) (!  (=> (or (< x@@222 0) (>= x@@222 l@@223)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@222) x@@222) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@222) x@@222))
))))))) (forall (($$0@@103 Int) ) (!  (=> (and (>= $$0@@103 0) (< $$0@@103 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@103)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@103)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@103)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@103))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@223 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@224 (|l#$ValueArray| va@@223)))
 (and (and (<= 0 l@@224) (<= l@@224 $MAX_U64)) (forall ((x@@223 Int) ) (!  (=> (or (< x@@223 0) (>= x@@223 l@@224)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@223) x@@223) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@223) x@@223))
))))))) (forall (($$0@@104 Int) ) (!  (=> (and (>= $$0@@104 0) (< $$0@@104 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@104)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@104)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@104)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@104))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@224 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@225 (|l#$ValueArray| va@@224)))
 (and (and (<= 0 l@@225) (<= l@@225 $MAX_U64)) (forall ((x@@224 Int) ) (!  (=> (or (< x@@224 0) (>= x@@224 l@@225)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@224) x@@224) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@224) x@@224))
))))))) (forall (($$0@@105 Int) ) (!  (=> (and (>= $$0@@105 0) (< $$0@@105 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@105)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@105)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@105)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@105))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@102))
))) (and (forall (($$0@@106 Int) ) (!  (=> (and (>= $$0@@106 0) (< $$0@@106 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) $$0@@106))
)) (|b#$Boolean| ($Boolean (let (($range_1@@48 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@63 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@48)) $i_0@@63) (< $i_0@@63 (|i#$Integer| (|ub#$Range| $range_1@@48)))) (let ((i@@31 ($Integer $i_0@@63)))
(|b#$Boolean| ($Boolean (let (($range_3@@16 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@18 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@16)) $i_2@@18) (< $i_2@@18 (|i#$Integer| (|ub#$Range| $range_3@@16)))) (let ((j@@13 ($Integer $i_2@@18)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@31)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| value)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@13)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@31 j@@13)))))))))))))))))))) (= (ControlFlow 0 125194) 126829)) anon0$1_correct@@8)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_DiemConfig_$CallerDomain@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))) (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemConfig_Configuration_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 163777) 125194)) anon0_correct@@8))))
PreconditionGeneratedEntry_correct@@7)))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@6 () Bool)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 () T@$Value)
(declare-fun i@@32 () T@$Value)
(declare-fun validators@@0 () T@$Value)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Ge$0$dst@1 () T@$Value)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t18@1 () T@$Value)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun inline$$Not$0$dst@1@@1 () T@$Value)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun $abort_flag@2@@8 () Bool)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t23@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun |inline$$Splice1$0$dst'@1| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun $abort_code@2@@6 () Int)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@2 () T@$Mutation)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$DiemSystem_update_ith_validator_info__$def_verify$0$config_ref@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun |inline$$Vector_borrow_mut$0$v'| () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@0 () T@$Mutation)
(declare-fun inline$$Vector_borrow_mut$0$i_ind@1 () Int)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$Vector_borrow_mut$0$dst@1 () T@$Mutation)
(declare-fun inline$$Vector_borrow_mut$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_length$0$l@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0@@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 167422) (let ((anon0$2_correct@@9  (and (=> (= (ControlFlow 0 130893) (- 0 170359)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@6)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@6) (and (=> (= (ControlFlow 0 130893) (- 0 170368)) (=> $abort_flag@3@@6 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@3@@6 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 130893) (- 0 170377)) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_addr))))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_addr))))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_config)))))))))))) (=> (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_addr))))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_addr))))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_config))))))))))) (and (=> (= (ControlFlow 0 130893) (- 0 170433)) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_config ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_addr))))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0))) (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32))))))) (|l#$ValueArray| (|v#$Vector| validators@@0)))))))))))) (=> (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_config ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32)))) $DiemSystem_ValidatorInfo_addr))))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0))) (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32))))))) (|l#$ValueArray| (|v#$Vector| validators@@0))))))))))) (and (=> (= (ControlFlow 0 130893) (- 0 170477)) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 validators@@0)))))))) (=> (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 validators@@0))))))) (and (=> (= (ControlFlow 0 130893) (- 0 170506)) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32))) (|l#$ValueArray| (|v#$Vector| validators@@0))))))))) (=> (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) (|i#$Integer| i@@32) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2)) (|i#$Integer| i@@32))) (|l#$ValueArray| (|v#$Vector| validators@@0)))))))) (and (=> (= (ControlFlow 0 130893) (- 0 170529)) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean (let (($range_1@@49 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@113 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@113)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@64 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@49)) $i_0@@64) (< $i_0@@64 (|i#$Integer| (|ub#$Range| $range_1@@49)))) (let ((i1@@15 ($Integer $i_0@@64)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@114 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@114)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@15)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))))) (=> (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean (let (($range_1@@49 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@113 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@113)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@65 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@49)) $i_0@@65) (< $i_0@@65 (|i#$Integer| (|ub#$Range| $range_1@@49)))) (let ((i1@@15 ($Integer $i_0@@65)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@114 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@114)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@15)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1))))))))))) (=> (= (ControlFlow 0 130893) (- 0 170591)) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@115 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@115)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@116 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@116)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))))))))))))))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon14_correct  (=> (and (and (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2 inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t11@1) (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 validators@@0)) (and (= $abort_flag@3@@6 false) (= (ControlFlow 0 130831) 130893))) anon0$2_correct@@9)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 130829) 130831)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon14_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 130839) 130831) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon14_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon54_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 130819) 130839) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 130819) 130829) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon55_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon54_Then_correct  (and (=> (= (ControlFlow 0 130847) 130839) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 130847) 130829) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon55_Else_correct))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon53_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1) (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t11@1 ($Boolean false))) (and (=> (= (ControlFlow 0 130813) 130847) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 130813) 130819) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon54_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon32_correct  (=> (and (and (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2 inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t18@1) (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 validators@@0)) (and (= $abort_flag@3@@6 $abort_flag@1@@9) (= (ControlFlow 0 130725) 130893))) anon0$2_correct@@9)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 130723) 130725)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon32_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 130733) 130725) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon32_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon63_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 130713) 130733) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 130713) 130723) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon63_Then_correct  (and (=> (= (ControlFlow 0 130741) 130733) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 130741) 130723) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon64_Else_correct))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon62_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@1) (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t18@1 ($Boolean false))) (and (=> (= (ControlFlow 0 130707) 130741) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 130707) 130713) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon63_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$Abort_correct  (=> (and (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@1 $Error) (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@1 $Error)) (=> (and (and (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2 inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@1) (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@1)) (and (= $abort_flag@3@@6 true) (= (ControlFlow 0 130687) 130893))) anon0$2_correct@@9))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 130791) 130687)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 130801) 130687) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon56_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 130785) 130801) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 130785) 130791) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 130751) 130687)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon61_Then_correct  (=> (= (ControlFlow 0 130761) 130687) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon60_Then_correct  (=> $abort_flag@1@@9 (and (=> (= (ControlFlow 0 130745) 130761) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 130745) 130751) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 130677) 130687)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 130695) 130687) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon65_Then_correct  (=> $abort_flag@2@@8 (and (=> (= (ControlFlow 0 130671) 130695) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 130671) 130677) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon42_correct  (=> (and (and (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2 inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t22@1) (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 validators@@0)) (and (= $abort_flag@3@@6 $abort_flag@2@@8) (= (ControlFlow 0 130651) 130893))) anon0$2_correct@@9)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 130649) 130651)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon42_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 130659) 130651) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon42_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon68_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 130639) 130659) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 130639) 130649) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon69_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon68_Then_correct  (and (=> (= (ControlFlow 0 130667) 130659) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 130667) 130649) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon69_Else_correct))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon67_Then_correct  (=> (and (|b#$Boolean| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t21@1) (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t22@1 ($Boolean false))) (and (=> (= (ControlFlow 0 130633) 130667) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 130633) 130639) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon68_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon48_correct  (=> (and (and (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret0@2 inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t23@1) (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@1|)) (and (= $abort_flag@3@@6 $abort_flag@2@@8) (= (ControlFlow 0 130595) 130893))) anon0$2_correct@@9)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 130593) 130595)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon48_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 130603) 130595) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon48_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon71_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 130583) 130603) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 130583) 130593) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon72_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon71_Then_correct  (and (=> (= (ControlFlow 0 130611) 130603) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 130611) 130593) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon72_Else_correct))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon44$3_correct  (=> (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t23@1 ($Boolean true)) (and (=> (= (ControlFlow 0 130577) 130611) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 130577) 130583) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon71_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 6))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@1| validators@@0) (= (ControlFlow 0 130537) 130577)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon44$3_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 6)) (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 validators@@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@1|) (= (ControlFlow 0 130563) 130577))) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon44$3_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowLoc$0$dst@1@@1)) (and (=> (= (ControlFlow 0 130382) 130563) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 130382) 130537) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (and (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|))) (and (=> (= (ControlFlow 0 130438) 130563) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 130438) 130537) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) (and (=> (= (ControlFlow 0 130346) 130438) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 130346) 130382) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| |inline$$Splice1$0$dst'@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$Splice1$0$dst'@1|) (= (ControlFlow 0 130147) 130346)) inline$$WritebackToReference$1$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| |inline$$Splice1$0$dst'@1|) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| |inline$$Splice1$0$dst'@1|) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| |inline$$Splice1$0$dst'@1|) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 130203) 130346))) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| |inline$$Splice1$0$dst'@1|))) (and (=> (= (ControlFlow 0 130111) 130203) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 130111) 130147) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 129974) 130111)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon70_Then_correct  (=> (and (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$trace_temp@3 (|v#$Mutation| |inline$$WriteRef$1$to'@1|)) (= (ControlFlow 0 130621) 130111)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1) (|p#$Mutation| inline$$BorrowField$2$dst@1) call3formal@$ret0@0@@10)) (and (=> (= (ControlFlow 0 129960) 130621) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 129960) 129974) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon70_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon67_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t21@1)) (= (ControlFlow 0 129966) 129960)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon65_Else$2_correct  (and (=> (= (ControlFlow 0 129901) (- 0 169760)) true) (=> (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$t21@1 ($Boolean ($IsEqual_stratified inline$$ReadRef$4$v@1 call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 129901) 130633) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 129901) 129966) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon67_Else_correct))))))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 129881) 129901)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon65_Else$2_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| |inline$$Splice1$0$dst'@1|)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $DiemSystem_ValidatorInfo_config) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| |inline$$Splice1$0$dst'@1|) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$Splice1$0$dst'@1|))) $DiemSystem_ValidatorInfo_config))) (= (ControlFlow 0 129843) 129881))) inline$$ReadRef$4$anon0_correct))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon65_Else_correct  (=> (and (not $abort_flag@2@@8) (= (ControlFlow 0 129849) 129843)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon62_Else$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ReadRef$3$v@1))))))) $abort_flag@2@@8) (=> (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ReadRef$3$v@1)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@2@@8) (=> $abort_flag@2@@8 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ReadRef$3$v@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ReadRef$3$v@1)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))) (and (=> $abort_flag@2@@8 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ReadRef$3$v@1))))))) (= $abort_code@2@@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ReadRef$3$v@1)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@2@@6 (|i#$Integer| ($Integer 7)))))) (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ReadRef$3$v@1)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0)))))))) (=> (and (and (and (and (and (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@10) (let ((va@@225 (|v#$Vector| call3formal@$ret0@0@@10)))
(let ((l@@226 (|l#$ValueArray| va@@225)))
 (and (and (<= 0 l@@226) (<= l@@226 $MAX_U64)) (forall ((x@@225 Int) ) (!  (=> (or (< x@@225 0) (>= x@@225 l@@226)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@225) x@@225) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@225) x@@225))
)))))) (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@226 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@227 (|l#$ValueArray| va@@226)))
 (and (and (<= 0 l@@227) (<= l@@227 $MAX_U64)) (forall ((x@@226 Int) ) (!  (=> (or (< x@@226 0) (>= x@@226 l@@227)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@226) x@@226) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@226) x@@226))
))))))) (forall (($$0@@107 Int) ) (!  (=> (and (>= $$0@@107 0) (< $$0@@107 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@107)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@107)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@107)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@107))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@227 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@228 (|l#$ValueArray| va@@227)))
 (and (and (<= 0 l@@228) (<= l@@228 $MAX_U64)) (forall ((x@@227 Int) ) (!  (=> (or (< x@@227 0) (>= x@@227 l@@228)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@227) x@@227) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@227) x@@227))
))))))) (forall (($$0@@108 Int) ) (!  (=> (and (>= $$0@@108 0) (< $$0@@108 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@108)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@108)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@108)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@108))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@228 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@229 (|l#$ValueArray| va@@228)))
 (and (and (<= 0 l@@229) (<= l@@229 $MAX_U64)) (forall ((x@@228 Int) ) (!  (=> (or (< x@@228 0) (>= x@@228 l@@229)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@228) x@@228) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@228) x@@228))
))))))) (forall (($$0@@109 Int) ) (!  (=> (and (>= $$0@@109 0) (< $$0@@109 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@109)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@109)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@109)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@109))
))) true) (and (=> (= (ControlFlow 0 129721) 130671) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 129721) 129849) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon65_Else_correct)))))))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 129705) 129721)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon62_Else$1_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| |inline$$Splice1$0$dst'@1|)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $DiemSystem_ValidatorInfo_addr) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| |inline$$Splice1$0$dst'@1|) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$Splice1$0$dst'@1|))) $DiemSystem_ValidatorInfo_addr))) (= (ControlFlow 0 129667) 129705))) inline$$ReadRef$3$anon0_correct))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon62_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@1)) (= (ControlFlow 0 129719) 129667)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$Not$0$anon0_correct@@1  (=> (= inline$$Not$0$dst@1@@1 ($Boolean  (not (|b#$Boolean| call3formal@$ret0@0@@11)))) (and (=> (= (ControlFlow 0 129499) 130707) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 129499) 129719) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon62_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 129489) (- 0 169363)) true) (=> (= (ControlFlow 0 129489) 129499) inline$$Not$0$anon0_correct@@1))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon60_Else_correct  (=> (and (not $abort_flag@1@@9) (= (ControlFlow 0 129505) 129489)) inline$$Not$0$Entry_correct@@1)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon22$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@9) (=> $abort_flag@1@@9 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ReadRef$2$v@1)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ReadRef$2$v@1)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 129451) 130745) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 129451) 129505) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon60_Else_correct)))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (= (ControlFlow 0 129435) 129451)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon22$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| |inline$$Splice1$0$dst'@1|)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $DiemSystem_ValidatorInfo_addr) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$Splice1$0$dst'@1|) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$Splice1$0$dst'@1|))) $DiemSystem_ValidatorInfo_addr))) (= (ControlFlow 0 129397) 129435))) inline$$ReadRef$2$anon0_correct))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 129243) 129397)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon59_Then_correct  (=> (and (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$Splice1$0$dst'@1|)) (= (ControlFlow 0 130771) 129397)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$Splice1$0$anon0_correct  (=> (= |inline$$Splice1$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) ($ConcatPath_stratified (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|p#$Mutation| inline$$Vector_borrow_mut$0$dst@2)) (|v#$Mutation| inline$$Vector_borrow_mut$0$dst@2))) (and (=> (= (ControlFlow 0 129195) 130771) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 129195) 129243) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon59_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon58_Else_correct  (=> (and (not true) (= (ControlFlow 0 129120) 129195)) inline$$Splice1$0$anon0_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon58_Then_correct  (=> (and (= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$DiemSystem_update_ith_validator_info__$def_verify$0$config_ref@0)) (= (ControlFlow 0 130781) 129195)) inline$$Splice1$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1) |inline$$Vector_borrow_mut$0$v'|)) (and (=> (= (ControlFlow 0 129106) 130781) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 129106) 129120) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon58_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon56_Else_correct  (=> (and (not $abort_flag@0@@9) (= (ControlFlow 0 129112) 129106)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$Vector_borrow_mut$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@9 true) (= inline$$Vector_borrow_mut$0$dst@2 inline$$Vector_borrow_mut$0$dst@0)) (and (=> (= (ControlFlow 0 129039) 130785) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 129039) 129112) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon56_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$anon3_Then_correct  (=> (and (or (< inline$$Vector_borrow_mut$0$i_ind@1 0) (>= inline$$Vector_borrow_mut$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)))) (= (ControlFlow 0 129037) 129039)) inline$$Vector_borrow_mut$0$anon3_Then$1_correct)))
(let ((inline$$Vector_borrow_mut$0$anon3_Else_correct  (=> (and (and (not (or (< inline$$Vector_borrow_mut$0$i_ind@1 0) (>= inline$$Vector_borrow_mut$0$i_ind@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1))))) (= inline$$Vector_borrow_mut$0$dst@1 ($Mutation ($Local 0) ($Path (|Store_[$int]$int| (|p#$Path| $EmptyPath) 0 inline$$Vector_borrow_mut$0$i_ind@1) 1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) inline$$Vector_borrow_mut$0$i_ind@1)))) (and (= $abort_flag@0@@9 false) (= inline$$Vector_borrow_mut$0$dst@2 inline$$Vector_borrow_mut$0$dst@1))) (and (=> (= (ControlFlow 0 128979) 130785) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 128979) 129112) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon56_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$anon0_correct  (=> (and (= inline$$Vector_borrow_mut$0$i_ind@1 (|i#$Integer| i@@32)) ((_ is $Vector) inline$$ReadRef$1$v@1)) (and (=> (= (ControlFlow 0 128931) 129037) inline$$Vector_borrow_mut$0$anon3_Then_correct) (=> (= (ControlFlow 0 128931) 128979) inline$$Vector_borrow_mut$0$anon3_Else_correct)))))
(let ((inline$$Vector_borrow_mut$0$Entry_correct  (=> (= inline$$Vector_borrow_mut$0$ta@0 $DiemSystem_ValidatorInfo_type_value) (and (=> (= (ControlFlow 0 128921) (- 0 168975)) true) (=> (= (ControlFlow 0 128921) 128931) inline$$Vector_borrow_mut$0$anon0_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon53_Else$2_correct  (and (=> (= (ControlFlow 0 129047) (- 0 168930)) (forall ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0 0) (< inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0))
))) (=> (forall ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@0 0) (< inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@0))
)) (=> (= (ControlFlow 0 129047) 128921) inline$$Vector_borrow_mut$0$Entry_correct)))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 128742) 129047)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon53_Else$2_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon53_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1)) (= (ControlFlow 0 128710) 128742)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$Ge$0$anon0_correct  (=> (= inline$$Ge$0$dst@1 ($Boolean (>= (|i#$Integer| i@@32) (|i#$Integer| inline$$Vector_length$0$l@1@@0)))) (and (=> (= (ControlFlow 0 128662) 130813) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 128662) 128710) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon53_Else_correct)))))
(let ((inline$$Ge$0$Entry_correct  (and (=> (= (ControlFlow 0 128648) (- 0 168862)) true) (=> (= (ControlFlow 0 128648) 128662) inline$$Ge$0$anon0_correct))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon51_Else_correct  (=> (and (not false) (= (ControlFlow 0 128668) 128648)) inline$$Ge$0$Entry_correct)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon51_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@1) (= inline$$Vector_length$0$l@1@@0 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1))))) (and (=> (= (ControlFlow 0 128592) 130851) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 128592) 128668) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@0  (=> (and (= inline$$Vector_length$0$ta@0@@0 $DiemSystem_ValidatorInfo_type_value) (= (ControlFlow 0 128580) 128592)) inline$$Vector_length$0$anon0_correct@@0)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon4$4_correct  (and (=> (= (ControlFlow 0 128598) (- 0 168792)) (forall ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@1 Int) ) (!  (=> (and (>= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@1 0) (< inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@1))
))) (=> (forall ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@2 Int) ) (!  (=> (and (>= inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@2 0) (< inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$$$0@@2))
)) (=> (= (ControlFlow 0 128598) 128580) inline$$Vector_length$0$Entry_correct@@0)))))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (= (ControlFlow 0 128499) 128598)) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon4$4_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 6) $EmptyPath validators@@0)) (= (ControlFlow 0 128461) 128499)) inline$$ReadRef$0$anon0_correct@@1)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 128343) 128461)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 130875) 128461) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon49_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 128335) 130875) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 128335) 128343) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon50_Else_correct)))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon49_Then_correct  (and (=> (= (ControlFlow 0 130883) 130875) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 130883) 128343) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon50_Else_correct))))
(let ((inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 128329) 130883) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 128329) 128335) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon49_Else_correct)))))
(let ((anon0$1_correct@@9  (=> (forall (($inv_addr@@42 Int) ($inv_tv0@@12 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@42)) (let ((va@@229 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@42))))
(let ((l@@230 (|l#$ValueArray| va@@229)))
 (and (and (<= 0 l@@230) (<= l@@230 $MAX_U64)) (forall ((x@@229 Int) ) (!  (=> (or (< x@@229 0) (>= x@@229 l@@230)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@229) x@@229) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@229) x@@229))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@42))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@42))) $Option_Option_vec)) (let ((va@@230 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@42))) $Option_Option_vec))))
(let ((l@@231 (|l#$ValueArray| va@@230)))
 (and (and (<= 0 l@@231) (<= l@@231 $MAX_U64)) (forall ((x@@230 Int) ) (!  (=> (or (< x@@230 0) (>= x@@230 l@@231)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@230) x@@230) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@230) x@@230))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@42))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@42))
)) (=> (and (and (and (forall (($inv_addr@@43 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43)) (let ((va@@231 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))))
(let ((l@@232 (|l#$ValueArray| va@@231)))
 (and (and (<= 0 l@@232) (<= l@@232 $MAX_U64)) (forall ((x@@231 Int) ) (!  (=> (or (< x@@231 0) (>= x@@231 l@@232)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@231) x@@231) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@231) x@@231))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@232 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@233 (|l#$ValueArray| va@@232)))
 (and (and (<= 0 l@@233) (<= l@@233 $MAX_U64)) (forall ((x@@232 Int) ) (!  (=> (or (< x@@232 0) (>= x@@232 l@@233)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@232) x@@232) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@232) x@@232))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@233 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@234 (|l#$ValueArray| va@@233)))
 (and (and (<= 0 l@@234) (<= l@@234 $MAX_U64)) (forall ((x@@233 Int) ) (!  (=> (or (< x@@233 0) (>= x@@233 l@@234)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@233) x@@233) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@233) x@@233))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@234 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@235 (|l#$ValueArray| va@@234)))
 (and (and (<= 0 l@@235) (<= l@@235 $MAX_U64)) (forall ((x@@234 Int) ) (!  (=> (or (< x@@234 0) (>= x@@234 l@@235)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@234) x@@234) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@234) x@@234))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@235 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@236 (|l#$ValueArray| va@@235)))
 (and (and (<= 0 l@@236) (<= l@@236 $MAX_U64)) (forall ((x@@235 Int) ) (!  (=> (or (< x@@235 0) (>= x@@235 l@@236)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@235) x@@235) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@235) x@@235))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@236 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@237 (|l#$ValueArray| va@@236)))
 (and (and (<= 0 l@@237) (<= l@@237 $MAX_U64)) (forall ((x@@236 Int) ) (!  (=> (or (< x@@236 0) (>= x@@236 l@@237)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@236) x@@236) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@236) x@@236))
))))))) (forall (($$0@@110 Int) ) (!  (=> (and (>= $$0@@110 0) (< $$0@@110 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@110)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@110)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@110)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@110))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@43))
)) (forall (($inv_addr@@44 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44)) (let ((va@@237 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))))
(let ((l@@238 (|l#$ValueArray| va@@237)))
 (and (and (<= 0 l@@238) (<= l@@238 $MAX_U64)) (forall ((x@@237 Int) ) (!  (=> (or (< x@@237 0) (>= x@@237 l@@238)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@237) x@@237) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@237) x@@237))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config)) (let ((va@@238 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@239 (|l#$ValueArray| va@@238)))
 (and (and (<= 0 l@@239) (<= l@@239 $MAX_U64)) (forall ((x@@238 Int) ) (!  (=> (or (< x@@238 0) (>= x@@238 l@@239)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@238) x@@238) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@238) x@@238))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@239 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@240 (|l#$ValueArray| va@@239)))
 (and (and (<= 0 l@@240) (<= l@@240 $MAX_U64)) (forall ((x@@239 Int) ) (!  (=> (or (< x@@239 0) (>= x@@239 l@@240)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@239) x@@239) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@239) x@@239))
))))))) (forall (($$0@@111 Int) ) (!  (=> (and (>= $$0@@111 0) (< $$0@@111 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@111)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@111)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@111)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@111))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@240 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@241 (|l#$ValueArray| va@@240)))
 (and (and (<= 0 l@@241) (<= l@@241 $MAX_U64)) (forall ((x@@240 Int) ) (!  (=> (or (< x@@240 0) (>= x@@240 l@@241)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@240) x@@240) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@240) x@@240))
))))))) (forall (($$0@@112 Int) ) (!  (=> (and (>= $$0@@112 0) (< $$0@@112 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@112)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@112)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@112)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@112))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@241 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@242 (|l#$ValueArray| va@@241)))
 (and (and (<= 0 l@@242) (<= l@@242 $MAX_U64)) (forall ((x@@241 Int) ) (!  (=> (or (< x@@241 0) (>= x@@241 l@@242)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@241) x@@241) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@241) x@@241))
))))))) (forall (($$0@@113 Int) ) (!  (=> (and (>= $$0@@113 0) (< $$0@@113 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@113)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@113)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@113)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@113))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@44))
))) (and (|b#$Boolean| ($Boolean (forall ((addr@@117 T@$Value) )  (=> ((_ is $Address) addr@@117) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@117)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@117)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@117)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@118 T@$Value) )  (=> ((_ is $Address) addr@@118) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@118)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@118)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@118)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@119 T@$Value) )  (=> ((_ is $Address) addr@@119) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@119)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@119)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@119)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@119)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer 0)) (|i#$Integer| i@@32)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@32) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| validators@@0))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_3@@17 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@120 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@120)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@19 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@17)) $i_2@@19) (< $i_2@@19 (|i#$Integer| (|ub#$Range| $range_3@@17)))) (let ((i1@@16 ($Integer $i_2@@19)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@121 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@121)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@16)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 130891) 128329)))) inline$$DiemSystem_update_ith_validator_info__$def_verify$0$anon0_correct))))
(let ((anon0_correct@@9  (=> (and (and ((_ is $Vector) validators@@0) (let ((va@@242 (|v#$Vector| validators@@0)))
(let ((l@@243 (|l#$ValueArray| va@@242)))
 (and (and (<= 0 l@@243) (<= l@@243 $MAX_U64)) (forall ((x@@242 Int) ) (!  (=> (or (< x@@242 0) (>= x@@242 l@@243)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@242) x@@242) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@242) x@@242))
)))))) (forall (($$0@@114 Int) ) (!  (=> (and (>= $$0@@114 0) (< $$0@@114 (|l#$ValueArray| (|v#$Vector| validators@@0)))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114)) (let ((va@@243 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))))
(let ((l@@244 (|l#$ValueArray| va@@243)))
 (and (and (<= 0 l@@244) (<= l@@244 $MAX_U64)) (forall ((x@@243 Int) ) (!  (=> (or (< x@@243 0) (>= x@@243 l@@244)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@243) x@@243) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@243) x@@243))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config)) (let ((va@@244 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@245 (|l#$ValueArray| va@@244)))
 (and (and (<= 0 l@@245) (<= l@@245 $MAX_U64)) (forall ((x@@244 Int) ) (!  (=> (or (< x@@244 0) (>= x@@244 l@@245)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@244) x@@244) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@244) x@@244))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@245 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@246 (|l#$ValueArray| va@@245)))
 (and (and (<= 0 l@@246) (<= l@@246 $MAX_U64)) (forall ((x@@245 Int) ) (!  (=> (or (< x@@245 0) (>= x@@245 l@@246)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@245) x@@245) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@245) x@@245))
))))))) (forall (($$0@@115 Int) ) (!  (=> (and (>= $$0@@115 0) (< $$0@@115 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@115)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@115)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@115)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@115))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@246 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@247 (|l#$ValueArray| va@@246)))
 (and (and (<= 0 l@@247) (<= l@@247 $MAX_U64)) (forall ((x@@246 Int) ) (!  (=> (or (< x@@246 0) (>= x@@246 l@@247)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@246) x@@246) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@246) x@@246))
))))))) (forall (($$0@@116 Int) ) (!  (=> (and (>= $$0@@116 0) (< $$0@@116 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@116)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@116)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@116)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@116))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@247 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@248 (|l#$ValueArray| va@@247)))
 (and (and (<= 0 l@@248) (<= l@@248 $MAX_U64)) (forall ((x@@247 Int) ) (!  (=> (or (< x@@247 0) (>= x@@247 l@@248)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@247) x@@247) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@247) x@@247))
))))))) (forall (($$0@@117 Int) ) (!  (=> (and (>= $$0@@117 0) (< $$0@@117 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@117)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@117)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@117)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@117))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validators@@0)) $$0@@114))
))) (=> (and (and (and ((_ is $Integer) i@@32) (>= (|i#$Integer| i@@32) 0)) (<= (|i#$Integer| i@@32) $MAX_U64)) (= (ControlFlow 0 127116) 130891)) anon0$1_correct@@9))))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 167422) 127116) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@8))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@10 () Bool)
(declare-fun $abort_code@1@@7 () Int)
(declare-fun inline$$DiemSystem_validator_set_size_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$DiemSystem_validator_set_size_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun inline$$Vector_length$0$l@1@@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@5 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0@@1 () T@$TypeValue)
(declare-fun call2formal@$ret0@0@@6 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 170615) (let ((anon0$2_correct@@10  (and (=> (= (ControlFlow 0 132165) (- 0 171593)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@10)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@10) (and (=> (= (ControlFlow 0 132165) (- 0 171624)) (=> $abort_flag@1@@10 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@1@@10 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 132165) (- 0 171655)) (=> $abort_flag@1@@10 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@7 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@1@@10 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@7 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 132165) (- 0 171697)) (=> (not $abort_flag@1@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_validator_set_size_$def_verify$0$$ret0@2 ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@122 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@122)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))) (=> (=> (not $abort_flag@1@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_validator_set_size_$def_verify$0$$ret0@2 ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@122 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@122)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))) (=> (= (ControlFlow 0 132165) (- 0 171715)) (=> (not $abort_flag@1@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@123 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@123)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@124 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@124)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))))))))))))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$Abort_correct  (=> (and (and (= inline$$DiemSystem_validator_set_size_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@10 true)) (and (= inline$$DiemSystem_validator_set_size_$def_verify$0$$ret0@2 inline$$DiemSystem_validator_set_size_$def_verify$0$$ret0@1) (= (ControlFlow 0 132129) 132165))) anon0$2_correct@@10)))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 132147) 132129)) inline$$DiemSystem_validator_set_size_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 132157) 132129) inline$$DiemSystem_validator_set_size_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon11_Then_correct  (=> $abort_flag@0@@10 (and (=> (= (ControlFlow 0 132141) 132157) inline$$DiemSystem_validator_set_size_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 132141) 132147) inline$$DiemSystem_validator_set_size_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 132121) 132129)) inline$$DiemSystem_validator_set_size_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 132137) 132129) inline$$DiemSystem_validator_set_size_$def_verify$0$Abort_correct)))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@10 (and (=> (= (ControlFlow 0 132115) 132137) inline$$DiemSystem_validator_set_size_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 132115) 132121) inline$$DiemSystem_validator_set_size_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon10_correct  (=> (= $abort_flag@1@@10 $abort_flag@0@@10) (=> (and (= inline$$DiemSystem_validator_set_size_$def_verify$0$$ret0@2 inline$$Vector_length$0$l@1@@1) (= (ControlFlow 0 132103) 132165)) anon0$2_correct@@10))))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 132101) 132103)) inline$$DiemSystem_validator_set_size_$def_verify$0$anon10_correct)))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 132111) 132103) inline$$DiemSystem_validator_set_size_$def_verify$0$anon10_correct)))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@10) (and (=> (= (ControlFlow 0 132095) 132111) inline$$DiemSystem_validator_set_size_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 132095) 132101) inline$$DiemSystem_validator_set_size_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Vector_length$0$anon0_correct@@1  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1@@5) (= inline$$Vector_length$0$l@1@@1 ($Integer (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@5))))) (and (=> (= (ControlFlow 0 132079) 132115) inline$$DiemSystem_validator_set_size_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 132079) 132095) inline$$DiemSystem_validator_set_size_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct@@1  (=> (and (= inline$$Vector_length$0$ta@0@@1 $DiemSystem_ValidatorInfo_type_value) (= (ControlFlow 0 132067) 132079)) inline$$Vector_length$0$anon0_correct@@1)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@6  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators)) (= (ControlFlow 0 132022) 132067)) inline$$Vector_length$0$Entry_correct@@1)))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon11_Else_correct  (=> (and (not $abort_flag@0@@10) (= (ControlFlow 0 132028) 132022)) inline$$GetFieldFromValue$0$anon0_correct@@6)))
(let ((inline$$DiemSystem_validator_set_size_$def_verify$0$anon0_correct  (=> (and (not false) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@10)) (=> (and (and (=> $abort_flag@0@@10 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@10 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@7 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@6 (let ((addr@@125 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@125)))) $DiemConfig_DiemConfig_payload)))))) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@126 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@126)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@127 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@127)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))))))) (=> (and (and (and (and (and (and ((_ is $Vector) call2formal@$ret0@0@@6) (let ((va@@248 (|v#$Vector| call2formal@$ret0@0@@6)))
(let ((l@@249 (|l#$ValueArray| va@@248)))
 (and (and (<= 0 l@@249) (<= l@@249 $MAX_U64)) (forall ((x@@248 Int) ) (!  (=> (or (< x@@248 0) (>= x@@248 l@@249)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@248) x@@248) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@248) x@@248))
)))))) (= (|l#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators)) (let ((va@@249 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))))
(let ((l@@250 (|l#$ValueArray| va@@249)))
 (and (and (<= 0 l@@250) (<= l@@250 $MAX_U64)) (forall ((x@@249 Int) ) (!  (=> (or (< x@@249 0) (>= x@@249 l@@250)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@249) x@@249) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@249) x@@249))
))))))) (forall (($$0@@118 Int) ) (!  (=> (and (>= $$0@@118 0) (< $$0@@118 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118)) (let ((va@@250 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))))
(let ((l@@251 (|l#$ValueArray| va@@250)))
 (and (and (<= 0 l@@251) (<= l@@251 $MAX_U64)) (forall ((x@@250 Int) ) (!  (=> (or (< x@@250 0) (>= x@@250 l@@251)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@250) x@@250) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@250) x@@250))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config)) (let ((va@@251 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@252 (|l#$ValueArray| va@@251)))
 (and (and (<= 0 l@@252) (<= l@@252 $MAX_U64)) (forall ((x@@251 Int) ) (!  (=> (or (< x@@251 0) (>= x@@251 l@@252)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@251) x@@251) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@251) x@@251))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@252 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@253 (|l#$ValueArray| va@@252)))
 (and (and (<= 0 l@@253) (<= l@@253 $MAX_U64)) (forall ((x@@252 Int) ) (!  (=> (or (< x@@252 0) (>= x@@252 l@@253)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@252) x@@252) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@252) x@@252))
))))))) (forall (($$0@@119 Int) ) (!  (=> (and (>= $$0@@119 0) (< $$0@@119 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@119)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@119)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@119)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@119))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@253 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@254 (|l#$ValueArray| va@@253)))
 (and (and (<= 0 l@@254) (<= l@@254 $MAX_U64)) (forall ((x@@253 Int) ) (!  (=> (or (< x@@253 0) (>= x@@253 l@@254)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@253) x@@253) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@253) x@@253))
))))))) (forall (($$0@@120 Int) ) (!  (=> (and (>= $$0@@120 0) (< $$0@@120 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@120)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@120)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@120)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@120))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@254 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@255 (|l#$ValueArray| va@@254)))
 (and (and (<= 0 l@@255) (<= l@@255 $MAX_U64)) (forall ((x@@254 Int) ) (!  (=> (or (< x@@254 0) (>= x@@254 l@@255)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@254) x@@254) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@254) x@@254))
))))))) (forall (($$0@@121 Int) ) (!  (=> (and (>= $$0@@121 0) (< $$0@@121 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@121)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@121)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@121)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@121))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@118))
))) (and (forall (($$0@@122 Int) ) (!  (=> (and (>= $$0@@122 0) (< $$0@@122 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) $$0@@122))
)) (|b#$Boolean| ($Boolean (let (($range_1@@50 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@66 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@50)) $i_0@@66) (< $i_0@@66 (|i#$Integer| (|ub#$Range| $range_1@@50)))) (let ((i@@33 ($Integer $i_0@@66)))
(|b#$Boolean| ($Boolean (let (($range_3@@18 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@20 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@18)) $i_2@@20) (< $i_2@@20 (|i#$Integer| (|ub#$Range| $range_3@@18)))) (let ((j@@14 ($Integer $i_2@@20)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@33)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@$ret0@0@@6)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@14)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@33 j@@14)))))))))))))))))))) (and (=> (= (ControlFlow 0 131976) 132141) inline$$DiemSystem_validator_set_size_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 131976) 132028) inline$$DiemSystem_validator_set_size_$def_verify$0$anon11_Else_correct)))))))
(let ((anon0$1_correct@@10  (=> (forall (($inv_addr@@45 Int) ($inv_tv0@@13 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@45)) (let ((va@@255 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@45))))
(let ((l@@256 (|l#$ValueArray| va@@255)))
 (and (and (<= 0 l@@256) (<= l@@256 $MAX_U64)) (forall ((x@@255 Int) ) (!  (=> (or (< x@@255 0) (>= x@@255 l@@256)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@255) x@@255) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@255) x@@255))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@45))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@45))
)) (=> (and (forall (($inv_addr@@46 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46)) (let ((va@@256 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))))
(let ((l@@257 (|l#$ValueArray| va@@256)))
 (and (and (<= 0 l@@257) (<= l@@257 $MAX_U64)) (forall ((x@@256 Int) ) (!  (=> (or (< x@@256 0) (>= x@@256 l@@257)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@256) x@@256) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@256) x@@256))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators)) (let ((va@@257 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))))
(let ((l@@258 (|l#$ValueArray| va@@257)))
 (and (and (<= 0 l@@258) (<= l@@258 $MAX_U64)) (forall ((x@@257 Int) ) (!  (=> (or (< x@@257 0) (>= x@@257 l@@258)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@257) x@@257) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@257) x@@257))
))))))) (forall (($$0@@123 Int) ) (!  (=> (and (>= $$0@@123 0) (< $$0@@123 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123)) (let ((va@@258 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))))
(let ((l@@259 (|l#$ValueArray| va@@258)))
 (and (and (<= 0 l@@259) (<= l@@259 $MAX_U64)) (forall ((x@@258 Int) ) (!  (=> (or (< x@@258 0) (>= x@@258 l@@259)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@258) x@@258) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@258) x@@258))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config)) (let ((va@@259 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@260 (|l#$ValueArray| va@@259)))
 (and (and (<= 0 l@@260) (<= l@@260 $MAX_U64)) (forall ((x@@259 Int) ) (!  (=> (or (< x@@259 0) (>= x@@259 l@@260)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@259) x@@259) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@259) x@@259))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@260 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@261 (|l#$ValueArray| va@@260)))
 (and (and (<= 0 l@@261) (<= l@@261 $MAX_U64)) (forall ((x@@260 Int) ) (!  (=> (or (< x@@260 0) (>= x@@260 l@@261)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@260) x@@260) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@260) x@@260))
))))))) (forall (($$0@@124 Int) ) (!  (=> (and (>= $$0@@124 0) (< $$0@@124 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@124)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@124)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@124)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@124))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@261 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@262 (|l#$ValueArray| va@@261)))
 (and (and (<= 0 l@@262) (<= l@@262 $MAX_U64)) (forall ((x@@261 Int) ) (!  (=> (or (< x@@261 0) (>= x@@261 l@@262)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@261) x@@261) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@261) x@@261))
))))))) (forall (($$0@@125 Int) ) (!  (=> (and (>= $$0@@125 0) (< $$0@@125 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@125)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@125)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@125)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@125))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@262 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@263 (|l#$ValueArray| va@@262)))
 (and (and (<= 0 l@@263) (<= l@@263 $MAX_U64)) (forall ((x@@262 Int) ) (!  (=> (or (< x@@262 0) (>= x@@262 l@@263)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@262) x@@262) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@262) x@@262))
))))))) (forall (($$0@@126 Int) ) (!  (=> (and (>= $$0@@126 0) (< $$0@@126 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@126)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@126)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@126)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@126))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@123))
))) (and (forall (($$0@@127 Int) ) (!  (=> (and (>= $$0@@127 0) (< $$0@@127 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) $$0@@127))
)) (|b#$Boolean| ($Boolean (let (($range_1@@51 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@67 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@51)) $i_0@@67) (< $i_0@@67 (|i#$Integer| (|ub#$Range| $range_1@@51)))) (let ((i@@34 ($Integer $i_0@@67)))
(|b#$Boolean| ($Boolean (let (($range_3@@19 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2@@21 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3@@19)) $i_2@@21) (< $i_2@@21 (|i#$Integer| (|ub#$Range| $range_3@@19)))) (let ((j@@15 ($Integer $i_2@@21)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@34)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@15)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@34 j@@15)))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@46))
)) (|b#$Boolean| ($Boolean (forall ((config_address@@7 T@$Value) )  (=> ((_ is $Address) config_address@@7) (|b#$Boolean| ($Boolean (forall ((config_type@@7 T@$Value) )  (=> ((_ is $Type) config_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@7)) 1) (|a#$Address| config_address@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@7 ($Address 173345816)))))))))))))))) (=> (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@52 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@128 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@128)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@68 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@52)) $i_0@@68) (< $i_0@@68 (|i#$Integer| (|ub#$Range| $range_1@@52)))) (let ((i1@@17 ($Integer $i_0@@68)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@129 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@129)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@17)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@129 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@129)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@17)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@53 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@130 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@130)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@69 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@53)) $i_0@@69) (< $i_0@@69 (|i#$Integer| (|ub#$Range| $range_1@@53)))) (let ((i1@@18 ($Integer $i_0@@69)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@131 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@131)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@18)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (= (ControlFlow 0 132163) 131976))) inline$$DiemSystem_validator_set_size_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@10  (=> (= (ControlFlow 0 170615) 132163) anon0$1_correct@@10)))
anon0_correct@@10))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
