(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $DiemTransactionPublishingOption_DiemTransactionPublishingOption)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@0) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@0))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun dr_account () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory () T@$Memory)
(declare-fun $abort_code@5 () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@2 () T@$Memory)
(declare-fun script_allow_list () T@$Value)
(declare-fun module_publishing_allowed () T@$Value)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $abort_code@4 () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@1 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@1 () T@$Memory)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@0 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$struct@1 () T@$Value)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 81570) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 69369) (- 0 85537)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85558)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85587)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85604)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85619)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85629)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account)))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account)))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85655)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85670)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85691)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85720)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3) (and (=> (= (ControlFlow 0 69369) (- 0 85737)) (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))))) (=> (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (and (=> (= (ControlFlow 0 69369) (- 0 85928)) (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@5 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@5 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@5 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@5 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@5 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@5 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@5 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@5 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 69369) (- 0 86207)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account)))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account))))) (and (=> (= (ControlFlow 0 69369) (- 0 86235)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 69369) (- 0 86247)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 script_allow_list) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 script_allow_list) (+ len@@1 1)))) len@@0 module_publishing_allowed) (+ len@@0 1))))))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 script_allow_list) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 script_allow_list) (+ len@@1 1)))) len@@0 module_publishing_allowed) (+ len@@0 1)))))))) (and (=> (= (ControlFlow 0 69369) (- 0 86275)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (= (ControlFlow 0 69369) (- 0 86294)) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$Abort_correct  (=> (= $abort_code@5 $abort_code@4) (=> (and (and (= $DiemConfig_ModifyConfigCapability_$memory@2 $DiemConfig_ModifyConfigCapability_$memory@1) (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@1)) (and (= $abort_flag@3 true) (= (ControlFlow 0 69291) 69369))) anon0$2_correct))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon9_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory)) (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 69331) 69291))) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 69329) 69331)) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 69339) 69331) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon22_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 69323) 69339) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 69323) 69329) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon13_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory)) (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 69311) 69291))) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 69309) 69311)) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon13_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 69319) 69311) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon13_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon24_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 69303) 69319) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 69303) 69309) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon17_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory@0) (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory@0)) (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 69287) 69291))) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 69285) 69287)) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon17_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 69299) 69287) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon17_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon26_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 69279) 69299) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 69279) 69285) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@2) (= $abort_code@5 $abort_code@3)) (=> (and (and (= $DiemConfig_ModifyConfigCapability_$memory@2 $DiemConfig_ModifyConfigCapability_$memory@0) (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@0)) (and (= $abort_flag@3 $abort_flag@2) (= (ControlFlow 0 69275) 69369))) anon0$2_correct))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon24_Else$1_correct  (=> (= call0formal@$tv0@0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) (=> (and (= call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 ($ConstMemoryDomain true)) (= call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 69269) (- 0 84721)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 69269) (- 0 84741)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account)))) $abort_flag@2)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@2))) (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@2)) (and (=> $abort_flag@2 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@2 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@3 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@3 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@3 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 2))))))))) (and (and (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$struct@1)))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 69269) 69279) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 69269) 69275) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon26_Else_correct)))))))))))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 69255) 69269)) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon24_Else$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 69261) 69269) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon24_Else$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 69249) 69261) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 69249) 69255) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 69241) 69269)) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon24_Else$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon0_correct  (=> (and (and (and ((_ is $Vector) script_allow_list) (let ((va@@8 (|v#$Vector| script_allow_list)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0 0) (< inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| script_allow_list)))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0)) (let ((va@@9 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1 Int) ) (!  (=> (and (>= inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1 0) (< inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))
))) (and ((_ is $Boolean) module_publishing_allowed) (= inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 script_allow_list) 1 module_publishing_allowed) 2))))) (and (=> (= (ControlFlow 0 69233) 69249) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 69233) 69241) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon24_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 69267) 69233)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon22_Else_correct  (=> (not $abort_flag@0) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@1)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1)) (and (=> $abort_flag@1 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@1 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 68912) 69303) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 68912) 69267) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon24_Else_correct)))))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 68906) 69323) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 68906) 68912) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 68802) 68906)) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon6$3_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 69347) 68906) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon6$3_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 68794) 69347) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 68794) 68802) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon20_Then_correct  (and (=> (= (ControlFlow 0 69355) 69347) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 69355) 68802) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon21_Else_correct))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 68786) 69355) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 68786) 68794) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 69363) 69355) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 69363) 68794) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon20_Else_correct))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 68780) 69363) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 68780) 68786) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (and (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (forall (($inv_addr@@1 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))
))) (and (forall (($inv_addr@@2 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address T@$Value) )  (=> ((_ is $Address) config_address) (|b#$Boolean| ($Boolean (forall ((config_type T@$Value) )  (=> ((_ is $Type) config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type)) 1) (|a#$Address| config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address ($Address 173345816)))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 69367) 68780)))) inline$$DiemTransactionPublishingOption_initialize_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and ((_ is $Vector) script_allow_list) (let ((va@@14 (|v#$Vector| script_allow_list)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| script_allow_list)))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) $$0)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) $$0))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (forall (($$1 Int) ) (!  (=> (and (>= $$1 0) (< $$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) $$0))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) $$0))) $$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) $$0))) $$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) $$0))) $$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) $$0))) $$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| script_allow_list)) $$0))
))) (and ((_ is $Boolean) module_publishing_allowed) (= (ControlFlow 0 68170) 69367))) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 81570) 68170) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun dr_account@@0 () T@$Value)
(declare-fun $abort_flag@5 () Bool)
(declare-fun new_hash () T@$Value)
(declare-fun $DiemConfig_DisableReconfiguration_$memory () T@$Memory)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@2@@0 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0 () T@$Memory)
(declare-fun $abort_code@8 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1 () T@$Memory)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$Vector_contains$0$res@1 () T@$Value)
(declare-fun inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t14@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_Configuration_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$ta@0 () T@$TypeValue)
(declare-fun inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t9@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@1 () T@$TypeValue)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 86369) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 71927) (- 0 91386)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@5) (and (=> (= (ControlFlow 0 71927) (- 0 91407)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@5) (and (=> (= (ControlFlow 0 71927) (- 0 91436)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@5) (and (=> (= (ControlFlow 0 71927) (- 0 91453)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Vector_$length $IntegerType new_hash) ($Integer 32))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Vector_$length $IntegerType new_hash) ($Integer 32))))) $abort_flag@5) (and (=> (= (ControlFlow 0 71927) (- 0 91474)) (=> (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)))
(exists (($i_0 Int) )  (and (and (>= $i_0 0) (< $i_0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 new_hash))))))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)))
(exists (($i_0@@0 Int) )  (and (and (>= $i_0@@0 0) (< $i_0@@0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@16 new_hash))))))))) $abort_flag@5) (and (=> (= (ControlFlow 0 71927) (- 0 91490)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5) (and (=> (= (ControlFlow 0 71927) (- 0 91520)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@0))))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@0))))))) $abort_flag@5) (and (=> (= (ControlFlow 0 71927) (- 0 91553)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5) (and (=> (= (ControlFlow 0 71927) (- 0 91583)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@5) (and (=> (= (ControlFlow 0 71927) (- 0 91682)) (=> $abort_flag@5 (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Vector_$length $IntegerType new_hash) ($Integer 32)))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@2 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| addr@@2)))) $DiemConfig_DiemConfig_payload)))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)))
(exists (($i_0@@1 Int) )  (and (and (>= $i_0@@1 0) (< $i_0@@1 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@17 new_hash)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (=> (=> $abort_flag@5 (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Vector_$length $IntegerType new_hash) ($Integer 32)))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@2 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| addr@@2)))) $DiemConfig_DiemConfig_payload)))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)))
(exists (($i_0@@2 Int) )  (and (and (>= $i_0@@2 0) (< $i_0@@2 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@17 new_hash)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))) (=> (= (ControlFlow 0 71927) (- 0 91970)) (=> $abort_flag@5 (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Vector_$length $IntegerType new_hash) ($Integer 32))))) (= $abort_code@9 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)))
(exists (($i_0@@3 Int) )  (and (and (>= $i_0@@3 0) (< $i_0@@3 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((x@@18 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@18 new_hash))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@0))))))) (= $abort_code@9 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1)))))))))))))))))))))))))))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon65_Else_correct  (=> (and (not $abort_flag@4) (= $abort_flag@5 $abort_flag@4)) (=> (and (and (= $abort_code@9 $abort_code@6) (= $DiemConfig_DiemConfig_$memory@2@@0 $DiemConfig_DiemConfig_$memory@0@@0)) (and (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 71709) 71927))) anon0$2_correct@@0))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct  (=> (= $abort_flag@5 true) (=> (and (and (= $abort_code@9 $abort_code@8) (= $DiemConfig_DiemConfig_$memory@2@@0 $DiemConfig_DiemConfig_$memory@1@@0)) (and (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@1) (= (ControlFlow 0 70844) 71927))) anon0$2_correct@@0))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon7_correct  (=> (and (and (= $abort_code@8 $abort_code@1@@0) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 71897) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 71895) 71897)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon7_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 71905) 71897) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon7_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon47_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 71889) 71905) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 71889) 71895) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon11_correct  (=> (and (and (= $abort_code@8 $abort_code@1@@0) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 71877) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 71875) 71877)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon11_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 71885) 71877) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon11_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon49_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 71869) 71885) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 71869) 71875) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon15_correct  (=> (and (and (= $abort_code@8 $abort_code@2@@0) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 71857) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 71855) 71857)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon15_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 71865) 71857) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon15_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon51_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 71849) 71865) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 71849) 71855) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon23_correct  (=> (and (and (= $abort_code@8 $abort_code@3@@0) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 71837) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 71835) 71837)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon23_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon56_Then_correct  (=> (= (ControlFlow 0 71845) 71837) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon23_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon55_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 71829) 71845) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 71829) 71835) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon27_correct  (=> (and (and (= $abort_code@8 $abort_code@3@@0) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 71817) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon58_Else_correct  (=> (and (not true) (= (ControlFlow 0 71815) 71817)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon27_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon58_Then_correct  (=> (= (ControlFlow 0 71825) 71817) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon27_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon57_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 71809) 71825) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 71809) 71815) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon33_correct  (=> (and (and (= $abort_code@8 $abort_code@5@@0) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 71797) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 71795) 71797)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon33_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon61_Then_correct  (=> (= (ControlFlow 0 71805) 71797) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon33_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon60_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 71789) 71805) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 71789) 71795) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon36_correct  (=> (and (and (= $abort_code@8 $abort_code@7) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 71777) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 71775) 71777)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon36_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 71785) 71777) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon36_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon60_Else_correct  (=> (and (not $abort_flag@3@@0) (= $abort_code@7 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 71769) 71785) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 71769) 71775) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon59_Then_correct  (=> (|b#$Boolean| inline$$Vector_contains$0$res@1) (=> (and (and (and (= inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t14@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0)) (and (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 71759) 71789) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 71759) 71769) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon60_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon39_correct  (=> (and (and (= $abort_code@8 $abort_code@3@@0) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 71741) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 71739) 71741)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon39_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 71749) 71741) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon39_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon63_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 71733) 71749) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 71733) 71739) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon43_correct  (=> (and (and (= $abort_code@8 $abort_code@6) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory@0@@0)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 71721) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 71719) 71721)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon43_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 71729) 71721) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon43_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon65_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 71713) 71729) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 71713) 71719) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon63_Else$3_correct  (=> (and (= call0formal@$tv0@0@@0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) (= call3formal@$DiemConfig_Configuration_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 71703) (- 0 90479)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| dr_account@@0))))))) $abort_flag@4) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@4) (=> $abort_flag@4 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| dr_account@@0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@4 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| dr_account@@0))))))) (= $abort_code@6 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@6 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)) |inline$$WritebackToValue$0$vdst'@2|)))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 71703) 71713) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 71703) 71709) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon65_Else_correct)))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| call3formal@$ret0@0@@0) (= (ControlFlow 0 71669) 71703)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon63_Else$3_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 call3formal@$ret0@0@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 71695) 71703))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon63_Else$3_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1)) (and (=> (= (ControlFlow 0 71514) 71695) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 71514) 71669) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 71570) 71695) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 71570) 71669) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 71478) 71570) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 71478) 71514) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) |inline$$Vector_push_back$0$v'@1|)) (= (ControlFlow 0 71335) 71478)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon63_Else_correct  (=> (and (not $abort_flag@2@@0) (= (ControlFlow 0 71341) 71335)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) len@@2 new_hash) (+ len@@2 1)))))) (and (=> (= (ControlFlow 0 71270) 71733) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 71270) 71341) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct  (=> (and (= inline$$Vector_push_back$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 71258) 71270)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 71205) 71258)) inline$$Vector_push_back$0$Entry_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) (= (ControlFlow 0 71167) 71205))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 2) $EmptyPath call3formal@$ret0@0@@0)) (= (ControlFlow 0 71043) 71167)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon59_Else_correct  (=> (and (not (|b#$Boolean| inline$$Vector_contains$0$res@1)) (= (ControlFlow 0 71049) 71043)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon57_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 70987) 71759) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 70987) 71049) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Vector_contains$0$anon0_correct  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1) (= inline$$Vector_contains$0$res@1 ($Boolean (exists ((i@@10 Int) )  (and (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)) i@@10) new_hash)))))) (and (=> (= (ControlFlow 0 70973) 71809) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 70973) 70987) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Vector_contains$0$Entry_correct  (=> (and (= inline$$Vector_contains$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 70959) 70973)) inline$$Vector_contains$0$anon0_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)) (= (ControlFlow 0 70904) 70959)) inline$$Vector_contains$0$Entry_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon55_Else_correct  (=> (and (not $abort_flag@2@@0) (= (ControlFlow 0 70910) 70904)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon53_Then_correct  (=> (and (|b#$Boolean| inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t9@1) (= call0formal@$tv0@0@@1 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@1) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@0) (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@1) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@2@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@1) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 (let ((addr@@5 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@1) 1) (|a#$Address| addr@@5)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 70858) 71829) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 70858) 70910) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon55_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon20_correct  (=> (and (and (= $abort_code@8 $abort_code@4@@0) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 70840) 70844))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 70838) 70840)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon20_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 70852) 70840) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon20_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon53_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t9@1)) (= $abort_code@4@@0 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 70832) 70852) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 70832) 70838) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon51_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 70820) 70858) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 70820) 70832) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (= inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t8@1 ($Integer 32)) (= inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t9@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1 inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t8@1)))) (=> (and (and (and (= inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$$t10@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0)) (and (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 70814) 71849) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 70814) 70820) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon51_Else_correct)))))))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) new_hash) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| new_hash))))) (and (=> (= (ControlFlow 0 70784) 71869) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 70784) 70814) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $IntegerType) (= (ControlFlow 0 70772) 70784)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon47_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 70790) 70772)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon4$2_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@0@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@0@@0)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@0@@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@0@@0)) (and (=> $abort_flag@0@@0 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))))) (=> $abort_flag@0@@0 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 70729) 71889) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 70729) 70790) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 70659) 70729)) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 71913) 70729) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 70651) 71913) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 70651) 70659) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 71921) 71913) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 71921) 70659) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon46_Else_correct))))
(let ((inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 70645) 71921) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 70645) 70651) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon45_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))
))) (and (forall (($inv_addr@@5 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5)) (let ((va@@18 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))
)) (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@19 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@24))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@0))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))
)))) (=> (and (and (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@22 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (forall (($inv_addr@@8 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@8)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@8))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@8))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@8))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@8))
))) (and (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@28))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@1)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@1))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@29))
)))))) (forall (($$1@@0 Int) ) (!  (=> (and (>= $$1@@0 0) (< $$1@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@1))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@1))) $$1@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@1))) $$1@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@1))) $$1@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@1))) $$1@@0))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@1))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@9))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address@@0 T@$Value) )  (=> ((_ is $Address) config_address@@0) (|b#$Boolean| ($Boolean (forall ((config_type@@0 T@$Value) )  (=> ((_ is $Type) config_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@0)) 1) (|a#$Address| config_address@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@0 ($Address 173345816)))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 71925) 70645)))) inline$$DiemTransactionPublishingOption_add_to_script_allow_list_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> ((_ is $Address) dr_account@@0) (=> (and (and (and ((_ is $Vector) new_hash) (let ((va@@27 (|v#$Vector| new_hash)))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@30))
)))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| new_hash)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_hash)) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_hash)) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_hash)) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_hash)) $$0@@2))
))) (= (ControlFlow 0 69580) 71925)) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 86369) 69580) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun inline$$Roles_has_diem_root_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_diem_root_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1 () T@$Value)
(declare-fun account () T@$Value)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun call0formal@$tv0@0@@2 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 92362) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 74195) (- 0 94081)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@7)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@7) (and (=> (= (ControlFlow 0 74195) (- 0 94124)) (=> $abort_flag@7 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))))) (=> (=> $abort_flag@7 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (and (=> (= (ControlFlow 0 74195) (- 0 94167)) (=> $abort_flag@7 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@7 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (=> (= (ControlFlow 0 74195) (- 0 94221)) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))))))))))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$Abort_correct  (=> (and (and (= inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$$ret0@1 $Error) (= $abort_flag@7 true)) (and (= $abort_code@9@@0 $abort_code@8@@0) (= (ControlFlow 0 74099) 74195))) anon0$2_correct@@1)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon5_correct  (=> (and (= $abort_code@8@@0 $abort_code@1@@1) (= (ControlFlow 0 74171) 74099)) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 74169) 74171)) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon5_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 74179) 74171) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon5_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon16_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 74163) 74179) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 74163) 74169) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon20_Then_correct  (=> $abort_flag@5@@0 (=> (and (= $abort_code@8@@0 $abort_code@6@@0) (= (ControlFlow 0 74093) 74099)) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$Abort_correct))))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon14_correct  (=> (= $abort_flag@7 $abort_flag@6) (=> (and (= $abort_code@9@@0 $abort_code@7@@0) (= (ControlFlow 0 74081) 74195)) anon0$2_correct@@1))))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 74079) 74081)) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon14_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 74089) 74081) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon14_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@6 $abort_flag@0@@1) (= $abort_code@7@@0 $abort_code@1@@1)) (and (=> (= (ControlFlow 0 74151) 74089) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 74151) 74079) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 74149) 74151)) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon10_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 74159) 74151) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon10_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon18_Then_correct  (=> (and (|b#$Boolean| inline$$GetFieldFromValue$0$dst@1@@0) (= inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 74141) 74159) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 74141) 74149) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon20_Else_correct  (=> (not $abort_flag@5@@0) (=> (and (= $abort_flag@6 $abort_flag@5@@0) (= $abort_code@7@@0 $abort_code@6@@0)) (and (=> (= (ControlFlow 0 74069) 74089) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 74069) 74079) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon6_correct  (=> (= $abort_flag@5@@0 $abort_flag@4@@0) (and (=> (= (ControlFlow 0 74023) 74093) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 74023) 74069) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 74021) 74023)) inline$$Roles_has_diem_root_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 74031) 74023) inline$$Roles_has_diem_root_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 74015) 74031) inline$$Roles_has_diem_root_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 74015) 74021) inline$$Roles_has_diem_root_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon8_Then_correct  (=> $abort_flag@4@@0 (=> (and (= inline$$Roles_has_diem_root_role_$def$0$$ret0@1 $Error) (= $abort_flag@5@@0 true)) (and (=> (= (ControlFlow 0 74039) 74093) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 74039) 74069) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$Abort_correct  (=> (= inline$$Roles_has_role_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@4@@0 true) (= $abort_code@6@@0 $abort_code@5@@1)) (and (=> (= (ControlFlow 0 73947) 74039) inline$$Roles_has_diem_root_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 73947) 74015) inline$$Roles_has_diem_root_role_$def$0$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$anon7_correct  (=> (and (= $abort_code@5@@1 $abort_code@2@@1) (= (ControlFlow 0 73967) 73947)) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 73965) 73967)) inline$$Roles_has_role_$def$0$anon7_correct)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 73975) 73967) inline$$Roles_has_role_$def$0$anon7_correct)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 73959) 73975) inline$$Roles_has_role_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 73959) 73965) inline$$Roles_has_role_$def$0$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon13_correct  (=> (and (= $abort_code@5@@1 $abort_code@3@@1) (= (ControlFlow 0 73941) 73947)) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 73939) 73941)) inline$$Roles_has_role_$def$0$anon13_correct)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 73955) 73941) inline$$Roles_has_role_$def$0$anon13_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 73933) 73955) inline$$Roles_has_role_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 73933) 73939) inline$$Roles_has_role_$def$0$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct  (=> (and (= $abort_flag@4@@0 $abort_flag@3@@1) (= $abort_code@6@@0 $abort_code@4@@1)) (and (=> (= (ControlFlow 0 73654) 74039) inline$$Roles_has_diem_root_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 73654) 74015) inline$$Roles_has_diem_root_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 73652) 73654)) inline$$Roles_has_role_$def$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 73662) 73654) inline$$Roles_has_role_$def$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct  (=> (and (= $abort_code@4@@1 $abort_code@3@@1) (= $abort_flag@3@@1 $abort_flag@2@@1)) (and (=> (= (ControlFlow 0 73921) 73662) inline$$Roles_has_role_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 73921) 73652) inline$$Roles_has_role_$def$0$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 73919) 73921)) inline$$Roles_has_role_$def$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 73929) 73921) inline$$Roles_has_role_$def$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$1$dst@1 inline$$Roles_has_diem_root_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 73913) 73929) inline$$Roles_has_role_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 73913) 73919) inline$$Roles_has_role_$def$0$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst)) $Roles_RoleId_role_id)) (= (ControlFlow 0 73897) 73913)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 73903) 73897)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@2@@1 true) (= $abort_code@3@@1 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 73843) 73933) inline$$Roles_has_role_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 73843) 73903) inline$$Roles_has_role_$def$0$anon26_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 73841) 73843)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@2)))) (and (= $abort_flag@2@@1 $abort_flag@1@@1) (= $abort_code@3@@1 $abort_code@2@@1))) (and (=> (= (ControlFlow 0 73789) 73933) inline$$Roles_has_role_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 73789) 73903) inline$$Roles_has_role_$def$0$anon26_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 73771) 73841) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 73771) 73789) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 73765) (- 0 93712)) true) (=> (= (ControlFlow 0 73765) 73771) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1) (= (ControlFlow 0 73849) 73765)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct  (=> (and (= $abort_code@4@@1 $abort_code@2@@1) (= $abort_flag@3@@1 $abort_flag@1@@1)) (and (=> (= (ControlFlow 0 73642) 73662) inline$$Roles_has_role_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 73642) 73652) inline$$Roles_has_role_$def$0$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 73640) 73642)) inline$$Roles_has_role_$def$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 73670) 73642) inline$$Roles_has_role_$def$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1)) (= inline$$Roles_has_role_$def$0$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 73632) 73670) inline$$Roles_has_role_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 73632) 73640) inline$$Roles_has_role_$def$0$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct  (=> (and (not $abort_flag@1@@1) (= inline$$Roles_has_role_$def$0$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@2))))) (and (=> (= (ControlFlow 0 73588) 73849) inline$$Roles_has_role_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 73588) 73632) inline$$Roles_has_role_$def$0$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1) (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 account)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 73574) 73959) inline$$Roles_has_role_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 73574) 73588) inline$$Roles_has_role_$def$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 73504) 73574)) inline$$Roles_has_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 73983) 73574) inline$$Roles_has_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 73496) 73983) inline$$Roles_has_role_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 73496) 73504) inline$$Roles_has_role_$def$0$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 73991) 73983) inline$$Roles_has_role_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 73991) 73504) inline$$Roles_has_role_$def$0$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 73490) 73991) inline$$Roles_has_role_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 73490) 73496) inline$$Roles_has_role_$def$0$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$0$anon0_correct  (=> ((_ is $Address) account) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_diem_root_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_diem_root_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_diem_root_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 73997) 73490)) inline$$Roles_has_role_$def$0$anon0_correct))))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_diem_root_role_$def$0$$t2@1 ($Integer 0)) (= (ControlFlow 0 74005) 73997)) inline$$Roles_has_role$0$anon0_correct)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 73017) 74005)) inline$$Roles_has_diem_root_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 74047) 74005) inline$$Roles_has_diem_root_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon0_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 73011) 74047) inline$$Roles_has_diem_root_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 73011) 73017) inline$$Roles_has_diem_root_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_diem_root_role_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) account) (= (ControlFlow 0 74053) 73011)) inline$$Roles_has_diem_root_role_$def$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon18_Else_correct  (=> (and (not (|b#$Boolean| inline$$GetFieldFromValue$0$dst@1@@0)) (= (ControlFlow 0 74061) 74053)) inline$$Roles_has_diem_root_role_$direct_inter$0$anon0_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed)) (and (=> (= (ControlFlow 0 72803) 74141) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 72803) 74061) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 72809) 72803)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon2$1_correct  (=> (= call0formal@$tv0@0@@2 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@0@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 (let ((addr@@6 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| addr@@6)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 72757) 74163) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 72757) 72809) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 72721) 72757)) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 74187) 72757) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 72715) 74187) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 72715) 72721) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@28 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@10))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@10))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@10))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@10))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@10))
)) (forall (($inv_addr@@11 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11)) (let ((va@@29 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))
))) (=> (and (and (forall (($inv_addr@@12 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@34))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@3)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@3))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@35))
)))))) (forall (($$1@@1 Int) ) (!  (=> (and (>= $$1@@1 0) (< $$1@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@3))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@3))) $$1@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@3))) $$1@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@3))) $$1@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@3))) $$1@@1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@3))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@12))
)) (|b#$Boolean| ($Boolean (forall ((config_address@@1 T@$Value) )  (=> ((_ is $Address) config_address@@1) (|b#$Boolean| ($Boolean (forall ((config_type@@1 T@$Value) )  (=> ((_ is $Type) config_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@1)) 1) (|a#$Address| config_address@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@1 ($Address 173345816)))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 74193) 72715))) inline$$DiemTransactionPublishingOption_is_module_allowed_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) account) (= (ControlFlow 0 72270) 74193)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 92362) 72270) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun $abort_code@9@@1 () Int)
(declare-fun inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun |inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$tmp#$3@1| () T@$Value)
(declare-fun inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$$t11@1 () T@$Value)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun inline$$Roles_has_diem_root_role_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1@@0| () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_diem_root_role_$def$0$$t2@1@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1@@0 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1@@0 () T@$Value)
(declare-fun account@@0 () T@$Value)
(declare-fun inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Vector_is_empty$0$b@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$res@1@@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@0 () T@$Value)
(declare-fun hash () T@$Value)
(declare-fun inline$$Vector_contains$0$ta@0@@0 () T@$TypeValue)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Vector_is_empty$0$ta@0 () T@$TypeValue)
(declare-fun call0formal@$tv0@0@@3 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 94292) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 77029) (- 0 96313)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 77029) (- 0 96356)) (=> $abort_flag@7@@0 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))))) (=> (=> $abort_flag@7@@0 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (and (=> (= (ControlFlow 0 77029) (- 0 96399)) (=> $abort_flag@7@@0 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9@@1 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@7@@0 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9@@1 (|i#$Integer| ($Integer 5))))) (=> (= (ControlFlow 0 77029) (- 0 96453)) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))))))))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$Abort_correct  (=> (and (and (= inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$$ret0@1 $Error) (= $abort_flag@7@@0 true)) (and (= $abort_code@9@@1 $abort_code@8@@1) (= (ControlFlow 0 76825) 77029))) anon0$2_correct@@2)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon7_correct  (=> (and (= $abort_code@8@@1 $abort_code@1@@2) (= (ControlFlow 0 76997) 76825)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 76995) 76997)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon7_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 77005) 76997) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon7_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon31_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 76989) 77005) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 76989) 76995) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon11_correct  (=> (and (= $abort_code@8@@1 $abort_code@1@@2) (= (ControlFlow 0 76977) 76825)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 76975) 76977)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon11_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 76985) 76977) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon11_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon33_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 76969) 76985) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 76969) 76975) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon19_correct  (=> (and (= $abort_code@8@@1 $abort_code@1@@2) (= (ControlFlow 0 76897) 76825)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 76895) 76897)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon19_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 76905) 76897) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon19_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon37_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 76889) 76905) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 76889) 76895) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon41_Then_correct  (=> $abort_flag@5@@1 (=> (and (= $abort_code@8@@1 $abort_code@6@@1) (= (ControlFlow 0 76819) 76825)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$Abort_correct))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon28_correct  (=> (= $abort_flag@7@@0 $abort_flag@6@@0) (=> (and (= $abort_code@9@@1 $abort_code@7@@1) (= (ControlFlow 0 76807) 77029)) anon0$2_correct@@2))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 76805) 76807)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon28_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 76815) 76807) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon28_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon24_correct  (=> (and (= $abort_flag@6@@0 $abort_flag@0@@2) (= $abort_code@7@@1 $abort_code@1@@2)) (and (=> (= (ControlFlow 0 76877) 76815) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 76877) 76805) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 76875) 76877)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon24_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 76885) 76877) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon24_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon39_Then_correct  (=> (and (|b#$Boolean| |inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$tmp#$3@1|) (= inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$$t11@1 ($Boolean true))) (and (=> (= (ControlFlow 0 76867) 76885) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 76867) 76875) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon41_Else_correct  (=> (not $abort_flag@5@@1) (=> (and (= $abort_flag@6@@0 $abort_flag@5@@1) (= $abort_code@7@@1 $abort_code@6@@1)) (and (=> (= (ControlFlow 0 76795) 76815) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 76795) 76805) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon6_correct@@0  (=> (= $abort_flag@5@@1 $abort_flag@4@@1) (and (=> (= (ControlFlow 0 76749) 76819) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 76749) 76795) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon9_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 76747) 76749)) inline$$Roles_has_diem_root_role_$def$0$anon6_correct@@0)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon9_Then_correct@@0  (=> (= (ControlFlow 0 76757) 76749) inline$$Roles_has_diem_root_role_$def$0$anon6_correct@@0)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon8_Else_correct@@0  (=> (not $abort_flag@4@@1) (and (=> (= (ControlFlow 0 76741) 76757) inline$$Roles_has_diem_root_role_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 76741) 76747) inline$$Roles_has_diem_root_role_$def$0$anon9_Else_correct@@0)))))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon8_Then_correct@@0  (=> $abort_flag@4@@1 (=> (and (= inline$$Roles_has_diem_root_role_$def$0$$ret0@1@@0 $Error) (= $abort_flag@5@@1 true)) (and (=> (= (ControlFlow 0 76765) 76819) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 76765) 76795) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$Abort_correct@@0  (=> (= inline$$Roles_has_role_$def$0$$ret0@1@@0 $Error) (=> (and (= $abort_flag@4@@1 true) (= $abort_code@6@@1 $abort_code@5@@2)) (and (=> (= (ControlFlow 0 76673) 76765) inline$$Roles_has_diem_root_role_$def$0$anon8_Then_correct@@0) (=> (= (ControlFlow 0 76673) 76741) inline$$Roles_has_diem_root_role_$def$0$anon8_Else_correct@@0))))))
(let ((inline$$Roles_has_role_$def$0$anon7_correct@@0  (=> (and (= $abort_code@5@@2 $abort_code@2@@2) (= (ControlFlow 0 76693) 76673)) inline$$Roles_has_role_$def$0$Abort_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 76691) 76693)) inline$$Roles_has_role_$def$0$anon7_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct@@0  (=> (= (ControlFlow 0 76701) 76693) inline$$Roles_has_role_$def$0$anon7_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct@@0  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 76685) 76701) inline$$Roles_has_role_$def$0$anon24_Then_correct@@0) (=> (= (ControlFlow 0 76685) 76691) inline$$Roles_has_role_$def$0$anon24_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon13_correct@@0  (=> (and (= $abort_code@5@@2 $abort_code@3@@2) (= (ControlFlow 0 76667) 76673)) inline$$Roles_has_role_$def$0$Abort_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 76665) 76667)) inline$$Roles_has_role_$def$0$anon13_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct@@0  (=> (= (ControlFlow 0 76681) 76667) inline$$Roles_has_role_$def$0$anon13_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct@@0  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 76659) 76681) inline$$Roles_has_role_$def$0$anon27_Then_correct@@0) (=> (= (ControlFlow 0 76659) 76665) inline$$Roles_has_role_$def$0$anon27_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct@@0  (=> (and (= $abort_flag@4@@1 $abort_flag@3@@2) (= $abort_code@6@@1 $abort_code@4@@2)) (and (=> (= (ControlFlow 0 76380) 76765) inline$$Roles_has_diem_root_role_$def$0$anon8_Then_correct@@0) (=> (= (ControlFlow 0 76380) 76741) inline$$Roles_has_diem_root_role_$def$0$anon8_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 76378) 76380)) inline$$Roles_has_role_$def$0$anon20_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct@@0  (=> (= (ControlFlow 0 76388) 76380) inline$$Roles_has_role_$def$0$anon20_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct@@0  (=> (and (= $abort_code@4@@2 $abort_code@3@@2) (= $abort_flag@3@@2 $abort_flag@2@@2)) (and (=> (= (ControlFlow 0 76647) 76388) inline$$Roles_has_role_$def$0$anon30_Then_correct@@0) (=> (= (ControlFlow 0 76647) 76378) inline$$Roles_has_role_$def$0$anon30_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 76645) 76647)) inline$$Roles_has_role_$def$0$anon16_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct@@0  (=> (= (ControlFlow 0 76655) 76647) inline$$Roles_has_role_$def$0$anon16_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@0  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1@@0| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$2$dst@1 inline$$Roles_has_diem_root_role_$def$0$$t2@1@@0))) (and (=> (= (ControlFlow 0 76639) 76655) inline$$Roles_has_role_$def$0$anon28_Then_correct@@0) (=> (= (ControlFlow 0 76639) 76645) inline$$Roles_has_role_$def$0$anon28_Else_correct@@0)))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (and (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@0)) $Roles_RoleId_role_id)) (= (ControlFlow 0 76623) 76639)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct@@0  (=> (and (not $abort_flag@2@@2) (= (ControlFlow 0 76629) 76623)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@2@@2 true) (= $abort_code@3@@2 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 76569) 76659) inline$$Roles_has_role_$def$0$anon26_Then_correct@@0) (=> (= (ControlFlow 0 76569) 76629) inline$$Roles_has_role_$def$0$anon26_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 76567) 76569)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0) (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4)))) (and (= $abort_flag@2@@2 $abort_flag@1@@2) (= $abort_code@3@@2 $abort_code@2@@2))) (and (=> (= (ControlFlow 0 76515) 76659) inline$$Roles_has_role_$def$0$anon26_Then_correct@@0) (=> (= (ControlFlow 0 76515) 76629) inline$$Roles_has_role_$def$0$anon26_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| call3formal@$ret0@0@@4)) (and (=> (= (ControlFlow 0 76497) 76567) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 76497) 76515) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 76491) (- 0 95927)) true) (=> (= (ControlFlow 0 76491) 76497) inline$$GetGlobal$0$anon0_correct@@0))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@0) (= (ControlFlow 0 76575) 76491)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct@@0  (=> (and (= $abort_code@4@@2 $abort_code@2@@2) (= $abort_flag@3@@2 $abort_flag@1@@2)) (and (=> (= (ControlFlow 0 76368) 76388) inline$$Roles_has_role_$def$0$anon30_Then_correct@@0) (=> (= (ControlFlow 0 76368) 76378) inline$$Roles_has_role_$def$0$anon30_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 76366) 76368)) inline$$Roles_has_role_$def$0$anon18_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct@@0  (=> (= (ControlFlow 0 76396) 76368) inline$$Roles_has_role_$def$0$anon18_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@0)) (= inline$$Roles_has_role_$def$0$$t9@1@@0 ($Boolean false))) (and (=> (= (ControlFlow 0 76358) 76396) inline$$Roles_has_role_$def$0$anon29_Then_correct@@0) (=> (= (ControlFlow 0 76358) 76366) inline$$Roles_has_role_$def$0$anon29_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct@@0  (=> (and (not $abort_flag@1@@2) (= inline$$Roles_has_role_$def$0$$t6@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4))))) (and (=> (= (ControlFlow 0 76314) 76575) inline$$Roles_has_role_$def$0$anon25_Then_correct@@0) (=> (= (ControlFlow 0 76314) 76358) inline$$Roles_has_role_$def$0$anon25_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct@@0  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@2) (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 76300) 76685) inline$$Roles_has_role_$def$0$anon23_Then_correct@@0) (=> (= (ControlFlow 0 76300) 76314) inline$$Roles_has_role_$def$0$anon23_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 76230) 76300)) inline$$Roles_has_role_$def$0$anon4$2_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct@@0  (=> (= (ControlFlow 0 76709) 76300) inline$$Roles_has_role_$def$0$anon4$2_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 76222) 76709) inline$$Roles_has_role_$def$0$anon22_Then_correct@@0) (=> (= (ControlFlow 0 76222) 76230) inline$$Roles_has_role_$def$0$anon22_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct@@0  (and (=> (= (ControlFlow 0 76717) 76709) inline$$Roles_has_role_$def$0$anon22_Then_correct@@0) (=> (= (ControlFlow 0 76717) 76230) inline$$Roles_has_role_$def$0$anon22_Else_correct@@0))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct@@0  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 76216) 76717) inline$$Roles_has_role_$def$0$anon21_Then_correct@@0) (=> (= (ControlFlow 0 76216) 76222) inline$$Roles_has_role_$def$0$anon21_Else_correct@@0)))))
(let ((inline$$Roles_has_role$0$anon0_correct@@0  (=> ((_ is $Address) account@@0) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_diem_root_role_$def$0$$t2@1@@0) (>= (|i#$Integer| inline$$Roles_has_diem_root_role_$def$0$$t2@1@@0) 0)) (<= (|i#$Integer| inline$$Roles_has_diem_root_role_$def$0$$t2@1@@0) $MAX_U64)) (= (ControlFlow 0 76723) 76216)) inline$$Roles_has_role_$def$0$anon0_correct@@0))))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon2$1_correct@@0  (=> (and (= inline$$Roles_has_diem_root_role_$def$0$$t2@1@@0 ($Integer 0)) (= (ControlFlow 0 76731) 76723)) inline$$Roles_has_role$0$anon0_correct@@0)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon7_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 75743) 76731)) inline$$Roles_has_diem_root_role_$def$0$anon2$1_correct@@0)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon7_Then_correct@@0  (=> (= (ControlFlow 0 76773) 76731) inline$$Roles_has_diem_root_role_$def$0$anon2$1_correct@@0)))
(let ((inline$$Roles_has_diem_root_role_$def$0$anon0_correct@@0  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 75737) 76773) inline$$Roles_has_diem_root_role_$def$0$anon7_Then_correct@@0) (=> (= (ControlFlow 0 75737) 75743) inline$$Roles_has_diem_root_role_$def$0$anon7_Else_correct@@0)))))
(let ((inline$$Roles_has_diem_root_role_$direct_inter$0$anon0_correct@@0  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 76779) 75737)) inline$$Roles_has_diem_root_role_$def$0$anon0_correct@@0)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| |inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$tmp#$3@1|)) (= (ControlFlow 0 76787) 76779)) inline$$Roles_has_diem_root_role_$direct_inter$0$anon0_correct@@0)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon16_correct  (=> (= |inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$tmp#$3@1| inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$$t9@1) (and (=> (= (ControlFlow 0 76957) 76867) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 76957) 76787) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 76955) 76957)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon16_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 76965) 76957) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon16_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon35_Then_correct  (=> (and (|b#$Boolean| inline$$Vector_is_empty$0$b@1) (= inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$$t9@1 ($Boolean true))) (and (=> (= (ControlFlow 0 76947) 76965) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 76947) 76955) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon37_Else_correct  (=> (and (not $abort_flag@0@@2) (= |inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$tmp#$3@1| inline$$Vector_contains$0$res@1@@0)) (and (=> (= (ControlFlow 0 75535) 76867) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 75535) 76787) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Vector_contains$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$1$dst@1@@0) (= inline$$Vector_contains$0$res@1@@0 ($Boolean (exists ((i@@11 Int) )  (and (and (<= 0 i@@11) (< i@@11 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1@@0)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1@@0)) i@@11) hash)))))) (and (=> (= (ControlFlow 0 75521) 76889) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 75521) 75535) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Vector_contains$0$Entry_correct@@0  (=> (and (= inline$$Vector_contains$0$ta@0@@0 ($VectorType $IntegerType)) (= (ControlFlow 0 75507) 75521)) inline$$Vector_contains$0$anon0_correct@@0)))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$1$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)) (= (ControlFlow 0 75452) 75507)) inline$$Vector_contains$0$Entry_correct@@0)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon35_Else_correct  (=> (and (not (|b#$Boolean| inline$$Vector_is_empty$0$b@1)) (= (ControlFlow 0 75458) 75452)) inline$$GetFieldFromValue$1$anon0_correct@@0)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon33_Else_correct  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 75404) 76947) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 75404) 75458) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Vector_is_empty$0$anon0_correct  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1@@1) (= inline$$Vector_is_empty$0$b@1 ($Boolean (= (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@1)) 0)))) (and (=> (= (ControlFlow 0 75390) 76969) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 75390) 75404) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Vector_is_empty$0$Entry_correct  (=> (and (= inline$$Vector_is_empty$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 75374) 75390)) inline$$Vector_is_empty$0$anon0_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)) (= (ControlFlow 0 75323) 75374)) inline$$Vector_is_empty$0$Entry_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon31_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 75329) 75323)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon4$2_correct  (=> (= call0formal@$tv0@0@@3 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@2) (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@0@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 (let ((addr@@7 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| addr@@7)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 75277) 76989) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 75277) 75329) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 75207) 75277)) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 77013) 75277) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 75199) 77013) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 75199) 75207) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 77021) 77013) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 77021) 75207) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon30_Else_correct))))
(let ((inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 75193) 77021) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 75193) 75199) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (forall (($inv_addr@@13 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@13)) (let ((va@@33 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@13))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@13))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@13))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@13))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@13))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@13))
)) (forall (($inv_addr@@14 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14)) (let ((va@@34 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@14))
))) (=> (and (and (forall (($inv_addr@@15 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@39))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@4)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@4))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@40))
)))))) (forall (($$1@@2 Int) ) (!  (=> (and (>= $$1@@2 0) (< $$1@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@4))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@4))) $$1@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@4))) $$1@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@4))) $$1@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@4))) $$1@@2))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) $$0@@4))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTransactionPublishingOption_DiemTransactionPublishingOption_$memory) $EmptyTypeValueArray $inv_addr@@15))
)) (|b#$Boolean| ($Boolean (forall ((config_address@@2 T@$Value) )  (=> ((_ is $Address) config_address@@2) (|b#$Boolean| ($Boolean (forall ((config_type@@2 T@$Value) )  (=> ((_ is $Type) config_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@2)) 1) (|a#$Address| config_address@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@2 ($Address 173345816)))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 77027) 75193))) inline$$DiemTransactionPublishingOption_is_script_allowed_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> ((_ is $Address) account@@0) (=> (and (and (and ((_ is $Vector) hash) (let ((va@@38 (|v#$Vector| hash)))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@41))
)))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| hash)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| hash)) $$0@@5))
))) (= (ControlFlow 0 74541) 77027)) anon0$1_correct@@2))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 94292) 74541) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun dr_account@@1 () T@$Value)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun $DiemConfig_Configuration_$memory@2@@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1@@0 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@2@@1 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@1 () T@$Memory)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun call0formal@$tv0@0@@4 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun open_module () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun call0formal@$tv0@0@@5 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 96523) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 78848) (- 0 100607)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@3@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@3@@3) (and (=> (= (ControlFlow 0 78848) (- 0 100628)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3@@3) (and (=> (= (ControlFlow 0 78848) (- 0 100657)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@3@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@3@@3) (and (=> (= (ControlFlow 0 78848) (- 0 100674)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@3) (and (=> (= (ControlFlow 0 78848) (- 0 100704)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@1))))))) $abort_flag@3@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@1))))))) $abort_flag@3@@3) (and (=> (= (ControlFlow 0 78848) (- 0 100737)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@3) (and (=> (= (ControlFlow 0 78848) (- 0 100767)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@3@@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@3@@3) (and (=> (= (ControlFlow 0 78848) (- 0 100866)) (=> $abort_flag@3@@3 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (=> (=> $abort_flag@3@@3 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))) (=> (= (ControlFlow 0 78848) (- 0 101119)) (=> $abort_flag@3@@3 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@5@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@5@@3 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@5@@3 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@3 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@1))))))) (= $abort_code@5@@3 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@3 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@5@@3 (|i#$Integer| ($Integer 1)))))))))))))))))))))))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$Abort_correct  (=> (= $abort_flag@3@@3 true) (=> (and (and (= $abort_code@5@@3 $abort_code@4@@3) (= $DiemConfig_Configuration_$memory@2@@0 $DiemConfig_Configuration_$memory@1@@0)) (and (= $DiemConfig_DiemConfig_$memory@2@@1 $DiemConfig_DiemConfig_$memory@1@@1) (= (ControlFlow 0 78778) 78848))) anon0$2_correct@@3))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon7_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory)) (and (= $abort_code@4@@3 $abort_code@1@@3) (= (ControlFlow 0 78818) 78778))) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 78816) 78818)) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon7_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 78826) 78818) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon7_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 78810) 78826) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 78810) 78816) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon11_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory)) (and (= $abort_code@4@@3 $abort_code@2@@3) (= (ControlFlow 0 78798) 78778))) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 78796) 78798)) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon11_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 78806) 78798) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon11_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 78790) 78806) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 78790) 78796) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon15_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory@0@@1) (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory@0@@0)) (and (= $abort_code@4@@3 $abort_code@3@@3) (= (ControlFlow 0 78774) 78778))) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 78772) 78774)) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon15_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 78786) 78774) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon15_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon23_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 78766) 78786) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 78766) 78772) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@2@@3) (= $abort_flag@3@@3 $abort_flag@2@@3)) (=> (and (and (= $abort_code@5@@3 $abort_code@3@@3) (= $DiemConfig_Configuration_$memory@2@@0 $DiemConfig_Configuration_$memory@0@@0)) (and (= $DiemConfig_DiemConfig_$memory@2@@1 $DiemConfig_DiemConfig_$memory@0@@1) (= (ControlFlow 0 78762) 78848))) anon0$2_correct@@3))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon21_Else$5_correct  (=> (and (= call0formal@$tv0@0@@4 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) (= call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 78756) (- 0 99856)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| dr_account@@1))))))) $abort_flag@2@@3) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@3)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@2@@3) (=> $abort_flag@2@@3 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| dr_account@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@2@@3 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| dr_account@@1))))))) (= $abort_code@3@@3 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@3@@3 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@3@@3 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@8 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@4) 1) (|a#$Address| addr@@8)))) $DiemConfig_DiemConfig_payload)) |inline$$WritebackToValue$0$vdst'@2@@0|)))) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 78756) 78766) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 78756) 78762) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon23_Else_correct)))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@0| call3formal@$ret0@0@@6) (= (ControlFlow 0 78722) 78756)) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon21_Else$5_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 call3formal@$ret0@0@@6 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@0|) (= (ControlFlow 0 78748) 78756))) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon21_Else$5_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowLoc$0$dst@1@@0)) (and (=> (= (ControlFlow 0 78567) 78748) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 78567) 78722) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (and (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)))) (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|))) (and (=> (= (ControlFlow 0 78623) 78748) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 78623) 78722) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) (and (=> (= (ControlFlow 0 78531) 78623) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 78531) 78567) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (and (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) open_module)) (= (ControlFlow 0 78388) 78531)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed))) (= (ControlFlow 0 78329) 78388))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 2) $EmptyPath call3formal@$ret0@0@@6)) (= (ControlFlow 0 78205) 78329)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon21_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 78211) 78205)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon19_Else_correct  (=> (and (not $abort_flag@0@@3) (= call0formal@$tv0@0@@5 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@5) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@3) (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@5) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@1@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@5) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2@@3 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 (let ((addr@@9 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@5) 1) (|a#$Address| addr@@9)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 78151) 78790) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 78151) 78211) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon4$2_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@0@@3) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@0@@3)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@0@@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@0@@3)) (and (=> $abort_flag@0@@3 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))))) (=> $abort_flag@0@@3 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 78145) 78810) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 78145) 78151) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 78075) 78145)) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 78834) 78145) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon4$2_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 78067) 78834) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 78067) 78075) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 78842) 78834) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 78842) 78075) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon18_Else_correct))))
(let ((inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 78061) 78842) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 78061) 78067) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@16 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16)) (let ((va@@39 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@16))
)) (=> (and (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@40 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))
)) (forall (($inv_addr@@18 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@18)) (let ((va@@41 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@18))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@44))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@18))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@18))
))) (=> (and (and (and (forall (($inv_addr@@19 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19)) (let ((va@@42 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@47))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@6))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@19))
)) (forall (($inv_addr@@20 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@20)) (let ((va@@45 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@20))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@20))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@20))
))) (and (forall (($inv_addr@@21 Int) ($inv_tv0@@6 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@21)) (let ((va@@46 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@21))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@49))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@21))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@21))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@21))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address@@3 T@$Value) )  (=> ((_ is $Address) config_address@@3) (|b#$Boolean| ($Boolean (forall ((config_type@@3 T@$Value) )  (=> ((_ is $Type) config_type@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@3)) 1) (|a#$Address| config_address@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@3 ($Address 173345816)))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 78846) 78061)))) inline$$DiemTransactionPublishingOption_set_open_module_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@3  (=> ((_ is $Address) dr_account@@1) (=> (and ((_ is $Boolean) open_module) (= (ControlFlow 0 77423) 78846)) anon0$1_correct@@3))))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 96523) 77423) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun dr_account@@2 () T@$Value)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun $abort_code@5@@4 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@2@@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@2 () T@$Memory)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun $DiemConfig_Configuration_$memory@2@@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1@@1 () T@$Memory)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@4 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@2 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0@@1 () T@$Memory)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun call0formal@$tv0@0@@6 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_Configuration_$CallerDomain@0@@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(declare-fun call0formal@$tv0@0@@7 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 101453) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 80537) (- 0 105557)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 80537) (- 0 105578)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 80537) (- 0 105607)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 80537) (- 0 105624)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 80537) (- 0 105654)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@2))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@2))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 80537) (- 0 105687)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 80537) (- 0 105717)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@3@@4)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@3@@4) (and (=> (= (ControlFlow 0 80537) (- 0 105816)) (=> $abort_flag@3@@4 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@2)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (=> (=> $abort_flag@3@@4 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@2)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))) (=> (= (ControlFlow 0 80537) (- 0 106069)) (=> $abort_flag@3@@4 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| dr_account@@2))))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 1)))))))))))))))))))))))))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$Abort_correct  (=> (= $DiemConfig_DiemConfig_$memory@2@@2 $DiemConfig_DiemConfig_$memory@1@@2) (=> (and (and (= $abort_flag@3@@4 true) (= $abort_code@5@@4 $abort_code@4@@4)) (and (= $DiemConfig_Configuration_$memory@2@@1 $DiemConfig_Configuration_$memory@1@@1) (= (ControlFlow 0 80455) 80537))) anon0$2_correct@@4))))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon5_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory)) (and (= $abort_code@4@@4 $abort_code@1@@4) (= (ControlFlow 0 80515) 80455))) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 80513) 80515)) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon5_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 80523) 80515) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon5_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 80507) 80523) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 80507) 80513) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon9_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory)) (and (= $abort_code@4@@4 $abort_code@2@@4) (= (ControlFlow 0 80495) 80455))) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 80493) 80495)) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon9_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 80503) 80495) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon9_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 80487) 80503) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 80487) 80493) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon13_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory)) (and (= $abort_code@4@@4 $abort_code@2@@4) (= (ControlFlow 0 80475) 80455))) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 80473) 80475)) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon13_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 80483) 80475) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon13_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon24_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 80467) 80483) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 80467) 80473) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon17_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1@@2 $DiemConfig_DiemConfig_$memory@0@@2) (= $DiemConfig_Configuration_$memory@1@@1 $DiemConfig_Configuration_$memory@0@@1)) (and (= $abort_code@4@@4 $abort_code@3@@4) (= (ControlFlow 0 80451) 80455))) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 80449) 80451)) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon17_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 80463) 80451) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon17_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon26_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 80443) 80463) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 80443) 80449) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@2@@4) (= $DiemConfig_DiemConfig_$memory@2@@2 $DiemConfig_DiemConfig_$memory@0@@2)) (=> (and (and (= $abort_flag@3@@4 $abort_flag@2@@4) (= $abort_code@5@@4 $abort_code@3@@4)) (and (= $DiemConfig_Configuration_$memory@2@@1 $DiemConfig_Configuration_$memory@0@@1) (= (ControlFlow 0 80439) 80537))) anon0$2_correct@@4))))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon24_Else$5_correct  (=> (and (= call0formal@$tv0@0@@6 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) (= call3formal@$DiemConfig_Configuration_$CallerDomain@0@@1 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 80433) (- 0 104784)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0@@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0@@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@6) 1) (|a#$Address| dr_account@@2))))))) $abort_flag@2@@4) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@6) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@4)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@2@@4) (=> $abort_flag@2@@4 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@6) 1) (|a#$Address| dr_account@@2))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@6) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@2@@4 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@6) 1) (|a#$Address| dr_account@@2))))))) (= $abort_code@3@@4 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@6) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@3@@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@3@@4 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@6) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@10 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@6) 1) (|a#$Address| addr@@10)))) $DiemConfig_DiemConfig_payload)) |inline$$WritebackToValue$0$vdst'@2@@1|)))) (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 80433) 80443) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 80433) 80439) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon26_Else_correct)))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 1))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@1| call3formal@$ret0@0@@7) (= (ControlFlow 0 80399) 80433)) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon24_Else$5_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 1)) (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 call3formal@$ret0@0@@7 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@1|) (= (ControlFlow 0 80425) 80433))) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon24_Else$5_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowLoc$0$dst@1@@1)) (and (=> (= (ControlFlow 0 80244) 80425) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 80244) 80399) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (and (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|)))) (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|))) (and (=> (= (ControlFlow 0 80300) 80425) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 80300) 80399) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) (and (=> (= (ControlFlow 0 80208) 80300) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 80208) 80244) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (and (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@1) (|p#$Mutation| inline$$BorrowField$0$dst@1@@1) inline$$Vector_empty$0$v@1)) (= (ControlFlow 0 80065) 80208)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list))) (= (ControlFlow 0 80006) 80065))) inline$$WriteRef$0$anon0_correct@@1))))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 1) $EmptyPath call3formal@$ret0@0@@7)) (= (ControlFlow 0 79882) 80006)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon24_Else_correct  (=> (and (not $abort_flag@1@@4) (= (ControlFlow 0 79888) 79882)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 79820) 80467) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 79820) 79888) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 79816) 79820)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@4) (= (ControlFlow 0 79826) 79816)) inline$$Vector_empty$0$Entry_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@4) (= call0formal@$tv0@0@@7 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@4) (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@1@@4 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2@@4 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 (let ((addr@@11 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| addr@@11)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 79785) 80487) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 79785) 79826) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon2$1_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) $abort_flag@0@@4) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) $abort_flag@0@@4)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@0@@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) $abort_flag@0@@4)) (and (=> $abort_flag@0@@4 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))))) (=> $abort_flag@0@@4 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2))))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@2 ($Address 173345816))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 79779) 80507) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 79779) 79785) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 79743) 79779)) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 80531) 79779) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 79737) 80531) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 79737) 79743) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (forall (($inv_addr@@22 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22)) (let ((va@@47 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@22))
)) (=> (and (forall (($inv_addr@@23 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23)) (let ((va@@48 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))
)) (forall (($inv_addr@@24 Int) ($inv_tv0@@7 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@24)) (let ((va@@49 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@24))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@24))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@24))
))) (=> (and (and (and (forall (($inv_addr@@25 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25)) (let ((va@@50 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@53))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@55))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@7))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@25))
)) (forall (($inv_addr@@26 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@26)) (let ((va@@53 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@26))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@26))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@26))
))) (and (forall (($inv_addr@@27 Int) ($inv_tv0@@8 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@27)) (let ((va@@54 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@27))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@57))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@27))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@27))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@27))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address@@4 T@$Value) )  (=> ((_ is $Address) config_address@@4) (|b#$Boolean| ($Boolean (forall ((config_type@@4 T@$Value) )  (=> ((_ is $Type) config_type@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@4)) 1) (|a#$Address| config_address@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@4 ($Address 173345816)))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 80535) 79737)))) inline$$DiemTransactionPublishingOption_set_open_script_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) dr_account@@2) (= (ControlFlow 0 79086) 80535)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 101453) 79086) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
