(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $DualAttestation_BaseUrlRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_Credential () T@$TypeName)
(declare-fun $DualAttestation_Limit () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun $DualAttestation_spec_dual_attestation_message (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $DualAttestation_BaseUrlRotationEvent_new_base_url () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Credential_human_name () Int)
(declare-fun $DualAttestation_Credential_base_url () Int)
(declare-fun $DualAttestation_Credential_compliance_public_key () Int)
(declare-fun $DualAttestation_Credential_expiration_date () Int)
(declare-fun $DualAttestation_Credential_compliance_key_rotation_events () Int)
(declare-fun $DualAttestation_Credential_base_url_rotation_events () Int)
(declare-fun $DualAttestation_Credential_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Limit_micro_xdx_limit () Int)
(declare-fun $DualAttestation_Limit_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $FixedPoint32_FixedPoint32 $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XDX_XDX $XDX_Reserve $VASP_ChildVASP $VASP_ParentVASP $DualAttestation_BaseUrlRotationEvent $DualAttestation_ComplianceKeyRotationEvent $DualAttestation_Credential $DualAttestation_Limit)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@0) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@0))
)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0@@1) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($Event_EventHandle_type_value $tv0@@1))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (forall ((payer T@$Value) (metadata T@$Value) (deposit_value T@$Value) )  (and (and ((_ is $Vector) ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value)) (let ((va@@8 (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0))
)))))
(assert (= $DualAttestation_BaseUrlRotationEvent_new_base_url 0))
(assert (= $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_BaseUrlRotationEvent_type_value ($StructType $DualAttestation_BaseUrlRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key 0))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_type_value ($StructType $DualAttestation_ComplianceKeyRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_Credential_human_name 0))
(assert (= $DualAttestation_Credential_base_url 1))
(assert (= $DualAttestation_Credential_compliance_public_key 2))
(assert (= $DualAttestation_Credential_expiration_date 3))
(assert (= $DualAttestation_Credential_compliance_key_rotation_events 4))
(assert (= $DualAttestation_Credential_base_url_rotation_events 5))
(assert (= $DualAttestation_Credential_type_value ($StructType $DualAttestation_Credential $EmptyTypeValueArray)))
(assert (= $DualAttestation_Limit_micro_xdx_limit 0))
(assert (= $DualAttestation_Limit_type_value ($StructType $DualAttestation_Limit $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_flag@12 () Bool)
(declare-fun dr_account () T@$Value)
(declare-fun $DualAttestation_Limit_$memory () T@$Memory)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun $abort_code@17 () Int)
(declare-fun $DualAttestation_Credential_$memory () T@$Memory)
(declare-fun $DualAttestation_Limit_$memory@1 () T@$Memory)
(declare-fun $abort_flag@11 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@15 () Int)
(declare-fun $abort_code@16 () Int)
(declare-fun $DualAttestation_Limit_$memory@0 () T@$Memory)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$DualAttestation_Limit_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$CastU64$0$dst@1 () T@$Value)
(declare-fun inline$$CastU64$0$dst@0 () T@$Value)
(declare-fun inline$$MulU128$0$dst@2 () T@$Value)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun $abort_code@13 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$MulU128$0$dst@0 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1 () T@$Value)
(declare-fun inline$$MulU128$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0 () T@$Value)
(declare-fun inline$$Diem_scaling_factor_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun inline$$Diem_scaling_factor_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$Diem_scaling_factor_$direct_inter$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$CastU128$0$dst@0 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $XDX_Reserve_$memory () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 192391) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 164326) (- 0 195704)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@12) (and (=> (= (ControlFlow 0 164326) (- 0 195719)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@12) (and (=> (= (ControlFlow 0 164326) (- 0 195736)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@12) (and (=> (= (ControlFlow 0 164326) (- 0 195748)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| ($Integer 1000)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_scaling_factor))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| ($Integer 1000)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_scaling_factor))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@12) (and (=> (= (ControlFlow 0 164326) (- 0 195769)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@12) (and (=> (= (ControlFlow 0 164326) (- 0 195786)) (=> $abort_flag@12 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| ($Integer 1000)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_scaling_factor))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@12 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| ($Integer 1000)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_scaling_factor))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 164326) (- 0 195864)) (=> $abort_flag@12 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@17 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@17 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@17 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| ($Integer 1000)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_scaling_factor))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@17 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@17 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@12 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@17 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@17 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@17 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| ($Integer 1000)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_scaling_factor))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@17 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@17 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 164326) (- 0 195997)) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1))))))))))))) (=> (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))))))))))) (and (=> (= (ControlFlow 0 164326) (- 0 196037)) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))))))))))))))) (=> (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean (forall ((addr1@@2 T@$Value) )  (=> ((_ is $Address) addr1@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2))))))))))))))) (and (=> (= (ControlFlow 0 164326) (- 0 196089)) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 164326) (- 0 196117)) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean (forall ((addr1@@3 T@$Value) )  (=> ((_ is $Address) addr1@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean (forall ((addr1@@4 T@$Value) )  (=> ((_ is $Address) addr1@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 164326) (- 0 196179)) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean (forall ((addr1@@5 T@$Value) )  (=> ((_ is $Address) addr1@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon77_Else_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 164116) (- 0 195462)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (and (and (= $abort_code@17 $abort_code@15) (= $abort_flag@12 $abort_flag@11)) (and (= $DualAttestation_Limit_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 164116) 164326))) anon0$2_correct))))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@17 $abort_code@16) (= $abort_flag@12 true)) (and (= $DualAttestation_Limit_$memory@1 $DualAttestation_Limit_$memory@0) (= (ControlFlow 0 162108) 164326))) anon0$2_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon5_correct  (=> (= $abort_code@16 $abort_code@1) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164304) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 164302) 164304)) inline$$DualAttestation_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 164312) 164304) inline$$DualAttestation_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon54_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 164296) 164312) inline$$DualAttestation_initialize_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 164296) 164302) inline$$DualAttestation_initialize_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon9_correct  (=> (= $abort_code@16 $abort_code@2) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164284) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 164282) 164284)) inline$$DualAttestation_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 164292) 164284) inline$$DualAttestation_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon56_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 164276) 164292) inline$$DualAttestation_initialize_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 164276) 164282) inline$$DualAttestation_initialize_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon15_correct  (=> (= $abort_code@16 $abort_code@3) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164260) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 164258) 164260)) inline$$DualAttestation_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 164268) 164260) inline$$DualAttestation_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon59_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 164252) 164268) inline$$DualAttestation_initialize_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 164252) 164258) inline$$DualAttestation_initialize_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon23_correct  (=> (= $abort_code@16 $abort_code@5) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164240) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 164238) 164240)) inline$$DualAttestation_initialize_$def_verify$0$anon23_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 164248) 164240) inline$$DualAttestation_initialize_$def_verify$0$anon23_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon63_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 164232) 164248) inline$$DualAttestation_initialize_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 164232) 164238) inline$$DualAttestation_initialize_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon29_correct  (=> (= $abort_code@16 $abort_code@10) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164216) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 164214) 164216)) inline$$DualAttestation_initialize_$def_verify$0$anon29_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon67_Then_correct  (=> (= (ControlFlow 0 164224) 164216) inline$$DualAttestation_initialize_$def_verify$0$anon29_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon66_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 164208) 164224) inline$$DualAttestation_initialize_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 164208) 164214) inline$$DualAttestation_initialize_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon33_correct  (=> (= $abort_code@16 $abort_code@11) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164196) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 164194) 164196)) inline$$DualAttestation_initialize_$def_verify$0$anon33_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 164204) 164196) inline$$DualAttestation_initialize_$def_verify$0$anon33_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon68_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 164188) 164204) inline$$DualAttestation_initialize_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 164188) 164194) inline$$DualAttestation_initialize_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon39_correct  (=> (= $abort_code@16 $abort_code@12) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164168) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 164166) 164168)) inline$$DualAttestation_initialize_$def_verify$0$anon39_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 164176) 164168) inline$$DualAttestation_initialize_$def_verify$0$anon39_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon71_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 164160) 164176) inline$$DualAttestation_initialize_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 164160) 164166) inline$$DualAttestation_initialize_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon47_correct  (=> (= $abort_code@16 $abort_code@14) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164148) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 164146) 164148)) inline$$DualAttestation_initialize_$def_verify$0$anon47_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 164156) 164148) inline$$DualAttestation_initialize_$def_verify$0$anon47_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon75_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 164140) 164156) inline$$DualAttestation_initialize_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 164140) 164146) inline$$DualAttestation_initialize_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon51_correct  (=> (= $abort_code@16 $abort_code@15) (=> (and (= $DualAttestation_Limit_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 164128) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 164126) 164128)) inline$$DualAttestation_initialize_$def_verify$0$anon51_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon78_Then_correct  (=> (= (ControlFlow 0 164136) 164128) inline$$DualAttestation_initialize_$def_verify$0$anon51_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon77_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 164120) 164136) inline$$DualAttestation_initialize_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 164120) 164126) inline$$DualAttestation_initialize_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@11 true) (=> (and (= $abort_code@15 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 164076) 164120) inline$$DualAttestation_initialize_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 164076) 164116) inline$$DualAttestation_initialize_$def_verify$0$anon77_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 164074) 164076)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$DualAttestation_Limit_pack$0$$struct@1))) (= $abort_flag@11 $abort_flag@10)) (and (= $abort_code@15 $abort_code@14) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 164024) 164120) inline$$DualAttestation_initialize_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 164024) 164116) inline$$DualAttestation_initialize_$def_verify$0$anon77_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 164082) 164074) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 164082) 164024) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 163870) (- 0 195347)) true) (=> (= (ControlFlow 0 163870) 164082) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$DualAttestation_Limit_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 163756) 163870)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DualAttestation_Limit_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 163762) 163870) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DualAttestation_Limit_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 163750) 163762) inline$$DualAttestation_Limit_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 163750) 163756) inline$$DualAttestation_Limit_pack$0$anon4_Else_correct)))))
(let ((inline$$DualAttestation_Limit_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 163742) 163870)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DualAttestation_Limit_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$CastU64$0$dst@1) (>= (|i#$Integer| inline$$CastU64$0$dst@1) 0)) (<= (|i#$Integer| inline$$CastU64$0$dst@1) $MAX_U64)) (= inline$$DualAttestation_Limit_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$CastU64$0$dst@1) 1)))) (and (=> (= (ControlFlow 0 163734) 163750) inline$$DualAttestation_Limit_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 163734) 163742) inline$$DualAttestation_Limit_pack$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon75_Else_correct  (=> (and (not $abort_flag@10) (= (ControlFlow 0 163768) 163734)) inline$$DualAttestation_Limit_pack$0$anon0_correct)))
(let ((inline$$CastU64$0$anon3_Then$1_correct  (=> (= $abort_code@14 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@10 true) (= inline$$CastU64$0$dst@1 inline$$CastU64$0$dst@0)) (and (=> (= (ControlFlow 0 163596) 164140) inline$$DualAttestation_initialize_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 163596) 163768) inline$$DualAttestation_initialize_$def_verify$0$anon75_Else_correct))))))
(let ((inline$$CastU64$0$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$MulU128$0$dst@2) $MAX_U64) (= (ControlFlow 0 163594) 163596)) inline$$CastU64$0$anon3_Then$1_correct)))
(let ((inline$$CastU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (|i#$Integer| inline$$MulU128$0$dst@2)) (= $abort_code@14 $abort_code@12)) (and (= $abort_flag@10 $abort_flag@9) (= inline$$CastU64$0$dst@1 inline$$MulU128$0$dst@2))) (and (=> (= (ControlFlow 0 163544) 164140) inline$$DualAttestation_initialize_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 163544) 163768) inline$$DualAttestation_initialize_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$CastU64$0$Entry_correct  (and (=> (= (ControlFlow 0 163530) (- 0 195195)) true) (and (=> (= (ControlFlow 0 163530) 163594) inline$$CastU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 163530) 163544) inline$$CastU64$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon73_Then_correct  (=> (and (|b#$Boolean| inline$$Le$0$dst@1) (= (ControlFlow 0 163602) 163530)) inline$$CastU64$0$Entry_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon44_correct  (=> (= $abort_code@16 $abort_code@13) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 163451) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 163449) 163451)) inline$$DualAttestation_initialize_$def_verify$0$anon44_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 163459) 163451) inline$$DualAttestation_initialize_$def_verify$0$anon44_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon73_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$0$dst@1)) (= $abort_code@13 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 163443) 163459) inline$$DualAttestation_initialize_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 163443) 163449) inline$$DualAttestation_initialize_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon71_Else_correct  (=> (not $abort_flag@9) (and (=> (= (ControlFlow 0 163431) 163602) inline$$DualAttestation_initialize_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 163431) 163443) inline$$DualAttestation_initialize_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon36$1_correct  (=> (and (and (and (= inline$$DualAttestation_initialize_$def_verify$0$$t18@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9)) (and (=> $abort_flag@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 163425) 164160) inline$$DualAttestation_initialize_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 163425) 163431) inline$$DualAttestation_initialize_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$Le$0$anon0_correct  (=> (and (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| inline$$MulU128$0$dst@2) (|i#$Integer| inline$$DualAttestation_initialize_$def_verify$0$$t16@1)))) (= (ControlFlow 0 163413) 163425)) inline$$DualAttestation_initialize_$def_verify$0$anon36$1_correct)))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 163399) (- 0 195074)) true) (=> (= (ControlFlow 0 163399) 163413) inline$$Le$0$anon0_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon36_correct  (=> (and (= inline$$DualAttestation_initialize_$def_verify$0$$t16@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 163419) 163399)) inline$$Le$0$Entry_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 163351) 163419)) inline$$DualAttestation_initialize_$def_verify$0$anon36_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 164184) 163419) inline$$DualAttestation_initialize_$def_verify$0$anon36_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon68_Else_correct  (=> (not $abort_flag@8) (and (=> (= (ControlFlow 0 163345) 164184) inline$$DualAttestation_initialize_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 163345) 163351) inline$$DualAttestation_initialize_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$MulU128$0$anon3_Then$1_correct  (=> (= $abort_flag@8 true) (=> (and (= $abort_code@11 $EXEC_FAILURE_CODE) (= inline$$MulU128$0$dst@2 inline$$MulU128$0$dst@0)) (and (=> (= (ControlFlow 0 163331) 164188) inline$$DualAttestation_initialize_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 163331) 163345) inline$$DualAttestation_initialize_$def_verify$0$anon68_Else_correct))))))
(let ((inline$$MulU128$0$anon3_Then_correct  (=> (and (> (* (|i#$Integer| inline$$CastU128$0$dst@1) (|i#$Integer| inline$$CastU128$1$dst@1)) $MAX_U128) (= (ControlFlow 0 163329) 163331)) inline$$MulU128$0$anon3_Then$1_correct)))
(let ((inline$$MulU128$0$anon3_Else_correct  (=> (>= $MAX_U128 (* (|i#$Integer| inline$$CastU128$0$dst@1) (|i#$Integer| inline$$CastU128$1$dst@1))) (=> (and (and (= inline$$MulU128$0$dst@1 ($Integer (* (|i#$Integer| inline$$CastU128$0$dst@1) (|i#$Integer| inline$$CastU128$1$dst@1)))) (= $abort_flag@8 $abort_flag@7)) (and (= $abort_code@11 $abort_code@10) (= inline$$MulU128$0$dst@2 inline$$MulU128$0$dst@1))) (and (=> (= (ControlFlow 0 163273) 164188) inline$$DualAttestation_initialize_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 163273) 163345) inline$$DualAttestation_initialize_$def_verify$0$anon68_Else_correct))))))
(let ((inline$$MulU128$0$Entry_correct  (and (=> (= (ControlFlow 0 163243) (- 0 194957)) true) (and (=> (= (ControlFlow 0 163243) 163329) inline$$MulU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 163243) 163273) inline$$MulU128$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon66_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 163337) 163243)) inline$$MulU128$0$Entry_correct)))
(let ((inline$$CastU128$1$anon3_Then$1_correct  (=> (= $abort_code@10 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7 true) (= inline$$CastU128$1$dst@1 inline$$CastU128$1$dst@0)) (and (=> (= (ControlFlow 0 163138) 164208) inline$$DualAttestation_initialize_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 163138) 163337) inline$$DualAttestation_initialize_$def_verify$0$anon66_Else_correct))))))
(let ((inline$$CastU128$1$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2) $MAX_U128) (= (ControlFlow 0 163136) 163138)) inline$$CastU128$1$anon3_Then$1_correct)))
(let ((inline$$CastU128$1$anon3_Else_correct  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)) (= $abort_code@10 $abort_code@9)) (and (= $abort_flag@7 $abort_flag@6) (= inline$$CastU128$1$dst@1 inline$$Diem_scaling_factor_$def$0$$ret0@2))) (and (=> (= (ControlFlow 0 163086) 164208) inline$$DualAttestation_initialize_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 163086) 163337) inline$$DualAttestation_initialize_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$CastU128$1$Entry_correct  (and (=> (= (ControlFlow 0 163072) (- 0 194885)) true) (and (=> (= (ControlFlow 0 163072) 163136) inline$$CastU128$1$anon3_Then_correct) (=> (= (ControlFlow 0 163072) 163086) inline$$CastU128$1$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon65_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 163144) 163072)) inline$$CastU128$1$Entry_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon65_Then_correct  (=> (and (and $abort_flag@6 (= $abort_code@16 $abort_code@9)) (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164228) 162108))) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_scaling_factor_$def$0$$ret0@1 $Error) (= $abort_code@9 $abort_code@8)) (and (= inline$$Diem_scaling_factor_$def$0$$ret0@2 inline$$Diem_scaling_factor_$def$0$$ret0@1) (= $abort_flag@6 true))) (and (=> (= (ControlFlow 0 162953) 164228) inline$$DualAttestation_initialize_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 162953) 163144) inline$$DualAttestation_initialize_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon3_correct  (=> (and (= $abort_code@8 $abort_code@6) (= (ControlFlow 0 162977) 162953)) inline$$Diem_scaling_factor_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 162975) 162977)) inline$$Diem_scaling_factor_$def$0$anon3_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon14_Then_correct  (=> (= (ControlFlow 0 162985) 162977) inline$$Diem_scaling_factor_$def$0$anon3_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon13_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 162969) 162985) inline$$Diem_scaling_factor_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 162969) 162975) inline$$Diem_scaling_factor_$def$0$anon14_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon9_correct  (=> (and (= $abort_code@8 $abort_code@7) (= (ControlFlow 0 162947) 162953)) inline$$Diem_scaling_factor_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 162945) 162947)) inline$$Diem_scaling_factor_$def$0$anon9_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 162961) 162947) inline$$Diem_scaling_factor_$def$0$anon9_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon16_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 162939) 162961) inline$$Diem_scaling_factor_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 162939) 162945) inline$$Diem_scaling_factor_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon15_Then_correct  (=> $abort_flag@4 (=> (and (= $abort_code@8 $abort_code@6) (= (ControlFlow 0 162965) 162953)) inline$$Diem_scaling_factor_$def$0$Abort_correct))))
(let ((inline$$Diem_scaling_factor_$def$0$anon12_correct  (=> (= $abort_code@9 $abort_code@7) (=> (and (= inline$$Diem_scaling_factor_$def$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1) (= $abort_flag@6 $abort_flag@5)) (and (=> (= (ControlFlow 0 162927) 164228) inline$$DualAttestation_initialize_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 162927) 163144) inline$$DualAttestation_initialize_$def_verify$0$anon65_Else_correct))))))
(let ((inline$$Diem_scaling_factor_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 162925) 162927)) inline$$Diem_scaling_factor_$def$0$anon12_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 162935) 162927) inline$$Diem_scaling_factor_$def$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $Diem_CurrencyInfo_scaling_factor)) (and (=> (= (ControlFlow 0 162909) 162935) inline$$Diem_scaling_factor_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 162909) 162925) inline$$Diem_scaling_factor_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 162915) 162909)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_code@7 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@5 true) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 162855) 162939) inline$$Diem_scaling_factor_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 162855) 162915) inline$$Diem_scaling_factor_$def$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 162853) 162855)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1))) (= $abort_code@7 $abort_code@6)) (and (= $abort_flag@5 $abort_flag@4) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 162801) 162939) inline$$Diem_scaling_factor_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 162801) 162915) inline$$Diem_scaling_factor_$def$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 162783) 162853) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 162783) 162801) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (=> (= inline$$GetGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_scaling_factor_$direct_inter$0$$tv0@0) 1)) (and (=> (= (ControlFlow 0 162777) (- 0 194683)) true) (=> (= (ControlFlow 0 162777) 162783) inline$$GetGlobal$0$anon0_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon15_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 162861) 162777)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 162644) 162965) inline$$Diem_scaling_factor_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 162644) 162861) inline$$Diem_scaling_factor_$def$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 162654) 162965) inline$$Diem_scaling_factor_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 162654) 162861) inline$$Diem_scaling_factor_$def$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@4) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 162638) 162654) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 162638) 162644) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon13_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 162668) 162638)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon0_correct  (=> (and (and (not $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_scaling_factor_$direct_inter$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_scaling_factor_$direct_inter$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@4 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_scaling_factor_$direct_inter$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 162533) 162969) inline$$Diem_scaling_factor_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 162533) 162668) inline$$Diem_scaling_factor_$def$0$anon13_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$direct_inter$0$Entry_correct  (=> (and (= inline$$Diem_scaling_factor_$direct_inter$0$$tv0@0 $XDX_XDX_type_value) (= (ControlFlow 0 162306) 162533)) inline$$Diem_scaling_factor_$def$0$anon0_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon63_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 162999) 162306)) inline$$Diem_scaling_factor_$direct_inter$0$Entry_correct)))
(let ((inline$$CastU128$0$anon3_Then$1_correct  (=> (= $abort_flag@3 true) (=> (and (= $abort_code@5 $EXEC_FAILURE_CODE) (= inline$$CastU128$0$dst@1 inline$$CastU128$0$dst@0)) (and (=> (= (ControlFlow 0 162257) 164232) inline$$DualAttestation_initialize_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 162257) 162999) inline$$DualAttestation_initialize_$def_verify$0$anon63_Else_correct))))))
(let ((inline$$CastU128$0$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$DualAttestation_initialize_$def_verify$0$$t12@1) $MAX_U128) (= (ControlFlow 0 162255) 162257)) inline$$CastU128$0$anon3_Then$1_correct)))
(let ((inline$$CastU128$0$anon3_Else_correct  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$DualAttestation_initialize_$def_verify$0$$t12@1)) (= $abort_flag@3 $abort_flag@2)) (and (= $abort_code@5 $abort_code@3) (= inline$$CastU128$0$dst@1 inline$$DualAttestation_initialize_$def_verify$0$$t12@1))) (and (=> (= (ControlFlow 0 162205) 164232) inline$$DualAttestation_initialize_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 162205) 162999) inline$$DualAttestation_initialize_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$CastU128$0$Entry_correct  (and (=> (= (ControlFlow 0 162191) (- 0 194424)) true) (and (=> (= (ControlFlow 0 162191) 162255) inline$$CastU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 162191) 162205) inline$$CastU128$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon61_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (= inline$$DualAttestation_initialize_$def_verify$0$$t12@1 ($Integer 1000)) (= (ControlFlow 0 162263) 162191)) inline$$CastU128$0$Entry_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon20_correct  (=> (= $abort_code@16 $abort_code@4) (=> (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 162104) 162108)) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 162102) 162104)) inline$$DualAttestation_initialize_$def_verify$0$anon20_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 162116) 162104) inline$$DualAttestation_initialize_$def_verify$0$anon20_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon61_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@4 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 162096) 162116) inline$$DualAttestation_initialize_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 162096) 162102) inline$$DualAttestation_initialize_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon59_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 162084) 162263) inline$$DualAttestation_initialize_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 162084) 162096) inline$$DualAttestation_initialize_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon58_Else$1_correct  (=> (and (and (and (= inline$$DualAttestation_initialize_$def_verify$0$$t10@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2)) (and (=> $abort_flag@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 162078) 164252) inline$$DualAttestation_initialize_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 162078) 162084) inline$$DualAttestation_initialize_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DualAttestation_initialize_$def_verify$0$$t8@1)))) (= (ControlFlow 0 162066) 162078)) inline$$DualAttestation_initialize_$def_verify$0$anon58_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 162056) (- 0 194296)) true) (=> (= (ControlFlow 0 162056) 162066) inline$$Not$0$anon0_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon58_Else_correct  (=> (not $abort_flag@1) (=> (and (= inline$$DualAttestation_initialize_$def_verify$0$$t8@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)))) (= (ControlFlow 0 162072) 162056)) inline$$Not$0$Entry_correct))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon58_Then_correct  (=> (and (and $abort_flag@1 (= $abort_code@16 $abort_code@2)) (and (= $DualAttestation_Limit_$memory@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 164272) 162108))) inline$$DualAttestation_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 161984) 164272) inline$$DualAttestation_initialize_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 161984) 162072) inline$$DualAttestation_initialize_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 161994) 164272) inline$$DualAttestation_initialize_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 161994) 162072) inline$$DualAttestation_initialize_$def_verify$0$anon58_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@1) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 161978) 161994) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 161978) 161984) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon56_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 162008) 161978)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon54_Else_correct  (=> (and (and (not $abort_flag@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@1 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 161873) 164276) inline$$DualAttestation_initialize_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 161873) 162008) inline$$DualAttestation_initialize_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 161867) 164296) inline$$DualAttestation_initialize_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 161867) 161873) inline$$DualAttestation_initialize_$def_verify$0$anon54_Else_correct))))))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 161831) 161867)) inline$$DualAttestation_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 164320) 161867) inline$$DualAttestation_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 161825) 164320) inline$$DualAttestation_initialize_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 161825) 161831) inline$$DualAttestation_initialize_$def_verify$0$anon53_Else_correct)))))
(let ((anon0$1_correct  (=> (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code)) (let ((va@@12 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_currency_code))) $$0@@0))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@1))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@2))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@5))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))
))) (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DualAttestation_Limit_micro_xdx_limit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DualAttestation_Limit_micro_xdx_limit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DualAttestation_Limit_micro_xdx_limit)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 164324) 161825)))) inline$$DualAttestation_initialize_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 160739) 164324)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 192391) 160739) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun metadata_signature () T@$Value)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun $tv0@@9 () T@$TypeValue)
(declare-fun value () T@$Value)
(declare-fun payer@@0 () T@$Value)
(declare-fun payee () T@$Value)
(declare-fun $VASP_ParentVASP_$memory () T@$Memory)
(declare-fun $VASP_ChildVASP_$memory () T@$Memory)
(declare-fun metadata@@0 () T@$Value)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun |inline$$DualAttestation_assert_payment_ok_$def_verify$0$tmp#$5@1| () T@$Value)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@0 () Int)
(declare-fun inline$$DualAttestation_assert_payment_ok_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun call6formal@$ret0@0 () T@$Value)
(declare-fun inline$$Vector_is_empty$0$b@1 () T@$Value)
(declare-fun inline$$Vector_is_empty$0$ta@0 () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 196258) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 166184) (- 0 200150)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 166184) (- 0 200185)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 166184) (- 0 200222)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 166184) (- 0 200269)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 166184) (- 0 200338)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 166184) (- 0 200407)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 value))))))))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 value))))))))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 166184) (- 0 200484)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 166184) (- 0 200555)) (=> $abort_flag@4@@0 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@0) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@0 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 value)))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee)))))))))))))) (=> (=> $abort_flag@4@@0 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@0) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@0 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 value)))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))))) (=> (= (ControlFlow 0 166184) (- 0 200954)) (=> $abort_flag@4@@0 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@6@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) (= $abort_code@6@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) (= $abort_code@6@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@1) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@1 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 value))))))))))))) (= $abort_code@6@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) (= $abort_code@6@@0 (|i#$Integer| ($Integer 5)))))))))))))))))))))))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$Abort_correct  (=> (= $abort_code@6@@0 $abort_code@5@@0) (=> (and (= $abort_flag@4@@0 true) (= (ControlFlow 0 166030) 166184)) anon0$2_correct@@0))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon21_correct  (=> (and (= $abort_code@5@@0 $abort_code@1@@0) (= (ControlFlow 0 166050) 166030)) inline$$DualAttestation_assert_payment_ok_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 166048) 166050)) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon21_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 166058) 166050) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon21_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon38_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 166042) 166058) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 166042) 166048) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon27_correct  (=> (and (= $abort_code@5@@0 $abort_code@3@@0) (= (ControlFlow 0 166026) 166030)) inline$$DualAttestation_assert_payment_ok_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 166024) 166026)) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon27_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 166038) 166026) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon27_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon41_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 166018) 166038) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 166018) 166024) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$L6_correct  (=> (= $abort_code@6@@0 $abort_code@4@@0) (=> (and (= $abort_flag@4@@0 $abort_flag@3@@0) (= (ControlFlow 0 166002) 166184)) anon0$2_correct@@0))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon41_Else_correct  (=> (and (and (not $abort_flag@2@@0) (= $abort_code@4@@0 $abort_code@3@@0)) (and (= $abort_flag@3@@0 $abort_flag@2@@0) (= (ControlFlow 0 166014) 166002))) inline$$DualAttestation_assert_payment_ok_$def_verify$0$L6_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon40_Then_correct  (=> (and (and (|b#$Boolean| |inline$$DualAttestation_assert_payment_ok_$def_verify$0$tmp#$5@1|) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))) $abort_flag@2@@0)) (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0)))) $abort_flag@2@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@2) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@2 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 value)))))))))) $abort_flag@2@@0))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee)))))))) $abort_flag@2@@0) (=> $abort_flag@2@@0 (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@3) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@3 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 value))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) (and (=> $abort_flag@2@@0 (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0)))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@4) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@4 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 value)))))))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee)))))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 5)))))) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@6 T@$Value) )  (=> ((_ is $Address) addr1@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))))))))))))) (and (and (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@7 T@$Value) )  (=> ((_ is $Address) addr1@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7))))))))))))))) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (and (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@8 T@$Value) )  (=> ((_ is $Address) addr1@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@9 T@$Value) )  (=> ((_ is $Address) addr1@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@9)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@9)))) $DualAttestation_Credential_base_url))))))))))))))) (and (=> (= (ControlFlow 0 166008) 166018) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 166008) 166014) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon40_Else_correct  (=> (and (and (not (|b#$Boolean| |inline$$DualAttestation_assert_payment_ok_$def_verify$0$tmp#$5@1|)) (= $abort_code@4@@0 $abort_code@2@@0)) (and (= $abort_flag@3@@0 $abort_flag@1@@0) (= (ControlFlow 0 166000) 166002))) inline$$DualAttestation_assert_payment_ok_$def_verify$0$L6_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon18_correct  (=> (= $abort_flag@1@@0 false) (=> (and (= $abort_code@2@@0 $abort_code@0) (= |inline$$DualAttestation_assert_payment_ok_$def_verify$0$tmp#$5@1| inline$$DualAttestation_assert_payment_ok_$def_verify$0$$t13@1)) (and (=> (= (ControlFlow 0 166110) 166008) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 166110) 166000) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 166108) 166110)) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon18_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 166118) 166110) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon18_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon36_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@0) (= inline$$DualAttestation_assert_payment_ok_$def_verify$0$$t13@1 ($Boolean true))) (and (=> (= (ControlFlow 0 166100) 166118) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 166100) 166108) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon38_Else_correct  (=> (and (and (not $abort_flag@0@@0) (= $abort_flag@1@@0 $abort_flag@0@@0)) (and (= $abort_code@2@@0 $abort_code@1@@0) (= |inline$$DualAttestation_assert_payment_ok_$def_verify$0$tmp#$5@1| call6formal@$ret0@0))) (and (=> (= (ControlFlow 0 165990) 166008) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 165990) 166000) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon36_Else_correct  (=> (and (and (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@0)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@0) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@0@@0))) (and (and (=> $abort_flag@0@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (=> $abort_flag@0@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 8))))))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call6formal@$ret0@0 ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) ((_ is $Boolean) call6formal@$ret0@0)))) (and (=> (= (ControlFlow 0 165984) 166042) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 165984) 165990) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@0  (=> (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$Vector_is_empty$0$b@1)))) (and (=> (= (ControlFlow 0 165968) 166100) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 165968) 165984) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 165958) (- 0 199153)) true) (=> (= (ControlFlow 0 165958) 165968) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon34_Else_correct  (=> (and (not false) (= (ControlFlow 0 165974) 165958)) inline$$Not$0$Entry_correct@@0)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon34_Then_correct true))
(let ((inline$$Vector_is_empty$0$anon0_correct  (=> (and ((_ is $Vector) metadata_signature) (= inline$$Vector_is_empty$0$b@1 ($Boolean (= (|l#$ValueArray| (|v#$Vector| metadata_signature)) 0)))) (and (=> (= (ControlFlow 0 165912) 166122) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 165912) 165974) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Vector_is_empty$0$Entry_correct  (=> (and (= inline$$Vector_is_empty$0$ta@0 $IntegerType) (= (ControlFlow 0 165896) 165912)) inline$$Vector_is_empty$0$anon0_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 165683) 165896)) inline$$Vector_is_empty$0$Entry_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 166146) 165896) inline$$Vector_is_empty$0$Entry_correct)))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon32_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 165675) 166146) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 165675) 165683) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon32_Then_correct  (and (=> (= (ControlFlow 0 166154) 166146) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 166154) 165683) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon33_Else_correct))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon31_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 165667) 166154) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 165667) 165675) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon31_Then_correct  (and (=> (= (ControlFlow 0 166162) 166154) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 166162) 165675) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon32_Else_correct))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon30_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 165659) 166162) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 165659) 165667) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon30_Then_correct  (and (=> (= (ControlFlow 0 166170) 166162) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 166170) 165667) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon31_Else_correct))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 165651) 166170) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 165651) 165659) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 166178) 166170) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 166178) 165659) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon30_Else_correct))))
(let ((inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 165645) 166178) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 165645) 165651) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@2))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@2))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@2))) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@6))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@7))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@8))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@9))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@10))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@11))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))
))) (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@38 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@39 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))
)))) (=> (and (and (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@40 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))) $$0@@12))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))) $$0@@13))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))) $$0@@14))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@15))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@46 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@47 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@16))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@48 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Limit_micro_xdx_limit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Limit_micro_xdx_limit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Limit_micro_xdx_limit)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@7))
))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((addr3@@0 T@$Value) )  (=> ((_ is $Address) addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((child_addr T@$Value) )  (=> ((_ is $Address) child_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr1@@10 T@$Value) )  (=> ((_ is $Address) addr1@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@10)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@10)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@10)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 166182) 165645)))) inline$$DualAttestation_assert_payment_ok_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) payer@@0) ((_ is $Address) payee)) (=> (and (and (and (and ((_ is $Integer) value) (>= (|i#$Integer| value) 0)) (<= (|i#$Integer| value) $MAX_U64)) (and (and ((_ is $Vector) metadata@@0) (let ((va@@49 (|v#$Vector| metadata@@0)))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
)))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| metadata@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) $$0@@17))
)))) (and (and (and ((_ is $Vector) metadata_signature) (let ((va@@50 (|v#$Vector| metadata_signature)))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| metadata_signature)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature)) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature)) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature)) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature)) $$0@@18))
))) (= (ControlFlow 0 164803) 166182))) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 196258) 164803) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun payee@@0 () T@$Value)
(declare-fun $abort_flag@9@@0 () Bool)
(declare-fun metadata_signature@@0 () T@$Value)
(declare-fun payer@@1 () T@$Value)
(declare-fun metadata@@1 () T@$Value)
(declare-fun deposit_value@@0 () T@$Value)
(declare-fun $abort_code@15@@0 () Int)
(declare-fun inline$$Signature_ed25519_verify$0$res@1 () T@$Value)
(declare-fun $abort_flag@8@@0 () Bool)
(declare-fun $abort_code@12@@0 () Int)
(declare-fun $abort_code@14@@0 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun $abort_code@13@@0 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t37@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun $abort_code@11@@0 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t34@1 () T@$Value)
(declare-fun inline$$Vector_is_empty$1$b@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Vector_is_empty$1$ta@0 () T@$TypeValue)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t29@1 () T@$Value)
(declare-fun inline$$Vector_is_empty$0$b@1@@0 () T@$Value)
(declare-fun inline$$Vector_is_empty$0$ta@0@@0 () T@$TypeValue)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t23@1 () T@$Value)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 201439) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 168945) (- 0 207339)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 168945) (- 0 207360)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_base_url)) ($Integer 0)))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_base_url)) ($Integer 0)))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 168945) (- 0 207381)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature@@0))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@5) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature@@0 payee_compliance_key@@5 ($DualAttestation_spec_dual_attestation_message payer@@1 metadata@@1 deposit_value@@0)))))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature@@0))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@5) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature@@0 payee_compliance_key@@5 ($DualAttestation_spec_dual_attestation_message payer@@1 metadata@@1 deposit_value@@0)))))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 168945) (- 0 207410)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0)))))))) $abort_flag@9@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0)))))))) $abort_flag@9@@0) (and (=> (= (ControlFlow 0 168945) (- 0 207433)) (=> $abort_flag@9@@0 (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_base_url)) ($Integer 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature@@0))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@6) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature@@0 payee_compliance_key@@6 ($DualAttestation_spec_dual_attestation_message payer@@1 metadata@@1 deposit_value@@0))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))))))))) (=> (=> $abort_flag@9@@0 (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_base_url)) ($Integer 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature@@0))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@6) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature@@0 payee_compliance_key@@6 ($DualAttestation_spec_dual_attestation_message payer@@1 metadata@@1 deposit_value@@0))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0)))))))))) (and (=> (= (ControlFlow 0 168945) (- 0 207524)) (=> $abort_flag@9@@0 (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_base_url)) ($Integer 0)))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature@@0))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@7) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature@@0 payee_compliance_key@@7 ($DualAttestation_spec_dual_attestation_message payer@@1 metadata@@1 deposit_value@@0)))))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0)))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@9@@0 (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_base_url)) ($Integer 0)))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature@@0))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@7) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature@@0 payee_compliance_key@@7 ($DualAttestation_spec_dual_attestation_message payer@@1 metadata@@1 deposit_value@@0)))))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0)))))))) (= $abort_code@15@@0 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 168945) (- 0 207659)) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@11 T@$Value) )  (=> ((_ is $Address) addr1@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@11)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@11))))))))))))) (=> (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@12 T@$Value) )  (=> ((_ is $Address) addr1@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@12)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@12)))))))))))) (and (=> (= (ControlFlow 0 168945) (- 0 207699)) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@13 T@$Value) )  (=> ((_ is $Address) addr1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@13))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@13)))))))))))))))) (=> (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@14 T@$Value) )  (=> ((_ is $Address) addr1@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@14))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@14))))))))))))))) (and (=> (= (ControlFlow 0 168945) (- 0 207751)) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 168945) (- 0 207782)) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@15 T@$Value) )  (=> ((_ is $Address) addr1@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@15)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@15)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@16 T@$Value) )  (=> ((_ is $Address) addr1@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@16)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@16)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 168945) (- 0 207844)) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@17 T@$Value) )  (=> ((_ is $Address) addr1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@17)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@17)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon116_Then_correct  (=> (and (and (|b#$Boolean| inline$$Signature_ed25519_verify$0$res@1) (= $abort_flag@9@@0 $abort_flag@8@@0)) (and (= $abort_code@15@@0 $abort_code@12@@0) (= (ControlFlow 0 168639) 168945))) anon0$2_correct@@1)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct  (=> (= $abort_flag@9@@0 true) (=> (and (= $abort_code@15@@0 $abort_code@14@@0) (= (ControlFlow 0 168157) 168945)) anon0$2_correct@@1))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon17_correct  (=> (and (= $abort_code@14@@0 $abort_code@1@@1) (= (ControlFlow 0 168871) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 168869) 168871)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon17_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon87_Then_correct  (=> (= (ControlFlow 0 168879) 168871) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon17_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon86_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 168863) 168879) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 168863) 168869) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon25_correct  (=> (and (= $abort_code@14@@0 $abort_code@2@@1) (= (ControlFlow 0 168851) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 168849) 168851)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon25_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon91_Then_correct  (=> (= (ControlFlow 0 168859) 168851) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon25_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon90_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 168843) 168859) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 168843) 168849) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon29_correct  (=> (and (= $abort_code@14@@0 $abort_code@4@@1) (= (ControlFlow 0 168831) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 168829) 168831)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon29_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon93_Then_correct  (=> (= (ControlFlow 0 168839) 168831) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon29_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon92_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 168823) 168839) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 168823) 168829) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon33_correct  (=> (and (= $abort_code@14@@0 $abort_code@4@@1) (= (ControlFlow 0 168811) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 168809) 168811)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon33_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon95_Then_correct  (=> (= (ControlFlow 0 168819) 168811) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon33_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon94_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 168803) 168819) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 168803) 168809) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon37_correct  (=> (and (= $abort_code@14@@0 $abort_code@5@@1) (= (ControlFlow 0 168791) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 168789) 168791)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon37_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon97_Then_correct  (=> (= (ControlFlow 0 168799) 168791) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon37_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon96_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 168783) 168799) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 168783) 168789) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon97_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon45_correct  (=> (and (= $abort_code@14@@0 $abort_code@6@@1) (= (ControlFlow 0 168771) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon101_Else_correct  (=> (and (not true) (= (ControlFlow 0 168769) 168771)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon45_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon101_Then_correct  (=> (= (ControlFlow 0 168779) 168771) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon45_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon100_Then_correct  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 168763) 168779) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 168763) 168769) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon101_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon49_correct  (=> (and (= $abort_code@14@@0 $abort_code@8@@0) (= (ControlFlow 0 168751) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon103_Else_correct  (=> (and (not true) (= (ControlFlow 0 168749) 168751)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon49_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon103_Then_correct  (=> (= (ControlFlow 0 168759) 168751) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon49_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon102_Then_correct  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 168743) 168759) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon103_Then_correct) (=> (= (ControlFlow 0 168743) 168749) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon103_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon53_correct  (=> (and (= $abort_code@14@@0 $abort_code@8@@0) (= (ControlFlow 0 168731) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon105_Else_correct  (=> (and (not true) (= (ControlFlow 0 168729) 168731)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon53_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon105_Then_correct  (=> (= (ControlFlow 0 168739) 168731) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon53_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon104_Then_correct  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 168723) 168739) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 168723) 168729) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon105_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon57_correct  (=> (and (= $abort_code@14@@0 $abort_code@9@@0) (= (ControlFlow 0 168711) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon107_Else_correct  (=> (and (not true) (= (ControlFlow 0 168709) 168711)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon57_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon107_Then_correct  (=> (= (ControlFlow 0 168719) 168711) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon57_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon106_Then_correct  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 168703) 168719) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon107_Then_correct) (=> (= (ControlFlow 0 168703) 168709) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon107_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon65_correct  (=> (and (= $abort_code@14@@0 $abort_code@10@@0) (= (ControlFlow 0 168691) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 168689) 168691)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon65_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon111_Then_correct  (=> (= (ControlFlow 0 168699) 168691) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon65_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon110_Then_correct  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 168683) 168699) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon111_Then_correct) (=> (= (ControlFlow 0 168683) 168689) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon111_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon69_correct  (=> (and (= $abort_code@14@@0 $abort_code@10@@0) (= (ControlFlow 0 168671) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon113_Else_correct  (=> (and (not true) (= (ControlFlow 0 168669) 168671)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon69_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon113_Then_correct  (=> (= (ControlFlow 0 168679) 168671) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon69_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon112_Then_correct  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 168663) 168679) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 168663) 168669) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon113_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon73_correct  (=> (and (= $abort_code@14@@0 $abort_code@12@@0) (= (ControlFlow 0 168651) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon115_Else_correct  (=> (and (not true) (= (ControlFlow 0 168649) 168651)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon73_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon115_Then_correct  (=> (= (ControlFlow 0 168659) 168651) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon73_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon114_Then_correct  (=> $abort_flag@8@@0 (and (=> (= (ControlFlow 0 168643) 168659) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon115_Then_correct) (=> (= (ControlFlow 0 168643) 168649) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon115_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon78_correct  (=> (and (= $abort_code@14@@0 $abort_code@13@@0) (= (ControlFlow 0 168625) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon117_Else_correct  (=> (and (not true) (= (ControlFlow 0 168623) 168625)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon78_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon117_Then_correct  (=> (= (ControlFlow 0 168633) 168625) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon78_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon116_Else_correct  (=> (and (not (|b#$Boolean| inline$$Signature_ed25519_verify$0$res@1)) (= $abort_code@13@@0 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 168617) 168633) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon117_Then_correct) (=> (= (ControlFlow 0 168617) 168623) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon117_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon114_Else_correct  (=> (not $abort_flag@8@@0) (and (=> (= (ControlFlow 0 168605) 168639) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon116_Then_correct) (=> (= (ControlFlow 0 168605) 168617) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon116_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon112_Else_correct  (=> (not $abort_flag@7@@0) (=> (and (and (and (= inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t37@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@8@@0)) (and (=> $abort_flag@8@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@8@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 168599) 168643) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon114_Then_correct) (=> (= (ControlFlow 0 168599) 168605) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon114_Else_correct))))))
(let ((inline$$Signature_ed25519_verify$0$anon0_correct  (=> (= inline$$Signature_ed25519_verify$0$res@1 ($Signature_$ed25519_verify metadata_signature@@0 call3formal@$ret0@0@@2 call5formal@$ret0@0)) (and (=> (= (ControlFlow 0 168581) 168663) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon112_Then_correct) (=> (= (ControlFlow 0 168581) 168599) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon112_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon110_Else_correct  (=> (and (not $abort_flag@7@@0) (= (ControlFlow 0 168587) 168581)) inline$$Signature_ed25519_verify$0$anon0_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon108_Then_correct  (=> (|b#$Boolean| inline$$Not$1$dst@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7@@0) (=> $abort_flag@7@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call5formal@$ret0@0 ($DualAttestation_spec_dual_attestation_message payer@@1 metadata@@1 deposit_value@@0))))) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@18 T@$Value) )  (=> ((_ is $Address) addr1@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@18)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@18)))))))))))))) (=> (and (and (and (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@19 T@$Value) )  (=> ((_ is $Address) addr1@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@19))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@19))))))))))))))) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (and (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@20 T@$Value) )  (=> ((_ is $Address) addr1@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@20)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@20)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@20)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@21 T@$Value) )  (=> ((_ is $Address) addr1@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@21)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@21)))) $DualAttestation_Credential_base_url)))))))))))))) (and (and ((_ is $Vector) call5formal@$ret0@0) (let ((va@@51 (|v#$Vector| call5formal@$ret0@0)))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $$0@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $$0@@19))
)))) (and (=> (= (ControlFlow 0 168525) 168683) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon110_Then_correct) (=> (= (ControlFlow 0 168525) 168587) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon110_Else_correct)))))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon62_correct  (=> (and (= $abort_code@14@@0 $abort_code@11@@0) (= (ControlFlow 0 168511) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon109_Else_correct  (=> (and (not true) (= (ControlFlow 0 168509) 168511)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon62_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon109_Then_correct  (=> (= (ControlFlow 0 168519) 168511) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon62_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon108_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= $abort_code@11@@0 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 168503) 168519) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 168503) 168509) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon109_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon106_Else_correct  (=> (not $abort_flag@6@@0) (and (=> (= (ControlFlow 0 168491) 168525) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon108_Then_correct) (=> (= (ControlFlow 0 168491) 168503) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon108_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon104_Else$1_correct  (=> (and (and (and (= inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t34@1 ($Integer 6)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@0)) (and (=> $abort_flag@6@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 168485) 168703) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon106_Then_correct) (=> (= (ControlFlow 0 168485) 168491) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon106_Else_correct)))))
(let ((inline$$Not$1$anon0_correct  (=> (and (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Vector_is_empty$1$b@1)))) (= (ControlFlow 0 168473) 168485)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon104_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 168463) (- 0 206538)) true) (=> (= (ControlFlow 0 168463) 168473) inline$$Not$1$anon0_correct))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon104_Else_correct  (=> (and (not $abort_flag@5@@0) (= (ControlFlow 0 168479) 168463)) inline$$Not$1$Entry_correct)))
(let ((inline$$Vector_is_empty$1$anon0_correct  (=> (and ((_ is $Vector) call3formal@$ret0@0@@4) (= inline$$Vector_is_empty$1$b@1 ($Boolean (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@4)) 0)))) (and (=> (= (ControlFlow 0 168417) 168723) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 168417) 168479) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon104_Else_correct)))))
(let ((inline$$Vector_is_empty$1$Entry_correct  (=> (and (= inline$$Vector_is_empty$1$ta@0 $IntegerType) (= (ControlFlow 0 168401) 168417)) inline$$Vector_is_empty$1$anon0_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon102_Else_correct  (=> (and (not $abort_flag@5@@0) (= (ControlFlow 0 168423) 168401)) inline$$Vector_is_empty$1$Entry_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon100_Else_correct  (=> (and (not $abort_flag@4@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5))))))) $abort_flag@5@@0)) (=> (and (and (=> $abort_flag@5@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5)))))))) (=> $abort_flag@5@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5))))))) (= $abort_code@8@@0 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5)))) $DualAttestation_Credential_base_url))))) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@22 T@$Value) )  (=> ((_ is $Address) addr1@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@22)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@22)))))))))))))) (=> (and (and (and (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@23 T@$Value) )  (=> ((_ is $Address) addr1@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@23))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@23))))))))))))))) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (and (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@24 T@$Value) )  (=> ((_ is $Address) addr1@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@24)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@24)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@25 T@$Value) )  (=> ((_ is $Address) addr1@@25) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@25)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@25)))) $DualAttestation_Credential_base_url)))))))))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@4) (let ((va@@52 (|v#$Vector| call3formal@$ret0@0@@4)))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (forall (($$0@@20 Int) ) (!  (=> (and (>= $$0@@20 0) (< $$0@@20 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@4)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@4)) $$0@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@4)) $$0@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@4)) $$0@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@4)) $$0@@20))
)))) (and (=> (= (ControlFlow 0 168354) 168743) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 168354) 168423) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon102_Else_correct)))))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon98_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@1) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@1)) (=> (and (and (and (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0)))))) (and (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@26 T@$Value) )  (=> ((_ is $Address) addr1@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@26)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@26)))))))))))) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@27 T@$Value) )  (=> ((_ is $Address) addr1@@27) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@27))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@27))))))))))))))))) (and (and (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@28 T@$Value) )  (=> ((_ is $Address) addr1@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@28)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@28)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@28)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (and (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@29 T@$Value) )  (=> ((_ is $Address) addr1@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@29)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@29)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@29)))) $DualAttestation_Credential_base_url)))))))))))) ((_ is $Address) call3formal@$ret0@0@@5)))) (and (=> (= (ControlFlow 0 168348) 168763) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 168348) 168354) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon100_Else_correct))))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon42_correct  (=> (and (= $abort_code@14@@0 $abort_code@7@@0) (= (ControlFlow 0 168334) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 168332) 168334)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon42_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon99_Then_correct  (=> (= (ControlFlow 0 168342) 168334) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon42_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon98_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@1)) (= $abort_code@7@@0 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 168326) 168342) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 168326) 168332) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon99_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon96_Else_correct  (=> (not $abort_flag@3@@1) (and (=> (= (ControlFlow 0 168314) 168348) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 168314) 168326) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon98_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon94_Else$1_correct  (=> (and (and (and (= inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t29@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@1)) (and (=> $abort_flag@3@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 168308) 168783) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 168308) 168314) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@1  (=> (and (= inline$$Not$0$dst@1@@1 ($Boolean  (not (|b#$Boolean| inline$$Vector_is_empty$0$b@1@@0)))) (= (ControlFlow 0 168296) 168308)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon94_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 168286) (- 0 205687)) true) (=> (= (ControlFlow 0 168286) 168296) inline$$Not$0$anon0_correct@@1))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon94_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 168302) 168286)) inline$$Not$0$Entry_correct@@1)))
(let ((inline$$Vector_is_empty$0$anon0_correct@@0  (=> (and ((_ is $Vector) call3formal@$ret0@0@@2) (= inline$$Vector_is_empty$0$b@1@@0 ($Boolean (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@2)) 0)))) (and (=> (= (ControlFlow 0 168240) 168803) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 168240) 168302) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$Vector_is_empty$0$Entry_correct@@0  (=> (and (= inline$$Vector_is_empty$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 168224) 168240)) inline$$Vector_is_empty$0$anon0_correct@@0)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon92_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 168246) 168224)) inline$$Vector_is_empty$0$Entry_correct@@0)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon90_Else_correct  (=> (and (not $abort_flag@1@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7))))))) $abort_flag@2@@1)) (=> (and (and (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))))))) (=> $abort_flag@2@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7))))))) (= $abort_code@4@@1 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) $DualAttestation_Credential_compliance_public_key))))) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@30 T@$Value) )  (=> ((_ is $Address) addr1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@30)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@30)))))))))))))) (=> (and (and (and (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@31 T@$Value) )  (=> ((_ is $Address) addr1@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@31))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@31))))))))))))))) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (and (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@32 T@$Value) )  (=> ((_ is $Address) addr1@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@32)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@32)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@32)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@33 T@$Value) )  (=> ((_ is $Address) addr1@@33) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@33)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@33)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@33)))) $DualAttestation_Credential_base_url)))))))))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@2) (let ((va@@53 (|v#$Vector| call3formal@$ret0@0@@2)))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
)))))) (forall (($$0@@21 Int) ) (!  (=> (and (>= $$0@@21 0) (< $$0@@21 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@2)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@2)) $$0@@21)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@2)) $$0@@21)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@2)) $$0@@21)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@2)) $$0@@21))
)))) (and (=> (= (ControlFlow 0 168177) 168823) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 168177) 168246) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon92_Else_correct)))))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon88_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t23@1) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (=> (and (and (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) payee@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@0)))) $VASP_ChildVASP_parent_vasp_addr)) payee@@0)))))) (and (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@34 T@$Value) )  (=> ((_ is $Address) addr1@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@34)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@34)))))))))))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@35 T@$Value) )  (=> ((_ is $Address) addr1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@35))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@35))))))))))))))))) (and (and (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@36 T@$Value) )  (=> ((_ is $Address) addr1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@36)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@36)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@36)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (and (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@37 T@$Value) )  (=> ((_ is $Address) addr1@@37) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@37)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@37)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@37)))) $DualAttestation_Credential_base_url)))))))))))) ((_ is $Address) call3formal@$ret0@0@@7)))) (and (=> (= (ControlFlow 0 168171) 168843) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 168171) 168177) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon90_Else_correct))))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon22_correct  (=> (and (= $abort_code@14@@0 $abort_code@3@@1) (= (ControlFlow 0 168153) 168157)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 168151) 168153)) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon22_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon89_Then_correct  (=> (= (ControlFlow 0 168165) 168153) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon22_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon88_Else_correct  (=> (and (not (|b#$Boolean| inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t23@1)) (= $abort_code@3@@1 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 168145) 168165) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 168145) 168151) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon86_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 168133) 168171) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 168133) 168145) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon84_Else_correct  (=> (not false) (=> (and (= inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t22@1 ($Integer 64)) (= inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t23@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1 inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t22@1)))) (=> (and (and (and (= inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$$t24@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1)) (and (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 168127) 168863) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 168127) 168133) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon86_Else_correct)))))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon84_Then_correct true))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) metadata_signature@@0) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature@@0))))) (and (=> (= (ControlFlow 0 168097) 168883) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 168097) 168127) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $IntegerType) (= (ControlFlow 0 168085) 168097)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 167876) 168085)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon83_Then_correct  (=> (= (ControlFlow 0 168907) 168085) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon82_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 167868) 168907) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 167868) 167876) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon82_Then_correct  (and (=> (= (ControlFlow 0 168915) 168907) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 168915) 167876) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon83_Else_correct))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon81_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 167860) 168915) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 167860) 167868) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon81_Then_correct  (and (=> (= (ControlFlow 0 168923) 168915) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 168923) 167868) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon82_Else_correct))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon80_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 167852) 168923) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 167852) 167860) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon80_Then_correct  (and (=> (= (ControlFlow 0 168931) 168923) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 168931) 167860) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon81_Else_correct))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon79_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 167844) 168931) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 167844) 167852) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon79_Then_correct  (and (=> (= (ControlFlow 0 168939) 168931) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 168939) 167852) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon80_Else_correct))))
(let ((inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 167838) 168939) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 167838) 167844) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon79_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@54 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@55 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))
))) (=> (and (and (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@56 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_human_name)) (let ((va@@57 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_human_name))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
))))))) (forall (($$0@@22 Int) ) (!  (=> (and (>= $$0@@22 0) (< $$0@@22 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_human_name))) $$0@@22)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_human_name))) $$0@@22)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_human_name))) $$0@@22)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_human_name))) $$0@@22))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
))))))) (forall (($$0@@23 Int) ) (!  (=> (and (>= $$0@@23 0) (< $$0@@23 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url))) $$0@@23)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url))) $$0@@23)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url))) $$0@@23)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url))) $$0@@23))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
))))))) (forall (($$0@@24 Int) ) (!  (=> (and (>= $$0@@24 0) (< $$0@@24 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_public_key))) $$0@@24)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_public_key))) $$0@@24)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_public_key))) $$0@@24)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_public_key))) $$0@@24))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@60 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@61 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
))))))) (forall (($$0@@25 Int) ) (!  (=> (and (>= $$0@@25 0) (< $$0@@25 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@25)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@25)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@25)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@25))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@62 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@63 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
))))))) (forall (($$0@@26 Int) ) (!  (=> (and (>= $$0@@26 0) (< $$0@@26 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@26)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@26)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@26)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@26))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@10))
)) (|b#$Boolean| ($Boolean (forall ((child_addr@@0 T@$Value) )  (=> ((_ is $Address) child_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr1@@38 T@$Value) )  (=> ((_ is $Address) addr1@@38) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@38)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@38)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@38)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@38)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@38)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 168943) 167838))) inline$$DualAttestation_assert_signature_is_valid_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) payer@@1) ((_ is $Address) payee@@0)) (=> (and (and (and (and ((_ is $Vector) metadata_signature@@0) (let ((va@@64 (|v#$Vector| metadata_signature@@0)))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
)))))) (forall (($$0@@27 Int) ) (!  (=> (and (>= $$0@@27 0) (< $$0@@27 (|l#$ValueArray| (|v#$Vector| metadata_signature@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature@@0)) $$0@@27)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature@@0)) $$0@@27)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature@@0)) $$0@@27)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature@@0)) $$0@@27))
))) (and (and ((_ is $Vector) metadata@@1) (let ((va@@65 (|v#$Vector| metadata@@1)))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
)))))) (forall (($$0@@28 Int) ) (!  (=> (and (>= $$0@@28 0) (< $$0@@28 (|l#$ValueArray| (|v#$Vector| metadata@@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@1)) $$0@@28)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@1)) $$0@@28)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@1)) $$0@@28)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@1)) $$0@@28))
)))) (and (and (and ((_ is $Integer) deposit_value@@0) (>= (|i#$Integer| deposit_value@@0) 0)) (<= (|i#$Integer| deposit_value@@0) $MAX_U64)) (= (ControlFlow 0 166525) 168943))) anon0$1_correct@@1))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 201439) 166525) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun addr () T@$Value)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun inline$$DualAttestation_base_url_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2@@0 () T@$Value)
(declare-fun inline$$DualAttestation_base_url_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun inline$$DualAttestation_base_url_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$DualAttestation_base_url_$def_verify$0$$t5@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 207912) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 170031) (- 0 208877)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) $abort_flag@2@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) $abort_flag@2@@2) (and (=> (= (ControlFlow 0 170031) (- 0 208894)) (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))))) (=> (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr)))))))) (and (=> (= (ControlFlow 0 170031) (- 0 208911)) (=> $abort_flag@2@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) (= $abort_code@5@@2 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) (= $abort_code@5@@2 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 170031) (- 0 208939)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_base_url_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $DualAttestation_Credential_base_url)))))) (=> (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_base_url_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $DualAttestation_Credential_base_url))))) (and (=> (= (ControlFlow 0 170031) (- 0 208963)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@39 T@$Value) )  (=> ((_ is $Address) addr1@@39) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@39)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@39))))))))))))) (=> (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@40 T@$Value) )  (=> ((_ is $Address) addr1@@40) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@40)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@40)))))))))))) (and (=> (= (ControlFlow 0 170031) (- 0 209003)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@41 T@$Value) )  (=> ((_ is $Address) addr1@@41) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@41))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@41)))))))))))))))) (=> (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@42 T@$Value) )  (=> ((_ is $Address) addr1@@42) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@42))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@42))))))))))))))) (and (=> (= (ControlFlow 0 170031) (- 0 209055)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 170031) (- 0 209086)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@43 T@$Value) )  (=> ((_ is $Address) addr1@@43) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@43)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@43)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@43)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@44 T@$Value) )  (=> ((_ is $Address) addr1@@44) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@44)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@44)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@44)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 170031) (- 0 209148)) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@45 T@$Value) )  (=> ((_ is $Address) addr1@@45) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@45)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@45)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@45)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@5@@2 $abort_code@3@@2) (= inline$$DualAttestation_base_url_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1@@0)) (and (= $abort_flag@2@@2 $abort_flag@1@@2) (= (ControlFlow 0 169967) 170031))) anon0$2_correct@@2)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 169965) 169967)) inline$$DualAttestation_base_url_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 169975) 169967) inline$$DualAttestation_base_url_$def_verify$0$anon16_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $DualAttestation_Credential_base_url)) (and (=> (= (ControlFlow 0 169949) 169975) inline$$DualAttestation_base_url_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 169949) 169965) inline$$DualAttestation_base_url_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 169955) 169949)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$Abort_correct  (=> (= inline$$DualAttestation_base_url_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@5@@2 $abort_code@4@@2) (= inline$$DualAttestation_base_url_$def_verify$0$$ret0@2 inline$$DualAttestation_base_url_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@2 true) (= (ControlFlow 0 169714) 170031))) anon0$2_correct@@2))))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@2 $abort_code@1@@2) (= (ControlFlow 0 170007) 169714)) inline$$DualAttestation_base_url_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 170005) 170007)) inline$$DualAttestation_base_url_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 170015) 170007) inline$$DualAttestation_base_url_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 169999) 170015) inline$$DualAttestation_base_url_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 169999) 170005) inline$$DualAttestation_base_url_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon13_correct  (=> (and (= $abort_code@4@@2 $abort_code@3@@2) (= (ControlFlow 0 169987) 169714)) inline$$DualAttestation_base_url_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 169985) 169987)) inline$$DualAttestation_base_url_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 169995) 169987) inline$$DualAttestation_base_url_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 169979) 169995) inline$$DualAttestation_base_url_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 169979) 169985) inline$$DualAttestation_base_url_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@1@@2 true) (=> (and (= $abort_code@3@@2 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 169895) 169979) inline$$DualAttestation_base_url_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 169895) 169955) inline$$DualAttestation_base_url_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 169893) 169895)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0) (=> (and (and (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr))) (= $abort_flag@1@@2 $abort_flag@0@@2)) (and (= $abort_code@3@@2 $abort_code@1@@2) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 169841) 169979) inline$$DualAttestation_base_url_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 169841) 169955) inline$$DualAttestation_base_url_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 169823) 169893) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 169823) 169841) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 169817) (- 0 208683)) true) (=> (= (ControlFlow 0 169817) 169823) inline$$GetGlobal$0$anon0_correct@@0))))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_base_url_$def_verify$0$$t4@1) (= (ControlFlow 0 169901) 169817)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon10_correct  (=> (and (= $abort_code@4@@2 $abort_code@2@@2) (= (ControlFlow 0 169708) 169714)) inline$$DualAttestation_base_url_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 169706) 169708)) inline$$DualAttestation_base_url_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 169722) 169708) inline$$DualAttestation_base_url_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$DualAttestation_base_url_$def_verify$0$$t4@1)) (= $abort_code@2@@2 (|i#$Integer| call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 169700) 169722) inline$$DualAttestation_base_url_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 169700) 169706) inline$$DualAttestation_base_url_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 169688) 169901) inline$$DualAttestation_base_url_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 169688) 169700) inline$$DualAttestation_base_url_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon2$1_correct  (=> (= inline$$DualAttestation_base_url_$def_verify$0$$t4@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (=> (and (and (and (= inline$$DualAttestation_base_url_$def_verify$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2)) (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 169682) 169999) inline$$DualAttestation_base_url_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 169682) 169688) inline$$DualAttestation_base_url_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 169634) 169682)) inline$$DualAttestation_base_url_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 170023) 169682) inline$$DualAttestation_base_url_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_base_url_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 169628) 170023) inline$$DualAttestation_base_url_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 169628) 169634) inline$$DualAttestation_base_url_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@66 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_human_name)) (let ((va@@67 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_human_name))))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
))))))) (forall (($$0@@29 Int) ) (!  (=> (and (>= $$0@@29 0) (< $$0@@29 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_human_name))) $$0@@29)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_human_name))) $$0@@29)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_human_name))) $$0@@29)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_human_name))) $$0@@29))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url)) (let ((va@@68 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url))))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
))))))) (forall (($$0@@30 Int) ) (!  (=> (and (>= $$0@@30 0) (< $$0@@30 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url))) $$0@@30)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url))) $$0@@30)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url))) $$0@@30)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url))) $$0@@30))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@69 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
))))))) (forall (($$0@@31 Int) ) (!  (=> (and (>= $$0@@31 0) (< $$0@@31 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_public_key))) $$0@@31)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_public_key))) $$0@@31)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_public_key))) $$0@@31)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_public_key))) $$0@@31))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@70 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@71 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
))))))) (forall (($$0@@32 Int) ) (!  (=> (and (>= $$0@@32 0) (< $$0@@32 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@32)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@32)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@32)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@32))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@72 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@73 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@73 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73))
))))))) (forall (($$0@@33 Int) ) (!  (=> (and (>= $$0@@33 0) (< $$0@@33 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@33)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@33)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@33)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@33))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@11))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((addr1@@46 T@$Value) )  (=> ((_ is $Address) addr1@@46) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@46)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@46)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@46)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@46)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@46)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 170029) 169628)) inline$$DualAttestation_base_url_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 169251) 170029)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 207912) 169251) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun addr@@0 () T@$Value)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun inline$$DualAttestation_compliance_public_key_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2@@1 () T@$Value)
(declare-fun inline$$DualAttestation_compliance_public_key_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0@@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@1 () T@$Value)
(declare-fun inline$$DualAttestation_compliance_public_key_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$DualAttestation_compliance_public_key_$def_verify$0$$t5@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 209215) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 170949) (- 0 210174)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))))))) $abort_flag@2@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))))))) $abort_flag@2@@3) (and (=> (= (ControlFlow 0 170949) (- 0 210191)) (=> $abort_flag@2@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))))))))) (=> (=> $abort_flag@2@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))))))) (and (=> (= (ControlFlow 0 170949) (- 0 210208)) (=> $abort_flag@2@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))))))) (= $abort_code@5@@3 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))))))) (= $abort_code@5@@3 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 170949) (- 0 210236)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_compliance_public_key_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DualAttestation_Credential_compliance_public_key)))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_compliance_public_key_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DualAttestation_Credential_compliance_public_key))))) (and (=> (= (ControlFlow 0 170949) (- 0 210254)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@47 T@$Value) )  (=> ((_ is $Address) addr1@@47) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@47)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@47))))))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@48 T@$Value) )  (=> ((_ is $Address) addr1@@48) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@48)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@48)))))))))))) (and (=> (= (ControlFlow 0 170949) (- 0 210294)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@49 T@$Value) )  (=> ((_ is $Address) addr1@@49) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@49))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@49)))))))))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@50 T@$Value) )  (=> ((_ is $Address) addr1@@50) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@50))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@50))))))))))))))) (and (=> (= (ControlFlow 0 170949) (- 0 210346)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 170949) (- 0 210377)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@51 T@$Value) )  (=> ((_ is $Address) addr1@@51) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@51)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@51)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@51)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@52 T@$Value) )  (=> ((_ is $Address) addr1@@52) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@52)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@52)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@52)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 170949) (- 0 210439)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@53 T@$Value) )  (=> ((_ is $Address) addr1@@53) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@53)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@53)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@53)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@5@@3 $abort_code@3@@3) (= inline$$DualAttestation_compliance_public_key_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1@@1)) (and (= $abort_flag@2@@3 $abort_flag@1@@3) (= (ControlFlow 0 170885) 170949))) anon0$2_correct@@3)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 170883) 170885)) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 170893) 170885) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon16_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@1)) $DualAttestation_Credential_compliance_public_key)) (and (=> (= (ControlFlow 0 170867) 170893) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 170867) 170883) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 170873) 170867)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$Abort_correct  (=> (= inline$$DualAttestation_compliance_public_key_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@5@@3 $abort_code@4@@3) (= inline$$DualAttestation_compliance_public_key_$def_verify$0$$ret0@2 inline$$DualAttestation_compliance_public_key_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@3 true) (= (ControlFlow 0 170632) 170949))) anon0$2_correct@@3))))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@3 $abort_code@1@@3) (= (ControlFlow 0 170925) 170632)) inline$$DualAttestation_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 170923) 170925)) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 170933) 170925) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 170917) 170933) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 170917) 170923) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon13_correct  (=> (and (= $abort_code@4@@3 $abort_code@3@@3) (= (ControlFlow 0 170905) 170632)) inline$$DualAttestation_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 170903) 170905)) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 170913) 170905) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 170897) 170913) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 170897) 170903) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@1@@3 true) (=> (and (= $abort_code@3@@3 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@1 inline$$GetGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 170813) 170897) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 170813) 170873) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@1)) (= (ControlFlow 0 170811) 170813)) inline$$GetGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@1) (=> (and (and (= inline$$GetGlobal$0$dst@1@@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))) (= $abort_flag@1@@3 $abort_flag@0@@3)) (and (= $abort_code@3@@3 $abort_code@1@@3) (= inline$$GetGlobal$0$dst@2@@1 inline$$GetGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 170759) 170897) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 170759) 170873) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@1  (=> (= inline$$GetGlobal$0$a@1@@1 (|a#$Address| addr@@0)) (and (=> (= (ControlFlow 0 170741) 170811) inline$$GetGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 170741) 170759) inline$$GetGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$GetGlobal$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 170735) (- 0 209980)) true) (=> (= (ControlFlow 0 170735) 170741) inline$$GetGlobal$0$anon0_correct@@1))))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_compliance_public_key_$def_verify$0$$t4@1) (= (ControlFlow 0 170819) 170735)) inline$$GetGlobal$0$Entry_correct@@1)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon10_correct  (=> (and (= $abort_code@4@@3 $abort_code@2@@3) (= (ControlFlow 0 170626) 170632)) inline$$DualAttestation_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 170624) 170626)) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 170640) 170626) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$DualAttestation_compliance_public_key_$def_verify$0$$t4@1)) (= $abort_code@2@@3 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 170618) 170640) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 170618) 170624) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0@@3) (and (=> (= (ControlFlow 0 170606) 170819) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 170606) 170618) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon2$1_correct  (=> (= inline$$DualAttestation_compliance_public_key_$def_verify$0$$t4@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (=> (and (and (and (= inline$$DualAttestation_compliance_public_key_$def_verify$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@3)) (and (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 170600) 170917) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 170600) 170606) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 170552) 170600)) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 170941) 170600) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_compliance_public_key_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 170546) 170941) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 170546) 170552) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@12 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12)) (let ((va@@74 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))))
(let ((l@@74 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_human_name)) (let ((va@@75 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_human_name))))
(let ((l@@75 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75))
))))))) (forall (($$0@@34 Int) ) (!  (=> (and (>= $$0@@34 0) (< $$0@@34 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_human_name))) $$0@@34)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_human_name))) $$0@@34)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_human_name))) $$0@@34)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_human_name))) $$0@@34))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url)) (let ((va@@76 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url))))
(let ((l@@76 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@76) (<= l@@76 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@76)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76))
))))))) (forall (($$0@@35 Int) ) (!  (=> (and (>= $$0@@35 0) (< $$0@@35 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url))) $$0@@35)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url))) $$0@@35)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url))) $$0@@35)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url))) $$0@@35))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@77 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@77 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77))
))))))) (forall (($$0@@36 Int) ) (!  (=> (and (>= $$0@@36 0) (< $$0@@36 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_public_key))) $$0@@36)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_public_key))) $$0@@36)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_public_key))) $$0@@36)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_public_key))) $$0@@36))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@78 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@78 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@79 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@79 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79))
))))))) (forall (($$0@@37 Int) ) (!  (=> (and (>= $$0@@37 0) (< $$0@@37 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@37)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@37)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@37)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@37))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@80 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@80 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@80) (<= l@@80 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@80)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@81 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@81 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81))
))))))) (forall (($$0@@38 Int) ) (!  (=> (and (>= $$0@@38 0) (< $$0@@38 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@38)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@38)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@38)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@38))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@12))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((addr1@@54 T@$Value) )  (=> ((_ is $Address) addr1@@54) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@54)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@54)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@54)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@54)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@54)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 170947) 170546)) inline$$DualAttestation_compliance_public_key_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@3  (=> (and ((_ is $Address) addr@@0) (= (ControlFlow 0 170169) 170947)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 209215) 170169) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun inline$$DualAttestation_credential_address_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun addr@@1 () T@$Value)
(declare-fun inline$$DualAttestation_credential_address_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun |inline$$DualAttestation_credential_address_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun $abort_code@2@@4 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 210506) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 171651) (- 0 211598)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2) (and (=> (= (ControlFlow 0 171651) (- 0 211607)) (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 171651) (- 0 211616)) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_credential_address_$def_verify$0$$ret0@2 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) addr@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $VASP_ChildVASP_parent_vasp_addr)) addr@@1)))))) (=> (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_credential_address_$def_verify$0$$ret0@2 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) addr@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $VASP_ChildVASP_parent_vasp_addr)) addr@@1))))) (and (=> (= (ControlFlow 0 171651) (- 0 211636)) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@55 T@$Value) )  (=> ((_ is $Address) addr1@@55) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@55)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@55))))))))))))) (=> (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@56 T@$Value) )  (=> ((_ is $Address) addr1@@56) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@56)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@56)))))))))))) (and (=> (= (ControlFlow 0 171651) (- 0 211676)) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@57 T@$Value) )  (=> ((_ is $Address) addr1@@57) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@57))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@57)))))))))))))))) (=> (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@58 T@$Value) )  (=> ((_ is $Address) addr1@@58) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@58))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@58))))))))))))))) (and (=> (= (ControlFlow 0 171651) (- 0 211728)) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 171651) (- 0 211759)) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@59 T@$Value) )  (=> ((_ is $Address) addr1@@59) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@59)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@59)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@59)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@60 T@$Value) )  (=> ((_ is $Address) addr1@@60) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@60)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@60)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@60)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 171651) (- 0 211821)) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@61 T@$Value) )  (=> ((_ is $Address) addr1@@61) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@61)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@61)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@61)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$Abort_correct  (=> (and (and (= inline$$DualAttestation_credential_address_$def_verify$0$$ret0@1 $Error) (= $abort_flag@3@@2 true)) (and (= inline$$DualAttestation_credential_address_$def_verify$0$$ret0@2 inline$$DualAttestation_credential_address_$def_verify$0$$ret0@1) (= (ControlFlow 0 171607) 171651))) anon0$2_correct@@4)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 171625) 171607)) inline$$DualAttestation_credential_address_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 171635) 171607) inline$$DualAttestation_credential_address_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 171619) 171635) inline$$DualAttestation_credential_address_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 171619) 171625) inline$$DualAttestation_credential_address_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 171599) 171607)) inline$$DualAttestation_credential_address_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 171615) 171607) inline$$DualAttestation_credential_address_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 171593) 171615) inline$$DualAttestation_credential_address_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 171593) 171599) inline$$DualAttestation_credential_address_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon16_correct  (=> (= $abort_flag@3@@2 $abort_flag@2@@4) (=> (and (= inline$$DualAttestation_credential_address_$def_verify$0$$ret0@2 |inline$$DualAttestation_credential_address_$def_verify$0$tmp#$1@1|) (= (ControlFlow 0 171561) 171651)) anon0$2_correct@@4))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 171559) 171561)) inline$$DualAttestation_credential_address_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 171569) 171561) inline$$DualAttestation_credential_address_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@1@@4) (=> (and (= $abort_flag@2@@4 $abort_flag@1@@4) (= |inline$$DualAttestation_credential_address_$def_verify$0$tmp#$1@1| call3formal@$ret0@0@@11)) (and (=> (= (ControlFlow 0 171589) 171569) inline$$DualAttestation_credential_address_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 171589) 171559) inline$$DualAttestation_credential_address_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| call3formal@$ret0@0@@12) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))))))))) $abort_flag@1@@4)) (=> (and (and (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))))))) (=> $abort_flag@1@@4 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))))))))) (= $abort_code@2@@4 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) addr@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $VASP_ChildVASP_parent_vasp_addr)))))) ((_ is $Address) call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 171583) 171593) inline$$DualAttestation_credential_address_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 171583) 171589) inline$$DualAttestation_credential_address_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon14_correct  (=> (and (= $abort_flag@2@@4 $abort_flag@0@@4) (= |inline$$DualAttestation_credential_address_$def_verify$0$tmp#$1@1| addr@@1)) (and (=> (= (ControlFlow 0 171549) 171569) inline$$DualAttestation_credential_address_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 171549) 171559) inline$$DualAttestation_credential_address_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 171547) 171549)) inline$$DualAttestation_credential_address_$def_verify$0$anon14_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 171577) 171549) inline$$DualAttestation_credential_address_$def_verify$0$anon14_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon20_Else_correct  (=> (not (|b#$Boolean| call3formal@$ret0@0@@12)) (and (=> (= (ControlFlow 0 171539) 171577) inline$$DualAttestation_credential_address_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 171539) 171547) inline$$DualAttestation_credential_address_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0@@4) (and (=> (= (ControlFlow 0 171499) 171583) inline$$DualAttestation_credential_address_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 171499) 171539) inline$$DualAttestation_credential_address_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@4) (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))) ((_ is $Boolean) call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 171493) 171619) inline$$DualAttestation_credential_address_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 171493) 171499) inline$$DualAttestation_credential_address_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 171457) 171493)) inline$$DualAttestation_credential_address_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 171643) 171493) inline$$DualAttestation_credential_address_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_credential_address_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 171451) 171643) inline$$DualAttestation_credential_address_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 171451) 171457) inline$$DualAttestation_credential_address_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (and (forall (($inv_addr@@13 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13)) (let ((va@@82 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13))))
(let ((l@@82 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13))
)) (forall (($inv_addr@@14 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14)) (let ((va@@83 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))))
(let ((l@@83 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))
))) (and (|b#$Boolean| ($Boolean (forall ((child_addr@@1 T@$Value) )  (=> ((_ is $Address) child_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@1)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 171649) 171451))) inline$$DualAttestation_credential_address_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) addr@@1) (= (ControlFlow 0 171087) 171649)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 210506) 171087) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@1| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_append$2$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$DualAttestation_dual_attestation_message_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$Vector_append$2$ta@0 () T@$TypeValue)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_append$1$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun call2formal@res@0 () T@$Value)
(declare-fun inline$$Vector_append$1$ta@0 () T@$TypeValue)
(declare-fun call0formal@ta@0 () T@$TypeValue)
(declare-fun deposit_value@@1 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun metadata@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_append$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun call2formal@res@0@@0 () T@$Value)
(declare-fun inline$$Vector_append$0$ta@0 () T@$TypeValue)
(declare-fun call0formal@ta@0@@0 () T@$TypeValue)
(declare-fun payer@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 211890) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 174064) (- 0 213430)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@5)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@5) (and (=> (= (ControlFlow 0 174064) (- 0 213439)) (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 174064) (- 0 213448)) (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@62 T@$Value) )  (=> ((_ is $Address) addr1@@62) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@62)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@62))))))))))))) (=> (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@63 T@$Value) )  (=> ((_ is $Address) addr1@@63) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@63)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@63)))))))))))) (and (=> (= (ControlFlow 0 174064) (- 0 213488)) (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@64 T@$Value) )  (=> ((_ is $Address) addr1@@64) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@64))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@64)))))))))))))))) (=> (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@65 T@$Value) )  (=> ((_ is $Address) addr1@@65) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@65))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@65))))))))))))))) (and (=> (= (ControlFlow 0 174064) (- 0 213540)) (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 174064) (- 0 213571)) (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@66 T@$Value) )  (=> ((_ is $Address) addr1@@66) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@66)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@66)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@66)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@67 T@$Value) )  (=> ((_ is $Address) addr1@@67) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@67)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@67)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@67)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 174064) (- 0 213633)) (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@68 T@$Value) )  (=> ((_ is $Address) addr1@@68) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@68)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@68)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@68)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon30_correct  (=> (and (= $abort_flag@0@@5 false) (= (ControlFlow 0 173910) 174064)) anon0$2_correct@@5)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 173908) 173910)) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon30_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 173918) 173910) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon30_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$2$to'@1|) ($Local 3))) (and (=> (= (ControlFlow 0 173866) 173918) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 173866) 173908) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (and (= (|l#$Mutation| |inline$$WriteRef$2$to'@1|) ($Local 3)) (= |inline$$WritebackToValue$2$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1|) 0 |inline$$WritebackToValue$1$vdst'@2| (|v#$Mutation| |inline$$WriteRef$2$to'@1|)))) (and (=> (= (ControlFlow 0 173892) 173918) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 173892) 173908) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|p#$Mutation| inline$$BorrowLoc$2$dst@1) |inline$$Vector_append$2$v'@1|)) (and (=> (= (ControlFlow 0 173767) 173892) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 173767) 173866) inline$$WritebackToValue$2$anon3_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon43_Else_correct  (=> (and (not false) (= (ControlFlow 0 173773) 173767)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon43_Then_correct true))
(let ((inline$$Vector_append$2$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$2$v@1) (=> (and ((_ is $Vector) inline$$DualAttestation_dual_attestation_message_$def_verify$0$$t13@1) (= |inline$$Vector_append$2$v'@1| ($Vector (let ((m2 (|v#$ValueArray| (|v#$Vector| inline$$DualAttestation_dual_attestation_message_$def_verify$0$$t13@1))))
(let ((l2 (|l#$ValueArray| (|v#$Vector| inline$$DualAttestation_dual_attestation_message_$def_verify$0$$t13@1))))
(let ((m1 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1))))
(let ((l1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1))))
($ValueArray (|lambda#2| 0 (+ l1 l2) l1 m1 m2 l1 $Error) (+ l1 l2))))))))) (and (=> (= (ControlFlow 0 173702) 173922) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 173702) 173773) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$Vector_append$2$Entry_correct  (=> (and (= inline$$Vector_append$2$ta@0 $IntegerType) (= (ControlFlow 0 173686) 173702)) inline$$Vector_append$2$anon0_correct)))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowLoc$2$dst@1)) (= (ControlFlow 0 173631) 173686)) inline$$Vector_append$2$Entry_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon41_Else$3_correct  (=> (and (= inline$$DualAttestation_dual_attestation_message_$def_verify$0$$t13@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 64)) 1 ($Integer 64)) 2 ($Integer 36)) 3 ($Integer 36)) 4 ($Integer 68)) 5 ($Integer 73)) 6 ($Integer 69)) 7 ($Integer 77)) 8 ($Integer 95)) 9 ($Integer 65)) 10 ($Integer 84)) 11 ($Integer 84)) 12 ($Integer 69)) 13 ($Integer 83)) 14 ($Integer 84)) 15 ($Integer 36)) 16 ($Integer 36)) 17 ($Integer 64)) 18 ($Integer 64)) 19))) (= (ControlFlow 0 173637) 173631)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$BorrowLoc$2$anon0_correct  (=> (and (= inline$$BorrowLoc$2$dst@1 ($Mutation ($Local 3) $EmptyPath |inline$$WritebackToValue$1$vdst'@2|)) (= (ControlFlow 0 173431) 173637)) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon41_Else$3_correct)))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$0$vdst'@2|) (= (ControlFlow 0 173349) 173431)) inline$$BorrowLoc$2$anon0_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 3)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1|) 0 |inline$$WritebackToValue$0$vdst'@2| (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 173375) 173431))) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|p#$Mutation| inline$$BorrowLoc$1$dst@1) |inline$$Vector_append$1$v'@1|)) (and (=> (= (ControlFlow 0 173250) 173375) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 173250) 173349) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon41_Else_correct  (=> (and (not false) (= (ControlFlow 0 173256) 173250)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon41_Then_correct true))
(let ((inline$$Vector_append$1$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$1$v@1) (=> (and ((_ is $Vector) call2formal@res@0) (= |inline$$Vector_append$1$v'@1| ($Vector (let ((m2@@0 (|v#$ValueArray| (|v#$Vector| call2formal@res@0))))
(let ((l2@@0 (|l#$ValueArray| (|v#$Vector| call2formal@res@0))))
(let ((m1@@0 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1))))
(let ((l1@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1))))
($ValueArray (|lambda#2| 0 (+ l1@@0 l2@@0) l1@@0 m1@@0 m2@@0 l1@@0 $Error) (+ l1@@0 l2@@0))))))))) (and (=> (= (ControlFlow 0 173185) 173948) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 173185) 173256) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$Vector_append$1$Entry_correct  (=> (and (= inline$$Vector_append$1$ta@0 $IntegerType) (= (ControlFlow 0 173169) 173185)) inline$$Vector_append$1$anon0_correct)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowLoc$1$dst@1)) (= (ControlFlow 0 173114) 173169)) inline$$Vector_append$1$Entry_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon39_Else_correct  (=> (and (not false) (= (ControlFlow 0 173120) 173114)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon39_Then_correct true))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon37_Else$3_correct  (=> (and (= call0formal@ta@0 $IntegerType) (= call2formal@res@0 ($BCS_serialize_core deposit_value@@1))) (=> (and (and ((_ is $Vector) call2formal@res@0) (let ((va@@84 (|v#$Vector| call2formal@res@0)))
(let ((l@@84 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84))
)))))) (forall ((i@@10 Int) ) (!  (=> (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| call2formal@res@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0)) i@@10))
))) (and (=> (= (ControlFlow 0 173078) 173968) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 173078) 173120) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 3) $EmptyPath |inline$$WritebackToValue$0$vdst'@2|)) (= (ControlFlow 0 173070) 173078)) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon37_Else$3_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 3))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| metadata@@2) (= (ControlFlow 0 172988) 173070)) inline$$BorrowLoc$1$anon0_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$0$to'@1|) ($Local 3)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1|) 0 metadata@@2 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 173014) 173070))) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) |inline$$Vector_append$0$v'@1|)) (and (=> (= (ControlFlow 0 172889) 173014) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 172889) 172988) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon37_Else_correct  (=> (and (not false) (= (ControlFlow 0 172895) 172889)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon37_Then_correct true))
(let ((inline$$Vector_append$0$anon0_correct  (=> ((_ is $Vector) inline$$ReadRef$0$v@1) (=> (and ((_ is $Vector) call2formal@res@0@@0) (= |inline$$Vector_append$0$v'@1| ($Vector (let ((m2@@1 (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0))))
(let ((l2@@1 (|l#$ValueArray| (|v#$Vector| call2formal@res@0@@0))))
(let ((m1@@1 (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
(let ((l1@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
($ValueArray (|lambda#2| 0 (+ l1@@1 l2@@1) l1@@1 m1@@1 m2@@1 l1@@1 $Error) (+ l1@@1 l2@@1))))))))) (and (=> (= (ControlFlow 0 172824) 173988) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 172824) 172895) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon37_Else_correct))))))
(let ((inline$$Vector_append$0$Entry_correct  (=> (and (= inline$$Vector_append$0$ta@0 $IntegerType) (= (ControlFlow 0 172808) 172824)) inline$$Vector_append$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 172753) 172808)) inline$$Vector_append$0$Entry_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon35_Else_correct  (=> (and (not false) (= (ControlFlow 0 172759) 172753)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon35_Then_correct true))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon8$1_correct  (=> (and (= call0formal@ta@0@@0 $AddressType) (= call2formal@res@0@@0 ($BCS_serialize_core payer@@2))) (=> (and (and ((_ is $Vector) call2formal@res@0@@0) (let ((va@@85 (|v#$Vector| call2formal@res@0@@0)))
(let ((l@@85 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85))
)))))) (forall ((i@@11 Int) ) (!  (=> (and (<= 0 i@@11) (< i@@11 (|l#$ValueArray| (|v#$Vector| call2formal@res@0@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0)) i@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0)) i@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0)) i@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call2formal@res@0@@0)) i@@11))
))) (and (=> (= (ControlFlow 0 172717) 174008) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 172717) 172759) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 3) $EmptyPath metadata@@2)) (= (ControlFlow 0 172709) 172717)) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon8$1_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 172659) 172709)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 174032) 172709) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 172515) 174032) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 172515) 172659) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 174040) 174032) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 174040) 172659) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon34_Else_correct))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon32_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 172507) 174040) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 172507) 172515) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon32_Then_correct  (and (=> (= (ControlFlow 0 174048) 174040) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 174048) 172515) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon33_Else_correct))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon31_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 172499) 174048) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 172499) 172507) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon31_Then_correct  (and (=> (= (ControlFlow 0 174056) 174048) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 174056) 172507) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon32_Else_correct))))
(let ((inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 172493) 174056) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 172493) 172499) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon31_Else_correct)))))
(let ((anon0_correct@@5  (=> ((_ is $Address) payer@@2) (=> (and (and ((_ is $Vector) metadata@@2) (let ((va@@86 (|v#$Vector| metadata@@2)))
(let ((l@@86 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86))
)))))) (forall (($$0@@39 Int) ) (!  (=> (and (>= $$0@@39 0) (< $$0@@39 (|l#$ValueArray| (|v#$Vector| metadata@@2)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@2)) $$0@@39)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@2)) $$0@@39)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@2)) $$0@@39)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@2)) $$0@@39))
))) (=> (and (and (and ((_ is $Integer) deposit_value@@1) (>= (|i#$Integer| deposit_value@@1) 0)) (<= (|i#$Integer| deposit_value@@1) $MAX_U64)) (= (ControlFlow 0 171805) 172493)) inline$$DualAttestation_dual_attestation_message_$def_verify$0$anon0_correct)))))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 211890) 171805) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@8@@1 () Bool)
(declare-fun $tv0@@10 () T@$TypeValue)
(declare-fun deposit_value@@2 () T@$Value)
(declare-fun $abort_code@10@@1 () Int)
(declare-fun inline$$DualAttestation_dual_attestation_required_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun payer@@3 () T@$Value)
(declare-fun payee@@1 () T@$Value)
(declare-fun $abort_code@2@@5 () Int)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@2 () T@$Value)
(declare-fun inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$DualAttestation_dual_attestation_required_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@9@@1 () Int)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun $abort_flag@2@@5 () Bool)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $abort_flag@7@@1 () Bool)
(declare-fun |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$6@2| () T@$Value)
(declare-fun |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$6@1| () T@$Value)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$5@1| () T@$Value)
(declare-fun $abort_code@5@@4 () Int)
(declare-fun inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t19@1 () T@$Value)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$Ge$0$dst@1 () T@$Value)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun call2formal@$ret0@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 213708) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 176231) (- 0 217010)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 176231) (- 0 217025)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 176231) (- 0 217042)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@8@@1)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@8@@1) (and (=> (= (ControlFlow 0 176231) (- 0 217069)) (=> $abort_flag@8@@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (=> (=> $abort_flag@8@@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> (= (ControlFlow 0 176231) (- 0 217126)) (=> $abort_flag@8@@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 8))))))) (=> (=> $abort_flag@8@@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 8)))))) (=> (= (ControlFlow 0 176231) (- 0 217216)) (=> (not $abort_flag@8@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_dual_attestation_required_$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@3 payee@@1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3)))) payer@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))) payee@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon20_correct  (=> (and (and (= $abort_code@10@@1 $abort_code@2@@5) (= $abort_flag@8@@1 $abort_flag@1@@5)) (and (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$ret0@2 inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t12@1) (= (ControlFlow 0 176143) 176231))) anon0$2_correct@@6)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 176141) 176143)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon20_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 176151) 176143) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon20_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon61_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@2) (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t12@1 ($Boolean false))) (and (=> (= (ControlFlow 0 176135) 176151) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 176135) 176141) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon24_correct  (=> (and (and (= $abort_code@10@@1 $abort_code@2@@5) (= $abort_flag@8@@1 $abort_flag@1@@5)) (and (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$ret0@2 inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t14@1) (= (ControlFlow 0 176115) 176231))) anon0$2_correct@@6)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 176113) 176115)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon24_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 176123) 176115) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon24_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon63_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t13@1) (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t14@1 ($Boolean false))) (and (=> (= (ControlFlow 0 176107) 176123) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 176107) 176113) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$Abort_correct  (=> (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@10@@1 $abort_code@9@@1) (= $abort_flag@8@@1 true)) (and (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$ret0@2 inline$$DualAttestation_dual_attestation_required_$def_verify$0$$ret0@1) (= (ControlFlow 0 176007) 176231))) anon0$2_correct@@6))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon9_correct  (=> (and (= $abort_code@9@@1 $abort_code@1@@4) (= (ControlFlow 0 176191) 176007)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 176189) 176191)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon9_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 176199) 176191) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon9_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon56_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 176183) 176199) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 176183) 176189) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon13_correct  (=> (and (= $abort_code@9@@1 $abort_code@2@@5) (= (ControlFlow 0 176171) 176007)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 176169) 176171)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 176179) 176171) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon58_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 176163) 176179) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 176163) 176169) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon27_correct  (=> (and (= $abort_code@9@@1 $abort_code@3@@4) (= (ControlFlow 0 176087) 176007)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 176085) 176087)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon27_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 176095) 176087) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon27_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon65_Then_correct  (=> $abort_flag@2@@5 (and (=> (= (ControlFlow 0 176079) 176095) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 176079) 176085) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon33_correct  (=> (and (= $abort_code@9@@1 $abort_code@4@@4) (= (ControlFlow 0 176067) 176007)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 176065) 176067)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon33_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 176075) 176067) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon33_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon68_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 176059) 176075) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 176059) 176065) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon41_correct  (=> (and (= $abort_code@9@@1 $abort_code@6@@2) (= (ControlFlow 0 176027) 176007)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 176025) 176027)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon41_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon73_Then_correct  (=> (= (ControlFlow 0 176035) 176027) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon41_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon72_Then_correct  (=> $abort_flag@5@@1 (and (=> (= (ControlFlow 0 176019) 176035) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 176019) 176025) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon45_correct  (=> (and (= $abort_code@9@@1 $abort_code@7@@1) (= (ControlFlow 0 176001) 176007)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 175999) 176001)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon45_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon75_Then_correct  (=> (= (ControlFlow 0 176015) 176001) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon45_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon74_Then_correct  (=> $abort_flag@6@@1 (and (=> (= (ControlFlow 0 175993) 176015) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 175993) 175999) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon52_correct  (=> (and (and (= $abort_code@10@@1 $abort_code@8@@1) (= $abort_flag@8@@1 $abort_flag@7@@1)) (and (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$ret0@2 |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$6@2|) (= (ControlFlow 0 175929) 176231))) anon0$2_correct@@6)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 175927) 175929)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon52_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon78_Then_correct  (=> (= (ControlFlow 0 175937) 175929) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon52_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon48_correct  (=> (= $abort_code@8@@1 $abort_code@7@@1) (=> (and (= |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$6@2| |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$6@1|) (= $abort_flag@7@@1 $abort_flag@6@@1)) (and (=> (= (ControlFlow 0 175981) 175937) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 175981) 175927) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon78_Else_correct))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 175979) 175981)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon48_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 175989) 175981) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon48_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon74_Else_correct  (=> (and (not $abort_flag@6@@1) (= |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$6@1| ($Boolean  (not ($IsEqual_stratified call3formal@$ret0@0@@13 call3formal@$ret0@0@@14))))) (and (=> (= (ControlFlow 0 175973) 175989) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 175973) 175979) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon72_Else_correct  (=> (and (not $abort_flag@5@@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))))))))) $abort_flag@6@@1)) (=> (and (and (=> $abort_flag@6@@1 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1))))))))))) (=> $abort_flag@6@@1 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))))))))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))) payee@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))) $VASP_ChildVASP_parent_vasp_addr)))))) ((_ is $Address) call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 175957) 175993) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 175957) 175973) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon74_Else_correct))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon71_Then_correct  (=> (and (|b#$Boolean| |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$5@1|) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3)))))))))) $abort_flag@5@@1)) (=> (and (and (=> $abort_flag@5@@1 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3))))))))))) (=> $abort_flag@5@@1 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3)))))))))) (= $abort_code@6@@2 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3)))) payer@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3)))) $VASP_ChildVASP_parent_vasp_addr)))))) ((_ is $Address) call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 175951) 176019) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 175951) 175957) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon72_Else_correct))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon50_correct  (=> (= $abort_code@8@@1 $abort_code@5@@4) (=> (and (= |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$6@2| inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t19@1) (= $abort_flag@7@@1 $abort_flag@4@@2)) (and (=> (= (ControlFlow 0 175917) 175937) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 175917) 175927) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon78_Else_correct))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon77_Else_correct  (=> (and (not true) (= (ControlFlow 0 175915) 175917)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon50_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon77_Then_correct  (=> (= (ControlFlow 0 175945) 175917) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon50_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon71_Else_correct  (=> (and (not (|b#$Boolean| |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$5@1|)) (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t19@1 ($Boolean false))) (and (=> (= (ControlFlow 0 175907) 175945) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 175907) 175915) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon68_Else_correct  (=> (and (and (not $abort_flag@3@@3) (= $abort_flag@4@@2 $abort_flag@3@@3)) (and (= $abort_code@5@@4 $abort_code@4@@4) (= |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$5@1| call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 176055) 175951) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 176055) 175907) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon67_Then_correct  (=> (|b#$Boolean| call3formal@$ret0@0@@16) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@3) (=> $abort_flag@3@@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@3@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee@@1)))))))))) ((_ is $Boolean) call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 176049) 176059) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 176049) 176055) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon68_Else_correct))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon36_correct  (=> (= $abort_flag@4@@2 $abort_flag@2@@5) (=> (and (= $abort_code@5@@4 $abort_code@3@@4) (= |inline$$DualAttestation_dual_attestation_required_$def_verify$0$tmp#$5@1| inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t16@1)) (and (=> (= (ControlFlow 0 175861) 175951) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 175861) 175907) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon71_Else_correct))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 175859) 175861)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon36_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 176043) 175861) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon36_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon67_Else_correct  (=> (and (not (|b#$Boolean| call3formal@$ret0@0@@16)) (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t16@1 ($Boolean false))) (and (=> (= (ControlFlow 0 175851) 176043) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 175851) 175859) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon65_Else_correct  (=> (not $abort_flag@2@@5) (and (=> (= (ControlFlow 0 175807) 176049) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 175807) 175851) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon63_Else_correct  (=> (not (|b#$Boolean| inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t13@1)) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@5) (=> $abort_flag@2@@5 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@3)))))))))) ((_ is $Boolean) call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 175801) 176079) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 175801) 175807) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon65_Else_correct))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon61_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@2)) (= inline$$DualAttestation_dual_attestation_required_$def_verify$0$$t13@1 ($Boolean ($IsEqual_stratified payer@@3 payee@@1)))) (and (=> (= (ControlFlow 0 175793) 176107) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 175793) 175801) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@2  (=> (= inline$$Not$0$dst@1@@2 ($Boolean  (not (|b#$Boolean| inline$$Ge$0$dst@1)))) (and (=> (= (ControlFlow 0 175769) 176135) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 175769) 175793) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 175759) (- 0 216163)) true) (=> (= (ControlFlow 0 175759) 175769) inline$$Not$0$anon0_correct@@2))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 175725) 175759)) inline$$Not$0$Entry_correct@@2)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 176159) 175759) inline$$Not$0$Entry_correct@@2)))
(let ((inline$$Ge$0$anon0_correct  (=> (= inline$$Ge$0$dst@1 ($Boolean (>= (|i#$Integer| call4formal@$ret0@0) (|i#$Integer| call2formal@$ret0@0)))) (and (=> (= (ControlFlow 0 175711) 176159) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 175711) 175725) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$Ge$0$Entry_correct  (and (=> (= (ControlFlow 0 175697) (- 0 216127)) true) (=> (= (ControlFlow 0 175697) 175711) inline$$Ge$0$anon0_correct))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon58_Else_correct  (=> (and (not $abort_flag@1@@5) (= (ControlFlow 0 175717) 175697)) inline$$Ge$0$Entry_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon56_Else_correct  (=> (and (not $abort_flag@0@@6) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@5)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@1@@5) (=> $abort_flag@1@@5 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (and (=> $abort_flag@1@@5 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2@@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@2@@5 (|i#$Integer| ($Integer 8)))))) (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) deposit_value@@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| deposit_value@@2) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1))))))))))))) (and (and ((_ is $Integer) call4formal@$ret0@0) (>= (|i#$Integer| call4formal@$ret0@0) 0)) (<= (|i#$Integer| call4formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 175649) 176163) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 175649) 175717) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon58_Else_correct))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@6) (=> (and (and (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@6 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@4 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@69 T@$Value) )  (=> ((_ is $Address) addr1@@69) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@69)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@69)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@70 T@$Value) )  (=> ((_ is $Address) addr1@@70) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@70))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@70))))))))))))))) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (and (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@71 T@$Value) )  (=> ((_ is $Address) addr1@@71) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@71)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@71)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@71)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@72 T@$Value) )  (=> ((_ is $Address) addr1@@72) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@72)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@72)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@72)))) $DualAttestation_Credential_base_url)))))))))))))) (and (and ((_ is $Integer) call2formal@$ret0@0) (>= (|i#$Integer| call2formal@$ret0@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 175643) 176183) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 175643) 175649) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon56_Else_correct)))))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 175539) 175643)) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon6$3_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 176207) 175643) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon6$3_correct)))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon54_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 175531) 176207) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 175531) 175539) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon54_Then_correct  (and (=> (= (ControlFlow 0 176215) 176207) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 176215) 175539) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon55_Else_correct))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon53_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 175523) 176215) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 175523) 175531) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon53_Then_correct  (and (=> (= (ControlFlow 0 176223) 176215) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 176223) 175531) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon54_Else_correct))))
(let ((inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 175517) 176223) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 175517) 175523) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon53_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (and (forall (($inv_addr@@15 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@15)) (let ((va@@87 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@15))))
(let ((l@@87 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@15))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@15))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@15))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@15))) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@15))
)) (forall (($inv_addr@@16 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16)) (let ((va@@88 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))))
(let ((l@@88 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@89 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@89 (|l#$ValueArray| va@@89)))
 (and (and (<= 0 l@@89) (<= l@@89 $MAX_U64)) (forall ((x@@89 Int) ) (!  (=> (or (< x@@89 0) (>= x@@89 l@@89)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_currency_code)) (let ((va@@90 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@90 (|l#$ValueArray| va@@90)))
 (and (and (<= 0 l@@90) (<= l@@90 $MAX_U64)) (forall ((x@@90 Int) ) (!  (=> (or (< x@@90 0) (>= x@@90 l@@90)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90))
))))))) (forall (($$0@@40 Int) ) (!  (=> (and (>= $$0@@40 0) (< $$0@@40 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_currency_code))) $$0@@40)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_currency_code))) $$0@@40)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_currency_code))) $$0@@40)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_currency_code))) $$0@@40))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events)) (let ((va@@91 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@91 (|l#$ValueArray| va@@91)))
 (and (and (<= 0 l@@91) (<= l@@91 $MAX_U64)) (forall ((x@@91 Int) ) (!  (=> (or (< x@@91 0) (>= x@@91 l@@91)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@92 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@92 (|l#$ValueArray| va@@92)))
 (and (and (<= 0 l@@92) (<= l@@92 $MAX_U64)) (forall ((x@@92 Int) ) (!  (=> (or (< x@@92 0) (>= x@@92 l@@92)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92))
))))))) (forall (($$0@@41 Int) ) (!  (=> (and (>= $$0@@41 0) (< $$0@@41 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@41)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@41)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@41)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@41))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events)) (let ((va@@93 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@93 (|l#$ValueArray| va@@93)))
 (and (and (<= 0 l@@93) (<= l@@93 $MAX_U64)) (forall ((x@@93 Int) ) (!  (=> (or (< x@@93 0) (>= x@@93 l@@93)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@94 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@94 (|l#$ValueArray| va@@94)))
 (and (and (<= 0 l@@94) (<= l@@94 $MAX_U64)) (forall ((x@@94 Int) ) (!  (=> (or (< x@@94 0) (>= x@@94 l@@94)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94))
))))))) (forall (($$0@@42 Int) ) (!  (=> (and (>= $$0@@42 0) (< $$0@@42 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@42)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@42)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@42)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@42))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@95 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@95 (|l#$ValueArray| va@@95)))
 (and (and (<= 0 l@@95) (<= l@@95 $MAX_U64)) (forall ((x@@95 Int) ) (!  (=> (or (< x@@95 0) (>= x@@95 l@@95)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@96 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@96 (|l#$ValueArray| va@@96)))
 (and (and (<= 0 l@@96) (<= l@@96 $MAX_U64)) (forall ((x@@96 Int) ) (!  (=> (or (< x@@96 0) (>= x@@96 l@@96)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96))
))))))) (forall (($$0@@43 Int) ) (!  (=> (and (>= $$0@@43 0) (< $$0@@43 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@43)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@43)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@43)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@43))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@97 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@97 (|l#$ValueArray| va@@97)))
 (and (and (<= 0 l@@97) (<= l@@97 $MAX_U64)) (forall ((x@@97 Int) ) (!  (=> (or (< x@@97 0) (>= x@@97 l@@97)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@98 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@98 (|l#$ValueArray| va@@98)))
 (and (and (<= 0 l@@98) (<= l@@98 $MAX_U64)) (forall ((x@@98 Int) ) (!  (=> (or (< x@@98 0) (>= x@@98 l@@98)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98))
))))))) (forall (($$0@@44 Int) ) (!  (=> (and (>= $$0@@44 0) (< $$0@@44 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@44)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@44)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@44)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@44))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@99 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@99 (|l#$ValueArray| va@@99)))
 (and (and (<= 0 l@@99) (<= l@@99 $MAX_U64)) (forall ((x@@99 Int) ) (!  (=> (or (< x@@99 0) (>= x@@99 l@@99)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@100 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@100 (|l#$ValueArray| va@@100)))
 (and (and (<= 0 l@@100) (<= l@@100 $MAX_U64)) (forall ((x@@100 Int) ) (!  (=> (or (< x@@100 0) (>= x@@100 l@@100)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100))
))))))) (forall (($$0@@45 Int) ) (!  (=> (and (>= $$0@@45 0) (< $$0@@45 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@45)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@45)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@45)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@45))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@16))
))) (=> (and (and (and (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@101 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@101 (|l#$ValueArray| va@@101)))
 (and (and (<= 0 l@@101) (<= l@@101 $MAX_U64)) (forall ((x@@101 Int) ) (!  (=> (or (< x@@101 0) (>= x@@101 l@@101)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17))
)) (forall (($inv_addr@@18 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18)) (let ((va@@102 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))))
(let ((l@@102 (|l#$ValueArray| va@@102)))
 (and (and (<= 0 l@@102) (<= l@@102 $MAX_U64)) (forall ((x@@102 Int) ) (!  (=> (or (< x@@102 0) (>= x@@102 l@@102)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))
))) (and (forall (($inv_addr@@19 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@19)) (let ((va@@103 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@19))))
(let ((l@@103 (|l#$ValueArray| va@@103)))
 (and (and (<= 0 l@@103) (<= l@@103 $MAX_U64)) (forall ((x@@103 Int) ) (!  (=> (or (< x@@103 0) (>= x@@103 l@@103)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@19))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DualAttestation_Limit_micro_xdx_limit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DualAttestation_Limit_micro_xdx_limit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DualAttestation_Limit_micro_xdx_limit)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@19))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr3@@1 T@$Value) )  (=> ((_ is $Address) addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((child_addr@@2 T@$Value) )  (=> ((_ is $Address) child_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@2)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 176229) 175517)))) inline$$DualAttestation_dual_attestation_required_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@6  (=> (and ((_ is $Address) payer@@3) ((_ is $Address) payee@@1)) (=> (and (and (and ((_ is $Integer) deposit_value@@2) (>= (|i#$Integer| deposit_value@@2) 0)) (<= (|i#$Integer| deposit_value@@2) $MAX_U64)) (= (ControlFlow 0 174419) 176229)) anon0$1_correct@@5))))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 213708) 174419) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun addr@@2 () T@$Value)
(declare-fun $abort_flag@2@@6 () Bool)
(declare-fun $abort_code@5@@5 () Int)
(declare-fun inline$$DualAttestation_expiration_date_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@3@@5 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@2 () T@$Value)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2@@2 () T@$Value)
(declare-fun inline$$DualAttestation_expiration_date_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4@@5 () Int)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@2 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@2 () T@$Value)
(declare-fun inline$$DualAttestation_expiration_date_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@6 () Int)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$DualAttestation_expiration_date_$def_verify$0$$t5@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 217251) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 177277) (- 0 218216)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2))))))) $abort_flag@2@@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2))))))) $abort_flag@2@@6) (and (=> (= (ControlFlow 0 177277) (- 0 218233)) (=> $abort_flag@2@@6 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2))))))))) (=> (=> $abort_flag@2@@6 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))))))) (and (=> (= (ControlFlow 0 177277) (- 0 218250)) (=> $abort_flag@2@@6 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2))))))) (= $abort_code@5@@5 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2@@6 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2))))))) (= $abort_code@5@@5 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 177277) (- 0 218278)) (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_expiration_date_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $DualAttestation_Credential_expiration_date)))))) (=> (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_expiration_date_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $DualAttestation_Credential_expiration_date))))) (and (=> (= (ControlFlow 0 177277) (- 0 218302)) (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@73 T@$Value) )  (=> ((_ is $Address) addr1@@73) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@73)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@73))))))))))))) (=> (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@74 T@$Value) )  (=> ((_ is $Address) addr1@@74) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@74)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@74)))))))))))) (and (=> (= (ControlFlow 0 177277) (- 0 218342)) (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@75 T@$Value) )  (=> ((_ is $Address) addr1@@75) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@75))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@75)))))))))))))))) (=> (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@76 T@$Value) )  (=> ((_ is $Address) addr1@@76) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@76))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@76))))))))))))))) (and (=> (= (ControlFlow 0 177277) (- 0 218394)) (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 177277) (- 0 218425)) (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@77 T@$Value) )  (=> ((_ is $Address) addr1@@77) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@77)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@77)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@77)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@78 T@$Value) )  (=> ((_ is $Address) addr1@@78) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@78)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@78)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@78)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 177277) (- 0 218487)) (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@79 T@$Value) )  (=> ((_ is $Address) addr1@@79) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@79)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@79)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@79)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@5@@5 $abort_code@3@@5) (= inline$$DualAttestation_expiration_date_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1@@2)) (and (= $abort_flag@2@@6 $abort_flag@1@@6) (= (ControlFlow 0 177213) 177277))) anon0$2_correct@@7)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 177211) 177213)) inline$$DualAttestation_expiration_date_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 177221) 177213) inline$$DualAttestation_expiration_date_$def_verify$0$anon16_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@2  (=> (= inline$$GetFieldFromValue$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@2)) $DualAttestation_Credential_expiration_date)) (and (=> (= (ControlFlow 0 177195) 177221) inline$$DualAttestation_expiration_date_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 177195) 177211) inline$$DualAttestation_expiration_date_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@6) (= (ControlFlow 0 177201) 177195)) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$Abort_correct  (=> (= inline$$DualAttestation_expiration_date_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@5@@5 $abort_code@4@@5) (= inline$$DualAttestation_expiration_date_$def_verify$0$$ret0@2 inline$$DualAttestation_expiration_date_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@6 true) (= (ControlFlow 0 176960) 177277))) anon0$2_correct@@7))))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@5 $abort_code@1@@5) (= (ControlFlow 0 177253) 176960)) inline$$DualAttestation_expiration_date_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 177251) 177253)) inline$$DualAttestation_expiration_date_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 177261) 177253) inline$$DualAttestation_expiration_date_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 177245) 177261) inline$$DualAttestation_expiration_date_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 177245) 177251) inline$$DualAttestation_expiration_date_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon13_correct  (=> (and (= $abort_code@4@@5 $abort_code@3@@5) (= (ControlFlow 0 177233) 176960)) inline$$DualAttestation_expiration_date_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 177231) 177233)) inline$$DualAttestation_expiration_date_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 177241) 177233) inline$$DualAttestation_expiration_date_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 177225) 177241) inline$$DualAttestation_expiration_date_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 177225) 177231) inline$$DualAttestation_expiration_date_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@1@@6 true) (=> (and (= $abort_code@3@@5 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@2 inline$$GetGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 177141) 177225) inline$$DualAttestation_expiration_date_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 177141) 177201) inline$$DualAttestation_expiration_date_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@2)) (= (ControlFlow 0 177139) 177141)) inline$$GetGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@2  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@2) (=> (and (and (= inline$$GetGlobal$0$dst@1@@2 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2))) (= $abort_flag@1@@6 $abort_flag@0@@7)) (and (= $abort_code@3@@5 $abort_code@1@@5) (= inline$$GetGlobal$0$dst@2@@2 inline$$GetGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 177087) 177225) inline$$DualAttestation_expiration_date_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 177087) 177201) inline$$DualAttestation_expiration_date_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@2  (=> (= inline$$GetGlobal$0$a@1@@2 (|a#$Address| addr@@2)) (and (=> (= (ControlFlow 0 177069) 177139) inline$$GetGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 177069) 177087) inline$$GetGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$GetGlobal$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 177063) (- 0 218022)) true) (=> (= (ControlFlow 0 177063) 177069) inline$$GetGlobal$0$anon0_correct@@2))))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_expiration_date_$def_verify$0$$t4@1) (= (ControlFlow 0 177147) 177063)) inline$$GetGlobal$0$Entry_correct@@2)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon10_correct  (=> (and (= $abort_code@4@@5 $abort_code@2@@6) (= (ControlFlow 0 176954) 176960)) inline$$DualAttestation_expiration_date_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 176952) 176954)) inline$$DualAttestation_expiration_date_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 176968) 176954) inline$$DualAttestation_expiration_date_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$DualAttestation_expiration_date_$def_verify$0$$t4@1)) (= $abort_code@2@@6 (|i#$Integer| call3formal@$ret0@0@@17))) (and (=> (= (ControlFlow 0 176946) 176968) inline$$DualAttestation_expiration_date_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 176946) 176952) inline$$DualAttestation_expiration_date_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0@@7) (and (=> (= (ControlFlow 0 176934) 177147) inline$$DualAttestation_expiration_date_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 176934) 176946) inline$$DualAttestation_expiration_date_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon2$1_correct  (=> (= inline$$DualAttestation_expiration_date_$def_verify$0$$t4@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (=> (and (and (and (= inline$$DualAttestation_expiration_date_$def_verify$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@7)) (and (=> $abort_flag@0@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@17) (>= (|i#$Integer| call3formal@$ret0@0@@17) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@17) $MAX_U64))) (and (=> (= (ControlFlow 0 176928) 177245) inline$$DualAttestation_expiration_date_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 176928) 176934) inline$$DualAttestation_expiration_date_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 176880) 176928)) inline$$DualAttestation_expiration_date_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 177269) 176928) inline$$DualAttestation_expiration_date_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_expiration_date_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 176874) 177269) inline$$DualAttestation_expiration_date_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 176874) 176880) inline$$DualAttestation_expiration_date_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (forall (($inv_addr@@20 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20)) (let ((va@@104 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))))
(let ((l@@104 (|l#$ValueArray| va@@104)))
 (and (and (<= 0 l@@104) (<= l@@104 $MAX_U64)) (forall ((x@@104 Int) ) (!  (=> (or (< x@@104 0) (>= x@@104 l@@104)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_human_name)) (let ((va@@105 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_human_name))))
(let ((l@@105 (|l#$ValueArray| va@@105)))
 (and (and (<= 0 l@@105) (<= l@@105 $MAX_U64)) (forall ((x@@105 Int) ) (!  (=> (or (< x@@105 0) (>= x@@105 l@@105)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105))
))))))) (forall (($$0@@46 Int) ) (!  (=> (and (>= $$0@@46 0) (< $$0@@46 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_human_name))) $$0@@46)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_human_name))) $$0@@46)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_human_name))) $$0@@46)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_human_name))) $$0@@46))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url)) (let ((va@@106 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url))))
(let ((l@@106 (|l#$ValueArray| va@@106)))
 (and (and (<= 0 l@@106) (<= l@@106 $MAX_U64)) (forall ((x@@106 Int) ) (!  (=> (or (< x@@106 0) (>= x@@106 l@@106)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106))
))))))) (forall (($$0@@47 Int) ) (!  (=> (and (>= $$0@@47 0) (< $$0@@47 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url))) $$0@@47)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url))) $$0@@47)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url))) $$0@@47)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url))) $$0@@47))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@107 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@107 (|l#$ValueArray| va@@107)))
 (and (and (<= 0 l@@107) (<= l@@107 $MAX_U64)) (forall ((x@@107 Int) ) (!  (=> (or (< x@@107 0) (>= x@@107 l@@107)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107))
))))))) (forall (($$0@@48 Int) ) (!  (=> (and (>= $$0@@48 0) (< $$0@@48 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_public_key))) $$0@@48)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_public_key))) $$0@@48)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_public_key))) $$0@@48)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_public_key))) $$0@@48))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@108 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@108 (|l#$ValueArray| va@@108)))
 (and (and (<= 0 l@@108) (<= l@@108 $MAX_U64)) (forall ((x@@108 Int) ) (!  (=> (or (< x@@108 0) (>= x@@108 l@@108)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@109 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@109 (|l#$ValueArray| va@@109)))
 (and (and (<= 0 l@@109) (<= l@@109 $MAX_U64)) (forall ((x@@109 Int) ) (!  (=> (or (< x@@109 0) (>= x@@109 l@@109)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109))
))))))) (forall (($$0@@49 Int) ) (!  (=> (and (>= $$0@@49 0) (< $$0@@49 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@49)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@49)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@49)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@49))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@110 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@110 (|l#$ValueArray| va@@110)))
 (and (and (<= 0 l@@110) (<= l@@110 $MAX_U64)) (forall ((x@@110 Int) ) (!  (=> (or (< x@@110 0) (>= x@@110 l@@110)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@111 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@111 (|l#$ValueArray| va@@111)))
 (and (and (<= 0 l@@111) (<= l@@111 $MAX_U64)) (forall ((x@@111 Int) ) (!  (=> (or (< x@@111 0) (>= x@@111 l@@111)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111))
))))))) (forall (($$0@@50 Int) ) (!  (=> (and (>= $$0@@50 0) (< $$0@@50 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@50)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@50)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@50)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@50))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@20))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((addr1@@80 T@$Value) )  (=> ((_ is $Address) addr1@@80) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@80)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@80)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@80)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@80)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@80)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 177275) 176874)) inline$$DualAttestation_expiration_date_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@7  (=> (and ((_ is $Address) addr@@2) (= (ControlFlow 0 176497) 177275)) anon0$1_correct@@6)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 217251) 176497) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@7))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@7 () Bool)
(declare-fun $abort_code@5@@6 () Int)
(declare-fun inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@3@@6 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@3 () T@$Value)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2@@3 () T@$Value)
(declare-fun inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4@@6 () Int)
(declare-fun $abort_code@1@@6 () Int)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0@@3 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@3 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@3 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$t3@1 () T@$Value)
(declare-fun $abort_code@2@@7 () Int)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(declare-fun inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$t4@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 218553) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 178394) (- 0 219577)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@7) (and (=> (= (ControlFlow 0 178394) (- 0 219592)) (=> $abort_flag@2@@7 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@2@@7 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 178394) (- 0 219607)) (=> $abort_flag@2@@7 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@6 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2@@7 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@6 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 178394) (- 0 219633)) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))) (=> (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (and (=> (= (ControlFlow 0 178394) (- 0 219649)) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@81 T@$Value) )  (=> ((_ is $Address) addr1@@81) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@81)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@81))))))))))))) (=> (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@82 T@$Value) )  (=> ((_ is $Address) addr1@@82) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@82)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@82)))))))))))) (and (=> (= (ControlFlow 0 178394) (- 0 219689)) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@83 T@$Value) )  (=> ((_ is $Address) addr1@@83) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@83))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@83)))))))))))))))) (=> (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@84 T@$Value) )  (=> ((_ is $Address) addr1@@84) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@84))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@84))))))))))))))) (and (=> (= (ControlFlow 0 178394) (- 0 219741)) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 178394) (- 0 219772)) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@85 T@$Value) )  (=> ((_ is $Address) addr1@@85) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@85)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@85)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@85)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@86 T@$Value) )  (=> ((_ is $Address) addr1@@86) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@86)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@86)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@86)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 178394) (- 0 219834)) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@87 T@$Value) )  (=> ((_ is $Address) addr1@@87) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@87)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@87)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@87)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon18_correct  (=> (and (and (= $abort_code@5@@6 $abort_code@3@@6) (= inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1@@3)) (and (= $abort_flag@2@@7 $abort_flag@1@@7) (= (ControlFlow 0 178330) 178394))) anon0$2_correct@@8)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 178328) 178330)) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon18_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 178338) 178330) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon18_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@3  (=> (= inline$$GetFieldFromValue$0$dst@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@3)) $DualAttestation_Limit_micro_xdx_limit)) (and (=> (= (ControlFlow 0 178312) 178338) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 178312) 178328) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1@@7) (= (ControlFlow 0 178318) 178312)) inline$$GetFieldFromValue$0$anon0_correct@@3)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$Abort_correct  (=> (= inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@5@@6 $abort_code@4@@6) (= inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$ret0@2 inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@7 true) (= (ControlFlow 0 177940) 178394))) anon0$2_correct@@8))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@6 $abort_code@1@@6) (= (ControlFlow 0 178374) 177940)) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 178372) 178374)) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 178382) 178374) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@8 (and (=> (= (ControlFlow 0 178366) 178382) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 178366) 178372) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon15_correct  (=> (and (= $abort_code@4@@6 $abort_code@3@@6) (= (ControlFlow 0 178350) 177940)) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 178348) 178350)) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon15_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 178358) 178350) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon15_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@7 (and (=> (= (ControlFlow 0 178342) 178358) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 178342) 178348) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@3  (=> (= $abort_flag@1@@7 true) (=> (and (= $abort_code@3@@6 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@3 inline$$GetGlobal$0$dst@0@@3)) (and (=> (= (ControlFlow 0 178258) 178342) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 178258) 178318) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@3  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@3)) (= (ControlFlow 0 178256) 178258)) inline$$GetGlobal$0$anon3_Then$1_correct@@3)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@3  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@3) (=> (and (and (= inline$$GetGlobal$0$dst@1@@3 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1))) (= $abort_flag@1@@7 $abort_flag@0@@8)) (and (= $abort_code@3@@6 $abort_code@1@@6) (= inline$$GetGlobal$0$dst@2@@3 inline$$GetGlobal$0$dst@1@@3))) (and (=> (= (ControlFlow 0 178204) 178342) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 178204) 178318) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@3  (=> (= inline$$GetGlobal$0$a@1@@3 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 178186) 178256) inline$$GetGlobal$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 178186) 178204) inline$$GetGlobal$0$anon3_Else_correct@@3)))))
(let ((inline$$GetGlobal$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 178180) (- 0 219377)) true) (=> (= (ControlFlow 0 178180) 178186) inline$$GetGlobal$0$anon0_correct@@3))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon24_Else_correct  (=> (and (not $abort_flag@0@@8) (= (ControlFlow 0 178264) 178180)) inline$$GetGlobal$0$Entry_correct@@3)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon24_Then_correct  (=> $abort_flag@0@@8 (=> (and (= $abort_code@4@@6 $abort_code@1@@6) (= (ControlFlow 0 178362) 177940)) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 178059) 178362) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 178059) 178264) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 178069) 178362) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 178069) 178264) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon24_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@0@@8) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 178053) 178069) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 178053) 178059) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon22_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$t3@1) (= (ControlFlow 0 178083) 178053)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon10_correct  (=> (and (= $abort_code@4@@6 $abort_code@2@@7) (= (ControlFlow 0 177934) 177940)) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 177932) 177934)) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 177948) 177934) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon22_Else_correct  (=> (and (not (|b#$Boolean| inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$t3@1)) (= $abort_code@2@@7 (|i#$Integer| call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 177926) 177948) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 177926) 177932) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon20_Else_correct  (=> (not $abort_flag@0@@8) (and (=> (= (ControlFlow 0 177914) 178083) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 177914) 177926) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon19_Else_correct  (=> (and (not false) (= inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$t3@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0))))) (=> (and (and (and (= inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$$t4@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@8)) (and (=> $abort_flag@0@@8 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@18) (>= (|i#$Integer| call3formal@$ret0@0@@18) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@18) $MAX_U64))) (and (=> (= (ControlFlow 0 177908) 178366) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 177908) 177914) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon19_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 177864) 178386) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 177864) 177908) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 177874) 178386) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 177874) 177908) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon19_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 177858) 177874) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 177858) 177864) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 177888) 177858)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0)))
(let ((anon0$1_correct@@7  (=> (forall (($inv_addr@@21 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@21)) (let ((va@@112 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@21))))
(let ((l@@112 (|l#$ValueArray| va@@112)))
 (and (and (<= 0 l@@112) (<= l@@112 $MAX_U64)) (forall ((x@@112 Int) ) (!  (=> (or (< x@@112 0) (>= x@@112 l@@112)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@21))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@21))) $DualAttestation_Limit_micro_xdx_limit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@21))) $DualAttestation_Limit_micro_xdx_limit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@21))) $DualAttestation_Limit_micro_xdx_limit)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@21))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 178392) 177888)) inline$$DualAttestation_get_cur_microdiem_limit_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@8  (=> (= (ControlFlow 0 218553) 178392) anon0$1_correct@@7)))
anon0_correct@@8))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun addr@@3 () T@$Value)
(declare-fun $abort_flag@2@@8 () Bool)
(declare-fun $abort_code@5@@7 () Int)
(declare-fun inline$$DualAttestation_human_name_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@3@@7 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@4 () T@$Value)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2@@4 () T@$Value)
(declare-fun inline$$DualAttestation_human_name_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4@@7 () Int)
(declare-fun $abort_code@1@@7 () Int)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0@@4 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@4 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@4 () T@$Value)
(declare-fun inline$$DualAttestation_human_name_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@8 () Int)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(declare-fun inline$$DualAttestation_human_name_$def_verify$0$$t5@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 219902) (let ((anon0$2_correct@@9  (and (=> (= (ControlFlow 0 179327) (- 0 220867)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))) $abort_flag@2@@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))) $abort_flag@2@@8) (and (=> (= (ControlFlow 0 179327) (- 0 220884)) (=> $abort_flag@2@@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))))) (=> (=> $abort_flag@2@@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))))))) (and (=> (= (ControlFlow 0 179327) (- 0 220901)) (=> $abort_flag@2@@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2@@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 179327) (- 0 220929)) (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_human_name_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $DualAttestation_Credential_human_name)))))) (=> (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DualAttestation_human_name_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $DualAttestation_Credential_human_name))))) (and (=> (= (ControlFlow 0 179327) (- 0 220953)) (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean (forall ((addr1@@88 T@$Value) )  (=> ((_ is $Address) addr1@@88) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@88)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@88))))))))))))) (=> (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean (forall ((addr1@@89 T@$Value) )  (=> ((_ is $Address) addr1@@89) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@89)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@89)))))))))))) (and (=> (= (ControlFlow 0 179327) (- 0 220993)) (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean (forall ((addr1@@90 T@$Value) )  (=> ((_ is $Address) addr1@@90) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@90))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@90)))))))))))))))) (=> (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean (forall ((addr1@@91 T@$Value) )  (=> ((_ is $Address) addr1@@91) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@91))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@91))))))))))))))) (and (=> (= (ControlFlow 0 179327) (- 0 221045)) (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 179327) (- 0 221076)) (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean (forall ((addr1@@92 T@$Value) )  (=> ((_ is $Address) addr1@@92) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@92)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@92)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@92)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean (forall ((addr1@@93 T@$Value) )  (=> ((_ is $Address) addr1@@93) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@93)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@93)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@93)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 179327) (- 0 221138)) (=> (not $abort_flag@2@@8) (|b#$Boolean| ($Boolean (forall ((addr1@@94 T@$Value) )  (=> ((_ is $Address) addr1@@94) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@94)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@94)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@94)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@5@@7 $abort_code@3@@7) (= inline$$DualAttestation_human_name_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1@@4)) (and (= $abort_flag@2@@8 $abort_flag@1@@8) (= (ControlFlow 0 179263) 179327))) anon0$2_correct@@9)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 179261) 179263)) inline$$DualAttestation_human_name_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 179271) 179263) inline$$DualAttestation_human_name_$def_verify$0$anon16_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@4  (=> (= inline$$GetFieldFromValue$0$dst@1@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@4)) $DualAttestation_Credential_human_name)) (and (=> (= (ControlFlow 0 179245) 179271) inline$$DualAttestation_human_name_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 179245) 179261) inline$$DualAttestation_human_name_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@8) (= (ControlFlow 0 179251) 179245)) inline$$GetFieldFromValue$0$anon0_correct@@4)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$Abort_correct  (=> (= inline$$DualAttestation_human_name_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@5@@7 $abort_code@4@@7) (= inline$$DualAttestation_human_name_$def_verify$0$$ret0@2 inline$$DualAttestation_human_name_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@8 true) (= (ControlFlow 0 179010) 179327))) anon0$2_correct@@9))))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@7 $abort_code@1@@7) (= (ControlFlow 0 179303) 179010)) inline$$DualAttestation_human_name_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 179301) 179303)) inline$$DualAttestation_human_name_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 179311) 179303) inline$$DualAttestation_human_name_$def_verify$0$anon5_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 179295) 179311) inline$$DualAttestation_human_name_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 179295) 179301) inline$$DualAttestation_human_name_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon13_correct  (=> (and (= $abort_code@4@@7 $abort_code@3@@7) (= (ControlFlow 0 179283) 179010)) inline$$DualAttestation_human_name_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 179281) 179283)) inline$$DualAttestation_human_name_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 179291) 179283) inline$$DualAttestation_human_name_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@8 (and (=> (= (ControlFlow 0 179275) 179291) inline$$DualAttestation_human_name_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 179275) 179281) inline$$DualAttestation_human_name_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@4  (=> (= $abort_flag@1@@8 true) (=> (and (= $abort_code@3@@7 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@4 inline$$GetGlobal$0$dst@0@@4)) (and (=> (= (ControlFlow 0 179191) 179275) inline$$DualAttestation_human_name_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 179191) 179251) inline$$DualAttestation_human_name_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@4  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@4)) (= (ControlFlow 0 179189) 179191)) inline$$GetGlobal$0$anon3_Then$1_correct@@4)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@4  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@4) (=> (and (and (= inline$$GetGlobal$0$dst@1@@4 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))) (= $abort_flag@1@@8 $abort_flag@0@@9)) (and (= $abort_code@3@@7 $abort_code@1@@7) (= inline$$GetGlobal$0$dst@2@@4 inline$$GetGlobal$0$dst@1@@4))) (and (=> (= (ControlFlow 0 179137) 179275) inline$$DualAttestation_human_name_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 179137) 179251) inline$$DualAttestation_human_name_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@4  (=> (= inline$$GetGlobal$0$a@1@@4 (|a#$Address| addr@@3)) (and (=> (= (ControlFlow 0 179119) 179189) inline$$GetGlobal$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 179119) 179137) inline$$GetGlobal$0$anon3_Else_correct@@4)))))
(let ((inline$$GetGlobal$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 179113) (- 0 220673)) true) (=> (= (ControlFlow 0 179113) 179119) inline$$GetGlobal$0$anon0_correct@@4))))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_human_name_$def_verify$0$$t4@1) (= (ControlFlow 0 179197) 179113)) inline$$GetGlobal$0$Entry_correct@@4)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon10_correct  (=> (and (= $abort_code@4@@7 $abort_code@2@@8) (= (ControlFlow 0 179004) 179010)) inline$$DualAttestation_human_name_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 179002) 179004)) inline$$DualAttestation_human_name_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 179018) 179004) inline$$DualAttestation_human_name_$def_verify$0$anon10_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$DualAttestation_human_name_$def_verify$0$$t4@1)) (= $abort_code@2@@8 (|i#$Integer| call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 178996) 179018) inline$$DualAttestation_human_name_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 178996) 179002) inline$$DualAttestation_human_name_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0@@9) (and (=> (= (ControlFlow 0 178984) 179197) inline$$DualAttestation_human_name_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 178984) 178996) inline$$DualAttestation_human_name_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon2$1_correct  (=> (= inline$$DualAttestation_human_name_$def_verify$0$$t4@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (=> (and (and (and (= inline$$DualAttestation_human_name_$def_verify$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@9)) (and (=> $abort_flag@0@@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@19) (>= (|i#$Integer| call3formal@$ret0@0@@19) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@19) $MAX_U64))) (and (=> (= (ControlFlow 0 178978) 179295) inline$$DualAttestation_human_name_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 178978) 178984) inline$$DualAttestation_human_name_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 178930) 178978)) inline$$DualAttestation_human_name_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 179319) 178978) inline$$DualAttestation_human_name_$def_verify$0$anon2$1_correct)))
(let ((inline$$DualAttestation_human_name_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 178924) 179319) inline$$DualAttestation_human_name_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 178924) 178930) inline$$DualAttestation_human_name_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@8  (=> (forall (($inv_addr@@22 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22)) (let ((va@@113 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))))
(let ((l@@113 (|l#$ValueArray| va@@113)))
 (and (and (<= 0 l@@113) (<= l@@113 $MAX_U64)) (forall ((x@@113 Int) ) (!  (=> (or (< x@@113 0) (>= x@@113 l@@113)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_human_name)) (let ((va@@114 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_human_name))))
(let ((l@@114 (|l#$ValueArray| va@@114)))
 (and (and (<= 0 l@@114) (<= l@@114 $MAX_U64)) (forall ((x@@114 Int) ) (!  (=> (or (< x@@114 0) (>= x@@114 l@@114)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114))
))))))) (forall (($$0@@51 Int) ) (!  (=> (and (>= $$0@@51 0) (< $$0@@51 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_human_name))) $$0@@51)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_human_name))) $$0@@51)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_human_name))) $$0@@51)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_human_name))) $$0@@51))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url)) (let ((va@@115 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url))))
(let ((l@@115 (|l#$ValueArray| va@@115)))
 (and (and (<= 0 l@@115) (<= l@@115 $MAX_U64)) (forall ((x@@115 Int) ) (!  (=> (or (< x@@115 0) (>= x@@115 l@@115)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115))
))))))) (forall (($$0@@52 Int) ) (!  (=> (and (>= $$0@@52 0) (< $$0@@52 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url))) $$0@@52)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url))) $$0@@52)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url))) $$0@@52)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url))) $$0@@52))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@116 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@116 (|l#$ValueArray| va@@116)))
 (and (and (<= 0 l@@116) (<= l@@116 $MAX_U64)) (forall ((x@@116 Int) ) (!  (=> (or (< x@@116 0) (>= x@@116 l@@116)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116))
))))))) (forall (($$0@@53 Int) ) (!  (=> (and (>= $$0@@53 0) (< $$0@@53 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_public_key))) $$0@@53)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_public_key))) $$0@@53)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_public_key))) $$0@@53)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_public_key))) $$0@@53))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@117 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@117 (|l#$ValueArray| va@@117)))
 (and (and (<= 0 l@@117) (<= l@@117 $MAX_U64)) (forall ((x@@117 Int) ) (!  (=> (or (< x@@117 0) (>= x@@117 l@@117)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@118 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@118 (|l#$ValueArray| va@@118)))
 (and (and (<= 0 l@@118) (<= l@@118 $MAX_U64)) (forall ((x@@118 Int) ) (!  (=> (or (< x@@118 0) (>= x@@118 l@@118)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118))
))))))) (forall (($$0@@54 Int) ) (!  (=> (and (>= $$0@@54 0) (< $$0@@54 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@54)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@54)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@54)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@54))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@119 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@119 (|l#$ValueArray| va@@119)))
 (and (and (<= 0 l@@119) (<= l@@119 $MAX_U64)) (forall ((x@@119 Int) ) (!  (=> (or (< x@@119 0) (>= x@@119 l@@119)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@120 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@120 (|l#$ValueArray| va@@120)))
 (and (and (<= 0 l@@120) (<= l@@120 $MAX_U64)) (forall ((x@@120 Int) ) (!  (=> (or (< x@@120 0) (>= x@@120 l@@120)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120))
))))))) (forall (($$0@@55 Int) ) (!  (=> (and (>= $$0@@55 0) (< $$0@@55 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@55)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@55)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@55)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@55))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@22))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((addr1@@95 T@$Value) )  (=> ((_ is $Address) addr1@@95) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@95)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@95)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@95)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@95)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@95)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 179325) 178924)) inline$$DualAttestation_human_name_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@9  (=> (and ((_ is $Address) addr@@3) (= (ControlFlow 0 178547) 179325)) anon0$1_correct@@8)))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 219902) 178547) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@8))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun created () T@$Value)
(declare-fun $abort_flag@5@@2 () Bool)
(declare-fun creator () T@$Value)
(declare-fun $abort_code@8@@2 () Int)
(declare-fun $DualAttestation_Credential_$memory@1 () T@$Memory)
(declare-fun $abort_flag@4@@3 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@6@@3 () Int)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun $DualAttestation_Credential_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@8 () Int)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun $abort_code@2@@9 () Int)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun $abort_code@3@@8 () Int)
(declare-fun $abort_flag@2@@9 () Bool)
(declare-fun $abort_code@4@@8 () Int)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$DualAttestation_Credential_pack$0$$struct@1 () T@$Value)
(declare-fun human_name () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$Vector_empty$1$v@1 () T@$Value)
(declare-fun inline$$DualAttestation_publish_credential_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Not$0$dst@1@@3 () T@$Value)
(declare-fun $abort_code@5@@8 () Int)
(declare-fun call3formal@$ret0@0@@20 () T@$Value)
(declare-fun inline$$DualAttestation_publish_credential_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$DualAttestation_publish_credential_$def_verify$0$$t9@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@21 () T@$Value)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 221206) (let ((anon0$2_correct@@10  (and (=> (= (ControlFlow 0 182071) (- 0 224790)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 182071) (- 0 224811)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 182071) (- 0 224856)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 182071) (- 0 224877)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 182071) (- 0 224906)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creator ($Address 186537453))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creator ($Address 186537453))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 182071) (- 0 224923)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 182071) (- 0 224935)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 182071) (- 0 224956)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 182071) (- 0 225001)) (=> $abort_flag@5@@2 (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creator ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| created))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2))))))))))) (=> (=> $abort_flag@5@@2 (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creator ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| created))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))))) (and (=> (= (ControlFlow 0 182071) (- 0 225205)) (=> $abort_flag@5@@2 (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creator ($Address 186537453))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| created)))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@5@@2 (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creator ($Address 186537453))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| created)))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 182071) (- 0 225497)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@96 T@$Value) )  (=> ((_ is $Address) addr1@@96) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@96)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@1) $EmptyTypeValueArray (|a#$Address| addr1@@96))))))))))))) (=> (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@97 T@$Value) )  (=> ((_ is $Address) addr1@@97) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@97)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@1) $EmptyTypeValueArray (|a#$Address| addr1@@97)))))))))))) (and (=> (= (ControlFlow 0 182071) (- 0 225535)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (and (=> (= (ControlFlow 0 182071) (- 0 225566)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@98 T@$Value) )  (=> ((_ is $Address) addr1@@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@98)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@1) $EmptyTypeValueArray (|a#$Address| addr1@@98)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@98)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@99 T@$Value) )  (=> ((_ is $Address) addr1@@99) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@99)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@1) $EmptyTypeValueArray (|a#$Address| addr1@@99)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@99)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 182071) (- 0 225625)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@100 T@$Value) )  (=> ((_ is $Address) addr1@@100) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@100)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@1) $EmptyTypeValueArray (|a#$Address| addr1@@100)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@100)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon68_Else_correct  (=> (not $abort_flag@4@@3) (and (=> (= (ControlFlow 0 181861) (- 0 224538)) (|b#$Boolean| ($Boolean (forall ((inline$$DualAttestation_publish_credential_$def_verify$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$DualAttestation_publish_credential_$def_verify$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DualAttestation_publish_credential_$def_verify$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$DualAttestation_publish_credential_$def_verify$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_publish_credential_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (=> (and (and (= $abort_code@8@@2 $abort_code@6@@3) (= $abort_flag@5@@2 $abort_flag@4@@3)) (and (= $DualAttestation_Credential_$memory@1 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 181861) 182071))) anon0$2_correct@@10))))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@8@@2 $abort_code@7@@2) (= $abort_flag@5@@2 true)) (and (= $DualAttestation_Credential_$memory@1 $DualAttestation_Credential_$memory@0) (= (ControlFlow 0 180794) 182071))) anon0$2_correct@@10)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon9_correct  (=> (= $abort_code@7@@2 $abort_code@1@@8) (=> (and (= $DualAttestation_Credential_$memory@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 182033) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 182031) 182033)) inline$$DualAttestation_publish_credential_$def_verify$0$anon9_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 182041) 182033) inline$$DualAttestation_publish_credential_$def_verify$0$anon9_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon50_Then_correct  (=> $abort_flag@0@@10 (and (=> (= (ControlFlow 0 182025) 182041) inline$$DualAttestation_publish_credential_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 182025) 182031) inline$$DualAttestation_publish_credential_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon13_correct  (=> (= $abort_code@7@@2 $abort_code@2@@9) (=> (and (= $DualAttestation_Credential_$memory@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 182013) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 182011) 182013)) inline$$DualAttestation_publish_credential_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 182021) 182013) inline$$DualAttestation_publish_credential_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon52_Then_correct  (=> $abort_flag@1@@9 (and (=> (= (ControlFlow 0 182005) 182021) inline$$DualAttestation_publish_credential_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 182005) 182011) inline$$DualAttestation_publish_credential_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon17_correct  (=> (= $abort_code@7@@2 $abort_code@3@@8) (=> (and (= $DualAttestation_Credential_$memory@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 181993) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 181991) 181993)) inline$$DualAttestation_publish_credential_$def_verify$0$anon17_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 182001) 181993) inline$$DualAttestation_publish_credential_$def_verify$0$anon17_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon54_Then_correct  (=> $abort_flag@2@@9 (and (=> (= (ControlFlow 0 181985) 182001) inline$$DualAttestation_publish_credential_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 181985) 181991) inline$$DualAttestation_publish_credential_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon21_correct  (=> (= $abort_code@7@@2 $abort_code@4@@8) (=> (and (= $DualAttestation_Credential_$memory@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 181973) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 181971) 181973)) inline$$DualAttestation_publish_credential_$def_verify$0$anon21_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 181981) 181973) inline$$DualAttestation_publish_credential_$def_verify$0$anon21_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon56_Then_correct  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 181965) 181981) inline$$DualAttestation_publish_credential_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 181965) 181971) inline$$DualAttestation_publish_credential_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon29_correct  (=> (= $abort_code@7@@2 $abort_code@4@@8) (=> (and (= $DualAttestation_Credential_$memory@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 181953) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 181951) 181953)) inline$$DualAttestation_publish_credential_$def_verify$0$anon29_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon61_Then_correct  (=> (= (ControlFlow 0 181961) 181953) inline$$DualAttestation_publish_credential_$def_verify$0$anon29_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon60_Then_correct  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 181945) 181961) inline$$DualAttestation_publish_credential_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 181945) 181951) inline$$DualAttestation_publish_credential_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon33_correct  (=> (= $abort_code@7@@2 $abort_code@4@@8) (=> (and (= $DualAttestation_Credential_$memory@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 181933) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 181931) 181933)) inline$$DualAttestation_publish_credential_$def_verify$0$anon33_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 181941) 181933) inline$$DualAttestation_publish_credential_$def_verify$0$anon33_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon62_Then_correct  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 181925) 181941) inline$$DualAttestation_publish_credential_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 181925) 181931) inline$$DualAttestation_publish_credential_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon37_correct  (=> (= $abort_code@7@@2 $abort_code@4@@8) (=> (and (= $DualAttestation_Credential_$memory@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 181913) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 181911) 181913)) inline$$DualAttestation_publish_credential_$def_verify$0$anon37_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon65_Then_correct  (=> (= (ControlFlow 0 181921) 181913) inline$$DualAttestation_publish_credential_$def_verify$0$anon37_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon64_Then_correct  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 181905) 181921) inline$$DualAttestation_publish_credential_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 181905) 181911) inline$$DualAttestation_publish_credential_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon41_correct  (=> (= $abort_code@7@@2 $abort_code@4@@8) (=> (and (= $DualAttestation_Credential_$memory@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 181893) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 181891) 181893)) inline$$DualAttestation_publish_credential_$def_verify$0$anon41_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon67_Then_correct  (=> (= (ControlFlow 0 181901) 181893) inline$$DualAttestation_publish_credential_$def_verify$0$anon41_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon66_Then_correct  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 181885) 181901) inline$$DualAttestation_publish_credential_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 181885) 181891) inline$$DualAttestation_publish_credential_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon45_correct  (=> (= $abort_code@7@@2 $abort_code@6@@3) (=> (and (= $DualAttestation_Credential_$memory@0 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 181873) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 181871) 181873)) inline$$DualAttestation_publish_credential_$def_verify$0$anon45_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 181881) 181873) inline$$DualAttestation_publish_credential_$def_verify$0$anon45_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon68_Then_correct  (=> $abort_flag@4@@3 (and (=> (= (ControlFlow 0 181865) 181881) inline$$DualAttestation_publish_credential_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 181865) 181871) inline$$DualAttestation_publish_credential_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@4@@3 true) (=> (and (= $abort_code@6@@3 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 181790) 181865) inline$$DualAttestation_publish_credential_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 181790) 181861) inline$$DualAttestation_publish_credential_$def_verify$0$anon68_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 181788) 181790)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 inline$$DualAttestation_Credential_pack$0$$struct@1))) (= $abort_flag@4@@3 $abort_flag@3@@4)) (and (= $abort_code@6@@3 $abort_code@4@@8) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 181738) 181865) inline$$DualAttestation_publish_credential_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 181738) 181861) inline$$DualAttestation_publish_credential_$def_verify$0$anon68_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| created)) (and (=> (= (ControlFlow 0 181796) 181788) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 181796) 181738) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 181584) (- 0 224423)) true) (=> (= (ControlFlow 0 181584) 181796) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$DualAttestation_Credential_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 181470) 181584)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$DualAttestation_Credential_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 181476) 181584) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$DualAttestation_Credential_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 181464) 181476) inline$$DualAttestation_Credential_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 181464) 181470) inline$$DualAttestation_Credential_pack$0$anon4_Else_correct)))))
(let ((inline$$DualAttestation_Credential_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 181456) 181584)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$DualAttestation_Credential_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) human_name) (let ((va@@121 (|v#$Vector| human_name)))
(let ((l@@121 (|l#$ValueArray| va@@121)))
 (and (and (<= 0 l@@121) (<= l@@121 $MAX_U64)) (forall ((x@@121 Int) ) (!  (=> (or (< x@@121 0) (>= x@@121 l@@121)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121))
)))))) (forall ((inline$$DualAttestation_Credential_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DualAttestation_Credential_pack$0$$$0 0) (< inline$$DualAttestation_Credential_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0))
))) (and (and ((_ is $Vector) inline$$Vector_empty$0$v@1) (let ((va@@122 (|v#$Vector| inline$$Vector_empty$0$v@1)))
(let ((l@@122 (|l#$ValueArray| va@@122)))
 (and (and (<= 0 l@@122) (<= l@@122 $MAX_U64)) (forall ((x@@122 Int) ) (!  (=> (or (< x@@122 0) (>= x@@122 l@@122)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122))
)))))) (forall ((inline$$DualAttestation_Credential_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DualAttestation_Credential_pack$0$$$0@@0 0) (< inline$$DualAttestation_Credential_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0))
)))) (and (and (and ((_ is $Vector) inline$$Vector_empty$1$v@1) (let ((va@@123 (|v#$Vector| inline$$Vector_empty$1$v@1)))
(let ((l@@123 (|l#$ValueArray| va@@123)))
 (and (and (<= 0 l@@123) (<= l@@123 $MAX_U64)) (forall ((x@@123 Int) ) (!  (=> (or (< x@@123 0) (>= x@@123 l@@123)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123))
)))))) (forall ((inline$$DualAttestation_Credential_pack$0$$$0@@1 Int) ) (!  (=> (and (>= inline$$DualAttestation_Credential_pack$0$$$0@@1 0) (< inline$$DualAttestation_Credential_pack$0$$$0@@1 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1))
))) (and (and ((_ is $Integer) inline$$DualAttestation_publish_credential_$def_verify$0$$t15@1) (>= (|i#$Integer| inline$$DualAttestation_publish_credential_$def_verify$0$$t15@1) 0)) (<= (|i#$Integer| inline$$DualAttestation_publish_credential_$def_verify$0$$t15@1) $MAX_U64)))) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@124 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@124 (|l#$ValueArray| va@@124)))
 (and (and (<= 0 l@@124) (<= l@@124 $MAX_U64)) (forall ((x@@124 Int) ) (!  (=> (or (< x@@124 0) (>= x@@124 l@@124)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@125 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@125 (|l#$ValueArray| va@@125)))
 (and (and (<= 0 l@@125) (<= l@@125 $MAX_U64)) (forall ((x@@125 Int) ) (!  (=> (or (< x@@125 0) (>= x@@125 l@@125)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125))
))))))) (forall (($$0@@56 Int) ) (!  (=> (and (>= $$0@@56 0) (< $$0@@56 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@56)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@56)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@56)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@56))
))) true) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$1$res@0) (let ((va@@126 (|v#$Vector| inline$$Event_new_event_handle$1$res@0)))
(let ((l@@126 (|l#$ValueArray| va@@126)))
 (and (and (<= 0 l@@126) (<= l@@126 $MAX_U64)) (forall ((x@@126 Int) ) (!  (=> (or (< x@@126 0) (>= x@@126 l@@126)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid)) (let ((va@@127 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))
(let ((l@@127 (|l#$ValueArray| va@@127)))
 (and (and (<= 0 l@@127) (<= l@@127 $MAX_U64)) (forall ((x@@127 Int) ) (!  (=> (or (< x@@127 0) (>= x@@127 l@@127)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127))
))))))) (forall (($$0@@57 Int) ) (!  (=> (and (>= $$0@@57 0) (< $$0@@57 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@57)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@57)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@57)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@57))
))) true) (= inline$$DualAttestation_Credential_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 human_name) 1 inline$$Vector_empty$0$v@1) 2 inline$$Vector_empty$1$v@1) 3 inline$$DualAttestation_publish_credential_$def_verify$0$$t15@1) 4 inline$$Event_new_event_handle$0$res@0) 5 inline$$Event_new_event_handle$1$res@0) 6)))) (and (=> (= (ControlFlow 0 181448) 181464) inline$$DualAttestation_Credential_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 181448) 181456) inline$$DualAttestation_Credential_pack$0$anon3_Else_correct)))))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon66_Else_correct  (=> (and (not $abort_flag@3@@4) (= (ControlFlow 0 181482) 181448)) inline$$DualAttestation_Credential_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$1$Entry_correct  (=> (= inline$$Event_new_event_handle$1$t@0 $DualAttestation_BaseUrlRotationEvent_type_value) (and (=> (= (ControlFlow 0 180962) 181885) inline$$DualAttestation_publish_credential_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 180962) 181482) inline$$DualAttestation_publish_credential_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon64_Else_correct  (=> (and (not $abort_flag@3@@4) (= (ControlFlow 0 180970) 180962)) inline$$Event_new_event_handle$1$Entry_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $DualAttestation_ComplianceKeyRotationEvent_type_value) (and (=> (= (ControlFlow 0 180920) 181905) inline$$DualAttestation_publish_credential_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 180920) 180970) inline$$DualAttestation_publish_credential_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon62_Else_correct  (=> (not $abort_flag@3@@4) (=> (and (= inline$$DualAttestation_publish_credential_$def_verify$0$$t15@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 180928) 180920)) inline$$Event_new_event_handle$0$Entry_correct))))
(let ((inline$$Vector_empty$1$anon0_correct  (=> (= inline$$Vector_empty$1$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 180876) 181925) inline$$DualAttestation_publish_credential_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 180876) 180928) inline$$DualAttestation_publish_credential_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct  (=> (and (= inline$$Vector_empty$1$ta@0 $IntegerType) (= (ControlFlow 0 180872) 180876)) inline$$Vector_empty$1$anon0_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon60_Else_correct  (=> (and (not $abort_flag@3@@4) (= (ControlFlow 0 180882) 180872)) inline$$Vector_empty$1$Entry_correct)))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 180835) 181945) inline$$DualAttestation_publish_credential_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 180835) 180882) inline$$DualAttestation_publish_credential_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 $IntegerType) (= (ControlFlow 0 180831) 180835)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon58_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@3) (= (ControlFlow 0 180841) 180831)) inline$$Vector_empty$0$Entry_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon26_correct  (=> (= $abort_code@7@@2 $abort_code@5@@8) (=> (and (= $DualAttestation_Credential_$memory@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 180790) 180794)) inline$$DualAttestation_publish_credential_$def_verify$0$Abort_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 180788) 180790)) inline$$DualAttestation_publish_credential_$def_verify$0$anon26_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 180802) 180790) inline$$DualAttestation_publish_credential_$def_verify$0$anon26_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon58_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@3)) (= $abort_code@5@@8 (|i#$Integer| call3formal@$ret0@0@@20))) (and (=> (= (ControlFlow 0 180782) 180802) inline$$DualAttestation_publish_credential_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 180782) 180788) inline$$DualAttestation_publish_credential_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon56_Else_correct  (=> (not $abort_flag@3@@4) (and (=> (= (ControlFlow 0 180770) 180841) inline$$DualAttestation_publish_credential_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 180770) 180782) inline$$DualAttestation_publish_credential_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon54_Else$1_correct  (=> (and (and (and (= inline$$DualAttestation_publish_credential_$def_verify$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@4)) (and (=> $abort_flag@3@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@20 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@20) (>= (|i#$Integer| call3formal@$ret0@0@@20) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@20) $MAX_U64))) (and (=> (= (ControlFlow 0 180764) 181965) inline$$DualAttestation_publish_credential_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 180764) 180770) inline$$DualAttestation_publish_credential_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@3  (=> (and (= inline$$Not$0$dst@1@@3 ($Boolean  (not (|b#$Boolean| inline$$DualAttestation_publish_credential_$def_verify$0$$t9@1)))) (= (ControlFlow 0 180752) 180764)) inline$$DualAttestation_publish_credential_$def_verify$0$anon54_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 180742) (- 0 223970)) true) (=> (= (ControlFlow 0 180742) 180752) inline$$Not$0$anon0_correct@@3))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon54_Else_correct  (=> (not $abort_flag@2@@9) (=> (and (= inline$$DualAttestation_publish_credential_$def_verify$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@21)))) (= (ControlFlow 0 180758) 180742)) inline$$Not$0$Entry_correct@@3))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@1@@9) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@9) (=> $abort_flag@2@@9 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@21 created)))) ((_ is $Address) call3formal@$ret0@0@@21))) (and (=> (= (ControlFlow 0 180696) 181985) inline$$DualAttestation_publish_credential_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 180696) 180758) inline$$DualAttestation_publish_credential_$def_verify$0$anon54_Else_correct))))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon50_Else_correct  (=> (and (not $abort_flag@0@@10) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator))))))) $abort_flag@1@@9)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@1@@9) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creator ($Address 186537453))))) $abort_flag@1@@9)) (and (=> $abort_flag@1@@9 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creator ($Address 186537453))))))) (=> $abort_flag@1@@9 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator))))))) (= $abort_code@2@@9 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creator)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@2@@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creator ($Address 186537453))))) (= $abort_code@2@@9 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 180690) 182005) inline$$DualAttestation_publish_credential_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 180690) 180696) inline$$DualAttestation_publish_credential_$def_verify$0$anon52_Else_correct))))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon6$3_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) $abort_flag@0@@10) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) $abort_flag@0@@10)) (and (=> $abort_flag@0@@10 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))))) (=> $abort_flag@0@@10 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created))))))) (= $abort_code@1@@8 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| created)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (= $abort_code@1@@8 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 180684) 182025) inline$$DualAttestation_publish_credential_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 180684) 180690) inline$$DualAttestation_publish_credential_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 180580) 180684)) inline$$DualAttestation_publish_credential_$def_verify$0$anon6$3_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 182049) 180684) inline$$DualAttestation_publish_credential_$def_verify$0$anon6$3_correct)))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon48_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 180572) 182049) inline$$DualAttestation_publish_credential_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 180572) 180580) inline$$DualAttestation_publish_credential_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon48_Then_correct  (and (=> (= (ControlFlow 0 182057) 182049) inline$$DualAttestation_publish_credential_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 182057) 180580) inline$$DualAttestation_publish_credential_$def_verify$0$anon49_Else_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon47_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 180564) 182057) inline$$DualAttestation_publish_credential_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 180564) 180572) inline$$DualAttestation_publish_credential_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon47_Then_correct  (and (=> (= (ControlFlow 0 182065) 182057) inline$$DualAttestation_publish_credential_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 182065) 180572) inline$$DualAttestation_publish_credential_$def_verify$0$anon48_Else_correct))))
(let ((inline$$DualAttestation_publish_credential_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 180558) 182065) inline$$DualAttestation_publish_credential_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 180558) 180564) inline$$DualAttestation_publish_credential_$def_verify$0$anon47_Else_correct)))))
(let ((anon0$1_correct@@9  (=> (forall (($inv_addr@@23 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23)) (let ((va@@128 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))))
(let ((l@@128 (|l#$ValueArray| va@@128)))
 (and (and (<= 0 l@@128) (<= l@@128 $MAX_U64)) (forall ((x@@128 Int) ) (!  (=> (or (< x@@128 0) (>= x@@128 l@@128)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))
)) (=> (and (forall (($inv_addr@@24 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24)) (let ((va@@129 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))))
(let ((l@@129 (|l#$ValueArray| va@@129)))
 (and (and (<= 0 l@@129) (<= l@@129 $MAX_U64)) (forall ((x@@129 Int) ) (!  (=> (or (< x@@129 0) (>= x@@129 l@@129)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_human_name)) (let ((va@@130 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_human_name))))
(let ((l@@130 (|l#$ValueArray| va@@130)))
 (and (and (<= 0 l@@130) (<= l@@130 $MAX_U64)) (forall ((x@@130 Int) ) (!  (=> (or (< x@@130 0) (>= x@@130 l@@130)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130))
))))))) (forall (($$0@@58 Int) ) (!  (=> (and (>= $$0@@58 0) (< $$0@@58 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_human_name))) $$0@@58)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_human_name))) $$0@@58)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_human_name))) $$0@@58)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_human_name))) $$0@@58))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url)) (let ((va@@131 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url))))
(let ((l@@131 (|l#$ValueArray| va@@131)))
 (and (and (<= 0 l@@131) (<= l@@131 $MAX_U64)) (forall ((x@@131 Int) ) (!  (=> (or (< x@@131 0) (>= x@@131 l@@131)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131))
))))))) (forall (($$0@@59 Int) ) (!  (=> (and (>= $$0@@59 0) (< $$0@@59 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url))) $$0@@59)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url))) $$0@@59)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url))) $$0@@59)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url))) $$0@@59))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@132 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@132 (|l#$ValueArray| va@@132)))
 (and (and (<= 0 l@@132) (<= l@@132 $MAX_U64)) (forall ((x@@132 Int) ) (!  (=> (or (< x@@132 0) (>= x@@132 l@@132)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132))
))))))) (forall (($$0@@60 Int) ) (!  (=> (and (>= $$0@@60 0) (< $$0@@60 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_public_key))) $$0@@60)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_public_key))) $$0@@60)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_public_key))) $$0@@60)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_public_key))) $$0@@60))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@133 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@133 (|l#$ValueArray| va@@133)))
 (and (and (<= 0 l@@133) (<= l@@133 $MAX_U64)) (forall ((x@@133 Int) ) (!  (=> (or (< x@@133 0) (>= x@@133 l@@133)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@134 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@134 (|l#$ValueArray| va@@134)))
 (and (and (<= 0 l@@134) (<= l@@134 $MAX_U64)) (forall ((x@@134 Int) ) (!  (=> (or (< x@@134 0) (>= x@@134 l@@134)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134))
))))))) (forall (($$0@@61 Int) ) (!  (=> (and (>= $$0@@61 0) (< $$0@@61 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@61)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@61)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@61)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@61))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@135 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@135 (|l#$ValueArray| va@@135)))
 (and (and (<= 0 l@@135) (<= l@@135 $MAX_U64)) (forall ((x@@135 Int) ) (!  (=> (or (< x@@135 0) (>= x@@135 l@@135)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@136 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@136 (|l#$ValueArray| va@@136)))
 (and (and (<= 0 l@@136) (<= l@@136 $MAX_U64)) (forall ((x@@136 Int) ) (!  (=> (or (< x@@136 0) (>= x@@136 l@@136)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136))
))))))) (forall (($$0@@62 Int) ) (!  (=> (and (>= $$0@@62 0) (< $$0@@62 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@62)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@62)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@62)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@62))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@24))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@3 T@$Value) )  (=> ((_ is $Type) coin_type@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@101 T@$Value) )  (=> ((_ is $Address) addr1@@101) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| addr1@@101)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@101)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@101)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@4 T@$Value) )  (=> ((_ is $Type) coin_type@@4) (|b#$Boolean| ($Boolean (forall ((addr1@@102 T@$Value) )  (=> ((_ is $Address) addr1@@102) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| addr1@@102)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@102)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@102)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr1@@103 T@$Value) )  (=> ((_ is $Address) addr1@@103) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@103)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@103)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@103)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@103)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@103)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 182069) 180558))) inline$$DualAttestation_publish_credential_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@10  (=> (and ((_ is $Address) created) ((_ is $Address) creator)) (=> (and (and (and ((_ is $Vector) human_name) (let ((va@@137 (|v#$Vector| human_name)))
(let ((l@@137 (|l#$ValueArray| va@@137)))
 (and (and (<= 0 l@@137) (<= l@@137 $MAX_U64)) (forall ((x@@137 Int) ) (!  (=> (or (< x@@137 0) (>= x@@137 l@@137)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137))
)))))) (forall (($$0@@63 Int) ) (!  (=> (and (>= $$0@@63 0) (< $$0@@63 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@63)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@63)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@63)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@63))
))) (= (ControlFlow 0 179511) 182069)) anon0$1_correct@@9))))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (= (ControlFlow 0 221206) 179511) anon0_correct@@10)))
PreconditionGeneratedEntry_correct@@9)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account () T@$Value)
(declare-fun $abort_flag@4@@4 () Bool)
(declare-fun $abort_code@7@@3 () Int)
(declare-fun $DualAttestation_Credential_$memory@0@@0 () T@$Memory)
(declare-fun new_url () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun $abort_code@5@@9 () Int)
(declare-fun $abort_flag@3@@5 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$DualAttestation_rotate_base_url_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun $abort_code@6@@4 () Int)
(declare-fun $abort_code@1@@9 () Int)
(declare-fun $abort_flag@0@@11 () Bool)
(declare-fun $abort_code@2@@10 () Int)
(declare-fun $abort_flag@1@@10 () Bool)
(declare-fun $abort_code@4@@9 () Int)
(declare-fun $abort_flag@2@@10 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0 () T@$TypeValue)
(declare-fun call2formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$DualAttestation_BaseUrlRotationEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$DualAttestation_rotate_base_url_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@22 () T@$Value)
(declare-fun inline$$DualAttestation_rotate_base_url_$def_verify$0$$t8@1 () T@$Value)
(declare-fun $abort_code@3@@9 () Int)
(declare-fun call3formal@$ret0@0@@23 () T@$Value)
(declare-fun inline$$DualAttestation_rotate_base_url_$def_verify$0$$t9@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 225689) (let ((anon0$2_correct@@11  (and (=> (= (ControlFlow 0 185229) (- 0 228239)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) $abort_flag@4@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) $abort_flag@4@@4) (and (=> (= (ControlFlow 0 185229) (- 0 228257)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@4) (and (=> (= (ControlFlow 0 185229) (- 0 228272)) (=> $abort_flag@4@@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@4@@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 185229) (- 0 228304)) (=> $abort_flag@4@@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) (= $abort_code@7@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@3 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@4@@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) (= $abort_code@7@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@3 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 185229) (- 0 228358)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| account)))) $DualAttestation_Credential_base_url) new_url))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| account)))) $DualAttestation_Credential_base_url) new_url)))) (and (=> (= (ControlFlow 0 185229) (- 0 228384)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr1@@104 T@$Value) )  (=> ((_ is $Address) addr1@@104) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified addr1@@104 account)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@104)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@104)))) $DualAttestation_Credential_base_url))))))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr1@@105 T@$Value) )  (=> ((_ is $Address) addr1@@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified addr1@@105 account)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@105)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@105)))) $DualAttestation_Credential_base_url)))))))))))) (and (=> (= (ControlFlow 0 185229) (- 0 228450)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr1@@106 T@$Value) )  (=> ((_ is $Address) addr1@@106) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@106)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@106))))))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr1@@107 T@$Value) )  (=> ((_ is $Address) addr1@@107) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@107)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@107)))))))))))) (and (=> (= (ControlFlow 0 185229) (- 0 228488)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr1@@108 T@$Value) )  (=> ((_ is $Address) addr1@@108) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@108))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@108)))))))))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr1@@109 T@$Value) )  (=> ((_ is $Address) addr1@@109) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@109))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@109))))))))))))))) (and (=> (= (ControlFlow 0 185229) (- 0 228538)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (=> (= (ControlFlow 0 185229) (- 0 228569)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr1@@110 T@$Value) )  (=> ((_ is $Address) addr1@@110) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@110)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr1@@110)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@110)))) $DualAttestation_Credential_compliance_public_key)))))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon32$2_correct  (and (=> (= (ControlFlow 0 185087) (- 0 228084)) (|b#$Boolean| ($Boolean (forall ((inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_base_url_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (=> (and (and (= $abort_code@7@@3 $abort_code@5@@9) (= $abort_flag@4@@4 $abort_flag@3@@5)) (and (= $DualAttestation_Credential_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 185087) 185229))) anon0$2_correct@@11)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $DualAttestation_Credential_$memory) (= (ControlFlow 0 184976) 185087)) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon32$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $DualAttestation_Credential_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 185030) 185087))) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon32$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (and (=> (= (ControlFlow 0 184966) 185030) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 184966) 184976) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$0$dst'@2|) (= (ControlFlow 0 184788) 184966)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 184844) 184966))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (and (=> (= (ControlFlow 0 184752) 184844) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 184752) 184788) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 184615) 184752)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon48_Then_correct  (=> (and (= inline$$DualAttestation_rotate_base_url_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 185097) 184752)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$ReadRef$0$v@1@@0)) (and (=> (= (ControlFlow 0 184601) 185097) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 184601) 184615) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon46_Else_correct  (=> (and (not $abort_flag@3@@5) (= (ControlFlow 0 184607) 184601)) inline$$WriteRef$1$anon0_correct@@0)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@7@@3 $abort_code@6@@4) (= $abort_flag@4@@4 true)) (and (= $DualAttestation_Credential_$memory@0@@0 $DualAttestation_Credential_$memory) (= (ControlFlow 0 183423) 185229))) anon0$2_correct@@11)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon7_correct  (=> (and (= $abort_code@6@@4 $abort_code@1@@9) (= (ControlFlow 0 185199) 183423)) inline$$DualAttestation_rotate_base_url_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 185197) 185199)) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon7_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 185207) 185199) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon7_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon35_Then_correct  (=> $abort_flag@0@@11 (and (=> (= (ControlFlow 0 185191) 185207) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 185191) 185197) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon11_correct  (=> (and (= $abort_code@6@@4 $abort_code@2@@10) (= (ControlFlow 0 185179) 183423)) inline$$DualAttestation_rotate_base_url_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 185177) 185179)) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon11_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 185187) 185179) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon11_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon37_Then_correct  (=> $abort_flag@1@@10 (and (=> (= (ControlFlow 0 185171) 185187) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 185171) 185177) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon19_correct  (=> (and (= $abort_code@6@@4 $abort_code@4@@9) (= (ControlFlow 0 185159) 183423)) inline$$DualAttestation_rotate_base_url_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 185157) 185159)) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon19_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 185167) 185159) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon19_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon41_Then_correct  (=> $abort_flag@2@@10 (and (=> (= (ControlFlow 0 185151) 185167) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 185151) 185157) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon25_correct  (=> (and (= $abort_code@6@@4 $abort_code@5@@9) (= (ControlFlow 0 185129) 183423)) inline$$DualAttestation_rotate_base_url_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 185127) 185129)) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon25_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 185137) 185129) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon25_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon44_Then_correct  (=> $abort_flag@3@@5 (and (=> (= (ControlFlow 0 185121) 185137) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 185121) 185127) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon29_correct  (=> (and (= $abort_code@6@@4 $abort_code@5@@9) (= (ControlFlow 0 185109) 183423)) inline$$DualAttestation_rotate_base_url_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 185107) 185109)) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon29_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 185117) 185109) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon29_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon46_Then_correct  (=> $abort_flag@3@@5 (and (=> (= (ControlFlow 0 185101) 185117) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 185101) 185107) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct  (=> (= inline$$Event_emit_event$0$t@0 $DualAttestation_BaseUrlRotationEvent_type_value) (and (=> (= (ControlFlow 0 184532) 185101) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 184532) 184607) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon44_Else$2_correct  (and (=> (= (ControlFlow 0 184542) (- 0 227788)) true) (=> (= (ControlFlow 0 184542) 184532) inline$$Event_emit_event$0$Entry_correct))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 184484) 184542)) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon44_Else$2_correct)))
(let ((inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 184440) 184484)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 184446) 184484) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 184434) 184446) inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 184434) 184440) inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 184426) 184484)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Vector) new_url) (let ((va@@138 (|v#$Vector| new_url)))
(let ((l@@138 (|l#$ValueArray| va@@138)))
 (and (and (<= 0 l@@138) (<= l@@138 $MAX_U64)) (forall ((x@@138 Int) ) (!  (=> (or (< x@@138 0) (>= x@@138 l@@138)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138))
)))))) (forall ((inline$$DualAttestation_BaseUrlRotationEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DualAttestation_BaseUrlRotationEvent_pack$0$$$0 0) (< inline$$DualAttestation_BaseUrlRotationEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| new_url)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_url)) inline$$DualAttestation_BaseUrlRotationEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_url)) inline$$DualAttestation_BaseUrlRotationEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_url)) inline$$DualAttestation_BaseUrlRotationEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_url)) inline$$DualAttestation_BaseUrlRotationEvent_pack$0$$$0))
))) (=> (and (and (and ((_ is $Integer) call2formal@$ret0@0@@0) (>= (|i#$Integer| call2formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@0) $MAX_U64)) (= inline$$DualAttestation_BaseUrlRotationEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 new_url) 1 call2formal@$ret0@0@@0) 2)))) (and (=> (= (ControlFlow 0 184418) 184434) inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 184418) 184426) inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon44_Else_correct  (=> (and (not $abort_flag@3@@5) (= (ControlFlow 0 184452) 184418)) inline$$DualAttestation_BaseUrlRotationEvent_pack$0$anon0_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon22$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@5) (=> $abort_flag@3@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@3@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@9 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@0 ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 1000000)))))))))) (and (and ((_ is $Integer) call2formal@$ret0@0@@0) (>= (|i#$Integer| call2formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 184190) 185121) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 184190) 184452) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $DualAttestation_Credential_base_url_rotation_events) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) $DualAttestation_Credential_base_url_rotation_events))) (= (ControlFlow 0 184182) 184190))) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon22$2_correct))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 184002) 184182)) inline$$BorrowField$1$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 184058) 184182))) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 183966) 184058) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 183966) 184002) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 183829) 183966)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon43_Then_correct  (=> (and (= inline$$DualAttestation_rotate_base_url_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 185147) 183966)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) new_url)) (and (=> (= (ControlFlow 0 183815) 185147) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 183815) 183829) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DualAttestation_Credential_base_url) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DualAttestation_Credential_base_url))) (= (ControlFlow 0 183756) 183815))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon41_Else_correct  (=> (and (not $abort_flag@2@@10) (= (ControlFlow 0 183762) 183756)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@10 true) (=> (and (= $abort_code@4@@9 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 183626) 185151) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 183626) 183762) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 183624) 183626)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_flag@2@@10 $abort_flag@1@@10)) (and (= $abort_code@4@@9 $abort_code@2@@10) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 183572) 185151) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 183572) 183762) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@22)) (and (=> (= (ControlFlow 0 183542) 183624) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 183542) 183572) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 183536) (- 0 227161)) true) (=> (= (ControlFlow 0 183536) 183542) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_rotate_base_url_$def_verify$0$$t8@1) (= (ControlFlow 0 183632) 183536)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon16_correct  (=> (and (= $abort_code@6@@4 $abort_code@3@@9) (= (ControlFlow 0 183419) 183423)) inline$$DualAttestation_rotate_base_url_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 183417) 183419)) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 183431) 183419) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| inline$$DualAttestation_rotate_base_url_$def_verify$0$$t8@1)) (= $abort_code@3@@9 (|i#$Integer| call3formal@$ret0@0@@23))) (and (=> (= (ControlFlow 0 183411) 183431) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 183411) 183417) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon37_Else_correct  (=> (not $abort_flag@1@@10) (and (=> (= (ControlFlow 0 183399) 183632) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 183399) 183411) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon35_Else_correct  (=> (and (not $abort_flag@0@@11) (= inline$$DualAttestation_rotate_base_url_$def_verify$0$$t8@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@22))))) (=> (and (and (and (= inline$$DualAttestation_rotate_base_url_$def_verify$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@10)) (and (=> $abort_flag@1@@10 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@23 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@23) (>= (|i#$Integer| call3formal@$ret0@0@@23) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@23) $MAX_U64))) (and (=> (= (ControlFlow 0 183393) 185171) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 183393) 183399) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon37_Else_correct))))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@11) (=> $abort_flag@0@@11 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@22 account)))) ((_ is $Address) call3formal@$ret0@0@@22))) (and (=> (= (ControlFlow 0 183375) 185191) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 183375) 183393) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 183305) 183375)) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon4$2_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 185215) 183375) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon4$2_correct)))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 183297) 185215) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 183297) 183305) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 185223) 185215) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 185223) 183305) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon34_Else_correct))))
(let ((inline$$DualAttestation_rotate_base_url_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 183291) 185223) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 183291) 183297) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon33_Else_correct)))))
(let ((anon0$1_correct@@10  (=> (forall (($inv_addr@@25 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@25)) (let ((va@@139 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@25))))
(let ((l@@139 (|l#$ValueArray| va@@139)))
 (and (and (<= 0 l@@139) (<= l@@139 $MAX_U64)) (forall ((x@@139 Int) ) (!  (=> (or (< x@@139 0) (>= x@@139 l@@139)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@25))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@25))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@25))
)) (=> (and (forall (($inv_addr@@26 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26)) (let ((va@@140 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))))
(let ((l@@140 (|l#$ValueArray| va@@140)))
 (and (and (<= 0 l@@140) (<= l@@140 $MAX_U64)) (forall ((x@@140 Int) ) (!  (=> (or (< x@@140 0) (>= x@@140 l@@140)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_human_name)) (let ((va@@141 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_human_name))))
(let ((l@@141 (|l#$ValueArray| va@@141)))
 (and (and (<= 0 l@@141) (<= l@@141 $MAX_U64)) (forall ((x@@141 Int) ) (!  (=> (or (< x@@141 0) (>= x@@141 l@@141)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141))
))))))) (forall (($$0@@64 Int) ) (!  (=> (and (>= $$0@@64 0) (< $$0@@64 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_human_name))) $$0@@64)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_human_name))) $$0@@64)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_human_name))) $$0@@64)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_human_name))) $$0@@64))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url)) (let ((va@@142 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url))))
(let ((l@@142 (|l#$ValueArray| va@@142)))
 (and (and (<= 0 l@@142) (<= l@@142 $MAX_U64)) (forall ((x@@142 Int) ) (!  (=> (or (< x@@142 0) (>= x@@142 l@@142)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142))
))))))) (forall (($$0@@65 Int) ) (!  (=> (and (>= $$0@@65 0) (< $$0@@65 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url))) $$0@@65)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url))) $$0@@65)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url))) $$0@@65)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url))) $$0@@65))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@143 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@143 (|l#$ValueArray| va@@143)))
 (and (and (<= 0 l@@143) (<= l@@143 $MAX_U64)) (forall ((x@@143 Int) ) (!  (=> (or (< x@@143 0) (>= x@@143 l@@143)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143))
))))))) (forall (($$0@@66 Int) ) (!  (=> (and (>= $$0@@66 0) (< $$0@@66 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_public_key))) $$0@@66)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_public_key))) $$0@@66)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_public_key))) $$0@@66)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_public_key))) $$0@@66))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@144 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@144 (|l#$ValueArray| va@@144)))
 (and (and (<= 0 l@@144) (<= l@@144 $MAX_U64)) (forall ((x@@144 Int) ) (!  (=> (or (< x@@144 0) (>= x@@144 l@@144)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@145 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@145 (|l#$ValueArray| va@@145)))
 (and (and (<= 0 l@@145) (<= l@@145 $MAX_U64)) (forall ((x@@145 Int) ) (!  (=> (or (< x@@145 0) (>= x@@145 l@@145)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145))
))))))) (forall (($$0@@67 Int) ) (!  (=> (and (>= $$0@@67 0) (< $$0@@67 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@67)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@67)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@67)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@67))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@146 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@146 (|l#$ValueArray| va@@146)))
 (and (and (<= 0 l@@146) (<= l@@146 $MAX_U64)) (forall ((x@@146 Int) ) (!  (=> (or (< x@@146 0) (>= x@@146 l@@146)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@147 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@147 (|l#$ValueArray| va@@147)))
 (and (and (<= 0 l@@147) (<= l@@147 $MAX_U64)) (forall ((x@@147 Int) ) (!  (=> (or (< x@@147 0) (>= x@@147 l@@147)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147))
))))))) (forall (($$0@@68 Int) ) (!  (=> (and (>= $$0@@68 0) (< $$0@@68 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@68)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@68)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@68)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@68))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@26))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr1@@111 T@$Value) )  (=> ((_ is $Address) addr1@@111) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@111)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@111)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@111)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@111)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@111)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 185227) 183291)))) inline$$DualAttestation_rotate_base_url_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@11  (=> ((_ is $Address) account) (=> (and (and (and ((_ is $Vector) new_url) (let ((va@@148 (|v#$Vector| new_url)))
(let ((l@@148 (|l#$ValueArray| va@@148)))
 (and (and (<= 0 l@@148) (<= l@@148 $MAX_U64)) (forall ((x@@148 Int) ) (!  (=> (or (< x@@148 0) (>= x@@148 l@@148)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148))
)))))) (forall (($$0@@69 Int) ) (!  (=> (and (>= $$0@@69 0) (< $$0@@69 (|l#$ValueArray| (|v#$Vector| new_url)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_url)) $$0@@69)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_url)) $$0@@69)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_url)) $$0@@69)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_url)) $$0@@69))
))) (= (ControlFlow 0 182438) 185227)) anon0$1_correct@@10))))
(let ((PreconditionGeneratedEntry_correct@@10  (=> (= (ControlFlow 0 225689) 182438) anon0_correct@@11)))
PreconditionGeneratedEntry_correct@@10))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun new_key () T@$Value)
(declare-fun $abort_flag@5@@3 () Bool)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_code@9@@2 () Int)
(declare-fun $DualAttestation_Credential_$memory@0@@1 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@7@@4 () Int)
(declare-fun $abort_flag@4@@5 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun $abort_code@8@@3 () Int)
(declare-fun $abort_code@1@@10 () Int)
(declare-fun $abort_flag@0@@12 () Bool)
(declare-fun $abort_code@2@@11 () Int)
(declare-fun $abort_flag@1@@11 () Bool)
(declare-fun $abort_code@4@@10 () Int)
(declare-fun $abort_flag@2@@11 () Bool)
(declare-fun $abort_code@6@@5 () Int)
(declare-fun $abort_flag@3@@6 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@0 () T@$TypeValue)
(declare-fun call2formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@24 () T@$Value)
(declare-fun inline$$Signature_ed25519_validate_pubkey$0$res@1 () T@$Value)
(declare-fun $abort_code@5@@10 () Int)
(declare-fun call3formal@$ret0@0@@25 () T@$Value)
(declare-fun inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$t10@1 () T@$Value)
(declare-fun $abort_code@3@@10 () Int)
(declare-fun call3formal@$ret0@0@@26 () T@$Value)
(declare-fun inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$t11@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 228633) (let ((anon0$2_correct@@12  (and (=> (= (ControlFlow 0 188759) (- 0 231484)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_key))))) $abort_flag@5@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_key))))) $abort_flag@5@@3) (and (=> (= (ControlFlow 0 188759) (- 0 231499)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@5@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@5@@3) (and (=> (= (ControlFlow 0 188759) (- 0 231517)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@3) (and (=> (= (ControlFlow 0 188759) (- 0 231532)) (=> $abort_flag@5@@3 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_key))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@5@@3 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_key))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 188759) (- 0 231578)) (=> $abort_flag@5@@3 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_key))))) (= $abort_code@9@@2 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@9@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@2 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@5@@3 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_key))))) (= $abort_code@9@@2 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@9@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@2 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 188759) (- 0 231657)) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DualAttestation_Credential_compliance_public_key) new_key))))) (=> (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DualAttestation_Credential_compliance_public_key) new_key)))) (and (=> (= (ControlFlow 0 188759) (- 0 231683)) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@112 T@$Value) )  (=> ((_ is $Address) addr1@@112) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified addr1@@112 account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr1@@112)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@112)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@113 T@$Value) )  (=> ((_ is $Address) addr1@@113) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified addr1@@113 account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr1@@113)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@113)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (and (=> (= (ControlFlow 0 188759) (- 0 231749)) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@114 T@$Value) )  (=> ((_ is $Address) addr1@@114) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@114)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr1@@114))))))))))))) (=> (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@115 T@$Value) )  (=> ((_ is $Address) addr1@@115) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@115)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr1@@115)))))))))))) (and (=> (= (ControlFlow 0 188759) (- 0 231787)) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@116 T@$Value) )  (=> ((_ is $Address) addr1@@116) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@116))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr1@@116)))))))))))))))) (=> (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@117 T@$Value) )  (=> ((_ is $Address) addr1@@117) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@117))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr1@@117))))))))))))))) (and (=> (= (ControlFlow 0 188759) (- 0 231837)) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))))))) (=> (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit)))))))) (=> (= (ControlFlow 0 188759) (- 0 231868)) (=> (not $abort_flag@5@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@118 T@$Value) )  (=> ((_ is $Address) addr1@@118) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@118)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr1@@118)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@118)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon44$2_correct  (and (=> (= (ControlFlow 0 188577) (- 0 231298)) (|b#$Boolean| ($Boolean (forall ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (=> (and (and (= $abort_code@9@@2 $abort_code@7@@4) (= $abort_flag@5@@3 $abort_flag@4@@5)) (and (= $DualAttestation_Credential_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 188577) 188759))) anon0$2_correct@@12)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $DualAttestation_Credential_$memory) (= (ControlFlow 0 188466) 188577)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon44$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $DualAttestation_Credential_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 188520) 188577))) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon44$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (and (=> (= (ControlFlow 0 188456) 188520) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 188456) 188466) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$0$dst'@2@@0|) (= (ControlFlow 0 188278) 188456)) inline$$WritebackToGlobal$0$anon0_correct@@0))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|) (= (ControlFlow 0 188334) 188456))) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (and (=> (= (ControlFlow 0 188242) 188334) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 188242) 188278) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 188105) 188242)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon66_Then_correct  (=> (and (= inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 188587) 188242)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@0) (|p#$Mutation| inline$$BorrowField$1$dst@1@@0) inline$$ReadRef$0$v@1@@1)) (and (=> (= (ControlFlow 0 188091) 188587) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 188091) 188105) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon64_Else_correct  (=> (and (not $abort_flag@4@@5) (= (ControlFlow 0 188097) 188091)) inline$$WriteRef$1$anon0_correct@@1)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@9@@2 $abort_code@8@@3) (= $abort_flag@5@@3 true)) (and (= $DualAttestation_Credential_$memory@0@@1 $DualAttestation_Credential_$memory) (= (ControlFlow 0 186825) 188759))) anon0$2_correct@@12)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon7_correct  (=> (and (= $abort_code@8@@3 $abort_code@1@@10) (= (ControlFlow 0 188729) 186825)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 188727) 188729)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon7_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 188737) 188729) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon7_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon47_Then_correct  (=> $abort_flag@0@@12 (and (=> (= (ControlFlow 0 188721) 188737) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 188721) 188727) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon11_correct  (=> (and (= $abort_code@8@@3 $abort_code@2@@11) (= (ControlFlow 0 188709) 186825)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 188707) 188709)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon11_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 188717) 188709) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon11_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon49_Then_correct  (=> $abort_flag@1@@11 (and (=> (= (ControlFlow 0 188701) 188717) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 188701) 188707) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon19_correct  (=> (and (= $abort_code@8@@3 $abort_code@2@@11) (= (ControlFlow 0 188689) 186825)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 188687) 188689)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon19_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 188697) 188689) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon19_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon53_Then_correct  (=> $abort_flag@1@@11 (and (=> (= (ControlFlow 0 188681) 188697) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 188681) 188687) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon23_correct  (=> (and (= $abort_code@8@@3 $abort_code@4@@10) (= (ControlFlow 0 188669) 186825)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 188667) 188669)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon23_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon56_Then_correct  (=> (= (ControlFlow 0 188677) 188669) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon23_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon55_Then_correct  (=> $abort_flag@2@@11 (and (=> (= (ControlFlow 0 188661) 188677) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 188661) 188667) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon31_correct  (=> (and (= $abort_code@8@@3 $abort_code@6@@5) (= (ControlFlow 0 188649) 186825)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 188647) 188649)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon31_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 188657) 188649) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon31_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon59_Then_correct  (=> $abort_flag@3@@6 (and (=> (= (ControlFlow 0 188641) 188657) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 188641) 188647) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon37_correct  (=> (and (= $abort_code@8@@3 $abort_code@7@@4) (= (ControlFlow 0 188619) 186825)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 188617) 188619)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon37_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 188627) 188619) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon37_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon62_Then_correct  (=> $abort_flag@4@@5 (and (=> (= (ControlFlow 0 188611) 188627) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 188611) 188617) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon41_correct  (=> (and (= $abort_code@8@@3 $abort_code@7@@4) (= (ControlFlow 0 188599) 186825)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 188597) 188599)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon41_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon65_Then_correct  (=> (= (ControlFlow 0 188607) 188599) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon41_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon64_Then_correct  (=> $abort_flag@4@@5 (and (=> (= (ControlFlow 0 188591) 188607) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 188591) 188597) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@0  (=> (= inline$$Event_emit_event$0$t@0@@0 $DualAttestation_ComplianceKeyRotationEvent_type_value) (and (=> (= (ControlFlow 0 188022) 188591) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 188022) 188097) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon62_Else$2_correct  (and (=> (= (ControlFlow 0 188032) (- 0 231002)) true) (=> (= (ControlFlow 0 188032) 188022) inline$$Event_emit_event$0$Entry_correct@@0))))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowField$1$dst@1@@0)) (= (ControlFlow 0 187974) 188032)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon62_Else$2_correct)))
(let ((inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 187930) 187974)) inline$$ReadRef$0$anon0_correct@@1)))
(let ((inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 187936) 187974) inline$$ReadRef$0$anon0_correct@@1)))
(let ((inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 187924) 187936) inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 187924) 187930) inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 187916) 187974)) inline$$ReadRef$0$anon0_correct@@1)))
(let ((inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Vector) new_key) (let ((va@@149 (|v#$Vector| new_key)))
(let ((l@@149 (|l#$ValueArray| va@@149)))
 (and (and (<= 0 l@@149) (<= l@@149 $MAX_U64)) (forall ((x@@149 Int) ) (!  (=> (or (< x@@149 0) (>= x@@149 l@@149)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149))
)))))) (forall ((inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$$$0 0) (< inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| new_key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_key)) inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_key)) inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_key)) inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_key)) inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$$$0))
))) (=> (and (and (and ((_ is $Integer) call2formal@$ret0@0@@1) (>= (|i#$Integer| call2formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@1) $MAX_U64)) (= inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 new_key) 1 call2formal@$ret0@0@@1) 2)))) (and (=> (= (ControlFlow 0 187908) 187924) inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 187908) 187916) inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon62_Else_correct  (=> (and (not $abort_flag@4@@5) (= (ControlFlow 0 187942) 187908)) inline$$DualAttestation_ComplianceKeyRotationEvent_pack$0$anon0_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon34$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@5) (=> $abort_flag@4@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@4@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@4 (|i#$Integer| ($Integer 1))))) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call2formal@$ret0@0@@1 ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 1000000)))))))))) (and (and ((_ is $Integer) call2formal@$ret0@0@@1) (>= (|i#$Integer| call2formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call2formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 187680) 188611) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 187680) 187942) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $DualAttestation_Credential_compliance_key_rotation_events) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) $DualAttestation_Credential_compliance_key_rotation_events))) (= (ControlFlow 0 187672) 187680))) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon34$2_correct))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 187492) 187672)) inline$$BorrowField$1$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 187548) 187672))) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 187456) 187548) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 187456) 187492) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 187319) 187456)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon61_Then_correct  (=> (and (= inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 188637) 187456)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) new_key)) (and (=> (= (ControlFlow 0 187305) 188637) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 187305) 187319) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $DualAttestation_Credential_compliance_public_key) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $DualAttestation_Credential_compliance_public_key))) (= (ControlFlow 0 187246) 187305))) inline$$WriteRef$0$anon0_correct@@1))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon59_Else_correct  (=> (and (not $abort_flag@3@@6) (= (ControlFlow 0 187252) 187246)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@3@@6 true) (=> (and (= $abort_code@6@@5 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 187116) 188641) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 187116) 187252) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 187114) 187116)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0))) (= $abort_flag@3@@6 $abort_flag@2@@11)) (and (= $abort_code@6@@5 $abort_code@4@@10) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 187062) 188641) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 187062) 187252) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| call3formal@$ret0@0@@24)) (and (=> (= (ControlFlow 0 187032) 187114) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 187032) 187062) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 187026) (- 0 230375)) true) (=> (= (ControlFlow 0 187026) 187032) inline$$BorrowGlobal$0$anon0_correct@@0))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon57_Then_correct  (=> (and (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1) (= (ControlFlow 0 187122) 187026)) inline$$BorrowGlobal$0$Entry_correct@@0)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon28_correct  (=> (and (= $abort_code@8@@3 $abort_code@5@@10) (= (ControlFlow 0 186913) 186825)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon58_Else_correct  (=> (and (not true) (= (ControlFlow 0 186911) 186913)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon28_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon58_Then_correct  (=> (= (ControlFlow 0 186921) 186913) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon28_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon57_Else_correct  (=> (and (not (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1)) (= $abort_code@5@@10 (|i#$Integer| call3formal@$ret0@0@@25))) (and (=> (= (ControlFlow 0 186905) 186921) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 186905) 186911) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon55_Else_correct  (=> (not $abort_flag@2@@11) (and (=> (= (ControlFlow 0 186893) 187122) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 186893) 186905) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon53_Else_correct  (=> (not $abort_flag@1@@11) (=> (and (and (and (= inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$t14@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@11)) (and (=> $abort_flag@2@@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@25 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@25) (>= (|i#$Integer| call3formal@$ret0@0@@25) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@25) $MAX_U64))) (and (=> (= (ControlFlow 0 186887) 188661) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 186887) 186893) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon55_Else_correct))))))
(let ((inline$$Signature_ed25519_validate_pubkey$0$anon0_correct  (=> (= inline$$Signature_ed25519_validate_pubkey$0$res@1 ($Signature_$ed25519_validate_pubkey new_key)) (and (=> (= (ControlFlow 0 186869) 188681) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 186869) 186887) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon51_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$t10@1) (= (ControlFlow 0 186875) 186869)) inline$$Signature_ed25519_validate_pubkey$0$anon0_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon16_correct  (=> (and (= $abort_code@8@@3 $abort_code@3@@10) (= (ControlFlow 0 186821) 186825)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 186819) 186821)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 186833) 186821) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon16_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon51_Else_correct  (=> (and (not (|b#$Boolean| inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$t10@1)) (= $abort_code@3@@10 (|i#$Integer| call3formal@$ret0@0@@26))) (and (=> (= (ControlFlow 0 186813) 186833) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 186813) 186819) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@1@@11) (and (=> (= (ControlFlow 0 186801) 186875) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 186801) 186813) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon47_Else_correct  (=> (and (not $abort_flag@0@@12) (= inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@24))))) (=> (and (and (and (= inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@11)) (and (=> $abort_flag@1@@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@26 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@26) (>= (|i#$Integer| call3formal@$ret0@0@@26) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@26) $MAX_U64))) (and (=> (= (ControlFlow 0 186795) 188701) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 186795) 186801) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon49_Else_correct))))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@12) (=> $abort_flag@0@@12 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@24 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@24))) (and (=> (= (ControlFlow 0 186777) 188721) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 186777) 186795) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 186707) 186777)) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon4$2_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 188745) 186777) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon4$2_correct)))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 186699) 188745) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 186699) 186707) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 188753) 188745) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 188753) 186707) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon46_Else_correct))))
(let ((inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 186693) 188753) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 186693) 186699) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon45_Else_correct)))))
(let ((anon0$1_correct@@11  (=> (forall (($inv_addr@@27 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27)) (let ((va@@150 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))))
(let ((l@@150 (|l#$ValueArray| va@@150)))
 (and (and (<= 0 l@@150) (<= l@@150 $MAX_U64)) (forall ((x@@150 Int) ) (!  (=> (or (< x@@150 0) (>= x@@150 l@@150)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@27))
)) (=> (and (forall (($inv_addr@@28 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28)) (let ((va@@151 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))))
(let ((l@@151 (|l#$ValueArray| va@@151)))
 (and (and (<= 0 l@@151) (<= l@@151 $MAX_U64)) (forall ((x@@151 Int) ) (!  (=> (or (< x@@151 0) (>= x@@151 l@@151)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_human_name)) (let ((va@@152 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_human_name))))
(let ((l@@152 (|l#$ValueArray| va@@152)))
 (and (and (<= 0 l@@152) (<= l@@152 $MAX_U64)) (forall ((x@@152 Int) ) (!  (=> (or (< x@@152 0) (>= x@@152 l@@152)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152))
))))))) (forall (($$0@@70 Int) ) (!  (=> (and (>= $$0@@70 0) (< $$0@@70 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_human_name))) $$0@@70)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_human_name))) $$0@@70)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_human_name))) $$0@@70)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_human_name))) $$0@@70))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url)) (let ((va@@153 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url))))
(let ((l@@153 (|l#$ValueArray| va@@153)))
 (and (and (<= 0 l@@153) (<= l@@153 $MAX_U64)) (forall ((x@@153 Int) ) (!  (=> (or (< x@@153 0) (>= x@@153 l@@153)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153))
))))))) (forall (($$0@@71 Int) ) (!  (=> (and (>= $$0@@71 0) (< $$0@@71 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url))) $$0@@71)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url))) $$0@@71)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url))) $$0@@71)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url))) $$0@@71))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@154 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@154 (|l#$ValueArray| va@@154)))
 (and (and (<= 0 l@@154) (<= l@@154 $MAX_U64)) (forall ((x@@154 Int) ) (!  (=> (or (< x@@154 0) (>= x@@154 l@@154)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154))
))))))) (forall (($$0@@72 Int) ) (!  (=> (and (>= $$0@@72 0) (< $$0@@72 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_public_key))) $$0@@72)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_public_key))) $$0@@72)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_public_key))) $$0@@72)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_public_key))) $$0@@72))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@155 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@155 (|l#$ValueArray| va@@155)))
 (and (and (<= 0 l@@155) (<= l@@155 $MAX_U64)) (forall ((x@@155 Int) ) (!  (=> (or (< x@@155 0) (>= x@@155 l@@155)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@156 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@156 (|l#$ValueArray| va@@156)))
 (and (and (<= 0 l@@156) (<= l@@156 $MAX_U64)) (forall ((x@@156 Int) ) (!  (=> (or (< x@@156 0) (>= x@@156 l@@156)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156))
))))))) (forall (($$0@@73 Int) ) (!  (=> (and (>= $$0@@73 0) (< $$0@@73 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@73)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@73)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@73)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@73))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@157 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@157 (|l#$ValueArray| va@@157)))
 (and (and (<= 0 l@@157) (<= l@@157 $MAX_U64)) (forall ((x@@157 Int) ) (!  (=> (or (< x@@157 0) (>= x@@157 l@@157)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@158 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@158 (|l#$ValueArray| va@@158)))
 (and (and (<= 0 l@@158) (<= l@@158 $MAX_U64)) (forall ((x@@158 Int) ) (!  (=> (or (< x@@158 0) (>= x@@158 l@@158)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158))
))))))) (forall (($$0@@74 Int) ) (!  (=> (and (>= $$0@@74 0) (< $$0@@74 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@74)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@74)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@74)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@74))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@28))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr1@@119 T@$Value) )  (=> ((_ is $Address) addr1@@119) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@119)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@119)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@119)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@119)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@119)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 188757) 186693)))) inline$$DualAttestation_rotate_compliance_public_key_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@12  (=> ((_ is $Address) account@@0) (=> (and (and (and ((_ is $Vector) new_key) (let ((va@@159 (|v#$Vector| new_key)))
(let ((l@@159 (|l#$ValueArray| va@@159)))
 (and (and (<= 0 l@@159) (<= l@@159 $MAX_U64)) (forall ((x@@159 Int) ) (!  (=> (or (< x@@159 0) (>= x@@159 l@@159)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159))
)))))) (forall (($$0@@75 Int) ) (!  (=> (and (>= $$0@@75 0) (< $$0@@75 (|l#$ValueArray| (|v#$Vector| new_key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_key)) $$0@@75)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_key)) $$0@@75)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_key)) $$0@@75)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_key)) $$0@@75))
))) (= (ControlFlow 0 185684) 188757)) anon0$1_correct@@11))))
(let ((PreconditionGeneratedEntry_correct@@11  (=> (= (ControlFlow 0 228633) 185684) anon0_correct@@12)))
PreconditionGeneratedEntry_correct@@11))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun tc_account () T@$Value)
(declare-fun $abort_flag@3@@7 () Bool)
(declare-fun $abort_code@6@@6 () Int)
(declare-fun $DualAttestation_Limit_$memory@0@@0 () T@$Memory)
(declare-fun micro_xdx_limit () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun $abort_code@4@@11 () Int)
(declare-fun $abort_flag@2@@12 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun $abort_code@5@@11 () Int)
(declare-fun $abort_code@1@@11 () Int)
(declare-fun $abort_flag@0@@13 () Bool)
(declare-fun $abort_code@2@@12 () Int)
(declare-fun $abort_flag@1@@12 () Bool)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0 () T@$Value)
(declare-fun inline$$DualAttestation_set_microdiem_limit_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@11 () Int)
(declare-fun call3formal@$ret0@0@@27 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1 () T@$Value)
(declare-fun inline$$DualAttestation_set_microdiem_limit_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 231932) (let ((anon0$2_correct@@13  (and (=> (= (ControlFlow 0 191265) (- 0 234368)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@3@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@3@@7) (and (=> (= (ControlFlow 0 191265) (- 0 234389)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3@@7) (and (=> (= (ControlFlow 0 191265) (- 0 234418)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@3@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@3@@7) (and (=> (= (ControlFlow 0 191265) (- 0 234435)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@7) (and (=> (= (ControlFlow 0 191265) (- 0 234449)) (=> $abort_flag@3@@7 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@3@@7 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 191265) (- 0 234527)) (=> $abort_flag@3@@7 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@6@@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@6@@6 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@6@@6 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6@@6 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@3@@7 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@6@@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@6@@6 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@6@@6 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6@@6 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 191265) (- 0 234649)) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) micro_xdx_limit))))) (=> (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit) micro_xdx_limit)))) (and (=> (= (ControlFlow 0 191265) (- 0 234673)) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@120 T@$Value) )  (=> ((_ is $Address) addr1@@120) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@120)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@120))))))))))))) (=> (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@121 T@$Value) )  (=> ((_ is $Address) addr1@@121) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@121)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@121)))))))))))) (and (=> (= (ControlFlow 0 191265) (- 0 234713)) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@122 T@$Value) )  (=> ((_ is $Address) addr1@@122) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@122))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@122)))))))))))))))) (=> (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@123 T@$Value) )  (=> ((_ is $Address) addr1@@123) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@123))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@123))))))))))))))) (and (=> (= (ControlFlow 0 191265) (- 0 234765)) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@124 T@$Value) )  (=> ((_ is $Address) addr1@@124) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@124)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@124)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@124)))) $DualAttestation_Credential_compliance_public_key))))))))))))) (=> (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@125 T@$Value) )  (=> ((_ is $Address) addr1@@125) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@125)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@125)))) $DualAttestation_Credential_compliance_public_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@125)))) $DualAttestation_Credential_compliance_public_key)))))))))))) (=> (= (ControlFlow 0 191265) (- 0 234827)) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@126 T@$Value) )  (=> ((_ is $Address) addr1@@126) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@126)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@126)))) $DualAttestation_Credential_base_url) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@126)))) $DualAttestation_Credential_base_url)))))))))))))))))))))))))))))))))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon35_Else$4_correct  (and (=> (= (ControlFlow 0 191175) (- 0 234266)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (and (and (= $abort_code@6@@6 $abort_code@4@@11) (= $abort_flag@3@@7 $abort_flag@2@@12)) (and (= $DualAttestation_Limit_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@1|) (= (ControlFlow 0 191175) 191265))) anon0$2_correct@@13)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@1| $DualAttestation_Limit_$memory) (= (ControlFlow 0 191095) 191175)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon35_Else$4_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $DualAttestation_Limit_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@1|) (= (ControlFlow 0 191149) 191175))) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon35_Else$4_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 191085) 191149) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 191085) 191095) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 190907) 191085)) inline$$WritebackToGlobal$0$anon0_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 190963) 191085))) inline$$WritebackToGlobal$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) (and (=> (= (ControlFlow 0 190871) 190963) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 190871) 190907) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (and (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@1) (|p#$Mutation| inline$$BorrowField$0$dst@1@@1) micro_xdx_limit)) (= (ControlFlow 0 190728) 190871)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $DualAttestation_Limit_micro_xdx_limit) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $DualAttestation_Limit_micro_xdx_limit))) (= (ControlFlow 0 190669) 190728))) inline$$WriteRef$0$anon0_correct@@2))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon35_Else_correct  (=> (and (not $abort_flag@2@@12) (= (ControlFlow 0 190675) 190669)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@6@@6 $abort_code@5@@11) (= $abort_flag@3@@7 true)) (and (= $DualAttestation_Limit_$memory@0@@0 $DualAttestation_Limit_$memory) (= (ControlFlow 0 190199) 191265))) anon0$2_correct@@13)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon7_correct  (=> (and (= $abort_code@5@@11 $abort_code@1@@11) (= (ControlFlow 0 191235) 190199)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 191233) 191235)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon7_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 191243) 191235) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon7_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon27_Then_correct  (=> $abort_flag@0@@13 (and (=> (= (ControlFlow 0 191227) 191243) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 191227) 191233) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon13_correct  (=> (and (= $abort_code@5@@11 $abort_code@2@@12) (= (ControlFlow 0 191211) 190199)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 191209) 191211)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 191219) 191211) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon13_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon30_Then_correct  (=> $abort_flag@1@@12 (and (=> (= (ControlFlow 0 191203) 191219) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 191203) 191209) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon23_correct  (=> (and (= $abort_code@5@@11 $abort_code@4@@11) (= (ControlFlow 0 191187) 190199)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 191185) 191187)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon23_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 191195) 191187) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon23_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon35_Then_correct  (=> $abort_flag@2@@12 (and (=> (= (ControlFlow 0 191179) 191195) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 191179) 191185) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@2@@12 true) (=> (and (= $abort_code@4@@11 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 190539) 191179) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 190539) 190675) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 190537) 190539)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1))) (= $abort_flag@2@@12 $abort_flag@1@@12)) (and (= $abort_code@4@@11 $abort_code@2@@12) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 190485) 191179) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 190485) 190675) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0)) (and (=> (= (ControlFlow 0 190455) 190537) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 190455) 190485) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 190449) (- 0 233845)) true) (=> (= (ControlFlow 0 190449) 190455) inline$$BorrowGlobal$0$anon0_correct@@1))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@1@@12) (= (ControlFlow 0 190545) 190449)) inline$$BorrowGlobal$0$Entry_correct@@1)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon34_Then_correct  (=> $abort_flag@1@@12 (=> (and (= $abort_code@5@@11 $abort_code@2@@12) (= (ControlFlow 0 191199) 190199)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 190318) 191199) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 190318) 190545) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 190328) 191199) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 190328) 190545) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon34_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@0  (=> (and (not $abort_flag@1@@12) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 190312) 190328) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 190312) 190318) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@0)))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon32_Then_correct  (=> (and (|b#$Boolean| inline$$DualAttestation_set_microdiem_limit_$def_verify$0$$t7@1) (= (ControlFlow 0 190342) 190312)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@0)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon18_correct  (=> (and (= $abort_code@5@@11 $abort_code@3@@11) (= (ControlFlow 0 190195) 190199)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$Abort_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 190193) 190195)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon18_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 190207) 190195) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon18_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon32_Else_correct  (=> (and (not (|b#$Boolean| inline$$DualAttestation_set_microdiem_limit_$def_verify$0$$t7@1)) (= $abort_code@3@@11 (|i#$Integer| call3formal@$ret0@0@@27))) (and (=> (= (ControlFlow 0 190187) 190207) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 190187) 190193) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon30_Else_correct  (=> (not $abort_flag@1@@12) (and (=> (= (ControlFlow 0 190175) 190342) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 190175) 190187) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon29_Else_correct  (=> (and (not $abort_flag@0@@13) (= inline$$DualAttestation_set_microdiem_limit_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1))))) (=> (and (and (and (= inline$$DualAttestation_set_microdiem_limit_$def_verify$0$$t8@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@12)) (and (=> $abort_flag@1@@12 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@27 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@27) (>= (|i#$Integer| call3formal@$ret0@0@@27) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@27) $MAX_U64))) (and (=> (= (ControlFlow 0 190169) 191203) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 190169) 190175) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon29_Then_correct  (=> $abort_flag@0@@13 (=> (and (= $abort_code@5@@11 $abort_code@1@@11) (= (ControlFlow 0 191223) 190199)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 190125) 191223) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 190125) 190169) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@1  (and (=> (= (ControlFlow 0 190135) 191223) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 190135) 190169) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon29_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@1  (=> (and (not $abort_flag@0@@13) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 190119) 190135) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 190119) 190125) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@1)))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@0@@13) (= (ControlFlow 0 190149) 190119)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@1)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@0@@13) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@13) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@0@@13)) (and (=> $abort_flag@0@@13 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@0@@13 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@1@@11 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@11 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@1@@11 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 190014) 191227) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 190014) 190149) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon27_Else_correct))))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 189944) 190014)) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon4$2_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 191251) 190014) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon4$2_correct)))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 189936) 191251) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 189936) 189944) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 191259) 191251) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 191259) 189944) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon26_Else_correct))))
(let ((inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 189930) 191259) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 189930) 189936) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@12  (=> (and (and (and (forall (($inv_addr@@29 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29)) (let ((va@@160 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))))
(let ((l@@160 (|l#$ValueArray| va@@160)))
 (and (and (<= 0 l@@160) (<= l@@160 $MAX_U64)) (forall ((x@@160 Int) ) (!  (=> (or (< x@@160 0) (>= x@@160 l@@160)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@29))
)) (forall (($inv_addr@@30 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@30)) (let ((va@@161 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@30))))
(let ((l@@161 (|l#$ValueArray| va@@161)))
 (and (and (<= 0 l@@161) (<= l@@161 $MAX_U64)) (forall ((x@@161 Int) ) (!  (=> (or (< x@@161 0) (>= x@@161 l@@161)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@30))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@30))) $DualAttestation_Limit_micro_xdx_limit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@30))) $DualAttestation_Limit_micro_xdx_limit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@30))) $DualAttestation_Limit_micro_xdx_limit)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@30))
))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@5 T@$Value) )  (=> ((_ is $Type) coin_type@@5) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@0 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@6 T@$Value) )  (=> ((_ is $Type) coin_type@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@127 T@$Value) )  (=> ((_ is $Address) addr1@@127) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| addr1@@127)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@127)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@127)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@7 T@$Value) )  (=> ((_ is $Type) coin_type@@7) (|b#$Boolean| ($Boolean (forall ((addr1@@128 T@$Value) )  (=> ((_ is $Address) addr1@@128) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| addr1@@128)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@128)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@128)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr1@@129 T@$Value) )  (=> ((_ is $Address) addr1@@129) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@129)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@129)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@129)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@129)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@129)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (= (ControlFlow 0 191263) 189930)))) inline$$DualAttestation_set_microdiem_limit_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@13  (=> ((_ is $Address) tc_account) (=> (and (and (and ((_ is $Integer) micro_xdx_limit) (>= (|i#$Integer| micro_xdx_limit) 0)) (<= (|i#$Integer| micro_xdx_limit) $MAX_U64)) (= (ControlFlow 0 189195) 191263)) anon0$1_correct@@12))))
(let ((PreconditionGeneratedEntry_correct@@12  (=> (= (ControlFlow 0 231932) 189195) anon0_correct@@13)))
PreconditionGeneratedEntry_correct@@12))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
