(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $AccountFreezing_FreezeAccountEvent () T@$TypeName)
(declare-fun $AccountFreezing_FreezeEventsHolder () T@$TypeName)
(declare-fun $AccountFreezing_FreezingBit () T@$TypeName)
(declare-fun $AccountFreezing_UnfreezeAccountEvent () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $ChainId_ChainId () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DesignatedDealer_Dealer () T@$TypeName)
(declare-fun $DesignatedDealer_ReceivedMintEvent () T@$TypeName)
(declare-fun $DesignatedDealer_TierInfo () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $SlidingNonce_SlidingNonce () T@$TypeName)
(declare-fun $DualAttestation_BaseUrlRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_Credential () T@$TypeName)
(declare-fun $DualAttestation_Limit () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $DiemAccount_DiemAccount () T@$TypeName)
(declare-fun $DiemAccount_AccountOperationsCapability () T@$TypeName)
(declare-fun $DiemAccount_AdminTransactionEvent () T@$TypeName)
(declare-fun $DiemAccount_Balance () T@$TypeName)
(declare-fun $DiemAccount_CreateAccountEvent () T@$TypeName)
(declare-fun $DiemAccount_DiemWriteSetManager () T@$TypeName)
(declare-fun $DiemAccount_KeyRotationCapability () T@$TypeName)
(declare-fun $DiemAccount_ReceivedPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_SentPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_WithdrawCapability () T@$TypeName)
(declare-fun $DiemSystem_DiemSystem () T@$TypeName)
(declare-fun $DiemSystem_CapabilityHolder () T@$TypeName)
(declare-fun $DiemSystem_ValidatorInfo () T@$TypeName)
(declare-fun $DiemBlock_BlockMetadata () T@$TypeName)
(declare-fun $DiemBlock_NewBlockEvent () T@$TypeName)
(declare-fun $DiemVMConfig_DiemVMConfig () T@$TypeName)
(declare-fun $DiemVMConfig_GasConstants () T@$TypeName)
(declare-fun $DiemVMConfig_GasSchedule () T@$TypeName)
(declare-fun $DiemVersion_DiemVersion () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_frozen_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeEventsHolder_freeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezingBit_is_frozen () Int)
(declare-fun $AccountFreezing_FreezingBit_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_unfrozen_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ChainId_ChainId_id () Int)
(declare-fun $ChainId_ChainId_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_Dealer_mint_event_handle () Int)
(declare-fun $DesignatedDealer_Dealer_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_ReceivedMintEvent_currency_code () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_destination_address () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_amount () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_TierInfo_window_start () Int)
(declare-fun $DesignatedDealer_TierInfo_window_inflow () Int)
(declare-fun $DesignatedDealer_TierInfo_tiers () Int)
(declare-fun $DesignatedDealer_TierInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $SlidingNonce_spec_try_record_nonce (T@$Value T@$Value) T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_min_nonce () Int)
(declare-fun $SlidingNonce_SlidingNonce_nonce_mask () Int)
(declare-fun $SlidingNonce_SlidingNonce_type_value () T@$TypeValue)
(declare-fun $DualAttestation_spec_dual_attestation_message (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $DualAttestation_BaseUrlRotationEvent_new_base_url () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Credential_human_name () Int)
(declare-fun $DualAttestation_Credential_base_url () Int)
(declare-fun $DualAttestation_Credential_compliance_public_key () Int)
(declare-fun $DualAttestation_Credential_expiration_date () Int)
(declare-fun $DualAttestation_Credential_compliance_key_rotation_events () Int)
(declare-fun $DualAttestation_Credential_base_url_rotation_events () Int)
(declare-fun $DualAttestation_Credential_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Limit_micro_xdx_limit () Int)
(declare-fun $DualAttestation_Limit_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun $DiemAccount_spec_abstract_create_authentication_key (T@$Value) T@$Value)
(declare-fun $DiemAccount_DiemAccount_authentication_key () Int)
(declare-fun $DiemAccount_DiemAccount_withdraw_capability () Int)
(declare-fun $DiemAccount_DiemAccount_key_rotation_capability () Int)
(declare-fun $DiemAccount_DiemAccount_received_events () Int)
(declare-fun $DiemAccount_DiemAccount_sent_events () Int)
(declare-fun $DiemAccount_DiemAccount_sequence_number () Int)
(declare-fun $DiemAccount_DiemAccount_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AccountOperationsCapability_limits_cap () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_creation_events () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AdminTransactionEvent_committed_timestamp_secs () Int)
(declare-fun $DiemAccount_AdminTransactionEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_Balance_coin () Int)
(declare-fun $DiemAccount_Balance_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemAccount_CreateAccountEvent_created () Int)
(declare-fun $DiemAccount_CreateAccountEvent_role_id () Int)
(declare-fun $DiemAccount_CreateAccountEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_DiemWriteSetManager_upgrade_events () Int)
(declare-fun $DiemAccount_DiemWriteSetManager_type_value () T@$TypeValue)
(declare-fun $DiemAccount_KeyRotationCapability_account_address () Int)
(declare-fun $DiemAccount_KeyRotationCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_ReceivedPaymentEvent_amount () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_payer () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_SentPaymentEvent_amount () Int)
(declare-fun $DiemAccount_SentPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_SentPaymentEvent_payee () Int)
(declare-fun $DiemAccount_SentPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_SentPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_WithdrawCapability_account_address () Int)
(declare-fun $DiemAccount_WithdrawCapability_type_value () T@$TypeValue)
(declare-fun $DiemSystem_DiemSystem_scheme () Int)
(declare-fun $DiemSystem_DiemSystem_validators () Int)
(declare-fun $DiemSystem_DiemSystem_type_value () T@$TypeValue)
(declare-fun $DiemSystem_CapabilityHolder_cap () Int)
(declare-fun $DiemSystem_CapabilityHolder_type_value () T@$TypeValue)
(declare-fun $DiemSystem_ValidatorInfo_addr () Int)
(declare-fun $DiemSystem_ValidatorInfo_consensus_voting_power () Int)
(declare-fun $DiemSystem_ValidatorInfo_config () Int)
(declare-fun $DiemSystem_ValidatorInfo_last_config_update_time () Int)
(declare-fun $DiemSystem_ValidatorInfo_type_value () T@$TypeValue)
(declare-fun $DiemBlock_BlockMetadata_height () Int)
(declare-fun $DiemBlock_BlockMetadata_new_block_events () Int)
(declare-fun $DiemBlock_BlockMetadata_type_value () T@$TypeValue)
(declare-fun $DiemBlock_NewBlockEvent_round () Int)
(declare-fun $DiemBlock_NewBlockEvent_proposer () Int)
(declare-fun $DiemBlock_NewBlockEvent_previous_block_votes () Int)
(declare-fun $DiemBlock_NewBlockEvent_time_microseconds () Int)
(declare-fun $DiemBlock_NewBlockEvent_type_value () T@$TypeValue)
(declare-fun $DiemVMConfig_DiemVMConfig_gas_schedule () Int)
(declare-fun $DiemVMConfig_DiemVMConfig_type_value () T@$TypeValue)
(declare-fun $DiemVMConfig_GasConstants_global_memory_per_byte_cost () Int)
(declare-fun $DiemVMConfig_GasConstants_global_memory_per_byte_write_cost () Int)
(declare-fun $DiemVMConfig_GasConstants_min_transaction_gas_units () Int)
(declare-fun $DiemVMConfig_GasConstants_large_transaction_cutoff () Int)
(declare-fun $DiemVMConfig_GasConstants_intrinsic_gas_per_byte () Int)
(declare-fun $DiemVMConfig_GasConstants_maximum_number_of_gas_units () Int)
(declare-fun $DiemVMConfig_GasConstants_min_price_per_gas_unit () Int)
(declare-fun $DiemVMConfig_GasConstants_max_price_per_gas_unit () Int)
(declare-fun $DiemVMConfig_GasConstants_max_transaction_size_in_bytes () Int)
(declare-fun $DiemVMConfig_GasConstants_gas_unit_scaling_factor () Int)
(declare-fun $DiemVMConfig_GasConstants_default_account_size () Int)
(declare-fun $DiemVMConfig_GasConstants_type_value () T@$TypeValue)
(declare-fun $DiemVMConfig_GasSchedule_instruction_schedule () Int)
(declare-fun $DiemVMConfig_GasSchedule_native_schedule () Int)
(declare-fun $DiemVMConfig_GasSchedule_gas_constants () Int)
(declare-fun $DiemVMConfig_GasSchedule_type_value () T@$TypeValue)
(declare-fun $DiemVersion_DiemVersion_major () Int)
(declare-fun $DiemVersion_DiemVersion_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $AccountFreezing_FreezeAccountEvent $AccountFreezing_FreezeEventsHolder $AccountFreezing_FreezingBit $AccountFreezing_UnfreezeAccountEvent $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $ChainId_ChainId $FixedPoint32_FixedPoint32 $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $DesignatedDealer_Dealer $DesignatedDealer_ReceivedMintEvent $DesignatedDealer_TierInfo $XDX_XDX $XDX_Reserve $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_Config $ValidatorConfig_ValidatorConfig $VASP_ChildVASP $VASP_ParentVASP $TransactionFee_TransactionFee $SlidingNonce_SlidingNonce $DualAttestation_BaseUrlRotationEvent $DualAttestation_ComplianceKeyRotationEvent $DualAttestation_Credential $DualAttestation_Limit $DiemTransactionPublishingOption_DiemTransactionPublishingOption $DiemAccount_DiemAccount $DiemAccount_AccountOperationsCapability $DiemAccount_AdminTransactionEvent $DiemAccount_Balance $DiemAccount_CreateAccountEvent $DiemAccount_DiemWriteSetManager $DiemAccount_KeyRotationCapability $DiemAccount_ReceivedPaymentEvent $DiemAccount_SentPaymentEvent $DiemAccount_WithdrawCapability $DiemSystem_DiemSystem $DiemSystem_CapabilityHolder $DiemSystem_ValidatorInfo $DiemBlock_BlockMetadata $DiemBlock_NewBlockEvent $DiemVMConfig_DiemVMConfig $DiemVMConfig_GasConstants $DiemVMConfig_GasSchedule $DiemVersion_DiemVersion)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_FreezeAccountEvent_frozen_address 1))
(assert (= $AccountFreezing_FreezeAccountEvent_type_value ($StructType $AccountFreezing_FreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeEventsHolder_freeze_event_handle 0))
(assert (= $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle 1))
(assert (= $AccountFreezing_FreezeEventsHolder_type_value ($StructType $AccountFreezing_FreezeEventsHolder $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezingBit_is_frozen 0))
(assert (= $AccountFreezing_FreezingBit_type_value ($StructType $AccountFreezing_FreezingBit $EmptyTypeValueArray)))
(assert (= $AccountFreezing_UnfreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_UnfreezeAccountEvent_unfrozen_address 1))
(assert (= $AccountFreezing_UnfreezeAccountEvent_type_value ($StructType $AccountFreezing_UnfreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0@@0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0@@0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@1) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@1))
)))
(assert (= $ChainId_ChainId_id 0))
(assert (= $ChainId_ChainId_type_value ($StructType $ChainId_ChainId $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_Dealer_mint_event_handle 0))
(assert (= $DesignatedDealer_Dealer_type_value ($StructType $DesignatedDealer_Dealer $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_ReceivedMintEvent_currency_code 0))
(assert (= $DesignatedDealer_ReceivedMintEvent_destination_address 1))
(assert (= $DesignatedDealer_ReceivedMintEvent_amount 2))
(assert (= $DesignatedDealer_ReceivedMintEvent_type_value ($StructType $DesignatedDealer_ReceivedMintEvent $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_TierInfo_window_start 0))
(assert (= $DesignatedDealer_TierInfo_window_inflow 1))
(assert (= $DesignatedDealer_TierInfo_tiers 2))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($DesignatedDealer_TierInfo_type_value $tv0@@9) ($StructType $DesignatedDealer_TierInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($DesignatedDealer_TierInfo_type_value $tv0@@9))
)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@10 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@10) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1))) :pattern ( ($Option_Option_type_value $tv0@@10))
)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@11 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@11) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@11))
)))
(assert (forall ((account T@$Value) (seq_nonce T@$Value) )  (and (and ((_ is $Integer) ($SlidingNonce_spec_try_record_nonce account seq_nonce)) (>= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) 0)) (<= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) $MAX_U64))))
(assert (= $SlidingNonce_SlidingNonce_min_nonce 0))
(assert (= $SlidingNonce_SlidingNonce_nonce_mask 1))
(assert (= $SlidingNonce_SlidingNonce_type_value ($StructType $SlidingNonce_SlidingNonce $EmptyTypeValueArray)))
(assert (forall ((payer T@$Value) (metadata T@$Value) (deposit_value T@$Value) )  (and (and ((_ is $Vector) ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value)) (let ((va@@8 (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0))
)))))
(assert (= $DualAttestation_BaseUrlRotationEvent_new_base_url 0))
(assert (= $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_BaseUrlRotationEvent_type_value ($StructType $DualAttestation_BaseUrlRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key 0))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_type_value ($StructType $DualAttestation_ComplianceKeyRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_Credential_human_name 0))
(assert (= $DualAttestation_Credential_base_url 1))
(assert (= $DualAttestation_Credential_compliance_public_key 2))
(assert (= $DualAttestation_Credential_expiration_date 3))
(assert (= $DualAttestation_Credential_compliance_key_rotation_events 4))
(assert (= $DualAttestation_Credential_base_url_rotation_events 5))
(assert (= $DualAttestation_Credential_type_value ($StructType $DualAttestation_Credential $EmptyTypeValueArray)))
(assert (= $DualAttestation_Limit_micro_xdx_limit 0))
(assert (= $DualAttestation_Limit_type_value ($StructType $DualAttestation_Limit $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((auth_key_prefix T@$Value) )  (and (and ((_ is $Vector) ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix)) (let ((va@@9 (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0))
)))))
(assert (= $DiemAccount_DiemAccount_authentication_key 0))
(assert (= $DiemAccount_DiemAccount_withdraw_capability 1))
(assert (= $DiemAccount_DiemAccount_key_rotation_capability 2))
(assert (= $DiemAccount_DiemAccount_received_events 3))
(assert (= $DiemAccount_DiemAccount_sent_events 4))
(assert (= $DiemAccount_DiemAccount_sequence_number 5))
(assert (= $DiemAccount_DiemAccount_type_value ($StructType $DiemAccount_DiemAccount $EmptyTypeValueArray)))
(assert (= $DiemAccount_AccountOperationsCapability_limits_cap 0))
(assert (= $DiemAccount_AccountOperationsCapability_creation_events 1))
(assert (= $DiemAccount_AccountOperationsCapability_type_value ($StructType $DiemAccount_AccountOperationsCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_AdminTransactionEvent_committed_timestamp_secs 0))
(assert (= $DiemAccount_AdminTransactionEvent_type_value ($StructType $DiemAccount_AdminTransactionEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_Balance_coin 0))
(assert (forall (($tv0@@12 T@$TypeValue) ) (! (= ($DiemAccount_Balance_type_value $tv0@@12) ($StructType $DiemAccount_Balance ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1))) :pattern ( ($DiemAccount_Balance_type_value $tv0@@12))
)))
(assert (= $DiemAccount_CreateAccountEvent_created 0))
(assert (= $DiemAccount_CreateAccountEvent_role_id 1))
(assert (= $DiemAccount_CreateAccountEvent_type_value ($StructType $DiemAccount_CreateAccountEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_DiemWriteSetManager_upgrade_events 0))
(assert (= $DiemAccount_DiemWriteSetManager_type_value ($StructType $DiemAccount_DiemWriteSetManager $EmptyTypeValueArray)))
(assert (= $DiemAccount_KeyRotationCapability_account_address 0))
(assert (= $DiemAccount_KeyRotationCapability_type_value ($StructType $DiemAccount_KeyRotationCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_ReceivedPaymentEvent_amount 0))
(assert (= $DiemAccount_ReceivedPaymentEvent_currency_code 1))
(assert (= $DiemAccount_ReceivedPaymentEvent_payer 2))
(assert (= $DiemAccount_ReceivedPaymentEvent_metadata 3))
(assert (= $DiemAccount_ReceivedPaymentEvent_type_value ($StructType $DiemAccount_ReceivedPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_SentPaymentEvent_amount 0))
(assert (= $DiemAccount_SentPaymentEvent_currency_code 1))
(assert (= $DiemAccount_SentPaymentEvent_payee 2))
(assert (= $DiemAccount_SentPaymentEvent_metadata 3))
(assert (= $DiemAccount_SentPaymentEvent_type_value ($StructType $DiemAccount_SentPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_WithdrawCapability_account_address 0))
(assert (= $DiemAccount_WithdrawCapability_type_value ($StructType $DiemAccount_WithdrawCapability $EmptyTypeValueArray)))
(assert (= $DiemSystem_DiemSystem_scheme 0))
(assert (= $DiemSystem_DiemSystem_validators 1))
(assert (= $DiemSystem_DiemSystem_type_value ($StructType $DiemSystem_DiemSystem $EmptyTypeValueArray)))
(assert (= $DiemSystem_CapabilityHolder_cap 0))
(assert (= $DiemSystem_CapabilityHolder_type_value ($StructType $DiemSystem_CapabilityHolder $EmptyTypeValueArray)))
(assert (= $DiemSystem_ValidatorInfo_addr 0))
(assert (= $DiemSystem_ValidatorInfo_consensus_voting_power 1))
(assert (= $DiemSystem_ValidatorInfo_config 2))
(assert (= $DiemSystem_ValidatorInfo_last_config_update_time 3))
(assert (= $DiemSystem_ValidatorInfo_type_value ($StructType $DiemSystem_ValidatorInfo $EmptyTypeValueArray)))
(assert (= $DiemBlock_BlockMetadata_height 0))
(assert (= $DiemBlock_BlockMetadata_new_block_events 1))
(assert (= $DiemBlock_BlockMetadata_type_value ($StructType $DiemBlock_BlockMetadata $EmptyTypeValueArray)))
(assert (= $DiemBlock_NewBlockEvent_round 0))
(assert (= $DiemBlock_NewBlockEvent_proposer 1))
(assert (= $DiemBlock_NewBlockEvent_previous_block_votes 2))
(assert (= $DiemBlock_NewBlockEvent_time_microseconds 3))
(assert (= $DiemBlock_NewBlockEvent_type_value ($StructType $DiemBlock_NewBlockEvent $EmptyTypeValueArray)))
(assert (= $DiemVMConfig_DiemVMConfig_gas_schedule 0))
(assert (= $DiemVMConfig_DiemVMConfig_type_value ($StructType $DiemVMConfig_DiemVMConfig $EmptyTypeValueArray)))
(assert (= $DiemVMConfig_GasConstants_global_memory_per_byte_cost 0))
(assert (= $DiemVMConfig_GasConstants_global_memory_per_byte_write_cost 1))
(assert (= $DiemVMConfig_GasConstants_min_transaction_gas_units 2))
(assert (= $DiemVMConfig_GasConstants_large_transaction_cutoff 3))
(assert (= $DiemVMConfig_GasConstants_intrinsic_gas_per_byte 4))
(assert (= $DiemVMConfig_GasConstants_maximum_number_of_gas_units 5))
(assert (= $DiemVMConfig_GasConstants_min_price_per_gas_unit 6))
(assert (= $DiemVMConfig_GasConstants_max_price_per_gas_unit 7))
(assert (= $DiemVMConfig_GasConstants_max_transaction_size_in_bytes 8))
(assert (= $DiemVMConfig_GasConstants_gas_unit_scaling_factor 9))
(assert (= $DiemVMConfig_GasConstants_default_account_size 10))
(assert (= $DiemVMConfig_GasConstants_type_value ($StructType $DiemVMConfig_GasConstants $EmptyTypeValueArray)))
(assert (= $DiemVMConfig_GasSchedule_instruction_schedule 0))
(assert (= $DiemVMConfig_GasSchedule_native_schedule 1))
(assert (= $DiemVMConfig_GasSchedule_gas_constants 2))
(assert (= $DiemVMConfig_GasSchedule_type_value ($StructType $DiemVMConfig_GasSchedule $EmptyTypeValueArray)))
(assert (= $DiemVersion_DiemVersion_major 0))
(assert (= $DiemVersion_DiemVersion_type_value ($StructType $DiemVersion_DiemVersion $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_flag@166 () Bool)
(declare-fun $abort_flag@163 () Bool)
(declare-fun $abort_flag@164 () Bool)
(declare-fun $abort_flag@165 () Bool)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun inline$$MoveTo$12$a@1 () Int)
(declare-fun |inline$$MoveToRaw$12$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$$struct@1 () T@$Value)
(declare-fun dr_account () T@$Value)
(declare-fun inline$$DiemTimestamp_set_time_has_started_$def$0$$t3@1 () T@$Value)
(declare-fun $abort_code@130 () Int)
(declare-fun $abort_code@129 () Int)
(declare-fun $abort_flag@162 () Bool)
(declare-fun $abort_flag@161 () Bool)
(declare-fun inline$$WritebackToGlobal$6$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$6$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$6$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$6$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$8$dst'@2| () T@$Mutation)
(declare-fun $DiemAccount_DiemAccount_$memory@5 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$6$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$7$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$6$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$8$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$8$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$8$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$8$dst'@1| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$3$$after@0 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$3$$tv0@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_restore_key_rotation_capability_$def$1$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$8$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@159 () Bool)
(declare-fun $abort_flag@160 () Bool)
(declare-fun inline$$ReadRef$5$v@1 () T@$Value)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun $abort_code@128 () Int)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$3$$before@0 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$3$$tv0@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$8$p@1 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1 () Int)
(declare-fun inline$$BorrowField$8$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$5$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$6$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$6$a@1 () Int)
(declare-fun inline$$BorrowGlobal$6$dst@1 () T@$Mutation)
(declare-fun inline$$GetFieldFromValue$12$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$7$$t2@1 () T@$Value)
(declare-fun $abort_code@127 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@158 () Bool)
(declare-fun inline$$DiemAccount_restore_key_rotation_capability_$def$1$$t7@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$11$dst@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$5$m'@2| () T@$Memory)
(declare-fun $abort_flag@157 () Bool)
(declare-fun inline$$WritebackToGlobal$5$l@1 () T@$Location)
(declare-fun $DiemAccount_DiemAccount_$memory@4 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$5$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$5$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$5$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$7$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$5$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$6$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$5$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$7$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$7$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$7$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$7$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$1$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1 () T@$Mutation)
(declare-fun tc_auth_key () T@$Value)
(declare-fun inline$$BorrowField$7$p@1 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1 () Int)
(declare-fun inline$$BorrowField$7$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$1$$t16@1 () T@$Value)
(declare-fun $abort_flag@155 () Bool)
(declare-fun $abort_flag@156 () Bool)
(declare-fun $abort_code@125 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$5$$after@0 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$1$$t15@1 () T@$Value)
(declare-fun inline$$Vector_length$1$l@1 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$1$$t17@1 () T@$Value)
(declare-fun inline$$Vector_length$1$ta@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$4$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$5$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$5$a@1 () Int)
(declare-fun inline$$BorrowGlobal$5$dst@1 () T@$Mutation)
(declare-fun inline$$GetFieldFromValue$10$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$6$$t2@1 () T@$Value)
(declare-fun $abort_code@123 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun $abort_flag@154 () Bool)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$1$$t11@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$9$dst@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$4$m'@2| () T@$Memory)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@153 () Bool)
(declare-fun inline$$WritebackToGlobal$4$l@1 () T@$Location)
(declare-fun $DiemAccount_DiemAccount_$memory@3 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$4$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$4$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$4$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$6$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$4$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$4$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$4$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$6$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$6$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$6$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$6$dst'@1| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$2$$after@0 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$2$$tv0@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$1$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_flag@145 () Bool)
(declare-fun $abort_flag@150 () Bool)
(declare-fun $abort_flag@151 () Bool)
(declare-fun $abort_flag@152 () Bool)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun $abort_code@121 () Int)
(declare-fun inline$$Option_Option_$unpack_ref$2$$before@0 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$2$$tv0@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$6$p@1 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1 () Int)
(declare-fun inline$$BorrowField$6$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$3$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$4$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$4$a@1 () Int)
(declare-fun inline$$BorrowGlobal$4$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$5$$t2@1 () T@$Value)
(declare-fun $abort_code@120 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$1$$t13@1 () T@$Value)
(declare-fun inline$$Not$15$dst@1 () T@$Value)
(declare-fun $abort_code@118 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$1$$t10@1 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$1$$ret0@2 () T@$Value)
(declare-fun $abort_flag@149 () Bool)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_flag@148 () Bool)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_flag@146 () Bool)
(declare-fun $abort_flag@147 () Bool)
(declare-fun call0formal@$tv0@0@@1 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$8$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$2$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$2$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$2$a@1 () Int)
(declare-fun inline$$GetGlobal$2$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$4$$t2@1 () T@$Value)
(declare-fun $abort_code@115 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$1$$t5@1 () T@$Value)
(declare-fun tc_account () T@$Value)
(declare-fun $abort_flag@144 () Bool)
(declare-fun $abort_flag@141 () Bool)
(declare-fun $abort_flag@142 () Bool)
(declare-fun $abort_flag@143 () Bool)
(declare-fun call0formal@$tv0@0@@2 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemConfig_DiemConfig_$memory@29 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@10 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@0 () T@$Memory)
(declare-fun $abort_code@112 () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@11 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@30 () T@$Memory)
(declare-fun inline$$DiemVMConfig_DiemVMConfig_pack$0$$struct@1 () T@$Value)
(declare-fun $DiemConfig_Configuration_$memory@16 () T@$Memory)
(declare-fun inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1 () T@$Value)
(declare-fun instruction_schedule () T@$Value)
(declare-fun native_schedule () T@$Value)
(declare-fun inline$$DiemVMConfig_GasConstants_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t7@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t8@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t11@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t12@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t13@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t14@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$DiemVMConfig_initialize_$def$0$$t17@1 () T@$Value)
(declare-fun $abort_code@111 () Int)
(declare-fun $abort_code@110 () Int)
(declare-fun $abort_flag@140 () Bool)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@9 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@28 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@26 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@7 () T@$Memory)
(declare-fun $abort_flag@137 () Bool)
(declare-fun $abort_flag@138 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@27 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@8 () T@$Memory)
(declare-fun $abort_flag@139 () Bool)
(declare-fun call0formal@$tv0@0@@3 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@109 () Int)
(declare-fun inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$struct@1 () T@$Value)
(declare-fun initial_script_allow_list () T@$Value)
(declare-fun is_open_module () T@$Value)
(declare-fun $abort_code@108 () Int)
(declare-fun $abort_code@107 () Int)
(declare-fun $abort_flag@136 () Bool)
(declare-fun |inline$$WritebackToGlobal$3$m'@2| () T@$Memory)
(declare-fun $abort_flag@135 () Bool)
(declare-fun inline$$WritebackToGlobal$3$l@1 () T@$Location)
(declare-fun $DiemAccount_DiemAccount_$memory@2 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$3$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$3$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$3$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$5$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$3$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$3$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$3$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$5$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$5$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$5$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$5$dst'@1| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$1$$tv0@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_restore_key_rotation_capability_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_flag@133 () Bool)
(declare-fun $abort_flag@134 () Bool)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@4 () T@$TypeValue)
(declare-fun $abort_code@106 () Int)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$1$$tv0@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$5$p@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1 () Int)
(declare-fun inline$$BorrowField$5$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$2$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$3$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$3$a@1 () Int)
(declare-fun inline$$BorrowGlobal$3$dst@1 () T@$Mutation)
(declare-fun inline$$GetFieldFromValue$7$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$3$$t2@1 () T@$Value)
(declare-fun $abort_code@105 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun $abort_flag@132 () Bool)
(declare-fun inline$$DiemAccount_restore_key_rotation_capability_$def$0$$t7@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$6$dst@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@2| () T@$Memory)
(declare-fun $abort_flag@131 () Bool)
(declare-fun inline$$WritebackToGlobal$2$l@1 () T@$Location)
(declare-fun $DiemAccount_DiemAccount_$memory@1 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$2$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$4$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$2$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$2$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$2$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$4$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$4$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$4$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$4$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun dr_auth_key () T@$Value)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1 () T@$Value)
(declare-fun $abort_flag@129 () Bool)
(declare-fun $abort_flag@130 () Bool)
(declare-fun $abort_code@103 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$2$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$2$a@1 () Int)
(declare-fun inline$$BorrowGlobal$2$dst@1 () T@$Mutation)
(declare-fun inline$$GetFieldFromValue$5$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$2$$t2@1 () T@$Value)
(declare-fun $abort_code@101 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun $abort_flag@128 () Bool)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$4$dst@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun call4formal@$ret0@0@@1 () T@$Value)
(declare-fun $abort_flag@127 () Bool)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun $DiemAccount_DiemAccount_$memory@0 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0@@0 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@119 () Bool)
(declare-fun $abort_flag@124 () Bool)
(declare-fun $abort_flag@125 () Bool)
(declare-fun $abort_flag@126 () Bool)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@5 () T@$TypeValue)
(declare-fun $abort_code@99 () Int)
(declare-fun inline$$Option_Option_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$1$$t2@1 () T@$Value)
(declare-fun $abort_code@98 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t13@1 () T@$Value)
(declare-fun inline$$Not$14$dst@1 () T@$Value)
(declare-fun $abort_code@96 () Int)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@123 () Bool)
(declare-fun call4formal@$ret0@0@@2 () T@$Value)
(declare-fun $abort_flag@122 () Bool)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@120 () Bool)
(declare-fun $abort_flag@121 () Bool)
(declare-fun call0formal@$tv0@0@@6 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$3$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$1$a@1 () Int)
(declare-fun inline$$GetGlobal$1$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$0$$t2@1 () T@$Value)
(declare-fun $abort_code@93 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$t5@1 () T@$Value)
(declare-fun $abort_flag@118 () Bool)
(declare-fun $abort_flag@117 () Bool)
(declare-fun $abort_flag@113 () Bool)
(declare-fun $abort_flag@114 () Bool)
(declare-fun $abort_flag@116 () Bool)
(declare-fun $DiemBlock_BlockMetadata_$memory () T@$Memory)
(declare-fun inline$$MoveTo$11$a@1 () Int)
(declare-fun |inline$$MoveToRaw$11$m'@1| () T@$Memory)
(declare-fun inline$$DiemBlock_BlockMetadata_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DiemBlock_initialize_block_metadata_$def$0$$t8@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$12$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$12$t@0 () T@$TypeValue)
(declare-fun inline$$Not$13$dst@1 () T@$Value)
(declare-fun $abort_code@90 () Int)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$DiemBlock_initialize_block_metadata_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$DiemBlock_is_initialized_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@115 () Bool)
(declare-fun inline$$DiemBlock_is_initialized_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$3$$t0@1 () T@$Value)
(declare-fun inline$$DiemBlock_is_initialized_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@88 () Int)
(declare-fun $abort_code@87 () Int)
(declare-fun $abort_flag@112 () Bool)
(declare-fun $abort_flag@111 () Bool)
(declare-fun $abort_flag@100 () Bool)
(declare-fun $abort_flag@101 () Bool)
(declare-fun $abort_flag@102 () Bool)
(declare-fun $abort_flag@103 () Bool)
(declare-fun $abort_flag@107 () Bool)
(declare-fun $abort_flag@108 () Bool)
(declare-fun $abort_flag@109 () Bool)
(declare-fun $abort_flag@110 () Bool)
(declare-fun $DualAttestation_Limit_$memory () T@$Memory)
(declare-fun inline$$MoveTo$10$a@1 () Int)
(declare-fun |inline$$MoveToRaw$10$m'@1| () T@$Memory)
(declare-fun inline$$DualAttestation_Limit_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$CastU64$0$dst@1 () T@$Value)
(declare-fun inline$$CastU64$0$dst@0 () T@$Value)
(declare-fun inline$$MulU128$0$dst@2 () T@$Value)
(declare-fun inline$$Le$2$dst@1 () T@$Value)
(declare-fun $abort_code@86 () Int)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def$0$$t18@1 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$MulU128$0$dst@0 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1 () T@$Value)
(declare-fun inline$$MulU128$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0 () T@$Value)
(declare-fun inline$$Diem_scaling_factor_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@106 () Bool)
(declare-fun inline$$Diem_scaling_factor_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@104 () Bool)
(declare-fun $abort_flag@105 () Bool)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@10 () T@$Memory)
(declare-fun inline$$GetGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$Diem_scaling_factor$0$$tv0@0 () T@$TypeValue)
(declare-fun $abort_code@84 () Int)
(declare-fun inline$$CastU128$0$dst@0 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def$0$$t12@1 () T@$Value)
(declare-fun inline$$Not$12$dst@1 () T@$Value)
(declare-fun $abort_code@83 () Int)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$DualAttestation_initialize_$def$0$$t8@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$$t0@1 () T@$Value)
(declare-fun $abort_code@81 () Int)
(declare-fun $abort_code@80 () Int)
(declare-fun $abort_flag@99 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@25 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@6 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@4 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@23 () T@$Memory)
(declare-fun $abort_flag@96 () Bool)
(declare-fun $abort_flag@97 () Bool)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@5 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@24 () T@$Memory)
(declare-fun $abort_flag@98 () Bool)
(declare-fun call0formal@$tv0@0@@7 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@79 () Int)
(declare-fun inline$$DiemVersion_DiemVersion_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DiemVersion_initialize_$def$0$$t2@1 () T@$Value)
(declare-fun $abort_code@78 () Int)
(declare-fun $abort_code@77 () Int)
(declare-fun $abort_flag@95 () Bool)
(declare-fun $abort_flag@94 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@21 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@22 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@20 () T@$Memory)
(declare-fun $abort_flag@90 () Bool)
(declare-fun $abort_flag@91 () Bool)
(declare-fun $abort_flag@92 () Bool)
(declare-fun $abort_flag@93 () Bool)
(declare-fun $DiemSystem_CapabilityHolder_$memory () T@$Memory)
(declare-fun inline$$MoveTo$9$a@1 () Int)
(declare-fun |inline$$MoveToRaw$9$m'@1| () T@$Memory)
(declare-fun inline$$DiemSystem_CapabilityHolder_pack$0$$struct@1 () T@$Value)
(declare-fun call7formal@$ret0@0 () T@$Value)
(declare-fun inline$$Not$11$dst@1 () T@$Value)
(declare-fun $abort_code@76 () Int)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun inline$$DiemSystem_initialize_validator_set_$def$0$$t11@1 () T@$Value)
(declare-fun inline$$DiemSystem_initialize_validator_set_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@8 () T@$TypeValue)
(declare-fun inline$$DiemSystem_initialize_validator_set_$def$0$$DiemConfig_DiemConfig_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@74 () Int)
(declare-fun inline$$DiemSystem_DiemSystem_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DiemSystem_initialize_validator_set_$def$0$$t5@1 () T@$Value)
(declare-fun inline$$Vector_empty$1$v@1 () T@$Value)
(declare-fun inline$$Vector_empty$1$ta@0 () T@$TypeValue)
(declare-fun $abort_code@73 () Int)
(declare-fun $abort_code@72 () Int)
(declare-fun $abort_flag@89 () Bool)
(declare-fun inline$$DiemSystem_initialize_validator_set_$direct_inter$0$$DiemConfig_DiemConfig_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_flag@75 () Bool)
(declare-fun $abort_flag@76 () Bool)
(declare-fun $abort_flag@88 () Bool)
(declare-fun $abort_flag@87 () Bool)
(declare-fun $abort_flag@77 () Bool)
(declare-fun $abort_flag@79 () Bool)
(declare-fun $TransactionFee_TransactionFee_$memory () T@$Memory)
(declare-fun inline$$MoveTo$8$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$8$a@1 () Int)
(declare-fun |inline$$MoveToRaw$8$m'@1| () T@$Memory)
(declare-fun inline$$TransactionFee_TransactionFee_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_flag@86 () Bool)
(declare-fun inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Diem_zero_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_create_preburn_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_create_preburn_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_flag@82 () Bool)
(declare-fun $abort_flag@83 () Bool)
(declare-fun $abort_flag@85 () Bool)
(declare-fun inline$$Diem_Preburn_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$2$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$2$$ret0@1 () T@$Value)
(declare-fun $abort_flag@84 () Bool)
(declare-fun inline$$Diem_Diem_pack$2$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$2$$t0@1 () T@$Value)
(declare-fun $abort_code@71 () Int)
(declare-fun $abort_code@70 () Int)
(declare-fun $abort_code@69 () Int)
(declare-fun $abort_flag@81 () Bool)
(declare-fun inline$$Diem_zero_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_flag@80 () Bool)
(declare-fun inline$$Diem_Diem_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$t0@1 () T@$Value)
(declare-fun $abort_code@68 () Int)
(declare-fun inline$$Not$10$dst@1 () T@$Value)
(declare-fun $abort_code@67 () Int)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$TransactionFee_add_txn_fee_currency_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@78 () Bool)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@65 () Int)
(declare-fun $abort_code@64 () Int)
(declare-fun $abort_code@63 () Int)
(declare-fun $abort_flag@74 () Bool)
(declare-fun $abort_flag@73 () Bool)
(declare-fun $abort_flag@69 () Bool)
(declare-fun $abort_flag@70 () Bool)
(declare-fun $abort_flag@71 () Bool)
(declare-fun $abort_flag@72 () Bool)
(declare-fun $AccountFreezing_FreezeEventsHolder_$memory () T@$Memory)
(declare-fun inline$$MoveTo$7$a@1 () Int)
(declare-fun |inline$$MoveToRaw$7$m'@1| () T@$Memory)
(declare-fun inline$$AccountFreezing_FreezeEventsHolder_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$10$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$11$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$11$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$10$t@0 () T@$TypeValue)
(declare-fun inline$$Not$9$dst@1 () T@$Value)
(declare-fun $abort_code@62 () Int)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$AccountFreezing_initialize_$def$0$$t7@1 () T@$Value)
(declare-fun inline$$AccountFreezing_initialize_$def$0$$t5@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(declare-fun $abort_code@59 () Int)
(declare-fun $abort_code@58 () Int)
(declare-fun $abort_flag@68 () Bool)
(declare-fun $abort_flag@67 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@18 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@14 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@8 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@19 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@15 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@9 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@13 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@9 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@5 () T@$Memory)
(declare-fun $abort_flag@39 () Bool)
(declare-fun $abort_flag@40 () Bool)
(declare-fun $abort_flag@41 () Bool)
(declare-fun $abort_flag@42 () Bool)
(declare-fun $XDX_Reserve_$memory () T@$Memory)
(declare-fun inline$$MoveTo$6$a@1 () Int)
(declare-fun |inline$$MoveToRaw$6$m'@1| () T@$Memory)
(declare-fun inline$$XDX_Reserve_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_flag@66 () Bool)
(declare-fun inline$$Diem_register_currency_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$ret1@2 () T@$Value)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@62 () Bool)
(declare-fun $abort_flag@63 () Bool)
(declare-fun $abort_flag@65 () Bool)
(declare-fun inline$$Diem_Preburn_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@64 () Bool)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$Diem_create_preburn$0$$tv0@0 () T@$TypeValue)
(declare-fun $abort_code@57 () Int)
(declare-fun $abort_code@56 () Int)
(declare-fun $abort_code@55 () Int)
(declare-fun $abort_flag@61 () Bool)
(declare-fun $abort_flag@60 () Bool)
(declare-fun $abort_flag@58 () Bool)
(declare-fun $abort_flag@59 () Bool)
(declare-fun $AccountLimits_LimitsDefinition_$memory@3 () T@$Memory)
(declare-fun inline$$MoveTo$5$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$5$a@1 () Int)
(declare-fun |inline$$MoveToRaw$5$m'@1| () T@$Memory)
(declare-fun inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits$1$$tv0@0 () T@$TypeValue)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t14@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t15@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t16@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t17@1 () T@$Value)
(declare-fun inline$$Not$8$dst@1 () T@$Value)
(declare-fun $abort_code@54 () Int)
(declare-fun call3formal@$ret0@0@@20 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t12@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@21 () T@$Value)
(declare-fun $abort_flag@57 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@7 () T@$Memory)
(declare-fun $abort_flag@54 () Bool)
(declare-fun $abort_flag@55 () Bool)
(declare-fun $abort_flag@56 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_update_minting_ability_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$XDX_initialize_$def$0$$t23@1 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$Diem_update_minting_ability$0$$tv0@0 () T@$TypeValue)
(declare-fun $abort_code@51 () Int)
(declare-fun $abort_code@50 () Int)
(declare-fun $abort_flag@53 () Bool)
(declare-fun |inline$$MoveToRaw$4$m'@2| () T@$Memory)
(declare-fun inline$$Diem_MintCapability_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$Diem_BurnCapability_pack$1$$struct@1 () T@$Value)
(declare-fun $DiemConfig_Configuration_$memory@12 () T@$Memory)
(declare-fun $abort_flag@52 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@16 () T@$Memory)
(declare-fun inline$$Diem_register_currency_$def$1$$t39@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$t37@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$ret0@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$ret1@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@6 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@13 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@17 () T@$Memory)
(declare-fun $abort_flag@43 () Bool)
(declare-fun $abort_flag@44 () Bool)
(declare-fun $abort_flag@45 () Bool)
(declare-fun $abort_flag@46 () Bool)
(declare-fun $abort_flag@47 () Bool)
(declare-fun $abort_flag@48 () Bool)
(declare-fun $abort_flag@51 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@14 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@10 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@15 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@11 () T@$Memory)
(declare-fun $abort_flag@49 () Bool)
(declare-fun $abort_flag@50 () Bool)
(declare-fun call0formal@$tv0@0@@9 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_Configuration_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemConfig_DisableReconfiguration_$memory () T@$Memory)
(declare-fun $abort_code@49 () Int)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun call3formal@$ret0@0@@22 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$1$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$XDX_initialize_$def$0$$t20@1 () T@$Value)
(declare-fun inline$$Vector_push_back$1$ta@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$Not$7$dst@1 () T@$Value)
(declare-fun $abort_code@48 () Int)
(declare-fun call3formal@$ret0@0@@23 () T@$Value)
(declare-fun inline$$RegisteredCurrencies_add_currency_code_$def$1$$t10@1 () T@$Value)
(declare-fun inline$$Vector_contains$1$res@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$Vector_contains$1$ta@0 () T@$TypeValue)
(declare-fun call0formal@$tv0@0@@10 () T@$TypeValue)
(declare-fun $abort_code@46 () Int)
(declare-fun |inline$$MoveToRaw$4$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$4$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$4$a@1 () Int)
(declare-fun |inline$$MoveToRaw$4$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$Diem_register_currency$1$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Diem_register_currency_$def$1$$t28@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$t29@1 () T@$Value)
(declare-fun call4formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$XDX_initialize_$def$0$$t17@1 () T@$Value)
(declare-fun inline$$XDX_initialize_$def$0$$t18@1 () T@$Value)
(declare-fun inline$$XDX_initialize_$def$0$$t19@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$t30@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$5$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$6$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$7$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$8$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$9$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$9$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$8$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$7$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$6$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$5$t@0 () T@$TypeValue)
(declare-fun |inline$$Diem_register_currency_$def$1$tmp#$10@1| () T@$Value)
(declare-fun $abort_code@45 () Int)
(declare-fun call3formal@$ret0@0@@24 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$t26@1 () T@$Value)
(declare-fun inline$$Le$1$dst@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$t24@1 () T@$Value)
(declare-fun inline$$Lt$1$dst@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$t25@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$t22@1 () T@$Value)
(declare-fun inline$$Not$6$dst@1 () T@$Value)
(declare-fun $abort_code@43 () Int)
(declare-fun call3formal@$ret0@0@@25 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$t20@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$1$$t18@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@26 () T@$Value)
(declare-fun $abort_code@40 () Int)
(declare-fun $abort_code@39 () Int)
(declare-fun inline$$Not$5$dst@1 () T@$Value)
(declare-fun inline$$XDX_initialize_$def$0$$t14@1 () T@$Value)
(declare-fun inline$$XDX_initialize_$def$0$$t15@1 () T@$Value)
(declare-fun $abort_code@37 () Int)
(declare-fun $abort_code@38 () Int)
(declare-fun call3formal@$ret0@0@@27 () T@$Value)
(declare-fun inline$$XDX_initialize_$def$0$$t12@1 () T@$Value)
(declare-fun inline$$XDX_initialize_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun $abort_code@35 () Int)
(declare-fun $abort_code@34 () Int)
(declare-fun $abort_flag@38 () Bool)
(declare-fun $DiemConfig_Configuration_$memory@8 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@4 () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@12 () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@4 () T@$Memory)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_flag@37 () Bool)
(declare-fun $AccountLimits_LimitsDefinition_$memory@1 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@3 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@7 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@11 () T@$Memory)
(declare-fun $abort_flag@33 () Bool)
(declare-fun $abort_flag@36 () Bool)
(declare-fun |inline$$MoveToRaw$3$m'@2| () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory@0 () T@$Memory)
(declare-fun $abort_flag@34 () Bool)
(declare-fun $abort_flag@35 () Bool)
(declare-fun |inline$$MoveToRaw$3$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$3$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$3$a@1 () Int)
(declare-fun |inline$$MoveToRaw$3$m'@1| () T@$Memory)
(declare-fun inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1 () T@$Value)
(declare-fun inline$$Not$4$dst@1 () T@$Value)
(declare-fun $abort_code@33 () Int)
(declare-fun call3formal@$ret0@0@@28 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t12@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@29 () T@$Value)
(declare-fun $abort_flag@32 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@1 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@9 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@5 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@10 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@6 () T@$Memory)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $abort_flag@24 () Bool)
(declare-fun $abort_flag@25 () Bool)
(declare-fun $abort_flag@26 () Bool)
(declare-fun $abort_flag@31 () Bool)
(declare-fun $abort_flag@27 () Bool)
(declare-fun $abort_flag@28 () Bool)
(declare-fun $abort_flag@29 () Bool)
(declare-fun $abort_flag@30 () Bool)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun inline$$MoveTo$2$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$2$a@1 () Int)
(declare-fun |inline$$MoveToRaw$2$m'@1| () T@$Memory)
(declare-fun inline$$Diem_register_currency_$def$0$$ret1@2 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Not$3$dst@1 () T@$Value)
(declare-fun $abort_code@30 () Int)
(declare-fun call3formal@$ret0@0@@30 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@31 () T@$Value)
(declare-fun $abort_code@27 () Int)
(declare-fun $abort_code@26 () Int)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun inline$$MoveTo$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$1$a@1 () Int)
(declare-fun |inline$$MoveToRaw$1$m'@1| () T@$Memory)
(declare-fun inline$$Diem_register_currency_$def$0$$ret0 () T@$Value)
(declare-fun inline$$Not$2$dst@1 () T@$Value)
(declare-fun $abort_code@25 () Int)
(declare-fun call3formal@$ret0@0@@32 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$def$0$$t22@1 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$def$0$$t20@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@33 () T@$Value)
(declare-fun $abort_flag@23 () Bool)
(declare-fun inline$$Diem_BurnCapability_pack$0$$struct@1 () T@$Value)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@7 () T@$Memory)
(declare-fun $abort_flag@22 () Bool)
(declare-fun $DiemConfig_Configuration_$memory@3 () T@$Memory)
(declare-fun inline$$Diem_register_currency_$def$0$$t39@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t37@1 () T@$Value)
(declare-fun inline$$Diem_MintCapability_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$ret1@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@0 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@8 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@4 () T@$Memory)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_flag@14 () Bool)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $abort_flag@18 () Bool)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $DiemConfig_Configuration_$memory@1 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@5 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@6 () T@$Memory)
(declare-fun $abort_flag@19 () Bool)
(declare-fun $abort_flag@20 () Bool)
(declare-fun call0formal@$tv0@0@@11 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@22 () Int)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun call3formal@$ret0@0@@34 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$XUS_initialize_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun $abort_code@21 () Int)
(declare-fun call3formal@$ret0@0@@35 () T@$Value)
(declare-fun inline$$RegisteredCurrencies_add_currency_code_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$res@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$ta@0 () T@$TypeValue)
(declare-fun call0formal@$tv0@0@@12 () T@$TypeValue)
(declare-fun $abort_code@19 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t28@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t29@1 () T@$Value)
(declare-fun call4formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$XUS_initialize_$def$0$$t7@1 () T@$Value)
(declare-fun inline$$XUS_initialize_$def$0$$t8@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t30@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$2$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$3$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$4$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$4$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$3$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$2$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$1$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun |inline$$Diem_register_currency_$def$0$tmp#$10@1| () T@$Value)
(declare-fun $abort_code@18 () Int)
(declare-fun call3formal@$ret0@0@@36 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t26@1 () T@$Value)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t24@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t25@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t22@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@16 () Int)
(declare-fun call3formal@$ret0@0@@37 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t20@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t18@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@38 () T@$Value)
(declare-fun $abort_code@13 () Int)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_code@11 () Int)
(declare-fun inline$$XUS_initialize_$def$0$$t4@1 () T@$Value)
(declare-fun inline$$XUS_initialize_$def$0$$t5@1 () T@$Value)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@3 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@3 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@1 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@1 () T@$Memory)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@0 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@0 () T@$Memory)
(declare-fun $abort_flag@7 () Bool)
(declare-fun call0formal@$tv0@0@@13 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@2 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@2 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@8 () Int)
(declare-fun inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_code@4 () Int)
(declare-fun call1formal@$DiemConfig_Configuration_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $abort_code@3 () Int)
(declare-fun call2formal@$ChainId_ChainId_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $ChainId_ChainId_$memory () T@$Memory)
(declare-fun $abort_code@2 () Int)
(declare-fun $ChainId_ChainId_$memory@0 () T@$Memory)
(declare-fun inline$$Genesis_initialize_$def_verify$0$$t20@1 () T@$Value)
(declare-fun call2formal@$Roles_RoleId_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call3formal@$AccountFreezing_FreezingBit_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call4formal@$SlidingNonce_SlidingNonce_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call5formal@$DiemAccount_DiemAccount_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call6formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call7formal@$DiemAccount_DiemWriteSetManager_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $SlidingNonce_SlidingNonce_$memory () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory () T@$Memory)
(declare-fun $DiemAccount_DiemWriteSetManager_$memory () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun $abort_code@1 () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_DiemWriteSetManager_$memory@0 () T@$Memory)
(declare-fun $SlidingNonce_SlidingNonce_$memory@0 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory () T@$Memory)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_$memory () T@$Memory)
(declare-fun $Option_Option_$memory () T@$Memory)
(declare-fun $DiemAccount_KeyRotationCapability_$memory () T@$Memory)
(declare-fun $AccountLimits_Window_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory () T@$Memory)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory () T@$Memory)
(declare-fun $DualAttestation_Credential_$memory () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory () T@$Memory)
(declare-fun chain_id () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 396650) (let ((inline$$Genesis_initialize_$def_verify$0$anon77_Else_correct true))
(let ((inline$$Genesis_initialize_$def_verify$0$anon77_Then_correct true))
(let ((inline$$Genesis_initialize_$def_verify$0$anon76_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 388356) 388372) inline$$Genesis_initialize_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 388356) 388362) inline$$Genesis_initialize_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon79_Else_correct true))
(let ((inline$$Genesis_initialize_$def_verify$0$anon79_Then_correct true))
(let ((inline$$Genesis_initialize_$def_verify$0$anon78_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 388336) 388352) inline$$Genesis_initialize_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 388336) 388342) inline$$Genesis_initialize_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon81_Else_correct true))
(let ((inline$$Genesis_initialize_$def_verify$0$anon81_Then_correct true))
(let ((inline$$Genesis_initialize_$def_verify$0$anon80_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 388316) 388332) inline$$Genesis_initialize_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 388316) 388322) inline$$Genesis_initialize_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon99_Else_correct true))
(let ((inline$$Genesis_initialize_$def_verify$0$anon99_Then_correct true))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$Abort_correct  (=> (= $abort_flag@166 true) (and (=> (= (ControlFlow 0 388162) 388240) inline$$Genesis_initialize_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 388162) 388236) inline$$Genesis_initialize_$def_verify$0$anon99_Else_correct)))))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 388200) 388162)) inline$$DiemTimestamp_set_time_has_started_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 388210) 388162) inline$$DiemTimestamp_set_time_has_started_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon16_Then_correct  (=> $abort_flag@163 (and (=> (= (ControlFlow 0 388194) 388210) inline$$DiemTimestamp_set_time_has_started_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 388194) 388200) inline$$DiemTimestamp_set_time_has_started_$def$0$anon17_Else_correct)))))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 388180) 388162)) inline$$DiemTimestamp_set_time_has_started_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 388190) 388162) inline$$DiemTimestamp_set_time_has_started_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon18_Then_correct  (=> $abort_flag@164 (and (=> (= (ControlFlow 0 388174) 388190) inline$$DiemTimestamp_set_time_has_started_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 388174) 388180) inline$$DiemTimestamp_set_time_has_started_$def$0$anon19_Else_correct)))))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 388156) 388162)) inline$$DiemTimestamp_set_time_has_started_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 388170) 388162) inline$$DiemTimestamp_set_time_has_started_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon20_Then_correct  (=> $abort_flag@165 (and (=> (= (ControlFlow 0 388150) 388170) inline$$DiemTimestamp_set_time_has_started_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 388150) 388156) inline$$DiemTimestamp_set_time_has_started_$def$0$anon21_Else_correct)))))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon20_Else_correct  (=> (and (not $abort_flag@165) (= $abort_flag@166 $abort_flag@165)) (and (=> (= (ControlFlow 0 388146) 388240) inline$$Genesis_initialize_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 388146) 388236) inline$$Genesis_initialize_$def_verify$0$anon99_Else_correct)))))
(let ((inline$$MoveToRaw$12$anon3_Then$1_correct  (=> (= $abort_flag@165 true) (and (=> (= (ControlFlow 0 388124) 388150) inline$$DiemTimestamp_set_time_has_started_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 388124) 388146) inline$$DiemTimestamp_set_time_has_started_$def$0$anon20_Else_correct)))))
(let ((inline$$MoveToRaw$12$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$MoveTo$12$a@1) (= (ControlFlow 0 388122) 388124)) inline$$MoveToRaw$12$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$12$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$MoveTo$12$a@1)) (=> (and (= |inline$$MoveToRaw$12$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$MoveTo$12$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$MoveTo$12$a@1 inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$$struct@1))) (= $abort_flag@165 $abort_flag@164)) (and (=> (= (ControlFlow 0 388072) 388150) inline$$DiemTimestamp_set_time_has_started_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 388072) 388146) inline$$DiemTimestamp_set_time_has_started_$def$0$anon20_Else_correct))))))
(let ((inline$$MoveTo$12$anon0$1_correct  (=> (= inline$$MoveTo$12$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 388130) 388122) inline$$MoveToRaw$12$anon3_Then_correct) (=> (= (ControlFlow 0 388130) 388072) inline$$MoveToRaw$12$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$12$Entry_correct  (and (=> (= (ControlFlow 0 387918) (- 0 461052)) true) (=> (= (ControlFlow 0 387918) 388130) inline$$MoveTo$12$anon0$1_correct))))
(let ((inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 387804) 387918)) inline$$Signer_borrow_address$12$Entry_correct)))
(let ((inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 387810) 387918) inline$$Signer_borrow_address$12$Entry_correct)))
(let ((inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 387798) 387810) inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 387798) 387804) inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 387790) 387918)) inline$$Signer_borrow_address$12$Entry_correct)))
(let ((inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$DiemTimestamp_set_time_has_started_$def$0$$t3@1) (>= (|i#$Integer| inline$$DiemTimestamp_set_time_has_started_$def$0$$t3@1) 0)) (<= (|i#$Integer| inline$$DiemTimestamp_set_time_has_started_$def$0$$t3@1) $MAX_U64)) (= inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemTimestamp_set_time_has_started_$def$0$$t3@1) 1)))) (and (=> (= (ControlFlow 0 387782) 387798) inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 387782) 387790) inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon18_Else_correct  (=> (not $abort_flag@164) (=> (and (= inline$$DiemTimestamp_set_time_has_started_$def$0$$t3@1 ($Integer 0)) (= (ControlFlow 0 387816) 387782)) inline$$DiemTimestamp_CurrentTimeMicroseconds_pack$0$anon0_correct))))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon16_Else_correct  (=> (and (and (not $abort_flag@163) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@164)) (and (=> $abort_flag@164 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@164 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@130 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 387648) 388174) inline$$DiemTimestamp_set_time_has_started_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 387648) 387816) inline$$DiemTimestamp_set_time_has_started_$def$0$anon18_Else_correct)))))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@163) (=> (and (=> $abort_flag@163 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@163 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@129 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 387642) 388194) inline$$DiemTimestamp_set_time_has_started_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 387642) 387648) inline$$DiemTimestamp_set_time_has_started_$def$0$anon16_Else_correct))))))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 387606) 387642)) inline$$DiemTimestamp_set_time_has_started_$def$0$anon2$1_correct)))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 388218) 387642) inline$$DiemTimestamp_set_time_has_started_$def$0$anon2$1_correct)))
(let ((inline$$DiemTimestamp_set_time_has_started_$def$0$anon0_correct  (=> (not $abort_flag@162) (and (=> (= (ControlFlow 0 387600) 388218) inline$$DiemTimestamp_set_time_has_started_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 387600) 387606) inline$$DiemTimestamp_set_time_has_started_$def$0$anon15_Else_correct)))))
(let ((inline$$DiemTimestamp_set_time_has_started_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 388222) 387600)) inline$$DiemTimestamp_set_time_has_started_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon98_Else_correct  (=> (and (not $abort_flag@162) (= (ControlFlow 0 388228) 388222)) inline$$DiemTimestamp_set_time_has_started_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon98_Then_correct true))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon22$4_correct  (=> (= $abort_flag@162 $abort_flag@161) (and (=> (= (ControlFlow 0 387204) 388248) inline$$Genesis_initialize_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 387204) 388228) inline$$Genesis_initialize_$def_verify$0$anon98_Else_correct)))))
(let ((inline$$WritebackToGlobal$6$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$6$l@1)) (= (ControlFlow 0 387142) 387204)) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon22$4_correct)))
(let ((inline$$WritebackToGlobal$6$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$6$l@1) (= inline$$WritebackToGlobal$6$ta@1 (|ts#$Global| inline$$WritebackToGlobal$6$l@1))) (=> (and (and (= inline$$WritebackToGlobal$6$a@1 (|a#$Global| inline$$WritebackToGlobal$6$l@1)) (= inline$$WritebackToGlobal$6$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$8$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@5) inline$$WritebackToGlobal$6$ta@1 inline$$WritebackToGlobal$6$a@1) (|v#$Mutation| |inline$$WritebackToReference$8$dst'@2|)))) (and (= |inline$$WritebackToGlobal$6$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory@5) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@5) inline$$WritebackToGlobal$6$ta@1 inline$$WritebackToGlobal$6$a@1 inline$$WritebackToGlobal$6$v@1))) (= (ControlFlow 0 387196) 387204))) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon22$4_correct))))
(let ((inline$$WritebackToGlobal$6$anon0_correct  (=> (= inline$$WritebackToGlobal$6$l@1 (|l#$Mutation| |inline$$WritebackToReference$8$dst'@2|)) (and (=> (= (ControlFlow 0 387132) 387196) inline$$WritebackToGlobal$6$anon3_Then_correct) (=> (= (ControlFlow 0 387132) 387142) inline$$WritebackToGlobal$6$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$7$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$7$$after@0 (|v#$Mutation| |inline$$WritebackToReference$8$dst'@2|)) (= (ControlFlow 0 387010) 387132)) inline$$WritebackToGlobal$6$anon0_correct)))
(let ((inline$$WritebackToReference$8$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$6$dst@2) (|l#$Mutation| |inline$$WriteRef$8$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$8$dstPath@1) (|size#$Path| inline$$WritebackToReference$8$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$8$dstPath@1 inline$$WritebackToReference$8$srcPath@1))) (=> (and (= |inline$$WritebackToReference$8$dst'@2| inline$$BorrowGlobal$6$dst@2) (= (ControlFlow 0 386931) 387010)) inline$$DiemAccount_DiemAccount_$pack_ref$7$Entry_correct))))
(let ((inline$$WritebackToReference$8$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$6$dst@2) (|l#$Mutation| |inline$$WriteRef$8$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$8$dstPath@1) (|size#$Path| inline$$WritebackToReference$8$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$8$dstPath@1 inline$$WritebackToReference$8$srcPath@1)) (= |inline$$WritebackToReference$8$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$6$dst@2) inline$$WritebackToReference$8$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$8$srcPath@1 (|size#$Path| inline$$WritebackToReference$8$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$6$dst@2) (|v#$Mutation| |inline$$WriteRef$8$to'@1|))))) (and (= |inline$$WritebackToReference$8$dst'@2| |inline$$WritebackToReference$8$dst'@1|) (= (ControlFlow 0 386987) 387010))) inline$$DiemAccount_DiemAccount_$pack_ref$7$Entry_correct)))
(let ((inline$$WritebackToReference$8$anon0_correct  (=> (and (= inline$$WritebackToReference$8$srcPath@1 (|p#$Mutation| |inline$$WriteRef$8$to'@1|)) (= inline$$WritebackToReference$8$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$6$dst@2))) (and (=> (= (ControlFlow 0 386895) 386987) inline$$WritebackToReference$8$anon3_Then_correct) (=> (= (ControlFlow 0 386895) 386931) inline$$WritebackToReference$8$anon3_Else_correct)))))
(let ((inline$$Option_Option_$pack_ref$3$anon0_correct  (and (=> (= (ControlFlow 0 386754) (- 0 460452)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$3$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$3$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 386754) 386895) inline$$WritebackToReference$8$anon0_correct)))))
(let ((inline$$Option_Option_$pack_ref$3$Entry_correct  (=> (= inline$$Option_Option_$pack_ref$3$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$pack_ref$3$$after@0 (|v#$Mutation| |inline$$WriteRef$8$to'@1|)) (= (ControlFlow 0 386730) 386754)) inline$$Option_Option_$pack_ref$3$anon0_correct))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 386684) 386730)) inline$$Option_Option_$pack_ref$3$Entry_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon33_Then_correct  (=> (and (= inline$$DiemAccount_restore_key_rotation_capability_$def$1$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$6$dst@2)) (= (ControlFlow 0 387214) 386730)) inline$$Option_Option_$pack_ref$3$Entry_correct)))
(let ((inline$$WriteRef$8$anon0_correct  (=> (= |inline$$WriteRef$8$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$8$dst@1) (|p#$Mutation| inline$$BorrowField$8$dst@1) call5formal@$ret0@0)) (and (=> (= (ControlFlow 0 386670) 387214) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon33_Then_correct) (=> (= (ControlFlow 0 386670) 386684) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon33_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon31_Else_correct  (=> (and (not $abort_flag@161) (= (ControlFlow 0 386676) 386670)) inline$$WriteRef$8$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct  (=> (= $abort_flag@162 true) (and (=> (= (ControlFlow 0 386113) 388248) inline$$Genesis_initialize_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 386113) 388228) inline$$Genesis_initialize_$def_verify$0$anon98_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 387264) 386113)) inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon26_Then_correct  (=> (= (ControlFlow 0 387274) 386113) inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon25_Then_correct  (=> $abort_flag@159 (and (=> (= (ControlFlow 0 387258) 387274) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 387258) 387264) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon26_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 387244) 386113)) inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon30_Then_correct  (=> (= (ControlFlow 0 387254) 386113) inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon29_Then_correct  (=> $abort_flag@160 (and (=> (= (ControlFlow 0 387238) 387254) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 387238) 387244) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon30_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 387224) 386113)) inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon32_Then_correct  (=> (= (ControlFlow 0 387234) 386113) inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon31_Then_correct  (=> $abort_flag@161 (and (=> (= (ControlFlow 0 387218) 387234) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon32_Then_correct) (=> (= (ControlFlow 0 387218) 387224) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon32_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon29_Else$4_correct  (and (=> (= (ControlFlow 0 386613) (- 0 460290)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (and (= call0formal@$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) $Option_Option_vec)) ($Integer 0))))))) $abort_flag@161)) (=> (and (and (=> $abort_flag@161 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) $Option_Option_vec)) ($Integer 0)))))))) (=> $abort_flag@161 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) $Option_Option_vec)) ($Integer 0))))))) (= $abort_code@128 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@161) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Option_Option_vec)) ($Integer 0)))))))) (=> (not $abort_flag@161) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$borrow call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Option_Option_vec) ($Integer 0)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0) (let ((va@@10 (|v#$Vector| call5formal@$ret0@0)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Option_Option_vec)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Option_Option_vec))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 386613) 387218) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon31_Then_correct) (=> (= (ControlFlow 0 386613) 386676) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon31_Else_correct)))))))))
(let ((inline$$ReadRef$5$anon0_correct  (=> (and (= inline$$ReadRef$5$v@1 (|v#$Mutation| inline$$BorrowField$8$dst@1)) (= (ControlFlow 0 386601) 386613)) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon29_Else$4_correct)))
(let ((inline$$Option_Option_$unpack_ref$3$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$3$$before@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 386565) 386601)) inline$$ReadRef$5$anon0_correct)))
(let ((inline$$Option_Option_$unpack_ref$3$Entry_correct  (=> (= inline$$Option_Option_$unpack_ref$3$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$unpack_ref$3$$before@0 (|v#$Mutation| inline$$BorrowField$8$dst@1)) (= (ControlFlow 0 386559) 386565)) inline$$Option_Option_$unpack_ref$3$anon0_correct))))
(let ((inline$$BorrowField$8$anon0_correct  (=> (= inline$$BorrowField$8$p@1 (|p#$Mutation| inline$$BorrowGlobal$6$dst@2)) (=> (and (and (= inline$$BorrowField$8$size@1 (|size#$Path| inline$$BorrowField$8$p@1)) (= inline$$BorrowField$8$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1) inline$$BorrowField$8$size@1 $DiemAccount_DiemAccount_key_rotation_capability) (+ inline$$BorrowField$8$size@1 1)))) (and (= inline$$BorrowField$8$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$6$dst@2) inline$$BorrowField$8$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$6$dst@2))) $DiemAccount_DiemAccount_key_rotation_capability))) (= (ControlFlow 0 386525) 386559))) inline$$Option_Option_$unpack_ref$3$Entry_correct))))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$5$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$5$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$5$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 386403) 386525)) inline$$BorrowField$8$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$5$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$5$$before@0 (|v#$Mutation| inline$$BorrowGlobal$6$dst@2)) (= (ControlFlow 0 386397) 386403)) inline$$DiemAccount_DiemAccount_$unpack_ref$5$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon29_Else_correct  (=> (and (not $abort_flag@160) (= (ControlFlow 0 386407) 386397)) inline$$DiemAccount_DiemAccount_$unpack_ref$5$Entry_correct)))
(let ((inline$$BorrowGlobal$6$anon3_Then$1_correct  (=> (and (= $abort_flag@160 true) (= inline$$BorrowGlobal$6$dst@2 inline$$BorrowGlobal$6$dst@0)) (and (=> (= (ControlFlow 0 386364) 387238) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon29_Then_correct) (=> (= (ControlFlow 0 386364) 386407) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon29_Else_correct)))))
(let ((inline$$BorrowGlobal$6$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@5) $EmptyTypeValueArray inline$$BorrowGlobal$6$a@1)) (= (ControlFlow 0 386362) 386364)) inline$$BorrowGlobal$6$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$6$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@5) $EmptyTypeValueArray inline$$BorrowGlobal$6$a@1) (= inline$$BorrowGlobal$6$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$6$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@5) $EmptyTypeValueArray inline$$BorrowGlobal$6$a@1)))) (and (= $abort_flag@160 $abort_flag@159) (= inline$$BorrowGlobal$6$dst@2 inline$$BorrowGlobal$6$dst@1))) (and (=> (= (ControlFlow 0 386310) 387238) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon29_Then_correct) (=> (= (ControlFlow 0 386310) 386407) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon29_Else_correct)))))
(let ((inline$$BorrowGlobal$6$anon0_correct  (=> (= inline$$BorrowGlobal$6$a@1 (|a#$Address| inline$$GetFieldFromValue$12$dst@1)) (and (=> (= (ControlFlow 0 386280) 386362) inline$$BorrowGlobal$6$anon3_Then_correct) (=> (= (ControlFlow 0 386280) 386310) inline$$BorrowGlobal$6$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$6$Entry_correct  (and (=> (= (ControlFlow 0 386274) (- 0 460082)) true) (=> (= (ControlFlow 0 386274) 386280) inline$$BorrowGlobal$6$anon0_correct))))
(let ((inline$$GetFieldFromValue$12$anon0_correct  (=> (and (= inline$$GetFieldFromValue$12$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 386167) 386274)) inline$$BorrowGlobal$6$Entry_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$7$$t2@1) (= (ControlFlow 0 386173) 386167)) inline$$GetFieldFromValue$12$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 386107) 386113)) inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon28_Then_correct  (=> (= (ControlFlow 0 386121) 386113) inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon27_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$7$$t2@1)) (= $abort_code@127 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 386101) 386121) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon28_Then_correct) (=> (= (ControlFlow 0 386101) 386107) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon28_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon25_Else_correct  (=> (not $abort_flag@159) (and (=> (= (ControlFlow 0 386089) 386173) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 386089) 386101) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon27_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon24_Else_correct  (=> (not $abort_flag@158) (=> (and (and (and (= inline$$DiemAccount_restore_key_rotation_capability_$def$1$$t7@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@159)) (and (=> $abort_flag@159 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@159) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 386083) 387258) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon25_Then_correct) (=> (= (ControlFlow 0 386083) 386089) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon25_Else_correct))))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon24_Then_correct  (=> (and $abort_flag@158 (= (ControlFlow 0 387278) 386113)) inline$$DiemAccount_restore_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_exists_at_$def$7$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 386039) 387278) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 386039) 386083) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon24_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$7$anon6_Then_correct  (and (=> (= (ControlFlow 0 386049) 387278) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 386049) 386083) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon24_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$7$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$7$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@5) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$11$dst@1)))) (and (=> (= (ControlFlow 0 386033) 386049) inline$$DiemAccount_exists_at_$def$7$anon6_Then_correct) (=> (= (ControlFlow 0 386033) 386039) inline$$DiemAccount_exists_at_$def$7$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$7$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 385987) 386033)) inline$$DiemAccount_exists_at_$def$7$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$7$anon5_Then_correct  (=> (= (ControlFlow 0 386057) 386033) inline$$DiemAccount_exists_at_$def$7$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$7$anon0_correct  (=> (not $abort_flag@158) (and (=> (= (ControlFlow 0 385981) 386057) inline$$DiemAccount_exists_at_$def$7$anon5_Then_correct) (=> (= (ControlFlow 0 385981) 385987) inline$$DiemAccount_exists_at_$def$7$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$7$anon0_correct  (=> (and ((_ is $Address) inline$$GetFieldFromValue$11$dst@1) (= (ControlFlow 0 386063) 385981)) inline$$DiemAccount_exists_at_$def$7$anon0_correct)))
(let ((inline$$GetFieldFromValue$11$anon0_correct  (=> (and (= inline$$GetFieldFromValue$11$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 385823) 386063)) inline$$DiemAccount_exists_at$7$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 385747) 385823)) inline$$GetFieldFromValue$11$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon23_Then_correct  (=> (= (ControlFlow 0 387286) 385823) inline$$GetFieldFromValue$11$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon0_correct  (=> (not $abort_flag@158) (and (=> (= (ControlFlow 0 385741) 387286) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 385741) 385747) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon23_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$direct_inter$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2) (let ((va@@12 (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address))) true) (= (ControlFlow 0 387290) 385741)) inline$$DiemAccount_restore_key_rotation_capability_$def$1$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon97_Else_correct  (=> (and (not $abort_flag@158) (= (ControlFlow 0 387296) 387290)) inline$$DiemAccount_restore_key_rotation_capability_$direct_inter$1$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon97_Then_correct true))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon32$3_correct  (=> (and (= $DiemAccount_DiemAccount_$memory@5 |inline$$WritebackToGlobal$5$m'@2|) (= $abort_flag@158 $abort_flag@157)) (and (=> (= (ControlFlow 0 385159) 388252) inline$$Genesis_initialize_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 385159) 387296) inline$$Genesis_initialize_$def_verify$0$anon97_Else_correct)))))
(let ((inline$$WritebackToGlobal$5$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$5$l@1)) (=> (and (= |inline$$WritebackToGlobal$5$m'@2| $DiemAccount_DiemAccount_$memory@4) (= (ControlFlow 0 385097) 385159)) inline$$DiemAccount_rotate_authentication_key_$def$1$anon32$3_correct))))
(let ((inline$$WritebackToGlobal$5$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$5$l@1) (=> (and (= inline$$WritebackToGlobal$5$ta@1 (|ts#$Global| inline$$WritebackToGlobal$5$l@1)) (= inline$$WritebackToGlobal$5$a@1 (|a#$Global| inline$$WritebackToGlobal$5$l@1))) (=> (and (and (= inline$$WritebackToGlobal$5$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$7$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@4) inline$$WritebackToGlobal$5$ta@1 inline$$WritebackToGlobal$5$a@1) (|v#$Mutation| |inline$$WritebackToReference$7$dst'@2|))) (= |inline$$WritebackToGlobal$5$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory@4) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@4) inline$$WritebackToGlobal$5$ta@1 inline$$WritebackToGlobal$5$a@1 inline$$WritebackToGlobal$5$v@1)))) (and (= |inline$$WritebackToGlobal$5$m'@2| |inline$$WritebackToGlobal$5$m'@1|) (= (ControlFlow 0 385151) 385159))) inline$$DiemAccount_rotate_authentication_key_$def$1$anon32$3_correct)))))
(let ((inline$$WritebackToGlobal$5$anon0_correct  (=> (= inline$$WritebackToGlobal$5$l@1 (|l#$Mutation| |inline$$WritebackToReference$7$dst'@2|)) (and (=> (= (ControlFlow 0 385087) 385151) inline$$WritebackToGlobal$5$anon3_Then_correct) (=> (= (ControlFlow 0 385087) 385097) inline$$WritebackToGlobal$5$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$6$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$6$$after@0 (|v#$Mutation| |inline$$WritebackToReference$7$dst'@2|)) (= (ControlFlow 0 384965) 385087)) inline$$WritebackToGlobal$5$anon0_correct)))
(let ((inline$$WritebackToReference$7$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$5$dst@2) (|l#$Mutation| |inline$$WriteRef$7$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$7$dstPath@1) (|size#$Path| inline$$WritebackToReference$7$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$7$dstPath@1 inline$$WritebackToReference$7$srcPath@1))) (=> (and (= |inline$$WritebackToReference$7$dst'@2| inline$$BorrowGlobal$5$dst@2) (= (ControlFlow 0 384886) 384965)) inline$$DiemAccount_DiemAccount_$pack_ref$6$Entry_correct))))
(let ((inline$$WritebackToReference$7$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$5$dst@2) (|l#$Mutation| |inline$$WriteRef$7$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$7$dstPath@1) (|size#$Path| inline$$WritebackToReference$7$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$7$dstPath@1 inline$$WritebackToReference$7$srcPath@1)) (= |inline$$WritebackToReference$7$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$5$dst@2) inline$$WritebackToReference$7$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$7$srcPath@1 (|size#$Path| inline$$WritebackToReference$7$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$5$dst@2) (|v#$Mutation| |inline$$WriteRef$7$to'@1|))))) (and (= |inline$$WritebackToReference$7$dst'@2| |inline$$WritebackToReference$7$dst'@1|) (= (ControlFlow 0 384942) 384965))) inline$$DiemAccount_DiemAccount_$pack_ref$6$Entry_correct)))
(let ((inline$$WritebackToReference$7$anon0_correct  (=> (and (= inline$$WritebackToReference$7$srcPath@1 (|p#$Mutation| |inline$$WriteRef$7$to'@1|)) (= inline$$WritebackToReference$7$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$5$dst@2))) (and (=> (= (ControlFlow 0 384850) 384942) inline$$WritebackToReference$7$anon3_Then_correct) (=> (= (ControlFlow 0 384850) 384886) inline$$WritebackToReference$7$anon3_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 384713) 384850)) inline$$WritebackToReference$7$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon48_Then_correct  (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$1$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$5$dst@2)) (= (ControlFlow 0 385169) 384850)) inline$$WritebackToReference$7$anon0_correct)))
(let ((inline$$WriteRef$7$anon0_correct  (=> (= |inline$$WriteRef$7$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$7$dst@1) (|p#$Mutation| inline$$BorrowField$7$dst@1) tc_auth_key)) (and (=> (= (ControlFlow 0 384699) 385169) inline$$DiemAccount_rotate_authentication_key_$def$1$anon48_Then_correct) (=> (= (ControlFlow 0 384699) 384713) inline$$DiemAccount_rotate_authentication_key_$def$1$anon48_Else_correct)))))
(let ((inline$$BorrowField$7$anon0_correct  (=> (= inline$$BorrowField$7$p@1 (|p#$Mutation| inline$$BorrowGlobal$5$dst@2)) (=> (and (and (= inline$$BorrowField$7$size@1 (|size#$Path| inline$$BorrowField$7$p@1)) (= inline$$BorrowField$7$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1) inline$$BorrowField$7$size@1 $DiemAccount_DiemAccount_authentication_key) (+ inline$$BorrowField$7$size@1 1)))) (and (= inline$$BorrowField$7$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$5$dst@2) inline$$BorrowField$7$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$5$dst@2))) $DiemAccount_DiemAccount_authentication_key))) (= (ControlFlow 0 384640) 384699))) inline$$WriteRef$7$anon0_correct))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon46_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$1$$t16@1) (= (ControlFlow 0 384646) 384640)) inline$$BorrowField$7$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct  (=> (and (= $DiemAccount_DiemAccount_$memory@5 $DiemAccount_DiemAccount_$memory@4) (= $abort_flag@158 true)) (and (=> (= (ControlFlow 0 384086) 388252) inline$$Genesis_initialize_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 384086) 387296) inline$$Genesis_initialize_$def_verify$0$anon97_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 385239) 384086)) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon37_Then_correct  (=> (= (ControlFlow 0 385249) 384086) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon36_Then_correct  (=> $abort_flag@155 (and (=> (= (ControlFlow 0 385233) 385249) inline$$DiemAccount_rotate_authentication_key_$def$1$anon37_Then_correct) (=> (= (ControlFlow 0 385233) 385239) inline$$DiemAccount_rotate_authentication_key_$def$1$anon37_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 385219) 384086)) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon41_Then_correct  (=> (= (ControlFlow 0 385229) 384086) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon40_Then_correct  (=> $abort_flag@156 (and (=> (= (ControlFlow 0 385213) 385229) inline$$DiemAccount_rotate_authentication_key_$def$1$anon41_Then_correct) (=> (= (ControlFlow 0 385213) 385219) inline$$DiemAccount_rotate_authentication_key_$def$1$anon41_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 385199) 384086)) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon43_Then_correct  (=> (= (ControlFlow 0 385209) 384086) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon42_Then_correct  (=> $abort_flag@156 (and (=> (= (ControlFlow 0 385193) 385209) inline$$DiemAccount_rotate_authentication_key_$def$1$anon43_Then_correct) (=> (= (ControlFlow 0 385193) 385199) inline$$DiemAccount_rotate_authentication_key_$def$1$anon43_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 385179) 384086)) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon45_Then_correct  (=> (= (ControlFlow 0 385189) 384086) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon44_Then_correct  (=> $abort_flag@157 (and (=> (= (ControlFlow 0 385173) 385189) inline$$DiemAccount_rotate_authentication_key_$def$1$anon45_Then_correct) (=> (= (ControlFlow 0 385173) 385179) inline$$DiemAccount_rotate_authentication_key_$def$1$anon45_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 384508) 384086)) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon47_Then_correct  (=> (= (ControlFlow 0 384518) 384086) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon46_Else$1_correct  (=> (= $abort_code@125 (|i#$Integer| call3formal@$ret0@0@@0)) (and (=> (= (ControlFlow 0 384502) 384518) inline$$DiemAccount_rotate_authentication_key_$def$1$anon47_Then_correct) (=> (= (ControlFlow 0 384502) 384508) inline$$DiemAccount_rotate_authentication_key_$def$1$anon47_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$5$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$5$$after@0 (|v#$Mutation| inline$$BorrowGlobal$5$dst@2)) (= (ControlFlow 0 384490) 384502)) inline$$DiemAccount_rotate_authentication_key_$def$1$anon46_Else$1_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon46_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$1$$t16@1)) (= (ControlFlow 0 384496) 384490)) inline$$DiemAccount_DiemAccount_$pack_ref$5$Entry_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon44_Else_correct  (=> (not $abort_flag@157) (and (=> (= (ControlFlow 0 384467) 384646) inline$$DiemAccount_rotate_authentication_key_$def$1$anon46_Then_correct) (=> (= (ControlFlow 0 384467) 384496) inline$$DiemAccount_rotate_authentication_key_$def$1$anon46_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon42_Else_correct  (=> (not $abort_flag@156) (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$1$$t15@1 ($Integer 32)) (= inline$$DiemAccount_rotate_authentication_key_$def$1$$t16@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$1$l@1 inline$$DiemAccount_rotate_authentication_key_$def$1$$t15@1)))) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$1$$t17@1 ($Integer 8)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@157)) (and (=> $abort_flag@157 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@157) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 384461) 385173) inline$$DiemAccount_rotate_authentication_key_$def$1$anon44_Then_correct) (=> (= (ControlFlow 0 384461) 384467) inline$$DiemAccount_rotate_authentication_key_$def$1$anon44_Else_correct)))))))
(let ((inline$$Vector_length$1$anon0_correct  (=> (and ((_ is $Vector) tc_auth_key) (= inline$$Vector_length$1$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| tc_auth_key))))) (and (=> (= (ControlFlow 0 384431) 385193) inline$$DiemAccount_rotate_authentication_key_$def$1$anon42_Then_correct) (=> (= (ControlFlow 0 384431) 384461) inline$$DiemAccount_rotate_authentication_key_$def$1$anon42_Else_correct)))))
(let ((inline$$Vector_length$1$Entry_correct  (=> (and (= inline$$Vector_length$1$ta@0 $IntegerType) (= (ControlFlow 0 384419) 384431)) inline$$Vector_length$1$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$4$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$4$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$4$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 384376) 384419)) inline$$Vector_length$1$Entry_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$4$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$4$$before@0 (|v#$Mutation| inline$$BorrowGlobal$5$dst@2)) (= (ControlFlow 0 384370) 384376)) inline$$DiemAccount_DiemAccount_$unpack_ref$4$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon40_Else_correct  (=> (and (not $abort_flag@156) (= (ControlFlow 0 384380) 384370)) inline$$DiemAccount_DiemAccount_$unpack_ref$4$Entry_correct)))
(let ((inline$$BorrowGlobal$5$anon3_Then$1_correct  (=> (and (= $abort_flag@156 true) (= inline$$BorrowGlobal$5$dst@2 inline$$BorrowGlobal$5$dst@0)) (and (=> (= (ControlFlow 0 384337) 385213) inline$$DiemAccount_rotate_authentication_key_$def$1$anon40_Then_correct) (=> (= (ControlFlow 0 384337) 384380) inline$$DiemAccount_rotate_authentication_key_$def$1$anon40_Else_correct)))))
(let ((inline$$BorrowGlobal$5$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@4) $EmptyTypeValueArray inline$$BorrowGlobal$5$a@1)) (= (ControlFlow 0 384335) 384337)) inline$$BorrowGlobal$5$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$5$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@4) $EmptyTypeValueArray inline$$BorrowGlobal$5$a@1) (= inline$$BorrowGlobal$5$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$5$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@4) $EmptyTypeValueArray inline$$BorrowGlobal$5$a@1)))) (and (= $abort_flag@156 $abort_flag@155) (= inline$$BorrowGlobal$5$dst@2 inline$$BorrowGlobal$5$dst@1))) (and (=> (= (ControlFlow 0 384283) 385213) inline$$DiemAccount_rotate_authentication_key_$def$1$anon40_Then_correct) (=> (= (ControlFlow 0 384283) 384380) inline$$DiemAccount_rotate_authentication_key_$def$1$anon40_Else_correct)))))
(let ((inline$$BorrowGlobal$5$anon0_correct  (=> (= inline$$BorrowGlobal$5$a@1 (|a#$Address| inline$$GetFieldFromValue$10$dst@1)) (and (=> (= (ControlFlow 0 384253) 384335) inline$$BorrowGlobal$5$anon3_Then_correct) (=> (= (ControlFlow 0 384253) 384283) inline$$BorrowGlobal$5$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$5$Entry_correct  (and (=> (= (ControlFlow 0 384247) (- 0 459097)) true) (=> (= (ControlFlow 0 384247) 384253) inline$$BorrowGlobal$5$anon0_correct))))
(let ((inline$$GetFieldFromValue$10$anon0_correct  (=> (and (= inline$$GetFieldFromValue$10$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 384140) 384247)) inline$$BorrowGlobal$5$Entry_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon38_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$6$$t2@1) (= (ControlFlow 0 384146) 384140)) inline$$GetFieldFromValue$10$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 384080) 384086)) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon39_Then_correct  (=> (= (ControlFlow 0 384094) 384086) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$6$$t2@1)) (= $abort_code@123 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 384074) 384094) inline$$DiemAccount_rotate_authentication_key_$def$1$anon39_Then_correct) (=> (= (ControlFlow 0 384074) 384080) inline$$DiemAccount_rotate_authentication_key_$def$1$anon39_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon36_Else_correct  (=> (not $abort_flag@155) (and (=> (= (ControlFlow 0 384062) 384146) inline$$DiemAccount_rotate_authentication_key_$def$1$anon38_Then_correct) (=> (= (ControlFlow 0 384062) 384074) inline$$DiemAccount_rotate_authentication_key_$def$1$anon38_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon35_Else_correct  (=> (not $abort_flag@154) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$1$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@155)) (and (=> $abort_flag@155 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@155) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 384056) 385233) inline$$DiemAccount_rotate_authentication_key_$def$1$anon36_Then_correct) (=> (= (ControlFlow 0 384056) 384062) inline$$DiemAccount_rotate_authentication_key_$def$1$anon36_Else_correct))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon35_Then_correct  (=> (and $abort_flag@154 (= (ControlFlow 0 385253) 384086)) inline$$DiemAccount_rotate_authentication_key_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_exists_at_$def$6$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 384012) 385253) inline$$DiemAccount_rotate_authentication_key_$def$1$anon35_Then_correct) (=> (= (ControlFlow 0 384012) 384056) inline$$DiemAccount_rotate_authentication_key_$def$1$anon35_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$6$anon6_Then_correct  (and (=> (= (ControlFlow 0 384022) 385253) inline$$DiemAccount_rotate_authentication_key_$def$1$anon35_Then_correct) (=> (= (ControlFlow 0 384022) 384056) inline$$DiemAccount_rotate_authentication_key_$def$1$anon35_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$6$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$6$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@4) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$9$dst@1)))) (and (=> (= (ControlFlow 0 384006) 384022) inline$$DiemAccount_exists_at_$def$6$anon6_Then_correct) (=> (= (ControlFlow 0 384006) 384012) inline$$DiemAccount_exists_at_$def$6$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$6$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 383960) 384006)) inline$$DiemAccount_exists_at_$def$6$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$6$anon5_Then_correct  (=> (= (ControlFlow 0 384030) 384006) inline$$DiemAccount_exists_at_$def$6$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$6$anon0_correct  (=> (not $abort_flag@154) (and (=> (= (ControlFlow 0 383954) 384030) inline$$DiemAccount_exists_at_$def$6$anon5_Then_correct) (=> (= (ControlFlow 0 383954) 383960) inline$$DiemAccount_exists_at_$def$6$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$6$anon0_correct  (=> (and ((_ is $Address) inline$$GetFieldFromValue$9$dst@1) (= (ControlFlow 0 384036) 383954)) inline$$DiemAccount_exists_at_$def$6$anon0_correct)))
(let ((inline$$GetFieldFromValue$9$anon0_correct  (=> (and (= inline$$GetFieldFromValue$9$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 383796) 384036)) inline$$DiemAccount_exists_at$6$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 383686) 383796)) inline$$GetFieldFromValue$9$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon34_Then_correct  (=> (= (ControlFlow 0 385261) 383796) inline$$GetFieldFromValue$9$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 383678) 385261) inline$$DiemAccount_rotate_authentication_key_$def$1$anon34_Then_correct) (=> (= (ControlFlow 0 383678) 383686) inline$$DiemAccount_rotate_authentication_key_$def$1$anon34_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon33_Then_correct  (and (=> (= (ControlFlow 0 385269) 385261) inline$$DiemAccount_rotate_authentication_key_$def$1$anon34_Then_correct) (=> (= (ControlFlow 0 385269) 383686) inline$$DiemAccount_rotate_authentication_key_$def$1$anon34_Else_correct))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$1$anon0_correct  (=> (not $abort_flag@154) (and (=> (= (ControlFlow 0 383672) 385269) inline$$DiemAccount_rotate_authentication_key_$def$1$anon33_Then_correct) (=> (= (ControlFlow 0 383672) 383678) inline$$DiemAccount_rotate_authentication_key_$def$1$anon33_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$direct_inter$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2) (let ((va@@13 (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address))) true) (and (and (and ((_ is $Vector) tc_auth_key) (let ((va@@14 (|v#$Vector| tc_auth_key)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (forall ((inline$$DiemAccount_rotate_authentication_key_$direct_inter$1$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_rotate_authentication_key_$direct_inter$1$$$0 0) (< inline$$DiemAccount_rotate_authentication_key_$direct_inter$1$$$0 (|l#$ValueArray| (|v#$Vector| tc_auth_key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tc_auth_key)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$1$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tc_auth_key)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$1$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tc_auth_key)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$1$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tc_auth_key)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$1$$$0))
))) (= (ControlFlow 0 385273) 383672))) inline$$DiemAccount_rotate_authentication_key_$def$1$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon96_Else_correct  (=> (and (not $abort_flag@154) (= (ControlFlow 0 385279) 385273)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$1$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon96_Then_correct true))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon38_correct  (=> (= $DiemAccount_DiemAccount_$memory@4 |inline$$WritebackToGlobal$4$m'@2|) (=> (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2 call4formal@$ret0@0) (= $abort_flag@154 $abort_flag@153)) (and (=> (= (ControlFlow 0 382823) 388256) inline$$Genesis_initialize_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 382823) 385279) inline$$Genesis_initialize_$def_verify$0$anon96_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 382821) 382823)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon38_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon57_Then_correct  (=> (= (ControlFlow 0 382831) 382823) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon38_correct)))
(let ((inline$$WritebackToGlobal$4$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$4$l@1)) (= |inline$$WritebackToGlobal$4$m'@2| $DiemAccount_DiemAccount_$memory@3)) (and (=> (= (ControlFlow 0 382751) 382831) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon57_Then_correct) (=> (= (ControlFlow 0 382751) 382821) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon57_Else_correct)))))
(let ((inline$$WritebackToGlobal$4$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$4$l@1) (= inline$$WritebackToGlobal$4$ta@1 (|ts#$Global| inline$$WritebackToGlobal$4$l@1))) (=> (and (and (= inline$$WritebackToGlobal$4$a@1 (|a#$Global| inline$$WritebackToGlobal$4$l@1)) (= inline$$WritebackToGlobal$4$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1) (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|)))) (and (= |inline$$WritebackToGlobal$4$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1 inline$$WritebackToGlobal$4$v@1))) (= |inline$$WritebackToGlobal$4$m'@2| |inline$$WritebackToGlobal$4$m'@1|))) (and (=> (= (ControlFlow 0 382805) 382831) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon57_Then_correct) (=> (= (ControlFlow 0 382805) 382821) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon57_Else_correct))))))
(let ((inline$$WritebackToGlobal$4$anon0_correct  (=> (= inline$$WritebackToGlobal$4$l@1 (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (and (=> (= (ControlFlow 0 382741) 382805) inline$$WritebackToGlobal$4$anon3_Then_correct) (=> (= (ControlFlow 0 382741) 382751) inline$$WritebackToGlobal$4$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$4$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$4$$after@0 (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (= (ControlFlow 0 382619) 382741)) inline$$WritebackToGlobal$4$anon0_correct)))
(let ((inline$$WritebackToReference$6$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$4$dst@2) (|l#$Mutation| |inline$$WriteRef$6$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|size#$Path| inline$$WritebackToReference$6$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$6$dstPath@1 inline$$WritebackToReference$6$srcPath@1))) (=> (and (= |inline$$WritebackToReference$6$dst'@2| inline$$BorrowGlobal$4$dst@2) (= (ControlFlow 0 382540) 382619)) inline$$DiemAccount_DiemAccount_$pack_ref$4$Entry_correct))))
(let ((inline$$WritebackToReference$6$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$4$dst@2) (|l#$Mutation| |inline$$WriteRef$6$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|size#$Path| inline$$WritebackToReference$6$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$6$dstPath@1 inline$$WritebackToReference$6$srcPath@1)) (= |inline$$WritebackToReference$6$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$4$dst@2) inline$$WritebackToReference$6$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$6$srcPath@1 (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$4$dst@2) (|v#$Mutation| |inline$$WriteRef$6$to'@1|))))) (and (= |inline$$WritebackToReference$6$dst'@2| |inline$$WritebackToReference$6$dst'@1|) (= (ControlFlow 0 382596) 382619))) inline$$DiemAccount_DiemAccount_$pack_ref$4$Entry_correct)))
(let ((inline$$WritebackToReference$6$anon0_correct  (=> (and (= inline$$WritebackToReference$6$srcPath@1 (|p#$Mutation| |inline$$WriteRef$6$to'@1|)) (= inline$$WritebackToReference$6$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$4$dst@2))) (and (=> (= (ControlFlow 0 382504) 382596) inline$$WritebackToReference$6$anon3_Then_correct) (=> (= (ControlFlow 0 382504) 382540) inline$$WritebackToReference$6$anon3_Else_correct)))))
(let ((inline$$Option_Option_$pack_ref$2$anon0_correct  (and (=> (= (ControlFlow 0 382363) (- 0 458345)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$2$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$2$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 382363) 382504) inline$$WritebackToReference$6$anon0_correct)))))
(let ((inline$$Option_Option_$pack_ref$2$Entry_correct  (=> (= inline$$Option_Option_$pack_ref$2$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WriteRef$6$to'@1|)) (= (ControlFlow 0 382339) 382363)) inline$$Option_Option_$pack_ref$2$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 382293) 382339)) inline$$Option_Option_$pack_ref$2$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon56_Then_correct  (=> (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$1$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$4$dst@2)) (= (ControlFlow 0 382841) 382339)) inline$$Option_Option_$pack_ref$2$Entry_correct)))
(let ((inline$$WriteRef$6$anon0_correct  (=> (= |inline$$WriteRef$6$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$6$dst@1) (|p#$Mutation| inline$$BorrowField$6$dst@1) call5formal@$ret1@0)) (and (=> (= (ControlFlow 0 382279) 382841) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon56_Then_correct) (=> (= (ControlFlow 0 382279) 382293) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon56_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon54_Else_correct  (=> (and (not $abort_flag@153) (= (ControlFlow 0 382285) 382279)) inline$$WriteRef$6$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct  (=> (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@1 $Error) (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3)) (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@2 inline$$DiemAccount_extract_key_rotation_capability_$def$1$$ret0@1) (= $abort_flag@154 true))) (and (=> (= (ControlFlow 0 381478) 388256) inline$$Genesis_initialize_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 381478) 385279) inline$$Genesis_initialize_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 382939) 381478)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon41_Then_correct  (=> (= (ControlFlow 0 382949) 381478) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon40_Then_correct  (=> $abort_flag@145 (and (=> (= (ControlFlow 0 382933) 382949) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon41_Then_correct) (=> (= (ControlFlow 0 382933) 382939) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon41_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 382915) 381478)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon44_Then_correct  (=> (= (ControlFlow 0 382925) 381478) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon43_Then_correct  (=> $abort_flag@150 (and (=> (= (ControlFlow 0 382909) 382925) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon44_Then_correct) (=> (= (ControlFlow 0 382909) 382915) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon44_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 382891) 381478)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon49_Then_correct  (=> (= (ControlFlow 0 382901) 381478) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon48_Then_correct  (=> $abort_flag@151 (and (=> (= (ControlFlow 0 382885) 382901) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon49_Then_correct) (=> (= (ControlFlow 0 382885) 382891) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon49_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 382871) 381478)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon53_Then_correct  (=> (= (ControlFlow 0 382881) 381478) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon52_Then_correct  (=> $abort_flag@152 (and (=> (= (ControlFlow 0 382865) 382881) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon53_Then_correct) (=> (= (ControlFlow 0 382865) 382871) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon53_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 382851) 381478)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon55_Then_correct  (=> (= (ControlFlow 0 382861) 381478) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon54_Then_correct  (=> $abort_flag@153 (and (=> (= (ControlFlow 0 382845) 382861) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon55_Then_correct) (=> (= (ControlFlow 0 382845) 382851) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon55_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon52_Else$4_correct  (and (=> (= (ControlFlow 0 382222) (- 0 458180)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (and (= call0formal@$tv0@0@@0 $DiemAccount_KeyRotationCapability_type_value) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Option_Option_vec)) ($Integer 0)))) $abort_flag@153)) (=> (and (and (=> $abort_flag@153 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Option_Option_vec)) ($Integer 0))))) (=> $abort_flag@153 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@121 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@153) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 ($Vector_$borrow call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Option_Option_vec) ($Integer 0)))))) (=> (not $abort_flag@153) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec)) ($Integer 0))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret1@0) (let ((va@@15 (|v#$Vector| call5formal@$ret1@0)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 382222) 382845) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon54_Then_correct) (=> (= (ControlFlow 0 382222) 382285) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon54_Else_correct)))))))))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowField$6$dst@1)) (= (ControlFlow 0 382210) 382222)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon52_Else$4_correct)))
(let ((inline$$Option_Option_$unpack_ref$2$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$2$$before@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 382174) 382210)) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$Option_Option_$unpack_ref$2$Entry_correct  (=> (= inline$$Option_Option_$unpack_ref$2$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$unpack_ref$2$$before@0 (|v#$Mutation| inline$$BorrowField$6$dst@1)) (= (ControlFlow 0 382168) 382174)) inline$$Option_Option_$unpack_ref$2$anon0_correct))))
(let ((inline$$BorrowField$6$anon0_correct  (=> (= inline$$BorrowField$6$p@1 (|p#$Mutation| inline$$BorrowGlobal$4$dst@2)) (=> (and (and (= inline$$BorrowField$6$size@1 (|size#$Path| inline$$BorrowField$6$p@1)) (= inline$$BorrowField$6$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1) inline$$BorrowField$6$size@1 $DiemAccount_DiemAccount_key_rotation_capability) (+ inline$$BorrowField$6$size@1 1)))) (and (= inline$$BorrowField$6$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$4$dst@2) inline$$BorrowField$6$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$4$dst@2))) $DiemAccount_DiemAccount_key_rotation_capability))) (= (ControlFlow 0 382134) 382168))) inline$$Option_Option_$unpack_ref$2$Entry_correct))))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$3$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$3$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$3$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 382012) 382134)) inline$$BorrowField$6$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$3$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$3$$before@0 (|v#$Mutation| inline$$BorrowGlobal$4$dst@2)) (= (ControlFlow 0 382006) 382012)) inline$$DiemAccount_DiemAccount_$unpack_ref$3$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon52_Else_correct  (=> (and (not $abort_flag@152) (= (ControlFlow 0 382016) 382006)) inline$$DiemAccount_DiemAccount_$unpack_ref$3$Entry_correct)))
(let ((inline$$BorrowGlobal$4$anon3_Then$1_correct  (=> (and (= $abort_flag@152 true) (= inline$$BorrowGlobal$4$dst@2 inline$$BorrowGlobal$4$dst@0)) (and (=> (= (ControlFlow 0 381973) 382865) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon52_Then_correct) (=> (= (ControlFlow 0 381973) 382016) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon52_Else_correct)))))
(let ((inline$$BorrowGlobal$4$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray inline$$BorrowGlobal$4$a@1)) (= (ControlFlow 0 381971) 381973)) inline$$BorrowGlobal$4$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$4$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray inline$$BorrowGlobal$4$a@1) (= inline$$BorrowGlobal$4$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$4$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray inline$$BorrowGlobal$4$a@1)))) (and (= $abort_flag@152 $abort_flag@151) (= inline$$BorrowGlobal$4$dst@2 inline$$BorrowGlobal$4$dst@1))) (and (=> (= (ControlFlow 0 381919) 382865) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon52_Then_correct) (=> (= (ControlFlow 0 381919) 382016) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon52_Else_correct)))))
(let ((inline$$BorrowGlobal$4$anon0_correct  (=> (= inline$$BorrowGlobal$4$a@1 (|a#$Address| call3formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 381889) 381971) inline$$BorrowGlobal$4$anon3_Then_correct) (=> (= (ControlFlow 0 381889) 381919) inline$$BorrowGlobal$4$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$4$Entry_correct  (and (=> (= (ControlFlow 0 381883) (- 0 457972)) true) (=> (= (ControlFlow 0 381883) 381889) inline$$BorrowGlobal$4$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon50_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$5$$t2@1) (= (ControlFlow 0 381979) 381883)) inline$$BorrowGlobal$4$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 381768) 381478)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon51_Then_correct  (=> (= (ControlFlow 0 381778) 381478) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon50_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$5$$t2@1)) (= $abort_code@120 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 381762) 381778) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon51_Then_correct) (=> (= (ControlFlow 0 381762) 381768) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon51_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon48_Else_correct  (=> (not $abort_flag@151) (and (=> (= (ControlFlow 0 381750) 381979) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon50_Then_correct) (=> (= (ControlFlow 0 381750) 381762) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon50_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon47_Else_correct  (=> (not $abort_flag@150) (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$1$$t13@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@151)) (and (=> $abort_flag@151 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@151) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 381744) 382885) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon48_Then_correct) (=> (= (ControlFlow 0 381744) 381750) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon48_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon47_Then_correct  (=> (and $abort_flag@150 (= (ControlFlow 0 382905) 381478)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_exists_at_$def$5$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 381700) 382905) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon47_Then_correct) (=> (= (ControlFlow 0 381700) 381744) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon47_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$5$anon6_Then_correct  (and (=> (= (ControlFlow 0 381710) 382905) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon47_Then_correct) (=> (= (ControlFlow 0 381710) 381744) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon47_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$5$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$5$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@2)))) (and (=> (= (ControlFlow 0 381694) 381710) inline$$DiemAccount_exists_at_$def$5$anon6_Then_correct) (=> (= (ControlFlow 0 381694) 381700) inline$$DiemAccount_exists_at_$def$5$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$5$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 381648) 381694)) inline$$DiemAccount_exists_at_$def$5$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$5$anon5_Then_correct  (=> (= (ControlFlow 0 381718) 381694) inline$$DiemAccount_exists_at_$def$5$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$5$anon0_correct  (=> (not $abort_flag@150) (and (=> (= (ControlFlow 0 381642) 381718) inline$$DiemAccount_exists_at_$def$5$anon5_Then_correct) (=> (= (ControlFlow 0 381642) 381648) inline$$DiemAccount_exists_at_$def$5$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$5$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@2) (= (ControlFlow 0 381724) 381642)) inline$$DiemAccount_exists_at_$def$5$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Not$15$dst@1) (= (ControlFlow 0 381732) 381724)) inline$$DiemAccount_exists_at$5$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 381470) 381478)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon46_Then_correct  (=> (= (ControlFlow 0 381486) 381478) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$15$dst@1)) (= $abort_code@118 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 381464) 381486) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon46_Then_correct) (=> (= (ControlFlow 0 381464) 381470) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon46_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon43_Else_correct  (=> (not $abort_flag@150) (and (=> (= (ControlFlow 0 381452) 381732) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon45_Then_correct) (=> (= (ControlFlow 0 381452) 381464) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon45_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon42_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$1$$t10@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@150)) (and (=> $abort_flag@150 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@150) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 381446) 382909) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon43_Then_correct) (=> (= (ControlFlow 0 381446) 381452) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon43_Else_correct)))))
(let ((inline$$Not$15$anon0_correct  (=> (and (= inline$$Not$15$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_delegated_key_rotation_capability_$def$1$$ret0@2)))) (= (ControlFlow 0 381434) 381446)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon42_Else$1_correct)))
(let ((inline$$Not$15$Entry_correct  (and (=> (= (ControlFlow 0 381424) (- 0 457670)) true) (=> (= (ControlFlow 0 381424) 381434) inline$$Not$15$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon42_Else_correct  (=> (and (not $abort_flag@149) (= (ControlFlow 0 381440) 381424)) inline$$Not$15$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon42_Then_correct  (=> (and $abort_flag@149 (= (ControlFlow 0 382929) 381478)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon22_correct  (=> (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$1$$ret0@2 call4formal@$ret0@0@@0) (= $abort_flag@149 $abort_flag@148)) (and (=> (= (ControlFlow 0 381290) 382929) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon42_Then_correct) (=> (= (ControlFlow 0 381290) 381440) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon42_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 381288) 381290)) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon33_Then_correct  (=> (= (ControlFlow 0 381298) 381290) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon31_Else_correct  (=> (not $abort_flag@148) (and (=> (= (ControlFlow 0 381282) 381298) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon33_Then_correct) (=> (= (ControlFlow 0 381282) 381288) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon33_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct  (=> (= inline$$DiemAccount_delegated_key_rotation_capability_$def$1$$ret0@1 $Error) (=> (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$1$$ret0@2 inline$$DiemAccount_delegated_key_rotation_capability_$def$1$$ret0@1) (= $abort_flag@149 true)) (and (=> (= (ControlFlow 0 381031) 382929) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon42_Then_correct) (=> (= (ControlFlow 0 381031) 381440) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon42_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 381348) 381031)) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon26_Then_correct  (=> (= (ControlFlow 0 381358) 381031) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon25_Then_correct  (=> $abort_flag@146 (and (=> (= (ControlFlow 0 381342) 381358) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 381342) 381348) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon26_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 381328) 381031)) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon30_Then_correct  (=> (= (ControlFlow 0 381338) 381031) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon29_Then_correct  (=> $abort_flag@147 (and (=> (= (ControlFlow 0 381322) 381338) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 381322) 381328) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon30_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 381308) 381031)) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon32_Then_correct  (=> (= (ControlFlow 0 381318) 381031) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon31_Then_correct  (=> $abort_flag@148 (and (=> (= (ControlFlow 0 381302) 381318) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon32_Then_correct) (=> (= (ControlFlow 0 381302) 381308) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon32_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon29_Else$1_correct  (=> (= call0formal@$tv0@0@@1 $DiemAccount_KeyRotationCapability_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@148) (=> $abort_flag@148 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@148) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$8$dst@1)) $Option_Option_vec)) ($Integer 0))))))) ((_ is $Boolean) call4formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 381274) 381302) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon31_Then_correct) (=> (= (ControlFlow 0 381274) 381282) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon31_Else_correct))))))
(let ((inline$$GetFieldFromValue$8$anon0_correct  (=> (and (= inline$$GetFieldFromValue$8$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$2$dst@2)) $DiemAccount_DiemAccount_key_rotation_capability)) (= (ControlFlow 0 381266) 381274)) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon29_Else$1_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon29_Else_correct  (=> (and (not $abort_flag@147) (= (ControlFlow 0 381272) 381266)) inline$$GetFieldFromValue$8$anon0_correct)))
(let ((inline$$GetGlobal$2$anon3_Then$1_correct  (=> (and (= $abort_flag@147 true) (= inline$$GetGlobal$2$dst@2 inline$$GetGlobal$2$dst@0)) (and (=> (= (ControlFlow 0 381212) 381322) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon29_Then_correct) (=> (= (ControlFlow 0 381212) 381272) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon29_Else_correct)))))
(let ((inline$$GetGlobal$2$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray inline$$GetGlobal$2$a@1)) (= (ControlFlow 0 381210) 381212)) inline$$GetGlobal$2$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$2$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray inline$$GetGlobal$2$a@1) (= inline$$GetGlobal$2$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@2)))) (and (= $abort_flag@147 $abort_flag@146) (= inline$$GetGlobal$2$dst@2 inline$$GetGlobal$2$dst@1))) (and (=> (= (ControlFlow 0 381158) 381322) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon29_Then_correct) (=> (= (ControlFlow 0 381158) 381272) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon29_Else_correct)))))
(let ((inline$$GetGlobal$2$anon0_correct  (=> (= inline$$GetGlobal$2$a@1 (|a#$Address| call3formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 381140) 381210) inline$$GetGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 381140) 381158) inline$$GetGlobal$2$anon3_Else_correct)))))
(let ((inline$$GetGlobal$2$Entry_correct  (and (=> (= (ControlFlow 0 381134) (- 0 457419)) true) (=> (= (ControlFlow 0 381134) 381140) inline$$GetGlobal$2$anon0_correct))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$4$$t2@1) (= (ControlFlow 0 381218) 381134)) inline$$GetGlobal$2$Entry_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 381023) 381031)) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon28_Then_correct  (=> (= (ControlFlow 0 381039) 381031) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon27_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$4$$t2@1)) (= $abort_code@115 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 381017) 381039) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon28_Then_correct) (=> (= (ControlFlow 0 381017) 381023) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon28_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon25_Else_correct  (=> (not $abort_flag@146) (and (=> (= (ControlFlow 0 381005) 381218) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 381005) 381017) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon27_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon24_Else_correct  (=> (not $abort_flag@145) (=> (and (and (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$1$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@146)) (and (=> $abort_flag@146 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@146) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 380999) 381342) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon25_Then_correct) (=> (= (ControlFlow 0 380999) 381005) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon25_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon24_Then_correct  (=> (and $abort_flag@145 (= (ControlFlow 0 381362) 381031)) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$Abort_correct)))
(let ((inline$$DiemAccount_exists_at_$def$4$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 380955) 381362) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 380955) 380999) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon24_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$4$anon6_Then_correct  (and (=> (= (ControlFlow 0 380965) 381362) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 380965) 380999) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon24_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$4$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$4$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@2)))) (and (=> (= (ControlFlow 0 380949) 380965) inline$$DiemAccount_exists_at_$def$4$anon6_Then_correct) (=> (= (ControlFlow 0 380949) 380955) inline$$DiemAccount_exists_at_$def$4$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$4$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 380903) 380949)) inline$$DiemAccount_exists_at_$def$4$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$4$anon5_Then_correct  (=> (= (ControlFlow 0 380973) 380949) inline$$DiemAccount_exists_at_$def$4$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$4$anon0_correct  (=> (not $abort_flag@145) (and (=> (= (ControlFlow 0 380897) 380973) inline$$DiemAccount_exists_at_$def$4$anon5_Then_correct) (=> (= (ControlFlow 0 380897) 380903) inline$$DiemAccount_exists_at_$def$4$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$4$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@2) (= (ControlFlow 0 380979) 380897)) inline$$DiemAccount_exists_at_$def$4$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 380711) 380979)) inline$$DiemAccount_exists_at$4$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon23_Then_correct  (=> (= (ControlFlow 0 381370) 380979) inline$$DiemAccount_exists_at$4$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon0_correct  (=> (not $abort_flag@145) (and (=> (= (ControlFlow 0 380705) 381370) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 380705) 380711) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon23_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability$1$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@2) (= (ControlFlow 0 381376) 380705)) inline$$DiemAccount_delegated_key_rotation_capability_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon40_Else_correct  (=> (and (not $abort_flag@145) (= (ControlFlow 0 381384) 381376)) inline$$DiemAccount_delegated_key_rotation_capability$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@145) (=> $abort_flag@145 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@145) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 tc_account)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 380295) 382933) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon40_Then_correct) (=> (= (ControlFlow 0 380295) 381384) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon40_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 380259) 380295)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon39_Then_correct  (=> (= (ControlFlow 0 382957) 380295) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon0_correct  (=> (not $abort_flag@144) (and (=> (= (ControlFlow 0 380253) 382957) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon39_Then_correct) (=> (= (ControlFlow 0 380253) 380259) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon39_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$direct_inter$1$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 382963) 380253)) inline$$DiemAccount_extract_key_rotation_capability_$def$1$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon95_Else_correct  (=> (and (not $abort_flag@144) (= (ControlFlow 0 382971) 382963)) inline$$DiemAccount_extract_key_rotation_capability_$direct_inter$1$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon95_Then_correct true))
(let ((inline$$DiemVMConfig_initialize_$def$0$Abort_correct  (=> (= $abort_flag@144 true) (and (=> (= (ControlFlow 0 379495) 388260) inline$$Genesis_initialize_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 379495) 382971) inline$$Genesis_initialize_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 379533) 379495)) inline$$DiemVMConfig_initialize_$def$0$Abort_correct)))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 379543) 379495) inline$$DiemVMConfig_initialize_$def$0$Abort_correct)))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon22_Then_correct  (=> $abort_flag@141 (and (=> (= (ControlFlow 0 379527) 379543) inline$$DiemVMConfig_initialize_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 379527) 379533) inline$$DiemVMConfig_initialize_$def$0$anon23_Else_correct)))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 379513) 379495)) inline$$DiemVMConfig_initialize_$def$0$Abort_correct)))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 379523) 379495) inline$$DiemVMConfig_initialize_$def$0$Abort_correct)))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon24_Then_correct  (=> $abort_flag@142 (and (=> (= (ControlFlow 0 379507) 379523) inline$$DiemVMConfig_initialize_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 379507) 379513) inline$$DiemVMConfig_initialize_$def$0$anon25_Else_correct)))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 379489) 379495)) inline$$DiemVMConfig_initialize_$def$0$Abort_correct)))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 379503) 379495) inline$$DiemVMConfig_initialize_$def$0$Abort_correct)))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon26_Then_correct  (=> $abort_flag@143 (and (=> (= (ControlFlow 0 379483) 379503) inline$$DiemVMConfig_initialize_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 379483) 379489) inline$$DiemVMConfig_initialize_$def$0$anon27_Else_correct)))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon26_Else_correct  (=> (and (not $abort_flag@143) (= $abort_flag@144 $abort_flag@143)) (and (=> (= (ControlFlow 0 379479) 388260) inline$$Genesis_initialize_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 379479) 382971) inline$$Genesis_initialize_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon24_Else$3_correct  (=> (= call0formal@$tv0@0@@2 $DiemVMConfig_DiemVMConfig_type_value) (=> (and (= call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 ($ConstMemoryDomain true)) (= call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 379473) (- 0 456267)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 379473) (- 0 456287)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@29) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@143) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| dr_account)))) $abort_flag@143)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@143) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@143))) (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@143) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@143)) (and (=> $abort_flag@143 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@29) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@143 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@29) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@112 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@112 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@112 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@112 (|i#$Integer| ($Integer 2))))))))) (and (and (and (=> (not $abort_flag@143) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| dr_account))))) (=> (not $abort_flag@143) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@30) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@143) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@30) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)) inline$$DiemVMConfig_DiemVMConfig_pack$0$$struct@1)))) (=> (not $abort_flag@143) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@16) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@16) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@30) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@29) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@30) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@30) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@29) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@30) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@11) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@11) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 379473) 379483) inline$$DiemVMConfig_initialize_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 379473) 379479) inline$$DiemVMConfig_initialize_$def$0$anon26_Else_correct)))))))))))
(let ((inline$$DiemVMConfig_DiemVMConfig_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 379459) 379473)) inline$$DiemVMConfig_initialize_$def$0$anon24_Else$3_correct)))
(let ((inline$$DiemVMConfig_DiemVMConfig_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 379465) 379473) inline$$DiemVMConfig_initialize_$def$0$anon24_Else$3_correct)))
(let ((inline$$DiemVMConfig_DiemVMConfig_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 379453) 379465) inline$$DiemVMConfig_DiemVMConfig_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 379453) 379459) inline$$DiemVMConfig_DiemVMConfig_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemVMConfig_DiemVMConfig_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 379445) 379473)) inline$$DiemVMConfig_initialize_$def$0$anon24_Else$3_correct)))
(let ((inline$$DiemVMConfig_DiemVMConfig_pack$0$anon0_correct  (=> (and (and (and (and (and (and (and (and (and ((_ is $Vector) inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1) (let ((va@@17 (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_instruction_schedule)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_instruction_schedule))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_instruction_schedule))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_instruction_schedule))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_instruction_schedule))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_instruction_schedule))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_instruction_schedule))) $$0@@1))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_native_schedule)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_native_schedule))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_native_schedule))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_native_schedule))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_native_schedule))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_native_schedule))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_native_schedule))) $$0@@2))
))) (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) 11)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_global_memory_per_byte_cost)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_global_memory_per_byte_cost)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_global_memory_per_byte_cost)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_global_memory_per_byte_write_cost)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_global_memory_per_byte_write_cost)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_global_memory_per_byte_write_cost)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_min_transaction_gas_units)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_min_transaction_gas_units)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_min_transaction_gas_units)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_large_transaction_cutoff)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_large_transaction_cutoff)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_large_transaction_cutoff)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_intrinsic_gas_per_byte)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_intrinsic_gas_per_byte)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_intrinsic_gas_per_byte)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_maximum_number_of_gas_units)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_maximum_number_of_gas_units)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_maximum_number_of_gas_units)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_min_price_per_gas_unit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_min_price_per_gas_unit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_min_price_per_gas_unit)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_max_price_per_gas_unit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_max_price_per_gas_unit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_max_price_per_gas_unit)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_max_transaction_size_in_bytes)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_max_transaction_size_in_bytes)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_max_transaction_size_in_bytes)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_gas_unit_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_gas_unit_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_gas_unit_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_default_account_size)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_default_account_size)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1)) $DiemVMConfig_GasSchedule_gas_constants))) $DiemVMConfig_GasConstants_default_account_size)) $MAX_U64)))) true) (= inline$$DiemVMConfig_DiemVMConfig_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1) 1)))) (and (=> (= (ControlFlow 0 379437) 379453) inline$$DiemVMConfig_DiemVMConfig_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 379437) 379445) inline$$DiemVMConfig_DiemVMConfig_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemVMConfig_GasSchedule_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 379299) 379437)) inline$$DiemVMConfig_DiemVMConfig_pack$0$anon0_correct)))
(let ((inline$$DiemVMConfig_GasSchedule_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 379305) 379437) inline$$DiemVMConfig_DiemVMConfig_pack$0$anon0_correct)))
(let ((inline$$DiemVMConfig_GasSchedule_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 379293) 379305) inline$$DiemVMConfig_GasSchedule_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 379293) 379299) inline$$DiemVMConfig_GasSchedule_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemVMConfig_GasSchedule_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 379285) 379437)) inline$$DiemVMConfig_DiemVMConfig_pack$0$anon0_correct)))
(let ((inline$$DiemVMConfig_GasSchedule_pack$0$anon0_correct  (=> (and (and (and ((_ is $Vector) instruction_schedule) (let ((va@@21 (|v#$Vector| instruction_schedule)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (forall ((inline$$DiemVMConfig_GasSchedule_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemVMConfig_GasSchedule_pack$0$$$0 0) (< inline$$DiemVMConfig_GasSchedule_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| instruction_schedule)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) inline$$DiemVMConfig_GasSchedule_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) inline$$DiemVMConfig_GasSchedule_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) inline$$DiemVMConfig_GasSchedule_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) inline$$DiemVMConfig_GasSchedule_pack$0$$$0))
))) (and (and ((_ is $Vector) native_schedule) (let ((va@@22 (|v#$Vector| native_schedule)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (forall ((inline$$DiemVMConfig_GasSchedule_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemVMConfig_GasSchedule_pack$0$$$0@@0 0) (< inline$$DiemVMConfig_GasSchedule_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| native_schedule)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) inline$$DiemVMConfig_GasSchedule_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) inline$$DiemVMConfig_GasSchedule_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) inline$$DiemVMConfig_GasSchedule_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) inline$$DiemVMConfig_GasSchedule_pack$0$$$0@@0))
)))) (=> (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) inline$$DiemVMConfig_GasConstants_pack$0$$struct@1) (let ((va@@23 (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) 11)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_global_memory_per_byte_cost)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_global_memory_per_byte_cost)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_global_memory_per_byte_cost)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_global_memory_per_byte_write_cost)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_global_memory_per_byte_write_cost)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_global_memory_per_byte_write_cost)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_min_transaction_gas_units)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_min_transaction_gas_units)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_min_transaction_gas_units)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_large_transaction_cutoff)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_large_transaction_cutoff)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_large_transaction_cutoff)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_intrinsic_gas_per_byte)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_intrinsic_gas_per_byte)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_intrinsic_gas_per_byte)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_maximum_number_of_gas_units)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_maximum_number_of_gas_units)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_maximum_number_of_gas_units)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_min_price_per_gas_unit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_min_price_per_gas_unit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_min_price_per_gas_unit)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_max_price_per_gas_unit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_max_price_per_gas_unit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_max_price_per_gas_unit)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_max_transaction_size_in_bytes)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_max_transaction_size_in_bytes)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_max_transaction_size_in_bytes)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_gas_unit_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_gas_unit_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_gas_unit_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_default_account_size)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_default_account_size)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemVMConfig_GasConstants_pack$0$$struct@1)) $DiemVMConfig_GasConstants_default_account_size)) $MAX_U64))) true) (= inline$$DiemVMConfig_GasSchedule_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 instruction_schedule) 1 native_schedule) 2 inline$$DiemVMConfig_GasConstants_pack$0$$struct@1) 3)))) (and (=> (= (ControlFlow 0 379277) 379293) inline$$DiemVMConfig_GasSchedule_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 379277) 379285) inline$$DiemVMConfig_GasSchedule_pack$0$anon3_Else_correct))))))
(let ((inline$$DiemVMConfig_GasConstants_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 378943) 379277)) inline$$DiemVMConfig_GasSchedule_pack$0$anon0_correct)))
(let ((inline$$DiemVMConfig_GasConstants_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 378949) 379277) inline$$DiemVMConfig_GasSchedule_pack$0$anon0_correct)))
(let ((inline$$DiemVMConfig_GasConstants_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 378937) 378949) inline$$DiemVMConfig_GasConstants_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 378937) 378943) inline$$DiemVMConfig_GasConstants_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemVMConfig_GasConstants_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 378929) 379277)) inline$$DiemVMConfig_GasSchedule_pack$0$anon0_correct)))
(let ((inline$$DiemVMConfig_GasConstants_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t7@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t7@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t7@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t8@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t8@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t8@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t9@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t9@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t9@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t10@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t10@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t10@1) $MAX_U64)))) (=> (and (and (and (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t11@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t11@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t11@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t12@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t12@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t12@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t13@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t13@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t13@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t14@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t14@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t14@1) $MAX_U64)))) (and (and (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t15@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t15@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t15@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t16@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t16@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t16@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$DiemVMConfig_initialize_$def$0$$t17@1) (>= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t17@1) 0)) (<= (|i#$Integer| inline$$DiemVMConfig_initialize_$def$0$$t17@1) $MAX_U64)) (= inline$$DiemVMConfig_GasConstants_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemVMConfig_initialize_$def$0$$t7@1) 1 inline$$DiemVMConfig_initialize_$def$0$$t8@1) 2 inline$$DiemVMConfig_initialize_$def$0$$t9@1) 3 inline$$DiemVMConfig_initialize_$def$0$$t10@1) 4 inline$$DiemVMConfig_initialize_$def$0$$t11@1) 5 inline$$DiemVMConfig_initialize_$def$0$$t12@1) 6 inline$$DiemVMConfig_initialize_$def$0$$t13@1) 7 inline$$DiemVMConfig_initialize_$def$0$$t14@1) 8 inline$$DiemVMConfig_initialize_$def$0$$t15@1) 9 inline$$DiemVMConfig_initialize_$def$0$$t16@1) 10 inline$$DiemVMConfig_initialize_$def$0$$t17@1) 11)))))) (and (=> (= (ControlFlow 0 378921) 378937) inline$$DiemVMConfig_GasConstants_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 378921) 378929) inline$$DiemVMConfig_GasConstants_pack$0$anon3_Else_correct))))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon24_Else_correct  (=> (not $abort_flag@142) (=> (and (and (= inline$$DiemVMConfig_initialize_$def$0$$t7@1 ($Integer 4)) (= inline$$DiemVMConfig_initialize_$def$0$$t8@1 ($Integer 9))) (and (= inline$$DiemVMConfig_initialize_$def$0$$t9@1 ($Integer 600)) (= inline$$DiemVMConfig_initialize_$def$0$$t10@1 ($Integer 600)))) (=> (and (and (and (= inline$$DiemVMConfig_initialize_$def$0$$t11@1 ($Integer 8)) (= inline$$DiemVMConfig_initialize_$def$0$$t12@1 ($Integer 4000000))) (and (= inline$$DiemVMConfig_initialize_$def$0$$t13@1 ($Integer 0)) (= inline$$DiemVMConfig_initialize_$def$0$$t14@1 ($Integer 10000)))) (and (and (= inline$$DiemVMConfig_initialize_$def$0$$t15@1 ($Integer 4096)) (= inline$$DiemVMConfig_initialize_$def$0$$t16@1 ($Integer 1000))) (and (= inline$$DiemVMConfig_initialize_$def$0$$t17@1 ($Integer 800)) (= (ControlFlow 0 378955) 378921)))) inline$$DiemVMConfig_GasConstants_pack$0$anon0_correct)))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon22_Else_correct  (=> (not $abort_flag@141) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@142) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@142)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@142) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@142)) (and (=> $abort_flag@142 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@142 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@111 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@111 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@111 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@111 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 378487) 379507) inline$$DiemVMConfig_initialize_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 378487) 378955) inline$$DiemVMConfig_initialize_$def$0$anon24_Else_correct)))))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@141) (=> (and (=> $abort_flag@141 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@141 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@110 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 378481) 379527) inline$$DiemVMConfig_initialize_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 378481) 378487) inline$$DiemVMConfig_initialize_$def$0$anon22_Else_correct))))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 378377) 378481)) inline$$DiemVMConfig_initialize_$def$0$anon6$3_correct)))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 379551) 378481) inline$$DiemVMConfig_initialize_$def$0$anon6$3_correct)))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 378369) 379551) inline$$DiemVMConfig_initialize_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 378369) 378377) inline$$DiemVMConfig_initialize_$def$0$anon21_Else_correct)))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon20_Then_correct  (and (=> (= (ControlFlow 0 379559) 379551) inline$$DiemVMConfig_initialize_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 379559) 378377) inline$$DiemVMConfig_initialize_$def$0$anon21_Else_correct))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 378361) 379559) inline$$DiemVMConfig_initialize_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 378361) 378369) inline$$DiemVMConfig_initialize_$def$0$anon20_Else_correct)))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 379567) 379559) inline$$DiemVMConfig_initialize_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 379567) 378369) inline$$DiemVMConfig_initialize_$def$0$anon20_Else_correct))))
(let ((inline$$DiemVMConfig_initialize_$def$0$anon0_correct  (=> (not $abort_flag@140) (and (=> (= (ControlFlow 0 378355) 379567) inline$$DiemVMConfig_initialize_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 378355) 378361) inline$$DiemVMConfig_initialize_$def$0$anon19_Else_correct)))))
(let ((inline$$DiemVMConfig_initialize_$direct_inter$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and ((_ is $Vector) instruction_schedule) (let ((va@@24 (|v#$Vector| instruction_schedule)))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (forall ((inline$$DiemVMConfig_initialize_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemVMConfig_initialize_$direct_inter$0$$$0 0) (< inline$$DiemVMConfig_initialize_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| instruction_schedule)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) inline$$DiemVMConfig_initialize_$direct_inter$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) inline$$DiemVMConfig_initialize_$direct_inter$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) inline$$DiemVMConfig_initialize_$direct_inter$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) inline$$DiemVMConfig_initialize_$direct_inter$0$$$0))
))) (=> (and (and (and ((_ is $Vector) native_schedule) (let ((va@@25 (|v#$Vector| native_schedule)))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (forall ((inline$$DiemVMConfig_initialize_$direct_inter$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemVMConfig_initialize_$direct_inter$0$$$0@@0 0) (< inline$$DiemVMConfig_initialize_$direct_inter$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| native_schedule)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) inline$$DiemVMConfig_initialize_$direct_inter$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) inline$$DiemVMConfig_initialize_$direct_inter$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) inline$$DiemVMConfig_initialize_$direct_inter$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) inline$$DiemVMConfig_initialize_$direct_inter$0$$$0@@0))
))) (= (ControlFlow 0 379571) 378355)) inline$$DiemVMConfig_initialize_$def$0$anon0_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon94_Else_correct  (=> (and (not $abort_flag@140) (= (ControlFlow 0 379577) 379571)) inline$$DiemVMConfig_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon94_Then_correct true))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$Abort_correct  (=> (= $abort_flag@140 true) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@10 $DiemConfig_ModifyConfigCapability_$memory@9) (= $DiemConfig_DiemConfig_$memory@29 $DiemConfig_DiemConfig_$memory@28)) (and (=> (= (ControlFlow 0 377574) 388264) inline$$Genesis_initialize_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 377574) 379577) inline$$Genesis_initialize_$def_verify$0$anon94_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon9_correct  (=> (= $DiemConfig_DiemConfig_$memory@28 $DiemConfig_DiemConfig_$memory@26) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@9 $DiemConfig_ModifyConfigCapability_$memory@7) (= (ControlFlow 0 377614) 377574)) inline$$DiemTransactionPublishingOption_initialize_$def$0$Abort_correct))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 377612) 377614)) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon9_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 377622) 377614) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon9_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon22_Then_correct  (=> $abort_flag@137 (and (=> (= (ControlFlow 0 377606) 377622) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 377606) 377612) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon23_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon13_correct  (=> (= $DiemConfig_DiemConfig_$memory@28 $DiemConfig_DiemConfig_$memory@26) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@9 $DiemConfig_ModifyConfigCapability_$memory@7) (= (ControlFlow 0 377594) 377574)) inline$$DiemTransactionPublishingOption_initialize_$def$0$Abort_correct))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 377592) 377594)) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon13_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 377602) 377594) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon13_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon24_Then_correct  (=> $abort_flag@138 (and (=> (= (ControlFlow 0 377586) 377602) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 377586) 377592) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon25_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon17_correct  (=> (= $DiemConfig_DiemConfig_$memory@28 $DiemConfig_DiemConfig_$memory@27) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@9 $DiemConfig_ModifyConfigCapability_$memory@8) (= (ControlFlow 0 377570) 377574)) inline$$DiemTransactionPublishingOption_initialize_$def$0$Abort_correct))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 377568) 377570)) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon17_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 377582) 377570) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon17_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon26_Then_correct  (=> $abort_flag@139 (and (=> (= (ControlFlow 0 377562) 377582) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 377562) 377568) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon27_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon26_Else_correct  (=> (and (and (not $abort_flag@139) (= $abort_flag@140 $abort_flag@139)) (and (= $DiemConfig_ModifyConfigCapability_$memory@10 $DiemConfig_ModifyConfigCapability_$memory@8) (= $DiemConfig_DiemConfig_$memory@29 $DiemConfig_DiemConfig_$memory@27))) (and (=> (= (ControlFlow 0 377558) 388264) inline$$Genesis_initialize_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 377558) 379577) inline$$Genesis_initialize_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon24_Else$1_correct  (=> (= call0formal@$tv0@0@@3 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) (=> (and (= call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@0 ($ConstMemoryDomain true)) (= call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 377552) (- 0 454385)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 377552) (- 0 454405)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@26) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@139) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@7) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| dr_account)))) $abort_flag@139)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@139) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@139))) (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@139) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@139)) (and (=> $abort_flag@139 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@26) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@7) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@139 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@26) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@7) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@109 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@109 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@109 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@109 (|i#$Integer| ($Integer 2))))))))) (and (and (and (=> (not $abort_flag@139) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| dr_account))))) (=> (not $abort_flag@139) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@27) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@139) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@27) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$struct@1)))) (=> (not $abort_flag@139) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@16) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@16) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@27) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@26) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@27) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@27) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@26) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@27) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@8) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@7) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@8) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@7) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 377552) 377562) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 377552) 377558) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon26_Else_correct)))))))))))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 377538) 377552)) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon24_Else$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 377544) 377552) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon24_Else$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 377532) 377544) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 377532) 377538) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 377524) 377552)) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon24_Else$1_correct)))
(let ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon0_correct  (=> (and (and (and ((_ is $Vector) initial_script_allow_list) (let ((va@@26 (|v#$Vector| initial_script_allow_list)))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (forall ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0 0) (< inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| initial_script_allow_list)))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (forall ((inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1 Int) ) (!  (=> (and (>= inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1 0) (< inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$$0))
))) (and ((_ is $Boolean) is_open_module) (= inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 initial_script_allow_list) 1 is_open_module) 2))))) (and (=> (= (ControlFlow 0 377516) 377532) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 377516) 377524) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon24_Else_correct  (=> (and (not $abort_flag@138) (= (ControlFlow 0 377550) 377516)) inline$$DiemTransactionPublishingOption_DiemTransactionPublishingOption_pack$0$anon0_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon22_Else_correct  (=> (not $abort_flag@137) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@138) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@138)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@138) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@138)) (and (=> $abort_flag@138 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@138 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@108 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@108 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@108 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@108 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 377195) 377586) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 377195) 377550) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon24_Else_correct)))))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@137) (=> (and (=> $abort_flag@137 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@137 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@107 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 377189) 377606) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 377189) 377195) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon22_Else_correct))))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 377085) 377189)) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon6$3_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 377630) 377189) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon6$3_correct)))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 377077) 377630) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 377077) 377085) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon21_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon20_Then_correct  (and (=> (= (ControlFlow 0 377638) 377630) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 377638) 377085) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon21_Else_correct))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 377069) 377638) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 377069) 377077) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon20_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 377646) 377638) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 377646) 377077) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon20_Else_correct))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$def$0$anon0_correct  (=> (not $abort_flag@136) (and (=> (= (ControlFlow 0 377063) 377646) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 377063) 377069) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon19_Else_correct)))))
(let ((inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and ((_ is $Vector) initial_script_allow_list) (let ((va@@28 (|v#$Vector| initial_script_allow_list)))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (forall ((inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0 0) (< inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| initial_script_allow_list)))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (forall ((inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$1 Int) ) (!  (=> (and (>= inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$1 0) (< inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0))) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0))) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0))) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0))) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$$$0))
))) (and ((_ is $Boolean) is_open_module) (= (ControlFlow 0 377650) 377063))) inline$$DiemTransactionPublishingOption_initialize_$def$0$anon0_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon93_Else_correct  (=> (and (not $abort_flag@136) (= (ControlFlow 0 377656) 377650)) inline$$DiemTransactionPublishingOption_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon93_Then_correct true))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon22$4_correct  (=> (and (= $DiemAccount_DiemAccount_$memory@3 |inline$$WritebackToGlobal$3$m'@2|) (= $abort_flag@136 $abort_flag@135)) (and (=> (= (ControlFlow 0 376383) 388268) inline$$Genesis_initialize_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 376383) 377656) inline$$Genesis_initialize_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$WritebackToGlobal$3$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$3$l@1)) (=> (and (= |inline$$WritebackToGlobal$3$m'@2| $DiemAccount_DiemAccount_$memory@2) (= (ControlFlow 0 376321) 376383)) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon22$4_correct))))
(let ((inline$$WritebackToGlobal$3$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$3$l@1) (=> (and (= inline$$WritebackToGlobal$3$ta@1 (|ts#$Global| inline$$WritebackToGlobal$3$l@1)) (= inline$$WritebackToGlobal$3$a@1 (|a#$Global| inline$$WritebackToGlobal$3$l@1))) (=> (and (and (= inline$$WritebackToGlobal$3$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@2) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1) (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) (= |inline$$WritebackToGlobal$3$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory@2) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@2) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1 inline$$WritebackToGlobal$3$v@1)))) (and (= |inline$$WritebackToGlobal$3$m'@2| |inline$$WritebackToGlobal$3$m'@1|) (= (ControlFlow 0 376375) 376383))) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon22$4_correct)))))
(let ((inline$$WritebackToGlobal$3$anon0_correct  (=> (= inline$$WritebackToGlobal$3$l@1 (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (and (=> (= (ControlFlow 0 376311) 376375) inline$$WritebackToGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 376311) 376321) inline$$WritebackToGlobal$3$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$3$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$3$$after@0 (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (= (ControlFlow 0 376189) 376311)) inline$$WritebackToGlobal$3$anon0_correct)))
(let ((inline$$WritebackToReference$5$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1))) (=> (and (= |inline$$WritebackToReference$5$dst'@2| inline$$BorrowGlobal$3$dst@2) (= (ControlFlow 0 376110) 376189)) inline$$DiemAccount_DiemAccount_$pack_ref$3$Entry_correct))))
(let ((inline$$WritebackToReference$5$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1)) (= |inline$$WritebackToReference$5$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) inline$$WritebackToReference$5$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$5$srcPath@1 (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$3$dst@2) (|v#$Mutation| |inline$$WriteRef$5$to'@1|))))) (and (= |inline$$WritebackToReference$5$dst'@2| |inline$$WritebackToReference$5$dst'@1|) (= (ControlFlow 0 376166) 376189))) inline$$DiemAccount_DiemAccount_$pack_ref$3$Entry_correct)))
(let ((inline$$WritebackToReference$5$anon0_correct  (=> (and (= inline$$WritebackToReference$5$srcPath@1 (|p#$Mutation| |inline$$WriteRef$5$to'@1|)) (= inline$$WritebackToReference$5$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$3$dst@2))) (and (=> (= (ControlFlow 0 376074) 376166) inline$$WritebackToReference$5$anon3_Then_correct) (=> (= (ControlFlow 0 376074) 376110) inline$$WritebackToReference$5$anon3_Else_correct)))))
(let ((inline$$Option_Option_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 375933) (- 0 453325)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$1$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$1$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 375933) 376074) inline$$WritebackToReference$5$anon0_correct)))))
(let ((inline$$Option_Option_$pack_ref$1$Entry_correct  (=> (= inline$$Option_Option_$pack_ref$1$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WriteRef$5$to'@1|)) (= (ControlFlow 0 375909) 375933)) inline$$Option_Option_$pack_ref$1$anon0_correct))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 375863) 375909)) inline$$Option_Option_$pack_ref$1$Entry_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon33_Then_correct  (=> (and (= inline$$DiemAccount_restore_key_rotation_capability_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$3$dst@2)) (= (ControlFlow 0 376393) 375909)) inline$$Option_Option_$pack_ref$1$Entry_correct)))
(let ((inline$$WriteRef$5$anon0_correct  (=> (= |inline$$WriteRef$5$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1) (|p#$Mutation| inline$$BorrowField$5$dst@1) call5formal@$ret0@0@@0)) (and (=> (= (ControlFlow 0 375849) 376393) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 375849) 375863) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon31_Else_correct  (=> (and (not $abort_flag@135) (= (ControlFlow 0 375855) 375849)) inline$$WriteRef$5$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct  (=> (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@2) (= $abort_flag@136 true)) (and (=> (= (ControlFlow 0 375292) 388268) inline$$Genesis_initialize_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 375292) 377656) inline$$Genesis_initialize_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 376443) 375292)) inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 376453) 375292) inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon25_Then_correct  (=> $abort_flag@133 (and (=> (= (ControlFlow 0 376437) 376453) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 376437) 376443) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon26_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 376423) 375292)) inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 376433) 375292) inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon29_Then_correct  (=> $abort_flag@134 (and (=> (= (ControlFlow 0 376417) 376433) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 376417) 376423) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 376403) 375292)) inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 376413) 375292) inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon31_Then_correct  (=> $abort_flag@135 (and (=> (= (ControlFlow 0 376397) 376413) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 376397) 376403) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon29_Else$4_correct  (and (=> (= (ControlFlow 0 375792) (- 0 453163)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (and (= call0formal@$tv0@0@@4 $DiemAccount_KeyRotationCapability_type_value) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Option_Option_vec)) ($Integer 0))))))) $abort_flag@135)) (=> (and (and (=> $abort_flag@135 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Option_Option_vec)) ($Integer 0)))))))) (=> $abort_flag@135 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Option_Option_vec)) ($Integer 0))))))) (= $abort_code@106 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@135) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Option_Option_vec)) ($Integer 0)))))))) (=> (not $abort_flag@135) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$borrow call0formal@$tv0@0@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Option_Option_vec) ($Integer 0)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@0) (let ((va@@30 (|v#$Vector| call5formal@$ret0@0@@0)))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Option_Option_vec)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Option_Option_vec))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 375792) 376397) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 375792) 375855) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon31_Else_correct)))))))))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$5$dst@1)) (= (ControlFlow 0 375780) 375792)) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon29_Else$4_correct)))
(let ((inline$$Option_Option_$unpack_ref$1$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$1$$before@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 375744) 375780)) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$Option_Option_$unpack_ref$1$Entry_correct  (=> (= inline$$Option_Option_$unpack_ref$1$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowField$5$dst@1)) (= (ControlFlow 0 375738) 375744)) inline$$Option_Option_$unpack_ref$1$anon0_correct))))
(let ((inline$$BorrowField$5$anon0_correct  (=> (= inline$$BorrowField$5$p@1 (|p#$Mutation| inline$$BorrowGlobal$3$dst@2)) (=> (and (and (= inline$$BorrowField$5$size@1 (|size#$Path| inline$$BorrowField$5$p@1)) (= inline$$BorrowField$5$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1) inline$$BorrowField$5$size@1 $DiemAccount_DiemAccount_key_rotation_capability) (+ inline$$BorrowField$5$size@1 1)))) (and (= inline$$BorrowField$5$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) inline$$BorrowField$5$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$3$dst@2))) $DiemAccount_DiemAccount_key_rotation_capability))) (= (ControlFlow 0 375704) 375738))) inline$$Option_Option_$unpack_ref$1$Entry_correct))))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$2$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$2$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$2$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 375582) 375704)) inline$$BorrowField$5$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$2$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$2$$before@0 (|v#$Mutation| inline$$BorrowGlobal$3$dst@2)) (= (ControlFlow 0 375576) 375582)) inline$$DiemAccount_DiemAccount_$unpack_ref$2$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon29_Else_correct  (=> (and (not $abort_flag@134) (= (ControlFlow 0 375586) 375576)) inline$$DiemAccount_DiemAccount_$unpack_ref$2$Entry_correct)))
(let ((inline$$BorrowGlobal$3$anon3_Then$1_correct  (=> (and (= $abort_flag@134 true) (= inline$$BorrowGlobal$3$dst@2 inline$$BorrowGlobal$3$dst@0)) (and (=> (= (ControlFlow 0 375543) 376417) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 375543) 375586) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$BorrowGlobal$3$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@2) $EmptyTypeValueArray inline$$BorrowGlobal$3$a@1)) (= (ControlFlow 0 375541) 375543)) inline$$BorrowGlobal$3$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$3$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@2) $EmptyTypeValueArray inline$$BorrowGlobal$3$a@1) (= inline$$BorrowGlobal$3$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$3$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@2) $EmptyTypeValueArray inline$$BorrowGlobal$3$a@1)))) (and (= $abort_flag@134 $abort_flag@133) (= inline$$BorrowGlobal$3$dst@2 inline$$BorrowGlobal$3$dst@1))) (and (=> (= (ControlFlow 0 375489) 376417) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 375489) 375586) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$BorrowGlobal$3$anon0_correct  (=> (= inline$$BorrowGlobal$3$a@1 (|a#$Address| inline$$GetFieldFromValue$7$dst@1)) (and (=> (= (ControlFlow 0 375459) 375541) inline$$BorrowGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 375459) 375489) inline$$BorrowGlobal$3$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$3$Entry_correct  (and (=> (= (ControlFlow 0 375453) (- 0 452955)) true) (=> (= (ControlFlow 0 375453) 375459) inline$$BorrowGlobal$3$anon0_correct))))
(let ((inline$$GetFieldFromValue$7$anon0_correct  (=> (and (= inline$$GetFieldFromValue$7$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 375346) 375453)) inline$$BorrowGlobal$3$Entry_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$3$$t2@1) (= (ControlFlow 0 375352) 375346)) inline$$GetFieldFromValue$7$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 375286) 375292)) inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 375300) 375292) inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon27_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$3$$t2@1)) (= $abort_code@105 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 375280) 375300) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 375280) 375286) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon28_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon25_Else_correct  (=> (not $abort_flag@133) (and (=> (= (ControlFlow 0 375268) 375352) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 375268) 375280) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon27_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon24_Else_correct  (=> (not $abort_flag@132) (=> (and (and (and (= inline$$DiemAccount_restore_key_rotation_capability_$def$0$$t7@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@133)) (and (=> $abort_flag@133 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@133) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 375262) 376437) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 375262) 375268) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon25_Else_correct))))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon24_Then_correct  (=> (and $abort_flag@132 (= (ControlFlow 0 376457) 375292)) inline$$DiemAccount_restore_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_exists_at_$def$3$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 375218) 376457) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 375218) 375262) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon24_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$3$anon6_Then_correct  (and (=> (= (ControlFlow 0 375228) 376457) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 375228) 375262) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon24_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$3$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$3$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@2) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$6$dst@1)))) (and (=> (= (ControlFlow 0 375212) 375228) inline$$DiemAccount_exists_at_$def$3$anon6_Then_correct) (=> (= (ControlFlow 0 375212) 375218) inline$$DiemAccount_exists_at_$def$3$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$3$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 375166) 375212)) inline$$DiemAccount_exists_at_$def$3$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$3$anon5_Then_correct  (=> (= (ControlFlow 0 375236) 375212) inline$$DiemAccount_exists_at_$def$3$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$3$anon0_correct  (=> (not $abort_flag@132) (and (=> (= (ControlFlow 0 375160) 375236) inline$$DiemAccount_exists_at_$def$3$anon5_Then_correct) (=> (= (ControlFlow 0 375160) 375166) inline$$DiemAccount_exists_at_$def$3$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$3$anon0_correct  (=> (and ((_ is $Address) inline$$GetFieldFromValue$6$dst@1) (= (ControlFlow 0 375242) 375160)) inline$$DiemAccount_exists_at_$def$3$anon0_correct)))
(let ((inline$$GetFieldFromValue$6$anon0_correct  (=> (and (= inline$$GetFieldFromValue$6$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 375002) 375242)) inline$$DiemAccount_exists_at$3$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 374926) 375002)) inline$$GetFieldFromValue$6$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 376465) 375002) inline$$GetFieldFromValue$6$anon0_correct)))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon0_correct  (=> (not $abort_flag@132) (and (=> (= (ControlFlow 0 374920) 376465) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 374920) 374926) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon23_Else_correct)))))
(let ((inline$$DiemAccount_restore_key_rotation_capability_$direct_inter$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2) (let ((va@@32 (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address))) true) (= (ControlFlow 0 376469) 374920)) inline$$DiemAccount_restore_key_rotation_capability_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon92_Else_correct  (=> (and (not $abort_flag@132) (= (ControlFlow 0 376475) 376469)) inline$$DiemAccount_restore_key_rotation_capability_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon92_Then_correct true))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct  (=> (and (= $DiemAccount_DiemAccount_$memory@2 |inline$$WritebackToGlobal$2$m'@2|) (= $abort_flag@132 $abort_flag@131)) (and (=> (= (ControlFlow 0 374338) 388272) inline$$Genesis_initialize_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 374338) 376475) inline$$Genesis_initialize_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2| $DiemAccount_DiemAccount_$memory@1) (= (ControlFlow 0 374276) 374338)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1) (=> (and (= inline$$WritebackToGlobal$2$ta@1 (|ts#$Global| inline$$WritebackToGlobal$2$l@1)) (= inline$$WritebackToGlobal$2$a@1 (|a#$Global| inline$$WritebackToGlobal$2$l@1))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1) (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|))) (= |inline$$WritebackToGlobal$2$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1 inline$$WritebackToGlobal$2$v@1)))) (and (= |inline$$WritebackToGlobal$2$m'@2| |inline$$WritebackToGlobal$2$m'@1|) (= (ControlFlow 0 374330) 374338))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct  (=> (= inline$$WritebackToGlobal$2$l@1 (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (and (=> (= (ControlFlow 0 374266) 374330) inline$$WritebackToGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 374266) 374276) inline$$WritebackToGlobal$2$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$2$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (= (ControlFlow 0 374144) 374266)) inline$$WritebackToGlobal$2$anon0_correct)))
(let ((inline$$WritebackToReference$4$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) (|l#$Mutation| |inline$$WriteRef$4$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1))) (=> (and (= |inline$$WritebackToReference$4$dst'@2| inline$$BorrowGlobal$2$dst@2) (= (ControlFlow 0 374065) 374144)) inline$$DiemAccount_DiemAccount_$pack_ref$2$Entry_correct))))
(let ((inline$$WritebackToReference$4$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) (|l#$Mutation| |inline$$WriteRef$4$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1)) (= |inline$$WritebackToReference$4$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$WritebackToReference$4$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$4$srcPath@1 (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$2$dst@2) (|v#$Mutation| |inline$$WriteRef$4$to'@1|))))) (and (= |inline$$WritebackToReference$4$dst'@2| |inline$$WritebackToReference$4$dst'@1|) (= (ControlFlow 0 374121) 374144))) inline$$DiemAccount_DiemAccount_$pack_ref$2$Entry_correct)))
(let ((inline$$WritebackToReference$4$anon0_correct  (=> (and (= inline$$WritebackToReference$4$srcPath@1 (|p#$Mutation| |inline$$WriteRef$4$to'@1|)) (= inline$$WritebackToReference$4$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2))) (and (=> (= (ControlFlow 0 374029) 374121) inline$$WritebackToReference$4$anon3_Then_correct) (=> (= (ControlFlow 0 374029) 374065) inline$$WritebackToReference$4$anon3_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 373892) 374029)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct  (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 374348) 374029)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$WriteRef$4$anon0_correct  (=> (= |inline$$WriteRef$4$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1) (|p#$Mutation| inline$$BorrowField$4$dst@1) dr_auth_key)) (and (=> (= (ControlFlow 0 373878) 374348) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 373878) 373892) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct)))))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $DiemAccount_DiemAccount_authentication_key) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2))) $DiemAccount_DiemAccount_authentication_key))) (= (ControlFlow 0 373819) 373878))) inline$$WriteRef$4$anon0_correct))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1) (= (ControlFlow 0 373825) 373819)) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct  (=> (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@1) (= $abort_flag@132 true)) (and (=> (= (ControlFlow 0 373265) 388272) inline$$Genesis_initialize_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 373265) 376475) inline$$Genesis_initialize_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 374418) 373265)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct  (=> (= (ControlFlow 0 374428) 373265) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct  (=> $abort_flag@129 (and (=> (= (ControlFlow 0 374412) 374428) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 374412) 374418) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 374398) 373265)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 374408) 373265) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct  (=> $abort_flag@130 (and (=> (= (ControlFlow 0 374392) 374408) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 374392) 374398) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 374378) 373265)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct  (=> (= (ControlFlow 0 374388) 373265) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct  (=> $abort_flag@130 (and (=> (= (ControlFlow 0 374372) 374388) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 374372) 374378) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 374358) 373265)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct  (=> (= (ControlFlow 0 374368) 373265) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct  (=> $abort_flag@131 (and (=> (= (ControlFlow 0 374352) 374368) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 374352) 374358) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 373687) 373265)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct  (=> (= (ControlFlow 0 373697) 373265) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct  (=> (= $abort_code@103 (|i#$Integer| call3formal@$ret0@0@@7)) (and (=> (= (ControlFlow 0 373681) 373697) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 373681) 373687) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 373669) 373681)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1)) (= (ControlFlow 0 373675) 373669)) inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct  (=> (not $abort_flag@131) (and (=> (= (ControlFlow 0 373646) 373825) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 373646) 373675) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct  (=> (not $abort_flag@130) (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1 ($Integer 32)) (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1 inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1)))) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1 ($Integer 8)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@131)) (and (=> $abort_flag@131 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@131) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 373640) 374352) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 373640) 373646) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct)))))))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) dr_auth_key) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| dr_auth_key))))) (and (=> (= (ControlFlow 0 373610) 374372) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 373610) 373640) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $IntegerType) (= (ControlFlow 0 373598) 373610)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$1$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 373555) 373598)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$1$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 373549) 373555)) inline$$DiemAccount_DiemAccount_$unpack_ref$1$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@130) (= (ControlFlow 0 373559) 373549)) inline$$DiemAccount_DiemAccount_$unpack_ref$1$Entry_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Then$1_correct  (=> (and (= $abort_flag@130 true) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@0)) (and (=> (= (ControlFlow 0 373516) 374392) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 373516) 373559) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct)))))
(let ((inline$$BorrowGlobal$2$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1)) (= (ControlFlow 0 373514) 373516)) inline$$BorrowGlobal$2$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1) (= inline$$BorrowGlobal$2$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray inline$$BorrowGlobal$2$a@1)))) (and (= $abort_flag@130 $abort_flag@129) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@1))) (and (=> (= (ControlFlow 0 373462) 374392) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 373462) 373559) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct)))))
(let ((inline$$BorrowGlobal$2$anon0_correct  (=> (= inline$$BorrowGlobal$2$a@1 (|a#$Address| inline$$GetFieldFromValue$5$dst@1)) (and (=> (= (ControlFlow 0 373432) 373514) inline$$BorrowGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 373432) 373462) inline$$BorrowGlobal$2$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$2$Entry_correct  (and (=> (= (ControlFlow 0 373426) (- 0 451970)) true) (=> (= (ControlFlow 0 373426) 373432) inline$$BorrowGlobal$2$anon0_correct))))
(let ((inline$$GetFieldFromValue$5$anon0_correct  (=> (and (= inline$$GetFieldFromValue$5$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 373319) 373426)) inline$$BorrowGlobal$2$Entry_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$2$$t2@1) (= (ControlFlow 0 373325) 373319)) inline$$GetFieldFromValue$5$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 373259) 373265)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 373273) 373265) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$2$$t2@1)) (= $abort_code@101 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 373253) 373273) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 373253) 373259) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct  (=> (not $abort_flag@129) (and (=> (= (ControlFlow 0 373241) 373325) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 373241) 373253) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct  (=> (not $abort_flag@128) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@129)) (and (=> $abort_flag@129 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@129) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 373235) 374412) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 373235) 373241) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct  (=> (and $abort_flag@128 (= (ControlFlow 0 374432) 373265)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_exists_at_$def$2$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 373191) 374432) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 373191) 373235) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon6_Then_correct  (and (=> (= (ControlFlow 0 373201) 374432) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 373201) 373235) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$2$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$4$dst@1)))) (and (=> (= (ControlFlow 0 373185) 373201) inline$$DiemAccount_exists_at_$def$2$anon6_Then_correct) (=> (= (ControlFlow 0 373185) 373191) inline$$DiemAccount_exists_at_$def$2$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 373139) 373185)) inline$$DiemAccount_exists_at_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$2$anon5_Then_correct  (=> (= (ControlFlow 0 373209) 373185) inline$$DiemAccount_exists_at_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$2$anon0_correct  (=> (not $abort_flag@128) (and (=> (= (ControlFlow 0 373133) 373209) inline$$DiemAccount_exists_at_$def$2$anon5_Then_correct) (=> (= (ControlFlow 0 373133) 373139) inline$$DiemAccount_exists_at_$def$2$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$2$anon0_correct  (=> (and ((_ is $Address) inline$$GetFieldFromValue$4$dst@1) (= (ControlFlow 0 373215) 373133)) inline$$DiemAccount_exists_at_$def$2$anon0_correct)))
(let ((inline$$GetFieldFromValue$4$anon0_correct  (=> (and (= inline$$GetFieldFromValue$4$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 372975) 373215)) inline$$DiemAccount_exists_at$2$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 372865) 372975)) inline$$GetFieldFromValue$4$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 374440) 372975) inline$$GetFieldFromValue$4$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 372857) 374440) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 372857) 372865) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 374448) 374440) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 374448) 372865) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct  (=> (not $abort_flag@128) (and (=> (= (ControlFlow 0 372851) 374448) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 372851) 372857) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2) (let ((va@@33 (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address))) true) (and (and (and ((_ is $Vector) dr_auth_key) (let ((va@@34 (|v#$Vector| dr_auth_key)))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (forall ((inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0 0) (< inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| dr_auth_key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dr_auth_key)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dr_auth_key)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dr_auth_key)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dr_auth_key)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0))
))) (= (ControlFlow 0 374452) 372851))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon91_Else_correct  (=> (and (not $abort_flag@128) (= (ControlFlow 0 374458) 374452)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon91_Then_correct true))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct  (=> (= $DiemAccount_DiemAccount_$memory@1 |inline$$WritebackToGlobal$1$m'@2|) (=> (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 call4formal@$ret0@0@@1) (= $abort_flag@128 $abort_flag@127)) (and (=> (= (ControlFlow 0 372002) 388276) inline$$Genesis_initialize_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 372002) 374458) inline$$Genesis_initialize_$def_verify$0$anon91_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 372000) 372002)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 372010) 372002) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct)))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (= |inline$$WritebackToGlobal$1$m'@2| $DiemAccount_DiemAccount_$memory@0)) (and (=> (= (ControlFlow 0 371930) 372010) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 371930) 372000) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct)))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)))) (and (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1))) (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|))) (and (=> (= (ControlFlow 0 371984) 372010) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 371984) 372000) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct))))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (and (=> (= (ControlFlow 0 371920) 371984) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 371920) 371930) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 371798) 371920)) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 371719) 371798)) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1)) (= |inline$$WritebackToReference$3$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$3$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$3$to'@1|))))) (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$3$dst'@1|) (= (ControlFlow 0 371775) 371798))) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$3$anon0_correct  (=> (and (= inline$$WritebackToReference$3$srcPath@1 (|p#$Mutation| |inline$$WriteRef$3$to'@1|)) (= inline$$WritebackToReference$3$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 371683) 371775) inline$$WritebackToReference$3$anon3_Then_correct) (=> (= (ControlFlow 0 371683) 371719) inline$$WritebackToReference$3$anon3_Else_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 371542) (- 0 451218)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 371542) 371683) inline$$WritebackToReference$3$anon0_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$pack_ref$0$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WriteRef$3$to'@1|)) (= (ControlFlow 0 371518) 371542)) inline$$Option_Option_$pack_ref$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 371472) 371518)) inline$$Option_Option_$pack_ref$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Then_correct  (=> (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 372020) 371518)) inline$$Option_Option_$pack_ref$0$Entry_correct)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) call5formal@$ret1@0@@0)) (and (=> (= (ControlFlow 0 371458) 372020) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 371458) 371472) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Else_correct  (=> (and (not $abort_flag@127) (= (ControlFlow 0 371464) 371458)) inline$$WriteRef$3$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct  (=> (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1 $Error) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory@0)) (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1) (= $abort_flag@128 true))) (and (=> (= (ControlFlow 0 370657) 388276) inline$$Genesis_initialize_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 370657) 374458) inline$$Genesis_initialize_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 372118) 370657)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 372128) 370657) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Then_correct  (=> $abort_flag@119 (and (=> (= (ControlFlow 0 372112) 372128) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 372112) 372118) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 372094) 370657)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 372104) 370657) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Then_correct  (=> $abort_flag@124 (and (=> (= (ControlFlow 0 372088) 372104) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 372088) 372094) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 372070) 370657)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Then_correct  (=> (= (ControlFlow 0 372080) 370657) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Then_correct  (=> $abort_flag@125 (and (=> (= (ControlFlow 0 372064) 372080) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 372064) 372070) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 372050) 370657)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 372060) 370657) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct  (=> $abort_flag@126 (and (=> (= (ControlFlow 0 372044) 372060) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 372044) 372050) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 372030) 370657)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 372040) 370657) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Then_correct  (=> $abort_flag@127 (and (=> (= (ControlFlow 0 372024) 372040) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 372024) 372030) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else$4_correct  (and (=> (= (ControlFlow 0 371401) (- 0 451053)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (and (= call0formal@$tv0@0@@5 $DiemAccount_KeyRotationCapability_type_value) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Option_Option_vec)) ($Integer 0)))) $abort_flag@127)) (=> (and (and (=> $abort_flag@127 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Option_Option_vec)) ($Integer 0))))) (=> $abort_flag@127 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@99 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@127) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@1 ($Vector_$borrow call0formal@$tv0@0@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Option_Option_vec) ($Integer 0)))))) (=> (not $abort_flag@127) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Option_Option_vec)) ($Integer 0))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret1@0@@0) (let ((va@@35 (|v#$Vector| call5formal@$ret1@0@@0)))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Option_Option_vec)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Option_Option_vec))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 371401) 372024) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 371401) 371464) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Else_correct)))))))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$3$dst@1)) (= (ControlFlow 0 371389) 371401)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else$4_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$0$$before@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 371353) 371389)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$unpack_ref$0$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowField$3$dst@1)) (= (ControlFlow 0 371347) 371353)) inline$$Option_Option_$unpack_ref$0$anon0_correct))))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $DiemAccount_DiemAccount_key_rotation_capability) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $DiemAccount_DiemAccount_key_rotation_capability))) (= (ControlFlow 0 371313) 371347))) inline$$Option_Option_$unpack_ref$0$Entry_correct))))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 371191) 371313)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 371185) 371191)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct  (=> (and (not $abort_flag@126) (= (ControlFlow 0 371195) 371185)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (and (= $abort_flag@126 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 371152) 372044) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 371152) 371195) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct)))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 371150) 371152)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)))) (and (= $abort_flag@126 $abort_flag@125) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 371098) 372044) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 371098) 371195) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct)))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| call3formal@$ret0@0@@9)) (and (=> (= (ControlFlow 0 371068) 371150) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 371068) 371098) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 371062) (- 0 450845)) true) (=> (= (ControlFlow 0 371062) 371068) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$1$$t2@1) (= (ControlFlow 0 371158) 371062)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 370947) 370657)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 370957) 370657) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$1$$t2@1)) (= $abort_code@98 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 370941) 370957) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 370941) 370947) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Else_correct  (=> (not $abort_flag@125) (and (=> (= (ControlFlow 0 370929) 371158) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 370929) 370941) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct  (=> (not $abort_flag@124) (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t13@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@125)) (and (=> $abort_flag@125 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@125) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 370923) 372064) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 370923) 370929) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct  (=> (and $abort_flag@124 (= (ControlFlow 0 372084) 370657)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_exists_at_$def$1$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 370879) 372084) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 370879) 370923) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon6_Then_correct  (and (=> (= (ControlFlow 0 370889) 372084) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 370889) 370923) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$1$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@9)))) (and (=> (= (ControlFlow 0 370873) 370889) inline$$DiemAccount_exists_at_$def$1$anon6_Then_correct) (=> (= (ControlFlow 0 370873) 370879) inline$$DiemAccount_exists_at_$def$1$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 370827) 370873)) inline$$DiemAccount_exists_at_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$1$anon5_Then_correct  (=> (= (ControlFlow 0 370897) 370873) inline$$DiemAccount_exists_at_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$1$anon0_correct  (=> (not $abort_flag@124) (and (=> (= (ControlFlow 0 370821) 370897) inline$$DiemAccount_exists_at_$def$1$anon5_Then_correct) (=> (= (ControlFlow 0 370821) 370827) inline$$DiemAccount_exists_at_$def$1$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$1$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@9) (= (ControlFlow 0 370903) 370821)) inline$$DiemAccount_exists_at_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Not$14$dst@1) (= (ControlFlow 0 370911) 370903)) inline$$DiemAccount_exists_at$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 370649) 370657)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 370665) 370657) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$14$dst@1)) (= $abort_code@96 (|i#$Integer| call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 370643) 370665) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 370643) 370649) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Else_correct  (=> (not $abort_flag@124) (and (=> (= (ControlFlow 0 370631) 370911) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 370631) 370643) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t10@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@124)) (and (=> $abort_flag@124 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@124) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@11) (>= (|i#$Integer| call3formal@$ret0@0@@11) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@11) $MAX_U64))) (and (=> (= (ControlFlow 0 370625) 372088) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 370625) 370631) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Else_correct)))))
(let ((inline$$Not$14$anon0_correct  (=> (and (= inline$$Not$14$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2)))) (= (ControlFlow 0 370613) 370625)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else$1_correct)))
(let ((inline$$Not$14$Entry_correct  (and (=> (= (ControlFlow 0 370603) (- 0 450543)) true) (=> (= (ControlFlow 0 370603) 370613) inline$$Not$14$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct  (=> (and (not $abort_flag@123) (= (ControlFlow 0 370619) 370603)) inline$$Not$14$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct  (=> (and $abort_flag@123 (= (ControlFlow 0 372108) 370657)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct  (=> (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 call4formal@$ret0@0@@2) (= $abort_flag@123 $abort_flag@122)) (and (=> (= (ControlFlow 0 370469) 372108) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 370469) 370619) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 370467) 370469)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Then_correct  (=> (= (ControlFlow 0 370477) 370469) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Else_correct  (=> (not $abort_flag@122) (and (=> (= (ControlFlow 0 370461) 370477) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 370461) 370467) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct  (=> (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1 $Error) (=> (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1) (= $abort_flag@123 true)) (and (=> (= (ControlFlow 0 370210) 372108) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 370210) 370619) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 370527) 370210)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 370537) 370210) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Then_correct  (=> $abort_flag@120 (and (=> (= (ControlFlow 0 370521) 370537) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 370521) 370527) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 370507) 370210)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 370517) 370210) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct  (=> $abort_flag@121 (and (=> (= (ControlFlow 0 370501) 370517) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 370501) 370507) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 370487) 370210)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 370497) 370210) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Then_correct  (=> $abort_flag@122 (and (=> (= (ControlFlow 0 370481) 370497) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 370481) 370487) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else$1_correct  (=> (= call0formal@$tv0@0@@6 $DiemAccount_KeyRotationCapability_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@122) (=> $abort_flag@122 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@122) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@2 ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$3$dst@1)) $Option_Option_vec)) ($Integer 0))))))) ((_ is $Boolean) call4formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 370453) 370481) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 370453) 370461) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Else_correct))))))
(let ((inline$$GetFieldFromValue$3$anon0_correct  (=> (and (= inline$$GetFieldFromValue$3$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$1$dst@2)) $DiemAccount_DiemAccount_key_rotation_capability)) (= (ControlFlow 0 370445) 370453)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else$1_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct  (=> (and (not $abort_flag@121) (= (ControlFlow 0 370451) 370445)) inline$$GetFieldFromValue$3$anon0_correct)))
(let ((inline$$GetGlobal$1$anon3_Then$1_correct  (=> (and (= $abort_flag@121 true) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 370391) 370501) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 370391) 370451) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$GetGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$GetGlobal$1$a@1)) (= (ControlFlow 0 370389) 370391)) inline$$GetGlobal$1$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$1$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$GetGlobal$1$a@1) (= inline$$GetGlobal$1$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@9)))) (and (= $abort_flag@121 $abort_flag@120) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 370337) 370501) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 370337) 370451) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$GetGlobal$1$anon0_correct  (=> (= inline$$GetGlobal$1$a@1 (|a#$Address| call3formal@$ret0@0@@9)) (and (=> (= (ControlFlow 0 370319) 370389) inline$$GetGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 370319) 370337) inline$$GetGlobal$1$anon3_Else_correct)))))
(let ((inline$$GetGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 370313) (- 0 450292)) true) (=> (= (ControlFlow 0 370313) 370319) inline$$GetGlobal$1$anon0_correct))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1) (= (ControlFlow 0 370397) 370313)) inline$$GetGlobal$1$Entry_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 370202) 370210)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 370218) 370210) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1)) (= $abort_code@93 (|i#$Integer| call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 370196) 370218) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 370196) 370202) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Else_correct  (=> (not $abort_flag@120) (and (=> (= (ControlFlow 0 370184) 370397) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 370184) 370196) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct  (=> (not $abort_flag@119) (=> (and (and (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@120)) (and (=> $abort_flag@120 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@120) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 370178) 370521) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 370178) 370184) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct  (=> (and $abort_flag@119 (= (ControlFlow 0 370541) 370210)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 370134) 370541) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 370134) 370178) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 370144) 370541) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 370144) 370178) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@9)))) (and (=> (= (ControlFlow 0 370128) 370144) inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 370128) 370134) inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 370082) 370128)) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 370152) 370128) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon0_correct  (=> (not $abort_flag@119) (and (=> (= (ControlFlow 0 370076) 370152) inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 370076) 370082) inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@9) (= (ControlFlow 0 370158) 370076)) inline$$DiemAccount_exists_at_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 369890) 370158)) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 370549) 370158) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon0_correct  (=> (not $abort_flag@119) (and (=> (= (ControlFlow 0 369884) 370549) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 369884) 369890) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@9) (= (ControlFlow 0 370555) 369884)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@119) (= (ControlFlow 0 370563) 370555)) inline$$DiemAccount_delegated_key_rotation_capability$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@119) (=> $abort_flag@119 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@119) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 369474) 372112) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 369474) 370563) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 369438) 369474)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 372136) 369474) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon0_correct  (=> (not $abort_flag@118) (and (=> (= (ControlFlow 0 369432) 372136) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 369432) 369438) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 372142) 369432)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon90_Else_correct  (=> (and (not $abort_flag@118) (= (ControlFlow 0 372150) 372142)) inline$$DiemAccount_extract_key_rotation_capability_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon90_Then_correct true))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon41_Else_correct  (=> (and (not $abort_flag@117) (= $abort_flag@118 $abort_flag@117)) (and (=> (= (ControlFlow 0 368634) 388280) inline$$Genesis_initialize_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 368634) 372150) inline$$Genesis_initialize_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct  (=> (= $abort_flag@118 true) (and (=> (= (ControlFlow 0 368060) 388280) inline$$Genesis_initialize_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 368060) 372150) inline$$Genesis_initialize_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 368728) 368060)) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon31_Then_correct  (=> (= (ControlFlow 0 368738) 368060) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon30_Then_correct  (=> $abort_flag@113 (and (=> (= (ControlFlow 0 368722) 368738) inline$$DiemBlock_initialize_block_metadata_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 368722) 368728) inline$$DiemBlock_initialize_block_metadata_$def$0$anon31_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 368708) 368060)) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon33_Then_correct  (=> (= (ControlFlow 0 368718) 368060) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon32_Then_correct  (=> $abort_flag@114 (and (=> (= (ControlFlow 0 368702) 368718) inline$$DiemBlock_initialize_block_metadata_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 368702) 368708) inline$$DiemBlock_initialize_block_metadata_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 368684) 368060)) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 368694) 368060) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon35_Then_correct  (=> $abort_flag@116 (and (=> (= (ControlFlow 0 368678) 368694) inline$$DiemBlock_initialize_block_metadata_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 368678) 368684) inline$$DiemBlock_initialize_block_metadata_$def$0$anon36_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 368664) 368060)) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 368674) 368060) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon39_Then_correct  (=> $abort_flag@116 (and (=> (= (ControlFlow 0 368658) 368674) inline$$DiemBlock_initialize_block_metadata_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 368658) 368664) inline$$DiemBlock_initialize_block_metadata_$def$0$anon40_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 368644) 368060)) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 368654) 368060) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon41_Then_correct  (=> $abort_flag@117 (and (=> (= (ControlFlow 0 368638) 368654) inline$$DiemBlock_initialize_block_metadata_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 368638) 368644) inline$$DiemBlock_initialize_block_metadata_$def$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$11$anon3_Then$1_correct  (=> (= $abort_flag@117 true) (and (=> (= (ControlFlow 0 368612) 368638) inline$$DiemBlock_initialize_block_metadata_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 368612) 368634) inline$$DiemBlock_initialize_block_metadata_$def$0$anon41_Else_correct)))))
(let ((inline$$MoveToRaw$11$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$MoveTo$11$a@1) (= (ControlFlow 0 368610) 368612)) inline$$MoveToRaw$11$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$11$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$MoveTo$11$a@1)) (=> (and (= |inline$$MoveToRaw$11$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$MoveTo$11$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$MoveTo$11$a@1 inline$$DiemBlock_BlockMetadata_pack$0$$struct@1))) (= $abort_flag@117 $abort_flag@116)) (and (=> (= (ControlFlow 0 368560) 368638) inline$$DiemBlock_initialize_block_metadata_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 368560) 368634) inline$$DiemBlock_initialize_block_metadata_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$11$anon0$1_correct  (=> (= inline$$MoveTo$11$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 368618) 368610) inline$$MoveToRaw$11$anon3_Then_correct) (=> (= (ControlFlow 0 368618) 368560) inline$$MoveToRaw$11$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$11$Entry_correct  (and (=> (= (ControlFlow 0 368406) (- 0 449713)) true) (=> (= (ControlFlow 0 368406) 368618) inline$$MoveTo$11$anon0$1_correct))))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 368292) 368406)) inline$$Signer_borrow_address$11$Entry_correct)))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 368298) 368406) inline$$Signer_borrow_address$11$Entry_correct)))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 368286) 368298) inline$$DiemBlock_BlockMetadata_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 368286) 368292) inline$$DiemBlock_BlockMetadata_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 368278) 368406)) inline$$Signer_borrow_address$11$Entry_correct)))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$DiemBlock_initialize_block_metadata_$def$0$$t8@1) (>= (|i#$Integer| inline$$DiemBlock_initialize_block_metadata_$def$0$$t8@1) 0)) (<= (|i#$Integer| inline$$DiemBlock_initialize_block_metadata_$def$0$$t8@1) $MAX_U64)) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$12$res@0) (let ((va@@37 (|v#$Vector| inline$$Event_new_event_handle$12$res@0)))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_guid)) (let ((va@@38 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_guid))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$12$res@0)) $Event_EventHandle_guid))) $$0@@3))
))) true) (= inline$$DiemBlock_BlockMetadata_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemBlock_initialize_block_metadata_$def$0$$t8@1) 1 inline$$Event_new_event_handle$12$res@0) 2)))) (and (=> (= (ControlFlow 0 368270) 368286) inline$$DiemBlock_BlockMetadata_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 368270) 368278) inline$$DiemBlock_BlockMetadata_pack$0$anon3_Else_correct))))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon39_Else_correct  (=> (and (not $abort_flag@116) (= (ControlFlow 0 368304) 368270)) inline$$DiemBlock_BlockMetadata_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$12$Entry_correct  (=> (= inline$$Event_new_event_handle$12$t@0 $DiemBlock_NewBlockEvent_type_value) (and (=> (= (ControlFlow 0 368104) 368658) inline$$DiemBlock_initialize_block_metadata_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 368104) 368304) inline$$DiemBlock_initialize_block_metadata_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon37_Then_correct  (=> (|b#$Boolean| inline$$Not$13$dst@1) (=> (and (= inline$$DiemBlock_initialize_block_metadata_$def$0$$t8@1 ($Integer 0)) (= (ControlFlow 0 368112) 368104)) inline$$Event_new_event_handle$12$Entry_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 368054) 368060)) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 368068) 368060) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$13$dst@1)) (= $abort_code@90 (|i#$Integer| call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 368048) 368068) inline$$DiemBlock_initialize_block_metadata_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 368048) 368054) inline$$DiemBlock_initialize_block_metadata_$def$0$anon38_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon35_Else_correct  (=> (not $abort_flag@116) (and (=> (= (ControlFlow 0 368036) 368112) inline$$DiemBlock_initialize_block_metadata_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 368036) 368048) inline$$DiemBlock_initialize_block_metadata_$def$0$anon37_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon34_Else$1_correct  (=> (and (and (and (= inline$$DiemBlock_initialize_block_metadata_$def$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@116)) (and (=> $abort_flag@116 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@116) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@13) (>= (|i#$Integer| call3formal@$ret0@0@@13) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@13) $MAX_U64))) (and (=> (= (ControlFlow 0 368030) 368678) inline$$DiemBlock_initialize_block_metadata_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 368030) 368036) inline$$DiemBlock_initialize_block_metadata_$def$0$anon35_Else_correct)))))
(let ((inline$$Not$13$anon0_correct  (=> (and (= inline$$Not$13$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemBlock_is_initialized_$def$0$$ret0@2)))) (= (ControlFlow 0 368018) 368030)) inline$$DiemBlock_initialize_block_metadata_$def$0$anon34_Else$1_correct)))
(let ((inline$$Not$13$Entry_correct  (and (=> (= (ControlFlow 0 368008) (- 0 449474)) true) (=> (= (ControlFlow 0 368008) 368018) inline$$Not$13$anon0_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon34_Else_correct  (=> (and (not $abort_flag@115) (= (ControlFlow 0 368024) 368008)) inline$$Not$13$Entry_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon34_Then_correct  (=> (and $abort_flag@115 (= (ControlFlow 0 368698) 368060)) inline$$DiemBlock_initialize_block_metadata_$def$0$Abort_correct)))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon4_correct  (=> (and (= $abort_flag@115 $abort_flag@114) (= inline$$DiemBlock_is_initialized_$def$0$$ret0@2 inline$$DiemBlock_is_initialized_$def$0$$t1@1)) (and (=> (= (ControlFlow 0 367938) 368698) inline$$DiemBlock_initialize_block_metadata_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 367938) 368024) inline$$DiemBlock_initialize_block_metadata_$def$0$anon34_Else_correct)))))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 367936) 367938)) inline$$DiemBlock_is_initialized_$def$0$anon4_correct)))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 367946) 367938) inline$$DiemBlock_is_initialized_$def$0$anon4_correct)))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon5_Else_correct  (=> (and (not $abort_flag@114) (= inline$$DiemBlock_is_initialized_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$3$$t0@1))))) (and (=> (= (ControlFlow 0 367930) 367946) inline$$DiemBlock_is_initialized_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 367930) 367936) inline$$DiemBlock_is_initialized_$def$0$anon6_Else_correct)))))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon5_Then_correct  (=> (and (and $abort_flag@114 (= inline$$DiemBlock_is_initialized_$def$0$$ret0@1 $Error)) (and (= $abort_flag@115 true) (= inline$$DiemBlock_is_initialized_$def$0$$ret0@2 inline$$DiemBlock_is_initialized_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 367954) 368698) inline$$DiemBlock_initialize_block_metadata_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 367954) 368024) inline$$DiemBlock_initialize_block_metadata_$def$0$anon34_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$3$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 367888) 367954) inline$$DiemBlock_is_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 367888) 367930) inline$$DiemBlock_is_initialized_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$3$anon3_Then_correct  (and (=> (= (ControlFlow 0 367898) 367954) inline$$DiemBlock_is_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 367898) 367930) inline$$DiemBlock_is_initialized_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$3$anon0_correct  (=> (and (not $abort_flag@114) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$3$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 367882) 367898) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$3$anon3_Then_correct) (=> (= (ControlFlow 0 367882) 367888) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$3$anon3_Else_correct)))))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon0_correct  (=> (and (not $abort_flag@114) (= (ControlFlow 0 367912) 367882)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$3$anon0_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon32_Else_correct  (=> (and (not $abort_flag@114) (= (ControlFlow 0 367968) 367912)) inline$$DiemBlock_is_initialized_$def$0$anon0_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon30_Else_correct  (=> (and (and (not $abort_flag@113) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@114)) (and (=> $abort_flag@114 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@114 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@88 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 367652) 368702) inline$$DiemBlock_initialize_block_metadata_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 367652) 367968) inline$$DiemBlock_initialize_block_metadata_$def$0$anon32_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@113) (=> (and (=> $abort_flag@113 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@113 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@87 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 367646) 368722) inline$$DiemBlock_initialize_block_metadata_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 367646) 367652) inline$$DiemBlock_initialize_block_metadata_$def$0$anon30_Else_correct))))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 367610) 367646)) inline$$DiemBlock_initialize_block_metadata_$def$0$anon2$1_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 368746) 367646) inline$$DiemBlock_initialize_block_metadata_$def$0$anon2$1_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def$0$anon0_correct  (=> (not $abort_flag@112) (and (=> (= (ControlFlow 0 367604) 368746) inline$$DiemBlock_initialize_block_metadata_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 367604) 367610) inline$$DiemBlock_initialize_block_metadata_$def$0$anon29_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 368750) 367604)) inline$$DiemBlock_initialize_block_metadata_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon89_Else_correct  (=> (and (not $abort_flag@112) (= (ControlFlow 0 368756) 368750)) inline$$DiemBlock_initialize_block_metadata_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon89_Then_correct true))
(let ((inline$$DualAttestation_initialize_$def$0$anon77_Else_correct  (=> (and (not $abort_flag@111) (= $abort_flag@112 $abort_flag@111)) (and (=> (= (ControlFlow 0 366902) 388284) inline$$Genesis_initialize_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 366902) 368756) inline$$Genesis_initialize_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$Abort_correct  (=> (= $abort_flag@112 true) (and (=> (= (ControlFlow 0 364912) 388284) inline$$Genesis_initialize_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 364912) 368756) inline$$Genesis_initialize_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 367088) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 367098) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon54_Then_correct  (=> $abort_flag@100 (and (=> (= (ControlFlow 0 367082) 367098) inline$$DualAttestation_initialize_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 367082) 367088) inline$$DualAttestation_initialize_$def$0$anon55_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 367068) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 367078) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon56_Then_correct  (=> $abort_flag@101 (and (=> (= (ControlFlow 0 367062) 367078) inline$$DualAttestation_initialize_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 367062) 367068) inline$$DualAttestation_initialize_$def$0$anon57_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 367044) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon60_Then_correct  (=> (= (ControlFlow 0 367054) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon59_Then_correct  (=> $abort_flag@102 (and (=> (= (ControlFlow 0 367038) 367054) inline$$DualAttestation_initialize_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 367038) 367044) inline$$DualAttestation_initialize_$def$0$anon60_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 367024) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon64_Then_correct  (=> (= (ControlFlow 0 367034) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon63_Then_correct  (=> $abort_flag@103 (and (=> (= (ControlFlow 0 367018) 367034) inline$$DualAttestation_initialize_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 367018) 367024) inline$$DualAttestation_initialize_$def$0$anon64_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 367000) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon67_Then_correct  (=> (= (ControlFlow 0 367010) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon66_Then_correct  (=> $abort_flag@107 (and (=> (= (ControlFlow 0 366994) 367010) inline$$DualAttestation_initialize_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 366994) 367000) inline$$DualAttestation_initialize_$def$0$anon67_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 366980) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon69_Then_correct  (=> (= (ControlFlow 0 366990) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon68_Then_correct  (=> $abort_flag@108 (and (=> (= (ControlFlow 0 366974) 366990) inline$$DualAttestation_initialize_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 366974) 366980) inline$$DualAttestation_initialize_$def$0$anon69_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 366952) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon72_Then_correct  (=> (= (ControlFlow 0 366962) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon71_Then_correct  (=> $abort_flag@109 (and (=> (= (ControlFlow 0 366946) 366962) inline$$DualAttestation_initialize_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 366946) 366952) inline$$DualAttestation_initialize_$def$0$anon72_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 366932) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon76_Then_correct  (=> (= (ControlFlow 0 366942) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon75_Then_correct  (=> $abort_flag@110 (and (=> (= (ControlFlow 0 366926) 366942) inline$$DualAttestation_initialize_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 366926) 366932) inline$$DualAttestation_initialize_$def$0$anon76_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 366912) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon78_Then_correct  (=> (= (ControlFlow 0 366922) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon77_Then_correct  (=> $abort_flag@111 (and (=> (= (ControlFlow 0 366906) 366922) inline$$DualAttestation_initialize_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 366906) 366912) inline$$DualAttestation_initialize_$def$0$anon78_Else_correct)))))
(let ((inline$$MoveToRaw$10$anon3_Then$1_correct  (=> (= $abort_flag@111 true) (and (=> (= (ControlFlow 0 366880) 366906) inline$$DualAttestation_initialize_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 366880) 366902) inline$$DualAttestation_initialize_$def$0$anon77_Else_correct)))))
(let ((inline$$MoveToRaw$10$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$MoveTo$10$a@1) (= (ControlFlow 0 366878) 366880)) inline$$MoveToRaw$10$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$10$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$MoveTo$10$a@1)) (=> (and (= |inline$$MoveToRaw$10$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$MoveTo$10$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray inline$$MoveTo$10$a@1 inline$$DualAttestation_Limit_pack$0$$struct@1))) (= $abort_flag@111 $abort_flag@110)) (and (=> (= (ControlFlow 0 366828) 366906) inline$$DualAttestation_initialize_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 366828) 366902) inline$$DualAttestation_initialize_$def$0$anon77_Else_correct))))))
(let ((inline$$MoveTo$10$anon0$1_correct  (=> (= inline$$MoveTo$10$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 366886) 366878) inline$$MoveToRaw$10$anon3_Then_correct) (=> (= (ControlFlow 0 366886) 366828) inline$$MoveToRaw$10$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$10$Entry_correct  (and (=> (= (ControlFlow 0 366674) (- 0 448895)) true) (=> (= (ControlFlow 0 366674) 366886) inline$$MoveTo$10$anon0$1_correct))))
(let ((inline$$DualAttestation_Limit_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 366560) 366674)) inline$$Signer_borrow_address$10$Entry_correct)))
(let ((inline$$DualAttestation_Limit_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 366566) 366674) inline$$Signer_borrow_address$10$Entry_correct)))
(let ((inline$$DualAttestation_Limit_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 366554) 366566) inline$$DualAttestation_Limit_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 366554) 366560) inline$$DualAttestation_Limit_pack$0$anon4_Else_correct)))))
(let ((inline$$DualAttestation_Limit_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 366546) 366674)) inline$$Signer_borrow_address$10$Entry_correct)))
(let ((inline$$DualAttestation_Limit_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$CastU64$0$dst@1) (>= (|i#$Integer| inline$$CastU64$0$dst@1) 0)) (<= (|i#$Integer| inline$$CastU64$0$dst@1) $MAX_U64)) (= inline$$DualAttestation_Limit_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$CastU64$0$dst@1) 1)))) (and (=> (= (ControlFlow 0 366538) 366554) inline$$DualAttestation_Limit_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 366538) 366546) inline$$DualAttestation_Limit_pack$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon75_Else_correct  (=> (and (not $abort_flag@110) (= (ControlFlow 0 366572) 366538)) inline$$DualAttestation_Limit_pack$0$anon0_correct)))
(let ((inline$$CastU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@110 true) (= inline$$CastU64$0$dst@1 inline$$CastU64$0$dst@0)) (and (=> (= (ControlFlow 0 366400) 366926) inline$$DualAttestation_initialize_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 366400) 366572) inline$$DualAttestation_initialize_$def$0$anon75_Else_correct)))))
(let ((inline$$CastU64$0$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$MulU128$0$dst@2) $MAX_U64) (= (ControlFlow 0 366398) 366400)) inline$$CastU64$0$anon3_Then$1_correct)))
(let ((inline$$CastU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (|i#$Integer| inline$$MulU128$0$dst@2)) (=> (and (= $abort_flag@110 $abort_flag@109) (= inline$$CastU64$0$dst@1 inline$$MulU128$0$dst@2)) (and (=> (= (ControlFlow 0 366348) 366926) inline$$DualAttestation_initialize_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 366348) 366572) inline$$DualAttestation_initialize_$def$0$anon75_Else_correct))))))
(let ((inline$$CastU64$0$Entry_correct  (and (=> (= (ControlFlow 0 366334) (- 0 448751)) true) (and (=> (= (ControlFlow 0 366334) 366398) inline$$CastU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 366334) 366348) inline$$CastU64$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon73_Then_correct  (=> (and (|b#$Boolean| inline$$Le$2$dst@1) (= (ControlFlow 0 366406) 366334)) inline$$CastU64$0$Entry_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 366253) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon74_Then_correct  (=> (= (ControlFlow 0 366263) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon73_Else_correct  (=> (and (not (|b#$Boolean| inline$$Le$2$dst@1)) (= $abort_code@86 (|i#$Integer| call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 366247) 366263) inline$$DualAttestation_initialize_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 366247) 366253) inline$$DualAttestation_initialize_$def$0$anon74_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon71_Else_correct  (=> (not $abort_flag@109) (and (=> (= (ControlFlow 0 366235) 366406) inline$$DualAttestation_initialize_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 366235) 366247) inline$$DualAttestation_initialize_$def$0$anon73_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon36$1_correct  (=> (and (and (and (= inline$$DualAttestation_initialize_$def$0$$t18@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@109)) (and (=> $abort_flag@109 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@109) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@14) (>= (|i#$Integer| call3formal@$ret0@0@@14) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@14) $MAX_U64))) (and (=> (= (ControlFlow 0 366229) 366946) inline$$DualAttestation_initialize_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 366229) 366235) inline$$DualAttestation_initialize_$def$0$anon71_Else_correct)))))
(let ((inline$$Le$2$anon0_correct  (=> (and (= inline$$Le$2$dst@1 ($Boolean (<= (|i#$Integer| inline$$MulU128$0$dst@2) (|i#$Integer| inline$$DualAttestation_initialize_$def$0$$t16@1)))) (= (ControlFlow 0 366217) 366229)) inline$$DualAttestation_initialize_$def$0$anon36$1_correct)))
(let ((inline$$Le$2$Entry_correct  (and (=> (= (ControlFlow 0 366203) (- 0 448629)) true) (=> (= (ControlFlow 0 366203) 366217) inline$$Le$2$anon0_correct))))
(let ((inline$$DualAttestation_initialize_$def$0$anon36_correct  (=> (and (= inline$$DualAttestation_initialize_$def$0$$t16@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 366223) 366203)) inline$$Le$2$Entry_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 366155) 366223)) inline$$DualAttestation_initialize_$def$0$anon36_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon70_Then_correct  (=> (= (ControlFlow 0 366970) 366223) inline$$DualAttestation_initialize_$def$0$anon36_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon68_Else_correct  (=> (not $abort_flag@108) (and (=> (= (ControlFlow 0 366149) 366970) inline$$DualAttestation_initialize_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 366149) 366155) inline$$DualAttestation_initialize_$def$0$anon70_Else_correct)))))
(let ((inline$$MulU128$0$anon3_Then$1_correct  (=> (and (= $abort_flag@108 true) (= inline$$MulU128$0$dst@2 inline$$MulU128$0$dst@0)) (and (=> (= (ControlFlow 0 366135) 366974) inline$$DualAttestation_initialize_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 366135) 366149) inline$$DualAttestation_initialize_$def$0$anon68_Else_correct)))))
(let ((inline$$MulU128$0$anon3_Then_correct  (=> (and (> (* (|i#$Integer| inline$$CastU128$0$dst@1) (|i#$Integer| inline$$CastU128$1$dst@1)) $MAX_U128) (= (ControlFlow 0 366133) 366135)) inline$$MulU128$0$anon3_Then$1_correct)))
(let ((inline$$MulU128$0$anon3_Else_correct  (=> (and (and (>= $MAX_U128 (* (|i#$Integer| inline$$CastU128$0$dst@1) (|i#$Integer| inline$$CastU128$1$dst@1))) (= inline$$MulU128$0$dst@1 ($Integer (* (|i#$Integer| inline$$CastU128$0$dst@1) (|i#$Integer| inline$$CastU128$1$dst@1))))) (and (= $abort_flag@108 $abort_flag@107) (= inline$$MulU128$0$dst@2 inline$$MulU128$0$dst@1))) (and (=> (= (ControlFlow 0 366077) 366974) inline$$DualAttestation_initialize_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 366077) 366149) inline$$DualAttestation_initialize_$def$0$anon68_Else_correct)))))
(let ((inline$$MulU128$0$Entry_correct  (and (=> (= (ControlFlow 0 366047) (- 0 448519)) true) (and (=> (= (ControlFlow 0 366047) 366133) inline$$MulU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 366047) 366077) inline$$MulU128$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon66_Else_correct  (=> (and (not $abort_flag@107) (= (ControlFlow 0 366141) 366047)) inline$$MulU128$0$Entry_correct)))
(let ((inline$$CastU128$1$anon3_Then$1_correct  (=> (and (= $abort_flag@107 true) (= inline$$CastU128$1$dst@1 inline$$CastU128$1$dst@0)) (and (=> (= (ControlFlow 0 365942) 366994) inline$$DualAttestation_initialize_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 365942) 366141) inline$$DualAttestation_initialize_$def$0$anon66_Else_correct)))))
(let ((inline$$CastU128$1$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2) $MAX_U128) (= (ControlFlow 0 365940) 365942)) inline$$CastU128$1$anon3_Then$1_correct)))
(let ((inline$$CastU128$1$anon3_Else_correct  (=> (>= $MAX_U128 (|i#$Integer| inline$$Diem_scaling_factor_$def$0$$ret0@2)) (=> (and (= $abort_flag@107 $abort_flag@106) (= inline$$CastU128$1$dst@1 inline$$Diem_scaling_factor_$def$0$$ret0@2)) (and (=> (= (ControlFlow 0 365890) 366994) inline$$DualAttestation_initialize_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 365890) 366141) inline$$DualAttestation_initialize_$def$0$anon66_Else_correct))))))
(let ((inline$$CastU128$1$Entry_correct  (and (=> (= (ControlFlow 0 365876) (- 0 448454)) true) (and (=> (= (ControlFlow 0 365876) 365940) inline$$CastU128$1$anon3_Then_correct) (=> (= (ControlFlow 0 365876) 365890) inline$$CastU128$1$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon65_Else_correct  (=> (and (not $abort_flag@106) (= (ControlFlow 0 365948) 365876)) inline$$CastU128$1$Entry_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon65_Then_correct  (=> (and $abort_flag@106 (= (ControlFlow 0 367014) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$Abort_correct  (=> (= inline$$Diem_scaling_factor_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@106 true) (= inline$$Diem_scaling_factor_$def$0$$ret0@2 inline$$Diem_scaling_factor_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 365757) 367014) inline$$DualAttestation_initialize_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 365757) 365948) inline$$DualAttestation_initialize_$def$0$anon65_Else_correct))))))
(let ((inline$$Diem_scaling_factor_$def$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 365779) 365757)) inline$$Diem_scaling_factor_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon14_Then_correct  (=> (= (ControlFlow 0 365789) 365757) inline$$Diem_scaling_factor_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon13_Then_correct  (=> $abort_flag@104 (and (=> (= (ControlFlow 0 365773) 365789) inline$$Diem_scaling_factor_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 365773) 365779) inline$$Diem_scaling_factor_$def$0$anon14_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 365749) 365757)) inline$$Diem_scaling_factor_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 365765) 365757) inline$$Diem_scaling_factor_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon16_Then_correct  (=> $abort_flag@105 (and (=> (= (ControlFlow 0 365743) 365765) inline$$Diem_scaling_factor_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 365743) 365749) inline$$Diem_scaling_factor_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon15_Then_correct  (=> (and $abort_flag@104 (= (ControlFlow 0 365769) 365757)) inline$$Diem_scaling_factor_$def$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon12_correct  (=> (and (= $abort_flag@106 $abort_flag@105) (= inline$$Diem_scaling_factor_$def$0$$ret0@2 inline$$GetFieldFromValue$2$dst@1)) (and (=> (= (ControlFlow 0 365731) 367014) inline$$DualAttestation_initialize_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 365731) 365948) inline$$DualAttestation_initialize_$def$0$anon65_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 365729) 365731)) inline$$Diem_scaling_factor_$def$0$anon12_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 365739) 365731) inline$$Diem_scaling_factor_$def$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $Diem_CurrencyInfo_scaling_factor)) (and (=> (= (ControlFlow 0 365713) 365739) inline$$Diem_scaling_factor_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 365713) 365729) inline$$Diem_scaling_factor_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@105) (= (ControlFlow 0 365719) 365713)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@105 true) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 365659) 365743) inline$$Diem_scaling_factor_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 365659) 365719) inline$$Diem_scaling_factor_$def$0$anon16_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 365657) 365659)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1) (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@10) inline$$GetGlobal$0$ta@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1)))) (and (= $abort_flag@105 $abort_flag@104) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 365605) 365743) inline$$Diem_scaling_factor_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 365605) 365719) inline$$Diem_scaling_factor_$def$0$anon16_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 365587) 365657) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 365587) 365605) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (=> (= inline$$GetGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_scaling_factor$0$$tv0@0) 1)) (and (=> (= (ControlFlow 0 365581) (- 0 448281)) true) (=> (= (ControlFlow 0 365581) 365587) inline$$GetGlobal$0$anon0_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon15_Else_correct  (=> (and (not $abort_flag@104) (= (ControlFlow 0 365665) 365581)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 365448) 365769) inline$$Diem_scaling_factor_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 365448) 365665) inline$$Diem_scaling_factor_$def$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 365458) 365769) inline$$Diem_scaling_factor_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 365458) 365665) inline$$Diem_scaling_factor_$def$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@104) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 365442) 365458) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 365442) 365448) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def$0$anon13_Else_correct  (=> (and (not $abort_flag@104) (= (ControlFlow 0 365472) 365442)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$Diem_scaling_factor_$def$0$anon0_correct  (=> (and (and (not $abort_flag@103) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_scaling_factor$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@104)) (and (=> $abort_flag@104 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_scaling_factor$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@104 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_scaling_factor$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@84 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 365337) 365773) inline$$Diem_scaling_factor_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 365337) 365472) inline$$Diem_scaling_factor_$def$0$anon13_Else_correct)))))
(let ((inline$$Diem_scaling_factor$0$Entry_correct  (=> (and (= inline$$Diem_scaling_factor$0$$tv0@0 $XDX_XDX_type_value) (= (ControlFlow 0 365110) 365337)) inline$$Diem_scaling_factor_$def$0$anon0_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon63_Else_correct  (=> (and (not $abort_flag@103) (= (ControlFlow 0 365803) 365110)) inline$$Diem_scaling_factor$0$Entry_correct)))
(let ((inline$$CastU128$0$anon3_Then$1_correct  (=> (and (= $abort_flag@103 true) (= inline$$CastU128$0$dst@1 inline$$CastU128$0$dst@0)) (and (=> (= (ControlFlow 0 365061) 367018) inline$$DualAttestation_initialize_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 365061) 365803) inline$$DualAttestation_initialize_$def$0$anon63_Else_correct)))))
(let ((inline$$CastU128$0$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$DualAttestation_initialize_$def$0$$t12@1) $MAX_U128) (= (ControlFlow 0 365059) 365061)) inline$$CastU128$0$anon3_Then$1_correct)))
(let ((inline$$CastU128$0$anon3_Else_correct  (=> (>= $MAX_U128 (|i#$Integer| inline$$DualAttestation_initialize_$def$0$$t12@1)) (=> (and (= $abort_flag@103 $abort_flag@102) (= inline$$CastU128$0$dst@1 inline$$DualAttestation_initialize_$def$0$$t12@1)) (and (=> (= (ControlFlow 0 365009) 367018) inline$$DualAttestation_initialize_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 365009) 365803) inline$$DualAttestation_initialize_$def$0$anon63_Else_correct))))))
(let ((inline$$CastU128$0$Entry_correct  (and (=> (= (ControlFlow 0 364995) (- 0 448032)) true) (and (=> (= (ControlFlow 0 364995) 365059) inline$$CastU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 364995) 365009) inline$$CastU128$0$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon61_Then_correct  (=> (|b#$Boolean| inline$$Not$12$dst@1) (=> (and (= inline$$DualAttestation_initialize_$def$0$$t12@1 ($Integer 1000)) (= (ControlFlow 0 365067) 364995)) inline$$CastU128$0$Entry_correct))))
(let ((inline$$DualAttestation_initialize_$def$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 364906) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon62_Then_correct  (=> (= (ControlFlow 0 364920) 364912) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon61_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$12$dst@1)) (= $abort_code@83 (|i#$Integer| call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 364900) 364920) inline$$DualAttestation_initialize_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 364900) 364906) inline$$DualAttestation_initialize_$def$0$anon62_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon59_Else_correct  (=> (not $abort_flag@102) (and (=> (= (ControlFlow 0 364888) 365067) inline$$DualAttestation_initialize_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 364888) 364900) inline$$DualAttestation_initialize_$def$0$anon61_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon58_Else$1_correct  (=> (and (and (and (= inline$$DualAttestation_initialize_$def$0$$t10@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@102)) (and (=> $abort_flag@102 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@102) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@15) (>= (|i#$Integer| call3formal@$ret0@0@@15) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@15) $MAX_U64))) (and (=> (= (ControlFlow 0 364882) 367038) inline$$DualAttestation_initialize_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 364882) 364888) inline$$DualAttestation_initialize_$def$0$anon59_Else_correct)))))
(let ((inline$$Not$12$anon0_correct  (=> (and (= inline$$Not$12$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DualAttestation_initialize_$def$0$$t8@1)))) (= (ControlFlow 0 364870) 364882)) inline$$DualAttestation_initialize_$def$0$anon58_Else$1_correct)))
(let ((inline$$Not$12$Entry_correct  (and (=> (= (ControlFlow 0 364860) (- 0 447904)) true) (=> (= (ControlFlow 0 364860) 364870) inline$$Not$12$anon0_correct))))
(let ((inline$$DualAttestation_initialize_$def$0$anon58_Else_correct  (=> (not $abort_flag@101) (=> (and (= inline$$DualAttestation_initialize_$def$0$$t8@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$$t0@1)))) (= (ControlFlow 0 364876) 364860)) inline$$Not$12$Entry_correct))))
(let ((inline$$DualAttestation_initialize_$def$0$anon58_Then_correct  (=> (and $abort_flag@101 (= (ControlFlow 0 367058) 364912)) inline$$DualAttestation_initialize_$def$0$Abort_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 364788) 367058) inline$$DualAttestation_initialize_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 364788) 364876) inline$$DualAttestation_initialize_$def$0$anon58_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon3_Then_correct  (and (=> (= (ControlFlow 0 364798) 367058) inline$$DualAttestation_initialize_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 364798) 364876) inline$$DualAttestation_initialize_$def$0$anon58_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon0_correct  (=> (and (not $abort_flag@101) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 364782) 364798) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon3_Then_correct) (=> (= (ControlFlow 0 364782) 364788) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon3_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon56_Else_correct  (=> (and (not $abort_flag@101) (= (ControlFlow 0 364812) 364782)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$2$anon0_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon54_Else_correct  (=> (and (and (not $abort_flag@100) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@101)) (and (=> $abort_flag@101 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@101 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@81 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 364677) 367062) inline$$DualAttestation_initialize_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 364677) 364812) inline$$DualAttestation_initialize_$def$0$anon56_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@100) (=> (and (=> $abort_flag@100 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@100 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@80 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 364671) 367082) inline$$DualAttestation_initialize_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 364671) 364677) inline$$DualAttestation_initialize_$def$0$anon54_Else_correct))))))
(let ((inline$$DualAttestation_initialize_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 364635) 364671)) inline$$DualAttestation_initialize_$def$0$anon2$1_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 367106) 364671) inline$$DualAttestation_initialize_$def$0$anon2$1_correct)))
(let ((inline$$DualAttestation_initialize_$def$0$anon0_correct  (=> (not $abort_flag@99) (and (=> (= (ControlFlow 0 364629) 367106) inline$$DualAttestation_initialize_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 364629) 364635) inline$$DualAttestation_initialize_$def$0$anon53_Else_correct)))))
(let ((inline$$DualAttestation_initialize_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 367110) 364629)) inline$$DualAttestation_initialize_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon88_Else_correct  (=> (and (not $abort_flag@99) (= (ControlFlow 0 367116) 367110)) inline$$DualAttestation_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon88_Then_correct true))
(let ((inline$$DiemVersion_initialize_$def$0$Abort_correct  (=> (= $abort_flag@99 true) (=> (and (= $DiemConfig_DiemConfig_$memory@26 $DiemConfig_DiemConfig_$memory@25) (= $DiemConfig_ModifyConfigCapability_$memory@7 $DiemConfig_ModifyConfigCapability_$memory@6)) (and (=> (= (ControlFlow 0 363750) 388288) inline$$Genesis_initialize_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 363750) 367116) inline$$Genesis_initialize_$def_verify$0$anon88_Else_correct))))))
(let ((inline$$DiemVersion_initialize_$def$0$anon5_correct  (=> (= $DiemConfig_ModifyConfigCapability_$memory@6 $DiemConfig_ModifyConfigCapability_$memory@4) (=> (and (= $DiemConfig_DiemConfig_$memory@25 $DiemConfig_DiemConfig_$memory@23) (= (ControlFlow 0 363790) 363750)) inline$$DiemVersion_initialize_$def$0$Abort_correct))))
(let ((inline$$DiemVersion_initialize_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 363788) 363790)) inline$$DiemVersion_initialize_$def$0$anon5_correct)))
(let ((inline$$DiemVersion_initialize_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 363798) 363790) inline$$DiemVersion_initialize_$def$0$anon5_correct)))
(let ((inline$$DiemVersion_initialize_$def$0$anon16_Then_correct  (=> $abort_flag@96 (and (=> (= (ControlFlow 0 363782) 363798) inline$$DiemVersion_initialize_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 363782) 363788) inline$$DiemVersion_initialize_$def$0$anon17_Else_correct)))))
(let ((inline$$DiemVersion_initialize_$def$0$anon9_correct  (=> (= $DiemConfig_ModifyConfigCapability_$memory@6 $DiemConfig_ModifyConfigCapability_$memory@4) (=> (and (= $DiemConfig_DiemConfig_$memory@25 $DiemConfig_DiemConfig_$memory@23) (= (ControlFlow 0 363770) 363750)) inline$$DiemVersion_initialize_$def$0$Abort_correct))))
(let ((inline$$DiemVersion_initialize_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 363768) 363770)) inline$$DiemVersion_initialize_$def$0$anon9_correct)))
(let ((inline$$DiemVersion_initialize_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 363778) 363770) inline$$DiemVersion_initialize_$def$0$anon9_correct)))
(let ((inline$$DiemVersion_initialize_$def$0$anon18_Then_correct  (=> $abort_flag@97 (and (=> (= (ControlFlow 0 363762) 363778) inline$$DiemVersion_initialize_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 363762) 363768) inline$$DiemVersion_initialize_$def$0$anon19_Else_correct)))))
(let ((inline$$DiemVersion_initialize_$def$0$anon13_correct  (=> (= $DiemConfig_ModifyConfigCapability_$memory@6 $DiemConfig_ModifyConfigCapability_$memory@5) (=> (and (= $DiemConfig_DiemConfig_$memory@25 $DiemConfig_DiemConfig_$memory@24) (= (ControlFlow 0 363746) 363750)) inline$$DiemVersion_initialize_$def$0$Abort_correct))))
(let ((inline$$DiemVersion_initialize_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 363744) 363746)) inline$$DiemVersion_initialize_$def$0$anon13_correct)))
(let ((inline$$DiemVersion_initialize_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 363758) 363746) inline$$DiemVersion_initialize_$def$0$anon13_correct)))
(let ((inline$$DiemVersion_initialize_$def$0$anon20_Then_correct  (=> $abort_flag@98 (and (=> (= (ControlFlow 0 363738) 363758) inline$$DiemVersion_initialize_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 363738) 363744) inline$$DiemVersion_initialize_$def$0$anon21_Else_correct)))))
(let ((inline$$DiemVersion_initialize_$def$0$anon20_Else_correct  (=> (and (and (not $abort_flag@98) (= $abort_flag@99 $abort_flag@98)) (and (= $DiemConfig_DiemConfig_$memory@26 $DiemConfig_DiemConfig_$memory@24) (= $DiemConfig_ModifyConfigCapability_$memory@7 $DiemConfig_ModifyConfigCapability_$memory@5))) (and (=> (= (ControlFlow 0 363734) 388288) inline$$Genesis_initialize_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 363734) 367116) inline$$Genesis_initialize_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$DiemVersion_initialize_$def$0$anon18_Else$1_correct  (=> (= call0formal@$tv0@0@@7 $DiemVersion_DiemVersion_type_value) (=> (and (= call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@1 ($ConstMemoryDomain true)) (= call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@1 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 363728) (- 0 446805)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 363728) (- 0 446825)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@23) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@98) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| dr_account)))) $abort_flag@98)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@98))) (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@98) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@98)) (and (=> $abort_flag@98 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@23) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@98 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@23) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@79 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@79 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@79 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@79 (|i#$Integer| ($Integer 2))))))))) (and (and (and (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| dr_account))))) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@24) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@24) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)) inline$$DiemVersion_DiemVersion_pack$0$$struct@1)))) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@16) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@16) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@24) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@23) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@24) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@24) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@23) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@24) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@5) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@5) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@7) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 363728) 363738) inline$$DiemVersion_initialize_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 363728) 363734) inline$$DiemVersion_initialize_$def$0$anon20_Else_correct)))))))))))
(let ((inline$$DiemVersion_DiemVersion_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 363714) 363728)) inline$$DiemVersion_initialize_$def$0$anon18_Else$1_correct)))
(let ((inline$$DiemVersion_DiemVersion_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 363720) 363728) inline$$DiemVersion_initialize_$def$0$anon18_Else$1_correct)))
(let ((inline$$DiemVersion_DiemVersion_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 363708) 363720) inline$$DiemVersion_DiemVersion_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 363708) 363714) inline$$DiemVersion_DiemVersion_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemVersion_DiemVersion_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 363700) 363728)) inline$$DiemVersion_initialize_$def$0$anon18_Else$1_correct)))
(let ((inline$$DiemVersion_DiemVersion_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$DiemVersion_initialize_$def$0$$t2@1) (>= (|i#$Integer| inline$$DiemVersion_initialize_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$DiemVersion_initialize_$def$0$$t2@1) $MAX_U64)) (= inline$$DiemVersion_DiemVersion_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemVersion_initialize_$def$0$$t2@1) 1)))) (and (=> (= (ControlFlow 0 363692) 363708) inline$$DiemVersion_DiemVersion_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 363692) 363700) inline$$DiemVersion_DiemVersion_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemVersion_initialize_$def$0$anon18_Else_correct  (=> (not $abort_flag@97) (=> (and (= inline$$DiemVersion_initialize_$def$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 363726) 363692)) inline$$DiemVersion_DiemVersion_pack$0$anon0_correct))))
(let ((inline$$DiemVersion_initialize_$def$0$anon16_Else_correct  (=> (not $abort_flag@96) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@97) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@97)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@97) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@97)) (and (=> $abort_flag@97 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@97 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@78 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@78 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@78 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@78 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 363558) 363762) inline$$DiemVersion_initialize_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 363558) 363726) inline$$DiemVersion_initialize_$def$0$anon18_Else_correct)))))))
(let ((inline$$DiemVersion_initialize_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@96) (=> (and (=> $abort_flag@96 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@96 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@77 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 363552) 363782) inline$$DiemVersion_initialize_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 363552) 363558) inline$$DiemVersion_initialize_$def$0$anon16_Else_correct))))))
(let ((inline$$DiemVersion_initialize_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 363516) 363552)) inline$$DiemVersion_initialize_$def$0$anon2$1_correct)))
(let ((inline$$DiemVersion_initialize_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 363806) 363552) inline$$DiemVersion_initialize_$def$0$anon2$1_correct)))
(let ((inline$$DiemVersion_initialize_$def$0$anon0_correct  (=> (not $abort_flag@95) (and (=> (= (ControlFlow 0 363510) 363806) inline$$DiemVersion_initialize_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 363510) 363516) inline$$DiemVersion_initialize_$def$0$anon15_Else_correct)))))
(let ((inline$$DiemVersion_initialize_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 363810) 363510)) inline$$DiemVersion_initialize_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon87_Else_correct  (=> (and (not $abort_flag@95) (= (ControlFlow 0 363816) 363810)) inline$$DiemVersion_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon87_Then_correct true))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon47_Else_correct  (=> (not $abort_flag@94) (=> (and (= $DiemConfig_DiemConfig_$memory@23 $DiemConfig_DiemConfig_$memory@21) (= $abort_flag@95 $abort_flag@94)) (and (=> (= (ControlFlow 0 363045) 388292) inline$$Genesis_initialize_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 363045) 363816) inline$$Genesis_initialize_$def_verify$0$anon87_Else_correct))))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$Abort_correct  (=> (and (= $DiemConfig_DiemConfig_$memory@23 $DiemConfig_DiemConfig_$memory@22) (= $abort_flag@95 true)) (and (=> (= (ControlFlow 0 362543) 388292) inline$$Genesis_initialize_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 362543) 363816) inline$$Genesis_initialize_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon5_correct  (=> (and (= $DiemConfig_DiemConfig_$memory@22 $DiemConfig_DiemConfig_$memory@20) (= (ControlFlow 0 363161) 362543)) inline$$DiemSystem_initialize_validator_set_$def$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 363159) 363161)) inline$$DiemSystem_initialize_validator_set_$def$0$anon5_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon35_Then_correct  (=> (= (ControlFlow 0 363169) 363161) inline$$DiemSystem_initialize_validator_set_$def$0$anon5_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon34_Then_correct  (=> $abort_flag@90 (and (=> (= (ControlFlow 0 363153) 363169) inline$$DiemSystem_initialize_validator_set_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 363153) 363159) inline$$DiemSystem_initialize_validator_set_$def$0$anon35_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon9_correct  (=> (and (= $DiemConfig_DiemConfig_$memory@22 $DiemConfig_DiemConfig_$memory@20) (= (ControlFlow 0 363141) 362543)) inline$$DiemSystem_initialize_validator_set_$def$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 363139) 363141)) inline$$DiemSystem_initialize_validator_set_$def$0$anon9_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon37_Then_correct  (=> (= (ControlFlow 0 363149) 363141) inline$$DiemSystem_initialize_validator_set_$def$0$anon9_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon36_Then_correct  (=> $abort_flag@91 (and (=> (= (ControlFlow 0 363133) 363149) inline$$DiemSystem_initialize_validator_set_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 363133) 363139) inline$$DiemSystem_initialize_validator_set_$def$0$anon37_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon13_correct  (=> (and (= $DiemConfig_DiemConfig_$memory@22 $DiemConfig_DiemConfig_$memory@20) (= (ControlFlow 0 363121) 362543)) inline$$DiemSystem_initialize_validator_set_$def$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 363119) 363121)) inline$$DiemSystem_initialize_validator_set_$def$0$anon13_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 363129) 363121) inline$$DiemSystem_initialize_validator_set_$def$0$anon13_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon38_Then_correct  (=> $abort_flag@91 (and (=> (= (ControlFlow 0 363113) 363129) inline$$DiemSystem_initialize_validator_set_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 363113) 363119) inline$$DiemSystem_initialize_validator_set_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon17_correct  (=> (and (= $DiemConfig_DiemConfig_$memory@22 $DiemConfig_DiemConfig_$memory@21) (= (ControlFlow 0 363101) 362543)) inline$$DiemSystem_initialize_validator_set_$def$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 363099) 363101)) inline$$DiemSystem_initialize_validator_set_$def$0$anon17_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 363109) 363101) inline$$DiemSystem_initialize_validator_set_$def$0$anon17_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon40_Then_correct  (=> $abort_flag@92 (and (=> (= (ControlFlow 0 363093) 363109) inline$$DiemSystem_initialize_validator_set_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 363093) 363099) inline$$DiemSystem_initialize_validator_set_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon23_correct  (=> (and (= $DiemConfig_DiemConfig_$memory@22 $DiemConfig_DiemConfig_$memory@21) (= (ControlFlow 0 363077) 362543)) inline$$DiemSystem_initialize_validator_set_$def$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 363075) 363077)) inline$$DiemSystem_initialize_validator_set_$def$0$anon23_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 363085) 363077) inline$$DiemSystem_initialize_validator_set_$def$0$anon23_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon43_Then_correct  (=> $abort_flag@93 (and (=> (= (ControlFlow 0 363069) 363085) inline$$DiemSystem_initialize_validator_set_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 363069) 363075) inline$$DiemSystem_initialize_validator_set_$def$0$anon44_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon31_correct  (=> (and (= $DiemConfig_DiemConfig_$memory@22 $DiemConfig_DiemConfig_$memory@21) (= (ControlFlow 0 363057) 362543)) inline$$DiemSystem_initialize_validator_set_$def$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 363055) 363057)) inline$$DiemSystem_initialize_validator_set_$def$0$anon31_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 363065) 363057) inline$$DiemSystem_initialize_validator_set_$def$0$anon31_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon47_Then_correct  (=> $abort_flag@94 (and (=> (= (ControlFlow 0 363049) 363065) inline$$DiemSystem_initialize_validator_set_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 363049) 363055) inline$$DiemSystem_initialize_validator_set_$def$0$anon48_Else_correct)))))
(let ((inline$$MoveToRaw$9$anon3_Then$1_correct  (=> (= $abort_flag@94 true) (and (=> (= (ControlFlow 0 363023) 363049) inline$$DiemSystem_initialize_validator_set_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 363023) 363045) inline$$DiemSystem_initialize_validator_set_$def$0$anon47_Else_correct)))))
(let ((inline$$MoveToRaw$9$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$9$a@1) (= (ControlFlow 0 363021) 363023)) inline$$MoveToRaw$9$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$9$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$9$a@1)) (=> (and (= |inline$$MoveToRaw$9$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$9$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$9$a@1 inline$$DiemSystem_CapabilityHolder_pack$0$$struct@1))) (= $abort_flag@94 $abort_flag@93)) (and (=> (= (ControlFlow 0 362971) 363049) inline$$DiemSystem_initialize_validator_set_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 362971) 363045) inline$$DiemSystem_initialize_validator_set_$def$0$anon47_Else_correct))))))
(let ((inline$$MoveTo$9$anon0$1_correct  (=> (= inline$$MoveTo$9$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 363029) 363021) inline$$MoveToRaw$9$anon3_Then_correct) (=> (= (ControlFlow 0 363029) 362971) inline$$MoveToRaw$9$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$9$Entry_correct  (and (=> (= (ControlFlow 0 362817) (- 0 446065)) true) (=> (= (ControlFlow 0 362817) 363029) inline$$MoveTo$9$anon0$1_correct))))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 362703) 362817)) inline$$Signer_borrow_address$9$Entry_correct)))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 362709) 362817) inline$$Signer_borrow_address$9$Entry_correct)))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 362697) 362709) inline$$DiemSystem_CapabilityHolder_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 362697) 362703) inline$$DiemSystem_CapabilityHolder_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 362689) 362817)) inline$$Signer_borrow_address$9$Entry_correct)))
(let ((inline$$DiemSystem_CapabilityHolder_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) call7formal@$ret0@0) (let ((va@@39 (|v#$Vector| call7formal@$ret0@0)))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $DiemConfig_ModifyConfigCapability_dummy_field))) true) (= inline$$DiemSystem_CapabilityHolder_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 call7formal@$ret0@0) 1)))) (and (=> (= (ControlFlow 0 362681) 362697) inline$$DiemSystem_CapabilityHolder_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 362681) 362689) inline$$DiemSystem_CapabilityHolder_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Not$11$dst@1) (= (ControlFlow 0 362715) 362681)) inline$$DiemSystem_CapabilityHolder_pack$0$anon0_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon28_correct  (=> (and (= $DiemConfig_DiemConfig_$memory@22 $DiemConfig_DiemConfig_$memory@21) (= (ControlFlow 0 362539) 362543)) inline$$DiemSystem_initialize_validator_set_$def$0$Abort_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 362537) 362539)) inline$$DiemSystem_initialize_validator_set_$def$0$anon28_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 362551) 362539) inline$$DiemSystem_initialize_validator_set_$def$0$anon28_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$11$dst@1)) (= $abort_code@76 (|i#$Integer| call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 362531) 362551) inline$$DiemSystem_initialize_validator_set_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 362531) 362537) inline$$DiemSystem_initialize_validator_set_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon43_Else_correct  (=> (not $abort_flag@93) (and (=> (= (ControlFlow 0 362519) 362715) inline$$DiemSystem_initialize_validator_set_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 362519) 362531) inline$$DiemSystem_initialize_validator_set_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon42_Else$1_correct  (=> (and (and (and (= inline$$DiemSystem_initialize_validator_set_$def$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@93)) (and (=> $abort_flag@93 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@93) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@16) (>= (|i#$Integer| call3formal@$ret0@0@@16) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@16) $MAX_U64))) (and (=> (= (ControlFlow 0 362513) 363069) inline$$DiemSystem_initialize_validator_set_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 362513) 362519) inline$$DiemSystem_initialize_validator_set_$def$0$anon43_Else_correct)))))
(let ((inline$$Not$11$anon0_correct  (=> (and (= inline$$Not$11$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemSystem_initialize_validator_set_$def$0$$t9@1)))) (= (ControlFlow 0 362501) 362513)) inline$$DiemSystem_initialize_validator_set_$def$0$anon42_Else$1_correct)))
(let ((inline$$Not$11$Entry_correct  (and (=> (= (ControlFlow 0 362491) (- 0 445865)) true) (=> (= (ControlFlow 0 362491) 362501) inline$$Not$11$anon0_correct))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon42_Else_correct  (=> (not $abort_flag@92) (=> (and (= inline$$DiemSystem_initialize_validator_set_$def$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1)))) (= (ControlFlow 0 362507) 362491)) inline$$Not$11$Entry_correct))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon42_Then_correct  (=> $abort_flag@92 (=> (and (= $DiemConfig_DiemConfig_$memory@22 $DiemConfig_DiemConfig_$memory@21) (= (ControlFlow 0 363089) 362543)) inline$$DiemSystem_initialize_validator_set_$def$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 362419) 363089) inline$$DiemSystem_initialize_validator_set_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 362419) 362507) inline$$DiemSystem_initialize_validator_set_$def$0$anon42_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 362429) 363089) inline$$DiemSystem_initialize_validator_set_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 362429) 362507) inline$$DiemSystem_initialize_validator_set_$def$0$anon42_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@92) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 362413) 362429) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 362413) 362419) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@92) (= (ControlFlow 0 362443) 362413)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon38_Else$1_correct  (=> (= call0formal@$tv0@0@@8 $DiemSystem_DiemSystem_type_value) (and (=> (= (ControlFlow 0 362308) (- 0 445264)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_initialize_validator_set_$def$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_initialize_validator_set_$def$0$$DiemConfig_DiemConfig_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@92) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@92)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@92) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@92)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@20) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@92) (=> $abort_flag@92 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@20) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))))))))) (and (and (=> $abort_flag@92 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@74 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@74 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@74 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@74 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@20) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))))) (= $abort_code@74 (|i#$Integer| ($Integer 6)))))) (=> (not $abort_flag@92) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@21) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@92) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@2 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@21) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| addr@@2)))) $DiemConfig_DiemConfig_payload)) inline$$DiemSystem_DiemSystem_pack$0$$struct@1)))) (=> (not $abort_flag@92) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@16) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@16) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (and (and (and (and (and ((_ is $Vector) call7formal@$ret0@0) (let ((va@@40 (|v#$Vector| call7formal@$ret0@0)))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $DiemConfig_ModifyConfigCapability_dummy_field))) true) (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@21) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@20) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@21) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@21) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@20) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@21) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@8) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (= (ControlFlow 0 362308) 363093) inline$$DiemSystem_initialize_validator_set_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 362308) 362443) inline$$DiemSystem_initialize_validator_set_$def$0$anon40_Else_correct))))))))))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 362280) (- 0 445128)) (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_pack$0$$range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_pack$0$$i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_1)) inline$$DiemSystem_DiemSystem_pack$0$$i_0) (< inline$$DiemSystem_DiemSystem_pack$0$$i_0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_1)))) (let ((inline$$DiemSystem_DiemSystem_pack$0$i ($Integer inline$$DiemSystem_DiemSystem_pack$0$$i_0)))
(|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_pack$0$$range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_pack$0$$i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_3)) inline$$DiemSystem_DiemSystem_pack$0$$i_2) (< inline$$DiemSystem_DiemSystem_pack$0$$i_2 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_3)))) (let ((inline$$DiemSystem_DiemSystem_pack$0$j ($Integer inline$$DiemSystem_DiemSystem_pack$0$$i_2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_pack$0$i)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_pack$0$j)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_DiemSystem_pack$0$i inline$$DiemSystem_DiemSystem_pack$0$j))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_pack$0$$range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_pack$0$$i_0@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_1)) inline$$DiemSystem_DiemSystem_pack$0$$i_0@@0) (< inline$$DiemSystem_DiemSystem_pack$0$$i_0@@0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_1)))) (let ((inline$$DiemSystem_DiemSystem_pack$0$i ($Integer inline$$DiemSystem_DiemSystem_pack$0$$i_0@@0)))
(|b#$Boolean| ($Boolean (let ((inline$$DiemSystem_DiemSystem_pack$0$$range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators)))))))
(forall ((inline$$DiemSystem_DiemSystem_pack$0$$i_2@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_3)) inline$$DiemSystem_DiemSystem_pack$0$$i_2@@0) (< inline$$DiemSystem_DiemSystem_pack$0$$i_2@@0 (|i#$Integer| (|ub#$Range| inline$$DiemSystem_DiemSystem_pack$0$$range_3)))) (let ((inline$$DiemSystem_DiemSystem_pack$0$j ($Integer inline$$DiemSystem_DiemSystem_pack$0$$i_2@@0)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_pack$0$i)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemSystem_DiemSystem_pack$0$$struct@1)) $DiemSystem_DiemSystem_validators))) (|i#$Integer| inline$$DiemSystem_DiemSystem_pack$0$j)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemSystem_DiemSystem_pack$0$i inline$$DiemSystem_DiemSystem_pack$0$j)))))))))))))))))) (=> (= (ControlFlow 0 362280) 362308) inline$$DiemSystem_initialize_validator_set_$def$0$anon38_Else$1_correct)))))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 362294) 362280)) inline$$DiemSystem_DiemSystem_pack$0$anon3_correct)))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 362300) 362280) inline$$DiemSystem_DiemSystem_pack$0$anon3_correct)))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 362288) 362300) inline$$DiemSystem_DiemSystem_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 362288) 362294) inline$$DiemSystem_DiemSystem_pack$0$anon5_Else_correct)))))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 362154) 362280)) inline$$DiemSystem_DiemSystem_pack$0$anon3_correct)))
(let ((inline$$DiemSystem_DiemSystem_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$DiemSystem_initialize_validator_set_$def$0$$t5@1) (>= (|i#$Integer| inline$$DiemSystem_initialize_validator_set_$def$0$$t5@1) 0)) (<= (|i#$Integer| inline$$DiemSystem_initialize_validator_set_$def$0$$t5@1) $MAX_U8)) (=> (and (and (and ((_ is $Vector) inline$$Vector_empty$1$v@1) (let ((va@@41 (|v#$Vector| inline$$Vector_empty$1$v@1)))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (forall ((inline$$DiemSystem_DiemSystem_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemSystem_DiemSystem_pack$0$$$0 0) (< inline$$DiemSystem_DiemSystem_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)))) (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@46 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DiemSystem_DiemSystem_pack$0$$$0))
))) (= inline$$DiemSystem_DiemSystem_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemSystem_initialize_validator_set_$def$0$$t5@1) 1 inline$$Vector_empty$1$v@1) 2)))) (and (=> (= (ControlFlow 0 362146) 362288) inline$$DiemSystem_DiemSystem_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 362146) 362154) inline$$DiemSystem_DiemSystem_pack$0$anon4_Else_correct))))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon38_Else_correct  (=> (and (not $abort_flag@91) (= (ControlFlow 0 362306) 362146)) inline$$DiemSystem_DiemSystem_pack$0$anon0_correct)))
(let ((inline$$Vector_empty$1$anon0_correct  (=> (= inline$$Vector_empty$1$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 361779) 363113) inline$$DiemSystem_initialize_validator_set_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 361779) 362306) inline$$DiemSystem_initialize_validator_set_$def$0$anon38_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct  (=> (and (= inline$$Vector_empty$1$ta@0 $DiemSystem_ValidatorInfo_type_value) (= (ControlFlow 0 361775) 361779)) inline$$Vector_empty$1$anon0_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon36_Else_correct  (=> (not $abort_flag@91) (=> (and (= inline$$DiemSystem_initialize_validator_set_$def$0$$t5@1 ($Integer 0)) (= (ControlFlow 0 361785) 361775)) inline$$Vector_empty$1$Entry_correct))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon34_Else_correct  (=> (not $abort_flag@90) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@91) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@91)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@91) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@91)) (and (=> $abort_flag@91 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@91 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@73 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@73 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@73 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@73 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 361742) 363133) inline$$DiemSystem_initialize_validator_set_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 361742) 361785) inline$$DiemSystem_initialize_validator_set_$def$0$anon36_Else_correct)))))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@90) (=> (and (=> $abort_flag@90 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@90 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@72 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 361736) 363153) inline$$DiemSystem_initialize_validator_set_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 361736) 361742) inline$$DiemSystem_initialize_validator_set_$def$0$anon34_Else_correct))))))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon2_correct  (=> (and (= inline$$DiemSystem_initialize_validator_set_$def$0$$DiemConfig_DiemConfig_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 361734) 361736)) inline$$DiemSystem_initialize_validator_set_$def$0$anon2$1_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 361674) 361734)) inline$$DiemSystem_initialize_validator_set_$def$0$anon2_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon33_Then_correct  (=> (= (ControlFlow 0 363177) 361734) inline$$DiemSystem_initialize_validator_set_$def$0$anon2_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$def$0$anon0_correct  (=> (not $abort_flag@89) (and (=> (= (ControlFlow 0 361668) 363177) inline$$DiemSystem_initialize_validator_set_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 361668) 361674) inline$$DiemSystem_initialize_validator_set_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemSystem_initialize_validator_set_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 363181) 361668)) inline$$DiemSystem_initialize_validator_set_$def$0$anon0_correct)))
(let ((inline$$DiemSystem_initialize_validator_set_$direct_inter$0$Entry_correct  (=> (= inline$$DiemSystem_initialize_validator_set_$direct_inter$0$$DiemConfig_DiemConfig_$CallerDomain@0 ($ConstMemoryDomain true)) (and (=> (= (ControlFlow 0 361109) (- 0 444487)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_initialize_validator_set_$direct_inter$0$$DiemConfig_DiemConfig_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemSystem_initialize_validator_set_$direct_inter$0$$DiemConfig_DiemConfig_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))) (=> (= (ControlFlow 0 361109) 363181) inline$$DiemSystem_initialize_validator_set_$direct_inter$0$anon0_correct))))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon86_Else_correct  (=> (and (not $abort_flag@89) (= (ControlFlow 0 363187) 361109)) inline$$DiemSystem_initialize_validator_set_$direct_inter$0$Entry_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon86_Then_correct true))
(let ((inline$$TransactionFee_initialize_$def$0$Abort_correct  (=> (= $abort_flag@89 true) (and (=> (= (ControlFlow 0 360942) 388296) inline$$Genesis_initialize_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 360942) 363187) inline$$Genesis_initialize_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$TransactionFee_initialize_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 360972) 360942)) inline$$TransactionFee_initialize_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_initialize_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 360982) 360942) inline$$TransactionFee_initialize_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_initialize_$def$0$anon14_Then_correct  (=> $abort_flag@75 (and (=> (= (ControlFlow 0 360966) 360982) inline$$TransactionFee_initialize_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 360966) 360972) inline$$TransactionFee_initialize_$def$0$anon15_Else_correct)))))
(let ((inline$$TransactionFee_initialize_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 360952) 360942)) inline$$TransactionFee_initialize_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_initialize_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 360962) 360942) inline$$TransactionFee_initialize_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_initialize_$def$0$anon16_Then_correct  (=> $abort_flag@76 (and (=> (= (ControlFlow 0 360946) 360962) inline$$TransactionFee_initialize_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 360946) 360952) inline$$TransactionFee_initialize_$def$0$anon17_Else_correct)))))
(let ((inline$$TransactionFee_initialize_$def$0$anon18_Then_correct  (=> (and $abort_flag@88 (= (ControlFlow 0 360938) 360942)) inline$$TransactionFee_initialize_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_initialize_$def$0$anon18_Else_correct  (=> (and (not $abort_flag@88) (= $abort_flag@89 $abort_flag@88)) (and (=> (= (ControlFlow 0 360934) 388296) inline$$Genesis_initialize_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 360934) 363187) inline$$Genesis_initialize_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Else_correct  (=> (and (not $abort_flag@87) (= $abort_flag@88 $abort_flag@87)) (and (=> (= (ControlFlow 0 360836) 360938) inline$$TransactionFee_initialize_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 360836) 360934) inline$$TransactionFee_initialize_$def$0$anon18_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct  (=> (= $abort_flag@88 true) (and (=> (= (ControlFlow 0 358802) 360938) inline$$TransactionFee_initialize_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 358802) 360934) inline$$TransactionFee_initialize_$def$0$anon18_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 360898) 358802)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 360908) 358802) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon26_Then_correct  (=> $abort_flag@77 (and (=> (= (ControlFlow 0 360892) 360908) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 360892) 360898) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon27_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 360874) 358802)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 360884) 358802) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon29_Then_correct  (=> $abort_flag@79 (and (=> (= (ControlFlow 0 360868) 360884) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 360868) 360874) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon30_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 360846) 358802)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 360856) 358802) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Then_correct  (=> $abort_flag@87 (and (=> (= (ControlFlow 0 360840) 360856) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 360840) 360846) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon36_Else_correct)))))
(let ((inline$$MoveToRaw$8$anon3_Then$1_correct  (=> (= $abort_flag@87 true) (and (=> (= (ControlFlow 0 360814) 360840) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 360814) 360836) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Else_correct)))))
(let ((inline$$MoveToRaw$8$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$8$ta@0 inline$$MoveTo$8$a@1) (= (ControlFlow 0 360812) 360814)) inline$$MoveToRaw$8$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$8$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$8$ta@0 inline$$MoveTo$8$a@1)) (=> (and (= |inline$$MoveToRaw$8$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$8$ta@0 inline$$MoveTo$8$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$8$ta@0 inline$$MoveTo$8$a@1 inline$$TransactionFee_TransactionFee_pack$0$$struct@1))) (= $abort_flag@87 $abort_flag@86)) (and (=> (= (ControlFlow 0 360762) 360840) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 360762) 360836) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Else_correct))))))
(let ((inline$$MoveTo$8$anon0$1_correct  (=> (= inline$$MoveTo$8$a@1 (|a#$Address| tc_account)) (and (=> (= (ControlFlow 0 360820) 360812) inline$$MoveToRaw$8$anon3_Then_correct) (=> (= (ControlFlow 0 360820) 360762) inline$$MoveToRaw$8$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$8$Entry_correct  (and (=> (= (ControlFlow 0 360608) (- 0 444287)) true) (=> (= (ControlFlow 0 360608) 360820) inline$$MoveTo$8$anon0$1_correct))))
(let ((inline$$MoveTo$8$Entry_correct  (=> (and (= inline$$MoveTo$8$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1)) (= (ControlFlow 0 360580) 360608)) inline$$Signer_borrow_address$8$Entry_correct)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 360482) 360580)) inline$$MoveTo$8$Entry_correct)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 360488) 360580) inline$$MoveTo$8$Entry_correct)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 360476) 360488) inline$$TransactionFee_TransactionFee_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 360476) 360482) inline$$TransactionFee_TransactionFee_pack$0$anon4_Else_correct)))))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 360468) 360580)) inline$$MoveTo$8$Entry_correct)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$1$$ret0@2) (let ((va@@47 (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_create_preburn_$def$1$$ret0@2) (let ((va@@48 (|v#$Vector| inline$$Diem_create_preburn_$def$1$$ret0@2)))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$1$$ret0@2)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$1$$ret0@2)) $Diem_Preburn_to_burn)) (let ((va@@49 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$1$$ret0@2)) $Diem_Preburn_to_burn))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$1$$ret0@2)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$1$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$1$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$1$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (= inline$$TransactionFee_TransactionFee_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$ret0@2) 1 inline$$Diem_create_preburn_$def$1$$ret0@2) 2)))) (and (=> (= (ControlFlow 0 360460) 360476) inline$$TransactionFee_TransactionFee_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 360460) 360468) inline$$TransactionFee_TransactionFee_pack$0$anon3_Else_correct))))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Else_correct  (=> (and (not $abort_flag@86) (= (ControlFlow 0 360494) 360460)) inline$$TransactionFee_TransactionFee_pack$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Then_correct  (=> (and $abort_flag@86 (= (ControlFlow 0 360860) 358802)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$1$Abort_correct  (=> (= inline$$Diem_create_preburn_$def$1$$ret0@1 $Error) (=> (and (= $abort_flag@86 true) (= inline$$Diem_create_preburn_$def$1$$ret0@2 inline$$Diem_create_preburn_$def$1$$ret0@1)) (and (=> (= (ControlFlow 0 360233) 360860) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 360233) 360494) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$1$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 360263) 360233)) inline$$Diem_create_preburn_$def$1$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$1$anon17_Then_correct  (=> (= (ControlFlow 0 360273) 360233) inline$$Diem_create_preburn_$def$1$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$1$anon16_Then_correct  (=> $abort_flag@82 (and (=> (= (ControlFlow 0 360257) 360273) inline$$Diem_create_preburn_$def$1$anon17_Then_correct) (=> (= (ControlFlow 0 360257) 360263) inline$$Diem_create_preburn_$def$1$anon17_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$1$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 360243) 360233)) inline$$Diem_create_preburn_$def$1$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$1$anon19_Then_correct  (=> (= (ControlFlow 0 360253) 360233) inline$$Diem_create_preburn_$def$1$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$1$anon18_Then_correct  (=> $abort_flag@83 (and (=> (= (ControlFlow 0 360237) 360253) inline$$Diem_create_preburn_$def$1$anon19_Then_correct) (=> (= (ControlFlow 0 360237) 360243) inline$$Diem_create_preburn_$def$1$anon19_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$1$anon20_Then_correct  (=> (and $abort_flag@85 (= (ControlFlow 0 360227) 360233)) inline$$Diem_create_preburn_$def$1$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$1$anon14_correct  (=> (and (= $abort_flag@86 $abort_flag@85) (= inline$$Diem_create_preburn_$def$1$$ret0@2 inline$$Diem_Preburn_pack$1$$struct@1)) (and (=> (= (ControlFlow 0 360215) 360860) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 360215) 360494) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$1$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 360213) 360215)) inline$$Diem_create_preburn_$def$1$anon14_correct)))
(let ((inline$$Diem_create_preburn_$def$1$anon21_Then_correct  (=> (= (ControlFlow 0 360223) 360215) inline$$Diem_create_preburn_$def$1$anon14_correct)))
(let ((inline$$Diem_Preburn_pack$1$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 360191) 360223) inline$$Diem_create_preburn_$def$1$anon21_Then_correct) (=> (= (ControlFlow 0 360191) 360213) inline$$Diem_create_preburn_$def$1$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$1$anon4_Then_correct  (and (=> (= (ControlFlow 0 360197) 360223) inline$$Diem_create_preburn_$def$1$anon21_Then_correct) (=> (= (ControlFlow 0 360197) 360213) inline$$Diem_create_preburn_$def$1$anon21_Else_correct))))
(let ((inline$$Diem_Preburn_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 360185) 360197) inline$$Diem_Preburn_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 360185) 360191) inline$$Diem_Preburn_pack$1$anon4_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$1$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 360177) 360223) inline$$Diem_create_preburn_$def$1$anon21_Then_correct) (=> (= (ControlFlow 0 360177) 360213) inline$$Diem_create_preburn_$def$1$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$2$$ret0@2) (let ((va@@50 (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$Diem_Preburn_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$2$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 360169) 360185) inline$$Diem_Preburn_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 360169) 360177) inline$$Diem_Preburn_pack$1$anon3_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$1$anon20_Else_correct  (=> (and (not $abort_flag@85) (= (ControlFlow 0 360203) 360169)) inline$$Diem_Preburn_pack$1$anon0_correct)))
(let ((inline$$Diem_zero_$def$2$anon3_correct  (=> (= inline$$Diem_zero_$def$2$$ret0@1 $Error) (=> (and (= $abort_flag@85 true) (= inline$$Diem_zero_$def$2$$ret0@2 inline$$Diem_zero_$def$2$$ret0@1)) (and (=> (= (ControlFlow 0 360008) 360227) inline$$Diem_create_preburn_$def$1$anon20_Then_correct) (=> (= (ControlFlow 0 360008) 360203) inline$$Diem_create_preburn_$def$1$anon20_Else_correct))))))
(let ((inline$$Diem_zero_$def$2$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 360002) 360008)) inline$$Diem_zero_$def$2$anon3_correct)))
(let ((inline$$Diem_zero_$def$2$anon8_Then_correct  (=> (= (ControlFlow 0 360016) 360008) inline$$Diem_zero_$def$2$anon3_correct)))
(let ((inline$$Diem_zero_$def$2$anon7_Then_correct  (=> $abort_flag@84 (and (=> (= (ControlFlow 0 359996) 360016) inline$$Diem_zero_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 359996) 360002) inline$$Diem_zero_$def$2$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$2$anon6_correct  (=> (and (= $abort_flag@85 $abort_flag@84) (= inline$$Diem_zero_$def$2$$ret0@2 inline$$Diem_Diem_pack$2$$struct@1)) (and (=> (= (ControlFlow 0 359984) 360227) inline$$Diem_create_preburn_$def$1$anon20_Then_correct) (=> (= (ControlFlow 0 359984) 360203) inline$$Diem_create_preburn_$def$1$anon20_Else_correct)))))
(let ((inline$$Diem_zero_$def$2$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 359982) 359984)) inline$$Diem_zero_$def$2$anon6_correct)))
(let ((inline$$Diem_zero_$def$2$anon9_Then_correct  (=> (= (ControlFlow 0 359992) 359984) inline$$Diem_zero_$def$2$anon6_correct)))
(let ((inline$$Diem_Diem_pack$2$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 359960) 359992) inline$$Diem_zero_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 359960) 359982) inline$$Diem_zero_$def$2$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$2$anon4_Then_correct  (and (=> (= (ControlFlow 0 359966) 359992) inline$$Diem_zero_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 359966) 359982) inline$$Diem_zero_$def$2$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$2$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 359954) 359966) inline$$Diem_Diem_pack$2$anon4_Then_correct) (=> (= (ControlFlow 0 359954) 359960) inline$$Diem_Diem_pack$2$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$2$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 359946) 359992) inline$$Diem_zero_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 359946) 359982) inline$$Diem_zero_$def$2$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$2$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$2$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$2$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$2$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$2$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$2$$t0@1) 1)))) (and (=> (= (ControlFlow 0 359938) 359954) inline$$Diem_Diem_pack$2$anon3_Then_correct) (=> (= (ControlFlow 0 359938) 359946) inline$$Diem_Diem_pack$2$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$2$anon7_Else_correct  (=> (not $abort_flag@84) (=> (and (= inline$$Diem_zero_$def$2$$t0@1 ($Integer 0)) (= (ControlFlow 0 359972) 359938)) inline$$Diem_Diem_pack$2$anon0_correct))))
(let ((inline$$Diem_zero_$def$2$anon0_correct  (=> (and (and (not $abort_flag@83) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@84)) (and (=> $abort_flag@84 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@84 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@71 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 359797) 359996) inline$$Diem_zero_$def$2$anon7_Then_correct) (=> (= (ControlFlow 0 359797) 359972) inline$$Diem_zero_$def$2$anon7_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$1$anon18_Else_correct  (=> (and (not $abort_flag@83) (= (ControlFlow 0 360030) 359797)) inline$$Diem_zero_$def$2$anon0_correct)))
(let ((inline$$Diem_create_preburn_$def$1$anon16_Else_correct  (=> (and (and (not $abort_flag@82) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@83)) (and (=> $abort_flag@83 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@83 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@70 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 359600) 360237) inline$$Diem_create_preburn_$def$1$anon18_Then_correct) (=> (= (ControlFlow 0 359600) 360030) inline$$Diem_create_preburn_$def$1$anon18_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$1$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@82) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@82) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@82)) (and (=> $abort_flag@82 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@82 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@69 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@69 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@69 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 359594) 360257) inline$$Diem_create_preburn_$def$1$anon16_Then_correct) (=> (= (ControlFlow 0 359594) 359600) inline$$Diem_create_preburn_$def$1$anon16_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$1$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 359558) 359594)) inline$$Diem_create_preburn_$def$1$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$1$anon15_Then_correct  (=> (= (ControlFlow 0 360281) 359594) inline$$Diem_create_preburn_$def$1$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$1$anon0_correct  (=> (not $abort_flag@81) (and (=> (= (ControlFlow 0 359552) 360281) inline$$Diem_create_preburn_$def$1$anon15_Then_correct) (=> (= (ControlFlow 0 359552) 359558) inline$$Diem_create_preburn_$def$1$anon15_Else_correct)))))
(let ((inline$$Diem_create_preburn$1$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 360287) 359552)) inline$$Diem_create_preburn_$def$1$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Else_correct  (=> (and (not $abort_flag@81) (= (ControlFlow 0 360295) 360287)) inline$$Diem_create_preburn$1$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Then_correct  (=> (and $abort_flag@81 (= (ControlFlow 0 360864) 358802)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_zero_$def$1$anon3_correct  (=> (= inline$$Diem_zero_$def$1$$ret0@1 $Error) (=> (and (= $abort_flag@81 true) (= inline$$Diem_zero_$def$1$$ret0@2 inline$$Diem_zero_$def$1$$ret0@1)) (and (=> (= (ControlFlow 0 359218) 360864) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 359218) 360295) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Else_correct))))))
(let ((inline$$Diem_zero_$def$1$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 359212) 359218)) inline$$Diem_zero_$def$1$anon3_correct)))
(let ((inline$$Diem_zero_$def$1$anon8_Then_correct  (=> (= (ControlFlow 0 359226) 359218) inline$$Diem_zero_$def$1$anon3_correct)))
(let ((inline$$Diem_zero_$def$1$anon7_Then_correct  (=> $abort_flag@80 (and (=> (= (ControlFlow 0 359206) 359226) inline$$Diem_zero_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 359206) 359212) inline$$Diem_zero_$def$1$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon6_correct  (=> (and (= $abort_flag@81 $abort_flag@80) (= inline$$Diem_zero_$def$1$$ret0@2 inline$$Diem_Diem_pack$1$$struct@1)) (and (=> (= (ControlFlow 0 359194) 360864) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 359194) 360295) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 359192) 359194)) inline$$Diem_zero_$def$1$anon6_correct)))
(let ((inline$$Diem_zero_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 359202) 359194) inline$$Diem_zero_$def$1$anon6_correct)))
(let ((inline$$Diem_Diem_pack$1$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 359170) 359202) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 359170) 359192) inline$$Diem_zero_$def$1$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon4_Then_correct  (and (=> (= (ControlFlow 0 359176) 359202) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 359176) 359192) inline$$Diem_zero_$def$1$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 359164) 359176) inline$$Diem_Diem_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 359164) 359170) inline$$Diem_Diem_pack$1$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 359156) 359202) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 359156) 359192) inline$$Diem_zero_$def$1$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$1$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$t0@1) 1)))) (and (=> (= (ControlFlow 0 359148) 359164) inline$$Diem_Diem_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 359148) 359156) inline$$Diem_Diem_pack$1$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon7_Else_correct  (=> (not $abort_flag@80) (=> (and (= inline$$Diem_zero_$def$1$$t0@1 ($Integer 0)) (= (ControlFlow 0 359182) 359148)) inline$$Diem_Diem_pack$1$anon0_correct))))
(let ((inline$$Diem_zero_$def$1$anon0_correct  (=> (and (and (not $abort_flag@79) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@80)) (and (=> $abort_flag@80 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@80 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@68 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 359007) 359206) inline$$Diem_zero_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 359007) 359182) inline$$Diem_zero_$def$1$anon7_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon31_Then_correct  (=> (and (|b#$Boolean| inline$$Not$10$dst@1) (= (ControlFlow 0 359240) 359007)) inline$$Diem_zero_$def$1$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 358796) 358802)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 358810) 358802) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon31_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$10$dst@1)) (= $abort_code@67 (|i#$Integer| call3formal@$ret0@0@@17))) (and (=> (= (ControlFlow 0 358790) 358810) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 358790) 358796) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon32_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon29_Else_correct  (=> (not $abort_flag@79) (and (=> (= (ControlFlow 0 358778) 359240) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 358778) 358790) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon31_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else$1_correct  (=> (and (and (and (= inline$$TransactionFee_add_txn_fee_currency_$def$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@79)) (and (=> $abort_flag@79 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@79) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@17) (>= (|i#$Integer| call3formal@$ret0@0@@17) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@17) $MAX_U64))) (and (=> (= (ControlFlow 0 358772) 360868) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 358772) 358778) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon29_Else_correct)))))
(let ((inline$$Not$10$anon0_correct  (=> (and (= inline$$Not$10$dst@1 ($Boolean  (not (|b#$Boolean| inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2)))) (= (ControlFlow 0 358760) 358772)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else$1_correct)))
(let ((inline$$Not$10$Entry_correct  (and (=> (= (ControlFlow 0 358750) (- 0 443085)) true) (=> (= (ControlFlow 0 358750) 358760) inline$$Not$10$anon0_correct))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else_correct  (=> (and (not $abort_flag@78) (= (ControlFlow 0 358766) 358750)) inline$$Not$10$Entry_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Then_correct  (=> (and $abort_flag@78 (= (ControlFlow 0 360888) 358802)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct  (=> (and (= $abort_flag@78 $abort_flag@77) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2 inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1)) (and (=> (= (ControlFlow 0 358680) 360888) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 358680) 358766) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 358678) 358680)) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 358688) 358680) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct  (=> (and (not $abort_flag@77) (= inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1))))) (and (=> (= (ControlFlow 0 358672) 358688) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 358672) 358678) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct  (=> (and (and $abort_flag@77 (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1 $Error)) (and (= $abort_flag@78 true) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2 inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 358696) 360888) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 358696) 358766) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 358618) 358696) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 358618) 358672) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 358628) 358696) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 358628) 358672) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@77) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 ($Address 186537453))) (and (=> (= (ControlFlow 0 358612) 358628) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 358612) 358618) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct  (=> (and (not $abort_flag@77) (= (ControlFlow 0 358642) 358612)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon26_Else_correct  (=> (and (not $abort_flag@77) (= (ControlFlow 0 358710) 358642)) inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@77) (=> (and (=> $abort_flag@77 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@77 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@65 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 358356) 360892) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 358356) 358710) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon26_Else_correct))))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 358320) 358356)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon2$1_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 360916) 358356) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon2$1_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon0_correct  (=> (not $abort_flag@76) (and (=> (= (ControlFlow 0 358314) 360916) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 358314) 358320) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon25_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency$0$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 360920) 358314)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency$0$Entry_correct  (=> (and (= inline$$TransactionFee_add_txn_fee_currency$0$$tv0@0 $XUS_XUS_type_value) (= (ControlFlow 0 357914) 360920)) inline$$TransactionFee_add_txn_fee_currency$0$anon0_correct)))
(let ((inline$$TransactionFee_initialize_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@76) (= (ControlFlow 0 360926) 357914)) inline$$TransactionFee_add_txn_fee_currency$0$Entry_correct)))
(let ((inline$$TransactionFee_initialize_$def$0$anon14_Else_correct  (=> (and (not $abort_flag@75) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@76)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@76) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@76)) (and (=> $abort_flag@76 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@76 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@64 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@64 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@64 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 357860) 360946) inline$$TransactionFee_initialize_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 357860) 360926) inline$$TransactionFee_initialize_$def$0$anon16_Else_correct))))))
(let ((inline$$TransactionFee_initialize_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@75) (=> (and (=> $abort_flag@75 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@75 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@63 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 357854) 360966) inline$$TransactionFee_initialize_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 357854) 357860) inline$$TransactionFee_initialize_$def$0$anon14_Else_correct))))))
(let ((inline$$TransactionFee_initialize_$def$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 357818) 357854)) inline$$TransactionFee_initialize_$def$0$anon2$1_correct)))
(let ((inline$$TransactionFee_initialize_$def$0$anon13_Then_correct  (=> (= (ControlFlow 0 360990) 357854) inline$$TransactionFee_initialize_$def$0$anon2$1_correct)))
(let ((inline$$TransactionFee_initialize_$def$0$anon0_correct  (=> (not $abort_flag@74) (and (=> (= (ControlFlow 0 357812) 360990) inline$$TransactionFee_initialize_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 357812) 357818) inline$$TransactionFee_initialize_$def$0$anon13_Else_correct)))))
(let ((inline$$TransactionFee_initialize_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 360994) 357812)) inline$$TransactionFee_initialize_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon85_Else_correct  (=> (and (not $abort_flag@74) (= (ControlFlow 0 361000) 360994)) inline$$TransactionFee_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon85_Then_correct true))
(let ((inline$$AccountFreezing_initialize_$def$0$anon50_Else_correct  (=> (and (not $abort_flag@73) (= $abort_flag@74 $abort_flag@73)) (and (=> (= (ControlFlow 0 357401) 388300) inline$$Genesis_initialize_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 357401) 361000) inline$$Genesis_initialize_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$Abort_correct  (=> (= $abort_flag@74 true) (and (=> (= (ControlFlow 0 356789) 388300) inline$$Genesis_initialize_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 356789) 361000) inline$$Genesis_initialize_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 357531) 356789)) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon37_Then_correct  (=> (= (ControlFlow 0 357541) 356789) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon36_Then_correct  (=> $abort_flag@69 (and (=> (= (ControlFlow 0 357525) 357541) inline$$AccountFreezing_initialize_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 357525) 357531) inline$$AccountFreezing_initialize_$def$0$anon37_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 357511) 356789)) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 357521) 356789) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon38_Then_correct  (=> $abort_flag@70 (and (=> (= (ControlFlow 0 357505) 357521) inline$$AccountFreezing_initialize_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 357505) 357511) inline$$AccountFreezing_initialize_$def$0$anon39_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 357491) 356789)) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 357501) 356789) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon40_Then_correct  (=> $abort_flag@71 (and (=> (= (ControlFlow 0 357485) 357501) inline$$AccountFreezing_initialize_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 357485) 357491) inline$$AccountFreezing_initialize_$def$0$anon41_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 357471) 356789)) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon43_Then_correct  (=> (= (ControlFlow 0 357481) 356789) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon42_Then_correct  (=> $abort_flag@72 (and (=> (= (ControlFlow 0 357465) 357481) inline$$AccountFreezing_initialize_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 357465) 357471) inline$$AccountFreezing_initialize_$def$0$anon43_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 357451) 356789)) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon47_Then_correct  (=> (= (ControlFlow 0 357461) 356789) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon46_Then_correct  (=> $abort_flag@72 (and (=> (= (ControlFlow 0 357445) 357461) inline$$AccountFreezing_initialize_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 357445) 357451) inline$$AccountFreezing_initialize_$def$0$anon47_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 357431) 356789)) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon49_Then_correct  (=> (= (ControlFlow 0 357441) 356789) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon48_Then_correct  (=> $abort_flag@72 (and (=> (= (ControlFlow 0 357425) 357441) inline$$AccountFreezing_initialize_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 357425) 357431) inline$$AccountFreezing_initialize_$def$0$anon49_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 357411) 356789)) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 357421) 356789) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon50_Then_correct  (=> $abort_flag@73 (and (=> (= (ControlFlow 0 357405) 357421) inline$$AccountFreezing_initialize_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 357405) 357411) inline$$AccountFreezing_initialize_$def$0$anon51_Else_correct)))))
(let ((inline$$MoveToRaw$7$anon3_Then$1_correct  (=> (= $abort_flag@73 true) (and (=> (= (ControlFlow 0 357379) 357405) inline$$AccountFreezing_initialize_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 357379) 357401) inline$$AccountFreezing_initialize_$def$0$anon50_Else_correct)))))
(let ((inline$$MoveToRaw$7$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$7$a@1) (= (ControlFlow 0 357377) 357379)) inline$$MoveToRaw$7$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$7$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$7$a@1)) (=> (and (= |inline$$MoveToRaw$7$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$7$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray inline$$MoveTo$7$a@1 inline$$AccountFreezing_FreezeEventsHolder_pack$0$$struct@1))) (= $abort_flag@73 $abort_flag@72)) (and (=> (= (ControlFlow 0 357327) 357405) inline$$AccountFreezing_initialize_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 357327) 357401) inline$$AccountFreezing_initialize_$def$0$anon50_Else_correct))))))
(let ((inline$$MoveTo$7$anon0$1_correct  (=> (= inline$$MoveTo$7$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 357385) 357377) inline$$MoveToRaw$7$anon3_Then_correct) (=> (= (ControlFlow 0 357385) 357327) inline$$MoveToRaw$7$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$7$Entry_correct  (and (=> (= (ControlFlow 0 357173) (- 0 442228)) true) (=> (= (ControlFlow 0 357173) 357385) inline$$MoveTo$7$anon0$1_correct))))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 357059) 357173)) inline$$Signer_borrow_address$7$Entry_correct)))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 357065) 357173) inline$$Signer_borrow_address$7$Entry_correct)))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 357053) 357065) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 357053) 357059) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon4_Else_correct)))))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 357045) 357173)) inline$$Signer_borrow_address$7$Entry_correct)))
(let ((inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon0_correct  (=> (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$10$res@0) (let ((va@@51 (|v#$Vector| inline$$Event_new_event_handle$10$res@0)))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_guid)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_guid))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$10$res@0)) $Event_EventHandle_guid))) $$0@@7))
))) true) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$11$res@0) (let ((va@@53 (|v#$Vector| inline$$Event_new_event_handle$11$res@0)))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_guid)) (let ((va@@54 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_guid))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_guid))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_guid))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_guid))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$11$res@0)) $Event_EventHandle_guid))) $$0@@8))
))) true) (= inline$$AccountFreezing_FreezeEventsHolder_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Event_new_event_handle$10$res@0) 1 inline$$Event_new_event_handle$11$res@0) 2)))) (and (=> (= (ControlFlow 0 357037) 357053) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 357037) 357045) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon3_Else_correct))))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon48_Else_correct  (=> (and (not $abort_flag@72) (= (ControlFlow 0 357071) 357037)) inline$$AccountFreezing_FreezeEventsHolder_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$11$Entry_correct  (=> (= inline$$Event_new_event_handle$11$t@0 $AccountFreezing_UnfreezeAccountEvent_type_value) (and (=> (= (ControlFlow 0 356871) 357425) inline$$AccountFreezing_initialize_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 356871) 357071) inline$$AccountFreezing_initialize_$def$0$anon48_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon46_Else_correct  (=> (and (not $abort_flag@72) (= (ControlFlow 0 356879) 356871)) inline$$Event_new_event_handle$11$Entry_correct)))
(let ((inline$$Event_new_event_handle$10$Entry_correct  (=> (= inline$$Event_new_event_handle$10$t@0 $AccountFreezing_FreezeAccountEvent_type_value) (and (=> (= (ControlFlow 0 356829) 357445) inline$$AccountFreezing_initialize_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 356829) 356879) inline$$AccountFreezing_initialize_$def$0$anon46_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon44_Then_correct  (=> (and (|b#$Boolean| inline$$Not$9$dst@1) (= (ControlFlow 0 356837) 356829)) inline$$Event_new_event_handle$10$Entry_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 356783) 356789)) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon45_Then_correct  (=> (= (ControlFlow 0 356797) 356789) inline$$AccountFreezing_initialize_$def$0$Abort_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon44_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$9$dst@1)) (= $abort_code@62 (|i#$Integer| call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 356777) 356797) inline$$AccountFreezing_initialize_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 356777) 356783) inline$$AccountFreezing_initialize_$def$0$anon45_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon42_Else_correct  (=> (not $abort_flag@72) (and (=> (= (ControlFlow 0 356765) 356837) inline$$AccountFreezing_initialize_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 356765) 356777) inline$$AccountFreezing_initialize_$def$0$anon44_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon40_Else$1_correct  (=> (and (and (and (= inline$$AccountFreezing_initialize_$def$0$$t7@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@72)) (and (=> $abort_flag@72 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@72) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@18) (>= (|i#$Integer| call3formal@$ret0@0@@18) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@18) $MAX_U64))) (and (=> (= (ControlFlow 0 356759) 357465) inline$$AccountFreezing_initialize_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 356759) 356765) inline$$AccountFreezing_initialize_$def$0$anon42_Else_correct)))))
(let ((inline$$Not$9$anon0_correct  (=> (and (= inline$$Not$9$dst@1 ($Boolean  (not (|b#$Boolean| inline$$AccountFreezing_initialize_$def$0$$t5@1)))) (= (ControlFlow 0 356747) 356759)) inline$$AccountFreezing_initialize_$def$0$anon40_Else$1_correct)))
(let ((inline$$Not$9$Entry_correct  (and (=> (= (ControlFlow 0 356737) (- 0 441980)) true) (=> (= (ControlFlow 0 356737) 356747) inline$$Not$9$anon0_correct))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon40_Else_correct  (=> (not $abort_flag@71) (=> (and (= inline$$AccountFreezing_initialize_$def$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@19)))) (= (ControlFlow 0 356753) 356737)) inline$$Not$9$Entry_correct))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon38_Else_correct  (=> (not $abort_flag@70) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@71) (=> $abort_flag@71 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@71) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 356691) 357485) inline$$AccountFreezing_initialize_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 356691) 356753) inline$$AccountFreezing_initialize_$def$0$anon40_Else_correct))))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon36_Else_correct  (=> (and (and (not $abort_flag@69) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@70)) (and (=> $abort_flag@70 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@70 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@59 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 356685) 357505) inline$$AccountFreezing_initialize_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 356685) 356691) inline$$AccountFreezing_initialize_$def$0$anon38_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@69) (=> (and (=> $abort_flag@69 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@69 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@58 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 356679) 357525) inline$$AccountFreezing_initialize_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 356679) 356685) inline$$AccountFreezing_initialize_$def$0$anon36_Else_correct))))))
(let ((inline$$AccountFreezing_initialize_$def$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 356643) 356679)) inline$$AccountFreezing_initialize_$def$0$anon2$1_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon35_Then_correct  (=> (= (ControlFlow 0 357549) 356679) inline$$AccountFreezing_initialize_$def$0$anon2$1_correct)))
(let ((inline$$AccountFreezing_initialize_$def$0$anon0_correct  (=> (not $abort_flag@68) (and (=> (= (ControlFlow 0 356637) 357549) inline$$AccountFreezing_initialize_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 356637) 356643) inline$$AccountFreezing_initialize_$def$0$anon35_Else_correct)))))
(let ((inline$$AccountFreezing_initialize_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 357553) 356637)) inline$$AccountFreezing_initialize_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon84_Else_correct  (=> (and (not $abort_flag@68) (= (ControlFlow 0 357559) 357553)) inline$$AccountFreezing_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon84_Then_correct true))
(let ((inline$$XDX_initialize_$def$0$anon62_Else_correct  (=> (not $abort_flag@67) (=> (and (and (= $DiemConfig_DiemConfig_$memory@20 $DiemConfig_DiemConfig_$memory@18) (= $DiemConfig_Configuration_$memory@16 $DiemConfig_Configuration_$memory@14)) (and (= $Diem_CurrencyInfo_$memory@10 $Diem_CurrencyInfo_$memory@8) (= $abort_flag@68 $abort_flag@67))) (and (=> (= (ControlFlow 0 355906) 388304) inline$$Genesis_initialize_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 355906) 357559) inline$$Genesis_initialize_$def_verify$0$anon84_Else_correct))))))
(let ((inline$$XDX_initialize_$def$0$Abort_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@20 $DiemConfig_DiemConfig_$memory@19) (= $DiemConfig_Configuration_$memory@16 $DiemConfig_Configuration_$memory@15)) (and (= $Diem_CurrencyInfo_$memory@10 $Diem_CurrencyInfo_$memory@9) (= $abort_flag@68 true))) (and (=> (= (ControlFlow 0 345061) 388304) inline$$Genesis_initialize_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 345061) 357559) inline$$Genesis_initialize_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon7_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@13) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@9)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@5) (= (ControlFlow 0 356034) 345061))) inline$$XDX_initialize_$def$0$Abort_correct)))
(let ((inline$$XDX_initialize_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 356032) 356034)) inline$$XDX_initialize_$def$0$anon7_correct)))
(let ((inline$$XDX_initialize_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 356042) 356034) inline$$XDX_initialize_$def$0$anon7_correct)))
(let ((inline$$XDX_initialize_$def$0$anon45_Then_correct  (=> $abort_flag@39 (and (=> (= (ControlFlow 0 356026) 356042) inline$$XDX_initialize_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 356026) 356032) inline$$XDX_initialize_$def$0$anon46_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon11_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@13) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@9)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@5) (= (ControlFlow 0 356014) 345061))) inline$$XDX_initialize_$def$0$Abort_correct)))
(let ((inline$$XDX_initialize_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 356012) 356014)) inline$$XDX_initialize_$def$0$anon11_correct)))
(let ((inline$$XDX_initialize_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 356022) 356014) inline$$XDX_initialize_$def$0$anon11_correct)))
(let ((inline$$XDX_initialize_$def$0$anon47_Then_correct  (=> $abort_flag@40 (and (=> (= (ControlFlow 0 356006) 356022) inline$$XDX_initialize_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 356006) 356012) inline$$XDX_initialize_$def$0$anon48_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon17_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@13) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@9)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@5) (= (ControlFlow 0 355990) 345061))) inline$$XDX_initialize_$def$0$Abort_correct)))
(let ((inline$$XDX_initialize_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 355988) 355990)) inline$$XDX_initialize_$def$0$anon17_correct)))
(let ((inline$$XDX_initialize_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 355998) 355990) inline$$XDX_initialize_$def$0$anon17_correct)))
(let ((inline$$XDX_initialize_$def$0$anon50_Then_correct  (=> $abort_flag@41 (and (=> (= (ControlFlow 0 355982) 355998) inline$$XDX_initialize_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 355982) 355988) inline$$XDX_initialize_$def$0$anon51_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon25_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@13) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@9)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@5) (= (ControlFlow 0 355970) 345061))) inline$$XDX_initialize_$def$0$Abort_correct)))
(let ((inline$$XDX_initialize_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 355968) 355970)) inline$$XDX_initialize_$def$0$anon25_correct)))
(let ((inline$$XDX_initialize_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 355978) 355970) inline$$XDX_initialize_$def$0$anon25_correct)))
(let ((inline$$XDX_initialize_$def$0$anon54_Then_correct  (=> $abort_flag@42 (and (=> (= (ControlFlow 0 355962) 355978) inline$$XDX_initialize_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 355962) 355968) inline$$XDX_initialize_$def$0$anon55_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon41_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@18) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@14)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@8) (= (ControlFlow 0 355918) 345061))) inline$$XDX_initialize_$def$0$Abort_correct)))
(let ((inline$$XDX_initialize_$def$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 355916) 355918)) inline$$XDX_initialize_$def$0$anon41_correct)))
(let ((inline$$XDX_initialize_$def$0$anon63_Then_correct  (=> (= (ControlFlow 0 355926) 355918) inline$$XDX_initialize_$def$0$anon41_correct)))
(let ((inline$$XDX_initialize_$def$0$anon62_Then_correct  (=> $abort_flag@67 (and (=> (= (ControlFlow 0 355910) 355926) inline$$XDX_initialize_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 355910) 355916) inline$$XDX_initialize_$def$0$anon63_Else_correct)))))
(let ((inline$$MoveToRaw$6$anon3_Then$1_correct  (=> (= $abort_flag@67 true) (and (=> (= (ControlFlow 0 355884) 355910) inline$$XDX_initialize_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 355884) 355906) inline$$XDX_initialize_$def$0$anon62_Else_correct)))))
(let ((inline$$MoveToRaw$6$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray inline$$MoveTo$6$a@1) (= (ControlFlow 0 355882) 355884)) inline$$MoveToRaw$6$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$6$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray inline$$MoveTo$6$a@1)) (=> (and (= |inline$$MoveToRaw$6$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray inline$$MoveTo$6$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray inline$$MoveTo$6$a@1 inline$$XDX_Reserve_pack$0$$struct@1))) (= $abort_flag@67 $abort_flag@66)) (and (=> (= (ControlFlow 0 355832) 355910) inline$$XDX_initialize_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 355832) 355906) inline$$XDX_initialize_$def$0$anon62_Else_correct))))))
(let ((inline$$MoveTo$6$anon0$1_correct  (=> (= inline$$MoveTo$6$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 355890) 355882) inline$$MoveToRaw$6$anon3_Then_correct) (=> (= (ControlFlow 0 355890) 355832) inline$$MoveToRaw$6$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$6$Entry_correct  (and (=> (= (ControlFlow 0 355678) (- 0 441376)) true) (=> (= (ControlFlow 0 355678) 355890) inline$$MoveTo$6$anon0$1_correct))))
(let ((inline$$XDX_Reserve_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 355564) 355678)) inline$$Signer_borrow_address$6$Entry_correct)))
(let ((inline$$XDX_Reserve_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 355570) 355678) inline$$Signer_borrow_address$6$Entry_correct)))
(let ((inline$$XDX_Reserve_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 355558) 355570) inline$$XDX_Reserve_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 355558) 355564) inline$$XDX_Reserve_pack$0$anon4_Else_correct)))))
(let ((inline$$XDX_Reserve_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 355550) 355678)) inline$$Signer_borrow_address$6$Entry_correct)))
(let ((inline$$XDX_Reserve_pack$0$anon0_correct  (=> (and (and (and (and (and (and ((_ is $Vector) inline$$Diem_register_currency_$def$1$$ret0@2) (let ((va@@55 (|v#$Vector| inline$$Diem_register_currency_$def$1$$ret0@2)))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$1$$ret0@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$1$$ret0@2)) $Diem_MintCapability_dummy_field))) true) (and (and (and (and ((_ is $Vector) inline$$Diem_register_currency_$def$1$$ret1@2) (let ((va@@56 (|v#$Vector| inline$$Diem_register_currency_$def$1$$ret1@2)))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$1$$ret1@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$1$$ret1@2)) $Diem_BurnCapability_dummy_field))) true)) (and (and (and (and (and ((_ is $Vector) inline$$Diem_create_preburn_$def$0$$ret0@2) (let ((va@@57 (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (= inline$$XDX_Reserve_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$1$$ret0@2) 1 inline$$Diem_register_currency_$def$1$$ret1@2) 2 inline$$Diem_create_preburn_$def$0$$ret0@2) 3))))) (and (=> (= (ControlFlow 0 355542) 355558) inline$$XDX_Reserve_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 355542) 355550) inline$$XDX_Reserve_pack$0$anon3_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon61_Else_correct  (=> (and (not $abort_flag@66) (= (ControlFlow 0 355576) 355542)) inline$$XDX_Reserve_pack$0$anon0_correct)))
(let ((inline$$XDX_initialize_$def$0$anon61_Then_correct  (=> $abort_flag@66 (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@18) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@14)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@8) (= (ControlFlow 0 355930) 345061))) inline$$XDX_initialize_$def$0$Abort_correct))))
(let ((inline$$Diem_create_preburn_$def$0$Abort_correct  (=> (= inline$$Diem_create_preburn_$def$0$$ret0@1 $Error) (=> (and (= inline$$Diem_create_preburn_$def$0$$ret0@2 inline$$Diem_create_preburn_$def$0$$ret0@1) (= $abort_flag@66 true)) (and (=> (= (ControlFlow 0 355296) 355930) inline$$XDX_initialize_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 355296) 355576) inline$$XDX_initialize_$def$0$anon61_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 355326) 355296)) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 355336) 355296) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Then_correct  (=> $abort_flag@62 (and (=> (= (ControlFlow 0 355320) 355336) inline$$Diem_create_preburn_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 355320) 355326) inline$$Diem_create_preburn_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 355306) 355296)) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 355316) 355296) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Then_correct  (=> $abort_flag@63 (and (=> (= (ControlFlow 0 355300) 355316) inline$$Diem_create_preburn_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 355300) 355306) inline$$Diem_create_preburn_$def$0$anon19_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Then_correct  (=> (and $abort_flag@65 (= (ControlFlow 0 355290) 355296)) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon14_correct  (=> (and (= inline$$Diem_create_preburn_$def$0$$ret0@2 inline$$Diem_Preburn_pack$0$$struct@1) (= $abort_flag@66 $abort_flag@65)) (and (=> (= (ControlFlow 0 355278) 355930) inline$$XDX_initialize_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 355278) 355576) inline$$XDX_initialize_$def$0$anon61_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 355276) 355278)) inline$$Diem_create_preburn_$def$0$anon14_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 355286) 355278) inline$$Diem_create_preburn_$def$0$anon14_correct)))
(let ((inline$$Diem_Preburn_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 355254) 355286) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 355254) 355276) inline$$Diem_create_preburn_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 355260) 355286) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 355260) 355276) inline$$Diem_create_preburn_$def$0$anon21_Else_correct))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 355248) 355260) inline$$Diem_Preburn_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 355248) 355254) inline$$Diem_Preburn_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 355240) 355286) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 355240) 355276) inline$$Diem_create_preburn_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$0$$ret0@2) (let ((va@@59 (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$Diem_Preburn_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 355232) 355248) inline$$Diem_Preburn_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 355232) 355240) inline$$Diem_Preburn_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Else_correct  (=> (and (not $abort_flag@65) (= (ControlFlow 0 355266) 355232)) inline$$Diem_Preburn_pack$0$anon0_correct)))
(let ((inline$$Diem_zero_$def$0$anon3_correct  (=> (= inline$$Diem_zero_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@65 true) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_zero_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 355071) 355290) inline$$Diem_create_preburn_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 355071) 355266) inline$$Diem_create_preburn_$def$0$anon20_Else_correct))))))
(let ((inline$$Diem_zero_$def$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 355065) 355071)) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon8_Then_correct  (=> (= (ControlFlow 0 355079) 355071) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon7_Then_correct  (=> $abort_flag@64 (and (=> (= (ControlFlow 0 355059) 355079) inline$$Diem_zero_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 355059) 355065) inline$$Diem_zero_$def$0$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon6_correct  (=> (and (= $abort_flag@65 $abort_flag@64) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_Diem_pack$0$$struct@1)) (and (=> (= (ControlFlow 0 355047) 355290) inline$$Diem_create_preburn_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 355047) 355266) inline$$Diem_create_preburn_$def$0$anon20_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 355045) 355047)) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_zero_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 355055) 355047) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 355023) 355055) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 355023) 355045) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 355029) 355055) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 355029) 355045) inline$$Diem_zero_$def$0$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 355017) 355029) inline$$Diem_Diem_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 355017) 355023) inline$$Diem_Diem_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 355009) 355055) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 355009) 355045) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$0$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 355001) 355017) inline$$Diem_Diem_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 355001) 355009) inline$$Diem_Diem_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon7_Else_correct  (=> (not $abort_flag@64) (=> (and (= inline$$Diem_zero_$def$0$$t0@1 ($Integer 0)) (= (ControlFlow 0 355035) 355001)) inline$$Diem_Diem_pack$0$anon0_correct))))
(let ((inline$$Diem_zero_$def$0$anon0_correct  (=> (and (and (not $abort_flag@63) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_create_preburn$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@64)) (and (=> $abort_flag@64 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_create_preburn$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@64 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_create_preburn$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@57 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 354860) 355059) inline$$Diem_zero_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 354860) 355035) inline$$Diem_zero_$def$0$anon7_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Else_correct  (=> (and (not $abort_flag@63) (= (ControlFlow 0 355093) 354860)) inline$$Diem_zero_$def$0$anon0_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Else_correct  (=> (and (and (not $abort_flag@62) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_create_preburn$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@63)) (and (=> $abort_flag@63 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_create_preburn$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@63 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_create_preburn$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 354663) 355300) inline$$Diem_create_preburn_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 354663) 355093) inline$$Diem_create_preburn_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@62) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@62) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@62)) (and (=> $abort_flag@62 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@62 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@55 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@55 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@55 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 354657) 355320) inline$$Diem_create_preburn_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 354657) 354663) inline$$Diem_create_preburn_$def$0$anon16_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 354621) 354657)) inline$$Diem_create_preburn_$def$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 355344) 354657) inline$$Diem_create_preburn_$def$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon0_correct  (=> (not $abort_flag@61) (and (=> (= (ControlFlow 0 354615) 355344) inline$$Diem_create_preburn_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 354615) 354621) inline$$Diem_create_preburn_$def$0$anon15_Else_correct)))))
(let ((inline$$Diem_create_preburn$0$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 355350) 354615)) inline$$Diem_create_preburn_$def$0$anon0_correct)))
(let ((inline$$Diem_create_preburn$0$Entry_correct  (=> (and (= inline$$Diem_create_preburn$0$$tv0@0 $XDX_XDX_type_value) (= (ControlFlow 0 354358) 355350)) inline$$Diem_create_preburn$0$anon0_correct)))
(let ((inline$$XDX_initialize_$def$0$anon60_Else_correct  (=> (and (not $abort_flag@61) (= (ControlFlow 0 355358) 354358)) inline$$Diem_create_preburn$0$Entry_correct)))
(let ((inline$$XDX_initialize_$def$0$anon60_Then_correct  (=> $abort_flag@61 (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@18) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@14)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@8) (= (ControlFlow 0 355934) 345061))) inline$$XDX_initialize_$def$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon26_Else_correct  (=> (and (not $abort_flag@60) (= $abort_flag@61 $abort_flag@60)) (and (=> (= (ControlFlow 0 354225) 355934) inline$$XDX_initialize_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 354225) 355358) inline$$XDX_initialize_$def$0$anon60_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$Abort_correct  (=> (= $abort_flag@61 true) (and (=> (= (ControlFlow 0 353446) 355934) inline$$XDX_initialize_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 353446) 355358) inline$$XDX_initialize_$def$0$anon60_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 354275) 353446)) inline$$AccountLimits_publish_unrestricted_limits_$def$1$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon21_Then_correct  (=> (= (ControlFlow 0 354285) 353446) inline$$AccountLimits_publish_unrestricted_limits_$def$1$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon20_Then_correct  (=> $abort_flag@58 (and (=> (= (ControlFlow 0 354269) 354285) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon21_Then_correct) (=> (= (ControlFlow 0 354269) 354275) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon21_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 354255) 353446)) inline$$AccountLimits_publish_unrestricted_limits_$def$1$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon23_Then_correct  (=> (= (ControlFlow 0 354265) 353446) inline$$AccountLimits_publish_unrestricted_limits_$def$1$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon22_Then_correct  (=> $abort_flag@59 (and (=> (= (ControlFlow 0 354249) 354265) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 354249) 354255) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon23_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 354235) 353446)) inline$$AccountLimits_publish_unrestricted_limits_$def$1$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon27_Then_correct  (=> (= (ControlFlow 0 354245) 353446) inline$$AccountLimits_publish_unrestricted_limits_$def$1$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon26_Then_correct  (=> $abort_flag@60 (and (=> (= (ControlFlow 0 354229) 354245) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 354229) 354235) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon27_Else_correct)))))
(let ((inline$$MoveToRaw$5$anon3_Then$1_correct  (=> (= $abort_flag@60 true) (and (=> (= (ControlFlow 0 354203) 354229) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 354203) 354225) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon26_Else_correct)))))
(let ((inline$$MoveToRaw$5$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory@3) inline$$MoveTo$5$ta@0 inline$$MoveTo$5$a@1) (= (ControlFlow 0 354201) 354203)) inline$$MoveToRaw$5$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$5$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory@3) inline$$MoveTo$5$ta@0 inline$$MoveTo$5$a@1)) (=> (and (= |inline$$MoveToRaw$5$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory@3) inline$$MoveTo$5$ta@0 inline$$MoveTo$5$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory@3) inline$$MoveTo$5$ta@0 inline$$MoveTo$5$a@1 inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1))) (= $abort_flag@60 $abort_flag@59)) (and (=> (= (ControlFlow 0 354151) 354229) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 354151) 354225) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon26_Else_correct))))))
(let ((inline$$MoveTo$5$anon0$1_correct  (=> (= inline$$MoveTo$5$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 354209) 354201) inline$$MoveToRaw$5$anon3_Then_correct) (=> (= (ControlFlow 0 354209) 354151) inline$$MoveToRaw$5$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$5$Entry_correct  (and (=> (= (ControlFlow 0 353997) (- 0 440378)) true) (=> (= (ControlFlow 0 353997) 354209) inline$$MoveTo$5$anon0$1_correct))))
(let ((inline$$MoveTo$5$Entry_correct  (=> (and (= inline$$MoveTo$5$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$AccountLimits_publish_unrestricted_limits$1$$tv0@0) 1)) (= (ControlFlow 0 353969) 353997)) inline$$Signer_borrow_address$5$Entry_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$1$anon3_correct  (and (=> (= (ControlFlow 0 353857) (- 0 440260)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 353857) (- 0 440279)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 353857) (- 0 440298)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 353857) (- 0 440317)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 353857) 353969) inline$$MoveTo$5$Entry_correct)))))))))))
(let ((inline$$AccountLimits_LimitsDefinition_pack$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 353871) 353857)) inline$$AccountLimits_LimitsDefinition_pack$1$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$1$anon5_Then_correct  (=> (= (ControlFlow 0 353877) 353857) inline$$AccountLimits_LimitsDefinition_pack$1$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$1$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 353865) 353877) inline$$AccountLimits_LimitsDefinition_pack$1$anon5_Then_correct) (=> (= (ControlFlow 0 353865) 353871) inline$$AccountLimits_LimitsDefinition_pack$1$anon5_Else_correct)))))
(let ((inline$$AccountLimits_LimitsDefinition_pack$1$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 353775) 353857)) inline$$AccountLimits_LimitsDefinition_pack$1$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$1$anon0_correct  (=> (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t14@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t14@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t14@1) $MAX_U64)) (=> (and (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t15@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t15@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t15@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t16@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t16@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t16@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t17@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t17@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t17@1) $MAX_U64)) (= inline$$AccountLimits_LimitsDefinition_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t14@1) 1 inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t15@1) 2 inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t16@1) 3 inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t17@1) 4))))) (and (=> (= (ControlFlow 0 353767) 353865) inline$$AccountLimits_LimitsDefinition_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 353767) 353775) inline$$AccountLimits_LimitsDefinition_pack$1$anon4_Else_correct))))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon24_Then_correct  (=> (and (|b#$Boolean| inline$$Not$8$dst@1) (= inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t14@1 ($Integer 18446744073709551615))) (=> (and (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t15@1 ($Integer 18446744073709551615)) (= inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t16@1 ($Integer 86400000000))) (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t17@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 353883) 353767))) inline$$AccountLimits_LimitsDefinition_pack$1$anon0_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 353440) 353446)) inline$$AccountLimits_publish_unrestricted_limits_$def$1$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon25_Then_correct  (=> (= (ControlFlow 0 353454) 353446) inline$$AccountLimits_publish_unrestricted_limits_$def$1$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon24_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$8$dst@1)) (= $abort_code@54 (|i#$Integer| call3formal@$ret0@0@@20))) (and (=> (= (ControlFlow 0 353434) 353454) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon25_Then_correct) (=> (= (ControlFlow 0 353434) 353440) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon25_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon22_Else_correct  (=> (not $abort_flag@59) (and (=> (= (ControlFlow 0 353422) 353883) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 353422) 353434) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon24_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon20_Else$1_correct  (=> (and (and (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@59)) (and (=> $abort_flag@59 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@59) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@20 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@20) (>= (|i#$Integer| call3formal@$ret0@0@@20) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@20) $MAX_U64))) (and (=> (= (ControlFlow 0 353416) 354249) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon22_Then_correct) (=> (= (ControlFlow 0 353416) 353422) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon22_Else_correct)))))
(let ((inline$$Not$8$anon0_correct  (=> (and (= inline$$Not$8$dst@1 ($Boolean  (not (|b#$Boolean| inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t10@1)))) (= (ControlFlow 0 353404) 353416)) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon20_Else$1_correct)))
(let ((inline$$Not$8$Entry_correct  (and (=> (= (ControlFlow 0 353394) (- 0 440015)) true) (=> (= (ControlFlow 0 353394) 353404) inline$$Not$8$anon0_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon20_Else_correct  (=> (not $abort_flag@58) (=> (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$1$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$AccountLimits_publish_unrestricted_limits$1$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@21)))) (= (ControlFlow 0 353410) 353394)) inline$$Not$8$Entry_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@58) (=> $abort_flag@58 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@58) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@21 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@21))) (and (=> (= (ControlFlow 0 353336) 354269) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon20_Then_correct) (=> (= (ControlFlow 0 353336) 353410) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon20_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 353300) 353336)) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon2$1_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon19_Then_correct  (=> (= (ControlFlow 0 354293) 353336) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon2$1_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon0_correct  (=> (not $abort_flag@57) (and (=> (= (ControlFlow 0 353294) 354293) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon19_Then_correct) (=> (= (ControlFlow 0 353294) 353300) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon19_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits$1$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 354297) 353294)) inline$$AccountLimits_publish_unrestricted_limits_$def$1$anon0_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits$1$Entry_correct  (=> (and (= inline$$AccountLimits_publish_unrestricted_limits$1$$tv0@0 $XDX_XDX_type_value) (= (ControlFlow 0 352894) 354297)) inline$$AccountLimits_publish_unrestricted_limits$1$anon0_correct)))
(let ((inline$$XDX_initialize_$def$0$anon59_Else_correct  (=> (and (not $abort_flag@57) (= (ControlFlow 0 354303) 352894)) inline$$AccountLimits_publish_unrestricted_limits$1$Entry_correct)))
(let ((inline$$XDX_initialize_$def$0$anon59_Then_correct  (=> $abort_flag@57 (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@18) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@14)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@8) (= (ControlFlow 0 355938) 345061))) inline$$XDX_initialize_$def$0$Abort_correct))))
(let ((inline$$Diem_update_minting_ability_$def$0$Abort_correct  (=> (and (= $Diem_CurrencyInfo_$memory@8 $Diem_CurrencyInfo_$memory@7) (= $abort_flag@57 true)) (and (=> (= (ControlFlow 0 352760) 355938) inline$$XDX_initialize_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 352760) 354303) inline$$XDX_initialize_$def$0$anon59_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 352802) 352760)) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 352812) 352760) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon23_Then_correct  (=> $abort_flag@54 (and (=> (= (ControlFlow 0 352796) 352812) inline$$Diem_update_minting_ability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 352796) 352802) inline$$Diem_update_minting_ability_$def$0$anon24_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 352782) 352760)) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 352792) 352760) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon25_Then_correct  (=> $abort_flag@55 (and (=> (= (ControlFlow 0 352776) 352792) inline$$Diem_update_minting_ability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 352776) 352782) inline$$Diem_update_minting_ability_$def$0$anon26_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 352754) 352760)) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 352768) 352760) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon28_Then_correct  (=> $abort_flag@56 (and (=> (= (ControlFlow 0 352748) 352768) inline$$Diem_update_minting_ability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 352748) 352754) inline$$Diem_update_minting_ability_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon27_Then_correct  (=> (and $abort_flag@55 (= (ControlFlow 0 352772) 352760)) inline$$Diem_update_minting_ability_$def$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon20$3_correct  (=> (and (= $Diem_CurrencyInfo_$memory@8 |inline$$WritebackToGlobal$0$m'@2|) (= $abort_flag@57 $abort_flag@56)) (and (=> (= (ControlFlow 0 352734) 355938) inline$$XDX_initialize_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 352734) 354303) inline$$XDX_initialize_$def$0$anon59_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $Diem_CurrencyInfo_$memory@7) (= (ControlFlow 0 352672) 352734)) inline$$Diem_update_minting_ability_$def$0$anon20$3_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@7) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@7) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@7) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 352726) 352734))) inline$$Diem_update_minting_ability_$def$0$anon20$3_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (and (=> (= (ControlFlow 0 352662) 352726) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 352662) 352672) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 352542) (- 0 439627)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 352542) 352662) inline$$WritebackToGlobal$0$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (= (ControlFlow 0 352494) 352542)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 352363) 352494)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))))) (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|) (= (ControlFlow 0 352419) 352494))) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 352327) 352419) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 352327) 352363) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 352190) 352327)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon30_Then_correct  (=> (and (= inline$$Diem_update_minting_ability_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 352744) 352327)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1) (|p#$Mutation| inline$$BorrowField$2$dst@1) inline$$XDX_initialize_$def$0$$t23@1)) (and (=> (= (ControlFlow 0 352176) 352744) inline$$Diem_update_minting_ability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 352176) 352190) inline$$Diem_update_minting_ability_$def$0$anon30_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $Diem_CurrencyInfo_can_mint) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $Diem_CurrencyInfo_can_mint))) (= (ControlFlow 0 352117) 352176))) inline$$WriteRef$2$anon0_correct))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 351995) 352117)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 351989) 351995)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon28_Else_correct  (=> (and (not $abort_flag@56) (= (ControlFlow 0 351999) 351989)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@56 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 351949) 352748) inline$$Diem_update_minting_ability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 351949) 351999) inline$$Diem_update_minting_ability_$def$0$anon28_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@7) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 351947) 351949)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@7) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@7) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)))) (and (= $abort_flag@56 $abort_flag@55) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 351895) 352748) inline$$Diem_update_minting_ability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 351895) 351999) inline$$Diem_update_minting_ability_$def$0$anon28_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 351865) 351947) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 351865) 351895) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (=> (= inline$$BorrowGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_update_minting_ability$0$$tv0@0) 1)) (and (=> (= (ControlFlow 0 351859) (- 0 439282)) true) (=> (= (ControlFlow 0 351859) 351865) inline$$BorrowGlobal$0$anon0_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon27_Else_correct  (=> (and (not $abort_flag@55) (= (ControlFlow 0 351955) 351859)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 351716) 352772) inline$$Diem_update_minting_ability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 351716) 351955) inline$$Diem_update_minting_ability_$def$0$anon27_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 351726) 352772) inline$$Diem_update_minting_ability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 351726) 351955) inline$$Diem_update_minting_ability_$def$0$anon27_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@55) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 351710) 351726) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 351710) 351716) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon25_Else_correct  (=> (and (not $abort_flag@55) (= (ControlFlow 0 351740) 351710)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon23_Else_correct  (=> (and (and (not $abort_flag@54) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@7) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_update_minting_ability$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@55)) (and (=> $abort_flag@55 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@7) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_update_minting_ability$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@55 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@7) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_update_minting_ability$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@51 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 351605) 352776) inline$$Diem_update_minting_ability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 351605) 351740) inline$$Diem_update_minting_ability_$def$0$anon25_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@54) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@54) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@54)) (and (=> $abort_flag@54 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@54 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@50 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@50 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@50 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 351599) 352796) inline$$Diem_update_minting_ability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 351599) 351605) inline$$Diem_update_minting_ability_$def$0$anon23_Else_correct))))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 351529) 351599)) inline$$Diem_update_minting_ability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 352820) 351599) inline$$Diem_update_minting_ability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_update_minting_ability_$def$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 351521) 352820) inline$$Diem_update_minting_ability_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 351521) 351529) inline$$Diem_update_minting_ability_$def$0$anon22_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 352828) 352820) inline$$Diem_update_minting_ability_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 352828) 351529) inline$$Diem_update_minting_ability_$def$0$anon22_Else_correct))))
(let ((inline$$Diem_update_minting_ability_$def$0$anon0_correct  (=> (not $abort_flag@53) (and (=> (= (ControlFlow 0 351515) 352828) inline$$Diem_update_minting_ability_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 351515) 351521) inline$$Diem_update_minting_ability_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_update_minting_ability$0$anon0_correct  (=> ((_ is $Address) tc_account) (=> (and ((_ is $Boolean) inline$$XDX_initialize_$def$0$$t23@1) (= (ControlFlow 0 352832) 351515)) inline$$Diem_update_minting_ability_$def$0$anon0_correct))))
(let ((inline$$Diem_update_minting_ability$0$Entry_correct  (=> (and (= inline$$Diem_update_minting_ability$0$$tv0@0 $XDX_XDX_type_value) (= (ControlFlow 0 351141) 352832)) inline$$Diem_update_minting_ability$0$anon0_correct)))
(let ((inline$$XDX_initialize_$def$0$anon32_correct  (=> (and (= inline$$XDX_initialize_$def$0$$t23@1 ($Boolean false)) (= (ControlFlow 0 352838) 351141)) inline$$Diem_update_minting_ability$0$Entry_correct)))
(let ((inline$$XDX_initialize_$def$0$anon58_Else_correct  (=> (and (not true) (= (ControlFlow 0 351075) 352838)) inline$$XDX_initialize_$def$0$anon32_correct)))
(let ((inline$$XDX_initialize_$def$0$anon58_Then_correct  (=> (= (ControlFlow 0 355946) 352838) inline$$XDX_initialize_$def$0$anon32_correct)))
(let ((inline$$XDX_initialize_$def$0$anon57_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 351033) 355946) inline$$XDX_initialize_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 351033) 351075) inline$$XDX_initialize_$def$0$anon58_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon57_Then_correct  (and (=> (= (ControlFlow 0 355954) 355946) inline$$XDX_initialize_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 355954) 351075) inline$$XDX_initialize_$def$0$anon58_Else_correct))))
(let ((inline$$XDX_initialize_$def$0$anon56_Else_correct  (=> (not $abort_flag@53) (and (=> (= (ControlFlow 0 351025) 355954) inline$$XDX_initialize_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 351025) 351033) inline$$XDX_initialize_$def$0$anon57_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon56_Then_correct  (=> $abort_flag@53 (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@18) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@14)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@7) (= (ControlFlow 0 355958) 345061))) inline$$XDX_initialize_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon76_correct  (=> (and (= $Diem_CurrencyInfo_$memory@7 |inline$$MoveToRaw$4$m'@2|) (= inline$$Diem_register_currency_$def$1$$ret0@2 inline$$Diem_MintCapability_pack$1$$struct@1)) (=> (and (and (= inline$$Diem_register_currency_$def$1$$ret1@2 inline$$Diem_BurnCapability_pack$1$$struct@1) (= $DiemConfig_Configuration_$memory@14 $DiemConfig_Configuration_$memory@12)) (and (= $abort_flag@53 $abort_flag@52) (= $DiemConfig_DiemConfig_$memory@18 $DiemConfig_DiemConfig_$memory@16))) (and (=> (= (ControlFlow 0 350581) 355958) inline$$XDX_initialize_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 350581) 351025) inline$$XDX_initialize_$def$0$anon56_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$1$anon114_Else_correct  (=> (and (not true) (= (ControlFlow 0 350579) 350581)) inline$$Diem_register_currency_$def$1$anon76_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon114_Then_correct  (=> (= (ControlFlow 0 350589) 350581) inline$$Diem_register_currency_$def$1$anon76_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon113_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 350569) 350589) inline$$Diem_register_currency_$def$1$anon114_Then_correct) (=> (= (ControlFlow 0 350569) 350579) inline$$Diem_register_currency_$def$1$anon114_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon113_Then_correct  (and (=> (= (ControlFlow 0 350597) 350589) inline$$Diem_register_currency_$def$1$anon114_Then_correct) (=> (= (ControlFlow 0 350597) 350579) inline$$Diem_register_currency_$def$1$anon114_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$1$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 350547) 350597) inline$$Diem_register_currency_$def$1$anon113_Then_correct) (=> (= (ControlFlow 0 350547) 350569) inline$$Diem_register_currency_$def$1$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$1$anon4_Then_correct  (and (=> (= (ControlFlow 0 350553) 350597) inline$$Diem_register_currency_$def$1$anon113_Then_correct) (=> (= (ControlFlow 0 350553) 350569) inline$$Diem_register_currency_$def$1$anon113_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 350541) 350553) inline$$Diem_BurnCapability_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 350541) 350547) inline$$Diem_BurnCapability_pack$1$anon4_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$1$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 350533) 350597) inline$$Diem_register_currency_$def$1$anon113_Then_correct) (=> (= (ControlFlow 0 350533) 350569) inline$$Diem_register_currency_$def$1$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$1$anon0_correct  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def$1$$t39@1) (= inline$$Diem_BurnCapability_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$1$$t39@1) 1)))) (and (=> (= (ControlFlow 0 350525) 350541) inline$$Diem_BurnCapability_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 350525) 350533) inline$$Diem_BurnCapability_pack$1$anon3_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon112_Else$1_correct  (=> (and (= inline$$Diem_register_currency_$def$1$$t39@1 ($Boolean false)) (= (ControlFlow 0 350559) 350525)) inline$$Diem_BurnCapability_pack$1$anon0_correct)))
(let ((inline$$Diem_MintCapability_pack$1$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 350376) 350559)) inline$$Diem_register_currency_$def$1$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$1$anon4_Then_correct  (=> (= (ControlFlow 0 350382) 350559) inline$$Diem_register_currency_$def$1$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 350370) 350382) inline$$Diem_MintCapability_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 350370) 350376) inline$$Diem_MintCapability_pack$1$anon4_Else_correct)))))
(let ((inline$$Diem_MintCapability_pack$1$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 350362) 350559)) inline$$Diem_register_currency_$def$1$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$1$anon0_correct  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def$1$$t37@1) (= inline$$Diem_MintCapability_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$1$$t37@1) 1)))) (and (=> (= (ControlFlow 0 350354) 350370) inline$$Diem_MintCapability_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 350354) 350362) inline$$Diem_MintCapability_pack$1$anon3_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon112_Else_correct  (=> (not $abort_flag@52) (=> (and (= inline$$Diem_register_currency_$def$1$$t37@1 ($Boolean false)) (= (ControlFlow 0 350388) 350354)) inline$$Diem_MintCapability_pack$1$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$1$Abort_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def$1$$ret0@1 $Error) (= inline$$Diem_register_currency_$def$1$$ret1@1 $Error)) (and (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory@6) (= inline$$Diem_register_currency_$def$1$$ret0@2 inline$$Diem_register_currency_$def$1$$ret0@1))) (and (and (= inline$$Diem_register_currency_$def$1$$ret1@2 inline$$Diem_register_currency_$def$1$$ret1@1) (= $DiemConfig_Configuration_$memory@14 $DiemConfig_Configuration_$memory@13)) (and (= $abort_flag@53 true) (= $DiemConfig_DiemConfig_$memory@18 $DiemConfig_DiemConfig_$memory@17)))) (and (=> (= (ControlFlow 0 347040) 355958) inline$$XDX_initialize_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 347040) 351025) inline$$XDX_initialize_$def$0$anon56_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon15_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350911) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 350909) 350911)) inline$$Diem_register_currency_$def$1$anon15_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon84_Then_correct  (=> (= (ControlFlow 0 350919) 350911) inline$$Diem_register_currency_$def$1$anon15_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon83_Then_correct  (=> $abort_flag@43 (and (=> (= (ControlFlow 0 350903) 350919) inline$$Diem_register_currency_$def$1$anon84_Then_correct) (=> (= (ControlFlow 0 350903) 350909) inline$$Diem_register_currency_$def$1$anon84_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon19_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350891) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 350889) 350891)) inline$$Diem_register_currency_$def$1$anon19_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon86_Then_correct  (=> (= (ControlFlow 0 350899) 350891) inline$$Diem_register_currency_$def$1$anon19_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon85_Then_correct  (=> $abort_flag@44 (and (=> (= (ControlFlow 0 350883) 350899) inline$$Diem_register_currency_$def$1$anon86_Then_correct) (=> (= (ControlFlow 0 350883) 350889) inline$$Diem_register_currency_$def$1$anon86_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon23_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350871) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 350869) 350871)) inline$$Diem_register_currency_$def$1$anon23_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon88_Then_correct  (=> (= (ControlFlow 0 350879) 350871) inline$$Diem_register_currency_$def$1$anon23_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon87_Then_correct  (=> $abort_flag@45 (and (=> (= (ControlFlow 0 350863) 350879) inline$$Diem_register_currency_$def$1$anon88_Then_correct) (=> (= (ControlFlow 0 350863) 350869) inline$$Diem_register_currency_$def$1$anon88_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon27_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350851) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon90_Else_correct  (=> (and (not true) (= (ControlFlow 0 350849) 350851)) inline$$Diem_register_currency_$def$1$anon27_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon90_Then_correct  (=> (= (ControlFlow 0 350859) 350851) inline$$Diem_register_currency_$def$1$anon27_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon89_Then_correct  (=> $abort_flag@46 (and (=> (= (ControlFlow 0 350843) 350859) inline$$Diem_register_currency_$def$1$anon90_Then_correct) (=> (= (ControlFlow 0 350843) 350849) inline$$Diem_register_currency_$def$1$anon90_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon41_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350733) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 350731) 350733)) inline$$Diem_register_currency_$def$1$anon41_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon97_Then_correct  (=> (= (ControlFlow 0 350741) 350733) inline$$Diem_register_currency_$def$1$anon41_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon96_Then_correct  (=> $abort_flag@47 (and (=> (= (ControlFlow 0 350725) 350741) inline$$Diem_register_currency_$def$1$anon97_Then_correct) (=> (= (ControlFlow 0 350725) 350731) inline$$Diem_register_currency_$def$1$anon97_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon49_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350713) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon101_Else_correct  (=> (and (not true) (= (ControlFlow 0 350711) 350713)) inline$$Diem_register_currency_$def$1$anon49_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon101_Then_correct  (=> (= (ControlFlow 0 350721) 350713) inline$$Diem_register_currency_$def$1$anon49_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon100_Then_correct  (=> $abort_flag@47 (and (=> (= (ControlFlow 0 350705) 350721) inline$$Diem_register_currency_$def$1$anon101_Then_correct) (=> (= (ControlFlow 0 350705) 350711) inline$$Diem_register_currency_$def$1$anon101_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon53_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350693) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon103_Else_correct  (=> (and (not true) (= (ControlFlow 0 350691) 350693)) inline$$Diem_register_currency_$def$1$anon53_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon103_Then_correct  (=> (= (ControlFlow 0 350701) 350693) inline$$Diem_register_currency_$def$1$anon53_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon102_Then_correct  (=> $abort_flag@47 (and (=> (= (ControlFlow 0 350685) 350701) inline$$Diem_register_currency_$def$1$anon103_Then_correct) (=> (= (ControlFlow 0 350685) 350691) inline$$Diem_register_currency_$def$1$anon103_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon57_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350673) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon105_Else_correct  (=> (and (not true) (= (ControlFlow 0 350671) 350673)) inline$$Diem_register_currency_$def$1$anon57_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon105_Then_correct  (=> (= (ControlFlow 0 350681) 350673) inline$$Diem_register_currency_$def$1$anon57_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon104_Then_correct  (=> $abort_flag@47 (and (=> (= (ControlFlow 0 350665) 350681) inline$$Diem_register_currency_$def$1$anon105_Then_correct) (=> (= (ControlFlow 0 350665) 350671) inline$$Diem_register_currency_$def$1$anon105_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon61_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350653) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon107_Else_correct  (=> (and (not true) (= (ControlFlow 0 350651) 350653)) inline$$Diem_register_currency_$def$1$anon61_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon107_Then_correct  (=> (= (ControlFlow 0 350661) 350653) inline$$Diem_register_currency_$def$1$anon61_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon106_Then_correct  (=> $abort_flag@47 (and (=> (= (ControlFlow 0 350645) 350661) inline$$Diem_register_currency_$def$1$anon107_Then_correct) (=> (= (ControlFlow 0 350645) 350651) inline$$Diem_register_currency_$def$1$anon107_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon65_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350633) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon109_Else_correct  (=> (and (not true) (= (ControlFlow 0 350631) 350633)) inline$$Diem_register_currency_$def$1$anon65_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon109_Then_correct  (=> (= (ControlFlow 0 350641) 350633) inline$$Diem_register_currency_$def$1$anon65_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon108_Then_correct  (=> $abort_flag@47 (and (=> (= (ControlFlow 0 350625) 350641) inline$$Diem_register_currency_$def$1$anon109_Then_correct) (=> (= (ControlFlow 0 350625) 350631) inline$$Diem_register_currency_$def$1$anon109_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon69_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 |inline$$MoveToRaw$4$m'@2|) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 350613) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 350611) 350613)) inline$$Diem_register_currency_$def$1$anon69_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon111_Then_correct  (=> (= (ControlFlow 0 350621) 350613) inline$$Diem_register_currency_$def$1$anon69_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon110_Then_correct  (=> $abort_flag@48 (and (=> (= (ControlFlow 0 350605) 350621) inline$$Diem_register_currency_$def$1$anon111_Then_correct) (=> (= (ControlFlow 0 350605) 350611) inline$$Diem_register_currency_$def$1$anon111_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon112_Then_correct  (=> $abort_flag@52 (=> (and (and (= $Diem_CurrencyInfo_$memory@6 |inline$$MoveToRaw$4$m'@2|) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@12)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@16) (= (ControlFlow 0 350601) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon41_Else_correct  (=> (and (and (not $abort_flag@51) (= $DiemConfig_DiemConfig_$memory@16 $DiemConfig_DiemConfig_$memory@14)) (and (= $DiemConfig_Configuration_$memory@12 $DiemConfig_Configuration_$memory@10) (= $abort_flag@52 $abort_flag@51))) (and (=> (= (ControlFlow 0 350085) 350601) inline$$Diem_register_currency_$def$1$anon112_Then_correct) (=> (= (ControlFlow 0 350085) 350388) inline$$Diem_register_currency_$def$1$anon112_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$Abort_correct  (=> (= $DiemConfig_DiemConfig_$memory@16 $DiemConfig_DiemConfig_$memory@15) (=> (and (= $DiemConfig_Configuration_$memory@12 $DiemConfig_Configuration_$memory@11) (= $abort_flag@52 true)) (and (=> (= (ControlFlow 0 349357) 350601) inline$$Diem_register_currency_$def$1$anon112_Then_correct) (=> (= (ControlFlow 0 349357) 350388) inline$$Diem_register_currency_$def$1$anon112_Else_correct))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon7_correct  (=> (= $DiemConfig_DiemConfig_$memory@15 $DiemConfig_DiemConfig_$memory@13) (=> (and (= $DiemConfig_Configuration_$memory@11 $DiemConfig_Configuration_$memory@9) (= (ControlFlow 0 350177) 349357)) inline$$RegisteredCurrencies_add_currency_code_$def$1$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 350175) 350177)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon7_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon32_Then_correct  (=> (= (ControlFlow 0 350185) 350177) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon7_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon31_Then_correct  (=> $abort_flag@49 (and (=> (= (ControlFlow 0 350169) 350185) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon32_Then_correct) (=> (= (ControlFlow 0 350169) 350175) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon32_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon11_correct  (=> (= $DiemConfig_DiemConfig_$memory@15 $DiemConfig_DiemConfig_$memory@13) (=> (and (= $DiemConfig_Configuration_$memory@11 $DiemConfig_Configuration_$memory@9) (= (ControlFlow 0 350157) 349357)) inline$$RegisteredCurrencies_add_currency_code_$def$1$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 350155) 350157)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon11_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon34_Then_correct  (=> (= (ControlFlow 0 350165) 350157) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon11_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon33_Then_correct  (=> $abort_flag@49 (and (=> (= (ControlFlow 0 350149) 350165) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon34_Then_correct) (=> (= (ControlFlow 0 350149) 350155) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon34_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon15_correct  (=> (= $DiemConfig_DiemConfig_$memory@15 $DiemConfig_DiemConfig_$memory@13) (=> (and (= $DiemConfig_Configuration_$memory@11 $DiemConfig_Configuration_$memory@9) (= (ControlFlow 0 350137) 349357)) inline$$RegisteredCurrencies_add_currency_code_$def$1$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 350135) 350137)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon15_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon36_Then_correct  (=> (= (ControlFlow 0 350145) 350137) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon15_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon35_Then_correct  (=> $abort_flag@50 (and (=> (= (ControlFlow 0 350129) 350145) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon36_Then_correct) (=> (= (ControlFlow 0 350129) 350135) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon36_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon23_correct  (=> (= $DiemConfig_DiemConfig_$memory@15 $DiemConfig_DiemConfig_$memory@13) (=> (and (= $DiemConfig_Configuration_$memory@11 $DiemConfig_Configuration_$memory@9) (= (ControlFlow 0 350117) 349357)) inline$$RegisteredCurrencies_add_currency_code_$def$1$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 350115) 350117)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon23_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon40_Then_correct  (=> (= (ControlFlow 0 350125) 350117) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon23_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon39_Then_correct  (=> $abort_flag@50 (and (=> (= (ControlFlow 0 350109) 350125) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon40_Then_correct) (=> (= (ControlFlow 0 350109) 350115) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon40_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon27_correct  (=> (= $DiemConfig_DiemConfig_$memory@15 $DiemConfig_DiemConfig_$memory@14) (=> (and (= $DiemConfig_Configuration_$memory@11 $DiemConfig_Configuration_$memory@10) (= (ControlFlow 0 350097) 349357)) inline$$RegisteredCurrencies_add_currency_code_$def$1$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 350095) 350097)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon27_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon42_Then_correct  (=> (= (ControlFlow 0 350105) 350097) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon27_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon41_Then_correct  (=> $abort_flag@51 (and (=> (= (ControlFlow 0 350089) 350105) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon42_Then_correct) (=> (= (ControlFlow 0 350089) 350095) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon42_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon39_Else$3_correct  (=> (and (= call0formal@$tv0@0@@9 $RegisteredCurrencies_RegisteredCurrencies_type_value) (= call3formal@$DiemConfig_Configuration_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 350079) (- 0 437478)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@9) 1) (|a#$Address| dr_account))))))) $abort_flag@51) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@13) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@9) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@51)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@9) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@9) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@51) (=> $abort_flag@51 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@9) 1) (|a#$Address| dr_account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@13) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@9) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@9) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@9) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@51 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@9) 1) (|a#$Address| dr_account))))))) (= $abort_code@49 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@13) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@9) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@49 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@9) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@9) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@49 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@51) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@9) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@51) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@9) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)) |inline$$WritebackToValue$1$vdst'@2|)))) (=> (not $abort_flag@51) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@9) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@10) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@10) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@9) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@10) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@10) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@9) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@10) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 350079) 350089) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon41_Then_correct) (=> (= (ControlFlow 0 350079) 350085) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon41_Else_correct)))))))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| call3formal@$ret0@0@@22) (= (ControlFlow 0 350045) 350079)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon39_Else$3_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 2)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 call3formal@$ret0@0@@22 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 350071) 350079))) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon39_Else$3_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowLoc$1$dst@1)) (and (=> (= (ControlFlow 0 349890) 350071) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 349890) 350045) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (and (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|))) (and (=> (= (ControlFlow 0 349946) 350071) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 349946) 350045) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 349854) 349946) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 349854) 349890) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (and (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) |inline$$Vector_push_back$1$v'@1|)) (= (ControlFlow 0 349711) 349854)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon39_Else_correct  (=> (and (not $abort_flag@50) (= (ControlFlow 0 349717) 349711)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$Vector_push_back$1$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1) (= |inline$$Vector_push_back$1$v'@1| ($Vector (let ((len@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) len@@0 inline$$XDX_initialize_$def$0$$t20@1) (+ len@@0 1)))))) (and (=> (= (ControlFlow 0 349646) 350109) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon39_Then_correct) (=> (= (ControlFlow 0 349646) 349717) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon39_Else_correct)))))
(let ((inline$$Vector_push_back$1$Entry_correct  (=> (and (= inline$$Vector_push_back$1$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 349634) 349646)) inline$$Vector_push_back$1$anon0_correct)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 349581) 349634)) inline$$Vector_push_back$1$Entry_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $RegisteredCurrencies_RegisteredCurrencies_currency_codes) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) (= (ControlFlow 0 349543) 349581))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 2) $EmptyPath call3formal@$ret0@0@@22)) (= (ControlFlow 0 349419) 349543)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon37_Then_correct  (=> (and (|b#$Boolean| inline$$Not$7$dst@1) (= (ControlFlow 0 349425) 349419)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon20_correct  (=> (= $DiemConfig_DiemConfig_$memory@15 $DiemConfig_DiemConfig_$memory@13) (=> (and (= $DiemConfig_Configuration_$memory@11 $DiemConfig_Configuration_$memory@9) (= (ControlFlow 0 349353) 349357)) inline$$RegisteredCurrencies_add_currency_code_$def$1$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 349351) 349353)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon20_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon38_Then_correct  (=> (= (ControlFlow 0 349365) 349353) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon20_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$7$dst@1)) (= $abort_code@48 (|i#$Integer| call3formal@$ret0@0@@23))) (and (=> (= (ControlFlow 0 349345) 349365) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon38_Then_correct) (=> (= (ControlFlow 0 349345) 349351) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon38_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon35_Else_correct  (=> (not $abort_flag@50) (and (=> (= (ControlFlow 0 349333) 349425) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon37_Then_correct) (=> (= (ControlFlow 0 349333) 349345) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon37_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon33_Else$1_correct  (=> (and (and (and (= inline$$RegisteredCurrencies_add_currency_code_$def$1$$t10@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@50)) (and (=> $abort_flag@50 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@50) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@23 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@23) (>= (|i#$Integer| call3formal@$ret0@0@@23) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@23) $MAX_U64))) (and (=> (= (ControlFlow 0 349327) 350129) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon35_Then_correct) (=> (= (ControlFlow 0 349327) 349333) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon35_Else_correct)))))
(let ((inline$$Not$7$anon0_correct  (=> (and (= inline$$Not$7$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Vector_contains$1$res@1)))) (= (ControlFlow 0 349315) 349327)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon33_Else$1_correct)))
(let ((inline$$Not$7$Entry_correct  (and (=> (= (ControlFlow 0 349305) (- 0 436994)) true) (=> (= (ControlFlow 0 349305) 349315) inline$$Not$7$anon0_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon33_Else_correct  (=> (and (not $abort_flag@49) (= (ControlFlow 0 349321) 349305)) inline$$Not$7$Entry_correct)))
(let ((inline$$Vector_contains$1$anon0_correct  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$1$dst@1) (= inline$$Vector_contains$1$res@1 ($Boolean (exists ((i@@10 Int) )  (and (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1)) i@@10) inline$$XDX_initialize_$def$0$$t20@1)))))) (and (=> (= (ControlFlow 0 349259) 350149) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon33_Then_correct) (=> (= (ControlFlow 0 349259) 349321) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon33_Else_correct)))))
(let ((inline$$Vector_contains$1$Entry_correct  (=> (and (= inline$$Vector_contains$1$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 349245) 349259)) inline$$Vector_contains$1$anon0_correct)))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@22)) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)) (= (ControlFlow 0 349190) 349245)) inline$$Vector_contains$1$Entry_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon31_Else_correct  (=> (and (not $abort_flag@49) (= (ControlFlow 0 349196) 349190)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon4$2_correct  (=> (= call0formal@$tv0@0@@10 $RegisteredCurrencies_RegisteredCurrencies_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@13) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@49) (=> $abort_flag@49 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@13) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@10) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@49 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@13) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@49) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@22 (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@13) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@10) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 349144) 350169) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon31_Then_correct) (=> (= (ControlFlow 0 349144) 349196) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon31_Else_correct))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 349074) 349144)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon4$2_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon30_Then_correct  (=> (= (ControlFlow 0 350193) 349144) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon4$2_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 349066) 350193) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 349066) 349074) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon30_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon29_Then_correct  (and (=> (= (ControlFlow 0 350201) 350193) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 350201) 349074) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon30_Else_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$1$anon0_correct  (=> (not $abort_flag@48) (and (=> (= (ControlFlow 0 349060) 350201) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon29_Then_correct) (=> (= (ControlFlow 0 349060) 349066) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon29_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code$1$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and ((_ is $Vector) inline$$XDX_initialize_$def$0$$t20@1) (let ((va@@60 (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))) (forall ((inline$$RegisteredCurrencies_add_currency_code$1$$$0 Int) ) (!  (=> (and (>= inline$$RegisteredCurrencies_add_currency_code$1$$$0 0) (< inline$$RegisteredCurrencies_add_currency_code$1$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$RegisteredCurrencies_add_currency_code$1$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$RegisteredCurrencies_add_currency_code$1$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$RegisteredCurrencies_add_currency_code$1$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$RegisteredCurrencies_add_currency_code$1$$$0))
))) (= (ControlFlow 0 350205) 349060)) inline$$RegisteredCurrencies_add_currency_code_$def$1$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon110_Else_correct  (=> (and (not $abort_flag@48) (= (ControlFlow 0 350211) 350205)) inline$$RegisteredCurrencies_add_currency_code$1$anon0_correct)))
(let ((inline$$MoveToRaw$4$anon3_Then$1_correct  (=> (and (= $abort_flag@48 true) (= |inline$$MoveToRaw$4$m'@2| |inline$$MoveToRaw$4$m'@0|)) (and (=> (= (ControlFlow 0 348408) 350605) inline$$Diem_register_currency_$def$1$anon110_Then_correct) (=> (= (ControlFlow 0 348408) 350211) inline$$Diem_register_currency_$def$1$anon110_Else_correct)))))
(let ((inline$$MoveToRaw$4$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@5) inline$$MoveTo$4$ta@0 inline$$MoveTo$4$a@1) (= (ControlFlow 0 348406) 348408)) inline$$MoveToRaw$4$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$4$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@5) inline$$MoveTo$4$ta@0 inline$$MoveTo$4$a@1)) (= |inline$$MoveToRaw$4$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@5) inline$$MoveTo$4$ta@0 inline$$MoveTo$4$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@5) inline$$MoveTo$4$ta@0 inline$$MoveTo$4$a@1 inline$$Diem_CurrencyInfo_pack$1$$struct@1)))) (and (= $abort_flag@48 $abort_flag@47) (= |inline$$MoveToRaw$4$m'@2| |inline$$MoveToRaw$4$m'@1|))) (and (=> (= (ControlFlow 0 348356) 350605) inline$$Diem_register_currency_$def$1$anon110_Then_correct) (=> (= (ControlFlow 0 348356) 350211) inline$$Diem_register_currency_$def$1$anon110_Else_correct)))))
(let ((inline$$MoveTo$4$anon0$1_correct  (=> (= inline$$MoveTo$4$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 348414) 348406) inline$$MoveToRaw$4$anon3_Then_correct) (=> (= (ControlFlow 0 348414) 348356) inline$$MoveToRaw$4$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$4$Entry_correct  (and (=> (= (ControlFlow 0 348202) (- 0 436537)) true) (=> (= (ControlFlow 0 348202) 348414) inline$$MoveTo$4$anon0$1_correct))))
(let ((inline$$MoveTo$4$Entry_correct  (=> (and (= inline$$MoveTo$4$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_currency$1$$tv0@0) 1)) (= (ControlFlow 0 348174) 348202)) inline$$Signer_borrow_address$4$Entry_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$1$anon3_correct  (and (=> (= (ControlFlow 0 348062) (- 0 436451)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$1$$struct@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$1$$struct@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$1$$struct@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$1$$struct@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 348062) 348174) inline$$MoveTo$4$Entry_correct)))))
(let ((inline$$Diem_CurrencyInfo_pack$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 348076) 348062)) inline$$Diem_CurrencyInfo_pack$1$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$1$anon5_Then_correct  (=> (= (ControlFlow 0 348082) 348062) inline$$Diem_CurrencyInfo_pack$1$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$1$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 348070) 348082) inline$$Diem_CurrencyInfo_pack$1$anon5_Then_correct) (=> (= (ControlFlow 0 348070) 348076) inline$$Diem_CurrencyInfo_pack$1$anon5_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_pack$1$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 348014) 348062)) inline$$Diem_CurrencyInfo_pack$1$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$1$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_register_currency_$def$1$$t28@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def$1$$t28@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def$1$$t28@1) $MAX_U128)) (and (and ((_ is $Integer) inline$$Diem_register_currency_$def$1$$t29@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def$1$$t29@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def$1$$t29@1) $MAX_U64))) (=> (and (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@3) (let ((va@@61 (|v#$Vector| call4formal@$ret0@0@@3)))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) inline$$XDX_initialize_$def$0$$t17@1)) (and (and (and (and ((_ is $Integer) inline$$XDX_initialize_$def$0$$t18@1) (>= (|i#$Integer| inline$$XDX_initialize_$def$0$$t18@1) 0)) (<= (|i#$Integer| inline$$XDX_initialize_$def$0$$t18@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$XDX_initialize_$def$0$$t19@1) (>= (|i#$Integer| inline$$XDX_initialize_$def$0$$t19@1) 0)) (<= (|i#$Integer| inline$$XDX_initialize_$def$0$$t19@1) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$XDX_initialize_$def$0$$t20@1) (let ((va@@62 (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
)))))) (forall ((inline$$Diem_CurrencyInfo_pack$1$$$0 Int) ) (!  (=> (and (>= inline$$Diem_CurrencyInfo_pack$1$$$0 0) (< inline$$Diem_CurrencyInfo_pack$1$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$Diem_CurrencyInfo_pack$1$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$Diem_CurrencyInfo_pack$1$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$Diem_CurrencyInfo_pack$1$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$Diem_CurrencyInfo_pack$1$$$0))
))) ((_ is $Boolean) inline$$Diem_register_currency_$def$1$$t30@1)))) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$5$res@0) (let ((va@@63 (|v#$Vector| inline$$Event_new_event_handle$5$res@0)))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_guid)) (let ((va@@64 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_guid))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_guid))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_guid))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_guid))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$5$res@0)) $Event_EventHandle_guid))) $$0@@9))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$6$res@0) (let ((va@@65 (|v#$Vector| inline$$Event_new_event_handle$6$res@0)))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_guid)) (let ((va@@66 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_guid))))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_guid))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_guid))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_guid))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$6$res@0)) $Event_EventHandle_guid))) $$0@@10))
))) true)) (=> (and (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$7$res@0) (let ((va@@67 (|v#$Vector| inline$$Event_new_event_handle$7$res@0)))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_guid)) (let ((va@@68 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_guid))))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_guid))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_guid))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_guid))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$7$res@0)) $Event_EventHandle_guid))) $$0@@11))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$8$res@0) (let ((va@@69 (|v#$Vector| inline$$Event_new_event_handle$8$res@0)))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_guid)) (let ((va@@70 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_guid))))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_guid))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_guid))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_guid))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$8$res@0)) $Event_EventHandle_guid))) $$0@@12))
))) true)) (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$9$res@0) (let ((va@@71 (|v#$Vector| inline$$Event_new_event_handle$9$res@0)))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_guid)) (let ((va@@72 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_guid))))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_guid))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_guid))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_guid))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$9$res@0)) $Event_EventHandle_guid))) $$0@@13))
))) true) (= inline$$Diem_CurrencyInfo_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$1$$t28@1) 1 inline$$Diem_register_currency_$def$1$$t29@1) 2 call4formal@$ret0@0@@3) 3 inline$$XDX_initialize_$def$0$$t17@1) 4 inline$$XDX_initialize_$def$0$$t18@1) 5 inline$$XDX_initialize_$def$0$$t19@1) 6 inline$$XDX_initialize_$def$0$$t20@1) 7 inline$$Diem_register_currency_$def$1$$t30@1) 8 inline$$Event_new_event_handle$5$res@0) 9 inline$$Event_new_event_handle$6$res@0) 10 inline$$Event_new_event_handle$7$res@0) 11 inline$$Event_new_event_handle$8$res@0) 12 inline$$Event_new_event_handle$9$res@0) 13))))) (and (=> (= (ControlFlow 0 348006) 348070) inline$$Diem_CurrencyInfo_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 348006) 348014) inline$$Diem_CurrencyInfo_pack$1$anon4_Else_correct))))))))
(let ((inline$$Diem_register_currency_$def$1$anon108_Else_correct  (=> (and (not $abort_flag@47) (= (ControlFlow 0 348088) 348006)) inline$$Diem_CurrencyInfo_pack$1$anon0_correct)))
(let ((inline$$Event_new_event_handle$9$Entry_correct  (=> (= inline$$Event_new_event_handle$9$t@0 $Diem_ToXDXExchangeRateUpdateEvent_type_value) (and (=> (= (ControlFlow 0 347428) 350625) inline$$Diem_register_currency_$def$1$anon108_Then_correct) (=> (= (ControlFlow 0 347428) 348088) inline$$Diem_register_currency_$def$1$anon108_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon106_Else_correct  (=> (and (not $abort_flag@47) (= (ControlFlow 0 347436) 347428)) inline$$Event_new_event_handle$9$Entry_correct)))
(let ((inline$$Event_new_event_handle$8$Entry_correct  (=> (= inline$$Event_new_event_handle$8$t@0 $Diem_CancelBurnEvent_type_value) (and (=> (= (ControlFlow 0 347386) 350645) inline$$Diem_register_currency_$def$1$anon106_Then_correct) (=> (= (ControlFlow 0 347386) 347436) inline$$Diem_register_currency_$def$1$anon106_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon104_Else_correct  (=> (and (not $abort_flag@47) (= (ControlFlow 0 347394) 347386)) inline$$Event_new_event_handle$8$Entry_correct)))
(let ((inline$$Event_new_event_handle$7$Entry_correct  (=> (= inline$$Event_new_event_handle$7$t@0 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 347344) 350665) inline$$Diem_register_currency_$def$1$anon104_Then_correct) (=> (= (ControlFlow 0 347344) 347394) inline$$Diem_register_currency_$def$1$anon104_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon102_Else_correct  (=> (and (not $abort_flag@47) (= (ControlFlow 0 347352) 347344)) inline$$Event_new_event_handle$7$Entry_correct)))
(let ((inline$$Event_new_event_handle$6$Entry_correct  (=> (= inline$$Event_new_event_handle$6$t@0 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 347302) 350685) inline$$Diem_register_currency_$def$1$anon102_Then_correct) (=> (= (ControlFlow 0 347302) 347352) inline$$Diem_register_currency_$def$1$anon102_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon100_Else_correct  (=> (and (not $abort_flag@47) (= (ControlFlow 0 347310) 347302)) inline$$Event_new_event_handle$6$Entry_correct)))
(let ((inline$$Event_new_event_handle$5$Entry_correct  (=> (= inline$$Event_new_event_handle$5$t@0 $Diem_MintEvent_type_value) (and (=> (= (ControlFlow 0 347260) 350705) inline$$Diem_register_currency_$def$1$anon100_Then_correct) (=> (= (ControlFlow 0 347260) 347310) inline$$Diem_register_currency_$def$1$anon100_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon98_Then_correct  (=> (|b#$Boolean| |inline$$Diem_register_currency_$def$1$tmp#$10@1|) (=> (and (and (= inline$$Diem_register_currency_$def$1$$t28@1 ($Integer 0)) (= inline$$Diem_register_currency_$def$1$$t29@1 ($Integer 0))) (and (= inline$$Diem_register_currency_$def$1$$t30@1 ($Boolean true)) (= (ControlFlow 0 347268) 347260))) inline$$Event_new_event_handle$5$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon46_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 347208) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 347206) 347208)) inline$$Diem_register_currency_$def$1$anon46_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon99_Then_correct  (=> (= (ControlFlow 0 347216) 347208) inline$$Diem_register_currency_$def$1$anon46_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon98_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Diem_register_currency_$def$1$tmp#$10@1|)) (= $abort_code@45 (|i#$Integer| call3formal@$ret0@0@@24))) (and (=> (= (ControlFlow 0 347200) 347216) inline$$Diem_register_currency_$def$1$anon99_Then_correct) (=> (= (ControlFlow 0 347200) 347206) inline$$Diem_register_currency_$def$1$anon99_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon96_Else_correct  (=> (not $abort_flag@47) (and (=> (= (ControlFlow 0 347188) 347268) inline$$Diem_register_currency_$def$1$anon98_Then_correct) (=> (= (ControlFlow 0 347188) 347200) inline$$Diem_register_currency_$def$1$anon98_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$L5_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def$1$$t26@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@47)) (and (=> $abort_flag@47 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@47) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@24 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@24) (>= (|i#$Integer| call3formal@$ret0@0@@24) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@24) $MAX_U64))) (and (=> (= (ControlFlow 0 347182) 350725) inline$$Diem_register_currency_$def$1$anon96_Then_correct) (=> (= (ControlFlow 0 347182) 347188) inline$$Diem_register_currency_$def$1$anon96_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon36_correct  (=> (and (= |inline$$Diem_register_currency_$def$1$tmp#$10@1| inline$$Le$1$dst@1) (= (ControlFlow 0 350831) 347182)) inline$$Diem_register_currency_$def$1$L5_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 350829) 350831)) inline$$Diem_register_currency_$def$1$anon36_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon94_Then_correct  (=> (= (ControlFlow 0 350839) 350831) inline$$Diem_register_currency_$def$1$anon36_correct)))
(let ((inline$$Le$1$anon0_correct  (=> (= inline$$Le$1$dst@1 ($Boolean (<= (|i#$Integer| inline$$XDX_initialize_$def$0$$t18@1) (|i#$Integer| inline$$Diem_register_currency_$def$1$$t24@1)))) (and (=> (= (ControlFlow 0 350815) 350839) inline$$Diem_register_currency_$def$1$anon94_Then_correct) (=> (= (ControlFlow 0 350815) 350829) inline$$Diem_register_currency_$def$1$anon94_Else_correct)))))
(let ((inline$$Le$1$Entry_correct  (and (=> (= (ControlFlow 0 350801) (- 0 435973)) true) (=> (= (ControlFlow 0 350801) 350815) inline$$Le$1$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon93_Then_correct  (=> (|b#$Boolean| inline$$Lt$1$dst@1) (=> (and (= inline$$Diem_register_currency_$def$1$$t24@1 ($Integer 10000000000)) (= (ControlFlow 0 350821) 350801)) inline$$Le$1$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon38_correct  (=> (and (= |inline$$Diem_register_currency_$def$1$tmp#$10@1| inline$$Diem_register_currency_$def$1$$t25@1) (= (ControlFlow 0 347176) 347182)) inline$$Diem_register_currency_$def$1$L5_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 347174) 347176)) inline$$Diem_register_currency_$def$1$anon38_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon95_Then_correct  (=> (= (ControlFlow 0 350749) 347176) inline$$Diem_register_currency_$def$1$anon38_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon93_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$1$dst@1)) (= inline$$Diem_register_currency_$def$1$$t25@1 ($Boolean false))) (and (=> (= (ControlFlow 0 347166) 350749) inline$$Diem_register_currency_$def$1$anon95_Then_correct) (=> (= (ControlFlow 0 347166) 347174) inline$$Diem_register_currency_$def$1$anon95_Else_correct)))))
(let ((inline$$Lt$1$anon0_correct  (=> (= inline$$Lt$1$dst@1 ($Boolean (< (|i#$Integer| inline$$Diem_register_currency_$def$1$$t22@1) (|i#$Integer| inline$$XDX_initialize_$def$0$$t18@1)))) (and (=> (= (ControlFlow 0 347114) 350821) inline$$Diem_register_currency_$def$1$anon93_Then_correct) (=> (= (ControlFlow 0 347114) 347166) inline$$Diem_register_currency_$def$1$anon93_Else_correct)))))
(let ((inline$$Lt$1$Entry_correct  (and (=> (= (ControlFlow 0 347100) (- 0 435898)) true) (=> (= (ControlFlow 0 347100) 347114) inline$$Lt$1$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon91_Then_correct  (=> (|b#$Boolean| inline$$Not$6$dst@1) (=> (and (= inline$$Diem_register_currency_$def$1$$t22@1 ($Integer 0)) (= (ControlFlow 0 347120) 347100)) inline$$Lt$1$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon32_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $DiemConfig_Configuration_$memory@13 $DiemConfig_Configuration_$memory@9)) (and (= $DiemConfig_DiemConfig_$memory@17 $DiemConfig_DiemConfig_$memory@13) (= (ControlFlow 0 347032) 347040))) inline$$Diem_register_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 347030) 347032)) inline$$Diem_register_currency_$def$1$anon32_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon92_Then_correct  (=> (= (ControlFlow 0 347048) 347032) inline$$Diem_register_currency_$def$1$anon32_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon91_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$6$dst@1)) (= $abort_code@43 (|i#$Integer| call3formal@$ret0@0@@25))) (and (=> (= (ControlFlow 0 347024) 347048) inline$$Diem_register_currency_$def$1$anon92_Then_correct) (=> (= (ControlFlow 0 347024) 347030) inline$$Diem_register_currency_$def$1$anon92_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon89_Else_correct  (=> (not $abort_flag@46) (and (=> (= (ControlFlow 0 347012) 347120) inline$$Diem_register_currency_$def$1$anon91_Then_correct) (=> (= (ControlFlow 0 347012) 347024) inline$$Diem_register_currency_$def$1$anon91_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon87_Else$1_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def$1$$t20@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@46)) (and (=> $abort_flag@46 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@46) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@25 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@25) (>= (|i#$Integer| call3formal@$ret0@0@@25) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@25) $MAX_U64))) (and (=> (= (ControlFlow 0 347006) 350843) inline$$Diem_register_currency_$def$1$anon89_Then_correct) (=> (= (ControlFlow 0 347006) 347012) inline$$Diem_register_currency_$def$1$anon89_Else_correct)))))
(let ((inline$$Not$6$anon0_correct  (=> (and (= inline$$Not$6$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_register_currency_$def$1$$t18@1)))) (= (ControlFlow 0 346994) 347006)) inline$$Diem_register_currency_$def$1$anon87_Else$1_correct)))
(let ((inline$$Not$6$Entry_correct  (and (=> (= (ControlFlow 0 346984) (- 0 435768)) true) (=> (= (ControlFlow 0 346984) 346994) inline$$Not$6$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon87_Else_correct  (=> (not $abort_flag@45) (=> (and (= inline$$Diem_register_currency_$def$1$$t18@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_currency$1$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@26)))) (= (ControlFlow 0 347000) 346984)) inline$$Not$6$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon85_Else_correct  (=> (not $abort_flag@44) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@45) (=> $abort_flag@45 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@45) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@26 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@26))) (and (=> (= (ControlFlow 0 346926) 350863) inline$$Diem_register_currency_$def$1$anon87_Then_correct) (=> (= (ControlFlow 0 346926) 347000) inline$$Diem_register_currency_$def$1$anon87_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$1$anon83_Else_correct  (=> (and (and (not $abort_flag@43) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@44)) (and (=> $abort_flag@44 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@44 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@40 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 346920) 350883) inline$$Diem_register_currency_$def$1$anon85_Then_correct) (=> (= (ControlFlow 0 346920) 346926) inline$$Diem_register_currency_$def$1$anon85_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon12$6_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@43) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@43)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@43) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@43)) (and (=> $abort_flag@43 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@43 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@39 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@39 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@39 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@39 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 346914) 350903) inline$$Diem_register_currency_$def$1$anon83_Then_correct) (=> (= (ControlFlow 0 346914) 346920) inline$$Diem_register_currency_$def$1$anon83_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$1$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 346708) 346914)) inline$$Diem_register_currency_$def$1$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon82_Then_correct  (=> (= (ControlFlow 0 350927) 346914) inline$$Diem_register_currency_$def$1$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def$1$anon81_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 346700) 350927) inline$$Diem_register_currency_$def$1$anon82_Then_correct) (=> (= (ControlFlow 0 346700) 346708) inline$$Diem_register_currency_$def$1$anon82_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon81_Then_correct  (and (=> (= (ControlFlow 0 350935) 350927) inline$$Diem_register_currency_$def$1$anon82_Then_correct) (=> (= (ControlFlow 0 350935) 346708) inline$$Diem_register_currency_$def$1$anon82_Else_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon80_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 346692) 350935) inline$$Diem_register_currency_$def$1$anon81_Then_correct) (=> (= (ControlFlow 0 346692) 346700) inline$$Diem_register_currency_$def$1$anon81_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon80_Then_correct  (and (=> (= (ControlFlow 0 350943) 350935) inline$$Diem_register_currency_$def$1$anon81_Then_correct) (=> (= (ControlFlow 0 350943) 346700) inline$$Diem_register_currency_$def$1$anon81_Else_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon79_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 346684) 350943) inline$$Diem_register_currency_$def$1$anon80_Then_correct) (=> (= (ControlFlow 0 346684) 346692) inline$$Diem_register_currency_$def$1$anon80_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon79_Then_correct  (and (=> (= (ControlFlow 0 350951) 350943) inline$$Diem_register_currency_$def$1$anon80_Then_correct) (=> (= (ControlFlow 0 350951) 346692) inline$$Diem_register_currency_$def$1$anon80_Else_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon78_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 346676) 350951) inline$$Diem_register_currency_$def$1$anon79_Then_correct) (=> (= (ControlFlow 0 346676) 346684) inline$$Diem_register_currency_$def$1$anon79_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon78_Then_correct  (and (=> (= (ControlFlow 0 350959) 350951) inline$$Diem_register_currency_$def$1$anon79_Then_correct) (=> (= (ControlFlow 0 350959) 346684) inline$$Diem_register_currency_$def$1$anon79_Else_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon77_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 346668) 350959) inline$$Diem_register_currency_$def$1$anon78_Then_correct) (=> (= (ControlFlow 0 346668) 346676) inline$$Diem_register_currency_$def$1$anon78_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$1$anon77_Then_correct  (and (=> (= (ControlFlow 0 350967) 350959) inline$$Diem_register_currency_$def$1$anon78_Then_correct) (=> (= (ControlFlow 0 350967) 346676) inline$$Diem_register_currency_$def$1$anon78_Else_correct))))
(let ((inline$$Diem_register_currency_$def$1$anon0_correct  (=> (not $abort_flag@42) (and (=> (= (ControlFlow 0 346662) 350967) inline$$Diem_register_currency_$def$1$anon77_Then_correct) (=> (= (ControlFlow 0 346662) 346668) inline$$Diem_register_currency_$def$1$anon77_Else_correct)))))
(let ((inline$$Diem_register_currency$1$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@3) (let ((va@@73 (|v#$Vector| call4formal@$ret0@0@@3)))
(let ((l@@73 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) inline$$XDX_initialize_$def$0$$t17@1)) (and (and (and (and ((_ is $Integer) inline$$XDX_initialize_$def$0$$t18@1) (>= (|i#$Integer| inline$$XDX_initialize_$def$0$$t18@1) 0)) (<= (|i#$Integer| inline$$XDX_initialize_$def$0$$t18@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$XDX_initialize_$def$0$$t19@1) (>= (|i#$Integer| inline$$XDX_initialize_$def$0$$t19@1) 0)) (<= (|i#$Integer| inline$$XDX_initialize_$def$0$$t19@1) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$XDX_initialize_$def$0$$t20@1) (let ((va@@74 (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)))
(let ((l@@74 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74))
)))))) (forall ((inline$$Diem_register_currency$1$$$0 Int) ) (!  (=> (and (>= inline$$Diem_register_currency$1$$$0 0) (< inline$$Diem_register_currency$1$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$Diem_register_currency$1$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$Diem_register_currency$1$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$Diem_register_currency$1$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XDX_initialize_$def$0$$t20@1)) inline$$Diem_register_currency$1$$$0))
))) (= (ControlFlow 0 350975) 346662)))) inline$$Diem_register_currency_$def$1$anon0_correct))))
(let ((inline$$Diem_register_currency$1$Entry_correct  (=> (and (= inline$$Diem_register_currency$1$$tv0@0 $XDX_XDX_type_value) (= (ControlFlow 0 345302) 350975)) inline$$Diem_register_currency$1$anon0_correct)))
(let ((inline$$XDX_initialize_$def$0$anon54_Else_correct  (=> (and (not $abort_flag@42) (= inline$$XDX_initialize_$def$0$$t17@1 ($Boolean true))) (=> (and (and (= inline$$XDX_initialize_$def$0$$t18@1 ($Integer 1000000)) (= inline$$XDX_initialize_$def$0$$t19@1 ($Integer 1000))) (and (= inline$$XDX_initialize_$def$0$$t20@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 88)) 1 ($Integer 68)) 2 ($Integer 88)) 3))) (= (ControlFlow 0 350985) 345302))) inline$$Diem_register_currency$1$Entry_correct))))
(let ((inline$$XDX_initialize_$def$0$anon52_Then_correct  (=> (|b#$Boolean| inline$$Not$5$dst@1) (=> (and (and (and (= inline$$XDX_initialize_$def$0$$t14@1 ($Integer 1)) (= inline$$XDX_initialize_$def$0$$t15@1 ($Integer 1))) (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl inline$$XDX_initialize_$def$0$$t15@1 ($Integer 32)) ($Integer 0)))) $abort_flag@42) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t14@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t15@1 ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl inline$$XDX_initialize_$def$0$$t14@1 ($Integer 64)) ($Integer 0)))))))) $abort_flag@42))) (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t14@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t15@1 ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@42) (=> $abort_flag@42 (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl inline$$XDX_initialize_$def$0$$t15@1 ($Integer 32)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t14@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t15@1 ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl inline$$XDX_initialize_$def$0$$t14@1 ($Integer 64)) ($Integer 0))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t14@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t15@1 ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (and (=> $abort_flag@42 (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl inline$$XDX_initialize_$def$0$$t15@1 ($Integer 32)) ($Integer 0)))) (= $abort_code@37 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t14@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t15@1 ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl inline$$XDX_initialize_$def$0$$t14@1 ($Integer 64)) ($Integer 0)))))))) (= $abort_code@37 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t14@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XDX_initialize_$def$0$$t15@1 ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@37 (|i#$Integer| ($Integer 8)))))) (=> (not $abort_flag@42) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@3 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$XDX_initialize_$def$0$$t14@1 inline$$XDX_initialize_$def$0$$t15@1))) ($Vector (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Integer 1)) (+ len@@1 1)))) ($Vector (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 ($Integer 2)) (+ len@@2 1)))))))))))) (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@3) (let ((va@@75 (|v#$Vector| call4formal@$ret0@0@@3)))
(let ((l@@75 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 345083) 355962) inline$$XDX_initialize_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 345083) 350985) inline$$XDX_initialize_$def$0$anon54_Else_correct)))))))
(let ((inline$$XDX_initialize_$def$0$anon22_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@13) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@9)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@5) (= (ControlFlow 0 345057) 345061))) inline$$XDX_initialize_$def$0$Abort_correct)))
(let ((inline$$XDX_initialize_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 345055) 345057)) inline$$XDX_initialize_$def$0$anon22_correct)))
(let ((inline$$XDX_initialize_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 345069) 345057) inline$$XDX_initialize_$def$0$anon22_correct)))
(let ((inline$$XDX_initialize_$def$0$anon52_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$5$dst@1)) (= $abort_code@38 (|i#$Integer| call3formal@$ret0@0@@27))) (and (=> (= (ControlFlow 0 345049) 345069) inline$$XDX_initialize_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 345049) 345055) inline$$XDX_initialize_$def$0$anon53_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon50_Else_correct  (=> (not $abort_flag@41) (and (=> (= (ControlFlow 0 345037) 345083) inline$$XDX_initialize_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 345037) 345049) inline$$XDX_initialize_$def$0$anon52_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon49_Else$1_correct  (=> (and (and (and (= inline$$XDX_initialize_$def$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@41)) (and (=> $abort_flag@41 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@41) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@27 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@27) (>= (|i#$Integer| call3formal@$ret0@0@@27) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@27) $MAX_U64))) (and (=> (= (ControlFlow 0 345031) 355982) inline$$XDX_initialize_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 345031) 345037) inline$$XDX_initialize_$def$0$anon50_Else_correct)))))
(let ((inline$$Not$5$anon0_correct  (=> (and (= inline$$Not$5$dst@1 ($Boolean  (not (|b#$Boolean| inline$$XDX_initialize_$def$0$$t10@1)))) (= (ControlFlow 0 345019) 345031)) inline$$XDX_initialize_$def$0$anon49_Else$1_correct)))
(let ((inline$$Not$5$Entry_correct  (and (=> (= (ControlFlow 0 345009) (- 0 434480)) true) (=> (= (ControlFlow 0 345009) 345019) inline$$Not$5$anon0_correct))))
(let ((inline$$XDX_initialize_$def$0$anon49_Else_correct  (=> (not $abort_flag@40) (=> (and (= inline$$XDX_initialize_$def$0$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)))) (= (ControlFlow 0 345025) 345009)) inline$$Not$5$Entry_correct))))
(let ((inline$$XDX_initialize_$def$0$anon49_Then_correct  (=> $abort_flag@40 (=> (and (and (= $DiemConfig_DiemConfig_$memory@19 $DiemConfig_DiemConfig_$memory@13) (= $DiemConfig_Configuration_$memory@15 $DiemConfig_Configuration_$memory@9)) (and (= $Diem_CurrencyInfo_$memory@9 $Diem_CurrencyInfo_$memory@5) (= (ControlFlow 0 356002) 345061))) inline$$XDX_initialize_$def$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 344937) 356002) inline$$XDX_initialize_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 344937) 345025) inline$$XDX_initialize_$def$0$anon49_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 344947) 356002) inline$$XDX_initialize_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 344947) 345025) inline$$XDX_initialize_$def$0$anon49_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@40) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 344931) 344947) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 344931) 344937) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon47_Else_correct  (=> (and (not $abort_flag@40) (= (ControlFlow 0 344961) 344931)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$XDX_initialize_$def$0$anon45_Else_correct  (=> (and (and (not $abort_flag@39) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@40)) (and (=> $abort_flag@40 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@40 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@35 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 344826) 356006) inline$$XDX_initialize_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 344826) 344961) inline$$XDX_initialize_$def$0$anon47_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@39) (=> (and (=> $abort_flag@39 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@39 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@34 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 344820) 356026) inline$$XDX_initialize_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 344820) 344826) inline$$XDX_initialize_$def$0$anon45_Else_correct))))))
(let ((inline$$XDX_initialize_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 344750) 344820)) inline$$XDX_initialize_$def$0$anon4$2_correct)))
(let ((inline$$XDX_initialize_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 356050) 344820) inline$$XDX_initialize_$def$0$anon4$2_correct)))
(let ((inline$$XDX_initialize_$def$0$anon43_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 344742) 356050) inline$$XDX_initialize_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 344742) 344750) inline$$XDX_initialize_$def$0$anon44_Else_correct)))))
(let ((inline$$XDX_initialize_$def$0$anon43_Then_correct  (and (=> (= (ControlFlow 0 356058) 356050) inline$$XDX_initialize_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 356058) 344750) inline$$XDX_initialize_$def$0$anon44_Else_correct))))
(let ((inline$$XDX_initialize_$def$0$anon0_correct  (=> (not $abort_flag@38) (and (=> (= (ControlFlow 0 344736) 356058) inline$$XDX_initialize_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 344736) 344742) inline$$XDX_initialize_$def$0$anon43_Else_correct)))))
(let ((inline$$XDX_initialize_$direct_inter$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 356062) 344736)) inline$$XDX_initialize_$def$0$anon0_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon83_Else_correct  (=> (and (not $abort_flag@38) (= (ControlFlow 0 356068) 356062)) inline$$XDX_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon83_Then_correct true))
(let ((inline$$XUS_initialize_$def$0$Abort_correct  (=> (= $DiemConfig_Configuration_$memory@9 $DiemConfig_Configuration_$memory@8) (=> (and (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@4) (= $AccountLimits_LimitsDefinition_$memory@3 $AccountLimits_LimitsDefinition_$memory@2)) (and (= $abort_flag@38 true) (= $DiemConfig_DiemConfig_$memory@13 $DiemConfig_DiemConfig_$memory@12))) (and (=> (= (ControlFlow 0 343815) 388308) inline$$Genesis_initialize_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 343815) 356068) inline$$Genesis_initialize_$def_verify$0$anon83_Else_correct))))))
(let ((inline$$XUS_initialize_$def$0$anon7_correct  (=> (= $AccountLimits_LimitsDefinition_$memory@2 $AccountLimits_LimitsDefinition_$memory) (=> (and (and (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@8 $DiemConfig_Configuration_$memory@0)) (and (= $DiemConfig_DiemConfig_$memory@12 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 343851) 343815))) inline$$XUS_initialize_$def$0$Abort_correct))))
(let ((inline$$XUS_initialize_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 343849) 343851)) inline$$XUS_initialize_$def$0$anon7_correct)))
(let ((inline$$XUS_initialize_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 343859) 343851) inline$$XUS_initialize_$def$0$anon7_correct)))
(let ((inline$$XUS_initialize_$def$0$anon19_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 343843) 343859) inline$$XUS_initialize_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 343843) 343849) inline$$XUS_initialize_$def$0$anon20_Else_correct)))))
(let ((inline$$XUS_initialize_$def$0$anon11_correct  (=> (= $AccountLimits_LimitsDefinition_$memory@2 $AccountLimits_LimitsDefinition_$memory) (=> (and (and (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@8 $DiemConfig_Configuration_$memory@0)) (and (= $DiemConfig_DiemConfig_$memory@12 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 343831) 343815))) inline$$XUS_initialize_$def$0$Abort_correct))))
(let ((inline$$XUS_initialize_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 343829) 343831)) inline$$XUS_initialize_$def$0$anon11_correct)))
(let ((inline$$XUS_initialize_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 343839) 343831) inline$$XUS_initialize_$def$0$anon11_correct)))
(let ((inline$$XUS_initialize_$def$0$anon21_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 343823) 343839) inline$$XUS_initialize_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 343823) 343829) inline$$XUS_initialize_$def$0$anon22_Else_correct)))))
(let ((inline$$XUS_initialize_$def$0$anon24_Then_correct  (=> (and $abort_flag@37 (= $AccountLimits_LimitsDefinition_$memory@2 $AccountLimits_LimitsDefinition_$memory@1)) (=> (and (and (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@3) (= $DiemConfig_Configuration_$memory@8 $DiemConfig_Configuration_$memory@7)) (and (= $DiemConfig_DiemConfig_$memory@12 $DiemConfig_DiemConfig_$memory@11) (= (ControlFlow 0 343811) 343815))) inline$$XUS_initialize_$def$0$Abort_correct))))
(let ((inline$$XUS_initialize_$def$0$anon23_Then_correct  (=> (and $abort_flag@33 (= $AccountLimits_LimitsDefinition_$memory@2 $AccountLimits_LimitsDefinition_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@3) (= $DiemConfig_Configuration_$memory@8 $DiemConfig_Configuration_$memory@7)) (and (= $DiemConfig_DiemConfig_$memory@12 $DiemConfig_DiemConfig_$memory@11) (= (ControlFlow 0 343819) 343815))) inline$$XUS_initialize_$def$0$Abort_correct))))
(let ((inline$$XUS_initialize_$def$0$anon24_Else_correct  (=> (and (not $abort_flag@37) (= $DiemConfig_Configuration_$memory@9 $DiemConfig_Configuration_$memory@7)) (=> (and (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@3) (= $AccountLimits_LimitsDefinition_$memory@3 $AccountLimits_LimitsDefinition_$memory@1)) (and (= $abort_flag@38 $abort_flag@37) (= $DiemConfig_DiemConfig_$memory@13 $DiemConfig_DiemConfig_$memory@11))) (and (=> (= (ControlFlow 0 343807) 388308) inline$$Genesis_initialize_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 343807) 356068) inline$$Genesis_initialize_$def_verify$0$anon83_Else_correct))))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Else_correct  (=> (not $abort_flag@36) (=> (and (= $abort_flag@37 $abort_flag@36) (= $AccountLimits_LimitsDefinition_$memory@1 |inline$$MoveToRaw$3$m'@2|)) (and (=> (= (ControlFlow 0 343721) 343811) inline$$XUS_initialize_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 343721) 343807) inline$$XUS_initialize_$def$0$anon24_Else_correct))))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct  (=> (and (= $abort_flag@37 true) (= $AccountLimits_LimitsDefinition_$memory@1 $AccountLimits_LimitsDefinition_$memory@0)) (and (=> (= (ControlFlow 0 342942) 343811) inline$$XUS_initialize_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 342942) 343807) inline$$XUS_initialize_$def$0$anon24_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon5_correct  (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 343773) 342942)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 343771) 343773)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon5_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 343781) 343773) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon5_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Then_correct  (=> $abort_flag@34 (and (=> (= (ControlFlow 0 343765) 343781) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 343765) 343771) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon21_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon9_correct  (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 343753) 342942)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 343751) 343753)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon9_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 343761) 343753) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon9_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon22_Then_correct  (=> $abort_flag@35 (and (=> (= (ControlFlow 0 343745) 343761) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 343745) 343751) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon23_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon17_correct  (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 |inline$$MoveToRaw$3$m'@2|) (= (ControlFlow 0 343733) 342942)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 343731) 343733)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon17_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 343741) 343733) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon17_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Then_correct  (=> $abort_flag@36 (and (=> (= (ControlFlow 0 343725) 343741) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 343725) 343731) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon27_Else_correct)))))
(let ((inline$$MoveToRaw$3$anon3_Then$1_correct  (=> (and (= $abort_flag@36 true) (= |inline$$MoveToRaw$3$m'@2| |inline$$MoveToRaw$3$m'@0|)) (and (=> (= (ControlFlow 0 343699) 343725) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 343699) 343721) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Else_correct)))))
(let ((inline$$MoveToRaw$3$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1) (= (ControlFlow 0 343697) 343699)) inline$$MoveToRaw$3$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$3$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1)) (= |inline$$MoveToRaw$3$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1 inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)))) (and (= $abort_flag@36 $abort_flag@35) (= |inline$$MoveToRaw$3$m'@2| |inline$$MoveToRaw$3$m'@1|))) (and (=> (= (ControlFlow 0 343647) 343725) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 343647) 343721) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Else_correct)))))
(let ((inline$$MoveTo$3$anon0$1_correct  (=> (= inline$$MoveTo$3$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 343705) 343697) inline$$MoveToRaw$3$anon3_Then_correct) (=> (= (ControlFlow 0 343705) 343647) inline$$MoveToRaw$3$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$3$Entry_correct  (and (=> (= (ControlFlow 0 343493) (- 0 433789)) true) (=> (= (ControlFlow 0 343493) 343705) inline$$MoveTo$3$anon0$1_correct))))
(let ((inline$$MoveTo$3$Entry_correct  (=> (and (= inline$$MoveTo$3$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$AccountLimits_publish_unrestricted_limits$0$$tv0@0) 1)) (= (ControlFlow 0 343465) 343493)) inline$$Signer_borrow_address$3$Entry_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 343353) (- 0 433670)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 343353) (- 0 433689)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 343353) (- 0 433708)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 343353) (- 0 433727)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 343353) 343465) inline$$MoveTo$3$Entry_correct)))))))))))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 343367) 343353)) inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 343373) 343353) inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 343361) 343373) inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 343361) 343367) inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Else_correct)))))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 343271) 343353)) inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1) $MAX_U64)) (=> (and (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1) $MAX_U64)) (= inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1) 1 inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1) 2 inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1) 3 inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1) 4))))) (and (=> (= (ControlFlow 0 343263) 343361) inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 343263) 343271) inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Else_correct))))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon24_Then_correct  (=> (and (|b#$Boolean| inline$$Not$4$dst@1) (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1 ($Integer 18446744073709551615))) (=> (and (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1 ($Integer 18446744073709551615)) (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1 ($Integer 86400000000))) (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 343379) 343263))) inline$$AccountLimits_LimitsDefinition_pack$0$anon0_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon14_correct  (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 342938) 342942)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 342936) 342938)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon14_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 342950) 342938) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon14_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon24_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$4$dst@1)) (= $abort_code@33 (|i#$Integer| call3formal@$ret0@0@@28))) (and (=> (= (ControlFlow 0 342930) 342950) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 342930) 342936) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon25_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon22_Else_correct  (=> (not $abort_flag@35) (and (=> (= (ControlFlow 0 342918) 343379) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 342918) 342930) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon24_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Else$1_correct  (=> (and (and (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@35)) (and (=> $abort_flag@35 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@35) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@28 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@28) (>= (|i#$Integer| call3formal@$ret0@0@@28) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@28) $MAX_U64))) (and (=> (= (ControlFlow 0 342912) 343745) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 342912) 342918) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon22_Else_correct)))))
(let ((inline$$Not$4$anon0_correct  (=> (and (= inline$$Not$4$dst@1 ($Boolean  (not (|b#$Boolean| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t10@1)))) (= (ControlFlow 0 342900) 342912)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Else$1_correct)))
(let ((inline$$Not$4$Entry_correct  (and (=> (= (ControlFlow 0 342890) (- 0 433425)) true) (=> (= (ControlFlow 0 342890) 342900) inline$$Not$4$anon0_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Else_correct  (=> (not $abort_flag@34) (=> (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$AccountLimits_publish_unrestricted_limits$0$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@29)))) (= (ControlFlow 0 342906) 342890)) inline$$Not$4$Entry_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@34) (=> $abort_flag@34 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@34) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@29 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@29))) (and (=> (= (ControlFlow 0 342832) 343765) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 342832) 342906) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 342796) 342832)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon2$1_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 343789) 342832) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon2$1_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon0_correct  (=> (not $abort_flag@33) (and (=> (= (ControlFlow 0 342790) 343789) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 342790) 342796) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon19_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 343793) 342790)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon0_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits$0$Entry_correct  (=> (and (= inline$$AccountLimits_publish_unrestricted_limits$0$$tv0@0 $XUS_XUS_type_value) (= (ControlFlow 0 342390) 343793)) inline$$AccountLimits_publish_unrestricted_limits$0$anon0_correct)))
(let ((inline$$XUS_initialize_$def$0$anon23_Else_correct  (=> (and (not $abort_flag@33) (= (ControlFlow 0 343799) 342390)) inline$$AccountLimits_publish_unrestricted_limits$0$Entry_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon60_Else_correct  (=> (not $abort_flag@32) (=> (and (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_DiemConfig_$memory@11 $DiemConfig_DiemConfig_$memory@9)) (and (= $DiemConfig_Configuration_$memory@7 $DiemConfig_Configuration_$memory@5) (= $abort_flag@33 $abort_flag@32))) (and (=> (= (ControlFlow 0 342172) 343819) inline$$XUS_initialize_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 342172) 343799) inline$$XUS_initialize_$def$0$anon23_Else_correct))))))
(let ((inline$$Diem_register_SCS_currency_$def$0$Abort_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@2) (= $DiemConfig_DiemConfig_$memory@11 $DiemConfig_DiemConfig_$memory@10)) (and (= $DiemConfig_Configuration_$memory@7 $DiemConfig_Configuration_$memory@6) (= $abort_flag@33 true))) (and (=> (= (ControlFlow 0 340583) 343819) inline$$XUS_initialize_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 340583) 343799) inline$$XUS_initialize_$def$0$anon23_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon15_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@0)) (and (= $DiemConfig_DiemConfig_$memory@10 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 342268) 340583))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 342266) 342268)) inline$$Diem_register_SCS_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 342276) 342268) inline$$Diem_register_SCS_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon47_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 342260) 342276) inline$$Diem_register_SCS_currency_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 342260) 342266) inline$$Diem_register_SCS_currency_$def$0$anon48_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon25_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@5)) (and (= $DiemConfig_DiemConfig_$memory@10 $DiemConfig_DiemConfig_$memory@9) (= (ControlFlow 0 342228) 340583))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 342226) 342228)) inline$$Diem_register_SCS_currency_$def$0$anon25_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 342236) 342228) inline$$Diem_register_SCS_currency_$def$0$anon25_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon52_Then_correct  (=> $abort_flag@24 (and (=> (= (ControlFlow 0 342220) 342236) inline$$Diem_register_SCS_currency_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 342220) 342226) inline$$Diem_register_SCS_currency_$def$0$anon53_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon29_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@5)) (and (= $DiemConfig_DiemConfig_$memory@10 $DiemConfig_DiemConfig_$memory@9) (= (ControlFlow 0 342208) 340583))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 342206) 342208)) inline$$Diem_register_SCS_currency_$def$0$anon29_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 342216) 342208) inline$$Diem_register_SCS_currency_$def$0$anon29_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon54_Then_correct  (=> $abort_flag@25 (and (=> (= (ControlFlow 0 342200) 342216) inline$$Diem_register_SCS_currency_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 342200) 342206) inline$$Diem_register_SCS_currency_$def$0$anon55_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon37_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@5)) (and (= $DiemConfig_DiemConfig_$memory@10 $DiemConfig_DiemConfig_$memory@9) (= (ControlFlow 0 342188) 340583))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 342186) 342188)) inline$$Diem_register_SCS_currency_$def$0$anon37_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon59_Then_correct  (=> (= (ControlFlow 0 342196) 342188) inline$$Diem_register_SCS_currency_$def$0$anon37_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon58_Then_correct  (=> $abort_flag@26 (and (=> (= (ControlFlow 0 342180) 342196) inline$$Diem_register_SCS_currency_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 342180) 342186) inline$$Diem_register_SCS_currency_$def$0$anon59_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon60_Then_correct  (=> $abort_flag@32 (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@5)) (and (= $DiemConfig_DiemConfig_$memory@10 $DiemConfig_DiemConfig_$memory@9) (= (ControlFlow 0 342176) 340583))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct  (=> (and (not $abort_flag@31) (= $abort_flag@32 $abort_flag@31)) (and (=> (= (ControlFlow 0 342038) 342176) inline$$Diem_register_SCS_currency_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 342038) 342172) inline$$Diem_register_SCS_currency_$def$0$anon60_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$Abort_correct  (=> (= $abort_flag@32 true) (and (=> (= (ControlFlow 0 341684) 342176) inline$$Diem_register_SCS_currency_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 341684) 342172) inline$$Diem_register_SCS_currency_$def$0$anon60_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 342128) 341684)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 342138) 341684) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct  (=> $abort_flag@27 (and (=> (= (ControlFlow 0 342122) 342138) inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 342122) 342128) inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 342108) 341684)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 342118) 341684) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct  (=> $abort_flag@28 (and (=> (= (ControlFlow 0 342102) 342118) inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 342102) 342108) inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 342088) 341684)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 342098) 341684) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct  (=> $abort_flag@29 (and (=> (= (ControlFlow 0 342082) 342098) inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 342082) 342088) inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 342068) 341684)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 342078) 341684) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct  (=> $abort_flag@30 (and (=> (= (ControlFlow 0 342062) 342078) inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 342062) 342068) inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 342048) 341684)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 342058) 341684) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct  (=> $abort_flag@31 (and (=> (= (ControlFlow 0 342042) 342058) inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 342042) 342048) inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$2$anon3_Then$1_correct  (=> (= $abort_flag@31 true) (and (=> (= (ControlFlow 0 342016) 342042) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 342016) 342038) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct)))))
(let ((inline$$MoveToRaw$2$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1) (= (ControlFlow 0 342014) 342016)) inline$$MoveToRaw$2$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$2$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1)) (=> (and (= |inline$$MoveToRaw$2$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 inline$$Diem_register_currency_$def$0$$ret1@2))) (= $abort_flag@31 $abort_flag@30)) (and (=> (= (ControlFlow 0 341964) 342042) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 341964) 342038) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$2$anon0$1_correct  (=> (= inline$$MoveTo$2$a@1 (|a#$Address| tc_account)) (and (=> (= (ControlFlow 0 342022) 342014) inline$$MoveToRaw$2$anon3_Then_correct) (=> (= (ControlFlow 0 342022) 341964) inline$$MoveToRaw$2$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$2$Entry_correct  (and (=> (= (ControlFlow 0 341810) (- 0 432915)) true) (=> (= (ControlFlow 0 341810) 342022) inline$$MoveTo$2$anon0$1_correct))))
(let ((inline$$MoveTo$2$Entry_correct  (=> (and (= inline$$MoveTo$2$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency$0$$tv0@0) 1)) (= (ControlFlow 0 341782) 341810)) inline$$Signer_borrow_address$2$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$Not$3$dst@1) (= (ControlFlow 0 342030) 341782)) inline$$MoveTo$2$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 341678) 341684)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 341692) 341684) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$3$dst@1)) (= $abort_code@30 (|i#$Integer| call3formal@$ret0@0@@30))) (and (=> (= (ControlFlow 0 341672) 341692) inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 341672) 341678) inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct  (=> (not $abort_flag@30) (and (=> (= (ControlFlow 0 341660) 342030) inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 341660) 341672) inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_burn_capability_$def$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@30)) (and (=> $abort_flag@30 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@30 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@30) (>= (|i#$Integer| call3formal@$ret0@0@@30) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@30) $MAX_U64))) (and (=> (= (ControlFlow 0 341654) 342062) inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 341654) 341660) inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct)))))
(let ((inline$$Not$3$anon0_correct  (=> (and (= inline$$Not$3$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_publish_burn_capability_$def$0$$t7@1)))) (= (ControlFlow 0 341642) 341654)) inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct)))
(let ((inline$$Not$3$Entry_correct  (and (=> (= (ControlFlow 0 341632) (- 0 432758)) true) (=> (= (ControlFlow 0 341632) 341642) inline$$Not$3$anon0_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct  (=> (not $abort_flag@29) (=> (and (= inline$$Diem_publish_burn_capability_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency$0$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@31)))) (= (ControlFlow 0 341648) 341632)) inline$$Not$3$Entry_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct  (=> (not $abort_flag@28) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@29) (=> $abort_flag@29 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@29) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@31 tc_account)))) ((_ is $Address) call3formal@$ret0@0@@31))) (and (=> (= (ControlFlow 0 341574) 342082) inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 341574) 341648) inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct  (=> (and (and (not $abort_flag@27) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@28)) (and (=> $abort_flag@28 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@28 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@27 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 341568) 342102) inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 341568) 341574) inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@27) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@27) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@27)) (and (=> $abort_flag@27 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@27 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@26 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@26 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@26 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 341562) 342122) inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 341562) 341568) inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 341492) 341562)) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 342146) 341562) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 341484) 342146) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 341484) 341492) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 342154) 342146) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 342154) 341492) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon0_correct  (=> (not $abort_flag@26) (and (=> (= (ControlFlow 0 341478) 342154) inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 341478) 341484) inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability$0$anon0_correct  (=> ((_ is $Address) tc_account) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_register_currency_$def$0$$ret1@2) (let ((va@@76 (|v#$Vector| inline$$Diem_register_currency_$def$0$$ret1@2)))
(let ((l@@76 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@76) (<= l@@76 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@76)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$0$$ret1@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$0$$ret1@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 342158) 341478)) inline$$Diem_publish_burn_capability_$def$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon58_Else_correct  (=> (and (not $abort_flag@26) (= (ControlFlow 0 342164) 342158)) inline$$Diem_publish_burn_capability$0$anon0_correct)))
(let ((inline$$MoveToRaw$1$anon3_Then$1_correct  (=> (= $abort_flag@26 true) (and (=> (= (ControlFlow 0 340915) 342180) inline$$Diem_register_SCS_currency_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 340915) 342164) inline$$Diem_register_SCS_currency_$def$0$anon58_Else_correct)))))
(let ((inline$$MoveToRaw$1$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1) (= (ControlFlow 0 340913) 340915)) inline$$MoveToRaw$1$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$1$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1)) (=> (and (= |inline$$MoveToRaw$1$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 inline$$Diem_register_currency_$def$0$$ret0))) (= $abort_flag@26 $abort_flag@25)) (and (=> (= (ControlFlow 0 340863) 342180) inline$$Diem_register_SCS_currency_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 340863) 342164) inline$$Diem_register_SCS_currency_$def$0$anon58_Else_correct))))))
(let ((inline$$MoveTo$1$anon0$1_correct  (=> (= inline$$MoveTo$1$a@1 (|a#$Address| tc_account)) (and (=> (= (ControlFlow 0 340921) 340913) inline$$MoveToRaw$1$anon3_Then_correct) (=> (= (ControlFlow 0 340921) 340863) inline$$MoveToRaw$1$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$1$Entry_correct  (and (=> (= (ControlFlow 0 340709) (- 0 432169)) true) (=> (= (ControlFlow 0 340709) 340921) inline$$MoveTo$1$anon0$1_correct))))
(let ((inline$$MoveTo$1$Entry_correct  (=> (and (= inline$$MoveTo$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency$0$$tv0@0) 1)) (= (ControlFlow 0 340681) 340709)) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon56_Then_correct  (=> (and (|b#$Boolean| inline$$Not$2$dst@1) (= (ControlFlow 0 340929) 340681)) inline$$MoveTo$1$Entry_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon34_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@5)) (and (= $DiemConfig_DiemConfig_$memory@10 $DiemConfig_DiemConfig_$memory@9) (= (ControlFlow 0 340579) 340583))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 340577) 340579)) inline$$Diem_register_SCS_currency_$def$0$anon34_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 340591) 340579) inline$$Diem_register_SCS_currency_$def$0$anon34_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon56_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$2$dst@1)) (= $abort_code@25 (|i#$Integer| call3formal@$ret0@0@@32))) (and (=> (= (ControlFlow 0 340571) 340591) inline$$Diem_register_SCS_currency_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 340571) 340577) inline$$Diem_register_SCS_currency_$def$0$anon57_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon54_Else_correct  (=> (not $abort_flag@25) (and (=> (= (ControlFlow 0 340559) 340929) inline$$Diem_register_SCS_currency_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 340559) 340571) inline$$Diem_register_SCS_currency_$def$0$anon56_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon52_Else$1_correct  (=> (and (and (and (= inline$$Diem_register_SCS_currency_$def$0$$t22@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@25)) (and (=> $abort_flag@25 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@25) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@32 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@32) (>= (|i#$Integer| call3formal@$ret0@0@@32) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@32) $MAX_U64))) (and (=> (= (ControlFlow 0 340553) 342200) inline$$Diem_register_SCS_currency_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 340553) 340559) inline$$Diem_register_SCS_currency_$def$0$anon54_Else_correct)))))
(let ((inline$$Not$2$anon0_correct  (=> (and (= inline$$Not$2$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_register_SCS_currency_$def$0$$t20@1)))) (= (ControlFlow 0 340541) 340553)) inline$$Diem_register_SCS_currency_$def$0$anon52_Else$1_correct)))
(let ((inline$$Not$2$Entry_correct  (and (=> (= (ControlFlow 0 340531) (- 0 432012)) true) (=> (= (ControlFlow 0 340531) 340541) inline$$Not$2$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon52_Else_correct  (=> (not $abort_flag@24) (=> (and (= inline$$Diem_register_SCS_currency_$def$0$$t20@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency$0$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@33)))) (= (ControlFlow 0 340547) 340531)) inline$$Not$2$Entry_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon22_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@24) (=> $abort_flag@24 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@24) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@33 tc_account)))) ((_ is $Address) call3formal@$ret0@0@@33))) (and (=> (= (ControlFlow 0 340473) 342220) inline$$Diem_register_SCS_currency_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 340473) 340547) inline$$Diem_register_SCS_currency_$def$0$anon52_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 340471) 340473)) inline$$Diem_register_SCS_currency_$def$0$anon22_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 342244) 340473) inline$$Diem_register_SCS_currency_$def$0$anon22_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon50_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 340429) 342244) inline$$Diem_register_SCS_currency_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 340429) 340471) inline$$Diem_register_SCS_currency_$def$0$anon51_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon50_Then_correct  (and (=> (= (ControlFlow 0 342252) 342244) inline$$Diem_register_SCS_currency_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 342252) 340471) inline$$Diem_register_SCS_currency_$def$0$anon51_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon49_Else_correct  (=> (not $abort_flag@23) (and (=> (= (ControlFlow 0 340421) 342252) inline$$Diem_register_SCS_currency_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 340421) 340429) inline$$Diem_register_SCS_currency_$def$0$anon50_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon49_Then_correct  (=> $abort_flag@23 (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@5)) (and (= $DiemConfig_DiemConfig_$memory@10 $DiemConfig_DiemConfig_$memory@9) (= (ControlFlow 0 342256) 340583))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon76_correct  (=> (= inline$$Diem_register_currency_$def$0$$ret1@2 inline$$Diem_BurnCapability_pack$0$$struct@1) (=> (and (and (= $Diem_CurrencyInfo_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= $DiemConfig_DiemConfig_$memory@9 $DiemConfig_DiemConfig_$memory@7)) (and (= $abort_flag@23 $abort_flag@22) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@3))) (and (=> (= (ControlFlow 0 339977) 342256) inline$$Diem_register_SCS_currency_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 339977) 340421) inline$$Diem_register_SCS_currency_$def$0$anon49_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$0$anon114_Else_correct  (=> (and (not true) (= (ControlFlow 0 339975) 339977)) inline$$Diem_register_currency_$def$0$anon76_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon114_Then_correct  (=> (= (ControlFlow 0 339985) 339977) inline$$Diem_register_currency_$def$0$anon76_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon113_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 339965) 339985) inline$$Diem_register_currency_$def$0$anon114_Then_correct) (=> (= (ControlFlow 0 339965) 339975) inline$$Diem_register_currency_$def$0$anon114_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon113_Then_correct  (and (=> (= (ControlFlow 0 339993) 339985) inline$$Diem_register_currency_$def$0$anon114_Then_correct) (=> (= (ControlFlow 0 339993) 339975) inline$$Diem_register_currency_$def$0$anon114_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 339943) 339993) inline$$Diem_register_currency_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 339943) 339965) inline$$Diem_register_currency_$def$0$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 339949) 339993) inline$$Diem_register_currency_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 339949) 339965) inline$$Diem_register_currency_$def$0$anon113_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 339937) 339949) inline$$Diem_BurnCapability_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 339937) 339943) inline$$Diem_BurnCapability_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 339929) 339993) inline$$Diem_register_currency_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 339929) 339965) inline$$Diem_register_currency_$def$0$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def$0$$t39@1) (= inline$$Diem_BurnCapability_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$0$$t39@1) 1)))) (and (=> (= (ControlFlow 0 339921) 339937) inline$$Diem_BurnCapability_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 339921) 339929) inline$$Diem_BurnCapability_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon112_Else$1_correct  (=> (and (= inline$$Diem_register_currency_$def$0$$t39@1 ($Boolean false)) (= (ControlFlow 0 339955) 339921)) inline$$Diem_BurnCapability_pack$0$anon0_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 339772) 339955)) inline$$Diem_register_currency_$def$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 339778) 339955) inline$$Diem_register_currency_$def$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 339766) 339778) inline$$Diem_MintCapability_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 339766) 339772) inline$$Diem_MintCapability_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_MintCapability_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 339758) 339955)) inline$$Diem_register_currency_$def$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def$0$$t37@1) (= inline$$Diem_MintCapability_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$0$$t37@1) 1)))) (and (=> (= (ControlFlow 0 339750) 339766) inline$$Diem_MintCapability_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 339750) 339758) inline$$Diem_MintCapability_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon112_Else_correct  (=> (not $abort_flag@22) (=> (and (= inline$$Diem_register_currency_$def$0$$t37@1 ($Boolean false)) (= (ControlFlow 0 339784) 339750)) inline$$Diem_MintCapability_pack$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$Abort_correct  (=> (= inline$$Diem_register_currency_$def$0$$ret0@1 $Error) (=> (and (= inline$$Diem_register_currency_$def$0$$ret1@1 $Error) (= inline$$Diem_register_currency_$def$0$$ret1@2 inline$$Diem_register_currency_$def$0$$ret1@1)) (=> (and (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory@0) (= $DiemConfig_DiemConfig_$memory@9 $DiemConfig_DiemConfig_$memory@8)) (and (= $abort_flag@23 true) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4))) (and (=> (= (ControlFlow 0 336436) 342256) inline$$Diem_register_SCS_currency_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 336436) 340421) inline$$Diem_register_SCS_currency_$def$0$anon49_Else_correct)))))))
(let ((inline$$Diem_register_currency_$def$0$anon15_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340307) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 340305) 340307)) inline$$Diem_register_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon84_Then_correct  (=> (= (ControlFlow 0 340315) 340307) inline$$Diem_register_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon83_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 340299) 340315) inline$$Diem_register_currency_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 340299) 340305) inline$$Diem_register_currency_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon19_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340287) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 340285) 340287)) inline$$Diem_register_currency_$def$0$anon19_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon86_Then_correct  (=> (= (ControlFlow 0 340295) 340287) inline$$Diem_register_currency_$def$0$anon19_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon85_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 340279) 340295) inline$$Diem_register_currency_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 340279) 340285) inline$$Diem_register_currency_$def$0$anon86_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon23_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340267) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 340265) 340267)) inline$$Diem_register_currency_$def$0$anon23_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon88_Then_correct  (=> (= (ControlFlow 0 340275) 340267) inline$$Diem_register_currency_$def$0$anon23_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon87_Then_correct  (=> $abort_flag@15 (and (=> (= (ControlFlow 0 340259) 340275) inline$$Diem_register_currency_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 340259) 340265) inline$$Diem_register_currency_$def$0$anon88_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon27_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340247) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon90_Else_correct  (=> (and (not true) (= (ControlFlow 0 340245) 340247)) inline$$Diem_register_currency_$def$0$anon27_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon90_Then_correct  (=> (= (ControlFlow 0 340255) 340247) inline$$Diem_register_currency_$def$0$anon27_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon89_Then_correct  (=> $abort_flag@16 (and (=> (= (ControlFlow 0 340239) 340255) inline$$Diem_register_currency_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 340239) 340245) inline$$Diem_register_currency_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon41_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340129) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 340127) 340129)) inline$$Diem_register_currency_$def$0$anon41_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon97_Then_correct  (=> (= (ControlFlow 0 340137) 340129) inline$$Diem_register_currency_$def$0$anon41_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon96_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 340121) 340137) inline$$Diem_register_currency_$def$0$anon97_Then_correct) (=> (= (ControlFlow 0 340121) 340127) inline$$Diem_register_currency_$def$0$anon97_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon49_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340109) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon101_Else_correct  (=> (and (not true) (= (ControlFlow 0 340107) 340109)) inline$$Diem_register_currency_$def$0$anon49_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon101_Then_correct  (=> (= (ControlFlow 0 340117) 340109) inline$$Diem_register_currency_$def$0$anon49_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon100_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 340101) 340117) inline$$Diem_register_currency_$def$0$anon101_Then_correct) (=> (= (ControlFlow 0 340101) 340107) inline$$Diem_register_currency_$def$0$anon101_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon53_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340089) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon103_Else_correct  (=> (and (not true) (= (ControlFlow 0 340087) 340089)) inline$$Diem_register_currency_$def$0$anon53_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon103_Then_correct  (=> (= (ControlFlow 0 340097) 340089) inline$$Diem_register_currency_$def$0$anon53_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon102_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 340081) 340097) inline$$Diem_register_currency_$def$0$anon103_Then_correct) (=> (= (ControlFlow 0 340081) 340087) inline$$Diem_register_currency_$def$0$anon103_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon57_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340069) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon105_Else_correct  (=> (and (not true) (= (ControlFlow 0 340067) 340069)) inline$$Diem_register_currency_$def$0$anon57_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon105_Then_correct  (=> (= (ControlFlow 0 340077) 340069) inline$$Diem_register_currency_$def$0$anon57_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon104_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 340061) 340077) inline$$Diem_register_currency_$def$0$anon105_Then_correct) (=> (= (ControlFlow 0 340061) 340067) inline$$Diem_register_currency_$def$0$anon105_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon61_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340049) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon107_Else_correct  (=> (and (not true) (= (ControlFlow 0 340047) 340049)) inline$$Diem_register_currency_$def$0$anon61_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon107_Then_correct  (=> (= (ControlFlow 0 340057) 340049) inline$$Diem_register_currency_$def$0$anon61_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon106_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 340041) 340057) inline$$Diem_register_currency_$def$0$anon107_Then_correct) (=> (= (ControlFlow 0 340041) 340047) inline$$Diem_register_currency_$def$0$anon107_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon65_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340029) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon109_Else_correct  (=> (and (not true) (= (ControlFlow 0 340027) 340029)) inline$$Diem_register_currency_$def$0$anon65_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon109_Then_correct  (=> (= (ControlFlow 0 340037) 340029) inline$$Diem_register_currency_$def$0$anon65_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon108_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 340021) 340037) inline$$Diem_register_currency_$def$0$anon109_Then_correct) (=> (= (ControlFlow 0 340021) 340027) inline$$Diem_register_currency_$def$0$anon109_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon69_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 340009) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 340007) 340009)) inline$$Diem_register_currency_$def$0$anon69_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon111_Then_correct  (=> (= (ControlFlow 0 340017) 340009) inline$$Diem_register_currency_$def$0$anon69_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon110_Then_correct  (=> $abort_flag@18 (and (=> (= (ControlFlow 0 340001) 340017) inline$$Diem_register_currency_$def$0$anon111_Then_correct) (=> (= (ControlFlow 0 340001) 340007) inline$$Diem_register_currency_$def$0$anon111_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon112_Then_correct  (=> $abort_flag@22 (=> (and (and (= $Diem_CurrencyInfo_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@7)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@3) (= (ControlFlow 0 339997) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Else_correct  (=> (and (and (not $abort_flag@21) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory@1)) (and (= $DiemConfig_DiemConfig_$memory@7 $DiemConfig_DiemConfig_$memory@5) (= $abort_flag@22 $abort_flag@21))) (and (=> (= (ControlFlow 0 339481) 339997) inline$$Diem_register_currency_$def$0$anon112_Then_correct) (=> (= (ControlFlow 0 339481) 339784) inline$$Diem_register_currency_$def$0$anon112_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct  (=> (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory@2) (=> (and (= $DiemConfig_DiemConfig_$memory@7 $DiemConfig_DiemConfig_$memory@6) (= $abort_flag@22 true)) (and (=> (= (ControlFlow 0 338753) 339997) inline$$Diem_register_currency_$def$0$anon112_Then_correct) (=> (= (ControlFlow 0 338753) 339784) inline$$Diem_register_currency_$def$0$anon112_Else_correct))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct  (=> (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0) (=> (and (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 339573) 338753)) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 339571) 339573)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 339581) 339573) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 339565) 339581) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 339565) 339571) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct  (=> (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0) (=> (and (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 339553) 338753)) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 339551) 339553)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 339561) 339553) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 339545) 339561) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 339545) 339551) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct  (=> (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0) (=> (and (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 339533) 338753)) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 339531) 339533)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 339541) 339533) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Then_correct  (=> $abort_flag@20 (and (=> (= (ControlFlow 0 339525) 339541) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 339525) 339531) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct  (=> (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0) (=> (and (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 339513) 338753)) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 339511) 339513)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 339521) 339513) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Then_correct  (=> $abort_flag@20 (and (=> (= (ControlFlow 0 339505) 339521) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 339505) 339511) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct  (=> (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@1) (=> (and (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@5) (= (ControlFlow 0 339493) 338753)) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 339491) 339493)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 339501) 339493) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Then_correct  (=> $abort_flag@21 (and (=> (= (ControlFlow 0 339485) 339501) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 339485) 339491) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct  (=> (and (= call0formal@$tv0@0@@11 $RegisteredCurrencies_RegisteredCurrencies_type_value) (= call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 339475) (- 0 430609)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@11) 1) (|a#$Address| dr_account))))))) $abort_flag@21) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@11) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@21) (=> $abort_flag@21 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@11) 1) (|a#$Address| dr_account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@11) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@21 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@11) 1) (|a#$Address| dr_account))))))) (= $abort_code@22 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@11) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@22 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@22 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@11) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@5 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@11) 1) (|a#$Address| addr@@5)))) $DiemConfig_DiemConfig_payload)) |inline$$WritebackToValue$0$vdst'@2|)))) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 339475) 339485) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 339475) 339481) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Else_correct)))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| call3formal@$ret0@0@@34) (= (ControlFlow 0 339441) 339475)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 call3formal@$ret0@0@@34 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 339467) 339475))) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1)) (and (=> (= (ControlFlow 0 339286) 339467) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 339286) 339441) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 339342) 339467) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 339342) 339441) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 339250) 339342) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 339250) 339286) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) |inline$$Vector_push_back$0$v'@1|)) (= (ControlFlow 0 339107) 339250)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else_correct  (=> (and (not $abort_flag@20) (= (ControlFlow 0 339113) 339107)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@3 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) len@@3 inline$$XUS_initialize_$def$0$$t9@1) (+ len@@3 1)))))) (and (=> (= (ControlFlow 0 339042) 339505) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 339042) 339113) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct  (=> (and (= inline$$Vector_push_back$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 339030) 339042)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 338977) 339030)) inline$$Vector_push_back$0$Entry_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $RegisteredCurrencies_RegisteredCurrencies_currency_codes) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) (= (ControlFlow 0 338939) 338977))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 2) $EmptyPath call3formal@$ret0@0@@34)) (= (ControlFlow 0 338815) 338939)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 338821) 338815)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct  (=> (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0) (=> (and (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 338749) 338753)) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 338747) 338749)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 338761) 338749) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= $abort_code@21 (|i#$Integer| call3formal@$ret0@0@@35))) (and (=> (= (ControlFlow 0 338741) 338761) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 338741) 338747) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Else_correct  (=> (not $abort_flag@20) (and (=> (= (ControlFlow 0 338729) 338821) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 338729) 338741) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else$1_correct  (=> (and (and (and (= inline$$RegisteredCurrencies_add_currency_code_$def$0$$t10@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@20)) (and (=> $abort_flag@20 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@35 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@35) (>= (|i#$Integer| call3formal@$ret0@0@@35) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@35) $MAX_U64))) (and (=> (= (ControlFlow 0 338723) 339525) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 338723) 338729) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Else_correct)))))
(let ((inline$$Not$1$anon0_correct  (=> (and (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Vector_contains$0$res@1)))) (= (ControlFlow 0 338711) 338723)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 338701) (- 0 430125)) true) (=> (= (ControlFlow 0 338701) 338711) inline$$Not$1$anon0_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else_correct  (=> (and (not $abort_flag@19) (= (ControlFlow 0 338717) 338701)) inline$$Not$1$Entry_correct)))
(let ((inline$$Vector_contains$0$anon0_correct  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1) (= inline$$Vector_contains$0$res@1 ($Boolean (exists ((i@@11 Int) )  (and (and (<= 0 i@@11) (< i@@11 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)) i@@11) inline$$XUS_initialize_$def$0$$t9@1)))))) (and (=> (= (ControlFlow 0 338655) 339545) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 338655) 338717) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else_correct)))))
(let ((inline$$Vector_contains$0$Entry_correct  (=> (and (= inline$$Vector_contains$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 338641) 338655)) inline$$Vector_contains$0$anon0_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@34)) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)) (= (ControlFlow 0 338586) 338641)) inline$$Vector_contains$0$Entry_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Else_correct  (=> (and (not $abort_flag@19) (= (ControlFlow 0 338592) 338586)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct  (=> (= call0formal@$tv0@0@@12 $RegisteredCurrencies_RegisteredCurrencies_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@12) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@19) (=> $abort_flag@19 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@12) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@19 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@12) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@19 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@19) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@34 (let ((addr@@6 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@12) 1) (|a#$Address| addr@@6)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 338540) 339565) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 338540) 338592) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Else_correct))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 338470) 338540)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 339589) 338540) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 338462) 339589) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 338462) 338470) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 339597) 339589) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 339597) 338470) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon0_correct  (=> (not $abort_flag@18) (and (=> (= (ControlFlow 0 338456) 339597) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 338456) 338462) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and ((_ is $Vector) inline$$XUS_initialize_$def$0$$t9@1) (let ((va@@77 (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)))
(let ((l@@77 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77))
)))))) (forall ((inline$$RegisteredCurrencies_add_currency_code$0$$$0 Int) ) (!  (=> (and (>= inline$$RegisteredCurrencies_add_currency_code$0$$$0 0) (< inline$$RegisteredCurrencies_add_currency_code$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$RegisteredCurrencies_add_currency_code$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$RegisteredCurrencies_add_currency_code$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$RegisteredCurrencies_add_currency_code$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$RegisteredCurrencies_add_currency_code$0$$$0))
))) (= (ControlFlow 0 339601) 338456)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon110_Else_correct  (=> (and (not $abort_flag@18) (= (ControlFlow 0 339607) 339601)) inline$$RegisteredCurrencies_add_currency_code$0$anon0_correct)))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (and (= $abort_flag@18 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 337804) 340001) inline$$Diem_register_currency_$def$0$anon110_Then_correct) (=> (= (ControlFlow 0 337804) 339607) inline$$Diem_register_currency_$def$0$anon110_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 337802) 337804)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 inline$$Diem_CurrencyInfo_pack$0$$struct@1)))) (and (= $abort_flag@18 $abort_flag@17) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 337752) 340001) inline$$Diem_register_currency_$def$0$anon110_Then_correct) (=> (= (ControlFlow 0 337752) 339607) inline$$Diem_register_currency_$def$0$anon110_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 337810) 337802) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 337810) 337752) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 337598) (- 0 429668)) true) (=> (= (ControlFlow 0 337598) 337810) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency$0$$tv0@0) 1)) (= (ControlFlow 0 337570) 337598)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 337458) (- 0 429581)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 337458) 337570) inline$$MoveTo$0$Entry_correct)))))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 337472) 337458)) inline$$Diem_CurrencyInfo_pack$0$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 337478) 337458) inline$$Diem_CurrencyInfo_pack$0$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 337466) 337478) inline$$Diem_CurrencyInfo_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 337466) 337472) inline$$Diem_CurrencyInfo_pack$0$anon5_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 337410) 337458)) inline$$Diem_CurrencyInfo_pack$0$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_register_currency_$def$0$$t28@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t28@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t28@1) $MAX_U128)) (and (and ((_ is $Integer) inline$$Diem_register_currency_$def$0$$t29@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t29@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t29@1) $MAX_U64))) (=> (and (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@4) (let ((va@@78 (|v#$Vector| call4formal@$ret0@0@@4)))
(let ((l@@78 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) inline$$Diem_register_SCS_currency_$def$0$$t16@1)) (and (and (and (and ((_ is $Integer) inline$$XUS_initialize_$def$0$$t7@1) (>= (|i#$Integer| inline$$XUS_initialize_$def$0$$t7@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def$0$$t7@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$XUS_initialize_$def$0$$t8@1) (>= (|i#$Integer| inline$$XUS_initialize_$def$0$$t8@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def$0$$t8@1) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$XUS_initialize_$def$0$$t9@1) (let ((va@@79 (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)))
(let ((l@@79 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79))
)))))) (forall ((inline$$Diem_CurrencyInfo_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_CurrencyInfo_pack$0$$$0 0) (< inline$$Diem_CurrencyInfo_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_CurrencyInfo_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_CurrencyInfo_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_CurrencyInfo_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_CurrencyInfo_pack$0$$$0))
))) ((_ is $Boolean) inline$$Diem_register_currency_$def$0$$t30@1)))) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@80 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@80 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@80) (<= l@@80 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@80)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@81 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@81 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@14))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$1$res@0) (let ((va@@82 (|v#$Vector| inline$$Event_new_event_handle$1$res@0)))
(let ((l@@82 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid)) (let ((va@@83 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))
(let ((l@@83 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@15))
))) true)) (=> (and (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$2$res@0) (let ((va@@84 (|v#$Vector| inline$$Event_new_event_handle$2$res@0)))
(let ((l@@84 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid)) (let ((va@@85 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))))
(let ((l@@85 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@16))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$3$res@0) (let ((va@@86 (|v#$Vector| inline$$Event_new_event_handle$3$res@0)))
(let ((l@@86 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid)) (let ((va@@87 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))))
(let ((l@@87 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87))
))))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@17))
))) true)) (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$4$res@0) (let ((va@@88 (|v#$Vector| inline$$Event_new_event_handle$4$res@0)))
(let ((l@@88 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid)) (let ((va@@89 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))))
(let ((l@@89 (|l#$ValueArray| va@@89)))
 (and (and (<= 0 l@@89) (<= l@@89 $MAX_U64)) (forall ((x@@89 Int) ) (!  (=> (or (< x@@89 0) (>= x@@89 l@@89)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89))
))))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@18))
))) true) (= inline$$Diem_CurrencyInfo_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$0$$t28@1) 1 inline$$Diem_register_currency_$def$0$$t29@1) 2 call4formal@$ret0@0@@4) 3 inline$$Diem_register_SCS_currency_$def$0$$t16@1) 4 inline$$XUS_initialize_$def$0$$t7@1) 5 inline$$XUS_initialize_$def$0$$t8@1) 6 inline$$XUS_initialize_$def$0$$t9@1) 7 inline$$Diem_register_currency_$def$0$$t30@1) 8 inline$$Event_new_event_handle$0$res@0) 9 inline$$Event_new_event_handle$1$res@0) 10 inline$$Event_new_event_handle$2$res@0) 11 inline$$Event_new_event_handle$3$res@0) 12 inline$$Event_new_event_handle$4$res@0) 13))))) (and (=> (= (ControlFlow 0 337402) 337466) inline$$Diem_CurrencyInfo_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 337402) 337410) inline$$Diem_CurrencyInfo_pack$0$anon4_Else_correct))))))))
(let ((inline$$Diem_register_currency_$def$0$anon108_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 337484) 337402)) inline$$Diem_CurrencyInfo_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$4$Entry_correct  (=> (= inline$$Event_new_event_handle$4$t@0 $Diem_ToXDXExchangeRateUpdateEvent_type_value) (and (=> (= (ControlFlow 0 336824) 340021) inline$$Diem_register_currency_$def$0$anon108_Then_correct) (=> (= (ControlFlow 0 336824) 337484) inline$$Diem_register_currency_$def$0$anon108_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon106_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 336832) 336824)) inline$$Event_new_event_handle$4$Entry_correct)))
(let ((inline$$Event_new_event_handle$3$Entry_correct  (=> (= inline$$Event_new_event_handle$3$t@0 $Diem_CancelBurnEvent_type_value) (and (=> (= (ControlFlow 0 336782) 340041) inline$$Diem_register_currency_$def$0$anon106_Then_correct) (=> (= (ControlFlow 0 336782) 336832) inline$$Diem_register_currency_$def$0$anon106_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon104_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 336790) 336782)) inline$$Event_new_event_handle$3$Entry_correct)))
(let ((inline$$Event_new_event_handle$2$Entry_correct  (=> (= inline$$Event_new_event_handle$2$t@0 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 336740) 340061) inline$$Diem_register_currency_$def$0$anon104_Then_correct) (=> (= (ControlFlow 0 336740) 336790) inline$$Diem_register_currency_$def$0$anon104_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon102_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 336748) 336740)) inline$$Event_new_event_handle$2$Entry_correct)))
(let ((inline$$Event_new_event_handle$1$Entry_correct  (=> (= inline$$Event_new_event_handle$1$t@0 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 336698) 340081) inline$$Diem_register_currency_$def$0$anon102_Then_correct) (=> (= (ControlFlow 0 336698) 336748) inline$$Diem_register_currency_$def$0$anon102_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon100_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 336706) 336698)) inline$$Event_new_event_handle$1$Entry_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $Diem_MintEvent_type_value) (and (=> (= (ControlFlow 0 336656) 340101) inline$$Diem_register_currency_$def$0$anon100_Then_correct) (=> (= (ControlFlow 0 336656) 336706) inline$$Diem_register_currency_$def$0$anon100_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon98_Then_correct  (=> (|b#$Boolean| |inline$$Diem_register_currency_$def$0$tmp#$10@1|) (=> (and (and (= inline$$Diem_register_currency_$def$0$$t28@1 ($Integer 0)) (= inline$$Diem_register_currency_$def$0$$t29@1 ($Integer 0))) (and (= inline$$Diem_register_currency_$def$0$$t30@1 ($Boolean true)) (= (ControlFlow 0 336664) 336656))) inline$$Event_new_event_handle$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon46_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 336604) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 336602) 336604)) inline$$Diem_register_currency_$def$0$anon46_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon99_Then_correct  (=> (= (ControlFlow 0 336612) 336604) inline$$Diem_register_currency_$def$0$anon46_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon98_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Diem_register_currency_$def$0$tmp#$10@1|)) (= $abort_code@18 (|i#$Integer| call3formal@$ret0@0@@36))) (and (=> (= (ControlFlow 0 336596) 336612) inline$$Diem_register_currency_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 336596) 336602) inline$$Diem_register_currency_$def$0$anon99_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon96_Else_correct  (=> (not $abort_flag@17) (and (=> (= (ControlFlow 0 336584) 336664) inline$$Diem_register_currency_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 336584) 336596) inline$$Diem_register_currency_$def$0$anon98_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$L5_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def$0$$t26@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@17)) (and (=> $abort_flag@17 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@36 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@36) (>= (|i#$Integer| call3formal@$ret0@0@@36) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@36) $MAX_U64))) (and (=> (= (ControlFlow 0 336578) 340121) inline$$Diem_register_currency_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 336578) 336584) inline$$Diem_register_currency_$def$0$anon96_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon36_correct  (=> (and (= |inline$$Diem_register_currency_$def$0$tmp#$10@1| inline$$Le$0$dst@1) (= (ControlFlow 0 340227) 336578)) inline$$Diem_register_currency_$def$0$L5_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 340225) 340227)) inline$$Diem_register_currency_$def$0$anon36_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon94_Then_correct  (=> (= (ControlFlow 0 340235) 340227) inline$$Diem_register_currency_$def$0$anon36_correct)))
(let ((inline$$Le$0$anon0_correct  (=> (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| inline$$XUS_initialize_$def$0$$t7@1) (|i#$Integer| inline$$Diem_register_currency_$def$0$$t24@1)))) (and (=> (= (ControlFlow 0 340211) 340235) inline$$Diem_register_currency_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 340211) 340225) inline$$Diem_register_currency_$def$0$anon94_Else_correct)))))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 340197) (- 0 429103)) true) (=> (= (ControlFlow 0 340197) 340211) inline$$Le$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon93_Then_correct  (=> (|b#$Boolean| inline$$Lt$0$dst@1) (=> (and (= inline$$Diem_register_currency_$def$0$$t24@1 ($Integer 10000000000)) (= (ControlFlow 0 340217) 340197)) inline$$Le$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon38_correct  (=> (and (= |inline$$Diem_register_currency_$def$0$tmp#$10@1| inline$$Diem_register_currency_$def$0$$t25@1) (= (ControlFlow 0 336572) 336578)) inline$$Diem_register_currency_$def$0$L5_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 336570) 336572)) inline$$Diem_register_currency_$def$0$anon38_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon95_Then_correct  (=> (= (ControlFlow 0 340145) 336572) inline$$Diem_register_currency_$def$0$anon38_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon93_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= inline$$Diem_register_currency_$def$0$$t25@1 ($Boolean false))) (and (=> (= (ControlFlow 0 336562) 340145) inline$$Diem_register_currency_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 336562) 336570) inline$$Diem_register_currency_$def$0$anon95_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct  (=> (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| inline$$Diem_register_currency_$def$0$$t22@1) (|i#$Integer| inline$$XUS_initialize_$def$0$$t7@1)))) (and (=> (= (ControlFlow 0 336510) 340217) inline$$Diem_register_currency_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 336510) 336562) inline$$Diem_register_currency_$def$0$anon93_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 336496) (- 0 429028)) true) (=> (= (ControlFlow 0 336496) 336510) inline$$Lt$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon91_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (= inline$$Diem_register_currency_$def$0$$t22@1 ($Integer 0)) (= (ControlFlow 0 336516) 336496)) inline$$Lt$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon32_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@4)) (and (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 336428) 336436))) inline$$Diem_register_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 336426) 336428)) inline$$Diem_register_currency_$def$0$anon32_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon92_Then_correct  (=> (= (ControlFlow 0 336444) 336428) inline$$Diem_register_currency_$def$0$anon32_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon91_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@16 (|i#$Integer| call3formal@$ret0@0@@37))) (and (=> (= (ControlFlow 0 336420) 336444) inline$$Diem_register_currency_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 336420) 336426) inline$$Diem_register_currency_$def$0$anon92_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon89_Else_correct  (=> (not $abort_flag@16) (and (=> (= (ControlFlow 0 336408) 336516) inline$$Diem_register_currency_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 336408) 336420) inline$$Diem_register_currency_$def$0$anon91_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon87_Else$1_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def$0$$t20@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@16)) (and (=> $abort_flag@16 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@16) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@37 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@37) (>= (|i#$Integer| call3formal@$ret0@0@@37) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@37) $MAX_U64))) (and (=> (= (ControlFlow 0 336402) 340239) inline$$Diem_register_currency_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 336402) 336408) inline$$Diem_register_currency_$def$0$anon89_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_register_currency_$def$0$$t18@1)))) (= (ControlFlow 0 336390) 336402)) inline$$Diem_register_currency_$def$0$anon87_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 336380) (- 0 428898)) true) (=> (= (ControlFlow 0 336380) 336390) inline$$Not$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon87_Else_correct  (=> (not $abort_flag@15) (=> (and (= inline$$Diem_register_currency_$def$0$$t18@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency$0$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@38)))) (= (ControlFlow 0 336396) 336380)) inline$$Not$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon85_Else_correct  (=> (not $abort_flag@14) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@15) (=> $abort_flag@15 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@15) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@38 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@38))) (and (=> (= (ControlFlow 0 336322) 340259) inline$$Diem_register_currency_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 336322) 336396) inline$$Diem_register_currency_$def$0$anon87_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$0$anon83_Else_correct  (=> (and (and (not $abort_flag@13) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@14)) (and (=> $abort_flag@14 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@14 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@13 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 336316) 340279) inline$$Diem_register_currency_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 336316) 336322) inline$$Diem_register_currency_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon12$6_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@13) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@13)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@13) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@13)) (and (=> $abort_flag@13 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@13 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@12 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@12 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@12 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@12 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 336310) 340299) inline$$Diem_register_currency_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 336310) 336316) inline$$Diem_register_currency_$def$0$anon83_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 336104) 336310)) inline$$Diem_register_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon82_Then_correct  (=> (= (ControlFlow 0 340323) 336310) inline$$Diem_register_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon81_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 336096) 340323) inline$$Diem_register_currency_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 336096) 336104) inline$$Diem_register_currency_$def$0$anon82_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon81_Then_correct  (and (=> (= (ControlFlow 0 340331) 340323) inline$$Diem_register_currency_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 340331) 336104) inline$$Diem_register_currency_$def$0$anon82_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon80_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 336088) 340331) inline$$Diem_register_currency_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 336088) 336096) inline$$Diem_register_currency_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon80_Then_correct  (and (=> (= (ControlFlow 0 340339) 340331) inline$$Diem_register_currency_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 340339) 336096) inline$$Diem_register_currency_$def$0$anon81_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon79_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 336080) 340339) inline$$Diem_register_currency_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 336080) 336088) inline$$Diem_register_currency_$def$0$anon80_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon79_Then_correct  (and (=> (= (ControlFlow 0 340347) 340339) inline$$Diem_register_currency_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 340347) 336088) inline$$Diem_register_currency_$def$0$anon80_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon78_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 336072) 340347) inline$$Diem_register_currency_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 336072) 336080) inline$$Diem_register_currency_$def$0$anon79_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon78_Then_correct  (and (=> (= (ControlFlow 0 340355) 340347) inline$$Diem_register_currency_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 340355) 336080) inline$$Diem_register_currency_$def$0$anon79_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon77_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 336064) 340355) inline$$Diem_register_currency_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 336064) 336072) inline$$Diem_register_currency_$def$0$anon78_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon77_Then_correct  (and (=> (= (ControlFlow 0 340363) 340355) inline$$Diem_register_currency_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 340363) 336072) inline$$Diem_register_currency_$def$0$anon78_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon0_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 336058) 340363) inline$$Diem_register_currency_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 336058) 336064) inline$$Diem_register_currency_$def$0$anon77_Else_correct)))))
(let ((inline$$Diem_register_currency$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@4) (let ((va@@90 (|v#$Vector| call4formal@$ret0@0@@4)))
(let ((l@@90 (|l#$ValueArray| va@@90)))
 (and (and (<= 0 l@@90) (<= l@@90 $MAX_U64)) (forall ((x@@90 Int) ) (!  (=> (or (< x@@90 0) (>= x@@90 l@@90)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) inline$$Diem_register_SCS_currency_$def$0$$t16@1)) (and (and (and (and ((_ is $Integer) inline$$XUS_initialize_$def$0$$t7@1) (>= (|i#$Integer| inline$$XUS_initialize_$def$0$$t7@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def$0$$t7@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$XUS_initialize_$def$0$$t8@1) (>= (|i#$Integer| inline$$XUS_initialize_$def$0$$t8@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def$0$$t8@1) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$XUS_initialize_$def$0$$t9@1) (let ((va@@91 (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)))
(let ((l@@91 (|l#$ValueArray| va@@91)))
 (and (and (<= 0 l@@91) (<= l@@91 $MAX_U64)) (forall ((x@@91 Int) ) (!  (=> (or (< x@@91 0) (>= x@@91 l@@91)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91))
)))))) (forall ((inline$$Diem_register_currency$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_register_currency$0$$$0 0) (< inline$$Diem_register_currency$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_register_currency$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_register_currency$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_register_currency$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_register_currency$0$$$0))
))) (= (ControlFlow 0 340371) 336058)))) inline$$Diem_register_currency_$def$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon47_Else_correct  (=> (not $abort_flag@12) (=> (and (= inline$$Diem_register_SCS_currency_$def$0$$t16@1 ($Boolean false)) (= (ControlFlow 0 340381) 340371)) inline$$Diem_register_currency$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon12$6_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@12) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@12) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@12)) (and (=> $abort_flag@12 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@12 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@11 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@11 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@11 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 334521) 342260) inline$$Diem_register_SCS_currency_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 334521) 340381) inline$$Diem_register_SCS_currency_$def$0$anon47_Else_correct))))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 334315) 334521)) inline$$Diem_register_SCS_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 342284) 334521) inline$$Diem_register_SCS_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 334307) 342284) inline$$Diem_register_SCS_currency_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 334307) 334315) inline$$Diem_register_SCS_currency_$def$0$anon46_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 342292) 342284) inline$$Diem_register_SCS_currency_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 342292) 334315) inline$$Diem_register_SCS_currency_$def$0$anon46_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon44_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 334299) 342292) inline$$Diem_register_SCS_currency_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 334299) 334307) inline$$Diem_register_SCS_currency_$def$0$anon45_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon44_Then_correct  (and (=> (= (ControlFlow 0 342300) 342292) inline$$Diem_register_SCS_currency_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 342300) 334307) inline$$Diem_register_SCS_currency_$def$0$anon45_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon43_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 334291) 342300) inline$$Diem_register_SCS_currency_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 334291) 334299) inline$$Diem_register_SCS_currency_$def$0$anon44_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon43_Then_correct  (and (=> (= (ControlFlow 0 342308) 342300) inline$$Diem_register_SCS_currency_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 342308) 334299) inline$$Diem_register_SCS_currency_$def$0$anon44_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon42_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 334283) 342308) inline$$Diem_register_SCS_currency_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 334283) 334291) inline$$Diem_register_SCS_currency_$def$0$anon43_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon42_Then_correct  (and (=> (= (ControlFlow 0 342316) 342308) inline$$Diem_register_SCS_currency_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 342316) 334291) inline$$Diem_register_SCS_currency_$def$0$anon43_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 334275) 342316) inline$$Diem_register_SCS_currency_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 334275) 334283) inline$$Diem_register_SCS_currency_$def$0$anon42_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 342324) 342316) inline$$Diem_register_SCS_currency_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 342324) 334283) inline$$Diem_register_SCS_currency_$def$0$anon42_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon0_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 334269) 342324) inline$$Diem_register_SCS_currency_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 334269) 334275) inline$$Diem_register_SCS_currency_$def$0$anon41_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency$0$anon0_correct  (=> (and ((_ is $Address) dr_account) ((_ is $Address) tc_account)) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@4) (let ((va@@92 (|v#$Vector| call4formal@$ret0@0@@4)))
(let ((l@@92 (|l#$ValueArray| va@@92)))
 (and (and (<= 0 l@@92) (<= l@@92 $MAX_U64)) (forall ((x@@92 Int) ) (!  (=> (or (< x@@92 0) (>= x@@92 l@@92)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Integer) inline$$XUS_initialize_$def$0$$t7@1) (>= (|i#$Integer| inline$$XUS_initialize_$def$0$$t7@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def$0$$t7@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$XUS_initialize_$def$0$$t8@1) (>= (|i#$Integer| inline$$XUS_initialize_$def$0$$t8@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def$0$$t8@1) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$XUS_initialize_$def$0$$t9@1) (let ((va@@93 (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)))
(let ((l@@93 (|l#$ValueArray| va@@93)))
 (and (and (<= 0 l@@93) (<= l@@93 $MAX_U64)) (forall ((x@@93 Int) ) (!  (=> (or (< x@@93 0) (>= x@@93 l@@93)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93))
)))))) (forall ((inline$$Diem_register_SCS_currency$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_register_SCS_currency$0$$$0 0) (< inline$$Diem_register_SCS_currency$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_register_SCS_currency$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_register_SCS_currency$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_register_SCS_currency$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def$0$$t9@1)) inline$$Diem_register_SCS_currency$0$$$0))
))) (= (ControlFlow 0 342328) 334269)))) inline$$Diem_register_SCS_currency_$def$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency$0$Entry_correct  (=> (and (= inline$$Diem_register_SCS_currency$0$$tv0@0 $XUS_XUS_type_value) (= (ControlFlow 0 333478) 342328)) inline$$Diem_register_SCS_currency$0$anon0_correct)))
(let ((inline$$XUS_initialize_$def$0$anon21_Else_correct  (=> (not $abort_flag@11) (=> (and (and (= inline$$XUS_initialize_$def$0$$t7@1 ($Integer 1000000)) (= inline$$XUS_initialize_$def$0$$t8@1 ($Integer 100))) (and (= inline$$XUS_initialize_$def$0$$t9@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 88)) 1 ($Integer 85)) 2 ($Integer 83)) 3))) (= (ControlFlow 0 342334) 333478))) inline$$Diem_register_SCS_currency$0$Entry_correct))))
(let ((inline$$XUS_initialize_$def$0$anon19_Else_correct  (=> (not $abort_flag@10) (=> (and (and (and (= inline$$XUS_initialize_$def$0$$t4@1 ($Integer 1)) (= inline$$XUS_initialize_$def$0$$t5@1 ($Integer 1))) (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl inline$$XUS_initialize_$def$0$$t5@1 ($Integer 32)) ($Integer 0)))) $abort_flag@11) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t5@1 ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl inline$$XUS_initialize_$def$0$$t4@1 ($Integer 64)) ($Integer 0)))))))) $abort_flag@11))) (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t5@1 ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@11) (=> $abort_flag@11 (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl inline$$XUS_initialize_$def$0$$t5@1 ($Integer 32)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t5@1 ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl inline$$XUS_initialize_$def$0$$t4@1 ($Integer 64)) ($Integer 0))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t5@1 ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (and (=> $abort_flag@11 (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl inline$$XUS_initialize_$def$0$$t5@1 ($Integer 32)) ($Integer 0)))) (= $abort_code@10 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t5@1 ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl inline$$XUS_initialize_$def$0$$t4@1 ($Integer 64)) ($Integer 0)))))))) (= $abort_code@10 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def$0$$t5@1 ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@10 (|i#$Integer| ($Integer 8)))))) (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@4 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$XUS_initialize_$def$0$$t4@1 inline$$XUS_initialize_$def$0$$t5@1))) ($Vector (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 ($Integer 1)) (+ len@@4 1)))) ($Vector (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Integer 2)) (+ len@@5 1)))))))))))) (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@4) (let ((va@@94 (|v#$Vector| call4formal@$ret0@0@@4)))
(let ((l@@94 (|l#$ValueArray| va@@94)))
 (and (and (<= 0 l@@94) (<= l@@94 $MAX_U64)) (forall ((x@@94 Int) ) (!  (=> (or (< x@@94 0) (>= x@@94 l@@94)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 333260) 343823) inline$$XUS_initialize_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 333260) 342334) inline$$XUS_initialize_$def$0$anon21_Else_correct)))))))
(let ((inline$$XUS_initialize_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@10) (=> (and (=> $abort_flag@10 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@10 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 333246) 343843) inline$$XUS_initialize_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 333246) 333260) inline$$XUS_initialize_$def$0$anon19_Else_correct))))))
(let ((inline$$XUS_initialize_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 333176) 333246)) inline$$XUS_initialize_$def$0$anon4$2_correct)))
(let ((inline$$XUS_initialize_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 343867) 333246) inline$$XUS_initialize_$def$0$anon4$2_correct)))
(let ((inline$$XUS_initialize_$def$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 333168) 343867) inline$$XUS_initialize_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 333168) 333176) inline$$XUS_initialize_$def$0$anon18_Else_correct)))))
(let ((inline$$XUS_initialize_$def$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 343875) 343867) inline$$XUS_initialize_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 343875) 333176) inline$$XUS_initialize_$def$0$anon18_Else_correct))))
(let ((inline$$XUS_initialize_$def$0$anon0_correct  (=> (not $abort_flag@9) (and (=> (= (ControlFlow 0 333162) 343875) inline$$XUS_initialize_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 333162) 333168) inline$$XUS_initialize_$def$0$anon17_Else_correct)))))
(let ((inline$$XUS_initialize_$direct_inter$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 343879) 333162)) inline$$XUS_initialize_$def$0$anon0_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon82_Else_correct  (=> (and (not $abort_flag@9) (= (ControlFlow 0 343885) 343879)) inline$$XUS_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon82_Then_correct true))
(let ((inline$$Diem_initialize_$def$0$Abort_correct  (=> (= $DiemConfig_ModifyConfigCapability_$memory@4 $DiemConfig_ModifyConfigCapability_$memory@3) (=> (and (= $abort_flag@9 true) (= $DiemConfig_DiemConfig_$memory@4 $DiemConfig_DiemConfig_$memory@3)) (and (=> (= (ControlFlow 0 332623) 388312) inline$$Genesis_initialize_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 332623) 343885) inline$$Genesis_initialize_$def_verify$0$anon82_Else_correct))))))
(let ((inline$$Diem_initialize_$def$0$anon5_correct  (=> (= $DiemConfig_ModifyConfigCapability_$memory@3 $DiemConfig_ModifyConfigCapability_$memory) (=> (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 332655) 332623)) inline$$Diem_initialize_$def$0$Abort_correct))))
(let ((inline$$Diem_initialize_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 332653) 332655)) inline$$Diem_initialize_$def$0$anon5_correct)))
(let ((inline$$Diem_initialize_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 332663) 332655) inline$$Diem_initialize_$def$0$anon5_correct)))
(let ((inline$$Diem_initialize_$def$0$anon14_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 332647) 332663) inline$$Diem_initialize_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 332647) 332653) inline$$Diem_initialize_$def$0$anon15_Else_correct)))))
(let ((inline$$Diem_initialize_$def$0$anon9_correct  (=> (= $DiemConfig_ModifyConfigCapability_$memory@3 $DiemConfig_ModifyConfigCapability_$memory) (=> (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 332635) 332623)) inline$$Diem_initialize_$def$0$Abort_correct))))
(let ((inline$$Diem_initialize_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 332633) 332635)) inline$$Diem_initialize_$def$0$anon9_correct)))
(let ((inline$$Diem_initialize_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 332643) 332635) inline$$Diem_initialize_$def$0$anon9_correct)))
(let ((inline$$Diem_initialize_$def$0$anon16_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 332627) 332643) inline$$Diem_initialize_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 332627) 332633) inline$$Diem_initialize_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_initialize_$def$0$anon18_Then_correct  (=> (and (and $abort_flag@8 (= $DiemConfig_ModifyConfigCapability_$memory@3 $DiemConfig_ModifyConfigCapability_$memory@2)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory@2) (= (ControlFlow 0 332619) 332623))) inline$$Diem_initialize_$def$0$Abort_correct)))
(let ((inline$$Diem_initialize_$def$0$anon18_Else_correct  (=> (and (and (not $abort_flag@8) (= $DiemConfig_ModifyConfigCapability_$memory@4 $DiemConfig_ModifyConfigCapability_$memory@2)) (and (= $abort_flag@9 $abort_flag@8) (= $DiemConfig_DiemConfig_$memory@4 $DiemConfig_DiemConfig_$memory@2))) (and (=> (= (ControlFlow 0 332615) 388312) inline$$Genesis_initialize_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 332615) 343885) inline$$Genesis_initialize_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct  (=> (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@1) (=> (and (= $abort_flag@8 true) (= $DiemConfig_ModifyConfigCapability_$memory@2 $DiemConfig_ModifyConfigCapability_$memory@1)) (and (=> (= (ControlFlow 0 332521) 332619) inline$$Diem_initialize_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 332521) 332615) inline$$Diem_initialize_$def$0$anon18_Else_correct))))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon5_correct  (=> (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory) (= (ControlFlow 0 332581) 332521)) inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 332579) 332581)) inline$$RegisteredCurrencies_initialize_$def$0$anon5_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 332589) 332581) inline$$RegisteredCurrencies_initialize_$def$0$anon5_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon20_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 332573) 332589) inline$$RegisteredCurrencies_initialize_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 332573) 332579) inline$$RegisteredCurrencies_initialize_$def$0$anon21_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon9_correct  (=> (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory) (= (ControlFlow 0 332561) 332521)) inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 332559) 332561)) inline$$RegisteredCurrencies_initialize_$def$0$anon9_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 332569) 332561) inline$$RegisteredCurrencies_initialize_$def$0$anon9_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon22_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 332553) 332569) inline$$RegisteredCurrencies_initialize_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 332553) 332559) inline$$RegisteredCurrencies_initialize_$def$0$anon23_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon13_correct  (=> (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory) (= (ControlFlow 0 332541) 332521)) inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 332539) 332541)) inline$$RegisteredCurrencies_initialize_$def$0$anon13_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 332549) 332541) inline$$RegisteredCurrencies_initialize_$def$0$anon13_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon24_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 332533) 332549) inline$$RegisteredCurrencies_initialize_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 332533) 332539) inline$$RegisteredCurrencies_initialize_$def$0$anon25_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon17_correct  (=> (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory@0) (=> (and (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory@0) (= (ControlFlow 0 332517) 332521)) inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 332515) 332517)) inline$$RegisteredCurrencies_initialize_$def$0$anon17_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 332529) 332517) inline$$RegisteredCurrencies_initialize_$def$0$anon17_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon26_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 332509) 332529) inline$$RegisteredCurrencies_initialize_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 332509) 332515) inline$$RegisteredCurrencies_initialize_$def$0$anon27_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon26_Else_correct  (=> (and (and (not $abort_flag@7) (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@0)) (and (= $abort_flag@8 $abort_flag@7) (= $DiemConfig_ModifyConfigCapability_$memory@2 $DiemConfig_ModifyConfigCapability_$memory@0))) (and (=> (= (ControlFlow 0 332505) 332619) inline$$Diem_initialize_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 332505) 332615) inline$$Diem_initialize_$def$0$anon18_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else$1_correct  (=> (= call0formal@$tv0@0@@13 $RegisteredCurrencies_RegisteredCurrencies_type_value) (=> (and (= call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@2 ($ConstMemoryDomain true)) (= call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@2 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 332499) (- 0 426106)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 332499) (- 0 426126)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@7) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| dr_account)))) $abort_flag@7)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@7) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@7))) (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@7) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@7)) (and (=> $abort_flag@7 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@7 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@8 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@8 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@8 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@8 (|i#$Integer| ($Integer 2))))))))) (and (and (and (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| dr_account))))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@7 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| addr@@7)))) $DiemConfig_DiemConfig_payload)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$struct@1)))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 332499) 332509) inline$$RegisteredCurrencies_initialize_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 332499) 332505) inline$$RegisteredCurrencies_initialize_$def$0$anon26_Else_correct)))))))))))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 332485) 332499)) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else$1_correct)))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 332491) 332499) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else$1_correct)))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 332479) 332491) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 332479) 332485) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon4_Else_correct)))))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 332471) 332499)) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else$1_correct)))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon0_correct  (=> (and (and (and ((_ is $Vector) inline$$Vector_empty$0$v@1) (let ((va@@95 (|v#$Vector| inline$$Vector_empty$0$v@1)))
(let ((l@@95 (|l#$ValueArray| va@@95)))
 (and (and (<= 0 l@@95) (<= l@@95 $MAX_U64)) (forall ((x@@95 Int) ) (!  (=> (or (< x@@95 0) (>= x@@95 l@@95)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95))
)))))) (forall ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0 0) (< inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0)) (let ((va@@96 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))))
(let ((l@@96 (|l#$ValueArray| va@@96)))
 (and (and (<= 0 l@@96) (<= l@@96 $MAX_U64)) (forall ((x@@96 Int) ) (!  (=> (or (< x@@96 0) (>= x@@96 l@@96)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96))
)))))) (forall ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1 Int) ) (!  (=> (and (>= inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1 0) (< inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))
))) (= inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Vector_empty$0$v@1) 1)))) (and (=> (= (ControlFlow 0 332463) 332479) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 332463) 332471) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon3_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 332497) 332463)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon0_correct)))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 332160) 332533) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 332160) 332497) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 332156) 332160)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon22_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 332166) 332156)) inline$$Vector_empty$0$Entry_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon20_Else_correct  (=> (not $abort_flag@5) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@6)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6)) (and (=> $abort_flag@6 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@6 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@7 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@7 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@7 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@7 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 332125) 332553) inline$$RegisteredCurrencies_initialize_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 332125) 332166) inline$$RegisteredCurrencies_initialize_$def$0$anon22_Else_correct)))))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5) (=> (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 332119) 332573) inline$$RegisteredCurrencies_initialize_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 332119) 332125) inline$$RegisteredCurrencies_initialize_$def$0$anon20_Else_correct))))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 332083) 332119)) inline$$RegisteredCurrencies_initialize_$def$0$anon2$1_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 332597) 332119) inline$$RegisteredCurrencies_initialize_$def$0$anon2$1_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon0_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 332077) 332597) inline$$RegisteredCurrencies_initialize_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 332077) 332083) inline$$RegisteredCurrencies_initialize_$def$0$anon19_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 332601) 332077)) inline$$RegisteredCurrencies_initialize_$def$0$anon0_correct)))
(let ((inline$$Diem_initialize_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 332607) 332601)) inline$$RegisteredCurrencies_initialize$0$anon0_correct)))
(let ((inline$$Diem_initialize_$def$0$anon14_Else_correct  (=> (and (and (not $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@4 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@5 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 331714) 332627) inline$$Diem_initialize_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 331714) 332607) inline$$Diem_initialize_$def$0$anon16_Else_correct)))))
(let ((inline$$Diem_initialize_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3) (=> (and (=> $abort_flag@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@4 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 331708) 332647) inline$$Diem_initialize_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 331708) 331714) inline$$Diem_initialize_$def$0$anon14_Else_correct))))))
(let ((inline$$Diem_initialize_$def$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 331672) 331708)) inline$$Diem_initialize_$def$0$anon2$1_correct)))
(let ((inline$$Diem_initialize_$def$0$anon13_Then_correct  (=> (= (ControlFlow 0 332671) 331708) inline$$Diem_initialize_$def$0$anon2$1_correct)))
(let ((inline$$Diem_initialize_$def$0$anon0_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 331666) 332671) inline$$Diem_initialize_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 331666) 331672) inline$$Diem_initialize_$def$0$anon13_Else_correct)))))
(let ((inline$$Diem_initialize_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 332675) 331666)) inline$$Diem_initialize_$def$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon80_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 332681) 332675)) inline$$Diem_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon78_Else_correct  (=> (and (not $abort_flag@1) (= call1formal@$DiemConfig_Configuration_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 331403) (- 0 424996)) (|Select_[$TypeValueArray,$int]$bool| call1formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call1formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@2) (=> $abort_flag@2 (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))))) (and (=> $abort_flag@2 (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@3 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 2)))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch) ($Integer 0))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time) ($Integer 0)))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 331403) 388316) inline$$Genesis_initialize_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 331403) 332681) inline$$Genesis_initialize_$def_verify$0$anon80_Else_correct)))))))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon76_Else_correct  (=> (and (not $abort_flag@0) (= call2formal@$ChainId_ChainId_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 331397) (- 0 424720)) (|Select_[$TypeValueArray,$int]$bool| call2formal@$ChainId_ChainId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| dr_account))) (=> (|Select_[$TypeValueArray,$int]$bool| call2formal@$ChainId_ChainId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| dr_account)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $abort_flag@1) (=> $abort_flag@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (and (and (=> $abort_flag@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@2 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) (= $abort_code@2 (|i#$Integer| ($Integer 6)))))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))) (and (= (|contents#$Memory| $ChainId_ChainId_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ChainId_ChainId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) (= (|domain#$Memory| $ChainId_ChainId_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (and (=> (= (ControlFlow 0 331397) 388336) inline$$Genesis_initialize_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 331397) 331403) inline$$Genesis_initialize_$def_verify$0$anon78_Else_correct))))))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon18$9_correct  (=> (= inline$$Genesis_initialize_$def_verify$0$$t20@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 0)) 1 ($Integer 0)) 2 ($Integer 0)) 3 ($Integer 0)) 4 ($Integer 0)) 5 ($Integer 0)) 6 ($Integer 0)) 7 ($Integer 0)) 8 ($Integer 0)) 9 ($Integer 0)) 10 ($Integer 0)) 11 ($Integer 0)) 12 ($Integer 0)) 13 ($Integer 0)) 14 ($Integer 0)) 15 ($Integer 0)) 16))) (=> (and (= call2formal@$Roles_RoleId_$CallerDomain@0 ($ConstMemoryDomain true)) (= call3formal@$AccountFreezing_FreezingBit_$CallerDomain@0 ($ConstMemoryDomain true))) (=> (and (and (= call4formal@$SlidingNonce_SlidingNonce_$CallerDomain@0 ($ConstMemoryDomain true)) (= call5formal@$DiemAccount_DiemAccount_$CallerDomain@0 ($ConstMemoryDomain true))) (and (= call6formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 ($ConstMemoryDomain true)) (= call7formal@$DiemAccount_DiemWriteSetManager_$CallerDomain@0 ($ConstMemoryDomain true)))) (and (=> (= (ControlFlow 0 331391) (- 0 423053)) (|Select_[$TypeValueArray,$int]$bool| call2formal@$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call2formal@$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 331391) (- 0 423062)) (|Select_[$TypeValueArray,$int]$bool| call2formal@$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| call2formal@$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 331391) (- 0 423071)) (|Select_[$TypeValueArray,$int]$bool| call2formal@$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call2formal@$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 331391) (- 0 423080)) (|Select_[$TypeValueArray,$int]$bool| call2formal@$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| call2formal@$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 331391) (- 0 423089)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$AccountFreezing_FreezingBit_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$AccountFreezing_FreezingBit_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 331391) (- 0 423098)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$AccountFreezing_FreezingBit_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$AccountFreezing_FreezingBit_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 331391) (- 0 423107)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$SlidingNonce_SlidingNonce_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$SlidingNonce_SlidingNonce_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 331391) (- 0 423116)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$SlidingNonce_SlidingNonce_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$SlidingNonce_SlidingNonce_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 331391) (- 0 423125)) (|Select_[$TypeValueArray,$int]$bool| call5formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call5formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 331391) (- 0 423134)) (|Select_[$TypeValueArray,$int]$bool| call5formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| call5formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 331391) (- 0 423143)) (|Select_[$TypeValueArray,$int]$bool| call6formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call6formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 331391) (- 0 423152)) (|Select_[$TypeValueArray,$int]$bool| call6formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call6formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 331391) (- 0 423161)) (|Select_[$TypeValueArray,$int]$bool| call7formal@$DiemAccount_DiemWriteSetManager_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call7formal@$DiemAccount_DiemWriteSetManager_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@0) (=> (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@0) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@0)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@0) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@0))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@0)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Genesis_initialize_$def_verify$0$$t20@1)))))) ($Integer 32))))) $abort_flag@0) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@0))) (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@0)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@0) (=> $abort_flag@0 (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Genesis_initialize_$def_verify$0$$t20@1)))))) ($Integer 32)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))))) (=> (and (and (and (and (and (=> $abort_flag@0 (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@1 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| inline$$Genesis_initialize_$def_verify$0$$t20@1)))))) ($Integer 32))))) (= $abort_code@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@1 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@1 (|i#$Integer| ($Integer 6)))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))) (and (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (and (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0)))))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 173345816) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))))) (and (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 173345816) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1)))))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))))) (and (and (and (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen)))))))))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))))) (and (and (= (|contents#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= (|domain#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (and (= (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))) (and (and (and (= (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (and (= (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))))) (and (and (= (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 331391) 388356) inline$$Genesis_initialize_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 331391) 331397) inline$$Genesis_initialize_$def_verify$0$anon76_Else_correct)))))))))))))))))))))))))))))))))))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 330945) 331391)) inline$$Genesis_initialize_$def_verify$0$anon18$9_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon75_Then_correct  (=> (= (ControlFlow 0 388380) 331391) inline$$Genesis_initialize_$def_verify$0$anon18$9_correct)))
(let ((inline$$Genesis_initialize_$def_verify$0$anon74_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 330937) 388380) inline$$Genesis_initialize_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 330937) 330945) inline$$Genesis_initialize_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon74_Then_correct  (and (=> (= (ControlFlow 0 388388) 388380) inline$$Genesis_initialize_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 388388) 330945) inline$$Genesis_initialize_$def_verify$0$anon75_Else_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon73_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 330929) 388388) inline$$Genesis_initialize_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 330929) 330937) inline$$Genesis_initialize_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon73_Then_correct  (and (=> (= (ControlFlow 0 388396) 388388) inline$$Genesis_initialize_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 388396) 330937) inline$$Genesis_initialize_$def_verify$0$anon74_Else_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon72_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 330921) 388396) inline$$Genesis_initialize_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 330921) 330929) inline$$Genesis_initialize_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon72_Then_correct  (and (=> (= (ControlFlow 0 388404) 388396) inline$$Genesis_initialize_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 388404) 330929) inline$$Genesis_initialize_$def_verify$0$anon73_Else_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon71_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 330913) 388404) inline$$Genesis_initialize_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 330913) 330921) inline$$Genesis_initialize_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon71_Then_correct  (and (=> (= (ControlFlow 0 388412) 388404) inline$$Genesis_initialize_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 388412) 330921) inline$$Genesis_initialize_$def_verify$0$anon72_Else_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon70_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 330905) 388412) inline$$Genesis_initialize_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 330905) 330913) inline$$Genesis_initialize_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon70_Then_correct  (and (=> (= (ControlFlow 0 388420) 388412) inline$$Genesis_initialize_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 388420) 330913) inline$$Genesis_initialize_$def_verify$0$anon71_Else_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon69_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 330897) 388420) inline$$Genesis_initialize_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 330897) 330905) inline$$Genesis_initialize_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon69_Then_correct  (and (=> (= (ControlFlow 0 388428) 388420) inline$$Genesis_initialize_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 388428) 330905) inline$$Genesis_initialize_$def_verify$0$anon70_Else_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon68_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 330889) 388428) inline$$Genesis_initialize_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 330889) 330897) inline$$Genesis_initialize_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon68_Then_correct  (and (=> (= (ControlFlow 0 388436) 388428) inline$$Genesis_initialize_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 388436) 330897) inline$$Genesis_initialize_$def_verify$0$anon69_Else_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon67_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 330881) 388436) inline$$Genesis_initialize_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 330881) 330889) inline$$Genesis_initialize_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon67_Then_correct  (and (=> (= (ControlFlow 0 388444) 388436) inline$$Genesis_initialize_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 388444) 330889) inline$$Genesis_initialize_$def_verify$0$anon68_Else_correct))))
(let ((inline$$Genesis_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 330875) 388444) inline$$Genesis_initialize_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 330875) 330881) inline$$Genesis_initialize_$def_verify$0$anon67_Else_correct)))))
(let ((anon0$1_correct  (=> (and (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@97 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@97 (|l#$ValueArray| va@@97)))
 (and (and (<= 0 l@@97) (<= l@@97 $MAX_U64)) (forall ((x@@97 Int) ) (!  (=> (or (< x@@97 0) (>= x@@97 l@@97)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@98 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@98 (|l#$ValueArray| va@@98)))
 (and (and (<= 0 l@@98) (<= l@@98 $MAX_U64)) (forall ((x@@98 Int) ) (!  (=> (or (< x@@98 0) (>= x@@98 l@@98)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@99 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@99 (|l#$ValueArray| va@@99)))
 (and (and (<= 0 l@@99) (<= l@@99 $MAX_U64)) (forall ((x@@99 Int) ) (!  (=> (or (< x@@99 0) (>= x@@99 l@@99)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) 2)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle)) (let ((va@@100 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))))
(let ((l@@100 (|l#$ValueArray| va@@100)))
 (and (and (<= 0 l@@100) (<= l@@100 $MAX_U64)) (forall ((x@@100 Int) ) (!  (=> (or (< x@@100 0) (>= x@@100 l@@100)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid)) (let ((va@@101 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))))
(let ((l@@101 (|l#$ValueArray| va@@101)))
 (and (and (<= 0 l@@101) (<= l@@101 $MAX_U64)) (forall ((x@@101 Int) ) (!  (=> (or (< x@@101 0) (>= x@@101 l@@101)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101))
))))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_freeze_event_handle))) $Event_EventHandle_guid))) $$0@@19))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle)) (let ((va@@102 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))))
(let ((l@@102 (|l#$ValueArray| va@@102)))
 (and (and (<= 0 l@@102) (<= l@@102 $MAX_U64)) (forall ((x@@102 Int) ) (!  (=> (or (< x@@102 0) (>= x@@102 l@@102)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid)) (let ((va@@103 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))))
(let ((l@@103 (|l#$ValueArray| va@@103)))
 (and (and (<= 0 l@@103) (<= l@@103 $MAX_U64)) (forall ((x@@103 Int) ) (!  (=> (or (< x@@103 0) (>= x@@103 l@@103)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103))
))))))) (forall (($$0@@20 Int) ) (!  (=> (and (>= $$0@@20 0) (< $$0@@20 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle))) $Event_EventHandle_guid))) $$0@@20))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@104 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@104 (|l#$ValueArray| va@@104)))
 (and (and (<= 0 l@@104) (<= l@@104 $MAX_U64)) (forall ((x@@104 Int) ) (!  (=> (or (< x@@104 0) (>= x@@104 l@@104)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@2))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@2))
)))) (and (and (forall (($inv_addr@@3 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3)) (let ((va@@105 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))))
(let ((l@@105 (|l#$ValueArray| va@@105)))
 (and (and (<= 0 l@@105) (<= l@@105 $MAX_U64)) (forall ((x@@105 Int) ) (!  (=> (or (< x@@105 0) (>= x@@105 l@@105)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@3))
)) (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@106 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@106 (|l#$ValueArray| va@@106)))
 (and (and (<= 0 l@@106) (<= l@@106 $MAX_U64)) (forall ((x@@106 Int) ) (!  (=> (or (< x@@106 0) (>= x@@106 l@@106)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray $inv_addr@@4))) $ChainId_ChainId_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray $inv_addr@@4))) $ChainId_ChainId_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray $inv_addr@@4))) $ChainId_ChainId_id)) $MAX_U8))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray $inv_addr@@4))
))) (and (forall (($inv_addr@@5 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@5)) (let ((va@@107 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@5))))
(let ((l@@107 (|l#$ValueArray| va@@107)))
 (and (and (<= 0 l@@107) (<= l@@107 $MAX_U64)) (forall ((x@@107 Int) ) (!  (=> (or (< x@@107 0) (>= x@@107 l@@107)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@5))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@5))
)) (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@108 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@108 (|l#$ValueArray| va@@108)))
 (and (and (<= 0 l@@108) (<= l@@108 $MAX_U64)) (forall ((x@@108 Int) ) (!  (=> (or (< x@@108 0) (>= x@@108 l@@108)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events)) (let ((va@@109 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))))
(let ((l@@109 (|l#$ValueArray| va@@109)))
 (and (and (<= 0 l@@109) (<= l@@109 $MAX_U64)) (forall ((x@@109 Int) ) (!  (=> (or (< x@@109 0) (>= x@@109 l@@109)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@110 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@110 (|l#$ValueArray| va@@110)))
 (and (and (<= 0 l@@110) (<= l@@110 $MAX_U64)) (forall ((x@@110 Int) ) (!  (=> (or (< x@@110 0) (>= x@@110 l@@110)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110))
))))))) (forall (($$0@@21 Int) ) (!  (=> (and (>= $$0@@21 0) (< $$0@@21 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@21)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@21)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@21)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@21))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@6))
))))) (=> (and (and (and (and (and (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@111 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@111 (|l#$ValueArray| va@@111)))
 (and (and (<= 0 l@@111) (<= l@@111 $MAX_U64)) (forall ((x@@111 Int) ) (!  (=> (or (< x@@111 0) (>= x@@111 l@@111)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (forall (($inv_addr@@8 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@8)) (let ((va@@112 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@8))))
(let ((l@@112 (|l#$ValueArray| va@@112)))
 (and (and (<= 0 l@@112) (<= l@@112 $MAX_U64)) (forall ((x@@112 Int) ) (!  (=> (or (< x@@112 0) (>= x@@112 l@@112)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@8))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@8))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@8))
))) (and (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@113 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@113 (|l#$ValueArray| va@@113)))
 (and (and (<= 0 l@@113) (<= l@@113 $MAX_U64)) (forall ((x@@113 Int) ) (!  (=> (or (< x@@113 0) (>= x@@113 l@@113)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)) (let ((va@@114 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))))
(let ((l@@114 (|l#$ValueArray| va@@114)))
 (and (and (<= 0 l@@114) (<= l@@114 $MAX_U64)) (forall ((x@@114 Int) ) (!  (=> (or (< x@@114 0) (>= x@@114 l@@114)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114))
))))))) (forall (($$0@@22 Int) ) (!  (=> (and (>= $$0@@22 0) (< $$0@@22 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@22)) (let ((va@@115 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@22))))
(let ((l@@115 (|l#$ValueArray| va@@115)))
 (and (and (<= 0 l@@115) (<= l@@115 $MAX_U64)) (forall ((x@@115 Int) ) (!  (=> (or (< x@@115 0) (>= x@@115 l@@115)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115))
)))))) (forall (($$1 Int) ) (!  (=> (and (>= $$1 0) (< $$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@22))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@22))) $$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@22))) $$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@22))) $$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@22))) $$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@22))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@9))
)) (forall (($inv_addr@@10 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10)) (let ((va@@116 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))))
(let ((l@@116 (|l#$ValueArray| va@@116)))
 (and (and (<= 0 l@@116) (<= l@@116 $MAX_U64)) (forall ((x@@116 Int) ) (!  (=> (or (< x@@116 0) (>= x@@116 l@@116)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))
)))) (and (and (forall (($inv_addr@@11 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11)) (let ((va@@117 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))))
(let ((l@@117 (|l#$ValueArray| va@@117)))
 (and (and (<= 0 l@@117) (<= l@@117 $MAX_U64)) (forall ((x@@117 Int) ) (!  (=> (or (< x@@117 0) (>= x@@117 l@@117)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@118 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@118 (|l#$ValueArray| va@@118)))
 (and (and (<= 0 l@@118) (<= l@@118 $MAX_U64)) (forall ((x@@118 Int) ) (!  (=> (or (< x@@118 0) (>= x@@118 l@@118)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code)) (let ((va@@119 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@119 (|l#$ValueArray| va@@119)))
 (and (and (<= 0 l@@119) (<= l@@119 $MAX_U64)) (forall ((x@@119 Int) ) (!  (=> (or (< x@@119 0) (>= x@@119 l@@119)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119))
))))))) (forall (($$0@@23 Int) ) (!  (=> (and (>= $$0@@23 0) (< $$0@@23 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))) $$0@@23)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))) $$0@@23)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))) $$0@@23)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))) $$0@@23))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events)) (let ((va@@120 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@120 (|l#$ValueArray| va@@120)))
 (and (and (<= 0 l@@120) (<= l@@120 $MAX_U64)) (forall ((x@@120 Int) ) (!  (=> (or (< x@@120 0) (>= x@@120 l@@120)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@121 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@121 (|l#$ValueArray| va@@121)))
 (and (and (<= 0 l@@121) (<= l@@121 $MAX_U64)) (forall ((x@@121 Int) ) (!  (=> (or (< x@@121 0) (>= x@@121 l@@121)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121))
))))))) (forall (($$0@@24 Int) ) (!  (=> (and (>= $$0@@24 0) (< $$0@@24 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@24)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@24)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@24)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@24))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events)) (let ((va@@122 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@122 (|l#$ValueArray| va@@122)))
 (and (and (<= 0 l@@122) (<= l@@122 $MAX_U64)) (forall ((x@@122 Int) ) (!  (=> (or (< x@@122 0) (>= x@@122 l@@122)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@123 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@123 (|l#$ValueArray| va@@123)))
 (and (and (<= 0 l@@123) (<= l@@123 $MAX_U64)) (forall ((x@@123 Int) ) (!  (=> (or (< x@@123 0) (>= x@@123 l@@123)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123))
))))))) (forall (($$0@@25 Int) ) (!  (=> (and (>= $$0@@25 0) (< $$0@@25 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@25)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@25)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@25)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@25))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@124 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@124 (|l#$ValueArray| va@@124)))
 (and (and (<= 0 l@@124) (<= l@@124 $MAX_U64)) (forall ((x@@124 Int) ) (!  (=> (or (< x@@124 0) (>= x@@124 l@@124)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@125 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@125 (|l#$ValueArray| va@@125)))
 (and (and (<= 0 l@@125) (<= l@@125 $MAX_U64)) (forall ((x@@125 Int) ) (!  (=> (or (< x@@125 0) (>= x@@125 l@@125)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125))
))))))) (forall (($$0@@26 Int) ) (!  (=> (and (>= $$0@@26 0) (< $$0@@26 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@26)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@26)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@26)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@26))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@126 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@126 (|l#$ValueArray| va@@126)))
 (and (and (<= 0 l@@126) (<= l@@126 $MAX_U64)) (forall ((x@@126 Int) ) (!  (=> (or (< x@@126 0) (>= x@@126 l@@126)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@127 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@127 (|l#$ValueArray| va@@127)))
 (and (and (<= 0 l@@127) (<= l@@127 $MAX_U64)) (forall ((x@@127 Int) ) (!  (=> (or (< x@@127 0) (>= x@@127 l@@127)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127))
))))))) (forall (($$0@@27 Int) ) (!  (=> (and (>= $$0@@27 0) (< $$0@@27 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@27)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@27)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@27)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@27))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@128 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@128 (|l#$ValueArray| va@@128)))
 (and (and (<= 0 l@@128) (<= l@@128 $MAX_U64)) (forall ((x@@128 Int) ) (!  (=> (or (< x@@128 0) (>= x@@128 l@@128)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@129 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@129 (|l#$ValueArray| va@@129)))
 (and (and (<= 0 l@@129) (<= l@@129 $MAX_U64)) (forall ((x@@129 Int) ) (!  (=> (or (< x@@129 0) (>= x@@129 l@@129)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129))
))))))) (forall (($$0@@28 Int) ) (!  (=> (and (>= $$0@@28 0) (< $$0@@28 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@28)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@28)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@28)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@28))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@11))
)) (forall (($inv_addr@@12 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12)) (let ((va@@130 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))))
(let ((l@@130 (|l#$ValueArray| va@@130)))
 (and (and (<= 0 l@@130) (<= l@@130 $MAX_U64)) (forall ((x@@130 Int) ) (!  (=> (or (< x@@130 0) (>= x@@130 l@@130)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))) $Diem_MintCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@12))
))) (and (forall (($inv_addr@@13 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13)) (let ((va@@131 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))))
(let ((l@@131 (|l#$ValueArray| va@@131)))
 (and (and (<= 0 l@@131) (<= l@@131 $MAX_U64)) (forall ((x@@131 Int) ) (!  (=> (or (< x@@131 0) (>= x@@131 l@@131)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_mint_cap)) (let ((va@@132 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_mint_cap))))
(let ((l@@132 (|l#$ValueArray| va@@132)))
 (and (and (<= 0 l@@132) (<= l@@132 $MAX_U64)) (forall ((x@@132 Int) ) (!  (=> (or (< x@@132 0) (>= x@@132 l@@132)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_mint_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_mint_cap))) $Diem_MintCapability_dummy_field)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_burn_cap)) (let ((va@@133 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_burn_cap))))
(let ((l@@133 (|l#$ValueArray| va@@133)))
 (and (and (<= 0 l@@133) (<= l@@133 $MAX_U64)) (forall ((x@@133 Int) ) (!  (=> (or (< x@@133 0) (>= x@@133 l@@133)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_burn_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_burn_cap))) $Diem_BurnCapability_dummy_field)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_preburn_cap)) (let ((va@@134 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_preburn_cap))))
(let ((l@@134 (|l#$ValueArray| va@@134)))
 (and (and (<= 0 l@@134) (<= l@@134 $MAX_U64)) (forall ((x@@134 Int) ) (!  (=> (or (< x@@134 0) (>= x@@134 l@@134)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_preburn_cap))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_preburn_cap))) $Diem_Preburn_to_burn)) (let ((va@@135 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_preburn_cap))) $Diem_Preburn_to_burn))))
(let ((l@@135 (|l#$ValueArray| va@@135)))
 (and (and (<= 0 l@@135) (<= l@@135 $MAX_U64)) (forall ((x@@135 Int) ) (!  (=> (or (< x@@135 0) (>= x@@135 l@@135)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_preburn_cap))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_preburn_cap))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_preburn_cap))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))) $XDX_Reserve_preburn_cap))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64))))) (and (and true true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray $inv_addr@@13))
)) (forall (($inv_addr@@14 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@14)) (let ((va@@136 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@14))))
(let ((l@@136 (|l#$ValueArray| va@@136)))
 (and (and (<= 0 l@@136) (<= l@@136 $MAX_U64)) (forall ((x@@136 Int) ) (!  (=> (or (< x@@136 0) (>= x@@136 l@@136)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@14))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@14))) $Option_Option_vec)) (let ((va@@137 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@14))) $Option_Option_vec))))
(let ((l@@137 (|l#$ValueArray| va@@137)))
 (and (and (<= 0 l@@137) (<= l@@137 $MAX_U64)) (forall ((x@@137 Int) ) (!  (=> (or (< x@@137 0) (>= x@@137 l@@137)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@14))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@14))
))))) (and (and (and (forall (($inv_addr@@15 Int) ($inv_tv0@@6 T@$TypeValue) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15)) (let ((va@@138 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))))
(let ((l@@138 (|l#$ValueArray| va@@138)))
 (and (and (<= 0 l@@138) (<= l@@138 $MAX_U64)) (forall ((x@@138 Int) ) (!  (=> (or (< x@@138 0) (>= x@@138 l@@138)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_balance)) (let ((va@@139 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_balance))))
(let ((l@@139 (|l#$ValueArray| va@@139)))
 (and (and (<= 0 l@@139) (<= l@@139 $MAX_U64)) (forall ((x@@139 Int) ) (!  (=> (or (< x@@139 0) (>= x@@139 l@@139)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_balance))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) $MAX_U64)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_preburn)) (let ((va@@140 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_preburn))))
(let ((l@@140 (|l#$ValueArray| va@@140)))
 (and (and (<= 0 l@@140) (<= l@@140 $MAX_U64)) (forall ((x@@140 Int) ) (!  (=> (or (< x@@140 0) (>= x@@140 l@@140)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_preburn))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn)) (let ((va@@141 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))))
(let ((l@@141 (|l#$ValueArray| va@@141)))
 (and (and (<= 0 l@@141) (<= l@@141 $MAX_U64)) (forall ((x@@141 Int) ) (!  (=> (or (< x@@141 0) (>= x@@141 l@@141)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64))))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@15))
)) (forall (($inv_addr@@16 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16)) (let ((va@@142 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16))))
(let ((l@@142 (|l#$ValueArray| va@@142)))
 (and (and (<= 0 l@@142) (<= l@@142 $MAX_U64)) (forall ((x@@142 Int) ) (!  (=> (or (< x@@142 0) (>= x@@142 l@@142)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16))) $SlidingNonce_SlidingNonce_min_nonce)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16))) $SlidingNonce_SlidingNonce_min_nonce)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16))) $SlidingNonce_SlidingNonce_min_nonce)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16))) $SlidingNonce_SlidingNonce_nonce_mask)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16))) $SlidingNonce_SlidingNonce_nonce_mask)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16))) $SlidingNonce_SlidingNonce_nonce_mask)) $MAX_U128))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@16))
))) (and (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@143 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@143 (|l#$ValueArray| va@@143)))
 (and (and (<= 0 l@@143) (<= l@@143 $MAX_U64)) (forall ((x@@143 Int) ) (!  (=> (or (< x@@143 0) (>= x@@143 l@@143)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@17))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DualAttestation_Limit_micro_xdx_limit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DualAttestation_Limit_micro_xdx_limit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DualAttestation_Limit_micro_xdx_limit)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@17))
)) (forall (($inv_addr@@18 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18)) (let ((va@@144 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))))
(let ((l@@144 (|l#$ValueArray| va@@144)))
 (and (and (<= 0 l@@144) (<= l@@144 $MAX_U64)) (forall ((x@@144 Int) ) (!  (=> (or (< x@@144 0) (>= x@@144 l@@144)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@145 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@145 (|l#$ValueArray| va@@145)))
 (and (and (<= 0 l@@145) (<= l@@145 $MAX_U64)) (forall ((x@@145 Int) ) (!  (=> (or (< x@@145 0) (>= x@@145 l@@145)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145))
))))))) (forall (($$0@@29 Int) ) (!  (=> (and (>= $$0@@29 0) (< $$0@@29 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_authentication_key))) $$0@@29)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_authentication_key))) $$0@@29)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_authentication_key))) $$0@@29)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_authentication_key))) $$0@@29))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@146 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@146 (|l#$ValueArray| va@@146)))
 (and (and (<= 0 l@@146) (<= l@@146 $MAX_U64)) (forall ((x@@146 Int) ) (!  (=> (or (< x@@146 0) (>= x@@146 l@@146)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@147 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@147 (|l#$ValueArray| va@@147)))
 (and (and (<= 0 l@@147) (<= l@@147 $MAX_U64)) (forall ((x@@147 Int) ) (!  (=> (or (< x@@147 0) (>= x@@147 l@@147)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@148 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@148 (|l#$ValueArray| va@@148)))
 (and (and (<= 0 l@@148) (<= l@@148 $MAX_U64)) (forall ((x@@148 Int) ) (!  (=> (or (< x@@148 0) (>= x@@148 l@@148)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@149 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@149 (|l#$ValueArray| va@@149)))
 (and (and (<= 0 l@@149) (<= l@@149 $MAX_U64)) (forall ((x@@149 Int) ) (!  (=> (or (< x@@149 0) (>= x@@149 l@@149)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events)) (let ((va@@150 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@150 (|l#$ValueArray| va@@150)))
 (and (and (<= 0 l@@150) (<= l@@150 $MAX_U64)) (forall ((x@@150 Int) ) (!  (=> (or (< x@@150 0) (>= x@@150 l@@150)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@151 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@151 (|l#$ValueArray| va@@151)))
 (and (and (<= 0 l@@151) (<= l@@151 $MAX_U64)) (forall ((x@@151 Int) ) (!  (=> (or (< x@@151 0) (>= x@@151 l@@151)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151))
))))))) (forall (($$0@@30 Int) ) (!  (=> (and (>= $$0@@30 0) (< $$0@@30 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@30)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@30)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@30)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@30))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@152 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@152 (|l#$ValueArray| va@@152)))
 (and (and (<= 0 l@@152) (<= l@@152 $MAX_U64)) (forall ((x@@152 Int) ) (!  (=> (or (< x@@152 0) (>= x@@152 l@@152)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@153 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@153 (|l#$ValueArray| va@@153)))
 (and (and (<= 0 l@@153) (<= l@@153 $MAX_U64)) (forall ((x@@153 Int) ) (!  (=> (or (< x@@153 0) (>= x@@153 l@@153)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153))
))))))) (forall (($$0@@31 Int) ) (!  (=> (and (>= $$0@@31 0) (< $$0@@31 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@31)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@31)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@31)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@31))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@18))
)))) (and (and (forall (($inv_addr@@19 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19)) (let ((va@@154 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))))
(let ((l@@154 (|l#$ValueArray| va@@154)))
 (and (and (<= 0 l@@154) (<= l@@154 $MAX_U64)) (forall ((x@@154 Int) ) (!  (=> (or (< x@@154 0) (>= x@@154 l@@154)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_limits_cap)) (let ((va@@155 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_limits_cap))))
(let ((l@@155 (|l#$ValueArray| va@@155)))
 (and (and (<= 0 l@@155) (<= l@@155 $MAX_U64)) (forall ((x@@155 Int) ) (!  (=> (or (< x@@155 0) (>= x@@155 l@@155)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_limits_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_limits_cap))) $AccountLimits_AccountLimitMutationCapability_dummy_field)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events)) (let ((va@@156 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))))
(let ((l@@156 (|l#$ValueArray| va@@156)))
 (and (and (<= 0 l@@156) (<= l@@156 $MAX_U64)) (forall ((x@@156 Int) ) (!  (=> (or (< x@@156 0) (>= x@@156 l@@156)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid)) (let ((va@@157 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))
(let ((l@@157 (|l#$ValueArray| va@@157)))
 (and (and (<= 0 l@@157) (<= l@@157 $MAX_U64)) (forall ((x@@157 Int) ) (!  (=> (or (< x@@157 0) (>= x@@157 l@@157)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157))
))))))) (forall (($$0@@32 Int) ) (!  (=> (and (>= $$0@@32 0) (< $$0@@32 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@32)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@32)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@32)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@32))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))
)) (forall (($inv_addr@@20 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20)) (let ((va@@158 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))))
(let ((l@@158 (|l#$ValueArray| va@@158)))
 (and (and (<= 0 l@@158) (<= l@@158 $MAX_U64)) (forall ((x@@158 Int) ) (!  (=> (or (< x@@158 0) (>= x@@158 l@@158)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) 1)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events)) (let ((va@@159 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))))
(let ((l@@159 (|l#$ValueArray| va@@159)))
 (and (and (<= 0 l@@159) (<= l@@159 $MAX_U64)) (forall ((x@@159 Int) ) (!  (=> (or (< x@@159 0) (>= x@@159 l@@159)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid)) (let ((va@@160 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))))
(let ((l@@160 (|l#$ValueArray| va@@160)))
 (and (and (<= 0 l@@160) (<= l@@160 $MAX_U64)) (forall ((x@@160 Int) ) (!  (=> (or (< x@@160 0) (>= x@@160 l@@160)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160))
))))))) (forall (($$0@@33 Int) ) (!  (=> (and (>= $$0@@33 0) (< $$0@@33 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))) $$0@@33)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))) $$0@@33)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))) $$0@@33)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))) $$0@@33))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@20))
))) (and (forall (($inv_addr@@21 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@21)) (let ((va@@161 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@21))))
(let ((l@@161 (|l#$ValueArray| va@@161)))
 (and (and (<= 0 l@@161) (<= l@@161 $MAX_U64)) (forall ((x@@161 Int) ) (!  (=> (or (< x@@161 0) (>= x@@161 l@@161)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@21))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@21))) $DiemAccount_KeyRotationCapability_account_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@21))
)) (forall (($inv_addr@@22 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@22)) (let ((va@@162 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@22))))
(let ((l@@162 (|l#$ValueArray| va@@162)))
 (and (and (<= 0 l@@162) (<= l@@162 $MAX_U64)) (forall ((x@@162 Int) ) (!  (=> (or (< x@@162 0) (>= x@@162 l@@162)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@162) x@@162) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@162) x@@162))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@22))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemSystem_CapabilityHolder_cap)) (let ((va@@163 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemSystem_CapabilityHolder_cap))))
(let ((l@@163 (|l#$ValueArray| va@@163)))
 (and (and (<= 0 l@@163) (<= l@@163 $MAX_U64)) (forall ((x@@163 Int) ) (!  (=> (or (< x@@163 0) (>= x@@163 l@@163)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@163) x@@163) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@163) x@@163))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemSystem_CapabilityHolder_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@22))) $DiemSystem_CapabilityHolder_cap))) $DiemConfig_ModifyConfigCapability_dummy_field)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray $inv_addr@@22))
)))))) (and (and (and (and (forall (($inv_addr@@23 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23)) (let ((va@@164 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))))
(let ((l@@164 (|l#$ValueArray| va@@164)))
 (and (and (<= 0 l@@164) (<= l@@164 $MAX_U64)) (forall ((x@@164 Int) ) (!  (=> (or (< x@@164 0) (>= x@@164 l@@164)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@164) x@@164) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@164) x@@164))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_height)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_height)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_height)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events)) (let ((va@@165 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))))
(let ((l@@165 (|l#$ValueArray| va@@165)))
 (and (and (<= 0 l@@165) (<= l@@165 $MAX_U64)) (forall ((x@@165 Int) ) (!  (=> (or (< x@@165 0) (>= x@@165 l@@165)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@165) x@@165) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@165) x@@165))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid)) (let ((va@@166 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))
(let ((l@@166 (|l#$ValueArray| va@@166)))
 (and (and (<= 0 l@@166) (<= l@@166 $MAX_U64)) (forall ((x@@166 Int) ) (!  (=> (or (< x@@166 0) (>= x@@166 l@@166)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@166) x@@166) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@166) x@@166))
))))))) (forall (($$0@@34 Int) ) (!  (=> (and (>= $$0@@34 0) (< $$0@@34 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@34)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@34)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@34)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@34))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@23))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (|b#$Boolean| ($Boolean (forall ((window_addr T@$Value) )  (=> ((_ is $Address) window_addr) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) $AccountLimits_Window_limit_address))))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((config_address T@$Value) )  (=> ((_ is $Address) config_address) (|b#$Boolean| ($Boolean (forall ((config_type T@$Value) )  (=> ((_ is $Type) config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type)) 1) (|a#$Address| config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@3 T@$Value) )  (=> ((_ is $Type) coin_type@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))))) (and (and (and (and (and (|b#$Boolean| ($Boolean (forall ((addr@@8 T@$Value) )  (=> ((_ is $Address) addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@8 ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@9 T@$Value) )  (=> ((_ is $Address) addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@9 ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@10 T@$Value) )  (=> ((_ is $Address) addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@11 T@$Value) )  (=> ((_ is $Address) addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@12 T@$Value) )  (=> ((_ is $Address) addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((addr@@13 T@$Value) )  (=> ((_ is $Address) addr@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@14 T@$Value) )  (=> ((_ is $Address) addr@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))))))) (and (and (and (and (|b#$Boolean| ($Boolean (forall ((addr@@15 T@$Value) )  (=> ((_ is $Address) addr@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@16 T@$Value) )  (=> ((_ is $Address) addr@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((token T@$Value) )  (=> ((_ is $Type) token) (|b#$Boolean| ($Boolean (forall ((addr@@17 T@$Value) )  (=> ((_ is $Address) addr@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| token)) 1) (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@18 T@$Value) )  (=> ((_ is $Address) addr@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@19 T@$Value) )  (=> ((_ is $Address) addr@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@20 T@$Value) )  (=> ((_ is $Address) addr@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (let (($range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@21 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@21)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1)) $i_0) (< $i_0 (|i#$Integer| (|ub#$Range| $range_1)))) (let ((i1 ($Integer $i_0)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@22 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@22)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@22 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@22)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@0 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@23 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@23)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@0)) $i_0@@0) (< $i_0@@0 (|i#$Integer| (|ub#$Range| $range_1@@0)))) (let ((i1@@0 ($Integer $i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@24 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@24)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@0)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1)))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemVMConfig_DiemVMConfig_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemVersion_DiemVersion_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 388448) 330875))))))) inline$$Genesis_initialize_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and ((_ is $Address) dr_account) ((_ is $Address) tc_account)) (=> (and (and (and (and (and ((_ is $Vector) dr_auth_key) (let ((va@@167 (|v#$Vector| dr_auth_key)))
(let ((l@@167 (|l#$ValueArray| va@@167)))
 (and (and (<= 0 l@@167) (<= l@@167 $MAX_U64)) (forall ((x@@167 Int) ) (!  (=> (or (< x@@167 0) (>= x@@167 l@@167)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@167) x@@167) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@167) x@@167))
)))))) (forall (($$0@@35 Int) ) (!  (=> (and (>= $$0@@35 0) (< $$0@@35 (|l#$ValueArray| (|v#$Vector| dr_auth_key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dr_auth_key)) $$0@@35)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dr_auth_key)) $$0@@35)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dr_auth_key)) $$0@@35)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dr_auth_key)) $$0@@35))
))) (and (and ((_ is $Vector) tc_auth_key) (let ((va@@168 (|v#$Vector| tc_auth_key)))
(let ((l@@168 (|l#$ValueArray| va@@168)))
 (and (and (<= 0 l@@168) (<= l@@168 $MAX_U64)) (forall ((x@@168 Int) ) (!  (=> (or (< x@@168 0) (>= x@@168 l@@168)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@168) x@@168) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@168) x@@168))
)))))) (forall (($$0@@36 Int) ) (!  (=> (and (>= $$0@@36 0) (< $$0@@36 (|l#$ValueArray| (|v#$Vector| tc_auth_key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tc_auth_key)) $$0@@36)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tc_auth_key)) $$0@@36)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tc_auth_key)) $$0@@36)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| tc_auth_key)) $$0@@36))
)))) (and (and (and ((_ is $Vector) initial_script_allow_list) (let ((va@@169 (|v#$Vector| initial_script_allow_list)))
(let ((l@@169 (|l#$ValueArray| va@@169)))
 (and (and (<= 0 l@@169) (<= l@@169 $MAX_U64)) (forall ((x@@169 Int) ) (!  (=> (or (< x@@169 0) (>= x@@169 l@@169)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@169) x@@169) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@169) x@@169))
)))))) (forall (($$0@@37 Int) ) (!  (=> (and (>= $$0@@37 0) (< $$0@@37 (|l#$ValueArray| (|v#$Vector| initial_script_allow_list)))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) $$0@@37)) (let ((va@@170 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) $$0@@37))))
(let ((l@@170 (|l#$ValueArray| va@@170)))
 (and (and (<= 0 l@@170) (<= l@@170 $MAX_U64)) (forall ((x@@170 Int) ) (!  (=> (or (< x@@170 0) (>= x@@170 l@@170)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@170) x@@170) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@170) x@@170))
)))))) (forall (($$1@@0 Int) ) (!  (=> (and (>= $$1@@0 0) (< $$1@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) $$0@@37))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) $$0@@37))) $$1@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) $$0@@37))) $$1@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) $$0@@37))) $$1@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) $$0@@37))) $$1@@0))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| initial_script_allow_list)) $$0@@37))
))) ((_ is $Boolean) is_open_module))) (and (and (and (and ((_ is $Vector) instruction_schedule) (let ((va@@171 (|v#$Vector| instruction_schedule)))
(let ((l@@171 (|l#$ValueArray| va@@171)))
 (and (and (<= 0 l@@171) (<= l@@171 $MAX_U64)) (forall ((x@@171 Int) ) (!  (=> (or (< x@@171 0) (>= x@@171 l@@171)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@171) x@@171) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@171) x@@171))
)))))) (forall (($$0@@38 Int) ) (!  (=> (and (>= $$0@@38 0) (< $$0@@38 (|l#$ValueArray| (|v#$Vector| instruction_schedule)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) $$0@@38)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) $$0@@38)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) $$0@@38)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| instruction_schedule)) $$0@@38))
))) (and (and ((_ is $Vector) native_schedule) (let ((va@@172 (|v#$Vector| native_schedule)))
(let ((l@@172 (|l#$ValueArray| va@@172)))
 (and (and (<= 0 l@@172) (<= l@@172 $MAX_U64)) (forall ((x@@172 Int) ) (!  (=> (or (< x@@172 0) (>= x@@172 l@@172)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@172) x@@172) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@172) x@@172))
)))))) (forall (($$0@@39 Int) ) (!  (=> (and (>= $$0@@39 0) (< $$0@@39 (|l#$ValueArray| (|v#$Vector| native_schedule)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) $$0@@39)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) $$0@@39)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) $$0@@39)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| native_schedule)) $$0@@39))
)))) (and (and (and ((_ is $Integer) chain_id) (>= (|i#$Integer| chain_id) 0)) (<= (|i#$Integer| chain_id) $MAX_U8)) (= (ControlFlow 0 327188) 388448)))) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 396650) 327188) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(exit)
