(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun account () T@$Value)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $abort_code@9 () Int)
(declare-fun inline$$Roles_assert_diem_root_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$Roles_assert_diem_root_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$Roles_assert_diem_root_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Roles_assert_diem_root_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$Roles_assert_diem_root_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 103406) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 68571) (- 0 105510)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@5) (and (=> (= (ControlFlow 0 68571) (- 0 105527)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) $abort_flag@5) (and (=> (= (ControlFlow 0 68571) (- 0 105548)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@5) (and (=> (= (ControlFlow 0 68571) (- 0 105577)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@5) (and (=> (= (ControlFlow 0 68571) (- 0 105594)) (=> $abort_flag@5 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816)))))))) (=> (=> $abort_flag@5 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))))) (and (=> (= (ControlFlow 0 68571) (- 0 105675)) (=> $abort_flag@5 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@5 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 68571) (- 0 105800)) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr T@$Value) )  (=> ((_ is $Address) addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 68571) (- 0 105900)) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 68571) (- 0 106000)) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@3 T@$Value) )  (=> ((_ is $Address) addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@4 T@$Value) )  (=> ((_ is $Address) addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 68571) (- 0 106100)) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@5 T@$Value) )  (=> ((_ is $Address) addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@6 T@$Value) )  (=> ((_ is $Address) addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 68571) (- 0 106200)) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@7 T@$Value) )  (=> ((_ is $Address) addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@8 T@$Value) )  (=> ((_ is $Address) addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 68571) (- 0 106300)) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@9 T@$Value) )  (=> ((_ is $Address) addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@10 T@$Value) )  (=> ((_ is $Address) addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 68571) (- 0 106400)) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean (forall ((addr@@11 T@$Value) )  (=> ((_ is $Address) addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon44_Then_correct  (=> (and (and (|b#$Boolean| inline$$Roles_assert_diem_root_$def_verify$0$$t13@1) (= $abort_code@9 $abort_code@6)) (and (= $abort_flag@5 $abort_flag@4) (= (ControlFlow 0 68457) 68571))) anon0$2_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$Abort_correct  (=> (= $abort_code@9 $abort_code@8) (=> (and (= $abort_flag@5 true) (= (ControlFlow 0 68158) 68571)) anon0$2_correct))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon5_correct  (=> (and (= $abort_code@8 $abort_code@1) (= (ControlFlow 0 68549) 68158)) inline$$Roles_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 68547) 68549)) inline$$Roles_assert_diem_root_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 68557) 68549) inline$$Roles_assert_diem_root_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon32_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 68541) 68557) inline$$Roles_assert_diem_root_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 68541) 68547) inline$$Roles_assert_diem_root_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon9_correct  (=> (and (= $abort_code@8 $abort_code@2) (= (ControlFlow 0 68529) 68158)) inline$$Roles_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 68527) 68529)) inline$$Roles_assert_diem_root_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 68537) 68529) inline$$Roles_assert_diem_root_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon34_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 68521) 68537) inline$$Roles_assert_diem_root_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 68521) 68527) inline$$Roles_assert_diem_root_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon13_correct  (=> (and (= $abort_code@8 $abort_code@3) (= (ControlFlow 0 68509) 68158)) inline$$Roles_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 68507) 68509)) inline$$Roles_assert_diem_root_$def_verify$0$anon13_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 68517) 68509) inline$$Roles_assert_diem_root_$def_verify$0$anon13_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon36_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 68501) 68517) inline$$Roles_assert_diem_root_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 68501) 68507) inline$$Roles_assert_diem_root_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon21_correct  (=> (and (= $abort_code@8 $abort_code@5) (= (ControlFlow 0 68489) 68158)) inline$$Roles_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 68487) 68489)) inline$$Roles_assert_diem_root_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 68497) 68489) inline$$Roles_assert_diem_root_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon40_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 68481) 68497) inline$$Roles_assert_diem_root_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 68481) 68487) inline$$Roles_assert_diem_root_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon25_correct  (=> (and (= $abort_code@8 $abort_code@6) (= (ControlFlow 0 68469) 68158)) inline$$Roles_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 68467) 68469)) inline$$Roles_assert_diem_root_$def_verify$0$anon25_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 68477) 68469) inline$$Roles_assert_diem_root_$def_verify$0$anon25_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon42_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 68461) 68477) inline$$Roles_assert_diem_root_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 68461) 68467) inline$$Roles_assert_diem_root_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon30_correct  (=> (and (= $abort_code@8 $abort_code@7) (= (ControlFlow 0 68443) 68158)) inline$$Roles_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 68441) 68443)) inline$$Roles_assert_diem_root_$def_verify$0$anon30_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 68451) 68443) inline$$Roles_assert_diem_root_$def_verify$0$anon30_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon44_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_diem_root_$def_verify$0$$t13@1)) (= $abort_code@7 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 68435) 68451) inline$$Roles_assert_diem_root_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 68435) 68441) inline$$Roles_assert_diem_root_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon42_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 68423) 68457) inline$$Roles_assert_diem_root_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 68423) 68435) inline$$Roles_assert_diem_root_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon40_Else$1_correct  (=> (and (= inline$$Roles_assert_diem_root_$def_verify$0$$t12@1 ($Integer 0)) (= inline$$Roles_assert_diem_root_$def_verify$0$$t13@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1 inline$$Roles_assert_diem_root_$def_verify$0$$t12@1)))) (=> (and (and (and (= inline$$Roles_assert_diem_root_$def_verify$0$$t14@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 3))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 68417) 68461) inline$$Roles_assert_diem_root_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 68417) 68423) inline$$Roles_assert_diem_root_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 68393) 68417)) inline$$Roles_assert_diem_root_$def_verify$0$anon40_Else$1_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon40_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 68399) 68393)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@3 true) (=> (and (= $abort_code@5 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 68339) 68481) inline$$Roles_assert_diem_root_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 68339) 68399) inline$$Roles_assert_diem_root_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 68337) 68339)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@0))) (= $abort_flag@3 $abort_flag@2)) (and (= $abort_code@5 $abort_code@3) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 68285) 68481) inline$$Roles_assert_diem_root_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 68285) 68399) inline$$Roles_assert_diem_root_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@0)) (and (=> (= (ControlFlow 0 68267) 68337) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 68267) 68285) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 68261) (- 0 105185)) true) (=> (= (ControlFlow 0 68261) 68267) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon38_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_diem_root_$def_verify$0$$t7@1) (= (ControlFlow 0 68345) 68261)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon18_correct  (=> (and (= $abort_code@8 $abort_code@4) (= (ControlFlow 0 68154) 68158)) inline$$Roles_assert_diem_root_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 68152) 68154)) inline$$Roles_assert_diem_root_$def_verify$0$anon18_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 68166) 68154) inline$$Roles_assert_diem_root_$def_verify$0$anon18_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_diem_root_$def_verify$0$$t7@1)) (= $abort_code@4 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 68146) 68166) inline$$Roles_assert_diem_root_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 68146) 68152) inline$$Roles_assert_diem_root_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 68134) 68345) inline$$Roles_assert_diem_root_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 68134) 68146) inline$$Roles_assert_diem_root_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@1) (= inline$$Roles_assert_diem_root_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@0))))) (=> (and (and (and (= inline$$Roles_assert_diem_root_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2)) (and (=> $abort_flag@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 68128) 68501) inline$$Roles_assert_diem_root_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 68128) 68134) inline$$Roles_assert_diem_root_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon32_Else_correct  (=> (not $abort_flag@0) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1) (=> $abort_flag@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 account)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 68110) 68521) inline$$Roles_assert_diem_root_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 68110) 68128) inline$$Roles_assert_diem_root_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816)))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (= $abort_code@1 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 68104) 68541) inline$$Roles_assert_diem_root_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 68104) 68110) inline$$Roles_assert_diem_root_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 68068) 68104)) inline$$Roles_assert_diem_root_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 68565) 68104) inline$$Roles_assert_diem_root_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_diem_root_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 68062) 68565) inline$$Roles_assert_diem_root_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 68062) 68068) inline$$Roles_assert_diem_root_$def_verify$0$anon31_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 68569) 68062)) inline$$Roles_assert_diem_root_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and ((_ is $Address) account) (= (ControlFlow 0 67551) 68569)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 103406) 67551) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun inline$$Roles_assert_treasury_compliance_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$Roles_assert_treasury_compliance_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Roles_assert_treasury_compliance_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$Roles_assert_treasury_compliance_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Roles_assert_treasury_compliance_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 106512) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 69728) (- 0 108553)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 69728) (- 0 108574)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 69728) (- 0 108603)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 186537453))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 186537453))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 69728) (- 0 108620)) (=> $abort_flag@5@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 186537453)))))))) (=> (=> $abort_flag@5@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 186537453))))))) (and (=> (= (ControlFlow 0 69728) (- 0 108685)) (=> $abort_flag@5@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 186537453))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@5@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 186537453))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 69728) (- 0 108783)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@12 T@$Value) )  (=> ((_ is $Address) addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@13 T@$Value) )  (=> ((_ is $Address) addr@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 69728) (- 0 108883)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@14 T@$Value) )  (=> ((_ is $Address) addr@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@15 T@$Value) )  (=> ((_ is $Address) addr@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 69728) (- 0 108983)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@16 T@$Value) )  (=> ((_ is $Address) addr@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@17 T@$Value) )  (=> ((_ is $Address) addr@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 69728) (- 0 109083)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@18 T@$Value) )  (=> ((_ is $Address) addr@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@19 T@$Value) )  (=> ((_ is $Address) addr@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 69728) (- 0 109183)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@20 T@$Value) )  (=> ((_ is $Address) addr@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@21 T@$Value) )  (=> ((_ is $Address) addr@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 69728) (- 0 109283)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@22 T@$Value) )  (=> ((_ is $Address) addr@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@23 T@$Value) )  (=> ((_ is $Address) addr@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 69728) (- 0 109383)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr@@24 T@$Value) )  (=> ((_ is $Address) addr@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon44_Then_correct  (=> (and (and (|b#$Boolean| inline$$Roles_assert_treasury_compliance_$def_verify$0$$t13@1) (= $abort_code@9@@0 $abort_code@6@@0)) (and (= $abort_flag@5@@0 $abort_flag@4@@0) (= (ControlFlow 0 69614) 69728))) anon0$2_correct@@0)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$Abort_correct  (=> (= $abort_code@9@@0 $abort_code@8@@0) (=> (and (= $abort_flag@5@@0 true) (= (ControlFlow 0 69315) 69728)) anon0$2_correct@@0))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon5_correct  (=> (and (= $abort_code@8@@0 $abort_code@1@@0) (= (ControlFlow 0 69706) 69315)) inline$$Roles_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 69704) 69706)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 69714) 69706) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon32_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 69698) 69714) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 69698) 69704) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon9_correct  (=> (and (= $abort_code@8@@0 $abort_code@2@@0) (= (ControlFlow 0 69686) 69315)) inline$$Roles_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 69684) 69686)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 69694) 69686) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon34_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 69678) 69694) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 69678) 69684) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon13_correct  (=> (and (= $abort_code@8@@0 $abort_code@3@@0) (= (ControlFlow 0 69666) 69315)) inline$$Roles_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 69664) 69666)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon13_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 69674) 69666) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon13_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon36_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 69658) 69674) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 69658) 69664) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon21_correct  (=> (and (= $abort_code@8@@0 $abort_code@5@@0) (= (ControlFlow 0 69646) 69315)) inline$$Roles_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 69644) 69646)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 69654) 69646) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon40_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 69638) 69654) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 69638) 69644) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon25_correct  (=> (and (= $abort_code@8@@0 $abort_code@6@@0) (= (ControlFlow 0 69626) 69315)) inline$$Roles_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 69624) 69626)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon25_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 69634) 69626) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon25_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon42_Then_correct  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 69618) 69634) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 69618) 69624) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon30_correct  (=> (and (= $abort_code@8@@0 $abort_code@7@@0) (= (ControlFlow 0 69600) 69315)) inline$$Roles_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 69598) 69600)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon30_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 69608) 69600) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon30_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon44_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_treasury_compliance_$def_verify$0$$t13@1)) (= $abort_code@7@@0 (|i#$Integer| call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 69592) 69608) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 69592) 69598) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon42_Else_correct  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 69580) 69614) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 69580) 69592) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon40_Else$1_correct  (=> (and (= inline$$Roles_assert_treasury_compliance_$def_verify$0$$t12@1 ($Integer 1)) (= inline$$Roles_assert_treasury_compliance_$def_verify$0$$t13@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@0 inline$$Roles_assert_treasury_compliance_$def_verify$0$$t12@1)))) (=> (and (and (and (= inline$$Roles_assert_treasury_compliance_$def_verify$0$$t14@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@0)) (and (=> $abort_flag@4@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 3))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 69574) 69618) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 69574) 69580) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $Roles_RoleId_role_id)) (= (ControlFlow 0 69550) 69574)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon40_Else$1_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon40_Else_correct  (=> (and (not $abort_flag@3@@0) (= (ControlFlow 0 69556) 69550)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@3@@0 true) (=> (and (= $abort_code@5@@0 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 69496) 69638) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 69496) 69556) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 69494) 69496)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0) (=> (and (and (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@3))) (= $abort_flag@3@@0 $abort_flag@2@@0)) (and (= $abort_code@5@@0 $abort_code@3@@0) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 69442) 69638) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 69442) 69556) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| call3formal@$ret0@0@@3)) (and (=> (= (ControlFlow 0 69424) 69494) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 69424) 69442) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 69418) (- 0 108228)) true) (=> (= (ControlFlow 0 69418) 69424) inline$$GetGlobal$0$anon0_correct@@0))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon38_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_treasury_compliance_$def_verify$0$$t7@1) (= (ControlFlow 0 69502) 69418)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon18_correct  (=> (and (= $abort_code@8@@0 $abort_code@4@@0) (= (ControlFlow 0 69311) 69315)) inline$$Roles_assert_treasury_compliance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 69309) 69311)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon18_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 69323) 69311) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon18_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_treasury_compliance_$def_verify$0$$t7@1)) (= $abort_code@4@@0 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 69303) 69323) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 69303) 69309) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 69291) 69502) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 69291) 69303) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@1@@0) (= inline$$Roles_assert_treasury_compliance_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@3))))) (=> (and (and (and (= inline$$Roles_assert_treasury_compliance_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@0)) (and (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 69285) 69658) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 69285) 69291) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon32_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 69267) 69678) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 69267) 69285) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 186537453))))) $abort_flag@0@@0) (=> (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 186537453)))))) (=> $abort_flag@0@@0 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account@@0 ($Address 186537453))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 69261) 69698) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 69261) 69267) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 69225) 69261)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 69722) 69261) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_treasury_compliance_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 69219) 69722) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 69219) 69225) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon31_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (= (ControlFlow 0 69726) 69219)) inline$$Roles_assert_treasury_compliance_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 68708) 69726)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 106512) 68708) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@1 () T@$Value)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun inline$$Roles_assert_child_vasp_role_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$Roles_assert_child_vasp_role_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Roles_assert_child_vasp_role_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$Roles_assert_child_vasp_role_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$Roles_assert_child_vasp_role_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 109487) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 70814) (- 0 111287)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@4@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@4@@1) (and (=> (= (ControlFlow 0 70814) (- 0 111308)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 6))))) $abort_flag@4@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 6))))) $abort_flag@4@@1) (and (=> (= (ControlFlow 0 70814) (- 0 111337)) (=> $abort_flag@4@@1 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 6)))))))) (=> (=> $abort_flag@4@@1 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 6))))))) (and (=> (= (ControlFlow 0 70814) (- 0 111386)) (=> $abort_flag@4@@1 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 6))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@4@@1 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $Roles_RoleId_role_id) ($Integer 6))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 70814) (- 0 111457)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@25 T@$Value) )  (=> ((_ is $Address) addr@@25) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@26 T@$Value) )  (=> ((_ is $Address) addr@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@26)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@26)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@26)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@26)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 70814) (- 0 111557)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@27 T@$Value) )  (=> ((_ is $Address) addr@@27) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@28 T@$Value) )  (=> ((_ is $Address) addr@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@28)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@28)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@28)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@28)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 70814) (- 0 111657)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@29 T@$Value) )  (=> ((_ is $Address) addr@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@29)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@29)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@29)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@29)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@30 T@$Value) )  (=> ((_ is $Address) addr@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 70814) (- 0 111757)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@31 T@$Value) )  (=> ((_ is $Address) addr@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@31)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@31)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@31)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@31)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@32 T@$Value) )  (=> ((_ is $Address) addr@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@32)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@32)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@32)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@32)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 70814) (- 0 111857)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@33 T@$Value) )  (=> ((_ is $Address) addr@@33) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@33)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@33)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@33)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@33)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@34 T@$Value) )  (=> ((_ is $Address) addr@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 70814) (- 0 111957)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@35 T@$Value) )  (=> ((_ is $Address) addr@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@36 T@$Value) )  (=> ((_ is $Address) addr@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@36)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@36)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@36)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@36)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 70814) (- 0 112057)) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean (forall ((addr@@37 T@$Value) )  (=> ((_ is $Address) addr@@37) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon38_Then_correct  (=> (and (and (|b#$Boolean| inline$$Roles_assert_child_vasp_role_$def_verify$0$$t13@1) (= $abort_code@8@@1 $abort_code@5@@1)) (and (= $abort_flag@4@@1 $abort_flag@3@@1) (= (ControlFlow 0 70720) 70814))) anon0$2_correct@@1)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$Abort_correct  (=> (= $abort_code@8@@1 $abort_code@7@@1) (=> (and (= $abort_flag@4@@1 true) (= (ControlFlow 0 70421) 70814)) anon0$2_correct@@1))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon5_correct  (=> (and (= $abort_code@7@@1 $abort_code@1@@1) (= (ControlFlow 0 70792) 70421)) inline$$Roles_assert_child_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 70790) 70792)) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 70800) 70792) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 70784) 70800) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 70784) 70790) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon9_correct  (=> (and (= $abort_code@7@@1 $abort_code@2@@1) (= (ControlFlow 0 70772) 70421)) inline$$Roles_assert_child_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 70770) 70772)) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 70780) 70772) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon30_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 70764) 70780) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 70764) 70770) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon17_correct  (=> (and (= $abort_code@7@@1 $abort_code@4@@1) (= (ControlFlow 0 70752) 70421)) inline$$Roles_assert_child_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 70750) 70752)) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 70760) 70752) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon34_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 70744) 70760) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 70744) 70750) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon21_correct  (=> (and (= $abort_code@7@@1 $abort_code@5@@1) (= (ControlFlow 0 70732) 70421)) inline$$Roles_assert_child_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 70730) 70732)) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 70740) 70732) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon36_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 70724) 70740) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 70724) 70730) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon26_correct  (=> (and (= $abort_code@7@@1 $abort_code@6@@1) (= (ControlFlow 0 70706) 70421)) inline$$Roles_assert_child_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 70704) 70706)) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 70714) 70706) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_child_vasp_role_$def_verify$0$$t13@1)) (= $abort_code@6@@1 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 70698) 70714) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 70698) 70704) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@3@@1) (and (=> (= (ControlFlow 0 70686) 70720) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 70686) 70698) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon34_Else$1_correct  (=> (and (= inline$$Roles_assert_child_vasp_role_$def_verify$0$$t12@1 ($Integer 6)) (= inline$$Roles_assert_child_vasp_role_$def_verify$0$$t13@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@1 inline$$Roles_assert_child_vasp_role_$def_verify$0$$t12@1)))) (=> (and (and (and (= inline$$Roles_assert_child_vasp_role_$def_verify$0$$t14@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@1)) (and (=> $abort_flag@3@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 3))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 70680) 70724) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 70680) 70686) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@1)) $Roles_RoleId_role_id)) (= (ControlFlow 0 70656) 70680)) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon34_Else$1_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 70662) 70656)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@2@@1 true) (=> (and (= $abort_code@4@@1 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@1 inline$$GetGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 70602) 70744) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 70602) 70662) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@1)) (= (ControlFlow 0 70600) 70602)) inline$$GetGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@1) (=> (and (and (= inline$$GetGlobal$0$dst@1@@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@6))) (= $abort_flag@2@@1 $abort_flag@1@@1)) (and (= $abort_code@4@@1 $abort_code@2@@1) (= inline$$GetGlobal$0$dst@2@@1 inline$$GetGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 70548) 70744) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 70548) 70662) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@1  (=> (= inline$$GetGlobal$0$a@1@@1 (|a#$Address| call3formal@$ret0@0@@6)) (and (=> (= (ControlFlow 0 70530) 70600) inline$$GetGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 70530) 70548) inline$$GetGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$GetGlobal$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 70524) (- 0 110976)) true) (=> (= (ControlFlow 0 70524) 70530) inline$$GetGlobal$0$anon0_correct@@1))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon32_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_child_vasp_role_$def_verify$0$$t7@1) (= (ControlFlow 0 70608) 70524)) inline$$GetGlobal$0$Entry_correct@@1)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon14_correct  (=> (and (= $abort_code@7@@1 $abort_code@3@@1) (= (ControlFlow 0 70417) 70421)) inline$$Roles_assert_child_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 70415) 70417)) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 70429) 70417) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon32_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_child_vasp_role_$def_verify$0$$t7@1)) (= $abort_code@3@@1 (|i#$Integer| call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 70409) 70429) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 70409) 70415) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon30_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 70397) 70608) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 70397) 70409) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@0@@1) (= inline$$Roles_assert_child_vasp_role_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@6))))) (=> (and (and (and (= inline$$Roles_assert_child_vasp_role_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 70391) 70764) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 70391) 70397) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 account@@1)))) ((_ is $Address) call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 70373) 70784) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 70373) 70391) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 70337) 70373)) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 70808) 70373) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_child_vasp_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 70331) 70808) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 70331) 70337) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon27_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (= (ControlFlow 0 70812) 70331)) inline$$Roles_assert_child_vasp_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) account@@1) (= (ControlFlow 0 69865) 70812)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 109487) 69865) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@2 () T@$Value)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun $abort_code@8@@2 () Int)
(declare-fun inline$$Roles_assert_designated_dealer_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$Roles_assert_designated_dealer_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@2 () T@$Value)
(declare-fun inline$$Roles_assert_designated_dealer_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@2 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@2 () T@$Value)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$Roles_assert_designated_dealer_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$Roles_assert_designated_dealer_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 112161) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 71900) (- 0 113961)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 71900) (- 0 113982)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@4@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@4@@2) (and (=> (= (ControlFlow 0 71900) (- 0 114011)) (=> $abort_flag@4@@2 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (=> (=> $abort_flag@4@@2 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))))) (and (=> (= (ControlFlow 0 71900) (- 0 114060)) (=> $abort_flag@4@@2 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@4@@2 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 71900) (- 0 114131)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@38 T@$Value) )  (=> ((_ is $Address) addr@@38) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@38)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@38)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@38)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@38)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@39 T@$Value) )  (=> ((_ is $Address) addr@@39) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@39)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@39)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@39)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@39)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 71900) (- 0 114231)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@40 T@$Value) )  (=> ((_ is $Address) addr@@40) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@40)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@40)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@40)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@40)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@41 T@$Value) )  (=> ((_ is $Address) addr@@41) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@41)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@41)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@41)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@41)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 71900) (- 0 114331)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@42 T@$Value) )  (=> ((_ is $Address) addr@@42) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@42)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@42)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@42)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@42)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@43 T@$Value) )  (=> ((_ is $Address) addr@@43) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@43)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@43)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@43)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@43)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 71900) (- 0 114431)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@44 T@$Value) )  (=> ((_ is $Address) addr@@44) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@44)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@44)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@44)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@44)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@45 T@$Value) )  (=> ((_ is $Address) addr@@45) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@45)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@45)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@45)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@45)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 71900) (- 0 114531)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@46 T@$Value) )  (=> ((_ is $Address) addr@@46) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@46)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@46)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@46)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@46)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@47 T@$Value) )  (=> ((_ is $Address) addr@@47) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@47)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@47)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@47)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@47)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 71900) (- 0 114631)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@48 T@$Value) )  (=> ((_ is $Address) addr@@48) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@48)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@48)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@48)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@48)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@49 T@$Value) )  (=> ((_ is $Address) addr@@49) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@49)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@49)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@49)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@49)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 71900) (- 0 114731)) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((addr@@50 T@$Value) )  (=> ((_ is $Address) addr@@50) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon38_Then_correct  (=> (and (and (|b#$Boolean| inline$$Roles_assert_designated_dealer_$def_verify$0$$t13@1) (= $abort_code@8@@2 $abort_code@5@@2)) (and (= $abort_flag@4@@2 $abort_flag@3@@2) (= (ControlFlow 0 71806) 71900))) anon0$2_correct@@2)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$Abort_correct  (=> (= $abort_code@8@@2 $abort_code@7@@2) (=> (and (= $abort_flag@4@@2 true) (= (ControlFlow 0 71507) 71900)) anon0$2_correct@@2))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon5_correct  (=> (and (= $abort_code@7@@2 $abort_code@1@@2) (= (ControlFlow 0 71878) 71507)) inline$$Roles_assert_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 71876) 71878)) inline$$Roles_assert_designated_dealer_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 71886) 71878) inline$$Roles_assert_designated_dealer_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 71870) 71886) inline$$Roles_assert_designated_dealer_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 71870) 71876) inline$$Roles_assert_designated_dealer_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon9_correct  (=> (and (= $abort_code@7@@2 $abort_code@2@@2) (= (ControlFlow 0 71858) 71507)) inline$$Roles_assert_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 71856) 71858)) inline$$Roles_assert_designated_dealer_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 71866) 71858) inline$$Roles_assert_designated_dealer_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon30_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 71850) 71866) inline$$Roles_assert_designated_dealer_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 71850) 71856) inline$$Roles_assert_designated_dealer_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon17_correct  (=> (and (= $abort_code@7@@2 $abort_code@4@@2) (= (ControlFlow 0 71838) 71507)) inline$$Roles_assert_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 71836) 71838)) inline$$Roles_assert_designated_dealer_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 71846) 71838) inline$$Roles_assert_designated_dealer_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon34_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 71830) 71846) inline$$Roles_assert_designated_dealer_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 71830) 71836) inline$$Roles_assert_designated_dealer_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon21_correct  (=> (and (= $abort_code@7@@2 $abort_code@5@@2) (= (ControlFlow 0 71818) 71507)) inline$$Roles_assert_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 71816) 71818)) inline$$Roles_assert_designated_dealer_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 71826) 71818) inline$$Roles_assert_designated_dealer_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon36_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 71810) 71826) inline$$Roles_assert_designated_dealer_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 71810) 71816) inline$$Roles_assert_designated_dealer_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon26_correct  (=> (and (= $abort_code@7@@2 $abort_code@6@@2) (= (ControlFlow 0 71792) 71507)) inline$$Roles_assert_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 71790) 71792)) inline$$Roles_assert_designated_dealer_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 71800) 71792) inline$$Roles_assert_designated_dealer_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_designated_dealer_$def_verify$0$$t13@1)) (= $abort_code@6@@2 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 71784) 71800) inline$$Roles_assert_designated_dealer_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 71784) 71790) inline$$Roles_assert_designated_dealer_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@3@@2) (and (=> (= (ControlFlow 0 71772) 71806) inline$$Roles_assert_designated_dealer_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 71772) 71784) inline$$Roles_assert_designated_dealer_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon34_Else$1_correct  (=> (and (= inline$$Roles_assert_designated_dealer_$def_verify$0$$t12@1 ($Integer 2)) (= inline$$Roles_assert_designated_dealer_$def_verify$0$$t13@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@2 inline$$Roles_assert_designated_dealer_$def_verify$0$$t12@1)))) (=> (and (and (and (= inline$$Roles_assert_designated_dealer_$def_verify$0$$t14@1 ($Integer 6)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2)) (and (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 3))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 71766) 71810) inline$$Roles_assert_designated_dealer_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 71766) 71772) inline$$Roles_assert_designated_dealer_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@2  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 71742) 71766)) inline$$Roles_assert_designated_dealer_$def_verify$0$anon34_Else$1_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@2) (= (ControlFlow 0 71748) 71742)) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@2@@2 true) (=> (and (= $abort_code@4@@2 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@2 inline$$GetGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 71688) 71830) inline$$Roles_assert_designated_dealer_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 71688) 71748) inline$$Roles_assert_designated_dealer_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@2)) (= (ControlFlow 0 71686) 71688)) inline$$GetGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@2  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@2) (=> (and (and (= inline$$GetGlobal$0$dst@1@@2 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@9))) (= $abort_flag@2@@2 $abort_flag@1@@2)) (and (= $abort_code@4@@2 $abort_code@2@@2) (= inline$$GetGlobal$0$dst@2@@2 inline$$GetGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 71634) 71830) inline$$Roles_assert_designated_dealer_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 71634) 71748) inline$$Roles_assert_designated_dealer_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@2  (=> (= inline$$GetGlobal$0$a@1@@2 (|a#$Address| call3formal@$ret0@0@@9)) (and (=> (= (ControlFlow 0 71616) 71686) inline$$GetGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 71616) 71634) inline$$GetGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$GetGlobal$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 71610) (- 0 113650)) true) (=> (= (ControlFlow 0 71610) 71616) inline$$GetGlobal$0$anon0_correct@@2))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon32_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_designated_dealer_$def_verify$0$$t7@1) (= (ControlFlow 0 71694) 71610)) inline$$GetGlobal$0$Entry_correct@@2)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon14_correct  (=> (and (= $abort_code@7@@2 $abort_code@3@@2) (= (ControlFlow 0 71503) 71507)) inline$$Roles_assert_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 71501) 71503)) inline$$Roles_assert_designated_dealer_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 71515) 71503) inline$$Roles_assert_designated_dealer_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon32_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_designated_dealer_$def_verify$0$$t7@1)) (= $abort_code@3@@2 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 71495) 71515) inline$$Roles_assert_designated_dealer_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 71495) 71501) inline$$Roles_assert_designated_dealer_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon30_Else_correct  (=> (not $abort_flag@1@@2) (and (=> (= (ControlFlow 0 71483) 71694) inline$$Roles_assert_designated_dealer_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 71483) 71495) inline$$Roles_assert_designated_dealer_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@0@@2) (= inline$$Roles_assert_designated_dealer_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@9))))) (=> (and (and (and (= inline$$Roles_assert_designated_dealer_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@2)) (and (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 71477) 71850) inline$$Roles_assert_designated_dealer_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 71477) 71483) inline$$Roles_assert_designated_dealer_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2) (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 account@@2)))) ((_ is $Address) call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 71459) 71870) inline$$Roles_assert_designated_dealer_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 71459) 71477) inline$$Roles_assert_designated_dealer_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 71423) 71459)) inline$$Roles_assert_designated_dealer_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 71894) 71459) inline$$Roles_assert_designated_dealer_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_designated_dealer_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 71417) 71894) inline$$Roles_assert_designated_dealer_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 71417) 71423) inline$$Roles_assert_designated_dealer_$def_verify$0$anon27_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (= (ControlFlow 0 71898) 71417)) inline$$Roles_assert_designated_dealer_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> (and ((_ is $Address) account@@2) (= (ControlFlow 0 70951) 71898)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 112161) 70951) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@3 () T@$Value)
(declare-fun $abort_flag@4@@3 () Bool)
(declare-fun $abort_code@8@@3 () Int)
(declare-fun |inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$tmp#$7@2| () T@$Value)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun $abort_code@7@@3 () Int)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_code@6@@3 () Int)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t15@1 () T@$Value)
(declare-fun |inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$tmp#$7@1| () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@3 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@3 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@3 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@3 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@3 () T@$Value)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t9@1 () T@$Value)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t10@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 114835) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 73268) (- 0 116816)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@4@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@4@@3) (and (=> (= (ControlFlow 0 73268) (- 0 116837)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 6)))))))) $abort_flag@4@@3)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 6)))))))) $abort_flag@4@@3) (and (=> (= (ControlFlow 0 73268) (- 0 116882)) (=> $abort_flag@4@@3 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 6))))))))))) (=> (=> $abort_flag@4@@3 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (and (=> (= (ControlFlow 0 73268) (- 0 116947)) (=> $abort_flag@4@@3 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (= $abort_code@8@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 6)))))))) (= $abort_code@8@@3 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@4@@3 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (= $abort_code@8@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 6)))))))) (= $abort_code@8@@3 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 73268) (- 0 117034)) (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@51 T@$Value) )  (=> ((_ is $Address) addr@@51) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@51)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@51)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@51)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@51)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@52 T@$Value) )  (=> ((_ is $Address) addr@@52) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@52)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@52)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@52)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@52)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 73268) (- 0 117134)) (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@53 T@$Value) )  (=> ((_ is $Address) addr@@53) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@53)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@53)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@53)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@53)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@54 T@$Value) )  (=> ((_ is $Address) addr@@54) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@54)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@54)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@54)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@54)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 73268) (- 0 117234)) (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@55 T@$Value) )  (=> ((_ is $Address) addr@@55) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@55)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@55)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@55)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@55)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@56 T@$Value) )  (=> ((_ is $Address) addr@@56) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@56)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@56)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@56)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@56)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 73268) (- 0 117334)) (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@57 T@$Value) )  (=> ((_ is $Address) addr@@57) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@57)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@57)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@57)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@57)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@58 T@$Value) )  (=> ((_ is $Address) addr@@58) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@58)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@58)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@58)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@58)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 73268) (- 0 117434)) (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@59 T@$Value) )  (=> ((_ is $Address) addr@@59) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@59)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@59)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@59)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@59)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@60 T@$Value) )  (=> ((_ is $Address) addr@@60) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@60)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@60)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@60)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@60)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 73268) (- 0 117534)) (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@61 T@$Value) )  (=> ((_ is $Address) addr@@61) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@61)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@61)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@61)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@61)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@62 T@$Value) )  (=> ((_ is $Address) addr@@62) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@62)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@62)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@62)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@62)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 73268) (- 0 117634)) (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean (forall ((addr@@63 T@$Value) )  (=> ((_ is $Address) addr@@63) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@63)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@63)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@63)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@63)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon50_Then_correct  (=> (and (and (|b#$Boolean| |inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$tmp#$7@2|) (= $abort_code@8@@3 $abort_code@5@@3)) (and (= $abort_flag@4@@3 $abort_flag@3@@3) (= (ControlFlow 0 73098) 73268))) anon0$2_correct@@3)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$Abort_correct  (=> (= $abort_code@8@@3 $abort_code@7@@3) (=> (and (= $abort_flag@4@@3 true) (= (ControlFlow 0 72727) 73268)) anon0$2_correct@@3))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon5_correct  (=> (and (= $abort_code@7@@3 $abort_code@1@@3) (= (ControlFlow 0 73246) 72727)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 73244) 73246)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 73254) 73246) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon36_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 73238) 73254) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 73238) 73244) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon9_correct  (=> (and (= $abort_code@7@@3 $abort_code@2@@3) (= (ControlFlow 0 73226) 72727)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 73224) 73226)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 73234) 73226) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon38_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 73218) 73234) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 73218) 73224) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon17_correct  (=> (and (= $abort_code@7@@3 $abort_code@4@@3) (= (ControlFlow 0 73206) 72727)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 73204) 73206)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 73214) 73206) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon42_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 73198) 73214) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 73198) 73204) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon29_correct  (=> (and (= $abort_code@7@@3 $abort_code@5@@3) (= (ControlFlow 0 73110) 72727)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 73108) 73110)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon29_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 73118) 73110) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon29_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon48_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 73102) 73118) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 73102) 73108) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon34_correct  (=> (and (= $abort_code@7@@3 $abort_code@6@@3) (= (ControlFlow 0 73084) 72727)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 73082) 73084)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon34_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 73092) 73084) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon34_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon50_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$tmp#$7@2|)) (= $abort_code@6@@3 (|i#$Integer| call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 73076) 73092) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 73076) 73082) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon48_Else_correct  (=> (not $abort_flag@3@@3) (and (=> (= (ControlFlow 0 73064) 73098) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 73064) 73076) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$L5_correct  (=> (and (and (and (= inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t18@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@3)) (and (=> $abort_flag@3@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 ($Integer 3))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@11) (>= (|i#$Integer| call3formal@$ret0@0@@11) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@11) $MAX_U64))) (and (=> (= (ControlFlow 0 73058) 73102) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 73058) 73064) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon24_correct  (=> (and (= |inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$tmp#$7@2| inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t16@1) (= (ControlFlow 0 73178) 73058)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$L5_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 73176) 73178)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon24_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 73186) 73178) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon24_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t15@1) (= inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t16@1 ($Boolean true))) (and (=> (= (ControlFlow 0 73168) 73186) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 73168) 73176) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon26_correct  (=> (and (= |inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$tmp#$7@2| |inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$tmp#$7@1|) (= (ControlFlow 0 73052) 73058)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$L5_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 73050) 73052)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 73126) 73052) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon45_Else_correct  (=> (not (|b#$Boolean| inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t15@1)) (=> (and (= inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t17@1 ($Integer 6)) (= |inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$tmp#$7@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@3 inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t17@1)))) (and (=> (= (ControlFlow 0 73044) 73126) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 73044) 73050) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon20_correct  (=> (and (= inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t14@1 ($Integer 5)) (= inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t15@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@3 inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t14@1)))) (and (=> (= (ControlFlow 0 73024) 73168) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 73024) 73044) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 73010) 73024)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon20_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 73194) 73024) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon20_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@3  (=> (= inline$$GetFieldFromValue$0$dst@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@3)) $Roles_RoleId_role_id)) (and (=> (= (ControlFlow 0 72962) 73194) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 72962) 73010) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon42_Else_correct  (=> (and (not $abort_flag@2@@3) (= (ControlFlow 0 72968) 72962)) inline$$GetFieldFromValue$0$anon0_correct@@3)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@3  (=> (= $abort_flag@2@@3 true) (=> (and (= $abort_code@4@@3 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@3 inline$$GetGlobal$0$dst@0@@3)) (and (=> (= (ControlFlow 0 72908) 73198) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 72908) 72968) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@3  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@3)) (= (ControlFlow 0 72906) 72908)) inline$$GetGlobal$0$anon3_Then$1_correct@@3)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@3  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@3) (=> (and (and (= inline$$GetGlobal$0$dst@1@@3 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@12))) (= $abort_flag@2@@3 $abort_flag@1@@3)) (and (= $abort_code@4@@3 $abort_code@2@@3) (= inline$$GetGlobal$0$dst@2@@3 inline$$GetGlobal$0$dst@1@@3))) (and (=> (= (ControlFlow 0 72854) 73198) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 72854) 72968) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@3  (=> (= inline$$GetGlobal$0$a@1@@3 (|a#$Address| call3formal@$ret0@0@@12)) (and (=> (= (ControlFlow 0 72836) 72906) inline$$GetGlobal$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 72836) 72854) inline$$GetGlobal$0$anon3_Else_correct@@3)))))
(let ((inline$$GetGlobal$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 72830) (- 0 116405)) true) (=> (= (ControlFlow 0 72830) 72836) inline$$GetGlobal$0$anon0_correct@@3))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon40_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t9@1) (= (ControlFlow 0 72914) 72830)) inline$$GetGlobal$0$Entry_correct@@3)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon14_correct  (=> (and (= $abort_code@7@@3 $abort_code@3@@3) (= (ControlFlow 0 72723) 72727)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 72721) 72723)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 72735) 72723) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon40_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t9@1)) (= $abort_code@3@@3 (|i#$Integer| call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 72715) 72735) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 72715) 72721) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon38_Else_correct  (=> (not $abort_flag@1@@3) (and (=> (= (ControlFlow 0 72703) 72914) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 72703) 72715) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@0@@3) (= inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@12))))) (=> (and (and (and (= inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$$t10@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3)) (and (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@13) (>= (|i#$Integer| call3formal@$ret0@0@@13) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@13) $MAX_U64))) (and (=> (= (ControlFlow 0 72697) 73218) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 72697) 72703) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon38_Else_correct))))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@3) (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 account@@3)))) ((_ is $Address) call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 72679) 73238) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 72679) 72697) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 72643) 72679)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 73262) 72679) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 72637) 73262) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 72637) 72643) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon35_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (= (ControlFlow 0 73266) 72637)) inline$$Roles_assert_parent_vasp_or_child_vasp_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and ((_ is $Address) account@@3) (= (ControlFlow 0 72037) 73266)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 114835) 72037) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@4 () T@$Value)
(declare-fun $abort_flag@4@@4 () Bool)
(declare-fun $abort_code@8@@4 () Int)
(declare-fun |inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$tmp#$7@2| () T@$Value)
(declare-fun $abort_code@5@@4 () Int)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun $abort_code@7@@4 () Int)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@4 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun $abort_code@6@@4 () Int)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t15@1 () T@$Value)
(declare-fun |inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$tmp#$7@1| () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@4 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@4 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@4 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@4 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@4 () T@$Value)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t9@1 () T@$Value)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t10@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 117738) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 74678) (- 0 119719)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4))))))) $abort_flag@4@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4))))))) $abort_flag@4@@4) (and (=> (= (ControlFlow 0 74678) (- 0 119740)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 2)))))))) $abort_flag@4@@4)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 2)))))))) $abort_flag@4@@4) (and (=> (= (ControlFlow 0 74678) (- 0 119785)) (=> $abort_flag@4@@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 2))))))))))) (=> (=> $abort_flag@4@@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 2)))))))))) (and (=> (= (ControlFlow 0 74678) (- 0 119850)) (=> $abort_flag@4@@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4))))))) (= $abort_code@8@@4 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (= $abort_code@8@@4 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@4@@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4))))))) (= $abort_code@8@@4 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@4)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (= $abort_code@8@@4 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 74678) (- 0 119937)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@64 T@$Value) )  (=> ((_ is $Address) addr@@64) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@64)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@64)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@65 T@$Value) )  (=> ((_ is $Address) addr@@65) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@65)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@65)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@65)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@65)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 74678) (- 0 120037)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@66 T@$Value) )  (=> ((_ is $Address) addr@@66) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@66)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@66)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@66)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@66)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@67 T@$Value) )  (=> ((_ is $Address) addr@@67) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@67)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@67)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@67)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@67)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 74678) (- 0 120137)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@68 T@$Value) )  (=> ((_ is $Address) addr@@68) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@68)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@68)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@68)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@68)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@69 T@$Value) )  (=> ((_ is $Address) addr@@69) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@69)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@69)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@69)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@69)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 74678) (- 0 120237)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@70 T@$Value) )  (=> ((_ is $Address) addr@@70) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@70)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@70)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@70)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@70)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@71 T@$Value) )  (=> ((_ is $Address) addr@@71) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@71)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@71)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@71)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@71)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 74678) (- 0 120337)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@72 T@$Value) )  (=> ((_ is $Address) addr@@72) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@72)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@72)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@72)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@72)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@73 T@$Value) )  (=> ((_ is $Address) addr@@73) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@73)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@73)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@73)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@73)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 74678) (- 0 120437)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@74 T@$Value) )  (=> ((_ is $Address) addr@@74) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@74)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@74)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@74)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@74)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@75 T@$Value) )  (=> ((_ is $Address) addr@@75) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@75)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@75)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@75)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@75)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 74678) (- 0 120537)) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean (forall ((addr@@76 T@$Value) )  (=> ((_ is $Address) addr@@76) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@76)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@76)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@76)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@76)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon50_Then_correct  (=> (and (and (|b#$Boolean| |inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$tmp#$7@2|) (= $abort_code@8@@4 $abort_code@5@@4)) (and (= $abort_flag@4@@4 $abort_flag@3@@4) (= (ControlFlow 0 74508) 74678))) anon0$2_correct@@4)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$Abort_correct  (=> (= $abort_code@8@@4 $abort_code@7@@4) (=> (and (= $abort_flag@4@@4 true) (= (ControlFlow 0 74137) 74678)) anon0$2_correct@@4))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon5_correct  (=> (and (= $abort_code@7@@4 $abort_code@1@@4) (= (ControlFlow 0 74656) 74137)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 74654) 74656)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 74664) 74656) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon36_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 74648) 74664) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 74648) 74654) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon9_correct  (=> (and (= $abort_code@7@@4 $abort_code@2@@4) (= (ControlFlow 0 74636) 74137)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 74634) 74636)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 74644) 74636) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon38_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 74628) 74644) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 74628) 74634) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon17_correct  (=> (and (= $abort_code@7@@4 $abort_code@4@@4) (= (ControlFlow 0 74616) 74137)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 74614) 74616)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 74624) 74616) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon42_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 74608) 74624) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 74608) 74614) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon29_correct  (=> (and (= $abort_code@7@@4 $abort_code@5@@4) (= (ControlFlow 0 74520) 74137)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 74518) 74520)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon29_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 74528) 74520) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon29_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon48_Then_correct  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 74512) 74528) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 74512) 74518) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon34_correct  (=> (and (= $abort_code@7@@4 $abort_code@6@@4) (= (ControlFlow 0 74494) 74137)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 74492) 74494)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon34_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 74502) 74494) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon34_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon50_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$tmp#$7@2|)) (= $abort_code@6@@4 (|i#$Integer| call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 74486) 74502) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 74486) 74492) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon48_Else_correct  (=> (not $abort_flag@3@@4) (and (=> (= (ControlFlow 0 74474) 74508) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 74474) 74486) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$L5_correct  (=> (and (and (and (= inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t18@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@4)) (and (=> $abort_flag@3@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 ($Integer 3))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@14) (>= (|i#$Integer| call3formal@$ret0@0@@14) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@14) $MAX_U64))) (and (=> (= (ControlFlow 0 74468) 74512) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 74468) 74474) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon24_correct  (=> (and (= |inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$tmp#$7@2| inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t16@1) (= (ControlFlow 0 74588) 74468)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$L5_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 74586) 74588)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon24_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 74596) 74588) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon24_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t15@1) (= inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t16@1 ($Boolean true))) (and (=> (= (ControlFlow 0 74578) 74596) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 74578) 74586) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon26_correct  (=> (and (= |inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$tmp#$7@2| |inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$tmp#$7@1|) (= (ControlFlow 0 74462) 74468)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$L5_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 74460) 74462)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 74536) 74462) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon45_Else_correct  (=> (not (|b#$Boolean| inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t15@1)) (=> (and (= inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t17@1 ($Integer 2)) (= |inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$tmp#$7@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@4 inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t17@1)))) (and (=> (= (ControlFlow 0 74454) 74536) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 74454) 74460) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon20_correct  (=> (and (= inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t14@1 ($Integer 5)) (= inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t15@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@4 inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t14@1)))) (and (=> (= (ControlFlow 0 74434) 74578) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 74434) 74454) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 74420) 74434)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon20_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 74604) 74434) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon20_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@4  (=> (= inline$$GetFieldFromValue$0$dst@1@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@4)) $Roles_RoleId_role_id)) (and (=> (= (ControlFlow 0 74372) 74604) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 74372) 74420) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon42_Else_correct  (=> (and (not $abort_flag@2@@4) (= (ControlFlow 0 74378) 74372)) inline$$GetFieldFromValue$0$anon0_correct@@4)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@4  (=> (= $abort_flag@2@@4 true) (=> (and (= $abort_code@4@@4 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@4 inline$$GetGlobal$0$dst@0@@4)) (and (=> (= (ControlFlow 0 74318) 74608) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 74318) 74378) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@4  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@4)) (= (ControlFlow 0 74316) 74318)) inline$$GetGlobal$0$anon3_Then$1_correct@@4)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@4  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@4) (=> (and (and (= inline$$GetGlobal$0$dst@1@@4 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@15))) (= $abort_flag@2@@4 $abort_flag@1@@4)) (and (= $abort_code@4@@4 $abort_code@2@@4) (= inline$$GetGlobal$0$dst@2@@4 inline$$GetGlobal$0$dst@1@@4))) (and (=> (= (ControlFlow 0 74264) 74608) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 74264) 74378) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@4  (=> (= inline$$GetGlobal$0$a@1@@4 (|a#$Address| call3formal@$ret0@0@@15)) (and (=> (= (ControlFlow 0 74246) 74316) inline$$GetGlobal$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 74246) 74264) inline$$GetGlobal$0$anon3_Else_correct@@4)))))
(let ((inline$$GetGlobal$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 74240) (- 0 119308)) true) (=> (= (ControlFlow 0 74240) 74246) inline$$GetGlobal$0$anon0_correct@@4))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon40_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t9@1) (= (ControlFlow 0 74324) 74240)) inline$$GetGlobal$0$Entry_correct@@4)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon14_correct  (=> (and (= $abort_code@7@@4 $abort_code@3@@4) (= (ControlFlow 0 74133) 74137)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 74131) 74133)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 74145) 74133) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon40_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t9@1)) (= $abort_code@3@@4 (|i#$Integer| call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 74125) 74145) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 74125) 74131) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon38_Else_correct  (=> (not $abort_flag@1@@4) (and (=> (= (ControlFlow 0 74113) 74324) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 74113) 74125) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@0@@4) (= inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@15))))) (=> (and (and (and (= inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$$t10@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@4)) (and (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@16) (>= (|i#$Integer| call3formal@$ret0@0@@16) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@16) $MAX_U64))) (and (=> (= (ControlFlow 0 74107) 74628) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 74107) 74113) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon38_Else_correct))))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@4) (=> $abort_flag@0@@4 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 account@@4)))) ((_ is $Address) call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 74089) 74648) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 74089) 74107) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 74053) 74089)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 74672) 74089) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 74047) 74672) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 74047) 74053) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon35_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (= (ControlFlow 0 74676) 74047)) inline$$Roles_assert_parent_vasp_or_designated_dealer_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) account@@4) (= (ControlFlow 0 73447) 74676)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 117738) 73447) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@5 () T@$Value)
(declare-fun $abort_flag@4@@5 () Bool)
(declare-fun $abort_code@8@@5 () Int)
(declare-fun inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@5@@5 () Int)
(declare-fun $abort_flag@3@@5 () Bool)
(declare-fun $abort_code@7@@5 () Int)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_code@2@@5 () Int)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_code@4@@5 () Int)
(declare-fun $abort_flag@2@@5 () Bool)
(declare-fun $abort_code@6@@5 () Int)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@5 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@5 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@5 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@5 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@5 () T@$Value)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@5 () Int)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(declare-fun inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 120641) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 75806) (- 0 122441)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5))))))) $abort_flag@4@@5)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5))))))) $abort_flag@4@@5) (and (=> (= (ControlFlow 0 75806) (- 0 122462)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@4@@5)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@4@@5) (and (=> (= (ControlFlow 0 75806) (- 0 122491)) (=> $abort_flag@4@@5 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5)))) $Roles_RoleId_role_id) ($Integer 5)))))))) (=> (=> $abort_flag@4@@5 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5)))) $Roles_RoleId_role_id) ($Integer 5))))))) (and (=> (= (ControlFlow 0 75806) (- 0 122540)) (=> $abort_flag@4@@5 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5))))))) (= $abort_code@8@@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@8@@5 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@4@@5 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5))))))) (= $abort_code@8@@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@5)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@8@@5 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 75806) (- 0 122611)) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@77 T@$Value) )  (=> ((_ is $Address) addr@@77) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@77)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@77)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@77)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@77)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@78 T@$Value) )  (=> ((_ is $Address) addr@@78) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@78)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@78)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@78)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@78)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 75806) (- 0 122711)) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@79 T@$Value) )  (=> ((_ is $Address) addr@@79) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@79)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@79)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@79)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@79)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@80 T@$Value) )  (=> ((_ is $Address) addr@@80) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@80)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@80)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@80)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@80)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 75806) (- 0 122811)) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@81 T@$Value) )  (=> ((_ is $Address) addr@@81) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@81)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@81)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@81)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@81)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@82 T@$Value) )  (=> ((_ is $Address) addr@@82) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@82)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@82)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@82)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@82)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 75806) (- 0 122911)) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@83 T@$Value) )  (=> ((_ is $Address) addr@@83) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@83)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@83)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@83)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@83)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@84 T@$Value) )  (=> ((_ is $Address) addr@@84) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@84)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@84)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@84)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@84)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 75806) (- 0 123011)) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@85 T@$Value) )  (=> ((_ is $Address) addr@@85) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@85)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@85)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@85)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@85)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@86 T@$Value) )  (=> ((_ is $Address) addr@@86) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@86)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@86)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@86)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@86)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 75806) (- 0 123111)) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@87 T@$Value) )  (=> ((_ is $Address) addr@@87) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@87)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@87)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@87)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@87)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@88 T@$Value) )  (=> ((_ is $Address) addr@@88) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@88)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@88)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@88)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@88)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 75806) (- 0 123211)) (=> (not $abort_flag@4@@5) (|b#$Boolean| ($Boolean (forall ((addr@@89 T@$Value) )  (=> ((_ is $Address) addr@@89) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@89)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@89)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@89)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@89)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon38_Then_correct  (=> (and (and (|b#$Boolean| inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t13@1) (= $abort_code@8@@5 $abort_code@5@@5)) (and (= $abort_flag@4@@5 $abort_flag@3@@5) (= (ControlFlow 0 75712) 75806))) anon0$2_correct@@5)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$Abort_correct  (=> (= $abort_code@8@@5 $abort_code@7@@5) (=> (and (= $abort_flag@4@@5 true) (= (ControlFlow 0 75413) 75806)) anon0$2_correct@@5))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon5_correct  (=> (and (= $abort_code@7@@5 $abort_code@1@@5) (= (ControlFlow 0 75784) 75413)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 75782) 75784)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 75792) 75784) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 75776) 75792) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 75776) 75782) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon9_correct  (=> (and (= $abort_code@7@@5 $abort_code@2@@5) (= (ControlFlow 0 75764) 75413)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 75762) 75764)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 75772) 75764) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon30_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 75756) 75772) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 75756) 75762) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon17_correct  (=> (and (= $abort_code@7@@5 $abort_code@4@@5) (= (ControlFlow 0 75744) 75413)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 75742) 75744)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 75752) 75744) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon34_Then_correct  (=> $abort_flag@2@@5 (and (=> (= (ControlFlow 0 75736) 75752) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 75736) 75742) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon21_correct  (=> (and (= $abort_code@7@@5 $abort_code@5@@5) (= (ControlFlow 0 75724) 75413)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 75722) 75724)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 75732) 75724) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon36_Then_correct  (=> $abort_flag@3@@5 (and (=> (= (ControlFlow 0 75716) 75732) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 75716) 75722) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon26_correct  (=> (and (= $abort_code@7@@5 $abort_code@6@@5) (= (ControlFlow 0 75698) 75413)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 75696) 75698)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 75706) 75698) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t13@1)) (= $abort_code@6@@5 (|i#$Integer| call3formal@$ret0@0@@17))) (and (=> (= (ControlFlow 0 75690) 75706) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 75690) 75696) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@3@@5) (and (=> (= (ControlFlow 0 75678) 75712) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 75678) 75690) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon34_Else$1_correct  (=> (and (= inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t12@1 ($Integer 5)) (= inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t13@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@5 inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t12@1)))) (=> (and (and (and (= inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t14@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@5)) (and (=> $abort_flag@3@@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 ($Integer 3))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@17) (>= (|i#$Integer| call3formal@$ret0@0@@17) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@17) $MAX_U64))) (and (=> (= (ControlFlow 0 75672) 75716) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 75672) 75678) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@5  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@5)) $Roles_RoleId_role_id)) (= (ControlFlow 0 75648) 75672)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon34_Else$1_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@5) (= (ControlFlow 0 75654) 75648)) inline$$GetFieldFromValue$0$anon0_correct@@5)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@5  (=> (= $abort_flag@2@@5 true) (=> (and (= $abort_code@4@@5 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@5 inline$$GetGlobal$0$dst@0@@5)) (and (=> (= (ControlFlow 0 75594) 75736) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 75594) 75654) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@5  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@5)) (= (ControlFlow 0 75592) 75594)) inline$$GetGlobal$0$anon3_Then$1_correct@@5)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@5  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@5) (=> (and (and (= inline$$GetGlobal$0$dst@1@@5 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@18))) (= $abort_flag@2@@5 $abort_flag@1@@5)) (and (= $abort_code@4@@5 $abort_code@2@@5) (= inline$$GetGlobal$0$dst@2@@5 inline$$GetGlobal$0$dst@1@@5))) (and (=> (= (ControlFlow 0 75540) 75736) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 75540) 75654) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@5  (=> (= inline$$GetGlobal$0$a@1@@5 (|a#$Address| call3formal@$ret0@0@@18)) (and (=> (= (ControlFlow 0 75522) 75592) inline$$GetGlobal$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 75522) 75540) inline$$GetGlobal$0$anon3_Else_correct@@5)))))
(let ((inline$$GetGlobal$0$Entry_correct@@5  (and (=> (= (ControlFlow 0 75516) (- 0 122130)) true) (=> (= (ControlFlow 0 75516) 75522) inline$$GetGlobal$0$anon0_correct@@5))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon32_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t7@1) (= (ControlFlow 0 75600) 75516)) inline$$GetGlobal$0$Entry_correct@@5)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon14_correct  (=> (and (= $abort_code@7@@5 $abort_code@3@@5) (= (ControlFlow 0 75409) 75413)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 75407) 75409)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 75421) 75409) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon32_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t7@1)) (= $abort_code@3@@5 (|i#$Integer| call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 75401) 75421) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 75401) 75407) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon30_Else_correct  (=> (not $abort_flag@1@@5) (and (=> (= (ControlFlow 0 75389) 75600) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 75389) 75401) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@0@@5) (= inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@18))))) (=> (and (and (and (= inline$$Roles_assert_parent_vasp_role_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@5)) (and (=> $abort_flag@1@@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@19) (>= (|i#$Integer| call3formal@$ret0@0@@19) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@19) $MAX_U64))) (and (=> (= (ControlFlow 0 75383) 75756) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 75383) 75389) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@5) (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 account@@5)))) ((_ is $Address) call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 75365) 75776) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 75365) 75383) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 75329) 75365)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 75800) 75365) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 75323) 75800) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 75323) 75329) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon27_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (and (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@5))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@5))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@5))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (= (ControlFlow 0 75804) 75323)) inline$$Roles_assert_parent_vasp_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@5  (=> (and ((_ is $Address) account@@5) (= (ControlFlow 0 74857) 75804)) anon0$1_correct@@5)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 120641) 74857) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun validator_account () T@$Value)
(declare-fun $abort_flag@4@@6 () Bool)
(declare-fun $abort_code@8@@6 () Int)
(declare-fun inline$$Roles_assert_validator_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@5@@6 () Int)
(declare-fun $abort_flag@3@@6 () Bool)
(declare-fun $abort_code@7@@6 () Int)
(declare-fun $abort_code@1@@6 () Int)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun $abort_code@2@@6 () Int)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun $abort_code@4@@6 () Int)
(declare-fun $abort_flag@2@@6 () Bool)
(declare-fun $abort_code@6@@6 () Int)
(declare-fun call3formal@$ret0@0@@20 () T@$Value)
(declare-fun inline$$Roles_assert_validator_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@6 () T@$Value)
(declare-fun inline$$Roles_assert_validator_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@6 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@6 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@6 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@6 () T@$Value)
(declare-fun call3formal@$ret0@0@@21 () T@$Value)
(declare-fun inline$$Roles_assert_validator_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@6 () Int)
(declare-fun call3formal@$ret0@0@@22 () T@$Value)
(declare-fun inline$$Roles_assert_validator_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 123315) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 76892) (- 0 125115)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) $abort_flag@4@@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) $abort_flag@4@@6) (and (=> (= (ControlFlow 0 76892) (- 0 125136)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@4@@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@4@@6) (and (=> (= (ControlFlow 0 76892) (- 0 125165)) (=> $abort_flag@4@@6 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3)))))))) (=> (=> $abort_flag@4@@6 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))))) (and (=> (= (ControlFlow 0 76892) (- 0 125214)) (=> $abort_flag@4@@6 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) (= $abort_code@8@@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@8@@6 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@4@@6 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) (= $abort_code@8@@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@8@@6 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 76892) (- 0 125285)) (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@90 T@$Value) )  (=> ((_ is $Address) addr@@90) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@90)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@90)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@90)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@90)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@91 T@$Value) )  (=> ((_ is $Address) addr@@91) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@91)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@91)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@91)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@91)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 76892) (- 0 125385)) (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@92 T@$Value) )  (=> ((_ is $Address) addr@@92) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@92)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@92)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@92)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@92)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@93 T@$Value) )  (=> ((_ is $Address) addr@@93) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@93)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@93)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@93)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@93)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 76892) (- 0 125485)) (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@94 T@$Value) )  (=> ((_ is $Address) addr@@94) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@94)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@94)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@94)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@94)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@95 T@$Value) )  (=> ((_ is $Address) addr@@95) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@95)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@95)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@95)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@95)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 76892) (- 0 125585)) (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@96 T@$Value) )  (=> ((_ is $Address) addr@@96) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@96)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@96)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@96)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@96)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@97 T@$Value) )  (=> ((_ is $Address) addr@@97) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@97)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@97)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@97)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@97)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 76892) (- 0 125685)) (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@98 T@$Value) )  (=> ((_ is $Address) addr@@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@98)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@98)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@98)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@98)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@99 T@$Value) )  (=> ((_ is $Address) addr@@99) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@99)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@99)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@99)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@99)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 76892) (- 0 125785)) (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@100 T@$Value) )  (=> ((_ is $Address) addr@@100) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@100)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@100)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@100)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@100)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@101 T@$Value) )  (=> ((_ is $Address) addr@@101) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@101)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@101)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@101)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@101)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 76892) (- 0 125885)) (=> (not $abort_flag@4@@6) (|b#$Boolean| ($Boolean (forall ((addr@@102 T@$Value) )  (=> ((_ is $Address) addr@@102) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@102)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@102)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@102)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@102)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon38_Then_correct  (=> (and (and (|b#$Boolean| inline$$Roles_assert_validator_$def_verify$0$$t13@1) (= $abort_code@8@@6 $abort_code@5@@6)) (and (= $abort_flag@4@@6 $abort_flag@3@@6) (= (ControlFlow 0 76798) 76892))) anon0$2_correct@@6)))
(let ((inline$$Roles_assert_validator_$def_verify$0$Abort_correct  (=> (= $abort_code@8@@6 $abort_code@7@@6) (=> (and (= $abort_flag@4@@6 true) (= (ControlFlow 0 76499) 76892)) anon0$2_correct@@6))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon5_correct  (=> (and (= $abort_code@7@@6 $abort_code@1@@6) (= (ControlFlow 0 76870) 76499)) inline$$Roles_assert_validator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 76868) 76870)) inline$$Roles_assert_validator_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 76878) 76870) inline$$Roles_assert_validator_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 76862) 76878) inline$$Roles_assert_validator_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 76862) 76868) inline$$Roles_assert_validator_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon9_correct  (=> (and (= $abort_code@7@@6 $abort_code@2@@6) (= (ControlFlow 0 76850) 76499)) inline$$Roles_assert_validator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 76848) 76850)) inline$$Roles_assert_validator_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 76858) 76850) inline$$Roles_assert_validator_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon30_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 76842) 76858) inline$$Roles_assert_validator_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 76842) 76848) inline$$Roles_assert_validator_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon17_correct  (=> (and (= $abort_code@7@@6 $abort_code@4@@6) (= (ControlFlow 0 76830) 76499)) inline$$Roles_assert_validator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 76828) 76830)) inline$$Roles_assert_validator_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 76838) 76830) inline$$Roles_assert_validator_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon34_Then_correct  (=> $abort_flag@2@@6 (and (=> (= (ControlFlow 0 76822) 76838) inline$$Roles_assert_validator_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 76822) 76828) inline$$Roles_assert_validator_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon21_correct  (=> (and (= $abort_code@7@@6 $abort_code@5@@6) (= (ControlFlow 0 76810) 76499)) inline$$Roles_assert_validator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 76808) 76810)) inline$$Roles_assert_validator_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 76818) 76810) inline$$Roles_assert_validator_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon36_Then_correct  (=> $abort_flag@3@@6 (and (=> (= (ControlFlow 0 76802) 76818) inline$$Roles_assert_validator_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 76802) 76808) inline$$Roles_assert_validator_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon26_correct  (=> (and (= $abort_code@7@@6 $abort_code@6@@6) (= (ControlFlow 0 76784) 76499)) inline$$Roles_assert_validator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 76782) 76784)) inline$$Roles_assert_validator_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 76792) 76784) inline$$Roles_assert_validator_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_validator_$def_verify$0$$t13@1)) (= $abort_code@6@@6 (|i#$Integer| call3formal@$ret0@0@@20))) (and (=> (= (ControlFlow 0 76776) 76792) inline$$Roles_assert_validator_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 76776) 76782) inline$$Roles_assert_validator_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@3@@6) (and (=> (= (ControlFlow 0 76764) 76798) inline$$Roles_assert_validator_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 76764) 76776) inline$$Roles_assert_validator_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon34_Else$1_correct  (=> (and (= inline$$Roles_assert_validator_$def_verify$0$$t12@1 ($Integer 3)) (= inline$$Roles_assert_validator_$def_verify$0$$t13@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@6 inline$$Roles_assert_validator_$def_verify$0$$t12@1)))) (=> (and (and (and (= inline$$Roles_assert_validator_$def_verify$0$$t14@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@6)) (and (=> $abort_flag@3@@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@20 ($Integer 3))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@20) (>= (|i#$Integer| call3formal@$ret0@0@@20) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@20) $MAX_U64))) (and (=> (= (ControlFlow 0 76758) 76802) inline$$Roles_assert_validator_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 76758) 76764) inline$$Roles_assert_validator_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@6  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@6)) $Roles_RoleId_role_id)) (= (ControlFlow 0 76734) 76758)) inline$$Roles_assert_validator_$def_verify$0$anon34_Else$1_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@6) (= (ControlFlow 0 76740) 76734)) inline$$GetFieldFromValue$0$anon0_correct@@6)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@6  (=> (= $abort_flag@2@@6 true) (=> (and (= $abort_code@4@@6 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@6 inline$$GetGlobal$0$dst@0@@6)) (and (=> (= (ControlFlow 0 76680) 76822) inline$$Roles_assert_validator_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 76680) 76740) inline$$Roles_assert_validator_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@6  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@6)) (= (ControlFlow 0 76678) 76680)) inline$$GetGlobal$0$anon3_Then$1_correct@@6)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@6  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@6) (=> (and (and (= inline$$GetGlobal$0$dst@1@@6 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@21))) (= $abort_flag@2@@6 $abort_flag@1@@6)) (and (= $abort_code@4@@6 $abort_code@2@@6) (= inline$$GetGlobal$0$dst@2@@6 inline$$GetGlobal$0$dst@1@@6))) (and (=> (= (ControlFlow 0 76626) 76822) inline$$Roles_assert_validator_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 76626) 76740) inline$$Roles_assert_validator_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@6  (=> (= inline$$GetGlobal$0$a@1@@6 (|a#$Address| call3formal@$ret0@0@@21)) (and (=> (= (ControlFlow 0 76608) 76678) inline$$GetGlobal$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 76608) 76626) inline$$GetGlobal$0$anon3_Else_correct@@6)))))
(let ((inline$$GetGlobal$0$Entry_correct@@6  (and (=> (= (ControlFlow 0 76602) (- 0 124804)) true) (=> (= (ControlFlow 0 76602) 76608) inline$$GetGlobal$0$anon0_correct@@6))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon32_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_validator_$def_verify$0$$t7@1) (= (ControlFlow 0 76686) 76602)) inline$$GetGlobal$0$Entry_correct@@6)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon14_correct  (=> (and (= $abort_code@7@@6 $abort_code@3@@6) (= (ControlFlow 0 76495) 76499)) inline$$Roles_assert_validator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 76493) 76495)) inline$$Roles_assert_validator_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 76507) 76495) inline$$Roles_assert_validator_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon32_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_validator_$def_verify$0$$t7@1)) (= $abort_code@3@@6 (|i#$Integer| call3formal@$ret0@0@@22))) (and (=> (= (ControlFlow 0 76487) 76507) inline$$Roles_assert_validator_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 76487) 76493) inline$$Roles_assert_validator_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon30_Else_correct  (=> (not $abort_flag@1@@6) (and (=> (= (ControlFlow 0 76475) 76686) inline$$Roles_assert_validator_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 76475) 76487) inline$$Roles_assert_validator_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@0@@6) (= inline$$Roles_assert_validator_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@21))))) (=> (and (and (and (= inline$$Roles_assert_validator_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@6)) (and (=> $abort_flag@1@@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@22 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@22) (>= (|i#$Integer| call3formal@$ret0@0@@22) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@22) $MAX_U64))) (and (=> (= (ControlFlow 0 76469) 76842) inline$$Roles_assert_validator_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 76469) 76475) inline$$Roles_assert_validator_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@6) (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@21 validator_account)))) ((_ is $Address) call3formal@$ret0@0@@21))) (and (=> (= (ControlFlow 0 76451) 76862) inline$$Roles_assert_validator_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 76451) 76469) inline$$Roles_assert_validator_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 76415) 76451)) inline$$Roles_assert_validator_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 76886) 76451) inline$$Roles_assert_validator_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_validator_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 76409) 76886) inline$$Roles_assert_validator_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 76409) 76415) inline$$Roles_assert_validator_$def_verify$0$anon27_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@6))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@6))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@6))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (= (ControlFlow 0 76890) 76409)) inline$$Roles_assert_validator_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@6  (=> (and ((_ is $Address) validator_account) (= (ControlFlow 0 75943) 76890)) anon0$1_correct@@6)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 123315) 75943) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun validator_operator_account () T@$Value)
(declare-fun $abort_flag@4@@7 () Bool)
(declare-fun $abort_code@8@@7 () Int)
(declare-fun inline$$Roles_assert_validator_operator_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@5@@7 () Int)
(declare-fun $abort_flag@3@@7 () Bool)
(declare-fun $abort_code@7@@7 () Int)
(declare-fun $abort_code@1@@7 () Int)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun $abort_code@2@@7 () Int)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun $abort_code@4@@7 () Int)
(declare-fun $abort_flag@2@@7 () Bool)
(declare-fun $abort_code@6@@7 () Int)
(declare-fun call3formal@$ret0@0@@23 () T@$Value)
(declare-fun inline$$Roles_assert_validator_operator_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@7 () T@$Value)
(declare-fun inline$$Roles_assert_validator_operator_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@7 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@7 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@7 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@7 () T@$Value)
(declare-fun call3formal@$ret0@0@@24 () T@$Value)
(declare-fun inline$$Roles_assert_validator_operator_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@7 () Int)
(declare-fun call3formal@$ret0@0@@25 () T@$Value)
(declare-fun inline$$Roles_assert_validator_operator_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 125989) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 77978) (- 0 127789)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) $abort_flag@4@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) $abort_flag@4@@7) (and (=> (= (ControlFlow 0 77978) (- 0 127810)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) $abort_flag@4@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) $abort_flag@4@@7) (and (=> (= (ControlFlow 0 77978) (- 0 127839)) (=> $abort_flag@4@@7 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4)))))))) (=> (=> $abort_flag@4@@7 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))))) (and (=> (= (ControlFlow 0 77978) (- 0 127888)) (=> $abort_flag@4@@7 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (= $abort_code@8@@7 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) (= $abort_code@8@@7 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@4@@7 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account))))))) (= $abort_code@8@@7 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_operator_account)))) $Roles_RoleId_role_id) ($Integer 4))))) (= $abort_code@8@@7 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 77978) (- 0 127959)) (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@103 T@$Value) )  (=> ((_ is $Address) addr@@103) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@103)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@103)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@103)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@103)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@104 T@$Value) )  (=> ((_ is $Address) addr@@104) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@104)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@104)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@104)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@104)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 77978) (- 0 128059)) (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@105 T@$Value) )  (=> ((_ is $Address) addr@@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@105)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@105)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@105)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@105)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@106 T@$Value) )  (=> ((_ is $Address) addr@@106) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@106)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@106)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@106)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@106)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 77978) (- 0 128159)) (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@107 T@$Value) )  (=> ((_ is $Address) addr@@107) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@107)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@107)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@107)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@107)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@108 T@$Value) )  (=> ((_ is $Address) addr@@108) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@108)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@108)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@108)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@108)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 77978) (- 0 128259)) (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@109 T@$Value) )  (=> ((_ is $Address) addr@@109) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@109)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@109)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@109)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@109)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@110 T@$Value) )  (=> ((_ is $Address) addr@@110) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@110)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@110)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@110)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@110)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 77978) (- 0 128359)) (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@111 T@$Value) )  (=> ((_ is $Address) addr@@111) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@111)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@111)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@111)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@111)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@112 T@$Value) )  (=> ((_ is $Address) addr@@112) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@112)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@112)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@112)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@112)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 77978) (- 0 128459)) (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@113 T@$Value) )  (=> ((_ is $Address) addr@@113) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@113)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@113)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@113)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@113)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@114 T@$Value) )  (=> ((_ is $Address) addr@@114) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@114)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@114)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@114)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@114)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 77978) (- 0 128559)) (=> (not $abort_flag@4@@7) (|b#$Boolean| ($Boolean (forall ((addr@@115 T@$Value) )  (=> ((_ is $Address) addr@@115) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@115)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@115)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@115)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@115)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon38_Then_correct  (=> (and (and (|b#$Boolean| inline$$Roles_assert_validator_operator_$def_verify$0$$t13@1) (= $abort_code@8@@7 $abort_code@5@@7)) (and (= $abort_flag@4@@7 $abort_flag@3@@7) (= (ControlFlow 0 77884) 77978))) anon0$2_correct@@7)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$Abort_correct  (=> (= $abort_code@8@@7 $abort_code@7@@7) (=> (and (= $abort_flag@4@@7 true) (= (ControlFlow 0 77585) 77978)) anon0$2_correct@@7))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon5_correct  (=> (and (= $abort_code@7@@7 $abort_code@1@@7) (= (ControlFlow 0 77956) 77585)) inline$$Roles_assert_validator_operator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 77954) 77956)) inline$$Roles_assert_validator_operator_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 77964) 77956) inline$$Roles_assert_validator_operator_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 77948) 77964) inline$$Roles_assert_validator_operator_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 77948) 77954) inline$$Roles_assert_validator_operator_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon9_correct  (=> (and (= $abort_code@7@@7 $abort_code@2@@7) (= (ControlFlow 0 77936) 77585)) inline$$Roles_assert_validator_operator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 77934) 77936)) inline$$Roles_assert_validator_operator_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 77944) 77936) inline$$Roles_assert_validator_operator_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon30_Then_correct  (=> $abort_flag@1@@7 (and (=> (= (ControlFlow 0 77928) 77944) inline$$Roles_assert_validator_operator_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 77928) 77934) inline$$Roles_assert_validator_operator_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon17_correct  (=> (and (= $abort_code@7@@7 $abort_code@4@@7) (= (ControlFlow 0 77916) 77585)) inline$$Roles_assert_validator_operator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 77914) 77916)) inline$$Roles_assert_validator_operator_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 77924) 77916) inline$$Roles_assert_validator_operator_$def_verify$0$anon17_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon34_Then_correct  (=> $abort_flag@2@@7 (and (=> (= (ControlFlow 0 77908) 77924) inline$$Roles_assert_validator_operator_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 77908) 77914) inline$$Roles_assert_validator_operator_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon21_correct  (=> (and (= $abort_code@7@@7 $abort_code@5@@7) (= (ControlFlow 0 77896) 77585)) inline$$Roles_assert_validator_operator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 77894) 77896)) inline$$Roles_assert_validator_operator_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 77904) 77896) inline$$Roles_assert_validator_operator_$def_verify$0$anon21_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon36_Then_correct  (=> $abort_flag@3@@7 (and (=> (= (ControlFlow 0 77888) 77904) inline$$Roles_assert_validator_operator_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 77888) 77894) inline$$Roles_assert_validator_operator_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon26_correct  (=> (and (= $abort_code@7@@7 $abort_code@6@@7) (= (ControlFlow 0 77870) 77585)) inline$$Roles_assert_validator_operator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 77868) 77870)) inline$$Roles_assert_validator_operator_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 77878) 77870) inline$$Roles_assert_validator_operator_$def_verify$0$anon26_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_validator_operator_$def_verify$0$$t13@1)) (= $abort_code@6@@7 (|i#$Integer| call3formal@$ret0@0@@23))) (and (=> (= (ControlFlow 0 77862) 77878) inline$$Roles_assert_validator_operator_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 77862) 77868) inline$$Roles_assert_validator_operator_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@3@@7) (and (=> (= (ControlFlow 0 77850) 77884) inline$$Roles_assert_validator_operator_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 77850) 77862) inline$$Roles_assert_validator_operator_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon34_Else$1_correct  (=> (and (= inline$$Roles_assert_validator_operator_$def_verify$0$$t12@1 ($Integer 4)) (= inline$$Roles_assert_validator_operator_$def_verify$0$$t13@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@7 inline$$Roles_assert_validator_operator_$def_verify$0$$t12@1)))) (=> (and (and (and (= inline$$Roles_assert_validator_operator_$def_verify$0$$t14@1 ($Integer 8)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@7)) (and (=> $abort_flag@3@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@23 ($Integer 3))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@23) (>= (|i#$Integer| call3formal@$ret0@0@@23) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@23) $MAX_U64))) (and (=> (= (ControlFlow 0 77844) 77888) inline$$Roles_assert_validator_operator_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 77844) 77850) inline$$Roles_assert_validator_operator_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@7  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@7)) $Roles_RoleId_role_id)) (= (ControlFlow 0 77820) 77844)) inline$$Roles_assert_validator_operator_$def_verify$0$anon34_Else$1_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@7) (= (ControlFlow 0 77826) 77820)) inline$$GetFieldFromValue$0$anon0_correct@@7)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@7  (=> (= $abort_flag@2@@7 true) (=> (and (= $abort_code@4@@7 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@7 inline$$GetGlobal$0$dst@0@@7)) (and (=> (= (ControlFlow 0 77766) 77908) inline$$Roles_assert_validator_operator_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 77766) 77826) inline$$Roles_assert_validator_operator_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@7  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@7)) (= (ControlFlow 0 77764) 77766)) inline$$GetGlobal$0$anon3_Then$1_correct@@7)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@7  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@7) (=> (and (and (= inline$$GetGlobal$0$dst@1@@7 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@24))) (= $abort_flag@2@@7 $abort_flag@1@@7)) (and (= $abort_code@4@@7 $abort_code@2@@7) (= inline$$GetGlobal$0$dst@2@@7 inline$$GetGlobal$0$dst@1@@7))) (and (=> (= (ControlFlow 0 77712) 77908) inline$$Roles_assert_validator_operator_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 77712) 77826) inline$$Roles_assert_validator_operator_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@7  (=> (= inline$$GetGlobal$0$a@1@@7 (|a#$Address| call3formal@$ret0@0@@24)) (and (=> (= (ControlFlow 0 77694) 77764) inline$$GetGlobal$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 77694) 77712) inline$$GetGlobal$0$anon3_Else_correct@@7)))))
(let ((inline$$GetGlobal$0$Entry_correct@@7  (and (=> (= (ControlFlow 0 77688) (- 0 127478)) true) (=> (= (ControlFlow 0 77688) 77694) inline$$GetGlobal$0$anon0_correct@@7))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon32_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_assert_validator_operator_$def_verify$0$$t7@1) (= (ControlFlow 0 77772) 77688)) inline$$GetGlobal$0$Entry_correct@@7)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon14_correct  (=> (and (= $abort_code@7@@7 $abort_code@3@@7) (= (ControlFlow 0 77581) 77585)) inline$$Roles_assert_validator_operator_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 77579) 77581)) inline$$Roles_assert_validator_operator_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 77593) 77581) inline$$Roles_assert_validator_operator_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon32_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_assert_validator_operator_$def_verify$0$$t7@1)) (= $abort_code@3@@7 (|i#$Integer| call3formal@$ret0@0@@25))) (and (=> (= (ControlFlow 0 77573) 77593) inline$$Roles_assert_validator_operator_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 77573) 77579) inline$$Roles_assert_validator_operator_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon30_Else_correct  (=> (not $abort_flag@1@@7) (and (=> (= (ControlFlow 0 77561) 77772) inline$$Roles_assert_validator_operator_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 77561) 77573) inline$$Roles_assert_validator_operator_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@0@@7) (= inline$$Roles_assert_validator_operator_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@24))))) (=> (and (and (and (= inline$$Roles_assert_validator_operator_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@7)) (and (=> $abort_flag@1@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@25 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@25) (>= (|i#$Integer| call3formal@$ret0@0@@25) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@25) $MAX_U64))) (and (=> (= (ControlFlow 0 77555) 77928) inline$$Roles_assert_validator_operator_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 77555) 77561) inline$$Roles_assert_validator_operator_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@7) (=> $abort_flag@0@@7 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@24 validator_operator_account)))) ((_ is $Address) call3formal@$ret0@0@@24))) (and (=> (= (ControlFlow 0 77537) 77948) inline$$Roles_assert_validator_operator_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 77537) 77555) inline$$Roles_assert_validator_operator_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 77501) 77537)) inline$$Roles_assert_validator_operator_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 77972) 77537) inline$$Roles_assert_validator_operator_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_assert_validator_operator_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 77495) 77972) inline$$Roles_assert_validator_operator_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 77495) 77501) inline$$Roles_assert_validator_operator_$def_verify$0$anon27_Else_correct)))))
(let ((anon0$1_correct@@7  (=> (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (= (ControlFlow 0 77976) 77495)) inline$$Roles_assert_validator_operator_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@7  (=> (and ((_ is $Address) validator_operator_account) (= (ControlFlow 0 77029) 77976)) anon0$1_correct@@7)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 125989) 77029) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@7)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@17 () Bool)
(declare-fun inline$$Roles_can_hold_balance_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_flag@4@@8 () Bool)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_flag@10 () Bool)
(declare-fun |inline$$Roles_can_hold_balance_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_flag@14 () Bool)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$ret0@1 () T@$Value)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $abort_flag@13 () Bool)
(declare-fun |inline$$Roles_has_role_$def$2$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$2$dst () T@$Value)
(declare-fun inline$$GetGlobal$2$a@1 () Int)
(declare-fun inline$$GetGlobal$2$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@26 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$t9@1 () T@$Value)
(declare-fun account@@6 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$ret0@2 () T@$Value)
(declare-fun $abort_flag@8 () Bool)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_flag@7 () Bool)
(declare-fun |inline$$Roles_has_role_$def$1$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$1$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$1$a@1 () Int)
(declare-fun inline$$GetGlobal$1$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@27 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$t9@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@3@@8 () Bool)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun $abort_flag@2@@8 () Bool)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@8 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@8 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@8 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@8 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@8 () T@$Value)
(declare-fun call3formal@$ret0@0@@28 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 128664) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 82422) (- 0 131895)) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@116 T@$Value) )  (=> ((_ is $Address) addr@@116) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@116)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@116)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@116)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@116)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@117 T@$Value) )  (=> ((_ is $Address) addr@@117) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@117)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@117)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@117)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@117)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 82422) (- 0 131995)) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@118 T@$Value) )  (=> ((_ is $Address) addr@@118) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@118)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@118)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@118)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@118)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@119 T@$Value) )  (=> ((_ is $Address) addr@@119) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@119)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@119)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@119)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@119)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 82422) (- 0 132095)) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@120 T@$Value) )  (=> ((_ is $Address) addr@@120) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@120)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@120)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@120)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@120)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@121 T@$Value) )  (=> ((_ is $Address) addr@@121) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@121)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@121)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@121)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@121)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 82422) (- 0 132195)) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@122 T@$Value) )  (=> ((_ is $Address) addr@@122) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@122)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@122)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@122)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@122)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@123 T@$Value) )  (=> ((_ is $Address) addr@@123) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@123)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@123)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@123)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@123)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 82422) (- 0 132295)) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@124 T@$Value) )  (=> ((_ is $Address) addr@@124) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@124)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@124)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@124)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@124)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@125 T@$Value) )  (=> ((_ is $Address) addr@@125) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@125)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@125)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@125)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@125)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 82422) (- 0 132395)) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@126 T@$Value) )  (=> ((_ is $Address) addr@@126) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@126)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@126)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@126)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@126)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@127 T@$Value) )  (=> ((_ is $Address) addr@@127) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@127)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@127)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@127)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@127)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 82422) (- 0 132495)) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean (forall ((addr@@128 T@$Value) )  (=> ((_ is $Address) addr@@128) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@128)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@128)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@128)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@128)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$Abort_correct  (=> (= inline$$Roles_can_hold_balance_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@17 true) (= (ControlFlow 0 82278) 82422)) anon0$2_correct@@8))))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon26_Then_correct  (=> (and $abort_flag@15 (= (ControlFlow 0 82272) 82278)) inline$$Roles_can_hold_balance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon23_Then_correct  (=> (and $abort_flag@9 (= (ControlFlow 0 82342) 82278)) inline$$Roles_can_hold_balance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon20_Then_correct  (=> (and $abort_flag@4@@8 (= (ControlFlow 0 82406) 82278)) inline$$Roles_can_hold_balance_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon18_correct  (=> (and (= $abort_flag@17 $abort_flag@16) (= (ControlFlow 0 82260) 82422)) anon0$2_correct@@8)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 82258) 82260)) inline$$Roles_can_hold_balance_$def_verify$0$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 82268) 82260) inline$$Roles_can_hold_balance_$def_verify$0$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon14_correct  (=> (= $abort_flag@16 $abort_flag@10) (and (=> (= (ControlFlow 0 82330) 82268) inline$$Roles_can_hold_balance_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 82330) 82258) inline$$Roles_can_hold_balance_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 82328) 82330)) inline$$Roles_can_hold_balance_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 82338) 82330) inline$$Roles_can_hold_balance_$def_verify$0$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon24_Then_correct  (=> (and (|b#$Boolean| |inline$$Roles_can_hold_balance_$def_verify$0$tmp#$1@1|) (= inline$$Roles_can_hold_balance_$def_verify$0$$t6@1 ($Boolean true))) (and (=> (= (ControlFlow 0 82320) 82338) inline$$Roles_can_hold_balance_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 82320) 82328) inline$$Roles_can_hold_balance_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@15) (= $abort_flag@16 $abort_flag@15)) (and (=> (= (ControlFlow 0 82248) 82268) inline$$Roles_can_hold_balance_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 82248) 82258) inline$$Roles_can_hold_balance_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon6_correct  (=> (= $abort_flag@15 $abort_flag@14) (and (=> (= (ControlFlow 0 82202) 82272) inline$$Roles_can_hold_balance_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 82202) 82248) inline$$Roles_can_hold_balance_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 82200) 82202)) inline$$Roles_has_designated_dealer_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 82210) 82202) inline$$Roles_has_designated_dealer_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@14) (and (=> (= (ControlFlow 0 82194) 82210) inline$$Roles_has_designated_dealer_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 82194) 82200) inline$$Roles_has_designated_dealer_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon8_Then_correct  (=> $abort_flag@14 (=> (and (= inline$$Roles_has_designated_dealer_role_$def$0$$ret0@1 $Error) (= $abort_flag@15 true)) (and (=> (= (ControlFlow 0 82218) 82272) inline$$Roles_can_hold_balance_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 82218) 82248) inline$$Roles_can_hold_balance_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$Roles_has_role_$def$2$Abort_correct  (=> (and (= inline$$Roles_has_role_$def$2$$ret0@1 $Error) (= $abort_flag@14 true)) (and (=> (= (ControlFlow 0 82126) 82218) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 82126) 82194) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 82144) 82126)) inline$$Roles_has_role_$def$2$Abort_correct)))
(let ((inline$$Roles_has_role_$def$2$anon24_Then_correct  (=> (= (ControlFlow 0 82154) 82126) inline$$Roles_has_role_$def$2$Abort_correct)))
(let ((inline$$Roles_has_role_$def$2$anon23_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 82138) 82154) inline$$Roles_has_role_$def$2$anon24_Then_correct) (=> (= (ControlFlow 0 82138) 82144) inline$$Roles_has_role_$def$2$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 82118) 82126)) inline$$Roles_has_role_$def$2$Abort_correct)))
(let ((inline$$Roles_has_role_$def$2$anon27_Then_correct  (=> (= (ControlFlow 0 82134) 82126) inline$$Roles_has_role_$def$2$Abort_correct)))
(let ((inline$$Roles_has_role_$def$2$anon26_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 82112) 82134) inline$$Roles_has_role_$def$2$anon27_Then_correct) (=> (= (ControlFlow 0 82112) 82118) inline$$Roles_has_role_$def$2$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon20_correct  (=> (= $abort_flag@14 $abort_flag@13) (and (=> (= (ControlFlow 0 81833) 82218) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 81833) 82194) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 81831) 81833)) inline$$Roles_has_role_$def$2$anon20_correct)))
(let ((inline$$Roles_has_role_$def$2$anon30_Then_correct  (=> (= (ControlFlow 0 81841) 81833) inline$$Roles_has_role_$def$2$anon20_correct)))
(let ((inline$$Roles_has_role_$def$2$anon16_correct  (=> (= $abort_flag@13 $abort_flag@12) (and (=> (= (ControlFlow 0 82100) 81841) inline$$Roles_has_role_$def$2$anon30_Then_correct) (=> (= (ControlFlow 0 82100) 81831) inline$$Roles_has_role_$def$2$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 82098) 82100)) inline$$Roles_has_role_$def$2$anon16_correct)))
(let ((inline$$Roles_has_role_$def$2$anon28_Then_correct  (=> (= (ControlFlow 0 82108) 82100) inline$$Roles_has_role_$def$2$anon16_correct)))
(let ((inline$$Roles_has_role_$def$2$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$2$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$2$dst@1 inline$$Roles_has_designated_dealer_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 82092) 82108) inline$$Roles_has_role_$def$2$anon28_Then_correct) (=> (= (ControlFlow 0 82092) 82098) inline$$Roles_has_role_$def$2$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (and (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$2$dst)) $Roles_RoleId_role_id)) (= (ControlFlow 0 82076) 82092)) inline$$Roles_has_role_$def$2$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$2$anon26_Else_correct  (=> (and (not $abort_flag@12) (= (ControlFlow 0 82082) 82076)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$GetGlobal$2$anon3_Then$1_correct  (=> (= $abort_flag@12 true) (and (=> (= (ControlFlow 0 82022) 82112) inline$$Roles_has_role_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 82022) 82082) inline$$Roles_has_role_$def$2$anon26_Else_correct)))))
(let ((inline$$GetGlobal$2$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$2$a@1)) (= (ControlFlow 0 82020) 82022)) inline$$GetGlobal$2$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$2$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$2$a@1) (=> (and (= inline$$GetGlobal$2$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@26))) (= $abort_flag@12 $abort_flag@11)) (and (=> (= (ControlFlow 0 81968) 82112) inline$$Roles_has_role_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 81968) 82082) inline$$Roles_has_role_$def$2$anon26_Else_correct))))))
(let ((inline$$GetGlobal$2$anon0_correct  (=> (= inline$$GetGlobal$2$a@1 (|a#$Address| call3formal@$ret0@0@@26)) (and (=> (= (ControlFlow 0 81950) 82020) inline$$GetGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 81950) 81968) inline$$GetGlobal$2$anon3_Else_correct)))))
(let ((inline$$GetGlobal$2$Entry_correct  (and (=> (= (ControlFlow 0 81944) (- 0 131599)) true) (=> (= (ControlFlow 0 81944) 81950) inline$$GetGlobal$2$anon0_correct))))
(let ((inline$$Roles_has_role_$def$2$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$2$$t6@1) (= (ControlFlow 0 82028) 81944)) inline$$GetGlobal$2$Entry_correct)))
(let ((inline$$Roles_has_role_$def$2$anon18_correct  (=> (= $abort_flag@13 $abort_flag@11) (and (=> (= (ControlFlow 0 81821) 81841) inline$$Roles_has_role_$def$2$anon30_Then_correct) (=> (= (ControlFlow 0 81821) 81831) inline$$Roles_has_role_$def$2$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 81819) 81821)) inline$$Roles_has_role_$def$2$anon18_correct)))
(let ((inline$$Roles_has_role_$def$2$anon29_Then_correct  (=> (= (ControlFlow 0 81849) 81821) inline$$Roles_has_role_$def$2$anon18_correct)))
(let ((inline$$Roles_has_role_$def$2$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$2$$t6@1)) (= inline$$Roles_has_role_$def$2$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 81811) 81849) inline$$Roles_has_role_$def$2$anon29_Then_correct) (=> (= (ControlFlow 0 81811) 81819) inline$$Roles_has_role_$def$2$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon23_Else_correct  (=> (and (not $abort_flag@11) (= inline$$Roles_has_role_$def$2$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@26))))) (and (=> (= (ControlFlow 0 81767) 82028) inline$$Roles_has_role_$def$2$anon25_Then_correct) (=> (= (ControlFlow 0 81767) 81811) inline$$Roles_has_role_$def$2$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11) (=> $abort_flag@11 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@26 account@@6)))) ((_ is $Address) call3formal@$ret0@0@@26))) (and (=> (= (ControlFlow 0 81753) 82138) inline$$Roles_has_role_$def$2$anon23_Then_correct) (=> (= (ControlFlow 0 81753) 81767) inline$$Roles_has_role_$def$2$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 81683) 81753)) inline$$Roles_has_role_$def$2$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$2$anon22_Then_correct  (=> (= (ControlFlow 0 82162) 81753) inline$$Roles_has_role_$def$2$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$2$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 81675) 82162) inline$$Roles_has_role_$def$2$anon22_Then_correct) (=> (= (ControlFlow 0 81675) 81683) inline$$Roles_has_role_$def$2$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon21_Then_correct  (and (=> (= (ControlFlow 0 82170) 82162) inline$$Roles_has_role_$def$2$anon22_Then_correct) (=> (= (ControlFlow 0 82170) 81683) inline$$Roles_has_role_$def$2$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$2$anon0_correct  (=> (not $abort_flag@10) (and (=> (= (ControlFlow 0 81669) 82170) inline$$Roles_has_role_$def$2$anon21_Then_correct) (=> (= (ControlFlow 0 81669) 81675) inline$$Roles_has_role_$def$2$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$2$anon0_correct  (=> ((_ is $Address) account@@6) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_designated_dealer_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 82176) 81669)) inline$$Roles_has_role_$def$2$anon0_correct))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$0$$t2@1 ($Integer 2)) (= (ControlFlow 0 82184) 82176)) inline$$Roles_has_role$2$anon0_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 81196) 82184)) inline$$Roles_has_designated_dealer_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 82226) 82184) inline$$Roles_has_designated_dealer_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon0_correct  (=> (not $abort_flag@10) (and (=> (= (ControlFlow 0 81190) 82226) inline$$Roles_has_designated_dealer_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 81190) 81196) inline$$Roles_has_designated_dealer_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$direct_intra$0$anon0_correct  (=> (and ((_ is $Address) account@@6) (= (ControlFlow 0 82232) 81190)) inline$$Roles_has_designated_dealer_role_$def$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon24_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Roles_can_hold_balance_$def_verify$0$tmp#$1@1|)) (= (ControlFlow 0 82240) 82232)) inline$$Roles_has_designated_dealer_role_$direct_intra$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon8_correct  (=> (and (= |inline$$Roles_can_hold_balance_$def_verify$0$tmp#$1@1| inline$$Roles_can_hold_balance_$def_verify$0$$t5@1) (= $abort_flag@10 $abort_flag@4@@8)) (and (=> (= (ControlFlow 0 82394) 82320) inline$$Roles_can_hold_balance_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 82394) 82240) inline$$Roles_can_hold_balance_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 82392) 82394)) inline$$Roles_can_hold_balance_$def_verify$0$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 82402) 82394) inline$$Roles_can_hold_balance_$def_verify$0$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2) (= inline$$Roles_can_hold_balance_$def_verify$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 82384) 82402) inline$$Roles_can_hold_balance_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 82384) 82392) inline$$Roles_can_hold_balance_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon23_Else_correct  (=> (not $abort_flag@9) (=> (and (= |inline$$Roles_can_hold_balance_$def_verify$0$tmp#$1@1| inline$$Roles_has_child_VASP_role_$def$0$$ret0@2) (= $abort_flag@10 $abort_flag@9)) (and (=> (= (ControlFlow 0 80988) 82320) inline$$Roles_can_hold_balance_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 80988) 82240) inline$$Roles_can_hold_balance_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon6_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$1$$ret0@2) (= $abort_flag@9 $abort_flag@8)) (and (=> (= (ControlFlow 0 80942) 82342) inline$$Roles_can_hold_balance_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 80942) 80988) inline$$Roles_can_hold_balance_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 80940) 80942)) inline$$Roles_has_child_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 80950) 80942) inline$$Roles_has_child_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@8) (and (=> (= (ControlFlow 0 80934) 80950) inline$$Roles_has_child_VASP_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 80934) 80940) inline$$Roles_has_child_VASP_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon8_Then_correct  (=> (and (and $abort_flag@8 (= inline$$Roles_has_child_VASP_role_$def$0$$ret0@1 $Error)) (and (= inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 inline$$Roles_has_child_VASP_role_$def$0$$ret0@1) (= $abort_flag@9 true))) (and (=> (= (ControlFlow 0 80958) 82342) inline$$Roles_can_hold_balance_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 80958) 80988) inline$$Roles_can_hold_balance_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$Abort_correct  (=> (= inline$$Roles_has_role_$def$1$$ret0@1 $Error) (=> (and (= $abort_flag@8 true) (= inline$$Roles_has_role_$def$1$$ret0@2 inline$$Roles_has_role_$def$1$$ret0@1)) (and (=> (= (ControlFlow 0 80866) 80958) inline$$Roles_has_child_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 80866) 80934) inline$$Roles_has_child_VASP_role_$def$0$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$1$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 80884) 80866)) inline$$Roles_has_role_$def$1$Abort_correct)))
(let ((inline$$Roles_has_role_$def$1$anon24_Then_correct  (=> (= (ControlFlow 0 80894) 80866) inline$$Roles_has_role_$def$1$Abort_correct)))
(let ((inline$$Roles_has_role_$def$1$anon23_Then_correct  (=> $abort_flag@5@@1 (and (=> (= (ControlFlow 0 80878) 80894) inline$$Roles_has_role_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 80878) 80884) inline$$Roles_has_role_$def$1$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 80858) 80866)) inline$$Roles_has_role_$def$1$Abort_correct)))
(let ((inline$$Roles_has_role_$def$1$anon27_Then_correct  (=> (= (ControlFlow 0 80874) 80866) inline$$Roles_has_role_$def$1$Abort_correct)))
(let ((inline$$Roles_has_role_$def$1$anon26_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 80852) 80874) inline$$Roles_has_role_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 80852) 80858) inline$$Roles_has_role_$def$1$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon20_correct  (=> (and (= $abort_flag@8 $abort_flag@7) (= inline$$Roles_has_role_$def$1$$ret0@2 |inline$$Roles_has_role_$def$1$tmp#$3@2|)) (and (=> (= (ControlFlow 0 80573) 80958) inline$$Roles_has_child_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 80573) 80934) inline$$Roles_has_child_VASP_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 80571) 80573)) inline$$Roles_has_role_$def$1$anon20_correct)))
(let ((inline$$Roles_has_role_$def$1$anon30_Then_correct  (=> (= (ControlFlow 0 80581) 80573) inline$$Roles_has_role_$def$1$anon20_correct)))
(let ((inline$$Roles_has_role_$def$1$anon16_correct  (=> (and (= |inline$$Roles_has_role_$def$1$tmp#$3@2| |inline$$Roles_has_role_$def$1$tmp#$3@1|) (= $abort_flag@7 $abort_flag@6)) (and (=> (= (ControlFlow 0 80840) 80581) inline$$Roles_has_role_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 80840) 80571) inline$$Roles_has_role_$def$1$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 80838) 80840)) inline$$Roles_has_role_$def$1$anon16_correct)))
(let ((inline$$Roles_has_role_$def$1$anon28_Then_correct  (=> (= (ControlFlow 0 80848) 80840) inline$$Roles_has_role_$def$1$anon16_correct)))
(let ((inline$$Roles_has_role_$def$1$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$1$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$1$dst@1 inline$$Roles_has_child_VASP_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 80832) 80848) inline$$Roles_has_role_$def$1$anon28_Then_correct) (=> (= (ControlFlow 0 80832) 80838) inline$$Roles_has_role_$def$1$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$1$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 80816) 80832)) inline$$Roles_has_role_$def$1$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$1$anon26_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 80822) 80816)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$GetGlobal$1$anon3_Then$1_correct  (=> (and (= $abort_flag@6 true) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 80762) 80852) inline$$Roles_has_role_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 80762) 80822) inline$$Roles_has_role_$def$1$anon26_Else_correct)))))
(let ((inline$$GetGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$1$a@1)) (= (ControlFlow 0 80760) 80762)) inline$$GetGlobal$1$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$1$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$1$a@1) (= inline$$GetGlobal$1$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@27)))) (and (= $abort_flag@6 $abort_flag@5@@1) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 80708) 80852) inline$$Roles_has_role_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 80708) 80822) inline$$Roles_has_role_$def$1$anon26_Else_correct)))))
(let ((inline$$GetGlobal$1$anon0_correct  (=> (= inline$$GetGlobal$1$a@1 (|a#$Address| call3formal@$ret0@0@@27)) (and (=> (= (ControlFlow 0 80690) 80760) inline$$GetGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 80690) 80708) inline$$GetGlobal$1$anon3_Else_correct)))))
(let ((inline$$GetGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 80684) (- 0 130993)) true) (=> (= (ControlFlow 0 80684) 80690) inline$$GetGlobal$1$anon0_correct))))
(let ((inline$$Roles_has_role_$def$1$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$1$$t6@1) (= (ControlFlow 0 80768) 80684)) inline$$GetGlobal$1$Entry_correct)))
(let ((inline$$Roles_has_role_$def$1$anon18_correct  (=> (and (= |inline$$Roles_has_role_$def$1$tmp#$3@2| inline$$Roles_has_role_$def$1$$t9@1) (= $abort_flag@7 $abort_flag@5@@1)) (and (=> (= (ControlFlow 0 80561) 80581) inline$$Roles_has_role_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 80561) 80571) inline$$Roles_has_role_$def$1$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 80559) 80561)) inline$$Roles_has_role_$def$1$anon18_correct)))
(let ((inline$$Roles_has_role_$def$1$anon29_Then_correct  (=> (= (ControlFlow 0 80589) 80561) inline$$Roles_has_role_$def$1$anon18_correct)))
(let ((inline$$Roles_has_role_$def$1$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$1$$t6@1)) (= inline$$Roles_has_role_$def$1$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 80551) 80589) inline$$Roles_has_role_$def$1$anon29_Then_correct) (=> (= (ControlFlow 0 80551) 80559) inline$$Roles_has_role_$def$1$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon23_Else_correct  (=> (and (not $abort_flag@5@@1) (= inline$$Roles_has_role_$def$1$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@27))))) (and (=> (= (ControlFlow 0 80507) 80768) inline$$Roles_has_role_$def$1$anon25_Then_correct) (=> (= (ControlFlow 0 80507) 80551) inline$$Roles_has_role_$def$1$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@1) (=> $abort_flag@5@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@27 account@@6)))) ((_ is $Address) call3formal@$ret0@0@@27))) (and (=> (= (ControlFlow 0 80493) 80878) inline$$Roles_has_role_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 80493) 80507) inline$$Roles_has_role_$def$1$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 80423) 80493)) inline$$Roles_has_role_$def$1$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$1$anon22_Then_correct  (=> (= (ControlFlow 0 80902) 80493) inline$$Roles_has_role_$def$1$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$1$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 80415) 80902) inline$$Roles_has_role_$def$1$anon22_Then_correct) (=> (= (ControlFlow 0 80415) 80423) inline$$Roles_has_role_$def$1$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon21_Then_correct  (and (=> (= (ControlFlow 0 80910) 80902) inline$$Roles_has_role_$def$1$anon22_Then_correct) (=> (= (ControlFlow 0 80910) 80423) inline$$Roles_has_role_$def$1$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$1$anon0_correct  (=> (not $abort_flag@4@@8) (and (=> (= (ControlFlow 0 80409) 80910) inline$$Roles_has_role_$def$1$anon21_Then_correct) (=> (= (ControlFlow 0 80409) 80415) inline$$Roles_has_role_$def$1$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$1$anon0_correct  (=> ((_ is $Address) account@@6) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_child_VASP_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 80916) 80409)) inline$$Roles_has_role_$def$1$anon0_correct))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$0$$t2@1 ($Integer 6)) (= (ControlFlow 0 80924) 80916)) inline$$Roles_has_role$1$anon0_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 79936) 80924)) inline$$Roles_has_child_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 80966) 80924) inline$$Roles_has_child_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon0_correct  (=> (not $abort_flag@4@@8) (and (=> (= (ControlFlow 0 79930) 80966) inline$$Roles_has_child_VASP_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 79930) 79936) inline$$Roles_has_child_VASP_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$direct_intra$0$anon0_correct  (=> (and ((_ is $Address) account@@6) (= (ControlFlow 0 80972) 79930)) inline$$Roles_has_child_VASP_role_$def$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2)) (= (ControlFlow 0 80980) 80972)) inline$$Roles_has_child_VASP_role_$direct_intra$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon20_Else_correct  (=> (not $abort_flag@4@@8) (and (=> (= (ControlFlow 0 79730) 82384) inline$$Roles_can_hold_balance_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 79730) 80980) inline$$Roles_can_hold_balance_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon6_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$0$$ret0@2) (= $abort_flag@4@@8 $abort_flag@3@@8)) (and (=> (= (ControlFlow 0 79684) 82406) inline$$Roles_can_hold_balance_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 79684) 79730) inline$$Roles_can_hold_balance_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 79682) 79684)) inline$$Roles_has_parent_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 79692) 79684) inline$$Roles_has_parent_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@3@@8) (and (=> (= (ControlFlow 0 79676) 79692) inline$$Roles_has_parent_VASP_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 79676) 79682) inline$$Roles_has_parent_VASP_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon8_Then_correct  (=> (and (and $abort_flag@3@@8 (= inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1 $Error)) (and (= inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1) (= $abort_flag@4@@8 true))) (and (=> (= (ControlFlow 0 79700) 82406) inline$$Roles_can_hold_balance_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 79700) 79730) inline$$Roles_can_hold_balance_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$Abort_correct  (=> (= inline$$Roles_has_role_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@3@@8 true) (= inline$$Roles_has_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 79608) 79700) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 79608) 79676) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 79626) 79608)) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 79636) 79608) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct  (=> $abort_flag@0@@8 (and (=> (= (ControlFlow 0 79620) 79636) inline$$Roles_has_role_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 79620) 79626) inline$$Roles_has_role_$def$0$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 79600) 79608)) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 79616) 79608) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct  (=> $abort_flag@1@@8 (and (=> (= (ControlFlow 0 79594) 79616) inline$$Roles_has_role_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 79594) 79600) inline$$Roles_has_role_$def$0$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct  (=> (and (= $abort_flag@3@@8 $abort_flag@2@@8) (= inline$$Roles_has_role_$def$0$$ret0@2 |inline$$Roles_has_role_$def$0$tmp#$3@2|)) (and (=> (= (ControlFlow 0 79315) 79700) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 79315) 79676) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 79313) 79315)) inline$$Roles_has_role_$def$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 79323) 79315) inline$$Roles_has_role_$def$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct  (=> (and (= |inline$$Roles_has_role_$def$0$tmp#$3@2| |inline$$Roles_has_role_$def$0$tmp#$3@1|) (= $abort_flag@2@@8 $abort_flag@1@@8)) (and (=> (= (ControlFlow 0 79582) 79323) inline$$Roles_has_role_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 79582) 79313) inline$$Roles_has_role_$def$0$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 79580) 79582)) inline$$Roles_has_role_$def$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 79590) 79582) inline$$Roles_has_role_$def$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@8 inline$$Roles_has_parent_VASP_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 79574) 79590) inline$$Roles_has_role_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 79574) 79580) inline$$Roles_has_role_$def$0$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@8  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@8)) $Roles_RoleId_role_id)) (= (ControlFlow 0 79558) 79574)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct  (=> (and (not $abort_flag@1@@8) (= (ControlFlow 0 79564) 79558)) inline$$GetFieldFromValue$0$anon0_correct@@8)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@8  (=> (and (= $abort_flag@1@@8 true) (= inline$$GetGlobal$0$dst@2@@8 inline$$GetGlobal$0$dst@0@@8)) (and (=> (= (ControlFlow 0 79504) 79594) inline$$Roles_has_role_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 79504) 79564) inline$$Roles_has_role_$def$0$anon26_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@8  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@8)) (= (ControlFlow 0 79502) 79504)) inline$$GetGlobal$0$anon3_Then$1_correct@@8)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@8  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@8) (= inline$$GetGlobal$0$dst@1@@8 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@28)))) (and (= $abort_flag@1@@8 $abort_flag@0@@8) (= inline$$GetGlobal$0$dst@2@@8 inline$$GetGlobal$0$dst@1@@8))) (and (=> (= (ControlFlow 0 79450) 79594) inline$$Roles_has_role_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 79450) 79564) inline$$Roles_has_role_$def$0$anon26_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct@@8  (=> (= inline$$GetGlobal$0$a@1@@8 (|a#$Address| call3formal@$ret0@0@@28)) (and (=> (= (ControlFlow 0 79432) 79502) inline$$GetGlobal$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 79432) 79450) inline$$GetGlobal$0$anon3_Else_correct@@8)))))
(let ((inline$$GetGlobal$0$Entry_correct@@8  (and (=> (= (ControlFlow 0 79426) (- 0 130425)) true) (=> (= (ControlFlow 0 79426) 79432) inline$$GetGlobal$0$anon0_correct@@8))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1) (= (ControlFlow 0 79510) 79426)) inline$$GetGlobal$0$Entry_correct@@8)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct  (=> (and (= |inline$$Roles_has_role_$def$0$tmp#$3@2| inline$$Roles_has_role_$def$0$$t9@1) (= $abort_flag@2@@8 $abort_flag@0@@8)) (and (=> (= (ControlFlow 0 79303) 79323) inline$$Roles_has_role_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 79303) 79313) inline$$Roles_has_role_$def$0$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 79301) 79303)) inline$$Roles_has_role_$def$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 79331) 79303) inline$$Roles_has_role_$def$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1)) (= inline$$Roles_has_role_$def$0$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 79293) 79331) inline$$Roles_has_role_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 79293) 79301) inline$$Roles_has_role_$def$0$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct  (=> (and (not $abort_flag@0@@8) (= inline$$Roles_has_role_$def$0$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@28))))) (and (=> (= (ControlFlow 0 79249) 79510) inline$$Roles_has_role_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 79249) 79293) inline$$Roles_has_role_$def$0$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@8) (=> $abort_flag@0@@8 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@28 account@@6)))) ((_ is $Address) call3formal@$ret0@0@@28))) (and (=> (= (ControlFlow 0 79235) 79620) inline$$Roles_has_role_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 79235) 79249) inline$$Roles_has_role_$def$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 79165) 79235)) inline$$Roles_has_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 79644) 79235) inline$$Roles_has_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 79157) 79644) inline$$Roles_has_role_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 79157) 79165) inline$$Roles_has_role_$def$0$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 79652) 79644) inline$$Roles_has_role_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 79652) 79165) inline$$Roles_has_role_$def$0$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 79151) 79652) inline$$Roles_has_role_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 79151) 79157) inline$$Roles_has_role_$def$0$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$0$anon0_correct  (=> ((_ is $Address) account@@6) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_parent_VASP_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 79658) 79151)) inline$$Roles_has_role_$def$0$anon0_correct))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$0$$t2@1 ($Integer 5)) (= (ControlFlow 0 79666) 79658)) inline$$Roles_has_role$0$anon0_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 78678) 79666)) inline$$Roles_has_parent_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 79708) 79666) inline$$Roles_has_parent_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 78672) 79708) inline$$Roles_has_parent_VASP_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 78672) 78678) inline$$Roles_has_parent_VASP_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$direct_intra$0$anon0_correct  (=> (and ((_ is $Address) account@@6) (= (ControlFlow 0 79714) 78672)) inline$$Roles_has_parent_VASP_role_$def$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 78444) 79714)) inline$$Roles_has_parent_VASP_role_$direct_intra$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 82414) 79714) inline$$Roles_has_parent_VASP_role_$direct_intra$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 78438) 82414) inline$$Roles_can_hold_balance_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 78438) 78444) inline$$Roles_can_hold_balance_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@8  (=> (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (= (ControlFlow 0 82420) 78438)) inline$$Roles_can_hold_balance_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@8  (=> (and ((_ is $Address) account@@6) (= (ControlFlow 0 78115) 82420)) anon0$1_correct@@8)))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 128664) 78115) anon0_correct@@8)))
PreconditionGeneratedEntry_correct@@8))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@9 () Bool)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@9 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst () T@$Value)
(declare-fun inline$$Roles_get_role_id_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun inline$$GetGlobal$0$a@1@@9 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@9 () T@$Value)
(declare-fun a () T@$Value)
(declare-fun inline$$Roles_get_role_id_$def_verify$0$$t4@1 () T@$Value)
(declare-fun $abort_code@2@@8 () Int)
(declare-fun call3formal@$ret0@0@@29 () T@$Value)
(declare-fun inline$$Roles_get_role_id_$def_verify$0$$t5@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 132600) (let ((anon0$2_correct@@9  (and (=> (= (ControlFlow 0 83786) (- 0 133840)) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@129 T@$Value) )  (=> ((_ is $Address) addr@@129) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@129)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@129)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@129)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@129)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@130 T@$Value) )  (=> ((_ is $Address) addr@@130) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@130)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@130)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@130)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@130)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 83786) (- 0 133940)) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@131 T@$Value) )  (=> ((_ is $Address) addr@@131) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@131)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@131)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@131)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@131)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@132 T@$Value) )  (=> ((_ is $Address) addr@@132) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@132)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@132)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@132)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@132)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 83786) (- 0 134040)) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@133 T@$Value) )  (=> ((_ is $Address) addr@@133) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@133)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@133)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@133)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@133)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@134 T@$Value) )  (=> ((_ is $Address) addr@@134) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@134)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@134)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@134)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@134)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 83786) (- 0 134140)) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@135 T@$Value) )  (=> ((_ is $Address) addr@@135) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@135)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@135)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@135)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@135)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@136 T@$Value) )  (=> ((_ is $Address) addr@@136) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@136)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@136)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@136)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@136)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 83786) (- 0 134240)) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@137 T@$Value) )  (=> ((_ is $Address) addr@@137) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@137)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@137)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@137)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@137)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@138 T@$Value) )  (=> ((_ is $Address) addr@@138) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@138)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@138)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@138)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@138)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 83786) (- 0 134340)) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@139 T@$Value) )  (=> ((_ is $Address) addr@@139) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@139)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@139)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@139)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@139)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@140 T@$Value) )  (=> ((_ is $Address) addr@@140) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@140)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@140)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@140)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@140)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 83786) (- 0 134440)) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@141 T@$Value) )  (=> ((_ is $Address) addr@@141) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@141)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@141)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@141)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@141)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon16_correct  (=> (and (= $abort_flag@2@@9 $abort_flag@1@@9) (= (ControlFlow 0 83722) 83786)) anon0$2_correct@@9)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 83720) 83722)) inline$$Roles_get_role_id_$def_verify$0$anon16_correct)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 83730) 83722) inline$$Roles_get_role_id_$def_verify$0$anon16_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@9  (=> (= inline$$GetFieldFromValue$0$dst@1@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst)) $Roles_RoleId_role_id)) (and (=> (= (ControlFlow 0 83704) 83730) inline$$Roles_get_role_id_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 83704) 83720) inline$$Roles_get_role_id_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@1@@9) (= (ControlFlow 0 83710) 83704)) inline$$GetFieldFromValue$0$anon0_correct@@9)))
(let ((inline$$Roles_get_role_id_$def_verify$0$Abort_correct  (=> (= inline$$Roles_get_role_id_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@2@@9 true) (= (ControlFlow 0 83469) 83786)) anon0$2_correct@@9))))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 83760) 83469)) inline$$Roles_get_role_id_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 83770) 83469) inline$$Roles_get_role_id_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 83754) 83770) inline$$Roles_get_role_id_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 83754) 83760) inline$$Roles_get_role_id_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 83740) 83469)) inline$$Roles_get_role_id_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 83750) 83469) inline$$Roles_get_role_id_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@9 (and (=> (= (ControlFlow 0 83734) 83750) inline$$Roles_get_role_id_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 83734) 83740) inline$$Roles_get_role_id_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@9  (=> (= $abort_flag@1@@9 true) (and (=> (= (ControlFlow 0 83650) 83734) inline$$Roles_get_role_id_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 83650) 83710) inline$$Roles_get_role_id_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@9  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@9)) (= (ControlFlow 0 83648) 83650)) inline$$GetGlobal$0$anon3_Then$1_correct@@9)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@9  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@9) (=> (and (= inline$$GetGlobal$0$dst@1@@9 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| a))) (= $abort_flag@1@@9 $abort_flag@0@@9)) (and (=> (= (ControlFlow 0 83596) 83734) inline$$Roles_get_role_id_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 83596) 83710) inline$$Roles_get_role_id_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@9  (=> (= inline$$GetGlobal$0$a@1@@9 (|a#$Address| a)) (and (=> (= (ControlFlow 0 83578) 83648) inline$$GetGlobal$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 83578) 83596) inline$$GetGlobal$0$anon3_Else_correct@@9)))))
(let ((inline$$GetGlobal$0$Entry_correct@@9  (and (=> (= (ControlFlow 0 83572) (- 0 133691)) true) (=> (= (ControlFlow 0 83572) 83578) inline$$GetGlobal$0$anon0_correct@@9))))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_get_role_id_$def_verify$0$$t4@1) (= (ControlFlow 0 83656) 83572)) inline$$GetGlobal$0$Entry_correct@@9)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 83461) 83469)) inline$$Roles_get_role_id_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 83477) 83469) inline$$Roles_get_role_id_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_get_role_id_$def_verify$0$$t4@1)) (= $abort_code@2@@8 (|i#$Integer| call3formal@$ret0@0@@29))) (and (=> (= (ControlFlow 0 83455) 83477) inline$$Roles_get_role_id_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 83455) 83461) inline$$Roles_get_role_id_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0@@9) (and (=> (= (ControlFlow 0 83443) 83656) inline$$Roles_get_role_id_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 83443) 83455) inline$$Roles_get_role_id_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon2$1_correct  (=> (= inline$$Roles_get_role_id_$def_verify$0$$t4@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| a)))) (=> (and (and (and (= inline$$Roles_get_role_id_$def_verify$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@9)) (and (=> $abort_flag@0@@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@29 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@29) (>= (|i#$Integer| call3formal@$ret0@0@@29) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@29) $MAX_U64))) (and (=> (= (ControlFlow 0 83437) 83754) inline$$Roles_get_role_id_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 83437) 83443) inline$$Roles_get_role_id_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 83389) 83437)) inline$$Roles_get_role_id_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 83778) 83437) inline$$Roles_get_role_id_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_get_role_id_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 83383) 83778) inline$$Roles_get_role_id_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 83383) 83389) inline$$Roles_get_role_id_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@9  (=> (and (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@18 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@9))
)) (= (ControlFlow 0 83784) 83383)) inline$$Roles_get_role_id_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@9  (=> (and ((_ is $Address) a) (= (ControlFlow 0 83055) 83784)) anon0$1_correct@@9)))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (= (ControlFlow 0 132600) 83055) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@9)))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_flag@3@@9 () Bool)
(declare-fun dr_account () T@$Value)
(declare-fun $abort_code@5@@8 () Int)
(declare-fun $Roles_RoleId_$memory@2 () T@$Memory)
(declare-fun $abort_code@4@@8 () Int)
(declare-fun $Roles_RoleId_$memory@1 () T@$Memory)
(declare-fun $abort_code@1@@8 () Int)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun $abort_code@2@@9 () Int)
(declare-fun $abort_flag@1@@10 () Bool)
(declare-fun $Roles_RoleId_$memory@0 () T@$Memory)
(declare-fun $abort_code@3@@8 () Int)
(declare-fun $abort_flag@2@@10 () Bool)
(declare-fun inline$$Roles_grant_diem_root_role_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Roles_grant_diem_root_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun $Roles_RoleId_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 134545) (let ((anon0$2_correct@@10  (and (=> (= (ControlFlow 0 84412) (- 0 136605)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3@@9) (and (=> (= (ControlFlow 0 84412) (- 0 136620)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3@@9) (and (=> (= (ControlFlow 0 84412) (- 0 136637)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $abort_flag@3@@9)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $abort_flag@3@@9) (and (=> (= (ControlFlow 0 84412) (- 0 136651)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3@@9) (and (=> (= (ControlFlow 0 84412) (- 0 136666)) (=> $abort_flag@3@@9 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (=> (=> $abort_flag@3@@9 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (=> (= (ControlFlow 0 84412) (- 0 136724)) (=> $abort_flag@3@@9 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5@@8 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@5@@8 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) (= $abort_code@5@@8 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5@@8 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@3@@9 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5@@8 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@5@@8 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) (= $abort_code@5@@8 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5@@8 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 84412) (- 0 136826)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| dr_account)))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| dr_account))))) (and (=> (= (ControlFlow 0 84412) (- 0 136842)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (and (=> (= (ControlFlow 0 84412) (- 0 136870)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@142 T@$Value) )  (=> ((_ is $Address) addr@@142) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@142)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@142)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@142)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@142)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@143 T@$Value) )  (=> ((_ is $Address) addr@@143) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@143)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@143)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@143)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@143)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 84412) (- 0 136966)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@144 T@$Value) )  (=> ((_ is $Address) addr@@144) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@144)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@144)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@144)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@144)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@145 T@$Value) )  (=> ((_ is $Address) addr@@145) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@145)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@145)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@145)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@145)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 84412) (- 0 137062)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@146 T@$Value) )  (=> ((_ is $Address) addr@@146) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@146)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@146)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@146)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@146)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@147 T@$Value) )  (=> ((_ is $Address) addr@@147) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@147)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@147)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@147)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@147)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 84412) (- 0 137158)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@148 T@$Value) )  (=> ((_ is $Address) addr@@148) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@148)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@148)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@148)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@148)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@149 T@$Value) )  (=> ((_ is $Address) addr@@149) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@149)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@149)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@149)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@149)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 84412) (- 0 137254)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@150 T@$Value) )  (=> ((_ is $Address) addr@@150) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@150)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@150)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@150)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@150)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@151 T@$Value) )  (=> ((_ is $Address) addr@@151) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@151)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@151)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@151)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@151)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 84412) (- 0 137350)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@152 T@$Value) )  (=> ((_ is $Address) addr@@152) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@152)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr@@152)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@152)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@152)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@3@@9 true) (= $abort_code@5@@8 $abort_code@4@@8)) (and (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory@1) (= (ControlFlow 0 84350) 84412))) anon0$2_correct@@10)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon5_correct  (=> (= $Roles_RoleId_$memory@1 $Roles_RoleId_$memory) (=> (and (= $abort_code@4@@8 $abort_code@1@@8) (= (ControlFlow 0 84390) 84350)) inline$$Roles_grant_diem_root_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 84388) 84390)) inline$$Roles_grant_diem_root_role_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 84398) 84390) inline$$Roles_grant_diem_root_role_$def_verify$0$anon5_correct)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon16_Then_correct  (=> $abort_flag@0@@10 (and (=> (= (ControlFlow 0 84382) 84398) inline$$Roles_grant_diem_root_role_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 84382) 84388) inline$$Roles_grant_diem_root_role_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon9_correct  (=> (= $Roles_RoleId_$memory@1 $Roles_RoleId_$memory) (=> (and (= $abort_code@4@@8 $abort_code@2@@9) (= (ControlFlow 0 84370) 84350)) inline$$Roles_grant_diem_root_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 84368) 84370)) inline$$Roles_grant_diem_root_role_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 84378) 84370) inline$$Roles_grant_diem_root_role_$def_verify$0$anon9_correct)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon18_Then_correct  (=> $abort_flag@1@@10 (and (=> (= (ControlFlow 0 84362) 84378) inline$$Roles_grant_diem_root_role_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 84362) 84368) inline$$Roles_grant_diem_root_role_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon13_correct  (=> (= $Roles_RoleId_$memory@1 $Roles_RoleId_$memory@0) (=> (and (= $abort_code@4@@8 $abort_code@3@@8) (= (ControlFlow 0 84346) 84350)) inline$$Roles_grant_diem_root_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 84344) 84346)) inline$$Roles_grant_diem_root_role_$def_verify$0$anon13_correct)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 84358) 84346) inline$$Roles_grant_diem_root_role_$def_verify$0$anon13_correct)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon20_Then_correct  (=> $abort_flag@2@@10 (and (=> (= (ControlFlow 0 84338) 84358) inline$$Roles_grant_diem_root_role_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 84338) 84344) inline$$Roles_grant_diem_root_role_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon20_Else_correct  (=> (not $abort_flag@2@@10) (=> (and (and (= $abort_flag@3@@9 $abort_flag@2@@10) (= $abort_code@5@@8 $abort_code@3@@8)) (and (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory@0) (= (ControlFlow 0 84334) 84412))) anon0$2_correct@@10))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@1@@10) (= inline$$Roles_grant_diem_root_role_$def_verify$0$$t2@1 ($Integer 0))) (and (=> (= (ControlFlow 0 84328) (- 0 136283)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_grant_diem_root_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| dr_account))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_grant_diem_root_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 84328) (- 0 136293)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_diem_root_role_$def_verify$0$$t2@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified dr_account ($Address 173345816)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_diem_root_role_$def_verify$0$$t2@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified dr_account ($Address 173345816))))))) (and (=> (= (ControlFlow 0 84328) (- 0 136321)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_diem_root_role_$def_verify$0$$t2@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified dr_account ($Address 186537453)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_diem_root_role_$def_verify$0$$t2@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified dr_account ($Address 186537453))))))) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $abort_flag@2@@10) (=> (and (=> $abort_flag@2@@10 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))) (=> $abort_flag@2@@10 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) (= $abort_code@3@@8 (|i#$Integer| ($Integer 6)))))) (=> (and (and (=> (not $abort_flag@2@@10) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))) (=> (not $abort_flag@2@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) inline$$Roles_grant_diem_root_role_$def_verify$0$$t2@1))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) (= (|domain#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))) (and (=> (= (ControlFlow 0 84328) 84338) inline$$Roles_grant_diem_root_role_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 84328) 84334) inline$$Roles_grant_diem_root_role_$def_verify$0$anon20_Else_correct))))))))))))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon16_Else_correct  (=> (and (and (not $abort_flag@0@@10) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1@@10)) (and (=> $abort_flag@1@@10 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@1@@10 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2@@9 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 84318) 84362) inline$$Roles_grant_diem_root_role_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 84318) 84328) inline$$Roles_grant_diem_root_role_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0@@10) (=> (and (=> $abort_flag@0@@10 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0@@10 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1@@8 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 84312) 84382) inline$$Roles_grant_diem_root_role_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 84312) 84318) inline$$Roles_grant_diem_root_role_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon2_correct  (=> (and (= inline$$Roles_grant_diem_root_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| dr_account) true)) (= (ControlFlow 0 84310) 84312)) inline$$Roles_grant_diem_root_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 84260) 84310)) inline$$Roles_grant_diem_root_role_$def_verify$0$anon2_correct)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 84406) 84310) inline$$Roles_grant_diem_root_role_$def_verify$0$anon2_correct)))
(let ((inline$$Roles_grant_diem_root_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 84254) 84406) inline$$Roles_grant_diem_root_role_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 84254) 84260) inline$$Roles_grant_diem_root_role_$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct@@10  (=> (and (and (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@19 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@10))
)) (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@11))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 84410) 84254))) inline$$Roles_grant_diem_root_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@10  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 83916) 84410)) anon0$1_correct@@10)))
(let ((PreconditionGeneratedEntry_correct@@10  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain $EmptyTypeValueArray (|a#$Address| dr_account)) (= (ControlFlow 0 134545) 83916)) anon0_correct@@10)))
PreconditionGeneratedEntry_correct@@10))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@7 () T@$Value)
(declare-fun $abort_flag@3@@10 () Bool)
(declare-fun $abort_code@6@@8 () Int)
(declare-fun $Roles_RoleId_$memory@1@@0 () T@$Memory)
(declare-fun role_id () T@$Value)
(declare-fun $abort_flag@2@@11 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@4@@9 () Int)
(declare-fun $abort_code@5@@9 () Int)
(declare-fun $Roles_RoleId_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@1@@9 () Int)
(declare-fun $abort_flag@0@@11 () Bool)
(declare-fun $abort_code@2@@10 () Int)
(declare-fun $abort_flag@1@@11 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$Roles_RoleId_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Roles_grant_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@3@@9 () Int)
(declare-fun call3formal@$ret0@0@@30 () T@$Value)
(declare-fun inline$$Roles_grant_role_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Roles_grant_role_$def_verify$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@31 () T@$Value)
(declare-fun $Roles_RoleId_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 137452) (let ((anon0$2_correct@@11  (and (=> (= (ControlFlow 0 87511) (- 0 139383)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@7)))) $abort_flag@3@@10)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@7)))) $abort_flag@3@@10) (and (=> (= (ControlFlow 0 87511) (- 0 139397)) (=> $abort_flag@3@@10 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@7)))))) (=> (=> $abort_flag@3@@10 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@7))))) (and (=> (= (ControlFlow 0 87511) (- 0 139411)) (=> $abort_flag@3@@10 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@7)))) (= $abort_code@6@@8 (|i#$Integer| ($Integer 6)))))) (=> (=> $abort_flag@3@@10 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@7)))) (= $abort_code@6@@8 (|i#$Integer| ($Integer 6))))) (and (=> (= (ControlFlow 0 87511) (- 0 139436)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| account@@7)))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| account@@7))))) (=> (= (ControlFlow 0 87511) (- 0 139452)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| account@@7)))) $Roles_RoleId_role_id) role_id)))))))))))))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon29_Else_correct  (=> (not $abort_flag@2@@11) (and (=> (= (ControlFlow 0 87429) (- 0 138851)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr)))) $Roles_RoleId_role_id) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr)))) $Roles_RoleId_role_id))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@0)))) $Roles_RoleId_role_id) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@0)))) $Roles_RoleId_role_id)))))))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 138922)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@1)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_role_$def_verify$0$addr@@1 ($Address 173345816)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@2)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_role_$def_verify$0$addr@@2 ($Address 173345816))))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 138958)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0)))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 138977)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@3)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_role_$def_verify$0$addr@@3 ($Address 186537453)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@4)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_role_$def_verify$0$addr@@4 ($Address 186537453))))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 139013)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1))))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1)))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 139032)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@5 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@5)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@5)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@5)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@5)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@6 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@6)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@6)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@6)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@6)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 139071)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@7 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@7)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@7)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@7)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@7)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@8 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@8)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@8)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@8)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@8)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 139110)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@9 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@9)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@9)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@9)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@9)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@10 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@10)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@10)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@10)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@10)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 139149)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@11 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@11)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@11)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@11)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@11)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@12 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@12)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@12)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@12)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@12)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 139188)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@13 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@13)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@13)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@13)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@13)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@14 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@14)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@14)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@14)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@14)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 139221)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@15 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@15)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@15)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@15)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@15)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@16 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@16)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@16)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@16)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@16)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (and (=> (= (ControlFlow 0 87429) (- 0 139254)) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@17 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@17)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@17)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@17)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@17)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@18 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@18)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@18)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@18)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@18)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (=> (and (and (= $abort_code@6@@8 $abort_code@4@@9) (= $abort_flag@3@@10 $abort_flag@2@@11)) (and (= $Roles_RoleId_$memory@1@@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 87429) 87511))) anon0$2_correct@@11))))))))))))))))))))))))))))
(let ((inline$$Roles_grant_role_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@6@@8 $abort_code@5@@9) (= $abort_flag@3@@10 true)) (and (= $Roles_RoleId_$memory@1@@0 $Roles_RoleId_$memory@0@@0) (= (ControlFlow 0 86072) 87511))) anon0$2_correct@@11)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon7_correct  (=> (= $abort_code@5@@9 $abort_code@1@@9) (=> (and (= $Roles_RoleId_$memory@0@@0 $Roles_RoleId_$memory) (= (ControlFlow 0 87481) 86072)) inline$$Roles_grant_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 87479) 87481)) inline$$Roles_grant_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 87489) 87481) inline$$Roles_grant_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0@@11 (and (=> (= (ControlFlow 0 87473) 87489) inline$$Roles_grant_role_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 87473) 87479) inline$$Roles_grant_role_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon11_correct  (=> (= $abort_code@5@@9 $abort_code@2@@10) (=> (and (= $Roles_RoleId_$memory@0@@0 $Roles_RoleId_$memory) (= (ControlFlow 0 87461) 86072)) inline$$Roles_grant_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 87459) 87461)) inline$$Roles_grant_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 87469) 87461) inline$$Roles_grant_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@11 (and (=> (= (ControlFlow 0 87453) 87469) inline$$Roles_grant_role_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 87453) 87459) inline$$Roles_grant_role_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon19_correct  (=> (= $abort_code@5@@9 $abort_code@4@@9) (=> (and (= $Roles_RoleId_$memory@0@@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 87441) 86072)) inline$$Roles_grant_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 87439) 87441)) inline$$Roles_grant_role_$def_verify$0$anon19_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 87449) 87441) inline$$Roles_grant_role_$def_verify$0$anon19_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon29_Then_correct  (=> $abort_flag@2@@11 (and (=> (= (ControlFlow 0 87433) 87449) inline$$Roles_grant_role_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 87433) 87439) inline$$Roles_grant_role_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@11 true) (=> (and (= $abort_code@4@@9 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 86949) 87433) inline$$Roles_grant_role_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 86949) 87429) inline$$Roles_grant_role_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 86947) 86949)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$Roles_RoleId_pack$0$$struct@1))) (= $abort_flag@2@@11 $abort_flag@1@@11)) (and (= $abort_code@4@@9 $abort_code@2@@10) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 86897) 87433) inline$$Roles_grant_role_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 86897) 87429) inline$$Roles_grant_role_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account@@7)) (and (=> (= (ControlFlow 0 86955) 86947) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 86955) 86897) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 86743) (- 0 138736)) true) (=> (= (ControlFlow 0 86743) 86955) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon27_Then$1_correct  (=> (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@19 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@19)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_role_$def_verify$0$addr@@19 ($Address 173345816))))))))))) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@20 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@20)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@20)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_role_$def_verify$0$addr@@20 ($Address 186537453)))))))))))) (=> (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1)))))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@21 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@21)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@21)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@21)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@21)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@22 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@22)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@22)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@22)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@22)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@22)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@22)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@22)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@22)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@23 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@23)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@23)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@23)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@23)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@24 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@24)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@24)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@24)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@24)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@25 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@25) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@25)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@25)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@25)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@25)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@26 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@26)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@26)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@26)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@26)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@26)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@26)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@26)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@26)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Roles_grant_role_$def_verify$0$addr@@27 T@$Value) )  (=> ((_ is $Address) inline$$Roles_grant_role_$def_verify$0$addr@@27) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@27)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@27)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@27)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@27)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@27)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@27)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@27)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Roles_grant_role_$def_verify$0$addr@@27)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (and (=> (= (ControlFlow 0 86963) (- 0 138701)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_grant_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| account@@7))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_grant_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| account@@7)) (=> (= (ControlFlow 0 86963) 86743) inline$$Signer_borrow_address$0$Entry_correct))))))))
(let ((inline$$Roles_RoleId_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 86232) 86963)) inline$$Roles_grant_role_$def_verify$0$anon27_Then$1_correct)))
(let ((inline$$Roles_RoleId_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 86238) 86963) inline$$Roles_grant_role_$def_verify$0$anon27_Then$1_correct)))
(let ((inline$$Roles_RoleId_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 86226) 86238) inline$$Roles_RoleId_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 86226) 86232) inline$$Roles_RoleId_pack$0$anon4_Else_correct)))))
(let ((inline$$Roles_RoleId_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 86218) 86963)) inline$$Roles_grant_role_$def_verify$0$anon27_Then$1_correct)))
(let ((inline$$Roles_RoleId_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) role_id) (>= (|i#$Integer| role_id) 0)) (<= (|i#$Integer| role_id) $MAX_U64)) (= inline$$Roles_RoleId_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 role_id) 1)))) (and (=> (= (ControlFlow 0 86210) 86226) inline$$Roles_RoleId_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 86210) 86218) inline$$Roles_RoleId_pack$0$anon3_Else_correct)))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 86244) 86210)) inline$$Roles_RoleId_pack$0$anon0_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon16_correct  (=> (= $abort_code@5@@9 $abort_code@3@@9) (=> (and (= $Roles_RoleId_$memory@0@@0 $Roles_RoleId_$memory) (= (ControlFlow 0 86068) 86072)) inline$$Roles_grant_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 86066) 86068)) inline$$Roles_grant_role_$def_verify$0$anon16_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 86080) 86068) inline$$Roles_grant_role_$def_verify$0$anon16_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon27_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@3@@9 (|i#$Integer| call3formal@$ret0@0@@30))) (and (=> (= (ControlFlow 0 86060) 86080) inline$$Roles_grant_role_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 86060) 86066) inline$$Roles_grant_role_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon25_Else_correct  (=> (not $abort_flag@1@@11) (and (=> (= (ControlFlow 0 86048) 86244) inline$$Roles_grant_role_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 86048) 86060) inline$$Roles_grant_role_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon23_Else$1_correct  (=> (and (and (and (= inline$$Roles_grant_role_$def_verify$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@11)) (and (=> $abort_flag@1@@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@30 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@30) (>= (|i#$Integer| call3formal@$ret0@0@@30) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@30) $MAX_U64))) (and (=> (= (ControlFlow 0 86042) 87453) inline$$Roles_grant_role_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 86042) 86048) inline$$Roles_grant_role_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Roles_grant_role_$def_verify$0$$t7@1)))) (= (ControlFlow 0 86030) 86042)) inline$$Roles_grant_role_$def_verify$0$anon23_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 86020) (- 0 138140)) true) (=> (= (ControlFlow 0 86020) 86030) inline$$Not$0$anon0_correct))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon23_Else_correct  (=> (not $abort_flag@0@@11) (=> (and (= inline$$Roles_grant_role_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@31)))) (= (ControlFlow 0 86036) 86020)) inline$$Not$0$Entry_correct))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@11) (=> $abort_flag@0@@11 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@31 account@@7)))) ((_ is $Address) call3formal@$ret0@0@@31))) (and (=> (= (ControlFlow 0 85974) 87473) inline$$Roles_grant_role_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 85974) 86036) inline$$Roles_grant_role_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon4_correct  (=> (and (= inline$$Roles_grant_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| account@@7) true)) (= (ControlFlow 0 85938) 85974)) inline$$Roles_grant_role_$def_verify$0$anon4$2_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 85888) 85938)) inline$$Roles_grant_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 87497) 85938) inline$$Roles_grant_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_grant_role_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 85880) 87497) inline$$Roles_grant_role_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 85880) 85888) inline$$Roles_grant_role_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 87505) 87497) inline$$Roles_grant_role_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 87505) 85888) inline$$Roles_grant_role_$def_verify$0$anon22_Else_correct))))
(let ((inline$$Roles_grant_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 85874) 87505) inline$$Roles_grant_role_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 85874) 85880) inline$$Roles_grant_role_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@11  (=> (and (and (forall (($inv_addr@@12 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12)) (let ((va@@21 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified role_id ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@7 ($Address 173345816)))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified role_id ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified account@@7 ($Address 186537453))))))) (= (ControlFlow 0 87509) 85874))) inline$$Roles_grant_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@11  (=> ((_ is $Address) account@@7) (=> (and (and (and ((_ is $Integer) role_id) (>= (|i#$Integer| role_id) 0)) (<= (|i#$Integer| role_id) $MAX_U64)) (= (ControlFlow 0 84511) 87509)) anon0$1_correct@@11))))
(let ((PreconditionGeneratedEntry_correct@@11  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain@@0 $EmptyTypeValueArray (|a#$Address| account@@7)) (= (ControlFlow 0 137452) 84511)) anon0_correct@@11)))
PreconditionGeneratedEntry_correct@@11)))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@9 () Bool)
(declare-fun treasury_compliance_account () T@$Value)
(declare-fun dr_account@@0 () T@$Value)
(declare-fun $abort_code@6@@9 () Int)
(declare-fun $Roles_RoleId_$memory@2@@0 () T@$Memory)
(declare-fun $abort_code@5@@10 () Int)
(declare-fun $Roles_RoleId_$memory@1@@1 () T@$Memory)
(declare-fun $abort_code@1@@10 () Int)
(declare-fun $abort_flag@0@@12 () Bool)
(declare-fun $abort_code@2@@11 () Int)
(declare-fun $abort_flag@1@@12 () Bool)
(declare-fun $abort_code@3@@10 () Int)
(declare-fun $abort_flag@2@@12 () Bool)
(declare-fun $Roles_RoleId_$memory@0@@1 () T@$Memory)
(declare-fun $abort_code@4@@10 () Int)
(declare-fun $abort_flag@3@@11 () Bool)
(declare-fun inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $Roles_RoleId_$CallerDomain@@1 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 139484) (let ((anon0$2_correct@@12  (and (=> (= (ControlFlow 0 88506) (- 0 143854)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 88506) (- 0 143869)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified treasury_compliance_account ($Address 186537453))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified treasury_compliance_account ($Address 186537453))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 88506) (- 0 143886)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 88506) (- 0 143906)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 88506) (- 0 143934)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 88506) (- 0 143951)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 88506) (- 0 143965)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 88506) (- 0 143980)) (=> $abort_flag@4@@9 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified treasury_compliance_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (=> (=> $abort_flag@4@@9 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified treasury_compliance_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (=> (= (ControlFlow 0 88506) (- 0 144100)) (=> $abort_flag@4@@9 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified treasury_compliance_account ($Address 186537453))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@4@@9 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified treasury_compliance_account ($Address 186537453))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6@@9 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 88506) (- 0 144297)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account))))) (and (=> (= (ControlFlow 0 88506) (- 0 144313)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (and (=> (= (ControlFlow 0 88506) (- 0 144341)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@153 T@$Value) )  (=> ((_ is $Address) addr@@153) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@153)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@153)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@153)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@153)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@154 T@$Value) )  (=> ((_ is $Address) addr@@154) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@154)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@154)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@154)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@154)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 88506) (- 0 144437)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@155 T@$Value) )  (=> ((_ is $Address) addr@@155) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@155)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@155)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@155)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@155)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@156 T@$Value) )  (=> ((_ is $Address) addr@@156) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@156)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@156)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@156)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@156)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 88506) (- 0 144533)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@157 T@$Value) )  (=> ((_ is $Address) addr@@157) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@157)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@157)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@157)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@157)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@158 T@$Value) )  (=> ((_ is $Address) addr@@158) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@158)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@158)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@158)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@158)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 88506) (- 0 144629)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@159 T@$Value) )  (=> ((_ is $Address) addr@@159) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@159)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@159)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@159)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@159)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@160 T@$Value) )  (=> ((_ is $Address) addr@@160) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@160)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@160)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@160)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@160)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 88506) (- 0 144725)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@161 T@$Value) )  (=> ((_ is $Address) addr@@161) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@161)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@161)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@161)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@161)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@162 T@$Value) )  (=> ((_ is $Address) addr@@162) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@162)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@162)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@162)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@162)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 88506) (- 0 144821)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@163 T@$Value) )  (=> ((_ is $Address) addr@@163) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@163)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@0) $EmptyTypeValueArray (|a#$Address| addr@@163)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@163)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@163)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@4@@9 true) (= $abort_code@6@@9 $abort_code@5@@10)) (and (= $Roles_RoleId_$memory@2@@0 $Roles_RoleId_$memory@1@@1) (= (ControlFlow 0 88416) 88506))) anon0$2_correct@@12)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon7_correct  (=> (= $Roles_RoleId_$memory@1@@1 $Roles_RoleId_$memory) (=> (and (= $abort_code@5@@10 $abort_code@1@@10) (= (ControlFlow 0 88476) 88416)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 88474) 88476)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 88484) 88476) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0@@12 (and (=> (= (ControlFlow 0 88468) 88484) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 88468) 88474) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon11_correct  (=> (= $Roles_RoleId_$memory@1@@1 $Roles_RoleId_$memory) (=> (and (= $abort_code@5@@10 $abort_code@2@@11) (= (ControlFlow 0 88456) 88416)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 88454) 88456)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 88464) 88456) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@12 (and (=> (= (ControlFlow 0 88448) 88464) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 88448) 88454) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon15_correct  (=> (= $Roles_RoleId_$memory@1@@1 $Roles_RoleId_$memory) (=> (and (= $abort_code@5@@10 $abort_code@3@@10) (= (ControlFlow 0 88436) 88416)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 88434) 88436)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon15_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 88444) 88436) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon15_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon27_Then_correct  (=> $abort_flag@2@@12 (and (=> (= (ControlFlow 0 88428) 88444) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 88428) 88434) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon19_correct  (=> (= $Roles_RoleId_$memory@1@@1 $Roles_RoleId_$memory@0@@1) (=> (and (= $abort_code@5@@10 $abort_code@4@@10) (= (ControlFlow 0 88412) 88416)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 88410) 88412)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon19_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 88424) 88412) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon19_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon29_Then_correct  (=> $abort_flag@3@@11 (and (=> (= (ControlFlow 0 88404) 88424) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 88404) 88410) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon29_Else_correct  (=> (not $abort_flag@3@@11) (=> (and (and (= $abort_flag@4@@9 $abort_flag@3@@11) (= $abort_code@6@@9 $abort_code@4@@10)) (and (= $Roles_RoleId_$memory@2@@0 $Roles_RoleId_$memory@0@@1) (= (ControlFlow 0 88400) 88506))) anon0$2_correct@@12))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@2@@12) (= inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$t4@1 ($Integer 1))) (and (=> (= (ControlFlow 0 88394) (- 0 143514)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| treasury_compliance_account))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)) (and (=> (= (ControlFlow 0 88394) (- 0 143524)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified treasury_compliance_account ($Address 173345816)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified treasury_compliance_account ($Address 173345816))))))) (and (=> (= (ControlFlow 0 88394) (- 0 143552)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified treasury_compliance_account ($Address 186537453)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified treasury_compliance_account ($Address 186537453))))))) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) $abort_flag@3@@11) (=> (and (=> $abort_flag@3@@11 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account))))) (=> $abort_flag@3@@11 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) (= $abort_code@4@@10 (|i#$Integer| ($Integer 6)))))) (=> (and (and (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account))))) (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) $Roles_RoleId_role_id) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$t4@1))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@0@@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))) (= (|domain#$Memory| $Roles_RoleId_$memory@0@@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)))))) (and (=> (= (ControlFlow 0 88394) 88404) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 88394) 88400) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon29_Else_correct))))))))))))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1@@12) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@2@@12)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@2@@12) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@12)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@2@@12) (=> $abort_flag@2@@12 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))))))) (=> (and (and (and (=> $abort_flag@2@@12 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@3@@10 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@3@@10 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@3@@10 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@3@@10 (|i#$Integer| ($Integer 2)))))) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@164 T@$Value) )  (=> ((_ is $Address) addr@@164) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@164)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@164)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@164)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@164)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (and (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@165 T@$Value) )  (=> ((_ is $Address) addr@@165) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@165)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@165)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@165)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@165)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@166 T@$Value) )  (=> ((_ is $Address) addr@@166) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@166)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@166)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@166)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@166)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))))) (and (and (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@167 T@$Value) )  (=> ((_ is $Address) addr@@167) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@167)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@167)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@167)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@167)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@168 T@$Value) )  (=> ((_ is $Address) addr@@168) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@168)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@168)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@168)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@168)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (and (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@169 T@$Value) )  (=> ((_ is $Address) addr@@169) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@169)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@169)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@169)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@169)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@170 T@$Value) )  (=> ((_ is $Address) addr@@170) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@170)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@170)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@170)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@170)))) $Roles_RoleId_role_id) ($Integer 6)))))))))))))))))) (and (=> (= (ControlFlow 0 88384) 88428) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 88384) 88394) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon27_Else_correct)))))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon23_Else_correct  (=> (and (and (not $abort_flag@0@@12) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified treasury_compliance_account ($Address 186537453))))) $abort_flag@1@@12)) (and (=> $abort_flag@1@@12 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified treasury_compliance_account ($Address 186537453)))))) (=> $abort_flag@1@@12 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified treasury_compliance_account ($Address 186537453))))) (= $abort_code@2@@11 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 88378) 88448) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 88378) 88384) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0@@12) (=> (and (=> $abort_flag@0@@12 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0@@12 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1@@10 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 88372) 88468) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 88372) 88378) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon4_correct  (=> (and (= inline$$Roles_grant_treasury_compliance_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| treasury_compliance_account) true)) (= (ControlFlow 0 88336) 88372)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon4$2_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 88286) 88336)) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 88492) 88336) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 88278) 88492) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 88278) 88286) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 88500) 88492) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 88500) 88286) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon22_Else_correct))))
(let ((inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 88272) 88500) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 88272) 88278) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@12  (=> (and (and (forall (($inv_addr@@13 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13)) (let ((va@@22 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@13))
)) (forall (($inv_addr@@14 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@14))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 88504) 88272))) inline$$Roles_grant_treasury_compliance_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@12  (=> ((_ is $Address) treasury_compliance_account) (=> (and ((_ is $Address) dr_account@@0) (= (ControlFlow 0 87851) 88504)) anon0$1_correct@@12))))
(let ((PreconditionGeneratedEntry_correct@@12  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain@@1 $EmptyTypeValueArray (|a#$Address| treasury_compliance_account)) (= (ControlFlow 0 139484) 87851)) anon0_correct@@12)))
PreconditionGeneratedEntry_correct@@12)))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@10 () Bool)
(declare-fun $abort_flag@3@@12 () Bool)
(declare-fun inline$$Roles_has_child_VASP_role_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@0@@13 () Bool)
(declare-fun $abort_flag@1@@13 () Bool)
(declare-fun $abort_flag@2@@13 () Bool)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1@@0| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@10 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@10 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@10 () T@$Value)
(declare-fun call3formal@$ret0@0@@32 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1@@0 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1@@0 () T@$Value)
(declare-fun account@@8 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 144922) (let ((anon0$2_correct@@13  (and (=> (= (ControlFlow 0 89839) (- 0 146388)) (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@171 T@$Value) )  (=> ((_ is $Address) addr@@171) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@171)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@171)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@171)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@171)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@172 T@$Value) )  (=> ((_ is $Address) addr@@172) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@172)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@172)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@172)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@172)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 89839) (- 0 146488)) (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@173 T@$Value) )  (=> ((_ is $Address) addr@@173) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@173)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@173)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@173)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@173)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@174 T@$Value) )  (=> ((_ is $Address) addr@@174) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@174)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@174)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@174)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@174)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 89839) (- 0 146588)) (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@175 T@$Value) )  (=> ((_ is $Address) addr@@175) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@175)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@175)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@175)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@175)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@176 T@$Value) )  (=> ((_ is $Address) addr@@176) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@176)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@176)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@176)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@176)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 89839) (- 0 146688)) (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@177 T@$Value) )  (=> ((_ is $Address) addr@@177) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@177)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@177)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@177)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@177)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@178 T@$Value) )  (=> ((_ is $Address) addr@@178) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@178)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@178)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@178)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@178)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 89839) (- 0 146788)) (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@179 T@$Value) )  (=> ((_ is $Address) addr@@179) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@179)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@179)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@179)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@179)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@180 T@$Value) )  (=> ((_ is $Address) addr@@180) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@180)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@180)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@180)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@180)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 89839) (- 0 146888)) (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@181 T@$Value) )  (=> ((_ is $Address) addr@@181) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@181)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@181)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@181)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@181)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@182 T@$Value) )  (=> ((_ is $Address) addr@@182) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@182)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@182)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@182)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@182)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 89839) (- 0 146988)) (=> (not $abort_flag@4@@10) (|b#$Boolean| ($Boolean (forall ((addr@@183 T@$Value) )  (=> ((_ is $Address) addr@@183) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@183)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@183)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@183)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@183)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_has_child_VASP_role_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@4@@10 $abort_flag@3@@12) (= (ControlFlow 0 89807) 89839)) anon0$2_correct@@13)))
(let ((inline$$Roles_has_child_VASP_role_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 89805) 89807)) inline$$Roles_has_child_VASP_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 89815) 89807) inline$$Roles_has_child_VASP_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@3@@12) (and (=> (= (ControlFlow 0 89799) 89815) inline$$Roles_has_child_VASP_role_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 89799) 89805) inline$$Roles_has_child_VASP_role_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def_verify$0$anon8_Then_correct  (=> (and (and $abort_flag@3@@12 (= inline$$Roles_has_child_VASP_role_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@4@@10 true) (= (ControlFlow 0 89823) 89839))) anon0$2_correct@@13)))
(let ((inline$$Roles_has_role_$def$0$Abort_correct@@0  (=> (and (= inline$$Roles_has_role_$def$0$$ret0@1@@0 $Error) (= $abort_flag@3@@12 true)) (and (=> (= (ControlFlow 0 89731) 89823) inline$$Roles_has_child_VASP_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 89731) 89799) inline$$Roles_has_child_VASP_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 89749) 89731)) inline$$Roles_has_role_$def$0$Abort_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct@@0  (=> (= (ControlFlow 0 89759) 89731) inline$$Roles_has_role_$def$0$Abort_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct@@0  (=> $abort_flag@0@@13 (and (=> (= (ControlFlow 0 89743) 89759) inline$$Roles_has_role_$def$0$anon24_Then_correct@@0) (=> (= (ControlFlow 0 89743) 89749) inline$$Roles_has_role_$def$0$anon24_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 89723) 89731)) inline$$Roles_has_role_$def$0$Abort_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct@@0  (=> (= (ControlFlow 0 89739) 89731) inline$$Roles_has_role_$def$0$Abort_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct@@0  (=> $abort_flag@1@@13 (and (=> (= (ControlFlow 0 89717) 89739) inline$$Roles_has_role_$def$0$anon27_Then_correct@@0) (=> (= (ControlFlow 0 89717) 89723) inline$$Roles_has_role_$def$0$anon27_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct@@0  (=> (= $abort_flag@3@@12 $abort_flag@2@@13) (and (=> (= (ControlFlow 0 89438) 89823) inline$$Roles_has_child_VASP_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 89438) 89799) inline$$Roles_has_child_VASP_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 89436) 89438)) inline$$Roles_has_role_$def$0$anon20_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct@@0  (=> (= (ControlFlow 0 89446) 89438) inline$$Roles_has_role_$def$0$anon20_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct@@0  (=> (= $abort_flag@2@@13 $abort_flag@1@@13) (and (=> (= (ControlFlow 0 89705) 89446) inline$$Roles_has_role_$def$0$anon30_Then_correct@@0) (=> (= (ControlFlow 0 89705) 89436) inline$$Roles_has_role_$def$0$anon30_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 89703) 89705)) inline$$Roles_has_role_$def$0$anon16_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct@@0  (=> (= (ControlFlow 0 89713) 89705) inline$$Roles_has_role_$def$0$anon16_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@0  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1@@0| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@10 inline$$Roles_has_child_VASP_role_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 89697) 89713) inline$$Roles_has_role_$def$0$anon28_Then_correct@@0) (=> (= (ControlFlow 0 89697) 89703) inline$$Roles_has_role_$def$0$anon28_Else_correct@@0)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@10  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@0)) $Roles_RoleId_role_id)) (= (ControlFlow 0 89681) 89697)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct@@0  (=> (and (not $abort_flag@1@@13) (= (ControlFlow 0 89687) 89681)) inline$$GetFieldFromValue$0$anon0_correct@@10)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@10  (=> (= $abort_flag@1@@13 true) (and (=> (= (ControlFlow 0 89627) 89717) inline$$Roles_has_role_$def$0$anon26_Then_correct@@0) (=> (= (ControlFlow 0 89627) 89687) inline$$Roles_has_role_$def$0$anon26_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@10  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@10)) (= (ControlFlow 0 89625) 89627)) inline$$GetGlobal$0$anon3_Then$1_correct@@10)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@10  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@10) (=> (and (= inline$$GetGlobal$0$dst@1@@10 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@32))) (= $abort_flag@1@@13 $abort_flag@0@@13)) (and (=> (= (ControlFlow 0 89573) 89717) inline$$Roles_has_role_$def$0$anon26_Then_correct@@0) (=> (= (ControlFlow 0 89573) 89687) inline$$Roles_has_role_$def$0$anon26_Else_correct@@0))))))
(let ((inline$$GetGlobal$0$anon0_correct@@10  (=> (= inline$$GetGlobal$0$a@1@@10 (|a#$Address| call3formal@$ret0@0@@32)) (and (=> (= (ControlFlow 0 89555) 89625) inline$$GetGlobal$0$anon3_Then_correct@@10) (=> (= (ControlFlow 0 89555) 89573) inline$$GetGlobal$0$anon3_Else_correct@@10)))))
(let ((inline$$GetGlobal$0$Entry_correct@@10  (and (=> (= (ControlFlow 0 89549) (- 0 146164)) true) (=> (= (ControlFlow 0 89549) 89555) inline$$GetGlobal$0$anon0_correct@@10))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@0) (= (ControlFlow 0 89633) 89549)) inline$$GetGlobal$0$Entry_correct@@10)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct@@0  (=> (= $abort_flag@2@@13 $abort_flag@0@@13) (and (=> (= (ControlFlow 0 89426) 89446) inline$$Roles_has_role_$def$0$anon30_Then_correct@@0) (=> (= (ControlFlow 0 89426) 89436) inline$$Roles_has_role_$def$0$anon30_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 89424) 89426)) inline$$Roles_has_role_$def$0$anon18_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct@@0  (=> (= (ControlFlow 0 89454) 89426) inline$$Roles_has_role_$def$0$anon18_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@0)) (= inline$$Roles_has_role_$def$0$$t9@1@@0 ($Boolean false))) (and (=> (= (ControlFlow 0 89416) 89454) inline$$Roles_has_role_$def$0$anon29_Then_correct@@0) (=> (= (ControlFlow 0 89416) 89424) inline$$Roles_has_role_$def$0$anon29_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct@@0  (=> (and (not $abort_flag@0@@13) (= inline$$Roles_has_role_$def$0$$t6@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@32))))) (and (=> (= (ControlFlow 0 89372) 89633) inline$$Roles_has_role_$def$0$anon25_Then_correct@@0) (=> (= (ControlFlow 0 89372) 89416) inline$$Roles_has_role_$def$0$anon25_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct@@0  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@13) (=> $abort_flag@0@@13 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@32 account@@8)))) ((_ is $Address) call3formal@$ret0@0@@32))) (and (=> (= (ControlFlow 0 89358) 89743) inline$$Roles_has_role_$def$0$anon23_Then_correct@@0) (=> (= (ControlFlow 0 89358) 89372) inline$$Roles_has_role_$def$0$anon23_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 89288) 89358)) inline$$Roles_has_role_$def$0$anon4$2_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct@@0  (=> (= (ControlFlow 0 89767) 89358) inline$$Roles_has_role_$def$0$anon4$2_correct@@0)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 89280) 89767) inline$$Roles_has_role_$def$0$anon22_Then_correct@@0) (=> (= (ControlFlow 0 89280) 89288) inline$$Roles_has_role_$def$0$anon22_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct@@0  (and (=> (= (ControlFlow 0 89775) 89767) inline$$Roles_has_role_$def$0$anon22_Then_correct@@0) (=> (= (ControlFlow 0 89775) 89288) inline$$Roles_has_role_$def$0$anon22_Else_correct@@0))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct@@0  (=> (not false) (and (=> (= (ControlFlow 0 89274) 89775) inline$$Roles_has_role_$def$0$anon21_Then_correct@@0) (=> (= (ControlFlow 0 89274) 89280) inline$$Roles_has_role_$def$0$anon21_Else_correct@@0)))))
(let ((inline$$Roles_has_role_$direct_intra$0$anon0_correct  (=> ((_ is $Address) account@@8) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_child_VASP_role_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def_verify$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 89781) 89274)) inline$$Roles_has_role_$def$0$anon0_correct@@0))))
(let ((inline$$Roles_has_child_VASP_role_$def_verify$0$anon2$1_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def_verify$0$$t2@1 ($Integer 6)) (= (ControlFlow 0 89789) 89781)) inline$$Roles_has_role_$direct_intra$0$anon0_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 88801) 89789)) inline$$Roles_has_child_VASP_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 89831) 89789) inline$$Roles_has_child_VASP_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 88795) 89831) inline$$Roles_has_child_VASP_role_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 88795) 88801) inline$$Roles_has_child_VASP_role_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@13  (=> (and (forall (($inv_addr@@15 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@15)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@15))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@15))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@15))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@15))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@15))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@15))
)) (= (ControlFlow 0 89837) 88795)) inline$$Roles_has_child_VASP_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@13  (=> (and ((_ is $Address) account@@8) (= (ControlFlow 0 88620) 89837)) anon0$1_correct@@13)))
(let ((PreconditionGeneratedEntry_correct@@13  (=> (= (ControlFlow 0 144922) 88620) anon0_correct@@13)))
PreconditionGeneratedEntry_correct@@13))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@11 () Bool)
(declare-fun $abort_flag@3@@13 () Bool)
(declare-fun inline$$Roles_has_designated_dealer_role_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1@@1 () T@$Value)
(declare-fun $abort_flag@0@@14 () Bool)
(declare-fun $abort_flag@1@@14 () Bool)
(declare-fun $abort_flag@2@@14 () Bool)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1@@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@11 () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@11 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@11 () T@$Value)
(declare-fun call3formal@$ret0@0@@33 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1@@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1@@1 () T@$Value)
(declare-fun account@@9 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 147093) (let ((anon0$2_correct@@14  (and (=> (= (ControlFlow 0 91270) (- 0 148559)) (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@184 T@$Value) )  (=> ((_ is $Address) addr@@184) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@184)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@184)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@184)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@184)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@185 T@$Value) )  (=> ((_ is $Address) addr@@185) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@185)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@185)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@185)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@185)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 91270) (- 0 148659)) (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@186 T@$Value) )  (=> ((_ is $Address) addr@@186) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@186)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@186)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@186)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@186)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@187 T@$Value) )  (=> ((_ is $Address) addr@@187) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@187)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@187)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@187)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@187)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 91270) (- 0 148759)) (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@188 T@$Value) )  (=> ((_ is $Address) addr@@188) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@188)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@188)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@188)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@188)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@189 T@$Value) )  (=> ((_ is $Address) addr@@189) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@189)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@189)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@189)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@189)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 91270) (- 0 148859)) (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@190 T@$Value) )  (=> ((_ is $Address) addr@@190) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@190)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@190)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@190)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@190)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@191 T@$Value) )  (=> ((_ is $Address) addr@@191) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@191)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@191)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@191)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@191)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 91270) (- 0 148959)) (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@192 T@$Value) )  (=> ((_ is $Address) addr@@192) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@192)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@192)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@192)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@192)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@193 T@$Value) )  (=> ((_ is $Address) addr@@193) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@193)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@193)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@193)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@193)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 91270) (- 0 149059)) (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@194 T@$Value) )  (=> ((_ is $Address) addr@@194) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@194)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@194)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@194)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@194)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@195 T@$Value) )  (=> ((_ is $Address) addr@@195) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@195)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@195)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@195)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@195)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 91270) (- 0 149159)) (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean (forall ((addr@@196 T@$Value) )  (=> ((_ is $Address) addr@@196) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@196)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@196)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@196)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@196)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_has_designated_dealer_role_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@4@@11 $abort_flag@3@@13) (= (ControlFlow 0 91238) 91270)) anon0$2_correct@@14)))
(let ((inline$$Roles_has_designated_dealer_role_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 91236) 91238)) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 91246) 91238) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@3@@13) (and (=> (= (ControlFlow 0 91230) 91246) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 91230) 91236) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def_verify$0$anon8_Then_correct  (=> (and (and $abort_flag@3@@13 (= inline$$Roles_has_designated_dealer_role_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@4@@11 true) (= (ControlFlow 0 91254) 91270))) anon0$2_correct@@14)))
(let ((inline$$Roles_has_role_$def$0$Abort_correct@@1  (=> (and (= inline$$Roles_has_role_$def$0$$ret0@1@@1 $Error) (= $abort_flag@3@@13 true)) (and (=> (= (ControlFlow 0 91162) 91254) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 91162) 91230) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 91180) 91162)) inline$$Roles_has_role_$def$0$Abort_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct@@1  (=> (= (ControlFlow 0 91190) 91162) inline$$Roles_has_role_$def$0$Abort_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct@@1  (=> $abort_flag@0@@14 (and (=> (= (ControlFlow 0 91174) 91190) inline$$Roles_has_role_$def$0$anon24_Then_correct@@1) (=> (= (ControlFlow 0 91174) 91180) inline$$Roles_has_role_$def$0$anon24_Else_correct@@1)))))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 91154) 91162)) inline$$Roles_has_role_$def$0$Abort_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct@@1  (=> (= (ControlFlow 0 91170) 91162) inline$$Roles_has_role_$def$0$Abort_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct@@1  (=> $abort_flag@1@@14 (and (=> (= (ControlFlow 0 91148) 91170) inline$$Roles_has_role_$def$0$anon27_Then_correct@@1) (=> (= (ControlFlow 0 91148) 91154) inline$$Roles_has_role_$def$0$anon27_Else_correct@@1)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct@@1  (=> (= $abort_flag@3@@13 $abort_flag@2@@14) (and (=> (= (ControlFlow 0 90869) 91254) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 90869) 91230) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 90867) 90869)) inline$$Roles_has_role_$def$0$anon20_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct@@1  (=> (= (ControlFlow 0 90877) 90869) inline$$Roles_has_role_$def$0$anon20_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct@@1  (=> (= $abort_flag@2@@14 $abort_flag@1@@14) (and (=> (= (ControlFlow 0 91136) 90877) inline$$Roles_has_role_$def$0$anon30_Then_correct@@1) (=> (= (ControlFlow 0 91136) 90867) inline$$Roles_has_role_$def$0$anon30_Else_correct@@1)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 91134) 91136)) inline$$Roles_has_role_$def$0$anon16_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct@@1  (=> (= (ControlFlow 0 91144) 91136) inline$$Roles_has_role_$def$0$anon16_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@1  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1@@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@11 inline$$Roles_has_designated_dealer_role_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 91128) 91144) inline$$Roles_has_role_$def$0$anon28_Then_correct@@1) (=> (= (ControlFlow 0 91128) 91134) inline$$Roles_has_role_$def$0$anon28_Else_correct@@1)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@11  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@1)) $Roles_RoleId_role_id)) (= (ControlFlow 0 91112) 91128)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct@@1  (=> (and (not $abort_flag@1@@14) (= (ControlFlow 0 91118) 91112)) inline$$GetFieldFromValue$0$anon0_correct@@11)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@11  (=> (= $abort_flag@1@@14 true) (and (=> (= (ControlFlow 0 91058) 91148) inline$$Roles_has_role_$def$0$anon26_Then_correct@@1) (=> (= (ControlFlow 0 91058) 91118) inline$$Roles_has_role_$def$0$anon26_Else_correct@@1)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@11  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@11)) (= (ControlFlow 0 91056) 91058)) inline$$GetGlobal$0$anon3_Then$1_correct@@11)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@11  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@11) (=> (and (= inline$$GetGlobal$0$dst@1@@11 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@33))) (= $abort_flag@1@@14 $abort_flag@0@@14)) (and (=> (= (ControlFlow 0 91004) 91148) inline$$Roles_has_role_$def$0$anon26_Then_correct@@1) (=> (= (ControlFlow 0 91004) 91118) inline$$Roles_has_role_$def$0$anon26_Else_correct@@1))))))
(let ((inline$$GetGlobal$0$anon0_correct@@11  (=> (= inline$$GetGlobal$0$a@1@@11 (|a#$Address| call3formal@$ret0@0@@33)) (and (=> (= (ControlFlow 0 90986) 91056) inline$$GetGlobal$0$anon3_Then_correct@@11) (=> (= (ControlFlow 0 90986) 91004) inline$$GetGlobal$0$anon3_Else_correct@@11)))))
(let ((inline$$GetGlobal$0$Entry_correct@@11  (and (=> (= (ControlFlow 0 90980) (- 0 148335)) true) (=> (= (ControlFlow 0 90980) 90986) inline$$GetGlobal$0$anon0_correct@@11))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct@@1  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@1) (= (ControlFlow 0 91064) 90980)) inline$$GetGlobal$0$Entry_correct@@11)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct@@1  (=> (= $abort_flag@2@@14 $abort_flag@0@@14) (and (=> (= (ControlFlow 0 90857) 90877) inline$$Roles_has_role_$def$0$anon30_Then_correct@@1) (=> (= (ControlFlow 0 90857) 90867) inline$$Roles_has_role_$def$0$anon30_Else_correct@@1)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 90855) 90857)) inline$$Roles_has_role_$def$0$anon18_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct@@1  (=> (= (ControlFlow 0 90885) 90857) inline$$Roles_has_role_$def$0$anon18_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct@@1  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@1)) (= inline$$Roles_has_role_$def$0$$t9@1@@1 ($Boolean false))) (and (=> (= (ControlFlow 0 90847) 90885) inline$$Roles_has_role_$def$0$anon29_Then_correct@@1) (=> (= (ControlFlow 0 90847) 90855) inline$$Roles_has_role_$def$0$anon29_Else_correct@@1)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct@@1  (=> (and (not $abort_flag@0@@14) (= inline$$Roles_has_role_$def$0$$t6@1@@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@33))))) (and (=> (= (ControlFlow 0 90803) 91064) inline$$Roles_has_role_$def$0$anon25_Then_correct@@1) (=> (= (ControlFlow 0 90803) 90847) inline$$Roles_has_role_$def$0$anon25_Else_correct@@1)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct@@1  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@14) (=> $abort_flag@0@@14 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@33 account@@9)))) ((_ is $Address) call3formal@$ret0@0@@33))) (and (=> (= (ControlFlow 0 90789) 91174) inline$$Roles_has_role_$def$0$anon23_Then_correct@@1) (=> (= (ControlFlow 0 90789) 90803) inline$$Roles_has_role_$def$0$anon23_Else_correct@@1)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 90719) 90789)) inline$$Roles_has_role_$def$0$anon4$2_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct@@1  (=> (= (ControlFlow 0 91198) 90789) inline$$Roles_has_role_$def$0$anon4$2_correct@@1)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 90711) 91198) inline$$Roles_has_role_$def$0$anon22_Then_correct@@1) (=> (= (ControlFlow 0 90711) 90719) inline$$Roles_has_role_$def$0$anon22_Else_correct@@1)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct@@1  (and (=> (= (ControlFlow 0 91206) 91198) inline$$Roles_has_role_$def$0$anon22_Then_correct@@1) (=> (= (ControlFlow 0 91206) 90719) inline$$Roles_has_role_$def$0$anon22_Else_correct@@1))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct@@1  (=> (not false) (and (=> (= (ControlFlow 0 90705) 91206) inline$$Roles_has_role_$def$0$anon21_Then_correct@@1) (=> (= (ControlFlow 0 90705) 90711) inline$$Roles_has_role_$def$0$anon21_Else_correct@@1)))))
(let ((inline$$Roles_has_role_$direct_intra$0$anon0_correct@@0  (=> ((_ is $Address) account@@9) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_designated_dealer_role_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def_verify$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 91212) 90705)) inline$$Roles_has_role_$def$0$anon0_correct@@1))))
(let ((inline$$Roles_has_designated_dealer_role_$def_verify$0$anon2$1_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def_verify$0$$t2@1 ($Integer 2)) (= (ControlFlow 0 91220) 91212)) inline$$Roles_has_role_$direct_intra$0$anon0_correct@@0)))
(let ((inline$$Roles_has_designated_dealer_role_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 90232) 91220)) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 91262) 91220) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 90226) 91262) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 90226) 90232) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@14  (=> (and (forall (($inv_addr@@16 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))
)) (= (ControlFlow 0 91268) 90226)) inline$$Roles_has_designated_dealer_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@14  (=> (and ((_ is $Address) account@@9) (= (ControlFlow 0 90051) 91268)) anon0$1_correct@@14)))
(let ((PreconditionGeneratedEntry_correct@@14  (=> (= (ControlFlow 0 147093) 90051) anon0_correct@@14)))
PreconditionGeneratedEntry_correct@@14))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@12 () Bool)
(declare-fun $abort_flag@3@@14 () Bool)
(declare-fun inline$$Roles_has_diem_root_role_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1@@2 () T@$Value)
(declare-fun $abort_flag@0@@15 () Bool)
(declare-fun $abort_flag@1@@15 () Bool)
(declare-fun $abort_flag@2@@15 () Bool)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1@@2| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@12 () T@$Value)
(declare-fun inline$$Roles_has_diem_root_role_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@12 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@12 () T@$Value)
(declare-fun call3formal@$ret0@0@@34 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1@@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1@@2 () T@$Value)
(declare-fun account@@10 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 149264) (let ((anon0$2_correct@@15  (and (=> (= (ControlFlow 0 92701) (- 0 150730)) (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@197 T@$Value) )  (=> ((_ is $Address) addr@@197) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@197)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@197)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@197)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@197)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@198 T@$Value) )  (=> ((_ is $Address) addr@@198) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@198)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@198)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@198)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@198)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 92701) (- 0 150830)) (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@199 T@$Value) )  (=> ((_ is $Address) addr@@199) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@199)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@199)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@199)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@199)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@200 T@$Value) )  (=> ((_ is $Address) addr@@200) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@200)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@200)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@200)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@200)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 92701) (- 0 150930)) (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@201 T@$Value) )  (=> ((_ is $Address) addr@@201) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@201)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@201)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@201)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@201)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@202 T@$Value) )  (=> ((_ is $Address) addr@@202) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@202)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@202)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@202)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@202)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 92701) (- 0 151030)) (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@203 T@$Value) )  (=> ((_ is $Address) addr@@203) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@203)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@203)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@203)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@203)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@204 T@$Value) )  (=> ((_ is $Address) addr@@204) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@204)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@204)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@204)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@204)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 92701) (- 0 151130)) (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@205 T@$Value) )  (=> ((_ is $Address) addr@@205) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@205)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@205)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@205)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@205)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@206 T@$Value) )  (=> ((_ is $Address) addr@@206) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@206)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@206)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@206)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@206)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 92701) (- 0 151230)) (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@207 T@$Value) )  (=> ((_ is $Address) addr@@207) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@207)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@207)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@207)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@207)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@208 T@$Value) )  (=> ((_ is $Address) addr@@208) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@208)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@208)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@208)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@208)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 92701) (- 0 151330)) (=> (not $abort_flag@4@@12) (|b#$Boolean| ($Boolean (forall ((addr@@209 T@$Value) )  (=> ((_ is $Address) addr@@209) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@209)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@209)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@209)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@209)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_has_diem_root_role_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@4@@12 $abort_flag@3@@14) (= (ControlFlow 0 92669) 92701)) anon0$2_correct@@15)))
(let ((inline$$Roles_has_diem_root_role_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 92667) 92669)) inline$$Roles_has_diem_root_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_diem_root_role_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 92677) 92669) inline$$Roles_has_diem_root_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_diem_root_role_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@3@@14) (and (=> (= (ControlFlow 0 92661) 92677) inline$$Roles_has_diem_root_role_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 92661) 92667) inline$$Roles_has_diem_root_role_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_diem_root_role_$def_verify$0$anon8_Then_correct  (=> (and (and $abort_flag@3@@14 (= inline$$Roles_has_diem_root_role_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@4@@12 true) (= (ControlFlow 0 92685) 92701))) anon0$2_correct@@15)))
(let ((inline$$Roles_has_role_$def$0$Abort_correct@@2  (=> (and (= inline$$Roles_has_role_$def$0$$ret0@1@@2 $Error) (= $abort_flag@3@@14 true)) (and (=> (= (ControlFlow 0 92593) 92685) inline$$Roles_has_diem_root_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 92593) 92661) inline$$Roles_has_diem_root_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 92611) 92593)) inline$$Roles_has_role_$def$0$Abort_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct@@2  (=> (= (ControlFlow 0 92621) 92593) inline$$Roles_has_role_$def$0$Abort_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct@@2  (=> $abort_flag@0@@15 (and (=> (= (ControlFlow 0 92605) 92621) inline$$Roles_has_role_$def$0$anon24_Then_correct@@2) (=> (= (ControlFlow 0 92605) 92611) inline$$Roles_has_role_$def$0$anon24_Else_correct@@2)))))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 92585) 92593)) inline$$Roles_has_role_$def$0$Abort_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct@@2  (=> (= (ControlFlow 0 92601) 92593) inline$$Roles_has_role_$def$0$Abort_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct@@2  (=> $abort_flag@1@@15 (and (=> (= (ControlFlow 0 92579) 92601) inline$$Roles_has_role_$def$0$anon27_Then_correct@@2) (=> (= (ControlFlow 0 92579) 92585) inline$$Roles_has_role_$def$0$anon27_Else_correct@@2)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct@@2  (=> (= $abort_flag@3@@14 $abort_flag@2@@15) (and (=> (= (ControlFlow 0 92300) 92685) inline$$Roles_has_diem_root_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 92300) 92661) inline$$Roles_has_diem_root_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 92298) 92300)) inline$$Roles_has_role_$def$0$anon20_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct@@2  (=> (= (ControlFlow 0 92308) 92300) inline$$Roles_has_role_$def$0$anon20_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct@@2  (=> (= $abort_flag@2@@15 $abort_flag@1@@15) (and (=> (= (ControlFlow 0 92567) 92308) inline$$Roles_has_role_$def$0$anon30_Then_correct@@2) (=> (= (ControlFlow 0 92567) 92298) inline$$Roles_has_role_$def$0$anon30_Else_correct@@2)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 92565) 92567)) inline$$Roles_has_role_$def$0$anon16_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct@@2  (=> (= (ControlFlow 0 92575) 92567) inline$$Roles_has_role_$def$0$anon16_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@2  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1@@2| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@12 inline$$Roles_has_diem_root_role_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 92559) 92575) inline$$Roles_has_role_$def$0$anon28_Then_correct@@2) (=> (= (ControlFlow 0 92559) 92565) inline$$Roles_has_role_$def$0$anon28_Else_correct@@2)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@12  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@12 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 92543) 92559)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct@@2  (=> (and (not $abort_flag@1@@15) (= (ControlFlow 0 92549) 92543)) inline$$GetFieldFromValue$0$anon0_correct@@12)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@12  (=> (= $abort_flag@1@@15 true) (and (=> (= (ControlFlow 0 92489) 92579) inline$$Roles_has_role_$def$0$anon26_Then_correct@@2) (=> (= (ControlFlow 0 92489) 92549) inline$$Roles_has_role_$def$0$anon26_Else_correct@@2)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@12  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@12)) (= (ControlFlow 0 92487) 92489)) inline$$GetGlobal$0$anon3_Then$1_correct@@12)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@12  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@12) (=> (and (= inline$$GetGlobal$0$dst@1@@12 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@34))) (= $abort_flag@1@@15 $abort_flag@0@@15)) (and (=> (= (ControlFlow 0 92435) 92579) inline$$Roles_has_role_$def$0$anon26_Then_correct@@2) (=> (= (ControlFlow 0 92435) 92549) inline$$Roles_has_role_$def$0$anon26_Else_correct@@2))))))
(let ((inline$$GetGlobal$0$anon0_correct@@12  (=> (= inline$$GetGlobal$0$a@1@@12 (|a#$Address| call3formal@$ret0@0@@34)) (and (=> (= (ControlFlow 0 92417) 92487) inline$$GetGlobal$0$anon3_Then_correct@@12) (=> (= (ControlFlow 0 92417) 92435) inline$$GetGlobal$0$anon3_Else_correct@@12)))))
(let ((inline$$GetGlobal$0$Entry_correct@@12  (and (=> (= (ControlFlow 0 92411) (- 0 150506)) true) (=> (= (ControlFlow 0 92411) 92417) inline$$GetGlobal$0$anon0_correct@@12))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct@@2  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@2) (= (ControlFlow 0 92495) 92411)) inline$$GetGlobal$0$Entry_correct@@12)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct@@2  (=> (= $abort_flag@2@@15 $abort_flag@0@@15) (and (=> (= (ControlFlow 0 92288) 92308) inline$$Roles_has_role_$def$0$anon30_Then_correct@@2) (=> (= (ControlFlow 0 92288) 92298) inline$$Roles_has_role_$def$0$anon30_Else_correct@@2)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 92286) 92288)) inline$$Roles_has_role_$def$0$anon18_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct@@2  (=> (= (ControlFlow 0 92316) 92288) inline$$Roles_has_role_$def$0$anon18_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct@@2  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@2)) (= inline$$Roles_has_role_$def$0$$t9@1@@2 ($Boolean false))) (and (=> (= (ControlFlow 0 92278) 92316) inline$$Roles_has_role_$def$0$anon29_Then_correct@@2) (=> (= (ControlFlow 0 92278) 92286) inline$$Roles_has_role_$def$0$anon29_Else_correct@@2)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct@@2  (=> (and (not $abort_flag@0@@15) (= inline$$Roles_has_role_$def$0$$t6@1@@2 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@34))))) (and (=> (= (ControlFlow 0 92234) 92495) inline$$Roles_has_role_$def$0$anon25_Then_correct@@2) (=> (= (ControlFlow 0 92234) 92278) inline$$Roles_has_role_$def$0$anon25_Else_correct@@2)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct@@2  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@15) (=> $abort_flag@0@@15 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@15) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@34 account@@10)))) ((_ is $Address) call3formal@$ret0@0@@34))) (and (=> (= (ControlFlow 0 92220) 92605) inline$$Roles_has_role_$def$0$anon23_Then_correct@@2) (=> (= (ControlFlow 0 92220) 92234) inline$$Roles_has_role_$def$0$anon23_Else_correct@@2)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 92150) 92220)) inline$$Roles_has_role_$def$0$anon4$2_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct@@2  (=> (= (ControlFlow 0 92629) 92220) inline$$Roles_has_role_$def$0$anon4$2_correct@@2)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 92142) 92629) inline$$Roles_has_role_$def$0$anon22_Then_correct@@2) (=> (= (ControlFlow 0 92142) 92150) inline$$Roles_has_role_$def$0$anon22_Else_correct@@2)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct@@2  (and (=> (= (ControlFlow 0 92637) 92629) inline$$Roles_has_role_$def$0$anon22_Then_correct@@2) (=> (= (ControlFlow 0 92637) 92150) inline$$Roles_has_role_$def$0$anon22_Else_correct@@2))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct@@2  (=> (not false) (and (=> (= (ControlFlow 0 92136) 92637) inline$$Roles_has_role_$def$0$anon21_Then_correct@@2) (=> (= (ControlFlow 0 92136) 92142) inline$$Roles_has_role_$def$0$anon21_Else_correct@@2)))))
(let ((inline$$Roles_has_role_$direct_intra$0$anon0_correct@@1  (=> ((_ is $Address) account@@10) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_diem_root_role_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_diem_root_role_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_diem_root_role_$def_verify$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 92643) 92136)) inline$$Roles_has_role_$def$0$anon0_correct@@2))))
(let ((inline$$Roles_has_diem_root_role_$def_verify$0$anon2$1_correct  (=> (and (= inline$$Roles_has_diem_root_role_$def_verify$0$$t2@1 ($Integer 0)) (= (ControlFlow 0 92651) 92643)) inline$$Roles_has_role_$direct_intra$0$anon0_correct@@1)))
(let ((inline$$Roles_has_diem_root_role_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 91663) 92651)) inline$$Roles_has_diem_root_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_diem_root_role_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 92693) 92651) inline$$Roles_has_diem_root_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_diem_root_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 91657) 92693) inline$$Roles_has_diem_root_role_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 91657) 91663) inline$$Roles_has_diem_root_role_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@15  (=> (and (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@17))
)) (= (ControlFlow 0 92699) 91657)) inline$$Roles_has_diem_root_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@15  (=> (and ((_ is $Address) account@@10) (= (ControlFlow 0 91482) 92699)) anon0$1_correct@@15)))
(let ((PreconditionGeneratedEntry_correct@@15  (=> (= (ControlFlow 0 149264) 91482) anon0_correct@@15)))
PreconditionGeneratedEntry_correct@@15))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@13 () Bool)
(declare-fun $abort_flag@3@@15 () Bool)
(declare-fun inline$$Roles_has_parent_VASP_role_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1@@3 () T@$Value)
(declare-fun $abort_flag@0@@16 () Bool)
(declare-fun $abort_flag@1@@16 () Bool)
(declare-fun $abort_flag@2@@16 () Bool)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1@@3| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@13 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@3 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@13 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@13 () T@$Value)
(declare-fun call3formal@$ret0@0@@35 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1@@3 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1@@3 () T@$Value)
(declare-fun account@@11 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 151435) (let ((anon0$2_correct@@16  (and (=> (= (ControlFlow 0 94132) (- 0 152901)) (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@210 T@$Value) )  (=> ((_ is $Address) addr@@210) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@210)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@210)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@210)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@210)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@211 T@$Value) )  (=> ((_ is $Address) addr@@211) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@211)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@211)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@211)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@211)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 94132) (- 0 153001)) (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@212 T@$Value) )  (=> ((_ is $Address) addr@@212) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@212)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@212)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@212)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@212)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@213 T@$Value) )  (=> ((_ is $Address) addr@@213) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@213)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@213)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@213)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@213)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 94132) (- 0 153101)) (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@214 T@$Value) )  (=> ((_ is $Address) addr@@214) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@214)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@214)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@214)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@214)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@215 T@$Value) )  (=> ((_ is $Address) addr@@215) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@215)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@215)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@215)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@215)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 94132) (- 0 153201)) (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@216 T@$Value) )  (=> ((_ is $Address) addr@@216) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@216)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@216)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@216)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@216)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@217 T@$Value) )  (=> ((_ is $Address) addr@@217) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@217)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@217)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@217)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@217)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 94132) (- 0 153301)) (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@218 T@$Value) )  (=> ((_ is $Address) addr@@218) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@218)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@218)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@218)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@218)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@219 T@$Value) )  (=> ((_ is $Address) addr@@219) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@219)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@219)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@219)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@219)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 94132) (- 0 153401)) (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@220 T@$Value) )  (=> ((_ is $Address) addr@@220) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@220)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@220)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@220)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@220)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@221 T@$Value) )  (=> ((_ is $Address) addr@@221) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@221)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@221)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@221)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@221)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 94132) (- 0 153501)) (=> (not $abort_flag@4@@13) (|b#$Boolean| ($Boolean (forall ((addr@@222 T@$Value) )  (=> ((_ is $Address) addr@@222) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@222)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@222)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@222)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@222)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_has_parent_VASP_role_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@4@@13 $abort_flag@3@@15) (= (ControlFlow 0 94100) 94132)) anon0$2_correct@@16)))
(let ((inline$$Roles_has_parent_VASP_role_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 94098) 94100)) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 94108) 94100) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@3@@15) (and (=> (= (ControlFlow 0 94092) 94108) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 94092) 94098) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def_verify$0$anon8_Then_correct  (=> (and (and $abort_flag@3@@15 (= inline$$Roles_has_parent_VASP_role_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@4@@13 true) (= (ControlFlow 0 94116) 94132))) anon0$2_correct@@16)))
(let ((inline$$Roles_has_role_$def$0$Abort_correct@@3  (=> (and (= inline$$Roles_has_role_$def$0$$ret0@1@@3 $Error) (= $abort_flag@3@@15 true)) (and (=> (= (ControlFlow 0 94024) 94116) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 94024) 94092) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct@@3  (=> (and (not true) (= (ControlFlow 0 94042) 94024)) inline$$Roles_has_role_$def$0$Abort_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct@@3  (=> (= (ControlFlow 0 94052) 94024) inline$$Roles_has_role_$def$0$Abort_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct@@3  (=> $abort_flag@0@@16 (and (=> (= (ControlFlow 0 94036) 94052) inline$$Roles_has_role_$def$0$anon24_Then_correct@@3) (=> (= (ControlFlow 0 94036) 94042) inline$$Roles_has_role_$def$0$anon24_Else_correct@@3)))))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct@@3  (=> (and (not true) (= (ControlFlow 0 94016) 94024)) inline$$Roles_has_role_$def$0$Abort_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct@@3  (=> (= (ControlFlow 0 94032) 94024) inline$$Roles_has_role_$def$0$Abort_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct@@3  (=> $abort_flag@1@@16 (and (=> (= (ControlFlow 0 94010) 94032) inline$$Roles_has_role_$def$0$anon27_Then_correct@@3) (=> (= (ControlFlow 0 94010) 94016) inline$$Roles_has_role_$def$0$anon27_Else_correct@@3)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct@@3  (=> (= $abort_flag@3@@15 $abort_flag@2@@16) (and (=> (= (ControlFlow 0 93731) 94116) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 93731) 94092) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct@@3  (=> (and (not true) (= (ControlFlow 0 93729) 93731)) inline$$Roles_has_role_$def$0$anon20_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct@@3  (=> (= (ControlFlow 0 93739) 93731) inline$$Roles_has_role_$def$0$anon20_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct@@3  (=> (= $abort_flag@2@@16 $abort_flag@1@@16) (and (=> (= (ControlFlow 0 93998) 93739) inline$$Roles_has_role_$def$0$anon30_Then_correct@@3) (=> (= (ControlFlow 0 93998) 93729) inline$$Roles_has_role_$def$0$anon30_Else_correct@@3)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct@@3  (=> (and (not true) (= (ControlFlow 0 93996) 93998)) inline$$Roles_has_role_$def$0$anon16_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct@@3  (=> (= (ControlFlow 0 94006) 93998) inline$$Roles_has_role_$def$0$anon16_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@3  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1@@3| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@13 inline$$Roles_has_parent_VASP_role_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 93990) 94006) inline$$Roles_has_role_$def$0$anon28_Then_correct@@3) (=> (= (ControlFlow 0 93990) 93996) inline$$Roles_has_role_$def$0$anon28_Else_correct@@3)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@13  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@13 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@3)) $Roles_RoleId_role_id)) (= (ControlFlow 0 93974) 93990)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct@@3  (=> (and (not $abort_flag@1@@16) (= (ControlFlow 0 93980) 93974)) inline$$GetFieldFromValue$0$anon0_correct@@13)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@13  (=> (= $abort_flag@1@@16 true) (and (=> (= (ControlFlow 0 93920) 94010) inline$$Roles_has_role_$def$0$anon26_Then_correct@@3) (=> (= (ControlFlow 0 93920) 93980) inline$$Roles_has_role_$def$0$anon26_Else_correct@@3)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@13  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@13)) (= (ControlFlow 0 93918) 93920)) inline$$GetGlobal$0$anon3_Then$1_correct@@13)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@13  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@13) (=> (and (= inline$$GetGlobal$0$dst@1@@13 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@35))) (= $abort_flag@1@@16 $abort_flag@0@@16)) (and (=> (= (ControlFlow 0 93866) 94010) inline$$Roles_has_role_$def$0$anon26_Then_correct@@3) (=> (= (ControlFlow 0 93866) 93980) inline$$Roles_has_role_$def$0$anon26_Else_correct@@3))))))
(let ((inline$$GetGlobal$0$anon0_correct@@13  (=> (= inline$$GetGlobal$0$a@1@@13 (|a#$Address| call3formal@$ret0@0@@35)) (and (=> (= (ControlFlow 0 93848) 93918) inline$$GetGlobal$0$anon3_Then_correct@@13) (=> (= (ControlFlow 0 93848) 93866) inline$$GetGlobal$0$anon3_Else_correct@@13)))))
(let ((inline$$GetGlobal$0$Entry_correct@@13  (and (=> (= (ControlFlow 0 93842) (- 0 152677)) true) (=> (= (ControlFlow 0 93842) 93848) inline$$GetGlobal$0$anon0_correct@@13))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct@@3  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@3) (= (ControlFlow 0 93926) 93842)) inline$$GetGlobal$0$Entry_correct@@13)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct@@3  (=> (= $abort_flag@2@@16 $abort_flag@0@@16) (and (=> (= (ControlFlow 0 93719) 93739) inline$$Roles_has_role_$def$0$anon30_Then_correct@@3) (=> (= (ControlFlow 0 93719) 93729) inline$$Roles_has_role_$def$0$anon30_Else_correct@@3)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct@@3  (=> (and (not true) (= (ControlFlow 0 93717) 93719)) inline$$Roles_has_role_$def$0$anon18_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct@@3  (=> (= (ControlFlow 0 93747) 93719) inline$$Roles_has_role_$def$0$anon18_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct@@3  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@3)) (= inline$$Roles_has_role_$def$0$$t9@1@@3 ($Boolean false))) (and (=> (= (ControlFlow 0 93709) 93747) inline$$Roles_has_role_$def$0$anon29_Then_correct@@3) (=> (= (ControlFlow 0 93709) 93717) inline$$Roles_has_role_$def$0$anon29_Else_correct@@3)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct@@3  (=> (and (not $abort_flag@0@@16) (= inline$$Roles_has_role_$def$0$$t6@1@@3 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@35))))) (and (=> (= (ControlFlow 0 93665) 93926) inline$$Roles_has_role_$def$0$anon25_Then_correct@@3) (=> (= (ControlFlow 0 93665) 93709) inline$$Roles_has_role_$def$0$anon25_Else_correct@@3)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct@@3  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@16) (=> $abort_flag@0@@16 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@35 account@@11)))) ((_ is $Address) call3formal@$ret0@0@@35))) (and (=> (= (ControlFlow 0 93651) 94036) inline$$Roles_has_role_$def$0$anon23_Then_correct@@3) (=> (= (ControlFlow 0 93651) 93665) inline$$Roles_has_role_$def$0$anon23_Else_correct@@3)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct@@3  (=> (and (not true) (= (ControlFlow 0 93581) 93651)) inline$$Roles_has_role_$def$0$anon4$2_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct@@3  (=> (= (ControlFlow 0 94060) 93651) inline$$Roles_has_role_$def$0$anon4$2_correct@@3)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 93573) 94060) inline$$Roles_has_role_$def$0$anon22_Then_correct@@3) (=> (= (ControlFlow 0 93573) 93581) inline$$Roles_has_role_$def$0$anon22_Else_correct@@3)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct@@3  (and (=> (= (ControlFlow 0 94068) 94060) inline$$Roles_has_role_$def$0$anon22_Then_correct@@3) (=> (= (ControlFlow 0 94068) 93581) inline$$Roles_has_role_$def$0$anon22_Else_correct@@3))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct@@3  (=> (not false) (and (=> (= (ControlFlow 0 93567) 94068) inline$$Roles_has_role_$def$0$anon21_Then_correct@@3) (=> (= (ControlFlow 0 93567) 93573) inline$$Roles_has_role_$def$0$anon21_Else_correct@@3)))))
(let ((inline$$Roles_has_role_$direct_intra$0$anon0_correct@@2  (=> ((_ is $Address) account@@11) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_parent_VASP_role_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def_verify$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 94074) 93567)) inline$$Roles_has_role_$def$0$anon0_correct@@3))))
(let ((inline$$Roles_has_parent_VASP_role_$def_verify$0$anon2$1_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def_verify$0$$t2@1 ($Integer 5)) (= (ControlFlow 0 94082) 94074)) inline$$Roles_has_role_$direct_intra$0$anon0_correct@@2)))
(let ((inline$$Roles_has_parent_VASP_role_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 93094) 94082)) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 94124) 94082) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 93088) 94124) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 93088) 93094) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@16  (=> (and (forall (($inv_addr@@18 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@18)) (let ((va@@27 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@18))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@18))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@18))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@18))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@18))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@18))
)) (= (ControlFlow 0 94130) 93088)) inline$$Roles_has_parent_VASP_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@16  (=> (and ((_ is $Address) account@@11) (= (ControlFlow 0 92913) 94130)) anon0$1_correct@@16)))
(let ((PreconditionGeneratedEntry_correct@@16  (=> (= (ControlFlow 0 151435) 92913) anon0_correct@@16)))
PreconditionGeneratedEntry_correct@@16))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@16 () Bool)
(declare-fun inline$$Roles_has_role_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@17 () Bool)
(declare-fun $abort_flag@1@@17 () Bool)
(declare-fun $abort_flag@2@@17 () Bool)
(declare-fun |inline$$Roles_has_role_$def_verify$0$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@14 () T@$Value)
(declare-fun role_id@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@4 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@14 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@14 () T@$Value)
(declare-fun call3formal@$ret0@0@@36 () T@$Value)
(declare-fun inline$$Roles_has_role_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def_verify$0$$t9@1 () T@$Value)
(declare-fun account@@12 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 153607) (let ((anon0$2_correct@@17  (and (=> (= (ControlFlow 0 95257) (- 0 154929)) (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@223 T@$Value) )  (=> ((_ is $Address) addr@@223) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@223)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@223)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@223)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@223)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@224 T@$Value) )  (=> ((_ is $Address) addr@@224) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@224)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@224)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@224)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@224)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 95257) (- 0 155029)) (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@225 T@$Value) )  (=> ((_ is $Address) addr@@225) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@225)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@225)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@225)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@225)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@226 T@$Value) )  (=> ((_ is $Address) addr@@226) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@226)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@226)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@226)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@226)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 95257) (- 0 155129)) (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@227 T@$Value) )  (=> ((_ is $Address) addr@@227) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@227)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@227)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@227)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@227)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@228 T@$Value) )  (=> ((_ is $Address) addr@@228) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@228)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@228)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@228)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@228)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 95257) (- 0 155229)) (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@229 T@$Value) )  (=> ((_ is $Address) addr@@229) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@229)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@229)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@229)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@229)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@230 T@$Value) )  (=> ((_ is $Address) addr@@230) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@230)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@230)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@230)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@230)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 95257) (- 0 155329)) (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@231 T@$Value) )  (=> ((_ is $Address) addr@@231) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@231)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@231)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@231)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@231)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@232 T@$Value) )  (=> ((_ is $Address) addr@@232) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@232)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@232)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@232)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@232)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 95257) (- 0 155429)) (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@233 T@$Value) )  (=> ((_ is $Address) addr@@233) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@233)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@233)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@233)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@233)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@234 T@$Value) )  (=> ((_ is $Address) addr@@234) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@234)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@234)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@234)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@234)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 95257) (- 0 155529)) (=> (not $abort_flag@3@@16) (|b#$Boolean| ($Boolean (forall ((addr@@235 T@$Value) )  (=> ((_ is $Address) addr@@235) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@235)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@235)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@235)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@235)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_has_role_$def_verify$0$Abort_correct  (=> (= inline$$Roles_has_role_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@3@@16 true) (= (ControlFlow 0 95205) 95257)) anon0$2_correct@@17))))
(let ((inline$$Roles_has_role_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 95223) 95205)) inline$$Roles_has_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 95233) 95205) inline$$Roles_has_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0@@17 (and (=> (= (ControlFlow 0 95217) 95233) inline$$Roles_has_role_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 95217) 95223) inline$$Roles_has_role_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 95197) 95205)) inline$$Roles_has_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 95213) 95205) inline$$Roles_has_role_$def_verify$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon26_Then_correct  (=> $abort_flag@1@@17 (and (=> (= (ControlFlow 0 95191) 95213) inline$$Roles_has_role_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 95191) 95197) inline$$Roles_has_role_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def_verify$0$anon20_correct  (=> (and (= $abort_flag@3@@16 $abort_flag@2@@17) (= (ControlFlow 0 94912) 95257)) anon0$2_correct@@17)))
(let ((inline$$Roles_has_role_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 94910) 94912)) inline$$Roles_has_role_$def_verify$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 94920) 94912) inline$$Roles_has_role_$def_verify$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon16_correct  (=> (= $abort_flag@2@@17 $abort_flag@1@@17) (and (=> (= (ControlFlow 0 95179) 94920) inline$$Roles_has_role_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 95179) 94910) inline$$Roles_has_role_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 95177) 95179)) inline$$Roles_has_role_$def_verify$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 95187) 95179) inline$$Roles_has_role_$def_verify$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def_verify$0$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@14 role_id@@0))) (and (=> (= (ControlFlow 0 95171) 95187) inline$$Roles_has_role_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 95171) 95177) inline$$Roles_has_role_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@14  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@4)) $Roles_RoleId_role_id)) (= (ControlFlow 0 95155) 95171)) inline$$Roles_has_role_$def_verify$0$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@1@@17) (= (ControlFlow 0 95161) 95155)) inline$$GetFieldFromValue$0$anon0_correct@@14)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@14  (=> (= $abort_flag@1@@17 true) (and (=> (= (ControlFlow 0 95101) 95191) inline$$Roles_has_role_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 95101) 95161) inline$$Roles_has_role_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@14  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@14)) (= (ControlFlow 0 95099) 95101)) inline$$GetGlobal$0$anon3_Then$1_correct@@14)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@14  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@14) (=> (and (= inline$$GetGlobal$0$dst@1@@14 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@36))) (= $abort_flag@1@@17 $abort_flag@0@@17)) (and (=> (= (ControlFlow 0 95047) 95191) inline$$Roles_has_role_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 95047) 95161) inline$$Roles_has_role_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@14  (=> (= inline$$GetGlobal$0$a@1@@14 (|a#$Address| call3formal@$ret0@0@@36)) (and (=> (= (ControlFlow 0 95029) 95099) inline$$GetGlobal$0$anon3_Then_correct@@14) (=> (= (ControlFlow 0 95029) 95047) inline$$GetGlobal$0$anon3_Else_correct@@14)))))
(let ((inline$$GetGlobal$0$Entry_correct@@14  (and (=> (= (ControlFlow 0 95023) (- 0 154747)) true) (=> (= (ControlFlow 0 95023) 95029) inline$$GetGlobal$0$anon0_correct@@14))))
(let ((inline$$Roles_has_role_$def_verify$0$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def_verify$0$$t6@1) (= (ControlFlow 0 95107) 95023)) inline$$GetGlobal$0$Entry_correct@@14)))
(let ((inline$$Roles_has_role_$def_verify$0$anon18_correct  (=> (= $abort_flag@2@@17 $abort_flag@0@@17) (and (=> (= (ControlFlow 0 94900) 94920) inline$$Roles_has_role_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 94900) 94910) inline$$Roles_has_role_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Roles_has_role_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 94898) 94900)) inline$$Roles_has_role_$def_verify$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 94928) 94900) inline$$Roles_has_role_$def_verify$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def_verify$0$$t6@1)) (= inline$$Roles_has_role_$def_verify$0$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 94890) 94928) inline$$Roles_has_role_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 94890) 94898) inline$$Roles_has_role_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@0@@17) (= inline$$Roles_has_role_$def_verify$0$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@36))))) (and (=> (= (ControlFlow 0 94846) 95107) inline$$Roles_has_role_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 94846) 94890) inline$$Roles_has_role_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@17) (=> $abort_flag@0@@17 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@36 account@@12)))) ((_ is $Address) call3formal@$ret0@0@@36))) (and (=> (= (ControlFlow 0 94832) 95217) inline$$Roles_has_role_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 94832) 94846) inline$$Roles_has_role_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 94762) 94832)) inline$$Roles_has_role_$def_verify$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 95241) 94832) inline$$Roles_has_role_$def_verify$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 94754) 95241) inline$$Roles_has_role_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 94754) 94762) inline$$Roles_has_role_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 95249) 95241) inline$$Roles_has_role_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 95249) 94762) inline$$Roles_has_role_$def_verify$0$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 94748) 95249) inline$$Roles_has_role_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 94748) 94754) inline$$Roles_has_role_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@17  (=> (and (forall (($inv_addr@@19 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19)) (let ((va@@28 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@19))
)) (= (ControlFlow 0 95255) 94748)) inline$$Roles_has_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@17  (=> ((_ is $Address) account@@12) (=> (and (and (and ((_ is $Integer) role_id@@0) (>= (|i#$Integer| role_id@@0) 0)) (<= (|i#$Integer| role_id@@0) $MAX_U64)) (= (ControlFlow 0 94348) 95255)) anon0$1_correct@@17))))
(let ((PreconditionGeneratedEntry_correct@@17  (=> (= (ControlFlow 0 153607) 94348) anon0_correct@@17)))
PreconditionGeneratedEntry_correct@@17))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@14 () Bool)
(declare-fun $abort_flag@3@@17 () Bool)
(declare-fun inline$$Roles_has_treasury_compliance_role_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1@@4 () T@$Value)
(declare-fun $abort_flag@0@@18 () Bool)
(declare-fun $abort_flag@1@@18 () Bool)
(declare-fun $abort_flag@2@@18 () Bool)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1@@4| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@15 () T@$Value)
(declare-fun inline$$Roles_has_treasury_compliance_role_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@5 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@15 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@15 () T@$Value)
(declare-fun call3formal@$ret0@0@@37 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1@@4 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1@@4 () T@$Value)
(declare-fun account@@13 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 155634) (let ((anon0$2_correct@@18  (and (=> (= (ControlFlow 0 96644) (- 0 157100)) (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@236 T@$Value) )  (=> ((_ is $Address) addr@@236) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@236)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@236)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@236)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@236)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@237 T@$Value) )  (=> ((_ is $Address) addr@@237) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@237)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@237)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@237)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@237)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 96644) (- 0 157200)) (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@238 T@$Value) )  (=> ((_ is $Address) addr@@238) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@238)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@238)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@238)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@238)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@239 T@$Value) )  (=> ((_ is $Address) addr@@239) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@239)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@239)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@239)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@239)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 96644) (- 0 157300)) (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@240 T@$Value) )  (=> ((_ is $Address) addr@@240) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@240)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@240)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@240)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@240)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@241 T@$Value) )  (=> ((_ is $Address) addr@@241) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@241)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@241)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@241)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@241)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 96644) (- 0 157400)) (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@242 T@$Value) )  (=> ((_ is $Address) addr@@242) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@242)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@242)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@242)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@242)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@243 T@$Value) )  (=> ((_ is $Address) addr@@243) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@243)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@243)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@243)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@243)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 96644) (- 0 157500)) (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@244 T@$Value) )  (=> ((_ is $Address) addr@@244) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@244)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@244)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@244)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@244)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@245 T@$Value) )  (=> ((_ is $Address) addr@@245) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@245)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@245)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@245)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@245)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 96644) (- 0 157600)) (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@246 T@$Value) )  (=> ((_ is $Address) addr@@246) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@246)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@246)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@246)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@246)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@247 T@$Value) )  (=> ((_ is $Address) addr@@247) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@247)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@247)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@247)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@247)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 96644) (- 0 157700)) (=> (not $abort_flag@4@@14) (|b#$Boolean| ($Boolean (forall ((addr@@248 T@$Value) )  (=> ((_ is $Address) addr@@248) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@248)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@248)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@248)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@248)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@4@@14 $abort_flag@3@@17) (= (ControlFlow 0 96612) 96644)) anon0$2_correct@@18)))
(let ((inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 96610) 96612)) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 96620) 96612) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@3@@17) (and (=> (= (ControlFlow 0 96604) 96620) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 96604) 96610) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon8_Then_correct  (=> (and (and $abort_flag@3@@17 (= inline$$Roles_has_treasury_compliance_role_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@4@@14 true) (= (ControlFlow 0 96628) 96644))) anon0$2_correct@@18)))
(let ((inline$$Roles_has_role_$def$0$Abort_correct@@4  (=> (and (= inline$$Roles_has_role_$def$0$$ret0@1@@4 $Error) (= $abort_flag@3@@17 true)) (and (=> (= (ControlFlow 0 96536) 96628) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 96536) 96604) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 96554) 96536)) inline$$Roles_has_role_$def$0$Abort_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct@@4  (=> (= (ControlFlow 0 96564) 96536) inline$$Roles_has_role_$def$0$Abort_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct@@4  (=> $abort_flag@0@@18 (and (=> (= (ControlFlow 0 96548) 96564) inline$$Roles_has_role_$def$0$anon24_Then_correct@@4) (=> (= (ControlFlow 0 96548) 96554) inline$$Roles_has_role_$def$0$anon24_Else_correct@@4)))))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 96528) 96536)) inline$$Roles_has_role_$def$0$Abort_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct@@4  (=> (= (ControlFlow 0 96544) 96536) inline$$Roles_has_role_$def$0$Abort_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct@@4  (=> $abort_flag@1@@18 (and (=> (= (ControlFlow 0 96522) 96544) inline$$Roles_has_role_$def$0$anon27_Then_correct@@4) (=> (= (ControlFlow 0 96522) 96528) inline$$Roles_has_role_$def$0$anon27_Else_correct@@4)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct@@4  (=> (= $abort_flag@3@@17 $abort_flag@2@@18) (and (=> (= (ControlFlow 0 96243) 96628) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 96243) 96604) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 96241) 96243)) inline$$Roles_has_role_$def$0$anon20_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct@@4  (=> (= (ControlFlow 0 96251) 96243) inline$$Roles_has_role_$def$0$anon20_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct@@4  (=> (= $abort_flag@2@@18 $abort_flag@1@@18) (and (=> (= (ControlFlow 0 96510) 96251) inline$$Roles_has_role_$def$0$anon30_Then_correct@@4) (=> (= (ControlFlow 0 96510) 96241) inline$$Roles_has_role_$def$0$anon30_Else_correct@@4)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 96508) 96510)) inline$$Roles_has_role_$def$0$anon16_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct@@4  (=> (= (ControlFlow 0 96518) 96510) inline$$Roles_has_role_$def$0$anon16_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@4  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1@@4| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@15 inline$$Roles_has_treasury_compliance_role_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 96502) 96518) inline$$Roles_has_role_$def$0$anon28_Then_correct@@4) (=> (= (ControlFlow 0 96502) 96508) inline$$Roles_has_role_$def$0$anon28_Else_correct@@4)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@15  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@5)) $Roles_RoleId_role_id)) (= (ControlFlow 0 96486) 96502)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct@@4  (=> (and (not $abort_flag@1@@18) (= (ControlFlow 0 96492) 96486)) inline$$GetFieldFromValue$0$anon0_correct@@15)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@15  (=> (= $abort_flag@1@@18 true) (and (=> (= (ControlFlow 0 96432) 96522) inline$$Roles_has_role_$def$0$anon26_Then_correct@@4) (=> (= (ControlFlow 0 96432) 96492) inline$$Roles_has_role_$def$0$anon26_Else_correct@@4)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@15  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@15)) (= (ControlFlow 0 96430) 96432)) inline$$GetGlobal$0$anon3_Then$1_correct@@15)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@15  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@15) (=> (and (= inline$$GetGlobal$0$dst@1@@15 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@37))) (= $abort_flag@1@@18 $abort_flag@0@@18)) (and (=> (= (ControlFlow 0 96378) 96522) inline$$Roles_has_role_$def$0$anon26_Then_correct@@4) (=> (= (ControlFlow 0 96378) 96492) inline$$Roles_has_role_$def$0$anon26_Else_correct@@4))))))
(let ((inline$$GetGlobal$0$anon0_correct@@15  (=> (= inline$$GetGlobal$0$a@1@@15 (|a#$Address| call3formal@$ret0@0@@37)) (and (=> (= (ControlFlow 0 96360) 96430) inline$$GetGlobal$0$anon3_Then_correct@@15) (=> (= (ControlFlow 0 96360) 96378) inline$$GetGlobal$0$anon3_Else_correct@@15)))))
(let ((inline$$GetGlobal$0$Entry_correct@@15  (and (=> (= (ControlFlow 0 96354) (- 0 156876)) true) (=> (= (ControlFlow 0 96354) 96360) inline$$GetGlobal$0$anon0_correct@@15))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct@@4  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@4) (= (ControlFlow 0 96438) 96354)) inline$$GetGlobal$0$Entry_correct@@15)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct@@4  (=> (= $abort_flag@2@@18 $abort_flag@0@@18) (and (=> (= (ControlFlow 0 96231) 96251) inline$$Roles_has_role_$def$0$anon30_Then_correct@@4) (=> (= (ControlFlow 0 96231) 96241) inline$$Roles_has_role_$def$0$anon30_Else_correct@@4)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 96229) 96231)) inline$$Roles_has_role_$def$0$anon18_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct@@4  (=> (= (ControlFlow 0 96259) 96231) inline$$Roles_has_role_$def$0$anon18_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct@@4  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@4)) (= inline$$Roles_has_role_$def$0$$t9@1@@4 ($Boolean false))) (and (=> (= (ControlFlow 0 96221) 96259) inline$$Roles_has_role_$def$0$anon29_Then_correct@@4) (=> (= (ControlFlow 0 96221) 96229) inline$$Roles_has_role_$def$0$anon29_Else_correct@@4)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct@@4  (=> (and (not $abort_flag@0@@18) (= inline$$Roles_has_role_$def$0$$t6@1@@4 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@37))))) (and (=> (= (ControlFlow 0 96177) 96438) inline$$Roles_has_role_$def$0$anon25_Then_correct@@4) (=> (= (ControlFlow 0 96177) 96221) inline$$Roles_has_role_$def$0$anon25_Else_correct@@4)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct@@4  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@18) (=> $abort_flag@0@@18 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@37 account@@13)))) ((_ is $Address) call3formal@$ret0@0@@37))) (and (=> (= (ControlFlow 0 96163) 96548) inline$$Roles_has_role_$def$0$anon23_Then_correct@@4) (=> (= (ControlFlow 0 96163) 96177) inline$$Roles_has_role_$def$0$anon23_Else_correct@@4)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 96093) 96163)) inline$$Roles_has_role_$def$0$anon4$2_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct@@4  (=> (= (ControlFlow 0 96572) 96163) inline$$Roles_has_role_$def$0$anon4$2_correct@@4)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct@@4  (=> (not true) (and (=> (= (ControlFlow 0 96085) 96572) inline$$Roles_has_role_$def$0$anon22_Then_correct@@4) (=> (= (ControlFlow 0 96085) 96093) inline$$Roles_has_role_$def$0$anon22_Else_correct@@4)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct@@4  (and (=> (= (ControlFlow 0 96580) 96572) inline$$Roles_has_role_$def$0$anon22_Then_correct@@4) (=> (= (ControlFlow 0 96580) 96093) inline$$Roles_has_role_$def$0$anon22_Else_correct@@4))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct@@4  (=> (not false) (and (=> (= (ControlFlow 0 96079) 96580) inline$$Roles_has_role_$def$0$anon21_Then_correct@@4) (=> (= (ControlFlow 0 96079) 96085) inline$$Roles_has_role_$def$0$anon21_Else_correct@@4)))))
(let ((inline$$Roles_has_role_$direct_intra$0$anon0_correct@@3  (=> ((_ is $Address) account@@13) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_treasury_compliance_role_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_treasury_compliance_role_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_treasury_compliance_role_$def_verify$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 96586) 96079)) inline$$Roles_has_role_$def$0$anon0_correct@@4))))
(let ((inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon2$1_correct  (=> (and (= inline$$Roles_has_treasury_compliance_role_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 96594) 96586)) inline$$Roles_has_role_$direct_intra$0$anon0_correct@@3)))
(let ((inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 95606) 96594)) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 96636) 96594) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 95600) 96636) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 95600) 95606) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@18  (=> (and (forall (($inv_addr@@20 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@20)) (let ((va@@29 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@20))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@20))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@20))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@20))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@20))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@20))
)) (= (ControlFlow 0 96642) 95600)) inline$$Roles_has_treasury_compliance_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@18  (=> (and ((_ is $Address) account@@13) (= (ControlFlow 0 95425) 96642)) anon0$1_correct@@18)))
(let ((PreconditionGeneratedEntry_correct@@18  (=> (= (ControlFlow 0 155634) 95425) anon0_correct@@18)))
PreconditionGeneratedEntry_correct@@18))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@15 () Bool)
(declare-fun $abort_flag@3@@18 () Bool)
(declare-fun inline$$Roles_has_validator_operator_role_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1@@5 () T@$Value)
(declare-fun $abort_flag@0@@19 () Bool)
(declare-fun $abort_flag@1@@19 () Bool)
(declare-fun $abort_flag@2@@19 () Bool)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1@@5| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@16 () T@$Value)
(declare-fun inline$$Roles_has_validator_operator_role_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@6 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@16 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@16 () T@$Value)
(declare-fun call3formal@$ret0@0@@38 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1@@5 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1@@5 () T@$Value)
(declare-fun account@@14 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 157805) (let ((anon0$2_correct@@19  (and (=> (= (ControlFlow 0 98075) (- 0 159271)) (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@249 T@$Value) )  (=> ((_ is $Address) addr@@249) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@249)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@249)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@249)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@249)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@250 T@$Value) )  (=> ((_ is $Address) addr@@250) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@250)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@250)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@250)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@250)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 98075) (- 0 159371)) (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@251 T@$Value) )  (=> ((_ is $Address) addr@@251) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@251)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@251)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@251)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@251)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@252 T@$Value) )  (=> ((_ is $Address) addr@@252) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@252)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@252)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@252)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@252)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 98075) (- 0 159471)) (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@253 T@$Value) )  (=> ((_ is $Address) addr@@253) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@253)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@253)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@253)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@253)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@254 T@$Value) )  (=> ((_ is $Address) addr@@254) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@254)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@254)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@254)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@254)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 98075) (- 0 159571)) (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@255 T@$Value) )  (=> ((_ is $Address) addr@@255) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@255)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@255)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@255)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@255)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@256 T@$Value) )  (=> ((_ is $Address) addr@@256) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@256)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@256)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@256)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@256)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 98075) (- 0 159671)) (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@257 T@$Value) )  (=> ((_ is $Address) addr@@257) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@257)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@257)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@257)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@257)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@258 T@$Value) )  (=> ((_ is $Address) addr@@258) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@258)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@258)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@258)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@258)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 98075) (- 0 159771)) (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@259 T@$Value) )  (=> ((_ is $Address) addr@@259) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@259)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@259)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@259)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@259)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@260 T@$Value) )  (=> ((_ is $Address) addr@@260) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@260)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@260)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@260)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@260)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 98075) (- 0 159871)) (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean (forall ((addr@@261 T@$Value) )  (=> ((_ is $Address) addr@@261) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@261)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@261)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@261)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@261)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_has_validator_operator_role_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@4@@15 $abort_flag@3@@18) (= (ControlFlow 0 98043) 98075)) anon0$2_correct@@19)))
(let ((inline$$Roles_has_validator_operator_role_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 98041) 98043)) inline$$Roles_has_validator_operator_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_validator_operator_role_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 98051) 98043) inline$$Roles_has_validator_operator_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_validator_operator_role_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@3@@18) (and (=> (= (ControlFlow 0 98035) 98051) inline$$Roles_has_validator_operator_role_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 98035) 98041) inline$$Roles_has_validator_operator_role_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_validator_operator_role_$def_verify$0$anon8_Then_correct  (=> (and (and $abort_flag@3@@18 (= inline$$Roles_has_validator_operator_role_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@4@@15 true) (= (ControlFlow 0 98059) 98075))) anon0$2_correct@@19)))
(let ((inline$$Roles_has_role_$def$0$Abort_correct@@5  (=> (and (= inline$$Roles_has_role_$def$0$$ret0@1@@5 $Error) (= $abort_flag@3@@18 true)) (and (=> (= (ControlFlow 0 97967) 98059) inline$$Roles_has_validator_operator_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 97967) 98035) inline$$Roles_has_validator_operator_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct@@5  (=> (and (not true) (= (ControlFlow 0 97985) 97967)) inline$$Roles_has_role_$def$0$Abort_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct@@5  (=> (= (ControlFlow 0 97995) 97967) inline$$Roles_has_role_$def$0$Abort_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct@@5  (=> $abort_flag@0@@19 (and (=> (= (ControlFlow 0 97979) 97995) inline$$Roles_has_role_$def$0$anon24_Then_correct@@5) (=> (= (ControlFlow 0 97979) 97985) inline$$Roles_has_role_$def$0$anon24_Else_correct@@5)))))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct@@5  (=> (and (not true) (= (ControlFlow 0 97959) 97967)) inline$$Roles_has_role_$def$0$Abort_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct@@5  (=> (= (ControlFlow 0 97975) 97967) inline$$Roles_has_role_$def$0$Abort_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct@@5  (=> $abort_flag@1@@19 (and (=> (= (ControlFlow 0 97953) 97975) inline$$Roles_has_role_$def$0$anon27_Then_correct@@5) (=> (= (ControlFlow 0 97953) 97959) inline$$Roles_has_role_$def$0$anon27_Else_correct@@5)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct@@5  (=> (= $abort_flag@3@@18 $abort_flag@2@@19) (and (=> (= (ControlFlow 0 97674) 98059) inline$$Roles_has_validator_operator_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 97674) 98035) inline$$Roles_has_validator_operator_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct@@5  (=> (and (not true) (= (ControlFlow 0 97672) 97674)) inline$$Roles_has_role_$def$0$anon20_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct@@5  (=> (= (ControlFlow 0 97682) 97674) inline$$Roles_has_role_$def$0$anon20_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct@@5  (=> (= $abort_flag@2@@19 $abort_flag@1@@19) (and (=> (= (ControlFlow 0 97941) 97682) inline$$Roles_has_role_$def$0$anon30_Then_correct@@5) (=> (= (ControlFlow 0 97941) 97672) inline$$Roles_has_role_$def$0$anon30_Else_correct@@5)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct@@5  (=> (and (not true) (= (ControlFlow 0 97939) 97941)) inline$$Roles_has_role_$def$0$anon16_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct@@5  (=> (= (ControlFlow 0 97949) 97941) inline$$Roles_has_role_$def$0$anon16_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@5  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1@@5| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@16 inline$$Roles_has_validator_operator_role_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 97933) 97949) inline$$Roles_has_role_$def$0$anon28_Then_correct@@5) (=> (= (ControlFlow 0 97933) 97939) inline$$Roles_has_role_$def$0$anon28_Else_correct@@5)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@16  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@6)) $Roles_RoleId_role_id)) (= (ControlFlow 0 97917) 97933)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct@@5  (=> (and (not $abort_flag@1@@19) (= (ControlFlow 0 97923) 97917)) inline$$GetFieldFromValue$0$anon0_correct@@16)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@16  (=> (= $abort_flag@1@@19 true) (and (=> (= (ControlFlow 0 97863) 97953) inline$$Roles_has_role_$def$0$anon26_Then_correct@@5) (=> (= (ControlFlow 0 97863) 97923) inline$$Roles_has_role_$def$0$anon26_Else_correct@@5)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@16  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@16)) (= (ControlFlow 0 97861) 97863)) inline$$GetGlobal$0$anon3_Then$1_correct@@16)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@16  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@16) (=> (and (= inline$$GetGlobal$0$dst@1@@16 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@38))) (= $abort_flag@1@@19 $abort_flag@0@@19)) (and (=> (= (ControlFlow 0 97809) 97953) inline$$Roles_has_role_$def$0$anon26_Then_correct@@5) (=> (= (ControlFlow 0 97809) 97923) inline$$Roles_has_role_$def$0$anon26_Else_correct@@5))))))
(let ((inline$$GetGlobal$0$anon0_correct@@16  (=> (= inline$$GetGlobal$0$a@1@@16 (|a#$Address| call3formal@$ret0@0@@38)) (and (=> (= (ControlFlow 0 97791) 97861) inline$$GetGlobal$0$anon3_Then_correct@@16) (=> (= (ControlFlow 0 97791) 97809) inline$$GetGlobal$0$anon3_Else_correct@@16)))))
(let ((inline$$GetGlobal$0$Entry_correct@@16  (and (=> (= (ControlFlow 0 97785) (- 0 159047)) true) (=> (= (ControlFlow 0 97785) 97791) inline$$GetGlobal$0$anon0_correct@@16))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct@@5  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@5) (= (ControlFlow 0 97869) 97785)) inline$$GetGlobal$0$Entry_correct@@16)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct@@5  (=> (= $abort_flag@2@@19 $abort_flag@0@@19) (and (=> (= (ControlFlow 0 97662) 97682) inline$$Roles_has_role_$def$0$anon30_Then_correct@@5) (=> (= (ControlFlow 0 97662) 97672) inline$$Roles_has_role_$def$0$anon30_Else_correct@@5)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct@@5  (=> (and (not true) (= (ControlFlow 0 97660) 97662)) inline$$Roles_has_role_$def$0$anon18_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct@@5  (=> (= (ControlFlow 0 97690) 97662) inline$$Roles_has_role_$def$0$anon18_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct@@5  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@5)) (= inline$$Roles_has_role_$def$0$$t9@1@@5 ($Boolean false))) (and (=> (= (ControlFlow 0 97652) 97690) inline$$Roles_has_role_$def$0$anon29_Then_correct@@5) (=> (= (ControlFlow 0 97652) 97660) inline$$Roles_has_role_$def$0$anon29_Else_correct@@5)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct@@5  (=> (and (not $abort_flag@0@@19) (= inline$$Roles_has_role_$def$0$$t6@1@@5 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@38))))) (and (=> (= (ControlFlow 0 97608) 97869) inline$$Roles_has_role_$def$0$anon25_Then_correct@@5) (=> (= (ControlFlow 0 97608) 97652) inline$$Roles_has_role_$def$0$anon25_Else_correct@@5)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct@@5  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@19) (=> $abort_flag@0@@19 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@38 account@@14)))) ((_ is $Address) call3formal@$ret0@0@@38))) (and (=> (= (ControlFlow 0 97594) 97979) inline$$Roles_has_role_$def$0$anon23_Then_correct@@5) (=> (= (ControlFlow 0 97594) 97608) inline$$Roles_has_role_$def$0$anon23_Else_correct@@5)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct@@5  (=> (and (not true) (= (ControlFlow 0 97524) 97594)) inline$$Roles_has_role_$def$0$anon4$2_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct@@5  (=> (= (ControlFlow 0 98003) 97594) inline$$Roles_has_role_$def$0$anon4$2_correct@@5)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct@@5  (=> (not true) (and (=> (= (ControlFlow 0 97516) 98003) inline$$Roles_has_role_$def$0$anon22_Then_correct@@5) (=> (= (ControlFlow 0 97516) 97524) inline$$Roles_has_role_$def$0$anon22_Else_correct@@5)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct@@5  (and (=> (= (ControlFlow 0 98011) 98003) inline$$Roles_has_role_$def$0$anon22_Then_correct@@5) (=> (= (ControlFlow 0 98011) 97524) inline$$Roles_has_role_$def$0$anon22_Else_correct@@5))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct@@5  (=> (not false) (and (=> (= (ControlFlow 0 97510) 98011) inline$$Roles_has_role_$def$0$anon21_Then_correct@@5) (=> (= (ControlFlow 0 97510) 97516) inline$$Roles_has_role_$def$0$anon21_Else_correct@@5)))))
(let ((inline$$Roles_has_role_$direct_intra$0$anon0_correct@@4  (=> ((_ is $Address) account@@14) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_validator_operator_role_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_validator_operator_role_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_validator_operator_role_$def_verify$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 98017) 97510)) inline$$Roles_has_role_$def$0$anon0_correct@@5))))
(let ((inline$$Roles_has_validator_operator_role_$def_verify$0$anon2$1_correct  (=> (and (= inline$$Roles_has_validator_operator_role_$def_verify$0$$t2@1 ($Integer 4)) (= (ControlFlow 0 98025) 98017)) inline$$Roles_has_role_$direct_intra$0$anon0_correct@@4)))
(let ((inline$$Roles_has_validator_operator_role_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 97037) 98025)) inline$$Roles_has_validator_operator_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_validator_operator_role_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 98067) 98025) inline$$Roles_has_validator_operator_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_validator_operator_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 97031) 98067) inline$$Roles_has_validator_operator_role_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 97031) 97037) inline$$Roles_has_validator_operator_role_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@19  (=> (and (forall (($inv_addr@@21 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@21)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@21))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@21))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@21))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@21))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@21))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@21))
)) (= (ControlFlow 0 98073) 97031)) inline$$Roles_has_validator_operator_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@19  (=> (and ((_ is $Address) account@@14) (= (ControlFlow 0 96856) 98073)) anon0$1_correct@@19)))
(let ((PreconditionGeneratedEntry_correct@@19  (=> (= (ControlFlow 0 157805) 96856) anon0_correct@@19)))
PreconditionGeneratedEntry_correct@@19))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@4@@16 () Bool)
(declare-fun $abort_flag@3@@19 () Bool)
(declare-fun inline$$Roles_has_validator_role_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1@@6 () T@$Value)
(declare-fun $abort_flag@0@@20 () Bool)
(declare-fun $abort_flag@1@@20 () Bool)
(declare-fun $abort_flag@2@@20 () Bool)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1@@6| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@17 () T@$Value)
(declare-fun inline$$Roles_has_validator_role_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@7 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@17 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@17 () T@$Value)
(declare-fun call3formal@$ret0@0@@39 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1@@6 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1@@6 () T@$Value)
(declare-fun account@@15 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 159976) (let ((anon0$2_correct@@20  (and (=> (= (ControlFlow 0 99506) (- 0 161442)) (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@262 T@$Value) )  (=> ((_ is $Address) addr@@262) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@262)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@262)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@262)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@262)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@263 T@$Value) )  (=> ((_ is $Address) addr@@263) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@263)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@263)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@263)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@263)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 99506) (- 0 161542)) (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@264 T@$Value) )  (=> ((_ is $Address) addr@@264) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@264)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@264)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@264)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@264)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@265 T@$Value) )  (=> ((_ is $Address) addr@@265) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@265)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@265)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@265)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@265)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 99506) (- 0 161642)) (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@266 T@$Value) )  (=> ((_ is $Address) addr@@266) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@266)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@266)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@266)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@266)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@267 T@$Value) )  (=> ((_ is $Address) addr@@267) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@267)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@267)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@267)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@267)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 99506) (- 0 161742)) (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@268 T@$Value) )  (=> ((_ is $Address) addr@@268) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@268)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@268)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@268)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@268)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@269 T@$Value) )  (=> ((_ is $Address) addr@@269) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@269)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@269)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@269)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@269)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 99506) (- 0 161842)) (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@270 T@$Value) )  (=> ((_ is $Address) addr@@270) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@270)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@270)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@270)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@270)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@271 T@$Value) )  (=> ((_ is $Address) addr@@271) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@271)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@271)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@271)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@271)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 99506) (- 0 161942)) (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@272 T@$Value) )  (=> ((_ is $Address) addr@@272) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@272)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@272)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@272)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@272)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@273 T@$Value) )  (=> ((_ is $Address) addr@@273) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@273)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@273)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@273)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@273)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 99506) (- 0 162042)) (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean (forall ((addr@@274 T@$Value) )  (=> ((_ is $Address) addr@@274) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@274)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@274)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@274)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@274)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))
(let ((inline$$Roles_has_validator_role_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@4@@16 $abort_flag@3@@19) (= (ControlFlow 0 99474) 99506)) anon0$2_correct@@20)))
(let ((inline$$Roles_has_validator_role_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 99472) 99474)) inline$$Roles_has_validator_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_validator_role_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 99482) 99474) inline$$Roles_has_validator_role_$def_verify$0$anon6_correct)))
(let ((inline$$Roles_has_validator_role_$def_verify$0$anon8_Else_correct  (=> (not $abort_flag@3@@19) (and (=> (= (ControlFlow 0 99466) 99482) inline$$Roles_has_validator_role_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 99466) 99472) inline$$Roles_has_validator_role_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_validator_role_$def_verify$0$anon8_Then_correct  (=> (and (and $abort_flag@3@@19 (= inline$$Roles_has_validator_role_$def_verify$0$$ret0@1 $Error)) (and (= $abort_flag@4@@16 true) (= (ControlFlow 0 99490) 99506))) anon0$2_correct@@20)))
(let ((inline$$Roles_has_role_$def$0$Abort_correct@@6  (=> (and (= inline$$Roles_has_role_$def$0$$ret0@1@@6 $Error) (= $abort_flag@3@@19 true)) (and (=> (= (ControlFlow 0 99398) 99490) inline$$Roles_has_validator_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 99398) 99466) inline$$Roles_has_validator_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct@@6  (=> (and (not true) (= (ControlFlow 0 99416) 99398)) inline$$Roles_has_role_$def$0$Abort_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct@@6  (=> (= (ControlFlow 0 99426) 99398) inline$$Roles_has_role_$def$0$Abort_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct@@6  (=> $abort_flag@0@@20 (and (=> (= (ControlFlow 0 99410) 99426) inline$$Roles_has_role_$def$0$anon24_Then_correct@@6) (=> (= (ControlFlow 0 99410) 99416) inline$$Roles_has_role_$def$0$anon24_Else_correct@@6)))))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct@@6  (=> (and (not true) (= (ControlFlow 0 99390) 99398)) inline$$Roles_has_role_$def$0$Abort_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct@@6  (=> (= (ControlFlow 0 99406) 99398) inline$$Roles_has_role_$def$0$Abort_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct@@6  (=> $abort_flag@1@@20 (and (=> (= (ControlFlow 0 99384) 99406) inline$$Roles_has_role_$def$0$anon27_Then_correct@@6) (=> (= (ControlFlow 0 99384) 99390) inline$$Roles_has_role_$def$0$anon27_Else_correct@@6)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct@@6  (=> (= $abort_flag@3@@19 $abort_flag@2@@20) (and (=> (= (ControlFlow 0 99105) 99490) inline$$Roles_has_validator_role_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 99105) 99466) inline$$Roles_has_validator_role_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct@@6  (=> (and (not true) (= (ControlFlow 0 99103) 99105)) inline$$Roles_has_role_$def$0$anon20_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct@@6  (=> (= (ControlFlow 0 99113) 99105) inline$$Roles_has_role_$def$0$anon20_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct@@6  (=> (= $abort_flag@2@@20 $abort_flag@1@@20) (and (=> (= (ControlFlow 0 99372) 99113) inline$$Roles_has_role_$def$0$anon30_Then_correct@@6) (=> (= (ControlFlow 0 99372) 99103) inline$$Roles_has_role_$def$0$anon30_Else_correct@@6)))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct@@6  (=> (and (not true) (= (ControlFlow 0 99370) 99372)) inline$$Roles_has_role_$def$0$anon16_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct@@6  (=> (= (ControlFlow 0 99380) 99372) inline$$Roles_has_role_$def$0$anon16_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@6  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1@@6| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1@@17 inline$$Roles_has_validator_role_$def_verify$0$$t2@1))) (and (=> (= (ControlFlow 0 99364) 99380) inline$$Roles_has_role_$def$0$anon28_Then_correct@@6) (=> (= (ControlFlow 0 99364) 99370) inline$$Roles_has_role_$def$0$anon28_Else_correct@@6)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@17  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@7)) $Roles_RoleId_role_id)) (= (ControlFlow 0 99348) 99364)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct@@6  (=> (and (not $abort_flag@1@@20) (= (ControlFlow 0 99354) 99348)) inline$$GetFieldFromValue$0$anon0_correct@@17)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@17  (=> (= $abort_flag@1@@20 true) (and (=> (= (ControlFlow 0 99294) 99384) inline$$Roles_has_role_$def$0$anon26_Then_correct@@6) (=> (= (ControlFlow 0 99294) 99354) inline$$Roles_has_role_$def$0$anon26_Else_correct@@6)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@17  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@17)) (= (ControlFlow 0 99292) 99294)) inline$$GetGlobal$0$anon3_Then$1_correct@@17)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@17  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@17) (=> (and (= inline$$GetGlobal$0$dst@1@@17 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@39))) (= $abort_flag@1@@20 $abort_flag@0@@20)) (and (=> (= (ControlFlow 0 99240) 99384) inline$$Roles_has_role_$def$0$anon26_Then_correct@@6) (=> (= (ControlFlow 0 99240) 99354) inline$$Roles_has_role_$def$0$anon26_Else_correct@@6))))))
(let ((inline$$GetGlobal$0$anon0_correct@@17  (=> (= inline$$GetGlobal$0$a@1@@17 (|a#$Address| call3formal@$ret0@0@@39)) (and (=> (= (ControlFlow 0 99222) 99292) inline$$GetGlobal$0$anon3_Then_correct@@17) (=> (= (ControlFlow 0 99222) 99240) inline$$GetGlobal$0$anon3_Else_correct@@17)))))
(let ((inline$$GetGlobal$0$Entry_correct@@17  (and (=> (= (ControlFlow 0 99216) (- 0 161218)) true) (=> (= (ControlFlow 0 99216) 99222) inline$$GetGlobal$0$anon0_correct@@17))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct@@6  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@6) (= (ControlFlow 0 99300) 99216)) inline$$GetGlobal$0$Entry_correct@@17)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct@@6  (=> (= $abort_flag@2@@20 $abort_flag@0@@20) (and (=> (= (ControlFlow 0 99093) 99113) inline$$Roles_has_role_$def$0$anon30_Then_correct@@6) (=> (= (ControlFlow 0 99093) 99103) inline$$Roles_has_role_$def$0$anon30_Else_correct@@6)))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct@@6  (=> (and (not true) (= (ControlFlow 0 99091) 99093)) inline$$Roles_has_role_$def$0$anon18_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct@@6  (=> (= (ControlFlow 0 99121) 99093) inline$$Roles_has_role_$def$0$anon18_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct@@6  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1@@6)) (= inline$$Roles_has_role_$def$0$$t9@1@@6 ($Boolean false))) (and (=> (= (ControlFlow 0 99083) 99121) inline$$Roles_has_role_$def$0$anon29_Then_correct@@6) (=> (= (ControlFlow 0 99083) 99091) inline$$Roles_has_role_$def$0$anon29_Else_correct@@6)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct@@6  (=> (and (not $abort_flag@0@@20) (= inline$$Roles_has_role_$def$0$$t6@1@@6 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@39))))) (and (=> (= (ControlFlow 0 99039) 99300) inline$$Roles_has_role_$def$0$anon25_Then_correct@@6) (=> (= (ControlFlow 0 99039) 99083) inline$$Roles_has_role_$def$0$anon25_Else_correct@@6)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct@@6  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@20) (=> $abort_flag@0@@20 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@39 account@@15)))) ((_ is $Address) call3formal@$ret0@0@@39))) (and (=> (= (ControlFlow 0 99025) 99410) inline$$Roles_has_role_$def$0$anon23_Then_correct@@6) (=> (= (ControlFlow 0 99025) 99039) inline$$Roles_has_role_$def$0$anon23_Else_correct@@6)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct@@6  (=> (and (not true) (= (ControlFlow 0 98955) 99025)) inline$$Roles_has_role_$def$0$anon4$2_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct@@6  (=> (= (ControlFlow 0 99434) 99025) inline$$Roles_has_role_$def$0$anon4$2_correct@@6)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct@@6  (=> (not true) (and (=> (= (ControlFlow 0 98947) 99434) inline$$Roles_has_role_$def$0$anon22_Then_correct@@6) (=> (= (ControlFlow 0 98947) 98955) inline$$Roles_has_role_$def$0$anon22_Else_correct@@6)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct@@6  (and (=> (= (ControlFlow 0 99442) 99434) inline$$Roles_has_role_$def$0$anon22_Then_correct@@6) (=> (= (ControlFlow 0 99442) 98955) inline$$Roles_has_role_$def$0$anon22_Else_correct@@6))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct@@6  (=> (not false) (and (=> (= (ControlFlow 0 98941) 99442) inline$$Roles_has_role_$def$0$anon21_Then_correct@@6) (=> (= (ControlFlow 0 98941) 98947) inline$$Roles_has_role_$def$0$anon21_Else_correct@@6)))))
(let ((inline$$Roles_has_role_$direct_intra$0$anon0_correct@@5  (=> ((_ is $Address) account@@15) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_validator_role_$def_verify$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_validator_role_$def_verify$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_validator_role_$def_verify$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 99448) 98941)) inline$$Roles_has_role_$def$0$anon0_correct@@6))))
(let ((inline$$Roles_has_validator_role_$def_verify$0$anon2$1_correct  (=> (and (= inline$$Roles_has_validator_role_$def_verify$0$$t2@1 ($Integer 3)) (= (ControlFlow 0 99456) 99448)) inline$$Roles_has_role_$direct_intra$0$anon0_correct@@5)))
(let ((inline$$Roles_has_validator_role_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 98468) 99456)) inline$$Roles_has_validator_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_validator_role_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 99498) 99456) inline$$Roles_has_validator_role_$def_verify$0$anon2$1_correct)))
(let ((inline$$Roles_has_validator_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 98462) 99498) inline$$Roles_has_validator_role_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 98462) 98468) inline$$Roles_has_validator_role_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct@@20  (=> (and (forall (($inv_addr@@22 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@22))
)) (= (ControlFlow 0 99504) 98462)) inline$$Roles_has_validator_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@20  (=> (and ((_ is $Address) account@@15) (= (ControlFlow 0 98287) 99504)) anon0$1_correct@@20)))
(let ((PreconditionGeneratedEntry_correct@@20  (=> (= (ControlFlow 0 159976) 98287) anon0_correct@@20)))
PreconditionGeneratedEntry_correct@@20))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun creating_account () T@$Value)
(declare-fun $abort_flag@2@@21 () Bool)
(declare-fun new_account () T@$Value)
(declare-fun $abort_code@4@@11 () Int)
(declare-fun $Roles_RoleId_$memory@2@@1 () T@$Memory)
(declare-fun $abort_code@3@@11 () Int)
(declare-fun $Roles_RoleId_$memory@1@@2 () T@$Memory)
(declare-fun $abort_code@1@@11 () Int)
(declare-fun $abort_flag@0@@21 () Bool)
(declare-fun $Roles_RoleId_$memory@0@@2 () T@$Memory)
(declare-fun $abort_code@2@@12 () Int)
(declare-fun $abort_flag@1@@21 () Bool)
(declare-fun inline$$Roles_new_child_vasp_role_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Roles_new_child_vasp_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $Roles_RoleId_$CallerDomain@@2 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 162148) (let ((anon0$2_correct@@21  (and (=> (= (ControlFlow 0 100188) (- 0 165818)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) $abort_flag@2@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) $abort_flag@2@@21) (and (=> (= (ControlFlow 0 100188) (- 0 165838)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@2@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@2@@21) (and (=> (= (ControlFlow 0 100188) (- 0 165866)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account)))) $abort_flag@2@@21)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account)))) $abort_flag@2@@21) (and (=> (= (ControlFlow 0 100188) (- 0 165880)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) $abort_flag@2@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) $abort_flag@2@@21) (and (=> (= (ControlFlow 0 100188) (- 0 165900)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@2@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@2@@21) (and (=> (= (ControlFlow 0 100188) (- 0 165928)) (=> $abort_flag@2@@21 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5)))))))) (=> (=> $abort_flag@2@@21 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))))) (and (=> (= (ControlFlow 0 100188) (- 0 166034)) (=> $abort_flag@2@@21 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account)))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@2@@21 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account)))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 100188) (- 0 166195)) (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| new_account)))))) (=> (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| new_account))))) (and (=> (= (ControlFlow 0 100188) (- 0 166211)) (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| new_account)))) $Roles_RoleId_role_id) ($Integer 6)))))) (=> (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| new_account)))) $Roles_RoleId_role_id) ($Integer 6))))) (and (=> (= (ControlFlow 0 100188) (- 0 166239)) (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@275 T@$Value) )  (=> ((_ is $Address) addr@@275) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@275)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@275)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@275)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@275)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@276 T@$Value) )  (=> ((_ is $Address) addr@@276) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@276)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@276)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@276)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@276)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 100188) (- 0 166335)) (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@277 T@$Value) )  (=> ((_ is $Address) addr@@277) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@277)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@277)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@277)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@277)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@278 T@$Value) )  (=> ((_ is $Address) addr@@278) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@278)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@278)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@278)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@278)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 100188) (- 0 166431)) (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@279 T@$Value) )  (=> ((_ is $Address) addr@@279) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@279)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@279)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@279)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@279)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@280 T@$Value) )  (=> ((_ is $Address) addr@@280) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@280)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@280)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@280)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@280)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 100188) (- 0 166527)) (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@281 T@$Value) )  (=> ((_ is $Address) addr@@281) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@281)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@281)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@281)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@281)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@282 T@$Value) )  (=> ((_ is $Address) addr@@282) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@282)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@282)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@282)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@282)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 100188) (- 0 166623)) (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@283 T@$Value) )  (=> ((_ is $Address) addr@@283) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@283)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@283)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@283)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@283)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@284 T@$Value) )  (=> ((_ is $Address) addr@@284) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@284)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@284)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@284)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@284)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (=> (= (ControlFlow 0 100188) (- 0 166719)) (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean (forall ((addr@@285 T@$Value) )  (=> ((_ is $Address) addr@@285) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@285)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@285)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@285)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@285)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@2@@21 true) (= $abort_code@4@@11 $abort_code@3@@11)) (and (= $Roles_RoleId_$memory@2@@1 $Roles_RoleId_$memory@1@@2) (= (ControlFlow 0 100138) 100188))) anon0$2_correct@@21)))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon7_correct  (=> (= $Roles_RoleId_$memory@1@@2 $Roles_RoleId_$memory) (=> (and (= $abort_code@3@@11 $abort_code@1@@11) (= (ControlFlow 0 100158) 100138)) inline$$Roles_new_child_vasp_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 100156) 100158)) inline$$Roles_new_child_vasp_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 100166) 100158) inline$$Roles_new_child_vasp_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@21 (and (=> (= (ControlFlow 0 100150) 100166) inline$$Roles_new_child_vasp_role_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 100150) 100156) inline$$Roles_new_child_vasp_role_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon11_correct  (=> (= $Roles_RoleId_$memory@1@@2 $Roles_RoleId_$memory@0@@2) (=> (and (= $abort_code@3@@11 $abort_code@2@@12) (= (ControlFlow 0 100134) 100138)) inline$$Roles_new_child_vasp_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 100132) 100134)) inline$$Roles_new_child_vasp_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 100146) 100134) inline$$Roles_new_child_vasp_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon17_Then_correct  (=> $abort_flag@1@@21 (and (=> (= (ControlFlow 0 100126) 100146) inline$$Roles_new_child_vasp_role_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 100126) 100132) inline$$Roles_new_child_vasp_role_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon17_Else_correct  (=> (not $abort_flag@1@@21) (=> (and (and (= $abort_flag@2@@21 $abort_flag@1@@21) (= $abort_code@4@@11 $abort_code@2@@12)) (and (= $Roles_RoleId_$memory@2@@1 $Roles_RoleId_$memory@0@@2) (= (ControlFlow 0 100122) 100188))) anon0$2_correct@@21))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@21) (= inline$$Roles_new_child_vasp_role_$def_verify$0$$t4@1 ($Integer 6))) (and (=> (= (ControlFlow 0 100116) (- 0 165514)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_child_vasp_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_child_vasp_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account)) (and (=> (= (ControlFlow 0 100116) (- 0 165524)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_child_vasp_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account ($Address 173345816)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_child_vasp_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account ($Address 173345816))))))) (and (=> (= (ControlFlow 0 100116) (- 0 165552)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_child_vasp_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account ($Address 186537453)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_child_vasp_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account ($Address 186537453))))))) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account)))) $abort_flag@1@@21) (=> (and (=> $abort_flag@1@@21 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account))))) (=> $abort_flag@1@@21 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account)))) (= $abort_code@2@@12 (|i#$Integer| ($Integer 6)))))) (=> (and (and (=> (not $abort_flag@1@@21) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| new_account))))) (=> (not $abort_flag@1@@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| new_account)))) $Roles_RoleId_role_id) inline$$Roles_new_child_vasp_role_$def_verify$0$$t4@1))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@0@@2) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| new_account)))) (= (|domain#$Memory| $Roles_RoleId_$memory@0@@2) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| new_account)))))) (and (=> (= (ControlFlow 0 100116) 100126) inline$$Roles_new_child_vasp_role_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 100116) 100122) inline$$Roles_new_child_vasp_role_$def_verify$0$anon17_Else_correct))))))))))))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) $abort_flag@0@@21) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@0@@21) (=> $abort_flag@0@@21 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5)))))))) (=> (and (and (and (=> $abort_flag@0@@21 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account))))))) (= $abort_code@1@@11 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@1@@11 (|i#$Integer| ($Integer 3)))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@286 T@$Value) )  (=> ((_ is $Address) addr@@286) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@286)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@286)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@286)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@286)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (and (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@287 T@$Value) )  (=> ((_ is $Address) addr@@287) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@287)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@287)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@287)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@287)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@288 T@$Value) )  (=> ((_ is $Address) addr@@288) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@288)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@288)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@288)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@288)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))))) (and (and (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@289 T@$Value) )  (=> ((_ is $Address) addr@@289) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@289)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@289)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@289)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@289)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@290 T@$Value) )  (=> ((_ is $Address) addr@@290) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@290)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@290)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@290)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@290)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (and (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@291 T@$Value) )  (=> ((_ is $Address) addr@@291) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@291)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@291)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@291)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@291)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@292 T@$Value) )  (=> ((_ is $Address) addr@@292) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@292)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@292)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@292)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@292)))) $Roles_RoleId_role_id) ($Integer 6)))))))))))))))))) (and (=> (= (ControlFlow 0 100106) 100150) inline$$Roles_new_child_vasp_role_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 100106) 100116) inline$$Roles_new_child_vasp_role_$def_verify$0$anon15_Else_correct)))))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon4_correct  (=> (and (= inline$$Roles_new_child_vasp_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| new_account) true)) (= (ControlFlow 0 100070) 100106)) inline$$Roles_new_child_vasp_role_$def_verify$0$anon4$2_correct)))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 100020) 100070)) inline$$Roles_new_child_vasp_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 100174) 100070) inline$$Roles_new_child_vasp_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 100012) 100174) inline$$Roles_new_child_vasp_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 100012) 100020) inline$$Roles_new_child_vasp_role_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 100182) 100174) inline$$Roles_new_child_vasp_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 100182) 100020) inline$$Roles_new_child_vasp_role_$def_verify$0$anon14_Else_correct))))
(let ((inline$$Roles_new_child_vasp_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 100006) 100182) inline$$Roles_new_child_vasp_role_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 100006) 100012) inline$$Roles_new_child_vasp_role_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@21  (=> (and (forall (($inv_addr@@23 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@23))
)) (= (ControlFlow 0 100186) 100006)) inline$$Roles_new_child_vasp_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@21  (=> ((_ is $Address) creating_account) (=> (and ((_ is $Address) new_account) (= (ControlFlow 0 99722) 100186)) anon0$1_correct@@21))))
(let ((PreconditionGeneratedEntry_correct@@21  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain@@2 $EmptyTypeValueArray (|a#$Address| new_account)) (= (ControlFlow 0 162148) 99722)) anon0_correct@@21)))
PreconditionGeneratedEntry_correct@@21)))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun creating_account@@0 () T@$Value)
(declare-fun $abort_flag@2@@22 () Bool)
(declare-fun new_account@@0 () T@$Value)
(declare-fun $abort_code@4@@12 () Int)
(declare-fun $Roles_RoleId_$memory@2@@2 () T@$Memory)
(declare-fun $abort_code@3@@12 () Int)
(declare-fun $Roles_RoleId_$memory@1@@3 () T@$Memory)
(declare-fun $abort_code@1@@12 () Int)
(declare-fun $abort_flag@0@@22 () Bool)
(declare-fun $Roles_RoleId_$memory@0@@3 () T@$Memory)
(declare-fun $abort_code@2@@13 () Int)
(declare-fun $abort_flag@1@@22 () Bool)
(declare-fun inline$$Roles_new_designated_dealer_role_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Roles_new_designated_dealer_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $Roles_RoleId_$CallerDomain@@3 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 166821) (let ((anon0$2_correct@@22  (and (=> (= (ControlFlow 0 100765) (- 0 170733)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) $abort_flag@2@@22)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) $abort_flag@2@@22) (and (=> (= (ControlFlow 0 100765) (- 0 170753)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@2@@22)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@2@@22) (and (=> (= (ControlFlow 0 100765) (- 0 170781)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) $abort_flag@2@@22)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) $abort_flag@2@@22) (and (=> (= (ControlFlow 0 100765) (- 0 170798)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) $abort_flag@2@@22)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) $abort_flag@2@@22) (and (=> (= (ControlFlow 0 100765) (- 0 170812)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) $abort_flag@2@@22)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) $abort_flag@2@@22) (and (=> (= (ControlFlow 0 100765) (- 0 170832)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@2@@22)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@2@@22) (and (=> (= (ControlFlow 0 100765) (- 0 170860)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) $abort_flag@2@@22)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) $abort_flag@2@@22) (and (=> (= (ControlFlow 0 100765) (- 0 170877)) (=> $abort_flag@2@@22 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453)))))))) (=> (=> $abort_flag@2@@22 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))))) (and (=> (= (ControlFlow 0 100765) (- 0 171015)) (=> $abort_flag@2@@22 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@2@@22 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) (= $abort_code@4@@12 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 100765) (- 0 171230)) (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| new_account@@0)))))) (=> (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| new_account@@0))))) (and (=> (= (ControlFlow 0 100765) (- 0 171246)) (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))) (=> (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) $Roles_RoleId_role_id) ($Integer 2))))) (and (=> (= (ControlFlow 0 100765) (- 0 171274)) (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@293 T@$Value) )  (=> ((_ is $Address) addr@@293) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@293)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@293)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@293)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@293)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@294 T@$Value) )  (=> ((_ is $Address) addr@@294) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@294)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@294)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@294)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@294)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 100765) (- 0 171370)) (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@295 T@$Value) )  (=> ((_ is $Address) addr@@295) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@295)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@295)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@295)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@295)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@296 T@$Value) )  (=> ((_ is $Address) addr@@296) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@296)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@296)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@296)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@296)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 100765) (- 0 171466)) (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@297 T@$Value) )  (=> ((_ is $Address) addr@@297) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@297)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@297)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@297)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@297)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@298 T@$Value) )  (=> ((_ is $Address) addr@@298) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@298)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@298)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@298)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@298)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 100765) (- 0 171562)) (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@299 T@$Value) )  (=> ((_ is $Address) addr@@299) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@299)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@299)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@299)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@299)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@300 T@$Value) )  (=> ((_ is $Address) addr@@300) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@300)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@300)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@300)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@300)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 100765) (- 0 171658)) (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@301 T@$Value) )  (=> ((_ is $Address) addr@@301) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@301)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@301)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@301)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@301)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@302 T@$Value) )  (=> ((_ is $Address) addr@@302) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@302)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@302)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@302)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@302)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 100765) (- 0 171754)) (=> (not $abort_flag@2@@22) (|b#$Boolean| ($Boolean (forall ((addr@@303 T@$Value) )  (=> ((_ is $Address) addr@@303) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@303)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@2) $EmptyTypeValueArray (|a#$Address| addr@@303)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@303)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@303)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@2@@22 true) (= $abort_code@4@@12 $abort_code@3@@12)) (and (= $Roles_RoleId_$memory@2@@2 $Roles_RoleId_$memory@1@@3) (= (ControlFlow 0 100715) 100765))) anon0$2_correct@@22)))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon7_correct  (=> (= $Roles_RoleId_$memory@1@@3 $Roles_RoleId_$memory) (=> (and (= $abort_code@3@@12 $abort_code@1@@12) (= (ControlFlow 0 100735) 100715)) inline$$Roles_new_designated_dealer_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 100733) 100735)) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 100743) 100735) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@22 (and (=> (= (ControlFlow 0 100727) 100743) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 100727) 100733) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon11_correct  (=> (= $Roles_RoleId_$memory@1@@3 $Roles_RoleId_$memory@0@@3) (=> (and (= $abort_code@3@@12 $abort_code@2@@13) (= (ControlFlow 0 100711) 100715)) inline$$Roles_new_designated_dealer_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 100709) 100711)) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 100723) 100711) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon17_Then_correct  (=> $abort_flag@1@@22 (and (=> (= (ControlFlow 0 100703) 100723) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 100703) 100709) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon17_Else_correct  (=> (not $abort_flag@1@@22) (=> (and (and (= $abort_flag@2@@22 $abort_flag@1@@22) (= $abort_code@4@@12 $abort_code@2@@13)) (and (= $Roles_RoleId_$memory@2@@2 $Roles_RoleId_$memory@0@@3) (= (ControlFlow 0 100699) 100765))) anon0$2_correct@@22))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@22) (= inline$$Roles_new_designated_dealer_role_$def_verify$0$$t4@1 ($Integer 2))) (and (=> (= (ControlFlow 0 100693) (- 0 170429)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_designated_dealer_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account@@0))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_designated_dealer_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account@@0)) (and (=> (= (ControlFlow 0 100693) (- 0 170439)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_designated_dealer_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@0 ($Address 173345816)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_designated_dealer_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@0 ($Address 173345816))))))) (and (=> (= (ControlFlow 0 100693) (- 0 170467)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_designated_dealer_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@0 ($Address 186537453)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_designated_dealer_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@0 ($Address 186537453))))))) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) $abort_flag@1@@22) (=> (and (=> $abort_flag@1@@22 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0))))) (=> $abort_flag@1@@22 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) (= $abort_code@2@@13 (|i#$Integer| ($Integer 6)))))) (=> (and (and (=> (not $abort_flag@1@@22) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| new_account@@0))))) (=> (not $abort_flag@1@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) $Roles_RoleId_role_id) inline$$Roles_new_designated_dealer_role_$def_verify$0$$t4@1))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@0@@3) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| new_account@@0)))) (= (|domain#$Memory| $Roles_RoleId_$memory@0@@3) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@0) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@3) $EmptyTypeValueArray (|a#$Address| new_account@@0)))))) (and (=> (= (ControlFlow 0 100693) 100703) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 100693) 100699) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon17_Else_correct))))))))))))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) $abort_flag@0@@22) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@22)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) $abort_flag@0@@22) (=> $abort_flag@0@@22 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))))))) (=> (and (and (and (=> $abort_flag@0@@22 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0))))))) (= $abort_code@1@@12 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@12 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@0 ($Address 186537453))))) (= $abort_code@1@@12 (|i#$Integer| ($Integer 2)))))) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean (forall ((addr@@304 T@$Value) )  (=> ((_ is $Address) addr@@304) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@304)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@304)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@304)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@304)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (and (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean (forall ((addr@@305 T@$Value) )  (=> ((_ is $Address) addr@@305) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@305)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@305)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@305)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@305)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean (forall ((addr@@306 T@$Value) )  (=> ((_ is $Address) addr@@306) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@306)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@306)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@306)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@306)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))))) (and (and (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean (forall ((addr@@307 T@$Value) )  (=> ((_ is $Address) addr@@307) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@307)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@307)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@307)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@307)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean (forall ((addr@@308 T@$Value) )  (=> ((_ is $Address) addr@@308) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@308)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@308)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@308)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@308)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (and (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean (forall ((addr@@309 T@$Value) )  (=> ((_ is $Address) addr@@309) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@309)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@309)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@309)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@309)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (not $abort_flag@0@@22) (|b#$Boolean| ($Boolean (forall ((addr@@310 T@$Value) )  (=> ((_ is $Address) addr@@310) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@310)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@310)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@310)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@310)))) $Roles_RoleId_role_id) ($Integer 6)))))))))))))))))) (and (=> (= (ControlFlow 0 100683) 100727) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 100683) 100693) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon4_correct  (=> (and (= inline$$Roles_new_designated_dealer_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| new_account@@0) true)) (= (ControlFlow 0 100647) 100683)) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon4$2_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 100597) 100647)) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 100751) 100647) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 100589) 100751) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 100589) 100597) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 100759) 100751) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 100759) 100597) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon14_Else_correct))))
(let ((inline$$Roles_new_designated_dealer_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 100583) 100759) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 100583) 100589) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@22  (=> (and (forall (($inv_addr@@24 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@24)) (let ((va@@33 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@24))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@24))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@24))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@24))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@24))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@24))
)) (= (ControlFlow 0 100763) 100583)) inline$$Roles_new_designated_dealer_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@22  (=> ((_ is $Address) creating_account@@0) (=> (and ((_ is $Address) new_account@@0) (= (ControlFlow 0 100299) 100763)) anon0$1_correct@@22))))
(let ((PreconditionGeneratedEntry_correct@@22  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain@@3 $EmptyTypeValueArray (|a#$Address| new_account@@0)) (= (ControlFlow 0 166821) 100299)) anon0_correct@@22)))
PreconditionGeneratedEntry_correct@@22)))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun creating_account@@1 () T@$Value)
(declare-fun $abort_flag@2@@23 () Bool)
(declare-fun new_account@@1 () T@$Value)
(declare-fun $abort_code@4@@13 () Int)
(declare-fun $Roles_RoleId_$memory@2@@3 () T@$Memory)
(declare-fun $abort_code@3@@13 () Int)
(declare-fun $Roles_RoleId_$memory@1@@4 () T@$Memory)
(declare-fun $abort_code@1@@13 () Int)
(declare-fun $abort_flag@0@@23 () Bool)
(declare-fun $Roles_RoleId_$memory@0@@4 () T@$Memory)
(declare-fun $abort_code@2@@14 () Int)
(declare-fun $abort_flag@1@@23 () Bool)
(declare-fun inline$$Roles_new_parent_vasp_role_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Roles_new_parent_vasp_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $Roles_RoleId_$CallerDomain@@4 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 171856) (let ((anon0$2_correct@@23  (and (=> (= (ControlFlow 0 101342) (- 0 175768)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) $abort_flag@2@@23)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) $abort_flag@2@@23) (and (=> (= (ControlFlow 0 101342) (- 0 175788)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@2@@23)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@2@@23) (and (=> (= (ControlFlow 0 101342) (- 0 175816)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) $abort_flag@2@@23)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) $abort_flag@2@@23) (and (=> (= (ControlFlow 0 101342) (- 0 175833)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) $abort_flag@2@@23)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) $abort_flag@2@@23) (and (=> (= (ControlFlow 0 101342) (- 0 175847)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) $abort_flag@2@@23)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) $abort_flag@2@@23) (and (=> (= (ControlFlow 0 101342) (- 0 175867)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@2@@23)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@2@@23) (and (=> (= (ControlFlow 0 101342) (- 0 175895)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) $abort_flag@2@@23)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) $abort_flag@2@@23) (and (=> (= (ControlFlow 0 101342) (- 0 175912)) (=> $abort_flag@2@@23 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453)))))))) (=> (=> $abort_flag@2@@23 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))))) (and (=> (= (ControlFlow 0 101342) (- 0 176050)) (=> $abort_flag@2@@23 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@2@@23 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) (= $abort_code@4@@13 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 101342) (- 0 176265)) (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| new_account@@1)))))) (=> (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| new_account@@1))))) (and (=> (= (ControlFlow 0 101342) (- 0 176281)) (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) $Roles_RoleId_role_id) ($Integer 5)))))) (=> (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) $Roles_RoleId_role_id) ($Integer 5))))) (and (=> (= (ControlFlow 0 101342) (- 0 176309)) (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@311 T@$Value) )  (=> ((_ is $Address) addr@@311) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@311)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@311)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@311)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@311)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@312 T@$Value) )  (=> ((_ is $Address) addr@@312) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@312)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@312)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@312)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@312)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 101342) (- 0 176405)) (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@313 T@$Value) )  (=> ((_ is $Address) addr@@313) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@313)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@313)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@313)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@313)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@314 T@$Value) )  (=> ((_ is $Address) addr@@314) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@314)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@314)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@314)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@314)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 101342) (- 0 176501)) (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@315 T@$Value) )  (=> ((_ is $Address) addr@@315) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@315)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@315)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@315)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@315)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@316 T@$Value) )  (=> ((_ is $Address) addr@@316) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@316)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@316)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@316)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@316)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 101342) (- 0 176597)) (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@317 T@$Value) )  (=> ((_ is $Address) addr@@317) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@317)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@317)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@317)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@317)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@318 T@$Value) )  (=> ((_ is $Address) addr@@318) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@318)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@318)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@318)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@318)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 101342) (- 0 176693)) (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@319 T@$Value) )  (=> ((_ is $Address) addr@@319) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@319)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@319)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@319)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@319)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@320 T@$Value) )  (=> ((_ is $Address) addr@@320) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@320)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@320)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@320)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@320)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (=> (= (ControlFlow 0 101342) (- 0 176789)) (=> (not $abort_flag@2@@23) (|b#$Boolean| ($Boolean (forall ((addr@@321 T@$Value) )  (=> ((_ is $Address) addr@@321) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@321)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@3) $EmptyTypeValueArray (|a#$Address| addr@@321)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@321)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@321)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@2@@23 true) (= $abort_code@4@@13 $abort_code@3@@13)) (and (= $Roles_RoleId_$memory@2@@3 $Roles_RoleId_$memory@1@@4) (= (ControlFlow 0 101292) 101342))) anon0$2_correct@@23)))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon7_correct  (=> (= $Roles_RoleId_$memory@1@@4 $Roles_RoleId_$memory) (=> (and (= $abort_code@3@@13 $abort_code@1@@13) (= (ControlFlow 0 101312) 101292)) inline$$Roles_new_parent_vasp_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 101310) 101312)) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 101320) 101312) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@23 (and (=> (= (ControlFlow 0 101304) 101320) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 101304) 101310) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon11_correct  (=> (= $Roles_RoleId_$memory@1@@4 $Roles_RoleId_$memory@0@@4) (=> (and (= $abort_code@3@@13 $abort_code@2@@14) (= (ControlFlow 0 101288) 101292)) inline$$Roles_new_parent_vasp_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 101286) 101288)) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 101300) 101288) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon17_Then_correct  (=> $abort_flag@1@@23 (and (=> (= (ControlFlow 0 101280) 101300) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 101280) 101286) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon17_Else_correct  (=> (not $abort_flag@1@@23) (=> (and (and (= $abort_flag@2@@23 $abort_flag@1@@23) (= $abort_code@4@@13 $abort_code@2@@14)) (and (= $Roles_RoleId_$memory@2@@3 $Roles_RoleId_$memory@0@@4) (= (ControlFlow 0 101276) 101342))) anon0$2_correct@@23))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@23) (= inline$$Roles_new_parent_vasp_role_$def_verify$0$$t4@1 ($Integer 5))) (and (=> (= (ControlFlow 0 101270) (- 0 175464)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_parent_vasp_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account@@1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_parent_vasp_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account@@1)) (and (=> (= (ControlFlow 0 101270) (- 0 175474)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_parent_vasp_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@1 ($Address 173345816)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_parent_vasp_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@1 ($Address 173345816))))))) (and (=> (= (ControlFlow 0 101270) (- 0 175502)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_parent_vasp_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@1 ($Address 186537453)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_parent_vasp_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@1 ($Address 186537453))))))) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) $abort_flag@1@@23) (=> (and (=> $abort_flag@1@@23 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1))))) (=> $abort_flag@1@@23 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) (= $abort_code@2@@14 (|i#$Integer| ($Integer 6)))))) (=> (and (and (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@4) $EmptyTypeValueArray (|a#$Address| new_account@@1))))) (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@4) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) $Roles_RoleId_role_id) inline$$Roles_new_parent_vasp_role_$def_verify$0$$t4@1))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@0@@4) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@4) $EmptyTypeValueArray (|a#$Address| new_account@@1)))) (= (|domain#$Memory| $Roles_RoleId_$memory@0@@4) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@1) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@4) $EmptyTypeValueArray (|a#$Address| new_account@@1)))))) (and (=> (= (ControlFlow 0 101270) 101280) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 101270) 101276) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon17_Else_correct))))))))))))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) $abort_flag@0@@23) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@23)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) $abort_flag@0@@23) (=> $abort_flag@0@@23 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))))))) (=> (and (and (and (=> $abort_flag@0@@23 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1))))))) (= $abort_code@1@@13 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@13 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@1 ($Address 186537453))))) (= $abort_code@1@@13 (|i#$Integer| ($Integer 2)))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@322 T@$Value) )  (=> ((_ is $Address) addr@@322) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@322)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@322)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@322)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@322)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (and (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@323 T@$Value) )  (=> ((_ is $Address) addr@@323) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@323)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@323)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@323)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@323)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@324 T@$Value) )  (=> ((_ is $Address) addr@@324) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@324)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@324)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@324)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@324)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))))) (and (and (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@325 T@$Value) )  (=> ((_ is $Address) addr@@325) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@325)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@325)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@325)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@325)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@326 T@$Value) )  (=> ((_ is $Address) addr@@326) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@326)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@326)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@326)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@326)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (and (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@327 T@$Value) )  (=> ((_ is $Address) addr@@327) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@327)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@327)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@327)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@327)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@328 T@$Value) )  (=> ((_ is $Address) addr@@328) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@328)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@328)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@328)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@328)))) $Roles_RoleId_role_id) ($Integer 6)))))))))))))))))) (and (=> (= (ControlFlow 0 101260) 101304) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 101260) 101270) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon4_correct  (=> (and (= inline$$Roles_new_parent_vasp_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| new_account@@1) true)) (= (ControlFlow 0 101224) 101260)) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon4$2_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 101174) 101224)) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 101328) 101224) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 101166) 101328) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 101166) 101174) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 101336) 101328) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 101336) 101174) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon14_Else_correct))))
(let ((inline$$Roles_new_parent_vasp_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 101160) 101336) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 101160) 101166) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@23  (=> (and (forall (($inv_addr@@25 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25)) (let ((va@@34 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@25))
)) (= (ControlFlow 0 101340) 101160)) inline$$Roles_new_parent_vasp_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@23  (=> ((_ is $Address) creating_account@@1) (=> (and ((_ is $Address) new_account@@1) (= (ControlFlow 0 100876) 101340)) anon0$1_correct@@23))))
(let ((PreconditionGeneratedEntry_correct@@23  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain@@4 $EmptyTypeValueArray (|a#$Address| new_account@@1)) (= (ControlFlow 0 171856) 100876)) anon0_correct@@23)))
PreconditionGeneratedEntry_correct@@23)))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun creating_account@@2 () T@$Value)
(declare-fun $abort_flag@2@@24 () Bool)
(declare-fun new_account@@2 () T@$Value)
(declare-fun $abort_code@4@@14 () Int)
(declare-fun $Roles_RoleId_$memory@2@@4 () T@$Memory)
(declare-fun $abort_code@3@@14 () Int)
(declare-fun $Roles_RoleId_$memory@1@@5 () T@$Memory)
(declare-fun $abort_code@1@@14 () Int)
(declare-fun $abort_flag@0@@24 () Bool)
(declare-fun $Roles_RoleId_$memory@0@@5 () T@$Memory)
(declare-fun $abort_code@2@@15 () Int)
(declare-fun $abort_flag@1@@24 () Bool)
(declare-fun inline$$Roles_new_validator_operator_role_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Roles_new_validator_operator_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $Roles_RoleId_$CallerDomain@@5 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 176891) (let ((anon0$2_correct@@24  (and (=> (= (ControlFlow 0 101919) (- 0 180919)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) $abort_flag@2@@24)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) $abort_flag@2@@24) (and (=> (= (ControlFlow 0 101919) (- 0 180939)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@24)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@24) (and (=> (= (ControlFlow 0 101919) (- 0 180967)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) $abort_flag@2@@24)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) $abort_flag@2@@24) (and (=> (= (ControlFlow 0 101919) (- 0 180984)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) $abort_flag@2@@24)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) $abort_flag@2@@24) (and (=> (= (ControlFlow 0 101919) (- 0 180998)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) $abort_flag@2@@24)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) $abort_flag@2@@24) (and (=> (= (ControlFlow 0 101919) (- 0 181018)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@24)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@24) (and (=> (= (ControlFlow 0 101919) (- 0 181046)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) $abort_flag@2@@24)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) $abort_flag@2@@24) (and (=> (= (ControlFlow 0 101919) (- 0 181063)) (=> $abort_flag@2@@24 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816)))))))) (=> (=> $abort_flag@2@@24 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))))) (and (=> (= (ControlFlow 0 101919) (- 0 181201)) (=> $abort_flag@2@@24 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@2@@24 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) (= $abort_code@4@@14 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 101919) (- 0 181416)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| new_account@@2)))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| new_account@@2))))) (and (=> (= (ControlFlow 0 101919) (- 0 181432)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) $Roles_RoleId_role_id) ($Integer 4)))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) $Roles_RoleId_role_id) ($Integer 4))))) (and (=> (= (ControlFlow 0 101919) (- 0 181460)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@329 T@$Value) )  (=> ((_ is $Address) addr@@329) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@329)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@329)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@329)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@329)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@330 T@$Value) )  (=> ((_ is $Address) addr@@330) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@330)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@330)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@330)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@330)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 101919) (- 0 181556)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@331 T@$Value) )  (=> ((_ is $Address) addr@@331) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@331)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@331)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@331)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@331)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@332 T@$Value) )  (=> ((_ is $Address) addr@@332) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@332)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@332)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@332)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@332)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 101919) (- 0 181652)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@333 T@$Value) )  (=> ((_ is $Address) addr@@333) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@333)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@333)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@333)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@333)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@334 T@$Value) )  (=> ((_ is $Address) addr@@334) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@334)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@334)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@334)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@334)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (=> (= (ControlFlow 0 101919) (- 0 181748)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@335 T@$Value) )  (=> ((_ is $Address) addr@@335) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@335)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@335)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@335)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@335)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@336 T@$Value) )  (=> ((_ is $Address) addr@@336) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@336)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@336)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@336)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@336)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 101919) (- 0 181844)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@337 T@$Value) )  (=> ((_ is $Address) addr@@337) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@337)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@337)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@337)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@337)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@338 T@$Value) )  (=> ((_ is $Address) addr@@338) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@338)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@338)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@338)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@338)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 101919) (- 0 181940)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@339 T@$Value) )  (=> ((_ is $Address) addr@@339) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@339)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@4) $EmptyTypeValueArray (|a#$Address| addr@@339)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@339)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@339)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@2@@24 true) (= $abort_code@4@@14 $abort_code@3@@14)) (and (= $Roles_RoleId_$memory@2@@4 $Roles_RoleId_$memory@1@@5) (= (ControlFlow 0 101869) 101919))) anon0$2_correct@@24)))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon7_correct  (=> (= $Roles_RoleId_$memory@1@@5 $Roles_RoleId_$memory) (=> (and (= $abort_code@3@@14 $abort_code@1@@14) (= (ControlFlow 0 101889) 101869)) inline$$Roles_new_validator_operator_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 101887) 101889)) inline$$Roles_new_validator_operator_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 101897) 101889) inline$$Roles_new_validator_operator_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@24 (and (=> (= (ControlFlow 0 101881) 101897) inline$$Roles_new_validator_operator_role_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 101881) 101887) inline$$Roles_new_validator_operator_role_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon11_correct  (=> (= $Roles_RoleId_$memory@1@@5 $Roles_RoleId_$memory@0@@5) (=> (and (= $abort_code@3@@14 $abort_code@2@@15) (= (ControlFlow 0 101865) 101869)) inline$$Roles_new_validator_operator_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 101863) 101865)) inline$$Roles_new_validator_operator_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 101877) 101865) inline$$Roles_new_validator_operator_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon17_Then_correct  (=> $abort_flag@1@@24 (and (=> (= (ControlFlow 0 101857) 101877) inline$$Roles_new_validator_operator_role_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 101857) 101863) inline$$Roles_new_validator_operator_role_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon17_Else_correct  (=> (not $abort_flag@1@@24) (=> (and (and (= $abort_flag@2@@24 $abort_flag@1@@24) (= $abort_code@4@@14 $abort_code@2@@15)) (and (= $Roles_RoleId_$memory@2@@4 $Roles_RoleId_$memory@0@@5) (= (ControlFlow 0 101853) 101919))) anon0$2_correct@@24))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@24) (= inline$$Roles_new_validator_operator_role_$def_verify$0$$t4@1 ($Integer 4))) (and (=> (= (ControlFlow 0 101847) (- 0 180615)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_validator_operator_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account@@2))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_validator_operator_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account@@2)) (and (=> (= (ControlFlow 0 101847) (- 0 180625)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_validator_operator_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@2 ($Address 173345816)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_validator_operator_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@2 ($Address 173345816))))))) (and (=> (= (ControlFlow 0 101847) (- 0 180653)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_validator_operator_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@2 ($Address 186537453)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_validator_operator_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@2 ($Address 186537453))))))) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) $abort_flag@1@@24) (=> (and (=> $abort_flag@1@@24 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2))))) (=> $abort_flag@1@@24 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) (= $abort_code@2@@15 (|i#$Integer| ($Integer 6)))))) (=> (and (and (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@5) $EmptyTypeValueArray (|a#$Address| new_account@@2))))) (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@5) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) $Roles_RoleId_role_id) inline$$Roles_new_validator_operator_role_$def_verify$0$$t4@1))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@0@@5) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@5) $EmptyTypeValueArray (|a#$Address| new_account@@2)))) (= (|domain#$Memory| $Roles_RoleId_$memory@0@@5) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@2) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@5) $EmptyTypeValueArray (|a#$Address| new_account@@2)))))) (and (=> (= (ControlFlow 0 101847) 101857) inline$$Roles_new_validator_operator_role_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 101847) 101853) inline$$Roles_new_validator_operator_role_$def_verify$0$anon17_Else_correct))))))))))))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) $abort_flag@0@@24) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) $abort_flag@0@@24) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@0@@24)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) $abort_flag@0@@24) (=> $abort_flag@0@@24 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))))))) (=> (and (and (and (=> $abort_flag@0@@24 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) (= $abort_code@1@@14 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2))))))) (= $abort_code@1@@14 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@2)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@1@@14 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@2 ($Address 173345816))))) (= $abort_code@1@@14 (|i#$Integer| ($Integer 2)))))) (=> (not $abort_flag@0@@24) (|b#$Boolean| ($Boolean (forall ((addr@@340 T@$Value) )  (=> ((_ is $Address) addr@@340) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@340)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@340)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@340)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@340)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (and (=> (not $abort_flag@0@@24) (|b#$Boolean| ($Boolean (forall ((addr@@341 T@$Value) )  (=> ((_ is $Address) addr@@341) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@341)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@341)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@341)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@341)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (=> (not $abort_flag@0@@24) (|b#$Boolean| ($Boolean (forall ((addr@@342 T@$Value) )  (=> ((_ is $Address) addr@@342) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@342)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@342)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@342)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@342)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))))) (and (and (=> (not $abort_flag@0@@24) (|b#$Boolean| ($Boolean (forall ((addr@@343 T@$Value) )  (=> ((_ is $Address) addr@@343) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@343)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@343)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@343)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@343)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (=> (not $abort_flag@0@@24) (|b#$Boolean| ($Boolean (forall ((addr@@344 T@$Value) )  (=> ((_ is $Address) addr@@344) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@344)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@344)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@344)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@344)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (and (=> (not $abort_flag@0@@24) (|b#$Boolean| ($Boolean (forall ((addr@@345 T@$Value) )  (=> ((_ is $Address) addr@@345) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@345)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@345)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@345)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@345)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (not $abort_flag@0@@24) (|b#$Boolean| ($Boolean (forall ((addr@@346 T@$Value) )  (=> ((_ is $Address) addr@@346) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@346)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@346)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@346)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@346)))) $Roles_RoleId_role_id) ($Integer 6)))))))))))))))))) (and (=> (= (ControlFlow 0 101837) 101881) inline$$Roles_new_validator_operator_role_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 101837) 101847) inline$$Roles_new_validator_operator_role_$def_verify$0$anon15_Else_correct)))))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon4_correct  (=> (and (= inline$$Roles_new_validator_operator_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| new_account@@2) true)) (= (ControlFlow 0 101801) 101837)) inline$$Roles_new_validator_operator_role_$def_verify$0$anon4$2_correct)))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 101751) 101801)) inline$$Roles_new_validator_operator_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 101905) 101801) inline$$Roles_new_validator_operator_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 101743) 101905) inline$$Roles_new_validator_operator_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 101743) 101751) inline$$Roles_new_validator_operator_role_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 101913) 101905) inline$$Roles_new_validator_operator_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 101913) 101751) inline$$Roles_new_validator_operator_role_$def_verify$0$anon14_Else_correct))))
(let ((inline$$Roles_new_validator_operator_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 101737) 101913) inline$$Roles_new_validator_operator_role_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 101737) 101743) inline$$Roles_new_validator_operator_role_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@24  (=> (and (forall (($inv_addr@@26 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@26)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@26))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@26))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@26))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@26))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@26))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@26))
)) (= (ControlFlow 0 101917) 101737)) inline$$Roles_new_validator_operator_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@24  (=> ((_ is $Address) creating_account@@2) (=> (and ((_ is $Address) new_account@@2) (= (ControlFlow 0 101453) 101917)) anon0$1_correct@@24))))
(let ((PreconditionGeneratedEntry_correct@@24  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain@@5 $EmptyTypeValueArray (|a#$Address| new_account@@2)) (= (ControlFlow 0 176891) 101453)) anon0_correct@@24)))
PreconditionGeneratedEntry_correct@@24)))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun creating_account@@3 () T@$Value)
(declare-fun $abort_flag@2@@25 () Bool)
(declare-fun new_account@@3 () T@$Value)
(declare-fun $abort_code@4@@15 () Int)
(declare-fun $Roles_RoleId_$memory@2@@5 () T@$Memory)
(declare-fun $abort_code@3@@15 () Int)
(declare-fun $Roles_RoleId_$memory@1@@6 () T@$Memory)
(declare-fun $abort_code@1@@15 () Int)
(declare-fun $abort_flag@0@@25 () Bool)
(declare-fun $Roles_RoleId_$memory@0@@6 () T@$Memory)
(declare-fun $abort_code@2@@16 () Int)
(declare-fun $abort_flag@1@@25 () Bool)
(declare-fun inline$$Roles_new_validator_role_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$Roles_new_validator_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $Roles_RoleId_$CallerDomain@@6 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 182042) (let ((anon0$2_correct@@25  (and (=> (= (ControlFlow 0 102496) (- 0 186070)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) $abort_flag@2@@25)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) $abort_flag@2@@25) (and (=> (= (ControlFlow 0 102496) (- 0 186090)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@25)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@25) (and (=> (= (ControlFlow 0 102496) (- 0 186118)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) $abort_flag@2@@25)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) $abort_flag@2@@25) (and (=> (= (ControlFlow 0 102496) (- 0 186135)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) $abort_flag@2@@25)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) $abort_flag@2@@25) (and (=> (= (ControlFlow 0 102496) (- 0 186149)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) $abort_flag@2@@25)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) $abort_flag@2@@25) (and (=> (= (ControlFlow 0 102496) (- 0 186169)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@25)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@2@@25) (and (=> (= (ControlFlow 0 102496) (- 0 186197)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) $abort_flag@2@@25)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) $abort_flag@2@@25) (and (=> (= (ControlFlow 0 102496) (- 0 186214)) (=> $abort_flag@2@@25 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816)))))))) (=> (=> $abort_flag@2@@25 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))))) (and (=> (= (ControlFlow 0 102496) (- 0 186352)) (=> $abort_flag@2@@25 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@2@@25 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 102496) (- 0 186567)) (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| new_account@@3)))))) (=> (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| new_account@@3))))) (and (=> (= (ControlFlow 0 102496) (- 0 186583)) (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) $Roles_RoleId_role_id) ($Integer 3)))))) (=> (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) $Roles_RoleId_role_id) ($Integer 3))))) (and (=> (= (ControlFlow 0 102496) (- 0 186611)) (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@347 T@$Value) )  (=> ((_ is $Address) addr@@347) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@347)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@347)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@347)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@347)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (=> (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@348 T@$Value) )  (=> ((_ is $Address) addr@@348) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@348)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@348)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@348)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@348)))) $Roles_RoleId_role_id) ($Integer 0))))))))))))))) (and (=> (= (ControlFlow 0 102496) (- 0 186707)) (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@349 T@$Value) )  (=> ((_ is $Address) addr@@349) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@349)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@349)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@349)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@349)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))) (=> (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@350 T@$Value) )  (=> ((_ is $Address) addr@@350) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@350)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@350)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@350)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@350)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (and (=> (= (ControlFlow 0 102496) (- 0 186803)) (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@351 T@$Value) )  (=> ((_ is $Address) addr@@351) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@351)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@351)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@351)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@351)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (=> (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@352 T@$Value) )  (=> ((_ is $Address) addr@@352) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@352)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@352)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@352)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@352)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (and (=> (= (ControlFlow 0 102496) (- 0 186899)) (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@353 T@$Value) )  (=> ((_ is $Address) addr@@353) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@353)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@353)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@353)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@353)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (=> (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@354 T@$Value) )  (=> ((_ is $Address) addr@@354) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@354)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@354)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@354)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@354)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))) (and (=> (= (ControlFlow 0 102496) (- 0 186995)) (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@355 T@$Value) )  (=> ((_ is $Address) addr@@355) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@355)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@355)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@355)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@355)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))) (=> (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@356 T@$Value) )  (=> ((_ is $Address) addr@@356) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@356)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@356)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@356)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@356)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (= (ControlFlow 0 102496) (- 0 187091)) (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean (forall ((addr@@357 T@$Value) )  (=> ((_ is $Address) addr@@357) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@357)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2@@5) $EmptyTypeValueArray (|a#$Address| addr@@357)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@357)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@357)))) $Roles_RoleId_role_id) ($Integer 6))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@2@@25 true) (= $abort_code@4@@15 $abort_code@3@@15)) (and (= $Roles_RoleId_$memory@2@@5 $Roles_RoleId_$memory@1@@6) (= (ControlFlow 0 102446) 102496))) anon0$2_correct@@25)))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon7_correct  (=> (= $Roles_RoleId_$memory@1@@6 $Roles_RoleId_$memory) (=> (and (= $abort_code@3@@15 $abort_code@1@@15) (= (ControlFlow 0 102466) 102446)) inline$$Roles_new_validator_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 102464) 102466)) inline$$Roles_new_validator_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 102474) 102466) inline$$Roles_new_validator_role_$def_verify$0$anon7_correct)))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@25 (and (=> (= (ControlFlow 0 102458) 102474) inline$$Roles_new_validator_role_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 102458) 102464) inline$$Roles_new_validator_role_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon11_correct  (=> (= $Roles_RoleId_$memory@1@@6 $Roles_RoleId_$memory@0@@6) (=> (and (= $abort_code@3@@15 $abort_code@2@@16) (= (ControlFlow 0 102442) 102446)) inline$$Roles_new_validator_role_$def_verify$0$Abort_correct))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 102440) 102442)) inline$$Roles_new_validator_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 102454) 102442) inline$$Roles_new_validator_role_$def_verify$0$anon11_correct)))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon17_Then_correct  (=> $abort_flag@1@@25 (and (=> (= (ControlFlow 0 102434) 102454) inline$$Roles_new_validator_role_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 102434) 102440) inline$$Roles_new_validator_role_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon17_Else_correct  (=> (not $abort_flag@1@@25) (=> (and (and (= $abort_flag@2@@25 $abort_flag@1@@25) (= $abort_code@4@@15 $abort_code@2@@16)) (and (= $Roles_RoleId_$memory@2@@5 $Roles_RoleId_$memory@0@@6) (= (ControlFlow 0 102430) 102496))) anon0$2_correct@@25))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@25) (= inline$$Roles_new_validator_role_$def_verify$0$$t4@1 ($Integer 3))) (and (=> (= (ControlFlow 0 102424) (- 0 185766)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_validator_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account@@3))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_validator_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account@@3)) (and (=> (= (ControlFlow 0 102424) (- 0 185776)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_validator_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@3 ($Address 173345816)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_validator_role_$def_verify$0$$t4@1 ($Integer 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@3 ($Address 173345816))))))) (and (=> (= (ControlFlow 0 102424) (- 0 185804)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_validator_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@3 ($Address 186537453)))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Roles_new_validator_role_$def_verify$0$$t4@1 ($Integer 1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account@@3 ($Address 186537453))))))) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) $abort_flag@1@@25) (=> (and (=> $abort_flag@1@@25 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3))))) (=> $abort_flag@1@@25 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) (= $abort_code@2@@16 (|i#$Integer| ($Integer 6)))))) (=> (and (and (=> (not $abort_flag@1@@25) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@6) $EmptyTypeValueArray (|a#$Address| new_account@@3))))) (=> (not $abort_flag@1@@25) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@6) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) $Roles_RoleId_role_id) inline$$Roles_new_validator_role_$def_verify$0$$t4@1))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@0@@6) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0@@6) $EmptyTypeValueArray (|a#$Address| new_account@@3)))) (= (|domain#$Memory| $Roles_RoleId_$memory@0@@6) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account@@3) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0@@6) $EmptyTypeValueArray (|a#$Address| new_account@@3)))))) (and (=> (= (ControlFlow 0 102424) 102434) inline$$Roles_new_validator_role_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 102424) 102430) inline$$Roles_new_validator_role_$def_verify$0$anon17_Else_correct))))))))))))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) $abort_flag@0@@25) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) $abort_flag@0@@25) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@0@@25)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) $abort_flag@0@@25) (=> $abort_flag@0@@25 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))))))) (=> (and (and (and (=> $abort_flag@0@@25 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) (= $abort_code@1@@15 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3))))))) (= $abort_code@1@@15 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| creating_account@@3)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@1@@15 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified creating_account@@3 ($Address 173345816))))) (= $abort_code@1@@15 (|i#$Integer| ($Integer 2)))))) (=> (not $abort_flag@0@@25) (|b#$Boolean| ($Boolean (forall ((addr@@358 T@$Value) )  (=> ((_ is $Address) addr@@358) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@358)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@358)))) $Roles_RoleId_role_id) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@358)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@358)))) $Roles_RoleId_role_id) ($Integer 0)))))))))))))))) (and (=> (not $abort_flag@0@@25) (|b#$Boolean| ($Boolean (forall ((addr@@359 T@$Value) )  (=> ((_ is $Address) addr@@359) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@359)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@359)))) $Roles_RoleId_role_id) ($Integer 1))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@359)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@359)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))) (=> (not $abort_flag@0@@25) (|b#$Boolean| ($Boolean (forall ((addr@@360 T@$Value) )  (=> ((_ is $Address) addr@@360) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@360)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@360)))) $Roles_RoleId_role_id) ($Integer 3))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@360)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@360)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))))) (and (and (=> (not $abort_flag@0@@25) (|b#$Boolean| ($Boolean (forall ((addr@@361 T@$Value) )  (=> ((_ is $Address) addr@@361) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@361)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@361)))) $Roles_RoleId_role_id) ($Integer 4))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@361)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@361)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (=> (not $abort_flag@0@@25) (|b#$Boolean| ($Boolean (forall ((addr@@362 T@$Value) )  (=> ((_ is $Address) addr@@362) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@362)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@362)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@362)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@362)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (and (=> (not $abort_flag@0@@25) (|b#$Boolean| ($Boolean (forall ((addr@@363 T@$Value) )  (=> ((_ is $Address) addr@@363) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@363)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@363)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@363)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@363)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))) (=> (not $abort_flag@0@@25) (|b#$Boolean| ($Boolean (forall ((addr@@364 T@$Value) )  (=> ((_ is $Address) addr@@364) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@364)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@364)))) $Roles_RoleId_role_id) ($Integer 6))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@364)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@364)))) $Roles_RoleId_role_id) ($Integer 6)))))))))))))))))) (and (=> (= (ControlFlow 0 102414) 102458) inline$$Roles_new_validator_role_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 102414) 102424) inline$$Roles_new_validator_role_$def_verify$0$anon15_Else_correct)))))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon4_correct  (=> (and (= inline$$Roles_new_validator_role_$def_verify$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| new_account@@3) true)) (= (ControlFlow 0 102378) 102414)) inline$$Roles_new_validator_role_$def_verify$0$anon4$2_correct)))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 102328) 102378)) inline$$Roles_new_validator_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 102482) 102378) inline$$Roles_new_validator_role_$def_verify$0$anon4_correct)))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 102320) 102482) inline$$Roles_new_validator_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 102320) 102328) inline$$Roles_new_validator_role_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 102490) 102482) inline$$Roles_new_validator_role_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 102490) 102328) inline$$Roles_new_validator_role_$def_verify$0$anon14_Else_correct))))
(let ((inline$$Roles_new_validator_role_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 102314) 102490) inline$$Roles_new_validator_role_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 102314) 102320) inline$$Roles_new_validator_role_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@25  (=> (and (forall (($inv_addr@@27 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@27)) (let ((va@@36 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@27))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@27))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@27))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@27))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@27))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@27))
)) (= (ControlFlow 0 102494) 102314)) inline$$Roles_new_validator_role_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@25  (=> ((_ is $Address) creating_account@@3) (=> (and ((_ is $Address) new_account@@3) (= (ControlFlow 0 102030) 102494)) anon0$1_correct@@25))))
(let ((PreconditionGeneratedEntry_correct@@25  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain@@6 $EmptyTypeValueArray (|a#$Address| new_account@@3)) (= (ControlFlow 0 182042) 102030)) anon0_correct@@25)))
PreconditionGeneratedEntry_correct@@25)))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
