(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $AccountFreezing_FreezeAccountEvent () T@$TypeName)
(declare-fun $AccountFreezing_FreezeEventsHolder () T@$TypeName)
(declare-fun $AccountFreezing_FreezingBit () T@$TypeName)
(declare-fun $AccountFreezing_UnfreezeAccountEvent () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $Authenticator_MultiEd25519PublicKey () T@$TypeName)
(declare-fun $ChainId_ChainId () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DesignatedDealer_Dealer () T@$TypeName)
(declare-fun $DesignatedDealer_ReceivedMintEvent () T@$TypeName)
(declare-fun $DesignatedDealer_TierInfo () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $SlidingNonce_SlidingNonce () T@$TypeName)
(declare-fun $DualAttestation_BaseUrlRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_Credential () T@$TypeName)
(declare-fun $DualAttestation_Limit () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $DiemAccount_DiemAccount () T@$TypeName)
(declare-fun $DiemAccount_AccountOperationsCapability () T@$TypeName)
(declare-fun $DiemAccount_AdminTransactionEvent () T@$TypeName)
(declare-fun $DiemAccount_Balance () T@$TypeName)
(declare-fun $DiemAccount_CreateAccountEvent () T@$TypeName)
(declare-fun $DiemAccount_DiemWriteSetManager () T@$TypeName)
(declare-fun $DiemAccount_KeyRotationCapability () T@$TypeName)
(declare-fun $DiemAccount_ReceivedPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_SentPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_WithdrawCapability () T@$TypeName)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_frozen_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeEventsHolder_freeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezingBit_is_frozen () Int)
(declare-fun $AccountFreezing_FreezingBit_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_unfrozen_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Authenticator_spec_ed25519_authentication_key (T@$Value) T@$Value)
(declare-fun $Authenticator_spec_multi_ed25519_authentication_key (T@$Value) T@$Value)
(declare-fun $Authenticator_MultiEd25519PublicKey_public_keys () Int)
(declare-fun $Authenticator_MultiEd25519PublicKey_threshold () Int)
(declare-fun $Authenticator_MultiEd25519PublicKey_type_value () T@$TypeValue)
(declare-fun $ChainId_ChainId_id () Int)
(declare-fun $ChainId_ChainId_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_Dealer_mint_event_handle () Int)
(declare-fun $DesignatedDealer_Dealer_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_ReceivedMintEvent_currency_code () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_destination_address () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_amount () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_TierInfo_window_start () Int)
(declare-fun $DesignatedDealer_TierInfo_window_inflow () Int)
(declare-fun $DesignatedDealer_TierInfo_tiers () Int)
(declare-fun $DesignatedDealer_TierInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $SlidingNonce_spec_try_record_nonce (T@$Value T@$Value) T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_min_nonce () Int)
(declare-fun $SlidingNonce_SlidingNonce_nonce_mask () Int)
(declare-fun $SlidingNonce_SlidingNonce_type_value () T@$TypeValue)
(declare-fun $DualAttestation_spec_dual_attestation_message (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $DualAttestation_BaseUrlRotationEvent_new_base_url () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Credential_human_name () Int)
(declare-fun $DualAttestation_Credential_base_url () Int)
(declare-fun $DualAttestation_Credential_compliance_public_key () Int)
(declare-fun $DualAttestation_Credential_expiration_date () Int)
(declare-fun $DualAttestation_Credential_compliance_key_rotation_events () Int)
(declare-fun $DualAttestation_Credential_base_url_rotation_events () Int)
(declare-fun $DualAttestation_Credential_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Limit_micro_xdx_limit () Int)
(declare-fun $DualAttestation_Limit_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun $DiemAccount_spec_abstract_create_authentication_key (T@$Value) T@$Value)
(declare-fun $DiemAccount_DiemAccount_authentication_key () Int)
(declare-fun $DiemAccount_DiemAccount_withdraw_capability () Int)
(declare-fun $DiemAccount_DiemAccount_key_rotation_capability () Int)
(declare-fun $DiemAccount_DiemAccount_received_events () Int)
(declare-fun $DiemAccount_DiemAccount_sent_events () Int)
(declare-fun $DiemAccount_DiemAccount_sequence_number () Int)
(declare-fun $DiemAccount_DiemAccount_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AccountOperationsCapability_limits_cap () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_creation_events () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AdminTransactionEvent_committed_timestamp_secs () Int)
(declare-fun $DiemAccount_AdminTransactionEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_Balance_coin () Int)
(declare-fun $DiemAccount_Balance_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemAccount_CreateAccountEvent_created () Int)
(declare-fun $DiemAccount_CreateAccountEvent_role_id () Int)
(declare-fun $DiemAccount_CreateAccountEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_DiemWriteSetManager_upgrade_events () Int)
(declare-fun $DiemAccount_DiemWriteSetManager_type_value () T@$TypeValue)
(declare-fun $DiemAccount_KeyRotationCapability_account_address () Int)
(declare-fun $DiemAccount_KeyRotationCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_ReceivedPaymentEvent_amount () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_payer () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_SentPaymentEvent_amount () Int)
(declare-fun $DiemAccount_SentPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_SentPaymentEvent_payee () Int)
(declare-fun $DiemAccount_SentPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_SentPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_WithdrawCapability_account_address () Int)
(declare-fun $DiemAccount_WithdrawCapability_type_value () T@$TypeValue)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_key () Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap () Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $AccountFreezing_FreezeAccountEvent $AccountFreezing_FreezeEventsHolder $AccountFreezing_FreezingBit $AccountFreezing_UnfreezeAccountEvent $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $Authenticator_MultiEd25519PublicKey $ChainId_ChainId $FixedPoint32_FixedPoint32 $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $DesignatedDealer_Dealer $DesignatedDealer_ReceivedMintEvent $DesignatedDealer_TierInfo $XDX_XDX $XDX_Reserve $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_Config $ValidatorConfig_ValidatorConfig $VASP_ChildVASP $VASP_ParentVASP $TransactionFee_TransactionFee $SlidingNonce_SlidingNonce $DualAttestation_BaseUrlRotationEvent $DualAttestation_ComplianceKeyRotationEvent $DualAttestation_Credential $DualAttestation_Limit $DiemTransactionPublishingOption_DiemTransactionPublishingOption $DiemAccount_DiemAccount $DiemAccount_AccountOperationsCapability $DiemAccount_AdminTransactionEvent $DiemAccount_Balance $DiemAccount_CreateAccountEvent $DiemAccount_DiemWriteSetManager $DiemAccount_KeyRotationCapability $DiemAccount_ReceivedPaymentEvent $DiemAccount_SentPaymentEvent $DiemAccount_WithdrawCapability $SharedEd25519PublicKey_SharedEd25519PublicKey)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_FreezeAccountEvent_frozen_address 1))
(assert (= $AccountFreezing_FreezeAccountEvent_type_value ($StructType $AccountFreezing_FreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeEventsHolder_freeze_event_handle 0))
(assert (= $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle 1))
(assert (= $AccountFreezing_FreezeEventsHolder_type_value ($StructType $AccountFreezing_FreezeEventsHolder $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezingBit_is_frozen 0))
(assert (= $AccountFreezing_FreezingBit_type_value ($StructType $AccountFreezing_FreezingBit $EmptyTypeValueArray)))
(assert (= $AccountFreezing_UnfreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_UnfreezeAccountEvent_unfrozen_address 1))
(assert (= $AccountFreezing_UnfreezeAccountEvent_type_value ($StructType $AccountFreezing_UnfreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0@@0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0@@0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@1) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@1))
)))
(assert (forall ((public_key@@1 T@$Value) )  (and (and ((_ is $Vector) ($Authenticator_spec_ed25519_authentication_key public_key@@1)) (let ((va@@8 (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key public_key@@1))) $$0))
)))))
(assert (forall ((k T@$Value) )  (and (and ((_ is $Vector) ($Authenticator_spec_multi_ed25519_authentication_key k)) (let ((va@@9 (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Authenticator_spec_multi_ed25519_authentication_key k))) $$0@@0))
)))))
(assert (= $Authenticator_MultiEd25519PublicKey_public_keys 0))
(assert (= $Authenticator_MultiEd25519PublicKey_threshold 1))
(assert (= $Authenticator_MultiEd25519PublicKey_type_value ($StructType $Authenticator_MultiEd25519PublicKey $EmptyTypeValueArray)))
(assert (= $ChainId_ChainId_id 0))
(assert (= $ChainId_ChainId_type_value ($StructType $ChainId_ChainId $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_Dealer_mint_event_handle 0))
(assert (= $DesignatedDealer_Dealer_type_value ($StructType $DesignatedDealer_Dealer $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_ReceivedMintEvent_currency_code 0))
(assert (= $DesignatedDealer_ReceivedMintEvent_destination_address 1))
(assert (= $DesignatedDealer_ReceivedMintEvent_amount 2))
(assert (= $DesignatedDealer_ReceivedMintEvent_type_value ($StructType $DesignatedDealer_ReceivedMintEvent $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_TierInfo_window_start 0))
(assert (= $DesignatedDealer_TierInfo_window_inflow 1))
(assert (= $DesignatedDealer_TierInfo_tiers 2))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($DesignatedDealer_TierInfo_type_value $tv0@@9) ($StructType $DesignatedDealer_TierInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($DesignatedDealer_TierInfo_type_value $tv0@@9))
)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@10 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@10) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1))) :pattern ( ($Option_Option_type_value $tv0@@10))
)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@11 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@11) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@11))
)))
(assert (forall ((account T@$Value) (seq_nonce T@$Value) )  (and (and ((_ is $Integer) ($SlidingNonce_spec_try_record_nonce account seq_nonce)) (>= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) 0)) (<= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) $MAX_U64))))
(assert (= $SlidingNonce_SlidingNonce_min_nonce 0))
(assert (= $SlidingNonce_SlidingNonce_nonce_mask 1))
(assert (= $SlidingNonce_SlidingNonce_type_value ($StructType $SlidingNonce_SlidingNonce $EmptyTypeValueArray)))
(assert (forall ((payer T@$Value) (metadata T@$Value) (deposit_value T@$Value) )  (and (and ((_ is $Vector) ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value)) (let ((va@@10 (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0@@1))
)))))
(assert (= $DualAttestation_BaseUrlRotationEvent_new_base_url 0))
(assert (= $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_BaseUrlRotationEvent_type_value ($StructType $DualAttestation_BaseUrlRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key 0))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_type_value ($StructType $DualAttestation_ComplianceKeyRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_Credential_human_name 0))
(assert (= $DualAttestation_Credential_base_url 1))
(assert (= $DualAttestation_Credential_compliance_public_key 2))
(assert (= $DualAttestation_Credential_expiration_date 3))
(assert (= $DualAttestation_Credential_compliance_key_rotation_events 4))
(assert (= $DualAttestation_Credential_base_url_rotation_events 5))
(assert (= $DualAttestation_Credential_type_value ($StructType $DualAttestation_Credential $EmptyTypeValueArray)))
(assert (= $DualAttestation_Limit_micro_xdx_limit 0))
(assert (= $DualAttestation_Limit_type_value ($StructType $DualAttestation_Limit $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((auth_key_prefix T@$Value) )  (and (and ((_ is $Vector) ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix)) (let ((va@@11 (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@2))
)))))
(assert (= $DiemAccount_DiemAccount_authentication_key 0))
(assert (= $DiemAccount_DiemAccount_withdraw_capability 1))
(assert (= $DiemAccount_DiemAccount_key_rotation_capability 2))
(assert (= $DiemAccount_DiemAccount_received_events 3))
(assert (= $DiemAccount_DiemAccount_sent_events 4))
(assert (= $DiemAccount_DiemAccount_sequence_number 5))
(assert (= $DiemAccount_DiemAccount_type_value ($StructType $DiemAccount_DiemAccount $EmptyTypeValueArray)))
(assert (= $DiemAccount_AccountOperationsCapability_limits_cap 0))
(assert (= $DiemAccount_AccountOperationsCapability_creation_events 1))
(assert (= $DiemAccount_AccountOperationsCapability_type_value ($StructType $DiemAccount_AccountOperationsCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_AdminTransactionEvent_committed_timestamp_secs 0))
(assert (= $DiemAccount_AdminTransactionEvent_type_value ($StructType $DiemAccount_AdminTransactionEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_Balance_coin 0))
(assert (forall (($tv0@@12 T@$TypeValue) ) (! (= ($DiemAccount_Balance_type_value $tv0@@12) ($StructType $DiemAccount_Balance ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1))) :pattern ( ($DiemAccount_Balance_type_value $tv0@@12))
)))
(assert (= $DiemAccount_CreateAccountEvent_created 0))
(assert (= $DiemAccount_CreateAccountEvent_role_id 1))
(assert (= $DiemAccount_CreateAccountEvent_type_value ($StructType $DiemAccount_CreateAccountEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_DiemWriteSetManager_upgrade_events 0))
(assert (= $DiemAccount_DiemWriteSetManager_type_value ($StructType $DiemAccount_DiemWriteSetManager $EmptyTypeValueArray)))
(assert (= $DiemAccount_KeyRotationCapability_account_address 0))
(assert (= $DiemAccount_KeyRotationCapability_type_value ($StructType $DiemAccount_KeyRotationCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_ReceivedPaymentEvent_amount 0))
(assert (= $DiemAccount_ReceivedPaymentEvent_currency_code 1))
(assert (= $DiemAccount_ReceivedPaymentEvent_payer 2))
(assert (= $DiemAccount_ReceivedPaymentEvent_metadata 3))
(assert (= $DiemAccount_ReceivedPaymentEvent_type_value ($StructType $DiemAccount_ReceivedPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_SentPaymentEvent_amount 0))
(assert (= $DiemAccount_SentPaymentEvent_currency_code 1))
(assert (= $DiemAccount_SentPaymentEvent_payee 2))
(assert (= $DiemAccount_SentPaymentEvent_metadata 3))
(assert (= $DiemAccount_SentPaymentEvent_type_value ($StructType $DiemAccount_SentPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_WithdrawCapability_account_address 0))
(assert (= $DiemAccount_WithdrawCapability_type_value ($StructType $DiemAccount_WithdrawCapability $EmptyTypeValueArray)))
(assert (= $SharedEd25519PublicKey_SharedEd25519PublicKey_key 0))
(assert (= $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap 1))
(assert (= $SharedEd25519PublicKey_SharedEd25519PublicKey_type_value ($StructType $SharedEd25519PublicKey_SharedEd25519PublicKey $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k@@0 Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k@@0) (ite  (and (<= |l#0@@3| k@@0) (< k@@0 |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k@@0)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k@@0))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$$t2@1 () T@$Value)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory () T@$Memory)
(declare-fun addr () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 333287) (let ((inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon6_Else_correct true))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon6_Then_correct true))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon2$1_correct  (=> (= inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (and (=> (= (ControlFlow 0 308817) 308833) inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 308817) 308823) inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 308771) 308817)) inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon2$1_correct)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 308841) 308817) inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon2$1_correct)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 308765) 308841) inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 308765) 308771) inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@3))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr))
)) (= (ControlFlow 0 308847) 308765)) inline$$SharedEd25519PublicKey_exists_at_$def_verify$0$anon0_correct)))
(let ((anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 308625) 308847)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 333287) 308625) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@20 () Bool)
(declare-fun $DiemAccount_DiemAccount_$memory () T@$Memory)
(declare-fun key () T@$Value)
(declare-fun $abort_code@33 () Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1 () T@$Memory)
(declare-fun $abort_flag@19 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@5 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@3 () T@$Memory)
(declare-fun $abort_code@31 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@4 () T@$Memory)
(declare-fun $abort_code@32 () Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 () T@$Memory)
(declare-fun $abort_code@28 () Int)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $abort_code@29 () Int)
(declare-fun $abort_flag@18 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun $abort_code@30 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_code@27 () Int)
(declare-fun $abort_code@25 () Int)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $DiemAccount_DiemAccount_$memory@1 () T@$Memory)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@26 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@2 () T@$Memory)
(declare-fun $abort_code@15 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@0 () T@$Memory)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@16 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_code@18 () Int)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_flag@14 () Bool)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun $abort_code@22 () Int)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$2$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1 () T@$Value)
(declare-fun $abort_code@24 () Int)
(declare-fun $abort_code@19 () Int)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $abort_code@21 () Int)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_code@23 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$2$$t2@1 () T@$Value)
(declare-fun $abort_code@20 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$Signature_ed25519_validate_pubkey$0$res@1 () T@$Value)
(declare-fun $abort_code@17 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def$0$$t8@1 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@13 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun inline$$Option_Option_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$1$$t2@1 () T@$Value)
(declare-fun $abort_code@11 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t13@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@9 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_code@5 () Int)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$0$$t2@1 () T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$t5@1 () T@$Value)
(declare-fun $Option_Option_$memory () T@$Memory)
(declare-fun $DiemAccount_KeyRotationCapability_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 333437) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 318657) (- 0 340799)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@20)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@20) (and (=> (= (ControlFlow 0 318657) (- 0 340811)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@20)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@20) (and (=> (= (ControlFlow 0 318657) (- 0 340829)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@20)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@20) (and (=> (= (ControlFlow 0 318657) (- 0 340841)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey key))))) $abort_flag@20)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey key))))) $abort_flag@20) (and (=> (= (ControlFlow 0 318657) (- 0 340856)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@1 1)))) len@@0 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@0 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) $abort_flag@20)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@1 1)))) len@@0 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@0 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) $abort_flag@20) (and (=> (= (ControlFlow 0 318657) (- 0 340903)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key key)))) ($Integer 32))))) $abort_flag@20)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key key)))) ($Integer 32))))) $abort_flag@20) (and (=> (= (ControlFlow 0 318657) (- 0 340924)) (=> $abort_flag@20 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey key)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@3 1)))) len@@2 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@2 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key key)))) ($Integer 32)))))))) (=> (=> $abort_flag@20 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey key)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@3 1)))) len@@2 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@2 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key key)))) ($Integer 32))))))) (and (=> (= (ControlFlow 0 318657) (- 0 341044)) (=> $abort_flag@20 (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (= $abort_code@33 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@33 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@33 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey key))))) (= $abort_code@33 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@5 1)))) len@@4 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@4 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) (= $abort_code@33 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key key)))) ($Integer 32))))) (= $abort_code@33 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@20 (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (= $abort_code@33 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@33 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@33 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey key))))) (= $abort_code@33 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (+ len@@5 1)))) len@@4 ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0))) (+ len@@4 1)))))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) (= $abort_code@33 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key key)))) ($Integer 32))))) (= $abort_code@33 (|i#$Integer| ($Integer 7)))))) (and (=> (= (ControlFlow 0 318657) (- 0 341230)) (=> (not $abort_flag@20) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0)))))) (=> (=> (not $abort_flag@20) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0))))) (=> (= (ControlFlow 0 318657) (- 0 341244)) (=> (not $abort_flag@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1) $EmptyTypeValueArray (|a#$Address| account@@0)))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key) key)))))))))))))))))))))))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon41_Else_correct  (=> (not $abort_flag@19) (and (=> (= (ControlFlow 0 318555) (- 0 340612)) (|b#$Boolean| ($Boolean (forall ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$SharedEd25519PublicKey_publish_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| inline$$SharedEd25519PublicKey_publish_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$SharedEd25519PublicKey_publish_$def_verify$0$addr)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$SharedEd25519PublicKey_publish_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| inline$$SharedEd25519PublicKey_publish_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$SharedEd25519PublicKey_publish_$def_verify$0$addr@@0))))))))))) (=> (= $DiemAccount_DiemAccount_$memory@5 $DiemAccount_DiemAccount_$memory@3) (=> (and (and (= $abort_flag@20 $abort_flag@19) (= $abort_code@33 $abort_code@31)) (and (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 318555) 318657))) anon0$2_correct)))))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$Abort_correct  (=> (= $DiemAccount_DiemAccount_$memory@5 $DiemAccount_DiemAccount_$memory@4) (=> (and (and (= $abort_flag@20 true) (= $abort_code@33 $abort_code@32)) (and (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@1 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0) (= (ControlFlow 0 318172) 318657))) anon0$2_correct))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon13_correct  (=> (and (and (= $abort_code@32 $abort_code@28) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 318611) 318172))) inline$$SharedEd25519PublicKey_publish_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 318609) 318611)) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon13_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 318619) 318611) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon13_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon34_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 318603) 318619) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 318603) 318609) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon19_correct  (=> (and (and (= $abort_code@32 $abort_code@29) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 318587) 318172))) inline$$SharedEd25519PublicKey_publish_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 318585) 318587)) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 318595) 318587) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon37_Then_correct  (=> $abort_flag@18 (and (=> (= (ControlFlow 0 318579) 318595) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 318579) 318585) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon27_correct  (=> (and (and (= $abort_code@32 $abort_code@31) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 |inline$$MoveToRaw$0$m'@2|)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 318567) 318172))) inline$$SharedEd25519PublicKey_publish_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 318565) 318567)) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon27_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 318575) 318567) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon27_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon41_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 318559) 318575) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 318559) 318565) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_code@31 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@19 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 318494) 318559) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 318494) 318555) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 318492) 318494)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 |inline$$WritebackToValue$1$vdst'@2|))) (= $abort_code@31 $abort_code@29)) (and (= $abort_flag@19 $abort_flag@18) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 318442) 318559) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 318442) 318555) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account@@0)) (and (=> (= (ControlFlow 0 318500) 318492) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 318500) 318442) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 318288) (- 0 340497)) true) (=> (= (ControlFlow 0 318288) 318500) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 318508) 318288)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon24_correct  (=> (and (and (= $abort_code@32 $abort_code@30) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 318168) 318172))) inline$$SharedEd25519PublicKey_publish_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 318166) 318168)) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon24_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 318180) 318168) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon24_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= $abort_code@30 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 318160) 318180) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 318160) 318166) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon37_Else_correct  (=> (not $abort_flag@18) (and (=> (= (ControlFlow 0 318148) 318508) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 318148) 318160) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon36_Else$1_correct  (=> (and (and (and (= inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t14@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@18)) (and (=> $abort_flag@18 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 318142) 318579) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 318142) 318148) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Not$1$anon0_correct  (=> (and (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1)))) (= (ControlFlow 0 318130) 318142)) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon36_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 318120) (- 0 340353)) true) (=> (= (ControlFlow 0 318120) 318130) inline$$Not$1$anon0_correct))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 318136) 318120)) inline$$Not$1$Entry_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon36_Then_correct  (=> $abort_flag@17 (=> (and (and (= $abort_code@32 $abort_code@28) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 318599) 318172))) inline$$SharedEd25519PublicKey_publish_$def_verify$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 318048) 318599) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 318048) 318136) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 318058) 318599) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 318058) 318136) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon36_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct  (=> (= inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@0)))) (and (=> (= (ControlFlow 0 318042) 318058) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 318042) 318048) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 317996) 318042)) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 318066) 318042) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon0_correct  (=> (not $abort_flag@17) (and (=> (= (ControlFlow 0 317990) 318066) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 317990) 317996) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$direct_intra$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@0) (= (ControlFlow 0 318072) 317990)) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 318080) 318072)) inline$$SharedEd25519PublicKey_exists_at_$direct_intra$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon33_Else$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@17) (=> $abort_flag@17 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 317834) 318603) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 317834) 318080) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WriteRef$3$to'@1|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1) (= (ControlFlow 0 317800) 317834)) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon33_Else$2_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WriteRef$3$to'@1|) ($Local 2)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1|) 0 inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1 (|v#$Mutation| |inline$$WriteRef$3$to'@1|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 317826) 317834))) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon33_Else$2_correct)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2)) (and (=> (= (ControlFlow 0 317701) 317826) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 317701) 317800) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon33_Else_correct  (=> (and (not $abort_flag@16) (= (ControlFlow 0 317707) 317701)) inline$$WriteRef$3$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon33_Then_correct  (=> $abort_flag@16 (=> (and (and (= $abort_code@32 $abort_code@27) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= (ControlFlow 0 318623) 318172))) inline$$SharedEd25519PublicKey_publish_$def_verify$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon24_correct  (=> (and (and (= $abort_code@27 $abort_code@25) (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2|)) (and (= $abort_flag@16 $abort_flag@15) (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@1))) (and (=> (= (ControlFlow 0 317540) 318623) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 317540) 317707) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 317538) 317540)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon24_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 317548) 317540) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon24_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 4))) (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$1$v@1)) (and (=> (= (ControlFlow 0 317496) 317548) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 317496) 317538) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 4)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 inline$$ReadRef$1$v@1 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|)) (and (=> (= (ControlFlow 0 317522) 317548) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 317522) 317538) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Else_correct))))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (= |inline$$WritebackToReference$2$dst'@2| inline$$BorrowLoc$1$dst@1)) (and (=> (= (ControlFlow 0 317341) 317522) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 317341) 317496) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (and (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$2$to'@1|)))) (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|))) (and (=> (= (ControlFlow 0 317397) 317522) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 317397) 317496) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 317305) 317397) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 317305) 317341) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct  (=> (and (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) key)) (= (ControlFlow 0 317162) 317305)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $SharedEd25519PublicKey_SharedEd25519PublicKey_key) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) (= (ControlFlow 0 317103) 317162))) inline$$WriteRef$2$anon0_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 317109) 317103)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct  (=> (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@1 $Error) (=> (and (and (= $abort_code@27 $abort_code@26) (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2 inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@1)) (and (= $abort_flag@16 true) (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@2))) (and (=> (= (ControlFlow 0 314449) 318623) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 314449) 317707) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon7_correct  (=> (= $abort_code@26 $abort_code@15) (=> (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 317604) 314449)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 317602) 317604)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon7_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 317612) 317604) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon7_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 317596) 317612) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 317596) 317602) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon11_correct  (=> (= $abort_code@26 $abort_code@16) (=> (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 317584) 314449)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 317582) 317584)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon11_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 317592) 317584) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon11_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 317576) 317592) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 317576) 317582) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon19_correct  (=> (= $abort_code@26 $abort_code@18) (=> (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 317564) 314449)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 317562) 317564)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 317572) 317564) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 317556) 317572) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 317556) 317562) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Then_correct  (=> (and (and $abort_flag@15 (= $abort_code@26 $abort_code@25)) (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@1) (= (ControlFlow 0 317552) 314449))) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct  (=> (= $abort_flag@15 $abort_flag@14) (=> (and (= $DiemAccount_DiemAccount_$memory@1 |inline$$WritebackToGlobal$1$m'@2|) (= $abort_code@25 $abort_code@22)) (and (=> (= (ControlFlow 0 316859) 317552) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 316859) 317109) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Else_correct))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 316797) 316859)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 316851) 316859))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (and (=> (= (ControlFlow 0 316787) 316851) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 316787) 316797) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$2$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (= (ControlFlow 0 316665) 316787)) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 316586) 316665)) inline$$DiemAccount_DiemAccount_$pack_ref$2$Entry_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 316642) 316665))) inline$$DiemAccount_DiemAccount_$pack_ref$2$Entry_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 316550) 316642) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 316550) 316586) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 316413) 316550)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct  (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 316869) 316550)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1) (|p#$Mutation| inline$$BorrowField$2$dst@1) call3formal@$ret0@0@@1)) (and (=> (= (ControlFlow 0 316399) 316869) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 316399) 316413) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct)))))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $DiemAccount_DiemAccount_authentication_key) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $DiemAccount_DiemAccount_authentication_key))) (= (ControlFlow 0 316340) 316399))) inline$$WriteRef$1$anon0_correct))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1) (= (ControlFlow 0 316346) 316340)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct  (=> (= $abort_flag@15 true) (=> (and (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory@0) (= $abort_code@25 $abort_code@24)) (and (=> (= (ControlFlow 0 315786) 317552) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 315786) 317109) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Else_correct))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct  (=> (and (= $abort_code@24 $abort_code@19) (= (ControlFlow 0 316941) 315786)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 316939) 316941)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct  (=> (= (ControlFlow 0 316949) 316941) inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 316933) 316949) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 316933) 316939) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct  (=> (and (= $abort_code@24 $abort_code@21) (= (ControlFlow 0 316921) 315786)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 316919) 316921)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 316929) 316921) inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 316913) 316929) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 316913) 316919) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct  (=> (and (= $abort_code@24 $abort_code@21) (= (ControlFlow 0 316901) 315786)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 316899) 316901)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct  (=> (= (ControlFlow 0 316909) 316901) inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 316893) 316909) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 316893) 316899) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct  (=> (and (= $abort_code@24 $abort_code@22) (= (ControlFlow 0 316881) 315786)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 316879) 316881)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct  (=> (= (ControlFlow 0 316889) 316881) inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 316873) 316889) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 316873) 316879) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct  (=> (and (= $abort_code@24 $abort_code@23) (= (ControlFlow 0 316210) 315786)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 316208) 316210)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct  (=> (= (ControlFlow 0 316218) 316210) inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct  (=> (= $abort_code@23 (|i#$Integer| call3formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 316202) 316218) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 316202) 316208) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 316190) 316202)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1)) (= (ControlFlow 0 316196) 316190)) inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct  (=> (not $abort_flag@14) (and (=> (= (ControlFlow 0 316167) 316346) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 316167) 316196) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct  (=> (not $abort_flag@13) (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1 ($Integer 32)) (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1 inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1)))) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1 ($Integer 8)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@14)) (and (=> $abort_flag@14 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 316161) 316873) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 316161) 316167) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct)))))))
(let ((inline$$Vector_length$0$anon0_correct  (=> (and ((_ is $Vector) call3formal@$ret0@0@@1) (= inline$$Vector_length$0$l@1 ($Integer (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1))))) (and (=> (= (ControlFlow 0 316131) 316893) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 316131) 316161) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct)))))
(let ((inline$$Vector_length$0$Entry_correct  (=> (and (= inline$$Vector_length$0$ta@0 $IntegerType) (= (ControlFlow 0 316119) 316131)) inline$$Vector_length$0$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$1$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 316076) 316119)) inline$$Vector_length$0$Entry_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$1$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 316070) 316076)) inline$$DiemAccount_DiemAccount_$unpack_ref$1$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@13) (= (ControlFlow 0 316080) 316070)) inline$$DiemAccount_DiemAccount_$unpack_ref$1$Entry_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (= $abort_code@21 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@13 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 316037) 316913) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 316037) 316080) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 316035) 316037)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1))) (= $abort_code@21 $abort_code@19)) (and (= $abort_flag@13 $abort_flag@12) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 315983) 316913) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 315983) 316080) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$GetFieldFromValue$2$dst@1)) (and (=> (= (ControlFlow 0 315953) 316035) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 315953) 315983) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 315947) (- 0 339003)) true) (=> (= (ControlFlow 0 315947) 315953) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (and (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 315840) 315947)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$2$$t2@1) (= (ControlFlow 0 315846) 315840)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct  (=> (and (= $abort_code@24 $abort_code@20) (= (ControlFlow 0 315782) 315786)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 315780) 315782)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 315794) 315782) inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$2$$t2@1)) (= $abort_code@20 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 315774) 315794) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 315774) 315780) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 315762) 315846) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 315762) 315774) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct  (=> (not $abort_flag@11) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@12)) (and (=> $abort_flag@12 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 315756) 316933) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 315756) 315762) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct  (=> $abort_flag@11 (=> (and (= $abort_code@24 $abort_code@18) (= (ControlFlow 0 316953) 315786)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 315712) 316953) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 315712) 315756) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon6_Then_correct  (and (=> (= (ControlFlow 0 315722) 316953) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 315722) 315756) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$2$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$1$dst@1)))) (and (=> (= (ControlFlow 0 315706) 315722) inline$$DiemAccount_exists_at_$def$2$anon6_Then_correct) (=> (= (ControlFlow 0 315706) 315712) inline$$DiemAccount_exists_at_$def$2$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$2$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 315660) 315706)) inline$$DiemAccount_exists_at_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$2$anon5_Then_correct  (=> (= (ControlFlow 0 315730) 315706) inline$$DiemAccount_exists_at_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$2$anon0_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 315654) 315730) inline$$DiemAccount_exists_at_$def$2$anon5_Then_correct) (=> (= (ControlFlow 0 315654) 315660) inline$$DiemAccount_exists_at_$def$2$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$2$anon0_correct  (=> (and ((_ is $Address) inline$$GetFieldFromValue$1$dst@1) (= (ControlFlow 0 315736) 315654)) inline$$DiemAccount_exists_at_$def$2$anon0_correct)))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 315496) 315736)) inline$$DiemAccount_exists_at$2$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 315386) 315496)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 316961) 315496) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 315378) 316961) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 315378) 315386) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 316969) 316961) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 316969) 315386) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 315372) 316969) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 315372) 315378) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_rotate_authentication_key$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$2$v@1) (let ((va@@15 (|v#$Vector| inline$$ReadRef$2$v@1)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $DiemAccount_KeyRotationCapability_account_address))) true) (and (and (and ((_ is $Vector) call3formal@$ret0@0@@1) (let ((va@@16 (|v#$Vector| call3formal@$ret0@0@@1)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (forall ((inline$$DiemAccount_rotate_authentication_key$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_rotate_authentication_key$0$$$0 0) (< inline$$DiemAccount_rotate_authentication_key$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$DiemAccount_rotate_authentication_key$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$DiemAccount_rotate_authentication_key$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$DiemAccount_rotate_authentication_key$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$DiemAccount_rotate_authentication_key$0$$$0))
))) (= (ControlFlow 0 316973) 315372))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Else_correct  (=> (and (not $abort_flag@11) (= (ControlFlow 0 316979) 316973)) inline$$DiemAccount_rotate_authentication_key$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then$1_correct  (and (=> (= (ControlFlow 0 314673) (- 0 338531)) true) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11) (=> (and (=> $abort_flag@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Authenticator_spec_ed25519_authentication_key key)))))) (=> (and (and ((_ is $Vector) call3formal@$ret0@0@@1) (let ((va@@17 (|v#$Vector| call3formal@$ret0@0@@1)))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@4))
))) (and (=> (= (ControlFlow 0 314673) 317556) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 314673) 316979) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Else_correct))))))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 314653) 314673)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then$1_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) (= (ControlFlow 0 314615) 314653))) inline$$ReadRef$2$anon0_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then_correct  (=> (and (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1) (= (ControlFlow 0 314667) 314615)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon16_correct  (=> (= $abort_code@26 $abort_code@17) (=> (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 314443) 314449)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 314441) 314443)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon16_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 314457) 314443) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon16_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Else_correct  (=> (and (not (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1)) (= $abort_code@17 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 314435) 314457) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 314435) 314441) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Else_correct  (=> (not $abort_flag@10) (and (=> (= (ControlFlow 0 314423) 314667) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 314423) 314435) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Else_correct  (=> (not $abort_flag@9) (=> (and (and (and (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@10)) (and (=> $abort_flag@10 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 314417) 317576) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 314417) 314423) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Else_correct))))))
(let ((inline$$Signature_ed25519_validate_pubkey$0$anon0_correct  (=> (= inline$$Signature_ed25519_validate_pubkey$0$res@1 ($Signature_$ed25519_validate_pubkey key)) (and (=> (= (ControlFlow 0 314399) 317596) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 314399) 314417) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Else_correct)))))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 4) $EmptyPath inline$$ReadRef$1$v@1)) (= (ControlFlow 0 314361) 314399)) inline$$Signature_ed25519_validate_pubkey$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 314243) 314361)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 317620) 314361) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 314235) 317620) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 314235) 314243) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 317628) 317620) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 317628) 314243) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon0_correct  (=> (not $abort_flag@9) (and (=> (= (ControlFlow 0 314229) 317628) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 314229) 314235) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$anon0_correct  (=> (and (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1) (let ((va@@18 (|v#$Vector| inline$$ReadRef$1$v@1)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@5))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) (and (and (and ((_ is $Vector) key) (let ((va@@21 (|v#$Vector| key)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (forall ((inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0 Int) ) (!  (=> (and (>= inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0 0) (< inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0 (|l#$ValueArray| (|v#$Vector| key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| key)) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| key)) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| key)) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| key)) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0))
))) (= (ControlFlow 0 317634) 314229))) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon8$2_correct  (and (=> (= (ControlFlow 0 317642) (- 0 338145)) true) (=> (= (ControlFlow 0 317642) 317634) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$anon0_correct))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 313652) 317642)) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon8$2_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 2) $EmptyPath inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1)) (= (ControlFlow 0 313614) 313652)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 313564) 313614)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 318631) 313614) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 313544) 318631) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 313544) 313564) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 313550) 318631) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 313550) 313564) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon32_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon3_Then_correct  (=> (> 1476 0) (and (=> (= (ControlFlow 0 313538) 313550) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 313538) 313544) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon4_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon3_Else_correct  (=> (>= 0 1476) (and (=> (= (ControlFlow 0 313530) 318631) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 313530) 313564) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon0_correct  (=> (and (and ((_ is $Vector) inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1) (let ((va@@22 (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (forall ((inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0 0) (< inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$$0))
))) (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2) (let ((va@@23 (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address))) true) (= inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1) 1 inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2) 2)))) (and (=> (= (ControlFlow 0 313522) 313538) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 313522) 313530) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon3_Else_correct))))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon31_Else_correct  (=> (and (not $abort_flag@9) (= (ControlFlow 0 313556) 313522)) inline$$SharedEd25519PublicKey_SharedEd25519PublicKey_pack$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon31_Then_correct  (=> $abort_flag@9 (=> (and (and (= $abort_code@32 $abort_code@15) (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory)) (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@0) (= (ControlFlow 0 318635) 318172))) inline$$SharedEd25519PublicKey_publish_$def_verify$0$Abort_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct  (=> (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 call4formal@$ret0@0) (= $abort_flag@9 $abort_flag@8)) (and (= $abort_code@15 $abort_code@13) (= $DiemAccount_DiemAccount_$memory@0 |inline$$WritebackToGlobal$0$m'@2|))) (and (=> (= (ControlFlow 0 313144) 318635) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 313144) 313556) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 313142) 313144)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 313152) 313144) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (= |inline$$WritebackToGlobal$0$m'@2| $DiemAccount_DiemAccount_$memory)) (and (=> (= (ControlFlow 0 313072) 313152) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 313072) 313142) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1))) (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|))) (and (=> (= (ControlFlow 0 313126) 313152) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 313126) 313142) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct))))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 313062) 313126) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 313062) 313072) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 312940) 313062)) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 312861) 312940)) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 312917) 312940))) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 312825) 312917) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 312825) 312861) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 312684) (- 0 337578)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 312684) 312825) inline$$WritebackToReference$0$anon0_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$pack_ref$0$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)) (= (ControlFlow 0 312660) 312684)) inline$$Option_Option_$pack_ref$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 312614) 312660)) inline$$Option_Option_$pack_ref$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Then_correct  (=> (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 313162) 312660)) inline$$Option_Option_$pack_ref$0$Entry_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) call5formal@$ret1@0)) (and (=> (= (ControlFlow 0 312600) 313162) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 312600) 312614) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 312606) 312600)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct  (=> (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1) (= $abort_flag@9 true)) (and (= $abort_code@15 $abort_code@14) (= $DiemAccount_DiemAccount_$memory@0 $DiemAccount_DiemAccount_$memory))) (and (=> (= (ControlFlow 0 311799) 318635) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 311799) 313556) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon5_correct  (=> (and (= $abort_code@14 $abort_code@1) (= (ControlFlow 0 313262) 311799)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 313260) 313262)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 313270) 313262) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 313254) 313270) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 313254) 313260) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon11_correct  (=> (and (= $abort_code@14 $abort_code@8) (= (ControlFlow 0 313238) 311799)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 313236) 313238)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 313246) 313238) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 313230) 313246) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 313230) 313236) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon21_correct  (=> (and (= $abort_code@14 $abort_code@10) (= (ControlFlow 0 313214) 311799)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 313212) 313214)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Then_correct  (=> (= (ControlFlow 0 313222) 313214) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 313206) 313222) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 313206) 313212) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon29_correct  (=> (and (= $abort_code@14 $abort_code@12) (= (ControlFlow 0 313194) 311799)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 313192) 313194)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon29_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 313202) 313194) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon29_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 313186) 313202) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 313186) 313192) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon33_correct  (=> (and (= $abort_code@14 $abort_code@13) (= (ControlFlow 0 313174) 311799)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 313172) 313174)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 313182) 313174) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 313166) 313182) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 313166) 313172) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else$4_correct  (and (=> (= (ControlFlow 0 312543) (- 0 337414)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (and (= call0formal@$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec)) ($Integer 0)))) $abort_flag@8)) (=> (and (and (=> $abort_flag@8 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec)) ($Integer 0))))) (=> $abort_flag@8 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@13 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 ($Vector_$borrow call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec) ($Integer 0)))))) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec)) ($Integer 0))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret1@0) (let ((va@@24 (|v#$Vector| call5formal@$ret1@0)))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 312543) 313166) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 312543) 312606) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Else_correct)))))))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 312531) 312543)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else$4_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$0$$before@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 312495) 312531)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$unpack_ref$0$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 312489) 312495)) inline$$Option_Option_$unpack_ref$0$anon0_correct))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemAccount_DiemAccount_key_rotation_capability) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemAccount_DiemAccount_key_rotation_capability))) (= (ControlFlow 0 312455) 312489))) inline$$Option_Option_$unpack_ref$0$Entry_correct))))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 312333) 312455)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 312327) 312333)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 312337) 312327)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_code@12 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 312294) 313186) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 312294) 312337) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 312292) 312294)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_code@12 $abort_code@10)) (and (= $abort_flag@7 $abort_flag@6) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 312240) 313186) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 312240) 312337) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@5)) (and (=> (= (ControlFlow 0 312210) 312292) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 312210) 312240) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 312204) (- 0 337197)) true) (=> (= (ControlFlow 0 312204) 312210) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$1$$t2@1) (= (ControlFlow 0 312300) 312204)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon26_correct  (=> (and (= $abort_code@14 $abort_code@11) (= (ControlFlow 0 312091) 311799)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 312089) 312091)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon26_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 312099) 312091) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon26_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$1$$t2@1)) (= $abort_code@11 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 312083) 312099) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 312083) 312089) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Else_correct  (=> (not $abort_flag@6) (and (=> (= (ControlFlow 0 312071) 312300) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 312071) 312083) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct  (=> (not $abort_flag@5) (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t13@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6)) (and (=> $abort_flag@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 312065) 313206) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 312065) 312071) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct  (=> $abort_flag@5 (=> (and (= $abort_code@14 $abort_code@8) (= (ControlFlow 0 313226) 311799)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 312021) 313226) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 312021) 312065) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon6_Then_correct  (and (=> (= (ControlFlow 0 312031) 313226) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 312031) 312065) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$1$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5)))) (and (=> (= (ControlFlow 0 312015) 312031) inline$$DiemAccount_exists_at_$def$1$anon6_Then_correct) (=> (= (ControlFlow 0 312015) 312021) inline$$DiemAccount_exists_at_$def$1$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 311969) 312015)) inline$$DiemAccount_exists_at_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$1$anon5_Then_correct  (=> (= (ControlFlow 0 312039) 312015) inline$$DiemAccount_exists_at_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$1$anon0_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 311963) 312039) inline$$DiemAccount_exists_at_$def$1$anon5_Then_correct) (=> (= (ControlFlow 0 311963) 311969) inline$$DiemAccount_exists_at_$def$1$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$1$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@5) (= (ControlFlow 0 312045) 311963)) inline$$DiemAccount_exists_at_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 312053) 312045)) inline$$DiemAccount_exists_at$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon16_correct  (=> (and (= $abort_code@14 $abort_code@9) (= (ControlFlow 0 311793) 311799)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 311791) 311793)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 311807) 311793) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@9 (|i#$Integer| call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 311785) 311807) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 311785) 311791) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Else_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 311773) 312053) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 311773) 311785) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t10@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5)) (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 311767) 313230) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 311767) 311773) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2)))) (= (ControlFlow 0 311755) 311767)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 311745) (- 0 336894)) true) (=> (= (ControlFlow 0 311745) 311755) inline$$Not$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 311761) 311745)) inline$$Not$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct  (=> $abort_flag@4 (=> (and (= $abort_code@14 $abort_code@7) (= (ControlFlow 0 313250) 311799)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct  (=> (= $abort_code@7 $abort_code@5) (=> (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 call4formal@$ret0@0@@0) (= $abort_flag@4 $abort_flag@3)) (and (=> (= (ControlFlow 0 311611) 313250) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 311611) 311761) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 311609) 311611)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Then_correct  (=> (= (ControlFlow 0 311619) 311611) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Else_correct  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 311603) 311619) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 311603) 311609) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct  (=> (and (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1 $Error) (= $abort_code@7 $abort_code@6)) (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1) (= $abort_flag@4 true))) (and (=> (= (ControlFlow 0 311352) 313250) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 311352) 311761) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon7_correct  (=> (and (= $abort_code@6 $abort_code@2) (= (ControlFlow 0 311671) 311352)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 311669) 311671)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 311679) 311671) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 311663) 311679) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 311663) 311669) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon15_correct  (=> (and (= $abort_code@6 $abort_code@4) (= (ControlFlow 0 311651) 311352)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 311649) 311651)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon15_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 311659) 311651) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon15_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 311643) 311659) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 311643) 311649) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon19_correct  (=> (and (= $abort_code@6 $abort_code@5) (= (ControlFlow 0 311631) 311352)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 311629) 311631)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 311639) 311631) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 311623) 311639) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 311623) 311629) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else$1_correct  (=> (= call0formal@$tv0@0@@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3) (=> $abort_flag@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)) $Option_Option_vec)) ($Integer 0))))))) ((_ is $Boolean) call4formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 311595) 311623) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 311595) 311603) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $DiemAccount_DiemAccount_key_rotation_capability)) (= (ControlFlow 0 311587) 311595)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else$1_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 311593) 311587)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@2 true) (=> (and (= $abort_code@4 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 311533) 311643) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 311533) 311593) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 311531) 311533)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5))) (= $abort_flag@2 $abort_flag@1)) (and (= $abort_code@4 $abort_code@2) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 311479) 311643) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 311479) 311593) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@5)) (and (=> (= (ControlFlow 0 311461) 311531) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 311461) 311479) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 311455) (- 0 336609)) true) (=> (= (ControlFlow 0 311455) 311461) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1) (= (ControlFlow 0 311539) 311455)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon12_correct  (=> (and (= $abort_code@6 $abort_code@3) (= (ControlFlow 0 311346) 311352)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 311344) 311346)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon12_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 311360) 311346) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon12_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1)) (= $abort_code@3 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 311338) 311360) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 311338) 311344) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 311326) 311539) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 311326) 311338) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct  (=> (not $abort_flag@0) (=> (and (and (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 311320) 311663) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 311320) 311326) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct  (=> $abort_flag@0 (=> (and (= $abort_code@6 $abort_code@1) (= (ControlFlow 0 311683) 311352)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 311276) 311683) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 311276) 311320) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 311286) 311683) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 311286) 311320) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5)))) (and (=> (= (ControlFlow 0 311270) 311286) inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 311270) 311276) inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 311224) 311270)) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 311294) 311270) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon0_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 311218) 311294) inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 311218) 311224) inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@5) (= (ControlFlow 0 311300) 311218)) inline$$DiemAccount_exists_at_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 311032) 311300)) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 311691) 311300) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon0_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 311026) 311691) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 311026) 311032) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@5) (= (ControlFlow 0 311697) 311026)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 311705) 311697)) inline$$DiemAccount_delegated_key_rotation_capability$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 310616) 313254) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 310616) 311705) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 310580) 310616)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 313278) 310616) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 310574) 313278) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 310574) 310580) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 313284) 310574)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon4$2_correct  (=> (and (= inline$$SharedEd25519PublicKey_publish_$def_verify$0$$t7@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (= (ControlFlow 0 313292) 313284)) inline$$DiemAccount_extract_key_rotation_capability_$direct_inter$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 309826) 313292)) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon4$2_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 318643) 313292) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon4$2_correct)))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 309818) 318643) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 309818) 309826) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 318651) 318643) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 318651) 309826) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon30_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 309812) 318651) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 309812) 309818) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@0 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Option_Option_vec)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Option_Option_vec))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))
)) (=> (and (and (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@28 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_authentication_key))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_authentication_key))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_authentication_key))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_authentication_key))) $$0@@6))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@7))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@8))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@38 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_KeyRotationCapability_account_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@2))
))) (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@39 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@9))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@3 T@$Value) )  (=> ((_ is $Address) addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))))))) (= (ControlFlow 0 318655) 309812)))) inline$$SharedEd25519PublicKey_publish_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> ((_ is $Address) account@@0) (=> (and (and (and ((_ is $Vector) key) (let ((va@@42 (|v#$Vector| key)))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| key)) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| key)) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| key)) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| key)) $$0@@10))
))) (= (ControlFlow 0 308973) 318655)) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 333437) 308973) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun addr@@4 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1@@0 () T@$Value)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_key_$def_verify$0$$t5@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 341275) (let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon27_Else_correct true))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon27_Then_correct true))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (and (=> (= (ControlFlow 0 320888) 320914) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 320888) 320904) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 320894) 320888)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$Abort_correct true))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 320944) 320653)) inline$$SharedEd25519PublicKey_key_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 320954) 320653) inline$$SharedEd25519PublicKey_key_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon21_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 320938) 320954) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 320938) 320944) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 320924) 320653)) inline$$SharedEd25519PublicKey_key_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 320934) 320653) inline$$SharedEd25519PublicKey_key_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 320918) 320934) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 320918) 320924) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@1@@0 true) (and (=> (= (ControlFlow 0 320834) 320918) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 320834) 320894) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 320832) 320834)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0) (=> (and (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))) (= $abort_flag@1@@0 $abort_flag@0@@0)) (and (=> (= (ControlFlow 0 320780) 320918) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 320780) 320894) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| addr@@4)) (and (=> (= (ControlFlow 0 320762) 320832) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 320762) 320780) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 320756) (- 0 341732)) true) (=> (= (ControlFlow 0 320756) 320762) inline$$GetGlobal$0$anon0_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon23_Then_correct  (=> (and (|b#$Boolean| inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1@@0) (= (ControlFlow 0 320840) 320756)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 320645) 320653)) inline$$SharedEd25519PublicKey_key_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 320661) 320653) inline$$SharedEd25519PublicKey_key_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1@@0)) (= $abort_code@2@@0 (|i#$Integer| call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 320639) 320661) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 320639) 320645) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 320627) 320840) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 320627) 320639) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon20_Else_correct  (=> (not false) (=> (and (and (and (= inline$$SharedEd25519PublicKey_key_$def_verify$0$$t5@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0)) (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 320621) 320938) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 320621) 320627) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon20_Then_correct true))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 320577) 320958) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 320577) 320621) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 320587) 320958) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 320587) 320621) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon20_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct@@0  (=> (= inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (and (=> (= (ControlFlow 0 320571) 320587) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 320571) 320577) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 320525) 320571)) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 320595) 320571) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon0_correct@@0  (=> (not false) (and (=> (= (ControlFlow 0 320519) 320595) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 320519) 320525) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$direct_intra$0$anon0_correct@@0  (=> (and ((_ is $Address) addr@@4) (= (ControlFlow 0 320601) 320519)) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 320333) 320601)) inline$$SharedEd25519PublicKey_exists_at_$direct_intra$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 320966) 320601) inline$$SharedEd25519PublicKey_exists_at_$direct_intra$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_key_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 320327) 320966) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 320327) 320333) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@43 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@11))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (= (ControlFlow 0 320972) 320327)) inline$$SharedEd25519PublicKey_key_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) addr@@4) (= (ControlFlow 0 319990) 320972)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 341275) 319990) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@1 () T@$Value)
(declare-fun $abort_flag@10@@0 () Bool)
(declare-fun new_public_key () T@$Value)
(declare-fun $abort_code@18@@0 () Int)
(declare-fun $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0@@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@0| () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@4@@0 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@2@@0 () T@$Memory)
(declare-fun $abort_flag@9@@0 () Bool)
(declare-fun $abort_code@16@@0 () Int)
(declare-fun inline$$WritebackToGlobal$1$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@0 () T@$Value)
(declare-fun |inline$$WriteRef$2$to'@1@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2@@0 () T@$Value)
(declare-fun $DiemAccount_DiemAccount_$memory@3@@0 () T@$Memory)
(declare-fun $abort_code@17@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun $DiemAccount_DiemAccount_$memory@0@@0 () T@$Memory)
(declare-fun $abort_flag@8@@0 () Bool)
(declare-fun $abort_code@14@@0 () Int)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$BorrowField$2$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@0 () Int)
(declare-fun inline$$BorrowField$2$p@2@@0 () T@$Path)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $DiemAccount_DiemAccount_$memory@1@@0 () T@$Memory)
(declare-fun $abort_code@15@@0 () Int)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun $abort_code@11@@0 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1@@0 () T@$Value)
(declare-fun $abort_code@13@@0 () Int)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $abort_code@12@@0 () Int)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1@@0 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@0 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1@@0 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0@@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$0$$t2@1@@0 () T@$Value)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1@@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$Signature_ed25519_validate_pubkey$0$res@1@@0 () T@$Value)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def$0$$t8@1@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1@@1 () T@$Value)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 341878) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 326881) (- 0 346218)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@10@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) $abort_flag@10@@0) (and (=> (= (ControlFlow 0 326881) (- 0 346236)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key))))) $abort_flag@10@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key))))) $abort_flag@10@@0) (and (=> (= (ControlFlow 0 326881) (- 0 346251)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) $abort_flag@10@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) $abort_flag@10@@0) (and (=> (= (ControlFlow 0 326881) (- 0 346282)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key)))) ($Integer 32))))) $abort_flag@10@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key)))) ($Integer 32))))) $abort_flag@10@@0) (and (=> (= (ControlFlow 0 326881) (- 0 346303)) (=> $abort_flag@10@@0 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key)))) ($Integer 32)))))))) (=> (=> $abort_flag@10@@0 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key)))) ($Integer 32))))))) (and (=> (= (ControlFlow 0 326881) (- 0 346385)) (=> $abort_flag@10@@0 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key)))) ($Integer 32))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@10@@0 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| account@@1)))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key)))) ($Integer 32))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 7)))))) (=> (= (ControlFlow 0 326881) (- 0 346511)) (=> (not $abort_flag@10@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| account@@1)))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key) new_public_key)))))))))))))))))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon36_Else$2_correct  (and (=> (= (ControlFlow 0 326791) (- 0 346061)) (|b#$Boolean| ($Boolean (forall ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$addr)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$addr@@0))))))))))) (=> (= $DiemAccount_DiemAccount_$memory@4@@0 $DiemAccount_DiemAccount_$memory@2@@0) (=> (and (and (= $abort_flag@10@@0 $abort_flag@9@@0) (= $abort_code@18@@0 $abort_code@16@@0)) (and (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0@@0 |inline$$WritebackToGlobal$1$m'@2@@0|) (= (ControlFlow 0 326791) 326881))) anon0$2_correct@@0))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@0| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) (= (ControlFlow 0 326690) 326791)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon36_Else$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@0)) (= inline$$WritebackToGlobal$1$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@0|))) (= |inline$$WritebackToGlobal$1$m'@1@@0| ($Memory (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0 inline$$WritebackToGlobal$1$v@1@@0)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@0| |inline$$WritebackToGlobal$1$m'@1@@0|) (= (ControlFlow 0 326744) 326791))) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon36_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$1$l@1@@0 (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (and (=> (= (ControlFlow 0 326680) 326744) inline$$WritebackToGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 326680) 326690) inline$$WritebackToGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$2$anon0_correct@@0  (=> (and (= |inline$$WriteRef$2$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2@@0)) (= (ControlFlow 0 326556) 326680)) inline$$WritebackToGlobal$1$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@9@@0) (= (ControlFlow 0 326562) 326556)) inline$$WriteRef$2$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$Abort_correct  (=> (= $DiemAccount_DiemAccount_$memory@4@@0 $DiemAccount_DiemAccount_$memory@3@@0) (=> (and (and (= $abort_flag@10@@0 true) (= $abort_code@18@@0 $abort_code@17@@0)) (and (= $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory@0@@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) (= (ControlFlow 0 322260) 326881))) anon0$2_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon7_correct  (=> (= $DiemAccount_DiemAccount_$memory@3@@0 $DiemAccount_DiemAccount_$memory) (=> (and (= $abort_code@17@@0 $abort_code@1@@0) (= (ControlFlow 0 326851) 322260)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 326849) 326851)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon7_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 326859) 326851) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon7_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon27_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 326843) 326859) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 326843) 326849) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon13_correct  (=> (= $DiemAccount_DiemAccount_$memory@3@@0 $DiemAccount_DiemAccount_$memory) (=> (and (= $abort_code@17@@0 $abort_code@2@@1) (= (ControlFlow 0 326827) 322260)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 326825) 326827)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon13_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 326835) 326827) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon13_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon30_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 326819) 326835) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 326819) 326825) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon21_correct  (=> (= $DiemAccount_DiemAccount_$memory@3@@0 $DiemAccount_DiemAccount_$memory) (=> (and (= $abort_code@17@@0 $abort_code@4@@0) (= (ControlFlow 0 326807) 322260)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 326805) 326807)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon21_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 326815) 326807) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon21_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon34_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 326799) 326815) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 326799) 326805) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon36_Then_correct  (=> (and (and $abort_flag@9@@0 (= $DiemAccount_DiemAccount_$memory@3@@0 $DiemAccount_DiemAccount_$memory@2@@0)) (and (= $abort_code@17@@0 $abort_code@16@@0) (= (ControlFlow 0 326795) 322260))) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon24_correct@@0  (=> (and (and (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2@@0 |inline$$WritebackToValue$0$vdst'@2@@0|) (= $DiemAccount_DiemAccount_$memory@2@@0 $DiemAccount_DiemAccount_$memory@0@@0)) (and (= $abort_flag@9@@0 $abort_flag@8@@0) (= $abort_code@16@@0 $abort_code@14@@0))) (and (=> (= (ControlFlow 0 326395) 326795) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 326395) 326562) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 326393) 326395)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon24_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Then_correct@@0  (=> (= (ControlFlow 0 326403) 326395) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon24_correct@@0)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) ($Local 4))) (= |inline$$WritebackToValue$0$vdst'@2@@0| inline$$ReadRef$0$v@1@@0)) (and (=> (= (ControlFlow 0 326351) 326403) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Then_correct@@0) (=> (= (ControlFlow 0 326351) 326393) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Else_correct@@0)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) ($Local 4)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 inline$$ReadRef$0$v@1@@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@0|)) (and (=> (= (ControlFlow 0 326377) 326403) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Then_correct@@0) (=> (= (ControlFlow 0 326377) 326393) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon36_Else_correct@@0))))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (= |inline$$WritebackToReference$1$dst'@2@@0| inline$$BorrowLoc$0$dst@1@@0)) (and (=> (= (ControlFlow 0 326196) 326377) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 326196) 326351) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (and (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|)))) (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|))) (and (=> (= (ControlFlow 0 326252) 326377) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 326252) 326351) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) (and (=> (= (ControlFlow 0 326160) 326252) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 326160) 326196) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (and (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@0) (|p#$Mutation| inline$$BorrowField$2$dst@1@@0) new_public_key)) (= (ControlFlow 0 326017) 326160)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$BorrowField$2$anon0_correct@@0  (=> (= inline$$BorrowField$2$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$2$size@1@@0 (|size#$Path| inline$$BorrowField$2$p@1@@0)) (= inline$$BorrowField$2$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@0) inline$$BorrowField$2$size@1@@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_key) (+ inline$$BorrowField$2$size@1@@0 1)))) (and (= inline$$BorrowField$2$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$2$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) (= (ControlFlow 0 325958) 326017))) inline$$WriteRef$1$anon0_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Else_correct@@0  (=> (and (not $abort_flag@8@@0) (= (ControlFlow 0 325964) 325958)) inline$$BorrowField$2$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct@@0  (=> (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@1@@0 $Error) (=> (and (and (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@2@@0 inline$$SharedEd25519PublicKey_rotate_key__$def$0$$ret0@1@@0) (= $DiemAccount_DiemAccount_$memory@2@@0 $DiemAccount_DiemAccount_$memory@1@@0)) (and (= $abort_flag@9@@0 true) (= $abort_code@16@@0 $abort_code@15@@0))) (and (=> (= (ControlFlow 0 323304) 326795) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 323304) 326562) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon7_correct@@0  (=> (= $DiemAccount_DiemAccount_$memory@1@@0 $DiemAccount_DiemAccount_$memory) (=> (and (= $abort_code@15@@0 $abort_code@4@@0) (= (ControlFlow 0 326459) 323304)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 326457) 326459)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon7_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Then_correct@@0  (=> (= (ControlFlow 0 326467) 326459) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon7_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Then_correct@@0  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 326451) 326467) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Then_correct@@0) (=> (= (ControlFlow 0 326451) 326457) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon28_Else_correct@@0)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon11_correct@@0  (=> (= $DiemAccount_DiemAccount_$memory@1@@0 $DiemAccount_DiemAccount_$memory) (=> (and (= $abort_code@15@@0 $abort_code@5@@0) (= (ControlFlow 0 326439) 323304)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 326437) 326439)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon11_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Then_correct@@0  (=> (= (ControlFlow 0 326447) 326439) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon11_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Then_correct@@0  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 326431) 326447) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Then_correct@@0) (=> (= (ControlFlow 0 326431) 326437) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon30_Else_correct@@0)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon19_correct@@0  (=> (= $DiemAccount_DiemAccount_$memory@1@@0 $DiemAccount_DiemAccount_$memory) (=> (and (= $abort_code@15@@0 $abort_code@7@@0) (= (ControlFlow 0 326419) 323304)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 326417) 326419)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon19_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Then_correct@@0  (=> (= (ControlFlow 0 326427) 326419) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon19_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Then_correct@@0  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 326411) 326427) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Then_correct@@0) (=> (= (ControlFlow 0 326411) 326417) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon34_Else_correct@@0)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Then_correct@@0  (=> (and (and $abort_flag@8@@0 (= $DiemAccount_DiemAccount_$memory@1@@0 $DiemAccount_DiemAccount_$memory@0@@0)) (and (= $abort_code@15@@0 $abort_code@14@@0) (= (ControlFlow 0 326407) 323304))) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct@@0  (=> (= $abort_flag@8@@0 $abort_flag@7@@0) (=> (and (= $abort_code@14@@0 $abort_code@11@@0) (= $DiemAccount_DiemAccount_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|)) (and (=> (= (ControlFlow 0 325714) 326407) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Then_correct@@0) (=> (= (ControlFlow 0 325714) 325964) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Else_correct@@0))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $DiemAccount_DiemAccount_$memory) (= (ControlFlow 0 325652) 325714)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct@@0))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 325706) 325714))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct@@0)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 325642) 325706) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 325642) 325652) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct@@0  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 325520) 325642)) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$1$dst@2@@0) (= (ControlFlow 0 325441) 325520)) inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 325497) 325520))) inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) (and (=> (= (ControlFlow 0 325405) 325497) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 325405) 325441) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 325268) 325405)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct@@0  (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1@@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (= (ControlFlow 0 325724) 325405)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@0) (|p#$Mutation| inline$$BorrowField$1$dst@1@@0) call3formal@$ret0@0@@10)) (and (=> (= (ControlFlow 0 325254) 325724) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct@@0) (=> (= (ControlFlow 0 325254) 325268) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct@@0)))))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $DiemAccount_DiemAccount_authentication_key) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $DiemAccount_DiemAccount_authentication_key))) (= (ControlFlow 0 325195) 325254))) inline$$WriteRef$0$anon0_correct@@0))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct@@0  (=> (and (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1@@0) (= (ControlFlow 0 325201) 325195)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@0  (=> (= $abort_flag@8@@0 true) (=> (and (= $abort_code@14@@0 $abort_code@13@@0) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (=> (= (ControlFlow 0 324641) 326407) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Then_correct@@0) (=> (= (ControlFlow 0 324641) 325964) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon35_Else_correct@@0))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct@@0  (=> (and (= $abort_code@13@@0 $abort_code@8@@0) (= (ControlFlow 0 325796) 324641)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 325794) 325796)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct@@0  (=> (= (ControlFlow 0 325804) 325796) inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct@@0  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 325788) 325804) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct@@0) (=> (= (ControlFlow 0 325788) 325794) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct@@0  (=> (and (= $abort_code@13@@0 $abort_code@10@@0) (= (ControlFlow 0 325776) 324641)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 325774) 325776)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct@@0  (=> (= (ControlFlow 0 325784) 325776) inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct@@0  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 325768) 325784) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct@@0) (=> (= (ControlFlow 0 325768) 325774) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct@@0  (=> (and (= $abort_code@13@@0 $abort_code@10@@0) (= (ControlFlow 0 325756) 324641)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 325754) 325756)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct@@0  (=> (= (ControlFlow 0 325764) 325756) inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct@@0  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 325748) 325764) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct@@0) (=> (= (ControlFlow 0 325748) 325754) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct@@0  (=> (and (= $abort_code@13@@0 $abort_code@11@@0) (= (ControlFlow 0 325736) 324641)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 325734) 325736)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct@@0  (=> (= (ControlFlow 0 325744) 325736) inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct@@0  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 325728) 325744) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct@@0) (=> (= (ControlFlow 0 325728) 325734) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct@@0  (=> (and (= $abort_code@13@@0 $abort_code@12@@0) (= (ControlFlow 0 325065) 324641)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 325063) 325065)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct@@0  (=> (= (ControlFlow 0 325073) 325065) inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct@@0  (=> (= $abort_code@12@@0 (|i#$Integer| call3formal@$ret0@0@@11)) (and (=> (= (ControlFlow 0 325057) 325073) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct@@0) (=> (= (ControlFlow 0 325057) 325063) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct@@0)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0@@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (= (ControlFlow 0 325045) 325057)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1@@0)) (= (ControlFlow 0 325051) 325045)) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct@@0  (=> (not $abort_flag@7@@0) (and (=> (= (ControlFlow 0 325022) 325201) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct@@0) (=> (= (ControlFlow 0 325022) 325051) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct@@0  (=> (not $abort_flag@6@@0) (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1@@0 ($Integer 32)) (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1@@0 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1@@0 inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1@@0)))) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1@@0 ($Integer 8)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7@@0)) (and (=> $abort_flag@7@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@11) (>= (|i#$Integer| call3formal@$ret0@0@@11) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@11) $MAX_U64))) (and (=> (= (ControlFlow 0 325016) 325728) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct@@0) (=> (= (ControlFlow 0 325016) 325022) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct@@0)))))))
(let ((inline$$Vector_length$0$anon0_correct@@0  (=> (and ((_ is $Vector) call3formal@$ret0@0@@10) (= inline$$Vector_length$0$l@1@@0 ($Integer (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10))))) (and (=> (= (ControlFlow 0 324986) 325748) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct@@0) (=> (= (ControlFlow 0 324986) 325016) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct@@0)))))
(let ((inline$$Vector_length$0$Entry_correct@@0  (=> (and (= inline$$Vector_length$0$ta@0@@0 $IntegerType) (= (ControlFlow 0 324974) 324986)) inline$$Vector_length$0$anon0_correct@@0)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct@@0  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 324931) 324974)) inline$$Vector_length$0$Entry_correct@@0)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (= (ControlFlow 0 324925) 324931)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct@@0  (=> (and (not $abort_flag@6@@0) (= (ControlFlow 0 324935) 324925)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@0  (=> (= $abort_code@10@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@6@@0 true) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@0@@0)) (and (=> (= (ControlFlow 0 324892) 325768) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct@@0) (=> (= (ControlFlow 0 324892) 324935) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct@@0))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0)) (= (ControlFlow 0 324890) 324892)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$1$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@0))) (= $abort_code@10@@0 $abort_code@8@@0)) (and (= $abort_flag@6@@0 $abort_flag@5@@0) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@1@@0))) (and (=> (= (ControlFlow 0 324838) 325768) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct@@0) (=> (= (ControlFlow 0 324838) 324935) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct@@0))))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@0  (=> (= inline$$BorrowGlobal$1$a@1@@0 (|a#$Address| inline$$GetFieldFromValue$1$dst@1@@0)) (and (=> (= (ControlFlow 0 324808) 324890) inline$$BorrowGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 324808) 324838) inline$$BorrowGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 324802) (- 0 344790)) true) (=> (= (ControlFlow 0 324802) 324808) inline$$BorrowGlobal$1$anon0_correct@@0))))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$1$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 324695) 324802)) inline$$BorrowGlobal$1$Entry_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct@@0  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1@@0) (= (ControlFlow 0 324701) 324695)) inline$$GetFieldFromValue$1$anon0_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct@@0  (=> (and (= $abort_code@13@@0 $abort_code@9@@0) (= (ControlFlow 0 324637) 324641)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 324635) 324637)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct@@0  (=> (= (ControlFlow 0 324649) 324637) inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1@@0)) (= $abort_code@9@@0 (|i#$Integer| call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 324629) 324649) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct@@0) (=> (= (ControlFlow 0 324629) 324635) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct@@0  (=> (not $abort_flag@5@@0) (and (=> (= (ControlFlow 0 324617) 324701) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct@@0) (=> (= (ControlFlow 0 324617) 324629) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct@@0  (=> (not $abort_flag@4@@0) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1@@0 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@0)) (and (=> $abort_flag@5@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 324611) 325788) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct@@0) (=> (= (ControlFlow 0 324611) 324617) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct@@0))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct@@0  (=> $abort_flag@4@@0 (=> (and (= $abort_code@13@@0 $abort_code@7@@0) (= (ControlFlow 0 325808) 324641)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@0))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 324567) 325808) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct@@0) (=> (= (ControlFlow 0 324567) 324611) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct@@0)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 324577) 325808) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct@@0) (=> (= (ControlFlow 0 324577) 324611) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct@@0))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon2$1_correct@@0  (=> (= inline$$DiemAccount_exists_at_$def$0$$t2@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1@@1)))) (and (=> (= (ControlFlow 0 324561) 324577) inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 324561) 324567) inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 324515) 324561)) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct@@0)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 324585) 324561) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct@@0)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon0_correct@@0  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 324509) 324585) inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 324509) 324515) inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$DiemAccount_exists_at$0$anon0_correct@@0  (=> (and ((_ is $Address) inline$$GetFieldFromValue$0$dst@1@@1) (= (ControlFlow 0 324591) 324509)) inline$$DiemAccount_exists_at_$def$0$anon0_correct@@0)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 324351) 324591)) inline$$DiemAccount_exists_at$0$anon0_correct@@0)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 324241) 324351)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct@@0  (=> (= (ControlFlow 0 325816) 324351) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 324233) 325816) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct@@0) (=> (= (ControlFlow 0 324233) 324241) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct@@0  (and (=> (= (ControlFlow 0 325824) 325816) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct@@0) (=> (= (ControlFlow 0 325824) 324241) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct@@0))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct@@0  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 324227) 325824) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct@@0) (=> (= (ControlFlow 0 324227) 324233) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct@@0)))))
(let ((inline$$DiemAccount_rotate_authentication_key$0$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1@@0) (let ((va@@46 (|v#$Vector| inline$$ReadRef$1$v@1@@0)))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $DiemAccount_KeyRotationCapability_account_address))) true) (and (and (and ((_ is $Vector) call3formal@$ret0@0@@10) (let ((va@@47 (|v#$Vector| call3formal@$ret0@0@@10)))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (forall ((inline$$DiemAccount_rotate_authentication_key$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemAccount_rotate_authentication_key$0$$$0@@0 0) (< inline$$DiemAccount_rotate_authentication_key$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) inline$$DiemAccount_rotate_authentication_key$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) inline$$DiemAccount_rotate_authentication_key$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) inline$$DiemAccount_rotate_authentication_key$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) inline$$DiemAccount_rotate_authentication_key$0$$$0@@0))
))) (= (ControlFlow 0 325828) 324227))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Else_correct@@0  (=> (and (not $abort_flag@4@@0) (= (ControlFlow 0 325834) 325828)) inline$$DiemAccount_rotate_authentication_key$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then$1_correct@@0  (and (=> (= (ControlFlow 0 323528) (- 0 344314)) true) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@0) (=> (and (=> $abort_flag@4@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Authenticator_spec_ed25519_authentication_key new_public_key)))))) (=> (and (and ((_ is $Vector) call3formal@$ret0@0@@10) (let ((va@@48 (|v#$Vector| call3formal@$ret0@0@@10)))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@10)) $$0@@12))
))) (and (=> (= (ControlFlow 0 323528) 326411) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Then_correct@@0) (=> (= (ControlFlow 0 323528) 325834) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon33_Else_correct@@0))))))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 323508) 323528)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then$1_correct@@0)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) (= (ControlFlow 0 323470) 323508))) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1@@0) (= (ControlFlow 0 323522) 323470)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon16_correct@@0  (=> (= $DiemAccount_DiemAccount_$memory@1@@0 $DiemAccount_DiemAccount_$memory) (=> (and (= $abort_code@15@@0 $abort_code@6@@0) (= (ControlFlow 0 323298) 323304)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$Abort_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 323296) 323298)) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon16_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Then_correct@@0  (=> (= (ControlFlow 0 323312) 323298) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon16_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1@@0)) (= $abort_code@6@@0 (|i#$Integer| call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 323290) 323312) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Then_correct@@0) (=> (= (ControlFlow 0 323290) 323296) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon32_Else_correct@@0)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Else_correct@@0  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 323278) 323522) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Then_correct@@0) (=> (= (ControlFlow 0 323278) 323290) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon31_Else_correct@@0)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Else_correct@@0  (=> (not $abort_flag@2@@0) (=> (and (and (and (= inline$$SharedEd25519PublicKey_rotate_key__$def$0$$t8@1@@0 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0)) (and (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@13) (>= (|i#$Integer| call3formal@$ret0@0@@13) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@13) $MAX_U64))) (and (=> (= (ControlFlow 0 323272) 326431) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Then_correct@@0) (=> (= (ControlFlow 0 323272) 323278) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon29_Else_correct@@0))))))
(let ((inline$$Signature_ed25519_validate_pubkey$0$anon0_correct@@0  (=> (= inline$$Signature_ed25519_validate_pubkey$0$res@1@@0 ($Signature_$ed25519_validate_pubkey new_public_key)) (and (=> (= (ControlFlow 0 323254) 326451) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Then_correct@@0) (=> (= (ControlFlow 0 323254) 323272) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon27_Else_correct@@0)))))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 4) $EmptyPath inline$$ReadRef$0$v@1@@0)) (= (ControlFlow 0 323216) 323254)) inline$$Signature_ed25519_validate_pubkey$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 323098) 323216)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Then_correct@@0  (=> (= (ControlFlow 0 326475) 323216) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 323090) 326475) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Then_correct@@0) (=> (= (ControlFlow 0 323090) 323098) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Else_correct@@0)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Then_correct@@0  (and (=> (= (ControlFlow 0 326483) 326475) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Then_correct@@0) (=> (= (ControlFlow 0 326483) 323098) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon26_Else_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon0_correct@@0  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 323084) 326483) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Then_correct@@0) (=> (= (ControlFlow 0 323084) 323090) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon25_Else_correct@@0)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$anon0_correct@@0  (=> (and (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@0) (let ((va@@49 (|v#$Vector| inline$$ReadRef$0$v@1@@0)))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@50 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@13))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) (and (and (and ((_ is $Vector) new_public_key) (let ((va@@52 (|v#$Vector| new_public_key)))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (forall ((inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0@@0 0) (< inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| new_public_key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key)) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key)) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key)) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key)) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$$$0@@0))
))) (= (ControlFlow 0 326489) 323084))) inline$$SharedEd25519PublicKey_rotate_key__$def$0$anon0_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon34_Else$1_correct  (and (=> (= (ControlFlow 0 326497) (- 0 343926)) true) (=> (= (ControlFlow 0 326497) 326489) inline$$SharedEd25519PublicKey_rotate_key__$direct_intra$0$anon0_correct@@0))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 322507) 326497)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon34_Else$1_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@0) (= (ControlFlow 0 322513) 322507)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@2@@0 true) (=> (and (= $abort_code@4@@0 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 322463) 326799) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 322463) 322513) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 322461) 322463)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0))) (= $abort_flag@2@@0 $abort_flag@1@@1)) (and (= $abort_code@4@@0 $abort_code@2@@1) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 322409) 326799) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 322409) 322513) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| call3formal@$ret0@0@@14)) (and (=> (= (ControlFlow 0 322379) 322461) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 322379) 322409) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 322373) (- 0 343813)) true) (=> (= (ControlFlow 0 322373) 322379) inline$$BorrowGlobal$0$anon0_correct@@0))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon32_Then_correct  (=> (and (|b#$Boolean| inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1@@1) (= (ControlFlow 0 322469) 322373)) inline$$BorrowGlobal$0$Entry_correct@@0)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon18_correct  (=> (= $DiemAccount_DiemAccount_$memory@3@@0 $DiemAccount_DiemAccount_$memory) (=> (and (= $abort_code@17@@0 $abort_code@3@@0) (= (ControlFlow 0 322256) 322260)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 322254) 322256)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon18_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 322268) 322256) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon18_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon32_Else_correct  (=> (and (not (|b#$Boolean| inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1@@1)) (= $abort_code@3@@0 (|i#$Integer| call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 322248) 322268) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 322248) 322254) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon30_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 322236) 322469) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 322236) 322248) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon29_Else_correct  (=> (not $abort_flag@0@@1) (=> (and (and (and (= inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$$t8@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@15) (>= (|i#$Integer| call3formal@$ret0@0@@15) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@15) $MAX_U64))) (and (=> (= (ControlFlow 0 322230) 326819) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 322230) 322236) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon29_Then_correct  (=> (and (and $abort_flag@0@@1 (= $DiemAccount_DiemAccount_$memory@3@@0 $DiemAccount_DiemAccount_$memory)) (and (= $abort_code@17@@0 $abort_code@1@@0) (= (ControlFlow 0 326839) 322260))) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$Abort_correct)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 322186) 326839) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 322186) 322230) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Then_correct@@1  (and (=> (= (ControlFlow 0 322196) 326839) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 322196) 322230) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon29_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct@@1  (=> (= inline$$SharedEd25519PublicKey_exists_at_$def$0$$t2@1@@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@14)))) (and (=> (= (ControlFlow 0 322180) 322196) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Then_correct@@1) (=> (= (ControlFlow 0 322180) 322186) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon6_Else_correct@@1)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 322134) 322180)) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 322204) 322180) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon2$1_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_exists_at_$def$0$anon0_correct@@1  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 322128) 322204) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 322128) 322134) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon5_Else_correct@@1)))))
(let ((inline$$SharedEd25519PublicKey_exists_at_$direct_intra$0$anon0_correct@@1  (=> (and ((_ is $Address) call3formal@$ret0@0@@14) (= (ControlFlow 0 322210) 322128)) inline$$SharedEd25519PublicKey_exists_at_$def$0$anon0_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@0@@1) (= (ControlFlow 0 322218) 322210)) inline$$SharedEd25519PublicKey_exists_at_$direct_intra$0$anon0_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 account@@1)))) ((_ is $Address) call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 321972) 326843) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 321972) 322218) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 321902) 321972)) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon4$2_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 326867) 321972) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon4$2_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 321894) 326867) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 321894) 321902) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 326875) 326867) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 326875) 321902) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon26_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 321888) 326875) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 321888) 321894) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (and (and (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@53 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@54 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_authentication_key))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_authentication_key))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_authentication_key))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_authentication_key))) $$0@@14))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@55 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@56 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@57 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@60 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@15))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@61 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@62 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@16))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@63 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemAccount_KeyRotationCapability_account_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@6))
))) (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@64 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@65 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
))))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@17))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@66 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (|b#$Boolean| ($Boolean (forall ((addr@@5 T@$Value) )  (=> ((_ is $Address) addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@6 T@$Value) )  (=> ((_ is $Address) addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@7 T@$Value) )  (=> ((_ is $Address) addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@8 T@$Value) )  (=> ((_ is $Address) addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8))))))))))) (= (ControlFlow 0 326879) 321888)))) inline$$SharedEd25519PublicKey_rotate_key_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> ((_ is $Address) account@@1) (=> (and (and (and ((_ is $Vector) new_public_key) (let ((va@@67 (|v#$Vector| new_public_key)))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
)))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| new_public_key)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key)) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key)) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key)) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key)) $$0@@18))
))) (= (ControlFlow 0 321184) 326879)) anon0$1_correct@@2))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 341878) 321184) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun new_public_key@@0 () T@$Value)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun shared_key () T@$Value)
(declare-fun $abort_code@12@@1 () Int)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$$ret0@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun $abort_code@10@@1 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@2@@1 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@0@@1 () T@$Memory)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$2$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@1 () Int)
(declare-fun inline$$BorrowField$2$p@2@@1 () T@$Path)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@11@@1 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@1@@1 () T@$Memory)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0@@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1@@1 () T@$Value)
(declare-fun $abort_code@9@@1 () Int)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1@@1 () T@$Value)
(declare-fun inline$$Vector_length$0$l@1@@1 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1@@1 () T@$Value)
(declare-fun inline$$Vector_length$0$ta@0@@1 () T@$TypeValue)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$0$$t2@1@@1 () T@$Value)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1@@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$Signature_ed25519_validate_pubkey$0$res@1@@1 () T@$Value)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(declare-fun inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 346543) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 331851) (- 0 349694)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key@@0))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key@@0))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 331851) (- 0 349709)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 331851) (- 0 349733)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key@@0)))) ($Integer 32))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key@@0)))) ($Integer 32))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 331851) (- 0 349754)) (=> $abort_flag@6@@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key@@0)))) ($Integer 32)))))))) (=> (=> $abort_flag@6@@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key@@0)))) ($Integer 32))))))) (and (=> (= (ControlFlow 0 331851) (- 0 349812)) (=> $abort_flag@6@@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key@@0))))) (= $abort_code@12@@1 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) (= $abort_code@12@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key@@0)))) ($Integer 32))))) (= $abort_code@12@@1 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@6@@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey new_public_key@@0))))) (= $abort_code@12@@1 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))))))) (= $abort_code@12@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Authenticator_spec_ed25519_authentication_key new_public_key@@0)))) ($Integer 32))))) (= $abort_code@12@@1 (|i#$Integer| ($Integer 7)))))) (=> (= (ControlFlow 0 331851) (- 0 349903)) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$$ret0@2)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key) new_public_key@@0)))))))))))))))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon24_correct  (=> (= inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@1|) (=> (and (and (= $abort_code@12@@1 $abort_code@10@@1) (= $DiemAccount_DiemAccount_$memory@2@@1 $DiemAccount_DiemAccount_$memory@0@@1)) (and (= $abort_flag@6@@1 $abort_flag@5@@1) (= (ControlFlow 0 331755) 331851))) anon0$2_correct@@1))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 331753) 331755)) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon24_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 331763) 331755) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon24_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) ($Local 4))) (= |inline$$WritebackToValue$0$vdst'@2@@1| shared_key)) (and (=> (= (ControlFlow 0 331711) 331763) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 331711) 331753) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon36_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) ($Local 4)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) 0 shared_key (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@1|)) (and (=> (= (ControlFlow 0 331737) 331763) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 331737) 331753) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon36_Else_correct))))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@1  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1))) (= |inline$$WritebackToReference$1$dst'@2@@1| inline$$BorrowLoc$0$dst@1@@1)) (and (=> (= (ControlFlow 0 331556) 331737) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 331556) 331711) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@1  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1)) (and (= |inline$$WritebackToReference$1$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$WritebackToReference$1$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|)))) (= |inline$$WritebackToReference$1$dst'@2@@1| |inline$$WritebackToReference$1$dst'@1@@1|))) (and (=> (= (ControlFlow 0 331612) 331737) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 331612) 331711) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$1$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= inline$$WritebackToReference$1$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) (and (=> (= (ControlFlow 0 331520) 331612) inline$$WritebackToReference$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 331520) 331556) inline$$WritebackToReference$1$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (and (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@1) (|p#$Mutation| inline$$BorrowField$2$dst@1@@1) new_public_key@@0)) (= (ControlFlow 0 331377) 331520)) inline$$WritebackToReference$1$anon0_correct@@1)))
(let ((inline$$BorrowField$2$anon0_correct@@1  (=> (= inline$$BorrowField$2$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$2$size@1@@1 (|size#$Path| inline$$BorrowField$2$p@1@@1)) (= inline$$BorrowField$2$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@1) inline$$BorrowField$2$size@1@@1 $SharedEd25519PublicKey_SharedEd25519PublicKey_key) (+ inline$$BorrowField$2$size@1@@1 1)))) (and (= inline$$BorrowField$2$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$2$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) (= (ControlFlow 0 331318) 331377))) inline$$WriteRef$1$anon0_correct@@1))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon35_Else_correct  (=> (and (not $abort_flag@5@@1) (= (ControlFlow 0 331324) 331318)) inline$$BorrowField$2$anon0_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$Abort_correct  (=> (and (= inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$$ret0@1 $Error) (= inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$$ret0@2 inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$$ret0@1)) (=> (and (and (= $abort_code@12@@1 $abort_code@11@@1) (= $DiemAccount_DiemAccount_$memory@2@@1 $DiemAccount_DiemAccount_$memory@1@@1)) (and (= $abort_flag@6@@1 true) (= (ControlFlow 0 328664) 331851))) anon0$2_correct@@1))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon11_correct  (=> (= $abort_code@11@@1 $abort_code@1@@1) (=> (and (= $DiemAccount_DiemAccount_$memory@1@@1 $DiemAccount_DiemAccount_$memory) (= (ControlFlow 0 331799) 328664)) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 331797) 331799)) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon11_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 331807) 331799) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon11_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon29_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 331791) 331807) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 331791) 331797) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon30_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon19_correct  (=> (= $abort_code@11@@1 $abort_code@3@@1) (=> (and (= $DiemAccount_DiemAccount_$memory@1@@1 $DiemAccount_DiemAccount_$memory) (= (ControlFlow 0 331779) 328664)) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 331777) 331779)) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 331787) 331779) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon19_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon33_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 331771) 331787) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 331771) 331777) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon34_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon35_Then_correct  (=> (and (and $abort_flag@5@@1 (= $abort_code@11@@1 $abort_code@10@@1)) (and (= $DiemAccount_DiemAccount_$memory@1@@1 $DiemAccount_DiemAccount_$memory@0@@1) (= (ControlFlow 0 331767) 328664))) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct@@1  (=> (= $abort_code@10@@1 $abort_code@7@@1) (=> (and (= $abort_flag@5@@1 $abort_flag@4@@1) (= $DiemAccount_DiemAccount_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@1|)) (and (=> (= (ControlFlow 0 331074) 331767) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 331074) 331324) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon35_Else_correct))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@1| $DiemAccount_DiemAccount_$memory) (= (ControlFlow 0 331012) 331074)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct@@1))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@1|) (= (ControlFlow 0 331066) 331074))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon32$3_correct@@1)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 331002) 331066) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 331002) 331012) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct@@1  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$1$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= (ControlFlow 0 330880) 331002)) inline$$WritebackToGlobal$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 330801) 330880)) inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 330857) 330880))) inline$$DiemAccount_DiemAccount_$pack_ref$1$Entry_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) (and (=> (= (ControlFlow 0 330765) 330857) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 330765) 330801) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 330628) 330765)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct@@1  (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$trace_temp@1@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 331084) 330765)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@1) (|p#$Mutation| inline$$BorrowField$1$dst@1@@1) call3formal@$ret0@0@@16)) (and (=> (= (ControlFlow 0 330614) 331084) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Then_correct@@1) (=> (= (ControlFlow 0 330614) 330628) inline$$DiemAccount_rotate_authentication_key_$def$0$anon48_Else_correct@@1)))))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1)) (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $DiemAccount_DiemAccount_authentication_key) (+ inline$$BorrowField$1$size@1@@1 1)))) (and (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $DiemAccount_DiemAccount_authentication_key))) (= (ControlFlow 0 330555) 330614))) inline$$WriteRef$0$anon0_correct@@1))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct@@1  (=> (and (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1@@1) (= (ControlFlow 0 330561) 330555)) inline$$BorrowField$1$anon0_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@1  (=> (= $abort_code@10@@1 $abort_code@9@@1) (=> (and (= $abort_flag@5@@1 true) (= $DiemAccount_DiemAccount_$memory@0@@1 $DiemAccount_DiemAccount_$memory)) (and (=> (= (ControlFlow 0 330001) 331767) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 330001) 331324) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon35_Else_correct))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct@@1  (=> (and (= $abort_code@9@@1 $abort_code@4@@1) (= (ControlFlow 0 331156) 330001)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 331154) 331156)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct@@1  (=> (= (ControlFlow 0 331164) 331156) inline$$DiemAccount_rotate_authentication_key_$def$0$anon9_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct@@1  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 331148) 331164) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Then_correct@@1) (=> (= (ControlFlow 0 331148) 331154) inline$$DiemAccount_rotate_authentication_key_$def$0$anon37_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct@@1  (=> (and (= $abort_code@9@@1 $abort_code@6@@1) (= (ControlFlow 0 331136) 330001)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 331134) 331136)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct@@1  (=> (= (ControlFlow 0 331144) 331136) inline$$DiemAccount_rotate_authentication_key_$def$0$anon17_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct@@1  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 331128) 331144) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Then_correct@@1) (=> (= (ControlFlow 0 331128) 331134) inline$$DiemAccount_rotate_authentication_key_$def$0$anon41_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct@@1  (=> (and (= $abort_code@9@@1 $abort_code@6@@1) (= (ControlFlow 0 331116) 330001)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 331114) 331116)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct@@1  (=> (= (ControlFlow 0 331124) 331116) inline$$DiemAccount_rotate_authentication_key_$def$0$anon21_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct@@1  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 331108) 331124) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Then_correct@@1) (=> (= (ControlFlow 0 331108) 331114) inline$$DiemAccount_rotate_authentication_key_$def$0$anon43_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct@@1  (=> (and (= $abort_code@9@@1 $abort_code@7@@1) (= (ControlFlow 0 331096) 330001)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 331094) 331096)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct@@1  (=> (= (ControlFlow 0 331104) 331096) inline$$DiemAccount_rotate_authentication_key_$def$0$anon25_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct@@1  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 331088) 331104) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Then_correct@@1) (=> (= (ControlFlow 0 331088) 331094) inline$$DiemAccount_rotate_authentication_key_$def$0$anon45_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct@@1  (=> (and (= $abort_code@9@@1 $abort_code@8@@1) (= (ControlFlow 0 330425) 330001)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 330423) 330425)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct@@1  (=> (= (ControlFlow 0 330433) 330425) inline$$DiemAccount_rotate_authentication_key_$def$0$anon30_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct@@1  (=> (= $abort_code@8@@1 (|i#$Integer| call3formal@$ret0@0@@17)) (and (=> (= (ControlFlow 0 330417) 330433) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Then_correct@@1) (=> (= (ControlFlow 0 330417) 330423) inline$$DiemAccount_rotate_authentication_key_$def$0$anon47_Else_correct@@1)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct@@1  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 330405) 330417)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else$1_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct@@1  (=> (and (not (|b#$Boolean| inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1@@1)) (= (ControlFlow 0 330411) 330405)) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct@@1  (=> (not $abort_flag@4@@1) (and (=> (= (ControlFlow 0 330382) 330561) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Then_correct@@1) (=> (= (ControlFlow 0 330382) 330411) inline$$DiemAccount_rotate_authentication_key_$def$0$anon46_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct@@1  (=> (not $abort_flag@3@@1) (=> (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1@@1 ($Integer 32)) (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t16@1@@1 ($Boolean ($IsEqual_stratified inline$$Vector_length$0$l@1@@1 inline$$DiemAccount_rotate_authentication_key_$def$0$$t15@1@@1)))) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t17@1@@1 ($Integer 8)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@1)) (and (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@17) (>= (|i#$Integer| call3formal@$ret0@0@@17) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@17) $MAX_U64))) (and (=> (= (ControlFlow 0 330376) 331088) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Then_correct@@1) (=> (= (ControlFlow 0 330376) 330382) inline$$DiemAccount_rotate_authentication_key_$def$0$anon44_Else_correct@@1)))))))
(let ((inline$$Vector_length$0$anon0_correct@@1  (=> (and ((_ is $Vector) call3formal@$ret0@0@@16) (= inline$$Vector_length$0$l@1@@1 ($Integer (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16))))) (and (=> (= (ControlFlow 0 330346) 331108) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Then_correct@@1) (=> (= (ControlFlow 0 330346) 330376) inline$$DiemAccount_rotate_authentication_key_$def$0$anon42_Else_correct@@1)))))
(let ((inline$$Vector_length$0$Entry_correct@@1  (=> (and (= inline$$Vector_length$0$ta@0@@1 $IntegerType) (= (ControlFlow 0 330334) 330346)) inline$$Vector_length$0$anon0_correct@@1)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct@@1  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@1)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@1)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 330291) 330334)) inline$$Vector_length$0$Entry_correct@@1)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct@@1  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 330285) 330291)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct@@1  (=> (and (not $abort_flag@3@@1) (= (ControlFlow 0 330295) 330285)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@3@@1 true) (=> (and (= $abort_code@6@@1 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 330252) 331128) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct@@1) (=> (= (ControlFlow 0 330252) 330295) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct@@1))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 330250) 330252)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1))) (= $abort_flag@3@@1 $abort_flag@2@@1)) (and (= $abort_code@6@@1 $abort_code@4@@1) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 330198) 331128) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Then_correct@@1) (=> (= (ControlFlow 0 330198) 330295) inline$$DiemAccount_rotate_authentication_key_$def$0$anon40_Else_correct@@1))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| inline$$GetFieldFromValue$1$dst@1@@1)) (and (=> (= (ControlFlow 0 330168) 330250) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 330168) 330198) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 330162) (- 0 348566)) true) (=> (= (ControlFlow 0 330162) 330168) inline$$BorrowGlobal$0$anon0_correct@@1))))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@1  (=> (and (= inline$$GetFieldFromValue$1$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 330055) 330162)) inline$$BorrowGlobal$0$Entry_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct@@1  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1@@1) (= (ControlFlow 0 330061) 330055)) inline$$GetFieldFromValue$1$anon0_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct@@1  (=> (and (= $abort_code@9@@1 $abort_code@5@@1) (= (ControlFlow 0 329997) 330001)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 329995) 329997)) inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct@@1  (=> (= (ControlFlow 0 330009) 329997) inline$$DiemAccount_rotate_authentication_key_$def$0$anon14_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct@@1  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1@@1)) (= $abort_code@5@@1 (|i#$Integer| call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 329989) 330009) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Then_correct@@1) (=> (= (ControlFlow 0 329989) 329995) inline$$DiemAccount_rotate_authentication_key_$def$0$anon39_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct@@1  (=> (not $abort_flag@2@@1) (and (=> (= (ControlFlow 0 329977) 330061) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Then_correct@@1) (=> (= (ControlFlow 0 329977) 329989) inline$$DiemAccount_rotate_authentication_key_$def$0$anon38_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct@@1  (=> (not $abort_flag@1@@2) (=> (and (and (and (= inline$$DiemAccount_rotate_authentication_key_$def$0$$t11@1@@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@1)) (and (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@18) (>= (|i#$Integer| call3formal@$ret0@0@@18) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@18) $MAX_U64))) (and (=> (= (ControlFlow 0 329971) 331148) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Then_correct@@1) (=> (= (ControlFlow 0 329971) 329977) inline$$DiemAccount_rotate_authentication_key_$def$0$anon36_Else_correct@@1))))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct@@1  (=> $abort_flag@1@@2 (=> (and (= $abort_code@9@@1 $abort_code@3@@1) (= (ControlFlow 0 331168) 330001)) inline$$DiemAccount_rotate_authentication_key_$def$0$Abort_correct@@1))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 329927) 331168) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct@@1) (=> (= (ControlFlow 0 329927) 329971) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct@@1)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct@@1  (and (=> (= (ControlFlow 0 329937) 331168) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Then_correct@@1) (=> (= (ControlFlow 0 329937) 329971) inline$$DiemAccount_rotate_authentication_key_$def$0$anon35_Else_correct@@1))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon2$1_correct@@1  (=> (= inline$$DiemAccount_exists_at_$def$0$$t2@1@@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1@@2)))) (and (=> (= (ControlFlow 0 329921) 329937) inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct@@1) (=> (= (ControlFlow 0 329921) 329927) inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct@@1)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 329875) 329921)) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct@@1)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 329945) 329921) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct@@1)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon0_correct@@1  (=> (not $abort_flag@1@@2) (and (=> (= (ControlFlow 0 329869) 329945) inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 329869) 329875) inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct@@1)))))
(let ((inline$$DiemAccount_exists_at$0$anon0_correct@@1  (=> (and ((_ is $Address) inline$$GetFieldFromValue$0$dst@1@@2) (= (ControlFlow 0 329951) 329869)) inline$$DiemAccount_exists_at_$def$0$anon0_correct@@1)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@2  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DiemAccount_KeyRotationCapability_account_address)) (= (ControlFlow 0 329711) 329951)) inline$$DiemAccount_exists_at$0$anon0_correct@@1)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 329601) 329711)) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct@@1  (=> (= (ControlFlow 0 331176) 329711) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 329593) 331176) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct@@1) (=> (= (ControlFlow 0 329593) 329601) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct@@1  (and (=> (= (ControlFlow 0 331184) 331176) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Then_correct@@1) (=> (= (ControlFlow 0 331184) 329601) inline$$DiemAccount_rotate_authentication_key_$def$0$anon34_Else_correct@@1))))
(let ((inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct@@1  (=> (not $abort_flag@1@@2) (and (=> (= (ControlFlow 0 329587) 331184) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Then_correct@@1) (=> (= (ControlFlow 0 329587) 329593) inline$$DiemAccount_rotate_authentication_key_$def$0$anon33_Else_correct@@1)))))
(let ((inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@1) (let ((va@@68 (|v#$Vector| inline$$ReadRef$0$v@1@@1)))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $DiemAccount_KeyRotationCapability_account_address))) true) (and (and (and ((_ is $Vector) call3formal@$ret0@0@@16) (let ((va@@69 (|v#$Vector| call3formal@$ret0@0@@16)))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
)))))) (forall ((inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0 0) (< inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$$$0))
))) (= (ControlFlow 0 331188) 329587))) inline$$DiemAccount_rotate_authentication_key_$def$0$anon0_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon33_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 331194) 331188)) inline$$DiemAccount_rotate_authentication_key_$direct_inter$0$anon0_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon31_Then$1_correct  (and (=> (= (ControlFlow 0 328888) (- 0 348090)) true) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@2) (=> (and (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 ($Authenticator_spec_ed25519_authentication_key new_public_key@@0)))))) (=> (and (and ((_ is $Vector) call3formal@$ret0@0@@16) (let ((va@@70 (|v#$Vector| call3formal@$ret0@0@@16)))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
)))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) $$0@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) $$0@@19))
))) (and (=> (= (ControlFlow 0 328888) 331771) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 328888) 331194) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon33_Else_correct))))))))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (= (ControlFlow 0 328868) 328888)) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon31_Then$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) (= (ControlFlow 0 328830) 328868))) inline$$ReadRef$0$anon0_correct@@1))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon31_Then_correct  (=> (and (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1@@1) (= (ControlFlow 0 328882) 328830)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon16_correct  (=> (= $abort_code@11@@1 $abort_code@2@@2) (=> (and (= $DiemAccount_DiemAccount_$memory@1@@1 $DiemAccount_DiemAccount_$memory) (= (ControlFlow 0 328658) 328664)) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$Abort_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 328656) 328658)) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon16_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 328672) 328658) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon16_correct)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon31_Else_correct  (=> (and (not (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1@@1)) (= $abort_code@2@@2 (|i#$Integer| call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 328650) 328672) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 328650) 328656) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon32_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon29_Else_correct  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 328638) 328882) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 328638) 328650) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon31_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon27_Else_correct  (=> (not false) (=> (and (and (and (= inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2)) (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@19) (>= (|i#$Integer| call3formal@$ret0@0@@19) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@19) $MAX_U64))) (and (=> (= (ControlFlow 0 328632) 331791) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 328632) 328638) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon29_Else_correct))))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon27_Then_correct true))
(let ((inline$$Signature_ed25519_validate_pubkey$0$anon0_correct@@1  (=> (= inline$$Signature_ed25519_validate_pubkey$0$res@1@@1 ($Signature_$ed25519_validate_pubkey new_public_key@@0)) (and (=> (= (ControlFlow 0 328614) 331811) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 328614) 328632) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon27_Else_correct)))))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 4) $EmptyPath shared_key)) (= (ControlFlow 0 328576) 328614)) inline$$Signature_ed25519_validate_pubkey$0$anon0_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 328458) 328576)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 331835) 328576) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 328450) 331835) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 328450) 328458) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon26_Else_correct)))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 331843) 331835) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 331843) 328458) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon26_Else_correct))))
(let ((inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 328444) 331843) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 328444) 328450) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (and (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@71 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@72 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
))))))) (forall (($$0@@20 Int) ) (!  (=> (and (>= $$0@@20 0) (< $$0@@20 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))) $$0@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))) $$0@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))) $$0@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))) $$0@@20))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@73 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@73 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@74 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@74 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@75 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@75 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@76 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@76 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@76) (<= l@@76 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@76)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events)) (let ((va@@77 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@77 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@78 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@78 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78))
))))))) (forall (($$0@@21 Int) ) (!  (=> (and (>= $$0@@21 0) (< $$0@@21 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@21)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@21)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@21)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@21))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@79 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@79 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@80 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@80 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@80) (<= l@@80 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@80)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80))
))))))) (forall (($$0@@22 Int) ) (!  (=> (and (>= $$0@@22 0) (< $$0@@22 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@22)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@22)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@22)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@22))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@81 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@81 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_KeyRotationCapability_account_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))
))) (and (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@82 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@82 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@83 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@83 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83))
))))))) (forall (($$0@@23 Int) ) (!  (=> (and (>= $$0@@23 0) (< $$0@@23 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@23)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@23)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@23)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@23))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@84 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@84 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SharedEd25519PublicKey_SharedEd25519PublicKey_$memory) $EmptyTypeValueArray $inv_addr@@10))
)) (|b#$Boolean| ($Boolean (forall ((addr@@9 T@$Value) )  (=> ((_ is $Address) addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@10 T@$Value) )  (=> ((_ is $Address) addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@11 T@$Value) )  (=> ((_ is $Address) addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@12 T@$Value) )  (=> ((_ is $Address) addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12))))))))))) (= (ControlFlow 0 331849) 328444)))) inline$$SharedEd25519PublicKey_rotate_key__$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and (and (and (and (and ((_ is $Vector) shared_key) (let ((va@@85 (|v#$Vector| shared_key)))
(let ((l@@85 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85))
)))))) (= (|l#$ValueArray| (|v#$Vector| shared_key)) 2)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key)) (let ((va@@86 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))
(let ((l@@86 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86))
))))))) (forall (($$0@@24 Int) ) (!  (=> (and (>= $$0@@24 0) (< $$0@@24 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@24)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@24)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@24)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_key))) $$0@@24))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap)) (let ((va@@87 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))))
(let ((l@@87 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| shared_key)) $SharedEd25519PublicKey_SharedEd25519PublicKey_rotation_cap))) $DiemAccount_KeyRotationCapability_account_address)))) (and (and (and ((_ is $Vector) new_public_key@@0) (let ((va@@88 (|v#$Vector| new_public_key@@0)))
(let ((l@@88 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88))
)))))) (forall (($$0@@25 Int) ) (!  (=> (and (>= $$0@@25 0) (< $$0@@25 (|l#$ValueArray| (|v#$Vector| new_public_key@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key@@0)) $$0@@25)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key@@0)) $$0@@25)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key@@0)) $$0@@25)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| new_public_key@@0)) $$0@@25))
))) (= (ControlFlow 0 327767) 331849))) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 346543) 327767) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
