(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $FixedPoint32_FixedPoint32 $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $XDX_XDX $XDX_Reserve $TransactionFee_TransactionFee)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@0) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@0))
)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0@@1) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($Event_EventHandle_type_value $tv0@@1))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@9) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@9))
)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_flag@14 () Bool)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun tc_account () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $TransactionFee_TransactionFee_$memory () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun $abort_code@16 () Int)
(declare-fun $TransactionFee_TransactionFee_$memory@3 () T@$Memory)
(declare-fun $abort_code@15 () Int)
(declare-fun $TransactionFee_TransactionFee_$memory@2 () T@$Memory)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $TransactionFee_TransactionFee_$memory@1 () T@$Memory)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_flag@12 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_code@13 () Int)
(declare-fun $TransactionFee_TransactionFee_$memory@0 () T@$Memory)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$TransactionFee_TransactionFee_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Diem_zero_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun inline$$Diem_Preburn_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_flag@9 () Bool)
(declare-fun inline$$Diem_Diem_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$t0@1 () T@$Value)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun inline$$Diem_zero_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@5 () Bool)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@5 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$TransactionFee_add_txn_fee_currency_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1 () T@$Value)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(declare-fun $XDX_Reserve_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 168889) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 134684) (- 0 173553)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@14)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@14) (and (=> (= (ControlFlow 0 134684) (- 0 173568)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@14)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@14) (and (=> (= (ControlFlow 0 134684) (- 0 173589)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@14)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@14) (and (=> (= (ControlFlow 0 134684) (- 0 173618)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@14)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@14) (and (=> (= (ControlFlow 0 134684) (- 0 173635)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))) $abort_flag@14)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))) $abort_flag@14) (and (=> (= (ControlFlow 0 134684) (- 0 173659)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@14)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@14) (and (=> (= (ControlFlow 0 134684) (- 0 173676)) (=> $abort_flag@14 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@14 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 134684) (- 0 173794)) (=> $abort_flag@14 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@16 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@16 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@16 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@16 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))) (= $abort_code@16 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@16 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@14 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@16 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@16 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@16 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@16 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))) (= $abort_code@16 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@16 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 134684) (- 0 173978)) (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))))) (=> (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))) (=> (= (ControlFlow 0 134684) (- 0 173988)) (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value) ($Integer 0))))))))))))))))))))))))))
(let ((inline$$TransactionFee_initialize_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@14 true) (= $abort_code@16 $abort_code@15)) (and (= $TransactionFee_TransactionFee_$memory@3 $TransactionFee_TransactionFee_$memory@2) (= (ControlFlow 0 134630) 134684))) anon0$2_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon5_correct  (=> (= $TransactionFee_TransactionFee_$memory@2 $TransactionFee_TransactionFee_$memory) (=> (and (= $abort_code@15 $abort_code@1) (= (ControlFlow 0 134662) 134630)) inline$$TransactionFee_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 134660) 134662)) inline$$TransactionFee_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 134670) 134662) inline$$TransactionFee_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 134654) 134670) inline$$TransactionFee_initialize_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 134654) 134660) inline$$TransactionFee_initialize_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon9_correct  (=> (= $TransactionFee_TransactionFee_$memory@2 $TransactionFee_TransactionFee_$memory) (=> (and (= $abort_code@15 $abort_code@2) (= (ControlFlow 0 134642) 134630)) inline$$TransactionFee_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 134640) 134642)) inline$$TransactionFee_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 134650) 134642) inline$$TransactionFee_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 134634) 134650) inline$$TransactionFee_initialize_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 134634) 134640) inline$$TransactionFee_initialize_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon18_Then_correct  (=> (and (and $abort_flag@13 (= $TransactionFee_TransactionFee_$memory@2 $TransactionFee_TransactionFee_$memory@1)) (and (= $abort_code@15 $abort_code@14) (= (ControlFlow 0 134626) 134630))) inline$$TransactionFee_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@13) (=> (and (and (= $abort_flag@14 $abort_flag@13) (= $abort_code@16 $abort_code@14)) (and (= $TransactionFee_TransactionFee_$memory@3 $TransactionFee_TransactionFee_$memory@1) (= (ControlFlow 0 134622) 134684))) anon0$2_correct))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Else_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 134524) (- 0 173337)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (=> (= $abort_code@14 $abort_code@12) (=> (and (= $abort_flag@13 $abort_flag@12) (= $TransactionFee_TransactionFee_$memory@1 |inline$$MoveToRaw$0$m'@2|)) (and (=> (= (ControlFlow 0 134524) 134626) inline$$TransactionFee_initialize_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 134524) 134622) inline$$TransactionFee_initialize_$def_verify$0$anon18_Else_correct)))))))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct  (=> (= $abort_code@14 $abort_code@13) (=> (and (= $abort_flag@13 true) (= $TransactionFee_TransactionFee_$memory@1 $TransactionFee_TransactionFee_$memory@0)) (and (=> (= (ControlFlow 0 132472) 134626) inline$$TransactionFee_initialize_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 132472) 134622) inline$$TransactionFee_initialize_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon5_correct  (=> (= $abort_code@13 $abort_code@3) (=> (and (= $TransactionFee_TransactionFee_$memory@0 $TransactionFee_TransactionFee_$memory) (= (ControlFlow 0 134588) 132472)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 134586) 134588)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon5_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 134596) 134588) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon5_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon26_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 134580) 134596) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 134580) 134586) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon27_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon11_correct  (=> (= $abort_code@13 $abort_code@4) (=> (and (= $TransactionFee_TransactionFee_$memory@0 $TransactionFee_TransactionFee_$memory) (= (ControlFlow 0 134564) 132472)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 134562) 134564)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon11_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 134572) 134564) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon11_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon29_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 134556) 134572) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 134556) 134562) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon30_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon23_correct  (=> (= $abort_code@13 $abort_code@12) (=> (and (= $TransactionFee_TransactionFee_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 134536) 132472)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 134534) 134536)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon23_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 134544) 134536) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon23_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 134528) 134544) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 134528) 134534) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon36_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@12 true) (=> (and (= $abort_code@12 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 134484) 134528) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 134484) 134524) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 134482) 134484)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 inline$$TransactionFee_TransactionFee_pack$0$$struct@1))) (= $abort_flag@12 $abort_flag@11)) (and (= $abort_code@12 $abort_code@11) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 134432) 134528) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 134432) 134524) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon35_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| tc_account)) (and (=> (= (ControlFlow 0 134490) 134482) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 134490) 134432) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 134278) (- 0 173222)) true) (=> (= (ControlFlow 0 134278) 134490) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1)) (= (ControlFlow 0 134250) 134278)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 134152) 134250)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 134158) 134250) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 134146) 134158) inline$$TransactionFee_TransactionFee_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 134146) 134152) inline$$TransactionFee_TransactionFee_pack$0$anon4_Else_correct)))))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 134138) 134250)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$0$$ret0@2) (let ((va@@8 (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_create_preburn_$def$0$$ret0@2) (let ((va@@9 (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn)) (let ((va@@10 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (= inline$$TransactionFee_TransactionFee_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$ret0@2) 1 inline$$Diem_create_preburn_$def$0$$ret0@2) 2)))) (and (=> (= (ControlFlow 0 134130) 134146) inline$$TransactionFee_TransactionFee_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 134130) 134138) inline$$TransactionFee_TransactionFee_pack$0$anon3_Else_correct))))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Else_correct  (=> (and (not $abort_flag@11) (= (ControlFlow 0 134164) 134130)) inline$$TransactionFee_TransactionFee_pack$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Then_correct  (=> (and (and $abort_flag@11 (= $abort_code@13 $abort_code@11)) (and (= $TransactionFee_TransactionFee_$memory@0 $TransactionFee_TransactionFee_$memory) (= (ControlFlow 0 134548) 132472))) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_create_preburn_$def$0$$ret0@1 $Error) (= $abort_code@11 $abort_code@10)) (and (= inline$$Diem_create_preburn_$def$0$$ret0@2 inline$$Diem_create_preburn_$def$0$$ret0@1) (= $abort_flag@11 true))) (and (=> (= (ControlFlow 0 133903) 134548) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 133903) 134164) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon5_correct  (=> (and (= $abort_code@10 $abort_code@7) (= (ControlFlow 0 133935) 133903)) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 133933) 133935)) inline$$Diem_create_preburn_$def$0$anon5_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 133943) 133935) inline$$Diem_create_preburn_$def$0$anon5_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 133927) 133943) inline$$Diem_create_preburn_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 133927) 133933) inline$$Diem_create_preburn_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon9_correct  (=> (and (= $abort_code@10 $abort_code@8) (= (ControlFlow 0 133915) 133903)) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 133913) 133915)) inline$$Diem_create_preburn_$def$0$anon9_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 133923) 133915) inline$$Diem_create_preburn_$def$0$anon9_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 133907) 133923) inline$$Diem_create_preburn_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 133907) 133913) inline$$Diem_create_preburn_$def$0$anon19_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Then_correct  (=> $abort_flag@10 (=> (and (= $abort_code@10 $abort_code@9) (= (ControlFlow 0 133897) 133903)) inline$$Diem_create_preburn_$def$0$Abort_correct))))
(let ((inline$$Diem_create_preburn_$def$0$anon14_correct  (=> (= $abort_code@11 $abort_code@9) (=> (and (= inline$$Diem_create_preburn_$def$0$$ret0@2 inline$$Diem_Preburn_pack$0$$struct@1) (= $abort_flag@11 $abort_flag@10)) (and (=> (= (ControlFlow 0 133885) 134548) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 133885) 134164) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon34_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 133883) 133885)) inline$$Diem_create_preburn_$def$0$anon14_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 133893) 133885) inline$$Diem_create_preburn_$def$0$anon14_correct)))
(let ((inline$$Diem_Preburn_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 133861) 133893) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 133861) 133883) inline$$Diem_create_preburn_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 133867) 133893) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 133867) 133883) inline$$Diem_create_preburn_$def$0$anon21_Else_correct))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 133855) 133867) inline$$Diem_Preburn_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 133855) 133861) inline$$Diem_Preburn_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 133847) 133893) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 133847) 133883) inline$$Diem_create_preburn_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$1$$ret0@2) (let ((va@@11 (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$Diem_Preburn_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 133839) 133855) inline$$Diem_Preburn_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 133839) 133847) inline$$Diem_Preburn_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Else_correct  (=> (and (not $abort_flag@10) (= (ControlFlow 0 133873) 133839)) inline$$Diem_Preburn_pack$0$anon0_correct)))
(let ((inline$$Diem_zero_$def$1$anon3_correct  (=> (= inline$$Diem_zero_$def$1$$ret0@1 $Error) (=> (and (= $abort_flag@10 true) (= inline$$Diem_zero_$def$1$$ret0@2 inline$$Diem_zero_$def$1$$ret0@1)) (and (=> (= (ControlFlow 0 133678) 133897) inline$$Diem_create_preburn_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 133678) 133873) inline$$Diem_create_preburn_$def$0$anon20_Else_correct))))))
(let ((inline$$Diem_zero_$def$1$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 133672) 133678)) inline$$Diem_zero_$def$1$anon3_correct)))
(let ((inline$$Diem_zero_$def$1$anon8_Then_correct  (=> (= (ControlFlow 0 133686) 133678) inline$$Diem_zero_$def$1$anon3_correct)))
(let ((inline$$Diem_zero_$def$1$anon7_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 133666) 133686) inline$$Diem_zero_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 133666) 133672) inline$$Diem_zero_$def$1$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon6_correct  (=> (and (= $abort_flag@10 $abort_flag@9) (= inline$$Diem_zero_$def$1$$ret0@2 inline$$Diem_Diem_pack$1$$struct@1)) (and (=> (= (ControlFlow 0 133654) 133897) inline$$Diem_create_preburn_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 133654) 133873) inline$$Diem_create_preburn_$def$0$anon20_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 133652) 133654)) inline$$Diem_zero_$def$1$anon6_correct)))
(let ((inline$$Diem_zero_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 133662) 133654) inline$$Diem_zero_$def$1$anon6_correct)))
(let ((inline$$Diem_Diem_pack$1$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 133630) 133662) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 133630) 133652) inline$$Diem_zero_$def$1$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon4_Then_correct  (and (=> (= (ControlFlow 0 133636) 133662) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 133636) 133652) inline$$Diem_zero_$def$1$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 133624) 133636) inline$$Diem_Diem_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 133624) 133630) inline$$Diem_Diem_pack$1$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 133616) 133662) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 133616) 133652) inline$$Diem_zero_$def$1$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$1$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$t0@1) 1)))) (and (=> (= (ControlFlow 0 133608) 133624) inline$$Diem_Diem_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 133608) 133616) inline$$Diem_Diem_pack$1$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon7_Else_correct  (=> (not $abort_flag@9) (=> (and (= inline$$Diem_zero_$def$1$$t0@1 ($Integer 0)) (= (ControlFlow 0 133642) 133608)) inline$$Diem_Diem_pack$1$anon0_correct))))
(let ((inline$$Diem_zero_$def$1$anon0_correct  (=> (and (and (not $abort_flag@8) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@9)) (and (=> $abort_flag@9 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@9 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 133467) 133666) inline$$Diem_zero_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 133467) 133642) inline$$Diem_zero_$def$1$anon7_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 133700) 133467)) inline$$Diem_zero_$def$1$anon0_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Else_correct  (=> (and (and (not $abort_flag@7) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@8)) (and (=> $abort_flag@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@8 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 133270) 133907) inline$$Diem_create_preburn_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 133270) 133700) inline$$Diem_create_preburn_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@7) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@7) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@7)) (and (=> $abort_flag@7 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@7 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@7 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@7 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@7 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 133264) 133927) inline$$Diem_create_preburn_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 133264) 133270) inline$$Diem_create_preburn_$def$0$anon16_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 133228) 133264)) inline$$Diem_create_preburn_$def$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 133951) 133264) inline$$Diem_create_preburn_$def$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon0_correct  (=> (not $abort_flag@6) (and (=> (= (ControlFlow 0 133222) 133951) inline$$Diem_create_preburn_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 133222) 133228) inline$$Diem_create_preburn_$def$0$anon15_Else_correct)))))
(let ((inline$$Diem_create_preburn$0$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 133957) 133222)) inline$$Diem_create_preburn_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 133965) 133957)) inline$$Diem_create_preburn$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Then_correct  (=> (and (and $abort_flag@6 (= $abort_code@13 $abort_code@6)) (and (= $TransactionFee_TransactionFee_$memory@0 $TransactionFee_TransactionFee_$memory) (= (ControlFlow 0 134552) 132472))) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_zero_$def$0$anon3_correct  (=> (= inline$$Diem_zero_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@6 true) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_zero_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 132888) 134552) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 132888) 133965) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Else_correct))))))
(let ((inline$$Diem_zero_$def$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 132882) 132888)) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon8_Then_correct  (=> (= (ControlFlow 0 132896) 132888) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon7_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 132876) 132896) inline$$Diem_zero_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 132876) 132882) inline$$Diem_zero_$def$0$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon6_correct  (=> (and (= $abort_flag@6 $abort_flag@5) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_Diem_pack$0$$struct@1)) (and (=> (= (ControlFlow 0 132864) 134552) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 132864) 133965) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon33_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 132862) 132864)) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_zero_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 132872) 132864) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 132840) 132872) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 132840) 132862) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 132846) 132872) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 132846) 132862) inline$$Diem_zero_$def$0$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 132834) 132846) inline$$Diem_Diem_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 132834) 132840) inline$$Diem_Diem_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 132826) 132872) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 132826) 132862) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$0$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 132818) 132834) inline$$Diem_Diem_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 132818) 132826) inline$$Diem_Diem_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon7_Else_correct  (=> (not $abort_flag@5) (=> (and (= inline$$Diem_zero_$def$0$$t0@1 ($Integer 0)) (= (ControlFlow 0 132852) 132818)) inline$$Diem_Diem_pack$0$anon0_correct))))
(let ((inline$$Diem_zero_$def$0$anon0_correct  (=> (and (and (not $abort_flag@4) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5)) (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 132677) 132876) inline$$Diem_zero_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 132677) 132852) inline$$Diem_zero_$def$0$anon7_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon31_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 132910) 132677)) inline$$Diem_zero_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon16_correct  (=> (= $abort_code@13 $abort_code@5) (=> (and (= $TransactionFee_TransactionFee_$memory@0 $TransactionFee_TransactionFee_$memory) (= (ControlFlow 0 132468) 132472)) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 132466) 132468)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon16_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 132480) 132468) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon16_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon31_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@5 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 132460) 132480) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 132460) 132466) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon32_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon29_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 132448) 132910) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 132448) 132460) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon31_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else$1_correct  (=> (and (and (and (= inline$$TransactionFee_add_txn_fee_currency_$def$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 132442) 134556) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 132442) 132448) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon29_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2)))) (= (ControlFlow 0 132430) 132442)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 132420) (- 0 171985)) true) (=> (= (ControlFlow 0 132420) 132430) inline$$Not$0$anon0_correct))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 132436) 132420)) inline$$Not$0$Entry_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Then_correct  (=> (and (and $abort_flag@3 (= $abort_code@13 $abort_code@3)) (and (= $TransactionFee_TransactionFee_$memory@0 $TransactionFee_TransactionFee_$memory) (= (ControlFlow 0 134576) 132472))) inline$$TransactionFee_add_txn_fee_currency_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct  (=> (and (= $abort_flag@3 $abort_flag@2) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2 inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1)) (and (=> (= (ControlFlow 0 132350) 134576) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 132350) 132436) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 132348) 132350)) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 132358) 132350) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct  (=> (and (not $abort_flag@2) (= inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1))))) (and (=> (= (ControlFlow 0 132342) 132358) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 132342) 132348) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct  (=> (and (and $abort_flag@2 (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1 $Error)) (and (= $abort_flag@3 true) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2 inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 132366) 134576) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 132366) 132436) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon28_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 132288) 132366) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 132288) 132342) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 132298) 132366) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 132298) 132342) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@2) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 ($Address 186537453))) (and (=> (= (ControlFlow 0 132282) 132298) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 132282) 132288) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 132312) 132282)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon26_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 132380) 132312)) inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2) (=> (and (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@3 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 132026) 134580) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 132026) 132380) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon26_Else_correct))))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 131990) 132026)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon2$1_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 134604) 132026) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon2$1_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def$0$anon0_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 131984) 134604) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 131984) 131990) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon25_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 134608) 131984)) inline$$TransactionFee_add_txn_fee_currency_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$Entry_correct  (=> (and (= inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$$tv0@0 $XUS_XUS_type_value) (= (ControlFlow 0 131565) 134608)) inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$anon0_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 134614) 131565)) inline$$TransactionFee_add_txn_fee_currency_$direct_intra$0$Entry_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon14_Else_correct  (=> (and (not $abort_flag@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@1)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@1)) (and (=> $abort_flag@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@2 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 131511) 134634) inline$$TransactionFee_initialize_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 131511) 134614) inline$$TransactionFee_initialize_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 131505) 134654) inline$$TransactionFee_initialize_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 131505) 131511) inline$$TransactionFee_initialize_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 131469) 131505)) inline$$TransactionFee_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 134678) 131505) inline$$TransactionFee_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$TransactionFee_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 131463) 134678) inline$$TransactionFee_initialize_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 131463) 131469) inline$$TransactionFee_initialize_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (=> (and (and (and (and (forall (($inv_addr@@1 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_currency_code)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_currency_code))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_currency_code))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_currency_code))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_currency_code))) $$0))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@23 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@24 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2)) (let ((va@@27 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_balance)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_balance))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_balance))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) $MAX_U64)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_preburn)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_preburn))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_preburn))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64))))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (= (ControlFlow 0 134682) 131463))))) inline$$TransactionFee_initialize_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 130660) 134682)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 168889) 130660) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_flag@10@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$TransactionFee_TransactionFee_pack$0$$struct@1@@0 () T@$Value)
(declare-fun $abort_flag@9@@0 () Bool)
(declare-fun tc_account@@0 () T@$Value)
(declare-fun $tv0@@10 () T@$TypeValue)
(declare-fun inline$$Diem_zero_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $abort_flag@8@@0 () Bool)
(declare-fun inline$$Diem_Preburn_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$ret0@2@@0 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun inline$$Diem_Diem_pack$1$$struct@1@@0 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$t0@1@@0 () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun inline$$Diem_zero_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$t0@1@@0 () T@$Value)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@0 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_code@1@@0 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 174029) (let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon27_Else_correct true))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon27_Then_correct true))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon26_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 138587) 138603) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 138587) 138593) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon30_Else_correct true))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon30_Then_correct true))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon29_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 138563) 138579) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 138563) 138569) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon36_Else_correct true))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon36_Then_correct true))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon35_Then_correct  (=> $abort_flag@10@@0 (and (=> (= (ControlFlow 0 138535) 138551) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 138535) 138541) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon35_Else_correct  (=> (and (not $abort_flag@10@@0) (= (ControlFlow 0 138531) (- 0 177047))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@10@@0 true) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 138491) 138535) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 138491) 138531) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 138489) 138491)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0)) (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0 inline$$TransactionFee_TransactionFee_pack$0$$struct@1@@0)))) (and (= $abort_flag@10@@0 $abort_flag@9@@0) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 138439) 138535) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 138439) 138531) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| tc_account@@0)) (and (=> (= (ControlFlow 0 138497) 138489) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 138497) 138439) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 138285) (- 0 176939)) true) (=> (= (ControlFlow 0 138285) 138497) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$MoveTo$0$Entry_correct@@0  (=> (and (= inline$$MoveTo$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (= (ControlFlow 0 138257) 138285)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 138159) 138257)) inline$$MoveTo$0$Entry_correct@@0)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 138165) 138257) inline$$MoveTo$0$Entry_correct@@0)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 138153) 138165) inline$$TransactionFee_TransactionFee_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 138153) 138159) inline$$TransactionFee_TransactionFee_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 138145) 138257)) inline$$MoveTo$0$Entry_correct@@0)))
(let ((inline$$TransactionFee_TransactionFee_pack$0$anon0_correct@@0  (=> (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$0$$ret0@2@@0) (let ((va@@31 (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_create_preburn_$def$0$$ret0@2@@0) (let ((va@@32 (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2@@0)))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2@@0)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2@@0)) $Diem_Preburn_to_burn)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2@@0)) $Diem_Preburn_to_burn))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2@@0)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_create_preburn_$def$0$$ret0@2@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (= inline$$TransactionFee_TransactionFee_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$ret0@2@@0) 1 inline$$Diem_create_preburn_$def$0$$ret0@2@@0) 2)))) (and (=> (= (ControlFlow 0 138137) 138153) inline$$TransactionFee_TransactionFee_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 138137) 138145) inline$$TransactionFee_TransactionFee_pack$0$anon3_Else_correct@@0))))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@9@@0) (= (ControlFlow 0 138171) 138137)) inline$$TransactionFee_TransactionFee_pack$0$anon0_correct@@0)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon34_Then_correct true))
(let ((inline$$Diem_create_preburn_$def$0$Abort_correct@@0  (=> (= inline$$Diem_create_preburn_$def$0$$ret0@1@@0 $Error) (=> (and (= $abort_flag@9@@0 true) (= inline$$Diem_create_preburn_$def$0$$ret0@2@@0 inline$$Diem_create_preburn_$def$0$$ret0@1@@0)) (and (=> (= (ControlFlow 0 137910) 138555) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 137910) 138171) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 137940) 137910)) inline$$Diem_create_preburn_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Then_correct@@0  (=> (= (ControlFlow 0 137950) 137910) inline$$Diem_create_preburn_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Then_correct@@0  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 137934) 137950) inline$$Diem_create_preburn_$def$0$anon17_Then_correct@@0) (=> (= (ControlFlow 0 137934) 137940) inline$$Diem_create_preburn_$def$0$anon17_Else_correct@@0)))))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 137920) 137910)) inline$$Diem_create_preburn_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Then_correct@@0  (=> (= (ControlFlow 0 137930) 137910) inline$$Diem_create_preburn_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Then_correct@@0  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 137914) 137930) inline$$Diem_create_preburn_$def$0$anon19_Then_correct@@0) (=> (= (ControlFlow 0 137914) 137920) inline$$Diem_create_preburn_$def$0$anon19_Else_correct@@0)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Then_correct@@0  (=> (and $abort_flag@8@@0 (= (ControlFlow 0 137904) 137910)) inline$$Diem_create_preburn_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon14_correct@@0  (=> (and (= $abort_flag@9@@0 $abort_flag@8@@0) (= inline$$Diem_create_preburn_$def$0$$ret0@2@@0 inline$$Diem_Preburn_pack$0$$struct@1@@0)) (and (=> (= (ControlFlow 0 137892) 138555) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 137892) 138171) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 137890) 137892)) inline$$Diem_create_preburn_$def$0$anon14_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Then_correct@@0  (=> (= (ControlFlow 0 137900) 137892) inline$$Diem_create_preburn_$def$0$anon14_correct@@0)))
(let ((inline$$Diem_Preburn_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 137868) 137900) inline$$Diem_create_preburn_$def$0$anon21_Then_correct@@0) (=> (= (ControlFlow 0 137868) 137890) inline$$Diem_create_preburn_$def$0$anon21_Else_correct@@0)))))
(let ((inline$$Diem_Preburn_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 137874) 137900) inline$$Diem_create_preburn_$def$0$anon21_Then_correct@@0) (=> (= (ControlFlow 0 137874) 137890) inline$$Diem_create_preburn_$def$0$anon21_Else_correct@@0))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 137862) 137874) inline$$Diem_Preburn_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 137862) 137868) inline$$Diem_Preburn_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Else_correct@@0  (=> (>= 0 0) (and (=> (= (ControlFlow 0 137854) 137900) inline$$Diem_create_preburn_$def$0$anon21_Then_correct@@0) (=> (= (ControlFlow 0 137854) 137890) inline$$Diem_create_preburn_$def$0$anon21_Else_correct@@0)))))
(let ((inline$$Diem_Preburn_pack$0$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$1$$ret0@2@@0) (let ((va@@34 (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2@@0)))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2@@0)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$Diem_Preburn_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$ret0@2@@0) 1)))) (and (=> (= (ControlFlow 0 137846) 137862) inline$$Diem_Preburn_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 137846) 137854) inline$$Diem_Preburn_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Else_correct@@0  (=> (and (not $abort_flag@8@@0) (= (ControlFlow 0 137880) 137846)) inline$$Diem_Preburn_pack$0$anon0_correct@@0)))
(let ((inline$$Diem_zero_$def$1$anon3_correct@@0  (=> (= inline$$Diem_zero_$def$1$$ret0@1@@0 $Error) (=> (and (= $abort_flag@8@@0 true) (= inline$$Diem_zero_$def$1$$ret0@2@@0 inline$$Diem_zero_$def$1$$ret0@1@@0)) (and (=> (= (ControlFlow 0 137685) 137904) inline$$Diem_create_preburn_$def$0$anon20_Then_correct@@0) (=> (= (ControlFlow 0 137685) 137880) inline$$Diem_create_preburn_$def$0$anon20_Else_correct@@0))))))
(let ((inline$$Diem_zero_$def$1$anon8_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 137679) 137685)) inline$$Diem_zero_$def$1$anon3_correct@@0)))
(let ((inline$$Diem_zero_$def$1$anon8_Then_correct@@0  (=> (= (ControlFlow 0 137693) 137685) inline$$Diem_zero_$def$1$anon3_correct@@0)))
(let ((inline$$Diem_zero_$def$1$anon7_Then_correct@@0  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 137673) 137693) inline$$Diem_zero_$def$1$anon8_Then_correct@@0) (=> (= (ControlFlow 0 137673) 137679) inline$$Diem_zero_$def$1$anon8_Else_correct@@0)))))
(let ((inline$$Diem_zero_$def$1$anon6_correct@@0  (=> (and (= $abort_flag@8@@0 $abort_flag@7@@0) (= inline$$Diem_zero_$def$1$$ret0@2@@0 inline$$Diem_Diem_pack$1$$struct@1@@0)) (and (=> (= (ControlFlow 0 137661) 137904) inline$$Diem_create_preburn_$def$0$anon20_Then_correct@@0) (=> (= (ControlFlow 0 137661) 137880) inline$$Diem_create_preburn_$def$0$anon20_Else_correct@@0)))))
(let ((inline$$Diem_zero_$def$1$anon9_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 137659) 137661)) inline$$Diem_zero_$def$1$anon6_correct@@0)))
(let ((inline$$Diem_zero_$def$1$anon9_Then_correct@@0  (=> (= (ControlFlow 0 137669) 137661) inline$$Diem_zero_$def$1$anon6_correct@@0)))
(let ((inline$$Diem_Diem_pack$1$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 137637) 137669) inline$$Diem_zero_$def$1$anon9_Then_correct@@0) (=> (= (ControlFlow 0 137637) 137659) inline$$Diem_zero_$def$1$anon9_Else_correct@@0)))))
(let ((inline$$Diem_Diem_pack$1$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 137643) 137669) inline$$Diem_zero_$def$1$anon9_Then_correct@@0) (=> (= (ControlFlow 0 137643) 137659) inline$$Diem_zero_$def$1$anon9_Else_correct@@0))))
(let ((inline$$Diem_Diem_pack$1$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 137631) 137643) inline$$Diem_Diem_pack$1$anon4_Then_correct@@0) (=> (= (ControlFlow 0 137631) 137637) inline$$Diem_Diem_pack$1$anon4_Else_correct@@0)))))
(let ((inline$$Diem_Diem_pack$1$anon3_Else_correct@@0  (=> (>= 0 0) (and (=> (= (ControlFlow 0 137623) 137669) inline$$Diem_zero_$def$1$anon9_Then_correct@@0) (=> (= (ControlFlow 0 137623) 137659) inline$$Diem_zero_$def$1$anon9_Else_correct@@0)))))
(let ((inline$$Diem_Diem_pack$1$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$1$$t0@1@@0) (>= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1@@0) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1@@0) $MAX_U64)) (= inline$$Diem_Diem_pack$1$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$t0@1@@0) 1)))) (and (=> (= (ControlFlow 0 137615) 137631) inline$$Diem_Diem_pack$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 137615) 137623) inline$$Diem_Diem_pack$1$anon3_Else_correct@@0)))))
(let ((inline$$Diem_zero_$def$1$anon7_Else_correct@@0  (=> (not $abort_flag@7@@0) (=> (and (= inline$$Diem_zero_$def$1$$t0@1@@0 ($Integer 0)) (= (ControlFlow 0 137649) 137615)) inline$$Diem_Diem_pack$1$anon0_correct@@0))))
(let ((inline$$Diem_zero_$def$1$anon0_correct@@0  (=> (and (and (not $abort_flag@6@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@7@@0)) (and (=> $abort_flag@7@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@7@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 137474) 137673) inline$$Diem_zero_$def$1$anon7_Then_correct@@0) (=> (= (ControlFlow 0 137474) 137649) inline$$Diem_zero_$def$1$anon7_Else_correct@@0)))))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Else_correct@@0  (=> (and (not $abort_flag@6@@0) (= (ControlFlow 0 137707) 137474)) inline$$Diem_zero_$def$1$anon0_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Else_correct@@0  (=> (and (and (not $abort_flag@5@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@0)) (and (=> $abort_flag@6@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@6@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6@@0 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 137277) 137914) inline$$Diem_create_preburn_$def$0$anon18_Then_correct@@0) (=> (= (ControlFlow 0 137277) 137707) inline$$Diem_create_preburn_$def$0$anon18_Else_correct@@0)))))
(let ((inline$$Diem_create_preburn_$def$0$anon2$1_correct@@0  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) $abort_flag@5@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@5@@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) $abort_flag@5@@0)) (and (=> $abort_flag@5@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))))) (=> $abort_flag@5@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (= $abort_code@5@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@5@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) (= $abort_code@5@@0 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 137271) 137934) inline$$Diem_create_preburn_$def$0$anon16_Then_correct@@0) (=> (= (ControlFlow 0 137271) 137277) inline$$Diem_create_preburn_$def$0$anon16_Else_correct@@0))))))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 137235) 137271)) inline$$Diem_create_preburn_$def$0$anon2$1_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Then_correct@@0  (=> (= (ControlFlow 0 137958) 137271) inline$$Diem_create_preburn_$def$0$anon2$1_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon0_correct@@0  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 137229) 137958) inline$$Diem_create_preburn_$def$0$anon15_Then_correct@@0) (=> (= (ControlFlow 0 137229) 137235) inline$$Diem_create_preburn_$def$0$anon15_Else_correct@@0)))))
(let ((inline$$Diem_create_preburn_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) tc_account@@0) (= (ControlFlow 0 137964) 137229)) inline$$Diem_create_preburn_$def$0$anon0_correct@@0)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon33_Else_correct  (=> (and (not $abort_flag@4@@0) (= (ControlFlow 0 137972) 137964)) inline$$Diem_create_preburn_$direct_inter$0$anon0_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon33_Then_correct true))
(let ((inline$$Diem_zero_$def$0$anon3_correct@@0  (=> (= inline$$Diem_zero_$def$0$$ret0@1@@0 $Error) (=> (and (= $abort_flag@4@@0 true) (= inline$$Diem_zero_$def$0$$ret0@2@@0 inline$$Diem_zero_$def$0$$ret0@1@@0)) (and (=> (= (ControlFlow 0 136895) 138559) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 136895) 137972) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$Diem_zero_$def$0$anon8_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 136889) 136895)) inline$$Diem_zero_$def$0$anon3_correct@@0)))
(let ((inline$$Diem_zero_$def$0$anon8_Then_correct@@0  (=> (= (ControlFlow 0 136903) 136895) inline$$Diem_zero_$def$0$anon3_correct@@0)))
(let ((inline$$Diem_zero_$def$0$anon7_Then_correct@@0  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 136883) 136903) inline$$Diem_zero_$def$0$anon8_Then_correct@@0) (=> (= (ControlFlow 0 136883) 136889) inline$$Diem_zero_$def$0$anon8_Else_correct@@0)))))
(let ((inline$$Diem_zero_$def$0$anon6_correct@@0  (=> (and (= $abort_flag@4@@0 $abort_flag@3@@0) (= inline$$Diem_zero_$def$0$$ret0@2@@0 inline$$Diem_Diem_pack$0$$struct@1@@0)) (and (=> (= (ControlFlow 0 136871) 138559) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 136871) 137972) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon9_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 136869) 136871)) inline$$Diem_zero_$def$0$anon6_correct@@0)))
(let ((inline$$Diem_zero_$def$0$anon9_Then_correct@@0  (=> (= (ControlFlow 0 136879) 136871) inline$$Diem_zero_$def$0$anon6_correct@@0)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 136847) 136879) inline$$Diem_zero_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 136847) 136869) inline$$Diem_zero_$def$0$anon9_Else_correct@@0)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 136853) 136879) inline$$Diem_zero_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 136853) 136869) inline$$Diem_zero_$def$0$anon9_Else_correct@@0))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 136841) 136853) inline$$Diem_Diem_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 136841) 136847) inline$$Diem_Diem_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct@@0  (=> (>= 0 0) (and (=> (= (ControlFlow 0 136833) 136879) inline$$Diem_zero_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 136833) 136869) inline$$Diem_zero_$def$0$anon9_Else_correct@@0)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$0$$t0@1@@0) (>= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1@@0) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1@@0) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$t0@1@@0) 1)))) (and (=> (= (ControlFlow 0 136825) 136841) inline$$Diem_Diem_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 136825) 136833) inline$$Diem_Diem_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_zero_$def$0$anon7_Else_correct@@0  (=> (not $abort_flag@3@@0) (=> (and (= inline$$Diem_zero_$def$0$$t0@1@@0 ($Integer 0)) (= (ControlFlow 0 136859) 136825)) inline$$Diem_Diem_pack$0$anon0_correct@@0))))
(let ((inline$$Diem_zero_$def$0$anon0_correct@@0  (=> (and (and (not $abort_flag@2@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@0)) (and (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@3@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@0 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 136684) 136883) inline$$Diem_zero_$def$0$anon7_Then_correct@@0) (=> (= (ControlFlow 0 136684) 136859) inline$$Diem_zero_$def$0$anon7_Else_correct@@0)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon31_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@0) (= (ControlFlow 0 136917) 136684)) inline$$Diem_zero_$def$0$anon0_correct@@0)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon32_Else_correct true))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon32_Then_correct true))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon31_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (= $abort_code@3@@0 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 136467) 136487) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 136467) 136473) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon29_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 136455) 136917) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 136455) 136467) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon28_Else$1_correct  (=> (and (and (and (= inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@0)) (and (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 136449) 138563) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 136449) 136455) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@0  (=> (and (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@0)))) (= (ControlFlow 0 136437) 136449)) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon28_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 136427) (- 0 175722)) true) (=> (= (ControlFlow 0 136427) 136437) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 136443) 136427)) inline$$Not$0$Entry_correct@@0)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon28_Then_correct true))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@0  (=> (and (= $abort_flag@1@@0 $abort_flag@0@@0) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@0 inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@0)) (and (=> (= (ControlFlow 0 136357) 138583) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 136357) 136443) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 136355) 136357)) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@0)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct@@0  (=> (= (ControlFlow 0 136365) 136357) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@0)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@0  (=> (and (not $abort_flag@0@@0) (= inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@0))))) (and (=> (= (ControlFlow 0 136349) 136365) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 136349) 136355) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@0  (=> (and (and $abort_flag@0@@0 (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1@@0 $Error)) (and (= $abort_flag@1@@0 true) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@0 inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1@@0))) (and (=> (= (ControlFlow 0 136373) 138583) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 136373) 136443) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 136295) 136373) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 136295) 136349) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 136305) 136373) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 136305) 136349) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@0))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@0@@0) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@0 ($Address 186537453))) (and (=> (= (ControlFlow 0 136289) 136305) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 136289) 136295) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 136319) 136289)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@0)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 136387) 136319)) inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct@@0)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@0) (=> (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 136033) 138587) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 136033) 136387) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 135997) 136033)) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon2$1_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 138611) 136033) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon2$1_correct)))
(let ((inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 135991) 138611) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 135991) 135997) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (=> (and (forall (($inv_addr@@4 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4)) (let ((va@@36 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_currency_code)) (let ((va@@38 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_currency_code))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_currency_code))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_currency_code))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_currency_code))) $$0@@5))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@6))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@7))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@8))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@46 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@9))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@47 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@10))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@4))
)) (forall (($inv_addr@@5 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5)) (let ((va@@49 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance)) (let ((va@@50 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) $MAX_U64)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64))))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@5))
))) (=> (and (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@3 T@$Value) )  (=> ((_ is $Type) coin_type@@3) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@0 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@4 T@$Value) )  (=> ((_ is $Type) coin_type@@4) (|b#$Boolean| ($Boolean (forall ((addr3@@0 T@$Value) )  (=> ((_ is $Address) addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@5 T@$Value) )  (=> ((_ is $Type) coin_type@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@6 T@$Value) )  (=> ((_ is $Type) coin_type@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@2 T@$Value) )  (=> ((_ is $Address) addr1@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| addr1@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (= (ControlFlow 0 138615) 135991)))) inline$$TransactionFee_add_txn_fee_currency_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) tc_account@@0) (= (ControlFlow 0 135146) 138615)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 174029) 135146) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun tc_account@@1 () T@$Value)
(declare-fun $abort_flag@40 () Bool)
(declare-fun $tv0@@11 () T@$TypeValue)
(declare-fun $abort_code@56 () Int)
(declare-fun $Diem_BurnCapability_$memory@5 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@8 () T@$Memory)
(declare-fun $TransactionFee_TransactionFee_$memory@1@@0 () T@$Memory)
(declare-fun $abort_flag@39 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@6 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$5$m'@2| () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory@3 () T@$Memory)
(declare-fun $abort_code@53 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@7 () T@$Memory)
(declare-fun $TransactionFee_TransactionFee_$memory@0@@0 () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory@4 () T@$Memory)
(declare-fun $abort_code@55 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_code@54 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$TransactionFee_burn_fees_$def_verify$0$$t12@1 () T@$Value)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_flag@7@@1 () Bool)
(declare-fun $abort_flag@38 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@1| () T@$Memory)
(declare-fun $abort_code@51 () Int)
(declare-fun $Diem_BurnCapability_$memory@2 () T@$Memory)
(declare-fun $abort_code@52 () Int)
(declare-fun $Diem_BurnCapability_$memory@1 () T@$Memory)
(declare-fun $abort_code@46 () Int)
(declare-fun $abort_flag@34 () Bool)
(declare-fun $abort_code@47 () Int)
(declare-fun $abort_flag@35 () Bool)
(declare-fun $abort_code@48 () Int)
(declare-fun $abort_flag@36 () Bool)
(declare-fun $abort_code@49 () Int)
(declare-fun $abort_flag@37 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@1| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0@@1 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1@@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$Diem_remove_burn_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Not$2$dst@1 () T@$Value)
(declare-fun $abort_code@50 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun $abort_flag@33 () Bool)
(declare-fun inline$$WritebackToGlobal$5$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$5$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$5$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$5$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$8$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$5$m'@1| () T@$Memory)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$10$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$8$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$8$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$8$dst'@1| () T@$Mutation)
(declare-fun inline$$TransactionFee_burn_fees_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$Diem_burn_now_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@45 () Int)
(declare-fun |inline$$WritebackToValue$2$vdst'@2| () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@4 () T@$Memory)
(declare-fun $abort_flag@32 () Bool)
(declare-fun $abort_code@43 () Int)
(declare-fun |inline$$WriteRef$9$to'@1| () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1| () T@$Value)
(declare-fun |inline$$WriteRef$4$to'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_burn_now_$def$0$$ret0@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@5 () T@$Memory)
(declare-fun $abort_code@44 () Int)
(declare-fun $abort_code@15@@0 () Int)
(declare-fun $abort_flag@12@@0 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@2 () T@$Memory)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun $abort_code@41 () Int)
(declare-fun $abort_flag@31 () Bool)
(declare-fun |inline$$WritebackToGlobal$4$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$4$l@1 () T@$Location)
(declare-fun $Diem_CurrencyInfo_$memory@1 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$4$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$4$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$4$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$7$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$4$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$6$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$8$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$7$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$7$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$7$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$BorrowField$18$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$17$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$3$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$3$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$3$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$3$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$3$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$3$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0 () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@3 () T@$Memory)
(declare-fun $abort_code@42 () Int)
(declare-fun $abort_code@28 () Int)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $abort_code@29 () Int)
(declare-fun $abort_flag@22 () Bool)
(declare-fun $abort_code@31 () Int)
(declare-fun $abort_flag@23 () Bool)
(declare-fun $abort_code@32 () Int)
(declare-fun $abort_flag@24 () Bool)
(declare-fun $abort_code@33 () Int)
(declare-fun $abort_flag@25 () Bool)
(declare-fun $abort_code@34 () Int)
(declare-fun $abort_flag@26 () Bool)
(declare-fun $abort_code@35 () Int)
(declare-fun $abort_flag@27 () Bool)
(declare-fun $abort_code@37 () Int)
(declare-fun $abort_flag@28 () Bool)
(declare-fun $abort_code@38 () Int)
(declare-fun $abort_flag@29 () Bool)
(declare-fun $abort_code@39 () Int)
(declare-fun $abort_flag@30 () Bool)
(declare-fun inline$$Event_emit_event$1$t@0 () T@$TypeValue)
(declare-fun inline$$Diem_Diem_unpack$0$value@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$Diem_BurnEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$18$p@1 () T@$Path)
(declare-fun inline$$BorrowField$18$size@1 () Int)
(declare-fun inline$$BorrowField$18$p@2 () T@$Path)
(declare-fun inline$$ReadRef$16$v@1 () T@$Value)
(declare-fun inline$$BorrowField$17$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$17$p@1 () T@$Path)
(declare-fun inline$$BorrowField$17$size@1 () Int)
(declare-fun inline$$BorrowField$17$p@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$5$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$7$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$6$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$6$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$6$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$16$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$2$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$16$p@1 () T@$Path)
(declare-fun inline$$BorrowField$16$size@1 () Int)
(declare-fun inline$$BorrowField$16$p@2 () T@$Path)
(declare-fun inline$$Sub$2$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$15$v@1 () T@$Value)
(declare-fun inline$$Sub$2$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$15$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$15$p@1 () T@$Path)
(declare-fun inline$$BorrowField$15$size@1 () Int)
(declare-fun inline$$BorrowField$15$p@2 () T@$Path)
(declare-fun inline$$Ge$2$dst@1 () T@$Value)
(declare-fun $abort_code@40 () Int)
(declare-fun |inline$$WritebackToGlobal$2$m'@2| () T@$Memory)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$WritebackToGlobal$2$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t36@1 () T@$Value)
(declare-fun inline$$ReadRef$14$v@1 () T@$Value)
(declare-fun inline$$BorrowField$14$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$14$p@1 () T@$Path)
(declare-fun inline$$BorrowField$14$size@1 () Int)
(declare-fun inline$$BorrowField$14$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$2$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$6$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$5$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$5$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$5$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$13$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$1$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$13$p@1 () T@$Path)
(declare-fun inline$$BorrowField$13$size@1 () Int)
(declare-fun inline$$BorrowField$13$p@2 () T@$Path)
(declare-fun inline$$Sub$1$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$13$v@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0 () T@$Value)
(declare-fun inline$$BorrowField$12$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$12$p@1 () T@$Path)
(declare-fun inline$$BorrowField$12$size@1 () Int)
(declare-fun inline$$BorrowField$12$p@2 () T@$Path)
(declare-fun inline$$Ge$1$dst@1 () T@$Value)
(declare-fun $abort_code@36 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t28@1 () T@$Value)
(declare-fun inline$$ReadRef$12$v@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@0 () T@$Value)
(declare-fun inline$$BorrowField$11$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$11$p@1 () T@$Path)
(declare-fun inline$$BorrowField$11$size@1 () Int)
(declare-fun inline$$BorrowField$11$p@2 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$2$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$2$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$2$a@1 () Int)
(declare-fun inline$$BorrowGlobal$2$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$4$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$9$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$5$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$4$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$4$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$4$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$10$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0 () T@$Value)
(declare-fun inline$$ReadRef$11$v@1 () T@$Value)
(declare-fun inline$$BorrowField$10$p@1 () T@$Path)
(declare-fun inline$$BorrowField$10$size@1 () Int)
(declare-fun inline$$BorrowField$10$p@2 () T@$Path)
(declare-fun inline$$Gt$1$dst@1 () T@$Value)
(declare-fun $abort_code@30 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t19@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$3$dst@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t17@1 () T@$Value)
(declare-fun inline$$ReadRef$10$v@1 () T@$Value)
(declare-fun inline$$BorrowField$9$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$9$p@1 () T@$Path)
(declare-fun inline$$BorrowField$9$size@1 () Int)
(declare-fun inline$$BorrowField$9$p@2 () T@$Path)
(declare-fun $abort_flag@20 () Bool)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@27 () Int)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun $abort_flag@19 () Bool)
(declare-fun $abort_code@25 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$8$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$8$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@26 () Int)
(declare-fun $abort_code@17 () Int)
(declare-fun $abort_flag@13@@0 () Bool)
(declare-fun $abort_code@19 () Int)
(declare-fun $abort_flag@14@@0 () Bool)
(declare-fun $abort_code@20 () Int)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $abort_code@21 () Int)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_code@22 () Int)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $abort_code@23 () Int)
(declare-fun $abort_flag@18 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$Diem_PreburnEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$8$p@1 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1 () Int)
(declare-fun inline$$BorrowField$8$p@2 () T@$Path)
(declare-fun inline$$ReadRef$7$v@1 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$7$p@1 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1 () Int)
(declare-fun inline$$BorrowField$7$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$6$p@1 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1 () Int)
(declare-fun inline$$BorrowField$6$p@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$6$v@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1 () Int)
(declare-fun inline$$BorrowField$5$p@2 () T@$Path)
(declare-fun inline$$Ge$0$dst@1 () T@$Value)
(declare-fun $abort_code@24 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t27@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t23@1 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t17@1 () T@$Value)
(declare-fun $abort_code@18 () Int)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t18@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$Gt$0$dst@1 () T@$Value)
(declare-fun $abort_code@16@@0 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$Diem_burn_now_$def$0$$t14@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_burn_now_$def$0$$t12@1 () T@$Value)
(declare-fun $abort_flag@11@@0 () Bool)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun $abort_code@14@@0 () Int)
(declare-fun inline$$MoveFrom$0$dst@2 () T@$Value)
(declare-fun $abort_code@12@@0 () Int)
(declare-fun $abort_flag@10@@1 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@2| () T@$Memory)
(declare-fun inline$$Diem_remove_burn_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@13@@0 () Int)
(declare-fun $Diem_BurnCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $abort_flag@8@@1 () Bool)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun $abort_flag@9@@1 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveFrom$0$a@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1| () T@$Memory)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$Diem_remove_burn_capability_$def$0$$t5@1 () T@$Value)
(declare-fun $abort_code@11@@0 () Int)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$Diem_remove_burn_capability_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$TransactionFee_burn_fees_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@1 () T@$Value)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun inline$$TransactionFee_burn_fees_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@1 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1@@1 () T@$Value)
(declare-fun $Diem_Diem_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 177106) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 161104) (- 0 195435)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195456)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195485)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195502)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195517)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453)))))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453)))))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195533)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value)))) (|b#$Boolean| ($Boolean true))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value)))) (|b#$Boolean| ($Boolean true))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195554)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| tc_account@@1)))))))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| tc_account@@1)))))))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195604)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value) ($Integer 0))))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value) ($Integer 0))))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195648)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)))))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)))))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195701)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195751)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195816)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@40)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@40) (and (=> (= (ControlFlow 0 161104) (- 0 195850)) (=> $abort_flag@40 (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value)))) (|b#$Boolean| ($Boolean true)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| tc_account@@1))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))))))))) (=> (=> $abort_flag@40 (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value)))) (|b#$Boolean| ($Boolean true)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| tc_account@@1))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))))))))))) (and (=> (= (ControlFlow 0 161104) (- 0 196254)) (=> $abort_flag@40 (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@56 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@56 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@56 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value)))) (|b#$Boolean| ($Boolean true))))) (= $abort_code@56 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| tc_account@@1)))))))))) (= $abort_code@56 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value) ($Integer 0))))))) (= $abort_code@56 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@56 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@40 (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@56 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@56 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@56 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value)))) (|b#$Boolean| ($Boolean true))))) (= $abort_code@56 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| tc_account@@1)))))))))) (= $abort_code@56 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value) ($Integer 0))))))) (= $abort_code@56 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@56 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@56 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 161104) (- 0 196790)) (=> (not $abort_flag@40) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| tc_account@@1))))))))) (=> (=> (not $abort_flag@40) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| tc_account@@1)))))))) (and (=> (= (ControlFlow 0 161104) (- 0 196836)) (=> (not $abort_flag@40) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@40) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)))))))) (=> (= (ControlFlow 0 161104) (- 0 196878)) (=> (not $abort_flag@40) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value) ($Integer 0))))))))))))))))))))))))))))))))))))))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon81_Else_correct  (=> (not $abort_flag@39) (=> (and (= $Diem_CurrencyInfo_$memory@8 $Diem_CurrencyInfo_$memory@6) (= $TransactionFee_TransactionFee_$memory@1@@0 |inline$$WritebackToGlobal$5$m'@2|)) (=> (and (and (= $abort_flag@40 $abort_flag@39) (= $Diem_BurnCapability_$memory@5 $Diem_BurnCapability_$memory@3)) (and (= $abort_code@56 $abort_code@53) (= (ControlFlow 0 160866) 161104))) anon0$2_correct@@0)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct  (=> (and (= $Diem_CurrencyInfo_$memory@8 $Diem_CurrencyInfo_$memory@7) (= $TransactionFee_TransactionFee_$memory@1@@0 $TransactionFee_TransactionFee_$memory@0@@0)) (=> (and (and (= $abort_flag@40 true) (= $Diem_BurnCapability_$memory@5 $Diem_BurnCapability_$memory@4)) (and (= $abort_code@56 $abort_code@55) (= (ControlFlow 0 141066) 161104))) anon0$2_correct@@0))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon5_correct  (=> (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@1@@1) (= (ControlFlow 0 161082) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 161080) 161082)) inline$$TransactionFee_burn_fees_$def_verify$0$anon5_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 161090) 161082) inline$$TransactionFee_burn_fees_$def_verify$0$anon5_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon56_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 161074) 161090) inline$$TransactionFee_burn_fees_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 161074) 161080) inline$$TransactionFee_burn_fees_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon9_correct  (=> (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@2@@0) (= (ControlFlow 0 161062) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 161060) 161062)) inline$$TransactionFee_burn_fees_$def_verify$0$anon9_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 161070) 161062) inline$$TransactionFee_burn_fees_$def_verify$0$anon9_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon58_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 161054) 161070) inline$$TransactionFee_burn_fees_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 161054) 161060) inline$$TransactionFee_burn_fees_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon15_correct  (=> (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@3@@1) (= (ControlFlow 0 161038) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 161036) 161038)) inline$$TransactionFee_burn_fees_$def_verify$0$anon15_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon62_Then_correct  (=> (= (ControlFlow 0 161046) 161038) inline$$TransactionFee_burn_fees_$def_verify$0$anon15_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon61_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 161030) 161046) inline$$TransactionFee_burn_fees_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 161030) 161036) inline$$TransactionFee_burn_fees_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon25_correct  (=> (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@5@@1) (= (ControlFlow 0 161014) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 161012) 161014)) inline$$TransactionFee_burn_fees_$def_verify$0$anon25_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon67_Then_correct  (=> (= (ControlFlow 0 161022) 161014) inline$$TransactionFee_burn_fees_$def_verify$0$anon25_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon66_Then_correct  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 161006) 161022) inline$$TransactionFee_burn_fees_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 161006) 161012) inline$$TransactionFee_burn_fees_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon31_correct  (=> (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@6@@1) (= (ControlFlow 0 160994) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 160992) 160994)) inline$$TransactionFee_burn_fees_$def_verify$0$anon31_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 161002) 160994) inline$$TransactionFee_burn_fees_$def_verify$0$anon31_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon69_Then_correct  (=> $abort_flag@5@@1 (and (=> (= (ControlFlow 0 160986) 161002) inline$$TransactionFee_burn_fees_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 160986) 160992) inline$$TransactionFee_burn_fees_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon34_correct  (=> (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@54) (= (ControlFlow 0 160974) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 160972) 160974)) inline$$TransactionFee_burn_fees_$def_verify$0$anon34_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon71_Then_correct  (=> (= (ControlFlow 0 160982) 160974) inline$$TransactionFee_burn_fees_$def_verify$0$anon34_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon69_Else_correct  (=> (and (not $abort_flag@5@@1) (= $abort_code@54 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 160966) 160982) inline$$TransactionFee_burn_fees_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 160966) 160972) inline$$TransactionFee_burn_fees_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon68_Then_correct  (=> (|b#$Boolean| call3formal@$ret0@0@@2) (=> (and (and (and (= inline$$TransactionFee_burn_fees_$def_verify$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@1)) (and (=> $abort_flag@5@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 160956) 160986) inline$$TransactionFee_burn_fees_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 160956) 160966) inline$$TransactionFee_burn_fees_$def_verify$0$anon69_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon37_correct  (=> (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@7@@1) (= (ControlFlow 0 160938) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 160936) 160938)) inline$$TransactionFee_burn_fees_$def_verify$0$anon37_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon73_Then_correct  (=> (= (ControlFlow 0 160946) 160938) inline$$TransactionFee_burn_fees_$def_verify$0$anon37_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon72_Then_correct  (=> $abort_flag@6@@1 (and (=> (= (ControlFlow 0 160930) 160946) inline$$TransactionFee_burn_fees_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 160930) 160936) inline$$TransactionFee_burn_fees_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon41_correct  (=> (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@8@@0) (= (ControlFlow 0 160918) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 160916) 160918)) inline$$TransactionFee_burn_fees_$def_verify$0$anon41_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon75_Then_correct  (=> (= (ControlFlow 0 160926) 160918) inline$$TransactionFee_burn_fees_$def_verify$0$anon41_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon74_Then_correct  (=> $abort_flag@7@@1 (and (=> (= (ControlFlow 0 160910) 160926) inline$$TransactionFee_burn_fees_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 160910) 160916) inline$$TransactionFee_burn_fees_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon81_Then_correct  (=> (and $abort_flag@39 (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory@6)) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 |inline$$WritebackToGlobal$5$m'@2|) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory@3)) (and (= $abort_code@55 $abort_code@53) (= (ControlFlow 0 160870) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct  (=> (and (and (not $abort_flag@38) (= $Diem_BurnCapability_$memory@3 |inline$$MoveToRaw$0$m'@2@@1|)) (and (= $abort_code@53 $abort_code@51) (= $abort_flag@39 $abort_flag@38))) (and (=> (= (ControlFlow 0 160732) 160870) inline$$TransactionFee_burn_fees_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 160732) 160866) inline$$TransactionFee_burn_fees_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$Abort_correct  (=> (= $Diem_BurnCapability_$memory@3 $Diem_BurnCapability_$memory@2) (=> (and (= $abort_code@53 $abort_code@52) (= $abort_flag@39 true)) (and (=> (= (ControlFlow 0 160378) 160870) inline$$TransactionFee_burn_fees_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 160378) 160866) inline$$TransactionFee_burn_fees_$def_verify$0$anon81_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon7_correct  (=> (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory@1) (=> (and (= $abort_code@52 $abort_code@46) (= (ControlFlow 0 160824) 160378)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 160822) 160824)) inline$$Diem_publish_burn_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 160832) 160824) inline$$Diem_publish_burn_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct  (=> $abort_flag@34 (and (=> (= (ControlFlow 0 160816) 160832) inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 160816) 160822) inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon11_correct  (=> (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory@1) (=> (and (= $abort_code@52 $abort_code@47) (= (ControlFlow 0 160804) 160378)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 160802) 160804)) inline$$Diem_publish_burn_capability_$def$0$anon11_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 160812) 160804) inline$$Diem_publish_burn_capability_$def$0$anon11_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct  (=> $abort_flag@35 (and (=> (= (ControlFlow 0 160796) 160812) inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 160796) 160802) inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon15_correct  (=> (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory@1) (=> (and (= $abort_code@52 $abort_code@48) (= (ControlFlow 0 160784) 160378)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 160782) 160784)) inline$$Diem_publish_burn_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 160792) 160784) inline$$Diem_publish_burn_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct  (=> $abort_flag@36 (and (=> (= (ControlFlow 0 160776) 160792) inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 160776) 160782) inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon19_correct  (=> (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory@1) (=> (and (= $abort_code@52 $abort_code@49) (= (ControlFlow 0 160764) 160378)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 160762) 160764)) inline$$Diem_publish_burn_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 160772) 160764) inline$$Diem_publish_burn_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct  (=> $abort_flag@37 (and (=> (= (ControlFlow 0 160756) 160772) inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 160756) 160762) inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon27_correct  (=> (= $Diem_BurnCapability_$memory@2 |inline$$MoveToRaw$0$m'@2@@1|) (=> (and (= $abort_code@52 $abort_code@51) (= (ControlFlow 0 160744) 160378)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 160742) 160744)) inline$$Diem_publish_burn_capability_$def$0$anon27_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 160752) 160744) inline$$Diem_publish_burn_capability_$def$0$anon27_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct  (=> $abort_flag@38 (and (=> (= (ControlFlow 0 160736) 160752) inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 160736) 160742) inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@38 true) (=> (and (= $abort_code@51 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@1| |inline$$MoveToRaw$0$m'@0@@1|)) (and (=> (= (ControlFlow 0 160710) 160736) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 160710) 160732) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@1  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) inline$$MoveTo$0$ta@0@@1 inline$$MoveTo$0$a@1@@1) (= (ControlFlow 0 160708) 160710)) inline$$MoveToRaw$0$anon3_Then$1_correct@@1)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@1  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) inline$$MoveTo$0$ta@0@@1 inline$$MoveTo$0$a@1@@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) inline$$MoveTo$0$ta@0@@1 inline$$MoveTo$0$a@1@@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory@1) inline$$MoveTo$0$ta@0@@1 inline$$MoveTo$0$a@1@@1 inline$$Diem_remove_burn_capability_$def$0$$ret0@2))) (= $abort_flag@38 $abort_flag@37)) (and (= $abort_code@51 $abort_code@49) (= |inline$$MoveToRaw$0$m'@2@@1| |inline$$MoveToRaw$0$m'@1@@1|))) (and (=> (= (ControlFlow 0 160658) 160736) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 160658) 160732) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@1  (=> (= inline$$MoveTo$0$a@1@@1 (|a#$Address| tc_account@@1)) (and (=> (= (ControlFlow 0 160716) 160708) inline$$MoveToRaw$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 160716) 160658) inline$$MoveToRaw$0$anon3_Else_correct@@1)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 160504) (- 0 194824)) true) (=> (= (ControlFlow 0 160504) 160716) inline$$MoveTo$0$anon0$1_correct@@1))))
(let ((inline$$MoveTo$0$Entry_correct@@1  (=> (and (= inline$$MoveTo$0$ta@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1)) (= (ControlFlow 0 160476) 160504)) inline$$Signer_borrow_address$0$Entry_correct@@1)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$Not$2$dst@1) (= (ControlFlow 0 160724) 160476)) inline$$MoveTo$0$Entry_correct@@1)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon24_correct  (=> (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory@1) (=> (and (= $abort_code@52 $abort_code@50) (= (ControlFlow 0 160374) 160378)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 160372) 160374)) inline$$Diem_publish_burn_capability_$def$0$anon24_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 160386) 160374) inline$$Diem_publish_burn_capability_$def$0$anon24_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$2$dst@1)) (= $abort_code@50 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 160366) 160386) inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 160366) 160372) inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct  (=> (not $abort_flag@37) (and (=> (= (ControlFlow 0 160354) 160724) inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 160354) 160366) inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_burn_capability_$def$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@37)) (and (=> $abort_flag@37 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@37) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 160348) 160756) inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 160348) 160354) inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct)))))
(let ((inline$$Not$2$anon0_correct  (=> (and (= inline$$Not$2$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_publish_burn_capability_$def$0$$t7@1)))) (= (ControlFlow 0 160336) 160348)) inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct)))
(let ((inline$$Not$2$Entry_correct  (and (=> (= (ControlFlow 0 160326) (- 0 194668)) true) (=> (= (ControlFlow 0 160326) 160336) inline$$Not$2$anon0_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct  (=> (not $abort_flag@36) (=> (and (= inline$$Diem_publish_burn_capability_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| call3formal@$ret0@0@@4)))) (= (ControlFlow 0 160342) 160326)) inline$$Not$2$Entry_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct  (=> (not $abort_flag@35) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@36) (=> $abort_flag@36 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@36) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 tc_account@@1)))) ((_ is $Address) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 160268) 160776) inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 160268) 160342) inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct  (=> (and (and (not $abort_flag@34) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@35)) (and (=> $abort_flag@35 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@35 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@47 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 160262) 160796) inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 160262) 160268) inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@34) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@34) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@34)) (and (=> $abort_flag@34 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))))) (=> $abort_flag@34 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@46 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@46 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 160256) 160816) inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 160256) 160262) inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 160186) 160256)) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 160840) 160256) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 160178) 160840) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 160178) 160186) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 160848) 160840) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 160848) 160186) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon0_correct  (=> (not $abort_flag@33) (and (=> (= (ControlFlow 0 160172) 160848) inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 160172) 160178) inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$direct_inter$0$anon0_correct  (=> ((_ is $Address) tc_account@@1) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_remove_burn_capability_$def$0$$ret0@2) (let ((va@@53 (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 160852) 160172)) inline$$Diem_publish_burn_capability_$def$0$anon0_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon52$2_correct  (and (=> (= (ControlFlow 0 160858) (- 0 194160)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$5$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$5$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (=> (= (ControlFlow 0 160858) 160852) inline$$Diem_publish_burn_capability_$direct_inter$0$anon0_correct)))))
(let ((inline$$WritebackToGlobal$5$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$5$l@1)) (=> (and (= |inline$$WritebackToGlobal$5$m'@2| $TransactionFee_TransactionFee_$memory) (= (ControlFlow 0 159551) 160858)) inline$$TransactionFee_burn_fees_$def_verify$0$anon52$2_correct))))
(let ((inline$$WritebackToGlobal$5$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$5$l@1) (=> (and (= inline$$WritebackToGlobal$5$ta@1 (|ts#$Global| inline$$WritebackToGlobal$5$l@1)) (= inline$$WritebackToGlobal$5$a@1 (|a#$Global| inline$$WritebackToGlobal$5$l@1))) (=> (and (and (= inline$$WritebackToGlobal$5$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$8$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$WritebackToGlobal$5$ta@1 inline$$WritebackToGlobal$5$a@1) (|v#$Mutation| |inline$$WritebackToReference$8$dst'@2|))) (= |inline$$WritebackToGlobal$5$m'@1| ($Memory (|domain#$Memory| $TransactionFee_TransactionFee_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$WritebackToGlobal$5$ta@1 inline$$WritebackToGlobal$5$a@1 inline$$WritebackToGlobal$5$v@1)))) (and (= |inline$$WritebackToGlobal$5$m'@2| |inline$$WritebackToGlobal$5$m'@1|) (= (ControlFlow 0 159605) 160858))) inline$$TransactionFee_burn_fees_$def_verify$0$anon52$2_correct)))))
(let ((inline$$WritebackToGlobal$5$anon0_correct  (=> (= inline$$WritebackToGlobal$5$l@1 (|l#$Mutation| |inline$$WritebackToReference$8$dst'@2|)) (and (=> (= (ControlFlow 0 159541) 159605) inline$$WritebackToGlobal$5$anon3_Then_correct) (=> (= (ControlFlow 0 159541) 159551) inline$$WritebackToGlobal$5$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$8$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$10$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$8$dstPath@1) (|size#$Path| inline$$WritebackToReference$8$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$8$dstPath@1 inline$$WritebackToReference$8$srcPath@1))) (=> (and (= |inline$$WritebackToReference$8$dst'@2| |inline$$WritebackToReference$0$dst'@2|) (= (ControlFlow 0 159363) 159541)) inline$$WritebackToGlobal$5$anon0_correct))))
(let ((inline$$WritebackToReference$8$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$10$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$8$dstPath@1) (|size#$Path| inline$$WritebackToReference$8$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$8$dstPath@1 inline$$WritebackToReference$8$srcPath@1)) (= |inline$$WritebackToReference$8$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$WritebackToReference$8$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$8$srcPath@1 (|size#$Path| inline$$WritebackToReference$8$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|v#$Mutation| |inline$$WriteRef$10$to'@1|))))) (and (= |inline$$WritebackToReference$8$dst'@2| |inline$$WritebackToReference$8$dst'@1|) (= (ControlFlow 0 159419) 159541))) inline$$WritebackToGlobal$5$anon0_correct)))
(let ((inline$$WritebackToReference$8$anon0_correct  (=> (and (= inline$$WritebackToReference$8$srcPath@1 (|p#$Mutation| |inline$$WriteRef$10$to'@1|)) (= inline$$WritebackToReference$8$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (and (=> (= (ControlFlow 0 159327) 159419) inline$$WritebackToReference$8$anon3_Then_correct) (=> (= (ControlFlow 0 159327) 159363) inline$$WritebackToReference$8$anon3_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 159190) 159327)) inline$$WritebackToReference$8$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon80_Then_correct  (=> (and (= inline$$TransactionFee_burn_fees_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 160880) 159327)) inline$$WritebackToReference$8$anon0_correct)))
(let ((inline$$WriteRef$10$anon0_correct  (=> (= |inline$$WriteRef$10$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$Diem_burn_now_$def$0$$ret0@2)) (and (=> (= (ControlFlow 0 159176) 160880) inline$$TransactionFee_burn_fees_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 159176) 159190) inline$$TransactionFee_burn_fees_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon79_Else_correct  (=> (and (not $abort_flag@33) (= (ControlFlow 0 159182) 159176)) inline$$WriteRef$10$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon79_Then_correct  (=> (and $abort_flag@33 (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory@6)) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory@1)) (and (= $abort_code@55 $abort_code@45) (= (ControlFlow 0 160884) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon22_correct  (=> (and (and (= inline$$Diem_burn_now_$def$0$$ret0@2 |inline$$WritebackToValue$2$vdst'@2|) (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@4)) (and (= $abort_flag@33 $abort_flag@32) (= $abort_code@45 $abort_code@43))) (and (=> (= (ControlFlow 0 159035) 160884) inline$$TransactionFee_burn_fees_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 159035) 159182) inline$$TransactionFee_burn_fees_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 159033) 159035)) inline$$Diem_burn_now_$def$0$anon22_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon33_Then_correct  (=> (= (ControlFlow 0 159043) 159035) inline$$Diem_burn_now_$def$0$anon22_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$9$to'@1|) ($Local 7))) (= |inline$$WritebackToValue$2$vdst'@2| inline$$ReadRef$1$v@1)) (and (=> (= (ControlFlow 0 158991) 159043) inline$$Diem_burn_now_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 158991) 159033) inline$$Diem_burn_now_$def$0$anon33_Else_correct)))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$9$to'@1|) ($Local 7)) (=> (and (= |inline$$WritebackToValue$2$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$9$to'@1|) 0 inline$$ReadRef$1$v@1 (|v#$Mutation| |inline$$WriteRef$9$to'@1|))) (= |inline$$WritebackToValue$2$vdst'@2| |inline$$WritebackToValue$2$vdst'@1|)) (and (=> (= (ControlFlow 0 159017) 159043) inline$$Diem_burn_now_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 159017) 159033) inline$$Diem_burn_now_$def$0$anon33_Else_correct))))))
(let ((inline$$WriteRef$9$anon0_correct  (=> (= |inline$$WriteRef$9$to'@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$4$to'@1|) (|p#$Mutation| |inline$$WriteRef$4$to'@1|) inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2)) (and (=> (= (ControlFlow 0 158892) 159017) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 158892) 158991) inline$$WritebackToValue$2$anon3_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon32_Else_correct  (=> (and (not $abort_flag@32) (= (ControlFlow 0 158898) 158892)) inline$$WriteRef$9$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$Abort_correct  (=> (= inline$$Diem_burn_now_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$Diem_burn_now_$def$0$$ret0@2 inline$$Diem_burn_now_$def$0$$ret0@1) (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5)) (and (= $abort_flag@33 true) (= $abort_code@45 $abort_code@44))) (and (=> (= (ControlFlow 0 143982) 160884) inline$$TransactionFee_burn_fees_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 143982) 159182) inline$$TransactionFee_burn_fees_$def_verify$0$anon79_Else_correct))))))
(let ((inline$$Diem_burn_now_$def$0$anon11_correct  (=> (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory) (=> (and (= $abort_code@44 $abort_code@15@@0) (= (ControlFlow 0 159063) 143982)) inline$$Diem_burn_now_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 159061) 159063)) inline$$Diem_burn_now_$def$0$anon11_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 159071) 159063) inline$$Diem_burn_now_$def$0$anon11_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon27_Then_correct  (=> $abort_flag@12@@0 (and (=> (= (ControlFlow 0 159055) 159071) inline$$Diem_burn_now_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 159055) 159061) inline$$Diem_burn_now_$def$0$anon28_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon32_Then_correct  (=> (and (and $abort_flag@32 (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@4)) (and (= $abort_code@44 $abort_code@43) (= (ControlFlow 0 159047) 143982))) inline$$Diem_burn_now_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@2) (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2|)) (and (= $abort_code@43 $abort_code@41) (= $abort_flag@32 $abort_flag@31))) (and (=> (= (ControlFlow 0 157376) 159047) inline$$Diem_burn_now_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 157376) 158898) inline$$Diem_burn_now_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct  (=> (and (not true) (= (ControlFlow 0 157374) 157376)) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct  (=> (= (ControlFlow 0 157384) 157376) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct  (=> (= $Diem_CurrencyInfo_$memory@2 |inline$$WritebackToGlobal$4$m'@2|) (and (=> (= (ControlFlow 0 158503) 157384) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct) (=> (= (ControlFlow 0 158503) 157374) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct)))))
(let ((inline$$WritebackToGlobal$4$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$4$l@1)) (=> (and (= |inline$$WritebackToGlobal$4$m'@2| $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158441) 158503)) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct))))
(let ((inline$$WritebackToGlobal$4$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$4$l@1) (=> (and (= inline$$WritebackToGlobal$4$ta@1 (|ts#$Global| inline$$WritebackToGlobal$4$l@1)) (= inline$$WritebackToGlobal$4$a@1 (|a#$Global| inline$$WritebackToGlobal$4$l@1))) (=> (and (and (= inline$$WritebackToGlobal$4$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$7$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1) (|v#$Mutation| |inline$$WritebackToReference$7$dst'@2|))) (= |inline$$WritebackToGlobal$4$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1 inline$$WritebackToGlobal$4$v@1)))) (and (= |inline$$WritebackToGlobal$4$m'@2| |inline$$WritebackToGlobal$4$m'@1|) (= (ControlFlow 0 158495) 158503))) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct)))))
(let ((inline$$WritebackToGlobal$4$anon0_correct  (=> (= inline$$WritebackToGlobal$4$l@1 (|l#$Mutation| |inline$$WritebackToReference$7$dst'@2|)) (and (=> (= (ControlFlow 0 158431) 158495) inline$$WritebackToGlobal$4$anon3_Then_correct) (=> (= (ControlFlow 0 158431) 158441) inline$$WritebackToGlobal$4$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$6$anon0_correct  (and (=> (= (ControlFlow 0 158311) (- 0 193235)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 158311) 158431) inline$$WritebackToGlobal$4$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$6$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0 (|v#$Mutation| |inline$$WritebackToReference$7$dst'@2|)) (= (ControlFlow 0 158263) 158311)) inline$$Diem_CurrencyInfo_$pack_ref$6$anon0_correct)))
(let ((inline$$WritebackToReference$7$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) (|l#$Mutation| |inline$$WriteRef$8$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$7$dstPath@1) (|size#$Path| inline$$WritebackToReference$7$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$7$dstPath@1 inline$$WritebackToReference$7$srcPath@1))) (=> (and (= |inline$$WritebackToReference$7$dst'@2| |inline$$WritebackToReference$6$dst'@2|) (= (ControlFlow 0 158132) 158263)) inline$$Diem_CurrencyInfo_$pack_ref$6$Entry_correct))))
(let ((inline$$WritebackToReference$7$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) (|l#$Mutation| |inline$$WriteRef$8$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$7$dstPath@1) (|size#$Path| inline$$WritebackToReference$7$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$7$dstPath@1 inline$$WritebackToReference$7$srcPath@1)) (= |inline$$WritebackToReference$7$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) inline$$WritebackToReference$7$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$7$srcPath@1 (|size#$Path| inline$$WritebackToReference$7$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|) (|v#$Mutation| |inline$$WriteRef$8$to'@1|))))) (and (= |inline$$WritebackToReference$7$dst'@2| |inline$$WritebackToReference$7$dst'@1|) (= (ControlFlow 0 158188) 158263))) inline$$Diem_CurrencyInfo_$pack_ref$6$Entry_correct)))
(let ((inline$$WritebackToReference$7$anon0_correct  (=> (and (= inline$$WritebackToReference$7$srcPath@1 (|p#$Mutation| |inline$$WriteRef$8$to'@1|)) (= inline$$WritebackToReference$7$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|))) (and (=> (= (ControlFlow 0 158096) 158188) inline$$WritebackToReference$7$anon3_Then_correct) (=> (= (ControlFlow 0 158096) 158132) inline$$WritebackToReference$7$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct  (=> (and (not true) (= (ControlFlow 0 157959) 158096)) inline$$WritebackToReference$7$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4 (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (= (ControlFlow 0 158513) 158096)) inline$$WritebackToReference$7$anon0_correct)))
(let ((inline$$WriteRef$8$anon0_correct  (=> (= |inline$$WriteRef$8$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$18$dst@1) (|p#$Mutation| inline$$BorrowField$18$dst@1) inline$$ReadRef$17$v@1)) (and (=> (= (ControlFlow 0 157945) 158513) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct) (=> (= (ControlFlow 0 157945) 157959) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct  (=> (and (not $abort_flag@31) (= (ControlFlow 0 157951) 157945)) inline$$WriteRef$8$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct  (=> (= $Diem_CurrencyInfo_$memory@2 |inline$$WritebackToGlobal$3$m'@2|) (and (=> (= (ControlFlow 0 157364) 157384) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct) (=> (= (ControlFlow 0 157364) 157374) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct)))))
(let ((inline$$WritebackToGlobal$3$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$3$l@1)) (=> (and (= |inline$$WritebackToGlobal$3$m'@2| $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 157302) 157364)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct))))
(let ((inline$$WritebackToGlobal$3$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$3$l@1) (=> (and (= inline$$WritebackToGlobal$3$ta@1 (|ts#$Global| inline$$WritebackToGlobal$3$l@1)) (= inline$$WritebackToGlobal$3$a@1 (|a#$Global| inline$$WritebackToGlobal$3$l@1))) (=> (and (and (= inline$$WritebackToGlobal$3$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1) (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|))) (= |inline$$WritebackToGlobal$3$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1 inline$$WritebackToGlobal$3$v@1)))) (and (= |inline$$WritebackToGlobal$3$m'@2| |inline$$WritebackToGlobal$3$m'@1|) (= (ControlFlow 0 157356) 157364))) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$3$anon0_correct  (=> (= inline$$WritebackToGlobal$3$l@1 (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (and (=> (= (ControlFlow 0 157292) 157356) inline$$WritebackToGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 157292) 157302) inline$$WritebackToGlobal$3$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$5$anon0_correct  (and (=> (= (ControlFlow 0 157172) (- 0 192683)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 157172) 157292) inline$$WritebackToGlobal$3$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$5$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0 (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (= (ControlFlow 0 157124) 157172)) inline$$Diem_CurrencyInfo_$pack_ref$5$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= (ControlFlow 0 157176) 157124)) inline$$Diem_CurrencyInfo_$pack_ref$5$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct  (=> (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1 $Error) (=> (and (and (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@3) (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2 inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1)) (and (= $abort_code@43 $abort_code@42) (= $abort_flag@32 true))) (and (=> (= (ControlFlow 0 152747) 159047) inline$$Diem_burn_now_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 152747) 158898) inline$$Diem_burn_now_$def$0$anon32_Else_correct))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct  (=> (= $abort_code@42 $abort_code@28) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158787) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 158785) 158787)) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 158795) 158787) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct  (=> $abort_flag@21 (and (=> (= (ControlFlow 0 158779) 158795) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 158779) 158785) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct  (=> (= $abort_code@42 $abort_code@29) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158767) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 158765) 158767)) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct  (=> (= (ControlFlow 0 158775) 158767) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct  (=> $abort_flag@22 (and (=> (= (ControlFlow 0 158759) 158775) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 158759) 158765) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct  (=> (= $abort_code@42 $abort_code@31) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158747) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 158745) 158747)) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct  (=> (= (ControlFlow 0 158755) 158747) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct  (=> $abort_flag@23 (and (=> (= (ControlFlow 0 158739) 158755) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 158739) 158745) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct  (=> (= $abort_code@42 $abort_code@32) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158709) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 158707) 158709)) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct  (=> (= (ControlFlow 0 158717) 158709) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct  (=> $abort_flag@24 (and (=> (= (ControlFlow 0 158701) 158717) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct) (=> (= (ControlFlow 0 158701) 158707) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct  (=> (= $abort_code@42 $abort_code@33) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158685) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct  (=> (and (not true) (= (ControlFlow 0 158683) 158685)) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct  (=> (= (ControlFlow 0 158693) 158685) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct  (=> $abort_flag@25 (and (=> (= (ControlFlow 0 158677) 158693) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct) (=> (= (ControlFlow 0 158677) 158683) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct  (=> (= $abort_code@42 $abort_code@34) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158665) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct  (=> (and (not true) (= (ControlFlow 0 158663) 158665)) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct  (=> (= (ControlFlow 0 158673) 158665) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct  (=> $abort_flag@26 (and (=> (= (ControlFlow 0 158657) 158673) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct) (=> (= (ControlFlow 0 158657) 158663) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct  (=> (= $abort_code@42 $abort_code@35) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158645) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct  (=> (and (not true) (= (ControlFlow 0 158643) 158645)) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct  (=> (= (ControlFlow 0 158653) 158645) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct  (=> $abort_flag@27 (and (=> (= (ControlFlow 0 158637) 158653) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct) (=> (= (ControlFlow 0 158637) 158643) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct  (=> (= $abort_code@42 $abort_code@37) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158625) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct  (=> (and (not true) (= (ControlFlow 0 158623) 158625)) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct  (=> (= (ControlFlow 0 158633) 158625) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct  (=> $abort_flag@28 (and (=> (= (ControlFlow 0 158617) 158633) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct) (=> (= (ControlFlow 0 158617) 158623) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct  (=> (= $abort_code@42 $abort_code@38) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158605) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct  (=> (and (not true) (= (ControlFlow 0 158603) 158605)) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct  (=> (= (ControlFlow 0 158613) 158605) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct  (=> $abort_flag@29 (and (=> (= (ControlFlow 0 158597) 158613) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct) (=> (= (ControlFlow 0 158597) 158603) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct  (=> (= $abort_code@42 $abort_code@39) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158575) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct  (=> (and (not true) (= (ControlFlow 0 158573) 158575)) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct  (=> (= (ControlFlow 0 158583) 158575) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct  (=> $abort_flag@30 (and (=> (= (ControlFlow 0 158567) 158583) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 158567) 158573) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct  (=> (= $abort_code@42 $abort_code@41) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158555) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct  (=> (and (not true) (= (ControlFlow 0 158553) 158555)) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct  (=> (= (ControlFlow 0 158563) 158555) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct  (=> $abort_flag@31 (and (=> (= (ControlFlow 0 158547) 158563) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct) (=> (= (ControlFlow 0 158547) 158553) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct  (=> (= $abort_code@42 $abort_code@41) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158525) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct  (=> (and (not true) (= (ControlFlow 0 158523) 158525)) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct  (=> (= (ControlFlow 0 158533) 158525) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct  (=> $abort_flag@31 (and (=> (= (ControlFlow 0 158517) 158533) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct) (=> (= (ControlFlow 0 158517) 158523) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct)))))
(let ((inline$$Event_emit_event$1$Entry_correct  (=> (= inline$$Event_emit_event$1$t@0 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 157876) 158517) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct) (=> (= (ControlFlow 0 157876) 157951) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct  (and (=> (= (ControlFlow 0 157886) (- 0 193038)) true) (=> (= (ControlFlow 0 157886) 157876) inline$$Event_emit_event$1$Entry_correct))))
(let ((inline$$ReadRef$17$anon0_correct  (=> (and (= inline$$ReadRef$17$v@1 (|v#$Mutation| inline$$BorrowField$18$dst@1)) (= (ControlFlow 0 157828) 157886)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 157784) 157828)) inline$$ReadRef$17$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 157790) 157828) inline$$ReadRef$17$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 157778) 157790) inline$$Diem_BurnEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 157778) 157784) inline$$Diem_BurnEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 157770) 157828)) inline$$ReadRef$17$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@5) (let ((va@@54 (|v#$Vector| call3formal@$ret0@0@@5)))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
)))))) (forall ((inline$$Diem_BurnEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_BurnEvent_pack$0$$$0 0) (< inline$$Diem_BurnEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) inline$$Diem_BurnEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) inline$$Diem_BurnEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) inline$$Diem_BurnEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) inline$$Diem_BurnEvent_pack$0$$$0))
))) (and ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) (= inline$$Diem_BurnEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_Diem_unpack$0$value@1) 1 call3formal@$ret0@0@@5) 2 inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) 3))))) (and (=> (= (ControlFlow 0 157762) 157778) inline$$Diem_BurnEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 157762) 157770) inline$$Diem_BurnEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$18$anon0_correct  (=> (= inline$$BorrowField$18$p@1 (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (=> (and (and (= inline$$BorrowField$18$size@1 (|size#$Path| inline$$BorrowField$18$p@1)) (= inline$$BorrowField$18$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$18$p@1) inline$$BorrowField$18$size@1 $Diem_CurrencyInfo_burn_events) (+ inline$$BorrowField$18$size@1 1)))) (and (= inline$$BorrowField$18$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) inline$$BorrowField$18$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|))) $Diem_CurrencyInfo_burn_events))) (= (ControlFlow 0 157506) 157762))) inline$$Diem_BurnEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 157512) 157506)) inline$$BorrowField$18$anon0_correct)))
(let ((inline$$Not$1$anon0_correct  (=> (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$16$v@1)))) (and (=> (= (ControlFlow 0 157041) 157512) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct) (=> (= (ControlFlow 0 157041) 157176) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct)))))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 157031) (- 0 192644)) true) (=> (= (ControlFlow 0 157031) 157041) inline$$Not$1$anon0_correct))))
(let ((inline$$ReadRef$16$anon0_correct  (=> (and (= inline$$ReadRef$16$v@1 (|v#$Mutation| inline$$BorrowField$17$dst@1)) (= (ControlFlow 0 156983) 157031)) inline$$Not$1$Entry_correct)))
(let ((inline$$BorrowField$17$anon0_correct  (=> (= inline$$BorrowField$17$p@1 (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (=> (and (and (= inline$$BorrowField$17$size@1 (|size#$Path| inline$$BorrowField$17$p@1)) (= inline$$BorrowField$17$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$17$p@1) inline$$BorrowField$17$size@1 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$17$size@1 1)))) (and (= inline$$BorrowField$17$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) inline$$BorrowField$17$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 156945) 156983))) inline$$ReadRef$16$anon0_correct))))
(let ((inline$$WritebackToReference$6$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) (|l#$Mutation| |inline$$WriteRef$7$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|size#$Path| inline$$WritebackToReference$6$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$6$dstPath@1 inline$$WritebackToReference$6$srcPath@1))) (=> (and (= |inline$$WritebackToReference$6$dst'@2| |inline$$WritebackToReference$5$dst'@2|) (= (ControlFlow 0 156729) 156945)) inline$$BorrowField$17$anon0_correct))))
(let ((inline$$WritebackToReference$6$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) (|l#$Mutation| |inline$$WriteRef$7$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|size#$Path| inline$$WritebackToReference$6$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$6$dstPath@1 inline$$WritebackToReference$6$srcPath@1)) (= |inline$$WritebackToReference$6$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$WritebackToReference$6$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$6$srcPath@1 (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|) (|v#$Mutation| |inline$$WriteRef$7$to'@1|))))) (and (= |inline$$WritebackToReference$6$dst'@2| |inline$$WritebackToReference$6$dst'@1|) (= (ControlFlow 0 156785) 156945))) inline$$BorrowField$17$anon0_correct)))
(let ((inline$$WritebackToReference$6$anon0_correct  (=> (and (= inline$$WritebackToReference$6$srcPath@1 (|p#$Mutation| |inline$$WriteRef$7$to'@1|)) (= inline$$WritebackToReference$6$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) (and (=> (= (ControlFlow 0 156693) 156785) inline$$WritebackToReference$6$anon3_Then_correct) (=> (= (ControlFlow 0 156693) 156729) inline$$WritebackToReference$6$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct  (=> (and (not true) (= (ControlFlow 0 156556) 156693)) inline$$WritebackToReference$6$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (= (ControlFlow 0 158543) 156693)) inline$$WritebackToReference$6$anon0_correct)))
(let ((inline$$WriteRef$7$anon0_correct  (=> (= |inline$$WriteRef$7$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$16$dst@1) (|p#$Mutation| inline$$BorrowField$16$dst@1) inline$$Sub$2$dst@2)) (and (=> (= (ControlFlow 0 156542) 158543) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct) (=> (= (ControlFlow 0 156542) 156556) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct)))))
(let ((inline$$BorrowField$16$anon0_correct  (=> (= inline$$BorrowField$16$p@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (=> (and (and (= inline$$BorrowField$16$size@1 (|size#$Path| inline$$BorrowField$16$p@1)) (= inline$$BorrowField$16$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$16$p@1) inline$$BorrowField$16$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$16$size@1 1)))) (and (= inline$$BorrowField$16$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$BorrowField$16$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 156483) 156542))) inline$$WriteRef$7$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct  (=> (and (not $abort_flag@31) (= (ControlFlow 0 156489) 156483)) inline$$BorrowField$16$anon0_correct)))
(let ((inline$$Sub$2$anon3_Then$1_correct  (=> (= $abort_flag@31 true) (=> (and (= $abort_code@41 $EXEC_FAILURE_CODE) (= inline$$Sub$2$dst@2 inline$$Sub$2$dst@0)) (and (=> (= (ControlFlow 0 156353) 158547) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct) (=> (= (ControlFlow 0 156353) 156489) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct))))))
(let ((inline$$Sub$2$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$15$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)) (= (ControlFlow 0 156351) 156353)) inline$$Sub$2$anon3_Then$1_correct)))
(let ((inline$$Sub$2$anon3_Else_correct  (=> (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) (|i#$Integer| inline$$ReadRef$15$v@1)) (=> (and (and (= inline$$Sub$2$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$15$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)))) (= $abort_flag@31 $abort_flag@30)) (and (= $abort_code@41 $abort_code@39) (= inline$$Sub$2$dst@2 inline$$Sub$2$dst@1))) (and (=> (= (ControlFlow 0 156299) 158547) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct) (=> (= (ControlFlow 0 156299) 156489) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct))))))
(let ((inline$$Sub$2$Entry_correct  (and (=> (= (ControlFlow 0 156273) (- 0 192226)) true) (and (=> (= (ControlFlow 0 156273) 156351) inline$$Sub$2$anon3_Then_correct) (=> (= (ControlFlow 0 156273) 156299) inline$$Sub$2$anon3_Else_correct)))))
(let ((inline$$ReadRef$15$anon0_correct  (=> (and (= inline$$ReadRef$15$v@1 (|v#$Mutation| inline$$BorrowField$15$dst@1)) (= (ControlFlow 0 156174) 156273)) inline$$Sub$2$Entry_correct)))
(let ((inline$$BorrowField$15$anon0_correct  (=> (= inline$$BorrowField$15$p@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (=> (and (and (= inline$$BorrowField$15$size@1 (|size#$Path| inline$$BorrowField$15$p@1)) (= inline$$BorrowField$15$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$15$p@1) inline$$BorrowField$15$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$15$size@1 1)))) (and (= inline$$BorrowField$15$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$BorrowField$15$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 156136) 156174))) inline$$ReadRef$15$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$2$dst@1) (= (ControlFlow 0 156188) 156136)) inline$$BorrowField$15$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct  (=> (= $abort_code@42 $abort_code@40) (=> (and (= $Diem_CurrencyInfo_$memory@3 |inline$$WritebackToGlobal$2$m'@2|) (= (ControlFlow 0 155970) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct  (=> (and (not true) (= (ControlFlow 0 155968) 155970)) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct  (=> (= (ControlFlow 0 155978) 155970) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct  (=> (= $abort_code@40 (|i#$Integer| call3formal@$ret0@0@@6)) (and (=> (= (ControlFlow 0 155962) 155978) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct) (=> (= (ControlFlow 0 155962) 155968) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct)))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2| $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 155896) 155962)) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1) (=> (and (= inline$$WritebackToGlobal$2$ta@1 (|ts#$Global| inline$$WritebackToGlobal$2$l@1)) (= inline$$WritebackToGlobal$2$a@1 (|a#$Global| inline$$WritebackToGlobal$2$l@1))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1) (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) (= |inline$$WritebackToGlobal$2$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1 inline$$WritebackToGlobal$2$v@1)))) (and (= |inline$$WritebackToGlobal$2$m'@2| |inline$$WritebackToGlobal$2$m'@1|) (= (ControlFlow 0 155950) 155962))) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct  (=> (= inline$$WritebackToGlobal$2$l@1 (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (and (=> (= (ControlFlow 0 155886) 155950) inline$$WritebackToGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 155886) 155896) inline$$WritebackToGlobal$2$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$4$anon0_correct  (and (=> (= (ControlFlow 0 155766) (- 0 191949)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 155766) 155886) inline$$WritebackToGlobal$2$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$4$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0 (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (= (ControlFlow 0 155718) 155766)) inline$$Diem_CurrencyInfo_$pack_ref$4$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$2$dst@1)) (= (ControlFlow 0 155770) 155718)) inline$$Diem_CurrencyInfo_$pack_ref$4$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct  (=> (not $abort_flag@30) (and (=> (= (ControlFlow 0 155643) 156188) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct) (=> (= (ControlFlow 0 155643) 155770) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t36@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@30)) (and (=> $abort_flag@30 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 155637) 158567) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct) (=> (= (ControlFlow 0 155637) 155643) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct)))))
(let ((inline$$Ge$2$anon0_correct  (=> (and (= inline$$Ge$2$dst@1 ($Boolean (>= (|i#$Integer| inline$$ReadRef$14$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)))) (= (ControlFlow 0 155625) 155637)) inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct)))
(let ((inline$$Ge$2$Entry_correct  (and (=> (= (ControlFlow 0 155611) (- 0 191839)) true) (=> (= (ControlFlow 0 155611) 155625) inline$$Ge$2$anon0_correct))))
(let ((inline$$ReadRef$14$anon0_correct  (=> (and (= inline$$ReadRef$14$v@1 (|v#$Mutation| inline$$BorrowField$14$dst@1)) (= (ControlFlow 0 155553) 155611)) inline$$Ge$2$Entry_correct)))
(let ((inline$$BorrowField$14$anon0_correct  (=> (= inline$$BorrowField$14$p@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (=> (and (and (= inline$$BorrowField$14$size@1 (|size#$Path| inline$$BorrowField$14$p@1)) (= inline$$BorrowField$14$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$14$p@1) inline$$BorrowField$14$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$14$size@1 1)))) (and (= inline$$BorrowField$14$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$BorrowField$14$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 155515) 155553))) inline$$ReadRef$14$anon0_correct))))
(let ((inline$$WritebackToReference$5$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) (|l#$Mutation| |inline$$WriteRef$6$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1))) (=> (and (= |inline$$WritebackToReference$5$dst'@2| inline$$BorrowGlobal$2$dst@2) (= (ControlFlow 0 155299) 155515)) inline$$BorrowField$14$anon0_correct))))
(let ((inline$$WritebackToReference$5$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) (|l#$Mutation| |inline$$WriteRef$6$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1)) (= |inline$$WritebackToReference$5$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$WritebackToReference$5$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$5$srcPath@1 (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$2$dst@2) (|v#$Mutation| |inline$$WriteRef$6$to'@1|))))) (and (= |inline$$WritebackToReference$5$dst'@2| |inline$$WritebackToReference$5$dst'@1|) (= (ControlFlow 0 155355) 155515))) inline$$BorrowField$14$anon0_correct)))
(let ((inline$$WritebackToReference$5$anon0_correct  (=> (and (= inline$$WritebackToReference$5$srcPath@1 (|p#$Mutation| |inline$$WriteRef$6$to'@1|)) (= inline$$WritebackToReference$5$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2))) (and (=> (= (ControlFlow 0 155263) 155355) inline$$WritebackToReference$5$anon3_Then_correct) (=> (= (ControlFlow 0 155263) 155299) inline$$WritebackToReference$5$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 155126) 155263)) inline$$WritebackToReference$5$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 158593) 155263)) inline$$WritebackToReference$5$anon0_correct)))
(let ((inline$$WriteRef$6$anon0_correct  (=> (= |inline$$WriteRef$6$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$13$dst@1) (|p#$Mutation| inline$$BorrowField$13$dst@1) inline$$Sub$1$dst@2)) (and (=> (= (ControlFlow 0 155112) 158593) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct) (=> (= (ControlFlow 0 155112) 155126) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct)))))
(let ((inline$$BorrowField$13$anon0_correct  (=> (= inline$$BorrowField$13$p@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2)) (=> (and (and (= inline$$BorrowField$13$size@1 (|size#$Path| inline$$BorrowField$13$p@1)) (= inline$$BorrowField$13$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$13$p@1) inline$$BorrowField$13$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$13$size@1 1)))) (and (= inline$$BorrowField$13$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$BorrowField$13$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 155053) 155112))) inline$$WriteRef$6$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct  (=> (and (not $abort_flag@29) (= (ControlFlow 0 155059) 155053)) inline$$BorrowField$13$anon0_correct)))
(let ((inline$$Sub$1$anon3_Then$1_correct  (=> (= $abort_code@38 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@29 true) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@0)) (and (=> (= (ControlFlow 0 154923) 158597) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct) (=> (= (ControlFlow 0 154923) 155059) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct))))))
(let ((inline$$Sub$1$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$13$v@1) (|i#$Integer| inline$$CastU128$1$dst@1)) (= (ControlFlow 0 154921) 154923)) inline$$Sub$1$anon3_Then$1_correct)))
(let ((inline$$Sub$1$anon3_Else_correct  (=> (<= (|i#$Integer| inline$$CastU128$1$dst@1) (|i#$Integer| inline$$ReadRef$13$v@1)) (=> (and (and (= inline$$Sub$1$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$13$v@1) (|i#$Integer| inline$$CastU128$1$dst@1)))) (= $abort_code@38 $abort_code@37)) (and (= $abort_flag@29 $abort_flag@28) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@1))) (and (=> (= (ControlFlow 0 154869) 158597) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct) (=> (= (ControlFlow 0 154869) 155059) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct))))))
(let ((inline$$Sub$1$Entry_correct  (and (=> (= (ControlFlow 0 154843) (- 0 191419)) true) (and (=> (= (ControlFlow 0 154843) 154921) inline$$Sub$1$anon3_Then_correct) (=> (= (ControlFlow 0 154843) 154869) inline$$Sub$1$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct  (=> (and (not $abort_flag@28) (= (ControlFlow 0 154929) 154843)) inline$$Sub$1$Entry_correct)))
(let ((inline$$CastU128$1$anon3_Then$1_correct  (=> (= $abort_flag@28 true) (=> (and (= $abort_code@37 $EXEC_FAILURE_CODE) (= inline$$CastU128$1$dst@1 inline$$CastU128$1$dst@0)) (and (=> (= (ControlFlow 0 154746) 158617) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct) (=> (= (ControlFlow 0 154746) 154929) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct))))))
(let ((inline$$CastU128$1$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U128) (= (ControlFlow 0 154744) 154746)) inline$$CastU128$1$anon3_Then$1_correct)))
(let ((inline$$CastU128$1$anon3_Else_correct  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)) (= $abort_flag@28 $abort_flag@27)) (and (= $abort_code@37 $abort_code@35) (= inline$$CastU128$1$dst@1 inline$$Diem_Diem_unpack$0$value@1))) (and (=> (= (ControlFlow 0 154694) 158617) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct) (=> (= (ControlFlow 0 154694) 154929) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct)))))
(let ((inline$$CastU128$1$Entry_correct  (and (=> (= (ControlFlow 0 154680) (- 0 191347)) true) (and (=> (= (ControlFlow 0 154680) 154744) inline$$CastU128$1$anon3_Then_correct) (=> (= (ControlFlow 0 154680) 154694) inline$$CastU128$1$anon3_Else_correct)))))
(let ((inline$$ReadRef$13$anon0_correct  (=> (and (= inline$$ReadRef$13$v@1 (|v#$Mutation| inline$$BorrowField$12$dst@1)) (= (ControlFlow 0 154599) 154680)) inline$$CastU128$1$Entry_correct)))
(let ((inline$$BorrowField$12$anon0_correct  (=> (= inline$$BorrowField$12$p@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2)) (=> (and (and (= inline$$BorrowField$12$size@1 (|size#$Path| inline$$BorrowField$12$p@1)) (= inline$$BorrowField$12$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$12$p@1) inline$$BorrowField$12$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$12$size@1 1)))) (and (= inline$$BorrowField$12$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$BorrowField$12$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 154561) 154599))) inline$$ReadRef$13$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$1$dst@1) (= (ControlFlow 0 154613) 154561)) inline$$BorrowField$12$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct  (=> (= $abort_code@42 $abort_code@36) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 154395) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct  (=> (and (not true) (= (ControlFlow 0 154393) 154395)) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct  (=> (= (ControlFlow 0 154403) 154395) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct  (=> (= $abort_code@36 (|i#$Integer| call3formal@$ret0@0@@7)) (and (=> (= (ControlFlow 0 154387) 154403) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct) (=> (= (ControlFlow 0 154387) 154393) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct  (and (=> (= (ControlFlow 0 154377) (- 0 191181)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 154377) 154387) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 154329) 154377)) inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$1$dst@1)) (= (ControlFlow 0 154381) 154329)) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct  (=> (not $abort_flag@27) (and (=> (= (ControlFlow 0 154254) 154613) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct) (=> (= (ControlFlow 0 154254) 154381) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t28@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@27)) (and (=> $abort_flag@27 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@27) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 154248) 158637) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct) (=> (= (ControlFlow 0 154248) 154254) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct)))))
(let ((inline$$Ge$1$anon0_correct  (=> (and (= inline$$Ge$1$dst@1 ($Boolean (>= (|i#$Integer| inline$$ReadRef$12$v@1) (|i#$Integer| inline$$CastU128$0$dst@1)))) (= (ControlFlow 0 154236) 154248)) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct)))
(let ((inline$$Ge$1$Entry_correct  (and (=> (= (ControlFlow 0 154222) (- 0 191071)) true) (=> (= (ControlFlow 0 154222) 154236) inline$$Ge$1$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct  (=> (and (not $abort_flag@26) (= (ControlFlow 0 154242) 154222)) inline$$Ge$1$Entry_correct)))
(let ((inline$$CastU128$0$anon3_Then$1_correct  (=> (= $abort_code@34 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@26 true) (= inline$$CastU128$0$dst@1 inline$$CastU128$0$dst@0)) (and (=> (= (ControlFlow 0 154166) 158657) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct) (=> (= (ControlFlow 0 154166) 154242) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct))))))
(let ((inline$$CastU128$0$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U128) (= (ControlFlow 0 154164) 154166)) inline$$CastU128$0$anon3_Then$1_correct)))
(let ((inline$$CastU128$0$anon3_Else_correct  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)) (= $abort_code@34 $abort_code@33)) (and (= $abort_flag@26 $abort_flag@25) (= inline$$CastU128$0$dst@1 inline$$Diem_Diem_unpack$0$value@1))) (and (=> (= (ControlFlow 0 154114) 158657) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct) (=> (= (ControlFlow 0 154114) 154242) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct)))))
(let ((inline$$CastU128$0$Entry_correct  (and (=> (= (ControlFlow 0 154100) (- 0 190999)) true) (and (=> (= (ControlFlow 0 154100) 154164) inline$$CastU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 154100) 154114) inline$$CastU128$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$12$anon0_correct  (=> (and (= inline$$ReadRef$12$v@1 (|v#$Mutation| inline$$BorrowField$11$dst@1)) (= (ControlFlow 0 154019) 154100)) inline$$CastU128$0$Entry_correct)))
(let ((inline$$BorrowField$11$anon0_correct  (=> (= inline$$BorrowField$11$p@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2)) (=> (and (and (= inline$$BorrowField$11$size@1 (|size#$Path| inline$$BorrowField$11$p@1)) (= inline$$BorrowField$11$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$11$p@1) inline$$BorrowField$11$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$11$size@1 1)))) (and (= inline$$BorrowField$11$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$BorrowField$11$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 153981) 154019))) inline$$ReadRef$12$anon0_correct))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$1$anon0_correct  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 153823) 153981)) inline$$BorrowField$11$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$1$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 153817) 153823)) inline$$Diem_CurrencyInfo_$unpack_ref$1$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct  (=> (and (not $abort_flag@25) (= (ControlFlow 0 153827) 153817)) inline$$Diem_CurrencyInfo_$unpack_ref$1$Entry_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Then$1_correct  (=> (= $abort_flag@25 true) (=> (and (= $abort_code@33 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@0)) (and (=> (= (ControlFlow 0 153777) 158677) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 153777) 153827) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct))))))
(let ((inline$$BorrowGlobal$2$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1)) (= (ControlFlow 0 153775) 153777)) inline$$BorrowGlobal$2$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1) (=> (and (and (= inline$$BorrowGlobal$2$dst@1 ($Mutation ($Global inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1))) (= $abort_flag@25 $abort_flag@24)) (and (= $abort_code@33 $abort_code@32) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@1))) (and (=> (= (ControlFlow 0 153723) 158677) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 153723) 153827) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct))))))
(let ((inline$$BorrowGlobal$2$anon0_correct  (=> (= inline$$BorrowGlobal$2$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 153693) 153775) inline$$BorrowGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 153693) 153723) inline$$BorrowGlobal$2$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$2$Entry_correct  (=> (= inline$$BorrowGlobal$2$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1)) (and (=> (= (ControlFlow 0 153687) (- 0 190786)) true) (=> (= (ControlFlow 0 153687) 153693) inline$$BorrowGlobal$2$anon0_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct  (=> (and (not $abort_flag@24) (= (ControlFlow 0 153783) 153687)) inline$$BorrowGlobal$2$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct  (=> (and (and $abort_flag@24 (= $abort_code@42 $abort_code@32)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 158697) 152747))) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 153544) 158697) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 153544) 153783) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 153554) 158697) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 153554) 153783) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@24) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 153538) 153554) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 153538) 153544) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct  (=> (and (not $abort_flag@24) (= (ControlFlow 0 153568) 153538)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@24) (=> (and (=> $abort_flag@24 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@24 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@32 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 153433) 158701) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 153433) 153568) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 153431) 153433)) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct  (=> (= (ControlFlow 0 158725) 153433) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct)))
(let ((inline$$Diem_Diem_unpack$0$anon0_correct  (=> (and ((_ is $Vector) call4formal@$ret0@0) (= inline$$Diem_Diem_unpack$0$value@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value))) (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U64)) (and (=> (= (ControlFlow 0 153417) 158725) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 153417) 153431) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct))))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) ($Local 12))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| inline$$ReadRef$9$v@1) (= (ControlFlow 0 153326) 153417)) inline$$Diem_Diem_unpack$0$anon0_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) ($Local 12)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|) 0 inline$$ReadRef$9$v@1 (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 153352) 153417))) inline$$Diem_Diem_unpack$0$anon0_correct)))
(let ((inline$$WritebackToReference$4$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1))) (= |inline$$WritebackToReference$4$dst'@2| inline$$BorrowLoc$2$dst@1)) (and (=> (= (ControlFlow 0 153171) 153352) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 153171) 153326) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$4$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1)) (and (= |inline$$WritebackToReference$4$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$WritebackToReference$4$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$4$srcPath@1 (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$2$dst@1) (|v#$Mutation| |inline$$WriteRef$5$to'@1|)))) (= |inline$$WritebackToReference$4$dst'@2| |inline$$WritebackToReference$4$dst'@1|))) (and (=> (= (ControlFlow 0 153227) 153352) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 153227) 153326) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$4$anon0_correct  (=> (and (= inline$$WritebackToReference$4$srcPath@1 (|p#$Mutation| |inline$$WriteRef$5$to'@1|)) (= inline$$WritebackToReference$4$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$2$dst@1))) (and (=> (= (ControlFlow 0 153135) 153227) inline$$WritebackToReference$4$anon3_Then_correct) (=> (= (ControlFlow 0 153135) 153171) inline$$WritebackToReference$4$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 152998) 153135)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_burn_with_resource_cap_$def$0$info@0)) (= (ControlFlow 0 158735) 153135)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$WriteRef$5$anon0_correct  (=> (= |inline$$WriteRef$5$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$10$dst@1) (|p#$Mutation| inline$$BorrowField$10$dst@1) call5formal@$ret1@0)) (and (=> (= (ControlFlow 0 152984) 158735) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 152984) 152998) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct  (=> (and (not $abort_flag@23) (= (ControlFlow 0 152990) 152984)) inline$$WriteRef$5$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct  (and (=> (= (ControlFlow 0 152927) (- 0 190292)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@23) (=> $abort_flag@23 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@23) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$11$v@1)) $Diem_Diem_value))))) (=> (not $abort_flag@23) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value) ($Integer 0))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0) (let ((va@@55 (|v#$Vector| call4formal@$ret0@0)))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0) (let ((va@@56 (|v#$Vector| call5formal@$ret1@0)))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 152927) 158739) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 152927) 152990) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct)))))))
(let ((inline$$ReadRef$11$anon0_correct  (=> (and (= inline$$ReadRef$11$v@1 (|v#$Mutation| inline$$BorrowField$10$dst@1)) (= (ControlFlow 0 152915) 152927)) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct)))
(let ((inline$$BorrowField$10$anon0_correct  (=> (= inline$$BorrowField$10$p@1 (|p#$Mutation| inline$$BorrowLoc$2$dst@1)) (=> (and (and (= inline$$BorrowField$10$size@1 (|size#$Path| inline$$BorrowField$10$p@1)) (= inline$$BorrowField$10$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$10$p@1) inline$$BorrowField$10$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$10$size@1 1)))) (and (= inline$$BorrowField$10$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$BorrowField$10$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$2$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 152877) 152915))) inline$$ReadRef$11$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$1$dst@1) (= (ControlFlow 0 152883) 152877)) inline$$BorrowField$10$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct  (=> (= $abort_code@42 $abort_code@30) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 152741) 152747)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 152739) 152741)) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 152755) 152741) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$1$dst@1)) (= $abort_code@30 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 152733) 152755) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 152733) 152739) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct  (=> (not $abort_flag@22) (and (=> (= (ControlFlow 0 152721) 152883) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 152721) 152733) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t19@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@22)) (and (=> $abort_flag@22 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 152715) 158759) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 152715) 152721) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct)))))
(let ((inline$$Gt$1$anon0_correct  (=> (and (= inline$$Gt$1$dst@1 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$3$dst@1) (|i#$Integer| inline$$Diem_burn_with_resource_cap_$def$0$$t17@1)))) (= (ControlFlow 0 152703) 152715)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct)))
(let ((inline$$Gt$1$Entry_correct  (and (=> (= (ControlFlow 0 152689) (- 0 190085)) true) (=> (= (ControlFlow 0 152689) 152703) inline$$Gt$1$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t17@1 ($Integer 0)) (= (ControlFlow 0 152709) 152689)) inline$$Gt$1$Entry_correct)))
(let ((inline$$GetFieldFromValue$3$anon0_correct  (=> (and (= inline$$GetFieldFromValue$3$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$10$v@1)) $Diem_Diem_value)) (= (ControlFlow 0 152635) 152709)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct  (and (=> (= (ControlFlow 0 152641) (- 0 190048)) true) (=> (= (ControlFlow 0 152641) 152635) inline$$GetFieldFromValue$3$anon0_correct))))
(let ((inline$$ReadRef$10$anon0_correct  (=> (and (= inline$$ReadRef$10$v@1 (|v#$Mutation| inline$$BorrowField$9$dst@1)) (= (ControlFlow 0 152575) 152641)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct)))
(let ((inline$$BorrowField$9$anon0_correct  (=> (= inline$$BorrowField$9$p@1 (|p#$Mutation| inline$$BorrowLoc$2$dst@1)) (=> (and (and (= inline$$BorrowField$9$size@1 (|size#$Path| inline$$BorrowField$9$p@1)) (= inline$$BorrowField$9$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$9$p@1) inline$$BorrowField$9$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$9$size@1 1)))) (and (= inline$$BorrowField$9$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$BorrowField$9$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$2$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 152537) 152575))) inline$$ReadRef$10$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct  (=> (and (not $abort_flag@21) (= (ControlFlow 0 152589) 152537)) inline$$BorrowField$9$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21) (=> $abort_flag@21 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@21 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@28 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@5) (let ((va@@57 (|v#$Vector| call3formal@$ret0@0@@5)))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
)))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) $$0@@11))
)))) (and (=> (= (ControlFlow 0 152379) 158779) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 152379) 152589) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct)))))
(let ((inline$$BorrowLoc$2$anon0_correct  (=> (and (= inline$$BorrowLoc$2$dst@1 ($Mutation ($Local 12) $EmptyPath inline$$ReadRef$9$v@1)) (= (ControlFlow 0 152371) 152379)) inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 152253) 152371)) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct  (=> (= (ControlFlow 0 158803) 152371) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 152245) 158803) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 152245) 152253) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct  (and (=> (= (ControlFlow 0 158811) 158803) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 158811) 152253) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 152237) 158811) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 152237) 152245) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct  (and (=> (= (ControlFlow 0 158819) 158811) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 158819) 152245) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct  (=> (not $abort_flag@20) (and (=> (= (ControlFlow 0 152231) 158819) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 152231) 152237) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$9$v@1) (let ((va@@58 (|v#$Vector| inline$$ReadRef$9$v@1)))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1)) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_remove_burn_capability_$def$0$$ret0@2) (let ((va@@60 (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 158825) 152231)) inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon31_Else$2_correct  (and (=> (= (ControlFlow 0 158833) (- 0 189572)) true) (=> (= (ControlFlow 0 158833) 158825) inline$$Diem_burn_with_resource_cap$0$anon0_correct))))
(let ((inline$$ReadRef$9$anon0_correct  (=> (and (= inline$$ReadRef$9$v@1 (|v#$Mutation| |inline$$WriteRef$4$to'@1|)) (= (ControlFlow 0 150746) 158833)) inline$$Diem_burn_now_$def$0$anon31_Else$2_correct)))
(let ((inline$$WriteRef$4$anon0_correct  (=> (and (= |inline$$WriteRef$4$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$Diem_preburn_with_resource_$def$0$$ret0@2)) (= (ControlFlow 0 150708) 150746)) inline$$ReadRef$9$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon31_Else_correct  (=> (and (not $abort_flag@20) (= (ControlFlow 0 150714) 150708)) inline$$WriteRef$4$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon31_Then_correct  (=> (and (and $abort_flag@20 (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@1)) (and (= $abort_code@44 $abort_code@27) (= (ControlFlow 0 159051) 143982))) inline$$Diem_burn_now_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon62_correct  (=> (and (and (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2|) (= $abort_flag@20 $abort_flag@19)) (and (= $abort_code@27 $abort_code@25) (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory@0))) (and (=> (= (ControlFlow 0 149282) 159051) inline$$Diem_burn_now_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 149282) 150714) inline$$Diem_burn_now_$def$0$anon31_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 149280) 149282)) inline$$Diem_preburn_with_resource_$def$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct  (=> (= (ControlFlow 0 149290) 149282) inline$$Diem_preburn_with_resource_$def$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct  (=> (= $Diem_CurrencyInfo_$memory@0 |inline$$WritebackToGlobal$1$m'@2|) (and (=> (= (ControlFlow 0 150409) 149290) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 150409) 149280) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct)))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 150347) 150409)) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 150401) 150409))) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (and (=> (= (ControlFlow 0 150337) 150401) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 150337) 150347) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct  (and (=> (= (ControlFlow 0 150217) (- 0 189170)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 150217) 150337) inline$$WritebackToGlobal$1$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 150169) 150217)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$2$dst'@2|) (= (ControlFlow 0 150038) 150169)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1)) (= |inline$$WritebackToReference$3$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) inline$$WritebackToReference$3$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|) (|v#$Mutation| |inline$$WriteRef$3$to'@1|))))) (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$3$dst'@1|) (= (ControlFlow 0 150094) 150169))) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct)))
(let ((inline$$WritebackToReference$3$anon0_correct  (=> (and (= inline$$WritebackToReference$3$srcPath@1 (|p#$Mutation| |inline$$WriteRef$3$to'@1|)) (= inline$$WritebackToReference$3$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (and (=> (= (ControlFlow 0 150002) 150094) inline$$WritebackToReference$3$anon3_Then_correct) (=> (= (ControlFlow 0 150002) 150038) inline$$WritebackToReference$3$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 149865) 150002)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (= (ControlFlow 0 150419) 150002)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$8$dst@1) (|p#$Mutation| inline$$BorrowField$8$dst@1) inline$$ReadRef$8$v@1)) (and (=> (= (ControlFlow 0 149851) 150419) inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 149851) 149865) inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct  (=> (and (not $abort_flag@19) (= (ControlFlow 0 149857) 149851)) inline$$WriteRef$3$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct  (=> (= $Diem_CurrencyInfo_$memory@0 |inline$$WritebackToGlobal$0$m'@2|) (and (=> (= (ControlFlow 0 149270) 149290) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 149270) 149280) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 149208) 149270)) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 149262) 149270))) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (and (=> (= (ControlFlow 0 149198) 149262) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 149198) 149208) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 149078) (- 0 188617)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 149078) 149198) inline$$WritebackToGlobal$0$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (= (ControlFlow 0 149030) 149078)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@1)) (= (ControlFlow 0 149082) 149030)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$Abort_correct  (=> (= inline$$Diem_preburn_with_resource_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2 inline$$Diem_preburn_with_resource_$def$0$$ret0@1) (= $abort_flag@20 true)) (and (= $abort_code@27 $abort_code@26) (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory))) (and (=> (= (ControlFlow 0 146249) 159051) inline$$Diem_burn_now_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 146249) 150714) inline$$Diem_burn_now_$def$0$anon31_Else_correct))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon13_correct  (=> (and (= $abort_code@26 $abort_code@17) (= (ControlFlow 0 150595) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 150593) 150595)) inline$$Diem_preburn_with_resource_$def$0$anon13_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct  (=> (= (ControlFlow 0 150603) 150595) inline$$Diem_preburn_with_resource_$def$0$anon13_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct  (=> $abort_flag@13@@0 (and (=> (= (ControlFlow 0 150587) 150603) inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 150587) 150593) inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon21_correct  (=> (and (= $abort_code@26 $abort_code@19) (= (ControlFlow 0 150575) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 150573) 150575)) inline$$Diem_preburn_with_resource_$def$0$anon21_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct  (=> (= (ControlFlow 0 150583) 150575) inline$$Diem_preburn_with_resource_$def$0$anon21_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct  (=> $abort_flag@14@@0 (and (=> (= (ControlFlow 0 150567) 150583) inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 150567) 150573) inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon27_correct  (=> (and (= $abort_code@26 $abort_code@20) (= (ControlFlow 0 150545) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 150543) 150545)) inline$$Diem_preburn_with_resource_$def$0$anon27_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct  (=> (= (ControlFlow 0 150553) 150545) inline$$Diem_preburn_with_resource_$def$0$anon27_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct  (=> $abort_flag@15 (and (=> (= (ControlFlow 0 150537) 150553) inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 150537) 150543) inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon33_correct  (=> (and (= $abort_code@26 $abort_code@21) (= (ControlFlow 0 150521) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 150519) 150521)) inline$$Diem_preburn_with_resource_$def$0$anon33_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct  (=> (= (ControlFlow 0 150529) 150521) inline$$Diem_preburn_with_resource_$def$0$anon33_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct  (=> $abort_flag@16 (and (=> (= (ControlFlow 0 150513) 150529) inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 150513) 150519) inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon37_correct  (=> (and (= $abort_code@26 $abort_code@22) (= (ControlFlow 0 150501) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 150499) 150501)) inline$$Diem_preburn_with_resource_$def$0$anon37_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct  (=> (= (ControlFlow 0 150509) 150501) inline$$Diem_preburn_with_resource_$def$0$anon37_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 150493) 150509) inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 150493) 150499) inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon41_correct  (=> (and (= $abort_code@26 $abort_code@23) (= (ControlFlow 0 150481) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 150479) 150481)) inline$$Diem_preburn_with_resource_$def$0$anon41_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct  (=> (= (ControlFlow 0 150489) 150481) inline$$Diem_preburn_with_resource_$def$0$anon41_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct  (=> $abort_flag@18 (and (=> (= (ControlFlow 0 150473) 150489) inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 150473) 150479) inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon49_correct  (=> (and (= $abort_code@26 $abort_code@25) (= (ControlFlow 0 150461) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 150459) 150461)) inline$$Diem_preburn_with_resource_$def$0$anon49_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 150469) 150461) inline$$Diem_preburn_with_resource_$def$0$anon49_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 150453) 150469) inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 150453) 150459) inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon57_correct  (=> (and (= $abort_code@26 $abort_code@25) (= (ControlFlow 0 150431) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 150429) 150431)) inline$$Diem_preburn_with_resource_$def$0$anon57_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 150439) 150431) inline$$Diem_preburn_with_resource_$def$0$anon57_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 150423) 150439) inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 150423) 150429) inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct  (=> (= inline$$Event_emit_event$0$t@0 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 149782) 150423) inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 149782) 149857) inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct  (and (=> (= (ControlFlow 0 149792) (- 0 188973)) true) (=> (= (ControlFlow 0 149792) 149782) inline$$Event_emit_event$0$Entry_correct))))
(let ((inline$$ReadRef$8$anon0_correct  (=> (and (= inline$$ReadRef$8$v@1 (|v#$Mutation| inline$$BorrowField$8$dst@1)) (= (ControlFlow 0 149734) 149792)) inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 149690) 149734)) inline$$ReadRef$8$anon0_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 149696) 149734) inline$$ReadRef$8$anon0_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 149684) 149696) inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 149684) 149690) inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 149676) 149734)) inline$$ReadRef$8$anon0_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$1$dst@1) (>= (|i#$Integer| inline$$GetFieldFromValue$1$dst@1) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$1$dst@1) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@9) (let ((va@@61 (|v#$Vector| call3formal@$ret0@0@@9)))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
)))))) (forall ((inline$$Diem_PreburnEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_PreburnEvent_pack$0$$$0 0) (< inline$$Diem_PreburnEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)) inline$$Diem_PreburnEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)) inline$$Diem_PreburnEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)) inline$$Diem_PreburnEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)) inline$$Diem_PreburnEvent_pack$0$$$0))
))) (and ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) (= inline$$Diem_PreburnEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$1$dst@1) 1 call3formal@$ret0@0@@9) 2 inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) 3))))) (and (=> (= (ControlFlow 0 149668) 149684) inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 149668) 149676) inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$8$anon0_correct  (=> (= inline$$BorrowField$8$p@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (=> (and (and (= inline$$BorrowField$8$size@1 (|size#$Path| inline$$BorrowField$8$p@1)) (= inline$$BorrowField$8$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1) inline$$BorrowField$8$size@1 $Diem_CurrencyInfo_preburn_events) (+ inline$$BorrowField$8$size@1 1)))) (and (= inline$$BorrowField$8$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) inline$$BorrowField$8$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) $Diem_CurrencyInfo_preburn_events))) (= (ControlFlow 0 149412) 149668))) inline$$Diem_PreburnEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@1) (= (ControlFlow 0 149418) 149412)) inline$$BorrowField$8$anon0_correct)))
(let ((inline$$Not$0$anon0_correct@@1  (=> (= inline$$Not$0$dst@1@@1 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$7$v@1)))) (and (=> (= (ControlFlow 0 148947) 149418) inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 148947) 149082) inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 148937) (- 0 188578)) true) (=> (= (ControlFlow 0 148937) 148947) inline$$Not$0$anon0_correct@@1))))
(let ((inline$$ReadRef$7$anon0_correct  (=> (and (= inline$$ReadRef$7$v@1 (|v#$Mutation| inline$$BorrowField$7$dst@1)) (= (ControlFlow 0 148889) 148937)) inline$$Not$0$Entry_correct@@1)))
(let ((inline$$BorrowField$7$anon0_correct  (=> (= inline$$BorrowField$7$p@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (=> (and (and (= inline$$BorrowField$7$size@1 (|size#$Path| inline$$BorrowField$7$p@1)) (= inline$$BorrowField$7$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1) inline$$BorrowField$7$size@1 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$7$size@1 1)))) (and (= inline$$BorrowField$7$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) inline$$BorrowField$7$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 148851) 148889))) inline$$ReadRef$7$anon0_correct))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 148635) 148851)) inline$$BorrowField$7$anon0_correct))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))))) (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|) (= (ControlFlow 0 148691) 148851))) inline$$BorrowField$7$anon0_correct)))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 148599) 148691) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 148599) 148635) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 148462) 148599)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 150449) 148599)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$6$dst@1) (|p#$Mutation| inline$$BorrowField$6$dst@1) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 148448) 150449) inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 148448) 148462) inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct)))))
(let ((inline$$BorrowField$6$anon0_correct  (=> (= inline$$BorrowField$6$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$6$size@1 (|size#$Path| inline$$BorrowField$6$p@1)) (= inline$$BorrowField$6$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1) inline$$BorrowField$6$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$6$size@1 1)))) (and (= inline$$BorrowField$6$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$6$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 148389) 148448))) inline$$WriteRef$2$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct  (=> (and (not $abort_flag@19) (= (ControlFlow 0 148395) 148389)) inline$$BorrowField$6$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_code@25 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@19 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 148259) 150453) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 148259) 148395) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)) $MAX_U64) (= (ControlFlow 0 148257) 148259)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1))) (=> (and (and (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)))) (= $abort_code@25 $abort_code@23)) (and (= $abort_flag@19 $abort_flag@18) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 148201) 150453) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 148201) 148395) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 148171) (- 0 188152)) true) (and (=> (= (ControlFlow 0 148171) 148257) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 148171) 148201) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$6$anon0_correct  (=> (and (= inline$$ReadRef$6$v@1 (|v#$Mutation| inline$$BorrowField$5$dst@1)) (= (ControlFlow 0 148064) 148171)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$BorrowField$5$anon0_correct  (=> (= inline$$BorrowField$5$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$5$size@1 (|size#$Path| inline$$BorrowField$5$p@1)) (= inline$$BorrowField$5$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1) inline$$BorrowField$5$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$5$size@1 1)))) (and (= inline$$BorrowField$5$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$5$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 148026) 148064))) inline$$ReadRef$6$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1) (= (ControlFlow 0 148078) 148026)) inline$$BorrowField$5$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon46_correct  (=> (and (= $abort_code@26 $abort_code@24) (= (ControlFlow 0 147860) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 147858) 147860)) inline$$Diem_preburn_with_resource_$def$0$anon46_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct  (=> (= (ControlFlow 0 147868) 147860) inline$$Diem_preburn_with_resource_$def$0$anon46_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct  (=> (= $abort_code@24 (|i#$Integer| call3formal@$ret0@0@@10)) (and (=> (= (ControlFlow 0 147852) 147868) inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 147852) 147858) inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 147842) (- 0 187984)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 147842) 147852) inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 147794) 147842)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1)) (= (ControlFlow 0 147846) 147794)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct  (=> (not $abort_flag@18) (and (=> (= (ControlFlow 0 147719) 148078) inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 147719) 147846) inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct  (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t27@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@18)) (and (=> $abort_flag@18 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 147713) 150473) inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 147713) 147719) inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct  (=> (and (= inline$$Ge$0$dst@1 ($Boolean (>= (|i#$Integer| inline$$Sub$0$dst@2) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)))) (= (ControlFlow 0 147701) 147713)) inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct)))
(let ((inline$$Ge$0$Entry_correct  (and (=> (= (ControlFlow 0 147687) (- 0 187874)) true) (=> (= (ControlFlow 0 147687) 147701) inline$$Ge$0$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 147707) 147687)) inline$$Ge$0$Entry_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (= $abort_flag@17 true) (=> (and (= $abort_code@22 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 147631) 150493) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 147631) 147707) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1) (|i#$Integer| inline$$ReadRef$5$v@1)) (= (ControlFlow 0 147629) 147631)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (<= (|i#$Integer| inline$$ReadRef$5$v@1) (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1)) (=> (and (and (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1) (|i#$Integer| inline$$ReadRef$5$v@1)))) (= $abort_flag@17 $abort_flag@16)) (and (= $abort_code@22 $abort_code@21) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 147577) 150493) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 147577) 147707) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 147551) (- 0 187786)) true) (and (=> (= (ControlFlow 0 147551) 147629) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 147551) 147577) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$5$anon0_correct  (=> (and (= inline$$ReadRef$5$v@1 (|v#$Mutation| inline$$BorrowField$4$dst@1)) (= (ControlFlow 0 147452) 147551)) inline$$Sub$0$Entry_correct)))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 147414) 147452))) inline$$ReadRef$5$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t23@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 147466) 147414)) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 147252) 147466)) inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 147246) 147252)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct  (=> (and (not $abort_flag@16) (= (ControlFlow 0 147256) 147246)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (= $abort_code@21 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@16 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 147206) 150513) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 147206) 147256) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 147204) 147206)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1))) (= $abort_code@21 $abort_code@20)) (and (= $abort_flag@16 $abort_flag@15) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 147152) 150513) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 147152) 147256) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 147122) 147204) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 147122) 147152) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (=> (= inline$$BorrowGlobal$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1)) (and (=> (= (ControlFlow 0 147116) (- 0 187561)) true) (=> (= (ControlFlow 0 147116) 147122) inline$$BorrowGlobal$1$anon0_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 147212) 147116)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct  (=> $abort_flag@15 (=> (and (= $abort_code@26 $abort_code@20) (= (ControlFlow 0 150533) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 146973) 150533) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 146973) 147212) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 146983) 150533) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 146983) 147212) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@15) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 146967) 146983) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 146967) 146973) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 146997) 146967)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@15) (=> $abort_flag@15 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@15 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@20 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@15) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@9) (let ((va@@62 (|v#$Vector| call3formal@$ret0@0@@9)))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
)))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@9)) $$0@@12))
)))) (and (=> (= (ControlFlow 0 146862) 150537) inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 146862) 146997) inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 11))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$2$v@1) (= (ControlFlow 0 146828) 146862)) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 11)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 inline$$ReadRef$2$v@1 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 146854) 146862))) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowLoc$1$dst@1)) (and (=> (= (ControlFlow 0 146673) 146854) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 146673) 146828) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (and (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|))) (and (=> (= (ControlFlow 0 146729) 146854) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 146729) 146828) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 146637) 146729) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 146637) 146673) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 146500) 146637)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_preburn_with_resource_$def$0$info@0)) (= (ControlFlow 0 150563) 146637)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) call5formal@$ret0@0)) (and (=> (= (ControlFlow 0 146486) 150563) inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 146486) 146500) inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct  (=> (and (not $abort_flag@14@@0) (= (ControlFlow 0 146492) 146486)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct  (and (=> (= (ControlFlow 0 146429) (- 0 186951)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@14@@0) (=> $abort_flag@14@@0 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> $abort_flag@14@@0 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@19 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@14@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)))))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0) (let ((va@@63 (|v#$Vector| call5formal@$ret0@0)))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 146429) 150567) inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 146429) 146492) inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct)))))))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowField$3$dst@1)) (= (ControlFlow 0 146417) 146429)) inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct)))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 146379) 146417))) inline$$ReadRef$4$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1) (= (ControlFlow 0 146385) 146379)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon18_correct  (=> (and (= $abort_code@26 $abort_code@18) (= (ControlFlow 0 146243) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 146241) 146243)) inline$$Diem_preburn_with_resource_$def$0$anon18_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct  (=> (= (ControlFlow 0 146257) 146243) inline$$Diem_preburn_with_resource_$def$0$anon18_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1)) (= $abort_code@18 (|i#$Integer| call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 146235) 146257) inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 146235) 146241) inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct  (=> (not $abort_flag@13@@0) (and (=> (= (ControlFlow 0 146223) 146385) inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 146223) 146235) inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct  (=> (not $abort_flag@12@@0) (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t16@1 ($Integer 0)) (= inline$$Diem_preburn_with_resource_$def$0$$t17@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$2$dst@1 inline$$Diem_preburn_with_resource_$def$0$$t16@1)))) (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t18@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@13@@0)) (and (=> $abort_flag@13@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@11) (>= (|i#$Integer| call3formal@$ret0@0@@11) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@11) $MAX_U64))) (and (=> (= (ControlFlow 0 146217) 150587) inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 146217) 146223) inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct)))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct  (=> $abort_flag@12@@0 (=> (and (= $abort_code@26 $abort_code@15@@0) (= (ControlFlow 0 150607) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct))))
(let ((inline$$Diem_value_$def$1$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 146161) 150607) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 146161) 146217) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct)))))
(let ((inline$$Diem_value_$def$1$anon6_Then_correct  (and (=> (= (ControlFlow 0 146171) 150607) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 146171) 146217) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 146145) 146171) inline$$Diem_value_$def$1$anon6_Then_correct) (=> (= (ControlFlow 0 146145) 146161) inline$$Diem_value_$def$1$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 146069) 146145)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$Diem_value_$def$1$anon5_Then_correct  (=> (= (ControlFlow 0 146179) 146145) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$Diem_value_$def$1$anon0_correct  (=> (not $abort_flag@12@@0) (and (=> (= (ControlFlow 0 146063) 146179) inline$$Diem_value_$def$1$anon5_Then_correct) (=> (= (ControlFlow 0 146063) 146069) inline$$Diem_value_$def$1$anon5_Else_correct)))))
(let ((inline$$Diem_value$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$3$v@1) (let ((va@@64 (|v#$Vector| inline$$ReadRef$3$v@1)))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 146185) 146063)) inline$$Diem_value_$def$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct  (and (=> (= (ControlFlow 0 146193) (- 0 186648)) true) (=> (= (ControlFlow 0 146193) 146185) inline$$Diem_value$1$anon0_correct))))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 145883) 146193)) inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 145845) 145883))) inline$$ReadRef$3$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct  (=> (and (not $abort_flag@12@@0) (= (ControlFlow 0 145897) 145845)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct  (=> $abort_flag@12@@0 (=> (and (= $abort_code@26 $abort_code@15@@0) (= (ControlFlow 0 150611) 146249)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct))))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 145653) 150611) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 145653) 145897) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 145663) 150611) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 145663) 145897) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 145637) 145663) inline$$Diem_value_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 145637) 145653) inline$$Diem_value_$def$0$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 145561) 145637)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 145671) 145637) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Diem_value_$def$0$anon0_correct  (=> (not $abort_flag@12@@0) (and (=> (= (ControlFlow 0 145555) 145671) inline$$Diem_value_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 145555) 145561) inline$$Diem_value_$def$0$anon5_Else_correct)))))
(let ((inline$$Diem_value$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@0) (let ((va@@65 (|v#$Vector| call4formal@$ret0@0@@0)))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 145677) 145555)) inline$$Diem_value_$def$0$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 11) $EmptyPath inline$$ReadRef$2$v@1)) (= (ControlFlow 0 145387) 145677)) inline$$Diem_value$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 145235) 145387)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct  (=> (= (ControlFlow 0 150619) 145387) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 145227) 150619) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 145227) 145235) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct  (and (=> (= (ControlFlow 0 150627) 150619) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 150627) 145235) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 145219) 150627) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 145219) 145227) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct  (and (=> (= (ControlFlow 0 150635) 150627) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 150635) 145227) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon0_correct  (=> (not $abort_flag@12@@0) (and (=> (= (ControlFlow 0 145213) 150635) inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 145213) 145219) inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@0) (let ((va@@66 (|v#$Vector| call4formal@$ret0@0@@0)))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$2$v@1) (let ((va@@67 (|v#$Vector| inline$$ReadRef$2$v@1)))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn)) (let ((va@@68 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (and ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) (= (ControlFlow 0 150641) 145213))) inline$$Diem_preburn_with_resource_$def$0$anon0_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon29_Then$1_correct  (and (=> (= (ControlFlow 0 150649) (- 0 186223)) true) (=> (= (ControlFlow 0 150649) 150641) inline$$Diem_preburn_with_resource$0$anon0_correct))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 144026) 150649)) inline$$Diem_burn_now_$def$0$anon29_Then$1_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon29_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1) (= (ControlFlow 0 144032) 144026)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon16_correct  (=> (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory) (=> (and (= $abort_code@44 $abort_code@16@@0) (= (ControlFlow 0 143976) 143982)) inline$$Diem_burn_now_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 143974) 143976)) inline$$Diem_burn_now_$def$0$anon16_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 143990) 143976) inline$$Diem_burn_now_$def$0$anon16_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon29_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1)) (= $abort_code@16@@0 (|i#$Integer| call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 143968) 143990) inline$$Diem_burn_now_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 143968) 143974) inline$$Diem_burn_now_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon27_Else_correct  (=> (not $abort_flag@12@@0) (and (=> (= (ControlFlow 0 143956) 144032) inline$$Diem_burn_now_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 143956) 143968) inline$$Diem_burn_now_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon8$7_correct  (=> (and (and (and (= inline$$Diem_burn_now_$def$0$$t14@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@12@@0)) (and (=> $abort_flag@12@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@12@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 143950) 159055) inline$$Diem_burn_now_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 143950) 143956) inline$$Diem_burn_now_$def$0$anon27_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct  (=> (and (= inline$$Gt$0$dst@1 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$0$dst@1) (|i#$Integer| inline$$Diem_burn_now_$def$0$$t12@1)))) (= (ControlFlow 0 143938) 143950)) inline$$Diem_burn_now_$def$0$anon8$7_correct)))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 143924) (- 0 186088)) true) (=> (= (ControlFlow 0 143924) 143938) inline$$Gt$0$anon0_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon8$6_correct  (=> (and (= inline$$Diem_burn_now_$def$0$$t12@1 ($Integer 0)) (= (ControlFlow 0 143944) 143924)) inline$$Gt$0$Entry_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (= (ControlFlow 0 143870) 143944)) inline$$Diem_burn_now_$def$0$anon8$6_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 7) $EmptyPath inline$$ReadRef$1$v@1)) (= (ControlFlow 0 143822) 143870)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 143636) 143822)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 159079) 143822) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 143628) 159079) inline$$Diem_burn_now_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 143628) 143636) inline$$Diem_burn_now_$def$0$anon26_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 159087) 159079) inline$$Diem_burn_now_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 159087) 143636) inline$$Diem_burn_now_$def$0$anon26_Else_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon24_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 143620) 159087) inline$$Diem_burn_now_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 143620) 143628) inline$$Diem_burn_now_$def$0$anon25_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon24_Then_correct  (and (=> (= (ControlFlow 0 159095) 159087) inline$$Diem_burn_now_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 159095) 143628) inline$$Diem_burn_now_$def$0$anon25_Else_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 143612) 159095) inline$$Diem_burn_now_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 143612) 143620) inline$$Diem_burn_now_$def$0$anon24_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 159103) 159095) inline$$Diem_burn_now_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 159103) 143620) inline$$Diem_burn_now_$def$0$anon24_Else_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon0_correct  (=> (not $abort_flag@11@@0) (and (=> (= (ControlFlow 0 143606) 159103) inline$$Diem_burn_now_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 143606) 143612) inline$$Diem_burn_now_$def$0$anon23_Else_correct)))))
(let ((inline$$Diem_burn_now_$direct_inter$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@0) (let ((va@@69 (|v#$Vector| call4formal@$ret0@0@@0)))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1) (let ((va@@70 (|v#$Vector| inline$$ReadRef$1$v@1)))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn)) (let ((va@@71 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1)) (and (and (and (and (and ((_ is $Vector) inline$$Diem_remove_burn_capability_$def$0$$ret0@2) (let ((va@@72 (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 159109) 143606))) inline$$Diem_burn_now_$def$0$anon0_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon78_Else$2_correct  (and (=> (= (ControlFlow 0 159117) (- 0 185853)) true) (=> (= (ControlFlow 0 159117) 159109) inline$$Diem_burn_now_$direct_inter$0$anon0_correct))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 143032) 159117)) inline$$TransactionFee_burn_fees_$def_verify$0$anon78_Else$2_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $TransactionFee_TransactionFee_preburn) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) $TransactionFee_TransactionFee_preburn))) (= (ControlFlow 0 142994) 143032))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon78_Else_correct  (=> (and (not $abort_flag@11@@0) (= (ControlFlow 0 143000) 142994)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon78_Then_correct  (=> (and $abort_flag@11@@0 (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory)) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory@1)) (and (= $abort_code@55 $abort_code@14@@0) (= (ControlFlow 0 160888) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon20_correct  (=> (and (and (= inline$$Diem_remove_burn_capability_$def$0$$ret0@2 inline$$MoveFrom$0$dst@2) (= $abort_code@14@@0 $abort_code@12@@0)) (and (= $abort_flag@11@@0 $abort_flag@10@@1) (= $Diem_BurnCapability_$memory@1 |inline$$MoveFrom$0$m'@2|))) (and (=> (= (ControlFlow 0 142780) 160888) inline$$TransactionFee_burn_fees_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 142780) 143000) inline$$TransactionFee_burn_fees_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 142778) 142780)) inline$$Diem_remove_burn_capability_$def$0$anon20_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 142788) 142780) inline$$Diem_remove_burn_capability_$def$0$anon20_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon28_Else_correct  (=> (not $abort_flag@10@@1) (and (=> (= (ControlFlow 0 142772) 142788) inline$$Diem_remove_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 142772) 142778) inline$$Diem_remove_burn_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$Abort_correct  (=> (= inline$$Diem_remove_burn_capability_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$Diem_remove_burn_capability_$def$0$$ret0@2 inline$$Diem_remove_burn_capability_$def$0$$ret0@1) (= $abort_code@14@@0 $abort_code@13@@0)) (and (= $abort_flag@11@@0 true) (= $Diem_BurnCapability_$memory@1 $Diem_BurnCapability_$memory@0))) (and (=> (= (ControlFlow 0 142504) 160888) inline$$TransactionFee_burn_fees_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 142504) 143000) inline$$TransactionFee_burn_fees_$def_verify$0$anon78_Else_correct))))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon5_correct  (=> (= $abort_code@13@@0 $abort_code@9@@0) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 142840) 142504)) inline$$Diem_remove_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 142838) 142840)) inline$$Diem_remove_burn_capability_$def$0$anon5_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 142848) 142840) inline$$Diem_remove_burn_capability_$def$0$anon5_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon22_Then_correct  (=> $abort_flag@8@@1 (and (=> (= (ControlFlow 0 142832) 142848) inline$$Diem_remove_burn_capability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 142832) 142838) inline$$Diem_remove_burn_capability_$def$0$anon23_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon9_correct  (=> (= $abort_code@13@@0 $abort_code@10@@0) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 142820) 142504)) inline$$Diem_remove_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 142818) 142820)) inline$$Diem_remove_burn_capability_$def$0$anon9_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 142828) 142820) inline$$Diem_remove_burn_capability_$def$0$anon9_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon24_Then_correct  (=> $abort_flag@9@@1 (and (=> (= (ControlFlow 0 142812) 142828) inline$$Diem_remove_burn_capability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 142812) 142818) inline$$Diem_remove_burn_capability_$def$0$anon25_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon17_correct  (=> (= $abort_code@13@@0 $abort_code@12@@0) (=> (and (= $Diem_BurnCapability_$memory@0 |inline$$MoveFrom$0$m'@2|) (= (ControlFlow 0 142800) 142504)) inline$$Diem_remove_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 142798) 142800)) inline$$Diem_remove_burn_capability_$def$0$anon17_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 142808) 142800) inline$$Diem_remove_burn_capability_$def$0$anon17_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon28_Then_correct  (=> $abort_flag@10@@1 (and (=> (= (ControlFlow 0 142792) 142808) inline$$Diem_remove_burn_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 142792) 142798) inline$$Diem_remove_burn_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct  (=> (and (and (= $abort_flag@10@@1 true) (= $abort_code@12@@0 $EXEC_FAILURE_CODE)) (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@0|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@0))) (and (=> (= (ControlFlow 0 142754) 142792) inline$$Diem_remove_burn_capability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 142754) 142772) inline$$Diem_remove_burn_capability_$def$0$anon28_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1)) (= (ControlFlow 0 142752) 142754)) inline$$MoveFrom$0$anon3_Then$1_correct)))
(let ((inline$$MoveFrom$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1) (=> (and (= inline$$MoveFrom$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1)) (= |inline$$MoveFrom$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 $Error)))) (=> (and (and (= $abort_flag@10@@1 $abort_flag@9@@1) (= $abort_code@12@@0 $abort_code@10@@0)) (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@1|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@1))) (and (=> (= (ControlFlow 0 142700) 142792) inline$$Diem_remove_burn_capability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 142700) 142772) inline$$Diem_remove_burn_capability_$def$0$anon28_Else_correct)))))))
(let ((inline$$MoveFrom$0$anon0_correct  (=> (= inline$$MoveFrom$0$a@1 (|a#$Address| call3formal@$ret0@0@@13)) (and (=> (= (ControlFlow 0 142654) 142752) inline$$MoveFrom$0$anon3_Then_correct) (=> (= (ControlFlow 0 142654) 142700) inline$$MoveFrom$0$anon3_Else_correct)))))
(let ((inline$$MoveFrom$0$Entry_correct  (=> (= inline$$MoveFrom$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1)) (and (=> (= (ControlFlow 0 142648) (- 0 185502)) true) (=> (= (ControlFlow 0 142648) 142654) inline$$MoveFrom$0$anon0_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon26_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_remove_burn_capability_$def$0$$t5@1) (= (ControlFlow 0 142762) 142648)) inline$$MoveFrom$0$Entry_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon14_correct  (=> (= $abort_code@13@@0 $abort_code@11@@0) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 142498) 142504)) inline$$Diem_remove_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 142496) 142498)) inline$$Diem_remove_burn_capability_$def$0$anon14_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 142512) 142498) inline$$Diem_remove_burn_capability_$def$0$anon14_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon26_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_remove_burn_capability_$def$0$$t5@1)) (= $abort_code@11@@0 (|i#$Integer| call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 142490) 142512) inline$$Diem_remove_burn_capability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 142490) 142496) inline$$Diem_remove_burn_capability_$def$0$anon27_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon24_Else_correct  (=> (not $abort_flag@9@@1) (and (=> (= (ControlFlow 0 142478) 142762) inline$$Diem_remove_burn_capability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 142478) 142490) inline$$Diem_remove_burn_capability_$def$0$anon26_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon22_Else_correct  (=> (and (not $abort_flag@8@@1) (= inline$$Diem_remove_burn_capability_$def$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| call3formal@$ret0@0@@13))))) (=> (and (and (and (= inline$$Diem_remove_burn_capability_$def$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9@@1)) (and (=> $abort_flag@9@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@9@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 ($Integer 4))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@14) (>= (|i#$Integer| call3formal@$ret0@0@@14) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@14) $MAX_U64))) (and (=> (= (ControlFlow 0 142472) 142812) inline$$Diem_remove_burn_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 142472) 142478) inline$$Diem_remove_burn_capability_$def$0$anon24_Else_correct))))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@8@@1) (=> $abort_flag@8@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@8@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 tc_account@@1)))) ((_ is $Address) call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 142442) 142832) inline$$Diem_remove_burn_capability_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 142442) 142472) inline$$Diem_remove_burn_capability_$def$0$anon22_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 142406) 142442)) inline$$Diem_remove_burn_capability_$def$0$anon2$1_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 142856) 142442) inline$$Diem_remove_burn_capability_$def$0$anon2$1_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon0_correct  (=> (not $abort_flag@7@@1) (and (=> (= (ControlFlow 0 142400) 142856) inline$$Diem_remove_burn_capability_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 142400) 142406) inline$$Diem_remove_burn_capability_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) tc_account@@1) (= (ControlFlow 0 142862) 142400)) inline$$Diem_remove_burn_capability_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon77_Else_correct  (=> (and (not true) (= (ControlFlow 0 141960) 142862)) inline$$Diem_remove_burn_capability_$direct_inter$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon77_Then_correct  (=> (= (ControlFlow 0 160896) 142862) inline$$Diem_remove_burn_capability_$direct_inter$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2)) (and (=> (= (ControlFlow 0 141856) 160896) inline$$TransactionFee_burn_fees_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 141856) 141960) inline$$TransactionFee_burn_fees_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 141912) 160896) inline$$TransactionFee_burn_fees_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 141912) 141960) inline$$TransactionFee_burn_fees_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 141820) 141912) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 141820) 141856) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 141683) 141820)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon76_Then_correct  (=> (and (= inline$$TransactionFee_burn_fees_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 160906) 141820)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) call5formal@$ret1@0@@0)) (and (=> (= (ControlFlow 0 141669) 160906) inline$$TransactionFee_burn_fees_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 141669) 141683) inline$$TransactionFee_burn_fees_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon74_Else_correct  (=> (and (not $abort_flag@7@@1) (= (ControlFlow 0 141675) 141669)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon72_Else$2_correct  (and (=> (= (ControlFlow 0 141612) (- 0 184947)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7@@1) (=> $abort_flag@7@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@7@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Diem_Diem_value))))) (=> (not $abort_flag@7@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value) ($Integer 0))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@0) (let ((va@@73 (|v#$Vector| call4formal@$ret0@0@@0)))
(let ((l@@73 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0@@0) (let ((va@@74 (|v#$Vector| call5formal@$ret1@0@@0)))
(let ((l@@74 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 141612) 160910) inline$$TransactionFee_burn_fees_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 141612) 141675) inline$$TransactionFee_burn_fees_$def_verify$0$anon74_Else_correct)))))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 141600) 141612)) inline$$TransactionFee_burn_fees_$def_verify$0$anon72_Else$2_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $TransactionFee_TransactionFee_balance) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $TransactionFee_TransactionFee_balance))) (= (ControlFlow 0 141562) 141600))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon72_Else_correct  (=> (and (not $abort_flag@6@@1) (= (ControlFlow 0 141568) 141562)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_code@7@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@6@@1 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 141432) 160930) inline$$TransactionFee_burn_fees_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 141432) 141568) inline$$TransactionFee_burn_fees_$def_verify$0$anon72_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 141430) 141432)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1))) (= $abort_code@7@@1 $abort_code@5@@1)) (and (= $abort_flag@6@@1 $abort_flag@4@@1) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 141378) 160930) inline$$TransactionFee_burn_fees_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 141378) 141568) inline$$TransactionFee_burn_fees_$def_verify$0$anon72_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 141348) 141430) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 141348) 141378) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (=> (= inline$$BorrowGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1)) (and (=> (= (ControlFlow 0 141342) (- 0 184762)) true) (=> (= (ControlFlow 0 141342) 141348) inline$$BorrowGlobal$0$anon0_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon68_Else_correct  (=> (and (not (|b#$Boolean| call3formal@$ret0@0@@2)) (= (ControlFlow 0 141438) 141342)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon66_Else_correct  (=> (not $abort_flag@4@@1) (and (=> (= (ControlFlow 0 141223) 160956) inline$$TransactionFee_burn_fees_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 141223) 141438) inline$$TransactionFee_burn_fees_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon65_Else_correct  (=> (and (not $abort_flag@3@@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4@@1)) (=> (and (and (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@4@@1 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5@@1 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@11) ($Type $XDX_XDX_type_value)))))))) ((_ is $Boolean) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 141217) 161006) inline$$TransactionFee_burn_fees_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 141217) 141223) inline$$TransactionFee_burn_fees_$def_verify$0$anon66_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon65_Then_correct  (=> (and $abort_flag@3@@1 (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory)) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@3@@1) (= (ControlFlow 0 161026) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 141185) 161026) inline$$TransactionFee_burn_fees_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 141185) 141217) inline$$TransactionFee_burn_fees_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 141195) 161026) inline$$TransactionFee_burn_fees_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 141195) 141217) inline$$TransactionFee_burn_fees_$def_verify$0$anon65_Else_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@3@@1) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1 ($Address 186537453))) (and (=> (= (ControlFlow 0 141179) 141195) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 141179) 141185) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon63_Then_correct  (=> (and (|b#$Boolean| inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@1) (= (ControlFlow 0 141209) 141179)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon20_correct  (=> (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@4@@1) (= (ControlFlow 0 141062) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 141060) 141062)) inline$$TransactionFee_burn_fees_$def_verify$0$anon20_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 141074) 141062) inline$$TransactionFee_burn_fees_$def_verify$0$anon20_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon63_Else_correct  (=> (and (not (|b#$Boolean| inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@1)) (= $abort_code@4@@1 (|i#$Integer| call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 141054) 141074) inline$$TransactionFee_burn_fees_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 141054) 141060) inline$$TransactionFee_burn_fees_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon61_Else_correct  (=> (not $abort_flag@3@@1) (and (=> (= (ControlFlow 0 141042) 141209) inline$$TransactionFee_burn_fees_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 141042) 141054) inline$$TransactionFee_burn_fees_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon60_Else_correct  (=> (not $abort_flag@2@@1) (=> (and (and (and (= inline$$TransactionFee_burn_fees_$def_verify$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@1)) (and (=> $abort_flag@3@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@15) (>= (|i#$Integer| call3formal@$ret0@0@@15) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@15) $MAX_U64))) (and (=> (= (ControlFlow 0 141036) 161030) inline$$TransactionFee_burn_fees_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 141036) 141042) inline$$TransactionFee_burn_fees_$def_verify$0$anon61_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon60_Then_correct  (=> (and $abort_flag@2@@1 (= $Diem_CurrencyInfo_$memory@7 $Diem_CurrencyInfo_$memory)) (=> (and (and (= $TransactionFee_TransactionFee_$memory@0@@0 $TransactionFee_TransactionFee_$memory) (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory)) (and (= $abort_code@55 $abort_code@2@@0) (= (ControlFlow 0 161050) 141066))) inline$$TransactionFee_burn_fees_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@1  (=> (and (= $abort_flag@2@@1 $abort_flag@1@@1) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@1 inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@1)) (and (=> (= (ControlFlow 0 140994) 161050) inline$$TransactionFee_burn_fees_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 140994) 141036) inline$$TransactionFee_burn_fees_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 140992) 140994)) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@1)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct@@1  (=> (= (ControlFlow 0 141002) 140994) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@1)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@1  (=> (and (not $abort_flag@1@@1) (= inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@1))))) (and (=> (= (ControlFlow 0 140986) 141002) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct@@1) (=> (= (ControlFlow 0 140986) 140992) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct@@1)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@1  (=> (and (and $abort_flag@1@@1 (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1@@1 $Error)) (and (= $abort_flag@2@@1 true) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@1 inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1@@1))) (and (=> (= (ControlFlow 0 141010) 161050) inline$$TransactionFee_burn_fees_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 141010) 141036) inline$$TransactionFee_burn_fees_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 140932) 141010) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 140932) 140986) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@1)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@1  (and (=> (= (ControlFlow 0 140942) 141010) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 140942) 140986) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@1))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@1  (=> (and (not $abort_flag@1@@1) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@1 ($Address 186537453))) (and (=> (= (ControlFlow 0 140926) 140942) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 140926) 140932) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@1)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct@@1  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 140956) 140926)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@1)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon58_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 141024) 140956)) inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct@@1)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon56_Else_correct  (=> (and (not $abort_flag@0@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@1@@1)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@1@@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))))) (=> $abort_flag@1@@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 140670) 161054) inline$$TransactionFee_burn_fees_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 140670) 141024) inline$$TransactionFee_burn_fees_$def_verify$0$anon58_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@1) (=> (and (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 140664) 161074) inline$$TransactionFee_burn_fees_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 140664) 140670) inline$$TransactionFee_burn_fees_$def_verify$0$anon56_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 140628) 140664)) inline$$TransactionFee_burn_fees_$def_verify$0$anon2$1_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 161098) 140664) inline$$TransactionFee_burn_fees_$def_verify$0$anon2$1_correct)))
(let ((inline$$TransactionFee_burn_fees_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 140622) 161098) inline$$TransactionFee_burn_fees_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 140622) 140628) inline$$TransactionFee_burn_fees_$def_verify$0$anon55_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@75 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@75 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (=> (and (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@76 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@76 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@76) (<= l@@76 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@76)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (forall (($inv_addr@@8 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8)) (let ((va@@77 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))))
(let ((l@@77 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))
))) (and (forall (($inv_addr@@9 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9)) (let ((va@@78 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))))
(let ((l@@78 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))
)) (forall (($inv_addr@@10 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10)) (let ((va@@79 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))))
(let ((l@@79 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@80 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@80 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@80) (<= l@@80 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@80)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code)) (let ((va@@81 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@81 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))) $$0@@13))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events)) (let ((va@@82 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@82 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@83 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@83 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@14))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events)) (let ((va@@84 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@84 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@85 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@85 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@15))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@86 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@86 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@87 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@87 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@16))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@88 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@88 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@89 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@89 (|l#$ValueArray| va@@89)))
 (and (and (<= 0 l@@89) (<= l@@89 $MAX_U64)) (forall ((x@@89 Int) ) (!  (=> (or (< x@@89 0) (>= x@@89 l@@89)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89))
))))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@17))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@90 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@90 (|l#$ValueArray| va@@90)))
 (and (and (<= 0 l@@90) (<= l@@90 $MAX_U64)) (forall ((x@@90 Int) ) (!  (=> (or (< x@@90 0) (>= x@@90 l@@90)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@91 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@91 (|l#$ValueArray| va@@91)))
 (and (and (<= 0 l@@91) (<= l@@91 $MAX_U64)) (forall ((x@@91 Int) ) (!  (=> (or (< x@@91 0) (>= x@@91 l@@91)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91))
))))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@18))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@10))
)))) (=> (and (and (and (and (forall (($inv_addr@@11 Int) ($inv_tv0@@6 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11)) (let ((va@@92 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))))
(let ((l@@92 (|l#$ValueArray| va@@92)))
 (and (and (<= 0 l@@92) (<= l@@92 $MAX_U64)) (forall ((x@@92 Int) ) (!  (=> (or (< x@@92 0) (>= x@@92 l@@92)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $Diem_Preburn_to_burn)) (let ((va@@93 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $Diem_Preburn_to_burn))))
(let ((l@@93 (|l#$ValueArray| va@@93)))
 (and (and (<= 0 l@@93) (<= l@@93 $MAX_U64)) (forall ((x@@93 Int) ) (!  (=> (or (< x@@93 0) (>= x@@93 l@@93)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@11))
)) (forall (($inv_addr@@12 Int) ($inv_tv0@@7 T@$TypeValue) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12)) (let ((va@@94 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))))
(let ((l@@94 (|l#$ValueArray| va@@94)))
 (and (and (<= 0 l@@94) (<= l@@94 $MAX_U64)) (forall ((x@@94 Int) ) (!  (=> (or (< x@@94 0) (>= x@@94 l@@94)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_balance)) (let ((va@@95 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_balance))))
(let ((l@@95 (|l#$ValueArray| va@@95)))
 (and (and (<= 0 l@@95) (<= l@@95 $MAX_U64)) (forall ((x@@95 Int) ) (!  (=> (or (< x@@95 0) (>= x@@95 l@@95)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_balance))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) $MAX_U64)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_preburn)) (let ((va@@96 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_preburn))))
(let ((l@@96 (|l#$ValueArray| va@@96)))
 (and (and (<= 0 l@@96) (<= l@@96 $MAX_U64)) (forall ((x@@96 Int) ) (!  (=> (or (< x@@96 0) (>= x@@96 l@@96)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_preburn))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn)) (let ((va@@97 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))))
(let ((l@@97 (|l#$ValueArray| va@@97)))
 (and (and (<= 0 l@@97) (<= l@@97 $MAX_U64)) (forall ((x@@97 Int) ) (!  (=> (or (< x@@97 0) (>= x@@97 l@@97)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64))))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@12))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@7 T@$Value) )  (=> ((_ is $Type) coin_type@@7) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@1 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| mint_cap_owner@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@8 T@$Value) )  (=> ((_ is $Type) coin_type@@8) (|b#$Boolean| ($Boolean (forall ((addr3@@1 T@$Value) )  (=> ((_ is $Address) addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@9 T@$Value) )  (=> ((_ is $Type) coin_type@@9) (|b#$Boolean| ($Boolean (forall ((addr1@@3 T@$Value) )  (=> ((_ is $Address) addr1@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@9)) 1) (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@10 T@$Value) )  (=> ((_ is $Type) coin_type@@10) (|b#$Boolean| ($Boolean (forall ((addr1@@4 T@$Value) )  (=> ((_ is $Address) addr1@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@10)) 1) (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (= (ControlFlow 0 161102) 140622))))) inline$$TransactionFee_burn_fees_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) tc_account@@1) (= (ControlFlow 0 139032) 161102)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 177106) 139032) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def_verify$0$$t1@1 () T@$Value)
(declare-fun $tv0@@12 () T@$TypeValue)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 196911) (let ((inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon6_Else_correct true))
(let ((inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon6_Then_correct true))
(let ((inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon5_Else_correct  (=> (and (not false) (= inline$$TransactionFee_is_coin_initialized_$def_verify$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@2))))) (and (=> (= (ControlFlow 0 164569) 164585) inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 164569) 164575) inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 164515) 164593) inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 164515) 164569) inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@2  (and (=> (= (ControlFlow 0 164525) 164593) inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 164525) 164569) inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@2  (=> (and (not false) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@2 ($Address 186537453))) (and (=> (= (ControlFlow 0 164509) 164525) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 164509) 164515) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@2)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 164539) 164509)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@2)))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@13 Int) ($inv_tv0@@8 T@$TypeValue) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13)) (let ((va@@98 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))))
(let ((l@@98 (|l#$ValueArray| va@@98)))
 (and (and (<= 0 l@@98) (<= l@@98 $MAX_U64)) (forall ((x@@98 Int) ) (!  (=> (or (< x@@98 0) (>= x@@98 l@@98)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_balance)) (let ((va@@99 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_balance))))
(let ((l@@99 (|l#$ValueArray| va@@99)))
 (and (and (<= 0 l@@99) (<= l@@99 $MAX_U64)) (forall ((x@@99 Int) ) (!  (=> (or (< x@@99 0) (>= x@@99 l@@99)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_balance))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) $MAX_U64)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_preburn)) (let ((va@@100 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_preburn))))
(let ((l@@100 (|l#$ValueArray| va@@100)))
 (and (and (<= 0 l@@100) (<= l@@100 $MAX_U64)) (forall ((x@@100 Int) ) (!  (=> (or (< x@@100 0) (>= x@@100 l@@100)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_preburn))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn)) (let ((va@@101 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))))
(let ((l@@101 (|l#$ValueArray| va@@101)))
 (and (and (<= 0 l@@101) (<= l@@101 $MAX_U64)) (forall ((x@@101 Int) ) (!  (=> (or (< x@@101 0) (>= x@@101 l@@101)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64))))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@13))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (= (ControlFlow 0 164599) 164539)) inline$$TransactionFee_is_coin_initialized_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (= (ControlFlow 0 196911) 164599) anon0$1_correct@@2)))
anon0_correct@@2)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@2 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$direct_intra$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@3 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 197154) (let ((inline$$TransactionFee_is_initialized_$def_verify$0$anon6_Else_correct true))
(let ((inline$$TransactionFee_is_initialized_$def_verify$0$anon6_Then_correct true))
(let ((inline$$TransactionFee_is_initialized_$def_verify$0$anon5_Else_correct  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 165209) 165225) inline$$TransactionFee_is_initialized_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 165209) 165215) inline$$TransactionFee_is_initialized_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TransactionFee_is_initialized_$def_verify$0$anon5_Then_correct true))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@2  (=> (= $abort_flag@0@@2 false) (and (=> (= (ControlFlow 0 165169) 165233) inline$$TransactionFee_is_initialized_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 165169) 165209) inline$$TransactionFee_is_initialized_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 165167) 165169)) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@2)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct@@2  (=> (= (ControlFlow 0 165177) 165169) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@2)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@2  (=> (and (not false) (= inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@2 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$TransactionFee_is_coin_initialized_$direct_intra$0$$tv0@0) 1) (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@3))))) (and (=> (= (ControlFlow 0 165161) 165177) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct@@2) (=> (= (ControlFlow 0 165161) 165167) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct@@2)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@2 true))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 165107) 165185) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@2) (=> (= (ControlFlow 0 165107) 165161) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@2)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@3  (and (=> (= (ControlFlow 0 165117) 165185) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@2) (=> (= (ControlFlow 0 165117) 165161) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@2))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@3  (=> (and (not false) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@3 ($Address 186537453))) (and (=> (= (ControlFlow 0 165101) 165117) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 165101) 165107) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@3)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct@@2  (=> (and (not false) (= (ControlFlow 0 165131) 165101)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@3)))
(let ((inline$$TransactionFee_is_coin_initialized_$direct_intra$0$Entry_correct  (=> (and (= inline$$TransactionFee_is_coin_initialized_$direct_intra$0$$tv0@0 $XUS_XUS_type_value) (= (ControlFlow 0 164879) 165131)) inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct@@2)))
(let ((inline$$TransactionFee_is_initialized_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 165199) 164879)) inline$$TransactionFee_is_coin_initialized_$direct_intra$0$Entry_correct)))
(let ((anon0$1_correct@@3  (=> (forall (($inv_addr@@14 Int) ($inv_tv0@@9 T@$TypeValue) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14)) (let ((va@@102 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))))
(let ((l@@102 (|l#$ValueArray| va@@102)))
 (and (and (<= 0 l@@102) (<= l@@102 $MAX_U64)) (forall ((x@@102 Int) ) (!  (=> (or (< x@@102 0) (>= x@@102 l@@102)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_balance)) (let ((va@@103 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_balance))))
(let ((l@@103 (|l#$ValueArray| va@@103)))
 (and (and (<= 0 l@@103) (<= l@@103 $MAX_U64)) (forall ((x@@103 Int) ) (!  (=> (or (< x@@103 0) (>= x@@103 l@@103)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_balance))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) $MAX_U64)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_preburn)) (let ((va@@104 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_preburn))))
(let ((l@@104 (|l#$ValueArray| va@@104)))
 (and (and (<= 0 l@@104) (<= l@@104 $MAX_U64)) (forall ((x@@104 Int) ) (!  (=> (or (< x@@104 0) (>= x@@104 l@@104)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_preburn))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn)) (let ((va@@105 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))))
(let ((l@@105 (|l#$ValueArray| va@@105)))
 (and (and (<= 0 l@@105) (<= l@@105 $MAX_U64)) (forall ((x@@105 Int) ) (!  (=> (or (< x@@105 0) (>= x@@105 l@@105)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64))))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@14))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (= (ControlFlow 0 165239) 165199)) inline$$TransactionFee_is_initialized_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@3  (=> (= (ControlFlow 0 197154) 165239) anon0$1_correct@@3)))
anon0_correct@@3))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@5@@2 () Bool)
(declare-fun $tv0@@13 () T@$TypeValue)
(declare-fun coin () T@$Value)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun $TransactionFee_TransactionFee_$memory@0@@1 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$TransactionFee_pay_fee_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun call5formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1@@0 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@2 () T@$Value)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$TransactionFee_pay_fee_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@3 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@4 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 197484) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 167751) (- 0 199875)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 167751) (- 0 199890)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453)))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453)))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 167751) (- 0 199906)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 167751) (- 0 199946)) (=> $abort_flag@5@@2 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (=> (=> $abort_flag@5@@2 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> (= (ControlFlow 0 167751) (- 0 200015)) (=> $abort_flag@5@@2 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453)))))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 8))))))) (=> (=> $abort_flag@5@@2 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453)))))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@7@@2 (|i#$Integer| ($Integer 8)))))) (=> (= (ControlFlow 0 167751) (- 0 200117)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 186537453))))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value)))))))))))))))))))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon28$2_correct  (and (=> (= (ControlFlow 0 167639) (- 0 199759)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (=> (and (and (= $abort_flag@5@@2 $abort_flag@4@@2) (= $abort_code@7@@2 $abort_code@5@@2)) (and (= $TransactionFee_TransactionFee_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 167639) 167751))) anon0$2_correct@@1)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $TransactionFee_TransactionFee_$memory) (= (ControlFlow 0 167559) 167639)) inline$$TransactionFee_pay_fee_$def_verify$0$anon28$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $TransactionFee_TransactionFee_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 167613) 167639))) inline$$TransactionFee_pay_fee_$def_verify$0$anon28$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 167549) 167613) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 167549) 167559) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 167371) 167549)) inline$$WritebackToGlobal$0$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 167427) 167549))) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 167335) 167427) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 167335) 167371) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 167198) 167335)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon42_Then_correct  (=> (and (= inline$$TransactionFee_pay_fee_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 167649) 167335)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) call5formal@$ret0@0@@0)) (and (=> (= (ControlFlow 0 167184) 167649) inline$$TransactionFee_pay_fee_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 167184) 167198) inline$$TransactionFee_pay_fee_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon40_Else_correct  (=> (and (not $abort_flag@4@@2) (= (ControlFlow 0 167190) 167184)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@5@@2 true) (= $abort_code@7@@2 $abort_code@6@@2)) (and (= $TransactionFee_TransactionFee_$memory@0@@1 $TransactionFee_TransactionFee_$memory) (= (ControlFlow 0 166595) 167751))) anon0$2_correct@@1)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon5_correct  (=> (and (= $abort_code@6@@2 $abort_code@1@@2) (= (ControlFlow 0 167729) 166595)) inline$$TransactionFee_pay_fee_$def_verify$0$Abort_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 167727) 167729)) inline$$TransactionFee_pay_fee_$def_verify$0$anon5_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 167737) 167729) inline$$TransactionFee_pay_fee_$def_verify$0$anon5_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon30_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 167721) 167737) inline$$TransactionFee_pay_fee_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 167721) 167727) inline$$TransactionFee_pay_fee_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon11_correct  (=> (and (= $abort_code@6@@2 $abort_code@2@@1) (= (ControlFlow 0 167705) 166595)) inline$$TransactionFee_pay_fee_$def_verify$0$Abort_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 167703) 167705)) inline$$TransactionFee_pay_fee_$def_verify$0$anon11_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 167713) 167705) inline$$TransactionFee_pay_fee_$def_verify$0$anon11_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon33_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 167697) 167713) inline$$TransactionFee_pay_fee_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 167697) 167703) inline$$TransactionFee_pay_fee_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon21_correct  (=> (and (= $abort_code@6@@2 $abort_code@4@@2) (= (ControlFlow 0 167681) 166595)) inline$$TransactionFee_pay_fee_$def_verify$0$Abort_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 167679) 167681)) inline$$TransactionFee_pay_fee_$def_verify$0$anon21_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 167689) 167681) inline$$TransactionFee_pay_fee_$def_verify$0$anon21_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon38_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 167673) 167689) inline$$TransactionFee_pay_fee_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 167673) 167679) inline$$TransactionFee_pay_fee_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon25_correct  (=> (and (= $abort_code@6@@2 $abort_code@5@@2) (= (ControlFlow 0 167661) 166595)) inline$$TransactionFee_pay_fee_$def_verify$0$Abort_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 167659) 167661)) inline$$TransactionFee_pay_fee_$def_verify$0$anon25_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 167669) 167661) inline$$TransactionFee_pay_fee_$def_verify$0$anon25_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon40_Then_correct  (=> $abort_flag@4@@2 (and (=> (= (ControlFlow 0 167653) 167669) inline$$TransactionFee_pay_fee_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 167653) 167659) inline$$TransactionFee_pay_fee_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon38_Else$2_correct  (and (=> (= (ControlFlow 0 167127) (- 0 199308)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@4@@2) (=> $abort_flag@4@@2 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> $abort_flag@4@@2 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@5@@2 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value)))))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@0) (let ((va@@106 (|v#$Vector| call5formal@$ret0@0@@0)))
(let ((l@@106 (|l#$ValueArray| va@@106)))
 (and (and (<= 0 l@@106) (<= l@@106 $MAX_U64)) (forall ((x@@106 Int) ) (!  (=> (or (< x@@106 0) (>= x@@106 l@@106)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 167127) 167653) inline$$TransactionFee_pay_fee_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 167127) 167190) inline$$TransactionFee_pay_fee_$def_verify$0$anon40_Else_correct)))))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 167115) 167127)) inline$$TransactionFee_pay_fee_$def_verify$0$anon38_Else$2_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $TransactionFee_TransactionFee_balance) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $TransactionFee_TransactionFee_balance))) (= (ControlFlow 0 167077) 167115))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon38_Else_correct  (=> (and (not $abort_flag@3@@2) (= (ControlFlow 0 167083) 167077)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_code@4@@2 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@3@@2 true) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 166947) 167673) inline$$TransactionFee_pay_fee_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 166947) 167083) inline$$TransactionFee_pay_fee_$def_verify$0$anon38_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 166945) 166947)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0))) (= $abort_code@4@@2 $abort_code@2@@1)) (and (= $abort_flag@3@@2 $abort_flag@2@@2) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 166893) 167673) inline$$TransactionFee_pay_fee_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 166893) 167083) inline$$TransactionFee_pay_fee_$def_verify$0$anon38_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1@@0)) (and (=> (= (ControlFlow 0 166863) 166945) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 166863) 166893) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (=> (= inline$$BorrowGlobal$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (and (=> (= (ControlFlow 0 166857) (- 0 199123)) true) (=> (= (ControlFlow 0 166857) 166863) inline$$BorrowGlobal$0$anon0_correct@@0)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon37_Else_correct  (=> (and (not $abort_flag@2@@2) (= (ControlFlow 0 166953) 166857)) inline$$BorrowGlobal$0$Entry_correct@@0)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon37_Then_correct  (=> $abort_flag@2@@2 (=> (and (= $abort_code@6@@2 $abort_code@2@@1) (= (ControlFlow 0 167693) 166595)) inline$$TransactionFee_pay_fee_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 166714) 167693) inline$$TransactionFee_pay_fee_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 166714) 166953) inline$$TransactionFee_pay_fee_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 166724) 167693) inline$$TransactionFee_pay_fee_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 166724) 166953) inline$$TransactionFee_pay_fee_$def_verify$0$anon37_Else_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon0_correct@@0  (=> (and (not $abort_flag@2@@2) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1@@0 ($Address 186537453))) (and (=> (= (ControlFlow 0 166708) 166724) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 166708) 166714) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Else_correct@@0)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon35_Then_correct  (=> (and (|b#$Boolean| inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@2) (= (ControlFlow 0 166738) 166708)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon0_correct@@0)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon16_correct  (=> (and (= $abort_code@6@@2 $abort_code@3@@2) (= (ControlFlow 0 166591) 166595)) inline$$TransactionFee_pay_fee_$def_verify$0$Abort_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 166589) 166591)) inline$$TransactionFee_pay_fee_$def_verify$0$anon16_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 166603) 166591) inline$$TransactionFee_pay_fee_$def_verify$0$anon16_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon35_Else_correct  (=> (and (not (|b#$Boolean| inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@2)) (= $abort_code@3@@2 (|i#$Integer| call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 166583) 166603) inline$$TransactionFee_pay_fee_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 166583) 166589) inline$$TransactionFee_pay_fee_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon33_Else_correct  (=> (not $abort_flag@2@@2) (and (=> (= (ControlFlow 0 166571) 166738) inline$$TransactionFee_pay_fee_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 166571) 166583) inline$$TransactionFee_pay_fee_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon32_Else_correct  (=> (not $abort_flag@1@@2) (=> (and (and (and (= inline$$TransactionFee_pay_fee_$def_verify$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@2)) (and (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@16) (>= (|i#$Integer| call3formal@$ret0@0@@16) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@16) $MAX_U64))) (and (=> (= (ControlFlow 0 166565) 167697) inline$$TransactionFee_pay_fee_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 166565) 166571) inline$$TransactionFee_pay_fee_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon32_Then_correct  (=> $abort_flag@1@@2 (=> (and (= $abort_code@6@@2 $abort_code@1@@2) (= (ControlFlow 0 167717) 166595)) inline$$TransactionFee_pay_fee_$def_verify$0$Abort_correct))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@3  (=> (and (= $abort_flag@1@@2 $abort_flag@0@@3) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@2 inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@3)) (and (=> (= (ControlFlow 0 166523) 167717) inline$$TransactionFee_pay_fee_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 166523) 166565) inline$$TransactionFee_pay_fee_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct@@3  (=> (and (not true) (= (ControlFlow 0 166521) 166523)) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@3)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct@@3  (=> (= (ControlFlow 0 166531) 166523) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct@@3)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@3  (=> (and (not $abort_flag@0@@3) (= inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1@@3 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@4))))) (and (=> (= (ControlFlow 0 166515) 166531) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct@@3) (=> (= (ControlFlow 0 166515) 166521) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct@@3)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@3  (=> (and (and $abort_flag@0@@3 (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1@@2 $Error)) (and (= $abort_flag@1@@2 true) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2@@2 inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1@@2))) (and (=> (= (ControlFlow 0 166539) 167717) inline$$TransactionFee_pay_fee_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 166539) 166565) inline$$TransactionFee_pay_fee_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@4  (=> (not true) (and (=> (= (ControlFlow 0 166461) 166539) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@3) (=> (= (ControlFlow 0 166461) 166515) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@3)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@4  (and (=> (= (ControlFlow 0 166471) 166539) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct@@3) (=> (= (ControlFlow 0 166471) 166515) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct@@3))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@4  (=> (and (not $abort_flag@0@@3) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1@@4 ($Address 186537453))) (and (=> (= (ControlFlow 0 166455) 166471) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 166455) 166461) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct@@4)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct@@3  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 166485) 166455)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct@@4)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon30_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 166553) 166485)) inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct@@3)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@3) (=> (and (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 166199) 167721) inline$$TransactionFee_pay_fee_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 166199) 166553) inline$$TransactionFee_pay_fee_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 166163) 166199)) inline$$TransactionFee_pay_fee_$def_verify$0$anon2$1_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 167745) 166199) inline$$TransactionFee_pay_fee_$def_verify$0$anon2$1_correct)))
(let ((inline$$TransactionFee_pay_fee_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 166157) 167745) inline$$TransactionFee_pay_fee_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 166157) 166163) inline$$TransactionFee_pay_fee_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (forall (($inv_addr@@15 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15)) (let ((va@@107 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))))
(let ((l@@107 (|l#$ValueArray| va@@107)))
 (and (and (<= 0 l@@107) (<= l@@107 $MAX_U64)) (forall ((x@@107 Int) ) (!  (=> (or (< x@@107 0) (>= x@@107 l@@107)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))
)) (=> (and (and (forall (($inv_addr@@16 Int) ($inv_tv0@@10 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@16)) (let ((va@@108 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@16))))
(let ((l@@108 (|l#$ValueArray| va@@108)))
 (and (and (<= 0 l@@108) (<= l@@108 $MAX_U64)) (forall ((x@@108 Int) ) (!  (=> (or (< x@@108 0) (>= x@@108 l@@108)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@16))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@16))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@16))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@16))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@16))
)) (forall (($inv_addr@@17 Int) ($inv_tv0@@11 T@$TypeValue) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17)) (let ((va@@109 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))))
(let ((l@@109 (|l#$ValueArray| va@@109)))
 (and (and (<= 0 l@@109) (<= l@@109 $MAX_U64)) (forall ((x@@109 Int) ) (!  (=> (or (< x@@109 0) (>= x@@109 l@@109)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_balance)) (let ((va@@110 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_balance))))
(let ((l@@110 (|l#$ValueArray| va@@110)))
 (and (and (<= 0 l@@110) (<= l@@110 $MAX_U64)) (forall ((x@@110 Int) ) (!  (=> (or (< x@@110 0) (>= x@@110 l@@110)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_balance))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) $MAX_U64)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_preburn)) (let ((va@@111 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_preburn))))
(let ((l@@111 (|l#$ValueArray| va@@111)))
 (and (and (<= 0 l@@111) (<= l@@111 $MAX_U64)) (forall ((x@@111 Int) ) (!  (=> (or (< x@@111 0) (>= x@@111 l@@111)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_preburn))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn)) (let ((va@@112 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))))
(let ((l@@112 (|l#$ValueArray| va@@112)))
 (and (and (<= 0 l@@112) (<= l@@112 $MAX_U64)) (forall ((x@@112 Int) ) (!  (=> (or (< x@@112 0) (>= x@@112 l@@112)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64))))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@17))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (= (ControlFlow 0 167749) 166157)))) inline$$TransactionFee_pay_fee_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@4  (=> (and (and (and (and (and ((_ is $Vector) coin) (let ((va@@113 (|v#$Vector| coin)))
(let ((l@@113 (|l#$ValueArray| va@@113)))
 (and (and (<= 0 l@@113) (<= l@@113 $MAX_U64)) (forall ((x@@113 Int) ) (!  (=> (or (< x@@113 0) (>= x@@113 l@@113)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 165351) 167749)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 197484) 165351) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
