(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $VASP_ChildVASP $VASP_ParentVASP)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@0) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@0))
)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $VASP_ChildVASP_$memory () T@$Memory)
(declare-fun inline$$VASP_has_account_limits_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$AccountLimits_has_window_published_$def$0$$t2@1 () T@$Value)
(declare-fun $AccountLimits_Window_$memory () T@$Memory)
(declare-fun $tv0@@1 () T@$TypeValue)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun $VASP_ParentVASP_$memory () T@$Memory)
(declare-fun addr () T@$Value)
(declare-fun $abort_code@1 () Int)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 85407) (let ((anon0$2_correct  (=> (= (ControlFlow 0 73263) (- 0 86494)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean (forall ((a T@$Value) )  (=> ((_ is $Address) a) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a))))))))))))))
(let ((inline$$VASP_has_account_limits_$def_verify$0$Abort_correct  (=> (= inline$$VASP_has_account_limits_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1 true) (= (ControlFlow 0 73227) 73263)) anon0$2_correct))))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 73237) 73227)) inline$$VASP_has_account_limits_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 73247) 73227) inline$$VASP_has_account_limits_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon12_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 73231) 73247) inline$$VASP_has_account_limits_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 73231) 73237) inline$$VASP_has_account_limits_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon14_Then_correct  (=> (and $abort_flag@0 (= (ControlFlow 0 73221) 73227)) inline$$VASP_has_account_limits_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1 $abort_flag@0) (= (ControlFlow 0 73209) 73263)) anon0$2_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 73207) 73209)) inline$$VASP_has_account_limits_$def_verify$0$anon10_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 73217) 73209) inline$$VASP_has_account_limits_$def_verify$0$anon10_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon14_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 73201) 73217) inline$$VASP_has_account_limits_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 73201) 73207) inline$$VASP_has_account_limits_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AccountLimits_has_window_published_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 73159) 73221) inline$$VASP_has_account_limits_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 73159) 73201) inline$$VASP_has_account_limits_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$AccountLimits_has_window_published_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 73169) 73221) inline$$VASP_has_account_limits_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 73169) 73201) inline$$VASP_has_account_limits_$def_verify$0$anon14_Else_correct))))
(let ((inline$$AccountLimits_has_window_published_$def$0$anon2$1_correct  (=> (= inline$$AccountLimits_has_window_published_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1) (|a#$Address| call3formal@$ret0@0)))) (and (=> (= (ControlFlow 0 73153) 73169) inline$$AccountLimits_has_window_published_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 73153) 73159) inline$$AccountLimits_has_window_published_$def$0$anon6_Else_correct)))))
(let ((inline$$AccountLimits_has_window_published_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 73095) 73153)) inline$$AccountLimits_has_window_published_$def$0$anon2$1_correct)))
(let ((inline$$AccountLimits_has_window_published_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 73177) 73153) inline$$AccountLimits_has_window_published_$def$0$anon2$1_correct)))
(let ((inline$$AccountLimits_has_window_published_$def$0$anon0_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 73089) 73177) inline$$AccountLimits_has_window_published_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 73089) 73095) inline$$AccountLimits_has_window_published_$def$0$anon5_Else_correct)))))
(let ((inline$$AccountLimits_has_window_published_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0) (= (ControlFlow 0 73183) 73089)) inline$$AccountLimits_has_window_published_$def$0$anon0_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon12_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 73191) 73183)) inline$$AccountLimits_has_window_published_$direct_inter$0$anon0_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr)))))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr)))))))))) (= $abort_code@1 (|i#$Integer| ($Integer 7)))))) (=> (and (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) addr (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $VASP_ChildVASP_parent_vasp_addr)))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (forall ((a@@0 T@$Value) )  (=> ((_ is $Address) a@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@0))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@0)))))))))))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean (forall ((parent T@$Value) )  (=> ((_ is $Address) parent) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Address) call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 72907) 73231) inline$$VASP_has_account_limits_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 72907) 73191) inline$$VASP_has_account_limits_$def_verify$0$anon12_Else_correct)))))))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 72871) 72907)) inline$$VASP_has_account_limits_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 73255) 72907) inline$$VASP_has_account_limits_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_has_account_limits_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 72865) 73255) inline$$VASP_has_account_limits_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 72865) 72871) inline$$VASP_has_account_limits_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (=> (and (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (|b#$Boolean| ($Boolean (forall ((window_addr T@$Value) )  (=> ((_ is $Address) window_addr) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) $AccountLimits_Window_limit_address))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((child_addr T@$Value) )  (=> ((_ is $Address) child_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 73261) 72865))) inline$$VASP_has_account_limits_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 72414) 73261)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 85407) 72414) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$VASP_is_child_$def_verify$0$$t2@1 () T@$Value)
(declare-fun addr@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 86547) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 73696) (- 0 86869)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 73696) (- 0 86878)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 73696) (- 0 86887)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_is_child_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_is_child_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0))))))) (and (=> (= (ControlFlow 0 73696) (- 0 86905)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((a@@1 T@$Value) )  (=> ((_ is $Address) a@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@1))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@1)))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((a@@2 T@$Value) )  (=> ((_ is $Address) a@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@2))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@2))))))))))) (=> (= (ControlFlow 0 73696) (- 0 86945)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((parent@@0 T@$Value) )  (=> ((_ is $Address) parent@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@0)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@0)))) $VASP_ParentVASP_num_children)))))))))))))))))))))))
(let ((inline$$VASP_is_child_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 73670) 73696)) anon0$2_correct@@0)))
(let ((inline$$VASP_is_child_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 73680) 73696) anon0$2_correct@@0)))
(let ((inline$$VASP_is_child_$def_verify$0$anon2$1_correct  (=> (= inline$$VASP_is_child_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (and (=> (= (ControlFlow 0 73664) 73680) inline$$VASP_is_child_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 73664) 73670) inline$$VASP_is_child_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$VASP_is_child_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 73618) 73664)) inline$$VASP_is_child_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_is_child_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 73688) 73664) inline$$VASP_is_child_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_is_child_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 73612) 73688) inline$$VASP_is_child_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 73612) 73618) inline$$VASP_is_child_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@2))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@2))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((child_addr@@0 T@$Value) )  (=> ((_ is $Address) child_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@0)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 73694) 73612)) inline$$VASP_is_child_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) addr@@0) (= (ControlFlow 0 73427) 73694)) anon0$1_correct@@0)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 86547) 73427) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$VASP_is_parent_$def_verify$0$$t2@1 () T@$Value)
(declare-fun addr@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 87000) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 74056) (- 0 87322)) (=> (|b#$Boolean| ($Boolean false)) false)) (=> (=> (|b#$Boolean| ($Boolean false)) false) (and (=> (= (ControlFlow 0 74056) (- 0 87331)) (=> false (|b#$Boolean| ($Boolean false)))) (=> (=> false (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 74056) (- 0 87340)) (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_is_parent_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_is_parent_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))) (and (=> (= (ControlFlow 0 74056) (- 0 87358)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((a@@3 T@$Value) )  (=> ((_ is $Address) a@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@3))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@3)))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((a@@4 T@$Value) )  (=> ((_ is $Address) a@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@4))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@4))))))))))) (=> (= (ControlFlow 0 74056) (- 0 87398)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((parent@@1 T@$Value) )  (=> ((_ is $Address) parent@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@1)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@1)))) $VASP_ParentVASP_num_children)))))))))))))))))))))))
(let ((inline$$VASP_is_parent_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 74030) 74056)) anon0$2_correct@@1)))
(let ((inline$$VASP_is_parent_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 74040) 74056) anon0$2_correct@@1)))
(let ((inline$$VASP_is_parent_$def_verify$0$anon2$1_correct  (=> (= inline$$VASP_is_parent_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (and (=> (= (ControlFlow 0 74024) 74040) inline$$VASP_is_parent_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 74024) 74030) inline$$VASP_is_parent_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$VASP_is_parent_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 73978) 74024)) inline$$VASP_is_parent_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_is_parent_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 74048) 74024) inline$$VASP_is_parent_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_is_parent_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 73972) 74048) inline$$VASP_is_parent_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 73972) 73978) inline$$VASP_is_parent_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((child_addr@@1 T@$Value) )  (=> ((_ is $Address) child_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@1)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 74054) 73972)) inline$$VASP_is_parent_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) addr@@1) (= (ControlFlow 0 73787) 74054)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 87000) 73787) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@6 () Bool)
(declare-fun inline$$VASP_is_same_vasp_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun addr1 () T@$Value)
(declare-fun addr2 () T@$Value)
(declare-fun inline$$VASP_is_same_vasp_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_flag@5 () Bool)
(declare-fun |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$3@2| () T@$Value)
(declare-fun |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$3@1| () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$2@1| () T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun inline$$VASP_is_same_vasp_$def_verify$0$$t10@1 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$VASP_is_same_vasp_$def_verify$0$$t7@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 87454) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 75152) (- 0 89768)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6) (and (=> (= (ControlFlow 0 75152) (- 0 89777)) (=> $abort_flag@6 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@6 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 75152) (- 0 89786)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_is_same_vasp_$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) addr1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) addr2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (=> (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_is_same_vasp_$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) addr1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) addr2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) $VASP_ChildVASP_parent_vasp_addr))))))))))) (and (=> (= (ControlFlow 0 75152) (- 0 89808)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean (forall ((a@@5 T@$Value) )  (=> ((_ is $Address) a@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@5))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@5)))))))))))) (=> (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean (forall ((a@@6 T@$Value) )  (=> ((_ is $Address) a@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@6))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@6))))))))))) (=> (= (ControlFlow 0 75152) (- 0 89848)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean (forall ((parent@@2 T@$Value) )  (=> ((_ is $Address) parent@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@2)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@2)))) $VASP_ParentVASP_num_children)))))))))))))))))))))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$Abort_correct  (=> (and (and (= inline$$VASP_is_same_vasp_$def_verify$0$$ret0@1 $Error) (= $abort_flag@6 true)) (and (= inline$$VASP_is_same_vasp_$def_verify$0$$ret0@2 inline$$VASP_is_same_vasp_$def_verify$0$$ret0@1) (= (ControlFlow 0 75040) 75152))) anon0$2_correct@@2)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 75118) 75040)) inline$$VASP_is_same_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 75128) 75040) inline$$VASP_is_same_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon35_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 75112) 75128) inline$$VASP_is_same_vasp_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 75112) 75118) inline$$VASP_is_same_vasp_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 75098) 75040)) inline$$VASP_is_same_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 75108) 75040) inline$$VASP_is_same_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon38_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 75092) 75108) inline$$VASP_is_same_vasp_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 75092) 75098) inline$$VASP_is_same_vasp_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 75058) 75040)) inline$$VASP_is_same_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 75068) 75040) inline$$VASP_is_same_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon42_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 75052) 75068) inline$$VASP_is_same_vasp_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 75052) 75058) inline$$VASP_is_same_vasp_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 75032) 75040)) inline$$VASP_is_same_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 75048) 75040) inline$$VASP_is_same_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon44_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 75026) 75048) inline$$VASP_is_same_vasp_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 75026) 75032) inline$$VASP_is_same_vasp_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon32_correct  (=> (= $abort_flag@6 $abort_flag@5) (=> (and (= inline$$VASP_is_same_vasp_$def_verify$0$$ret0@2 |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$3@2|) (= (ControlFlow 0 74964) 75152)) anon0$2_correct@@2))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 74962) 74964)) inline$$VASP_is_same_vasp_$def_verify$0$anon32_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 74972) 74964) inline$$VASP_is_same_vasp_$def_verify$0$anon32_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon28_correct  (=> (and (= |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$3@2| |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$3@1|) (= $abort_flag@5 $abort_flag@4)) (and (=> (= (ControlFlow 0 75014) 74972) inline$$VASP_is_same_vasp_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 75014) 74962) inline$$VASP_is_same_vasp_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 75012) 75014)) inline$$VASP_is_same_vasp_$def_verify$0$anon28_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 75022) 75014) inline$$VASP_is_same_vasp_$def_verify$0$anon28_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon44_Else_correct  (=> (and (not $abort_flag@4) (= |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$3@1| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 call3formal@$ret0@0@@1)))) (and (=> (= (ControlFlow 0 75006) 75022) inline$$VASP_is_same_vasp_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 75006) 75012) inline$$VASP_is_same_vasp_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon42_Else_correct  (=> (and (and (and (not $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))))))))) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2))))))))))) (=> $abort_flag@4 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))))))))) (= $abort_code@4 (|i#$Integer| ($Integer 7))))))) (and (and (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) addr2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) $VASP_ChildVASP_parent_vasp_addr)))))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (forall ((a@@7 T@$Value) )  (=> ((_ is $Address) a@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@7))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@7)))))))))))) (and (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (forall ((parent@@3 T@$Value) )  (=> ((_ is $Address) parent@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@3)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@3)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Address) call3formal@$ret0@0@@1)))) (and (=> (= (ControlFlow 0 74992) 75026) inline$$VASP_is_same_vasp_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 74992) 75006) inline$$VASP_is_same_vasp_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon41_Then_correct  (=> (and (and (and (|b#$Boolean| |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$2@1|) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))))))))) $abort_flag@3)) (and (=> $abort_flag@3 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1))))))))))) (=> $abort_flag@3 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))))))))) (= $abort_code@3 (|i#$Integer| ($Integer 7))))))) (and (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) addr1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $VASP_ChildVASP_parent_vasp_addr)))))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (forall ((a@@8 T@$Value) )  (=> ((_ is $Address) a@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@8))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@8)))))))))))) (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (forall ((parent@@4 T@$Value) )  (=> ((_ is $Address) parent@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@4)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@4)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Address) call3formal@$ret0@0@@0)))) (and (=> (= (ControlFlow 0 74986) 75052) inline$$VASP_is_same_vasp_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 74986) 74992) inline$$VASP_is_same_vasp_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon30_correct  (=> (and (= |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$3@2| inline$$VASP_is_same_vasp_$def_verify$0$$t10@1) (= $abort_flag@5 $abort_flag@2)) (and (=> (= (ControlFlow 0 74952) 74972) inline$$VASP_is_same_vasp_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 74952) 74962) inline$$VASP_is_same_vasp_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 74950) 74952)) inline$$VASP_is_same_vasp_$def_verify$0$anon30_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 74980) 74952) inline$$VASP_is_same_vasp_$def_verify$0$anon30_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon41_Else_correct  (=> (and (not (|b#$Boolean| |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$2@1|)) (= inline$$VASP_is_same_vasp_$def_verify$0$$t10@1 ($Boolean false))) (and (=> (= (ControlFlow 0 74942) 74980) inline$$VASP_is_same_vasp_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 74942) 74950) inline$$VASP_is_same_vasp_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon38_Else_correct  (=> (not $abort_flag@1@@0) (=> (and (= $abort_flag@2 $abort_flag@1@@0) (= |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$2@1| call3formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 75088) 74986) inline$$VASP_is_same_vasp_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 75088) 74942) inline$$VASP_is_same_vasp_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon37_Then_correct  (=> (|b#$Boolean| call3formal@$ret0@0@@3) (=> (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false)))) (=> (and (and (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr2)))))))))) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean (forall ((a@@9 T@$Value) )  (=> ((_ is $Address) a@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@9))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@9)))))))))))) (and (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean (forall ((parent@@5 T@$Value) )  (=> ((_ is $Address) parent@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@5)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@5)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 75082) 75092) inline$$VASP_is_same_vasp_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 75082) 75088) inline$$VASP_is_same_vasp_$def_verify$0$anon38_Else_correct)))))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon16_correct  (=> (and (= $abort_flag@2 $abort_flag@0@@0) (= |inline$$VASP_is_same_vasp_$def_verify$0$tmp#$2@1| inline$$VASP_is_same_vasp_$def_verify$0$$t7@1)) (and (=> (= (ControlFlow 0 74896) 74986) inline$$VASP_is_same_vasp_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 74896) 74942) inline$$VASP_is_same_vasp_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 74894) 74896)) inline$$VASP_is_same_vasp_$def_verify$0$anon16_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 75076) 74896) inline$$VASP_is_same_vasp_$def_verify$0$anon16_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| call3formal@$ret0@0@@3)) (= inline$$VASP_is_same_vasp_$def_verify$0$$t7@1 ($Boolean false))) (and (=> (= (ControlFlow 0 74886) 75076) inline$$VASP_is_same_vasp_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 74886) 74894) inline$$VASP_is_same_vasp_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@0@@0) (and (=> (= (ControlFlow 0 74842) 75082) inline$$VASP_is_same_vasp_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 74842) 74886) inline$$VASP_is_same_vasp_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon4$2_correct  (=> (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@0) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean false)))) (=> (and (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))))))))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean (forall ((a@@10 T@$Value) )  (=> ((_ is $Address) a@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@10))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@10)))))))))))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean (forall ((parent@@6 T@$Value) )  (=> ((_ is $Address) parent@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@6)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@6)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 74836) 75112) inline$$VASP_is_same_vasp_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 74836) 74842) inline$$VASP_is_same_vasp_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 74766) 74836)) inline$$VASP_is_same_vasp_$def_verify$0$anon4$2_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 75136) 74836) inline$$VASP_is_same_vasp_$def_verify$0$anon4$2_correct)))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 74758) 75136) inline$$VASP_is_same_vasp_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 74758) 74766) inline$$VASP_is_same_vasp_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 75144) 75136) inline$$VASP_is_same_vasp_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 75144) 74766) inline$$VASP_is_same_vasp_$def_verify$0$anon34_Else_correct))))
(let ((inline$$VASP_is_same_vasp_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 74752) 75144) inline$$VASP_is_same_vasp_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 74752) 74758) inline$$VASP_is_same_vasp_$def_verify$0$anon33_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@5))
))) (and (|b#$Boolean| ($Boolean (forall ((child_addr@@2 T@$Value) )  (=> ((_ is $Address) child_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@2)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 75150) 74752))) inline$$VASP_is_same_vasp_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@2  (=> ((_ is $Address) addr1) (=> (and ((_ is $Address) addr2) (= (ControlFlow 0 74151) 75150)) anon0$1_correct@@2))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 87454) 74151) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun inline$$VASP_is_vasp_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun addr@@2 () T@$Value)
(declare-fun inline$$VASP_is_vasp_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun |inline$$VASP_is_vasp_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$VASP_is_vasp_$def_verify$0$$t4@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 89903) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 75888) (- 0 91004)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0) (and (=> (= (ControlFlow 0 75888) (- 0 91013)) (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 75888) (- 0 91022)) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_is_vasp_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2))))))))))) (=> (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_is_vasp_$def_verify$0$$ret0@2 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))))))))) (and (=> (= (ControlFlow 0 75888) (- 0 91042)) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean (forall ((a@@11 T@$Value) )  (=> ((_ is $Address) a@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@11))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@11)))))))))))) (=> (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean (forall ((a@@12 T@$Value) )  (=> ((_ is $Address) a@@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@12))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@12))))))))))) (=> (= (ControlFlow 0 75888) (- 0 91082)) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean (forall ((parent@@7 T@$Value) )  (=> ((_ is $Address) parent@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@7)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@7)))) $VASP_ParentVASP_num_children)))))))))))))))))))))))
(let ((inline$$VASP_is_vasp_$def_verify$0$Abort_correct  (=> (and (and (= inline$$VASP_is_vasp_$def_verify$0$$ret0@1 $Error) (= $abort_flag@3@@0 true)) (and (= inline$$VASP_is_vasp_$def_verify$0$$ret0@2 inline$$VASP_is_vasp_$def_verify$0$$ret0@1) (= (ControlFlow 0 75784) 75888))) anon0$2_correct@@3)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 75862) 75784)) inline$$VASP_is_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 75872) 75784) inline$$VASP_is_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon18_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 75856) 75872) inline$$VASP_is_vasp_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 75856) 75862) inline$$VASP_is_vasp_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 75776) 75784)) inline$$VASP_is_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 75792) 75784) inline$$VASP_is_vasp_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 75770) 75792) inline$$VASP_is_vasp_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 75770) 75776) inline$$VASP_is_vasp_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon16_correct  (=> (= $abort_flag@3@@0 $abort_flag@2@@0) (=> (and (= inline$$VASP_is_vasp_$def_verify$0$$ret0@2 |inline$$VASP_is_vasp_$def_verify$0$tmp#$1@1|) (= (ControlFlow 0 75758) 75888)) anon0$2_correct@@3))))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 75756) 75758)) inline$$VASP_is_vasp_$def_verify$0$anon16_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 75766) 75758) inline$$VASP_is_vasp_$def_verify$0$anon16_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@2@@0 $abort_flag@0@@1) (= |inline$$VASP_is_vasp_$def_verify$0$tmp#$1@1| inline$$VASP_is_vasp_$def_verify$0$$t4@1)) (and (=> (= (ControlFlow 0 75844) 75766) inline$$VASP_is_vasp_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 75844) 75756) inline$$VASP_is_vasp_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 75842) 75844)) inline$$VASP_is_vasp_$def_verify$0$anon10_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 75852) 75844) inline$$VASP_is_vasp_$def_verify$0$anon10_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon20_Then_correct  (=> (and (|b#$Boolean| call3formal@$ret0@0@@4) (= inline$$VASP_is_vasp_$def_verify$0$$t4@1 ($Boolean true))) (and (=> (= (ControlFlow 0 75834) 75852) inline$$VASP_is_vasp_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 75834) 75842) inline$$VASP_is_vasp_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon22_Else_correct  (=> (not $abort_flag@1@@1) (=> (and (= $abort_flag@2@@0 $abort_flag@1@@1) (= |inline$$VASP_is_vasp_$def_verify$0$tmp#$1@1| call3formal@$ret0@0@@5)) (and (=> (= (ControlFlow 0 75746) 75766) inline$$VASP_is_vasp_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 75746) 75756) inline$$VASP_is_vasp_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon20_Else_correct  (=> (not (|b#$Boolean| call3formal@$ret0@0@@4)) (=> (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1) (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false)))) (=> (and (and (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2))))))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((a@@13 T@$Value) )  (=> ((_ is $Address) a@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@13))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@13)))))))))))) (and (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((parent@@8 T@$Value) )  (=> ((_ is $Address) parent@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@8)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@8)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 75740) 75770) inline$$VASP_is_vasp_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 75740) 75746) inline$$VASP_is_vasp_$def_verify$0$anon22_Else_correct)))))))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 75732) 75834) inline$$VASP_is_vasp_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 75732) 75740) inline$$VASP_is_vasp_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon2$1_correct  (=> (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (=> (and (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2))))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean (forall ((a@@14 T@$Value) )  (=> ((_ is $Address) a@@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@14))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@14)))))))))))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean (forall ((parent@@9 T@$Value) )  (=> ((_ is $Address) parent@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@9)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@9)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 75726) 75856) inline$$VASP_is_vasp_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 75726) 75732) inline$$VASP_is_vasp_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 75690) 75726)) inline$$VASP_is_vasp_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 75880) 75726) inline$$VASP_is_vasp_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_is_vasp_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 75684) 75880) inline$$VASP_is_vasp_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 75684) 75690) inline$$VASP_is_vasp_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@15 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@6))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@7))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@7))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@7))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@7))
))) (and (|b#$Boolean| ($Boolean (forall ((child_addr@@3 T@$Value) )  (=> ((_ is $Address) child_addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@3)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 75886) 75684))) inline$$VASP_is_vasp_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and ((_ is $Address) addr@@2) (= (ControlFlow 0 75311) 75886)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 89903) 75311) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun addr@@3 () T@$Value)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun inline$$VASP_num_children_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 91137) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 76683) (- 0 92239)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))))))))) $abort_flag@2@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))))))))) $abort_flag@2@@1) (and (=> (= (ControlFlow 0 76683) (- 0 92258)) (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))))))))))) (=> (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))))))) (and (=> (= (ControlFlow 0 76683) (- 0 92277)) (=> $abort_flag@2@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))))))))) (= $abort_code@4@@0 (|i#$Integer| ($Integer 7)))))) (=> (=> $abort_flag@2@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))))))))) (= $abort_code@4@@0 (|i#$Integer| ($Integer 7))))) (and (=> (= (ControlFlow 0 76683) (- 0 92307)) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean (forall ((a@@15 T@$Value) )  (=> ((_ is $Address) a@@15) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@15))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@15)))))))))))) (=> (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean (forall ((a@@16 T@$Value) )  (=> ((_ is $Address) a@@16) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@16))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@16))))))))))) (=> (= (ControlFlow 0 76683) (- 0 92347)) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean (forall ((parent@@10 T@$Value) )  (=> ((_ is $Address) parent@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@10)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@10)))) $VASP_ParentVASP_num_children)))))))))))))))))))))))
(let ((inline$$VASP_num_children_$def_verify$0$Abort_correct  (=> (and (and (= inline$$VASP_num_children_$def_verify$0$$ret0@1 $Error) (= $abort_flag@2@@1 true)) (and (= $abort_code@4@@0 $abort_code@3@@0) (= (ControlFlow 0 76639) 76683))) anon0$2_correct@@4)))
(let ((inline$$VASP_num_children_$def_verify$0$anon5_correct  (=> (and (= $abort_code@3@@0 $abort_code@1@@0) (= (ControlFlow 0 76659) 76639)) inline$$VASP_num_children_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 76657) 76659)) inline$$VASP_num_children_$def_verify$0$anon5_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 76667) 76659) inline$$VASP_num_children_$def_verify$0$anon5_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 76651) 76667) inline$$VASP_num_children_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 76651) 76657) inline$$VASP_num_children_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$VASP_num_children_$def_verify$0$anon9_correct  (=> (and (= $abort_code@3@@0 $abort_code@2) (= (ControlFlow 0 76633) 76639)) inline$$VASP_num_children_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 76631) 76633)) inline$$VASP_num_children_$def_verify$0$anon9_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 76647) 76633) inline$$VASP_num_children_$def_verify$0$anon9_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 76625) 76647) inline$$VASP_num_children_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 76625) 76631) inline$$VASP_num_children_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$VASP_num_children_$def_verify$0$anon12_correct  (=> (= $abort_flag@2@@1 $abort_flag@1@@2) (=> (and (= $abort_code@4@@0 $abort_code@2) (= (ControlFlow 0 76613) 76683)) anon0$2_correct@@4))))
(let ((inline$$VASP_num_children_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 76611) 76613)) inline$$VASP_num_children_$def_verify$0$anon12_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 76621) 76613) inline$$VASP_num_children_$def_verify$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst)) $VASP_ParentVASP_num_children)) (and (=> (= (ControlFlow 0 76595) 76621) inline$$VASP_num_children_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 76595) 76611) inline$$VASP_num_children_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$VASP_num_children_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 76601) 76595)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@2 true) (= $abort_code@2 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 76541) 76625) inline$$VASP_num_children_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 76541) 76601) inline$$VASP_num_children_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 76539) 76541)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@6)))) (and (= $abort_flag@1@@2 $abort_flag@0@@2) (= $abort_code@2 $abort_code@1@@0))) (and (=> (= (ControlFlow 0 76487) 76625) inline$$VASP_num_children_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 76487) 76601) inline$$VASP_num_children_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@6)) (and (=> (= (ControlFlow 0 76469) 76539) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 76469) 76487) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 76463) (- 0 92064)) true) (=> (= (ControlFlow 0 76463) 76469) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$VASP_num_children_$def_verify$0$anon14_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 76547) 76463)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))))))))) $abort_flag@0@@2) (=> (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))))))) (=> $abort_flag@0@@2 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 7)))))) (=> (and (and (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) addr@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $VASP_ChildVASP_parent_vasp_addr)))))) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean (forall ((a@@17 T@$Value) )  (=> ((_ is $Address) a@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@17))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@17)))))))))))) (and (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean (forall ((parent@@11 T@$Value) )  (=> ((_ is $Address) parent@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@11)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@11)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Address) call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 76368) 76651) inline$$VASP_num_children_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 76368) 76547) inline$$VASP_num_children_$def_verify$0$anon14_Else_correct)))))))
(let ((inline$$VASP_num_children_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 76332) 76368)) inline$$VASP_num_children_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 76675) 76368) inline$$VASP_num_children_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_num_children_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 76326) 76675) inline$$VASP_num_children_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 76326) 76332) inline$$VASP_num_children_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@17 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@18 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@9))
))) (and (|b#$Boolean| ($Boolean (forall ((child_addr@@4 T@$Value) )  (=> ((_ is $Address) child_addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@4)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 76681) 76326))) inline$$VASP_num_children_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) addr@@3) (= (ControlFlow 0 75999) 76681)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 91137) 75999) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun addr@@4 () T@$Value)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun inline$$VASP_parent_address_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun |inline$$VASP_parent_address_$def_verify$0$tmp#$2@1| () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$VASP_parent_address_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$VASP_parent_address_$def_verify$0$$t6@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 92402) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 77939) (- 0 94016)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))))))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))))))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 77939) (- 0 94053)) (=> $abort_flag@5@@0 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))))))))))) (=> (=> $abort_flag@5@@0 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))))))))))) (and (=> (= (ControlFlow 0 77939) (- 0 94090)) (=> $abort_flag@5@@0 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))))))))) (= $abort_code@8 (|i#$Integer| ($Integer 7)))))) (=> (=> $abort_flag@5@@0 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))))))))) (= $abort_code@8 (|i#$Integer| ($Integer 7))))) (and (=> (= (ControlFlow 0 77939) (- 0 94138)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_parent_address_$def_verify$0$$ret0@2 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) addr@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $VASP_ChildVASP_parent_vasp_addr))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$VASP_parent_address_$def_verify$0$$ret0@2 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) addr@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $VASP_ChildVASP_parent_vasp_addr)))))) (and (=> (= (ControlFlow 0 77939) (- 0 94158)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((a@@18 T@$Value) )  (=> ((_ is $Address) a@@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@18))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@18)))))))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((a@@19 T@$Value) )  (=> ((_ is $Address) a@@19) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@19))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@19))))))))))) (=> (= (ControlFlow 0 77939) (- 0 94198)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((parent@@12 T@$Value) )  (=> ((_ is $Address) parent@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@12)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@12)))) $VASP_ParentVASP_num_children)))))))))))))))))))))))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon30_correct  (=> (and (and (= $abort_code@8 $abort_code@6) (= $abort_flag@5@@0 $abort_flag@4@@0)) (and (= inline$$VASP_parent_address_$def_verify$0$$ret0@2 |inline$$VASP_parent_address_$def_verify$0$tmp#$2@1|) (= (ControlFlow 0 77791) 77939))) anon0$2_correct@@5)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 77789) 77791)) inline$$VASP_parent_address_$def_verify$0$anon30_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 77799) 77791) inline$$VASP_parent_address_$def_verify$0$anon30_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon10_correct  (=> (= $abort_flag@4@@0 $abort_flag@0@@3) (=> (and (= $abort_code@6 $abort_code@1@@1) (= |inline$$VASP_parent_address_$def_verify$0$tmp#$2@1| addr@@4)) (and (=> (= (ControlFlow 0 77895) 77799) inline$$VASP_parent_address_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 77895) 77789) inline$$VASP_parent_address_$def_verify$0$anon45_Else_correct))))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 77893) 77895)) inline$$VASP_parent_address_$def_verify$0$anon10_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 77903) 77895) inline$$VASP_parent_address_$def_verify$0$anon10_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon34_Then_correct  (=> (|b#$Boolean| call3formal@$ret0@0@@7) (and (=> (= (ControlFlow 0 77885) 77903) inline$$VASP_parent_address_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 77885) 77893) inline$$VASP_parent_address_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon28_correct  (=> (= $abort_flag@4@@0 $abort_flag@3@@1) (=> (and (= $abort_code@6 $abort_code@5) (= |inline$$VASP_parent_address_$def_verify$0$tmp#$2@1| inline$$GetFieldFromValue$0$dst@1@@0)) (and (=> (= (ControlFlow 0 77779) 77799) inline$$VASP_parent_address_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 77779) 77789) inline$$VASP_parent_address_$def_verify$0$anon45_Else_correct))))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 77777) 77779)) inline$$VASP_parent_address_$def_verify$0$anon28_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 77807) 77779) inline$$VASP_parent_address_$def_verify$0$anon28_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $VASP_ChildVASP_parent_vasp_addr)) (and (=> (= (ControlFlow 0 77729) 77807) inline$$VASP_parent_address_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 77729) 77777) inline$$VASP_parent_address_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon42_Else_correct  (=> (and (not $abort_flag@3@@1) (= (ControlFlow 0 77735) 77729)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$VASP_parent_address_$def_verify$0$Abort_correct  (=> (= inline$$VASP_parent_address_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@8 $abort_code@7) (= $abort_flag@5@@0 true)) (and (= inline$$VASP_parent_address_$def_verify$0$$ret0@2 inline$$VASP_parent_address_$def_verify$0$$ret0@1) (= (ControlFlow 0 77474) 77939))) anon0$2_correct@@5))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon5_correct  (=> (and (= $abort_code@7 $abort_code@1@@1) (= (ControlFlow 0 77915) 77474)) inline$$VASP_parent_address_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 77913) 77915)) inline$$VASP_parent_address_$def_verify$0$anon5_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 77923) 77915) inline$$VASP_parent_address_$def_verify$0$anon5_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon32_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 77907) 77923) inline$$VASP_parent_address_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 77907) 77913) inline$$VASP_parent_address_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon13_correct  (=> (and (= $abort_code@7 $abort_code@2@@0) (= (ControlFlow 0 77839) 77474)) inline$$VASP_parent_address_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 77837) 77839)) inline$$VASP_parent_address_$def_verify$0$anon13_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 77847) 77839) inline$$VASP_parent_address_$def_verify$0$anon13_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon36_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 77831) 77847) inline$$VASP_parent_address_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 77831) 77837) inline$$VASP_parent_address_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon25_correct  (=> (and (= $abort_code@7 $abort_code@5) (= (ControlFlow 0 77819) 77474)) inline$$VASP_parent_address_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon43_Else_correct  (=> (and (not true) (= (ControlFlow 0 77817) 77819)) inline$$VASP_parent_address_$def_verify$0$anon25_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon43_Then_correct  (=> (= (ControlFlow 0 77827) 77819) inline$$VASP_parent_address_$def_verify$0$anon25_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon42_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 77811) 77827) inline$$VASP_parent_address_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 77811) 77817) inline$$VASP_parent_address_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@3@@1 true) (=> (and (= $abort_code@5 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 77675) 77811) inline$$VASP_parent_address_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 77675) 77735) inline$$VASP_parent_address_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 77673) 77675)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0) (=> (and (and (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))) (= $abort_flag@3@@1 $abort_flag@1@@3)) (and (= $abort_code@5 $abort_code@2@@0) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 77621) 77811) inline$$VASP_parent_address_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 77621) 77735) inline$$VASP_parent_address_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| addr@@4)) (and (=> (= (ControlFlow 0 77603) 77673) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 77603) 77621) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 77597) (- 0 93738)) true) (=> (= (ControlFlow 0 77597) 77603) inline$$GetGlobal$0$anon0_correct@@0))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon38_Then_correct  (=> (and (|b#$Boolean| call3formal@$ret0@0@@8) (= (ControlFlow 0 77681) 77597)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon19_correct  (=> (and (= $abort_code@7 $abort_code@3@@1) (= (ControlFlow 0 77494) 77474)) inline$$VASP_parent_address_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 77492) 77494)) inline$$VASP_parent_address_$def_verify$0$anon19_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 77502) 77494) inline$$VASP_parent_address_$def_verify$0$anon19_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon39_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 77486) 77502) inline$$VASP_parent_address_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 77486) 77492) inline$$VASP_parent_address_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon22_correct  (=> (and (= $abort_code@7 $abort_code@4@@1) (= (ControlFlow 0 77468) 77474)) inline$$VASP_parent_address_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 77466) 77468)) inline$$VASP_parent_address_$def_verify$0$anon22_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 77482) 77468) inline$$VASP_parent_address_$def_verify$0$anon22_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@2@@2) (= $abort_code@4@@1 (|i#$Integer| call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 77460) 77482) inline$$VASP_parent_address_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 77460) 77466) inline$$VASP_parent_address_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon38_Else_correct  (=> (not (|b#$Boolean| call3formal@$ret0@0@@8)) (=> (and (and (and (= inline$$VASP_parent_address_$def_verify$0$$t6@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@2)) (and (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 77450) 77486) inline$$VASP_parent_address_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 77450) 77460) inline$$VASP_parent_address_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@1@@3) (and (=> (= (ControlFlow 0 77438) 77681) inline$$VASP_parent_address_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 77438) 77450) inline$$VASP_parent_address_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon34_Else_correct  (=> (not (|b#$Boolean| call3formal@$ret0@0@@7)) (=> (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3) (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean false)))) (=> (and (and (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))))))) (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean (forall ((a@@20 T@$Value) )  (=> ((_ is $Address) a@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@20))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@20)))))))))))) (and (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean (forall ((parent@@13 T@$Value) )  (=> ((_ is $Address) parent@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@13)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@13)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 77432) 77831) inline$$VASP_parent_address_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 77432) 77438) inline$$VASP_parent_address_$def_verify$0$anon36_Else_correct)))))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon32_Else_correct  (=> (not $abort_flag@0@@3) (and (=> (= (ControlFlow 0 77424) 77885) inline$$VASP_parent_address_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 77424) 77432) inline$$VASP_parent_address_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon2$1_correct  (=> (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@3) (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean false)))) (=> (and (and (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4))))))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean (forall ((a@@21 T@$Value) )  (=> ((_ is $Address) a@@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@21))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@21)))))))))))) (and (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean (forall ((parent@@14 T@$Value) )  (=> ((_ is $Address) parent@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@14)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@14)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 77418) 77907) inline$$VASP_parent_address_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 77418) 77424) inline$$VASP_parent_address_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$VASP_parent_address_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 77382) 77418)) inline$$VASP_parent_address_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 77931) 77418) inline$$VASP_parent_address_$def_verify$0$anon2$1_correct)))
(let ((inline$$VASP_parent_address_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 77376) 77931) inline$$VASP_parent_address_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 77376) 77382) inline$$VASP_parent_address_$def_verify$0$anon31_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (and (and (forall (($inv_addr@@10 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@10)) (let ((va@@19 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@10))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@10))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@10))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@10))
)) (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@11))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@11))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@11))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@11))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@11))
))) (and (|b#$Boolean| ($Boolean (forall ((child_addr@@5 T@$Value) )  (=> ((_ is $Address) child_addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@5)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 77937) 77376))) inline$$VASP_parent_address_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@5  (=> (and ((_ is $Address) addr@@4) (= (ControlFlow 0 76814) 77937)) anon0$1_correct@@5)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 92402) 76814) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun child () T@$Value)
(declare-fun $abort_flag@12 () Bool)
(declare-fun parent@@15 () T@$Value)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun $abort_code@17 () Int)
(declare-fun $VASP_ParentVASP_$memory@1 () T@$Memory)
(declare-fun $VASP_ChildVASP_$memory@1 () T@$Memory)
(declare-fun $abort_flag@11 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun $abort_code@15 () Int)
(declare-fun $abort_code@16 () Int)
(declare-fun $VASP_ParentVASP_$memory@0 () T@$Memory)
(declare-fun $VASP_ChildVASP_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$VASP_ChildVASP_pack$0$$struct@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$VASP_publish_child_vasp_credential_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t27@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun $abort_code@13 () Int)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun $abort_code@10 () Int)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t15@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 94253) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 82010) (- 0 99074)) (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| child)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| child)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) $abort_flag@12) (and (=> (= (ControlFlow 0 82010) (- 0 99087)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) $abort_flag@12) (and (=> (= (ControlFlow 0 82010) (- 0 99105)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 256))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 256))))) $abort_flag@12) (and (=> (= (ControlFlow 0 82010) (- 0 99141)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) $abort_flag@12) (and (=> (= (ControlFlow 0 82010) (- 0 99162)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@12) (and (=> (= (ControlFlow 0 82010) (- 0 99191)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) $abort_flag@12) (and (=> (= (ControlFlow 0 82010) (- 0 99212)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))) $Roles_RoleId_role_id) ($Integer 6))))) $abort_flag@12)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))) $Roles_RoleId_role_id) ($Integer 6))))) $abort_flag@12) (and (=> (= (ControlFlow 0 82010) (- 0 99241)) (=> $abort_flag@12 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| child)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 256)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $Roles_RoleId_role_id) ($Integer 5)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))) $Roles_RoleId_role_id) ($Integer 6)))))))) (=> (=> $abort_flag@12 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| child)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 256)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $Roles_RoleId_role_id) ($Integer 5)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))) $Roles_RoleId_role_id) ($Integer 6))))))) (and (=> (= (ControlFlow 0 82010) (- 0 99402)) (=> $abort_flag@12 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| child)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) (= $abort_code@17 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) (= $abort_code@17 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 256))))) (= $abort_code@17 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) (= $abort_code@17 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@17 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) (= $abort_code@17 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))) $Roles_RoleId_role_id) ($Integer 6))))) (= $abort_code@17 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@12 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| child)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) (= $abort_code@17 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) (= $abort_code@17 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 256))))) (= $abort_code@17 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) (= $abort_code@17 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@17 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) (= $abort_code@17 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))) $Roles_RoleId_role_id) ($Integer 6))))) (= $abort_code@17 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 82010) (- 0 99640)) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory@1) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children)) (|i#$Integer| ($Integer 1))))))))) (=> (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory@1) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $VASP_ParentVASP_num_children)) (|i#$Integer| ($Integer 1)))))))) (and (=> (= (ControlFlow 0 82010) (- 0 99677)) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory@1) $EmptyTypeValueArray (|a#$Address| child)))))) (=> (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory@1) $EmptyTypeValueArray (|a#$Address| child))))) (=> (= (ControlFlow 0 82010) (- 0 99691)) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory@1) $EmptyTypeValueArray (|a#$Address| child)))) child (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory@1) $EmptyTypeValueArray (|a#$Address| child)))) $VASP_ChildVASP_parent_vasp_addr)) parent@@15)))))))))))))))))))))))))))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon98_Else_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 81738) (- 0 98612)) (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@0))))))))))) (and (=> (= (ControlFlow 0 81738) (- 0 98645)) (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@0)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (and (=> (= (ControlFlow 0 81738) (- 0 98687)) (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$a T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a)))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a)))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@0 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@0)))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@0)))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@0)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (=> (= $abort_code@17 $abort_code@15) (=> (and (and (= $VASP_ParentVASP_$memory@1 |inline$$WritebackToGlobal$0$m'@2|) (= $abort_flag@12 $abort_flag@11)) (and (= $VASP_ChildVASP_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 81738) 82010))) anon0$2_correct@@6)))))))))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct  (=> (= $abort_code@17 $abort_code@16) (=> (and (and (= $VASP_ParentVASP_$memory@1 $VASP_ParentVASP_$memory@0) (= $abort_flag@12 true)) (and (= $VASP_ChildVASP_$memory@1 $VASP_ChildVASP_$memory@0) (= (ControlFlow 0 79714) 82010))) anon0$2_correct@@6))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon7_correct  (=> (and (and (= $abort_code@16 $abort_code@1@@2) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81980) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 81978) 81980)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon7_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 81988) 81980) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon7_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon69_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 81972) 81988) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 81972) 81978) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon11_correct  (=> (and (and (= $abort_code@16 $abort_code@2@@1) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81960) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 81958) 81960)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon11_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 81968) 81960) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon11_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon71_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 81952) 81968) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 81952) 81958) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon15_correct  (=> (and (and (= $abort_code@16 $abort_code@3@@2) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81940) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 81938) 81940)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon15_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 81948) 81940) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon15_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon73_Then_correct  (=> $abort_flag@2@@3 (and (=> (= (ControlFlow 0 81932) 81948) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 81932) 81938) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon19_correct  (=> (and (and (= $abort_code@16 $abort_code@4@@2) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81920) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 81918) 81920)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon19_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 81928) 81920) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon19_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon75_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 81912) 81928) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 81912) 81918) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon23_correct  (=> (and (and (= $abort_code@16 $abort_code@5@@0) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81900) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 81898) 81900)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon23_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon78_Then_correct  (=> (= (ControlFlow 0 81908) 81900) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon23_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon77_Then_correct  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 81892) 81908) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 81892) 81898) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon31_correct  (=> (and (and (= $abort_code@16 $abort_code@6@@0) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81880) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 81878) 81880)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon31_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon82_Then_correct  (=> (= (ControlFlow 0 81888) 81880) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon31_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon81_Then_correct  (=> $abort_flag@5@@1 (and (=> (= (ControlFlow 0 81872) 81888) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 81872) 81878) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon35_correct  (=> (and (and (= $abort_code@16 $abort_code@8@@0) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81860) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 81858) 81860)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon35_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon84_Then_correct  (=> (= (ControlFlow 0 81868) 81860) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon35_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon83_Then_correct  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 81852) 81868) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 81852) 81858) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon39_correct  (=> (and (and (= $abort_code@16 $abort_code@9) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81840) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 81838) 81840)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon39_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon86_Then_correct  (=> (= (ControlFlow 0 81848) 81840) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon39_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon85_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 81832) 81848) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 81832) 81838) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon47_correct  (=> (and (and (= $abort_code@16 $abort_code@11) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81820) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon90_Else_correct  (=> (and (not true) (= (ControlFlow 0 81818) 81820)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon47_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon90_Then_correct  (=> (= (ControlFlow 0 81828) 81820) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon47_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 81812) 81828) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 81812) 81818) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon51_correct  (=> (and (and (= $abort_code@16 $abort_code@12) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81800) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 81798) 81800)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon51_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon92_Then_correct  (=> (= (ControlFlow 0 81808) 81800) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon51_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon91_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 81792) 81808) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 81792) 81798) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon59_correct  (=> (and (and (= $abort_code@16 $abort_code@14) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 81780) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon96_Else_correct  (=> (and (not true) (= (ControlFlow 0 81778) 81780)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon59_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon96_Then_correct  (=> (= (ControlFlow 0 81788) 81780) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon59_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon95_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 81772) 81788) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 81772) 81778) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon65_correct  (=> (and (and (= $abort_code@16 $abort_code@15) (= $VASP_ParentVASP_$memory@0 |inline$$WritebackToGlobal$0$m'@2|)) (and (= $VASP_ChildVASP_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 81750) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 81748) 81750)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon65_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon99_Then_correct  (=> (= (ControlFlow 0 81758) 81750) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon65_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon98_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 81742) 81758) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 81742) 81748) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon99_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@11 true) (=> (and (= $abort_code@15 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 81587) 81742) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 81587) 81738) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon98_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 81585) 81587)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$VASP_ChildVASP_pack$0$$struct@1))) (= $abort_flag@11 $abort_flag@10)) (and (= $abort_code@15 $abort_code@14) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 81535) 81742) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 81535) 81738) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon98_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| child)) (and (=> (= (ControlFlow 0 81593) 81585) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 81593) 81535) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 81381) (- 0 98497)) true) (=> (= (ControlFlow 0 81381) 81593) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$VASP_ChildVASP_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 81263) 81381)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$VASP_ChildVASP_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 81269) 81381) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$VASP_ChildVASP_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 81257) 81269) inline$$VASP_ChildVASP_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 81257) 81263) inline$$VASP_ChildVASP_pack$0$anon4_Else_correct)))))
(let ((inline$$VASP_ChildVASP_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 81249) 81381)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$VASP_ChildVASP_pack$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@10) (= inline$$VASP_ChildVASP_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 call3formal@$ret0@0@@10) 1)))) (and (=> (= (ControlFlow 0 81241) 81257) inline$$VASP_ChildVASP_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 81241) 81249) inline$$VASP_ChildVASP_pack$0$anon3_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon62$2_correct  (and (=> (= (ControlFlow 0 81275) (- 0 98286)) (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@1)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$addr@@2))))))))))) (and (=> (= (ControlFlow 0 81275) (- 0 98319)) (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@1)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$child_addr@@2)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (and (=> (= (ControlFlow 0 81275) (- 0 98363)) (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@1 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@1)))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@1)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@1)))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@1)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@2 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@2)))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@2)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@2)))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_child_vasp_credential_$def_verify$0$a@@2)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (=> (= (ControlFlow 0 81275) 81241) inline$$VASP_ChildVASP_pack$0$anon0_correct)))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $VASP_ParentVASP_$memory) (= (ControlFlow 0 80926) 81275)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon62$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $VASP_ParentVASP_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 80980) 81275))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon62$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 80916) 80980) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 80916) 80926) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 80734) 80916)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 80790) 80916))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 80698) 80790) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 80698) 80734) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 80561) 80698)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon97_Then_correct  (=> (and (= inline$$VASP_publish_child_vasp_credential_$def_verify$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)) (= (ControlFlow 0 81768) 80698)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 80547) 81768) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 80547) 80561) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon97_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon95_Else_correct  (=> (and (not $abort_flag@10) (= (ControlFlow 0 80553) 80547)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_code@14 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@10 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 80482) 81772) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 80482) 80553) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon95_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t27@1)) $MAX_U64) (= (ControlFlow 0 80480) 80482)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t27@1))) (=> (and (and (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t27@1)))) (= $abort_code@14 $abort_code@12)) (and (= $abort_flag@10 $abort_flag@9) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 80424) 81772) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 80424) 80553) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon95_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 80394) (- 0 97918)) true) (and (=> (= (ControlFlow 0 80394) 80480) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 80394) 80424) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon93_Then$1_correct  (=> (and (= inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t27@1 ($Integer 1)) (= (ControlFlow 0 80488) 80394)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 80291) 80488)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon93_Then$1_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon93_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@1) (= (ControlFlow 0 80297) 80291)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon56_correct  (=> (and (and (= $abort_code@16 $abort_code@13) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 80247) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 80245) 80247)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon56_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon94_Then_correct  (=> (= (ControlFlow 0 80255) 80247) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon56_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon93_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= $abort_code@13 (|i#$Integer| call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 80239) 80255) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 80239) 80245) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon91_Else_correct  (=> (not $abort_flag@9) (and (=> (= (ControlFlow 0 80227) 80297) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 80227) 80239) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Else$3_correct  (=> (and (and (and (= inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t24@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9)) (and (=> $abort_flag@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@11) (>= (|i#$Integer| call3formal@$ret0@0@@11) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@11) $MAX_U64))) (and (=> (= (ControlFlow 0 80221) 81792) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 80221) 80227) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct  (=> (and (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t22@1)))) (= (ControlFlow 0 80209) 80221)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Else$3_correct)))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 80195) (- 0 97769)) true) (=> (= (ControlFlow 0 80195) 80209) inline$$Lt$0$anon0_correct))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Else$2_correct  (=> (and (= inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t22@1 ($Integer 256)) (= (ControlFlow 0 80215) 80195)) inline$$Lt$0$Entry_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 80141) 80215)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Else$2_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $VASP_ParentVASP_num_children) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $VASP_ParentVASP_num_children))) (= (ControlFlow 0 80103) 80141))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 80109) 80103)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@8 true) (=> (and (= $abort_code@11 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 79973) 81812) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 79973) 80109) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 79971) 79973)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_flag@8 $abort_flag@7)) (and (= $abort_code@11 $abort_code@9) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 79919) 81812) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 79919) 80109) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon89_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@10)) (and (=> (= (ControlFlow 0 79889) 79971) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 79889) 79919) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 79883) (- 0 97570)) true) (=> (= (ControlFlow 0 79883) 79889) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon87_Then_correct  (=> (and (|b#$Boolean| call3formal@$ret0@0@@12) (= (ControlFlow 0 79979) 79883)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon44_correct  (=> (and (and (= $abort_code@16 $abort_code@10) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 79770) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 79768) 79770)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon44_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon88_Then_correct  (=> (= (ControlFlow 0 79778) 79770) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon44_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon87_Else_correct  (=> (and (not (|b#$Boolean| call3formal@$ret0@0@@12)) (= $abort_code@10 (|i#$Integer| call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 79762) 79778) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 79762) 79768) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon85_Else_correct  (=> (not $abort_flag@7) (and (=> (= (ControlFlow 0 79750) 79979) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 79750) 79762) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon83_Else_correct  (=> (not $abort_flag@6@@0) (=> (and (and (and (= inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t18@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7)) (and (=> $abort_flag@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@13) (>= (|i#$Integer| call3formal@$ret0@0@@13) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@13) $MAX_U64))) (and (=> (= (ControlFlow 0 79744) 81832) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 79744) 79750) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon85_Else_correct))))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon81_Else_correct  (=> (not $abort_flag@5@@1) (=> (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@0) (=> $abort_flag@6@@0 (|b#$Boolean| ($Boolean false)))) (=> (and (and (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@10))))))) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((a@@22 T@$Value) )  (=> ((_ is $Address) a@@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@22))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@22)))))))))))) (and (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((parent@@16 T@$Value) )  (=> ((_ is $Address) parent@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@16)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@16)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 79734) 81852) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 79734) 79744) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon83_Else_correct)))))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon79_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@1) (=> $abort_flag@5@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 parent@@15)))) ((_ is $Address) call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 79728) 81872) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 79728) 79734) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon81_Else_correct))))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon28_correct  (=> (and (and (= $abort_code@16 $abort_code@7@@0) (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory)) (and (= $VASP_ChildVASP_$memory@0 $VASP_ChildVASP_$memory) (= (ControlFlow 0 79710) 79714))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$Abort_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 79708) 79710)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon28_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon80_Then_correct  (=> (= (ControlFlow 0 79722) 79710) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon28_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon79_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@7@@0 (|i#$Integer| call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 79702) 79722) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 79702) 79708) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon77_Else_correct  (=> (not $abort_flag@4@@1) (and (=> (= (ControlFlow 0 79690) 79728) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 79690) 79702) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon75_Else$1_correct  (=> (and (and (and (= inline$$VASP_publish_child_vasp_credential_$def_verify$0$$t15@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@1)) (and (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@14) (>= (|i#$Integer| call3formal@$ret0@0@@14) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@14) $MAX_U64))) (and (=> (= (ControlFlow 0 79684) 81892) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 79684) 79690) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| call3formal@$ret0@0@@15)))) (= (ControlFlow 0 79672) 79684)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon75_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 79662) (- 0 97144)) true) (=> (= (ControlFlow 0 79662) 79672) inline$$Not$0$anon0_correct))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon75_Else_correct  (=> (and (not $abort_flag@3@@2) (= (ControlFlow 0 79678) 79662)) inline$$Not$0$Entry_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon73_Else_correct  (=> (not $abort_flag@2@@3) (=> (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2) (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false)))) (=> (and (and (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@16)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@16)))))))))) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((a@@23 T@$Value) )  (=> ((_ is $Address) a@@23) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@23))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@23)))))))))))) (and (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((parent@@17 T@$Value) )  (=> ((_ is $Address) parent@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@17)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@17)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 79624) 81912) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 79624) 79678) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon75_Else_correct)))))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon71_Else_correct  (=> (not $abort_flag@1@@4) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@3) (=> $abort_flag@2@@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 child)))) ((_ is $Address) call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 79618) 81932) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 79618) 79624) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon73_Else_correct))))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon69_Else_correct  (=> (not $abort_flag@0@@4) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) $abort_flag@1@@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))) $Roles_RoleId_role_id) ($Integer 6))))) $abort_flag@1@@4)) (and (=> $abort_flag@1@@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))) $Roles_RoleId_role_id) ($Integer 6))))))) (=> $abort_flag@1@@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child))))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| child)))) $Roles_RoleId_role_id) ($Integer 6))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 79612) 81952) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 79612) 79618) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon71_Else_correct))))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) $abort_flag@0@@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@0@@4)) (and (=> $abort_flag@0@@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $Roles_RoleId_role_id) ($Integer 5))))))) (=> $abort_flag@0@@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| parent@@15)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 79606) 81972) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 79606) 79612) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 79536) 79606)) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon4$2_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon68_Then_correct  (=> (= (ControlFlow 0 81996) 79606) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon4$2_correct)))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon67_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 79528) 81996) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 79528) 79536) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon67_Then_correct  (and (=> (= (ControlFlow 0 82004) 81996) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 82004) 79536) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon68_Else_correct))))
(let ((inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 79522) 82004) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 79522) 79528) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon67_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (forall (($inv_addr@@12 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12)) (let ((va@@21 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))
)) (=> (and (and (forall (($inv_addr@@13 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13)) (let ((va@@22 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@13))
)) (forall (($inv_addr@@14 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))
))) (and (|b#$Boolean| ($Boolean (forall ((child_addr@@6 T@$Value) )  (=> ((_ is $Address) child_addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@6)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 82008) 79522))) inline$$VASP_publish_child_vasp_credential_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@6  (=> ((_ is $Address) parent@@15) (=> (and ((_ is $Address) child) (= (ControlFlow 0 78112) 82008)) anon0$1_correct@@6))))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 94253) 78112) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun tc_account () T@$Value)
(declare-fun vasp () T@$Value)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun $VASP_ParentVASP_$memory@1@@0 () T@$Memory)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $VASP_ParentVASP_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun $abort_flag@5@@2 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$VASP_ParentVASP_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$VASP_publish_parent_vasp_credential_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$VASP_publish_parent_vasp_credential_$def_verify$0$$t9@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 99719) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 84365) (- 0 102956)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 84365) (- 0 102971)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 84365) (- 0 102992)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 84365) (- 0 103021)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 84365) (- 0 103038)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 84365) (- 0 103059)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 84365) (- 0 103088)) (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 84365) (- 0 103102)) (=> $abort_flag@7@@0 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) $Roles_RoleId_role_id) ($Integer 5)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))))))))) (=> (=> $abort_flag@7@@0 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) $Roles_RoleId_role_id) ($Integer 5)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))))) (and (=> (= (ControlFlow 0 84365) (- 0 103242)) (=> $abort_flag@7@@0 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 6))))))) (=> (=> $abort_flag@7@@0 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) (= $abort_code@10@@0 (|i#$Integer| ($Integer 6)))))) (and (=> (= (ControlFlow 0 84365) (- 0 103459)) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| vasp)))))) (=> (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| vasp))))) (and (=> (= (ControlFlow 0 84365) (- 0 103473)) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| vasp)))) $VASP_ParentVASP_num_children) ($Integer 0)))))) (=> (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| vasp)))) $VASP_ParentVASP_num_children) ($Integer 0))))) (and (=> (= (ControlFlow 0 84365) (- 0 103495)) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (forall ((a@@24 T@$Value) )  (=> ((_ is $Address) a@@24) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@24))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@24)))))))))))) (=> (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (forall ((a@@25 T@$Value) )  (=> ((_ is $Address) a@@25) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@25))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@25))))))))))) (=> (= (ControlFlow 0 84365) (- 0 103535)) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (forall ((parent@@18 T@$Value) )  (=> ((_ is $Address) parent@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory@1@@0) $EmptyTypeValueArray (|a#$Address| parent@@18)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@18)))) $VASP_ParentVASP_num_children)))))))))))))))))))))))))))))))))))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon53_Else_correct  (=> (not $abort_flag@6@@1) (and (=> (= (ControlFlow 0 84203) (- 0 102666)) (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$addr)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$addr@@0))))))))))) (and (=> (= (ControlFlow 0 84203) (- 0 102699)) (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$child_addr T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$child_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$child_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$child_addr)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$child_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$child_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$child_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$child_addr@@0)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (and (=> (= (ControlFlow 0 84203) (- 0 102743)) (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a)))) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a)))) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a@@0 T@$Value) )  (=> ((_ is $Address) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a@@0)))) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a@@0)))) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$a@@0)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (=> (and (and (= $abort_code@10@@0 $abort_code@8@@1) (= $abort_flag@7@@0 $abort_flag@6@@1)) (and (= $VASP_ParentVASP_$memory@1@@0 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 84203) 84365))) anon0$2_correct@@7))))))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@10@@0 $abort_code@9@@0) (= $abort_flag@7@@0 true)) (and (= $VASP_ParentVASP_$memory@1@@0 $VASP_ParentVASP_$memory@0@@0) (= (ControlFlow 0 83564) 84365))) anon0$2_correct@@7)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon7_correct  (=> (= $abort_code@9@@0 $abort_code@1@@3) (=> (and (= $VASP_ParentVASP_$memory@0@@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 84335) 83564)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 84333) 84335)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon7_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 84343) 84335) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon7_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon39_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 84327) 84343) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 84327) 84333) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon11_correct  (=> (= $abort_code@9@@0 $abort_code@2@@2) (=> (and (= $VASP_ParentVASP_$memory@0@@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 84315) 83564)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 84313) 84315)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon11_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 84323) 84315) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon11_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon41_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 84307) 84323) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 84307) 84313) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon15_correct  (=> (= $abort_code@9@@0 $abort_code@3@@3) (=> (and (= $VASP_ParentVASP_$memory@0@@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 84295) 83564)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 84293) 84295)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon15_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 84303) 84295) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon15_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon43_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 84287) 84303) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 84287) 84293) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon19_correct  (=> (= $abort_code@9@@0 $abort_code@4@@3) (=> (and (= $VASP_ParentVASP_$memory@0@@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 84275) 83564)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 84273) 84275)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon19_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 84283) 84275) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon19_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon45_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 84267) 84283) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 84267) 84273) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon23_correct  (=> (= $abort_code@9@@0 $abort_code@5@@1) (=> (and (= $VASP_ParentVASP_$memory@0@@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 84255) 83564)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 84253) 84255)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon23_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 84263) 84255) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon23_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon47_Then_correct  (=> $abort_flag@4@@2 (and (=> (= (ControlFlow 0 84247) 84263) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 84247) 84253) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon27_correct  (=> (= $abort_code@9@@0 $abort_code@6@@1) (=> (and (= $VASP_ParentVASP_$memory@0@@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 84235) 83564)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 84233) 84235)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon27_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 84243) 84235) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon27_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon49_Then_correct  (=> $abort_flag@5@@2 (and (=> (= (ControlFlow 0 84227) 84243) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 84227) 84233) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon35_correct  (=> (= $abort_code@9@@0 $abort_code@8@@1) (=> (and (= $VASP_ParentVASP_$memory@0@@0 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 84215) 83564)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 84213) 84215)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon35_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 84223) 84215) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon35_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon53_Then_correct  (=> $abort_flag@6@@1 (and (=> (= (ControlFlow 0 84207) 84223) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 84207) 84213) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@6@@1 true) (=> (and (= $abort_code@8@@1 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 84052) 84207) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 84052) 84203) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon53_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 84050) 84052)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1@@0 inline$$VASP_ParentVASP_pack$0$$struct@1))) (= $abort_flag@6@@1 $abort_flag@5@@2)) (and (= $abort_code@8@@1 $abort_code@6@@1) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 84000) 84207) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 84000) 84203) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon53_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| vasp)) (and (=> (= (ControlFlow 0 84058) 84050) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 84058) 84000) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 83846) (- 0 102551)) true) (=> (= (ControlFlow 0 83846) 84058) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$VASP_ParentVASP_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 83728) 83846)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$VASP_ParentVASP_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 83734) 83846) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$VASP_ParentVASP_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 83722) 83734) inline$$VASP_ParentVASP_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 83722) 83728) inline$$VASP_ParentVASP_pack$0$anon4_Else_correct)))))
(let ((inline$$VASP_ParentVASP_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 83714) 83846)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$VASP_ParentVASP_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$$t11@1) (>= (|i#$Integer| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$$t11@1) 0)) (<= (|i#$Integer| inline$$VASP_publish_parent_vasp_credential_$def_verify$0$$t11@1) $MAX_U64)) (= inline$$VASP_ParentVASP_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$VASP_publish_parent_vasp_credential_$def_verify$0$$t11@1) 1)))) (and (=> (= (ControlFlow 0 83706) 83722) inline$$VASP_ParentVASP_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 83706) 83714) inline$$VASP_ParentVASP_pack$0$anon3_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon51_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1@@0) (=> (and (= inline$$VASP_publish_parent_vasp_credential_$def_verify$0$$t11@1 ($Integer 0)) (= (ControlFlow 0 83740) 83706)) inline$$VASP_ParentVASP_pack$0$anon0_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon32_correct  (=> (= $abort_code@9@@0 $abort_code@7@@1) (=> (and (= $VASP_ParentVASP_$memory@0@@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 83560) 83564)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 83558) 83560)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon32_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon52_Then_correct  (=> (= (ControlFlow 0 83572) 83560) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon32_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon51_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (= $abort_code@7@@1 (|i#$Integer| call3formal@$ret0@0@@17))) (and (=> (= (ControlFlow 0 83552) 83572) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 83552) 83558) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@5@@2) (and (=> (= (ControlFlow 0 83540) 83740) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 83540) 83552) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon47_Else$1_correct  (=> (and (and (and (= inline$$VASP_publish_parent_vasp_credential_$def_verify$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@2)) (and (=> $abort_flag@5@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@17) (>= (|i#$Integer| call3formal@$ret0@0@@17) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@17) $MAX_U64))) (and (=> (= (ControlFlow 0 83534) 84227) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 83534) 83540) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@0  (=> (and (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| call3formal@$ret0@0@@18)))) (= (ControlFlow 0 83522) 83534)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon47_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 83512) (- 0 102335)) true) (=> (= (ControlFlow 0 83512) 83522) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon47_Else_correct  (=> (and (not $abort_flag@4@@2) (= (ControlFlow 0 83528) 83512)) inline$$Not$0$Entry_correct@@0)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon45_Else_correct  (=> (not $abort_flag@3@@3) (=> (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@2) (=> $abort_flag@4@@2 (|b#$Boolean| ($Boolean false)))) (=> (and (and (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@19)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@19)))))))))) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((a@@26 T@$Value) )  (=> ((_ is $Address) a@@26) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@26))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| a@@26)))))))))))) (and (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean (forall ((parent@@19 T@$Value) )  (=> ((_ is $Address) parent@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@19)))) $VASP_ParentVASP_num_children) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| parent@@19)))) $VASP_ParentVASP_num_children)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 83474) 84247) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 83474) 83528) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon47_Else_correct)))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon43_Else_correct  (=> (not $abort_flag@2@@4) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@3) (=> $abort_flag@3@@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@3@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 vasp)))) ((_ is $Address) call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 83468) 84267) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 83468) 83474) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon45_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon41_Else_correct  (=> (not $abort_flag@1@@5) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) $abort_flag@2@@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@2@@4)) (and (=> $abort_flag@2@@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) $Roles_RoleId_role_id) ($Integer 5))))))) (=> $abort_flag@2@@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp))))))) (= $abort_code@3@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| vasp)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@3@@3 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 83462) 84287) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 83462) 83468) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@0@@5) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@1@@5)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@1@@5) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@1@@5)) (and (=> $abort_flag@1@@5 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@1@@5 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 83456) 84307) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 83456) 83462) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@5) (=> (and (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 83450) 84327) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 83450) 83456) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 83380) 83450)) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon4$2_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 84351) 83450) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon4$2_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon37_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 83372) 84351) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 83372) 83380) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon37_Then_correct  (and (=> (= (ControlFlow 0 84359) 84351) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 84359) 83380) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon38_Else_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 83366) 84359) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 83366) 83372) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon37_Else_correct)))))
(let ((anon0$1_correct@@7  (=> (forall (($inv_addr@@15 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@15))
)) (=> (and (forall (($inv_addr@@16 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))
)) (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@17))
))) (=> (and (and (forall (($inv_addr@@18 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18)) (let ((va@@27 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@18))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((child_addr@@7 T@$Value) )  (=> ((_ is $Address) child_addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@7)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= (ControlFlow 0 84363) 83366))) inline$$VASP_publish_parent_vasp_credential_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@7  (=> ((_ is $Address) vasp) (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 82496) 84363)) anon0$1_correct@@7))))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 99719) 82496) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@7)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
