(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Option_Option $Roles_RoleId $ValidatorOperatorConfig_ValidatorOperatorConfig $ValidatorConfig_ValidatorConfig $ValidatorConfig_Config)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Option_Option_type_value $tv0))
)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory () T@$Memory)
(declare-fun addr () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun inline$$ValidatorConfig_get_human_name_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$ValidatorConfig_get_human_name_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$ValidatorConfig_get_human_name_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$ValidatorConfig_get_human_name_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 87061) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 67629) (- 0 87892)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) $abort_flag@2) (and (=> (= (ControlFlow 0 67629) (- 0 87909)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr)))))))) (and (=> (= (ControlFlow 0 67629) (- 0 87926)) (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 67629) (- 0 87954)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorConfig_get_human_name_$def_verify$0$$ret0@2 (let ((t_ref (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr))))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref)) $ValidatorConfig_ValidatorConfig_human_name))))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorConfig_get_human_name_$def_verify$0$$ret0@2 (let ((t_ref (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr))))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref)) $ValidatorConfig_ValidatorConfig_human_name)))))) (=> (= (ControlFlow 0 67629) (- 0 87972)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))))))))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon18_correct  (=> (and (and (= $abort_code@5 $abort_code@3) (= inline$$ValidatorConfig_get_human_name_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1)) (and (= $abort_flag@2 $abort_flag@1) (= (ControlFlow 0 67557) 67629))) anon0$2_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 67555) 67557)) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon18_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 67565) 67557) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon18_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $ValidatorConfig_ValidatorConfig_human_name)) (and (=> (= (ControlFlow 0 67539) 67565) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 67539) 67555) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 67497) 67539)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 67573) 67539) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon24_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 67491) 67573) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 67491) 67497) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$Abort_correct  (=> (= inline$$ValidatorConfig_get_human_name_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@5 $abort_code@4) (= inline$$ValidatorConfig_get_human_name_$def_verify$0$$ret0@2 inline$$ValidatorConfig_get_human_name_$def_verify$0$$ret0@1)) (and (= $abort_flag@2 true) (= (ControlFlow 0 67296) 67629))) anon0$2_correct))))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 67605) 67296)) inline$$ValidatorConfig_get_human_name_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 67603) 67605)) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon5_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 67613) 67605) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon5_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 67597) 67613) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 67597) 67603) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon13_correct  (=> (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 67585) 67296)) inline$$ValidatorConfig_get_human_name_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 67583) 67585)) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 67593) 67585) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon24_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 67577) 67593) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 67577) 67583) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@1 true) (=> (and (= $abort_code@3 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 67477) 67577) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 67477) 67491) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 67475) 67477)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr))) (= $abort_flag@1 $abort_flag@0)) (and (= $abort_code@3 $abort_code@1) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 67423) 67577) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 67423) 67491) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 67405) 67475) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 67405) 67423) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 67399) (- 0 87687)) true) (=> (= (ControlFlow 0 67399) 67405) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon22_Then_correct  (=> (and (|b#$Boolean| inline$$ValidatorConfig_get_human_name_$def_verify$0$$t5@1) (= (ControlFlow 0 67483) 67399)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon10_correct  (=> (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 67290) 67296)) inline$$ValidatorConfig_get_human_name_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 67288) 67290)) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon10_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 67304) 67290) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon10_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon22_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorConfig_get_human_name_$def_verify$0$$t5@1)) (= $abort_code@2 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 67282) 67304) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 67282) 67288) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon20_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 67270) 67483) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 67270) 67282) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon2$1_correct  (=> (= inline$$ValidatorConfig_get_human_name_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (=> (and (and (and (= inline$$ValidatorConfig_get_human_name_$def_verify$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0)) (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 67264) 67597) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 67264) 67270) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 67216) 67264)) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 67621) 67264) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_get_human_name_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 67210) 67621) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 67210) 67216) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@8 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@9 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@10 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@12 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_human_name))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_human_name))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_human_name))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_human_name))) $$0))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (and (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (= (ControlFlow 0 67627) 67210))) inline$$ValidatorConfig_get_human_name_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 66751) 67627)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 87061) 66751) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun validator_account () T@$Value)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun dr_account () T@$Value)
(declare-fun $abort_code@11 () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory@1 () T@$Memory)
(declare-fun $abort_flag@7 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_code@10 () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$ValidatorConfig_ValidatorConfig_pack$0$$struct@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun human_name () T@$Value)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun $abort_code@7 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$ValidatorConfig_publish_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$ValidatorConfig_publish_$def_verify$0$$t9@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 88050) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 70071) (- 0 91529)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $abort_flag@8) (and (=> (= (ControlFlow 0 70071) (- 0 91541)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@8) (and (=> (= (ControlFlow 0 70071) (- 0 91556)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@8) (and (=> (= (ControlFlow 0 70071) (- 0 91577)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@8) (and (=> (= (ControlFlow 0 70071) (- 0 91606)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@8) (and (=> (= (ControlFlow 0 70071) (- 0 91623)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) $abort_flag@8) (and (=> (= (ControlFlow 0 70071) (- 0 91644)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@8)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@8) (and (=> (= (ControlFlow 0 70071) (- 0 91673)) (=> $abort_flag@8 (or (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3)))))))) (=> (=> $abort_flag@8 (or (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))))) (and (=> (= (ControlFlow 0 70071) (- 0 91811)) (=> $abort_flag@8 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) (= $abort_code@11 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@11 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@11 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@11 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@11 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) (= $abort_code@11 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@11 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@8 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) (= $abort_code@11 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@11 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@11 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@11 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@11 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) (= $abort_code@11 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@11 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 70071) (- 0 92026)) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory@1) $EmptyTypeValueArray (|a#$Address| validator_account)))))) (=> (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory@1) $EmptyTypeValueArray (|a#$Address| validator_account))))) (=> (= (ControlFlow 0 70071) (- 0 92040)) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@1) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))))))))))))))))))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon62_Else_correct  (=> (not $abort_flag@7) (and (=> (= (ControlFlow 0 69881) (- 0 91208)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_publish_$def_verify$0$validator T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_publish_$def_verify$0$validator) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$validator)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$validator)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$validator)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$validator)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_publish_$def_verify$0$validator@@0 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_publish_$def_verify$0$validator@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$validator@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$validator@@0)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$validator@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$validator@@0)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))))))) (and (=> (= (ControlFlow 0 69881) (- 0 91241)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_publish_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_publish_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_publish_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_publish_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@0)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (=> (= (ControlFlow 0 69881) (- 0 91275)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_publish_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_publish_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@1)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_publish_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_publish_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@2)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (=> (= (ControlFlow 0 69881) (- 0 91309)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_publish_$def_verify$0$addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_publish_$def_verify$0$addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@3)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@3)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_publish_$def_verify$0$addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_publish_$def_verify$0$addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@4)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_publish_$def_verify$0$addr@@4)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (=> (and (and (= $abort_code@11 $abort_code@9) (= $abort_flag@8 $abort_flag@7)) (and (= $ValidatorConfig_ValidatorConfig_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 69881) 70071))) anon0$2_correct@@0))))))))))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@11 $abort_code@10) (= $abort_flag@8 true)) (and (= $ValidatorConfig_ValidatorConfig_$memory@1 $ValidatorConfig_ValidatorConfig_$memory@0) (= (ControlFlow 0 69101) 70071))) anon0$2_correct@@0)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon9_correct  (=> (= $abort_code@10 $abort_code@1@@0) (=> (and (= $ValidatorConfig_ValidatorConfig_$memory@0 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 70033) 69101)) inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 70031) 70033)) inline$$ValidatorConfig_publish_$def_verify$0$anon9_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 70041) 70033) inline$$ValidatorConfig_publish_$def_verify$0$anon9_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon46_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 70025) 70041) inline$$ValidatorConfig_publish_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 70025) 70031) inline$$ValidatorConfig_publish_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon13_correct  (=> (= $abort_code@10 $abort_code@2@@0) (=> (and (= $ValidatorConfig_ValidatorConfig_$memory@0 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 70013) 69101)) inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 70011) 70013)) inline$$ValidatorConfig_publish_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 70021) 70013) inline$$ValidatorConfig_publish_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon48_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 70005) 70021) inline$$ValidatorConfig_publish_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 70005) 70011) inline$$ValidatorConfig_publish_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon17_correct  (=> (= $abort_code@10 $abort_code@3@@0) (=> (and (= $ValidatorConfig_ValidatorConfig_$memory@0 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 69993) 69101)) inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 69991) 69993)) inline$$ValidatorConfig_publish_$def_verify$0$anon17_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 70001) 69993) inline$$ValidatorConfig_publish_$def_verify$0$anon17_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon50_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 69985) 70001) inline$$ValidatorConfig_publish_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 69985) 69991) inline$$ValidatorConfig_publish_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon21_correct  (=> (= $abort_code@10 $abort_code@4@@0) (=> (and (= $ValidatorConfig_ValidatorConfig_$memory@0 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 69973) 69101)) inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 69971) 69973)) inline$$ValidatorConfig_publish_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 69981) 69973) inline$$ValidatorConfig_publish_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon52_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 69965) 69981) inline$$ValidatorConfig_publish_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 69965) 69971) inline$$ValidatorConfig_publish_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon25_correct  (=> (= $abort_code@10 $abort_code@5@@0) (=> (and (= $ValidatorConfig_ValidatorConfig_$memory@0 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 69953) 69101)) inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 69951) 69953)) inline$$ValidatorConfig_publish_$def_verify$0$anon25_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 69961) 69953) inline$$ValidatorConfig_publish_$def_verify$0$anon25_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon54_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 69945) 69961) inline$$ValidatorConfig_publish_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 69945) 69951) inline$$ValidatorConfig_publish_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon33_correct  (=> (= $abort_code@10 $abort_code@6) (=> (and (= $ValidatorConfig_ValidatorConfig_$memory@0 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 69933) 69101)) inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 69931) 69933)) inline$$ValidatorConfig_publish_$def_verify$0$anon33_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 69941) 69933) inline$$ValidatorConfig_publish_$def_verify$0$anon33_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon58_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 69925) 69941) inline$$ValidatorConfig_publish_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 69925) 69931) inline$$ValidatorConfig_publish_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon37_correct  (=> (= $abort_code@10 $abort_code@8) (=> (and (= $ValidatorConfig_ValidatorConfig_$memory@0 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 69913) 69101)) inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 69911) 69913)) inline$$ValidatorConfig_publish_$def_verify$0$anon37_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon61_Then_correct  (=> (= (ControlFlow 0 69921) 69913) inline$$ValidatorConfig_publish_$def_verify$0$anon37_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon60_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 69905) 69921) inline$$ValidatorConfig_publish_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 69905) 69911) inline$$ValidatorConfig_publish_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon41_correct  (=> (= $abort_code@10 $abort_code@9) (=> (and (= $ValidatorConfig_ValidatorConfig_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 69893) 69101)) inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 69891) 69893)) inline$$ValidatorConfig_publish_$def_verify$0$anon41_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 69901) 69893) inline$$ValidatorConfig_publish_$def_verify$0$anon41_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon62_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 69885) 69901) inline$$ValidatorConfig_publish_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 69885) 69891) inline$$ValidatorConfig_publish_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@7 true) (=> (and (= $abort_code@9 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 69719) 69885) inline$$ValidatorConfig_publish_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 69719) 69881) inline$$ValidatorConfig_publish_$def_verify$0$anon62_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 69717) 69719)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$ValidatorConfig_ValidatorConfig_pack$0$$struct@1))) (= $abort_flag@7 $abort_flag@6)) (and (= $abort_code@9 $abort_code@8) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 69667) 69885) inline$$ValidatorConfig_publish_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 69667) 69881) inline$$ValidatorConfig_publish_$def_verify$0$anon62_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| validator_account)) (and (=> (= (ControlFlow 0 69725) 69717) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 69725) 69667) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 69513) (- 0 91093)) true) (=> (= (ControlFlow 0 69513) 69725) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$ValidatorConfig_ValidatorConfig_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 69397) 69513)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$ValidatorConfig_ValidatorConfig_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 69403) 69513) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$ValidatorConfig_ValidatorConfig_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 69391) 69403) inline$$ValidatorConfig_ValidatorConfig_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 69391) 69397) inline$$ValidatorConfig_ValidatorConfig_pack$0$anon4_Else_correct)))))
(let ((inline$$ValidatorConfig_ValidatorConfig_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 69383) 69513)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$ValidatorConfig_ValidatorConfig_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@0) (let ((va@@14 (|v#$Vector| call3formal@$ret0@0@@0)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) $Option_Option_vec)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) $Option_Option_vec))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (and (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@1) (let ((va@@16 (|v#$Vector| call3formal@$ret0@0@@1)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $Option_Option_vec)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $Option_Option_vec))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (and (and ((_ is $Vector) human_name) (let ((va@@18 (|v#$Vector| human_name)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (forall ((inline$$ValidatorConfig_ValidatorConfig_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$ValidatorConfig_ValidatorConfig_pack$0$$$0 0) (< inline$$ValidatorConfig_ValidatorConfig_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$ValidatorConfig_ValidatorConfig_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$ValidatorConfig_ValidatorConfig_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$ValidatorConfig_ValidatorConfig_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$ValidatorConfig_ValidatorConfig_pack$0$$$0))
))) (= inline$$ValidatorConfig_ValidatorConfig_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 call3formal@$ret0@0@@0) 1 call3formal@$ret0@0@@1) 2 human_name) 3))))) (and (=> (= (ControlFlow 0 69375) 69391) inline$$ValidatorConfig_ValidatorConfig_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 69375) 69383) inline$$ValidatorConfig_ValidatorConfig_pack$0$anon3_Else_correct))))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon60_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 69409) 69375)) inline$$ValidatorConfig_ValidatorConfig_pack$0$anon0_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon58_Else_correct  (=> (not $abort_flag@5) (=> (and (and (= call0formal@$tv0@0 $AddressType) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6)) (and (=> $abort_flag@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Vector $EmptyValueArray)) (+ len@@0 1)))))))))) (=> (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@1) (let ((va@@19 (|v#$Vector| call3formal@$ret0@0@@1)))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $Option_Option_vec)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $Option_Option_vec))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 69121) 69905) inline$$ValidatorConfig_publish_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 69121) 69409) inline$$ValidatorConfig_publish_$def_verify$0$anon60_Else_correct)))))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon56_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (and (= call0formal@$tv0@0@@0 $ValidatorConfig_Config_type_value) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5)) (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Vector (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Vector $EmptyValueArray)) (+ len@@1 1)))))))))) (=> (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@0) (let ((va@@21 (|v#$Vector| call3formal@$ret0@0@@0)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) $Option_Option_vec)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) $Option_Option_vec))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 69115) 69925) inline$$ValidatorConfig_publish_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 69115) 69121) inline$$ValidatorConfig_publish_$def_verify$0$anon58_Else_correct)))))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon30_correct  (=> (= $abort_code@10 $abort_code@7) (=> (and (= $ValidatorConfig_ValidatorConfig_$memory@0 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 69097) 69101)) inline$$ValidatorConfig_publish_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 69095) 69097)) inline$$ValidatorConfig_publish_$def_verify$0$anon30_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 69109) 69097) inline$$ValidatorConfig_publish_$def_verify$0$anon30_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon56_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@7 (|i#$Integer| call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 69089) 69109) inline$$ValidatorConfig_publish_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 69089) 69095) inline$$ValidatorConfig_publish_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon54_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 69077) 69115) inline$$ValidatorConfig_publish_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 69077) 69089) inline$$ValidatorConfig_publish_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon52_Else$1_correct  (=> (and (and (and (= inline$$ValidatorConfig_publish_$def_verify$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 69071) 69945) inline$$ValidatorConfig_publish_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 69071) 69077) inline$$ValidatorConfig_publish_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$ValidatorConfig_publish_$def_verify$0$$t9@1)))) (= (ControlFlow 0 69059) 69071)) inline$$ValidatorConfig_publish_$def_verify$0$anon52_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 69049) (- 0 90709)) true) (=> (= (ControlFlow 0 69049) 69059) inline$$Not$0$anon0_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@3) (=> (and (= inline$$ValidatorConfig_publish_$def_verify$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@3)))) (= (ControlFlow 0 69065) 69049)) inline$$Not$0$Entry_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon50_Else_correct  (=> (not $abort_flag@2@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3) (=> $abort_flag@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 validator_account)))) ((_ is $Address) call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 69003) 69965) inline$$ValidatorConfig_publish_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 69003) 69065) inline$$ValidatorConfig_publish_$def_verify$0$anon52_Else_correct))))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon48_Else_correct  (=> (not $abort_flag@1@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) $abort_flag@2@@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@2@@0)) (and (=> $abort_flag@2@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))))) (=> $abort_flag@2@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account))))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 68997) 69985) inline$$ValidatorConfig_publish_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 68997) 69003) inline$$ValidatorConfig_publish_$def_verify$0$anon50_Else_correct))))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon46_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@1@@0)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@1@@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1@@0)) (and (=> $abort_flag@1@@0 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@1@@0 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2@@0 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 68991) 70005) inline$$ValidatorConfig_publish_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 68991) 68997) inline$$ValidatorConfig_publish_$def_verify$0$anon48_Else_correct)))))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@0) (=> (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 68985) 70025) inline$$ValidatorConfig_publish_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 68985) 68991) inline$$ValidatorConfig_publish_$def_verify$0$anon46_Else_correct))))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 68881) 68985)) inline$$ValidatorConfig_publish_$def_verify$0$anon6$3_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 70049) 68985) inline$$ValidatorConfig_publish_$def_verify$0$anon6$3_correct)))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon44_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 68873) 70049) inline$$ValidatorConfig_publish_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 68873) 68881) inline$$ValidatorConfig_publish_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon44_Then_correct  (and (=> (= (ControlFlow 0 70057) 70049) inline$$ValidatorConfig_publish_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 70057) 68881) inline$$ValidatorConfig_publish_$def_verify$0$anon45_Else_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon43_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 68865) 70057) inline$$ValidatorConfig_publish_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 68865) 68873) inline$$ValidatorConfig_publish_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon43_Then_correct  (and (=> (= (ControlFlow 0 70065) 70057) inline$$ValidatorConfig_publish_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 70065) 68873) inline$$ValidatorConfig_publish_$def_verify$0$anon44_Else_correct))))
(let ((inline$$ValidatorConfig_publish_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 68859) 70065) inline$$ValidatorConfig_publish_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 68859) 68865) inline$$ValidatorConfig_publish_$def_verify$0$anon43_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (=> (and (and (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@0))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@2))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@3 T@$Value) )  (=> ((_ is $Address) addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@4 T@$Value) )  (=> ((_ is $Address) addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@5 T@$Value) )  (=> ((_ is $Address) addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@6 T@$Value) )  (=> ((_ is $Address) addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (= (ControlFlow 0 70069) 68859)))) inline$$ValidatorConfig_publish_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (and ((_ is $Address) validator_account) ((_ is $Address) dr_account)) (=> (and (and (and ((_ is $Vector) human_name) (let ((va@@31 (|v#$Vector| human_name)))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@1))
))) (= (ControlFlow 0 67826) 70069)) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 88050) 67826) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$ValidatorConfig_exists_config_$def_verify$0$$t2@1 () T@$Value)
(declare-fun addr@@7 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 92106) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 70682) (- 0 92421)) (not false)) (=> (not false) (=> (= (ControlFlow 0 70682) (- 0 92424)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))
(let ((inline$$ValidatorConfig_exists_config_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 70656) 70682)) anon0$2_correct@@1)))
(let ((inline$$ValidatorConfig_exists_config_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 70666) 70682) anon0$2_correct@@1)))
(let ((inline$$ValidatorConfig_exists_config_$def_verify$0$anon2$1_correct  (=> (= inline$$ValidatorConfig_exists_config_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) (and (=> (= (ControlFlow 0 70650) 70666) inline$$ValidatorConfig_exists_config_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 70650) 70656) inline$$ValidatorConfig_exists_config_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$ValidatorConfig_exists_config_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 70604) 70650)) inline$$ValidatorConfig_exists_config_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_exists_config_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 70674) 70650) inline$$ValidatorConfig_exists_config_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_exists_config_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 70598) 70674) inline$$ValidatorConfig_exists_config_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 70598) 70604) inline$$ValidatorConfig_exists_config_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@2))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (=> (and (and (|b#$Boolean| ($Boolean (forall ((addr@@8 T@$Value) )  (=> ((_ is $Address) addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@9 T@$Value) )  (=> ((_ is $Address) addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@10 T@$Value) )  (=> ((_ is $Address) addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (= (ControlFlow 0 70680) 70598))) inline$$ValidatorConfig_exists_config_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) addr@@7) (= (ControlFlow 0 70353) 70680)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 92106) 70353) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun addr@@11 () T@$Value)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun inline$$ValidatorConfig_get_config_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun inline$$ValidatorConfig_get_config_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun call0formal@$tv0@0@@1 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$ValidatorConfig_get_config_$def_verify$0$$t12@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@2 () T@$TypeValue)
(declare-fun inline$$GetGlobal$0$dst@2@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun inline$$ValidatorConfig_exists_config_$def$0$$t2@1 () T@$Value)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$ValidatorConfig_get_config_$def_verify$0$$t8@1 () T@$Value)
(declare-fun $Option_Option_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 92493) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 72287) (- 0 94111)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11))))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11))))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 72287) (- 0 94128)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 72287) (- 0 94149)) (=> $abort_flag@5@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))) (=> (=> $abort_flag@5@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))) (and (=> (= (ControlFlow 0 72287) (- 0 94186)) (=> $abort_flag@5@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@5@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 7)))))) (and (=> (= (ControlFlow 0 72287) (- 0 94245)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorConfig_get_config_$def_verify$0$$ret0@2 ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorConfig_get_config_$def_verify$0$$ret0@2 ($Vector_$borrow $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec) ($Integer 0)))))) (=> (= (ControlFlow 0 72287) (- 0 94263)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@2 T@$Value) )  (=> ((_ is $Address) addr1@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))))))))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon36_correct  (=> (and (and (= $abort_code@9@@0 $abort_code@6@@0) (= inline$$ValidatorConfig_get_config_$def_verify$0$$ret0@2 call4formal@$ret0@0)) (and (= $abort_flag@5@@0 $abort_flag@4@@0) (= (ControlFlow 0 72151) 72287))) anon0$2_correct@@2)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 72149) 72151)) inline$$ValidatorConfig_get_config_$def_verify$0$anon36_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 72159) 72151) inline$$ValidatorConfig_get_config_$def_verify$0$anon36_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 72143) 72159) inline$$ValidatorConfig_get_config_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 72143) 72149) inline$$ValidatorConfig_get_config_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$Abort_correct  (=> (= inline$$ValidatorConfig_get_config_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@9@@0 $abort_code@8@@0) (= inline$$ValidatorConfig_get_config_$def_verify$0$$ret0@2 inline$$ValidatorConfig_get_config_$def_verify$0$$ret0@1)) (and (= $abort_flag@5@@0 true) (= (ControlFlow 0 71834) 72287))) anon0$2_correct@@2))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon7_correct  (=> (and (= $abort_code@8@@0 $abort_code@1@@1) (= (ControlFlow 0 72259) 71834)) inline$$ValidatorConfig_get_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 72257) 72259)) inline$$ValidatorConfig_get_config_$def_verify$0$anon7_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 72267) 72259) inline$$ValidatorConfig_get_config_$def_verify$0$anon7_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon39_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 72251) 72267) inline$$ValidatorConfig_get_config_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 72251) 72257) inline$$ValidatorConfig_get_config_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon15_correct  (=> (and (= $abort_code@8@@0 $abort_code@3@@1) (= (ControlFlow 0 72239) 71834)) inline$$ValidatorConfig_get_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 72237) 72239)) inline$$ValidatorConfig_get_config_$def_verify$0$anon15_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 72247) 72239) inline$$ValidatorConfig_get_config_$def_verify$0$anon15_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon43_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 72231) 72247) inline$$ValidatorConfig_get_config_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 72231) 72237) inline$$ValidatorConfig_get_config_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon21_correct  (=> (and (= $abort_code@8@@0 $abort_code@4@@1) (= (ControlFlow 0 72211) 71834)) inline$$ValidatorConfig_get_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 72209) 72211)) inline$$ValidatorConfig_get_config_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 72219) 72211) inline$$ValidatorConfig_get_config_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon46_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 72203) 72219) inline$$ValidatorConfig_get_config_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 72203) 72209) inline$$ValidatorConfig_get_config_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon25_correct  (=> (and (= $abort_code@8@@0 $abort_code@5@@1) (= (ControlFlow 0 72191) 71834)) inline$$ValidatorConfig_get_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 72189) 72191)) inline$$ValidatorConfig_get_config_$def_verify$0$anon25_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 72199) 72191) inline$$ValidatorConfig_get_config_$def_verify$0$anon25_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon48_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 72183) 72199) inline$$ValidatorConfig_get_config_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 72183) 72189) inline$$ValidatorConfig_get_config_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon33_correct  (=> (and (= $abort_code@8@@0 $abort_code@6@@0) (= (ControlFlow 0 72171) 71834)) inline$$ValidatorConfig_get_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 72169) 72171)) inline$$ValidatorConfig_get_config_$def_verify$0$anon33_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 72179) 72171) inline$$ValidatorConfig_get_config_$def_verify$0$anon33_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon52_Then_correct  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 72163) 72179) inline$$ValidatorConfig_get_config_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 72163) 72169) inline$$ValidatorConfig_get_config_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon50_Then_correct  (=> (and (|b#$Boolean| call4formal@$ret0@0@@0) (= call0formal@$tv0@0@@1 $ValidatorConfig_Config_type_value)) (=> (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@0)) $Option_Option_vec)) ($Integer 0)))) $abort_flag@4@@0) (=> $abort_flag@4@@0 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@0)) $Option_Option_vec)) ($Integer 0)))))) (and (=> $abort_flag@4@@0 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@0)) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@6@@0 (|i#$Integer| ($Integer 7))))) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 ($Vector_$borrow call0formal@$tv0@0@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@0)) $Option_Option_vec) ($Integer 0)))))))) (and (=> (= (ControlFlow 0 72135) 72163) inline$$ValidatorConfig_get_config_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 72135) 72143) inline$$ValidatorConfig_get_config_$def_verify$0$anon52_Else_correct))))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon30_correct  (=> (and (= $abort_code@8@@0 $abort_code@7@@0) (= (ControlFlow 0 72121) 71834)) inline$$ValidatorConfig_get_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 72119) 72121)) inline$$ValidatorConfig_get_config_$def_verify$0$anon30_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 72129) 72121) inline$$ValidatorConfig_get_config_$def_verify$0$anon30_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon50_Else_correct  (=> (and (not (|b#$Boolean| call4formal@$ret0@0@@0)) (= $abort_code@7@@0 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 72113) 72129) inline$$ValidatorConfig_get_config_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 72113) 72119) inline$$ValidatorConfig_get_config_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon48_Else_correct  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 72101) 72135) inline$$ValidatorConfig_get_config_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 72101) 72113) inline$$ValidatorConfig_get_config_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon46_Else_correct  (=> (not $abort_flag@2@@1) (=> (and (and (and (= inline$$ValidatorConfig_get_config_$def_verify$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0)) (and (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 72095) 72183) inline$$ValidatorConfig_get_config_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 72095) 72101) inline$$ValidatorConfig_get_config_$def_verify$0$anon48_Else_correct))))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon18_correct  (=> (= call0formal@$tv0@0@@2 $ValidatorConfig_Config_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@1) (=> $abort_flag@2@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@0)) $Option_Option_vec)) ($Integer 0)))))))))) ((_ is $Boolean) call4formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 72085) 72203) inline$$ValidatorConfig_get_config_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 72085) 72095) inline$$ValidatorConfig_get_config_$def_verify$0$anon46_Else_correct))))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 72083) 72085)) inline$$ValidatorConfig_get_config_$def_verify$0$anon18_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 72227) 72085) inline$$ValidatorConfig_get_config_$def_verify$0$anon18_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $ValidatorConfig_ValidatorConfig_config)) (and (=> (= (ControlFlow 0 72069) 72227) inline$$ValidatorConfig_get_config_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 72069) 72083) inline$$ValidatorConfig_get_config_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon43_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 72075) 72069)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@1@@1 true) (=> (and (= $abort_code@3@@1 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 72015) 72231) inline$$ValidatorConfig_get_config_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 72015) 72075) inline$$ValidatorConfig_get_config_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 72013) 72015)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@0) (=> (and (and (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11))) (= $abort_flag@1@@1 $abort_flag@0@@1)) (and (= $abort_code@3@@1 $abort_code@1@@1) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 71961) 72231) inline$$ValidatorConfig_get_config_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 71961) 72075) inline$$ValidatorConfig_get_config_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| addr@@11)) (and (=> (= (ControlFlow 0 71943) 72013) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 71943) 71961) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 71937) (- 0 93613)) true) (=> (= (ControlFlow 0 71937) 71943) inline$$GetGlobal$0$anon0_correct@@0))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon41_Then_correct  (=> (and (|b#$Boolean| inline$$ValidatorConfig_exists_config_$def$0$$t2@1) (= (ControlFlow 0 72021) 71937)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon12_correct  (=> (and (= $abort_code@8@@0 $abort_code@2@@1) (= (ControlFlow 0 71828) 71834)) inline$$ValidatorConfig_get_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 71826) 71828)) inline$$ValidatorConfig_get_config_$def_verify$0$anon12_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 71842) 71828) inline$$ValidatorConfig_get_config_$def_verify$0$anon12_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorConfig_exists_config_$def$0$$t2@1)) (= $abort_code@2@@1 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 71820) 71842) inline$$ValidatorConfig_get_config_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 71820) 71826) inline$$ValidatorConfig_get_config_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon39_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 71808) 72021) inline$$ValidatorConfig_get_config_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 71808) 71820) inline$$ValidatorConfig_get_config_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon38_Else_correct  (=> (not false) (=> (and (and (and (= inline$$ValidatorConfig_get_config_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1)) (and (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 71802) 72251) inline$$ValidatorConfig_get_config_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 71802) 71808) inline$$ValidatorConfig_get_config_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon38_Then_correct true))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 71758) 72271) inline$$ValidatorConfig_get_config_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 71758) 71802) inline$$ValidatorConfig_get_config_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 71768) 72271) inline$$ValidatorConfig_get_config_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 71768) 71802) inline$$ValidatorConfig_get_config_$def_verify$0$anon38_Else_correct))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct  (=> (= inline$$ValidatorConfig_exists_config_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (and (=> (= (ControlFlow 0 71752) 71768) inline$$ValidatorConfig_exists_config_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 71752) 71758) inline$$ValidatorConfig_exists_config_$def$0$anon6_Else_correct)))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 71706) 71752)) inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 71776) 71752) inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 71700) 71776) inline$$ValidatorConfig_exists_config_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 71700) 71706) inline$$ValidatorConfig_exists_config_$def$0$anon5_Else_correct)))))
(let ((inline$$ValidatorConfig_exists_config_$direct_intra$0$anon0_correct  (=> (and ((_ is $Address) addr@@11) (= (ControlFlow 0 71782) 71700)) inline$$ValidatorConfig_exists_config_$def$0$anon0_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 71514) 71782)) inline$$ValidatorConfig_exists_config_$direct_intra$0$anon0_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 72279) 71782) inline$$ValidatorConfig_exists_config_$direct_intra$0$anon0_correct)))
(let ((inline$$ValidatorConfig_get_config_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 71508) 72279) inline$$ValidatorConfig_get_config_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 71508) 71514) inline$$ValidatorConfig_get_config_$def_verify$0$anon37_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (forall (($inv_addr@@4 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4)) (let ((va@@38 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4))) $Option_Option_vec)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4))) $Option_Option_vec))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@4))
)) (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@40 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@3))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@5))
))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((addr@@12 T@$Value) )  (=> ((_ is $Address) addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@13 T@$Value) )  (=> ((_ is $Address) addr@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@14 T@$Value) )  (=> ((_ is $Address) addr@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (= (ControlFlow 0 72285) 71508))) inline$$ValidatorConfig_get_config_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (and ((_ is $Address) addr@@11) (= (ControlFlow 0 70782) 72285)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 92493) 70782) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(declare-fun config_ref () T@$Value)
(declare-fun $ValidatorConfig_Config_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 94333) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 72752) (- 0 94556)) (not false)) (=> (not false) (=> (= (ControlFlow 0 72752) (- 0 94559)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr1@@3 T@$Value) )  (=> ((_ is $Address) addr1@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))
(let ((inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 72726) 72752)) anon0$2_correct@@3)))
(let ((inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 72736) 72752) anon0$2_correct@@3)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_consensus_pubkey)) (and (=> (= (ControlFlow 0 72710) 72736) inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 72710) 72726) inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 72634) 72710)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 72744) 72710) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 72628) 72744) inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 72628) 72634) inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@46 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@47 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@49 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (= (ControlFlow 0 72750) 72628)) inline$$ValidatorConfig_get_consensus_pubkey_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) config_ref) (let ((va@@50 (|v#$Vector| config_ref)))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| config_ref)) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@7))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@8))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@53 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@9))
))) true) (= (ControlFlow 0 72493) 72750)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 94333) 72493) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@3)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun addr@@15 () T@$Value)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_code@9@@1 () Int)
(declare-fun inline$$ValidatorConfig_get_operator_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun call4formal@$ret0@0@@1 () T@$Value)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun inline$$ValidatorConfig_get_operator_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun call0formal@$tv0@0@@3 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@1 () T@$Value)
(declare-fun call4formal@$ret0@0@@2 () T@$Value)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$ValidatorConfig_get_operator_$def_verify$0$$t12@1 () T@$Value)
(declare-fun call0formal@$tv0@0@@4 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@1 () T@$Value)
(declare-fun inline$$ValidatorConfig_get_operator_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$ValidatorConfig_get_operator_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 94628) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 74150) (- 0 96198)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))) $abort_flag@5@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))) $abort_flag@5@@1) (and (=> (= (ControlFlow 0 74150) (- 0 96225)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15))))))) $abort_flag@5@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15))))))) $abort_flag@5@@1) (and (=> (= (ControlFlow 0 74150) (- 0 96242)) (=> $abort_flag@5@@1 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))))))))) (=> (=> $abort_flag@5@@1 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15))))))))) (and (=> (= (ControlFlow 0 74150) (- 0 96285)) (=> $abort_flag@5@@1 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))) (= $abort_code@9@@1 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15))))))) (= $abort_code@9@@1 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@5@@1 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))) (= $abort_code@9@@1 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15))))))) (= $abort_code@9@@1 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 74150) (- 0 96350)) (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorConfig_get_operator_$def_verify$0$$ret0@2 (let ((t_ref@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@0)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0)))))))) (=> (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorConfig_get_operator_$def_verify$0$$ret0@2 (let ((t_ref@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@0)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0))))))) (=> (= (ControlFlow 0 74150) (- 0 96368)) (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@4 T@$Value) )  (=> ((_ is $Address) addr1@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))))))))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon34_correct  (=> (and (and (= $abort_code@9@@1 $abort_code@7@@1) (= inline$$ValidatorConfig_get_operator_$def_verify$0$$ret0@2 call4formal@$ret0@0@@1)) (and (= $abort_flag@5@@1 $abort_flag@4@@1) (= (ControlFlow 0 74018) 74150))) anon0$2_correct@@4)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 74016) 74018)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon34_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 74026) 74018) inline$$ValidatorConfig_get_operator_$def_verify$0$anon34_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@4@@1) (and (=> (= (ControlFlow 0 74010) 74026) inline$$ValidatorConfig_get_operator_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 74010) 74016) inline$$ValidatorConfig_get_operator_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$Abort_correct  (=> (= inline$$ValidatorConfig_get_operator_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@9@@1 $abort_code@8@@1) (= inline$$ValidatorConfig_get_operator_$def_verify$0$$ret0@2 inline$$ValidatorConfig_get_operator_$def_verify$0$$ret0@1)) (and (= $abort_flag@5@@1 true) (= (ControlFlow 0 73653) 74150))) anon0$2_correct@@4))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon5_correct  (=> (and (= $abort_code@8@@1 $abort_code@1@@2) (= (ControlFlow 0 74126) 73653)) inline$$ValidatorConfig_get_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 74124) 74126)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon5_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 74134) 74126) inline$$ValidatorConfig_get_operator_$def_verify$0$anon5_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon36_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 74118) 74134) inline$$ValidatorConfig_get_operator_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 74118) 74124) inline$$ValidatorConfig_get_operator_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon13_correct  (=> (and (= $abort_code@8@@1 $abort_code@3@@2) (= (ControlFlow 0 74106) 73653)) inline$$ValidatorConfig_get_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 74104) 74106)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 74114) 74106) inline$$ValidatorConfig_get_operator_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon40_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 74098) 74114) inline$$ValidatorConfig_get_operator_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 74098) 74104) inline$$ValidatorConfig_get_operator_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon19_correct  (=> (and (= $abort_code@8@@1 $abort_code@4@@2) (= (ControlFlow 0 74078) 73653)) inline$$ValidatorConfig_get_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 74076) 74078)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon19_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 74086) 74078) inline$$ValidatorConfig_get_operator_$def_verify$0$anon19_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon43_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 74070) 74086) inline$$ValidatorConfig_get_operator_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 74070) 74076) inline$$ValidatorConfig_get_operator_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon23_correct  (=> (and (= $abort_code@8@@1 $abort_code@5@@2) (= (ControlFlow 0 74058) 73653)) inline$$ValidatorConfig_get_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 74056) 74058)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon23_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 74066) 74058) inline$$ValidatorConfig_get_operator_$def_verify$0$anon23_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon45_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 74050) 74066) inline$$ValidatorConfig_get_operator_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 74050) 74056) inline$$ValidatorConfig_get_operator_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon31_correct  (=> (and (= $abort_code@8@@1 $abort_code@7@@1) (= (ControlFlow 0 74038) 73653)) inline$$ValidatorConfig_get_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 74036) 74038)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon31_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon50_Then_correct  (=> (= (ControlFlow 0 74046) 74038) inline$$ValidatorConfig_get_operator_$def_verify$0$anon31_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon49_Then_correct  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 74030) 74046) inline$$ValidatorConfig_get_operator_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 74030) 74036) inline$$ValidatorConfig_get_operator_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon47_Then$1_correct  (=> (= call0formal@$tv0@0@@3 $AddressType) (=> (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1)) $Option_Option_vec)) ($Integer 0)))) $abort_flag@4@@1) (=> $abort_flag@4@@1 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1)) $Option_Option_vec)) ($Integer 0)))))) (and (=> $abort_flag@4@@1 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1)) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@7@@1 (|i#$Integer| ($Integer 7))))) (=> (not $abort_flag@4@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@1 ($Vector_$borrow call0formal@$tv0@0@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$1$dst@1)) $Option_Option_vec) ($Integer 0)))))))) (and (=> (= (ControlFlow 0 74002) 74030) inline$$ValidatorConfig_get_operator_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 74002) 74010) inline$$ValidatorConfig_get_operator_$def_verify$0$anon49_Else_correct))))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@1)) $ValidatorConfig_ValidatorConfig_operator_account)) (= (ControlFlow 0 73994) 74002)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon47_Then$1_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon47_Then_correct  (=> (and (|b#$Boolean| call4formal@$ret0@0@@2) (= (ControlFlow 0 74000) 73994)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon28_correct  (=> (and (= $abort_code@8@@1 $abort_code@6@@1) (= (ControlFlow 0 73940) 73653)) inline$$ValidatorConfig_get_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 73938) 73940)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon28_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 73948) 73940) inline$$ValidatorConfig_get_operator_$def_verify$0$anon28_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon47_Else_correct  (=> (and (not (|b#$Boolean| call4formal@$ret0@0@@2)) (= $abort_code@6@@1 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 73932) 73948) inline$$ValidatorConfig_get_operator_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 73932) 73938) inline$$ValidatorConfig_get_operator_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon45_Else_correct  (=> (not $abort_flag@3@@1) (and (=> (= (ControlFlow 0 73920) 74000) inline$$ValidatorConfig_get_operator_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 73920) 73932) inline$$ValidatorConfig_get_operator_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon43_Else_correct  (=> (not $abort_flag@2@@2) (=> (and (and (and (= inline$$ValidatorConfig_get_operator_$def_verify$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@1)) (and (=> $abort_flag@3@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 73914) 74050) inline$$ValidatorConfig_get_operator_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 73914) 73920) inline$$ValidatorConfig_get_operator_$def_verify$0$anon45_Else_correct))))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon16$1_correct  (=> (= call0formal@$tv0@0@@4 $AddressType) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@2) (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@2 ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@2)) $Option_Option_vec)) ($Integer 0)))))))))) ((_ is $Boolean) call4formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 73904) 74070) inline$$ValidatorConfig_get_operator_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 73904) 73914) inline$$ValidatorConfig_get_operator_$def_verify$0$anon43_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@2  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@1)) $ValidatorConfig_ValidatorConfig_operator_account)) (= (ControlFlow 0 73896) 73904)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon16$1_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 73854) 73896)) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 74094) 73896) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon40_Else_correct  (=> (not $abort_flag@1@@2) (and (=> (= (ControlFlow 0 73848) 74094) inline$$ValidatorConfig_get_operator_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 73848) 73854) inline$$ValidatorConfig_get_operator_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@1@@2 true) (=> (and (= $abort_code@3@@2 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@1 inline$$GetGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 73834) 74098) inline$$ValidatorConfig_get_operator_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 73834) 73848) inline$$ValidatorConfig_get_operator_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@1)) (= (ControlFlow 0 73832) 73834)) inline$$GetGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@1) (=> (and (and (= inline$$GetGlobal$0$dst@1@@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15))) (= $abort_flag@1@@2 $abort_flag@0@@2)) (and (= $abort_code@3@@2 $abort_code@1@@2) (= inline$$GetGlobal$0$dst@2@@1 inline$$GetGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 73780) 74098) inline$$ValidatorConfig_get_operator_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 73780) 73848) inline$$ValidatorConfig_get_operator_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@1  (=> (= inline$$GetGlobal$0$a@1@@1 (|a#$Address| addr@@15)) (and (=> (= (ControlFlow 0 73762) 73832) inline$$GetGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 73762) 73780) inline$$GetGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$GetGlobal$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 73756) (- 0 95683)) true) (=> (= (ControlFlow 0 73756) 73762) inline$$GetGlobal$0$anon0_correct@@1))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon38_Then_correct  (=> (and (|b#$Boolean| inline$$ValidatorConfig_get_operator_$def_verify$0$$t7@1) (= (ControlFlow 0 73840) 73756)) inline$$GetGlobal$0$Entry_correct@@1)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon10_correct  (=> (and (= $abort_code@8@@1 $abort_code@2@@2) (= (ControlFlow 0 73647) 73653)) inline$$ValidatorConfig_get_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 73645) 73647)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon10_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 73661) 73647) inline$$ValidatorConfig_get_operator_$def_verify$0$anon10_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorConfig_get_operator_$def_verify$0$$t7@1)) (= $abort_code@2@@2 (|i#$Integer| call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 73639) 73661) inline$$ValidatorConfig_get_operator_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 73639) 73645) inline$$ValidatorConfig_get_operator_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@0@@2) (and (=> (= (ControlFlow 0 73627) 73840) inline$$ValidatorConfig_get_operator_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 73627) 73639) inline$$ValidatorConfig_get_operator_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon2$1_correct  (=> (= inline$$ValidatorConfig_get_operator_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) (=> (and (and (and (= inline$$ValidatorConfig_get_operator_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@2)) (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 73621) 74118) inline$$ValidatorConfig_get_operator_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 73621) 73627) inline$$ValidatorConfig_get_operator_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 73573) 73621)) inline$$ValidatorConfig_get_operator_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 74142) 73621) inline$$ValidatorConfig_get_operator_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_get_operator_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 73567) 74142) inline$$ValidatorConfig_get_operator_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 73567) 73573) inline$$ValidatorConfig_get_operator_$def_verify$0$anon35_Else_correct)))))
(let ((anon0$1_correct@@4  (=> (and (forall (($inv_addr@@7 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@7)) (let ((va@@54 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@7))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@7))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@7))) $Option_Option_vec)) (let ((va@@55 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@7))) $Option_Option_vec))))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@7))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@7))
)) (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@56 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@57 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@60 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@61 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@10))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@8))
))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((addr@@16 T@$Value) )  (=> ((_ is $Address) addr@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@17 T@$Value) )  (=> ((_ is $Address) addr@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@18 T@$Value) )  (=> ((_ is $Address) addr@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (= (ControlFlow 0 74148) 73567))) inline$$ValidatorConfig_get_operator_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@4  (=> (and ((_ is $Address) addr@@15) (= (ControlFlow 0 72843) 74148)) anon0$1_correct@@4)))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 94628) 72843) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@3 () T@$Value)
(declare-fun config_ref@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 96437) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 74592) (- 0 96660)) (not false)) (=> (not false) (=> (= (ControlFlow 0 74592) (- 0 96663)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr1@@5 T@$Value) )  (=> ((_ is $Address) addr1@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))
(let ((inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 74566) 74592)) anon0$2_correct@@5)))
(let ((inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 74576) 74592) anon0$2_correct@@5)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@3  (=> (= inline$$GetFieldFromValue$0$dst@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_validator_network_addresses)) (and (=> (= (ControlFlow 0 74550) 74576) inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 74550) 74566) inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 74474) 74550)) inline$$GetFieldFromValue$0$anon0_correct@@3)))
(let ((inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 74584) 74550) inline$$GetFieldFromValue$0$anon0_correct@@3)))
(let ((inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 74468) 74584) inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 74468) 74474) inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@5  (=> (and (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@62 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@63 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@11))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@64 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@12))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@65 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@13))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_Config_$memory) $EmptyTypeValueArray $inv_addr@@9))
)) (= (ControlFlow 0 74590) 74468)) inline$$ValidatorConfig_get_validator_network_addresses_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@5  (=> (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) config_ref@@0) (let ((va@@66 (|v#$Vector| config_ref@@0)))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
)))))) (= (|l#$ValueArray| (|v#$Vector| config_ref@@0)) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@67 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_consensus_pubkey))) $$0@@14))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@68 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_validator_network_addresses))) $$0@@15))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@69 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| config_ref@@0)) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@16))
))) true) (= (ControlFlow 0 74333) 74590)) anon0$1_correct@@5)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 96437) 74333) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@5)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun inline$$ValidatorConfig_is_valid_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun addr@@19 () T@$Value)
(declare-fun inline$$ValidatorConfig_is_valid_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun |inline$$ValidatorConfig_is_valid_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun call4formal@$ret0@0@@3 () T@$Value)
(declare-fun call0formal@$tv0@0@@5 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@4 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@2 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@2 () T@$Value)
(declare-fun inline$$ValidatorConfig_is_valid_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$ValidatorConfig_is_valid_$def_verify$0$$t6@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 96732) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 75600) (- 0 97565)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2) (and (=> (= (ControlFlow 0 75600) (- 0 97574)) (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 75600) (- 0 97583)) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorConfig_is_valid_$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))))))) (=> (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$ValidatorConfig_is_valid_$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))) (=> (= (ControlFlow 0 75600) (- 0 97601)) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@6 T@$Value) )  (=> ((_ is $Address) addr1@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))))))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$Abort_correct  (=> (and (and (= inline$$ValidatorConfig_is_valid_$def_verify$0$$ret0@1 $Error) (= inline$$ValidatorConfig_is_valid_$def_verify$0$$ret0@2 inline$$ValidatorConfig_is_valid_$def_verify$0$$ret0@1)) (and (= $abort_flag@3@@2 true) (= (ControlFlow 0 75556) 75600))) anon0$2_correct@@6)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 75574) 75556)) inline$$ValidatorConfig_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 75584) 75556) inline$$ValidatorConfig_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 75568) 75584) inline$$ValidatorConfig_is_valid_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 75568) 75574) inline$$ValidatorConfig_is_valid_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 75548) 75556)) inline$$ValidatorConfig_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 75564) 75556) inline$$ValidatorConfig_is_valid_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@3 (and (=> (= (ControlFlow 0 75542) 75564) inline$$ValidatorConfig_is_valid_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 75542) 75548) inline$$ValidatorConfig_is_valid_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon16_correct  (=> (= inline$$ValidatorConfig_is_valid_$def_verify$0$$ret0@2 |inline$$ValidatorConfig_is_valid_$def_verify$0$tmp#$1@1|) (=> (and (= $abort_flag@3@@2 $abort_flag@2@@3) (= (ControlFlow 0 75281) 75600)) anon0$2_correct@@6))))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 75279) 75281)) inline$$ValidatorConfig_is_valid_$def_verify$0$anon16_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 75289) 75281) inline$$ValidatorConfig_is_valid_$def_verify$0$anon16_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@1@@3) (=> (and (= |inline$$ValidatorConfig_is_valid_$def_verify$0$tmp#$1@1| call4formal@$ret0@0@@3) (= $abort_flag@2@@3 $abort_flag@1@@3)) (and (=> (= (ControlFlow 0 75538) 75289) inline$$ValidatorConfig_is_valid_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 75538) 75279) inline$$ValidatorConfig_is_valid_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon19_Else$1_correct  (=> (= call0formal@$tv0@0@@5 $ValidatorConfig_Config_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3) (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@3 ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@4)) $Option_Option_vec)) ($Integer 0)))))))))) ((_ is $Boolean) call4formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 75532) 75542) inline$$ValidatorConfig_is_valid_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 75532) 75538) inline$$ValidatorConfig_is_valid_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@4  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@2)) $ValidatorConfig_ValidatorConfig_config)) (= (ControlFlow 0 75524) 75532)) inline$$ValidatorConfig_is_valid_$def_verify$0$anon19_Else$1_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon19_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 75530) 75524)) inline$$GetFieldFromValue$0$anon0_correct@@4)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@0@@3 true) (= inline$$GetGlobal$0$dst@2@@2 inline$$GetGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 75470) 75568) inline$$ValidatorConfig_is_valid_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 75470) 75530) inline$$ValidatorConfig_is_valid_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@2)) (= (ControlFlow 0 75468) 75470)) inline$$GetGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@2  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@2) (= inline$$GetGlobal$0$dst@1@@2 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (and (= $abort_flag@0@@3 false) (= inline$$GetGlobal$0$dst@2@@2 inline$$GetGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 75416) 75568) inline$$ValidatorConfig_is_valid_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 75416) 75530) inline$$ValidatorConfig_is_valid_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct@@2  (=> (= inline$$GetGlobal$0$a@1@@2 (|a#$Address| addr@@19)) (and (=> (= (ControlFlow 0 75398) 75468) inline$$GetGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 75398) 75416) inline$$GetGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$GetGlobal$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 75392) (- 0 97315)) true) (=> (= (ControlFlow 0 75392) 75398) inline$$GetGlobal$0$anon0_correct@@2))))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon18_Then_correct  (=> (and (|b#$Boolean| inline$$ValidatorConfig_is_valid_$def_verify$0$$t3@1) (= (ControlFlow 0 75476) 75392)) inline$$GetGlobal$0$Entry_correct@@2)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon14_correct  (=> (and (= |inline$$ValidatorConfig_is_valid_$def_verify$0$tmp#$1@1| inline$$ValidatorConfig_is_valid_$def_verify$0$$t6@1) (= $abort_flag@2@@3 false)) (and (=> (= (ControlFlow 0 75269) 75289) inline$$ValidatorConfig_is_valid_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 75269) 75279) inline$$ValidatorConfig_is_valid_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 75267) 75269)) inline$$ValidatorConfig_is_valid_$def_verify$0$anon14_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 75297) 75269) inline$$ValidatorConfig_is_valid_$def_verify$0$anon14_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon18_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorConfig_is_valid_$def_verify$0$$t3@1)) (= inline$$ValidatorConfig_is_valid_$def_verify$0$$t6@1 ($Boolean false))) (and (=> (= (ControlFlow 0 75259) 75297) inline$$ValidatorConfig_is_valid_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 75259) 75267) inline$$ValidatorConfig_is_valid_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon2$1_correct  (=> (= inline$$ValidatorConfig_is_valid_$def_verify$0$$t3@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (and (=> (= (ControlFlow 0 75215) 75476) inline$$ValidatorConfig_is_valid_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 75215) 75259) inline$$ValidatorConfig_is_valid_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 75171) 75215)) inline$$ValidatorConfig_is_valid_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 75592) 75215) inline$$ValidatorConfig_is_valid_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_is_valid_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 75165) 75592) inline$$ValidatorConfig_is_valid_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 75165) 75171) inline$$ValidatorConfig_is_valid_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (and (forall (($inv_addr@@10 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10)) (let ((va@@70 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))) $Option_Option_vec)) (let ((va@@71 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))) $Option_Option_vec))))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@10))
)) (forall (($inv_addr@@11 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11)) (let ((va@@72 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@73 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@73 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@74 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@74 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@75 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@75 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@76 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@76 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@76) (<= l@@76 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@76)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@77 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@77 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77))
))))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@17))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@11))
))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((addr@@20 T@$Value) )  (=> ((_ is $Address) addr@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@21 T@$Value) )  (=> ((_ is $Address) addr@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@22 T@$Value) )  (=> ((_ is $Address) addr@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (= (ControlFlow 0 75598) 75165))) inline$$ValidatorConfig_is_valid_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@6  (=> (and ((_ is $Address) addr@@19) (= (ControlFlow 0 74683) 75598)) anon0$1_correct@@6)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 96732) 74683) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun validator_account@@0 () T@$Value)
(declare-fun $abort_flag@5@@2 () Bool)
(declare-fun $abort_code@8@@2 () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory@0@@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@0 () T@$Value)
(declare-fun call0formal@$tv0@0@@6 () T@$TypeValue)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$ValidatorConfig_remove_operator_$def_verify$0$$t6@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 97669) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 78154) (- 0 100088)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 78154) (- 0 100109)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 78154) (- 0 100138)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) $abort_flag@5@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) $abort_flag@5@@2) (and (=> (= (ControlFlow 0 78154) (- 0 100156)) (=> $abort_flag@5@@2 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $Roles_RoleId_role_id) ($Integer 3)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))))))))) (=> (=> $abort_flag@5@@2 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $Roles_RoleId_role_id) ($Integer 3)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))))) (and (=> (= (ControlFlow 0 78154) (- 0 100222)) (=> $abort_flag@5@@2 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@5@@2 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 78154) (- 0 100321)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))))) (=> (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0))))))))))) (=> (= (ControlFlow 0 78154) (- 0 100341)) (=> (not $abort_flag@5@@2) (|b#$Boolean| ($Boolean (forall ((addr@@23 T@$Value) )  (=> ((_ is $Address) addr@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified addr@@23 validator_account@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| addr@@23)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))))))))))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon41_Else$8_correct  (and (=> (= (ControlFlow 0 78036) (- 0 99843)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_remove_operator_$def_verify$0$validator T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_remove_operator_$def_verify$0$validator) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$validator)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$validator)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$validator)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$validator)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_remove_operator_$def_verify$0$validator@@0 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_remove_operator_$def_verify$0$validator@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$validator@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$validator@@0)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$validator@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$validator@@0)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))))))) (and (=> (= (ControlFlow 0 78036) (- 0 99876)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_remove_operator_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_remove_operator_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@0)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (=> (= (ControlFlow 0 78036) (- 0 99910)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@1)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@2)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (=> (= (ControlFlow 0 78036) (- 0 99944)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@3)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@3)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@4)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_remove_operator_$def_verify$0$addr@@4)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (=> (and (and (= $abort_code@8@@2 $abort_code@6@@2) (= $abort_flag@5@@2 $abort_flag@4@@2)) (and (= $ValidatorConfig_ValidatorConfig_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 78036) 78154))) anon0$2_correct@@7)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 77834) 78036)) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon41_Else$8_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 77888) 78036))) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon41_Else$8_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 77824) 77888) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 77824) 77834) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$Entry_correct  (=> (and (= inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 77700) 77824)) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 77621) 77700)) inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 77677) 77700))) inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 77585) 77677) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 77585) 77621) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 77444) (- 0 99582)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 77444) 77585) inline$$WritebackToReference$0$anon0_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$pack_ref$0$$tv0@0 $AddressType) (=> (and (= inline$$Option_Option_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)) (= (ControlFlow 0 77420) 77444)) inline$$Option_Option_$pack_ref$0$anon0_correct))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) call3formal@$ret0@0@@8)) (= (ControlFlow 0 77368) 77420)) inline$$Option_Option_$pack_ref$0$Entry_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$0$$before@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 77311) 77368)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$unpack_ref$0$$tv0@0 $AddressType) (=> (and (= inline$$Option_Option_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 77305) 77311)) inline$$Option_Option_$unpack_ref$0$anon0_correct))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $ValidatorConfig_ValidatorConfig_operator_account) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $ValidatorConfig_ValidatorConfig_operator_account))) (= (ControlFlow 0 77271) 77305))) inline$$Option_Option_$unpack_ref$0$Entry_correct))))
(let ((inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$anon0_correct  (=> (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0)) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (= (ControlFlow 0 77149) 77271)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$Entry_correct  (=> (and (= inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 77143) 77149)) inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$anon0_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon41_Else_correct  (=> (and (not $abort_flag@4@@2) (= (ControlFlow 0 77153) 77143)) inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$Entry_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@8@@2 $abort_code@7@@2) (= $abort_flag@5@@2 true)) (and (= $ValidatorConfig_ValidatorConfig_$memory@0@@0 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 76901) 78154))) anon0$2_correct@@7)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon5_correct  (=> (and (= $abort_code@7@@2 $abort_code@1@@3) (= (ControlFlow 0 78132) 76901)) inline$$ValidatorConfig_remove_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 78130) 78132)) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon5_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 78140) 78132) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon5_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon30_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 78124) 78140) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 78124) 78130) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon9_correct  (=> (and (= $abort_code@7@@2 $abort_code@2@@3) (= (ControlFlow 0 78112) 76901)) inline$$ValidatorConfig_remove_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 78110) 78112)) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon9_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 78120) 78112) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon9_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon32_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 78104) 78120) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 78104) 78110) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon15_correct  (=> (and (= $abort_code@7@@2 $abort_code@3@@3) (= (ControlFlow 0 78088) 76901)) inline$$ValidatorConfig_remove_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 78086) 78088)) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon15_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 78096) 78088) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon15_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon35_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 78080) 78096) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 78080) 78086) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon23_correct  (=> (and (= $abort_code@7@@2 $abort_code@4@@3) (= (ControlFlow 0 78068) 76901)) inline$$ValidatorConfig_remove_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 78066) 78068)) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon23_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 78076) 78068) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon23_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon39_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 78060) 78076) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 78060) 78066) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon27_correct  (=> (and (= $abort_code@7@@2 $abort_code@6@@2) (= (ControlFlow 0 78048) 76901)) inline$$ValidatorConfig_remove_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 78046) 78048)) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon27_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 78056) 78048) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon27_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon41_Then_correct  (=> $abort_flag@4@@2 (and (=> (= (ControlFlow 0 78040) 78056) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 78040) 78046) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@4@@2 true) (=> (and (= $abort_code@6@@2 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 77110) 78040) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 77110) 77153) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 77108) 77110)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_flag@4@@2 $abort_flag@3@@3)) (and (= $abort_code@6@@2 $abort_code@4@@3) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 77056) 78040) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 77056) 77153) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@9)) (and (=> (= (ControlFlow 0 77026) 77108) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 77026) 77056) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 77020) (- 0 99340)) true) (=> (= (ControlFlow 0 77020) 77026) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@3@@3) (= (ControlFlow 0 77116) 77020)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon37_Then_correct  (=> (|b#$Boolean| inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@0) (=> (and (and (= call0formal@$tv0@0@@6 $AddressType) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@3)) (and (=> $abort_flag@3@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Vector (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 ($Vector $EmptyValueArray)) (+ len@@2 1)))))))))) (=> (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@8) (let ((va@@78 (|v#$Vector| call3formal@$ret0@0@@8)))
(let ((l@@78 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78))
)))))) (= (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $Option_Option_vec)) (let ((va@@79 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $Option_Option_vec))))
(let ((l@@79 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 76915) 78060) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 76915) 77116) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon39_Else_correct)))))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon20_correct  (=> (and (= $abort_code@7@@2 $abort_code@5@@3) (= (ControlFlow 0 76897) 76901)) inline$$ValidatorConfig_remove_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 76895) 76897)) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon20_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 76909) 76897) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon20_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@0)) (= $abort_code@5@@3 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 76889) 76909) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 76889) 76895) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@2@@4) (and (=> (= (ControlFlow 0 76877) 76915) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 76877) 76889) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon34_Else_correct  (=> (not $abort_flag@1@@4) (=> (and (and (and (= inline$$ValidatorConfig_remove_operator_$def_verify$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@4)) (and (=> $abort_flag@2@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 76871) 78080) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 76871) 76877) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon34_Then_correct  (=> $abort_flag@1@@4 (=> (and (= $abort_code@7@@2 $abort_code@2@@3) (= (ControlFlow 0 78100) 76901)) inline$$ValidatorConfig_remove_operator_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 76827) 78100) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 76827) 76871) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 76837) 78100) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 76837) 76871) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon34_Else_correct))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct@@0  (=> (= inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@9)))) (and (=> (= (ControlFlow 0 76821) 76837) inline$$ValidatorConfig_exists_config_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 76821) 76827) inline$$ValidatorConfig_exists_config_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 76775) 76821)) inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct@@0)))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 76845) 76821) inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct@@0)))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon0_correct@@0  (=> (not $abort_flag@1@@4) (and (=> (= (ControlFlow 0 76769) 76845) inline$$ValidatorConfig_exists_config_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 76769) 76775) inline$$ValidatorConfig_exists_config_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$ValidatorConfig_exists_config_$direct_intra$0$anon0_correct@@0  (=> (and ((_ is $Address) call3formal@$ret0@0@@9) (= (ControlFlow 0 76851) 76769)) inline$$ValidatorConfig_exists_config_$def$0$anon0_correct@@0)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon32_Else_correct  (=> (and (not $abort_flag@1@@4) (= (ControlFlow 0 76859) 76851)) inline$$ValidatorConfig_exists_config_$direct_intra$0$anon0_correct@@0)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon30_Else_correct  (=> (not $abort_flag@0@@4) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@4) (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 validator_account@@0)))) ((_ is $Address) call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 76613) 78104) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 76613) 76859) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) $abort_flag@0@@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@0@@4)) (and (=> $abort_flag@0@@4 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $Roles_RoleId_role_id) ($Integer 3))))))) (=> $abort_flag@0@@4 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0))))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@0)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 76607) 78124) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 76607) 76613) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 76571) 76607)) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 78148) 76607) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon2$1_correct)))
(let ((inline$$ValidatorConfig_remove_operator_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 76565) 78148) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 76565) 76571) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@7  (=> (forall (($inv_addr@@12 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12)) (let ((va@@80 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))))
(let ((l@@80 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@80) (<= l@@80 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@80)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@12))
)) (=> (and (forall (($inv_addr@@13 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13)) (let ((va@@81 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))))
(let ((l@@81 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@82 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@82 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@83 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@83 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@84 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@84 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@85 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@85 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@86 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@86 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86))
))))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@18))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@13))
)) (|b#$Boolean| ($Boolean (forall ((addr@@24 T@$Value) )  (=> ((_ is $Address) addr@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) $Roles_RoleId_role_id) ($Integer 4))))))))))))))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((addr@@25 T@$Value) )  (=> ((_ is $Address) addr@@25) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@26 T@$Value) )  (=> ((_ is $Address) addr@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@26)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@26)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@26)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@27 T@$Value) )  (=> ((_ is $Address) addr@@27) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (= (ControlFlow 0 78152) 76565))) inline$$ValidatorConfig_remove_operator_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@7  (=> (and ((_ is $Address) validator_account@@0) (= (ControlFlow 0 75764) 78152)) anon0$1_correct@@7)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 97669) 75764) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@7))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun validator_operator_account () T@$Value)
(declare-fun validator_addr () T@$Value)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun consensus_pubkey () T@$Value)
(declare-fun $abort_code@12 () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory@0@@1 () T@$Memory)
(declare-fun validator_network_addresses () T@$Value)
(declare-fun fullnode_network_addresses () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$0$$tv0@0@@0 () T@$TypeValue)
(declare-fun inline$$ValidatorConfig_set_config_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun call4formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$tv0@0@@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun $abort_code@11@@0 () Int)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_code@2@@4 () Int)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun $abort_flag@2@@5 () Bool)
(declare-fun $abort_code@5@@4 () Int)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun $abort_code@7@@3 () Int)
(declare-fun $abort_flag@4@@3 () Bool)
(declare-fun $abort_code@9@@2 () Int)
(declare-fun $abort_flag@5@@3 () Bool)
(declare-fun call0formal@$tv0@0@@7 () T@$TypeValue)
(declare-fun inline$$ValidatorConfig_Config_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@1 () T@$Value)
(declare-fun inline$$ValidatorConfig_set_config_$def_verify$0$$ValidatorConfig_ValidatorConfig_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@8@@3 () Int)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$ValidatorConfig_set_config_$def_verify$0$$t26@1 () T@$Value)
(declare-fun inline$$Signature_ed25519_validate_pubkey$0$res@1 () T@$Value)
(declare-fun $abort_code@6@@3 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$ValidatorConfig_set_config_$def_verify$0$$t23@1 () T@$Value)
(declare-fun inline$$ValidatorConfig_set_config_$def_verify$0$$t19@1 () T@$Value)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$ValidatorConfig_set_config_$def_verify$0$$t20@1 () T@$Value)
(declare-fun $ValidatorConfig_ValidatorConfig_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 100416) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 82379) (- 0 103986)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified validator_operator_account (let ((t_ref@@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@1)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0))))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified validator_operator_account (let ((t_ref@@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@1)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0))))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 82379) (- 0 104006)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey consensus_pubkey))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey consensus_pubkey))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 82379) (- 0 104021)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))) $abort_flag@7@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))) $abort_flag@7@@0) (and (=> (= (ControlFlow 0 82379) (- 0 104037)) (=> $abort_flag@7@@0 (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified validator_operator_account (let ((t_ref@@2 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@2)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey consensus_pubkey)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))))))))) (=> (=> $abort_flag@7@@0 (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified validator_operator_account (let ((t_ref@@2 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@2)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey consensus_pubkey)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))))) (and (=> (= (ControlFlow 0 82379) (- 0 104086)) (=> $abort_flag@7@@0 (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified validator_operator_account (let ((t_ref@@3 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@3)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0))))))) (= $abort_code@12 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey consensus_pubkey))))) (= $abort_code@12 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))) (= $abort_code@12 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@7@@0 (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified validator_operator_account (let ((t_ref@@3 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@3)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0))))))) (= $abort_code@12 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Signature_$ed25519_validate_pubkey consensus_pubkey))))) (= $abort_code@12 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))) (= $abort_code@12 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 82379) (- 0 104168)) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))))) (=> (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))) (and (=> (= (ControlFlow 0 82379) (- 0 104180)) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| validator_addr)) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config ($Vector (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Vector (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@6 consensus_pubkey) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@6 consensus_pubkey) (+ len@@6 1)))) len@@5 validator_network_addresses) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@6 consensus_pubkey) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@6 consensus_pubkey) (+ len@@6 1)))) len@@5 validator_network_addresses) (+ len@@5 1)))) len@@4 fullnode_network_addresses) (+ len@@4 1))))) 1))) (+ len@@3 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))))))) (=> (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| validator_addr)) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_config ($Vector (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Vector (let ((len@@4 (|l#$ValueArray| (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@6 consensus_pubkey) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@6 consensus_pubkey) (+ len@@6 1)))) len@@5 validator_network_addresses) (+ len@@5 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@6 consensus_pubkey) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@6 consensus_pubkey) (+ len@@6 1)))) len@@5 validator_network_addresses) (+ len@@5 1)))) len@@4 fullnode_network_addresses) (+ len@@4 1))))) 1))) (+ len@@3 1))))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))))))))) (=> (= (ControlFlow 0 82379) (- 0 104229)) (=> (not $abort_flag@7@@0) (|b#$Boolean| ($Boolean (forall ((addr1@@7 T@$Value) )  (=> ((_ is $Address) addr1@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))))))))))))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon58$4_correct  (and (=> (= (ControlFlow 0 82159) (- 0 103693)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_config_$def_verify$0$validator T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_config_$def_verify$0$validator) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$validator)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$validator)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$validator)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$validator)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_config_$def_verify$0$validator@@0 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_config_$def_verify$0$validator@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$validator@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$validator@@0)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$validator@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$validator@@0)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))))))) (and (=> (= (ControlFlow 0 82159) (- 0 103726)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_config_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_config_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_config_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_config_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@0)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (=> (= (ControlFlow 0 82159) (- 0 103760)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_config_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_config_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@1)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_config_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_config_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@2)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (=> (= (ControlFlow 0 82159) (- 0 103794)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_config_$def_verify$0$addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_config_$def_verify$0$addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@3)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@3)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_config_$def_verify$0$addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_config_$def_verify$0$addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@4)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_config_$def_verify$0$addr@@4)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (=> (and (and (= $abort_code@12 $abort_code@10@@0) (= $abort_flag@7@@0 $abort_flag@6@@0)) (and (= $ValidatorConfig_ValidatorConfig_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 82159) 82379))) anon0$2_correct@@8)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 81957) 82159)) inline$$ValidatorConfig_set_config_$def_verify$0$anon58$4_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 82011) 82159))) inline$$ValidatorConfig_set_config_$def_verify$0$anon58$4_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 81947) 82011) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 81947) 81957) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 81823) 81947)) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 81744) 81823)) inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$Entry_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 81800) 81823))) inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 81708) 81800) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 81708) 81744) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$Option_Option_$pack_ref$0$anon0_correct@@0  (and (=> (= (ControlFlow 0 81567) (- 0 103432)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0@@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0@@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 81567) 81708) inline$$WritebackToReference$0$anon0_correct@@0)))))
(let ((inline$$Option_Option_$pack_ref$0$Entry_correct@@0  (=> (= inline$$Option_Option_$pack_ref$0$$tv0@0@@0 $ValidatorConfig_Config_type_value) (=> (and (= inline$$Option_Option_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= (ControlFlow 0 81543) 81567)) inline$$Option_Option_$pack_ref$0$anon0_correct@@0))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 81497) 81543)) inline$$Option_Option_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon87_Then_correct  (=> (and (= inline$$ValidatorConfig_set_config_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 82169) 81543)) inline$$Option_Option_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) call4formal@$ret0@0@@4)) (and (=> (= (ControlFlow 0 81483) 82169) inline$$ValidatorConfig_set_config_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 81483) 81497) inline$$ValidatorConfig_set_config_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$Option_Option_$unpack_ref$0$anon0_correct@@0  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$0$$before@0@@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 81426) 81483)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$Option_Option_$unpack_ref$0$Entry_correct@@0  (=> (= inline$$Option_Option_$unpack_ref$0$$tv0@0@@0 $ValidatorConfig_Config_type_value) (=> (and (= inline$$Option_Option_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 81420) 81426)) inline$$Option_Option_$unpack_ref$0$anon0_correct@@0))))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $ValidatorConfig_ValidatorConfig_config) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $ValidatorConfig_ValidatorConfig_config))) (= (ControlFlow 0 81386) 81420))) inline$$Option_Option_$unpack_ref$0$Entry_correct@@0))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon85_Else_correct  (=> (and (not $abort_flag@6@@0) (= (ControlFlow 0 81392) 81386)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@12 $abort_code@11@@0) (= $abort_flag@7@@0 true)) (and (= $ValidatorConfig_ValidatorConfig_$memory@0@@1 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 80198) 82379))) anon0$2_correct@@8)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon13_correct  (=> (and (= $abort_code@11@@0 $abort_code@1@@4) (= (ControlFlow 0 82325) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 82323) 82325)) inline$$ValidatorConfig_set_config_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon65_Then_correct  (=> (= (ControlFlow 0 82333) 82325) inline$$ValidatorConfig_set_config_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon64_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 82317) 82333) inline$$ValidatorConfig_set_config_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 82317) 82323) inline$$ValidatorConfig_set_config_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon17_correct  (=> (and (= $abort_code@11@@0 $abort_code@2@@4) (= (ControlFlow 0 82305) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 82303) 82305)) inline$$ValidatorConfig_set_config_$def_verify$0$anon17_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon67_Then_correct  (=> (= (ControlFlow 0 82313) 82305) inline$$ValidatorConfig_set_config_$def_verify$0$anon17_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon66_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 82297) 82313) inline$$ValidatorConfig_set_config_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 82297) 82303) inline$$ValidatorConfig_set_config_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon21_correct  (=> (and (= $abort_code@11@@0 $abort_code@3@@4) (= (ControlFlow 0 82285) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 82283) 82285)) inline$$ValidatorConfig_set_config_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 82293) 82285) inline$$ValidatorConfig_set_config_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon68_Then_correct  (=> $abort_flag@2@@5 (and (=> (= (ControlFlow 0 82277) 82293) inline$$ValidatorConfig_set_config_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 82277) 82283) inline$$ValidatorConfig_set_config_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon29_correct  (=> (and (= $abort_code@11@@0 $abort_code@3@@4) (= (ControlFlow 0 82265) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 82263) 82265)) inline$$ValidatorConfig_set_config_$def_verify$0$anon29_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon73_Then_correct  (=> (= (ControlFlow 0 82273) 82265) inline$$ValidatorConfig_set_config_$def_verify$0$anon29_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon72_Then_correct  (=> $abort_flag@2@@5 (and (=> (= (ControlFlow 0 82257) 82273) inline$$ValidatorConfig_set_config_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 82257) 82263) inline$$ValidatorConfig_set_config_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon33_correct  (=> (and (= $abort_code@11@@0 $abort_code@5@@4) (= (ControlFlow 0 82245) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 82243) 82245)) inline$$ValidatorConfig_set_config_$def_verify$0$anon33_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon75_Then_correct  (=> (= (ControlFlow 0 82253) 82245) inline$$ValidatorConfig_set_config_$def_verify$0$anon33_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon74_Then_correct  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 82237) 82253) inline$$ValidatorConfig_set_config_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 82237) 82243) inline$$ValidatorConfig_set_config_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon43_correct  (=> (and (= $abort_code@11@@0 $abort_code@7@@3) (= (ControlFlow 0 82221) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 82219) 82221)) inline$$ValidatorConfig_set_config_$def_verify$0$anon43_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon80_Then_correct  (=> (= (ControlFlow 0 82229) 82221) inline$$ValidatorConfig_set_config_$def_verify$0$anon43_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon79_Then_correct  (=> $abort_flag@4@@3 (and (=> (= (ControlFlow 0 82213) 82229) inline$$ValidatorConfig_set_config_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 82213) 82219) inline$$ValidatorConfig_set_config_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon51_correct  (=> (and (= $abort_code@11@@0 $abort_code@9@@2) (= (ControlFlow 0 82201) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 82199) 82201)) inline$$ValidatorConfig_set_config_$def_verify$0$anon51_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon84_Then_correct  (=> (= (ControlFlow 0 82209) 82201) inline$$ValidatorConfig_set_config_$def_verify$0$anon51_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Then_correct  (=> $abort_flag@5@@3 (and (=> (= (ControlFlow 0 82193) 82209) inline$$ValidatorConfig_set_config_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 82193) 82199) inline$$ValidatorConfig_set_config_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon55_correct  (=> (and (= $abort_code@11@@0 $abort_code@10@@0) (= (ControlFlow 0 82181) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 82179) 82181)) inline$$ValidatorConfig_set_config_$def_verify$0$anon55_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon86_Then_correct  (=> (= (ControlFlow 0 82189) 82181) inline$$ValidatorConfig_set_config_$def_verify$0$anon55_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon85_Then_correct  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 82173) 82189) inline$$ValidatorConfig_set_config_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 82173) 82179) inline$$ValidatorConfig_set_config_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Else$2_correct  (=> (and (and (= call0formal@$tv0@0@@7 $ValidatorConfig_Config_type_value) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@0)) (and (=> $abort_flag@6@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@4 ($Vector (let ((len@@7 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@7 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$ValidatorConfig_Config_pack$0$$struct@1) 1))) (+ len@@7 1)))))))))) (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@4) (let ((va@@87 (|v#$Vector| call4formal@$ret0@0@@4)))
(let ((l@@87 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $Option_Option_vec)) (let ((va@@88 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $Option_Option_vec))))
(let ((l@@88 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 81264) 82173) inline$$ValidatorConfig_set_config_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 81264) 81392) inline$$ValidatorConfig_set_config_$def_verify$0$anon85_Else_correct))))))
(let ((inline$$ValidatorConfig_Config_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 81250) 81264)) inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Else$2_correct)))
(let ((inline$$ValidatorConfig_Config_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 81256) 81264) inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Else$2_correct)))
(let ((inline$$ValidatorConfig_Config_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 81244) 81256) inline$$ValidatorConfig_Config_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 81244) 81250) inline$$ValidatorConfig_Config_pack$0$anon4_Else_correct)))))
(let ((inline$$ValidatorConfig_Config_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 81236) 81264)) inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Else$2_correct)))
(let ((inline$$ValidatorConfig_Config_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) consensus_pubkey) (let ((va@@89 (|v#$Vector| consensus_pubkey)))
(let ((l@@89 (|l#$ValueArray| va@@89)))
 (and (and (<= 0 l@@89) (<= l@@89 $MAX_U64)) (forall ((x@@89 Int) ) (!  (=> (or (< x@@89 0) (>= x@@89 l@@89)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89))
)))))) (forall ((inline$$ValidatorConfig_Config_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$ValidatorConfig_Config_pack$0$$$0 0) (< inline$$ValidatorConfig_Config_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| consensus_pubkey)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| consensus_pubkey)) inline$$ValidatorConfig_Config_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| consensus_pubkey)) inline$$ValidatorConfig_Config_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| consensus_pubkey)) inline$$ValidatorConfig_Config_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| consensus_pubkey)) inline$$ValidatorConfig_Config_pack$0$$$0))
))) (and (and ((_ is $Vector) validator_network_addresses) (let ((va@@90 (|v#$Vector| validator_network_addresses)))
(let ((l@@90 (|l#$ValueArray| va@@90)))
 (and (and (<= 0 l@@90) (<= l@@90 $MAX_U64)) (forall ((x@@90 Int) ) (!  (=> (or (< x@@90 0) (>= x@@90 l@@90)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90))
)))))) (forall ((inline$$ValidatorConfig_Config_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$ValidatorConfig_Config_pack$0$$$0@@0 0) (< inline$$ValidatorConfig_Config_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| validator_network_addresses)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validator_network_addresses)) inline$$ValidatorConfig_Config_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validator_network_addresses)) inline$$ValidatorConfig_Config_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validator_network_addresses)) inline$$ValidatorConfig_Config_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validator_network_addresses)) inline$$ValidatorConfig_Config_pack$0$$$0@@0))
)))) (and (and (and ((_ is $Vector) fullnode_network_addresses) (let ((va@@91 (|v#$Vector| fullnode_network_addresses)))
(let ((l@@91 (|l#$ValueArray| va@@91)))
 (and (and (<= 0 l@@91) (<= l@@91 $MAX_U64)) (forall ((x@@91 Int) ) (!  (=> (or (< x@@91 0) (>= x@@91 l@@91)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91))
)))))) (forall ((inline$$ValidatorConfig_Config_pack$0$$$0@@1 Int) ) (!  (=> (and (>= inline$$ValidatorConfig_Config_pack$0$$$0@@1 0) (< inline$$ValidatorConfig_Config_pack$0$$$0@@1 (|l#$ValueArray| (|v#$Vector| fullnode_network_addresses)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| fullnode_network_addresses)) inline$$ValidatorConfig_Config_pack$0$$$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| fullnode_network_addresses)) inline$$ValidatorConfig_Config_pack$0$$$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| fullnode_network_addresses)) inline$$ValidatorConfig_Config_pack$0$$$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| fullnode_network_addresses)) inline$$ValidatorConfig_Config_pack$0$$$0@@1))
))) (= inline$$ValidatorConfig_Config_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 consensus_pubkey) 1 validator_network_addresses) 2 fullnode_network_addresses) 3))))) (and (=> (= (ControlFlow 0 81228) 81244) inline$$ValidatorConfig_Config_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 81228) 81236) inline$$ValidatorConfig_Config_pack$0$anon3_Else_correct)))))
(let ((inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$anon0_correct@@0  (=> (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0@@0)) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0@@0)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (= (ControlFlow 0 80830) 81228)) inline$$ValidatorConfig_Config_pack$0$anon0_correct)))
(let ((inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 80824) 80830)) inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Else_correct  (=> (and (not $abort_flag@5@@3) (= (ControlFlow 0 80834) 80824)) inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@5@@3 true) (=> (and (= $abort_code@9@@2 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 80791) 82193) inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 80791) 80834) inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 80789) 80791)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@0))) (= $abort_flag@5@@3 $abort_flag@4@@3)) (and (= $abort_code@9@@2 $abort_code@7@@3) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 80737) 82193) inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 80737) 80834) inline$$ValidatorConfig_set_config_$def_verify$0$anon83_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| validator_addr)) (and (=> (= (ControlFlow 0 80707) 80789) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 80707) 80737) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 80701) (- 0 102922)) true) (=> (= (ControlFlow 0 80701) 80707) inline$$BorrowGlobal$0$anon0_correct@@0))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon81_Then_correct  (=> (|b#$Boolean| inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@1) (and (=> (= (ControlFlow 0 80797) (- 0 102881)) (|Select_[$TypeValueArray,$int]$bool| inline$$ValidatorConfig_set_config_$def_verify$0$$ValidatorConfig_ValidatorConfig_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| validator_addr))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$ValidatorConfig_set_config_$def_verify$0$$ValidatorConfig_ValidatorConfig_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| validator_addr)) (=> (= (ControlFlow 0 80797) 80701) inline$$BorrowGlobal$0$Entry_correct@@0))))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon48_correct  (=> (and (= $abort_code@11@@0 $abort_code@8@@3) (= (ControlFlow 0 80578) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 80576) 80578)) inline$$ValidatorConfig_set_config_$def_verify$0$anon48_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon82_Then_correct  (=> (= (ControlFlow 0 80586) 80578) inline$$ValidatorConfig_set_config_$def_verify$0$anon48_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon81_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@1)) (= $abort_code@8@@3 (|i#$Integer| call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 80570) 80586) inline$$ValidatorConfig_set_config_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 80570) 80576) inline$$ValidatorConfig_set_config_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon79_Else_correct  (=> (not $abort_flag@4@@3) (and (=> (= (ControlFlow 0 80558) 80797) inline$$ValidatorConfig_set_config_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 80558) 80570) inline$$ValidatorConfig_set_config_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon78_Else_correct  (=> (not $abort_flag@3@@4) (=> (and (and (and (= inline$$ValidatorConfig_set_config_$def_verify$0$$t26@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@3)) (and (=> $abort_flag@4@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@11) (>= (|i#$Integer| call3formal@$ret0@0@@11) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@11) $MAX_U64))) (and (=> (= (ControlFlow 0 80552) 82213) inline$$ValidatorConfig_set_config_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 80552) 80558) inline$$ValidatorConfig_set_config_$def_verify$0$anon79_Else_correct))))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon78_Then_correct  (=> $abort_flag@3@@4 (=> (and (= $abort_code@11@@0 $abort_code@5@@4) (= (ControlFlow 0 82233) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon6_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 80508) 82233) inline$$ValidatorConfig_set_config_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 80508) 80552) inline$$ValidatorConfig_set_config_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon6_Then_correct@@1  (and (=> (= (ControlFlow 0 80518) 82233) inline$$ValidatorConfig_set_config_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 80518) 80552) inline$$ValidatorConfig_set_config_$def_verify$0$anon78_Else_correct))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct@@1  (=> (= inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) (and (=> (= (ControlFlow 0 80502) 80518) inline$$ValidatorConfig_exists_config_$def$0$anon6_Then_correct@@1) (=> (= (ControlFlow 0 80502) 80508) inline$$ValidatorConfig_exists_config_$def$0$anon6_Else_correct@@1)))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 80456) 80502)) inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct@@1)))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 80526) 80502) inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct@@1)))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon0_correct@@1  (=> (not $abort_flag@3@@4) (and (=> (= (ControlFlow 0 80450) 80526) inline$$ValidatorConfig_exists_config_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 80450) 80456) inline$$ValidatorConfig_exists_config_$def$0$anon5_Else_correct@@1)))))
(let ((inline$$ValidatorConfig_exists_config_$direct_intra$0$anon0_correct@@1  (=> (and ((_ is $Address) validator_addr) (= (ControlFlow 0 80532) 80450)) inline$$ValidatorConfig_exists_config_$def$0$anon0_correct@@1)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon76_Then_correct  (=> (and (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1) (= (ControlFlow 0 80540) 80532)) inline$$ValidatorConfig_exists_config_$direct_intra$0$anon0_correct@@1)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon38_correct  (=> (and (= $abort_code@11@@0 $abort_code@6@@3) (= (ControlFlow 0 80286) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon77_Else_correct  (=> (and (not true) (= (ControlFlow 0 80284) 80286)) inline$$ValidatorConfig_set_config_$def_verify$0$anon38_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon77_Then_correct  (=> (= (ControlFlow 0 80294) 80286) inline$$ValidatorConfig_set_config_$def_verify$0$anon38_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon76_Else_correct  (=> (and (not (|b#$Boolean| inline$$Signature_ed25519_validate_pubkey$0$res@1)) (= $abort_code@6@@3 (|i#$Integer| call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 80278) 80294) inline$$ValidatorConfig_set_config_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 80278) 80284) inline$$ValidatorConfig_set_config_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon74_Else_correct  (=> (not $abort_flag@3@@4) (and (=> (= (ControlFlow 0 80266) 80540) inline$$ValidatorConfig_set_config_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 80266) 80278) inline$$ValidatorConfig_set_config_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon72_Else_correct  (=> (not $abort_flag@2@@5) (=> (and (and (and (= inline$$ValidatorConfig_set_config_$def_verify$0$$t23@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@4)) (and (=> $abort_flag@3@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 80260) 82237) inline$$ValidatorConfig_set_config_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 80260) 80266) inline$$ValidatorConfig_set_config_$def_verify$0$anon74_Else_correct))))))
(let ((inline$$Signature_ed25519_validate_pubkey$0$anon0_correct  (=> (= inline$$Signature_ed25519_validate_pubkey$0$res@1 ($Signature_$ed25519_validate_pubkey consensus_pubkey)) (and (=> (= (ControlFlow 0 80242) 82257) inline$$ValidatorConfig_set_config_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 80242) 80260) inline$$ValidatorConfig_set_config_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon70_Then_correct  (=> (and (|b#$Boolean| inline$$ValidatorConfig_set_config_$def_verify$0$$t19@1) (= (ControlFlow 0 80248) 80242)) inline$$Signature_ed25519_validate_pubkey$0$anon0_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon26_correct  (=> (and (= $abort_code@11@@0 $abort_code@4@@4) (= (ControlFlow 0 80194) 80198)) inline$$ValidatorConfig_set_config_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 80192) 80194)) inline$$ValidatorConfig_set_config_$def_verify$0$anon26_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon71_Then_correct  (=> (= (ControlFlow 0 80206) 80194) inline$$ValidatorConfig_set_config_$def_verify$0$anon26_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon70_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorConfig_set_config_$def_verify$0$$t19@1)) (= $abort_code@4@@4 (|i#$Integer| call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 80186) 80206) inline$$ValidatorConfig_set_config_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 80186) 80192) inline$$ValidatorConfig_set_config_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon68_Else_correct  (=> (not $abort_flag@2@@5) (and (=> (= (ControlFlow 0 80174) 80248) inline$$ValidatorConfig_set_config_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 80174) 80186) inline$$ValidatorConfig_set_config_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon66_Else_correct  (=> (and (not $abort_flag@1@@5) (= inline$$ValidatorConfig_set_config_$def_verify$0$$t19@1 ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 call3formal@$ret0@0@@15)))) (=> (and (and (and (= inline$$ValidatorConfig_set_config_$def_verify$0$$t20@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@5)) (and (=> $abort_flag@2@@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@13) (>= (|i#$Integer| call3formal@$ret0@0@@13) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@13) $MAX_U64))) (and (=> (= (ControlFlow 0 80168) 82277) inline$$ValidatorConfig_set_config_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 80168) 80174) inline$$ValidatorConfig_set_config_$def_verify$0$anon68_Else_correct))))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon64_Else_correct  (=> (and (and (and (not $abort_flag@0@@5) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))) $abort_flag@1@@5)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))) $abort_flag@1@@5) (=> $abort_flag@1@@5 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))))))) (and (and (=> $abort_flag@1@@5 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))))) (= $abort_code@2@@4 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))))) (= $abort_code@2@@4 (|i#$Integer| ($Integer 5)))))) (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 (let ((t_ref@@4 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_addr))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@4)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0)))))))) (and (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@8 T@$Value) )  (=> ((_ is $Address) addr1@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))) ((_ is $Address) call3formal@$ret0@0@@15)))) (and (=> (= (ControlFlow 0 80150) 82297) inline$$ValidatorConfig_set_config_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 80150) 80168) inline$$ValidatorConfig_set_config_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon10$5_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@5) (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 validator_operator_account)))) ((_ is $Address) call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 80144) 82317) inline$$ValidatorConfig_set_config_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 80144) 80150) inline$$ValidatorConfig_set_config_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon10_correct  (=> (and (= inline$$ValidatorConfig_set_config_$def_verify$0$$ValidatorConfig_ValidatorConfig_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| validator_addr) true)) (= (ControlFlow 0 80006) 80144)) inline$$ValidatorConfig_set_config_$def_verify$0$anon10$5_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 79958) 80006)) inline$$ValidatorConfig_set_config_$def_verify$0$anon10_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 82341) 80006) inline$$ValidatorConfig_set_config_$def_verify$0$anon10_correct)))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon62_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 79950) 82341) inline$$ValidatorConfig_set_config_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 79950) 79958) inline$$ValidatorConfig_set_config_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon62_Then_correct  (and (=> (= (ControlFlow 0 82349) 82341) inline$$ValidatorConfig_set_config_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 82349) 79958) inline$$ValidatorConfig_set_config_$def_verify$0$anon63_Else_correct))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon61_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 79942) 82349) inline$$ValidatorConfig_set_config_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 79942) 79950) inline$$ValidatorConfig_set_config_$def_verify$0$anon62_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon61_Then_correct  (and (=> (= (ControlFlow 0 82357) 82349) inline$$ValidatorConfig_set_config_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 82357) 79950) inline$$ValidatorConfig_set_config_$def_verify$0$anon62_Else_correct))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon60_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 79934) 82357) inline$$ValidatorConfig_set_config_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 79934) 79942) inline$$ValidatorConfig_set_config_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon60_Then_correct  (and (=> (= (ControlFlow 0 82365) 82357) inline$$ValidatorConfig_set_config_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 82365) 79942) inline$$ValidatorConfig_set_config_$def_verify$0$anon61_Else_correct))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon59_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 79926) 82365) inline$$ValidatorConfig_set_config_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 79926) 79934) inline$$ValidatorConfig_set_config_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon59_Then_correct  (and (=> (= (ControlFlow 0 82373) 82365) inline$$ValidatorConfig_set_config_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 82373) 79934) inline$$ValidatorConfig_set_config_$def_verify$0$anon60_Else_correct))))
(let ((inline$$ValidatorConfig_set_config_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 79920) 82373) inline$$ValidatorConfig_set_config_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 79920) 79926) inline$$ValidatorConfig_set_config_$def_verify$0$anon59_Else_correct)))))
(let ((anon0$1_correct@@8  (=> (and (forall (($inv_addr@@14 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@14)) (let ((va@@92 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@14))))
(let ((l@@92 (|l#$ValueArray| va@@92)))
 (and (and (<= 0 l@@92) (<= l@@92 $MAX_U64)) (forall ((x@@92 Int) ) (!  (=> (or (< x@@92 0) (>= x@@92 l@@92)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@14))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@14))) $Option_Option_vec)) (let ((va@@93 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@14))) $Option_Option_vec))))
(let ((l@@93 (|l#$ValueArray| va@@93)))
 (and (and (<= 0 l@@93) (<= l@@93 $MAX_U64)) (forall ((x@@93 Int) ) (!  (=> (or (< x@@93 0) (>= x@@93 l@@93)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@14))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@14))
)) (forall (($inv_addr@@15 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15)) (let ((va@@94 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))))
(let ((l@@94 (|l#$ValueArray| va@@94)))
 (and (and (<= 0 l@@94) (<= l@@94 $MAX_U64)) (forall ((x@@94 Int) ) (!  (=> (or (< x@@94 0) (>= x@@94 l@@94)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@95 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@95 (|l#$ValueArray| va@@95)))
 (and (and (<= 0 l@@95) (<= l@@95 $MAX_U64)) (forall ((x@@95 Int) ) (!  (=> (or (< x@@95 0) (>= x@@95 l@@95)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@96 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@96 (|l#$ValueArray| va@@96)))
 (and (and (<= 0 l@@96) (<= l@@96 $MAX_U64)) (forall ((x@@96 Int) ) (!  (=> (or (< x@@96 0) (>= x@@96 l@@96)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@97 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@97 (|l#$ValueArray| va@@97)))
 (and (and (<= 0 l@@97) (<= l@@97 $MAX_U64)) (forall ((x@@97 Int) ) (!  (=> (or (< x@@97 0) (>= x@@97 l@@97)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@98 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@98 (|l#$ValueArray| va@@98)))
 (and (and (<= 0 l@@98) (<= l@@98 $MAX_U64)) (forall ((x@@98 Int) ) (!  (=> (or (< x@@98 0) (>= x@@98 l@@98)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@99 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@99 (|l#$ValueArray| va@@99)))
 (and (and (<= 0 l@@99) (<= l@@99 $MAX_U64)) (forall ((x@@99 Int) ) (!  (=> (or (< x@@99 0) (>= x@@99 l@@99)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99))
))))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@19))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@15))
))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((addr@@28 T@$Value) )  (=> ((_ is $Address) addr@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@28)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@28)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@28)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@29 T@$Value) )  (=> ((_ is $Address) addr@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@29)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@29)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@29)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@30 T@$Value) )  (=> ((_ is $Address) addr@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (= (ControlFlow 0 82377) 79920))) inline$$ValidatorConfig_set_config_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@8  (=> (and ((_ is $Address) validator_operator_account) ((_ is $Address) validator_addr)) (=> (and (and (and (and ((_ is $Vector) consensus_pubkey) (let ((va@@100 (|v#$Vector| consensus_pubkey)))
(let ((l@@100 (|l#$ValueArray| va@@100)))
 (and (and (<= 0 l@@100) (<= l@@100 $MAX_U64)) (forall ((x@@100 Int) ) (!  (=> (or (< x@@100 0) (>= x@@100 l@@100)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100))
)))))) (forall (($$0@@20 Int) ) (!  (=> (and (>= $$0@@20 0) (< $$0@@20 (|l#$ValueArray| (|v#$Vector| consensus_pubkey)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| consensus_pubkey)) $$0@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| consensus_pubkey)) $$0@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| consensus_pubkey)) $$0@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| consensus_pubkey)) $$0@@20))
))) (and (and ((_ is $Vector) validator_network_addresses) (let ((va@@101 (|v#$Vector| validator_network_addresses)))
(let ((l@@101 (|l#$ValueArray| va@@101)))
 (and (and (<= 0 l@@101) (<= l@@101 $MAX_U64)) (forall ((x@@101 Int) ) (!  (=> (or (< x@@101 0) (>= x@@101 l@@101)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101))
)))))) (forall (($$0@@21 Int) ) (!  (=> (and (>= $$0@@21 0) (< $$0@@21 (|l#$ValueArray| (|v#$Vector| validator_network_addresses)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validator_network_addresses)) $$0@@21)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validator_network_addresses)) $$0@@21)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validator_network_addresses)) $$0@@21)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| validator_network_addresses)) $$0@@21))
)))) (and (and (and ((_ is $Vector) fullnode_network_addresses) (let ((va@@102 (|v#$Vector| fullnode_network_addresses)))
(let ((l@@102 (|l#$ValueArray| va@@102)))
 (and (and (<= 0 l@@102) (<= l@@102 $MAX_U64)) (forall ((x@@102 Int) ) (!  (=> (or (< x@@102 0) (>= x@@102 l@@102)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102))
)))))) (forall (($$0@@22 Int) ) (!  (=> (and (>= $$0@@22 0) (< $$0@@22 (|l#$ValueArray| (|v#$Vector| fullnode_network_addresses)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| fullnode_network_addresses)) $$0@@22)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| fullnode_network_addresses)) $$0@@22)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| fullnode_network_addresses)) $$0@@22)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| fullnode_network_addresses)) $$0@@22))
))) (= (ControlFlow 0 78624) 82377))) anon0$1_correct@@8))))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (and (|Select_[$TypeValueArray,$int]$bool| $ValidatorConfig_ValidatorConfig_$CallerDomain $EmptyTypeValueArray (|a#$Address| validator_addr)) (= (ControlFlow 0 100416) 78624)) anon0_correct@@8)))
PreconditionGeneratedEntry_correct@@8)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun validator_account@@1 () T@$Value)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun operator_addr () T@$Value)
(declare-fun $abort_code@10@@1 () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory@0@@2 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun $abort_code@8@@4 () Int)
(declare-fun $abort_flag@5@@4 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$0$$tv0@0@@1 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun call4formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$before@0@@1 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$tv0@0@@1 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0@@1 () T@$Value)
(declare-fun $abort_code@9@@3 () Int)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun $abort_code@2@@5 () Int)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun $abort_code@3@@5 () Int)
(declare-fun $abort_flag@2@@6 () Bool)
(declare-fun $abort_code@5@@5 () Int)
(declare-fun $abort_flag@3@@5 () Bool)
(declare-fun $abort_code@6@@4 () Int)
(declare-fun $abort_flag@4@@4 () Bool)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@2 () T@$Value)
(declare-fun call0formal@$tv0@0@@8 () T@$TypeValue)
(declare-fun $abort_code@7@@4 () Int)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$ValidatorConfig_set_operator_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1 () T@$Value)
(declare-fun $abort_code@4@@5 () Int)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$ValidatorConfig_set_operator_$def_verify$0$$t10@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 104295) (let ((anon0$2_correct@@9  (and (=> (= (ControlFlow 0 85842) (- 0 107421)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 85842) (- 0 107442)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 85842) (- 0 107471)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr))))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr))))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 85842) (- 0 107488)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr))))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr))))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 85842) (- 0 107505)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 85842) (- 0 107526)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 85842) (- 0 107555)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) $abort_flag@6@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) $abort_flag@6@@1) (and (=> (= (ControlFlow 0 85842) (- 0 107573)) (=> $abort_flag@6@@1 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))))))))) (=> (=> $abort_flag@6@@1 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))))) (and (=> (= (ControlFlow 0 85842) (- 0 107719)) (=> $abort_flag@6@@1 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@6@@1 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (= $abort_code@10@@1 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 85842) (- 0 107942)) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0))))))))) (=> (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) ($Integer 0)))))))) (and (=> (= (ControlFlow 0 85842) (- 0 107956)) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((t_ref@@5 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@5)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0))) operator_addr))))) (=> (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((t_ref@@5 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))
($Vector_$borrow $AddressType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| t_ref@@5)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec) ($Integer 0))) operator_addr)))) (=> (= (ControlFlow 0 85842) (- 0 107976)) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean (forall ((addr@@31 T@$Value) )  (=> ((_ is $Address) addr@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified addr@@31 validator_account@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| addr@@31)))) $ValidatorConfig_ValidatorConfig_operator_account) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@31)))) $ValidatorConfig_ValidatorConfig_operator_account)))))))))))))))))))))))))))))))))))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon59_Else$8_correct  (and (=> (= (ControlFlow 0 85692) (- 0 107156)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_operator_$def_verify$0$validator T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_operator_$def_verify$0$validator) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$validator)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$validator)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$validator)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$validator)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_operator_$def_verify$0$validator@@0 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_operator_$def_verify$0$validator@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$validator@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$validator@@0)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$validator@@0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$validator@@0)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0))))))))))))))))) (and (=> (= (ControlFlow 0 85692) (- 0 107189)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_operator_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_operator_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@0)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (=> (= (ControlFlow 0 85692) (- 0 107223)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@1)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@2)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (and (=> (= (ControlFlow 0 85692) (- 0 107257)) (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@3)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@3)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@4)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$ValidatorConfig_set_operator_$def_verify$0$addr@@4)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (=> (and (and (= $abort_code@10@@1 $abort_code@8@@4) (= $abort_flag@6@@1 $abort_flag@5@@4)) (and (= $ValidatorConfig_ValidatorConfig_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@1|) (= (ControlFlow 0 85692) 85842))) anon0$2_correct@@9)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@1| $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 85490) 85692)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon59_Else$8_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@1|) (= (ControlFlow 0 85544) 85692))) inline$$ValidatorConfig_set_operator_$def_verify$0$anon59_Else$8_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 85480) 85544) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 85480) 85490) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$Entry_correct@@1  (=> (and (= inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (= (ControlFlow 0 85356) 85480)) inline$$WritebackToGlobal$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 85277) 85356)) inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$Entry_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 85333) 85356))) inline$$ValidatorConfig_ValidatorConfig_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) (and (=> (= (ControlFlow 0 85241) 85333) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 85241) 85277) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$Option_Option_$pack_ref$0$anon0_correct@@1  (and (=> (= (ControlFlow 0 85100) (- 0 106895)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0@@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0@@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 85100) 85241) inline$$WritebackToReference$0$anon0_correct@@1)))))
(let ((inline$$Option_Option_$pack_ref$0$Entry_correct@@1  (=> (= inline$$Option_Option_$pack_ref$0$$tv0@0@@1 $AddressType) (=> (and (= inline$$Option_Option_$pack_ref$0$$after@0@@1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= (ControlFlow 0 85076) 85100)) inline$$Option_Option_$pack_ref$0$anon0_correct@@1))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (and (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@1) (|p#$Mutation| inline$$BorrowField$0$dst@1@@1) call4formal@$ret0@0@@5)) (= (ControlFlow 0 85024) 85076)) inline$$Option_Option_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$Option_Option_$unpack_ref$0$anon0_correct@@1  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$0$$before@0@@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 84967) 85024)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$Option_Option_$unpack_ref$0$Entry_correct@@1  (=> (= inline$$Option_Option_$unpack_ref$0$$tv0@0@@1 $AddressType) (=> (and (= inline$$Option_Option_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (= (ControlFlow 0 84961) 84967)) inline$$Option_Option_$unpack_ref$0$anon0_correct@@1))))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $ValidatorConfig_ValidatorConfig_operator_account) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $ValidatorConfig_ValidatorConfig_operator_account))) (= (ControlFlow 0 84927) 84961))) inline$$Option_Option_$unpack_ref$0$Entry_correct@@1))))
(let ((inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$anon0_correct@@1  (=> (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0@@1)) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0@@1)) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (= (ControlFlow 0 84805) 84927)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$Entry_correct@@1  (=> (and (= inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 84799) 84805)) inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$anon0_correct@@1)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon59_Else_correct  (=> (and (not $abort_flag@5@@4) (= (ControlFlow 0 84809) 84799)) inline$$ValidatorConfig_ValidatorConfig_$unpack_ref$0$Entry_correct@@1)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@10@@1 $abort_code@9@@3) (= $abort_flag@6@@1 true)) (and (= $ValidatorConfig_ValidatorConfig_$memory@0@@2 $ValidatorConfig_ValidatorConfig_$memory) (= (ControlFlow 0 84259) 85842))) anon0$2_correct@@9)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon7_correct  (=> (and (= $abort_code@9@@3 $abort_code@1@@5) (= (ControlFlow 0 85812) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 85810) 85812)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon7_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 85820) 85812) inline$$ValidatorConfig_set_operator_$def_verify$0$anon7_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon43_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 85804) 85820) inline$$ValidatorConfig_set_operator_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 85804) 85810) inline$$ValidatorConfig_set_operator_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon13_correct  (=> (and (= $abort_code@9@@3 $abort_code@2@@5) (= (ControlFlow 0 85788) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 85786) 85788)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 85796) 85788) inline$$ValidatorConfig_set_operator_$def_verify$0$anon13_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon46_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 85780) 85796) inline$$ValidatorConfig_set_operator_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 85780) 85786) inline$$ValidatorConfig_set_operator_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon21_correct  (=> (and (= $abort_code@9@@3 $abort_code@3@@5) (= (ControlFlow 0 85768) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 85766) 85768)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 85776) 85768) inline$$ValidatorConfig_set_operator_$def_verify$0$anon21_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon50_Then_correct  (=> $abort_flag@2@@6 (and (=> (= (ControlFlow 0 85760) 85776) inline$$ValidatorConfig_set_operator_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 85760) 85766) inline$$ValidatorConfig_set_operator_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon27_correct  (=> (and (= $abort_code@9@@3 $abort_code@5@@5) (= (ControlFlow 0 85744) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 85742) 85744)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon27_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon54_Then_correct  (=> (= (ControlFlow 0 85752) 85744) inline$$ValidatorConfig_set_operator_$def_verify$0$anon27_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon53_Then_correct  (=> $abort_flag@3@@5 (and (=> (= (ControlFlow 0 85736) 85752) inline$$ValidatorConfig_set_operator_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 85736) 85742) inline$$ValidatorConfig_set_operator_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon35_correct  (=> (and (= $abort_code@9@@3 $abort_code@6@@4) (= (ControlFlow 0 85724) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon58_Else_correct  (=> (and (not true) (= (ControlFlow 0 85722) 85724)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon35_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon58_Then_correct  (=> (= (ControlFlow 0 85732) 85724) inline$$ValidatorConfig_set_operator_$def_verify$0$anon35_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon57_Then_correct  (=> $abort_flag@4@@4 (and (=> (= (ControlFlow 0 85716) 85732) inline$$ValidatorConfig_set_operator_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 85716) 85722) inline$$ValidatorConfig_set_operator_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon39_correct  (=> (and (= $abort_code@9@@3 $abort_code@8@@4) (= (ControlFlow 0 85704) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 85702) 85704)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon39_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 85712) 85704) inline$$ValidatorConfig_set_operator_$def_verify$0$anon39_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon59_Then_correct  (=> $abort_flag@5@@4 (and (=> (= (ControlFlow 0 85696) 85712) inline$$ValidatorConfig_set_operator_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 85696) 85702) inline$$ValidatorConfig_set_operator_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@5@@4 true) (=> (and (= $abort_code@8@@4 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 84766) 85696) inline$$ValidatorConfig_set_operator_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 84766) 84809) inline$$ValidatorConfig_set_operator_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 84764) 84766)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1@@1))) (= $abort_flag@5@@4 $abort_flag@4@@4)) (and (= $abort_code@8@@4 $abort_code@6@@4) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 84712) 85696) inline$$ValidatorConfig_set_operator_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 84712) 84809) inline$$ValidatorConfig_set_operator_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| call3formal@$ret0@0@@16)) (and (=> (= (ControlFlow 0 84682) 84764) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 84682) 84712) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 84676) (- 0 106653)) true) (=> (= (ControlFlow 0 84676) 84682) inline$$BorrowGlobal$0$anon0_correct@@1))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon57_Else_correct  (=> (and (not $abort_flag@4@@4) (= (ControlFlow 0 84772) 84676)) inline$$BorrowGlobal$0$Entry_correct@@1)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon55_Then_correct  (=> (|b#$Boolean| inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@2) (=> (and (and (= call0formal@$tv0@0@@8 $AddressType) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@4)) (and (=> $abort_flag@4@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@5 ($Vector (let ((len@@8 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@8 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 operator_addr) 1))) (+ len@@8 1)))))))))) (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@5) (let ((va@@103 (|v#$Vector| call4formal@$ret0@0@@5)))
(let ((l@@103 (|l#$ValueArray| va@@103)))
 (and (and (<= 0 l@@103) (<= l@@103 $MAX_U64)) (forall ((x@@103 Int) ) (!  (=> (or (< x@@103 0) (>= x@@103 l@@103)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Option_Option_vec)) (let ((va@@104 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Option_Option_vec))))
(let ((l@@104 (|l#$ValueArray| va@@104)))
 (and (and (<= 0 l@@104) (<= l@@104 $MAX_U64)) (forall ((x@@104 Int) ) (!  (=> (or (< x@@104 0) (>= x@@104 l@@104)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 84571) 85716) inline$$ValidatorConfig_set_operator_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 84571) 84772) inline$$ValidatorConfig_set_operator_$def_verify$0$anon57_Else_correct)))))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon32_correct  (=> (and (= $abort_code@9@@3 $abort_code@7@@4) (= (ControlFlow 0 84557) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 84555) 84557)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon32_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon56_Then_correct  (=> (= (ControlFlow 0 84565) 84557) inline$$ValidatorConfig_set_operator_$def_verify$0$anon32_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon55_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@2)) (= $abort_code@7@@4 (|i#$Integer| call3formal@$ret0@0@@17))) (and (=> (= (ControlFlow 0 84549) 84565) inline$$ValidatorConfig_set_operator_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 84549) 84555) inline$$ValidatorConfig_set_operator_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon53_Else_correct  (=> (not $abort_flag@3@@5) (and (=> (= (ControlFlow 0 84537) 84571) inline$$ValidatorConfig_set_operator_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 84537) 84549) inline$$ValidatorConfig_set_operator_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@2@@6) (=> (and (and (and (= inline$$ValidatorConfig_set_operator_$def_verify$0$$t13@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@5)) (and (=> $abort_flag@3@@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@17) (>= (|i#$Integer| call3formal@$ret0@0@@17) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@17) $MAX_U64))) (and (=> (= (ControlFlow 0 84531) 85736) inline$$ValidatorConfig_set_operator_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 84531) 84537) inline$$ValidatorConfig_set_operator_$def_verify$0$anon53_Else_correct))))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon52_Then_correct  (=> $abort_flag@2@@6 (=> (and (= $abort_code@9@@3 $abort_code@3@@5) (= (ControlFlow 0 85756) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon6_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 84487) 85756) inline$$ValidatorConfig_set_operator_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 84487) 84531) inline$$ValidatorConfig_set_operator_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon6_Then_correct@@2  (and (=> (= (ControlFlow 0 84497) 85756) inline$$ValidatorConfig_set_operator_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 84497) 84531) inline$$ValidatorConfig_set_operator_$def_verify$0$anon52_Else_correct))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct@@2  (=> (= inline$$ValidatorConfig_exists_config_$def$0$$t2@1@@2 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@16)))) (and (=> (= (ControlFlow 0 84481) 84497) inline$$ValidatorConfig_exists_config_$def$0$anon6_Then_correct@@2) (=> (= (ControlFlow 0 84481) 84487) inline$$ValidatorConfig_exists_config_$def$0$anon6_Else_correct@@2)))))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon5_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 84435) 84481)) inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct@@2)))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon5_Then_correct@@2  (=> (= (ControlFlow 0 84505) 84481) inline$$ValidatorConfig_exists_config_$def$0$anon2$1_correct@@2)))
(let ((inline$$ValidatorConfig_exists_config_$def$0$anon0_correct@@2  (=> (not $abort_flag@2@@6) (and (=> (= (ControlFlow 0 84429) 84505) inline$$ValidatorConfig_exists_config_$def$0$anon5_Then_correct@@2) (=> (= (ControlFlow 0 84429) 84435) inline$$ValidatorConfig_exists_config_$def$0$anon5_Else_correct@@2)))))
(let ((inline$$ValidatorConfig_exists_config_$direct_intra$0$anon0_correct@@2  (=> (and ((_ is $Address) call3formal@$ret0@0@@16) (= (ControlFlow 0 84511) 84429)) inline$$ValidatorConfig_exists_config_$def$0$anon0_correct@@2)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon50_Else_correct  (=> (and (not $abort_flag@2@@6) (= (ControlFlow 0 84519) 84511)) inline$$ValidatorConfig_exists_config_$direct_intra$0$anon0_correct@@2)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon48_Then_correct  (=> (|b#$Boolean| inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@6) (=> $abort_flag@2@@6 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 validator_account@@1)))) ((_ is $Address) call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 84273) 85760) inline$$ValidatorConfig_set_operator_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 84273) 84519) inline$$ValidatorConfig_set_operator_$def_verify$0$anon50_Else_correct))))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon18_correct  (=> (and (= $abort_code@9@@3 $abort_code@4@@5) (= (ControlFlow 0 84255) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 84253) 84255)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon18_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 84267) 84255) inline$$ValidatorConfig_set_operator_$def_verify$0$anon18_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon48_Else_correct  (=> (and (not (|b#$Boolean| inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1)) (= $abort_code@4@@5 (|i#$Integer| call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 84247) 84267) inline$$ValidatorConfig_set_operator_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 84247) 84253) inline$$ValidatorConfig_set_operator_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon46_Else_correct  (=> (not $abort_flag@1@@6) (and (=> (= (ControlFlow 0 84235) 84273) inline$$ValidatorConfig_set_operator_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 84235) 84247) inline$$ValidatorConfig_set_operator_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon45_Else_correct  (=> (not $abort_flag@0@@6) (=> (and (and (and (= inline$$ValidatorConfig_set_operator_$def_verify$0$$t10@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@6)) (and (=> $abort_flag@1@@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@18) (>= (|i#$Integer| call3formal@$ret0@0@@18) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@18) $MAX_U64))) (and (=> (= (ControlFlow 0 84229) 85780) inline$$ValidatorConfig_set_operator_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 84229) 84235) inline$$ValidatorConfig_set_operator_$def_verify$0$anon46_Else_correct))))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon45_Then_correct  (=> $abort_flag@0@@6 (=> (and (= $abort_code@9@@3 $abort_code@1@@5) (= (ControlFlow 0 85800) 84259)) inline$$ValidatorConfig_set_operator_$def_verify$0$Abort_correct))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 84185) 85800) inline$$ValidatorConfig_set_operator_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 84185) 84229) inline$$ValidatorConfig_set_operator_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 84195) 85800) inline$$ValidatorConfig_set_operator_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 84195) 84229) inline$$ValidatorConfig_set_operator_$def_verify$0$anon45_Else_correct))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon2$1_correct  (=> (= inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| operator_addr)))) (and (=> (= (ControlFlow 0 84179) 84195) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 84179) 84185) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon6_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 84133) 84179)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon2$1_correct)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 84203) 84179) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon2$1_correct)))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon0_correct  (=> (not $abort_flag@0@@6) (and (=> (= (ControlFlow 0 84127) 84203) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 84127) 84133) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon5_Else_correct)))))
(let ((inline$$ValidatorOperatorConfig_has_validator_operator_config_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) operator_addr) (= (ControlFlow 0 84209) 84127)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$def$0$anon0_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon43_Else_correct  (=> (and (not $abort_flag@0@@6) (= (ControlFlow 0 84217) 84209)) inline$$ValidatorOperatorConfig_has_validator_operator_config_$direct_inter$0$anon0_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) $abort_flag@0@@6) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) $abort_flag@0@@6)) (and (=> $abort_flag@0@@6 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))))) (=> $abort_flag@0@@6 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1))))))) (= $abort_code@1@@5 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| validator_account@@1)))) $Roles_RoleId_role_id) ($Integer 3))))) (= $abort_code@1@@5 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 83971) 85804) inline$$ValidatorConfig_set_operator_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 83971) 84217) inline$$ValidatorConfig_set_operator_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 83901) 83971)) inline$$ValidatorConfig_set_operator_$def_verify$0$anon4$2_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 85828) 83971) inline$$ValidatorConfig_set_operator_$def_verify$0$anon4$2_correct)))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 83893) 85828) inline$$ValidatorConfig_set_operator_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 83893) 83901) inline$$ValidatorConfig_set_operator_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 85836) 85828) inline$$ValidatorConfig_set_operator_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 85836) 83901) inline$$ValidatorConfig_set_operator_$def_verify$0$anon42_Else_correct))))
(let ((inline$$ValidatorConfig_set_operator_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 83887) 85836) inline$$ValidatorConfig_set_operator_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 83887) 83893) inline$$ValidatorConfig_set_operator_$def_verify$0$anon41_Else_correct)))))
(let ((anon0$1_correct@@9  (=> (and (and (and (forall (($inv_addr@@16 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16)) (let ((va@@105 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))))
(let ((l@@105 (|l#$ValueArray| va@@105)))
 (and (and (<= 0 l@@105) (<= l@@105 $MAX_U64)) (forall ((x@@105 Int) ) (!  (=> (or (< x@@105 0) (>= x@@105 l@@105)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@16))
)) (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@106 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@106 (|l#$ValueArray| va@@106)))
 (and (and (<= 0 l@@106) (<= l@@106 $MAX_U64)) (forall ((x@@106 Int) ) (!  (=> (or (< x@@106 0) (>= x@@106 l@@106)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name)) (let ((va@@107 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))))
(let ((l@@107 (|l#$ValueArray| va@@107)))
 (and (and (<= 0 l@@107) (<= l@@107 $MAX_U64)) (forall ((x@@107 Int) ) (!  (=> (or (< x@@107 0) (>= x@@107 l@@107)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107))
))))))) (forall (($$0@@23 Int) ) (!  (=> (and (>= $$0@@23 0) (< $$0@@23 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@23)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@23)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@23)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))) $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name))) $$0@@23))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@17))
))) (and (forall (($inv_addr@@18 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18)) (let ((va@@108 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))))
(let ((l@@108 (|l#$ValueArray| va@@108)))
 (and (and (<= 0 l@@108) (<= l@@108 $MAX_U64)) (forall ((x@@108 Int) ) (!  (=> (or (< x@@108 0) (>= x@@108 l@@108)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) 3)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_config)) (let ((va@@109 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_config))))
(let ((l@@109 (|l#$ValueArray| va@@109)))
 (and (and (<= 0 l@@109) (<= l@@109 $MAX_U64)) (forall ((x@@109 Int) ) (!  (=> (or (< x@@109 0) (>= x@@109 l@@109)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_config))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) (let ((va@@110 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))
(let ((l@@110 (|l#$ValueArray| va@@110)))
 (and (and (<= 0 l@@110) (<= l@@110 $MAX_U64)) (forall ((x@@110 Int) ) (!  (=> (or (< x@@110 0) (>= x@@110 l@@110)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_operator_account)) (let ((va@@111 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_operator_account))))
(let ((l@@111 (|l#$ValueArray| va@@111)))
 (and (and (<= 0 l@@111) (<= l@@111 $MAX_U64)) (forall ((x@@111 Int) ) (!  (=> (or (< x@@111 0) (>= x@@111 l@@111)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_operator_account))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec)) (let ((va@@112 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))
(let ((l@@112 (|l#$ValueArray| va@@112)))
 (and (and (<= 0 l@@112) (<= l@@112 $MAX_U64)) (forall ((x@@112 Int) ) (!  (=> (or (< x@@112 0) (>= x@@112 l@@112)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112))
)))))))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_human_name)) (let ((va@@113 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_human_name))))
(let ((l@@113 (|l#$ValueArray| va@@113)))
 (and (and (<= 0 l@@113) (<= l@@113 $MAX_U64)) (forall ((x@@113 Int) ) (!  (=> (or (< x@@113 0) (>= x@@113 l@@113)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113))
))))))) (forall (($$0@@24 Int) ) (!  (=> (and (>= $$0@@24 0) (< $$0@@24 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@24)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@24)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@24)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_human_name))) $$0@@24))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))) $ValidatorConfig_ValidatorConfig_operator_account))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray $inv_addr@@18))
)) (|b#$Boolean| ($Boolean (forall ((addr@@32 T@$Value) )  (=> ((_ is $Address) addr@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@32)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@32)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@32)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@33 T@$Value) )  (=> ((_ is $Address) addr@@33) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@33)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@33)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@33)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@34 T@$Value) )  (=> ((_ is $Address) addr@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@35 T@$Value) )  (=> ((_ is $Address) addr@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (= (ControlFlow 0 85840) 83887)))) inline$$ValidatorConfig_set_operator_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@9  (=> ((_ is $Address) validator_account@@1) (=> (and ((_ is $Address) operator_addr) (= (ControlFlow 0 82892) 85840)) anon0$1_correct@@9))))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (= (ControlFlow 0 104295) 82892) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@9)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
