(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $FixedPoint32_FixedPoint32 $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@0) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@0))
)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0@@1) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($Event_EventHandle_type_value $tv0@@1))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun tc_account () T@$Value)
(declare-fun $abort_flag@28 () Bool)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun dr_account () T@$Value)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory () T@$Memory)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $DiemConfig_DisableReconfiguration_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(declare-fun $abort_code@41 () Int)
(declare-fun $Diem_MintCapability_$memory@3 () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory@3 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@8 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@7 () T@$Memory)
(declare-fun $abort_code@40 () Int)
(declare-fun $AccountLimits_LimitsDefinition_$memory@2 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@5 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@4 () T@$Memory)
(declare-fun $Diem_MintCapability_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@8 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@7 () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory@5 () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory@4 () T@$Memory)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@27 () Bool)
(declare-fun $AccountLimits_LimitsDefinition_$memory@1 () T@$Memory)
(declare-fun $abort_code@39 () Int)
(declare-fun $DiemConfig_Configuration_$memory@6 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@6 () T@$Memory)
(declare-fun $Diem_MintCapability_$memory@1 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@3 () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory@3 () T@$Memory)
(declare-fun $abort_flag@23 () Bool)
(declare-fun $abort_code@33 () Int)
(declare-fun $abort_flag@26 () Bool)
(declare-fun $abort_code@37 () Int)
(declare-fun |inline$$MoveToRaw$3$m'@2| () T@$Memory)
(declare-fun $abort_code@38 () Int)
(declare-fun $AccountLimits_LimitsDefinition_$memory@0 () T@$Memory)
(declare-fun $abort_code@34 () Int)
(declare-fun $abort_flag@24 () Bool)
(declare-fun $abort_code@35 () Int)
(declare-fun $abort_flag@25 () Bool)
(declare-fun |inline$$MoveToRaw$3$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$3$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$3$a@1 () Int)
(declare-fun |inline$$MoveToRaw$3$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$direct_inter$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1 () T@$Value)
(declare-fun inline$$Not$4$dst@1 () T@$Value)
(declare-fun $abort_code@36 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t12@1 () T@$Value)
(declare-fun inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_flag@22 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@4 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@4 () T@$Memory)
(declare-fun |inline$$MoveToRaw$1$m'@2| () T@$Memory)
(declare-fun $abort_code@31 () Int)
(declare-fun $Diem_BurnCapability_$memory@1 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@5 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@5 () T@$Memory)
(declare-fun $Diem_MintCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@32 () Int)
(declare-fun $Diem_BurnCapability_$memory@2 () T@$Memory)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@20 () Int)
(declare-fun $abort_flag@14 () Bool)
(declare-fun $abort_code@21 () Int)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $abort_code@23 () Int)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $abort_code@29 () Int)
(declare-fun |inline$$MoveToRaw$2$m'@2| () T@$Memory)
(declare-fun $abort_code@30 () Int)
(declare-fun $Diem_BurnCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@24 () Int)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $abort_code@25 () Int)
(declare-fun $abort_flag@18 () Bool)
(declare-fun $abort_code@26 () Int)
(declare-fun $abort_flag@19 () Bool)
(declare-fun $abort_code@27 () Int)
(declare-fun $abort_flag@20 () Bool)
(declare-fun |inline$$MoveToRaw$2$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$2$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$2$a@1 () Int)
(declare-fun |inline$$MoveToRaw$2$m'@1| () T@$Memory)
(declare-fun inline$$Diem_register_currency_$def$0$$ret1@2 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Not$3$dst@1 () T@$Value)
(declare-fun $abort_code@28 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun |inline$$MoveToRaw$1$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$1$a@1 () Int)
(declare-fun |inline$$MoveToRaw$1$m'@1| () T@$Memory)
(declare-fun inline$$Diem_register_currency_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Not$2$dst@1 () T@$Value)
(declare-fun $abort_code@22 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$def$0$$t22@1 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$def$0$$t20@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_code@19 () Int)
(declare-fun inline$$Diem_MintCapability_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_BurnCapability_pack$0$$struct@1 () T@$Value)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $DiemConfig_Configuration_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@2 () T@$Memory)
(declare-fun $abort_code@17 () Int)
(declare-fun inline$$Diem_register_currency_$def$0$$t39@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t37@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$ret1@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@3 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@3 () T@$Memory)
(declare-fun $abort_code@18 () Int)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_code@15 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0 () T@$Memory)
(declare-fun $abort_code@16 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1 () T@$Memory)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@13 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_Configuration_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$XUS_initialize_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun $abort_code@14 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$RegisteredCurrencies_add_currency_code_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$res@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$ta@0 () T@$TypeValue)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t28@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t29@1 () T@$Value)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$XUS_initialize_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$XUS_initialize_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t30@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$2$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$3$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$4$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$4$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$3$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$2$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$1$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun |inline$$Diem_register_currency_$def$0$tmp#$10@1| () T@$Value)
(declare-fun $abort_code@10 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t26@1 () T@$Value)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t24@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t25@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t22@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@8 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t20@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t18@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$XUS_initialize_$def_verify$0$$t4@1 () T@$Value)
(declare-fun inline$$XUS_initialize_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_$memory () T@$Memory)
(declare-fun $AccountLimits_Window_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 137758) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 135381) (- 0 152882)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 152908)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 152929)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 152958)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 152975)) (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer 1000000) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer 1000000)) (|i#$Integer| ($Integer 10000000000)))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer 1000000) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer 1000000)) (|i#$Integer| ($Integer 10000000000)))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153016)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account)))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account)))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153042)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153063)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153092)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153109)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153126)) (=> (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0 Int) )  (and (and (>= $i_0 0) (< $i_0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 88)) 1 ($Integer 85)) 2 ($Integer 83)) 3))))))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@0 Int) )  (and (and (>= $i_0@@0 0) (< $i_0@@0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@8 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 88)) 1 ($Integer 85)) 2 ($Integer 83)) 3))))))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153180)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153213)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153243)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153342)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153368)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153389)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153418)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153435)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account)))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account)))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153461)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153476)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153497)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153526)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153543)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153564)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153593)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@28)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@28) (and (=> (= (ControlFlow 0 135381) (- 0 153610)) (=> $abort_flag@28 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer 1000000) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer 1000000)) (|i#$Integer| ($Integer 10000000000))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@1 Int) )  (and (and (>= $i_0@@1 0) (< $i_0@@1 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 88)) 1 ($Integer 85)) 2 ($Integer 83)) 3)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))))) (=> (=> $abort_flag@28 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer 1000000) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer 1000000)) (|i#$Integer| ($Integer 10000000000))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@2 Int) )  (and (and (>= $i_0@@2 0) (< $i_0@@2 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@9 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 88)) 1 ($Integer 85)) 2 ($Integer 83)) 3)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (and (=> (= (ControlFlow 0 135381) (- 0 154313)) (=> $abort_flag@28 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) (= $abort_code@41 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer 1000000) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer 1000000)) (|i#$Integer| ($Integer 10000000000)))))))) (= $abort_code@41 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account)))) (= $abort_code@41 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@3 Int) )  (and (and (>= $i_0@@3 0) (< $i_0@@3 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((x@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@10 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 88)) 1 ($Integer 85)) 2 ($Integer 83)) 3))))))))))) (= $abort_code@41 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@41 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) (= $abort_code@41 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account)))) (= $abort_code@41 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@41 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@28 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) (= $abort_code@41 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer 1000000) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer 1000000)) (|i#$Integer| ($Integer 10000000000)))))))) (= $abort_code@41 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account)))) (= $abort_code@41 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@4 Int) )  (and (and (>= $i_0@@4 0) (< $i_0@@4 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((x@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@10 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 88)) 1 ($Integer 85)) 2 ($Integer 83)) 3))))))))))) (= $abort_code@41 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@41 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))) (= $abort_code@41 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account)))) (= $abort_code@41 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@41 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@41 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@41 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@41 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 135381) (- 0 155302)) (=> (not $abort_flag@28) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account)))))) (=> (=> (not $abort_flag@28) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| tc_account))))) (=> (= (ControlFlow 0 135381) (- 0 155318)) (=> (not $abort_flag@28) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| dr_account))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$XUS_initialize_$def_verify$0$Abort_correct  (=> (= $DiemConfig_Configuration_$memory@8 $DiemConfig_Configuration_$memory@7) (=> (and (and (and (= $abort_code@41 $abort_code@40) (= $AccountLimits_LimitsDefinition_$memory@3 $AccountLimits_LimitsDefinition_$memory@2)) (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@4) (= $Diem_MintCapability_$memory@3 $Diem_MintCapability_$memory@2))) (and (and (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@7) (= $abort_flag@28 true)) (and (= $Diem_BurnCapability_$memory@5 $Diem_BurnCapability_$memory@4) (= (ControlFlow 0 135315) 135381)))) anon0$2_correct))))
(let ((inline$$XUS_initialize_$def_verify$0$anon7_correct  (=> (and (and (and (= $AccountLimits_LimitsDefinition_$memory@2 $AccountLimits_LimitsDefinition_$memory) (= $abort_code@40 $abort_code@1)) (and (= $DiemConfig_Configuration_$memory@7 $DiemConfig_Configuration_$memory) (= $DiemConfig_DiemConfig_$memory@7 $DiemConfig_DiemConfig_$memory))) (and (and (= $Diem_MintCapability_$memory@2 $Diem_MintCapability_$memory) (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory)) (and (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory) (= (ControlFlow 0 135351) 135315)))) inline$$XUS_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 135349) 135351)) inline$$XUS_initialize_$def_verify$0$anon7_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 135359) 135351) inline$$XUS_initialize_$def_verify$0$anon7_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 135343) 135359) inline$$XUS_initialize_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 135343) 135349) inline$$XUS_initialize_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$XUS_initialize_$def_verify$0$anon11_correct  (=> (and (and (and (= $AccountLimits_LimitsDefinition_$memory@2 $AccountLimits_LimitsDefinition_$memory) (= $abort_code@40 $abort_code@2)) (and (= $DiemConfig_Configuration_$memory@7 $DiemConfig_Configuration_$memory) (= $DiemConfig_DiemConfig_$memory@7 $DiemConfig_DiemConfig_$memory))) (and (and (= $Diem_MintCapability_$memory@2 $Diem_MintCapability_$memory) (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory)) (and (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory) (= (ControlFlow 0 135331) 135315)))) inline$$XUS_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 135329) 135331)) inline$$XUS_initialize_$def_verify$0$anon11_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 135339) 135331) inline$$XUS_initialize_$def_verify$0$anon11_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 135323) 135339) inline$$XUS_initialize_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 135323) 135329) inline$$XUS_initialize_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$XUS_initialize_$def_verify$0$anon24_Then_correct  (=> $abort_flag@27 (=> (and (and (and (= $AccountLimits_LimitsDefinition_$memory@2 $AccountLimits_LimitsDefinition_$memory@1) (= $abort_code@40 $abort_code@39)) (and (= $DiemConfig_Configuration_$memory@7 $DiemConfig_Configuration_$memory@6) (= $DiemConfig_DiemConfig_$memory@7 $DiemConfig_DiemConfig_$memory@6))) (and (and (= $Diem_MintCapability_$memory@2 $Diem_MintCapability_$memory@1) (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@3)) (and (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory@3) (= (ControlFlow 0 135311) 135315)))) inline$$XUS_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$XUS_initialize_$def_verify$0$anon23_Then_correct  (=> $abort_flag@23 (=> (and (and (and (= $AccountLimits_LimitsDefinition_$memory@2 $AccountLimits_LimitsDefinition_$memory) (= $abort_code@40 $abort_code@33)) (and (= $DiemConfig_Configuration_$memory@7 $DiemConfig_Configuration_$memory@6) (= $DiemConfig_DiemConfig_$memory@7 $DiemConfig_DiemConfig_$memory@6))) (and (and (= $Diem_MintCapability_$memory@2 $Diem_MintCapability_$memory@1) (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@3)) (and (= $Diem_BurnCapability_$memory@4 $Diem_BurnCapability_$memory@3) (= (ControlFlow 0 135319) 135315)))) inline$$XUS_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$XUS_initialize_$def_verify$0$anon24_Else_correct  (=> (and (not $abort_flag@27) (= $DiemConfig_Configuration_$memory@8 $DiemConfig_Configuration_$memory@6)) (=> (and (and (and (= $abort_code@41 $abort_code@39) (= $AccountLimits_LimitsDefinition_$memory@3 $AccountLimits_LimitsDefinition_$memory@1)) (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@3) (= $Diem_MintCapability_$memory@3 $Diem_MintCapability_$memory@1))) (and (and (= $DiemConfig_DiemConfig_$memory@8 $DiemConfig_DiemConfig_$memory@6) (= $abort_flag@28 $abort_flag@27)) (and (= $Diem_BurnCapability_$memory@5 $Diem_BurnCapability_$memory@3) (= (ControlFlow 0 135307) 135381)))) anon0$2_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Else_correct  (=> (and (and (not $abort_flag@26) (= $abort_flag@27 $abort_flag@26)) (and (= $abort_code@39 $abort_code@37) (= $AccountLimits_LimitsDefinition_$memory@1 |inline$$MoveToRaw$3$m'@2|))) (and (=> (= (ControlFlow 0 135221) 135311) inline$$XUS_initialize_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 135221) 135307) inline$$XUS_initialize_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct  (=> (= $abort_flag@27 true) (=> (and (= $abort_code@39 $abort_code@38) (= $AccountLimits_LimitsDefinition_$memory@1 $AccountLimits_LimitsDefinition_$memory@0)) (and (=> (= (ControlFlow 0 134442) 135311) inline$$XUS_initialize_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 134442) 135307) inline$$XUS_initialize_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon5_correct  (=> (= $abort_code@38 $abort_code@34) (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 135273) 134442)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 135271) 135273)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon5_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 135281) 135273) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon5_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Then_correct  (=> $abort_flag@24 (and (=> (= (ControlFlow 0 135265) 135281) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 135265) 135271) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon21_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon9_correct  (=> (= $abort_code@38 $abort_code@35) (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 135253) 134442)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 135251) 135253)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon9_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 135261) 135253) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon9_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon22_Then_correct  (=> $abort_flag@25 (and (=> (= (ControlFlow 0 135245) 135261) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 135245) 135251) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon23_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon17_correct  (=> (= $abort_code@38 $abort_code@37) (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 |inline$$MoveToRaw$3$m'@2|) (= (ControlFlow 0 135233) 134442)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 135231) 135233)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon17_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 135241) 135233) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon17_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Then_correct  (=> $abort_flag@26 (and (=> (= (ControlFlow 0 135225) 135241) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 135225) 135231) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon27_Else_correct)))))
(let ((inline$$MoveToRaw$3$anon3_Then$1_correct  (=> (= $abort_code@37 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@26 true) (= |inline$$MoveToRaw$3$m'@2| |inline$$MoveToRaw$3$m'@0|)) (and (=> (= (ControlFlow 0 135199) 135225) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 135199) 135221) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Else_correct))))))
(let ((inline$$MoveToRaw$3$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1) (= (ControlFlow 0 135197) 135199)) inline$$MoveToRaw$3$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$3$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1)) (=> (and (and (= |inline$$MoveToRaw$3$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1 inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1))) (= $abort_code@37 $abort_code@35)) (and (= $abort_flag@26 $abort_flag@25) (= |inline$$MoveToRaw$3$m'@2| |inline$$MoveToRaw$3$m'@1|))) (and (=> (= (ControlFlow 0 135147) 135225) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 135147) 135221) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon26_Else_correct))))))
(let ((inline$$MoveTo$3$anon0$1_correct  (=> (= inline$$MoveTo$3$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 135205) 135197) inline$$MoveToRaw$3$anon3_Then_correct) (=> (= (ControlFlow 0 135205) 135147) inline$$MoveToRaw$3$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$3$Entry_correct  (and (=> (= (ControlFlow 0 134993) (- 0 152452)) true) (=> (= (ControlFlow 0 134993) 135205) inline$$MoveTo$3$anon0$1_correct))))
(let ((inline$$MoveTo$3$Entry_correct  (=> (and (= inline$$MoveTo$3$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$AccountLimits_publish_unrestricted_limits_$direct_inter$0$$tv0@0) 1)) (= (ControlFlow 0 134965) 134993)) inline$$Signer_borrow_address$3$Entry_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 134853) (- 0 152333)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 134853) (- 0 152352)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 134853) (- 0 152371)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0))))) (and (=> (= (ControlFlow 0 134853) (- 0 152390)) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0)))))) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1)) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))) (=> (= (ControlFlow 0 134853) 134965) inline$$MoveTo$3$Entry_correct)))))))))))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 134867) 134853)) inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 134873) 134853) inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 134861) 134873) inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 134861) 134867) inline$$AccountLimits_LimitsDefinition_pack$0$anon5_Else_correct)))))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 134771) 134853)) inline$$AccountLimits_LimitsDefinition_pack$0$anon3_correct)))
(let ((inline$$AccountLimits_LimitsDefinition_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1) $MAX_U64)) (=> (and (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1) $MAX_U64))) (and (and (and ((_ is $Integer) inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1) (>= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1) 0)) (<= (|i#$Integer| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1) $MAX_U64)) (= inline$$AccountLimits_LimitsDefinition_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1) 1 inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1) 2 inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1) 3 inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1) 4))))) (and (=> (= (ControlFlow 0 134763) 134861) inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 134763) 134771) inline$$AccountLimits_LimitsDefinition_pack$0$anon4_Else_correct))))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon24_Then_correct  (=> (and (|b#$Boolean| inline$$Not$4$dst@1) (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t14@1 ($Integer 18446744073709551615))) (=> (and (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t15@1 ($Integer 18446744073709551615)) (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t16@1 ($Integer 86400000000))) (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t17@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 134879) 134763))) inline$$AccountLimits_LimitsDefinition_pack$0$anon0_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon14_correct  (=> (= $abort_code@38 $abort_code@36) (=> (and (= $AccountLimits_LimitsDefinition_$memory@0 $AccountLimits_LimitsDefinition_$memory) (= (ControlFlow 0 134438) 134442)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$Abort_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 134436) 134438)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon14_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 134450) 134438) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon14_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon24_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$4$dst@1)) (= $abort_code@36 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 134430) 134450) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 134430) 134436) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon25_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon22_Else_correct  (=> (not $abort_flag@25) (and (=> (= (ControlFlow 0 134418) 134879) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 134418) 134430) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon24_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Else$1_correct  (=> (and (and (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@25)) (and (=> $abort_flag@25 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@25) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 134412) 135245) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 134412) 134418) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon22_Else_correct)))))
(let ((inline$$Not$4$anon0_correct  (=> (and (= inline$$Not$4$dst@1 ($Boolean  (not (|b#$Boolean| inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t10@1)))) (= (ControlFlow 0 134400) 134412)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Else$1_correct)))
(let ((inline$$Not$4$Entry_correct  (and (=> (= (ControlFlow 0 134390) (- 0 152088)) true) (=> (= (ControlFlow 0 134390) 134400) inline$$Not$4$anon0_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Else_correct  (=> (not $abort_flag@24) (=> (and (= inline$$AccountLimits_publish_unrestricted_limits_$def$0$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$AccountLimits_publish_unrestricted_limits_$direct_inter$0$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@0)))) (= (ControlFlow 0 134406) 134390)) inline$$Not$4$Entry_correct))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@24) (=> $abort_flag@24 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@24) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 134332) 135265) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 134332) 134406) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon20_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 134296) 134332)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon2$1_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 135289) 134332) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon2$1_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon0_correct  (=> (not $abort_flag@23) (and (=> (= (ControlFlow 0 134290) 135289) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 134290) 134296) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon19_Else_correct)))))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 135293) 134290)) inline$$AccountLimits_publish_unrestricted_limits_$def$0$anon0_correct)))
(let ((inline$$AccountLimits_publish_unrestricted_limits_$direct_inter$0$Entry_correct  (=> (and (= inline$$AccountLimits_publish_unrestricted_limits_$direct_inter$0$$tv0@0 $XUS_XUS_type_value) (= (ControlFlow 0 133890) 135293)) inline$$AccountLimits_publish_unrestricted_limits_$direct_inter$0$anon0_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@23) (= (ControlFlow 0 135299) 133890)) inline$$AccountLimits_publish_unrestricted_limits_$direct_inter$0$Entry_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon60_Else_correct  (=> (and (and (and (not $abort_flag@22) (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1)) (and (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@4) (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@4))) (and (and (= $Diem_MintCapability_$memory@1 |inline$$MoveToRaw$1$m'@2|) (= $abort_code@33 $abort_code@31)) (and (= $Diem_BurnCapability_$memory@3 $Diem_BurnCapability_$memory@1) (= $abort_flag@23 $abort_flag@22)))) (and (=> (= (ControlFlow 0 133672) 135319) inline$$XUS_initialize_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 133672) 135299) inline$$XUS_initialize_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$Abort_correct  (=> (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@2) (=> (and (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@5) (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@5)) (=> (and (and (= $Diem_MintCapability_$memory@1 $Diem_MintCapability_$memory@0) (= $abort_code@33 $abort_code@32)) (and (= $Diem_BurnCapability_$memory@3 $Diem_BurnCapability_$memory@2) (= $abort_flag@23 true))) (and (=> (= (ControlFlow 0 132083) 135319) inline$$XUS_initialize_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 132083) 135299) inline$$XUS_initialize_$def_verify$0$anon23_Else_correct)))))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon15_correct  (=> (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory) (=> (and (= $abort_code@32 $abort_code@3) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 133768) 132083))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 133766) 133768)) inline$$Diem_register_SCS_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 133776) 133768) inline$$Diem_register_SCS_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon47_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 133760) 133776) inline$$Diem_register_SCS_currency_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 133760) 133766) inline$$Diem_register_SCS_currency_$def$0$anon48_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon25_correct  (=> (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory) (=> (and (= $abort_code@32 $abort_code@20) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 133728) 132083))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 133726) 133728)) inline$$Diem_register_SCS_currency_$def$0$anon25_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 133736) 133728) inline$$Diem_register_SCS_currency_$def$0$anon25_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon52_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 133720) 133736) inline$$Diem_register_SCS_currency_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 133720) 133726) inline$$Diem_register_SCS_currency_$def$0$anon53_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon29_correct  (=> (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory) (=> (and (= $abort_code@32 $abort_code@21) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 133708) 132083))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 133706) 133708)) inline$$Diem_register_SCS_currency_$def$0$anon29_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 133716) 133708) inline$$Diem_register_SCS_currency_$def$0$anon29_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon54_Then_correct  (=> $abort_flag@15 (and (=> (= (ControlFlow 0 133700) 133716) inline$$Diem_register_SCS_currency_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 133700) 133706) inline$$Diem_register_SCS_currency_$def$0$anon55_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon37_correct  (=> (= $Diem_MintCapability_$memory@0 |inline$$MoveToRaw$1$m'@2|) (=> (and (= $abort_code@32 $abort_code@23) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 133688) 132083))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 133686) 133688)) inline$$Diem_register_SCS_currency_$def$0$anon37_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon59_Then_correct  (=> (= (ControlFlow 0 133696) 133688) inline$$Diem_register_SCS_currency_$def$0$anon37_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon58_Then_correct  (=> $abort_flag@16 (and (=> (= (ControlFlow 0 133680) 133696) inline$$Diem_register_SCS_currency_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 133680) 133686) inline$$Diem_register_SCS_currency_$def$0$anon59_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon60_Then_correct  (=> (and (and (and $abort_flag@22 (= $Diem_MintCapability_$memory@0 |inline$$MoveToRaw$1$m'@2|)) (and (= $abort_code@32 $abort_code@31) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory@1))) (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 133676) 132083)))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct  (=> (and (and (not $abort_flag@21) (= $abort_flag@22 $abort_flag@21)) (and (= $abort_code@31 $abort_code@29) (= $Diem_BurnCapability_$memory@1 |inline$$MoveToRaw$2$m'@2|))) (and (=> (= (ControlFlow 0 133538) 133676) inline$$Diem_register_SCS_currency_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 133538) 133672) inline$$Diem_register_SCS_currency_$def$0$anon60_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$Abort_correct  (=> (= $abort_flag@22 true) (=> (and (= $abort_code@31 $abort_code@30) (= $Diem_BurnCapability_$memory@1 $Diem_BurnCapability_$memory@0)) (and (=> (= (ControlFlow 0 133184) 133676) inline$$Diem_register_SCS_currency_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 133184) 133672) inline$$Diem_register_SCS_currency_$def$0$anon60_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon7_correct  (=> (= $abort_code@30 $abort_code@24) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 133630) 133184)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 133628) 133630)) inline$$Diem_publish_burn_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 133638) 133630) inline$$Diem_publish_burn_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 133622) 133638) inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 133622) 133628) inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon11_correct  (=> (= $abort_code@30 $abort_code@25) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 133610) 133184)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 133608) 133610)) inline$$Diem_publish_burn_capability_$def$0$anon11_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 133618) 133610) inline$$Diem_publish_burn_capability_$def$0$anon11_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct  (=> $abort_flag@18 (and (=> (= (ControlFlow 0 133602) 133618) inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 133602) 133608) inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon15_correct  (=> (= $abort_code@30 $abort_code@26) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 133590) 133184)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 133588) 133590)) inline$$Diem_publish_burn_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 133598) 133590) inline$$Diem_publish_burn_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 133582) 133598) inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 133582) 133588) inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon19_correct  (=> (= $abort_code@30 $abort_code@27) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 133570) 133184)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 133568) 133570)) inline$$Diem_publish_burn_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 133578) 133570) inline$$Diem_publish_burn_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct  (=> $abort_flag@20 (and (=> (= (ControlFlow 0 133562) 133578) inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 133562) 133568) inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon27_correct  (=> (= $abort_code@30 $abort_code@29) (=> (and (= $Diem_BurnCapability_$memory@0 |inline$$MoveToRaw$2$m'@2|) (= (ControlFlow 0 133550) 133184)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 133548) 133550)) inline$$Diem_publish_burn_capability_$def$0$anon27_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 133558) 133550) inline$$Diem_publish_burn_capability_$def$0$anon27_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct  (=> $abort_flag@21 (and (=> (= (ControlFlow 0 133542) 133558) inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 133542) 133548) inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$2$anon3_Then$1_correct  (=> (= $abort_code@29 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@21 true) (= |inline$$MoveToRaw$2$m'@2| |inline$$MoveToRaw$2$m'@0|)) (and (=> (= (ControlFlow 0 133516) 133542) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 133516) 133538) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveToRaw$2$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1) (= (ControlFlow 0 133514) 133516)) inline$$MoveToRaw$2$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$2$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1)) (=> (and (and (= |inline$$MoveToRaw$2$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 inline$$Diem_register_currency_$def$0$$ret1@2))) (= $abort_code@29 $abort_code@27)) (and (= $abort_flag@21 $abort_flag@20) (= |inline$$MoveToRaw$2$m'@2| |inline$$MoveToRaw$2$m'@1|))) (and (=> (= (ControlFlow 0 133464) 133542) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 133464) 133538) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$2$anon0$1_correct  (=> (= inline$$MoveTo$2$a@1 (|a#$Address| tc_account)) (and (=> (= (ControlFlow 0 133522) 133514) inline$$MoveToRaw$2$anon3_Then_correct) (=> (= (ControlFlow 0 133522) 133464) inline$$MoveToRaw$2$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$2$Entry_correct  (and (=> (= (ControlFlow 0 133310) (- 0 151389)) true) (=> (= (ControlFlow 0 133310) 133522) inline$$MoveTo$2$anon0$1_correct))))
(let ((inline$$MoveTo$2$Entry_correct  (=> (and (= inline$$MoveTo$2$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0) 1)) (= (ControlFlow 0 133282) 133310)) inline$$Signer_borrow_address$2$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$Not$3$dst@1) (= (ControlFlow 0 133530) 133282)) inline$$MoveTo$2$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon24_correct  (=> (= $abort_code@30 $abort_code@28) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 133180) 133184)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 133178) 133180)) inline$$Diem_publish_burn_capability_$def$0$anon24_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 133192) 133180) inline$$Diem_publish_burn_capability_$def$0$anon24_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$3$dst@1)) (= $abort_code@28 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 133172) 133192) inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 133172) 133178) inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct  (=> (not $abort_flag@20) (and (=> (= (ControlFlow 0 133160) 133530) inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 133160) 133172) inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_burn_capability_$def$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@20)) (and (=> $abort_flag@20 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 133154) 133562) inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 133154) 133160) inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct)))))
(let ((inline$$Not$3$anon0_correct  (=> (and (= inline$$Not$3$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_publish_burn_capability_$def$0$$t7@1)))) (= (ControlFlow 0 133142) 133154)) inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct)))
(let ((inline$$Not$3$Entry_correct  (and (=> (= (ControlFlow 0 133132) (- 0 151232)) true) (=> (= (ControlFlow 0 133132) 133142) inline$$Not$3$anon0_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct  (=> (not $abort_flag@19) (=> (and (= inline$$Diem_publish_burn_capability_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@2)))) (= (ControlFlow 0 133148) 133132)) inline$$Not$3$Entry_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct  (=> (not $abort_flag@18) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@19) (=> $abort_flag@19 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@19) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 tc_account)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 133074) 133582) inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 133074) 133148) inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct  (=> (and (and (not $abort_flag@17) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@18)) (and (=> $abort_flag@18 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@18 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@25 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 133068) 133602) inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 133068) 133074) inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@17) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@17) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@17)) (and (=> $abort_flag@17 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@17 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@24 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@24 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@24 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 133062) 133622) inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 133062) 133068) inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 132992) 133062)) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 133646) 133062) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 132984) 133646) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 132984) 132992) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 133654) 133646) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 133654) 132992) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon0_correct  (=> (not $abort_flag@16) (and (=> (= (ControlFlow 0 132978) 133654) inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 132978) 132984) inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability$0$anon0_correct  (=> ((_ is $Address) tc_account) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_register_currency_$def$0$$ret1@2) (let ((va@@8 (|v#$Vector| inline$$Diem_register_currency_$def$0$$ret1@2)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$0$$ret1@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$0$$ret1@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 133658) 132978)) inline$$Diem_publish_burn_capability_$def$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon58_Else_correct  (=> (and (not $abort_flag@16) (= (ControlFlow 0 133664) 133658)) inline$$Diem_publish_burn_capability$0$anon0_correct)))
(let ((inline$$MoveToRaw$1$anon3_Then$1_correct  (=> (= $abort_flag@16 true) (=> (and (= $abort_code@23 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@0|)) (and (=> (= (ControlFlow 0 132415) 133680) inline$$Diem_register_SCS_currency_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 132415) 133664) inline$$Diem_register_SCS_currency_$def$0$anon58_Else_correct))))))
(let ((inline$$MoveToRaw$1$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1) (= (ControlFlow 0 132413) 132415)) inline$$MoveToRaw$1$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$1$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1)) (=> (and (and (= |inline$$MoveToRaw$1$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 inline$$Diem_register_currency_$def$0$$ret0@2))) (= $abort_flag@16 $abort_flag@15)) (and (= $abort_code@23 $abort_code@21) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@1|))) (and (=> (= (ControlFlow 0 132363) 133680) inline$$Diem_register_SCS_currency_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 132363) 133664) inline$$Diem_register_SCS_currency_$def$0$anon58_Else_correct))))))
(let ((inline$$MoveTo$1$anon0$1_correct  (=> (= inline$$MoveTo$1$a@1 (|a#$Address| tc_account)) (and (=> (= (ControlFlow 0 132421) 132413) inline$$MoveToRaw$1$anon3_Then_correct) (=> (= (ControlFlow 0 132421) 132363) inline$$MoveToRaw$1$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$1$Entry_correct  (and (=> (= (ControlFlow 0 132209) (- 0 150623)) true) (=> (= (ControlFlow 0 132209) 132421) inline$$MoveTo$1$anon0$1_correct))))
(let ((inline$$MoveTo$1$Entry_correct  (=> (and (= inline$$MoveTo$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0) 1)) (= (ControlFlow 0 132181) 132209)) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon56_Then_correct  (=> (and (|b#$Boolean| inline$$Not$2$dst@1) (= (ControlFlow 0 132429) 132181)) inline$$MoveTo$1$Entry_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon34_correct  (=> (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory) (=> (and (= $abort_code@32 $abort_code@22) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 132079) 132083))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 132077) 132079)) inline$$Diem_register_SCS_currency_$def$0$anon34_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 132091) 132079) inline$$Diem_register_SCS_currency_$def$0$anon34_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon56_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$2$dst@1)) (= $abort_code@22 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 132071) 132091) inline$$Diem_register_SCS_currency_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 132071) 132077) inline$$Diem_register_SCS_currency_$def$0$anon57_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon54_Else_correct  (=> (not $abort_flag@15) (and (=> (= (ControlFlow 0 132059) 132429) inline$$Diem_register_SCS_currency_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 132059) 132071) inline$$Diem_register_SCS_currency_$def$0$anon56_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon52_Else$1_correct  (=> (and (and (and (= inline$$Diem_register_SCS_currency_$def$0$$t22@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@15)) (and (=> $abort_flag@15 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@15) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 132053) 133700) inline$$Diem_register_SCS_currency_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 132053) 132059) inline$$Diem_register_SCS_currency_$def$0$anon54_Else_correct)))))
(let ((inline$$Not$2$anon0_correct  (=> (and (= inline$$Not$2$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_register_SCS_currency_$def$0$$t20@1)))) (= (ControlFlow 0 132041) 132053)) inline$$Diem_register_SCS_currency_$def$0$anon52_Else$1_correct)))
(let ((inline$$Not$2$Entry_correct  (and (=> (= (ControlFlow 0 132031) (- 0 150466)) true) (=> (= (ControlFlow 0 132031) 132041) inline$$Not$2$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon52_Else_correct  (=> (not $abort_flag@14) (=> (and (= inline$$Diem_register_SCS_currency_$def$0$$t20@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@4)))) (= (ControlFlow 0 132047) 132031)) inline$$Not$2$Entry_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon22_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@14) (=> $abort_flag@14 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 tc_account)))) ((_ is $Address) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 131973) 133720) inline$$Diem_register_SCS_currency_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 131973) 132047) inline$$Diem_register_SCS_currency_$def$0$anon52_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 131971) 131973)) inline$$Diem_register_SCS_currency_$def$0$anon22_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 133744) 131973) inline$$Diem_register_SCS_currency_$def$0$anon22_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon50_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 131929) 133744) inline$$Diem_register_SCS_currency_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 131929) 131971) inline$$Diem_register_SCS_currency_$def$0$anon51_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon50_Then_correct  (and (=> (= (ControlFlow 0 133752) 133744) inline$$Diem_register_SCS_currency_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 133752) 131971) inline$$Diem_register_SCS_currency_$def$0$anon51_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon49_Else_correct  (=> (not $abort_flag@13) (and (=> (= (ControlFlow 0 131921) 133752) inline$$Diem_register_SCS_currency_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 131921) 131929) inline$$Diem_register_SCS_currency_$def$0$anon50_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon49_Then_correct  (=> (and (and (and $abort_flag@13 (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory)) (and (= $abort_code@32 $abort_code@19) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory))) (and (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4) (= (ControlFlow 0 133756) 132083)))) inline$$Diem_register_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon76_correct  (=> (= inline$$Diem_register_currency_$def$0$$ret0@2 inline$$Diem_MintCapability_pack$0$$struct@1) (=> (and (= inline$$Diem_register_currency_$def$0$$ret1@2 inline$$Diem_BurnCapability_pack$0$$struct@1) (= $Diem_CurrencyInfo_$memory@1 |inline$$MoveToRaw$0$m'@2|)) (=> (and (and (= $abort_flag@13 $abort_flag@12) (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@2)) (and (= $DiemConfig_DiemConfig_$memory@4 $DiemConfig_DiemConfig_$memory@2) (= $abort_code@19 $abort_code@17))) (and (=> (= (ControlFlow 0 131477) 133756) inline$$Diem_register_SCS_currency_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 131477) 131921) inline$$Diem_register_SCS_currency_$def$0$anon49_Else_correct)))))))
(let ((inline$$Diem_register_currency_$def$0$anon114_Else_correct  (=> (and (not true) (= (ControlFlow 0 131475) 131477)) inline$$Diem_register_currency_$def$0$anon76_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon114_Then_correct  (=> (= (ControlFlow 0 131485) 131477) inline$$Diem_register_currency_$def$0$anon76_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon113_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 131465) 131485) inline$$Diem_register_currency_$def$0$anon114_Then_correct) (=> (= (ControlFlow 0 131465) 131475) inline$$Diem_register_currency_$def$0$anon114_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon113_Then_correct  (and (=> (= (ControlFlow 0 131493) 131485) inline$$Diem_register_currency_$def$0$anon114_Then_correct) (=> (= (ControlFlow 0 131493) 131475) inline$$Diem_register_currency_$def$0$anon114_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 131443) 131493) inline$$Diem_register_currency_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 131443) 131465) inline$$Diem_register_currency_$def$0$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 131449) 131493) inline$$Diem_register_currency_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 131449) 131465) inline$$Diem_register_currency_$def$0$anon113_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 131437) 131449) inline$$Diem_BurnCapability_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 131437) 131443) inline$$Diem_BurnCapability_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 131429) 131493) inline$$Diem_register_currency_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 131429) 131465) inline$$Diem_register_currency_$def$0$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def$0$$t39@1) (= inline$$Diem_BurnCapability_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$0$$t39@1) 1)))) (and (=> (= (ControlFlow 0 131421) 131437) inline$$Diem_BurnCapability_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 131421) 131429) inline$$Diem_BurnCapability_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon112_Else$1_correct  (=> (and (= inline$$Diem_register_currency_$def$0$$t39@1 ($Boolean false)) (= (ControlFlow 0 131455) 131421)) inline$$Diem_BurnCapability_pack$0$anon0_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 131272) 131455)) inline$$Diem_register_currency_$def$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 131278) 131455) inline$$Diem_register_currency_$def$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 131266) 131278) inline$$Diem_MintCapability_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 131266) 131272) inline$$Diem_MintCapability_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_MintCapability_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 131258) 131455)) inline$$Diem_register_currency_$def$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def$0$$t37@1) (= inline$$Diem_MintCapability_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$0$$t37@1) 1)))) (and (=> (= (ControlFlow 0 131250) 131266) inline$$Diem_MintCapability_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 131250) 131258) inline$$Diem_MintCapability_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon112_Else_correct  (=> (not $abort_flag@12) (=> (and (= inline$$Diem_register_currency_$def$0$$t37@1 ($Boolean false)) (= (ControlFlow 0 131284) 131250)) inline$$Diem_MintCapability_pack$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$Abort_correct  (=> (= inline$$Diem_register_currency_$def$0$$ret0@1 $Error) (=> (and (and (and (= inline$$Diem_register_currency_$def$0$$ret1@1 $Error) (= inline$$Diem_register_currency_$def$0$$ret0@2 inline$$Diem_register_currency_$def$0$$ret0@1)) (and (= inline$$Diem_register_currency_$def$0$$ret1@2 inline$$Diem_register_currency_$def$0$$ret1@1) (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory@0))) (and (and (= $abort_flag@13 true) (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@3)) (and (= $DiemConfig_DiemConfig_$memory@4 $DiemConfig_DiemConfig_$memory@3) (= $abort_code@19 $abort_code@18)))) (and (=> (= (ControlFlow 0 127936) 133756) inline$$Diem_register_SCS_currency_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 127936) 131921) inline$$Diem_register_SCS_currency_$def$0$anon49_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$0$anon15_correct  (=> (= $abort_code@18 $abort_code@4) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131807) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 131805) 131807)) inline$$Diem_register_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon84_Then_correct  (=> (= (ControlFlow 0 131815) 131807) inline$$Diem_register_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon83_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 131799) 131815) inline$$Diem_register_currency_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 131799) 131805) inline$$Diem_register_currency_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon19_correct  (=> (= $abort_code@18 $abort_code@5) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131787) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 131785) 131787)) inline$$Diem_register_currency_$def$0$anon19_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon86_Then_correct  (=> (= (ControlFlow 0 131795) 131787) inline$$Diem_register_currency_$def$0$anon19_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon85_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 131779) 131795) inline$$Diem_register_currency_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 131779) 131785) inline$$Diem_register_currency_$def$0$anon86_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon23_correct  (=> (= $abort_code@18 $abort_code@6) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131767) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 131765) 131767)) inline$$Diem_register_currency_$def$0$anon23_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon88_Then_correct  (=> (= (ControlFlow 0 131775) 131767) inline$$Diem_register_currency_$def$0$anon23_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon87_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 131759) 131775) inline$$Diem_register_currency_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 131759) 131765) inline$$Diem_register_currency_$def$0$anon88_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon27_correct  (=> (= $abort_code@18 $abort_code@7) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131747) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon90_Else_correct  (=> (and (not true) (= (ControlFlow 0 131745) 131747)) inline$$Diem_register_currency_$def$0$anon27_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon90_Then_correct  (=> (= (ControlFlow 0 131755) 131747) inline$$Diem_register_currency_$def$0$anon27_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon89_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 131739) 131755) inline$$Diem_register_currency_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 131739) 131745) inline$$Diem_register_currency_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon41_correct  (=> (= $abort_code@18 $abort_code@9) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131629) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 131627) 131629)) inline$$Diem_register_currency_$def$0$anon41_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon97_Then_correct  (=> (= (ControlFlow 0 131637) 131629) inline$$Diem_register_currency_$def$0$anon41_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon96_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 131621) 131637) inline$$Diem_register_currency_$def$0$anon97_Then_correct) (=> (= (ControlFlow 0 131621) 131627) inline$$Diem_register_currency_$def$0$anon97_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon49_correct  (=> (= $abort_code@18 $abort_code@9) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131609) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon101_Else_correct  (=> (and (not true) (= (ControlFlow 0 131607) 131609)) inline$$Diem_register_currency_$def$0$anon49_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon101_Then_correct  (=> (= (ControlFlow 0 131617) 131609) inline$$Diem_register_currency_$def$0$anon49_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon100_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 131601) 131617) inline$$Diem_register_currency_$def$0$anon101_Then_correct) (=> (= (ControlFlow 0 131601) 131607) inline$$Diem_register_currency_$def$0$anon101_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon53_correct  (=> (= $abort_code@18 $abort_code@9) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131589) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon103_Else_correct  (=> (and (not true) (= (ControlFlow 0 131587) 131589)) inline$$Diem_register_currency_$def$0$anon53_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon103_Then_correct  (=> (= (ControlFlow 0 131597) 131589) inline$$Diem_register_currency_$def$0$anon53_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon102_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 131581) 131597) inline$$Diem_register_currency_$def$0$anon103_Then_correct) (=> (= (ControlFlow 0 131581) 131587) inline$$Diem_register_currency_$def$0$anon103_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon57_correct  (=> (= $abort_code@18 $abort_code@9) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131569) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon105_Else_correct  (=> (and (not true) (= (ControlFlow 0 131567) 131569)) inline$$Diem_register_currency_$def$0$anon57_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon105_Then_correct  (=> (= (ControlFlow 0 131577) 131569) inline$$Diem_register_currency_$def$0$anon57_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon104_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 131561) 131577) inline$$Diem_register_currency_$def$0$anon105_Then_correct) (=> (= (ControlFlow 0 131561) 131567) inline$$Diem_register_currency_$def$0$anon105_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon61_correct  (=> (= $abort_code@18 $abort_code@9) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131549) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon107_Else_correct  (=> (and (not true) (= (ControlFlow 0 131547) 131549)) inline$$Diem_register_currency_$def$0$anon61_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon107_Then_correct  (=> (= (ControlFlow 0 131557) 131549) inline$$Diem_register_currency_$def$0$anon61_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon106_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 131541) 131557) inline$$Diem_register_currency_$def$0$anon107_Then_correct) (=> (= (ControlFlow 0 131541) 131547) inline$$Diem_register_currency_$def$0$anon107_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon65_correct  (=> (= $abort_code@18 $abort_code@9) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131529) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon109_Else_correct  (=> (and (not true) (= (ControlFlow 0 131527) 131529)) inline$$Diem_register_currency_$def$0$anon65_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon109_Then_correct  (=> (= (ControlFlow 0 131537) 131529) inline$$Diem_register_currency_$def$0$anon65_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon108_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 131521) 131537) inline$$Diem_register_currency_$def$0$anon109_Then_correct) (=> (= (ControlFlow 0 131521) 131527) inline$$Diem_register_currency_$def$0$anon109_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon69_correct  (=> (= $abort_code@18 $abort_code@11) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 131509) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 131507) 131509)) inline$$Diem_register_currency_$def$0$anon69_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon111_Then_correct  (=> (= (ControlFlow 0 131517) 131509) inline$$Diem_register_currency_$def$0$anon69_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon110_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 131501) 131517) inline$$Diem_register_currency_$def$0$anon111_Then_correct) (=> (= (ControlFlow 0 131501) 131507) inline$$Diem_register_currency_$def$0$anon111_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon112_Then_correct  (=> (and $abort_flag@12 (= $abort_code@18 $abort_code@17)) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory@2)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory@2) (= (ControlFlow 0 131497) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Else_correct  (=> (not $abort_flag@11) (=> (and (and (= $abort_code@17 $abort_code@15) (= $abort_flag@12 $abort_flag@11)) (and (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@0) (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0))) (and (=> (= (ControlFlow 0 130981) 131497) inline$$Diem_register_currency_$def$0$anon112_Then_correct) (=> (= (ControlFlow 0 130981) 131284) inline$$Diem_register_currency_$def$0$anon112_Else_correct))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct  (=> (and (and (= $abort_code@17 $abort_code@16) (= $abort_flag@12 true)) (and (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@1) (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@1))) (and (=> (= (ControlFlow 0 130253) 131497) inline$$Diem_register_currency_$def$0$anon112_Then_correct) (=> (= (ControlFlow 0 130253) 131284) inline$$Diem_register_currency_$def$0$anon112_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct  (=> (and (and (= $abort_code@16 $abort_code@12) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 131073) 130253))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 131071) 131073)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 131081) 131073) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 131065) 131081) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 131065) 131071) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct  (=> (and (and (= $abort_code@16 $abort_code@12) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 131053) 130253))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 131051) 131053)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 131061) 131053) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 131045) 131061) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 131045) 131051) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct  (=> (and (and (= $abort_code@16 $abort_code@13) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 131033) 130253))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 131031) 131033)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 131041) 131033) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 131025) 131041) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 131025) 131031) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct  (=> (and (and (= $abort_code@16 $abort_code@13) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 131013) 130253))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 131011) 131013)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 131021) 131013) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 131005) 131021) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 131005) 131011) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct  (=> (and (and (= $abort_code@16 $abort_code@15) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory@0)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 130993) 130253))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 130991) 130993)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 131001) 130993) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 130985) 131001) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 130985) 130991) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct  (=> (and (= call0formal@$tv0@0 $RegisteredCurrencies_RegisteredCurrencies_type_value) (= call3formal@$DiemConfig_Configuration_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 130975) (- 0 148932)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))))) $abort_flag@11) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@11)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@11) (=> $abort_flag@11 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@11 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))))) (= $abort_code@15 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@15 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@15 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@2 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@2)))) $DiemConfig_DiemConfig_payload)) |inline$$WritebackToValue$0$vdst'@2|)))) (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 130975) 130985) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 130975) 130981) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Else_correct)))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| call3formal@$ret0@0@@5) (= (ControlFlow 0 130941) 130975)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 call3formal@$ret0@0@@5 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 130967) 130975))) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1)) (and (=> (= (ControlFlow 0 130786) 130967) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 130786) 130941) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 130842) 130967) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 130842) 130941) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 130750) 130842) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 130750) 130786) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct  (=> (and (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) |inline$$Vector_push_back$0$v'@1|)) (= (ControlFlow 0 130607) 130750)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else_correct  (=> (and (not $abort_flag@10) (= (ControlFlow 0 130613) 130607)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) len@@0 inline$$XUS_initialize_$def_verify$0$$t9@1) (+ len@@0 1)))))) (and (=> (= (ControlFlow 0 130542) 131005) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 130542) 130613) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct  (=> (and (= inline$$Vector_push_back$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 130530) 130542)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 130477) 130530)) inline$$Vector_push_back$0$Entry_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $RegisteredCurrencies_RegisteredCurrencies_currency_codes) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) (= (ControlFlow 0 130439) 130477))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 2) $EmptyPath call3formal@$ret0@0@@5)) (= (ControlFlow 0 130315) 130439)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 130321) 130315)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct  (=> (and (and (= $abort_code@16 $abort_code@14) (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 130249) 130253))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 130247) 130249)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 130261) 130249) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= $abort_code@14 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 130241) 130261) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 130241) 130247) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Else_correct  (=> (not $abort_flag@10) (and (=> (= (ControlFlow 0 130229) 130321) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 130229) 130241) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else$1_correct  (=> (and (and (and (= inline$$RegisteredCurrencies_add_currency_code_$def$0$$t10@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@10)) (and (=> $abort_flag@10 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 130223) 131025) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 130223) 130229) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Else_correct)))))
(let ((inline$$Not$1$anon0_correct  (=> (and (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Vector_contains$0$res@1)))) (= (ControlFlow 0 130211) 130223)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 130201) (- 0 148448)) true) (=> (= (ControlFlow 0 130201) 130211) inline$$Not$1$anon0_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else_correct  (=> (and (not $abort_flag@9) (= (ControlFlow 0 130217) 130201)) inline$$Not$1$Entry_correct)))
(let ((inline$$Vector_contains$0$anon0_correct  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1) (= inline$$Vector_contains$0$res@1 ($Boolean (exists ((i@@10 Int) )  (and (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)) i@@10) inline$$XUS_initialize_$def_verify$0$$t9@1)))))) (and (=> (= (ControlFlow 0 130155) 131045) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 130155) 130217) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else_correct)))))
(let ((inline$$Vector_contains$0$Entry_correct  (=> (and (= inline$$Vector_contains$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 130141) 130155)) inline$$Vector_contains$0$anon0_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@5)) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)) (= (ControlFlow 0 130086) 130141)) inline$$Vector_contains$0$Entry_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Else_correct  (=> (and (not $abort_flag@9) (= (ControlFlow 0 130092) 130086)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct  (=> (= call0formal@$tv0@0@@0 $RegisteredCurrencies_RegisteredCurrencies_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@9) (=> $abort_flag@9 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@9 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@12 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 130040) 131065) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 130040) 130092) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Else_correct))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 129970) 130040)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 131089) 130040) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 129962) 131089) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 129962) 129970) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 131097) 131089) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 131097) 129970) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon0_correct  (=> (not $abort_flag@8) (and (=> (= (ControlFlow 0 129956) 131097) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 129956) 129962) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and ((_ is $Vector) inline$$XUS_initialize_$def_verify$0$$t9@1) (let ((va@@9 (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@12))
)))))) (forall ((inline$$RegisteredCurrencies_add_currency_code$0$$$0 Int) ) (!  (=> (and (>= inline$$RegisteredCurrencies_add_currency_code$0$$$0 0) (< inline$$RegisteredCurrencies_add_currency_code$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$RegisteredCurrencies_add_currency_code$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$RegisteredCurrencies_add_currency_code$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$RegisteredCurrencies_add_currency_code$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$RegisteredCurrencies_add_currency_code$0$$$0))
))) (= (ControlFlow 0 131101) 129956)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon110_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 131107) 131101)) inline$$RegisteredCurrencies_add_currency_code$0$anon0_correct)))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@8 true) (=> (and (= $abort_code@11 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 129304) 131501) inline$$Diem_register_currency_$def$0$anon110_Then_correct) (=> (= (ControlFlow 0 129304) 131107) inline$$Diem_register_currency_$def$0$anon110_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 129302) 129304)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 inline$$Diem_CurrencyInfo_pack$0$$struct@1))) (= $abort_flag@8 $abort_flag@7)) (and (= $abort_code@11 $abort_code@9) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 129252) 131501) inline$$Diem_register_currency_$def$0$anon110_Then_correct) (=> (= (ControlFlow 0 129252) 131107) inline$$Diem_register_currency_$def$0$anon110_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| dr_account)) (and (=> (= (ControlFlow 0 129310) 129302) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 129310) 129252) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 129098) (- 0 147977)) true) (=> (= (ControlFlow 0 129098) 129310) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0) 1)) (= (ControlFlow 0 129070) 129098)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 128958) (- 0 147890)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 128958) 129070) inline$$MoveTo$0$Entry_correct)))))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 128972) 128958)) inline$$Diem_CurrencyInfo_pack$0$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 128978) 128958) inline$$Diem_CurrencyInfo_pack$0$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 128966) 128978) inline$$Diem_CurrencyInfo_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 128966) 128972) inline$$Diem_CurrencyInfo_pack$0$anon5_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 128910) 128958)) inline$$Diem_CurrencyInfo_pack$0$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_register_currency_$def$0$$t28@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t28@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t28@1) $MAX_U128)) (and (and ((_ is $Integer) inline$$Diem_register_currency_$def$0$$t29@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t29@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t29@1) $MAX_U64))) (=> (and (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0) (let ((va@@10 (|v#$Vector| call4formal@$ret0@0)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) inline$$Diem_register_SCS_currency_$def$0$$t16@1)) (and (and (and (and ((_ is $Integer) inline$$XUS_initialize_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t7@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$XUS_initialize_$def_verify$0$$t8@1) (>= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t8@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t8@1) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$XUS_initialize_$def_verify$0$$t9@1) (let ((va@@11 (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@14))
)))))) (forall ((inline$$Diem_CurrencyInfo_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_CurrencyInfo_pack$0$$$0 0) (< inline$$Diem_CurrencyInfo_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_CurrencyInfo_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_CurrencyInfo_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_CurrencyInfo_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_CurrencyInfo_pack$0$$$0))
))) ((_ is $Boolean) inline$$Diem_register_currency_$def$0$$t30@1)))) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@12 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@13 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@16))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$1$res@0) (let ((va@@14 (|v#$Vector| inline$$Event_new_event_handle$1$res@0)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@18))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@0))
))) true)) (=> (and (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$2$res@0) (let ((va@@16 (|v#$Vector| inline$$Event_new_event_handle$2$res@0)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@20))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@1))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$3$res@0) (let ((va@@18 (|v#$Vector| inline$$Event_new_event_handle$3$res@0)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@22))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@2))
))) true)) (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$4$res@0) (let ((va@@20 (|v#$Vector| inline$$Event_new_event_handle$4$res@0)))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@24))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@3))
))) true) (= inline$$Diem_CurrencyInfo_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$0$$t28@1) 1 inline$$Diem_register_currency_$def$0$$t29@1) 2 call4formal@$ret0@0) 3 inline$$Diem_register_SCS_currency_$def$0$$t16@1) 4 inline$$XUS_initialize_$def_verify$0$$t7@1) 5 inline$$XUS_initialize_$def_verify$0$$t8@1) 6 inline$$XUS_initialize_$def_verify$0$$t9@1) 7 inline$$Diem_register_currency_$def$0$$t30@1) 8 inline$$Event_new_event_handle$0$res@0) 9 inline$$Event_new_event_handle$1$res@0) 10 inline$$Event_new_event_handle$2$res@0) 11 inline$$Event_new_event_handle$3$res@0) 12 inline$$Event_new_event_handle$4$res@0) 13))))) (and (=> (= (ControlFlow 0 128902) 128966) inline$$Diem_CurrencyInfo_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 128902) 128910) inline$$Diem_CurrencyInfo_pack$0$anon4_Else_correct))))))))
(let ((inline$$Diem_register_currency_$def$0$anon108_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 128984) 128902)) inline$$Diem_CurrencyInfo_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$4$Entry_correct  (=> (= inline$$Event_new_event_handle$4$t@0 $Diem_ToXDXExchangeRateUpdateEvent_type_value) (and (=> (= (ControlFlow 0 128324) 131521) inline$$Diem_register_currency_$def$0$anon108_Then_correct) (=> (= (ControlFlow 0 128324) 128984) inline$$Diem_register_currency_$def$0$anon108_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon106_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 128332) 128324)) inline$$Event_new_event_handle$4$Entry_correct)))
(let ((inline$$Event_new_event_handle$3$Entry_correct  (=> (= inline$$Event_new_event_handle$3$t@0 $Diem_CancelBurnEvent_type_value) (and (=> (= (ControlFlow 0 128282) 131541) inline$$Diem_register_currency_$def$0$anon106_Then_correct) (=> (= (ControlFlow 0 128282) 128332) inline$$Diem_register_currency_$def$0$anon106_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon104_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 128290) 128282)) inline$$Event_new_event_handle$3$Entry_correct)))
(let ((inline$$Event_new_event_handle$2$Entry_correct  (=> (= inline$$Event_new_event_handle$2$t@0 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 128240) 131561) inline$$Diem_register_currency_$def$0$anon104_Then_correct) (=> (= (ControlFlow 0 128240) 128290) inline$$Diem_register_currency_$def$0$anon104_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon102_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 128248) 128240)) inline$$Event_new_event_handle$2$Entry_correct)))
(let ((inline$$Event_new_event_handle$1$Entry_correct  (=> (= inline$$Event_new_event_handle$1$t@0 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 128198) 131581) inline$$Diem_register_currency_$def$0$anon102_Then_correct) (=> (= (ControlFlow 0 128198) 128248) inline$$Diem_register_currency_$def$0$anon102_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon100_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 128206) 128198)) inline$$Event_new_event_handle$1$Entry_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $Diem_MintEvent_type_value) (and (=> (= (ControlFlow 0 128156) 131601) inline$$Diem_register_currency_$def$0$anon100_Then_correct) (=> (= (ControlFlow 0 128156) 128206) inline$$Diem_register_currency_$def$0$anon100_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon98_Then_correct  (=> (|b#$Boolean| |inline$$Diem_register_currency_$def$0$tmp#$10@1|) (=> (and (and (= inline$$Diem_register_currency_$def$0$$t28@1 ($Integer 0)) (= inline$$Diem_register_currency_$def$0$$t29@1 ($Integer 0))) (and (= inline$$Diem_register_currency_$def$0$$t30@1 ($Boolean true)) (= (ControlFlow 0 128164) 128156))) inline$$Event_new_event_handle$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon46_correct  (=> (= $abort_code@18 $abort_code@10) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 128104) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 128102) 128104)) inline$$Diem_register_currency_$def$0$anon46_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon99_Then_correct  (=> (= (ControlFlow 0 128112) 128104) inline$$Diem_register_currency_$def$0$anon46_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon98_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Diem_register_currency_$def$0$tmp#$10@1|)) (= $abort_code@10 (|i#$Integer| call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 128096) 128112) inline$$Diem_register_currency_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 128096) 128102) inline$$Diem_register_currency_$def$0$anon99_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon96_Else_correct  (=> (not $abort_flag@7) (and (=> (= (ControlFlow 0 128084) 128164) inline$$Diem_register_currency_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 128084) 128096) inline$$Diem_register_currency_$def$0$anon98_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$L5_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def$0$$t26@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7)) (and (=> $abort_flag@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 128078) 131621) inline$$Diem_register_currency_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 128078) 128084) inline$$Diem_register_currency_$def$0$anon96_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon36_correct  (=> (and (= |inline$$Diem_register_currency_$def$0$tmp#$10@1| inline$$Le$0$dst@1) (= (ControlFlow 0 131727) 128078)) inline$$Diem_register_currency_$def$0$L5_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 131725) 131727)) inline$$Diem_register_currency_$def$0$anon36_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon94_Then_correct  (=> (= (ControlFlow 0 131735) 131727) inline$$Diem_register_currency_$def$0$anon36_correct)))
(let ((inline$$Le$0$anon0_correct  (=> (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t7@1) (|i#$Integer| inline$$Diem_register_currency_$def$0$$t24@1)))) (and (=> (= (ControlFlow 0 131711) 131735) inline$$Diem_register_currency_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 131711) 131725) inline$$Diem_register_currency_$def$0$anon94_Else_correct)))))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 131697) (- 0 147412)) true) (=> (= (ControlFlow 0 131697) 131711) inline$$Le$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon93_Then_correct  (=> (|b#$Boolean| inline$$Lt$0$dst@1) (=> (and (= inline$$Diem_register_currency_$def$0$$t24@1 ($Integer 10000000000)) (= (ControlFlow 0 131717) 131697)) inline$$Le$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon38_correct  (=> (and (= |inline$$Diem_register_currency_$def$0$tmp#$10@1| inline$$Diem_register_currency_$def$0$$t25@1) (= (ControlFlow 0 128072) 128078)) inline$$Diem_register_currency_$def$0$L5_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 128070) 128072)) inline$$Diem_register_currency_$def$0$anon38_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon95_Then_correct  (=> (= (ControlFlow 0 131645) 128072) inline$$Diem_register_currency_$def$0$anon38_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon93_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= inline$$Diem_register_currency_$def$0$$t25@1 ($Boolean false))) (and (=> (= (ControlFlow 0 128062) 131645) inline$$Diem_register_currency_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 128062) 128070) inline$$Diem_register_currency_$def$0$anon95_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct  (=> (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| inline$$Diem_register_currency_$def$0$$t22@1) (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t7@1)))) (and (=> (= (ControlFlow 0 128010) 131717) inline$$Diem_register_currency_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 128010) 128062) inline$$Diem_register_currency_$def$0$anon93_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 127996) (- 0 147337)) true) (=> (= (ControlFlow 0 127996) 128010) inline$$Lt$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon91_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (= inline$$Diem_register_currency_$def$0$$t22@1 ($Integer 0)) (= (ControlFlow 0 128016) 127996)) inline$$Lt$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon32_correct  (=> (= $abort_code@18 $abort_code@8) (=> (and (and (= $Diem_CurrencyInfo_$memory@0 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 127928) 127936))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 127926) 127928)) inline$$Diem_register_currency_$def$0$anon32_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon92_Then_correct  (=> (= (ControlFlow 0 127944) 127928) inline$$Diem_register_currency_$def$0$anon32_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon91_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@8 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 127920) 127944) inline$$Diem_register_currency_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 127920) 127926) inline$$Diem_register_currency_$def$0$anon92_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon89_Else_correct  (=> (not $abort_flag@6) (and (=> (= (ControlFlow 0 127908) 128016) inline$$Diem_register_currency_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 127908) 127920) inline$$Diem_register_currency_$def$0$anon91_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon87_Else$1_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def$0$$t20@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6)) (and (=> $abort_flag@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 127902) 131739) inline$$Diem_register_currency_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 127902) 127908) inline$$Diem_register_currency_$def$0$anon89_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_register_currency_$def$0$$t18@1)))) (= (ControlFlow 0 127890) 127902)) inline$$Diem_register_currency_$def$0$anon87_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 127880) (- 0 147207)) true) (=> (= (ControlFlow 0 127880) 127890) inline$$Not$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon87_Else_correct  (=> (not $abort_flag@5) (=> (and (= inline$$Diem_register_currency_$def$0$$t18@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@9)))) (= (ControlFlow 0 127896) 127880)) inline$$Not$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon85_Else_correct  (=> (not $abort_flag@4) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5) (=> $abort_flag@5 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 dr_account)))) ((_ is $Address) call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 127822) 131759) inline$$Diem_register_currency_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 127822) 127896) inline$$Diem_register_currency_$def$0$anon87_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$0$anon83_Else_correct  (=> (and (and (not $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@4)) (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@4 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@5 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 127816) 131779) inline$$Diem_register_currency_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 127816) 127822) inline$$Diem_register_currency_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon12$6_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@3)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3)) (and (=> $abort_flag@3 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@3 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@4 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@4 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 127810) 131799) inline$$Diem_register_currency_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 127810) 127816) inline$$Diem_register_currency_$def$0$anon83_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 127604) 127810)) inline$$Diem_register_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon82_Then_correct  (=> (= (ControlFlow 0 131823) 127810) inline$$Diem_register_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon81_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 127596) 131823) inline$$Diem_register_currency_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 127596) 127604) inline$$Diem_register_currency_$def$0$anon82_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon81_Then_correct  (and (=> (= (ControlFlow 0 131831) 131823) inline$$Diem_register_currency_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 131831) 127604) inline$$Diem_register_currency_$def$0$anon82_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon80_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 127588) 131831) inline$$Diem_register_currency_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 127588) 127596) inline$$Diem_register_currency_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon80_Then_correct  (and (=> (= (ControlFlow 0 131839) 131831) inline$$Diem_register_currency_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 131839) 127596) inline$$Diem_register_currency_$def$0$anon81_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon79_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 127580) 131839) inline$$Diem_register_currency_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 127580) 127588) inline$$Diem_register_currency_$def$0$anon80_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon79_Then_correct  (and (=> (= (ControlFlow 0 131847) 131839) inline$$Diem_register_currency_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 131847) 127588) inline$$Diem_register_currency_$def$0$anon80_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon78_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 127572) 131847) inline$$Diem_register_currency_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 127572) 127580) inline$$Diem_register_currency_$def$0$anon79_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon78_Then_correct  (and (=> (= (ControlFlow 0 131855) 131847) inline$$Diem_register_currency_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 131855) 127580) inline$$Diem_register_currency_$def$0$anon79_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon77_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 127564) 131855) inline$$Diem_register_currency_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 127564) 127572) inline$$Diem_register_currency_$def$0$anon78_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon77_Then_correct  (and (=> (= (ControlFlow 0 131863) 131855) inline$$Diem_register_currency_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 131863) 127572) inline$$Diem_register_currency_$def$0$anon78_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon0_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 127558) 131863) inline$$Diem_register_currency_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 127558) 127564) inline$$Diem_register_currency_$def$0$anon77_Else_correct)))))
(let ((inline$$Diem_register_currency$0$anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0) (let ((va@@22 (|v#$Vector| call4formal@$ret0@0)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) inline$$Diem_register_SCS_currency_$def$0$$t16@1)) (and (and (and (and ((_ is $Integer) inline$$XUS_initialize_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t7@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$XUS_initialize_$def_verify$0$$t8@1) (>= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t8@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t8@1) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$XUS_initialize_$def_verify$0$$t9@1) (let ((va@@23 (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@26))
)))))) (forall ((inline$$Diem_register_currency$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_register_currency$0$$$0 0) (< inline$$Diem_register_currency$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_register_currency$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_register_currency$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_register_currency$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_register_currency$0$$$0))
))) (= (ControlFlow 0 131871) 127558)))) inline$$Diem_register_currency_$def$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon47_Else_correct  (=> (not $abort_flag@2) (=> (and (= inline$$Diem_register_SCS_currency_$def$0$$t16@1 ($Boolean false)) (= (ControlFlow 0 131881) 131871)) inline$$Diem_register_currency$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon12$6_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@2) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@2)) (and (=> $abort_flag@2 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@2 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@3 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@3 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@3 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 126021) 133760) inline$$Diem_register_SCS_currency_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 126021) 131881) inline$$Diem_register_SCS_currency_$def$0$anon47_Else_correct))))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 125815) 126021)) inline$$Diem_register_SCS_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 133784) 126021) inline$$Diem_register_SCS_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 125807) 133784) inline$$Diem_register_SCS_currency_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 125807) 125815) inline$$Diem_register_SCS_currency_$def$0$anon46_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 133792) 133784) inline$$Diem_register_SCS_currency_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 133792) 125815) inline$$Diem_register_SCS_currency_$def$0$anon46_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon44_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 125799) 133792) inline$$Diem_register_SCS_currency_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 125799) 125807) inline$$Diem_register_SCS_currency_$def$0$anon45_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon44_Then_correct  (and (=> (= (ControlFlow 0 133800) 133792) inline$$Diem_register_SCS_currency_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 133800) 125807) inline$$Diem_register_SCS_currency_$def$0$anon45_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon43_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 125791) 133800) inline$$Diem_register_SCS_currency_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 125791) 125799) inline$$Diem_register_SCS_currency_$def$0$anon44_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon43_Then_correct  (and (=> (= (ControlFlow 0 133808) 133800) inline$$Diem_register_SCS_currency_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 133808) 125799) inline$$Diem_register_SCS_currency_$def$0$anon44_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon42_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 125783) 133808) inline$$Diem_register_SCS_currency_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 125783) 125791) inline$$Diem_register_SCS_currency_$def$0$anon43_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon42_Then_correct  (and (=> (= (ControlFlow 0 133816) 133808) inline$$Diem_register_SCS_currency_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 133816) 125791) inline$$Diem_register_SCS_currency_$def$0$anon43_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 125775) 133816) inline$$Diem_register_SCS_currency_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 125775) 125783) inline$$Diem_register_SCS_currency_$def$0$anon42_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 133824) 133816) inline$$Diem_register_SCS_currency_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 133824) 125783) inline$$Diem_register_SCS_currency_$def$0$anon42_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def$0$anon0_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 125769) 133824) inline$$Diem_register_SCS_currency_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 125769) 125775) inline$$Diem_register_SCS_currency_$def$0$anon41_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) ((_ is $Address) tc_account)) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0) (let ((va@@24 (|v#$Vector| call4formal@$ret0@0)))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Integer) inline$$XUS_initialize_$def_verify$0$$t7@1) (>= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t7@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t7@1) $MAX_U64)) (and (and ((_ is $Integer) inline$$XUS_initialize_$def_verify$0$$t8@1) (>= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t8@1) 0)) (<= (|i#$Integer| inline$$XUS_initialize_$def_verify$0$$t8@1) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$XUS_initialize_$def_verify$0$$t9@1) (let ((va@@25 (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@28))
)))))) (forall ((inline$$Diem_register_SCS_currency_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_register_SCS_currency_$direct_inter$0$$$0 0) (< inline$$Diem_register_SCS_currency_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_register_SCS_currency_$direct_inter$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_register_SCS_currency_$direct_inter$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_register_SCS_currency_$direct_inter$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$XUS_initialize_$def_verify$0$$t9@1)) inline$$Diem_register_SCS_currency_$direct_inter$0$$$0))
))) (= (ControlFlow 0 133828) 125769)))) inline$$Diem_register_SCS_currency_$def$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$direct_inter$0$Entry_correct  (=> (and (= inline$$Diem_register_SCS_currency_$direct_inter$0$$tv0@0 $XUS_XUS_type_value) (= (ControlFlow 0 124978) 133828)) inline$$Diem_register_SCS_currency_$direct_inter$0$anon0_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@1) (=> (and (and (= inline$$XUS_initialize_$def_verify$0$$t7@1 ($Integer 1000000)) (= inline$$XUS_initialize_$def_verify$0$$t8@1 ($Integer 100))) (and (= inline$$XUS_initialize_$def_verify$0$$t9@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 ($Integer 88)) 1 ($Integer 85)) 2 ($Integer 83)) 3))) (= (ControlFlow 0 133834) 124978))) inline$$Diem_register_SCS_currency_$direct_inter$0$Entry_correct))))
(let ((inline$$XUS_initialize_$def_verify$0$anon19_Else_correct  (=> (not $abort_flag@0) (=> (and (and (and (= inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 1)) (= inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 1))) (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 32)) ($Integer 0)))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 64)) ($Integer 0)))))))) $abort_flag@1))) (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@1) (=> $abort_flag@1 (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 32)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 64)) ($Integer 0))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (and (=> $abort_flag@1 (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($shl inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 32)) ($Integer 0)))) (= $abort_code@2 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 32))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($shl inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 64)) ($Integer 0)))))))) (= $abort_code@2 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (div (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t4@1 ($Integer 64))) (|i#$Integer| ($shl inline$$XUS_initialize_$def_verify$0$$t5@1 ($Integer 32)))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@2 (|i#$Integer| ($Integer 8)))))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$XUS_initialize_$def_verify$0$$t4@1 inline$$XUS_initialize_$def_verify$0$$t5@1))) ($Vector (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Integer 1)) (+ len@@1 1)))) ($Vector (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 ($Integer 2)) (+ len@@2 1)))))))))))) (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0) (let ((va@@26 (|v#$Vector| call4formal@$ret0@0)))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 124760) 135323) inline$$XUS_initialize_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 124760) 133834) inline$$XUS_initialize_$def_verify$0$anon21_Else_correct)))))))
(let ((inline$$XUS_initialize_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 124746) 135343) inline$$XUS_initialize_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 124746) 124760) inline$$XUS_initialize_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$XUS_initialize_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 124676) 124746)) inline$$XUS_initialize_$def_verify$0$anon4$2_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 135367) 124746) inline$$XUS_initialize_$def_verify$0$anon4$2_correct)))
(let ((inline$$XUS_initialize_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 124668) 135367) inline$$XUS_initialize_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 124668) 124676) inline$$XUS_initialize_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$XUS_initialize_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 135375) 135367) inline$$XUS_initialize_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 135375) 124676) inline$$XUS_initialize_$def_verify$0$anon18_Else_correct))))
(let ((inline$$XUS_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 124662) 135375) inline$$XUS_initialize_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 124662) 124668) inline$$XUS_initialize_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct  (=> (and (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@27 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@28 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (and (forall (($inv_addr@@1 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1)) (let ((va@@29 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))
)))) (and (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@36))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@4))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@34 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@4))
))) (and (forall (($inv_addr@@5 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))
)) (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@36 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@40))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@5)) (let ((va@@38 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@5))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@41))
)))))) (forall (($$1 Int) ) (!  (=> (and (>= $$1 0) (< $$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@5))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@5))) $$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@5))) $$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@5))) $$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@5))) $$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@5))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@6))
))))) (=> (and (and (and (and (forall (($inv_addr@@7 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@7)) (let ((va@@39 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@7))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@7))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@7))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@7))
)) (forall (($inv_addr@@8 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8)) (let ((va@@40 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@44))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_currency_code)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@45))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_currency_code))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_currency_code))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_currency_code))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_currency_code))) $$0@@6))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@47))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@7))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@46 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@49))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@8))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@47 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@51))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@9))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@49 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@50 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@53))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@10))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@55))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@11))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@8))
))) (and (forall (($inv_addr@@9 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9)) (let ((va@@53 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))) $Diem_MintCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@9))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((window_addr T@$Value) )  (=> ((_ is $Address) window_addr) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| window_addr)))) $AccountLimits_Window_limit_address)))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((config_address T@$Value) )  (=> ((_ is $Address) config_address) (|b#$Boolean| ($Boolean (forall ((config_type T@$Value) )  (=> ((_ is $Type) config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type)) 1) (|a#$Address| config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@3 T@$Value) )  (=> ((_ is $Type) coin_type@@3) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@4 T@$Value) )  (=> ((_ is $Address) addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@4 ($Address 173345816))))))))))) (= (ControlFlow 0 135379) 124662))))) inline$$XUS_initialize_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> ((_ is $Address) dr_account) (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 123273) 135379)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 137758) 123273) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
