(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun x@@8 () T@$Value)
(declare-fun y () T@$Value)
(declare-fun $abort_flag@1 () Bool)
(declare-fun inline$$TestArithmetic_add_two_number_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestArithmetic_add_two_number_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestArithmetic_add_two_number_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestArithmetic_add_two_number_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0 () Bool)
(declare-fun inline$$TestArithmetic_add_two_number_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 41784) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 22918) (- 0 42254)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@8) (|i#$Integer| y)))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@8) (|i#$Integer| y)))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1) (and (=> (= (ControlFlow 0 22918) (- 0 42283)) (=> $abort_flag@1 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@8) (|i#$Integer| y)))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@1 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@8) (|i#$Integer| y)))) (|i#$Integer| ($Integer $MAX_U64)))))) (and (=> (= (ControlFlow 0 22918) (- 0 42312)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_add_two_number_$def_verify$0$$ret0@2 ($Integer 3)))))) (=> (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_add_two_number_$def_verify$0$$ret0@2 ($Integer 3))))) (=> (= (ControlFlow 0 22918) (- 0 42328)) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_add_two_number_$def_verify$0$$ret1@2 ($Integer (+ (|i#$Integer| x@@8) (|i#$Integer| y))))))))))))))))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon7_correct  (=> (and (= inline$$TestArithmetic_add_two_number_$def_verify$0$$ret0@1 $Error) (= inline$$TestArithmetic_add_two_number_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= inline$$TestArithmetic_add_two_number_$def_verify$0$$ret0@2 inline$$TestArithmetic_add_two_number_$def_verify$0$$ret0@1) (= inline$$TestArithmetic_add_two_number_$def_verify$0$$ret1@2 inline$$TestArithmetic_add_two_number_$def_verify$0$$ret1@1)) (and (= $abort_flag@1 true) (= (ControlFlow 0 22884) 22918))) anon0$2_correct))))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 22876) 22884)) inline$$TestArithmetic_add_two_number_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 22892) 22884) inline$$TestArithmetic_add_two_number_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon17_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 22870) 22892) inline$$TestArithmetic_add_two_number_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 22870) 22876) inline$$TestArithmetic_add_two_number_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon14_correct  (=> (and (and (= inline$$TestArithmetic_add_two_number_$def_verify$0$$ret0@2 inline$$TestArithmetic_add_two_number_$def_verify$0$$t6@1) (= inline$$TestArithmetic_add_two_number_$def_verify$0$$ret1@2 inline$$AddU64$0$dst@2)) (and (= $abort_flag@1 $abort_flag@0) (= (ControlFlow 0 22842) 22918))) anon0$2_correct)))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 22840) 22842)) inline$$TestArithmetic_add_two_number_$def_verify$0$anon14_correct)))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 22850) 22842) inline$$TestArithmetic_add_two_number_$def_verify$0$anon14_correct)))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 22830) 22850) inline$$TestArithmetic_add_two_number_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 22830) 22840) inline$$TestArithmetic_add_two_number_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon20_Then_correct  (and (=> (= (ControlFlow 0 22858) 22850) inline$$TestArithmetic_add_two_number_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 22858) 22840) inline$$TestArithmetic_add_two_number_$def_verify$0$anon21_Else_correct))))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon10_correct  (=> (= inline$$TestArithmetic_add_two_number_$def_verify$0$$t6@1 ($Integer 3)) (and (=> (= (ControlFlow 0 22824) 22858) inline$$TestArithmetic_add_two_number_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 22824) 22830) inline$$TestArithmetic_add_two_number_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 22816) 22824)) inline$$TestArithmetic_add_two_number_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 22866) 22824) inline$$TestArithmetic_add_two_number_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon17_Else_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 22810) 22866) inline$$TestArithmetic_add_two_number_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 22810) 22816) inline$$TestArithmetic_add_two_number_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 22796) 22870) inline$$TestArithmetic_add_two_number_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 22796) 22810) inline$$TestArithmetic_add_two_number_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| x@@8) (|i#$Integer| y)) $MAX_U64) (= (ControlFlow 0 22794) 22796)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| x@@8) (|i#$Integer| y))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| x@@8) (|i#$Integer| y))))) (and (= $abort_flag@0 false) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 22738) 22870) inline$$TestArithmetic_add_two_number_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 22738) 22810) inline$$TestArithmetic_add_two_number_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 22708) (- 0 42062)) true) (and (=> (= (ControlFlow 0 22708) 22794) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 22708) 22738) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 22547) 22708)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 22900) 22708) inline$$AddU64$0$Entry_correct)))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 22539) 22900) inline$$TestArithmetic_add_two_number_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 22539) 22547) inline$$TestArithmetic_add_two_number_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 22908) 22900) inline$$TestArithmetic_add_two_number_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 22908) 22547) inline$$TestArithmetic_add_two_number_$def_verify$0$anon16_Else_correct))))
(let ((inline$$TestArithmetic_add_two_number_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 22533) 22908) inline$$TestArithmetic_add_two_number_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 22533) 22539) inline$$TestArithmetic_add_two_number_$def_verify$0$anon15_Else_correct)))))
(let ((anon0_correct  (=> (and (and ((_ is $Integer) x@@8) (>= (|i#$Integer| x@@8) 0)) (<= (|i#$Integer| x@@8) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y) (>= (|i#$Integer| y) 0)) (<= (|i#$Integer| y) $MAX_U64)) (= (ControlFlow 0 22252) 22533)) inline$$TestArithmetic_add_two_number_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 41784) 22252) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun a () T@$Value)
(declare-fun inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@1 () Int)
(declare-fun inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t4@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 42366) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 23535) (- 0 42762)) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret0@2 ($Integer (mod (|i#$Integer| ($Integer (div (|i#$Integer| ($Integer (* (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (+ (|i#$Integer| ($Integer 6)) (|i#$Integer| ($Integer 4))))) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 2))))) (|i#$Integer| ($Integer 3))))) (|i#$Integer| ($Integer 4))))))))) (=> (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret0@2 ($Integer (mod (|i#$Integer| ($Integer (div (|i#$Integer| ($Integer (* (|i#$Integer| ($Integer (- (|i#$Integer| ($Integer (+ (|i#$Integer| ($Integer 6)) (|i#$Integer| ($Integer 4))))) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 2))))) (|i#$Integer| ($Integer 3))))) (|i#$Integer| ($Integer 4)))))))) (=> (= (ControlFlow 0 23535) (- 0 42838)) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret1@2 a)))))))))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon8_correct  (=> (and (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret0@1 $Error) (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@0@@0 true) (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret0@2 inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret0@1)) (and (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret1@2 inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret1@1) (= (ControlFlow 0 23501) 23535))) anon0$2_correct@@0))))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 23493) 23501)) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon8_correct)))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 23509) 23501) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon8_correct)))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon15_Then_correct  (=> (|b#$Boolean| inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t5@1) (=> (and (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t6@1 ($Integer 42)) (= $abort_code@1 (|i#$Integer| inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t6@1))) (and (=> (= (ControlFlow 0 23487) 23509) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 23487) 23493) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon12_correct  (=> (and (and (= $abort_flag@0@@0 false) (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret0@2 inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t3@1)) (and (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$ret1@2 a) (= (ControlFlow 0 23457) 23535))) anon0$2_correct@@0)))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 23455) 23457)) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon12_correct)))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 23465) 23457) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon12_correct)))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 23445) 23465) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 23445) 23455) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 23473) 23465) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 23473) 23455) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon15_Else_correct  (=> (not (|b#$Boolean| inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t5@1)) (and (=> (= (ControlFlow 0 23439) 23473) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 23439) 23445) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon4_correct  (=> (and (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t4@1 ($Integer 2)) (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t5@1 ($Boolean  (not ($IsEqual_stratified inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t3@1 inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t4@1))))) (and (=> (= (ControlFlow 0 23429) 23487) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 23429) 23439) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 23413) 23429)) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon4_correct)))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 23517) 23429) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon4_correct)))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon2$1_correct  (=> (= inline$$TestArithmetic_arithmetic_ops_$def_verify$0$$t3@1 ($Integer 2)) (and (=> (= (ControlFlow 0 23405) 23517) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 23405) 23413) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 23333) 23405)) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 23525) 23405) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 23327) 23525) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 23327) 23333) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@0  (=> (and (and (and ((_ is $Integer) a) (>= (|i#$Integer| a) 0)) (<= (|i#$Integer| a) $MAX_U64)) (= (ControlFlow 0 23046) 23327)) inline$$TestArithmetic_arithmetic_ops_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 42366) 23046) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$TestArithmetic_bool_ops_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun a@@0 () T@$Value)
(declare-fun b () T@$Value)
(declare-fun inline$$TestArithmetic_bool_ops_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestArithmetic_bool_ops_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestArithmetic_bool_ops_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun inline$$TestArithmetic_bool_ops_$def_verify$0$$t14@1 () T@$Value)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$4@1| () T@$Value)
(declare-fun |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$5@1| () T@$Value)
(declare-fun inline$$TestArithmetic_bool_ops_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$TestArithmetic_bool_ops_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun inline$$Ge$0$dst@1 () T@$Value)
(declare-fun inline$$Gt$0$dst@1 () T@$Value)
(declare-fun inline$$TestArithmetic_bool_ops_$def_verify$0$$t9@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 42859) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 24959) (- 0 43616)) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_bool_ops_$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| a@@0) (|i#$Integer| b)))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| a@@0) (|i#$Integer| b))))))))))) (=> (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_bool_ops_$def_verify$0$$ret0@2 ($Boolean  (and (|b#$Boolean| ($Boolean (> (|i#$Integer| a@@0) (|i#$Integer| b)))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| a@@0) (|i#$Integer| b)))))))))) (=> (= (ControlFlow 0 24959) (- 0 43660)) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_bool_ops_$def_verify$0$$ret1@2 ($Boolean  (or (|b#$Boolean| ($Boolean (< (|i#$Integer| a@@0) (|i#$Integer| b)))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| a@@0) (|i#$Integer| b)))))))))))))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon24_correct  (=> (and (= inline$$TestArithmetic_bool_ops_$def_verify$0$$ret0@1 $Error) (= inline$$TestArithmetic_bool_ops_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@0@@1 true) (= inline$$TestArithmetic_bool_ops_$def_verify$0$$ret0@2 inline$$TestArithmetic_bool_ops_$def_verify$0$$ret0@1)) (and (= inline$$TestArithmetic_bool_ops_$def_verify$0$$ret1@2 inline$$TestArithmetic_bool_ops_$def_verify$0$$ret1@1) (= (ControlFlow 0 24747) 24959))) anon0$2_correct@@1))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 24739) 24747)) inline$$TestArithmetic_bool_ops_$def_verify$0$anon24_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 24755) 24747) inline$$TestArithmetic_bool_ops_$def_verify$0$anon24_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon39_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (= inline$$TestArithmetic_bool_ops_$def_verify$0$$t14@1 ($Integer 42)) (= $abort_code@1@@0 (|i#$Integer| inline$$TestArithmetic_bool_ops_$def_verify$0$$t14@1))) (and (=> (= (ControlFlow 0 24733) 24755) inline$$TestArithmetic_bool_ops_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 24733) 24739) inline$$TestArithmetic_bool_ops_$def_verify$0$anon40_Else_correct))))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon28_correct  (=> (and (and (= $abort_flag@0@@1 false) (= inline$$TestArithmetic_bool_ops_$def_verify$0$$ret0@2 |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$4@1|)) (and (= inline$$TestArithmetic_bool_ops_$def_verify$0$$ret1@2 |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$5@1|) (= (ControlFlow 0 24703) 24959))) anon0$2_correct@@1)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 24701) 24703)) inline$$TestArithmetic_bool_ops_$def_verify$0$anon28_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 24711) 24703) inline$$TestArithmetic_bool_ops_$def_verify$0$anon28_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 24691) 24711) inline$$TestArithmetic_bool_ops_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 24691) 24701) inline$$TestArithmetic_bool_ops_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 24719) 24711) inline$$TestArithmetic_bool_ops_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 24719) 24701) inline$$TestArithmetic_bool_ops_$def_verify$0$anon42_Else_correct))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon39_Else_correct  (=> (not (|b#$Boolean| inline$$Not$0$dst@1)) (and (=> (= (ControlFlow 0 24685) 24719) inline$$TestArithmetic_bool_ops_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 24685) 24691) inline$$TestArithmetic_bool_ops_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$TestArithmetic_bool_ops_$def_verify$0$$t12@1)))) (and (=> (= (ControlFlow 0 24667) 24733) inline$$TestArithmetic_bool_ops_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 24667) 24685) inline$$TestArithmetic_bool_ops_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 24657) (- 0 43482)) true) (=> (= (ControlFlow 0 24657) 24667) inline$$Not$0$anon0_correct))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon20_correct  (=> (and (= inline$$TestArithmetic_bool_ops_$def_verify$0$$t12@1 ($Boolean  (not ($IsEqual_stratified |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$4@1| |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$5@1|)))) (= (ControlFlow 0 24673) 24657)) inline$$Not$0$Entry_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 24613) 24673)) inline$$TestArithmetic_bool_ops_$def_verify$0$anon20_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 24763) 24673) inline$$TestArithmetic_bool_ops_$def_verify$0$anon20_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon16_correct  (=> (= |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$5@1| inline$$TestArithmetic_bool_ops_$def_verify$0$$t11@1) (and (=> (= (ControlFlow 0 24823) 24763) inline$$TestArithmetic_bool_ops_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 24823) 24613) inline$$TestArithmetic_bool_ops_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 24821) 24823)) inline$$TestArithmetic_bool_ops_$def_verify$0$anon16_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 24831) 24823) inline$$TestArithmetic_bool_ops_$def_verify$0$anon16_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon35_Then_correct  (=> (and (|b#$Boolean| inline$$Lt$0$dst@1) (= inline$$TestArithmetic_bool_ops_$def_verify$0$$t11@1 ($Boolean true))) (and (=> (= (ControlFlow 0 24813) 24831) inline$$TestArithmetic_bool_ops_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 24813) 24821) inline$$TestArithmetic_bool_ops_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon18_correct  (=> (= |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$5@1| inline$$Le$0$dst@1) (and (=> (= (ControlFlow 0 24571) 24763) inline$$TestArithmetic_bool_ops_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 24571) 24613) inline$$TestArithmetic_bool_ops_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 24569) 24571)) inline$$TestArithmetic_bool_ops_$def_verify$0$anon18_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 24771) 24571) inline$$TestArithmetic_bool_ops_$def_verify$0$anon18_correct)))
(let ((inline$$Le$0$anon0_correct  (=> (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| a@@0) (|i#$Integer| b)))) (and (=> (= (ControlFlow 0 24555) 24771) inline$$TestArithmetic_bool_ops_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 24555) 24569) inline$$TestArithmetic_bool_ops_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 24541) (- 0 43383)) true) (=> (= (ControlFlow 0 24541) 24555) inline$$Le$0$anon0_correct))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon35_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= (ControlFlow 0 24561) 24541)) inline$$Le$0$Entry_correct)))
(let ((inline$$Lt$0$anon0_correct  (=> (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| a@@0) (|i#$Integer| b)))) (and (=> (= (ControlFlow 0 24483) 24813) inline$$TestArithmetic_bool_ops_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 24483) 24561) inline$$TestArithmetic_bool_ops_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 24469) (- 0 43338)) true) (=> (= (ControlFlow 0 24469) 24483) inline$$Lt$0$anon0_correct))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 24425) 24469)) inline$$Lt$0$Entry_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 24839) 24469) inline$$Lt$0$Entry_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon8_correct  (=> (= |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$4@1| inline$$Ge$0$dst@1) (and (=> (= (ControlFlow 0 24925) 24839) inline$$TestArithmetic_bool_ops_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 24925) 24425) inline$$TestArithmetic_bool_ops_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 24923) 24925)) inline$$TestArithmetic_bool_ops_$def_verify$0$anon8_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 24933) 24925) inline$$TestArithmetic_bool_ops_$def_verify$0$anon8_correct)))
(let ((inline$$Ge$0$anon0_correct  (=> (= inline$$Ge$0$dst@1 ($Boolean (>= (|i#$Integer| a@@0) (|i#$Integer| b)))) (and (=> (= (ControlFlow 0 24909) 24933) inline$$TestArithmetic_bool_ops_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 24909) 24923) inline$$TestArithmetic_bool_ops_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Ge$0$Entry_correct  (and (=> (= (ControlFlow 0 24895) (- 0 43271)) true) (=> (= (ControlFlow 0 24895) 24909) inline$$Ge$0$anon0_correct))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon31_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1) (= (ControlFlow 0 24915) 24895)) inline$$Ge$0$Entry_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon10_correct  (=> (= |inline$$TestArithmetic_bool_ops_$def_verify$0$tmp#$4@1| inline$$TestArithmetic_bool_ops_$def_verify$0$$t9@1) (and (=> (= (ControlFlow 0 24383) 24839) inline$$TestArithmetic_bool_ops_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 24383) 24425) inline$$TestArithmetic_bool_ops_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 24381) 24383)) inline$$TestArithmetic_bool_ops_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 24847) 24383) inline$$TestArithmetic_bool_ops_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon31_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1)) (= inline$$TestArithmetic_bool_ops_$def_verify$0$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 24373) 24847) inline$$TestArithmetic_bool_ops_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 24373) 24381) inline$$TestArithmetic_bool_ops_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct  (=> (= inline$$Gt$0$dst@1 ($Boolean (> (|i#$Integer| a@@0) (|i#$Integer| b)))) (and (=> (= (ControlFlow 0 24321) 24915) inline$$TestArithmetic_bool_ops_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 24321) 24373) inline$$TestArithmetic_bool_ops_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 24307) (- 0 43206)) true) (=> (= (ControlFlow 0 24307) 24321) inline$$Gt$0$anon0_correct))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 24195) 24307)) inline$$Gt$0$Entry_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 24941) 24307) inline$$Gt$0$Entry_correct)))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 24187) 24941) inline$$TestArithmetic_bool_ops_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 24187) 24195) inline$$TestArithmetic_bool_ops_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 24949) 24941) inline$$TestArithmetic_bool_ops_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 24949) 24195) inline$$TestArithmetic_bool_ops_$def_verify$0$anon30_Else_correct))))
(let ((inline$$TestArithmetic_bool_ops_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 24181) 24949) inline$$TestArithmetic_bool_ops_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 24181) 24187) inline$$TestArithmetic_bool_ops_$def_verify$0$anon29_Else_correct)))))
(let ((anon0_correct@@1  (=> (and (and ((_ is $Integer) a@@0) (>= (|i#$Integer| a@@0) 0)) (<= (|i#$Integer| a@@0) $MAX_U64)) (=> (and (and (and ((_ is $Integer) b) (>= (|i#$Integer| b) 0)) (<= (|i#$Integer| b) $MAX_U64)) (= (ControlFlow 0 23654) 24181)) inline$$TestArithmetic_bool_ops_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 42859) 23654) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun y@@0 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$TestArithmetic_div_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun x@@9 () T@$Value)
(declare-fun inline$$TestArithmetic_div_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$TestArithmetic_div_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$TestArithmetic_div_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$Div$0$dst@2 () T@$Value)
(declare-fun inline$$Mod$0$dst@2 () T@$Value)
(declare-fun inline$$Mod$0$dst@0 () T@$Value)
(declare-fun inline$$Mod$0$dst@1 () T@$Value)
(declare-fun inline$$Div$0$dst@0 () T@$Value)
(declare-fun inline$$Div$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 43711) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 26049) (- 0 44239)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 0)))) $abort_flag@2)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 0)))) $abort_flag@2) (and (=> (= (ControlFlow 0 26049) (- 0 44254)) (=> $abort_flag@2 (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 0)))))) (=> (=> $abort_flag@2 (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@0 ($Integer 0))))) (and (=> (= (ControlFlow 0 26049) (- 0 44269)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_div_$def_verify$0$$ret0@2 ($Integer (div (|i#$Integer| x@@9) (|i#$Integer| y@@0)))))))) (=> (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_div_$def_verify$0$$ret0@2 ($Integer (div (|i#$Integer| x@@9) (|i#$Integer| y@@0))))))) (=> (= (ControlFlow 0 26049) (- 0 44293)) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_div_$def_verify$0$$ret1@2 ($Integer (mod (|i#$Integer| x@@9) (|i#$Integer| y@@0))))))))))))))))
(let ((inline$$TestArithmetic_div_$def_verify$0$Abort_correct  (=> (and (= inline$$TestArithmetic_div_$def_verify$0$$ret0@1 $Error) (= inline$$TestArithmetic_div_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= inline$$TestArithmetic_div_$def_verify$0$$ret0@2 inline$$TestArithmetic_div_$def_verify$0$$ret0@1) (= inline$$TestArithmetic_div_$def_verify$0$$ret1@2 inline$$TestArithmetic_div_$def_verify$0$$ret1@1)) (and (= $abort_flag@2 true) (= (ControlFlow 0 25995) 26049))) anon0$2_correct@@2))))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 26013) 25995)) inline$$TestArithmetic_div_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 26023) 25995) inline$$TestArithmetic_div_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon19_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 26007) 26023) inline$$TestArithmetic_div_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 26007) 26013) inline$$TestArithmetic_div_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 25985) 25995)) inline$$TestArithmetic_div_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 26003) 25995) inline$$TestArithmetic_div_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon21_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 25979) 26003) inline$$TestArithmetic_div_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 25979) 25985) inline$$TestArithmetic_div_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon16_correct  (=> (and (and (= inline$$TestArithmetic_div_$def_verify$0$$ret0@2 inline$$Div$0$dst@2) (= inline$$TestArithmetic_div_$def_verify$0$$ret1@2 inline$$Mod$0$dst@2)) (and (= $abort_flag@2 $abort_flag@1@@0) (= (ControlFlow 0 25959) 26049))) anon0$2_correct@@2)))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 25957) 25959)) inline$$TestArithmetic_div_$def_verify$0$anon16_correct)))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 25967) 25959) inline$$TestArithmetic_div_$def_verify$0$anon16_correct)))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 25947) 25967) inline$$TestArithmetic_div_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 25947) 25957) inline$$TestArithmetic_div_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 25975) 25967) inline$$TestArithmetic_div_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 25975) 25957) inline$$TestArithmetic_div_$def_verify$0$anon24_Else_correct))))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 25941) 25975) inline$$TestArithmetic_div_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 25941) 25947) inline$$TestArithmetic_div_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Mod$0$anon3_Then$1_correct  (=> (and (= $abort_flag@1@@0 true) (= inline$$Mod$0$dst@2 inline$$Mod$0$dst@0)) (and (=> (= (ControlFlow 0 25925) 25979) inline$$TestArithmetic_div_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 25925) 25941) inline$$TestArithmetic_div_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Mod$0$anon3_Then_correct  (=> (and (= (|i#$Integer| y@@0) 0) (= (ControlFlow 0 25923) 25925)) inline$$Mod$0$anon3_Then$1_correct)))
(let ((inline$$Mod$0$anon3_Else_correct  (=> (and (and (not (= (|i#$Integer| y@@0) 0)) (= inline$$Mod$0$dst@1 ($Integer (mod (|i#$Integer| x@@9) (|i#$Integer| y@@0))))) (and (= $abort_flag@1@@0 $abort_flag@0@@2) (= inline$$Mod$0$dst@2 inline$$Mod$0$dst@1))) (and (=> (= (ControlFlow 0 25873) 25979) inline$$TestArithmetic_div_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 25873) 25941) inline$$TestArithmetic_div_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Mod$0$Entry_correct  (and (=> (= (ControlFlow 0 25849) (- 0 44064)) true) (and (=> (= (ControlFlow 0 25849) 25923) inline$$Mod$0$anon3_Then_correct) (=> (= (ControlFlow 0 25849) 25873) inline$$Mod$0$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon19_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 25931) 25849)) inline$$Mod$0$Entry_correct)))
(let ((inline$$Div$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@2 true) (= inline$$Div$0$dst@2 inline$$Div$0$dst@0)) (and (=> (= (ControlFlow 0 25754) 26007) inline$$TestArithmetic_div_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 25754) 25931) inline$$TestArithmetic_div_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Div$0$anon3_Then_correct  (=> (and (= (|i#$Integer| y@@0) 0) (= (ControlFlow 0 25752) 25754)) inline$$Div$0$anon3_Then$1_correct)))
(let ((inline$$Div$0$anon3_Else_correct  (=> (and (and (not (= (|i#$Integer| y@@0) 0)) (= inline$$Div$0$dst@1 ($Integer (div (|i#$Integer| x@@9) (|i#$Integer| y@@0))))) (and (= $abort_flag@0@@2 false) (= inline$$Div$0$dst@2 inline$$Div$0$dst@1))) (and (=> (= (ControlFlow 0 25702) 26007) inline$$TestArithmetic_div_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 25702) 25931) inline$$TestArithmetic_div_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Div$0$Entry_correct  (and (=> (= (ControlFlow 0 25678) (- 0 43987)) true) (and (=> (= (ControlFlow 0 25678) 25752) inline$$Div$0$anon3_Then_correct) (=> (= (ControlFlow 0 25678) 25702) inline$$Div$0$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 25527) 25678)) inline$$Div$0$Entry_correct)))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 26031) 25678) inline$$Div$0$Entry_correct)))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 25519) 26031) inline$$TestArithmetic_div_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 25519) 25527) inline$$TestArithmetic_div_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 26039) 26031) inline$$TestArithmetic_div_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 26039) 25527) inline$$TestArithmetic_div_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestArithmetic_div_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 25513) 26039) inline$$TestArithmetic_div_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 25513) 25519) inline$$TestArithmetic_div_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@2  (=> (and (and ((_ is $Integer) x@@9) (>= (|i#$Integer| x@@9) 0)) (<= (|i#$Integer| x@@9) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@0) (>= (|i#$Integer| y@@0) 0)) (<= (|i#$Integer| y@@0) $MAX_U64)) (= (ControlFlow 0 25216) 25513)) inline$$TestArithmetic_div_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 43711) 25216) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun inline$$TestArithmetic_div_by_zero_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun inline$$TestArithmetic_div_by_zero_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Div$0$dst@1@@0 () T@$Value)
(declare-fun inline$$TestArithmetic_div_by_zero_$def_verify$0$$t1@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 44321) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 26561) (- 0 44566)) (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@1)) (=> (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@1) (=> (= (ControlFlow 0 26561) (- 0 44575)) (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean true))))))))
(let ((inline$$TestArithmetic_div_by_zero_$def_verify$0$anon3_correct  (=> (= inline$$TestArithmetic_div_by_zero_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@1 true) (= (ControlFlow 0 26545) 26561)) anon0$2_correct@@3))))
(let ((inline$$TestArithmetic_div_by_zero_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 26539) 26545)) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon3_correct)))
(let ((inline$$TestArithmetic_div_by_zero_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 26553) 26545) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon3_correct)))
(let ((inline$$TestArithmetic_div_by_zero_$def_verify$0$anon7_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 26533) 26553) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 26533) 26539) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestArithmetic_div_by_zero_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@1@@1 $abort_flag@0@@3) (= (ControlFlow 0 26521) 26561)) anon0$2_correct@@3)))
(let ((inline$$TestArithmetic_div_by_zero_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 26519) 26521)) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon6_correct)))
(let ((inline$$TestArithmetic_div_by_zero_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 26529) 26521) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon6_correct)))
(let ((inline$$TestArithmetic_div_by_zero_$def_verify$0$anon7_Else_correct  (=> (not $abort_flag@0@@3) (and (=> (= (ControlFlow 0 26513) 26529) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 26513) 26519) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Div$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@0@@3 true) (and (=> (= (ControlFlow 0 26497) 26533) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 26497) 26513) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon7_Else_correct)))))
(let ((inline$$Div$0$anon3_Then_correct@@0  (=> (and (= (|i#$Integer| inline$$TestArithmetic_div_by_zero_$def_verify$0$$t2@1) 0) (= (ControlFlow 0 26495) 26497)) inline$$Div$0$anon3_Then$1_correct@@0)))
(let ((inline$$Div$0$anon3_Else_correct@@0  (=> (not (= (|i#$Integer| inline$$TestArithmetic_div_by_zero_$def_verify$0$$t2@1) 0)) (=> (and (= inline$$Div$0$dst@1@@0 ($Integer (div (|i#$Integer| inline$$TestArithmetic_div_by_zero_$def_verify$0$$t1@1) (|i#$Integer| inline$$TestArithmetic_div_by_zero_$def_verify$0$$t2@1)))) (= $abort_flag@0@@3 false)) (and (=> (= (ControlFlow 0 26445) 26533) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 26445) 26513) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon7_Else_correct))))))
(let ((inline$$Div$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 26421) (- 0 44453)) true) (and (=> (= (ControlFlow 0 26421) 26495) inline$$Div$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 26421) 26445) inline$$Div$0$anon3_Else_correct@@0)))))
(let ((inline$$TestArithmetic_div_by_zero_$def_verify$0$anon0_correct  (=> (and (and (not false) (= inline$$TestArithmetic_div_by_zero_$def_verify$0$$t1@1 ($Integer 1))) (and (= inline$$TestArithmetic_div_by_zero_$def_verify$0$$t2@1 ($Integer 0)) (= (ControlFlow 0 26503) 26421))) inline$$Div$0$Entry_correct@@0)))
(let ((anon0_correct@@3  (=> (= (ControlFlow 0 44321) 26503) inline$$TestArithmetic_div_by_zero_$def_verify$0$anon0_correct)))
anon0_correct@@3))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun y@@1 () T@$Value)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun inline$$Div$0$dst@1@@1 () T@$Value)
(declare-fun x@@10 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 44590) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 27171) (- 0 44895)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@1 ($Integer 0)))) $abort_flag@1@@2)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@1 ($Integer 0)))) $abort_flag@1@@2) (=> (= (ControlFlow 0 27171) (- 0 44910)) (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean ($IsEqual_stratified y@@1 ($Integer 0))))))))))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@2 true) (= (ControlFlow 0 27139) 27171)) anon0$2_correct@@4))))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 27133) 27139)) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 27147) 27139) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@4 (and (=> (= (ControlFlow 0 27127) 27147) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 27127) 27133) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@2 $abort_flag@0@@4) (= (ControlFlow 0 27115) 27171)) anon0$2_correct@@4)))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 27113) 27115)) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 27123) 27115) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@4) (and (=> (= (ControlFlow 0 27107) 27123) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 27107) 27113) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Div$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@0@@4 true) (and (=> (= (ControlFlow 0 27091) 27127) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 27091) 27107) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Div$0$anon3_Then_correct@@1  (=> (and (= (|i#$Integer| y@@1) 0) (= (ControlFlow 0 27089) 27091)) inline$$Div$0$anon3_Then$1_correct@@1)))
(let ((inline$$Div$0$anon3_Else_correct@@1  (=> (not (= (|i#$Integer| y@@1) 0)) (=> (and (= inline$$Div$0$dst@1@@1 ($Integer (div (|i#$Integer| x@@10) (|i#$Integer| y@@1)))) (= $abort_flag@0@@4 false)) (and (=> (= (ControlFlow 0 27039) 27127) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 27039) 27107) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$Div$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 27015) (- 0 44782)) true) (and (=> (= (ControlFlow 0 27015) 27089) inline$$Div$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 27015) 27039) inline$$Div$0$anon3_Else_correct@@1)))))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 26864) 27015)) inline$$Div$0$Entry_correct@@1)))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 27155) 27015) inline$$Div$0$Entry_correct@@1)))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 26856) 27155) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 26856) 26864) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 27163) 27155) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 27163) 26864) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 26850) 27163) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 26850) 26856) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@4  (=> (and (and ((_ is $Integer) x@@10) (>= (|i#$Integer| x@@10) 0)) (<= (|i#$Integer| x@@10) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@1) (>= (|i#$Integer| y@@1) 0)) (<= (|i#$Integer| y@@1) $MAX_U64)) (= (ControlFlow 0 26642) 26850)) inline$$TestArithmetic_div_by_zero_u64_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 44590) 26642) anon0_correct@@4)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun y@@2 () T@$Value)
(declare-fun inline$$Div$0$dst@1@@2 () T@$Value)
(declare-fun x@@11 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 44931) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 27813) (- 0 45226)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@3) (=> (= (ControlFlow 0 27813) (- 0 45235)) (=> $abort_flag@1@@3 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@3 true) (= (ControlFlow 0 27781) 27813)) anon0$2_correct@@5))))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 27775) 27781)) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 27789) 27781) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 27769) 27789) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 27769) 27775) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@3 $abort_flag@0@@5) (= (ControlFlow 0 27757) 27813)) anon0$2_correct@@5)))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 27755) 27757)) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 27765) 27757) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@5) (and (=> (= (ControlFlow 0 27749) 27765) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 27749) 27755) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Div$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@0@@5 true) (and (=> (= (ControlFlow 0 27733) 27769) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 27733) 27749) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Div$0$anon3_Then_correct@@2  (=> (and (= (|i#$Integer| y@@2) 0) (= (ControlFlow 0 27731) 27733)) inline$$Div$0$anon3_Then$1_correct@@2)))
(let ((inline$$Div$0$anon3_Else_correct@@2  (=> (not (= (|i#$Integer| y@@2) 0)) (=> (and (= inline$$Div$0$dst@1@@2 ($Integer (div (|i#$Integer| x@@11) (|i#$Integer| y@@2)))) (= $abort_flag@0@@5 false)) (and (=> (= (ControlFlow 0 27681) 27769) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 27681) 27749) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$Div$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 27657) (- 0 45113)) true) (and (=> (= (ControlFlow 0 27657) 27731) inline$$Div$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 27657) 27681) inline$$Div$0$anon3_Else_correct@@2)))))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 27506) 27657)) inline$$Div$0$Entry_correct@@2)))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 27797) 27657) inline$$Div$0$Entry_correct@@2)))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 27498) 27797) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 27498) 27506) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 27805) 27797) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 27805) 27506) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 27492) 27805) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 27492) 27498) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@5  (=> (and (and ((_ is $Integer) x@@11) (>= (|i#$Integer| x@@11) 0)) (<= (|i#$Integer| x@@11) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@2) (>= (|i#$Integer| y@@2) 0)) (<= (|i#$Integer| y@@2) $MAX_U64)) (= (ControlFlow 0 27284) 27492)) inline$$TestArithmetic_div_by_zero_u64_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 44931) 27284) anon0_correct@@5)))
PreconditionGeneratedEntry_correct@@4)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@12 () T@$Value)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun inline$$TestArithmetic_f_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestArithmetic_f_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$TestArithmetic_f_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 45249) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 28398) (- 0 45614)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@12) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@4)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@12) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@4) (and (=> (= (ControlFlow 0 28398) (- 0 45645)) (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@12) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@12) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer $MAX_U64)))))) (=> (= (ControlFlow 0 28398) (- 0 45676)) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_f_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| x@@12) (|i#$Integer| ($Integer 1)))))))))))))))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon5_correct  (=> (and (and (= inline$$TestArithmetic_f_$def_verify$0$$ret0@1 $Error) (= inline$$TestArithmetic_f_$def_verify$0$$ret0@2 inline$$TestArithmetic_f_$def_verify$0$$ret0@1)) (and (= $abort_flag@1@@4 true) (= (ControlFlow 0 28374) 28398))) anon0$2_correct@@6)))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 28368) 28374)) inline$$TestArithmetic_f_$def_verify$0$anon5_correct)))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 28382) 28374) inline$$TestArithmetic_f_$def_verify$0$anon5_correct)))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 28362) 28382) inline$$TestArithmetic_f_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 28362) 28368) inline$$TestArithmetic_f_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon8_correct  (=> (= inline$$TestArithmetic_f_$def_verify$0$$ret0@2 inline$$AddU64$0$dst@2@@0) (=> (and (= $abort_flag@1@@4 $abort_flag@0@@6) (= (ControlFlow 0 28350) 28398)) anon0$2_correct@@6))))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 28348) 28350)) inline$$TestArithmetic_f_$def_verify$0$anon8_correct)))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 28358) 28350) inline$$TestArithmetic_f_$def_verify$0$anon8_correct)))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@6) (and (=> (= (ControlFlow 0 28342) 28358) inline$$TestArithmetic_f_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 28342) 28348) inline$$TestArithmetic_f_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (and (= $abort_flag@0@@6 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 28326) 28362) inline$$TestArithmetic_f_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 28326) 28342) inline$$TestArithmetic_f_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| x@@12) (|i#$Integer| inline$$TestArithmetic_f_$def_verify$0$$t2@1)) $MAX_U64) (= (ControlFlow 0 28324) 28326)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| x@@12) (|i#$Integer| inline$$TestArithmetic_f_$def_verify$0$$t2@1))) (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| x@@12) (|i#$Integer| inline$$TestArithmetic_f_$def_verify$0$$t2@1))))) (and (= $abort_flag@0@@6 false) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 28268) 28362) inline$$TestArithmetic_f_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 28268) 28342) inline$$TestArithmetic_f_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 28238) (- 0 45475)) true) (and (=> (= (ControlFlow 0 28238) 28324) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 28238) 28268) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestArithmetic_f_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 28332) 28238)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 28107) 28332)) inline$$TestArithmetic_f_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 28390) 28332) inline$$TestArithmetic_f_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_f_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 28101) 28390) inline$$TestArithmetic_f_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 28101) 28107) inline$$TestArithmetic_f_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@6  (=> (and (and (and ((_ is $Integer) x@@12) (>= (|i#$Integer| x@@12) 0)) (<= (|i#$Integer| x@@12) $MAX_U64)) (= (ControlFlow 0 27922) 28101)) inline$$TestArithmetic_f_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 45249) 27922) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@5))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@13 () T@$Value)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun inline$$TestArithmetic_g_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestArithmetic_g_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$TestArithmetic_g_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 45707) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 28969) (- 0 46072)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@13) (|i#$Integer| ($Integer 2))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@5)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@13) (|i#$Integer| ($Integer 2))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@5) (and (=> (= (ControlFlow 0 28969) (- 0 46103)) (=> $abort_flag@1@@5 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@13) (|i#$Integer| ($Integer 2))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@1@@5 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@13) (|i#$Integer| ($Integer 2))))) (|i#$Integer| ($Integer $MAX_U64)))))) (=> (= (ControlFlow 0 28969) (- 0 46134)) (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_g_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| x@@13) (|i#$Integer| ($Integer 2)))))))))))))))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon5_correct  (=> (and (and (= inline$$TestArithmetic_g_$def_verify$0$$ret0@1 $Error) (= inline$$TestArithmetic_g_$def_verify$0$$ret0@2 inline$$TestArithmetic_g_$def_verify$0$$ret0@1)) (and (= $abort_flag@1@@5 true) (= (ControlFlow 0 28945) 28969))) anon0$2_correct@@7)))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 28939) 28945)) inline$$TestArithmetic_g_$def_verify$0$anon5_correct)))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 28953) 28945) inline$$TestArithmetic_g_$def_verify$0$anon5_correct)))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon10_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 28933) 28953) inline$$TestArithmetic_g_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 28933) 28939) inline$$TestArithmetic_g_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon8_correct  (=> (= inline$$TestArithmetic_g_$def_verify$0$$ret0@2 inline$$AddU64$0$dst@2@@1) (=> (and (= $abort_flag@1@@5 $abort_flag@0@@7) (= (ControlFlow 0 28921) 28969)) anon0$2_correct@@7))))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 28919) 28921)) inline$$TestArithmetic_g_$def_verify$0$anon8_correct)))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 28929) 28921) inline$$TestArithmetic_g_$def_verify$0$anon8_correct)))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon10_Else_correct  (=> (not $abort_flag@0@@7) (and (=> (= (ControlFlow 0 28913) 28929) inline$$TestArithmetic_g_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 28913) 28919) inline$$TestArithmetic_g_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@0@@7 true) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 28897) 28933) inline$$TestArithmetic_g_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 28897) 28913) inline$$TestArithmetic_g_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| x@@13) (|i#$Integer| inline$$TestArithmetic_g_$def_verify$0$$t2@1)) $MAX_U64) (= (ControlFlow 0 28895) 28897)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| x@@13) (|i#$Integer| inline$$TestArithmetic_g_$def_verify$0$$t2@1))) (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| x@@13) (|i#$Integer| inline$$TestArithmetic_g_$def_verify$0$$t2@1))))) (and (= $abort_flag@0@@7 false) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 28839) 28933) inline$$TestArithmetic_g_$def_verify$0$anon10_Then_correct) (=> (= (ControlFlow 0 28839) 28913) inline$$TestArithmetic_g_$def_verify$0$anon10_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 28809) (- 0 45933)) true) (and (=> (= (ControlFlow 0 28809) 28895) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 28809) 28839) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon2$1_correct  (=> (and (= inline$$TestArithmetic_g_$def_verify$0$$t2@1 ($Integer 2)) (= (ControlFlow 0 28903) 28809)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 28678) 28903)) inline$$TestArithmetic_g_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 28961) 28903) inline$$TestArithmetic_g_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_g_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 28672) 28961) inline$$TestArithmetic_g_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 28672) 28678) inline$$TestArithmetic_g_$def_verify$0$anon9_Else_correct)))))
(let ((anon0_correct@@7  (=> (and (and (and ((_ is $Integer) x@@13) (>= (|i#$Integer| x@@13) 0)) (<= (|i#$Integer| x@@13) $MAX_U64)) (= (ControlFlow 0 28493) 28672)) inline$$TestArithmetic_g_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 45707) 28493) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@6))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@5 () Bool)
(declare-fun inline$$TestArithmetic_h_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun |inline$$TestArithmetic_h_$def_verify$0$tmp#$1@2| () T@$Value)
(declare-fun inline$$TestArithmetic_h_$def_verify$0$$t9@1 () T@$Value)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun |inline$$TestArithmetic_h_$def_verify$0$tmp#$2@2| () T@$Value)
(declare-fun inline$$TestArithmetic_h_$def_verify$0$$t13@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun |inline$$TestArithmetic_h_$def_verify$0$tmp#$2@1| () T@$Value)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun inline$$TestArithmetic_h_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$TestArithmetic_h_$def_verify$0$y@1 () T@$Value)
(declare-fun inline$$TestArithmetic_h_$def_verify$0$$t12@1 () T@$Value)
(declare-fun b@@0 () T@$Value)
(declare-fun |inline$$TestArithmetic_h_$def_verify$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$TestArithmetic_h_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$TestArithmetic_h_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$TestArithmetic_f_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestArithmetic_f_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun inline$$AddU64$1$dst@2 () T@$Value)
(declare-fun inline$$AddU64$1$dst@0 () T@$Value)
(declare-fun inline$$TestArithmetic_h_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$TestArithmetic_f_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$AddU64$1$dst@1 () T@$Value)
(declare-fun inline$$TestArithmetic_g_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$TestArithmetic_g_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun inline$$AddU64$0$dst@2@@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@2 () T@$Value)
(declare-fun inline$$TestArithmetic_g_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 46165) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 31173) (- 0 47276)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5) (=> (= (ControlFlow 0 31173) (- 0 47285)) (=> $abort_flag@5 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$TestArithmetic_h_$def_verify$0$Abort_correct  (=> (= inline$$TestArithmetic_h_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@5 true) (= (ControlFlow 0 30476) 31173)) anon0$2_correct@@8))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon36_Then_correct  (=> (and $abort_flag@3 (= (ControlFlow 0 31149) 30476)) inline$$TestArithmetic_h_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 30548) 30476)) inline$$TestArithmetic_h_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 30558) 30476) inline$$TestArithmetic_h_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon41_Then_correct  (=> (|b#$Boolean| |inline$$TestArithmetic_h_$def_verify$0$tmp#$1@2|) (=> (and (= inline$$TestArithmetic_h_$def_verify$0$$t9@1 ($Integer 4)) (= $abort_code@1@@1 (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t9@1))) (and (=> (= (ControlFlow 0 30542) 30558) inline$$TestArithmetic_h_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 30542) 30548) inline$$TestArithmetic_h_$def_verify$0$anon42_Else_correct))))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 30468) 30476)) inline$$TestArithmetic_h_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon47_Then_correct  (=> (= (ControlFlow 0 30484) 30476) inline$$TestArithmetic_h_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon46_Then_correct  (=> (|b#$Boolean| |inline$$TestArithmetic_h_$def_verify$0$tmp#$2@2|) (=> (and (= inline$$TestArithmetic_h_$def_verify$0$$t13@1 ($Integer 5)) (= $abort_code@2 (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t13@1))) (and (=> (= (ControlFlow 0 30462) 30484) inline$$TestArithmetic_h_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 30462) 30468) inline$$TestArithmetic_h_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon37_Then_correct  (=> (and $abort_flag@1@@6 (= (ControlFlow 0 30606) 30476)) inline$$TestArithmetic_h_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon32_correct  (=> (and (= $abort_flag@5 $abort_flag@4) (= (ControlFlow 0 30440) 31173)) anon0$2_correct@@8)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 30438) 30440)) inline$$TestArithmetic_h_$def_verify$0$anon32_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 30448) 30440) inline$$TestArithmetic_h_$def_verify$0$anon32_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon46_Else_correct  (=> (not (|b#$Boolean| |inline$$TestArithmetic_h_$def_verify$0$tmp#$2@2|)) (and (=> (= (ControlFlow 0 30432) 30448) inline$$TestArithmetic_h_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 30432) 30438) inline$$TestArithmetic_h_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon24_correct  (=> (= |inline$$TestArithmetic_h_$def_verify$0$tmp#$2@2| |inline$$TestArithmetic_h_$def_verify$0$tmp#$2@1|) (and (=> (= (ControlFlow 0 30520) 30462) inline$$TestArithmetic_h_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 30520) 30432) inline$$TestArithmetic_h_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 30518) 30520)) inline$$TestArithmetic_h_$def_verify$0$anon24_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 30528) 30520) inline$$TestArithmetic_h_$def_verify$0$anon24_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon43_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1@@0) (=> (and (= inline$$TestArithmetic_h_$def_verify$0$$t11@1 ($Integer 5)) (= |inline$$TestArithmetic_h_$def_verify$0$tmp#$2@1| ($Boolean  (not ($IsEqual_stratified inline$$TestArithmetic_h_$def_verify$0$y@1 inline$$TestArithmetic_h_$def_verify$0$$t11@1))))) (and (=> (= (ControlFlow 0 30512) 30528) inline$$TestArithmetic_h_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 30512) 30518) inline$$TestArithmetic_h_$def_verify$0$anon44_Else_correct))))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon26_correct  (=> (= |inline$$TestArithmetic_h_$def_verify$0$tmp#$2@2| inline$$TestArithmetic_h_$def_verify$0$$t12@1) (and (=> (= (ControlFlow 0 30420) 30462) inline$$TestArithmetic_h_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 30420) 30432) inline$$TestArithmetic_h_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 30418) 30420)) inline$$TestArithmetic_h_$def_verify$0$anon26_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon45_Then_correct  (=> (= (ControlFlow 0 30492) 30420) inline$$TestArithmetic_h_$def_verify$0$anon26_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon43_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (= inline$$TestArithmetic_h_$def_verify$0$$t12@1 ($Boolean false))) (and (=> (= (ControlFlow 0 30410) 30492) inline$$TestArithmetic_h_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 30410) 30418) inline$$TestArithmetic_h_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@0  (=> (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| b@@0)))) (and (=> (= (ControlFlow 0 30358) 30512) inline$$TestArithmetic_h_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 30358) 30410) inline$$TestArithmetic_h_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 30348) (- 0 47089)) true) (=> (= (ControlFlow 0 30348) 30358) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon41_Else_correct  (=> (and (not (|b#$Boolean| |inline$$TestArithmetic_h_$def_verify$0$tmp#$1@2|)) (= (ControlFlow 0 30364) 30348)) inline$$Not$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon14_correct  (=> (= |inline$$TestArithmetic_h_$def_verify$0$tmp#$1@2| |inline$$TestArithmetic_h_$def_verify$0$tmp#$1@1|) (and (=> (= (ControlFlow 0 30594) 30542) inline$$TestArithmetic_h_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 30594) 30364) inline$$TestArithmetic_h_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 30592) 30594)) inline$$TestArithmetic_h_$def_verify$0$anon14_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 30602) 30594) inline$$TestArithmetic_h_$def_verify$0$anon14_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon38_Then_correct  (=> (|b#$Boolean| b@@0) (=> (and (= inline$$TestArithmetic_h_$def_verify$0$$t7@1 ($Integer 4)) (= |inline$$TestArithmetic_h_$def_verify$0$tmp#$1@1| ($Boolean  (not ($IsEqual_stratified inline$$TestArithmetic_h_$def_verify$0$y@1 inline$$TestArithmetic_h_$def_verify$0$$t7@1))))) (and (=> (= (ControlFlow 0 30586) 30602) inline$$TestArithmetic_h_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 30586) 30592) inline$$TestArithmetic_h_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon16_correct  (=> (= |inline$$TestArithmetic_h_$def_verify$0$tmp#$1@2| inline$$TestArithmetic_h_$def_verify$0$$t8@1) (and (=> (= (ControlFlow 0 30306) 30542) inline$$TestArithmetic_h_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 30306) 30364) inline$$TestArithmetic_h_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 30304) 30306)) inline$$TestArithmetic_h_$def_verify$0$anon16_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 30566) 30306) inline$$TestArithmetic_h_$def_verify$0$anon16_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon38_Else_correct  (=> (and (not (|b#$Boolean| b@@0)) (= inline$$TestArithmetic_h_$def_verify$0$$t8@1 ($Boolean false))) (and (=> (= (ControlFlow 0 30296) 30566) inline$$TestArithmetic_h_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 30296) 30304) inline$$TestArithmetic_h_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon36_Else_correct  (=> (not $abort_flag@3) (=> (and (= inline$$TestArithmetic_h_$def_verify$0$y@1 inline$$TestArithmetic_f_$def$0$$ret0@2) (= $abort_flag@4 $abort_flag@3)) (and (=> (= (ControlFlow 0 31145) 30586) inline$$TestArithmetic_h_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 31145) 30296) inline$$TestArithmetic_h_$def_verify$0$anon38_Else_correct))))))
(let ((inline$$TestArithmetic_f_$def$0$anon5_correct  (=> (= inline$$TestArithmetic_f_$def$0$$ret0@1 $Error) (=> (and (= inline$$TestArithmetic_f_$def$0$$ret0@2 inline$$TestArithmetic_f_$def$0$$ret0@1) (= $abort_flag@3 true)) (and (=> (= (ControlFlow 0 31107) 31149) inline$$TestArithmetic_h_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 31107) 31145) inline$$TestArithmetic_h_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$TestArithmetic_f_$def$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 31101) 31107)) inline$$TestArithmetic_f_$def$0$anon5_correct)))
(let ((inline$$TestArithmetic_f_$def$0$anon11_Then_correct  (=> (= (ControlFlow 0 31115) 31107) inline$$TestArithmetic_f_$def$0$anon5_correct)))
(let ((inline$$TestArithmetic_f_$def$0$anon10_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 31095) 31115) inline$$TestArithmetic_f_$def$0$anon11_Then_correct) (=> (= (ControlFlow 0 31095) 31101) inline$$TestArithmetic_f_$def$0$anon11_Else_correct)))))
(let ((inline$$TestArithmetic_f_$def$0$anon8_correct  (=> (and (= inline$$TestArithmetic_f_$def$0$$ret0@2 inline$$AddU64$1$dst@2) (= $abort_flag@3 $abort_flag@2@@0)) (and (=> (= (ControlFlow 0 31083) 31149) inline$$TestArithmetic_h_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 31083) 31145) inline$$TestArithmetic_h_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$TestArithmetic_f_$def$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 31081) 31083)) inline$$TestArithmetic_f_$def$0$anon8_correct)))
(let ((inline$$TestArithmetic_f_$def$0$anon12_Then_correct  (=> (= (ControlFlow 0 31091) 31083) inline$$TestArithmetic_f_$def$0$anon8_correct)))
(let ((inline$$TestArithmetic_f_$def$0$anon10_Else_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 31075) 31091) inline$$TestArithmetic_f_$def$0$anon12_Then_correct) (=> (= (ControlFlow 0 31075) 31081) inline$$TestArithmetic_f_$def$0$anon12_Else_correct)))))
(let ((inline$$AddU64$1$anon3_Then$1_correct  (=> (and (= $abort_flag@2@@0 true) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@0)) (and (=> (= (ControlFlow 0 31059) 31095) inline$$TestArithmetic_f_$def$0$anon10_Then_correct) (=> (= (ControlFlow 0 31059) 31075) inline$$TestArithmetic_f_$def$0$anon10_Else_correct)))))
(let ((inline$$AddU64$1$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) (|i#$Integer| inline$$TestArithmetic_f_$def$0$$t2@1)) $MAX_U64) (= (ControlFlow 0 31057) 31059)) inline$$AddU64$1$anon3_Then$1_correct)))
(let ((inline$$AddU64$1$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) (|i#$Integer| inline$$TestArithmetic_f_$def$0$$t2@1))) (= inline$$AddU64$1$dst@1 ($Integer (+ (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) (|i#$Integer| inline$$TestArithmetic_f_$def$0$$t2@1))))) (and (= $abort_flag@2@@0 false) (= inline$$AddU64$1$dst@2 inline$$AddU64$1$dst@1))) (and (=> (= (ControlFlow 0 31001) 31095) inline$$TestArithmetic_f_$def$0$anon10_Then_correct) (=> (= (ControlFlow 0 31001) 31075) inline$$TestArithmetic_f_$def$0$anon10_Else_correct)))))
(let ((inline$$AddU64$1$Entry_correct  (and (=> (= (ControlFlow 0 30971) (- 0 46815)) true) (and (=> (= (ControlFlow 0 30971) 31057) inline$$AddU64$1$anon3_Then_correct) (=> (= (ControlFlow 0 30971) 31001) inline$$AddU64$1$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_f_$def$0$anon2$1_correct  (=> (and (= inline$$TestArithmetic_f_$def$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 31065) 30971)) inline$$AddU64$1$Entry_correct)))
(let ((inline$$TestArithmetic_f_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 30840) 31065)) inline$$TestArithmetic_f_$def$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_f_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 31123) 31065) inline$$TestArithmetic_f_$def$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_f_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 30834) 31123) inline$$TestArithmetic_f_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 30834) 30840) inline$$TestArithmetic_f_$def$0$anon9_Else_correct)))))
(let ((inline$$TestArithmetic_f_$direct_intra$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestArithmetic_h_$def_verify$0$$t6@1) (>= (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) 0)) (<= (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) $MAX_U64)) (= (ControlFlow 0 31129) 30834)) inline$$TestArithmetic_f_$def$0$anon0_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon35_Then_correct  (=> (and (|b#$Boolean| b@@0) (= (ControlFlow 0 31137) 31129)) inline$$TestArithmetic_f_$direct_intra$0$anon0_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon37_Else_correct  (=> (not $abort_flag@1@@6) (=> (and (= inline$$TestArithmetic_h_$def_verify$0$y@1 inline$$TestArithmetic_g_$def$0$$ret0@2) (= $abort_flag@4 $abort_flag@1@@6)) (and (=> (= (ControlFlow 0 30250) 30586) inline$$TestArithmetic_h_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 30250) 30296) inline$$TestArithmetic_h_$def_verify$0$anon38_Else_correct))))))
(let ((inline$$TestArithmetic_g_$def$0$anon5_correct  (=> (= inline$$TestArithmetic_g_$def$0$$ret0@1 $Error) (=> (and (= inline$$TestArithmetic_g_$def$0$$ret0@2 inline$$TestArithmetic_g_$def$0$$ret0@1) (= $abort_flag@1@@6 true)) (and (=> (= (ControlFlow 0 30212) 30606) inline$$TestArithmetic_h_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 30212) 30250) inline$$TestArithmetic_h_$def_verify$0$anon37_Else_correct))))))
(let ((inline$$TestArithmetic_g_$def$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 30206) 30212)) inline$$TestArithmetic_g_$def$0$anon5_correct)))
(let ((inline$$TestArithmetic_g_$def$0$anon11_Then_correct  (=> (= (ControlFlow 0 30220) 30212) inline$$TestArithmetic_g_$def$0$anon5_correct)))
(let ((inline$$TestArithmetic_g_$def$0$anon10_Then_correct  (=> $abort_flag@0@@8 (and (=> (= (ControlFlow 0 30200) 30220) inline$$TestArithmetic_g_$def$0$anon11_Then_correct) (=> (= (ControlFlow 0 30200) 30206) inline$$TestArithmetic_g_$def$0$anon11_Else_correct)))))
(let ((inline$$TestArithmetic_g_$def$0$anon8_correct  (=> (and (= inline$$TestArithmetic_g_$def$0$$ret0@2 inline$$AddU64$0$dst@2@@2) (= $abort_flag@1@@6 $abort_flag@0@@8)) (and (=> (= (ControlFlow 0 30188) 30606) inline$$TestArithmetic_h_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 30188) 30250) inline$$TestArithmetic_h_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$TestArithmetic_g_$def$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 30186) 30188)) inline$$TestArithmetic_g_$def$0$anon8_correct)))
(let ((inline$$TestArithmetic_g_$def$0$anon12_Then_correct  (=> (= (ControlFlow 0 30196) 30188) inline$$TestArithmetic_g_$def$0$anon8_correct)))
(let ((inline$$TestArithmetic_g_$def$0$anon10_Else_correct  (=> (not $abort_flag@0@@8) (and (=> (= (ControlFlow 0 30180) 30196) inline$$TestArithmetic_g_$def$0$anon12_Then_correct) (=> (= (ControlFlow 0 30180) 30186) inline$$TestArithmetic_g_$def$0$anon12_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@2  (=> (and (= $abort_flag@0@@8 true) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@0@@2)) (and (=> (= (ControlFlow 0 30164) 30200) inline$$TestArithmetic_g_$def$0$anon10_Then_correct) (=> (= (ControlFlow 0 30164) 30180) inline$$TestArithmetic_g_$def$0$anon10_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) (|i#$Integer| inline$$TestArithmetic_g_$def$0$$t2@1)) $MAX_U64) (= (ControlFlow 0 30162) 30164)) inline$$AddU64$0$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$0$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) (|i#$Integer| inline$$TestArithmetic_g_$def$0$$t2@1))) (= inline$$AddU64$0$dst@1@@2 ($Integer (+ (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) (|i#$Integer| inline$$TestArithmetic_g_$def$0$$t2@1))))) (and (= $abort_flag@0@@8 false) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@1@@2))) (and (=> (= (ControlFlow 0 30106) 30200) inline$$TestArithmetic_g_$def$0$anon10_Then_correct) (=> (= (ControlFlow 0 30106) 30180) inline$$TestArithmetic_g_$def$0$anon10_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 30076) (- 0 46597)) true) (and (=> (= (ControlFlow 0 30076) 30162) inline$$AddU64$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 30076) 30106) inline$$AddU64$0$anon3_Else_correct@@2)))))
(let ((inline$$TestArithmetic_g_$def$0$anon2$1_correct  (=> (and (= inline$$TestArithmetic_g_$def$0$$t2@1 ($Integer 2)) (= (ControlFlow 0 30170) 30076)) inline$$AddU64$0$Entry_correct@@2)))
(let ((inline$$TestArithmetic_g_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 29945) 30170)) inline$$TestArithmetic_g_$def$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_g_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 30228) 30170) inline$$TestArithmetic_g_$def$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_g_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 29939) 30228) inline$$TestArithmetic_g_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 29939) 29945) inline$$TestArithmetic_g_$def$0$anon9_Else_correct)))))
(let ((inline$$TestArithmetic_g_$direct_intra$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$TestArithmetic_h_$def_verify$0$$t6@1) (>= (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) 0)) (<= (|i#$Integer| inline$$TestArithmetic_h_$def_verify$0$$t6@1) $MAX_U64)) (= (ControlFlow 0 30234) 29939)) inline$$TestArithmetic_g_$def$0$anon0_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon35_Else_correct  (=> (and (not (|b#$Boolean| b@@0)) (= (ControlFlow 0 30242) 30234)) inline$$TestArithmetic_g_$direct_intra$0$anon0_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon34_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 29707) 31137) inline$$TestArithmetic_h_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 29707) 30242) inline$$TestArithmetic_h_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon34_Then_correct  (and (=> (= (ControlFlow 0 31157) 31137) inline$$TestArithmetic_h_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 31157) 30242) inline$$TestArithmetic_h_$def_verify$0$anon35_Else_correct))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon2$1_correct  (=> (= inline$$TestArithmetic_h_$def_verify$0$$t6@1 ($Integer 3)) (and (=> (= (ControlFlow 0 29699) 31157) inline$$TestArithmetic_h_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 29699) 29707) inline$$TestArithmetic_h_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 29627) 29699)) inline$$TestArithmetic_h_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 31165) 29699) inline$$TestArithmetic_h_$def_verify$0$anon2$1_correct)))
(let ((inline$$TestArithmetic_h_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 29621) 31165) inline$$TestArithmetic_h_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 29621) 29627) inline$$TestArithmetic_h_$def_verify$0$anon33_Else_correct)))))
(let ((anon0_correct@@8  (=> (and ((_ is $Boolean) b@@0) (= (ControlFlow 0 29064) 29621)) inline$$TestArithmetic_h_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 46165) 29064) anon0_correct@@8)))
PreconditionGeneratedEntry_correct@@7))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun inline$$TestArithmetic_multiple_ops_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun x@@14 () T@$Value)
(declare-fun y@@3 () T@$Value)
(declare-fun z () T@$Value)
(declare-fun inline$$TestArithmetic_multiple_ops_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun inline$$AddU64$0$dst@2@@3 () T@$Value)
(declare-fun inline$$AddU64$0$dst@0@@3 () T@$Value)
(declare-fun inline$$MulU64$0$dst@2 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@3 () T@$Value)
(declare-fun inline$$MulU64$0$dst@0 () T@$Value)
(declare-fun inline$$MulU64$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 47301) (let ((anon0$2_correct@@9  (=> (= (ControlFlow 0 32377) (- 0 47797)) (=> (not $abort_flag@2@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$TestArithmetic_multiple_ops_$def_verify$0$$ret0@2 ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| ($Integer (* (|i#$Integer| y@@3) (|i#$Integer| z)))))))))))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$Abort_correct  (=> (and (and (= inline$$TestArithmetic_multiple_ops_$def_verify$0$$ret0@1 $Error) (= inline$$TestArithmetic_multiple_ops_$def_verify$0$$ret0@2 inline$$TestArithmetic_multiple_ops_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@1 true) (= (ControlFlow 0 32317) 32377))) anon0$2_correct@@9)))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 32335) 32317)) inline$$TestArithmetic_multiple_ops_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 32345) 32317) inline$$TestArithmetic_multiple_ops_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon20_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 32329) 32345) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 32329) 32335) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 32309) 32317)) inline$$TestArithmetic_multiple_ops_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 32325) 32317) inline$$TestArithmetic_multiple_ops_$def_verify$0$Abort_correct)))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon22_Then_correct  (=> $abort_flag@1@@7 (and (=> (= (ControlFlow 0 32303) 32325) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 32303) 32309) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon16_correct  (=> (= inline$$TestArithmetic_multiple_ops_$def_verify$0$$ret0@2 inline$$AddU64$0$dst@2@@3) (=> (and (= $abort_flag@2@@1 $abort_flag@1@@7) (= (ControlFlow 0 32291) 32377)) anon0$2_correct@@9))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 32289) 32291)) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon16_correct)))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 32299) 32291) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon16_correct)))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon22_Else_correct  (=> (not $abort_flag@1@@7) (and (=> (= (ControlFlow 0 32283) 32299) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 32283) 32289) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@3  (=> (and (= $abort_flag@1@@7 true) (= inline$$AddU64$0$dst@2@@3 inline$$AddU64$0$dst@0@@3)) (and (=> (= (ControlFlow 0 32267) 32303) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 32267) 32283) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@3  (=> (and (> (+ (|i#$Integer| x@@14) (|i#$Integer| inline$$MulU64$0$dst@2)) $MAX_U64) (= (ControlFlow 0 32265) 32267)) inline$$AddU64$0$anon3_Then$1_correct@@3)))
(let ((inline$$AddU64$0$anon3_Else_correct@@3  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| x@@14) (|i#$Integer| inline$$MulU64$0$dst@2))) (= inline$$AddU64$0$dst@1@@3 ($Integer (+ (|i#$Integer| x@@14) (|i#$Integer| inline$$MulU64$0$dst@2))))) (and (= $abort_flag@1@@7 $abort_flag@0@@9) (= inline$$AddU64$0$dst@2@@3 inline$$AddU64$0$dst@1@@3))) (and (=> (= (ControlFlow 0 32209) 32303) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 32209) 32283) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 32179) (- 0 47644)) true) (and (=> (= (ControlFlow 0 32179) 32265) inline$$AddU64$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 32179) 32209) inline$$AddU64$0$anon3_Else_correct@@3)))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@0@@9) (= (ControlFlow 0 32273) 32179)) inline$$AddU64$0$Entry_correct@@3)))
(let ((inline$$MulU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@0@@9 true) (= inline$$MulU64$0$dst@2 inline$$MulU64$0$dst@0)) (and (=> (= (ControlFlow 0 32074) 32329) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 32074) 32273) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$MulU64$0$anon3_Then_correct  (=> (and (> (* (|i#$Integer| y@@3) (|i#$Integer| z)) $MAX_U64) (= (ControlFlow 0 32072) 32074)) inline$$MulU64$0$anon3_Then$1_correct)))
(let ((inline$$MulU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (* (|i#$Integer| y@@3) (|i#$Integer| z))) (= inline$$MulU64$0$dst@1 ($Integer (* (|i#$Integer| y@@3) (|i#$Integer| z))))) (and (= $abort_flag@0@@9 false) (= inline$$MulU64$0$dst@2 inline$$MulU64$0$dst@1))) (and (=> (= (ControlFlow 0 32016) 32329) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 32016) 32273) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$MulU64$0$Entry_correct  (and (=> (= (ControlFlow 0 31986) (- 0 47557)) true) (and (=> (= (ControlFlow 0 31986) 32072) inline$$MulU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 31986) 32016) inline$$MulU64$0$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 31791) 31986)) inline$$MulU64$0$Entry_correct)))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 32353) 31986) inline$$MulU64$0$Entry_correct)))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon18_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 31783) 32353) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 31783) 31791) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon18_Then_correct  (and (=> (= (ControlFlow 0 32361) 32353) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 32361) 31791) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon19_Else_correct))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 31775) 32361) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 31775) 31783) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 32369) 32361) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 32369) 31783) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon18_Else_correct))))
(let ((inline$$TestArithmetic_multiple_ops_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 31769) 32369) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 31769) 31775) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon17_Else_correct)))))
(let ((anon0_correct@@9  (=> (and (and (and (and ((_ is $Integer) x@@14) (>= (|i#$Integer| x@@14) 0)) (<= (|i#$Integer| x@@14) $MAX_U64)) (and (and ((_ is $Integer) y@@3) (>= (|i#$Integer| y@@3) 0)) (<= (|i#$Integer| y@@3) $MAX_U64))) (and (and (and ((_ is $Integer) z) (>= (|i#$Integer| z) 0)) (<= (|i#$Integer| z) $MAX_U64)) (= (ControlFlow 0 31472) 31769))) inline$$TestArithmetic_multiple_ops_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 47301) 31472) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@8)))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun x@@15 () T@$Value)
(declare-fun y@@4 () T@$Value)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u128_add_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun inline$$AddU128$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 47837) (let ((anon0$2_correct@@10  (and (=> (= (ControlFlow 0 33081) (- 0 48178)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@15) (|i#$Integer| y@@4)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@1@@8)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@15) (|i#$Integer| y@@4)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@1@@8) (=> (= (ControlFlow 0 33081) (- 0 48207)) (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@15) (|i#$Integer| y@@4)))) (|i#$Integer| ($Integer $MAX_U128)))))))))))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u128_add_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@8 true) (= (ControlFlow 0 33049) 33081)) anon0$2_correct@@10))))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 33043) 33049)) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 33057) 33049) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@10 (and (=> (= (ControlFlow 0 33037) 33057) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 33037) 33043) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@8 $abort_flag@0@@10) (= (ControlFlow 0 33025) 33081)) anon0$2_correct@@10)))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 33023) 33025)) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 33033) 33025) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@10) (and (=> (= (ControlFlow 0 33017) 33033) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 33017) 33023) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU128$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@10 true) (and (=> (= (ControlFlow 0 33001) 33037) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 33001) 33017) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU128$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| x@@15) (|i#$Integer| y@@4)) $MAX_U128) (= (ControlFlow 0 32999) 33001)) inline$$AddU128$0$anon3_Then$1_correct)))
(let ((inline$$AddU128$0$anon3_Else_correct  (=> (>= $MAX_U128 (+ (|i#$Integer| x@@15) (|i#$Integer| y@@4))) (=> (and (= inline$$AddU128$0$dst@1 ($Integer (+ (|i#$Integer| x@@15) (|i#$Integer| y@@4)))) (= $abort_flag@0@@10 false)) (and (=> (= (ControlFlow 0 32943) 33037) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 32943) 33017) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$AddU128$0$Entry_correct  (and (=> (= (ControlFlow 0 32913) (- 0 48055)) true) (and (=> (= (ControlFlow 0 32913) 32999) inline$$AddU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 32913) 32943) inline$$AddU128$0$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 32752) 32913)) inline$$AddU128$0$Entry_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 33065) 32913) inline$$AddU128$0$Entry_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 32744) 33065) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 32744) 32752) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 33073) 33065) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 33073) 32752) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 32738) 33073) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 32738) 32744) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@10  (=> (and (and ((_ is $Integer) x@@15) (>= (|i#$Integer| x@@15) 0)) (<= (|i#$Integer| x@@15) $MAX_U128)) (=> (and (and (and ((_ is $Integer) y@@4) (>= (|i#$Integer| y@@4) 0)) (<= (|i#$Integer| y@@4) $MAX_U128)) (= (ControlFlow 0 32530) 32738)) inline$$TestArithmetic_overflow_u128_add_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (= (ControlFlow 0 47837) 32530) anon0_correct@@10)))
PreconditionGeneratedEntry_correct@@9)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@11 () Bool)
(declare-fun x@@16 () T@$Value)
(declare-fun y@@5 () T@$Value)
(declare-fun inline$$AddU128$0$dst@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 48242) (let ((anon0$2_correct@@11  (and (=> (= (ControlFlow 0 33747) (- 0 48547)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@9)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@9) (=> (= (ControlFlow 0 33747) (- 0 48556)) (=> $abort_flag@1@@9 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@9 true) (= (ControlFlow 0 33715) 33747)) anon0$2_correct@@11))))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 33709) 33715)) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 33723) 33715) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@11 (and (=> (= (ControlFlow 0 33703) 33723) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 33703) 33709) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@9 $abort_flag@0@@11) (= (ControlFlow 0 33691) 33747)) anon0$2_correct@@11)))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 33689) 33691)) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 33699) 33691) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@11) (and (=> (= (ControlFlow 0 33683) 33699) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 33683) 33689) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU128$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@0@@11 true) (and (=> (= (ControlFlow 0 33667) 33703) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 33667) 33683) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU128$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| x@@16) (|i#$Integer| y@@5)) $MAX_U128) (= (ControlFlow 0 33665) 33667)) inline$$AddU128$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU128$0$anon3_Else_correct@@0  (=> (>= $MAX_U128 (+ (|i#$Integer| x@@16) (|i#$Integer| y@@5))) (=> (and (= inline$$AddU128$0$dst@1@@0 ($Integer (+ (|i#$Integer| x@@16) (|i#$Integer| y@@5)))) (= $abort_flag@0@@11 false)) (and (=> (= (ControlFlow 0 33609) 33703) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 33609) 33683) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$AddU128$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 33579) (- 0 48424)) true) (and (=> (= (ControlFlow 0 33579) 33665) inline$$AddU128$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 33579) 33609) inline$$AddU128$0$anon3_Else_correct@@0)))))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 33418) 33579)) inline$$AddU128$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 33731) 33579) inline$$AddU128$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 33410) 33731) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 33410) 33418) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 33739) 33731) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 33739) 33418) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 33404) 33739) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 33404) 33410) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@11  (=> (and (and ((_ is $Integer) x@@16) (>= (|i#$Integer| x@@16) 0)) (<= (|i#$Integer| x@@16) $MAX_U128)) (=> (and (and (and ((_ is $Integer) y@@5) (>= (|i#$Integer| y@@5) 0)) (<= (|i#$Integer| y@@5) $MAX_U128)) (= (ControlFlow 0 33196) 33404)) inline$$TestArithmetic_overflow_u128_add_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@10  (=> (= (ControlFlow 0 48242) 33196) anon0_correct@@11)))
PreconditionGeneratedEntry_correct@@10)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@17 () T@$Value)
(declare-fun y@@6 () T@$Value)
(declare-fun $abort_flag@1@@10 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@12 () Bool)
(declare-fun inline$$MulU128$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 48571) (let ((anon0$2_correct@@12  (and (=> (= (ControlFlow 0 34413) (- 0 48912)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| x@@17) (|i#$Integer| y@@6)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@1@@10)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| x@@17) (|i#$Integer| y@@6)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@1@@10) (=> (= (ControlFlow 0 34413) (- 0 48941)) (=> $abort_flag@1@@10 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| x@@17) (|i#$Integer| y@@6)))) (|i#$Integer| ($Integer $MAX_U128)))))))))))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@10 true) (= (ControlFlow 0 34381) 34413)) anon0$2_correct@@12))))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 34375) 34381)) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 34389) 34381) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@12 (and (=> (= (ControlFlow 0 34369) 34389) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 34369) 34375) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@10 $abort_flag@0@@12) (= (ControlFlow 0 34357) 34413)) anon0$2_correct@@12)))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 34355) 34357)) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 34365) 34357) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@12) (and (=> (= (ControlFlow 0 34349) 34365) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 34349) 34355) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$MulU128$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@12 true) (and (=> (= (ControlFlow 0 34333) 34369) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 34333) 34349) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$MulU128$0$anon3_Then_correct  (=> (and (> (* (|i#$Integer| x@@17) (|i#$Integer| y@@6)) $MAX_U128) (= (ControlFlow 0 34331) 34333)) inline$$MulU128$0$anon3_Then$1_correct)))
(let ((inline$$MulU128$0$anon3_Else_correct  (=> (>= $MAX_U128 (* (|i#$Integer| x@@17) (|i#$Integer| y@@6))) (=> (and (= inline$$MulU128$0$dst@1 ($Integer (* (|i#$Integer| x@@17) (|i#$Integer| y@@6)))) (= $abort_flag@0@@12 false)) (and (=> (= (ControlFlow 0 34275) 34369) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 34275) 34349) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$MulU128$0$Entry_correct  (and (=> (= (ControlFlow 0 34245) (- 0 48789)) true) (and (=> (= (ControlFlow 0 34245) 34331) inline$$MulU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 34245) 34275) inline$$MulU128$0$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 34084) 34245)) inline$$MulU128$0$Entry_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 34397) 34245) inline$$MulU128$0$Entry_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 34076) 34397) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 34076) 34084) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 34405) 34397) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 34405) 34084) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 34070) 34405) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 34070) 34076) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@12  (=> (and (and ((_ is $Integer) x@@17) (>= (|i#$Integer| x@@17) 0)) (<= (|i#$Integer| x@@17) $MAX_U128)) (=> (and (and (and ((_ is $Integer) y@@6) (>= (|i#$Integer| y@@6) 0)) (<= (|i#$Integer| y@@6) $MAX_U128)) (= (ControlFlow 0 33862) 34070)) inline$$TestArithmetic_overflow_u128_mul_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@11  (=> (= (ControlFlow 0 48571) 33862) anon0_correct@@12)))
PreconditionGeneratedEntry_correct@@11)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@11 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@13 () Bool)
(declare-fun x@@18 () T@$Value)
(declare-fun y@@7 () T@$Value)
(declare-fun inline$$MulU128$0$dst@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 48976) (let ((anon0$2_correct@@13  (and (=> (= (ControlFlow 0 35079) (- 0 49281)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@11)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@11) (=> (= (ControlFlow 0 35079) (- 0 49290)) (=> $abort_flag@1@@11 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@11 true) (= (ControlFlow 0 35047) 35079)) anon0$2_correct@@13))))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 35041) 35047)) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 35055) 35047) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@13 (and (=> (= (ControlFlow 0 35035) 35055) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 35035) 35041) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@11 $abort_flag@0@@13) (= (ControlFlow 0 35023) 35079)) anon0$2_correct@@13)))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 35021) 35023)) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 35031) 35023) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@13) (and (=> (= (ControlFlow 0 35015) 35031) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 35015) 35021) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$MulU128$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@0@@13 true) (and (=> (= (ControlFlow 0 34999) 35035) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 34999) 35015) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$MulU128$0$anon3_Then_correct@@0  (=> (and (> (* (|i#$Integer| x@@18) (|i#$Integer| y@@7)) $MAX_U128) (= (ControlFlow 0 34997) 34999)) inline$$MulU128$0$anon3_Then$1_correct@@0)))
(let ((inline$$MulU128$0$anon3_Else_correct@@0  (=> (>= $MAX_U128 (* (|i#$Integer| x@@18) (|i#$Integer| y@@7))) (=> (and (= inline$$MulU128$0$dst@1@@0 ($Integer (* (|i#$Integer| x@@18) (|i#$Integer| y@@7)))) (= $abort_flag@0@@13 false)) (and (=> (= (ControlFlow 0 34941) 35035) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 34941) 35015) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$MulU128$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 34911) (- 0 49158)) true) (and (=> (= (ControlFlow 0 34911) 34997) inline$$MulU128$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 34911) 34941) inline$$MulU128$0$anon3_Else_correct@@0)))))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 34750) 34911)) inline$$MulU128$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 35063) 34911) inline$$MulU128$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 34742) 35063) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 34742) 34750) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 35071) 35063) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 35071) 34750) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 34736) 35071) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 34736) 34742) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@13  (=> (and (and ((_ is $Integer) x@@18) (>= (|i#$Integer| x@@18) 0)) (<= (|i#$Integer| x@@18) $MAX_U128)) (=> (and (and (and ((_ is $Integer) y@@7) (>= (|i#$Integer| y@@7) 0)) (<= (|i#$Integer| y@@7) $MAX_U128)) (= (ControlFlow 0 34528) 34736)) inline$$TestArithmetic_overflow_u128_mul_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@12  (=> (= (ControlFlow 0 48976) 34528) anon0_correct@@13)))
PreconditionGeneratedEntry_correct@@12)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@19 () T@$Value)
(declare-fun y@@8 () T@$Value)
(declare-fun $abort_flag@1@@12 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u64_add_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@14 () Bool)
(declare-fun inline$$AddU64$0$dst@1@@4 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 49305) (let ((anon0$2_correct@@14  (and (=> (= (ControlFlow 0 35745) (- 0 49646)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@19) (|i#$Integer| y@@8)))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@12)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@19) (|i#$Integer| y@@8)))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@12) (=> (= (ControlFlow 0 35745) (- 0 49675)) (=> $abort_flag@1@@12 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@19) (|i#$Integer| y@@8)))) (|i#$Integer| ($Integer $MAX_U64)))))))))))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u64_add_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@12 true) (= (ControlFlow 0 35713) 35745)) anon0$2_correct@@14))))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 35707) 35713)) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 35721) 35713) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@14 (and (=> (= (ControlFlow 0 35701) 35721) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 35701) 35707) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@12 $abort_flag@0@@14) (= (ControlFlow 0 35689) 35745)) anon0$2_correct@@14)))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 35687) 35689)) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 35697) 35689) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@14) (and (=> (= (ControlFlow 0 35681) 35697) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 35681) 35687) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@4  (=> (= $abort_flag@0@@14 true) (and (=> (= (ControlFlow 0 35665) 35701) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 35665) 35681) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@4  (=> (and (> (+ (|i#$Integer| x@@19) (|i#$Integer| y@@8)) $MAX_U64) (= (ControlFlow 0 35663) 35665)) inline$$AddU64$0$anon3_Then$1_correct@@4)))
(let ((inline$$AddU64$0$anon3_Else_correct@@4  (=> (>= $MAX_U64 (+ (|i#$Integer| x@@19) (|i#$Integer| y@@8))) (=> (and (= inline$$AddU64$0$dst@1@@4 ($Integer (+ (|i#$Integer| x@@19) (|i#$Integer| y@@8)))) (= $abort_flag@0@@14 false)) (and (=> (= (ControlFlow 0 35607) 35701) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 35607) 35681) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 35577) (- 0 49523)) true) (and (=> (= (ControlFlow 0 35577) 35663) inline$$AddU64$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 35577) 35607) inline$$AddU64$0$anon3_Else_correct@@4)))))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 35416) 35577)) inline$$AddU64$0$Entry_correct@@4)))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 35729) 35577) inline$$AddU64$0$Entry_correct@@4)))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 35408) 35729) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 35408) 35416) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 35737) 35729) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 35737) 35416) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 35402) 35737) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 35402) 35408) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@14  (=> (and (and ((_ is $Integer) x@@19) (>= (|i#$Integer| x@@19) 0)) (<= (|i#$Integer| x@@19) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@8) (>= (|i#$Integer| y@@8) 0)) (<= (|i#$Integer| y@@8) $MAX_U64)) (= (ControlFlow 0 35194) 35402)) inline$$TestArithmetic_overflow_u64_add_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@13  (=> (= (ControlFlow 0 49305) 35194) anon0_correct@@14)))
PreconditionGeneratedEntry_correct@@13)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@13 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@15 () Bool)
(declare-fun x@@20 () T@$Value)
(declare-fun y@@9 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@5 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 49710) (let ((anon0$2_correct@@15  (and (=> (= (ControlFlow 0 36411) (- 0 50015)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@13)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@13) (=> (= (ControlFlow 0 36411) (- 0 50024)) (=> $abort_flag@1@@13 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@13 true) (= (ControlFlow 0 36379) 36411)) anon0$2_correct@@15))))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 36373) 36379)) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 36387) 36379) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@15 (and (=> (= (ControlFlow 0 36367) 36387) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 36367) 36373) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@13 $abort_flag@0@@15) (= (ControlFlow 0 36355) 36411)) anon0$2_correct@@15)))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 36353) 36355)) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 36363) 36355) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@15) (and (=> (= (ControlFlow 0 36347) 36363) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 36347) 36353) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@5  (=> (= $abort_flag@0@@15 true) (and (=> (= (ControlFlow 0 36331) 36367) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 36331) 36347) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct@@5  (=> (and (> (+ (|i#$Integer| x@@20) (|i#$Integer| y@@9)) $MAX_U64) (= (ControlFlow 0 36329) 36331)) inline$$AddU64$0$anon3_Then$1_correct@@5)))
(let ((inline$$AddU64$0$anon3_Else_correct@@5  (=> (>= $MAX_U64 (+ (|i#$Integer| x@@20) (|i#$Integer| y@@9))) (=> (and (= inline$$AddU64$0$dst@1@@5 ($Integer (+ (|i#$Integer| x@@20) (|i#$Integer| y@@9)))) (= $abort_flag@0@@15 false)) (and (=> (= (ControlFlow 0 36273) 36367) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 36273) 36347) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct@@5  (and (=> (= (ControlFlow 0 36243) (- 0 49892)) true) (and (=> (= (ControlFlow 0 36243) 36329) inline$$AddU64$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 36243) 36273) inline$$AddU64$0$anon3_Else_correct@@5)))))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 36082) 36243)) inline$$AddU64$0$Entry_correct@@5)))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 36395) 36243) inline$$AddU64$0$Entry_correct@@5)))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 36074) 36395) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 36074) 36082) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 36403) 36395) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 36403) 36082) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 36068) 36403) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 36068) 36074) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@15  (=> (and (and ((_ is $Integer) x@@20) (>= (|i#$Integer| x@@20) 0)) (<= (|i#$Integer| x@@20) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@9) (>= (|i#$Integer| y@@9) 0)) (<= (|i#$Integer| y@@9) $MAX_U64)) (= (ControlFlow 0 35860) 36068)) inline$$TestArithmetic_overflow_u64_add_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@14  (=> (= (ControlFlow 0 49710) 35860) anon0_correct@@15)))
PreconditionGeneratedEntry_correct@@14)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@21 () T@$Value)
(declare-fun y@@10 () T@$Value)
(declare-fun $abort_flag@1@@14 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@16 () Bool)
(declare-fun inline$$MulU64$0$dst@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 50039) (let ((anon0$2_correct@@16  (and (=> (= (ControlFlow 0 37077) (- 0 50380)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| x@@21) (|i#$Integer| y@@10)))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@14)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| x@@21) (|i#$Integer| y@@10)))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@14) (=> (= (ControlFlow 0 37077) (- 0 50409)) (=> $abort_flag@1@@14 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| x@@21) (|i#$Integer| y@@10)))) (|i#$Integer| ($Integer $MAX_U64)))))))))))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@14 true) (= (ControlFlow 0 37045) 37077)) anon0$2_correct@@16))))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 37039) 37045)) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 37053) 37045) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@16 (and (=> (= (ControlFlow 0 37033) 37053) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 37033) 37039) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@14 $abort_flag@0@@16) (= (ControlFlow 0 37021) 37077)) anon0$2_correct@@16)))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 37019) 37021)) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 37029) 37021) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@16) (and (=> (= (ControlFlow 0 37013) 37029) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 37013) 37019) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$MulU64$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@0@@16 true) (and (=> (= (ControlFlow 0 36997) 37033) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 36997) 37013) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$MulU64$0$anon3_Then_correct@@0  (=> (and (> (* (|i#$Integer| x@@21) (|i#$Integer| y@@10)) $MAX_U64) (= (ControlFlow 0 36995) 36997)) inline$$MulU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$MulU64$0$anon3_Else_correct@@0  (=> (>= $MAX_U64 (* (|i#$Integer| x@@21) (|i#$Integer| y@@10))) (=> (and (= inline$$MulU64$0$dst@1@@0 ($Integer (* (|i#$Integer| x@@21) (|i#$Integer| y@@10)))) (= $abort_flag@0@@16 false)) (and (=> (= (ControlFlow 0 36939) 37033) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 36939) 37013) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$MulU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 36909) (- 0 50257)) true) (and (=> (= (ControlFlow 0 36909) 36995) inline$$MulU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 36909) 36939) inline$$MulU64$0$anon3_Else_correct@@0)))))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 36748) 36909)) inline$$MulU64$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 37061) 36909) inline$$MulU64$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 36740) 37061) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 36740) 36748) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 37069) 37061) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 37069) 36748) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 36734) 37069) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 36734) 36740) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@16  (=> (and (and ((_ is $Integer) x@@21) (>= (|i#$Integer| x@@21) 0)) (<= (|i#$Integer| x@@21) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@10) (>= (|i#$Integer| y@@10) 0)) (<= (|i#$Integer| y@@10) $MAX_U64)) (= (ControlFlow 0 36526) 36734)) inline$$TestArithmetic_overflow_u64_mul_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@15  (=> (= (ControlFlow 0 50039) 36526) anon0_correct@@16)))
PreconditionGeneratedEntry_correct@@15)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@15 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@17 () Bool)
(declare-fun x@@22 () T@$Value)
(declare-fun y@@11 () T@$Value)
(declare-fun inline$$MulU64$0$dst@1@@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 50444) (let ((anon0$2_correct@@17  (and (=> (= (ControlFlow 0 37743) (- 0 50749)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@15)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@15) (=> (= (ControlFlow 0 37743) (- 0 50758)) (=> $abort_flag@1@@15 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@15 true) (= (ControlFlow 0 37711) 37743)) anon0$2_correct@@17))))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 37705) 37711)) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 37719) 37711) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@17 (and (=> (= (ControlFlow 0 37699) 37719) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 37699) 37705) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@15 $abort_flag@0@@17) (= (ControlFlow 0 37687) 37743)) anon0$2_correct@@17)))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 37685) 37687)) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 37695) 37687) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@17) (and (=> (= (ControlFlow 0 37679) 37695) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 37679) 37685) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$MulU64$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@0@@17 true) (and (=> (= (ControlFlow 0 37663) 37699) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 37663) 37679) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$MulU64$0$anon3_Then_correct@@1  (=> (and (> (* (|i#$Integer| x@@22) (|i#$Integer| y@@11)) $MAX_U64) (= (ControlFlow 0 37661) 37663)) inline$$MulU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$MulU64$0$anon3_Else_correct@@1  (=> (>= $MAX_U64 (* (|i#$Integer| x@@22) (|i#$Integer| y@@11))) (=> (and (= inline$$MulU64$0$dst@1@@1 ($Integer (* (|i#$Integer| x@@22) (|i#$Integer| y@@11)))) (= $abort_flag@0@@17 false)) (and (=> (= (ControlFlow 0 37605) 37699) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 37605) 37679) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$MulU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 37575) (- 0 50626)) true) (and (=> (= (ControlFlow 0 37575) 37661) inline$$MulU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 37575) 37605) inline$$MulU64$0$anon3_Else_correct@@1)))))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 37414) 37575)) inline$$MulU64$0$Entry_correct@@1)))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 37727) 37575) inline$$MulU64$0$Entry_correct@@1)))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 37406) 37727) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 37406) 37414) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 37735) 37727) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 37735) 37414) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 37400) 37735) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 37400) 37406) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@17  (=> (and (and ((_ is $Integer) x@@22) (>= (|i#$Integer| x@@22) 0)) (<= (|i#$Integer| x@@22) $MAX_U64)) (=> (and (and (and ((_ is $Integer) y@@11) (>= (|i#$Integer| y@@11) 0)) (<= (|i#$Integer| y@@11) $MAX_U64)) (= (ControlFlow 0 37192) 37400)) inline$$TestArithmetic_overflow_u64_mul_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@16  (=> (= (ControlFlow 0 50444) 37192) anon0_correct@@17)))
PreconditionGeneratedEntry_correct@@16)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@23 () T@$Value)
(declare-fun y@@12 () T@$Value)
(declare-fun $abort_flag@1@@16 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u8_add_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@18 () Bool)
(declare-fun inline$$AddU8$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 50773) (let ((anon0$2_correct@@18  (and (=> (= (ControlFlow 0 38409) (- 0 51114)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@23) (|i#$Integer| y@@12)))) (|i#$Integer| ($Integer $MAX_U8))))) $abort_flag@1@@16)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@23) (|i#$Integer| y@@12)))) (|i#$Integer| ($Integer $MAX_U8))))) $abort_flag@1@@16) (=> (= (ControlFlow 0 38409) (- 0 51143)) (=> $abort_flag@1@@16 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| x@@23) (|i#$Integer| y@@12)))) (|i#$Integer| ($Integer $MAX_U8)))))))))))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u8_add_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@16 true) (= (ControlFlow 0 38377) 38409)) anon0$2_correct@@18))))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 38371) 38377)) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 38385) 38377) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@18 (and (=> (= (ControlFlow 0 38365) 38385) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 38365) 38371) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@16 $abort_flag@0@@18) (= (ControlFlow 0 38353) 38409)) anon0$2_correct@@18)))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 38351) 38353)) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 38361) 38353) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@18) (and (=> (= (ControlFlow 0 38345) 38361) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 38345) 38351) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU8$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@18 true) (and (=> (= (ControlFlow 0 38329) 38365) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 38329) 38345) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU8$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| x@@23) (|i#$Integer| y@@12)) $MAX_U8) (= (ControlFlow 0 38327) 38329)) inline$$AddU8$0$anon3_Then$1_correct)))
(let ((inline$$AddU8$0$anon3_Else_correct  (=> (>= $MAX_U8 (+ (|i#$Integer| x@@23) (|i#$Integer| y@@12))) (=> (and (= inline$$AddU8$0$dst@1 ($Integer (+ (|i#$Integer| x@@23) (|i#$Integer| y@@12)))) (= $abort_flag@0@@18 false)) (and (=> (= (ControlFlow 0 38271) 38365) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 38271) 38345) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$AddU8$0$Entry_correct  (and (=> (= (ControlFlow 0 38241) (- 0 50991)) true) (and (=> (= (ControlFlow 0 38241) 38327) inline$$AddU8$0$anon3_Then_correct) (=> (= (ControlFlow 0 38241) 38271) inline$$AddU8$0$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 38080) 38241)) inline$$AddU8$0$Entry_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 38393) 38241) inline$$AddU8$0$Entry_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 38072) 38393) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38072) 38080) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 38401) 38393) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38401) 38080) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 38066) 38401) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 38066) 38072) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@18  (=> (and (and ((_ is $Integer) x@@23) (>= (|i#$Integer| x@@23) 0)) (<= (|i#$Integer| x@@23) $MAX_U8)) (=> (and (and (and ((_ is $Integer) y@@12) (>= (|i#$Integer| y@@12) 0)) (<= (|i#$Integer| y@@12) $MAX_U8)) (= (ControlFlow 0 37858) 38066)) inline$$TestArithmetic_overflow_u8_add_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@17  (=> (= (ControlFlow 0 50773) 37858) anon0_correct@@18)))
PreconditionGeneratedEntry_correct@@17)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@17 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@19 () Bool)
(declare-fun x@@24 () T@$Value)
(declare-fun y@@13 () T@$Value)
(declare-fun inline$$AddU8$0$dst@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 51178) (let ((anon0$2_correct@@19  (and (=> (= (ControlFlow 0 39075) (- 0 51483)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@17)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@17) (=> (= (ControlFlow 0 39075) (- 0 51492)) (=> $abort_flag@1@@17 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@17 true) (= (ControlFlow 0 39043) 39075)) anon0$2_correct@@19))))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 39037) 39043)) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 39051) 39043) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@19 (and (=> (= (ControlFlow 0 39031) 39051) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 39031) 39037) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@17 $abort_flag@0@@19) (= (ControlFlow 0 39019) 39075)) anon0$2_correct@@19)))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 39017) 39019)) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 39027) 39019) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@19) (and (=> (= (ControlFlow 0 39011) 39027) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 39011) 39017) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$AddU8$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@0@@19 true) (and (=> (= (ControlFlow 0 38995) 39031) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 38995) 39011) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$AddU8$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| x@@24) (|i#$Integer| y@@13)) $MAX_U8) (= (ControlFlow 0 38993) 38995)) inline$$AddU8$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU8$0$anon3_Else_correct@@0  (=> (>= $MAX_U8 (+ (|i#$Integer| x@@24) (|i#$Integer| y@@13))) (=> (and (= inline$$AddU8$0$dst@1@@0 ($Integer (+ (|i#$Integer| x@@24) (|i#$Integer| y@@13)))) (= $abort_flag@0@@19 false)) (and (=> (= (ControlFlow 0 38937) 39031) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 38937) 39011) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$AddU8$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 38907) (- 0 51360)) true) (and (=> (= (ControlFlow 0 38907) 38993) inline$$AddU8$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 38907) 38937) inline$$AddU8$0$anon3_Else_correct@@0)))))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 38746) 38907)) inline$$AddU8$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 39059) 38907) inline$$AddU8$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 38738) 39059) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 38738) 38746) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 39067) 39059) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 39067) 38746) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 38732) 39067) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 38732) 38738) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@19  (=> (and (and ((_ is $Integer) x@@24) (>= (|i#$Integer| x@@24) 0)) (<= (|i#$Integer| x@@24) $MAX_U8)) (=> (and (and (and ((_ is $Integer) y@@13) (>= (|i#$Integer| y@@13) 0)) (<= (|i#$Integer| y@@13) $MAX_U8)) (= (ControlFlow 0 38524) 38732)) inline$$TestArithmetic_overflow_u8_add_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@18  (=> (= (ControlFlow 0 51178) 38524) anon0_correct@@19)))
PreconditionGeneratedEntry_correct@@18)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun x@@25 () T@$Value)
(declare-fun y@@14 () T@$Value)
(declare-fun $abort_flag@1@@18 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@20 () Bool)
(declare-fun inline$$MulU8$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 51507) (let ((anon0$2_correct@@20  (and (=> (= (ControlFlow 0 39741) (- 0 51848)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| x@@25) (|i#$Integer| y@@14)))) (|i#$Integer| ($Integer $MAX_U8))))) $abort_flag@1@@18)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| x@@25) (|i#$Integer| y@@14)))) (|i#$Integer| ($Integer $MAX_U8))))) $abort_flag@1@@18) (=> (= (ControlFlow 0 39741) (- 0 51877)) (=> $abort_flag@1@@18 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (* (|i#$Integer| x@@25) (|i#$Integer| y@@14)))) (|i#$Integer| ($Integer $MAX_U8)))))))))))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@18 true) (= (ControlFlow 0 39709) 39741)) anon0$2_correct@@20))))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 39703) 39709)) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 39717) 39709) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@20 (and (=> (= (ControlFlow 0 39697) 39717) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 39697) 39703) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@18 $abort_flag@0@@20) (= (ControlFlow 0 39685) 39741)) anon0$2_correct@@20)))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 39683) 39685)) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 39693) 39685) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@20) (and (=> (= (ControlFlow 0 39677) 39693) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 39677) 39683) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$MulU8$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@20 true) (and (=> (= (ControlFlow 0 39661) 39697) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 39661) 39677) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$MulU8$0$anon3_Then_correct  (=> (and (> (* (|i#$Integer| x@@25) (|i#$Integer| y@@14)) $MAX_U8) (= (ControlFlow 0 39659) 39661)) inline$$MulU8$0$anon3_Then$1_correct)))
(let ((inline$$MulU8$0$anon3_Else_correct  (=> (>= $MAX_U8 (* (|i#$Integer| x@@25) (|i#$Integer| y@@14))) (=> (and (= inline$$MulU8$0$dst@1 ($Integer (* (|i#$Integer| x@@25) (|i#$Integer| y@@14)))) (= $abort_flag@0@@20 false)) (and (=> (= (ControlFlow 0 39603) 39697) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 39603) 39677) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$MulU8$0$Entry_correct  (and (=> (= (ControlFlow 0 39573) (- 0 51725)) true) (and (=> (= (ControlFlow 0 39573) 39659) inline$$MulU8$0$anon3_Then_correct) (=> (= (ControlFlow 0 39573) 39603) inline$$MulU8$0$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 39412) 39573)) inline$$MulU8$0$Entry_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 39725) 39573) inline$$MulU8$0$Entry_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 39404) 39725) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 39404) 39412) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 39733) 39725) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 39733) 39412) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 39398) 39733) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 39398) 39404) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@20  (=> (and (and ((_ is $Integer) x@@25) (>= (|i#$Integer| x@@25) 0)) (<= (|i#$Integer| x@@25) $MAX_U8)) (=> (and (and (and ((_ is $Integer) y@@14) (>= (|i#$Integer| y@@14) 0)) (<= (|i#$Integer| y@@14) $MAX_U8)) (= (ControlFlow 0 39190) 39398)) inline$$TestArithmetic_overflow_u8_mul_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@19  (=> (= (ControlFlow 0 51507) 39190) anon0_correct@@20)))
PreconditionGeneratedEntry_correct@@19)))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@19 () Bool)
(declare-fun inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@21 () Bool)
(declare-fun x@@26 () T@$Value)
(declare-fun y@@15 () T@$Value)
(declare-fun inline$$MulU8$0$dst@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 51912) (let ((anon0$2_correct@@21  (and (=> (= (ControlFlow 0 40407) (- 0 52217)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@19)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@19) (=> (= (ControlFlow 0 40407) (- 0 52226)) (=> $abort_flag@1@@19 (|b#$Boolean| ($Boolean false))))))))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon7_correct  (=> (= inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@19 true) (= (ControlFlow 0 40375) 40407)) anon0$2_correct@@21))))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 40369) 40375)) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 40383) 40375) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon7_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@21 (and (=> (= (ControlFlow 0 40363) 40383) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 40363) 40369) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@19 $abort_flag@0@@21) (= (ControlFlow 0 40351) 40407)) anon0$2_correct@@21)))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 40349) 40351)) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 40359) 40351) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon10_correct)))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@21) (and (=> (= (ControlFlow 0 40343) 40359) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 40343) 40349) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$MulU8$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@0@@21 true) (and (=> (= (ControlFlow 0 40327) 40363) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 40327) 40343) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$MulU8$0$anon3_Then_correct@@0  (=> (and (> (* (|i#$Integer| x@@26) (|i#$Integer| y@@15)) $MAX_U8) (= (ControlFlow 0 40325) 40327)) inline$$MulU8$0$anon3_Then$1_correct@@0)))
(let ((inline$$MulU8$0$anon3_Else_correct@@0  (=> (>= $MAX_U8 (* (|i#$Integer| x@@26) (|i#$Integer| y@@15))) (=> (and (= inline$$MulU8$0$dst@1@@0 ($Integer (* (|i#$Integer| x@@26) (|i#$Integer| y@@15)))) (= $abort_flag@0@@21 false)) (and (=> (= (ControlFlow 0 40269) 40363) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 40269) 40343) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$MulU8$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 40239) (- 0 52094)) true) (and (=> (= (ControlFlow 0 40239) 40325) inline$$MulU8$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 40239) 40269) inline$$MulU8$0$anon3_Else_correct@@0)))))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 40078) 40239)) inline$$MulU8$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 40391) 40239) inline$$MulU8$0$Entry_correct@@0)))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 40070) 40391) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 40070) 40078) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 40399) 40391) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 40399) 40078) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon12_Else_correct))))
(let ((inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 40064) 40399) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 40064) 40070) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon11_Else_correct)))))
(let ((anon0_correct@@21  (=> (and (and ((_ is $Integer) x@@26) (>= (|i#$Integer| x@@26) 0)) (<= (|i#$Integer| x@@26) $MAX_U8)) (=> (and (and (and ((_ is $Integer) y@@15) (>= (|i#$Integer| y@@15) 0)) (<= (|i#$Integer| y@@15) $MAX_U8)) (= (ControlFlow 0 39856) 40064)) inline$$TestArithmetic_overflow_u8_mul_incorrect_$def_verify$0$anon0_correct))))
(let ((PreconditionGeneratedEntry_correct@@20  (=> (= (ControlFlow 0 51912) 39856) anon0_correct@@21)))
PreconditionGeneratedEntry_correct@@20)))))))))))))))))))))
))
(set-info :status unknown)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@20 () Bool)
(declare-fun inline$$TestArithmetic_underflow_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@22 () Bool)
(declare-fun inline$$TestArithmetic_underflow_$def_verify$0$$t1@1 () T@$Value)
(declare-fun inline$$TestArithmetic_underflow_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 52239) (let ((anon0$2_correct@@22  (and (=> (= (ControlFlow 0 40899) (- 0 52486)) (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@20)) (=> (=> (|b#$Boolean| ($Boolean true)) $abort_flag@1@@20) (=> (= (ControlFlow 0 40899) (- 0 52495)) (=> $abort_flag@1@@20 (|b#$Boolean| ($Boolean true))))))))
(let ((inline$$TestArithmetic_underflow_$def_verify$0$anon3_correct  (=> (= inline$$TestArithmetic_underflow_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@20 true) (= (ControlFlow 0 40883) 40899)) anon0$2_correct@@22))))
(let ((inline$$TestArithmetic_underflow_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 40877) 40883)) inline$$TestArithmetic_underflow_$def_verify$0$anon3_correct)))
(let ((inline$$TestArithmetic_underflow_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 40891) 40883) inline$$TestArithmetic_underflow_$def_verify$0$anon3_correct)))
(let ((inline$$TestArithmetic_underflow_$def_verify$0$anon7_Then_correct  (=> $abort_flag@0@@22 (and (=> (= (ControlFlow 0 40871) 40891) inline$$TestArithmetic_underflow_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 40871) 40877) inline$$TestArithmetic_underflow_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$TestArithmetic_underflow_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@1@@20 $abort_flag@0@@22) (= (ControlFlow 0 40859) 40899)) anon0$2_correct@@22)))
(let ((inline$$TestArithmetic_underflow_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 40857) 40859)) inline$$TestArithmetic_underflow_$def_verify$0$anon6_correct)))
(let ((inline$$TestArithmetic_underflow_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 40867) 40859) inline$$TestArithmetic_underflow_$def_verify$0$anon6_correct)))
(let ((inline$$TestArithmetic_underflow_$def_verify$0$anon7_Else_correct  (=> (not $abort_flag@0@@22) (and (=> (= (ControlFlow 0 40851) 40867) inline$$TestArithmetic_underflow_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 40851) 40857) inline$$TestArithmetic_underflow_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (= $abort_flag@0@@22 true) (and (=> (= (ControlFlow 0 40835) 40871) inline$$TestArithmetic_underflow_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 40835) 40851) inline$$TestArithmetic_underflow_$def_verify$0$anon7_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$TestArithmetic_underflow_$def_verify$0$$t1@1) (|i#$Integer| inline$$TestArithmetic_underflow_$def_verify$0$$t2@1)) (= (ControlFlow 0 40833) 40835)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (<= (|i#$Integer| inline$$TestArithmetic_underflow_$def_verify$0$$t2@1) (|i#$Integer| inline$$TestArithmetic_underflow_$def_verify$0$$t1@1)) (=> (and (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$TestArithmetic_underflow_$def_verify$0$$t1@1) (|i#$Integer| inline$$TestArithmetic_underflow_$def_verify$0$$t2@1)))) (= $abort_flag@0@@22 false)) (and (=> (= (ControlFlow 0 40781) 40871) inline$$TestArithmetic_underflow_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 40781) 40851) inline$$TestArithmetic_underflow_$def_verify$0$anon7_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 40755) (- 0 52371)) true) (and (=> (= (ControlFlow 0 40755) 40833) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 40755) 40781) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$TestArithmetic_underflow_$def_verify$0$anon0_correct  (=> (and (and (not false) (= inline$$TestArithmetic_underflow_$def_verify$0$$t1@1 ($Integer 0))) (and (= inline$$TestArithmetic_underflow_$def_verify$0$$t2@1 ($Integer 1)) (= (ControlFlow 0 40841) 40755))) inline$$Sub$0$Entry_correct)))
(let ((anon0_correct@@22  (=> (= (ControlFlow 0 52239) 40841) inline$$TestArithmetic_underflow_$def_verify$0$anon0_correct)))
anon0_correct@@22))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
