(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $FixedPoint32_FixedPoint32 $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $XDX_XDX $XDX_Reserve $TransactionFee_TransactionFee)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@0) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@0))
)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0@@1) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($Event_EventHandle_type_value $tv0@@1))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@9) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@9))
)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $abort_flag@39 () Bool)
(declare-fun $abort_flag@40 () Bool)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@33 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$TransactionFee_burn_fees_$def$0$$t12@1 () T@$Value)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_flag@38 () Bool)
(declare-fun $abort_flag@34 () Bool)
(declare-fun $abort_flag@35 () Bool)
(declare-fun $abort_flag@36 () Bool)
(declare-fun $abort_flag@37 () Bool)
(declare-fun $Diem_BurnCapability_$memory@1 () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$Diem_remove_burn_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun tc_account () T@$Value)
(declare-fun $tv0@@10 () T@$TypeValue)
(declare-fun inline$$Not$2$dst@1 () T@$Value)
(declare-fun $abort_code@32 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@6 () T@$Memory)
(declare-fun $abort_code@29 () Int)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun $abort_code@28 () Int)
(declare-fun $abort_flag@33 () Bool)
(declare-fun inline$$WritebackToGlobal$5$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$5$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$5$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$5$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$8$dst'@2| () T@$Mutation)
(declare-fun $TransactionFee_TransactionFee_$memory () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$5$m'@1| () T@$Memory)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$10$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$8$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$8$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$8$dst'@1| () T@$Mutation)
(declare-fun inline$$TransactionFee_burn_fees_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$Diem_burn_now_$def$0$$ret0@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@2| () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@4 () T@$Memory)
(declare-fun $abort_flag@32 () Bool)
(declare-fun |inline$$WriteRef$9$to'@1| () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$2$vdst'@1| () T@$Value)
(declare-fun |inline$$WriteRef$4$to'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_burn_now_$def$0$$ret0@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@5 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@2 () T@$Memory)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun $abort_flag@31 () Bool)
(declare-fun |inline$$WritebackToGlobal$4$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$4$l@1 () T@$Location)
(declare-fun $Diem_CurrencyInfo_$memory@1 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$4$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$4$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$4$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$7$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$4$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$6$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$8$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$7$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$7$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$7$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$BorrowField$18$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$17$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$3$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$3$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$3$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$3$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$3$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$3$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0 () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@3 () T@$Memory)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $abort_flag@22 () Bool)
(declare-fun $abort_flag@23 () Bool)
(declare-fun $abort_flag@24 () Bool)
(declare-fun $abort_flag@25 () Bool)
(declare-fun $abort_flag@26 () Bool)
(declare-fun $abort_flag@27 () Bool)
(declare-fun $abort_flag@28 () Bool)
(declare-fun $abort_flag@29 () Bool)
(declare-fun $abort_flag@30 () Bool)
(declare-fun inline$$Event_emit_event$1$t@0 () T@$TypeValue)
(declare-fun inline$$Diem_Diem_unpack$0$value@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$Diem_BurnEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$18$p@1 () T@$Path)
(declare-fun inline$$BorrowField$18$size@1 () Int)
(declare-fun inline$$BorrowField$18$p@2 () T@$Path)
(declare-fun inline$$ReadRef$16$v@1 () T@$Value)
(declare-fun inline$$BorrowField$17$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$17$p@1 () T@$Path)
(declare-fun inline$$BorrowField$17$size@1 () Int)
(declare-fun inline$$BorrowField$17$p@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$5$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$7$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$6$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$6$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$6$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$16$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$2$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$16$p@1 () T@$Path)
(declare-fun inline$$BorrowField$16$size@1 () Int)
(declare-fun inline$$BorrowField$16$p@2 () T@$Path)
(declare-fun inline$$Sub$2$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$15$v@1 () T@$Value)
(declare-fun inline$$Sub$2$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$15$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$15$p@1 () T@$Path)
(declare-fun inline$$BorrowField$15$size@1 () Int)
(declare-fun inline$$BorrowField$15$p@2 () T@$Path)
(declare-fun inline$$Ge$2$dst@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@2| () T@$Memory)
(declare-fun $abort_code@27 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$WritebackToGlobal$2$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t36@1 () T@$Value)
(declare-fun inline$$ReadRef$14$v@1 () T@$Value)
(declare-fun inline$$BorrowField$14$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$14$p@1 () T@$Path)
(declare-fun inline$$BorrowField$14$size@1 () Int)
(declare-fun inline$$BorrowField$14$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$2$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$6$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$5$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$5$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$5$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$13$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$1$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$13$p@1 () T@$Path)
(declare-fun inline$$BorrowField$13$size@1 () Int)
(declare-fun inline$$BorrowField$13$p@2 () T@$Path)
(declare-fun inline$$Sub$1$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$13$v@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0 () T@$Value)
(declare-fun inline$$BorrowField$12$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$12$p@1 () T@$Path)
(declare-fun inline$$BorrowField$12$size@1 () Int)
(declare-fun inline$$BorrowField$12$p@2 () T@$Path)
(declare-fun inline$$Ge$1$dst@1 () T@$Value)
(declare-fun $abort_code@25 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t28@1 () T@$Value)
(declare-fun inline$$ReadRef$12$v@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@0 () T@$Value)
(declare-fun inline$$BorrowField$11$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$11$p@1 () T@$Path)
(declare-fun inline$$BorrowField$11$size@1 () Int)
(declare-fun inline$$BorrowField$11$p@2 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$2$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$2$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$2$a@1 () Int)
(declare-fun inline$$BorrowGlobal$2$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun $abort_code@23 () Int)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$4$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$9$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$5$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$4$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$4$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$4$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$10$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0 () T@$Value)
(declare-fun inline$$ReadRef$11$v@1 () T@$Value)
(declare-fun inline$$BorrowField$10$p@1 () T@$Path)
(declare-fun inline$$BorrowField$10$size@1 () Int)
(declare-fun inline$$BorrowField$10$p@2 () T@$Path)
(declare-fun inline$$Gt$1$dst@1 () T@$Value)
(declare-fun $abort_code@21 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t19@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$3$dst@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t17@1 () T@$Value)
(declare-fun inline$$ReadRef$10$v@1 () T@$Value)
(declare-fun inline$$BorrowField$9$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$9$p@1 () T@$Path)
(declare-fun inline$$BorrowField$9$size@1 () Int)
(declare-fun inline$$BorrowField$9$p@2 () T@$Path)
(declare-fun $abort_code@19 () Int)
(declare-fun $abort_flag@20 () Bool)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun $abort_flag@19 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$8$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$8$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_flag@14 () Bool)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $abort_flag@18 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$Diem_PreburnEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$8$p@1 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1 () Int)
(declare-fun inline$$BorrowField$8$p@2 () T@$Path)
(declare-fun inline$$ReadRef$7$v@1 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$7$p@1 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1 () Int)
(declare-fun inline$$BorrowField$7$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$6$p@1 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1 () Int)
(declare-fun inline$$BorrowField$6$p@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$6$v@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1 () Int)
(declare-fun inline$$BorrowField$5$p@2 () T@$Path)
(declare-fun inline$$Ge$0$dst@1 () T@$Value)
(declare-fun $abort_code@18 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t27@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t23@1 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun $abort_code@16 () Int)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_code@15 () Int)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t17@1 () T@$Value)
(declare-fun $abort_code@14 () Int)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t18@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$Gt$0$dst@1 () T@$Value)
(declare-fun $abort_code@12 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$Diem_burn_now_$def$0$$t14@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_burn_now_$def$0$$t12@1 () T@$Value)
(declare-fun $abort_flag@11 () Bool)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun |inline$$MoveFrom$0$m'@2| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@2 () T@$Value)
(declare-fun $abort_flag@10 () Bool)
(declare-fun inline$$Diem_remove_burn_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $Diem_BurnCapability_$memory@0 () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_flag@9 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveFrom$0$dst@0 () T@$Value)
(declare-fun inline$$MoveFrom$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveFrom$0$a@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1| () T@$Memory)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$Diem_remove_burn_capability_$def$0$$t5@1 () T@$Value)
(declare-fun $abort_code@10 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$Diem_remove_burn_capability_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$TransactionFee_burn_fees_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun $abort_code@5 () Int)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@4 () Int)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun $abort_flag@2 () Bool)
(declare-fun inline$$TransactionFee_burn_fees_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@2 () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_code@1 () Int)
(declare-fun $Diem_Diem_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(declare-fun $XDX_Reserve_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 152011) (let ((inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon6_Else_correct true))
(let ((inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon6_Then_correct true))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon81_Else_correct  (=> (and (not $abort_flag@39) (= $abort_flag@40 $abort_flag@39)) (and (=> (= (ControlFlow 0 147773) 148029) inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 147773) 148023) inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$Abort_correct  (=> (= $abort_flag@40 true) (and (=> (= (ControlFlow 0 127991) 148029) inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 127991) 148023) inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 147987) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 147997) 127991) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon56_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 147981) 147997) inline$$TransactionFee_burn_fees_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 147981) 147987) inline$$TransactionFee_burn_fees_$def$0$anon57_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 147967) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon59_Then_correct  (=> (= (ControlFlow 0 147977) 127991) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon58_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 147961) 147977) inline$$TransactionFee_burn_fees_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 147961) 147967) inline$$TransactionFee_burn_fees_$def$0$anon59_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 147943) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon62_Then_correct  (=> (= (ControlFlow 0 147953) 127991) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon61_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 147937) 147953) inline$$TransactionFee_burn_fees_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 147937) 147943) inline$$TransactionFee_burn_fees_$def$0$anon62_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 147919) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon67_Then_correct  (=> (= (ControlFlow 0 147929) 127991) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon66_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 147913) 147929) inline$$TransactionFee_burn_fees_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 147913) 147919) inline$$TransactionFee_burn_fees_$def$0$anon67_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 147899) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon70_Then_correct  (=> (= (ControlFlow 0 147909) 127991) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon69_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 147893) 147909) inline$$TransactionFee_burn_fees_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 147893) 147899) inline$$TransactionFee_burn_fees_$def$0$anon70_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 147879) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon71_Then_correct  (=> (= (ControlFlow 0 147889) 127991) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon69_Else_correct  (=> (and (not $abort_flag@5) (= $abort_code@33 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 147873) 147889) inline$$TransactionFee_burn_fees_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 147873) 147879) inline$$TransactionFee_burn_fees_$def$0$anon71_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon68_Then_correct  (=> (|b#$Boolean| call3formal@$ret0@0@@0) (=> (and (and (and (= inline$$TransactionFee_burn_fees_$def$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5)) (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 147863) 147893) inline$$TransactionFee_burn_fees_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 147863) 147873) inline$$TransactionFee_burn_fees_$def$0$anon69_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 147843) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon73_Then_correct  (=> (= (ControlFlow 0 147853) 127991) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon72_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 147837) 147853) inline$$TransactionFee_burn_fees_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 147837) 147843) inline$$TransactionFee_burn_fees_$def$0$anon73_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 147823) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon75_Then_correct  (=> (= (ControlFlow 0 147833) 127991) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon74_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 147817) 147833) inline$$TransactionFee_burn_fees_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 147817) 147823) inline$$TransactionFee_burn_fees_$def$0$anon75_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon81_Then_correct  (=> (and $abort_flag@39 (= (ControlFlow 0 147777) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct  (=> (and (not $abort_flag@38) (= $abort_flag@39 $abort_flag@38)) (and (=> (= (ControlFlow 0 147639) 147777) inline$$TransactionFee_burn_fees_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 147639) 147773) inline$$TransactionFee_burn_fees_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$Abort_correct  (=> (= $abort_flag@39 true) (and (=> (= (ControlFlow 0 147285) 147777) inline$$TransactionFee_burn_fees_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 147285) 147773) inline$$TransactionFee_burn_fees_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 147729) 147285)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 147739) 147285) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct  (=> $abort_flag@34 (and (=> (= (ControlFlow 0 147723) 147739) inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 147723) 147729) inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 147709) 147285)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 147719) 147285) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct  (=> $abort_flag@35 (and (=> (= (ControlFlow 0 147703) 147719) inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 147703) 147709) inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 147689) 147285)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 147699) 147285) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct  (=> $abort_flag@36 (and (=> (= (ControlFlow 0 147683) 147699) inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 147683) 147689) inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 147669) 147285)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 147679) 147285) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct  (=> $abort_flag@37 (and (=> (= (ControlFlow 0 147663) 147679) inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 147663) 147669) inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 147649) 147285)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 147659) 147285) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct  (=> $abort_flag@38 (and (=> (= (ControlFlow 0 147643) 147659) inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 147643) 147649) inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@38 true) (and (=> (= (ControlFlow 0 147617) 147643) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 147617) 147639) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 147615) 147617)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (=> (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory@1) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 inline$$Diem_remove_burn_capability_$def$0$$ret0@2))) (= $abort_flag@38 $abort_flag@37)) (and (=> (= (ControlFlow 0 147565) 147643) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 147565) 147639) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| tc_account)) (and (=> (= (ControlFlow 0 147623) 147615) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 147623) 147565) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 147411) (- 0 168069)) true) (=> (= (ControlFlow 0 147411) 147623) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (= (ControlFlow 0 147383) 147411)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$Not$2$dst@1) (= (ControlFlow 0 147631) 147383)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 147279) 147285)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 147293) 147285) inline$$Diem_publish_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$2$dst@1)) (= $abort_code@32 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 147273) 147293) inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 147273) 147279) inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct  (=> (not $abort_flag@37) (and (=> (= (ControlFlow 0 147261) 147631) inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 147261) 147273) inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_burn_capability_$def$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@37)) (and (=> $abort_flag@37 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@37) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 147255) 147663) inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 147255) 147261) inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct)))))
(let ((inline$$Not$2$anon0_correct  (=> (and (= inline$$Not$2$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_publish_burn_capability_$def$0$$t7@1)))) (= (ControlFlow 0 147243) 147255)) inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct)))
(let ((inline$$Not$2$Entry_correct  (and (=> (= (ControlFlow 0 147233) (- 0 167913)) true) (=> (= (ControlFlow 0 147233) 147243) inline$$Not$2$anon0_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct  (=> (not $abort_flag@36) (=> (and (= inline$$Diem_publish_burn_capability_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0@@2)))) (= (ControlFlow 0 147249) 147233)) inline$$Not$2$Entry_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct  (=> (not $abort_flag@35) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@36) (=> $abort_flag@36 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@36) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 tc_account)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 147175) 147683) inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 147175) 147249) inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct  (=> (and (and (not $abort_flag@34) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@35)) (and (=> $abort_flag@35 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@35 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@29 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 147169) 147703) inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 147169) 147175) inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@34) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@34) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@34)) (and (=> $abort_flag@34 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@34 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@28 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@28 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@28 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 147163) 147723) inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 147163) 147169) inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 147093) 147163)) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 147747) 147163) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 147085) 147747) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 147085) 147093) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 147755) 147747) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 147755) 147093) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon0_correct  (=> (not $abort_flag@33) (and (=> (= (ControlFlow 0 147079) 147755) inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 147079) 147085) inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability$0$anon0_correct  (=> ((_ is $Address) tc_account) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_remove_burn_capability_$def$0$$ret0@2) (let ((va@@8 (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 147759) 147079)) inline$$Diem_publish_burn_capability_$def$0$anon0_correct))))
(let ((inline$$WritebackToGlobal$5$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$5$l@1)) (= (ControlFlow 0 146476) 147759)) inline$$Diem_publish_burn_capability$0$anon0_correct)))
(let ((inline$$WritebackToGlobal$5$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$5$l@1) (= inline$$WritebackToGlobal$5$ta@1 (|ts#$Global| inline$$WritebackToGlobal$5$l@1))) (=> (and (and (= inline$$WritebackToGlobal$5$a@1 (|a#$Global| inline$$WritebackToGlobal$5$l@1)) (= inline$$WritebackToGlobal$5$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$8$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$WritebackToGlobal$5$ta@1 inline$$WritebackToGlobal$5$a@1) (|v#$Mutation| |inline$$WritebackToReference$8$dst'@2|)))) (and (= |inline$$WritebackToGlobal$5$m'@1| ($Memory (|domain#$Memory| $TransactionFee_TransactionFee_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$WritebackToGlobal$5$ta@1 inline$$WritebackToGlobal$5$a@1 inline$$WritebackToGlobal$5$v@1))) (= (ControlFlow 0 146530) 147759))) inline$$Diem_publish_burn_capability$0$anon0_correct))))
(let ((inline$$WritebackToGlobal$5$anon0_correct  (=> (= inline$$WritebackToGlobal$5$l@1 (|l#$Mutation| |inline$$WritebackToReference$8$dst'@2|)) (and (=> (= (ControlFlow 0 146466) 146530) inline$$WritebackToGlobal$5$anon3_Then_correct) (=> (= (ControlFlow 0 146466) 146476) inline$$WritebackToGlobal$5$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$8$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$10$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$8$dstPath@1) (|size#$Path| inline$$WritebackToReference$8$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$8$dstPath@1 inline$$WritebackToReference$8$srcPath@1))) (=> (and (= |inline$$WritebackToReference$8$dst'@2| |inline$$WritebackToReference$0$dst'@2|) (= (ControlFlow 0 146288) 146466)) inline$$WritebackToGlobal$5$anon0_correct))))
(let ((inline$$WritebackToReference$8$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|l#$Mutation| |inline$$WriteRef$10$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$8$dstPath@1) (|size#$Path| inline$$WritebackToReference$8$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$8$dstPath@1 inline$$WritebackToReference$8$srcPath@1)) (= |inline$$WritebackToReference$8$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$WritebackToReference$8$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$8$srcPath@1 (|size#$Path| inline$$WritebackToReference$8$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|) (|v#$Mutation| |inline$$WriteRef$10$to'@1|))))) (and (= |inline$$WritebackToReference$8$dst'@2| |inline$$WritebackToReference$8$dst'@1|) (= (ControlFlow 0 146344) 146466))) inline$$WritebackToGlobal$5$anon0_correct)))
(let ((inline$$WritebackToReference$8$anon0_correct  (=> (and (= inline$$WritebackToReference$8$srcPath@1 (|p#$Mutation| |inline$$WriteRef$10$to'@1|)) (= inline$$WritebackToReference$8$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (and (=> (= (ControlFlow 0 146252) 146344) inline$$WritebackToReference$8$anon3_Then_correct) (=> (= (ControlFlow 0 146252) 146288) inline$$WritebackToReference$8$anon3_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 146115) 146252)) inline$$WritebackToReference$8$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon80_Then_correct  (=> (and (= inline$$TransactionFee_burn_fees_$def$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 147787) 146252)) inline$$WritebackToReference$8$anon0_correct)))
(let ((inline$$WriteRef$10$anon0_correct  (=> (= |inline$$WriteRef$10$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) inline$$Diem_burn_now_$def$0$$ret0@2)) (and (=> (= (ControlFlow 0 146101) 147787) inline$$TransactionFee_burn_fees_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 146101) 146115) inline$$TransactionFee_burn_fees_$def$0$anon80_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon79_Else_correct  (=> (and (not $abort_flag@33) (= (ControlFlow 0 146107) 146101)) inline$$WriteRef$10$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon79_Then_correct  (=> (and $abort_flag@33 (= (ControlFlow 0 147791) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon22_correct  (=> (= inline$$Diem_burn_now_$def$0$$ret0@2 |inline$$WritebackToValue$2$vdst'@2|) (=> (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@4) (= $abort_flag@33 $abort_flag@32)) (and (=> (= (ControlFlow 0 145960) 147791) inline$$TransactionFee_burn_fees_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 145960) 146107) inline$$TransactionFee_burn_fees_$def$0$anon79_Else_correct))))))
(let ((inline$$Diem_burn_now_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 145958) 145960)) inline$$Diem_burn_now_$def$0$anon22_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon33_Then_correct  (=> (= (ControlFlow 0 145968) 145960) inline$$Diem_burn_now_$def$0$anon22_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$9$to'@1|) ($Local 7))) (= |inline$$WritebackToValue$2$vdst'@2| inline$$ReadRef$1$v@1)) (and (=> (= (ControlFlow 0 145916) 145968) inline$$Diem_burn_now_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 145916) 145958) inline$$Diem_burn_now_$def$0$anon33_Else_correct)))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$9$to'@1|) ($Local 7)) (=> (and (= |inline$$WritebackToValue$2$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$9$to'@1|) 0 inline$$ReadRef$1$v@1 (|v#$Mutation| |inline$$WriteRef$9$to'@1|))) (= |inline$$WritebackToValue$2$vdst'@2| |inline$$WritebackToValue$2$vdst'@1|)) (and (=> (= (ControlFlow 0 145942) 145968) inline$$Diem_burn_now_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 145942) 145958) inline$$Diem_burn_now_$def$0$anon33_Else_correct))))))
(let ((inline$$WriteRef$9$anon0_correct  (=> (= |inline$$WriteRef$9$to'@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$4$to'@1|) (|p#$Mutation| |inline$$WriteRef$4$to'@1|) inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2)) (and (=> (= (ControlFlow 0 145817) 145942) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 145817) 145916) inline$$WritebackToValue$2$anon3_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon32_Else_correct  (=> (and (not $abort_flag@32) (= (ControlFlow 0 145823) 145817)) inline$$WriteRef$9$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_burn_now_$def$0$$ret0@1 $Error) (= inline$$Diem_burn_now_$def$0$$ret0@2 inline$$Diem_burn_now_$def$0$$ret0@1)) (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $abort_flag@33 true))) (and (=> (= (ControlFlow 0 130907) 147791) inline$$TransactionFee_burn_fees_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 130907) 146107) inline$$TransactionFee_burn_fees_$def$0$anon79_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon11_correct  (=> (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 145988) 130907)) inline$$Diem_burn_now_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 145986) 145988)) inline$$Diem_burn_now_$def$0$anon11_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 145996) 145988) inline$$Diem_burn_now_$def$0$anon11_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon27_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 145980) 145996) inline$$Diem_burn_now_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 145980) 145986) inline$$Diem_burn_now_$def$0$anon28_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon32_Then_correct  (=> $abort_flag@32 (=> (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@4) (= (ControlFlow 0 145972) 130907)) inline$$Diem_burn_now_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct  (=> (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@2) (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2|) (= $abort_flag@32 $abort_flag@31)) (and (=> (= (ControlFlow 0 144301) 145972) inline$$Diem_burn_now_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 144301) 145823) inline$$Diem_burn_now_$def$0$anon32_Else_correct))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct  (=> (and (not true) (= (ControlFlow 0 144299) 144301)) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct  (=> (= (ControlFlow 0 144309) 144301) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct  (=> (= $Diem_CurrencyInfo_$memory@2 |inline$$WritebackToGlobal$4$m'@2|) (and (=> (= (ControlFlow 0 145428) 144309) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct) (=> (= (ControlFlow 0 145428) 144299) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct)))))
(let ((inline$$WritebackToGlobal$4$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$4$l@1)) (=> (and (= |inline$$WritebackToGlobal$4$m'@2| $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145366) 145428)) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct))))
(let ((inline$$WritebackToGlobal$4$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$4$l@1) (=> (and (= inline$$WritebackToGlobal$4$ta@1 (|ts#$Global| inline$$WritebackToGlobal$4$l@1)) (= inline$$WritebackToGlobal$4$a@1 (|a#$Global| inline$$WritebackToGlobal$4$l@1))) (=> (and (and (= inline$$WritebackToGlobal$4$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$7$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1) (|v#$Mutation| |inline$$WritebackToReference$7$dst'@2|))) (= |inline$$WritebackToGlobal$4$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1 inline$$WritebackToGlobal$4$v@1)))) (and (= |inline$$WritebackToGlobal$4$m'@2| |inline$$WritebackToGlobal$4$m'@1|) (= (ControlFlow 0 145420) 145428))) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct)))))
(let ((inline$$WritebackToGlobal$4$anon0_correct  (=> (= inline$$WritebackToGlobal$4$l@1 (|l#$Mutation| |inline$$WritebackToReference$7$dst'@2|)) (and (=> (= (ControlFlow 0 145356) 145420) inline$$WritebackToGlobal$4$anon3_Then_correct) (=> (= (ControlFlow 0 145356) 145366) inline$$WritebackToGlobal$4$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$6$anon0_correct  (and (=> (= (ControlFlow 0 145236) (- 0 166580)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 145236) 145356) inline$$WritebackToGlobal$4$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$6$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0 (|v#$Mutation| |inline$$WritebackToReference$7$dst'@2|)) (= (ControlFlow 0 145188) 145236)) inline$$Diem_CurrencyInfo_$pack_ref$6$anon0_correct)))
(let ((inline$$WritebackToReference$7$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) (|l#$Mutation| |inline$$WriteRef$8$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$7$dstPath@1) (|size#$Path| inline$$WritebackToReference$7$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$7$dstPath@1 inline$$WritebackToReference$7$srcPath@1))) (=> (and (= |inline$$WritebackToReference$7$dst'@2| |inline$$WritebackToReference$6$dst'@2|) (= (ControlFlow 0 145057) 145188)) inline$$Diem_CurrencyInfo_$pack_ref$6$Entry_correct))))
(let ((inline$$WritebackToReference$7$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) (|l#$Mutation| |inline$$WriteRef$8$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$7$dstPath@1) (|size#$Path| inline$$WritebackToReference$7$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$7$dstPath@1 inline$$WritebackToReference$7$srcPath@1)) (= |inline$$WritebackToReference$7$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) inline$$WritebackToReference$7$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$7$srcPath@1 (|size#$Path| inline$$WritebackToReference$7$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|) (|v#$Mutation| |inline$$WriteRef$8$to'@1|))))) (and (= |inline$$WritebackToReference$7$dst'@2| |inline$$WritebackToReference$7$dst'@1|) (= (ControlFlow 0 145113) 145188))) inline$$Diem_CurrencyInfo_$pack_ref$6$Entry_correct)))
(let ((inline$$WritebackToReference$7$anon0_correct  (=> (and (= inline$$WritebackToReference$7$srcPath@1 (|p#$Mutation| |inline$$WriteRef$8$to'@1|)) (= inline$$WritebackToReference$7$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|))) (and (=> (= (ControlFlow 0 145021) 145113) inline$$WritebackToReference$7$anon3_Then_correct) (=> (= (ControlFlow 0 145021) 145057) inline$$WritebackToReference$7$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct  (=> (and (not true) (= (ControlFlow 0 144884) 145021)) inline$$WritebackToReference$7$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4 (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (= (ControlFlow 0 145438) 145021)) inline$$WritebackToReference$7$anon0_correct)))
(let ((inline$$WriteRef$8$anon0_correct  (=> (= |inline$$WriteRef$8$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$18$dst@1) (|p#$Mutation| inline$$BorrowField$18$dst@1) inline$$ReadRef$17$v@1)) (and (=> (= (ControlFlow 0 144870) 145438) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct) (=> (= (ControlFlow 0 144870) 144884) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct  (=> (and (not $abort_flag@31) (= (ControlFlow 0 144876) 144870)) inline$$WriteRef$8$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct  (=> (= $Diem_CurrencyInfo_$memory@2 |inline$$WritebackToGlobal$3$m'@2|) (and (=> (= (ControlFlow 0 144289) 144309) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct) (=> (= (ControlFlow 0 144289) 144299) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct)))))
(let ((inline$$WritebackToGlobal$3$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$3$l@1)) (=> (and (= |inline$$WritebackToGlobal$3$m'@2| $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 144227) 144289)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct))))
(let ((inline$$WritebackToGlobal$3$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$3$l@1) (=> (and (= inline$$WritebackToGlobal$3$ta@1 (|ts#$Global| inline$$WritebackToGlobal$3$l@1)) (= inline$$WritebackToGlobal$3$a@1 (|a#$Global| inline$$WritebackToGlobal$3$l@1))) (=> (and (and (= inline$$WritebackToGlobal$3$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1) (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|))) (= |inline$$WritebackToGlobal$3$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1 inline$$WritebackToGlobal$3$v@1)))) (and (= |inline$$WritebackToGlobal$3$m'@2| |inline$$WritebackToGlobal$3$m'@1|) (= (ControlFlow 0 144281) 144289))) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$3$anon0_correct  (=> (= inline$$WritebackToGlobal$3$l@1 (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (and (=> (= (ControlFlow 0 144217) 144281) inline$$WritebackToGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 144217) 144227) inline$$WritebackToGlobal$3$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$5$anon0_correct  (and (=> (= (ControlFlow 0 144097) (- 0 166028)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 144097) 144217) inline$$WritebackToGlobal$3$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$5$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0 (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (= (ControlFlow 0 144049) 144097)) inline$$Diem_CurrencyInfo_$pack_ref$5$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= (ControlFlow 0 144101) 144049)) inline$$Diem_CurrencyInfo_$pack_ref$5$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1 $Error) (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@3)) (and (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2 inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1) (= $abort_flag@32 true))) (and (=> (= (ControlFlow 0 139672) 145972) inline$$Diem_burn_now_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 139672) 145823) inline$$Diem_burn_now_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145712) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 145710) 145712)) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 145720) 145712) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct  (=> $abort_flag@21 (and (=> (= (ControlFlow 0 145704) 145720) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 145704) 145710) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145692) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 145690) 145692)) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct  (=> (= (ControlFlow 0 145700) 145692) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct  (=> $abort_flag@22 (and (=> (= (ControlFlow 0 145684) 145700) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 145684) 145690) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145672) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 145670) 145672)) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct  (=> (= (ControlFlow 0 145680) 145672) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct  (=> $abort_flag@23 (and (=> (= (ControlFlow 0 145664) 145680) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 145664) 145670) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145634) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 145632) 145634)) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct  (=> (= (ControlFlow 0 145642) 145634) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct  (=> $abort_flag@24 (and (=> (= (ControlFlow 0 145626) 145642) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct) (=> (= (ControlFlow 0 145626) 145632) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145610) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct  (=> (and (not true) (= (ControlFlow 0 145608) 145610)) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct  (=> (= (ControlFlow 0 145618) 145610) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct  (=> $abort_flag@25 (and (=> (= (ControlFlow 0 145602) 145618) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct) (=> (= (ControlFlow 0 145602) 145608) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145590) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct  (=> (and (not true) (= (ControlFlow 0 145588) 145590)) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct  (=> (= (ControlFlow 0 145598) 145590) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct  (=> $abort_flag@26 (and (=> (= (ControlFlow 0 145582) 145598) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct) (=> (= (ControlFlow 0 145582) 145588) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145570) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct  (=> (and (not true) (= (ControlFlow 0 145568) 145570)) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct  (=> (= (ControlFlow 0 145578) 145570) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct  (=> $abort_flag@27 (and (=> (= (ControlFlow 0 145562) 145578) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct) (=> (= (ControlFlow 0 145562) 145568) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145550) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct  (=> (and (not true) (= (ControlFlow 0 145548) 145550)) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct  (=> (= (ControlFlow 0 145558) 145550) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct  (=> $abort_flag@28 (and (=> (= (ControlFlow 0 145542) 145558) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct) (=> (= (ControlFlow 0 145542) 145548) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145530) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct  (=> (and (not true) (= (ControlFlow 0 145528) 145530)) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct  (=> (= (ControlFlow 0 145538) 145530) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct  (=> $abort_flag@29 (and (=> (= (ControlFlow 0 145522) 145538) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct) (=> (= (ControlFlow 0 145522) 145528) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145500) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct  (=> (and (not true) (= (ControlFlow 0 145498) 145500)) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct  (=> (= (ControlFlow 0 145508) 145500) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct  (=> $abort_flag@30 (and (=> (= (ControlFlow 0 145492) 145508) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 145492) 145498) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145480) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct  (=> (and (not true) (= (ControlFlow 0 145478) 145480)) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct  (=> (= (ControlFlow 0 145488) 145480) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct  (=> $abort_flag@31 (and (=> (= (ControlFlow 0 145472) 145488) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct) (=> (= (ControlFlow 0 145472) 145478) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145450) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct  (=> (and (not true) (= (ControlFlow 0 145448) 145450)) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct  (=> (= (ControlFlow 0 145458) 145450) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct  (=> $abort_flag@31 (and (=> (= (ControlFlow 0 145442) 145458) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct) (=> (= (ControlFlow 0 145442) 145448) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct)))))
(let ((inline$$Event_emit_event$1$Entry_correct  (=> (= inline$$Event_emit_event$1$t@0 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 144801) 145442) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct) (=> (= (ControlFlow 0 144801) 144876) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct  (and (=> (= (ControlFlow 0 144811) (- 0 166383)) true) (=> (= (ControlFlow 0 144811) 144801) inline$$Event_emit_event$1$Entry_correct))))
(let ((inline$$ReadRef$17$anon0_correct  (=> (and (= inline$$ReadRef$17$v@1 (|v#$Mutation| inline$$BorrowField$18$dst@1)) (= (ControlFlow 0 144753) 144811)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 144709) 144753)) inline$$ReadRef$17$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 144715) 144753) inline$$ReadRef$17$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 144703) 144715) inline$$Diem_BurnEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 144703) 144709) inline$$Diem_BurnEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 144695) 144753)) inline$$ReadRef$17$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@3) (let ((va@@9 (|v#$Vector| call3formal@$ret0@0@@3)))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall ((inline$$Diem_BurnEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_BurnEvent_pack$0$$$0 0) (< inline$$Diem_BurnEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)) inline$$Diem_BurnEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)) inline$$Diem_BurnEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)) inline$$Diem_BurnEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)) inline$$Diem_BurnEvent_pack$0$$$0))
))) (and ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) (= inline$$Diem_BurnEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_Diem_unpack$0$value@1) 1 call3formal@$ret0@0@@3) 2 inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) 3))))) (and (=> (= (ControlFlow 0 144687) 144703) inline$$Diem_BurnEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 144687) 144695) inline$$Diem_BurnEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$18$anon0_correct  (=> (= inline$$BorrowField$18$p@1 (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (=> (and (and (= inline$$BorrowField$18$size@1 (|size#$Path| inline$$BorrowField$18$p@1)) (= inline$$BorrowField$18$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$18$p@1) inline$$BorrowField$18$size@1 $Diem_CurrencyInfo_burn_events) (+ inline$$BorrowField$18$size@1 1)))) (and (= inline$$BorrowField$18$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) inline$$BorrowField$18$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|))) $Diem_CurrencyInfo_burn_events))) (= (ControlFlow 0 144431) 144687))) inline$$Diem_BurnEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 144437) 144431)) inline$$BorrowField$18$anon0_correct)))
(let ((inline$$Not$1$anon0_correct  (=> (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$16$v@1)))) (and (=> (= (ControlFlow 0 143966) 144437) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct) (=> (= (ControlFlow 0 143966) 144101) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct)))))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 143956) (- 0 165989)) true) (=> (= (ControlFlow 0 143956) 143966) inline$$Not$1$anon0_correct))))
(let ((inline$$ReadRef$16$anon0_correct  (=> (and (= inline$$ReadRef$16$v@1 (|v#$Mutation| inline$$BorrowField$17$dst@1)) (= (ControlFlow 0 143908) 143956)) inline$$Not$1$Entry_correct)))
(let ((inline$$BorrowField$17$anon0_correct  (=> (= inline$$BorrowField$17$p@1 (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (=> (and (and (= inline$$BorrowField$17$size@1 (|size#$Path| inline$$BorrowField$17$p@1)) (= inline$$BorrowField$17$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$17$p@1) inline$$BorrowField$17$size@1 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$17$size@1 1)))) (and (= inline$$BorrowField$17$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|) inline$$BorrowField$17$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 143870) 143908))) inline$$ReadRef$16$anon0_correct))))
(let ((inline$$WritebackToReference$6$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) (|l#$Mutation| |inline$$WriteRef$7$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|size#$Path| inline$$WritebackToReference$6$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$6$dstPath@1 inline$$WritebackToReference$6$srcPath@1))) (=> (and (= |inline$$WritebackToReference$6$dst'@2| |inline$$WritebackToReference$5$dst'@2|) (= (ControlFlow 0 143654) 143870)) inline$$BorrowField$17$anon0_correct))))
(let ((inline$$WritebackToReference$6$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) (|l#$Mutation| |inline$$WriteRef$7$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|size#$Path| inline$$WritebackToReference$6$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$6$dstPath@1 inline$$WritebackToReference$6$srcPath@1)) (= |inline$$WritebackToReference$6$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$WritebackToReference$6$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$6$srcPath@1 (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|) (|v#$Mutation| |inline$$WriteRef$7$to'@1|))))) (and (= |inline$$WritebackToReference$6$dst'@2| |inline$$WritebackToReference$6$dst'@1|) (= (ControlFlow 0 143710) 143870))) inline$$BorrowField$17$anon0_correct)))
(let ((inline$$WritebackToReference$6$anon0_correct  (=> (and (= inline$$WritebackToReference$6$srcPath@1 (|p#$Mutation| |inline$$WriteRef$7$to'@1|)) (= inline$$WritebackToReference$6$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) (and (=> (= (ControlFlow 0 143618) 143710) inline$$WritebackToReference$6$anon3_Then_correct) (=> (= (ControlFlow 0 143618) 143654) inline$$WritebackToReference$6$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct  (=> (and (not true) (= (ControlFlow 0 143481) 143618)) inline$$WritebackToReference$6$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (= (ControlFlow 0 145468) 143618)) inline$$WritebackToReference$6$anon0_correct)))
(let ((inline$$WriteRef$7$anon0_correct  (=> (= |inline$$WriteRef$7$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$16$dst@1) (|p#$Mutation| inline$$BorrowField$16$dst@1) inline$$Sub$2$dst@2)) (and (=> (= (ControlFlow 0 143467) 145468) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct) (=> (= (ControlFlow 0 143467) 143481) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct)))))
(let ((inline$$BorrowField$16$anon0_correct  (=> (= inline$$BorrowField$16$p@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (=> (and (and (= inline$$BorrowField$16$size@1 (|size#$Path| inline$$BorrowField$16$p@1)) (= inline$$BorrowField$16$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$16$p@1) inline$$BorrowField$16$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$16$size@1 1)))) (and (= inline$$BorrowField$16$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$BorrowField$16$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 143408) 143467))) inline$$WriteRef$7$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct  (=> (and (not $abort_flag@31) (= (ControlFlow 0 143414) 143408)) inline$$BorrowField$16$anon0_correct)))
(let ((inline$$Sub$2$anon3_Then$1_correct  (=> (and (= $abort_flag@31 true) (= inline$$Sub$2$dst@2 inline$$Sub$2$dst@0)) (and (=> (= (ControlFlow 0 143278) 145472) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct) (=> (= (ControlFlow 0 143278) 143414) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct)))))
(let ((inline$$Sub$2$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$15$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)) (= (ControlFlow 0 143276) 143278)) inline$$Sub$2$anon3_Then$1_correct)))
(let ((inline$$Sub$2$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) (|i#$Integer| inline$$ReadRef$15$v@1)) (= inline$$Sub$2$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$15$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1))))) (and (= $abort_flag@31 $abort_flag@30) (= inline$$Sub$2$dst@2 inline$$Sub$2$dst@1))) (and (=> (= (ControlFlow 0 143224) 145472) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct) (=> (= (ControlFlow 0 143224) 143414) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct)))))
(let ((inline$$Sub$2$Entry_correct  (and (=> (= (ControlFlow 0 143198) (- 0 165580)) true) (and (=> (= (ControlFlow 0 143198) 143276) inline$$Sub$2$anon3_Then_correct) (=> (= (ControlFlow 0 143198) 143224) inline$$Sub$2$anon3_Else_correct)))))
(let ((inline$$ReadRef$15$anon0_correct  (=> (and (= inline$$ReadRef$15$v@1 (|v#$Mutation| inline$$BorrowField$15$dst@1)) (= (ControlFlow 0 143099) 143198)) inline$$Sub$2$Entry_correct)))
(let ((inline$$BorrowField$15$anon0_correct  (=> (= inline$$BorrowField$15$p@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (=> (and (and (= inline$$BorrowField$15$size@1 (|size#$Path| inline$$BorrowField$15$p@1)) (= inline$$BorrowField$15$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$15$p@1) inline$$BorrowField$15$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$15$size@1 1)))) (and (= inline$$BorrowField$15$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$BorrowField$15$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 143061) 143099))) inline$$ReadRef$15$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$2$dst@1) (= (ControlFlow 0 143113) 143061)) inline$$BorrowField$15$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 |inline$$WritebackToGlobal$2$m'@2|) (= (ControlFlow 0 142895) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct  (=> (and (not true) (= (ControlFlow 0 142893) 142895)) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct  (=> (= (ControlFlow 0 142903) 142895) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct  (=> (= $abort_code@27 (|i#$Integer| call3formal@$ret0@0@@4)) (and (=> (= (ControlFlow 0 142887) 142903) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct) (=> (= (ControlFlow 0 142887) 142893) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct)))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2| $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 142821) 142887)) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1) (=> (and (= inline$$WritebackToGlobal$2$ta@1 (|ts#$Global| inline$$WritebackToGlobal$2$l@1)) (= inline$$WritebackToGlobal$2$a@1 (|a#$Global| inline$$WritebackToGlobal$2$l@1))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1) (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) (= |inline$$WritebackToGlobal$2$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1 inline$$WritebackToGlobal$2$v@1)))) (and (= |inline$$WritebackToGlobal$2$m'@2| |inline$$WritebackToGlobal$2$m'@1|) (= (ControlFlow 0 142875) 142887))) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct  (=> (= inline$$WritebackToGlobal$2$l@1 (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (and (=> (= (ControlFlow 0 142811) 142875) inline$$WritebackToGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 142811) 142821) inline$$WritebackToGlobal$2$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$4$anon0_correct  (and (=> (= (ControlFlow 0 142691) (- 0 165303)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 142691) 142811) inline$$WritebackToGlobal$2$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$4$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0 (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (= (ControlFlow 0 142643) 142691)) inline$$Diem_CurrencyInfo_$pack_ref$4$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$2$dst@1)) (= (ControlFlow 0 142695) 142643)) inline$$Diem_CurrencyInfo_$pack_ref$4$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct  (=> (not $abort_flag@30) (and (=> (= (ControlFlow 0 142568) 143113) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct) (=> (= (ControlFlow 0 142568) 142695) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t36@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@30)) (and (=> $abort_flag@30 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 142562) 145492) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct) (=> (= (ControlFlow 0 142562) 142568) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct)))))
(let ((inline$$Ge$2$anon0_correct  (=> (and (= inline$$Ge$2$dst@1 ($Boolean (>= (|i#$Integer| inline$$ReadRef$14$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)))) (= (ControlFlow 0 142550) 142562)) inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct)))
(let ((inline$$Ge$2$Entry_correct  (and (=> (= (ControlFlow 0 142536) (- 0 165192)) true) (=> (= (ControlFlow 0 142536) 142550) inline$$Ge$2$anon0_correct))))
(let ((inline$$ReadRef$14$anon0_correct  (=> (and (= inline$$ReadRef$14$v@1 (|v#$Mutation| inline$$BorrowField$14$dst@1)) (= (ControlFlow 0 142478) 142536)) inline$$Ge$2$Entry_correct)))
(let ((inline$$BorrowField$14$anon0_correct  (=> (= inline$$BorrowField$14$p@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (=> (and (and (= inline$$BorrowField$14$size@1 (|size#$Path| inline$$BorrowField$14$p@1)) (= inline$$BorrowField$14$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$14$p@1) inline$$BorrowField$14$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$14$size@1 1)))) (and (= inline$$BorrowField$14$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$BorrowField$14$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 142440) 142478))) inline$$ReadRef$14$anon0_correct))))
(let ((inline$$WritebackToReference$5$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) (|l#$Mutation| |inline$$WriteRef$6$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1))) (=> (and (= |inline$$WritebackToReference$5$dst'@2| inline$$BorrowGlobal$2$dst@2) (= (ControlFlow 0 142224) 142440)) inline$$BorrowField$14$anon0_correct))))
(let ((inline$$WritebackToReference$5$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) (|l#$Mutation| |inline$$WriteRef$6$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1)) (= |inline$$WritebackToReference$5$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$WritebackToReference$5$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$5$srcPath@1 (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$2$dst@2) (|v#$Mutation| |inline$$WriteRef$6$to'@1|))))) (and (= |inline$$WritebackToReference$5$dst'@2| |inline$$WritebackToReference$5$dst'@1|) (= (ControlFlow 0 142280) 142440))) inline$$BorrowField$14$anon0_correct)))
(let ((inline$$WritebackToReference$5$anon0_correct  (=> (and (= inline$$WritebackToReference$5$srcPath@1 (|p#$Mutation| |inline$$WriteRef$6$to'@1|)) (= inline$$WritebackToReference$5$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2))) (and (=> (= (ControlFlow 0 142188) 142280) inline$$WritebackToReference$5$anon3_Then_correct) (=> (= (ControlFlow 0 142188) 142224) inline$$WritebackToReference$5$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 142051) 142188)) inline$$WritebackToReference$5$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 145518) 142188)) inline$$WritebackToReference$5$anon0_correct)))
(let ((inline$$WriteRef$6$anon0_correct  (=> (= |inline$$WriteRef$6$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$13$dst@1) (|p#$Mutation| inline$$BorrowField$13$dst@1) inline$$Sub$1$dst@2)) (and (=> (= (ControlFlow 0 142037) 145518) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct) (=> (= (ControlFlow 0 142037) 142051) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct)))))
(let ((inline$$BorrowField$13$anon0_correct  (=> (= inline$$BorrowField$13$p@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2)) (=> (and (and (= inline$$BorrowField$13$size@1 (|size#$Path| inline$$BorrowField$13$p@1)) (= inline$$BorrowField$13$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$13$p@1) inline$$BorrowField$13$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$13$size@1 1)))) (and (= inline$$BorrowField$13$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$BorrowField$13$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 141978) 142037))) inline$$WriteRef$6$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct  (=> (and (not $abort_flag@29) (= (ControlFlow 0 141984) 141978)) inline$$BorrowField$13$anon0_correct)))
(let ((inline$$Sub$1$anon3_Then$1_correct  (=> (and (= $abort_flag@29 true) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@0)) (and (=> (= (ControlFlow 0 141848) 145522) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct) (=> (= (ControlFlow 0 141848) 141984) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct)))))
(let ((inline$$Sub$1$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$13$v@1) (|i#$Integer| inline$$CastU128$1$dst@1)) (= (ControlFlow 0 141846) 141848)) inline$$Sub$1$anon3_Then$1_correct)))
(let ((inline$$Sub$1$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$CastU128$1$dst@1) (|i#$Integer| inline$$ReadRef$13$v@1)) (= inline$$Sub$1$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$13$v@1) (|i#$Integer| inline$$CastU128$1$dst@1))))) (and (= $abort_flag@29 $abort_flag@28) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@1))) (and (=> (= (ControlFlow 0 141794) 145522) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct) (=> (= (ControlFlow 0 141794) 141984) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct)))))
(let ((inline$$Sub$1$Entry_correct  (and (=> (= (ControlFlow 0 141768) (- 0 164779)) true) (and (=> (= (ControlFlow 0 141768) 141846) inline$$Sub$1$anon3_Then_correct) (=> (= (ControlFlow 0 141768) 141794) inline$$Sub$1$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct  (=> (and (not $abort_flag@28) (= (ControlFlow 0 141854) 141768)) inline$$Sub$1$Entry_correct)))
(let ((inline$$CastU128$1$anon3_Then$1_correct  (=> (and (= $abort_flag@28 true) (= inline$$CastU128$1$dst@1 inline$$CastU128$1$dst@0)) (and (=> (= (ControlFlow 0 141671) 145542) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct) (=> (= (ControlFlow 0 141671) 141854) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct)))))
(let ((inline$$CastU128$1$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U128) (= (ControlFlow 0 141669) 141671)) inline$$CastU128$1$anon3_Then$1_correct)))
(let ((inline$$CastU128$1$anon3_Else_correct  (=> (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)) (=> (and (= $abort_flag@28 $abort_flag@27) (= inline$$CastU128$1$dst@1 inline$$Diem_Diem_unpack$0$value@1)) (and (=> (= (ControlFlow 0 141619) 145542) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct) (=> (= (ControlFlow 0 141619) 141854) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct))))))
(let ((inline$$CastU128$1$Entry_correct  (and (=> (= (ControlFlow 0 141605) (- 0 164716)) true) (and (=> (= (ControlFlow 0 141605) 141669) inline$$CastU128$1$anon3_Then_correct) (=> (= (ControlFlow 0 141605) 141619) inline$$CastU128$1$anon3_Else_correct)))))
(let ((inline$$ReadRef$13$anon0_correct  (=> (and (= inline$$ReadRef$13$v@1 (|v#$Mutation| inline$$BorrowField$12$dst@1)) (= (ControlFlow 0 141524) 141605)) inline$$CastU128$1$Entry_correct)))
(let ((inline$$BorrowField$12$anon0_correct  (=> (= inline$$BorrowField$12$p@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2)) (=> (and (and (= inline$$BorrowField$12$size@1 (|size#$Path| inline$$BorrowField$12$p@1)) (= inline$$BorrowField$12$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$12$p@1) inline$$BorrowField$12$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$12$size@1 1)))) (and (= inline$$BorrowField$12$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$BorrowField$12$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 141486) 141524))) inline$$ReadRef$13$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$1$dst@1) (= (ControlFlow 0 141538) 141486)) inline$$BorrowField$12$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 141320) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct  (=> (and (not true) (= (ControlFlow 0 141318) 141320)) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct  (=> (= (ControlFlow 0 141328) 141320) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct  (=> (= $abort_code@25 (|i#$Integer| call3formal@$ret0@0@@5)) (and (=> (= (ControlFlow 0 141312) 141328) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct) (=> (= (ControlFlow 0 141312) 141318) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct  (and (=> (= (ControlFlow 0 141302) (- 0 164550)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 141302) 141312) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 141254) 141302)) inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$1$dst@1)) (= (ControlFlow 0 141306) 141254)) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct  (=> (not $abort_flag@27) (and (=> (= (ControlFlow 0 141179) 141538) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct) (=> (= (ControlFlow 0 141179) 141306) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t28@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@27)) (and (=> $abort_flag@27 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@27) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 141173) 145562) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct) (=> (= (ControlFlow 0 141173) 141179) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct)))))
(let ((inline$$Ge$1$anon0_correct  (=> (and (= inline$$Ge$1$dst@1 ($Boolean (>= (|i#$Integer| inline$$ReadRef$12$v@1) (|i#$Integer| inline$$CastU128$0$dst@1)))) (= (ControlFlow 0 141161) 141173)) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct)))
(let ((inline$$Ge$1$Entry_correct  (and (=> (= (ControlFlow 0 141147) (- 0 164439)) true) (=> (= (ControlFlow 0 141147) 141161) inline$$Ge$1$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct  (=> (and (not $abort_flag@26) (= (ControlFlow 0 141167) 141147)) inline$$Ge$1$Entry_correct)))
(let ((inline$$CastU128$0$anon3_Then$1_correct  (=> (and (= $abort_flag@26 true) (= inline$$CastU128$0$dst@1 inline$$CastU128$0$dst@0)) (and (=> (= (ControlFlow 0 141091) 145582) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct) (=> (= (ControlFlow 0 141091) 141167) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct)))))
(let ((inline$$CastU128$0$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U128) (= (ControlFlow 0 141089) 141091)) inline$$CastU128$0$anon3_Then$1_correct)))
(let ((inline$$CastU128$0$anon3_Else_correct  (=> (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)) (=> (and (= $abort_flag@26 $abort_flag@25) (= inline$$CastU128$0$dst@1 inline$$Diem_Diem_unpack$0$value@1)) (and (=> (= (ControlFlow 0 141039) 145582) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct) (=> (= (ControlFlow 0 141039) 141167) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct))))))
(let ((inline$$CastU128$0$Entry_correct  (and (=> (= (ControlFlow 0 141025) (- 0 164374)) true) (and (=> (= (ControlFlow 0 141025) 141089) inline$$CastU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 141025) 141039) inline$$CastU128$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$12$anon0_correct  (=> (and (= inline$$ReadRef$12$v@1 (|v#$Mutation| inline$$BorrowField$11$dst@1)) (= (ControlFlow 0 140944) 141025)) inline$$CastU128$0$Entry_correct)))
(let ((inline$$BorrowField$11$anon0_correct  (=> (= inline$$BorrowField$11$p@1 (|p#$Mutation| inline$$BorrowGlobal$2$dst@2)) (=> (and (and (= inline$$BorrowField$11$size@1 (|size#$Path| inline$$BorrowField$11$p@1)) (= inline$$BorrowField$11$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$11$p@1) inline$$BorrowField$11$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$11$size@1 1)))) (and (= inline$$BorrowField$11$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$BorrowField$11$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$2$dst@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 140906) 140944))) inline$$ReadRef$12$anon0_correct))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$1$anon0_correct  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 140748) 140906)) inline$$BorrowField$11$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$1$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 140742) 140748)) inline$$Diem_CurrencyInfo_$unpack_ref$1$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct  (=> (and (not $abort_flag@25) (= (ControlFlow 0 140752) 140742)) inline$$Diem_CurrencyInfo_$unpack_ref$1$Entry_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Then$1_correct  (=> (and (= $abort_flag@25 true) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@0)) (and (=> (= (ControlFlow 0 140702) 145602) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 140702) 140752) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct)))))
(let ((inline$$BorrowGlobal$2$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1)) (= (ControlFlow 0 140700) 140702)) inline$$BorrowGlobal$2$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1) (= inline$$BorrowGlobal$2$dst@1 ($Mutation ($Global inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1)))) (and (= $abort_flag@25 $abort_flag@24) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@1))) (and (=> (= (ControlFlow 0 140648) 145602) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 140648) 140752) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct)))))
(let ((inline$$BorrowGlobal$2$anon0_correct  (=> (= inline$$BorrowGlobal$2$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 140618) 140700) inline$$BorrowGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 140618) 140648) inline$$BorrowGlobal$2$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$2$Entry_correct  (=> (= inline$$BorrowGlobal$2$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (and (=> (= (ControlFlow 0 140612) (- 0 164170)) true) (=> (= (ControlFlow 0 140612) 140618) inline$$BorrowGlobal$2$anon0_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct  (=> (and (not $abort_flag@24) (= (ControlFlow 0 140708) 140612)) inline$$BorrowGlobal$2$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct  (=> $abort_flag@24 (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145622) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 140469) 145622) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 140469) 140708) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 140479) 145622) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 140479) 140708) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@24) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 140463) 140479) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 140463) 140469) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct  (=> (and (not $abort_flag@24) (= (ControlFlow 0 140493) 140463)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@24) (=> (and (=> $abort_flag@24 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@24 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@23 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 140358) 145626) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 140358) 140493) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 140356) 140358)) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct  (=> (= (ControlFlow 0 145650) 140358) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct)))
(let ((inline$$Diem_Diem_unpack$0$anon0_correct  (=> (and ((_ is $Vector) call4formal@$ret0@0) (= inline$$Diem_Diem_unpack$0$value@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value))) (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U64)) (and (=> (= (ControlFlow 0 140342) 145650) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 140342) 140356) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct))))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) ($Local 12))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| inline$$ReadRef$9$v@1) (= (ControlFlow 0 140251) 140342)) inline$$Diem_Diem_unpack$0$anon0_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) ($Local 12)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|) 0 inline$$ReadRef$9$v@1 (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 140277) 140342))) inline$$Diem_Diem_unpack$0$anon0_correct)))
(let ((inline$$WritebackToReference$4$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1))) (= |inline$$WritebackToReference$4$dst'@2| inline$$BorrowLoc$2$dst@1)) (and (=> (= (ControlFlow 0 140096) 140277) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 140096) 140251) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$4$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1)) (and (= |inline$$WritebackToReference$4$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$WritebackToReference$4$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$4$srcPath@1 (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$2$dst@1) (|v#$Mutation| |inline$$WriteRef$5$to'@1|)))) (= |inline$$WritebackToReference$4$dst'@2| |inline$$WritebackToReference$4$dst'@1|))) (and (=> (= (ControlFlow 0 140152) 140277) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 140152) 140251) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$4$anon0_correct  (=> (and (= inline$$WritebackToReference$4$srcPath@1 (|p#$Mutation| |inline$$WriteRef$5$to'@1|)) (= inline$$WritebackToReference$4$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$2$dst@1))) (and (=> (= (ControlFlow 0 140060) 140152) inline$$WritebackToReference$4$anon3_Then_correct) (=> (= (ControlFlow 0 140060) 140096) inline$$WritebackToReference$4$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 139923) 140060)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_burn_with_resource_cap_$def$0$info@0)) (= (ControlFlow 0 145660) 140060)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$WriteRef$5$anon0_correct  (=> (= |inline$$WriteRef$5$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$10$dst@1) (|p#$Mutation| inline$$BorrowField$10$dst@1) call5formal@$ret1@0)) (and (=> (= (ControlFlow 0 139909) 145660) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 139909) 139923) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct  (=> (and (not $abort_flag@23) (= (ControlFlow 0 139915) 139909)) inline$$WriteRef$5$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct  (and (=> (= (ControlFlow 0 139852) (- 0 163676)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@23) (=> $abort_flag@23 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@23) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$11$v@1)) $Diem_Diem_value))))) (=> (not $abort_flag@23) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value) ($Integer 0))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0) (let ((va@@10 (|v#$Vector| call4formal@$ret0@0)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0) (let ((va@@11 (|v#$Vector| call5formal@$ret1@0)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 139852) 145664) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 139852) 139915) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct)))))))
(let ((inline$$ReadRef$11$anon0_correct  (=> (and (= inline$$ReadRef$11$v@1 (|v#$Mutation| inline$$BorrowField$10$dst@1)) (= (ControlFlow 0 139840) 139852)) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct)))
(let ((inline$$BorrowField$10$anon0_correct  (=> (= inline$$BorrowField$10$p@1 (|p#$Mutation| inline$$BorrowLoc$2$dst@1)) (=> (and (and (= inline$$BorrowField$10$size@1 (|size#$Path| inline$$BorrowField$10$p@1)) (= inline$$BorrowField$10$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$10$p@1) inline$$BorrowField$10$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$10$size@1 1)))) (and (= inline$$BorrowField$10$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$BorrowField$10$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$2$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 139802) 139840))) inline$$ReadRef$11$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$1$dst@1) (= (ControlFlow 0 139808) 139802)) inline$$BorrowField$10$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct  (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 139666) 139672)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 139664) 139666)) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 139680) 139666) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$1$dst@1)) (= $abort_code@21 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 139658) 139680) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 139658) 139664) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct  (=> (not $abort_flag@22) (and (=> (= (ControlFlow 0 139646) 139808) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 139646) 139658) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t19@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@22)) (and (=> $abort_flag@22 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 139640) 145684) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 139640) 139646) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct)))))
(let ((inline$$Gt$1$anon0_correct  (=> (and (= inline$$Gt$1$dst@1 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$3$dst@1) (|i#$Integer| inline$$Diem_burn_with_resource_cap_$def$0$$t17@1)))) (= (ControlFlow 0 139628) 139640)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct)))
(let ((inline$$Gt$1$Entry_correct  (and (=> (= (ControlFlow 0 139614) (- 0 163469)) true) (=> (= (ControlFlow 0 139614) 139628) inline$$Gt$1$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t17@1 ($Integer 0)) (= (ControlFlow 0 139634) 139614)) inline$$Gt$1$Entry_correct)))
(let ((inline$$GetFieldFromValue$3$anon0_correct  (=> (and (= inline$$GetFieldFromValue$3$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$10$v@1)) $Diem_Diem_value)) (= (ControlFlow 0 139560) 139634)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct  (and (=> (= (ControlFlow 0 139566) (- 0 163432)) true) (=> (= (ControlFlow 0 139566) 139560) inline$$GetFieldFromValue$3$anon0_correct))))
(let ((inline$$ReadRef$10$anon0_correct  (=> (and (= inline$$ReadRef$10$v@1 (|v#$Mutation| inline$$BorrowField$9$dst@1)) (= (ControlFlow 0 139500) 139566)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct)))
(let ((inline$$BorrowField$9$anon0_correct  (=> (= inline$$BorrowField$9$p@1 (|p#$Mutation| inline$$BorrowLoc$2$dst@1)) (=> (and (and (= inline$$BorrowField$9$size@1 (|size#$Path| inline$$BorrowField$9$p@1)) (= inline$$BorrowField$9$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$9$p@1) inline$$BorrowField$9$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$9$size@1 1)))) (and (= inline$$BorrowField$9$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$BorrowField$9$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$2$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 139462) 139500))) inline$$ReadRef$10$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct  (=> (and (not $abort_flag@21) (= (ControlFlow 0 139514) 139462)) inline$$BorrowField$9$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21) (=> $abort_flag@21 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@21 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@19 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@3) (let ((va@@12 (|v#$Vector| call3formal@$ret0@0@@3)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@3)) $$0))
)))) (and (=> (= (ControlFlow 0 139304) 145704) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 139304) 139514) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct)))))
(let ((inline$$BorrowLoc$2$anon0_correct  (=> (and (= inline$$BorrowLoc$2$dst@1 ($Mutation ($Local 12) $EmptyPath inline$$ReadRef$9$v@1)) (= (ControlFlow 0 139296) 139304)) inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 139178) 139296)) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct  (=> (= (ControlFlow 0 145728) 139296) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 139170) 145728) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 139170) 139178) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct  (and (=> (= (ControlFlow 0 145736) 145728) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 145736) 139178) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 139162) 145736) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 139162) 139170) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct  (and (=> (= (ControlFlow 0 145744) 145736) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 145744) 139170) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct  (=> (not $abort_flag@20) (and (=> (= (ControlFlow 0 139156) 145744) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 139156) 139162) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$9$v@1) (let ((va@@13 (|v#$Vector| inline$$ReadRef$9$v@1)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1)) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_remove_burn_capability_$def$0$$ret0@2) (let ((va@@15 (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 145750) 139156)) inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon31_Else$2_correct  (and (=> (= (ControlFlow 0 145758) (- 0 162953)) true) (=> (= (ControlFlow 0 145758) 145750) inline$$Diem_burn_with_resource_cap$0$anon0_correct))))
(let ((inline$$ReadRef$9$anon0_correct  (=> (and (= inline$$ReadRef$9$v@1 (|v#$Mutation| |inline$$WriteRef$4$to'@1|)) (= (ControlFlow 0 137671) 145758)) inline$$Diem_burn_now_$def$0$anon31_Else$2_correct)))
(let ((inline$$WriteRef$4$anon0_correct  (=> (and (= |inline$$WriteRef$4$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$Diem_preburn_with_resource_$def$0$$ret0@2)) (= (ControlFlow 0 137633) 137671)) inline$$ReadRef$9$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon31_Else_correct  (=> (and (not $abort_flag@20) (= (ControlFlow 0 137639) 137633)) inline$$WriteRef$4$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon31_Then_correct  (=> $abort_flag@20 (=> (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 145976) 130907)) inline$$Diem_burn_now_$def$0$Abort_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon62_correct  (=> (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2|) (=> (and (= $abort_flag@20 $abort_flag@19) (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory@0)) (and (=> (= (ControlFlow 0 136207) 145976) inline$$Diem_burn_now_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 136207) 137639) inline$$Diem_burn_now_$def$0$anon31_Else_correct))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 136205) 136207)) inline$$Diem_preburn_with_resource_$def$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct  (=> (= (ControlFlow 0 136215) 136207) inline$$Diem_preburn_with_resource_$def$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct  (=> (= $Diem_CurrencyInfo_$memory@0 |inline$$WritebackToGlobal$1$m'@2|) (and (=> (= (ControlFlow 0 137334) 136215) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 137334) 136205) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct)))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 137272) 137334)) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 137326) 137334))) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (and (=> (= (ControlFlow 0 137262) 137326) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 137262) 137272) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct  (and (=> (= (ControlFlow 0 137142) (- 0 162598)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 137142) 137262) inline$$WritebackToGlobal$1$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 137094) 137142)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$2$dst'@2|) (= (ControlFlow 0 136963) 137094)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1)) (= |inline$$WritebackToReference$3$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) inline$$WritebackToReference$3$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|) (|v#$Mutation| |inline$$WriteRef$3$to'@1|))))) (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$3$dst'@1|) (= (ControlFlow 0 137019) 137094))) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct)))
(let ((inline$$WritebackToReference$3$anon0_correct  (=> (and (= inline$$WritebackToReference$3$srcPath@1 (|p#$Mutation| |inline$$WriteRef$3$to'@1|)) (= inline$$WritebackToReference$3$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (and (=> (= (ControlFlow 0 136927) 137019) inline$$WritebackToReference$3$anon3_Then_correct) (=> (= (ControlFlow 0 136927) 136963) inline$$WritebackToReference$3$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 136790) 136927)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (= (ControlFlow 0 137344) 136927)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$8$dst@1) (|p#$Mutation| inline$$BorrowField$8$dst@1) inline$$ReadRef$8$v@1)) (and (=> (= (ControlFlow 0 136776) 137344) inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 136776) 136790) inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct  (=> (and (not $abort_flag@19) (= (ControlFlow 0 136782) 136776)) inline$$WriteRef$3$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct  (=> (= $Diem_CurrencyInfo_$memory@0 |inline$$WritebackToGlobal$0$m'@2|) (and (=> (= (ControlFlow 0 136195) 136215) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 136195) 136205) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 136133) 136195)) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 136187) 136195))) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (and (=> (= (ControlFlow 0 136123) 136187) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 136123) 136133) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 136003) (- 0 162045)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 136003) 136123) inline$$WritebackToGlobal$0$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (= (ControlFlow 0 135955) 136003)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= (ControlFlow 0 136007) 135955)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_preburn_with_resource_$def$0$$ret0@1 $Error) (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2 inline$$Diem_preburn_with_resource_$def$0$$ret0@1)) (and (= $abort_flag@20 true) (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory))) (and (=> (= (ControlFlow 0 133174) 145976) inline$$Diem_burn_now_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 133174) 137639) inline$$Diem_burn_now_$def$0$anon31_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 137518) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct  (=> (= (ControlFlow 0 137528) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 137512) 137528) inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 137512) 137518) inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 137498) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct  (=> (= (ControlFlow 0 137508) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 137492) 137508) inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 137492) 137498) inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 137468) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct  (=> (= (ControlFlow 0 137478) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct  (=> $abort_flag@15 (and (=> (= (ControlFlow 0 137462) 137478) inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 137462) 137468) inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 137444) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct  (=> (= (ControlFlow 0 137454) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct  (=> $abort_flag@16 (and (=> (= (ControlFlow 0 137438) 137454) inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 137438) 137444) inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 137424) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct  (=> (= (ControlFlow 0 137434) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 137418) 137434) inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 137418) 137424) inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 137404) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct  (=> (= (ControlFlow 0 137414) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct  (=> $abort_flag@18 (and (=> (= (ControlFlow 0 137398) 137414) inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 137398) 137404) inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 137384) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 137394) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 137378) 137394) inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 137378) 137384) inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 137354) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 137364) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 137348) 137364) inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 137348) 137354) inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct  (=> (= inline$$Event_emit_event$0$t@0 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 136707) 137348) inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 136707) 136782) inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct  (and (=> (= (ControlFlow 0 136717) (- 0 162401)) true) (=> (= (ControlFlow 0 136717) 136707) inline$$Event_emit_event$0$Entry_correct))))
(let ((inline$$ReadRef$8$anon0_correct  (=> (and (= inline$$ReadRef$8$v@1 (|v#$Mutation| inline$$BorrowField$8$dst@1)) (= (ControlFlow 0 136659) 136717)) inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 136615) 136659)) inline$$ReadRef$8$anon0_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 136621) 136659) inline$$ReadRef$8$anon0_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 136609) 136621) inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 136609) 136615) inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 136601) 136659)) inline$$ReadRef$8$anon0_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$1$dst@1) (>= (|i#$Integer| inline$$GetFieldFromValue$1$dst@1) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$1$dst@1) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@7) (let ((va@@16 (|v#$Vector| call3formal@$ret0@0@@7)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (forall ((inline$$Diem_PreburnEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_PreburnEvent_pack$0$$$0 0) (< inline$$Diem_PreburnEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)) inline$$Diem_PreburnEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)) inline$$Diem_PreburnEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)) inline$$Diem_PreburnEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)) inline$$Diem_PreburnEvent_pack$0$$$0))
))) (and ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) (= inline$$Diem_PreburnEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$1$dst@1) 1 call3formal@$ret0@0@@7) 2 inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) 3))))) (and (=> (= (ControlFlow 0 136593) 136609) inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 136593) 136601) inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$8$anon0_correct  (=> (= inline$$BorrowField$8$p@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (=> (and (and (= inline$$BorrowField$8$size@1 (|size#$Path| inline$$BorrowField$8$p@1)) (= inline$$BorrowField$8$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1) inline$$BorrowField$8$size@1 $Diem_CurrencyInfo_preburn_events) (+ inline$$BorrowField$8$size@1 1)))) (and (= inline$$BorrowField$8$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) inline$$BorrowField$8$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) $Diem_CurrencyInfo_preburn_events))) (= (ControlFlow 0 136337) 136593))) inline$$Diem_PreburnEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 136343) 136337)) inline$$BorrowField$8$anon0_correct)))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$7$v@1)))) (and (=> (= (ControlFlow 0 135872) 136343) inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 135872) 136007) inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 135862) (- 0 162006)) true) (=> (= (ControlFlow 0 135862) 135872) inline$$Not$0$anon0_correct))))
(let ((inline$$ReadRef$7$anon0_correct  (=> (and (= inline$$ReadRef$7$v@1 (|v#$Mutation| inline$$BorrowField$7$dst@1)) (= (ControlFlow 0 135814) 135862)) inline$$Not$0$Entry_correct)))
(let ((inline$$BorrowField$7$anon0_correct  (=> (= inline$$BorrowField$7$p@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (=> (and (and (= inline$$BorrowField$7$size@1 (|size#$Path| inline$$BorrowField$7$p@1)) (= inline$$BorrowField$7$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1) inline$$BorrowField$7$size@1 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$7$size@1 1)))) (and (= inline$$BorrowField$7$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) inline$$BorrowField$7$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 135776) 135814))) inline$$ReadRef$7$anon0_correct))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 135560) 135776)) inline$$BorrowField$7$anon0_correct))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))))) (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|) (= (ControlFlow 0 135616) 135776))) inline$$BorrowField$7$anon0_correct)))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 135524) 135616) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 135524) 135560) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 135387) 135524)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 137374) 135524)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$6$dst@1) (|p#$Mutation| inline$$BorrowField$6$dst@1) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 135373) 137374) inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 135373) 135387) inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct)))))
(let ((inline$$BorrowField$6$anon0_correct  (=> (= inline$$BorrowField$6$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$6$size@1 (|size#$Path| inline$$BorrowField$6$p@1)) (= inline$$BorrowField$6$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1) inline$$BorrowField$6$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$6$size@1 1)))) (and (= inline$$BorrowField$6$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$6$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 135314) 135373))) inline$$WriteRef$2$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct  (=> (and (not $abort_flag@19) (= (ControlFlow 0 135320) 135314)) inline$$BorrowField$6$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (and (= $abort_flag@19 true) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 135184) 137378) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 135184) 135320) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)) $MAX_U64) (= (ControlFlow 0 135182) 135184)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (and (and (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1))) (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1))))) (and (= $abort_flag@19 $abort_flag@18) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 135126) 137378) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 135126) 135320) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct)))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 135096) (- 0 161589)) true) (and (=> (= (ControlFlow 0 135096) 135182) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 135096) 135126) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$6$anon0_correct  (=> (and (= inline$$ReadRef$6$v@1 (|v#$Mutation| inline$$BorrowField$5$dst@1)) (= (ControlFlow 0 134989) 135096)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$BorrowField$5$anon0_correct  (=> (= inline$$BorrowField$5$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$5$size@1 (|size#$Path| inline$$BorrowField$5$p@1)) (= inline$$BorrowField$5$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1) inline$$BorrowField$5$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$5$size@1 1)))) (and (= inline$$BorrowField$5$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$5$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 134951) 134989))) inline$$ReadRef$6$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1) (= (ControlFlow 0 135003) 134951)) inline$$BorrowField$5$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 134783) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct  (=> (= (ControlFlow 0 134793) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct  (=> (= $abort_code@18 (|i#$Integer| call3formal@$ret0@0@@8)) (and (=> (= (ControlFlow 0 134777) 134793) inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 134777) 134783) inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 134767) (- 0 161421)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 134767) 134777) inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 134719) 134767)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1)) (= (ControlFlow 0 134771) 134719)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct  (=> (not $abort_flag@18) (and (=> (= (ControlFlow 0 134644) 135003) inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 134644) 134771) inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct  (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t27@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@18)) (and (=> $abort_flag@18 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 134638) 137398) inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 134638) 134644) inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct  (=> (and (= inline$$Ge$0$dst@1 ($Boolean (>= (|i#$Integer| inline$$Sub$0$dst@2) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)))) (= (ControlFlow 0 134626) 134638)) inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct)))
(let ((inline$$Ge$0$Entry_correct  (and (=> (= (ControlFlow 0 134612) (- 0 161310)) true) (=> (= (ControlFlow 0 134612) 134626) inline$$Ge$0$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 134632) 134612)) inline$$Ge$0$Entry_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (and (= $abort_flag@17 true) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 134556) 137418) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 134556) 134632) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1) (|i#$Integer| inline$$ReadRef$5$v@1)) (= (ControlFlow 0 134554) 134556)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (and (and (<= (|i#$Integer| inline$$ReadRef$5$v@1) (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1)) (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1) (|i#$Integer| inline$$ReadRef$5$v@1))))) (and (= $abort_flag@17 $abort_flag@16) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 134502) 137418) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 134502) 134632) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct)))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 134476) (- 0 161229)) true) (and (=> (= (ControlFlow 0 134476) 134554) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 134476) 134502) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$5$anon0_correct  (=> (and (= inline$$ReadRef$5$v@1 (|v#$Mutation| inline$$BorrowField$4$dst@1)) (= (ControlFlow 0 134377) 134476)) inline$$Sub$0$Entry_correct)))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 134339) 134377))) inline$$ReadRef$5$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t23@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 134391) 134339)) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 134177) 134391)) inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 134171) 134177)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct  (=> (and (not $abort_flag@16) (= (ControlFlow 0 134181) 134171)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (and (= $abort_flag@16 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 134131) 137438) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 134131) 134181) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct)))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 134129) 134131)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1) (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1)))) (and (= $abort_flag@16 $abort_flag@15) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 134077) 137438) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 134077) 134181) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct)))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 134047) 134129) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 134047) 134077) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (=> (= inline$$BorrowGlobal$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (and (=> (= (ControlFlow 0 134041) (- 0 161013)) true) (=> (= (ControlFlow 0 134041) 134047) inline$$BorrowGlobal$1$anon0_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 134137) 134041)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct  (=> (and $abort_flag@15 (= (ControlFlow 0 137458) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 133898) 137458) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 133898) 134137) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 133908) 137458) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 133908) 134137) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@15) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 133892) 133908) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 133892) 133898) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 133922) 133892)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@15) (=> $abort_flag@15 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@15 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@16 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@15) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@7) (let ((va@@17 (|v#$Vector| call3formal@$ret0@0@@7)))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@7)) $$0@@0))
)))) (and (=> (= (ControlFlow 0 133787) 137462) inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 133787) 133922) inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 11))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$2$v@1) (= (ControlFlow 0 133753) 133787)) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 11)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 inline$$ReadRef$2$v@1 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 133779) 133787))) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowLoc$1$dst@1)) (and (=> (= (ControlFlow 0 133598) 133779) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 133598) 133753) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (and (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|))) (and (=> (= (ControlFlow 0 133654) 133779) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 133654) 133753) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 133562) 133654) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 133562) 133598) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 133425) 133562)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_preburn_with_resource_$def$0$info@0)) (= (ControlFlow 0 137488) 133562)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) call5formal@$ret0@0)) (and (=> (= (ControlFlow 0 133411) 137488) inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 133411) 133425) inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct  (=> (and (not $abort_flag@14) (= (ControlFlow 0 133417) 133411)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct  (and (=> (= (ControlFlow 0 133354) (- 0 160403)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@14) (=> $abort_flag@14 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> $abort_flag@14 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@15 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)))))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0) (let ((va@@18 (|v#$Vector| call5formal@$ret0@0)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 133354) 137492) inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 133354) 133417) inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct)))))))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowField$3$dst@1)) (= (ControlFlow 0 133342) 133354)) inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct)))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 133304) 133342))) inline$$ReadRef$4$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1) (= (ControlFlow 0 133310) 133304)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 133166) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct  (=> (= (ControlFlow 0 133182) 133174) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1)) (= $abort_code@14 (|i#$Integer| call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 133160) 133182) inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 133160) 133166) inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct  (=> (not $abort_flag@13) (and (=> (= (ControlFlow 0 133148) 133310) inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 133148) 133160) inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct  (=> (not $abort_flag@12) (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t16@1 ($Integer 0)) (= inline$$Diem_preburn_with_resource_$def$0$$t17@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$2$dst@1 inline$$Diem_preburn_with_resource_$def$0$$t16@1)))) (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t18@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@13)) (and (=> $abort_flag@13 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 133142) 137512) inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 133142) 133148) inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct)))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct  (=> (and $abort_flag@12 (= (ControlFlow 0 137532) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_value_$def$1$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 133086) 137532) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 133086) 133142) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct)))))
(let ((inline$$Diem_value_$def$1$anon6_Then_correct  (and (=> (= (ControlFlow 0 133096) 137532) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 133096) 133142) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 133070) 133096) inline$$Diem_value_$def$1$anon6_Then_correct) (=> (= (ControlFlow 0 133070) 133086) inline$$Diem_value_$def$1$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 132994) 133070)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$Diem_value_$def$1$anon5_Then_correct  (=> (= (ControlFlow 0 133104) 133070) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$Diem_value_$def$1$anon0_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 132988) 133104) inline$$Diem_value_$def$1$anon5_Then_correct) (=> (= (ControlFlow 0 132988) 132994) inline$$Diem_value_$def$1$anon5_Else_correct)))))
(let ((inline$$Diem_value$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$3$v@1) (let ((va@@19 (|v#$Vector| inline$$ReadRef$3$v@1)))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 133110) 132988)) inline$$Diem_value_$def$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct  (and (=> (= (ControlFlow 0 133118) (- 0 160100)) true) (=> (= (ControlFlow 0 133118) 133110) inline$$Diem_value$1$anon0_correct))))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 132808) 133118)) inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 132770) 132808))) inline$$ReadRef$3$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct  (=> (and (not $abort_flag@12) (= (ControlFlow 0 132822) 132770)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct  (=> (and $abort_flag@12 (= (ControlFlow 0 137536) 133174)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 132578) 137536) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 132578) 132822) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 132588) 137536) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 132588) 132822) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 132562) 132588) inline$$Diem_value_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 132562) 132578) inline$$Diem_value_$def$0$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 132486) 132562)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 132596) 132562) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Diem_value_$def$0$anon0_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 132480) 132596) inline$$Diem_value_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 132480) 132486) inline$$Diem_value_$def$0$anon5_Else_correct)))))
(let ((inline$$Diem_value$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@0) (let ((va@@20 (|v#$Vector| call4formal@$ret0@0@@0)))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 132602) 132480)) inline$$Diem_value_$def$0$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 11) $EmptyPath inline$$ReadRef$2$v@1)) (= (ControlFlow 0 132312) 132602)) inline$$Diem_value$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 132160) 132312)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct  (=> (= (ControlFlow 0 137544) 132312) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 132152) 137544) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 132152) 132160) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct  (and (=> (= (ControlFlow 0 137552) 137544) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 137552) 132160) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 132144) 137552) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 132144) 132152) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct  (and (=> (= (ControlFlow 0 137560) 137552) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 137560) 132152) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon0_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 132138) 137560) inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 132138) 132144) inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@0) (let ((va@@21 (|v#$Vector| call4formal@$ret0@0@@0)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$2$v@1) (let ((va@@22 (|v#$Vector| inline$$ReadRef$2$v@1)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn)) (let ((va@@23 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (and ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1) (= (ControlFlow 0 137566) 132138))) inline$$Diem_preburn_with_resource_$def$0$anon0_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon29_Then$1_correct  (and (=> (= (ControlFlow 0 137574) (- 0 159675)) true) (=> (= (ControlFlow 0 137574) 137566) inline$$Diem_preburn_with_resource$0$anon0_correct))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 130951) 137574)) inline$$Diem_burn_now_$def$0$anon29_Then$1_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon29_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1) (= (ControlFlow 0 130957) 130951)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon16_correct  (=> (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 130901) 130907)) inline$$Diem_burn_now_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 130899) 130901)) inline$$Diem_burn_now_$def$0$anon16_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 130915) 130901) inline$$Diem_burn_now_$def$0$anon16_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon29_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1)) (= $abort_code@12 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 130893) 130915) inline$$Diem_burn_now_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 130893) 130899) inline$$Diem_burn_now_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon27_Else_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 130881) 130957) inline$$Diem_burn_now_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 130881) 130893) inline$$Diem_burn_now_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon8$7_correct  (=> (and (and (and (= inline$$Diem_burn_now_$def$0$$t14@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@12)) (and (=> $abort_flag@12 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 130875) 145980) inline$$Diem_burn_now_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 130875) 130881) inline$$Diem_burn_now_$def$0$anon27_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct  (=> (and (= inline$$Gt$0$dst@1 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$0$dst@1) (|i#$Integer| inline$$Diem_burn_now_$def$0$$t12@1)))) (= (ControlFlow 0 130863) 130875)) inline$$Diem_burn_now_$def$0$anon8$7_correct)))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 130849) (- 0 159539)) true) (=> (= (ControlFlow 0 130849) 130863) inline$$Gt$0$anon0_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon8$6_correct  (=> (and (= inline$$Diem_burn_now_$def$0$$t12@1 ($Integer 0)) (= (ControlFlow 0 130869) 130849)) inline$$Gt$0$Entry_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (= (ControlFlow 0 130795) 130869)) inline$$Diem_burn_now_$def$0$anon8$6_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 7) $EmptyPath inline$$ReadRef$1$v@1)) (= (ControlFlow 0 130747) 130795)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 130561) 130747)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 146004) 130747) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Diem_burn_now_$def$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 130553) 146004) inline$$Diem_burn_now_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 130553) 130561) inline$$Diem_burn_now_$def$0$anon26_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 146012) 146004) inline$$Diem_burn_now_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 146012) 130561) inline$$Diem_burn_now_$def$0$anon26_Else_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon24_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 130545) 146012) inline$$Diem_burn_now_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 130545) 130553) inline$$Diem_burn_now_$def$0$anon25_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon24_Then_correct  (and (=> (= (ControlFlow 0 146020) 146012) inline$$Diem_burn_now_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 146020) 130553) inline$$Diem_burn_now_$def$0$anon25_Else_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 130537) 146020) inline$$Diem_burn_now_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 130537) 130545) inline$$Diem_burn_now_$def$0$anon24_Else_correct)))))
(let ((inline$$Diem_burn_now_$def$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 146028) 146020) inline$$Diem_burn_now_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 146028) 130545) inline$$Diem_burn_now_$def$0$anon24_Else_correct))))
(let ((inline$$Diem_burn_now_$def$0$anon0_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 130531) 146028) inline$$Diem_burn_now_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 130531) 130537) inline$$Diem_burn_now_$def$0$anon23_Else_correct)))))
(let ((inline$$Diem_burn_now$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@0) (let ((va@@24 (|v#$Vector| call4formal@$ret0@0@@0)))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1) (let ((va@@25 (|v#$Vector| inline$$ReadRef$1$v@1)))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) ((_ is $Address) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1)) (and (and (and (and (and ((_ is $Vector) inline$$Diem_remove_burn_capability_$def$0$$ret0@2) (let ((va@@27 (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_remove_burn_capability_$def$0$$ret0@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 146034) 130531))) inline$$Diem_burn_now_$def$0$anon0_correct))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon78_Else$2_correct  (and (=> (= (ControlFlow 0 146042) (- 0 159302)) true) (=> (= (ControlFlow 0 146042) 146034) inline$$Diem_burn_now$0$anon0_correct))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 129957) 146042)) inline$$TransactionFee_burn_fees_$def$0$anon78_Else$2_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $TransactionFee_TransactionFee_preburn) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) $TransactionFee_TransactionFee_preburn))) (= (ControlFlow 0 129919) 129957))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon78_Else_correct  (=> (and (not $abort_flag@11) (= (ControlFlow 0 129925) 129919)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon78_Then_correct  (=> (and $abort_flag@11 (= (ControlFlow 0 147795) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon20_correct  (=> (= $Diem_BurnCapability_$memory@1 |inline$$MoveFrom$0$m'@2|) (=> (and (= inline$$Diem_remove_burn_capability_$def$0$$ret0@2 inline$$MoveFrom$0$dst@2) (= $abort_flag@11 $abort_flag@10)) (and (=> (= (ControlFlow 0 129705) 147795) inline$$TransactionFee_burn_fees_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 129705) 129925) inline$$TransactionFee_burn_fees_$def$0$anon78_Else_correct))))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 129703) 129705)) inline$$Diem_remove_burn_capability_$def$0$anon20_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 129713) 129705) inline$$Diem_remove_burn_capability_$def$0$anon20_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon28_Else_correct  (=> (not $abort_flag@10) (and (=> (= (ControlFlow 0 129697) 129713) inline$$Diem_remove_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 129697) 129703) inline$$Diem_remove_burn_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_remove_burn_capability_$def$0$$ret0@1 $Error) (= $Diem_BurnCapability_$memory@1 $Diem_BurnCapability_$memory@0)) (and (= inline$$Diem_remove_burn_capability_$def$0$$ret0@2 inline$$Diem_remove_burn_capability_$def$0$$ret0@1) (= $abort_flag@11 true))) (and (=> (= (ControlFlow 0 129429) 147795) inline$$TransactionFee_burn_fees_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 129429) 129925) inline$$TransactionFee_burn_fees_$def$0$anon78_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon5_correct  (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 129765) 129429)) inline$$Diem_remove_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 129763) 129765)) inline$$Diem_remove_burn_capability_$def$0$anon5_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 129773) 129765) inline$$Diem_remove_burn_capability_$def$0$anon5_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon22_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 129757) 129773) inline$$Diem_remove_burn_capability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 129757) 129763) inline$$Diem_remove_burn_capability_$def$0$anon23_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon9_correct  (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 129745) 129429)) inline$$Diem_remove_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 129743) 129745)) inline$$Diem_remove_burn_capability_$def$0$anon9_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 129753) 129745) inline$$Diem_remove_burn_capability_$def$0$anon9_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon24_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 129737) 129753) inline$$Diem_remove_burn_capability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 129737) 129743) inline$$Diem_remove_burn_capability_$def$0$anon25_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon17_correct  (=> (and (= $Diem_BurnCapability_$memory@0 |inline$$MoveFrom$0$m'@2|) (= (ControlFlow 0 129725) 129429)) inline$$Diem_remove_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 129723) 129725)) inline$$Diem_remove_burn_capability_$def$0$anon17_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 129733) 129725) inline$$Diem_remove_burn_capability_$def$0$anon17_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon28_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 129717) 129733) inline$$Diem_remove_burn_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 129717) 129723) inline$$Diem_remove_burn_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct  (=> (= $abort_flag@10 true) (=> (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@0|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@0)) (and (=> (= (ControlFlow 0 129679) 129717) inline$$Diem_remove_burn_capability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 129679) 129697) inline$$Diem_remove_burn_capability_$def$0$anon28_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1)) (= (ControlFlow 0 129677) 129679)) inline$$MoveFrom$0$anon3_Then$1_correct)))
(let ((inline$$MoveFrom$0$anon3_Else_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1) (= inline$$MoveFrom$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1))) (=> (and (and (= |inline$$MoveFrom$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 $Error))) (= $abort_flag@10 $abort_flag@9)) (and (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@1|) (= inline$$MoveFrom$0$dst@2 inline$$MoveFrom$0$dst@1))) (and (=> (= (ControlFlow 0 129625) 129717) inline$$Diem_remove_burn_capability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 129625) 129697) inline$$Diem_remove_burn_capability_$def$0$anon28_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct  (=> (= inline$$MoveFrom$0$a@1 (|a#$Address| call3formal@$ret0@0@@11)) (and (=> (= (ControlFlow 0 129579) 129677) inline$$MoveFrom$0$anon3_Then_correct) (=> (= (ControlFlow 0 129579) 129625) inline$$MoveFrom$0$anon3_Else_correct)))))
(let ((inline$$MoveFrom$0$Entry_correct  (=> (= inline$$MoveFrom$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (and (=> (= (ControlFlow 0 129573) (- 0 158983)) true) (=> (= (ControlFlow 0 129573) 129579) inline$$MoveFrom$0$anon0_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon26_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_remove_burn_capability_$def$0$$t5@1) (= (ControlFlow 0 129687) 129573)) inline$$MoveFrom$0$Entry_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon14_correct  (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 129423) 129429)) inline$$Diem_remove_burn_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 129421) 129423)) inline$$Diem_remove_burn_capability_$def$0$anon14_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 129437) 129423) inline$$Diem_remove_burn_capability_$def$0$anon14_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon26_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_remove_burn_capability_$def$0$$t5@1)) (= $abort_code@10 (|i#$Integer| call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 129415) 129437) inline$$Diem_remove_burn_capability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 129415) 129421) inline$$Diem_remove_burn_capability_$def$0$anon27_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon24_Else_correct  (=> (not $abort_flag@9) (and (=> (= (ControlFlow 0 129403) 129687) inline$$Diem_remove_burn_capability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 129403) 129415) inline$$Diem_remove_burn_capability_$def$0$anon26_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon22_Else_correct  (=> (and (not $abort_flag@8) (= inline$$Diem_remove_burn_capability_$def$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| call3formal@$ret0@0@@11))))) (=> (and (and (and (= inline$$Diem_remove_burn_capability_$def$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9)) (and (=> $abort_flag@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 4))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 129397) 129737) inline$$Diem_remove_burn_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 129397) 129403) inline$$Diem_remove_burn_capability_$def$0$anon24_Else_correct))))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@8) (=> $abort_flag@8 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 tc_account)))) ((_ is $Address) call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 129367) 129757) inline$$Diem_remove_burn_capability_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 129367) 129397) inline$$Diem_remove_burn_capability_$def$0$anon22_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 129331) 129367)) inline$$Diem_remove_burn_capability_$def$0$anon2$1_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 129781) 129367) inline$$Diem_remove_burn_capability_$def$0$anon2$1_correct)))
(let ((inline$$Diem_remove_burn_capability_$def$0$anon0_correct  (=> (not $abort_flag@7) (and (=> (= (ControlFlow 0 129325) 129781) inline$$Diem_remove_burn_capability_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 129325) 129331) inline$$Diem_remove_burn_capability_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability$0$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 129787) 129325)) inline$$Diem_remove_burn_capability_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon77_Else_correct  (=> (and (not true) (= (ControlFlow 0 128885) 129787)) inline$$Diem_remove_burn_capability$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon77_Then_correct  (=> (= (ControlFlow 0 147803) 129787) inline$$Diem_remove_burn_capability$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2)) (and (=> (= (ControlFlow 0 128781) 147803) inline$$TransactionFee_burn_fees_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 128781) 128885) inline$$TransactionFee_burn_fees_$def$0$anon77_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 128837) 147803) inline$$TransactionFee_burn_fees_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 128837) 128885) inline$$TransactionFee_burn_fees_$def$0$anon77_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 128745) 128837) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 128745) 128781) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 128608) 128745)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon76_Then_correct  (=> (and (= inline$$TransactionFee_burn_fees_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 147813) 128745)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) call5formal@$ret1@0@@0)) (and (=> (= (ControlFlow 0 128594) 147813) inline$$TransactionFee_burn_fees_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 128594) 128608) inline$$TransactionFee_burn_fees_$def$0$anon76_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon74_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 128600) 128594)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon72_Else$2_correct  (and (=> (= (ControlFlow 0 128537) (- 0 158427)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7) (=> $abort_flag@7 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Diem_Diem_value))))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value) ($Integer 0))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@0) (let ((va@@28 (|v#$Vector| call4formal@$ret0@0@@0)))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0@@0) (let ((va@@29 (|v#$Vector| call5formal@$ret1@0@@0)))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 128537) 147817) inline$$TransactionFee_burn_fees_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 128537) 128600) inline$$TransactionFee_burn_fees_$def$0$anon74_Else_correct)))))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 128525) 128537)) inline$$TransactionFee_burn_fees_$def$0$anon72_Else$2_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $TransactionFee_TransactionFee_balance) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $TransactionFee_TransactionFee_balance))) (= (ControlFlow 0 128487) 128525))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon72_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 128493) 128487)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@6 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 128357) 147837) inline$$TransactionFee_burn_fees_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 128357) 128493) inline$$TransactionFee_burn_fees_$def$0$anon72_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 128355) 128357)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)))) (and (= $abort_flag@6 $abort_flag@4) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 128303) 147837) inline$$TransactionFee_burn_fees_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 128303) 128493) inline$$TransactionFee_burn_fees_$def$0$anon72_Else_correct)))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 128273) 128355) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 128273) 128303) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (=> (= inline$$BorrowGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (and (=> (= (ControlFlow 0 128267) (- 0 158251)) true) (=> (= (ControlFlow 0 128267) 128273) inline$$BorrowGlobal$0$anon0_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon68_Else_correct  (=> (and (not (|b#$Boolean| call3formal@$ret0@0@@0)) (= (ControlFlow 0 128363) 128267)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon66_Else_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 128148) 147863) inline$$TransactionFee_burn_fees_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 128148) 128363) inline$$TransactionFee_burn_fees_$def$0$anon68_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon65_Else_correct  (=> (and (not $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4)) (=> (and (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@4 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Type $tv0@@10) ($Type $XDX_XDX_type_value)))))))) ((_ is $Boolean) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 128142) 147913) inline$$TransactionFee_burn_fees_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 128142) 128148) inline$$TransactionFee_burn_fees_$def$0$anon66_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon65_Then_correct  (=> (and $abort_flag@3 (= (ControlFlow 0 147933) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 128110) 147933) inline$$TransactionFee_burn_fees_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 128110) 128142) inline$$TransactionFee_burn_fees_$def$0$anon65_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 128120) 147933) inline$$TransactionFee_burn_fees_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 128120) 128142) inline$$TransactionFee_burn_fees_$def$0$anon65_Else_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@3) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$$t0@1 ($Address 186537453))) (and (=> (= (ControlFlow 0 128104) 128120) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 128104) 128110) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon63_Then_correct  (=> (and (|b#$Boolean| inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2) (= (ControlFlow 0 128134) 128104)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 127985) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon64_Then_correct  (=> (= (ControlFlow 0 127999) 127991) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon63_Else_correct  (=> (and (not (|b#$Boolean| inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2)) (= $abort_code@4 (|i#$Integer| call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 127979) 127999) inline$$TransactionFee_burn_fees_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 127979) 127985) inline$$TransactionFee_burn_fees_$def$0$anon64_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon61_Else_correct  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 127967) 128134) inline$$TransactionFee_burn_fees_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 127967) 127979) inline$$TransactionFee_burn_fees_$def$0$anon63_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon60_Else_correct  (=> (not $abort_flag@2) (=> (and (and (and (= inline$$TransactionFee_burn_fees_$def$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3)) (and (=> $abort_flag@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@13) (>= (|i#$Integer| call3formal@$ret0@0@@13) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@13) $MAX_U64))) (and (=> (= (ControlFlow 0 127961) 147937) inline$$TransactionFee_burn_fees_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 127961) 127967) inline$$TransactionFee_burn_fees_$def$0$anon61_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon60_Then_correct  (=> (and $abort_flag@2 (= (ControlFlow 0 147957) 127991)) inline$$TransactionFee_burn_fees_$def$0$Abort_correct)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct  (=> (and (= $abort_flag@2 $abort_flag@1) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2 inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1)) (and (=> (= (ControlFlow 0 127919) 147957) inline$$TransactionFee_burn_fees_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 127919) 127961) inline$$TransactionFee_burn_fees_$def$0$anon60_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 127917) 127919)) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 127927) 127919) inline$$TransactionFee_is_coin_initialized_$def$0$anon4_correct)))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct  (=> (and (not $abort_flag@1) (= inline$$TransactionFee_is_coin_initialized_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1))))) (and (=> (= (ControlFlow 0 127911) 127927) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 127911) 127917) inline$$TransactionFee_is_coin_initialized_$def$0$anon6_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct  (=> (and (and $abort_flag@1 (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1 $Error)) (and (= $abort_flag@2 true) (= inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@2 inline$$TransactionFee_is_coin_initialized_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 127935) 147957) inline$$TransactionFee_burn_fees_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 127935) 127961) inline$$TransactionFee_burn_fees_$def$0$anon60_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 127857) 127935) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 127857) 127911) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 127867) 127935) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 127867) 127911) inline$$TransactionFee_is_coin_initialized_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@1) (= inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$$t0@1 ($Address 186537453))) (and (=> (= (ControlFlow 0 127851) 127867) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 127851) 127857) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 127881) 127851)) inline$$CoreAddresses_TREASURY_COMPLIANCE_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon58_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 127949) 127881)) inline$$TransactionFee_is_coin_initialized_$def$0$anon0_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon56_Else_correct  (=> (and (not $abort_flag@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@1)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@1)) (and (=> $abort_flag@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@2 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 127595) 147961) inline$$TransactionFee_burn_fees_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 127595) 127949) inline$$TransactionFee_burn_fees_$def$0$anon58_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 127589) 147981) inline$$TransactionFee_burn_fees_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 127589) 127595) inline$$TransactionFee_burn_fees_$def$0$anon56_Else_correct))))))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 127553) 127589)) inline$$TransactionFee_burn_fees_$def$0$anon2$1_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 148005) 127589) inline$$TransactionFee_burn_fees_$def$0$anon2$1_correct)))
(let ((inline$$TransactionFee_burn_fees_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 127547) 148005) inline$$TransactionFee_burn_fees_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 127547) 127553) inline$$TransactionFee_burn_fees_$def$0$anon55_Else_correct)))))
(let ((inline$$TransactionFee_burn_fees_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 148009) 127547)) inline$$TransactionFee_burn_fees_$def$0$anon0_correct)))
(let ((inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 126626) 148009)) inline$$TransactionFee_burn_fees_$direct_inter$0$anon0_correct)))
(let ((inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 148037) 148009) inline$$TransactionFee_burn_fees_$direct_inter$0$anon0_correct)))
(let ((inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 126620) 148037) inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 126620) 126626) inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (forall (($inv_addr@@1 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))
))) (and (forall (($inv_addr@@2 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2)) (let ((va@@33 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3)) (let ((va@@34 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0@@1))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@38 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@2))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@5))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@46 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@6))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))
)))) (=> (and (and (and (and (forall (($inv_addr@@4 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4)) (let ((va@@47 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $Diem_Preburn_to_burn)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))
)) (forall (($inv_addr@@5 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5)) (let ((va@@49 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance)) (let ((va@@50 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_balance))) $Diem_Diem_value)) $MAX_U64)))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))) $TransactionFee_TransactionFee_preburn))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64))))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@5))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (= (ControlFlow 0 148041) 126620))))) inline$$burn_txn_fees_burn_txn_fees_$def_verify$0$anon0_correct)))))
(let ((anon0_correct  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 125741) 148041)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 152011) 125741) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
