(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $AccountFreezing_FreezeAccountEvent () T@$TypeName)
(declare-fun $AccountFreezing_FreezeEventsHolder () T@$TypeName)
(declare-fun $AccountFreezing_FreezingBit () T@$TypeName)
(declare-fun $AccountFreezing_UnfreezeAccountEvent () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $ChainId_ChainId () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DesignatedDealer_Dealer () T@$TypeName)
(declare-fun $DesignatedDealer_ReceivedMintEvent () T@$TypeName)
(declare-fun $DesignatedDealer_TierInfo () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $SlidingNonce_SlidingNonce () T@$TypeName)
(declare-fun $DualAttestation_BaseUrlRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_Credential () T@$TypeName)
(declare-fun $DualAttestation_Limit () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $DiemAccount_DiemAccount () T@$TypeName)
(declare-fun $DiemAccount_AccountOperationsCapability () T@$TypeName)
(declare-fun $DiemAccount_AdminTransactionEvent () T@$TypeName)
(declare-fun $DiemAccount_Balance () T@$TypeName)
(declare-fun $DiemAccount_CreateAccountEvent () T@$TypeName)
(declare-fun $DiemAccount_DiemWriteSetManager () T@$TypeName)
(declare-fun $DiemAccount_KeyRotationCapability () T@$TypeName)
(declare-fun $DiemAccount_ReceivedPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_SentPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_WithdrawCapability () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_frozen_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeEventsHolder_freeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezingBit_is_frozen () Int)
(declare-fun $AccountFreezing_FreezingBit_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_unfrozen_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ChainId_ChainId_id () Int)
(declare-fun $ChainId_ChainId_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_Dealer_mint_event_handle () Int)
(declare-fun $DesignatedDealer_Dealer_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_ReceivedMintEvent_currency_code () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_destination_address () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_amount () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_TierInfo_window_start () Int)
(declare-fun $DesignatedDealer_TierInfo_window_inflow () Int)
(declare-fun $DesignatedDealer_TierInfo_tiers () Int)
(declare-fun $DesignatedDealer_TierInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $SlidingNonce_spec_try_record_nonce (T@$Value T@$Value) T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_min_nonce () Int)
(declare-fun $SlidingNonce_SlidingNonce_nonce_mask () Int)
(declare-fun $SlidingNonce_SlidingNonce_type_value () T@$TypeValue)
(declare-fun $DualAttestation_spec_dual_attestation_message (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $DualAttestation_BaseUrlRotationEvent_new_base_url () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Credential_human_name () Int)
(declare-fun $DualAttestation_Credential_base_url () Int)
(declare-fun $DualAttestation_Credential_compliance_public_key () Int)
(declare-fun $DualAttestation_Credential_expiration_date () Int)
(declare-fun $DualAttestation_Credential_compliance_key_rotation_events () Int)
(declare-fun $DualAttestation_Credential_base_url_rotation_events () Int)
(declare-fun $DualAttestation_Credential_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Limit_micro_xdx_limit () Int)
(declare-fun $DualAttestation_Limit_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun $DiemAccount_spec_abstract_create_authentication_key (T@$Value) T@$Value)
(declare-fun $DiemAccount_DiemAccount_authentication_key () Int)
(declare-fun $DiemAccount_DiemAccount_withdraw_capability () Int)
(declare-fun $DiemAccount_DiemAccount_key_rotation_capability () Int)
(declare-fun $DiemAccount_DiemAccount_received_events () Int)
(declare-fun $DiemAccount_DiemAccount_sent_events () Int)
(declare-fun $DiemAccount_DiemAccount_sequence_number () Int)
(declare-fun $DiemAccount_DiemAccount_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AccountOperationsCapability_limits_cap () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_creation_events () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AdminTransactionEvent_committed_timestamp_secs () Int)
(declare-fun $DiemAccount_AdminTransactionEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_Balance_coin () Int)
(declare-fun $DiemAccount_Balance_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemAccount_CreateAccountEvent_created () Int)
(declare-fun $DiemAccount_CreateAccountEvent_role_id () Int)
(declare-fun $DiemAccount_CreateAccountEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_DiemWriteSetManager_upgrade_events () Int)
(declare-fun $DiemAccount_DiemWriteSetManager_type_value () T@$TypeValue)
(declare-fun $DiemAccount_KeyRotationCapability_account_address () Int)
(declare-fun $DiemAccount_KeyRotationCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_ReceivedPaymentEvent_amount () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_payer () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_SentPaymentEvent_amount () Int)
(declare-fun $DiemAccount_SentPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_SentPaymentEvent_payee () Int)
(declare-fun $DiemAccount_SentPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_SentPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_WithdrawCapability_account_address () Int)
(declare-fun $DiemAccount_WithdrawCapability_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $AccountFreezing_FreezeAccountEvent $AccountFreezing_FreezeEventsHolder $AccountFreezing_FreezingBit $AccountFreezing_UnfreezeAccountEvent $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $ChainId_ChainId $FixedPoint32_FixedPoint32 $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $DesignatedDealer_Dealer $DesignatedDealer_ReceivedMintEvent $DesignatedDealer_TierInfo $XDX_XDX $XDX_Reserve $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_Config $ValidatorConfig_ValidatorConfig $VASP_ChildVASP $VASP_ParentVASP $TransactionFee_TransactionFee $SlidingNonce_SlidingNonce $DualAttestation_BaseUrlRotationEvent $DualAttestation_ComplianceKeyRotationEvent $DualAttestation_Credential $DualAttestation_Limit $DiemTransactionPublishingOption_DiemTransactionPublishingOption $DiemAccount_DiemAccount $DiemAccount_AccountOperationsCapability $DiemAccount_AdminTransactionEvent $DiemAccount_Balance $DiemAccount_CreateAccountEvent $DiemAccount_DiemWriteSetManager $DiemAccount_KeyRotationCapability $DiemAccount_ReceivedPaymentEvent $DiemAccount_SentPaymentEvent $DiemAccount_WithdrawCapability)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_FreezeAccountEvent_frozen_address 1))
(assert (= $AccountFreezing_FreezeAccountEvent_type_value ($StructType $AccountFreezing_FreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeEventsHolder_freeze_event_handle 0))
(assert (= $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle 1))
(assert (= $AccountFreezing_FreezeEventsHolder_type_value ($StructType $AccountFreezing_FreezeEventsHolder $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezingBit_is_frozen 0))
(assert (= $AccountFreezing_FreezingBit_type_value ($StructType $AccountFreezing_FreezingBit $EmptyTypeValueArray)))
(assert (= $AccountFreezing_UnfreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_UnfreezeAccountEvent_unfrozen_address 1))
(assert (= $AccountFreezing_UnfreezeAccountEvent_type_value ($StructType $AccountFreezing_UnfreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0@@0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0@@0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@1) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@1))
)))
(assert (= $ChainId_ChainId_id 0))
(assert (= $ChainId_ChainId_type_value ($StructType $ChainId_ChainId $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_Dealer_mint_event_handle 0))
(assert (= $DesignatedDealer_Dealer_type_value ($StructType $DesignatedDealer_Dealer $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_ReceivedMintEvent_currency_code 0))
(assert (= $DesignatedDealer_ReceivedMintEvent_destination_address 1))
(assert (= $DesignatedDealer_ReceivedMintEvent_amount 2))
(assert (= $DesignatedDealer_ReceivedMintEvent_type_value ($StructType $DesignatedDealer_ReceivedMintEvent $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_TierInfo_window_start 0))
(assert (= $DesignatedDealer_TierInfo_window_inflow 1))
(assert (= $DesignatedDealer_TierInfo_tiers 2))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($DesignatedDealer_TierInfo_type_value $tv0@@9) ($StructType $DesignatedDealer_TierInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($DesignatedDealer_TierInfo_type_value $tv0@@9))
)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@10 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@10) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1))) :pattern ( ($Option_Option_type_value $tv0@@10))
)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@11 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@11) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@11))
)))
(assert (forall ((account T@$Value) (seq_nonce T@$Value) )  (and (and ((_ is $Integer) ($SlidingNonce_spec_try_record_nonce account seq_nonce)) (>= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) 0)) (<= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) $MAX_U64))))
(assert (= $SlidingNonce_SlidingNonce_min_nonce 0))
(assert (= $SlidingNonce_SlidingNonce_nonce_mask 1))
(assert (= $SlidingNonce_SlidingNonce_type_value ($StructType $SlidingNonce_SlidingNonce $EmptyTypeValueArray)))
(assert (forall ((payer T@$Value) (metadata T@$Value) (deposit_value T@$Value) )  (and (and ((_ is $Vector) ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value)) (let ((va@@8 (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0))
)))))
(assert (= $DualAttestation_BaseUrlRotationEvent_new_base_url 0))
(assert (= $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_BaseUrlRotationEvent_type_value ($StructType $DualAttestation_BaseUrlRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key 0))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_type_value ($StructType $DualAttestation_ComplianceKeyRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_Credential_human_name 0))
(assert (= $DualAttestation_Credential_base_url 1))
(assert (= $DualAttestation_Credential_compliance_public_key 2))
(assert (= $DualAttestation_Credential_expiration_date 3))
(assert (= $DualAttestation_Credential_compliance_key_rotation_events 4))
(assert (= $DualAttestation_Credential_base_url_rotation_events 5))
(assert (= $DualAttestation_Credential_type_value ($StructType $DualAttestation_Credential $EmptyTypeValueArray)))
(assert (= $DualAttestation_Limit_micro_xdx_limit 0))
(assert (= $DualAttestation_Limit_type_value ($StructType $DualAttestation_Limit $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((auth_key_prefix T@$Value) )  (and (and ((_ is $Vector) ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix)) (let ((va@@9 (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0))
)))))
(assert (= $DiemAccount_DiemAccount_authentication_key 0))
(assert (= $DiemAccount_DiemAccount_withdraw_capability 1))
(assert (= $DiemAccount_DiemAccount_key_rotation_capability 2))
(assert (= $DiemAccount_DiemAccount_received_events 3))
(assert (= $DiemAccount_DiemAccount_sent_events 4))
(assert (= $DiemAccount_DiemAccount_sequence_number 5))
(assert (= $DiemAccount_DiemAccount_type_value ($StructType $DiemAccount_DiemAccount $EmptyTypeValueArray)))
(assert (= $DiemAccount_AccountOperationsCapability_limits_cap 0))
(assert (= $DiemAccount_AccountOperationsCapability_creation_events 1))
(assert (= $DiemAccount_AccountOperationsCapability_type_value ($StructType $DiemAccount_AccountOperationsCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_AdminTransactionEvent_committed_timestamp_secs 0))
(assert (= $DiemAccount_AdminTransactionEvent_type_value ($StructType $DiemAccount_AdminTransactionEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_Balance_coin 0))
(assert (forall (($tv0@@12 T@$TypeValue) ) (! (= ($DiemAccount_Balance_type_value $tv0@@12) ($StructType $DiemAccount_Balance ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1))) :pattern ( ($DiemAccount_Balance_type_value $tv0@@12))
)))
(assert (= $DiemAccount_CreateAccountEvent_created 0))
(assert (= $DiemAccount_CreateAccountEvent_role_id 1))
(assert (= $DiemAccount_CreateAccountEvent_type_value ($StructType $DiemAccount_CreateAccountEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_DiemWriteSetManager_upgrade_events 0))
(assert (= $DiemAccount_DiemWriteSetManager_type_value ($StructType $DiemAccount_DiemWriteSetManager $EmptyTypeValueArray)))
(assert (= $DiemAccount_KeyRotationCapability_account_address 0))
(assert (= $DiemAccount_KeyRotationCapability_type_value ($StructType $DiemAccount_KeyRotationCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_ReceivedPaymentEvent_amount 0))
(assert (= $DiemAccount_ReceivedPaymentEvent_currency_code 1))
(assert (= $DiemAccount_ReceivedPaymentEvent_payer 2))
(assert (= $DiemAccount_ReceivedPaymentEvent_metadata 3))
(assert (= $DiemAccount_ReceivedPaymentEvent_type_value ($StructType $DiemAccount_ReceivedPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_SentPaymentEvent_amount 0))
(assert (= $DiemAccount_SentPaymentEvent_currency_code 1))
(assert (= $DiemAccount_SentPaymentEvent_payee 2))
(assert (= $DiemAccount_SentPaymentEvent_metadata 3))
(assert (= $DiemAccount_SentPaymentEvent_type_value ($StructType $DiemAccount_SentPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_WithdrawCapability_account_address 0))
(assert (= $DiemAccount_WithdrawCapability_type_value ($StructType $DiemAccount_WithdrawCapability $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $SlidingNonce_SlidingNonce_$memory () T@$Memory)
(declare-fun tc_account () T@$Value)
(declare-fun $abort_flag@98 () Bool)
(declare-fun sliding_nonce () T@$Value)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun addr () T@$Value)
(declare-fun $DesignatedDealer_Dealer_$memory () T@$Memory)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun add_all_currencies () T@$Value)
(declare-fun $DesignatedDealer_TierInfo_$memory () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(declare-fun $tv0@@13 () T@$TypeValue)
(declare-fun $DiemAccount_Balance_$memory () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory () T@$Memory)
(declare-fun auth_key_prefix@@0 () T@$Value)
(declare-fun $abort_code@116 () Int)
(declare-fun $DesignatedDealer_Dealer_$memory@4 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@4 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@6 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@14 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@4 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@3 () T@$Memory)
(declare-fun $abort_code@115 () Int)
(declare-fun $AccountFreezing_FreezingBit_$memory@4 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@3 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@3 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@5 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@4 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@3 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@4 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@3 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@13 () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory@3 () T@$Memory)
(declare-fun $abort_flag@97 () Bool)
(declare-fun $DesignatedDealer_Dealer_$memory@2 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@2 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@12 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@2 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@2 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@4 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@2 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@2 () T@$Memory)
(declare-fun $abort_code@114 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $DiemAccount_DiemAccount_$memory () T@$Memory)
(declare-fun $abort_code@5 () Int)
(declare-fun $AccountFreezing_FreezingBit_$memory@1 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@3 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@1 () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory@1 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@1 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@11 () T@$Memory)
(declare-fun $abort_code@113 () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@1 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@1 () T@$Memory)
(declare-fun $abort_code@10 () Int)
(declare-fun $Diem_Preburn_$memory@0 () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory@0 () T@$Memory)
(declare-fun $DesignatedDealer_TierInfo_$memory@0 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@2 () T@$Memory)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $AccountFreezing_FreezingBit_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@112 () Int)
(declare-fun $DiemAccount_Balance_$memory@10 () T@$Memory)
(declare-fun $abort_flag@96 () Bool)
(declare-fun $abort_flag@95 () Bool)
(declare-fun $abort_code@111 () Int)
(declare-fun $abort_flag@89 () Bool)
(declare-fun $abort_code@103 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun call2formal@$AccountFreezing_FreezingBit_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call3formal@$DiemAccount_DiemAccount_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call4formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun $abort_flag@94 () Bool)
(declare-fun $abort_code@109 () Int)
(declare-fun $abort_code@110 () Int)
(declare-fun $abort_code@104 () Int)
(declare-fun $abort_flag@90 () Bool)
(declare-fun $abort_code@105 () Int)
(declare-fun $abort_flag@91 () Bool)
(declare-fun $abort_code@106 () Int)
(declare-fun $abort_flag@92 () Bool)
(declare-fun $abort_code@107 () Int)
(declare-fun $abort_flag@93 () Bool)
(declare-fun $DualAttestation_Credential_$memory () T@$Memory)
(declare-fun inline$$MoveTo$3$a@1 () Int)
(declare-fun |inline$$MoveToRaw$3$m'@1| () T@$Memory)
(declare-fun inline$$DualAttestation_Credential_pack$0$$struct@1 () T@$Value)
(declare-fun human_name () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$Vector_empty$1$v@1 () T@$Value)
(declare-fun inline$$DualAttestation_publish_credential_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Not$5$dst@1 () T@$Value)
(declare-fun $abort_code@108 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$DualAttestation_publish_credential_$def$0$$t11@1 () T@$Value)
(declare-fun inline$$DualAttestation_publish_credential_$def$0$$t9@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_code@102 () Int)
(declare-fun $DiemAccount_Balance_$memory@9 () T@$Memory)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_flag@59 () Bool)
(declare-fun $DiemAccount_Balance_$memory@3 () T@$Memory)
(declare-fun $abort_code@69 () Int)
(declare-fun $abort_flag@86 () Bool)
(declare-fun $DiemAccount_Balance_$memory@6 () T@$Memory)
(declare-fun $abort_code@99 () Int)
(declare-fun $abort_flag@33 () Bool)
(declare-fun $DiemAccount_Balance_$memory@1 () T@$Memory)
(declare-fun $abort_code@40 () Int)
(declare-fun $abort_flag@88 () Bool)
(declare-fun $abort_code@101 () Int)
(declare-fun $DiemAccount_Balance_$memory@8 () T@$Memory)
(declare-fun $abort_code@100 () Int)
(declare-fun $DiemAccount_Balance_$memory@7 () T@$Memory)
(declare-fun $abort_flag@87 () Bool)
(declare-fun $abort_flag@85 () Bool)
(declare-fun |inline$$MoveToRaw$1$m'@2| () T@$Memory)
(declare-fun $abort_code@97 () Int)
(declare-fun $DiemAccount_Balance_$memory@5 () T@$Memory)
(declare-fun $abort_code@98 () Int)
(declare-fun $abort_code@71 () Int)
(declare-fun $DiemAccount_Balance_$memory@4 () T@$Memory)
(declare-fun $abort_flag@61 () Bool)
(declare-fun $abort_code@91 () Int)
(declare-fun $abort_flag@80 () Bool)
(declare-fun $abort_code@92 () Int)
(declare-fun $abort_flag@81 () Bool)
(declare-fun $abort_code@94 () Int)
(declare-fun $abort_flag@82 () Bool)
(declare-fun |inline$$MoveToRaw$1$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$1$a@1 () Int)
(declare-fun |inline$$MoveToRaw$1$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_Balance_pack$1$$struct@1 () T@$Value)
(declare-fun $abort_code@96 () Int)
(declare-fun $abort_flag@84 () Bool)
(declare-fun inline$$DiemAccount_add_currency$1$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Diem_zero_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_flag@83 () Bool)
(declare-fun inline$$Diem_Diem_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$Not$3$dst@1 () T@$Value)
(declare-fun $abort_code@95 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$1$$t12@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$1$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$1$$ret0@2 () T@$Value)
(declare-fun $abort_code@93 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun $abort_flag@79 () Bool)
(declare-fun inline$$DiemAccount_add_currency_$def$1$$t8@1 () T@$Value)
(declare-fun $abort_code@90 () Int)
(declare-fun inline$$Roles_can_hold_balance_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_code@88 () Int)
(declare-fun $abort_flag@77 () Bool)
(declare-fun $abort_code@87 () Int)
(declare-fun $abort_flag@71 () Bool)
(declare-fun $abort_code@81 () Int)
(declare-fun $abort_flag@66 () Bool)
(declare-fun $abort_code@76 () Int)
(declare-fun |inline$$Roles_can_hold_balance_$def$1$tmp#$2@1| () T@$Value)
(declare-fun $abort_code@89 () Int)
(declare-fun $abort_flag@78 () Bool)
(declare-fun inline$$Roles_can_hold_balance_$def$1$$t6@1 () T@$Value)
(declare-fun $abort_code@82 () Int)
(declare-fun $abort_flag@72 () Bool)
(declare-fun |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1| () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$5$$ret0@2 () T@$Value)
(declare-fun $abort_flag@76 () Bool)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$1$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$5$$ret0@1 () T@$Value)
(declare-fun $abort_code@86 () Int)
(declare-fun $abort_code@83 () Int)
(declare-fun $abort_flag@73 () Bool)
(declare-fun $abort_code@84 () Int)
(declare-fun $abort_flag@74 () Bool)
(declare-fun $abort_flag@75 () Bool)
(declare-fun $abort_code@85 () Int)
(declare-fun |inline$$Roles_has_role_$def$5$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$5$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$5$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$1$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$5$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$5$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$5$a@1 () Int)
(declare-fun inline$$GetGlobal$5$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$5$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$5$$t9@1 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$1$$t5@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$4$$ret0@2 () T@$Value)
(declare-fun $abort_flag@70 () Bool)
(declare-fun inline$$Roles_has_child_VASP_role_$def$1$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$4$$ret0@1 () T@$Value)
(declare-fun $abort_code@80 () Int)
(declare-fun $abort_code@77 () Int)
(declare-fun $abort_flag@67 () Bool)
(declare-fun $abort_code@78 () Int)
(declare-fun $abort_flag@68 () Bool)
(declare-fun $abort_flag@69 () Bool)
(declare-fun $abort_code@79 () Int)
(declare-fun |inline$$Roles_has_role_$def$4$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$4$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$4$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$1$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$4$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$4$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$4$a@1 () Int)
(declare-fun inline$$GetGlobal$4$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$4$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$4$$t9@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$3$$ret0@2 () T@$Value)
(declare-fun $abort_flag@65 () Bool)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$1$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$3$$ret0@1 () T@$Value)
(declare-fun $abort_code@75 () Int)
(declare-fun $abort_code@72 () Int)
(declare-fun $abort_flag@62 () Bool)
(declare-fun $abort_code@73 () Int)
(declare-fun $abort_flag@63 () Bool)
(declare-fun $abort_flag@64 () Bool)
(declare-fun $abort_code@74 () Int)
(declare-fun |inline$$Roles_has_role_$def$3$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$3$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$3$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$1$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$3$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$3$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$3$a@1 () Int)
(declare-fun inline$$GetGlobal$3$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$3$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$3$$t9@1 () T@$Value)
(declare-fun $abort_flag@60 () Bool)
(declare-fun inline$$Not$2$dst@1 () T@$Value)
(declare-fun $abort_code@70 () Int)
(declare-fun inline$$DiemAccount_add_currencies_for_account_$def$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun $abort_flag@58 () Bool)
(declare-fun |inline$$MoveToRaw$2$m'@2| () T@$Memory)
(declare-fun $abort_code@67 () Int)
(declare-fun $DiemAccount_Balance_$memory@2 () T@$Memory)
(declare-fun $abort_code@68 () Int)
(declare-fun $abort_code@41 () Int)
(declare-fun $abort_flag@34 () Bool)
(declare-fun $abort_code@61 () Int)
(declare-fun $abort_flag@53 () Bool)
(declare-fun $abort_code@62 () Int)
(declare-fun $abort_flag@54 () Bool)
(declare-fun $abort_code@64 () Int)
(declare-fun $abort_flag@55 () Bool)
(declare-fun |inline$$MoveToRaw$2$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$2$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$2$a@1 () Int)
(declare-fun |inline$$MoveToRaw$2$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_Balance_pack$2$$struct@1 () T@$Value)
(declare-fun $abort_code@66 () Int)
(declare-fun $abort_flag@57 () Bool)
(declare-fun inline$$DiemAccount_add_currency$2$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Diem_zero_$def$2$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$2$$ret0@1 () T@$Value)
(declare-fun $abort_flag@56 () Bool)
(declare-fun inline$$Diem_Diem_pack$2$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$2$$t0@1 () T@$Value)
(declare-fun inline$$Not$4$dst@1 () T@$Value)
(declare-fun $abort_code@65 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$2$$t12@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$2$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$2$$ret0@2 () T@$Value)
(declare-fun $abort_code@63 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun $abort_flag@52 () Bool)
(declare-fun inline$$DiemAccount_add_currency_$def$2$$t8@1 () T@$Value)
(declare-fun $abort_code@60 () Int)
(declare-fun inline$$Roles_can_hold_balance_$def$2$$ret0@1 () T@$Value)
(declare-fun $abort_code@58 () Int)
(declare-fun $abort_flag@50 () Bool)
(declare-fun $abort_code@57 () Int)
(declare-fun $abort_flag@44 () Bool)
(declare-fun $abort_code@51 () Int)
(declare-fun $abort_flag@39 () Bool)
(declare-fun $abort_code@46 () Int)
(declare-fun |inline$$Roles_can_hold_balance_$def$2$tmp#$2@1| () T@$Value)
(declare-fun $abort_code@59 () Int)
(declare-fun $abort_flag@51 () Bool)
(declare-fun inline$$Roles_can_hold_balance_$def$2$$t6@1 () T@$Value)
(declare-fun $abort_code@52 () Int)
(declare-fun $abort_flag@45 () Bool)
(declare-fun |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1| () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$2$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$8$$ret0@2 () T@$Value)
(declare-fun $abort_flag@49 () Bool)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$2$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$8$$ret0@1 () T@$Value)
(declare-fun $abort_code@56 () Int)
(declare-fun $abort_code@53 () Int)
(declare-fun $abort_flag@46 () Bool)
(declare-fun $abort_code@54 () Int)
(declare-fun $abort_flag@47 () Bool)
(declare-fun $abort_flag@48 () Bool)
(declare-fun $abort_code@55 () Int)
(declare-fun |inline$$Roles_has_role_$def$8$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$8$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$8$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$2$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$8$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$8$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$8$a@1 () Int)
(declare-fun inline$$GetGlobal$8$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$8$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$8$$t9@1 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$2$$t5@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$2$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$7$$ret0@2 () T@$Value)
(declare-fun $abort_flag@43 () Bool)
(declare-fun inline$$Roles_has_child_VASP_role_$def$2$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$7$$ret0@1 () T@$Value)
(declare-fun $abort_code@50 () Int)
(declare-fun $abort_code@47 () Int)
(declare-fun $abort_flag@40 () Bool)
(declare-fun $abort_code@48 () Int)
(declare-fun $abort_flag@41 () Bool)
(declare-fun $abort_flag@42 () Bool)
(declare-fun $abort_code@49 () Int)
(declare-fun |inline$$Roles_has_role_$def$7$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$7$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$7$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$2$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$7$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$7$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$7$a@1 () Int)
(declare-fun inline$$GetGlobal$7$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$7$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$7$$t9@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$6$$ret0@2 () T@$Value)
(declare-fun $abort_flag@38 () Bool)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$2$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$6$$ret0@1 () T@$Value)
(declare-fun $abort_code@45 () Int)
(declare-fun $abort_code@42 () Int)
(declare-fun $abort_flag@35 () Bool)
(declare-fun $abort_code@43 () Int)
(declare-fun $abort_flag@36 () Bool)
(declare-fun $abort_flag@37 () Bool)
(declare-fun $abort_code@44 () Int)
(declare-fun |inline$$Roles_has_role_$def$6$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$6$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$6$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$2$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$6$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$6$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$6$a@1 () Int)
(declare-fun inline$$GetGlobal$6$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$6$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$6$$t9@1 () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currencies_for_account_$def$0$$t5@1 () T@$Value)
(declare-fun $abort_flag@32 () Bool)
(declare-fun $abort_code@38 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@39 () Int)
(declare-fun $DiemAccount_Balance_$memory@0 () T@$Memory)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@32 () Int)
(declare-fun $abort_flag@27 () Bool)
(declare-fun $abort_code@33 () Int)
(declare-fun $abort_flag@28 () Bool)
(declare-fun $abort_code@35 () Int)
(declare-fun $abort_flag@29 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_Balance_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_code@37 () Int)
(declare-fun $abort_flag@31 () Bool)
(declare-fun inline$$Diem_zero_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@30 () Bool)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@36 () Int)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$0$$t12@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$0$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@34 () Int)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun $abort_flag@26 () Bool)
(declare-fun inline$$DiemAccount_add_currency_$def$0$$t8@1 () T@$Value)
(declare-fun $abort_code@31 () Int)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@29 () Int)
(declare-fun $abort_flag@24 () Bool)
(declare-fun $abort_code@28 () Int)
(declare-fun $abort_flag@18 () Bool)
(declare-fun $abort_code@22 () Int)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_code@17 () Int)
(declare-fun |inline$$Roles_can_hold_balance_$def$0$tmp#$2@1| () T@$Value)
(declare-fun $abort_code@30 () Int)
(declare-fun $abort_flag@25 () Bool)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$t6@1 () T@$Value)
(declare-fun $abort_code@23 () Int)
(declare-fun $abort_flag@19 () Bool)
(declare-fun |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$ret0@2 () T@$Value)
(declare-fun $abort_flag@23 () Bool)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$ret0@1 () T@$Value)
(declare-fun $abort_code@27 () Int)
(declare-fun $abort_code@24 () Int)
(declare-fun $abort_flag@20 () Bool)
(declare-fun $abort_code@25 () Int)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $abort_flag@22 () Bool)
(declare-fun $abort_code@26 () Int)
(declare-fun |inline$$Roles_has_role_$def$2$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$2$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$2$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$2$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$2$a@1 () Int)
(declare-fun inline$$GetGlobal$2$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$t9@1 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$t5@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$ret0@2 () T@$Value)
(declare-fun $abort_flag@17 () Bool)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_code@21 () Int)
(declare-fun $abort_code@18 () Int)
(declare-fun $abort_flag@14 () Bool)
(declare-fun $abort_code@19 () Int)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_code@20 () Int)
(declare-fun |inline$$Roles_has_role_$def$1$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$1$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$1$a@1 () Int)
(declare-fun inline$$GetGlobal$1$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$t9@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@12 () Bool)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@16 () Int)
(declare-fun $abort_code@13 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_code@15 () Int)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1 () T@$Value)
(declare-fun call4formal@$DesignatedDealer_Dealer_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call5formal@$DesignatedDealer_TierInfo_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@8 () Int)
(declare-fun $Roles_RoleId_$memory@1 () T@$Memory)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $Roles_RoleId_$memory@0 () T@$Memory)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun inline$$Roles_new_designated_dealer_role_$def$0$$t4@1 () T@$Value)
(declare-fun inline$$Roles_new_designated_dealer_role_$def$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$Roles_new_designated_dealer_role$0$$Roles_RoleId_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@20 () T@$Value)
(declare-fun inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t7@1 () T@$Value)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun $AccountFreezing_FreezeEventsHolder_$memory () T@$Memory)
(declare-fun $ChainId_ChainId_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(declare-fun $XDX_Reserve_$memory () T@$Memory)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory () T@$Memory)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory () T@$Memory)
(declare-fun $TransactionFee_TransactionFee_$memory () T@$Memory)
(declare-fun $DualAttestation_Limit_$memory () T@$Memory)
(declare-fun $DiemAccount_DiemWriteSetManager_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 335333) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 331115) (- 0 364296)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364316)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364337)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364349)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364361)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364376)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364396)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364424)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364441)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364475)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@0 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@0)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@0)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@0 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@0)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@0)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364496)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364530)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364557)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364582)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364622)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@1 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@1)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@1)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@1 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@1)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@1)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364649)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364689)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364722)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364753)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364777)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364794)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364854)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364914)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 0)))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 0)))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364927)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 1)))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 1)))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364940)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364952)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 364982)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 365013)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 365033)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 365061)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@98)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@98) (and (=> (= (ControlFlow 0 331115) (- 0 365078)) (=> $abort_flag@98 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@2 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@2)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@2)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@3 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@3)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@3)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 0))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 1))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))))) (=> (=> $abort_flag@98 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@2 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@2)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@2)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@3 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@3)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@3)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 0))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 1))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (and (=> (= (ControlFlow 0 331115) (- 0 365831)) (=> $abort_flag@98 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0))))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@116 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@116 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@116 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@4 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@4)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@4)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@5 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@5)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@5)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 0)))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 1)))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@116 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@116 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@98 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0))))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@116 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@116 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@116 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@4 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@4)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@4)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@5 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@5)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@5)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 0)))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 1)))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (= $abort_code@116 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) (= $abort_code@116 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@116 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@116 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@116 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 331115) (- 0 366914)) (=> $abort_flag@98 (or (or (or (or (= $abort_code@116 (|i#$Integer| ($Integer 7))) (= $abort_code@116 (|i#$Integer| ($Integer 2)))) (= $abort_code@116 (|i#$Integer| ($Integer 5)))) (= $abort_code@116 (|i#$Integer| ($Integer 6)))) (= $abort_code@116 (|i#$Integer| ($Integer 3)))))) (=> (=> $abort_flag@98 (or (or (or (or (= $abort_code@116 (|i#$Integer| ($Integer 7))) (= $abort_code@116 (|i#$Integer| ($Integer 2)))) (= $abort_code@116 (|i#$Integer| ($Integer 5)))) (= $abort_code@116 (|i#$Integer| ($Integer 6)))) (= $abort_code@116 (|i#$Integer| ($Integer 3))))) (and (=> (= (ControlFlow 0 331115) (- 0 366970)) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory@4) $EmptyTypeValueArray (|a#$Address| addr)))))) (=> (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory@4) $EmptyTypeValueArray (|a#$Address| addr))))) (and (=> (= (ControlFlow 0 331115) (- 0 366984)) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@4) $EmptyTypeValueArray (|a#$Address| addr)))))) (=> (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@4) $EmptyTypeValueArray (|a#$Address| addr))))) (and (=> (= (ControlFlow 0 331115) (- 0 366996)) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@6) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@6) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 2))))))))) (=> (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@6) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@6) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (and (=> (= (ControlFlow 0 331115) (- 0 367008)) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))))) (=> (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))) (and (=> (= (ControlFlow 0 331115) (- 0 367034)) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)) ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Vector (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Integer 0)) (+ len@@1 1))))) (+ len@@0 1))))))))) (=> (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)) ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Vector (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Integer 0)) (+ len@@1 1))))) (+ len@@0 1)))))))) (and (=> (= (ControlFlow 0 331115) (- 0 367080)) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))))) (=> (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))) (and (=> (= (ControlFlow 0 331115) (- 0 367149)) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)) ($Vector (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 ($Vector (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Integer 0)) (+ len@@3 1))))) (+ len@@2 1)))))))))))) (=> (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)) ($Vector (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 ($Vector (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Integer 0)) (+ len@@3 1))))) (+ len@@2 1))))))))))) (and (=> (= (ControlFlow 0 331115) (- 0 367238)) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr))))))))) (=> (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))) (=> (= (ControlFlow 0 331115) (- 0 367307)) (=> (not $abort_flag@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr)) ($Vector (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 ($Vector (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Integer 0)) (+ len@@5 1))))) (+ len@@4 1))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$Abort_correct  (=> (= $Diem_Preburn_$memory@4 $Diem_Preburn_$memory@3) (=> (and (= $abort_flag@98 true) (= $abort_code@116 $abort_code@115)) (=> (and (and (and (= $AccountFreezing_FreezingBit_$memory@4 $AccountFreezing_FreezingBit_$memory@3) (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3)) (and (= $Roles_RoleId_$memory@6 $Roles_RoleId_$memory@5) (= $DiemAccount_AccountOperationsCapability_$memory@4 $DiemAccount_AccountOperationsCapability_$memory@3))) (and (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory@3) (= $DiemAccount_Balance_$memory@14 $DiemAccount_Balance_$memory@13)) (and (= $DesignatedDealer_Dealer_$memory@4 $DesignatedDealer_Dealer_$memory@3) (= (ControlFlow 0 331057) 331115)))) anon0$2_correct)))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon24_Then_correct  (=> $abort_flag@97 (=> (and (= $DesignatedDealer_Dealer_$memory@3 $DesignatedDealer_Dealer_$memory@2) (= $Diem_Preburn_$memory@3 $Diem_Preburn_$memory@2)) (=> (and (and (and (= $DiemAccount_Balance_$memory@13 $DiemAccount_Balance_$memory@12) (= $DesignatedDealer_TierInfo_$memory@3 $DesignatedDealer_TierInfo_$memory@2)) (and (= $DiemAccount_AccountOperationsCapability_$memory@3 $DiemAccount_AccountOperationsCapability_$memory@2) (= $Roles_RoleId_$memory@5 $Roles_RoleId_$memory@4))) (and (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@2) (= $AccountFreezing_FreezingBit_$memory@3 $AccountFreezing_FreezingBit_$memory@2)) (and (= $abort_code@115 $abort_code@114) (= (ControlFlow 0 331053) 331057)))) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$Abort_correct)))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon23_Then_correct  (=> $abort_flag@2 (=> (and (= $DesignatedDealer_Dealer_$memory@3 $DesignatedDealer_Dealer_$memory) (= $Diem_Preburn_$memory@3 $Diem_Preburn_$memory)) (=> (and (and (and (= $DiemAccount_Balance_$memory@13 $DiemAccount_Balance_$memory) (= $DesignatedDealer_TierInfo_$memory@3 $DesignatedDealer_TierInfo_$memory)) (and (= $DiemAccount_AccountOperationsCapability_$memory@3 $DiemAccount_AccountOperationsCapability_$memory) (= $Roles_RoleId_$memory@5 $Roles_RoleId_$memory))) (and (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory) (= $AccountFreezing_FreezingBit_$memory@3 $AccountFreezing_FreezingBit_$memory)) (and (= $abort_code@115 $abort_code@5) (= (ControlFlow 0 331061) 331057)))) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$Abort_correct)))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon24_Else_correct  (=> (and (and (not $abort_flag@97) (= $Diem_Preburn_$memory@4 $Diem_Preburn_$memory@2)) (and (= $abort_flag@98 $abort_flag@97) (= $abort_code@116 $abort_code@114))) (=> (and (and (and (= $AccountFreezing_FreezingBit_$memory@4 $AccountFreezing_FreezingBit_$memory@2) (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@2)) (and (= $Roles_RoleId_$memory@6 $Roles_RoleId_$memory@4) (= $DiemAccount_AccountOperationsCapability_$memory@4 $DiemAccount_AccountOperationsCapability_$memory@2))) (and (and (= $DesignatedDealer_TierInfo_$memory@4 $DesignatedDealer_TierInfo_$memory@2) (= $DiemAccount_Balance_$memory@14 $DiemAccount_Balance_$memory@12)) (and (= $DesignatedDealer_Dealer_$memory@4 $DesignatedDealer_Dealer_$memory@2) (= (ControlFlow 0 331049) 331115)))) anon0$2_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$Abort_correct  (=> (and (= $AccountFreezing_FreezingBit_$memory@2 $AccountFreezing_FreezingBit_$memory@1) (= $abort_flag@97 true)) (=> (and (and (and (= $Roles_RoleId_$memory@4 $Roles_RoleId_$memory@3) (= $DesignatedDealer_TierInfo_$memory@2 $DesignatedDealer_TierInfo_$memory@1)) (and (= $DesignatedDealer_Dealer_$memory@2 $DesignatedDealer_Dealer_$memory@1) (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1))) (and (and (= $DiemAccount_Balance_$memory@12 $DiemAccount_Balance_$memory@11) (= $abort_code@114 $abort_code@113)) (and (= $DiemAccount_AccountOperationsCapability_$memory@2 $DiemAccount_AccountOperationsCapability_$memory@1) (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@1)))) (and (=> (= (ControlFlow 0 330911) 331053) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 330911) 331049) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon13_correct  (=> (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (=> (and (and (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@113 $abort_code@5)) (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory))) (and (and (= $DesignatedDealer_Dealer_$memory@1 $DesignatedDealer_Dealer_$memory) (= $DesignatedDealer_TierInfo_$memory@1 $DesignatedDealer_TierInfo_$memory)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory) (= (ControlFlow 0 330983) 330911)))) inline$$DiemAccount_create_designated_dealer_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 330981) 330983)) inline$$DiemAccount_create_designated_dealer_$def$0$anon13_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 330991) 330983) inline$$DiemAccount_create_designated_dealer_$def$0$anon13_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon38_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 330975) 330991) inline$$DiemAccount_create_designated_dealer_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 330975) 330981) inline$$DiemAccount_create_designated_dealer_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon17_correct  (=> (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (=> (and (and (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@113 $abort_code@5)) (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory))) (and (and (= $DesignatedDealer_Dealer_$memory@1 $DesignatedDealer_Dealer_$memory) (= $DesignatedDealer_TierInfo_$memory@1 $DesignatedDealer_TierInfo_$memory)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory) (= (ControlFlow 0 330963) 330911)))) inline$$DiemAccount_create_designated_dealer_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 330961) 330963)) inline$$DiemAccount_create_designated_dealer_$def$0$anon17_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 330971) 330963) inline$$DiemAccount_create_designated_dealer_$def$0$anon17_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon40_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 330955) 330971) inline$$DiemAccount_create_designated_dealer_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 330955) 330961) inline$$DiemAccount_create_designated_dealer_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon23_correct  (=> (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (=> (and (and (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@113 $abort_code@10)) (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory@0))) (and (and (= $DesignatedDealer_Dealer_$memory@1 $DesignatedDealer_Dealer_$memory@0) (= $DesignatedDealer_TierInfo_$memory@1 $DesignatedDealer_TierInfo_$memory@0)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 330939) 330911)))) inline$$DiemAccount_create_designated_dealer_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 330937) 330939)) inline$$DiemAccount_create_designated_dealer_$def$0$anon23_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 330947) 330939) inline$$DiemAccount_create_designated_dealer_$def$0$anon23_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon43_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 330931) 330947) inline$$DiemAccount_create_designated_dealer_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 330931) 330937) inline$$DiemAccount_create_designated_dealer_$def$0$anon44_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon31_correct  (=> (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory@0) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory@0)) (=> (and (and (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory@0) (= $abort_code@113 $abort_code@112)) (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory@10) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory@0))) (and (and (= $DesignatedDealer_Dealer_$memory@1 $DesignatedDealer_Dealer_$memory@0) (= $DesignatedDealer_TierInfo_$memory@1 $DesignatedDealer_TierInfo_$memory@0)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 330907) 330911)))) inline$$DiemAccount_create_designated_dealer_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 330905) 330907)) inline$$DiemAccount_create_designated_dealer_$def$0$anon31_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 330919) 330907) inline$$DiemAccount_create_designated_dealer_$def$0$anon31_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon47_Then_correct  (=> $abort_flag@96 (and (=> (= (ControlFlow 0 330899) 330919) inline$$DiemAccount_create_designated_dealer_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 330899) 330905) inline$$DiemAccount_create_designated_dealer_$def$0$anon48_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon46_Then_correct  (=> $abort_flag@95 (=> (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (=> (and (and (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@113 $abort_code@111)) (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory@10) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory@0))) (and (and (= $DesignatedDealer_Dealer_$memory@1 $DesignatedDealer_Dealer_$memory@0) (= $DesignatedDealer_TierInfo_$memory@1 $DesignatedDealer_TierInfo_$memory@0)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 330923) 330911)))) inline$$DiemAccount_create_designated_dealer_$def$0$Abort_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon45_Then_correct  (=> $abort_flag@89 (=> (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (=> (and (and (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@113 $abort_code@103)) (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory@10) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory@0))) (and (and (= $DesignatedDealer_Dealer_$memory@1 $DesignatedDealer_Dealer_$memory@0) (= $DesignatedDealer_TierInfo_$memory@1 $DesignatedDealer_TierInfo_$memory@0)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 330927) 330911)))) inline$$DiemAccount_create_designated_dealer_$def$0$Abort_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon42_Then_correct  (=> $abort_flag@5 (=> (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (=> (and (and (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@113 $abort_code@9)) (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory) (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory))) (and (and (= $DesignatedDealer_Dealer_$memory@1 $DesignatedDealer_Dealer_$memory) (= $DesignatedDealer_TierInfo_$memory@1 $DesignatedDealer_TierInfo_$memory)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 330951) 330911)))) inline$$DiemAccount_create_designated_dealer_$def$0$Abort_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon47_Else_correct  (=> (not $abort_flag@96) (=> (and (= $AccountFreezing_FreezingBit_$memory@2 $AccountFreezing_FreezingBit_$memory@0) (= $abort_flag@97 $abort_flag@96)) (=> (and (and (and (= $Roles_RoleId_$memory@4 $Roles_RoleId_$memory@2) (= $DesignatedDealer_TierInfo_$memory@2 $DesignatedDealer_TierInfo_$memory@0)) (and (= $DesignatedDealer_Dealer_$memory@2 $DesignatedDealer_Dealer_$memory@0) (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@0))) (and (and (= $DiemAccount_Balance_$memory@12 $DiemAccount_Balance_$memory@10) (= $abort_code@114 $abort_code@112)) (and (= $DiemAccount_AccountOperationsCapability_$memory@2 $DiemAccount_AccountOperationsCapability_$memory@0) (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0)))) (and (=> (= (ControlFlow 0 330895) 331053) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 330895) 331049) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon24_Else_correct)))))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon46_Else_correct  (=> (and (and (not $abort_flag@95) (= call2formal@$AccountFreezing_FreezingBit_$CallerDomain@0 ($ConstMemoryDomain true))) (and (= call3formal@$DiemAccount_DiemAccount_$CallerDomain@0 ($ConstMemoryDomain true)) (= call4formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 ($ConstMemoryDomain true)))) (and (=> (= (ControlFlow 0 330889) (- 0 363049)) (|Select_[$TypeValueArray,$int]$bool| call2formal@$AccountFreezing_FreezingBit_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| addr))) (=> (|Select_[$TypeValueArray,$int]$bool| call2formal@$AccountFreezing_FreezingBit_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| addr)) (and (=> (= (ControlFlow 0 330889) (- 0 363059)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| addr))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| addr)) (and (=> (= (ControlFlow 0 330889) (- 0 363069)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 0)))) $abort_flag@96) (=> (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 1)))) $abort_flag@96) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $abort_flag@96)) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@96) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) $abort_flag@96)) (and (=> $abort_flag@96 (or (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 1))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))))) (=> $abort_flag@96 (or (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 0)))) (= $abort_code@112 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified addr ($Address 1)))) (= $abort_code@112 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (= $abort_code@112 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@112 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) (= $abort_code@112 (|i#$Integer| ($Integer 7)))))))) (and (and (=> (not $abort_flag@96) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (=> (not $abort_flag@96) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))))) (and (=> (not $abort_flag@96) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) $AccountFreezing_FreezingBit_is_frozen))))))))) (=> (not $abort_flag@96) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_AccountOperationsCapability_creation_events (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_AccountOperationsCapability_creation_events)) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (and (and (and (=> (not $abort_flag@96) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))) (=> (not $abort_flag@96) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))) (and (= (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) (= (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))))) (and (and (= (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) (= (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr))))) (and (= (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 330889) 330899) inline$$DiemAccount_create_designated_dealer_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 330889) 330895) inline$$DiemAccount_create_designated_dealer_$def$0$anon47_Else_correct))))))))))))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon68_Else_correct  (=> (not $abort_flag@94) (=> (and (= $abort_code@111 $abort_code@109) (= $abort_flag@95 $abort_flag@94)) (and (=> (= (ControlFlow 0 330667) 330923) inline$$DiemAccount_create_designated_dealer_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 330667) 330889) inline$$DiemAccount_create_designated_dealer_$def$0$anon46_Else_correct))))))
(let ((inline$$DualAttestation_publish_credential_$def$0$Abort_correct  (=> (and (= $abort_code@111 $abort_code@110) (= $abort_flag@95 true)) (and (=> (= (ControlFlow 0 329649) 330923) inline$$DiemAccount_create_designated_dealer_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 329649) 330889) inline$$DiemAccount_create_designated_dealer_$def$0$anon46_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon9_correct  (=> (and (= $abort_code@110 $abort_code@104) (= (ControlFlow 0 330839) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 330837) 330839)) inline$$DualAttestation_publish_credential_$def$0$anon9_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 330847) 330839) inline$$DualAttestation_publish_credential_$def$0$anon9_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon50_Then_correct  (=> $abort_flag@90 (and (=> (= (ControlFlow 0 330831) 330847) inline$$DualAttestation_publish_credential_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 330831) 330837) inline$$DualAttestation_publish_credential_$def$0$anon51_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon13_correct  (=> (and (= $abort_code@110 $abort_code@105) (= (ControlFlow 0 330819) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 330817) 330819)) inline$$DualAttestation_publish_credential_$def$0$anon13_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 330827) 330819) inline$$DualAttestation_publish_credential_$def$0$anon13_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon52_Then_correct  (=> $abort_flag@91 (and (=> (= (ControlFlow 0 330811) 330827) inline$$DualAttestation_publish_credential_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 330811) 330817) inline$$DualAttestation_publish_credential_$def$0$anon53_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon17_correct  (=> (and (= $abort_code@110 $abort_code@106) (= (ControlFlow 0 330799) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 330797) 330799)) inline$$DualAttestation_publish_credential_$def$0$anon17_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 330807) 330799) inline$$DualAttestation_publish_credential_$def$0$anon17_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon54_Then_correct  (=> $abort_flag@92 (and (=> (= (ControlFlow 0 330791) 330807) inline$$DualAttestation_publish_credential_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 330791) 330797) inline$$DualAttestation_publish_credential_$def$0$anon55_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon21_correct  (=> (and (= $abort_code@110 $abort_code@107) (= (ControlFlow 0 330779) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 330777) 330779)) inline$$DualAttestation_publish_credential_$def$0$anon21_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 330787) 330779) inline$$DualAttestation_publish_credential_$def$0$anon21_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon56_Then_correct  (=> $abort_flag@93 (and (=> (= (ControlFlow 0 330771) 330787) inline$$DualAttestation_publish_credential_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 330771) 330777) inline$$DualAttestation_publish_credential_$def$0$anon57_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon29_correct  (=> (and (= $abort_code@110 $abort_code@107) (= (ControlFlow 0 330759) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 330757) 330759)) inline$$DualAttestation_publish_credential_$def$0$anon29_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon61_Then_correct  (=> (= (ControlFlow 0 330767) 330759) inline$$DualAttestation_publish_credential_$def$0$anon29_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon60_Then_correct  (=> $abort_flag@93 (and (=> (= (ControlFlow 0 330751) 330767) inline$$DualAttestation_publish_credential_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 330751) 330757) inline$$DualAttestation_publish_credential_$def$0$anon61_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon33_correct  (=> (and (= $abort_code@110 $abort_code@107) (= (ControlFlow 0 330739) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 330737) 330739)) inline$$DualAttestation_publish_credential_$def$0$anon33_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon63_Then_correct  (=> (= (ControlFlow 0 330747) 330739) inline$$DualAttestation_publish_credential_$def$0$anon33_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon62_Then_correct  (=> $abort_flag@93 (and (=> (= (ControlFlow 0 330731) 330747) inline$$DualAttestation_publish_credential_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 330731) 330737) inline$$DualAttestation_publish_credential_$def$0$anon63_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon37_correct  (=> (and (= $abort_code@110 $abort_code@107) (= (ControlFlow 0 330719) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 330717) 330719)) inline$$DualAttestation_publish_credential_$def$0$anon37_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon65_Then_correct  (=> (= (ControlFlow 0 330727) 330719) inline$$DualAttestation_publish_credential_$def$0$anon37_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon64_Then_correct  (=> $abort_flag@93 (and (=> (= (ControlFlow 0 330711) 330727) inline$$DualAttestation_publish_credential_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 330711) 330717) inline$$DualAttestation_publish_credential_$def$0$anon65_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon41_correct  (=> (and (= $abort_code@110 $abort_code@107) (= (ControlFlow 0 330699) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 330697) 330699)) inline$$DualAttestation_publish_credential_$def$0$anon41_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon67_Then_correct  (=> (= (ControlFlow 0 330707) 330699) inline$$DualAttestation_publish_credential_$def$0$anon41_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon66_Then_correct  (=> $abort_flag@93 (and (=> (= (ControlFlow 0 330691) 330707) inline$$DualAttestation_publish_credential_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 330691) 330697) inline$$DualAttestation_publish_credential_$def$0$anon67_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon45_correct  (=> (and (= $abort_code@110 $abort_code@109) (= (ControlFlow 0 330679) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 330677) 330679)) inline$$DualAttestation_publish_credential_$def$0$anon45_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon69_Then_correct  (=> (= (ControlFlow 0 330687) 330679) inline$$DualAttestation_publish_credential_$def$0$anon45_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon68_Then_correct  (=> $abort_flag@94 (and (=> (= (ControlFlow 0 330671) 330687) inline$$DualAttestation_publish_credential_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 330671) 330677) inline$$DualAttestation_publish_credential_$def$0$anon69_Else_correct)))))
(let ((inline$$MoveToRaw$3$anon3_Then$1_correct  (=> (and (= $abort_flag@94 true) (= $abort_code@109 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 330645) 330671) inline$$DualAttestation_publish_credential_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 330645) 330667) inline$$DualAttestation_publish_credential_$def$0$anon68_Else_correct)))))
(let ((inline$$MoveToRaw$3$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$3$a@1) (= (ControlFlow 0 330643) 330645)) inline$$MoveToRaw$3$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$3$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$3$a@1)) (= |inline$$MoveToRaw$3$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$3$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$3$a@1 inline$$DualAttestation_Credential_pack$0$$struct@1)))) (and (= $abort_flag@94 $abort_flag@93) (= $abort_code@109 $abort_code@107))) (and (=> (= (ControlFlow 0 330593) 330671) inline$$DualAttestation_publish_credential_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 330593) 330667) inline$$DualAttestation_publish_credential_$def$0$anon68_Else_correct)))))
(let ((inline$$MoveTo$3$anon0$1_correct  (=> (= inline$$MoveTo$3$a@1 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 330651) 330643) inline$$MoveToRaw$3$anon3_Then_correct) (=> (= (ControlFlow 0 330651) 330593) inline$$MoveToRaw$3$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$3$Entry_correct  (and (=> (= (ControlFlow 0 330439) (- 0 362751)) true) (=> (= (ControlFlow 0 330439) 330651) inline$$MoveTo$3$anon0$1_correct))))
(let ((inline$$DualAttestation_Credential_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 330325) 330439)) inline$$Signer_borrow_address$3$Entry_correct)))
(let ((inline$$DualAttestation_Credential_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 330331) 330439) inline$$Signer_borrow_address$3$Entry_correct)))
(let ((inline$$DualAttestation_Credential_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 330319) 330331) inline$$DualAttestation_Credential_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 330319) 330325) inline$$DualAttestation_Credential_pack$0$anon4_Else_correct)))))
(let ((inline$$DualAttestation_Credential_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 330311) 330439)) inline$$Signer_borrow_address$3$Entry_correct)))
(let ((inline$$DualAttestation_Credential_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) human_name) (let ((va@@10 (|v#$Vector| human_name)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (forall ((inline$$DualAttestation_Credential_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DualAttestation_Credential_pack$0$$$0 0) (< inline$$DualAttestation_Credential_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0))
))) (and (and ((_ is $Vector) inline$$Vector_empty$0$v@1) (let ((va@@11 (|v#$Vector| inline$$Vector_empty$0$v@1)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (forall ((inline$$DualAttestation_Credential_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DualAttestation_Credential_pack$0$$$0@@0 0) (< inline$$DualAttestation_Credential_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0))
)))) (and (and (and ((_ is $Vector) inline$$Vector_empty$1$v@1) (let ((va@@12 (|v#$Vector| inline$$Vector_empty$1$v@1)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (forall ((inline$$DualAttestation_Credential_pack$0$$$0@@1 Int) ) (!  (=> (and (>= inline$$DualAttestation_Credential_pack$0$$$0@@1 0) (< inline$$DualAttestation_Credential_pack$0$$$0@@1 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1))
))) (and (and ((_ is $Integer) inline$$DualAttestation_publish_credential_$def$0$$t15@1) (>= (|i#$Integer| inline$$DualAttestation_publish_credential_$def$0$$t15@1) 0)) (<= (|i#$Integer| inline$$DualAttestation_publish_credential_$def$0$$t15@1) $MAX_U64)))) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@13 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1))
))) true) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$1$res@0) (let ((va@@15 (|v#$Vector| inline$$Event_new_event_handle$1$res@0)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2))
))) true) (= inline$$DualAttestation_Credential_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 human_name) 1 inline$$Vector_empty$0$v@1) 2 inline$$Vector_empty$1$v@1) 3 inline$$DualAttestation_publish_credential_$def$0$$t15@1) 4 inline$$Event_new_event_handle$0$res@0) 5 inline$$Event_new_event_handle$1$res@0) 6)))) (and (=> (= (ControlFlow 0 330303) 330319) inline$$DualAttestation_Credential_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 330303) 330311) inline$$DualAttestation_Credential_pack$0$anon3_Else_correct)))))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon66_Else_correct  (=> (and (not $abort_flag@93) (= (ControlFlow 0 330337) 330303)) inline$$DualAttestation_Credential_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$1$Entry_correct  (=> (= inline$$Event_new_event_handle$1$t@0 $DualAttestation_BaseUrlRotationEvent_type_value) (and (=> (= (ControlFlow 0 329817) 330691) inline$$DualAttestation_publish_credential_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 329817) 330337) inline$$DualAttestation_publish_credential_$def$0$anon66_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon64_Else_correct  (=> (and (not $abort_flag@93) (= (ControlFlow 0 329825) 329817)) inline$$Event_new_event_handle$1$Entry_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $DualAttestation_ComplianceKeyRotationEvent_type_value) (and (=> (= (ControlFlow 0 329775) 330711) inline$$DualAttestation_publish_credential_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 329775) 329825) inline$$DualAttestation_publish_credential_$def$0$anon64_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon62_Else_correct  (=> (not $abort_flag@93) (=> (and (= inline$$DualAttestation_publish_credential_$def$0$$t15@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 329783) 329775)) inline$$Event_new_event_handle$0$Entry_correct))))
(let ((inline$$Vector_empty$1$anon0_correct  (=> (= inline$$Vector_empty$1$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 329731) 330731) inline$$DualAttestation_publish_credential_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 329731) 329783) inline$$DualAttestation_publish_credential_$def$0$anon62_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct  (=> (and (= inline$$Vector_empty$1$ta@0 $IntegerType) (= (ControlFlow 0 329727) 329731)) inline$$Vector_empty$1$anon0_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon60_Else_correct  (=> (and (not $abort_flag@93) (= (ControlFlow 0 329737) 329727)) inline$$Vector_empty$1$Entry_correct)))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 329690) 330751) inline$$DualAttestation_publish_credential_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 329690) 329737) inline$$DualAttestation_publish_credential_$def$0$anon60_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 $IntegerType) (= (ControlFlow 0 329686) 329690)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon58_Then_correct  (=> (and (|b#$Boolean| inline$$Not$5$dst@1) (= (ControlFlow 0 329696) 329686)) inline$$Vector_empty$0$Entry_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon26_correct  (=> (and (= $abort_code@110 $abort_code@108) (= (ControlFlow 0 329645) 329649)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 329643) 329645)) inline$$DualAttestation_publish_credential_$def$0$anon26_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon59_Then_correct  (=> (= (ControlFlow 0 329657) 329645) inline$$DualAttestation_publish_credential_$def$0$anon26_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon58_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$5$dst@1)) (= $abort_code@108 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 329637) 329657) inline$$DualAttestation_publish_credential_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 329637) 329643) inline$$DualAttestation_publish_credential_$def$0$anon59_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon56_Else_correct  (=> (not $abort_flag@93) (and (=> (= (ControlFlow 0 329625) 329696) inline$$DualAttestation_publish_credential_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 329625) 329637) inline$$DualAttestation_publish_credential_$def$0$anon58_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon54_Else$1_correct  (=> (and (and (and (= inline$$DualAttestation_publish_credential_$def$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@93)) (and (=> $abort_flag@93 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@93) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 329619) 330771) inline$$DualAttestation_publish_credential_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 329619) 329625) inline$$DualAttestation_publish_credential_$def$0$anon56_Else_correct)))))
(let ((inline$$Not$5$anon0_correct  (=> (and (= inline$$Not$5$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DualAttestation_publish_credential_$def$0$$t9@1)))) (= (ControlFlow 0 329607) 329619)) inline$$DualAttestation_publish_credential_$def$0$anon54_Else$1_correct)))
(let ((inline$$Not$5$Entry_correct  (and (=> (= (ControlFlow 0 329597) (- 0 362298)) true) (=> (= (ControlFlow 0 329597) 329607) inline$$Not$5$anon0_correct))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon54_Else_correct  (=> (not $abort_flag@92) (=> (and (= inline$$DualAttestation_publish_credential_$def$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@0)))) (= (ControlFlow 0 329613) 329597)) inline$$Not$5$Entry_correct))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon52_Else_correct  (=> (not $abort_flag@91) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@92) (=> $abort_flag@92 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@92) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 addr)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 329551) 330791) inline$$DualAttestation_publish_credential_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 329551) 329613) inline$$DualAttestation_publish_credential_$def$0$anon54_Else_correct))))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon50_Else_correct  (=> (and (not $abort_flag@90) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@91)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@91) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@91)) (and (=> $abort_flag@91 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@91 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@105 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@105 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@105 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 329545) 330811) inline$$DualAttestation_publish_credential_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 329545) 329551) inline$$DualAttestation_publish_credential_$def$0$anon52_Else_correct))))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon6$3_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr))))))) $abort_flag@90) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 2)))))))) $abort_flag@90)) (and (=> $abort_flag@90 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 2)))))))))) (=> $abort_flag@90 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr))))))) (= $abort_code@104 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (= $abort_code@104 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 329539) 330831) inline$$DualAttestation_publish_credential_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 329539) 329545) inline$$DualAttestation_publish_credential_$def$0$anon50_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 329435) 329539)) inline$$DualAttestation_publish_credential_$def$0$anon6$3_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon49_Then_correct  (=> (= (ControlFlow 0 330855) 329539) inline$$DualAttestation_publish_credential_$def$0$anon6$3_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon48_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 329427) 330855) inline$$DualAttestation_publish_credential_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 329427) 329435) inline$$DualAttestation_publish_credential_$def$0$anon49_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon48_Then_correct  (and (=> (= (ControlFlow 0 330863) 330855) inline$$DualAttestation_publish_credential_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 330863) 329435) inline$$DualAttestation_publish_credential_$def$0$anon49_Else_correct))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon47_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 329419) 330863) inline$$DualAttestation_publish_credential_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 329419) 329427) inline$$DualAttestation_publish_credential_$def$0$anon48_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon47_Then_correct  (and (=> (= (ControlFlow 0 330871) 330863) inline$$DualAttestation_publish_credential_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 330871) 329427) inline$$DualAttestation_publish_credential_$def$0$anon48_Else_correct))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon0_correct  (=> (not $abort_flag@89) (and (=> (= (ControlFlow 0 329413) 330871) inline$$DualAttestation_publish_credential_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 329413) 329419) inline$$DualAttestation_publish_credential_$def$0$anon47_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential$0$anon0_correct  (=> (and ((_ is $Address) addr) ((_ is $Address) tc_account)) (=> (and (and (and ((_ is $Vector) human_name) (let ((va@@17 (|v#$Vector| human_name)))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (forall ((inline$$DualAttestation_publish_credential$0$$$0 Int) ) (!  (=> (and (>= inline$$DualAttestation_publish_credential$0$$$0 0) (< inline$$DualAttestation_publish_credential$0$$$0 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_publish_credential$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_publish_credential$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_publish_credential$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_publish_credential$0$$$0))
))) (= (ControlFlow 0 330875) 329413)) inline$$DualAttestation_publish_credential_$def$0$anon0_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon45_Else_correct  (=> (and (not $abort_flag@89) (= (ControlFlow 0 330881) 330875)) inline$$DualAttestation_publish_credential$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct  (=> (= $abort_flag@89 true) (=> (and (= $abort_code@103 $abort_code@102) (= $DiemAccount_Balance_$memory@10 $DiemAccount_Balance_$memory@9)) (and (=> (= (ControlFlow 0 322261) 330927) inline$$DiemAccount_create_designated_dealer_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 322261) 330881) inline$$DiemAccount_create_designated_dealer_$def$0$anon45_Else_correct))))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon7_correct  (=> (= $DiemAccount_Balance_$memory@9 $DiemAccount_Balance_$memory) (=> (and (= $abort_code@102 $abort_code@11) (= (ControlFlow 0 328518) 322261)) inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 328516) 328518)) inline$$DiemAccount_add_currencies_for_account_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 328526) 328518) inline$$DiemAccount_add_currencies_for_account_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon23_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 328510) 328526) inline$$DiemAccount_add_currencies_for_account_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 328510) 328516) inline$$DiemAccount_add_currencies_for_account_$def$0$anon24_Else_correct)))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Then_correct  (=> (and (and $abort_flag@59 (= $DiemAccount_Balance_$memory@9 $DiemAccount_Balance_$memory@3)) (and (= $abort_code@102 $abort_code@69) (= (ControlFlow 0 328502) 322261))) inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Then_correct  (=> (and (and $abort_flag@86 (= $DiemAccount_Balance_$memory@9 $DiemAccount_Balance_$memory@6)) (and (= $abort_code@102 $abort_code@99) (= (ControlFlow 0 322257) 322261))) inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Then_correct  (=> (and (and $abort_flag@33 (= $DiemAccount_Balance_$memory@9 $DiemAccount_Balance_$memory@1)) (and (= $abort_code@102 $abort_code@40) (= (ControlFlow 0 328506) 322261))) inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$L10_correct  (=> (= $abort_flag@89 $abort_flag@88) (=> (and (= $abort_code@103 $abort_code@101) (= $DiemAccount_Balance_$memory@10 $DiemAccount_Balance_$memory@8)) (and (=> (= (ControlFlow 0 315850) 330927) inline$$DiemAccount_create_designated_dealer_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 315850) 330881) inline$$DiemAccount_create_designated_dealer_$def$0$anon45_Else_correct))))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$L9_correct  (=> (and (and (= $abort_code@101 $abort_code@100) (= $DiemAccount_Balance_$memory@8 $DiemAccount_Balance_$memory@7)) (and (= $abort_flag@88 $abort_flag@87) (= (ControlFlow 0 316016) 315850))) inline$$DiemAccount_add_currencies_for_account_$def$0$L10_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Else_correct  (=> (not $abort_flag@86) (=> (and (and (= $DiemAccount_Balance_$memory@7 $DiemAccount_Balance_$memory@6) (= $abort_flag@87 $abort_flag@86)) (and (= $abort_code@100 $abort_code@99) (= (ControlFlow 0 322253) 316016))) inline$$DiemAccount_add_currencies_for_account_$def$0$L9_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon50_Else_correct  (=> (and (and (not $abort_flag@85) (= $DiemAccount_Balance_$memory@6 |inline$$MoveToRaw$1$m'@2|)) (and (= $abort_flag@86 $abort_flag@85) (= $abort_code@99 $abort_code@97))) (and (=> (= (ControlFlow 0 322119) 322257) inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 322119) 322253) inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$Abort_correct  (=> (= $DiemAccount_Balance_$memory@6 $DiemAccount_Balance_$memory@5) (=> (and (= $abort_flag@86 true) (= $abort_code@99 $abort_code@98)) (and (=> (= (ControlFlow 0 321046) 322257) inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 321046) 322253) inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon5_correct  (=> (= $abort_code@98 $abort_code@71) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 322219) 321046)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 322217) 322219)) inline$$DiemAccount_add_currency_$def$1$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon37_Then_correct  (=> (= (ControlFlow 0 322227) 322219) inline$$DiemAccount_add_currency_$def$1$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon36_Then_correct  (=> $abort_flag@61 (and (=> (= (ControlFlow 0 322211) 322227) inline$$DiemAccount_add_currency_$def$1$anon37_Then_correct) (=> (= (ControlFlow 0 322211) 322217) inline$$DiemAccount_add_currency_$def$1$anon37_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon11_correct  (=> (= $abort_code@98 $abort_code@91) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 322195) 321046)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 322193) 322195)) inline$$DiemAccount_add_currency_$def$1$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon40_Then_correct  (=> (= (ControlFlow 0 322203) 322195) inline$$DiemAccount_add_currency_$def$1$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon39_Then_correct  (=> $abort_flag@80 (and (=> (= (ControlFlow 0 322187) 322203) inline$$DiemAccount_add_currency_$def$1$anon40_Then_correct) (=> (= (ControlFlow 0 322187) 322193) inline$$DiemAccount_add_currency_$def$1$anon40_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon19_correct  (=> (= $abort_code@98 $abort_code@92) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 322175) 321046)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 322173) 322175)) inline$$DiemAccount_add_currency_$def$1$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon44_Then_correct  (=> (= (ControlFlow 0 322183) 322175) inline$$DiemAccount_add_currency_$def$1$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon43_Then_correct  (=> $abort_flag@81 (and (=> (= (ControlFlow 0 322167) 322183) inline$$DiemAccount_add_currency_$def$1$anon44_Then_correct) (=> (= (ControlFlow 0 322167) 322173) inline$$DiemAccount_add_currency_$def$1$anon44_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon23_correct  (=> (= $abort_code@98 $abort_code@94) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 322155) 321046)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 322153) 322155)) inline$$DiemAccount_add_currency_$def$1$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon46_Then_correct  (=> (= (ControlFlow 0 322163) 322155) inline$$DiemAccount_add_currency_$def$1$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon45_Then_correct  (=> $abort_flag@82 (and (=> (= (ControlFlow 0 322147) 322163) inline$$DiemAccount_add_currency_$def$1$anon46_Then_correct) (=> (= (ControlFlow 0 322147) 322153) inline$$DiemAccount_add_currency_$def$1$anon46_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon33_correct  (=> (= $abort_code@98 $abort_code@97) (=> (and (= $DiemAccount_Balance_$memory@5 |inline$$MoveToRaw$1$m'@2|) (= (ControlFlow 0 322131) 321046)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 322129) 322131)) inline$$DiemAccount_add_currency_$def$1$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon51_Then_correct  (=> (= (ControlFlow 0 322139) 322131) inline$$DiemAccount_add_currency_$def$1$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon50_Then_correct  (=> $abort_flag@85 (and (=> (= (ControlFlow 0 322123) 322139) inline$$DiemAccount_add_currency_$def$1$anon51_Then_correct) (=> (= (ControlFlow 0 322123) 322129) inline$$DiemAccount_add_currency_$def$1$anon51_Else_correct)))))
(let ((inline$$MoveToRaw$1$anon3_Then$1_correct  (=> (= $abort_code@97 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@85 true) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@0|)) (and (=> (= (ControlFlow 0 322097) 322123) inline$$DiemAccount_add_currency_$def$1$anon50_Then_correct) (=> (= (ControlFlow 0 322097) 322119) inline$$DiemAccount_add_currency_$def$1$anon50_Else_correct))))))
(let ((inline$$MoveToRaw$1$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1) (= (ControlFlow 0 322095) 322097)) inline$$MoveToRaw$1$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$1$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1)) (=> (and (and (= |inline$$MoveToRaw$1$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@4) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 inline$$DiemAccount_Balance_pack$1$$struct@1))) (= $abort_code@97 $abort_code@96)) (and (= $abort_flag@85 $abort_flag@84) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@1|))) (and (=> (= (ControlFlow 0 322045) 322123) inline$$DiemAccount_add_currency_$def$1$anon50_Then_correct) (=> (= (ControlFlow 0 322045) 322119) inline$$DiemAccount_add_currency_$def$1$anon50_Else_correct))))))
(let ((inline$$MoveTo$1$anon0$1_correct  (=> (= inline$$MoveTo$1$a@1 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 322103) 322095) inline$$MoveToRaw$1$anon3_Then_correct) (=> (= (ControlFlow 0 322103) 322045) inline$$MoveToRaw$1$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$1$Entry_correct  (and (=> (= (ControlFlow 0 321891) (- 0 361204)) true) (=> (= (ControlFlow 0 321891) 322103) inline$$MoveTo$1$anon0$1_correct))))
(let ((inline$$MoveTo$1$Entry_correct  (=> (and (= inline$$MoveTo$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1)) (= (ControlFlow 0 321863) 321891)) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$1$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 321765) 321863)) inline$$MoveTo$1$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$1$anon4_Then_correct  (=> (= (ControlFlow 0 321771) 321863) inline$$MoveTo$1$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 321759) 321771) inline$$DiemAccount_Balance_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 321759) 321765) inline$$DiemAccount_Balance_pack$1$anon4_Else_correct)))))
(let ((inline$$DiemAccount_Balance_pack$1$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 321751) 321863)) inline$$MoveTo$1$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$1$$ret0@2) (let ((va@@18 (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$DiemAccount_Balance_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 321743) 321759) inline$$DiemAccount_Balance_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 321743) 321751) inline$$DiemAccount_Balance_pack$1$anon3_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon49_Else_correct  (=> (and (not $abort_flag@84) (= (ControlFlow 0 321777) 321743)) inline$$DiemAccount_Balance_pack$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon49_Then_correct  (=> (and (and $abort_flag@84 (= $abort_code@98 $abort_code@96)) (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 322143) 321046))) inline$$DiemAccount_add_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_zero_$def$1$anon3_correct  (=> (= inline$$Diem_zero_$def$1$$ret0@1 $Error) (=> (and (= $abort_flag@84 true) (= inline$$Diem_zero_$def$1$$ret0@2 inline$$Diem_zero_$def$1$$ret0@1)) (and (=> (= (ControlFlow 0 321582) 322143) inline$$DiemAccount_add_currency_$def$1$anon49_Then_correct) (=> (= (ControlFlow 0 321582) 321777) inline$$DiemAccount_add_currency_$def$1$anon49_Else_correct))))))
(let ((inline$$Diem_zero_$def$1$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 321576) 321582)) inline$$Diem_zero_$def$1$anon3_correct)))
(let ((inline$$Diem_zero_$def$1$anon8_Then_correct  (=> (= (ControlFlow 0 321590) 321582) inline$$Diem_zero_$def$1$anon3_correct)))
(let ((inline$$Diem_zero_$def$1$anon7_Then_correct  (=> $abort_flag@83 (and (=> (= (ControlFlow 0 321570) 321590) inline$$Diem_zero_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 321570) 321576) inline$$Diem_zero_$def$1$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon6_correct  (=> (and (= $abort_flag@84 $abort_flag@83) (= inline$$Diem_zero_$def$1$$ret0@2 inline$$Diem_Diem_pack$1$$struct@1)) (and (=> (= (ControlFlow 0 321558) 322143) inline$$DiemAccount_add_currency_$def$1$anon49_Then_correct) (=> (= (ControlFlow 0 321558) 321777) inline$$DiemAccount_add_currency_$def$1$anon49_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 321556) 321558)) inline$$Diem_zero_$def$1$anon6_correct)))
(let ((inline$$Diem_zero_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 321566) 321558) inline$$Diem_zero_$def$1$anon6_correct)))
(let ((inline$$Diem_Diem_pack$1$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 321534) 321566) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 321534) 321556) inline$$Diem_zero_$def$1$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon4_Then_correct  (and (=> (= (ControlFlow 0 321540) 321566) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 321540) 321556) inline$$Diem_zero_$def$1$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 321528) 321540) inline$$Diem_Diem_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 321528) 321534) inline$$Diem_Diem_pack$1$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 321520) 321566) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 321520) 321556) inline$$Diem_zero_$def$1$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$1$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$t0@1) 1)))) (and (=> (= (ControlFlow 0 321512) 321528) inline$$Diem_Diem_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 321512) 321520) inline$$Diem_Diem_pack$1$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon7_Else_correct  (=> (not $abort_flag@83) (=> (and (= inline$$Diem_zero_$def$1$$t0@1 ($Integer 0)) (= (ControlFlow 0 321546) 321512)) inline$$Diem_Diem_pack$1$anon0_correct))))
(let ((inline$$Diem_zero_$def$1$anon0_correct  (=> (and (and (not $abort_flag@82) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@83)) (and (=> $abort_flag@83 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@83 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@96 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 321371) 321570) inline$$Diem_zero_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 321371) 321546) inline$$Diem_zero_$def$1$anon7_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon47_Then_correct  (=> (and (|b#$Boolean| inline$$Not$3$dst@1) (= (ControlFlow 0 321604) 321371)) inline$$Diem_zero_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon28_correct  (=> (= $abort_code@98 $abort_code@95) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 321166) 321046)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 321164) 321166)) inline$$DiemAccount_add_currency_$def$1$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon48_Then_correct  (=> (= (ControlFlow 0 321174) 321166) inline$$DiemAccount_add_currency_$def$1$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon47_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$3$dst@1)) (= $abort_code@95 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 321158) 321174) inline$$DiemAccount_add_currency_$def$1$anon48_Then_correct) (=> (= (ControlFlow 0 321158) 321164) inline$$DiemAccount_add_currency_$def$1$anon48_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon45_Else_correct  (=> (not $abort_flag@82) (and (=> (= (ControlFlow 0 321146) 321604) inline$$DiemAccount_add_currency_$def$1$anon47_Then_correct) (=> (= (ControlFlow 0 321146) 321158) inline$$DiemAccount_add_currency_$def$1$anon47_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon43_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$1$$t12@1 ($Integer 15)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@82)) (and (=> $abort_flag@82 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@82) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 321140) 322147) inline$$DiemAccount_add_currency_$def$1$anon45_Then_correct) (=> (= (ControlFlow 0 321140) 321146) inline$$DiemAccount_add_currency_$def$1$anon45_Else_correct)))))
(let ((inline$$Not$3$anon0_correct  (=> (and (= inline$$Not$3$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currency_$def$1$$t10@1)))) (= (ControlFlow 0 321128) 321140)) inline$$DiemAccount_add_currency_$def$1$anon43_Else$1_correct)))
(let ((inline$$Not$3$Entry_correct  (and (=> (= (ControlFlow 0 321118) (- 0 360747)) true) (=> (= (ControlFlow 0 321118) 321128) inline$$Not$3$anon0_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon43_Else_correct  (=> (not $abort_flag@81) (=> (and (= inline$$DiemAccount_add_currency_$def$1$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@2)))) (= (ControlFlow 0 321134) 321118)) inline$$Not$3$Entry_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon41_Then_correct  (=> (|b#$Boolean| inline$$Roles_can_hold_balance_$def$1$$ret0@2) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@81) (=> $abort_flag@81 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@81) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 addr)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 321060) 322167) inline$$DiemAccount_add_currency_$def$1$anon43_Then_correct) (=> (= (ControlFlow 0 321060) 321134) inline$$DiemAccount_add_currency_$def$1$anon43_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon16_correct  (=> (= $abort_code@98 $abort_code@93) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 321042) 321046)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 321040) 321042)) inline$$DiemAccount_add_currency_$def$1$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon42_Then_correct  (=> (= (ControlFlow 0 321054) 321042) inline$$DiemAccount_add_currency_$def$1$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_can_hold_balance_$def$1$$ret0@2)) (= $abort_code@93 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 321034) 321054) inline$$DiemAccount_add_currency_$def$1$anon42_Then_correct) (=> (= (ControlFlow 0 321034) 321040) inline$$DiemAccount_add_currency_$def$1$anon42_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon39_Else_correct  (=> (not $abort_flag@80) (and (=> (= (ControlFlow 0 321022) 321060) inline$$DiemAccount_add_currency_$def$1$anon41_Then_correct) (=> (= (ControlFlow 0 321022) 321034) inline$$DiemAccount_add_currency_$def$1$anon41_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon38_Else_correct  (=> (not $abort_flag@79) (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$1$$t8@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@80)) (and (=> $abort_flag@80 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@80) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 321016) 322187) inline$$DiemAccount_add_currency_$def$1$anon39_Then_correct) (=> (= (ControlFlow 0 321016) 321022) inline$$DiemAccount_add_currency_$def$1$anon39_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon38_Then_correct  (=> (and (and $abort_flag@79 (= $abort_code@98 $abort_code@90)) (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 322207) 321046))) inline$$DiemAccount_add_currency_$def$1$Abort_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$Abort_correct  (=> (and (and (= inline$$Roles_can_hold_balance_$def$1$$ret0@1 $Error) (= inline$$Roles_can_hold_balance_$def$1$$ret0@2 inline$$Roles_can_hold_balance_$def$1$$ret0@1)) (and (= $abort_code@90 $abort_code@88) (= $abort_flag@79 true))) (and (=> (= (ControlFlow 0 320854) 322207) inline$$DiemAccount_add_currency_$def$1$anon38_Then_correct) (=> (= (ControlFlow 0 320854) 321016) inline$$DiemAccount_add_currency_$def$1$anon38_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon26_Then_correct  (=> $abort_flag@77 (=> (and (= $abort_code@88 $abort_code@87) (= (ControlFlow 0 320848) 320854)) inline$$Roles_can_hold_balance_$def$1$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon23_Then_correct  (=> $abort_flag@71 (=> (and (= $abort_code@88 $abort_code@81) (= (ControlFlow 0 320918) 320854)) inline$$Roles_can_hold_balance_$def$1$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon20_Then_correct  (=> $abort_flag@66 (=> (and (= $abort_code@88 $abort_code@76) (= (ControlFlow 0 320982) 320854)) inline$$Roles_can_hold_balance_$def$1$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon18_correct  (=> (= inline$$Roles_can_hold_balance_$def$1$$ret0@2 |inline$$Roles_can_hold_balance_$def$1$tmp#$2@1|) (=> (and (= $abort_code@90 $abort_code@89) (= $abort_flag@79 $abort_flag@78)) (and (=> (= (ControlFlow 0 320836) 322207) inline$$DiemAccount_add_currency_$def$1$anon38_Then_correct) (=> (= (ControlFlow 0 320836) 321016) inline$$DiemAccount_add_currency_$def$1$anon38_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 320834) 320836)) inline$$Roles_can_hold_balance_$def$1$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon27_Then_correct  (=> (= (ControlFlow 0 320844) 320836) inline$$Roles_can_hold_balance_$def$1$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon14_correct  (=> (= |inline$$Roles_can_hold_balance_$def$1$tmp#$2@1| inline$$Roles_can_hold_balance_$def$1$$t6@1) (=> (and (= $abort_code@89 $abort_code@82) (= $abort_flag@78 $abort_flag@72)) (and (=> (= (ControlFlow 0 320906) 320844) inline$$Roles_can_hold_balance_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 320906) 320834) inline$$Roles_can_hold_balance_$def$1$anon27_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 320904) 320906)) inline$$Roles_can_hold_balance_$def$1$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon25_Then_correct  (=> (= (ControlFlow 0 320914) 320906) inline$$Roles_can_hold_balance_$def$1$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon24_Then_correct  (=> (and (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1|) (= inline$$Roles_can_hold_balance_$def$1$$t6@1 ($Boolean true))) (and (=> (= (ControlFlow 0 320896) 320914) inline$$Roles_can_hold_balance_$def$1$anon25_Then_correct) (=> (= (ControlFlow 0 320896) 320904) inline$$Roles_can_hold_balance_$def$1$anon25_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon26_Else_correct  (=> (and (and (not $abort_flag@77) (= |inline$$Roles_can_hold_balance_$def$1$tmp#$2@1| inline$$Roles_has_designated_dealer_role_$def$1$$ret0@2)) (and (= $abort_code@89 $abort_code@87) (= $abort_flag@78 $abort_flag@77))) (and (=> (= (ControlFlow 0 320824) 320844) inline$$Roles_can_hold_balance_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 320824) 320834) inline$$Roles_can_hold_balance_$def$1$anon27_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon6_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$1$$ret0@2 inline$$Roles_has_role_$def$5$$ret0@2) (= $abort_flag@77 $abort_flag@76)) (and (=> (= (ControlFlow 0 320778) 320848) inline$$Roles_can_hold_balance_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 320778) 320824) inline$$Roles_can_hold_balance_$def$1$anon26_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 320776) 320778)) inline$$Roles_has_designated_dealer_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 320786) 320778) inline$$Roles_has_designated_dealer_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon8_Else_correct  (=> (not $abort_flag@76) (and (=> (= (ControlFlow 0 320770) 320786) inline$$Roles_has_designated_dealer_role_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 320770) 320776) inline$$Roles_has_designated_dealer_role_$def$1$anon9_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon8_Then_correct  (=> (and (and $abort_flag@76 (= inline$$Roles_has_designated_dealer_role_$def$1$$ret0@1 $Error)) (and (= inline$$Roles_has_designated_dealer_role_$def$1$$ret0@2 inline$$Roles_has_designated_dealer_role_$def$1$$ret0@1) (= $abort_flag@77 true))) (and (=> (= (ControlFlow 0 320794) 320848) inline$$Roles_can_hold_balance_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 320794) 320824) inline$$Roles_can_hold_balance_$def$1$anon26_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$5$$ret0@1 $Error) (= $abort_flag@76 true)) (and (= $abort_code@87 $abort_code@86) (= inline$$Roles_has_role_$def$5$$ret0@2 inline$$Roles_has_role_$def$5$$ret0@1))) (and (=> (= (ControlFlow 0 320702) 320794) inline$$Roles_has_designated_dealer_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 320702) 320770) inline$$Roles_has_designated_dealer_role_$def$1$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon7_correct  (=> (and (= $abort_code@86 $abort_code@83) (= (ControlFlow 0 320722) 320702)) inline$$Roles_has_role_$def$5$Abort_correct)))
(let ((inline$$Roles_has_role_$def$5$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 320720) 320722)) inline$$Roles_has_role_$def$5$anon7_correct)))
(let ((inline$$Roles_has_role_$def$5$anon24_Then_correct  (=> (= (ControlFlow 0 320730) 320722) inline$$Roles_has_role_$def$5$anon7_correct)))
(let ((inline$$Roles_has_role_$def$5$anon23_Then_correct  (=> $abort_flag@73 (and (=> (= (ControlFlow 0 320714) 320730) inline$$Roles_has_role_$def$5$anon24_Then_correct) (=> (= (ControlFlow 0 320714) 320720) inline$$Roles_has_role_$def$5$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon13_correct  (=> (and (= $abort_code@86 $abort_code@84) (= (ControlFlow 0 320696) 320702)) inline$$Roles_has_role_$def$5$Abort_correct)))
(let ((inline$$Roles_has_role_$def$5$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 320694) 320696)) inline$$Roles_has_role_$def$5$anon13_correct)))
(let ((inline$$Roles_has_role_$def$5$anon27_Then_correct  (=> (= (ControlFlow 0 320710) 320696) inline$$Roles_has_role_$def$5$anon13_correct)))
(let ((inline$$Roles_has_role_$def$5$anon26_Then_correct  (=> $abort_flag@74 (and (=> (= (ControlFlow 0 320688) 320710) inline$$Roles_has_role_$def$5$anon27_Then_correct) (=> (= (ControlFlow 0 320688) 320694) inline$$Roles_has_role_$def$5$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon20_correct  (=> (= $abort_flag@76 $abort_flag@75) (=> (and (= $abort_code@87 $abort_code@85) (= inline$$Roles_has_role_$def$5$$ret0@2 |inline$$Roles_has_role_$def$5$tmp#$3@2|)) (and (=> (= (ControlFlow 0 320409) 320794) inline$$Roles_has_designated_dealer_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 320409) 320770) inline$$Roles_has_designated_dealer_role_$def$1$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$5$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 320407) 320409)) inline$$Roles_has_role_$def$5$anon20_correct)))
(let ((inline$$Roles_has_role_$def$5$anon30_Then_correct  (=> (= (ControlFlow 0 320417) 320409) inline$$Roles_has_role_$def$5$anon20_correct)))
(let ((inline$$Roles_has_role_$def$5$anon16_correct  (=> (= $abort_flag@75 $abort_flag@74) (=> (and (= |inline$$Roles_has_role_$def$5$tmp#$3@2| |inline$$Roles_has_role_$def$5$tmp#$3@1|) (= $abort_code@85 $abort_code@84)) (and (=> (= (ControlFlow 0 320676) 320417) inline$$Roles_has_role_$def$5$anon30_Then_correct) (=> (= (ControlFlow 0 320676) 320407) inline$$Roles_has_role_$def$5$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$5$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 320674) 320676)) inline$$Roles_has_role_$def$5$anon16_correct)))
(let ((inline$$Roles_has_role_$def$5$anon28_Then_correct  (=> (= (ControlFlow 0 320684) 320676) inline$$Roles_has_role_$def$5$anon16_correct)))
(let ((inline$$Roles_has_role_$def$5$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$5$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$5$dst@1 inline$$Roles_has_designated_dealer_role_$def$1$$t2@1))) (and (=> (= (ControlFlow 0 320668) 320684) inline$$Roles_has_role_$def$5$anon28_Then_correct) (=> (= (ControlFlow 0 320668) 320674) inline$$Roles_has_role_$def$5$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$5$anon0_correct  (=> (and (= inline$$GetFieldFromValue$5$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$5$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 320652) 320668)) inline$$Roles_has_role_$def$5$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$5$anon26_Else_correct  (=> (and (not $abort_flag@74) (= (ControlFlow 0 320658) 320652)) inline$$GetFieldFromValue$5$anon0_correct)))
(let ((inline$$GetGlobal$5$anon3_Then$1_correct  (=> (= $abort_code@84 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@74 true) (= inline$$GetGlobal$5$dst@2 inline$$GetGlobal$5$dst@0)) (and (=> (= (ControlFlow 0 320598) 320688) inline$$Roles_has_role_$def$5$anon26_Then_correct) (=> (= (ControlFlow 0 320598) 320658) inline$$Roles_has_role_$def$5$anon26_Else_correct))))))
(let ((inline$$GetGlobal$5$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$5$a@1)) (= (ControlFlow 0 320596) 320598)) inline$$GetGlobal$5$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$5$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$5$a@1) (=> (and (and (= inline$$GetGlobal$5$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4))) (= $abort_code@84 $abort_code@83)) (and (= $abort_flag@74 $abort_flag@73) (= inline$$GetGlobal$5$dst@2 inline$$GetGlobal$5$dst@1))) (and (=> (= (ControlFlow 0 320544) 320688) inline$$Roles_has_role_$def$5$anon26_Then_correct) (=> (= (ControlFlow 0 320544) 320658) inline$$Roles_has_role_$def$5$anon26_Else_correct))))))
(let ((inline$$GetGlobal$5$anon0_correct  (=> (= inline$$GetGlobal$5$a@1 (|a#$Address| call3formal@$ret0@0@@4)) (and (=> (= (ControlFlow 0 320526) 320596) inline$$GetGlobal$5$anon3_Then_correct) (=> (= (ControlFlow 0 320526) 320544) inline$$GetGlobal$5$anon3_Else_correct)))))
(let ((inline$$GetGlobal$5$Entry_correct  (and (=> (= (ControlFlow 0 320520) (- 0 360154)) true) (=> (= (ControlFlow 0 320520) 320526) inline$$GetGlobal$5$anon0_correct))))
(let ((inline$$Roles_has_role_$def$5$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$5$$t6@1) (= (ControlFlow 0 320604) 320520)) inline$$GetGlobal$5$Entry_correct)))
(let ((inline$$Roles_has_role_$def$5$anon18_correct  (=> (= $abort_flag@75 $abort_flag@73) (=> (and (= |inline$$Roles_has_role_$def$5$tmp#$3@2| inline$$Roles_has_role_$def$5$$t9@1) (= $abort_code@85 $abort_code@83)) (and (=> (= (ControlFlow 0 320397) 320417) inline$$Roles_has_role_$def$5$anon30_Then_correct) (=> (= (ControlFlow 0 320397) 320407) inline$$Roles_has_role_$def$5$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$5$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 320395) 320397)) inline$$Roles_has_role_$def$5$anon18_correct)))
(let ((inline$$Roles_has_role_$def$5$anon29_Then_correct  (=> (= (ControlFlow 0 320425) 320397) inline$$Roles_has_role_$def$5$anon18_correct)))
(let ((inline$$Roles_has_role_$def$5$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$5$$t6@1)) (= inline$$Roles_has_role_$def$5$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 320387) 320425) inline$$Roles_has_role_$def$5$anon29_Then_correct) (=> (= (ControlFlow 0 320387) 320395) inline$$Roles_has_role_$def$5$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon23_Else_correct  (=> (and (not $abort_flag@73) (= inline$$Roles_has_role_$def$5$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4))))) (and (=> (= (ControlFlow 0 320343) 320604) inline$$Roles_has_role_$def$5$anon25_Then_correct) (=> (= (ControlFlow 0 320343) 320387) inline$$Roles_has_role_$def$5$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@73) (=> $abort_flag@73 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@73) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 addr)))) ((_ is $Address) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 320329) 320714) inline$$Roles_has_role_$def$5$anon23_Then_correct) (=> (= (ControlFlow 0 320329) 320343) inline$$Roles_has_role_$def$5$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 320259) 320329)) inline$$Roles_has_role_$def$5$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$5$anon22_Then_correct  (=> (= (ControlFlow 0 320738) 320329) inline$$Roles_has_role_$def$5$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$5$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 320251) 320738) inline$$Roles_has_role_$def$5$anon22_Then_correct) (=> (= (ControlFlow 0 320251) 320259) inline$$Roles_has_role_$def$5$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon21_Then_correct  (and (=> (= (ControlFlow 0 320746) 320738) inline$$Roles_has_role_$def$5$anon22_Then_correct) (=> (= (ControlFlow 0 320746) 320259) inline$$Roles_has_role_$def$5$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$5$anon0_correct  (=> (not $abort_flag@72) (and (=> (= (ControlFlow 0 320245) 320746) inline$$Roles_has_role_$def$5$anon21_Then_correct) (=> (= (ControlFlow 0 320245) 320251) inline$$Roles_has_role_$def$5$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$5$anon0_correct  (=> ((_ is $Address) addr) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_designated_dealer_role_$def$1$$t2@1) (>= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$1$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$1$$t2@1) $MAX_U64)) (= (ControlFlow 0 320752) 320245)) inline$$Roles_has_role_$def$5$anon0_correct))))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon2$1_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$1$$t2@1 ($Integer 2)) (= (ControlFlow 0 320760) 320752)) inline$$Roles_has_role$5$anon0_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 319772) 320760)) inline$$Roles_has_designated_dealer_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon7_Then_correct  (=> (= (ControlFlow 0 320802) 320760) inline$$Roles_has_designated_dealer_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon0_correct  (=> (not $abort_flag@72) (and (=> (= (ControlFlow 0 319766) 320802) inline$$Roles_has_designated_dealer_role_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 319766) 319772) inline$$Roles_has_designated_dealer_role_$def$1$anon7_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role$1$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 320808) 319766)) inline$$Roles_has_designated_dealer_role_$def$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon24_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1|)) (= (ControlFlow 0 320816) 320808)) inline$$Roles_has_designated_dealer_role$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon8_correct  (=> (= |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1| inline$$Roles_can_hold_balance_$def$1$$t5@1) (=> (and (= $abort_flag@72 $abort_flag@66) (= $abort_code@82 $abort_code@76)) (and (=> (= (ControlFlow 0 320970) 320896) inline$$Roles_can_hold_balance_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 320970) 320816) inline$$Roles_can_hold_balance_$def$1$anon24_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 320968) 320970)) inline$$Roles_can_hold_balance_$def$1$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon22_Then_correct  (=> (= (ControlFlow 0 320978) 320970) inline$$Roles_can_hold_balance_$def$1$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2) (= inline$$Roles_can_hold_balance_$def$1$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 320960) 320978) inline$$Roles_can_hold_balance_$def$1$anon22_Then_correct) (=> (= (ControlFlow 0 320960) 320968) inline$$Roles_can_hold_balance_$def$1$anon22_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon23_Else_correct  (=> (and (and (not $abort_flag@71) (= |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1| inline$$Roles_has_child_VASP_role_$def$1$$ret0@2)) (and (= $abort_flag@72 $abort_flag@71) (= $abort_code@82 $abort_code@81))) (and (=> (= (ControlFlow 0 319564) 320896) inline$$Roles_can_hold_balance_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 319564) 320816) inline$$Roles_can_hold_balance_$def$1$anon24_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon6_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$1$$ret0@2 inline$$Roles_has_role_$def$4$$ret0@2) (= $abort_flag@71 $abort_flag@70)) (and (=> (= (ControlFlow 0 319518) 320918) inline$$Roles_can_hold_balance_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 319518) 319564) inline$$Roles_can_hold_balance_$def$1$anon23_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 319516) 319518)) inline$$Roles_has_child_VASP_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 319526) 319518) inline$$Roles_has_child_VASP_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon8_Else_correct  (=> (not $abort_flag@70) (and (=> (= (ControlFlow 0 319510) 319526) inline$$Roles_has_child_VASP_role_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 319510) 319516) inline$$Roles_has_child_VASP_role_$def$1$anon9_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon8_Then_correct  (=> (and (and $abort_flag@70 (= inline$$Roles_has_child_VASP_role_$def$1$$ret0@1 $Error)) (and (= inline$$Roles_has_child_VASP_role_$def$1$$ret0@2 inline$$Roles_has_child_VASP_role_$def$1$$ret0@1) (= $abort_flag@71 true))) (and (=> (= (ControlFlow 0 319534) 320918) inline$$Roles_can_hold_balance_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 319534) 319564) inline$$Roles_can_hold_balance_$def$1$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$4$$ret0@1 $Error) (= $abort_flag@70 true)) (and (= $abort_code@81 $abort_code@80) (= inline$$Roles_has_role_$def$4$$ret0@2 inline$$Roles_has_role_$def$4$$ret0@1))) (and (=> (= (ControlFlow 0 319442) 319534) inline$$Roles_has_child_VASP_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 319442) 319510) inline$$Roles_has_child_VASP_role_$def$1$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon7_correct  (=> (and (= $abort_code@80 $abort_code@77) (= (ControlFlow 0 319462) 319442)) inline$$Roles_has_role_$def$4$Abort_correct)))
(let ((inline$$Roles_has_role_$def$4$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 319460) 319462)) inline$$Roles_has_role_$def$4$anon7_correct)))
(let ((inline$$Roles_has_role_$def$4$anon24_Then_correct  (=> (= (ControlFlow 0 319470) 319462) inline$$Roles_has_role_$def$4$anon7_correct)))
(let ((inline$$Roles_has_role_$def$4$anon23_Then_correct  (=> $abort_flag@67 (and (=> (= (ControlFlow 0 319454) 319470) inline$$Roles_has_role_$def$4$anon24_Then_correct) (=> (= (ControlFlow 0 319454) 319460) inline$$Roles_has_role_$def$4$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon13_correct  (=> (and (= $abort_code@80 $abort_code@78) (= (ControlFlow 0 319436) 319442)) inline$$Roles_has_role_$def$4$Abort_correct)))
(let ((inline$$Roles_has_role_$def$4$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 319434) 319436)) inline$$Roles_has_role_$def$4$anon13_correct)))
(let ((inline$$Roles_has_role_$def$4$anon27_Then_correct  (=> (= (ControlFlow 0 319450) 319436) inline$$Roles_has_role_$def$4$anon13_correct)))
(let ((inline$$Roles_has_role_$def$4$anon26_Then_correct  (=> $abort_flag@68 (and (=> (= (ControlFlow 0 319428) 319450) inline$$Roles_has_role_$def$4$anon27_Then_correct) (=> (= (ControlFlow 0 319428) 319434) inline$$Roles_has_role_$def$4$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon20_correct  (=> (= $abort_flag@70 $abort_flag@69) (=> (and (= $abort_code@81 $abort_code@79) (= inline$$Roles_has_role_$def$4$$ret0@2 |inline$$Roles_has_role_$def$4$tmp#$3@2|)) (and (=> (= (ControlFlow 0 319149) 319534) inline$$Roles_has_child_VASP_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 319149) 319510) inline$$Roles_has_child_VASP_role_$def$1$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$4$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 319147) 319149)) inline$$Roles_has_role_$def$4$anon20_correct)))
(let ((inline$$Roles_has_role_$def$4$anon30_Then_correct  (=> (= (ControlFlow 0 319157) 319149) inline$$Roles_has_role_$def$4$anon20_correct)))
(let ((inline$$Roles_has_role_$def$4$anon16_correct  (=> (= $abort_code@79 $abort_code@78) (=> (and (= |inline$$Roles_has_role_$def$4$tmp#$3@2| |inline$$Roles_has_role_$def$4$tmp#$3@1|) (= $abort_flag@69 $abort_flag@68)) (and (=> (= (ControlFlow 0 319416) 319157) inline$$Roles_has_role_$def$4$anon30_Then_correct) (=> (= (ControlFlow 0 319416) 319147) inline$$Roles_has_role_$def$4$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$4$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 319414) 319416)) inline$$Roles_has_role_$def$4$anon16_correct)))
(let ((inline$$Roles_has_role_$def$4$anon28_Then_correct  (=> (= (ControlFlow 0 319424) 319416) inline$$Roles_has_role_$def$4$anon16_correct)))
(let ((inline$$Roles_has_role_$def$4$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$4$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$4$dst@1 inline$$Roles_has_child_VASP_role_$def$1$$t2@1))) (and (=> (= (ControlFlow 0 319408) 319424) inline$$Roles_has_role_$def$4$anon28_Then_correct) (=> (= (ControlFlow 0 319408) 319414) inline$$Roles_has_role_$def$4$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$4$anon0_correct  (=> (and (= inline$$GetFieldFromValue$4$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$4$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 319392) 319408)) inline$$Roles_has_role_$def$4$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$4$anon26_Else_correct  (=> (and (not $abort_flag@68) (= (ControlFlow 0 319398) 319392)) inline$$GetFieldFromValue$4$anon0_correct)))
(let ((inline$$GetGlobal$4$anon3_Then$1_correct  (=> (= $abort_flag@68 true) (=> (and (= $abort_code@78 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$4$dst@2 inline$$GetGlobal$4$dst@0)) (and (=> (= (ControlFlow 0 319338) 319428) inline$$Roles_has_role_$def$4$anon26_Then_correct) (=> (= (ControlFlow 0 319338) 319398) inline$$Roles_has_role_$def$4$anon26_Else_correct))))))
(let ((inline$$GetGlobal$4$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$4$a@1)) (= (ControlFlow 0 319336) 319338)) inline$$GetGlobal$4$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$4$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$4$a@1) (=> (and (and (= inline$$GetGlobal$4$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5))) (= $abort_flag@68 $abort_flag@67)) (and (= $abort_code@78 $abort_code@77) (= inline$$GetGlobal$4$dst@2 inline$$GetGlobal$4$dst@1))) (and (=> (= (ControlFlow 0 319284) 319428) inline$$Roles_has_role_$def$4$anon26_Then_correct) (=> (= (ControlFlow 0 319284) 319398) inline$$Roles_has_role_$def$4$anon26_Else_correct))))))
(let ((inline$$GetGlobal$4$anon0_correct  (=> (= inline$$GetGlobal$4$a@1 (|a#$Address| call3formal@$ret0@0@@5)) (and (=> (= (ControlFlow 0 319266) 319336) inline$$GetGlobal$4$anon3_Then_correct) (=> (= (ControlFlow 0 319266) 319284) inline$$GetGlobal$4$anon3_Else_correct)))))
(let ((inline$$GetGlobal$4$Entry_correct  (and (=> (= (ControlFlow 0 319260) (- 0 359511)) true) (=> (= (ControlFlow 0 319260) 319266) inline$$GetGlobal$4$anon0_correct))))
(let ((inline$$Roles_has_role_$def$4$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$4$$t6@1) (= (ControlFlow 0 319344) 319260)) inline$$GetGlobal$4$Entry_correct)))
(let ((inline$$Roles_has_role_$def$4$anon18_correct  (=> (= $abort_code@79 $abort_code@77) (=> (and (= |inline$$Roles_has_role_$def$4$tmp#$3@2| inline$$Roles_has_role_$def$4$$t9@1) (= $abort_flag@69 $abort_flag@67)) (and (=> (= (ControlFlow 0 319137) 319157) inline$$Roles_has_role_$def$4$anon30_Then_correct) (=> (= (ControlFlow 0 319137) 319147) inline$$Roles_has_role_$def$4$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$4$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 319135) 319137)) inline$$Roles_has_role_$def$4$anon18_correct)))
(let ((inline$$Roles_has_role_$def$4$anon29_Then_correct  (=> (= (ControlFlow 0 319165) 319137) inline$$Roles_has_role_$def$4$anon18_correct)))
(let ((inline$$Roles_has_role_$def$4$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$4$$t6@1)) (= inline$$Roles_has_role_$def$4$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 319127) 319165) inline$$Roles_has_role_$def$4$anon29_Then_correct) (=> (= (ControlFlow 0 319127) 319135) inline$$Roles_has_role_$def$4$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon23_Else_correct  (=> (and (not $abort_flag@67) (= inline$$Roles_has_role_$def$4$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@5))))) (and (=> (= (ControlFlow 0 319083) 319344) inline$$Roles_has_role_$def$4$anon25_Then_correct) (=> (= (ControlFlow 0 319083) 319127) inline$$Roles_has_role_$def$4$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@67) (=> $abort_flag@67 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@67) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 addr)))) ((_ is $Address) call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 319069) 319454) inline$$Roles_has_role_$def$4$anon23_Then_correct) (=> (= (ControlFlow 0 319069) 319083) inline$$Roles_has_role_$def$4$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 318999) 319069)) inline$$Roles_has_role_$def$4$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$4$anon22_Then_correct  (=> (= (ControlFlow 0 319478) 319069) inline$$Roles_has_role_$def$4$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$4$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 318991) 319478) inline$$Roles_has_role_$def$4$anon22_Then_correct) (=> (= (ControlFlow 0 318991) 318999) inline$$Roles_has_role_$def$4$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon21_Then_correct  (and (=> (= (ControlFlow 0 319486) 319478) inline$$Roles_has_role_$def$4$anon22_Then_correct) (=> (= (ControlFlow 0 319486) 318999) inline$$Roles_has_role_$def$4$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$4$anon0_correct  (=> (not $abort_flag@66) (and (=> (= (ControlFlow 0 318985) 319486) inline$$Roles_has_role_$def$4$anon21_Then_correct) (=> (= (ControlFlow 0 318985) 318991) inline$$Roles_has_role_$def$4$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$4$anon0_correct  (=> ((_ is $Address) addr) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_child_VASP_role_$def$1$$t2@1) (>= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$1$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$1$$t2@1) $MAX_U64)) (= (ControlFlow 0 319492) 318985)) inline$$Roles_has_role_$def$4$anon0_correct))))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon2$1_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$1$$t2@1 ($Integer 6)) (= (ControlFlow 0 319500) 319492)) inline$$Roles_has_role$4$anon0_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 318512) 319500)) inline$$Roles_has_child_VASP_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon7_Then_correct  (=> (= (ControlFlow 0 319542) 319500) inline$$Roles_has_child_VASP_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon0_correct  (=> (not $abort_flag@66) (and (=> (= (ControlFlow 0 318506) 319542) inline$$Roles_has_child_VASP_role_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 318506) 318512) inline$$Roles_has_child_VASP_role_$def$1$anon7_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role$1$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 319548) 318506)) inline$$Roles_has_child_VASP_role_$def$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2)) (= (ControlFlow 0 319556) 319548)) inline$$Roles_has_child_VASP_role$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon20_Else_correct  (=> (not $abort_flag@66) (and (=> (= (ControlFlow 0 318306) 320960) inline$$Roles_can_hold_balance_$def$1$anon21_Then_correct) (=> (= (ControlFlow 0 318306) 319556) inline$$Roles_can_hold_balance_$def$1$anon21_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon6_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2 inline$$Roles_has_role_$def$3$$ret0@2) (= $abort_flag@66 $abort_flag@65)) (and (=> (= (ControlFlow 0 318260) 320982) inline$$Roles_can_hold_balance_$def$1$anon20_Then_correct) (=> (= (ControlFlow 0 318260) 318306) inline$$Roles_can_hold_balance_$def$1$anon20_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 318258) 318260)) inline$$Roles_has_parent_VASP_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 318268) 318260) inline$$Roles_has_parent_VASP_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon8_Else_correct  (=> (not $abort_flag@65) (and (=> (= (ControlFlow 0 318252) 318268) inline$$Roles_has_parent_VASP_role_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 318252) 318258) inline$$Roles_has_parent_VASP_role_$def$1$anon9_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon8_Then_correct  (=> (and (and $abort_flag@65 (= inline$$Roles_has_parent_VASP_role_$def$1$$ret0@1 $Error)) (and (= inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2 inline$$Roles_has_parent_VASP_role_$def$1$$ret0@1) (= $abort_flag@66 true))) (and (=> (= (ControlFlow 0 318276) 320982) inline$$Roles_can_hold_balance_$def$1$anon20_Then_correct) (=> (= (ControlFlow 0 318276) 318306) inline$$Roles_can_hold_balance_$def$1$anon20_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$3$$ret0@1 $Error) (= $abort_flag@65 true)) (and (= $abort_code@76 $abort_code@75) (= inline$$Roles_has_role_$def$3$$ret0@2 inline$$Roles_has_role_$def$3$$ret0@1))) (and (=> (= (ControlFlow 0 318184) 318276) inline$$Roles_has_parent_VASP_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 318184) 318252) inline$$Roles_has_parent_VASP_role_$def$1$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon7_correct  (=> (and (= $abort_code@75 $abort_code@72) (= (ControlFlow 0 318204) 318184)) inline$$Roles_has_role_$def$3$Abort_correct)))
(let ((inline$$Roles_has_role_$def$3$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 318202) 318204)) inline$$Roles_has_role_$def$3$anon7_correct)))
(let ((inline$$Roles_has_role_$def$3$anon24_Then_correct  (=> (= (ControlFlow 0 318212) 318204) inline$$Roles_has_role_$def$3$anon7_correct)))
(let ((inline$$Roles_has_role_$def$3$anon23_Then_correct  (=> $abort_flag@62 (and (=> (= (ControlFlow 0 318196) 318212) inline$$Roles_has_role_$def$3$anon24_Then_correct) (=> (= (ControlFlow 0 318196) 318202) inline$$Roles_has_role_$def$3$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon13_correct  (=> (and (= $abort_code@75 $abort_code@73) (= (ControlFlow 0 318178) 318184)) inline$$Roles_has_role_$def$3$Abort_correct)))
(let ((inline$$Roles_has_role_$def$3$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 318176) 318178)) inline$$Roles_has_role_$def$3$anon13_correct)))
(let ((inline$$Roles_has_role_$def$3$anon27_Then_correct  (=> (= (ControlFlow 0 318192) 318178) inline$$Roles_has_role_$def$3$anon13_correct)))
(let ((inline$$Roles_has_role_$def$3$anon26_Then_correct  (=> $abort_flag@63 (and (=> (= (ControlFlow 0 318170) 318192) inline$$Roles_has_role_$def$3$anon27_Then_correct) (=> (= (ControlFlow 0 318170) 318176) inline$$Roles_has_role_$def$3$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon20_correct  (=> (= $abort_flag@65 $abort_flag@64) (=> (and (= $abort_code@76 $abort_code@74) (= inline$$Roles_has_role_$def$3$$ret0@2 |inline$$Roles_has_role_$def$3$tmp#$3@2|)) (and (=> (= (ControlFlow 0 317891) 318276) inline$$Roles_has_parent_VASP_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 317891) 318252) inline$$Roles_has_parent_VASP_role_$def$1$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$3$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 317889) 317891)) inline$$Roles_has_role_$def$3$anon20_correct)))
(let ((inline$$Roles_has_role_$def$3$anon30_Then_correct  (=> (= (ControlFlow 0 317899) 317891) inline$$Roles_has_role_$def$3$anon20_correct)))
(let ((inline$$Roles_has_role_$def$3$anon16_correct  (=> (= $abort_flag@64 $abort_flag@63) (=> (and (= |inline$$Roles_has_role_$def$3$tmp#$3@2| |inline$$Roles_has_role_$def$3$tmp#$3@1|) (= $abort_code@74 $abort_code@73)) (and (=> (= (ControlFlow 0 318158) 317899) inline$$Roles_has_role_$def$3$anon30_Then_correct) (=> (= (ControlFlow 0 318158) 317889) inline$$Roles_has_role_$def$3$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$3$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 318156) 318158)) inline$$Roles_has_role_$def$3$anon16_correct)))
(let ((inline$$Roles_has_role_$def$3$anon28_Then_correct  (=> (= (ControlFlow 0 318166) 318158) inline$$Roles_has_role_$def$3$anon16_correct)))
(let ((inline$$Roles_has_role_$def$3$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$3$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$3$dst@1 inline$$Roles_has_parent_VASP_role_$def$1$$t2@1))) (and (=> (= (ControlFlow 0 318150) 318166) inline$$Roles_has_role_$def$3$anon28_Then_correct) (=> (= (ControlFlow 0 318150) 318156) inline$$Roles_has_role_$def$3$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$3$anon0_correct  (=> (and (= inline$$GetFieldFromValue$3$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$3$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 318134) 318150)) inline$$Roles_has_role_$def$3$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$3$anon26_Else_correct  (=> (and (not $abort_flag@63) (= (ControlFlow 0 318140) 318134)) inline$$GetFieldFromValue$3$anon0_correct)))
(let ((inline$$GetGlobal$3$anon3_Then$1_correct  (=> (= $abort_code@73 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@63 true) (= inline$$GetGlobal$3$dst@2 inline$$GetGlobal$3$dst@0)) (and (=> (= (ControlFlow 0 318080) 318170) inline$$Roles_has_role_$def$3$anon26_Then_correct) (=> (= (ControlFlow 0 318080) 318140) inline$$Roles_has_role_$def$3$anon26_Else_correct))))))
(let ((inline$$GetGlobal$3$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$3$a@1)) (= (ControlFlow 0 318078) 318080)) inline$$GetGlobal$3$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$3$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$3$a@1) (=> (and (and (= inline$$GetGlobal$3$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@6))) (= $abort_code@73 $abort_code@72)) (and (= $abort_flag@63 $abort_flag@62) (= inline$$GetGlobal$3$dst@2 inline$$GetGlobal$3$dst@1))) (and (=> (= (ControlFlow 0 318026) 318170) inline$$Roles_has_role_$def$3$anon26_Then_correct) (=> (= (ControlFlow 0 318026) 318140) inline$$Roles_has_role_$def$3$anon26_Else_correct))))))
(let ((inline$$GetGlobal$3$anon0_correct  (=> (= inline$$GetGlobal$3$a@1 (|a#$Address| call3formal@$ret0@0@@6)) (and (=> (= (ControlFlow 0 318008) 318078) inline$$GetGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 318008) 318026) inline$$GetGlobal$3$anon3_Else_correct)))))
(let ((inline$$GetGlobal$3$Entry_correct  (and (=> (= (ControlFlow 0 318002) (- 0 358915)) true) (=> (= (ControlFlow 0 318002) 318008) inline$$GetGlobal$3$anon0_correct))))
(let ((inline$$Roles_has_role_$def$3$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$3$$t6@1) (= (ControlFlow 0 318086) 318002)) inline$$GetGlobal$3$Entry_correct)))
(let ((inline$$Roles_has_role_$def$3$anon18_correct  (=> (= $abort_flag@64 $abort_flag@62) (=> (and (= |inline$$Roles_has_role_$def$3$tmp#$3@2| inline$$Roles_has_role_$def$3$$t9@1) (= $abort_code@74 $abort_code@72)) (and (=> (= (ControlFlow 0 317879) 317899) inline$$Roles_has_role_$def$3$anon30_Then_correct) (=> (= (ControlFlow 0 317879) 317889) inline$$Roles_has_role_$def$3$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$3$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 317877) 317879)) inline$$Roles_has_role_$def$3$anon18_correct)))
(let ((inline$$Roles_has_role_$def$3$anon29_Then_correct  (=> (= (ControlFlow 0 317907) 317879) inline$$Roles_has_role_$def$3$anon18_correct)))
(let ((inline$$Roles_has_role_$def$3$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$3$$t6@1)) (= inline$$Roles_has_role_$def$3$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 317869) 317907) inline$$Roles_has_role_$def$3$anon29_Then_correct) (=> (= (ControlFlow 0 317869) 317877) inline$$Roles_has_role_$def$3$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon23_Else_correct  (=> (and (not $abort_flag@62) (= inline$$Roles_has_role_$def$3$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@6))))) (and (=> (= (ControlFlow 0 317825) 318086) inline$$Roles_has_role_$def$3$anon25_Then_correct) (=> (= (ControlFlow 0 317825) 317869) inline$$Roles_has_role_$def$3$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@62) (=> $abort_flag@62 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@62) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 addr)))) ((_ is $Address) call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 317811) 318196) inline$$Roles_has_role_$def$3$anon23_Then_correct) (=> (= (ControlFlow 0 317811) 317825) inline$$Roles_has_role_$def$3$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 317741) 317811)) inline$$Roles_has_role_$def$3$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$3$anon22_Then_correct  (=> (= (ControlFlow 0 318220) 317811) inline$$Roles_has_role_$def$3$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$3$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 317733) 318220) inline$$Roles_has_role_$def$3$anon22_Then_correct) (=> (= (ControlFlow 0 317733) 317741) inline$$Roles_has_role_$def$3$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon21_Then_correct  (and (=> (= (ControlFlow 0 318228) 318220) inline$$Roles_has_role_$def$3$anon22_Then_correct) (=> (= (ControlFlow 0 318228) 317741) inline$$Roles_has_role_$def$3$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$3$anon0_correct  (=> (not $abort_flag@61) (and (=> (= (ControlFlow 0 317727) 318228) inline$$Roles_has_role_$def$3$anon21_Then_correct) (=> (= (ControlFlow 0 317727) 317733) inline$$Roles_has_role_$def$3$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$3$anon0_correct  (=> ((_ is $Address) addr) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_parent_VASP_role_$def$1$$t2@1) (>= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$1$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$1$$t2@1) $MAX_U64)) (= (ControlFlow 0 318234) 317727)) inline$$Roles_has_role_$def$3$anon0_correct))))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon2$1_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$1$$t2@1 ($Integer 5)) (= (ControlFlow 0 318242) 318234)) inline$$Roles_has_role$3$anon0_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 317254) 318242)) inline$$Roles_has_parent_VASP_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon7_Then_correct  (=> (= (ControlFlow 0 318284) 318242) inline$$Roles_has_parent_VASP_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon0_correct  (=> (not $abort_flag@61) (and (=> (= (ControlFlow 0 317248) 318284) inline$$Roles_has_parent_VASP_role_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 317248) 317254) inline$$Roles_has_parent_VASP_role_$def$1$anon7_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role$1$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 318290) 317248)) inline$$Roles_has_parent_VASP_role_$def$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 317020) 318290)) inline$$Roles_has_parent_VASP_role$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon19_Then_correct  (=> (= (ControlFlow 0 320990) 318290) inline$$Roles_has_parent_VASP_role$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon0_correct  (=> (not $abort_flag@61) (and (=> (= (ControlFlow 0 317014) 320990) inline$$Roles_can_hold_balance_$def$1$anon19_Then_correct) (=> (= (ControlFlow 0 317014) 317020) inline$$Roles_can_hold_balance_$def$1$anon19_Else_correct)))))
(let ((inline$$Roles_can_hold_balance$1$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 320996) 317014)) inline$$Roles_can_hold_balance_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon36_Else_correct  (=> (and (not $abort_flag@61) (= (ControlFlow 0 321004) 320996)) inline$$Roles_can_hold_balance$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@61) (=> (and (=> $abort_flag@61 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@61 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@71 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 316668) 322211) inline$$DiemAccount_add_currency_$def$1$anon36_Then_correct) (=> (= (ControlFlow 0 316668) 321004) inline$$DiemAccount_add_currency_$def$1$anon36_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 316632) 316668)) inline$$DiemAccount_add_currency_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon35_Then_correct  (=> (= (ControlFlow 0 322235) 316668) inline$$DiemAccount_add_currency_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon0_correct  (=> (not $abort_flag@60) (and (=> (= (ControlFlow 0 316626) 322235) inline$$DiemAccount_add_currency_$def$1$anon35_Then_correct) (=> (= (ControlFlow 0 316626) 316632) inline$$DiemAccount_add_currency_$def$1$anon35_Else_correct)))))
(let ((inline$$DiemAccount_add_currency$1$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 322239) 316626)) inline$$DiemAccount_add_currency_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency$1$Entry_correct  (=> (and (= inline$$DiemAccount_add_currency$1$$tv0@0 $XDX_XDX_type_value) (= (ControlFlow 0 316070) 322239)) inline$$DiemAccount_add_currency$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon29_Then_correct  (=> (and (|b#$Boolean| inline$$Not$2$dst@1) (= (ControlFlow 0 322245) 316070)) inline$$DiemAccount_add_currency$1$Entry_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon29_Else_correct  (=> (not (|b#$Boolean| inline$$Not$2$dst@1)) (=> (and (and (= $DiemAccount_Balance_$memory@7 $DiemAccount_Balance_$memory@4) (= $abort_flag@87 $abort_flag@60)) (and (= $abort_code@100 $abort_code@70) (= (ControlFlow 0 316014) 316016))) inline$$DiemAccount_add_currencies_for_account_$def$0$L9_correct))))
(let ((inline$$Not$2$anon0_correct  (=> (= inline$$Not$2$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currencies_for_account_$def$0$$t7@1)))) (and (=> (= (ControlFlow 0 315998) 322245) inline$$DiemAccount_add_currencies_for_account_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 315998) 316014) inline$$DiemAccount_add_currencies_for_account_$def$0$anon29_Else_correct)))))
(let ((inline$$Not$2$Entry_correct  (and (=> (= (ControlFlow 0 315988) (- 0 358375)) true) (=> (= (ControlFlow 0 315988) 315998) inline$$Not$2$anon0_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$L5_correct  (=> (and (= inline$$DiemAccount_add_currencies_for_account_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| call3formal@$ret0@0@@7)))) (= (ControlFlow 0 316004) 315988)) inline$$Not$2$Entry_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Else_correct  (=> (not $abort_flag@59) (=> (and (and (= $DiemAccount_Balance_$memory@4 $DiemAccount_Balance_$memory@3) (= $abort_flag@60 $abort_flag@59)) (and (= $abort_code@70 $abort_code@69) (= (ControlFlow 0 328498) 316004))) inline$$DiemAccount_add_currencies_for_account_$def$0$L5_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon50_Else_correct  (=> (and (and (not $abort_flag@58) (= $DiemAccount_Balance_$memory@3 |inline$$MoveToRaw$2$m'@2|)) (and (= $abort_flag@59 $abort_flag@58) (= $abort_code@69 $abort_code@67))) (and (=> (= (ControlFlow 0 328364) 328502) inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 328364) 328498) inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$Abort_correct  (=> (= $DiemAccount_Balance_$memory@3 $DiemAccount_Balance_$memory@2) (=> (and (= $abort_flag@59 true) (= $abort_code@69 $abort_code@68)) (and (=> (= (ControlFlow 0 327291) 328502) inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 327291) 328498) inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon5_correct  (=> (= $abort_code@68 $abort_code@41) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 328464) 327291)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 328462) 328464)) inline$$DiemAccount_add_currency_$def$2$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon37_Then_correct  (=> (= (ControlFlow 0 328472) 328464) inline$$DiemAccount_add_currency_$def$2$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon36_Then_correct  (=> $abort_flag@34 (and (=> (= (ControlFlow 0 328456) 328472) inline$$DiemAccount_add_currency_$def$2$anon37_Then_correct) (=> (= (ControlFlow 0 328456) 328462) inline$$DiemAccount_add_currency_$def$2$anon37_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon11_correct  (=> (= $abort_code@68 $abort_code@61) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 328440) 327291)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 328438) 328440)) inline$$DiemAccount_add_currency_$def$2$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon40_Then_correct  (=> (= (ControlFlow 0 328448) 328440) inline$$DiemAccount_add_currency_$def$2$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon39_Then_correct  (=> $abort_flag@53 (and (=> (= (ControlFlow 0 328432) 328448) inline$$DiemAccount_add_currency_$def$2$anon40_Then_correct) (=> (= (ControlFlow 0 328432) 328438) inline$$DiemAccount_add_currency_$def$2$anon40_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon19_correct  (=> (= $abort_code@68 $abort_code@62) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 328420) 327291)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 328418) 328420)) inline$$DiemAccount_add_currency_$def$2$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon44_Then_correct  (=> (= (ControlFlow 0 328428) 328420) inline$$DiemAccount_add_currency_$def$2$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon43_Then_correct  (=> $abort_flag@54 (and (=> (= (ControlFlow 0 328412) 328428) inline$$DiemAccount_add_currency_$def$2$anon44_Then_correct) (=> (= (ControlFlow 0 328412) 328418) inline$$DiemAccount_add_currency_$def$2$anon44_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon23_correct  (=> (= $abort_code@68 $abort_code@64) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 328400) 327291)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 328398) 328400)) inline$$DiemAccount_add_currency_$def$2$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon46_Then_correct  (=> (= (ControlFlow 0 328408) 328400) inline$$DiemAccount_add_currency_$def$2$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon45_Then_correct  (=> $abort_flag@55 (and (=> (= (ControlFlow 0 328392) 328408) inline$$DiemAccount_add_currency_$def$2$anon46_Then_correct) (=> (= (ControlFlow 0 328392) 328398) inline$$DiemAccount_add_currency_$def$2$anon46_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon33_correct  (=> (= $abort_code@68 $abort_code@67) (=> (and (= $DiemAccount_Balance_$memory@2 |inline$$MoveToRaw$2$m'@2|) (= (ControlFlow 0 328376) 327291)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 328374) 328376)) inline$$DiemAccount_add_currency_$def$2$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon51_Then_correct  (=> (= (ControlFlow 0 328384) 328376) inline$$DiemAccount_add_currency_$def$2$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon50_Then_correct  (=> $abort_flag@58 (and (=> (= (ControlFlow 0 328368) 328384) inline$$DiemAccount_add_currency_$def$2$anon51_Then_correct) (=> (= (ControlFlow 0 328368) 328374) inline$$DiemAccount_add_currency_$def$2$anon51_Else_correct)))))
(let ((inline$$MoveToRaw$2$anon3_Then$1_correct  (=> (= $abort_code@67 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@58 true) (= |inline$$MoveToRaw$2$m'@2| |inline$$MoveToRaw$2$m'@0|)) (and (=> (= (ControlFlow 0 328342) 328368) inline$$DiemAccount_add_currency_$def$2$anon50_Then_correct) (=> (= (ControlFlow 0 328342) 328364) inline$$DiemAccount_add_currency_$def$2$anon50_Else_correct))))))
(let ((inline$$MoveToRaw$2$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1) (= (ControlFlow 0 328340) 328342)) inline$$MoveToRaw$2$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$2$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1)) (=> (and (and (= |inline$$MoveToRaw$2$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@1) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 inline$$DiemAccount_Balance_pack$2$$struct@1))) (= $abort_code@67 $abort_code@66)) (and (= $abort_flag@58 $abort_flag@57) (= |inline$$MoveToRaw$2$m'@2| |inline$$MoveToRaw$2$m'@1|))) (and (=> (= (ControlFlow 0 328290) 328368) inline$$DiemAccount_add_currency_$def$2$anon50_Then_correct) (=> (= (ControlFlow 0 328290) 328364) inline$$DiemAccount_add_currency_$def$2$anon50_Else_correct))))))
(let ((inline$$MoveTo$2$anon0$1_correct  (=> (= inline$$MoveTo$2$a@1 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 328348) 328340) inline$$MoveToRaw$2$anon3_Then_correct) (=> (= (ControlFlow 0 328348) 328290) inline$$MoveToRaw$2$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$2$Entry_correct  (and (=> (= (ControlFlow 0 328136) (- 0 358058)) true) (=> (= (ControlFlow 0 328136) 328348) inline$$MoveTo$2$anon0$1_correct))))
(let ((inline$$MoveTo$2$Entry_correct  (=> (and (= inline$$MoveTo$2$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1)) (= (ControlFlow 0 328108) 328136)) inline$$Signer_borrow_address$2$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$2$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 328010) 328108)) inline$$MoveTo$2$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$2$anon4_Then_correct  (=> (= (ControlFlow 0 328016) 328108) inline$$MoveTo$2$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$2$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 328004) 328016) inline$$DiemAccount_Balance_pack$2$anon4_Then_correct) (=> (= (ControlFlow 0 328004) 328010) inline$$DiemAccount_Balance_pack$2$anon4_Else_correct)))))
(let ((inline$$DiemAccount_Balance_pack$2$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 327996) 328108)) inline$$MoveTo$2$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$2$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$2$$ret0@2) (let ((va@@19 (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$DiemAccount_Balance_pack$2$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$2$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 327988) 328004) inline$$DiemAccount_Balance_pack$2$anon3_Then_correct) (=> (= (ControlFlow 0 327988) 327996) inline$$DiemAccount_Balance_pack$2$anon3_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon49_Else_correct  (=> (and (not $abort_flag@57) (= (ControlFlow 0 328022) 327988)) inline$$DiemAccount_Balance_pack$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon49_Then_correct  (=> (and (and $abort_flag@57 (= $abort_code@68 $abort_code@66)) (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 328388) 327291))) inline$$DiemAccount_add_currency_$def$2$Abort_correct)))
(let ((inline$$Diem_zero_$def$2$anon3_correct  (=> (= inline$$Diem_zero_$def$2$$ret0@1 $Error) (=> (and (= $abort_flag@57 true) (= inline$$Diem_zero_$def$2$$ret0@2 inline$$Diem_zero_$def$2$$ret0@1)) (and (=> (= (ControlFlow 0 327827) 328388) inline$$DiemAccount_add_currency_$def$2$anon49_Then_correct) (=> (= (ControlFlow 0 327827) 328022) inline$$DiemAccount_add_currency_$def$2$anon49_Else_correct))))))
(let ((inline$$Diem_zero_$def$2$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 327821) 327827)) inline$$Diem_zero_$def$2$anon3_correct)))
(let ((inline$$Diem_zero_$def$2$anon8_Then_correct  (=> (= (ControlFlow 0 327835) 327827) inline$$Diem_zero_$def$2$anon3_correct)))
(let ((inline$$Diem_zero_$def$2$anon7_Then_correct  (=> $abort_flag@56 (and (=> (= (ControlFlow 0 327815) 327835) inline$$Diem_zero_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 327815) 327821) inline$$Diem_zero_$def$2$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$2$anon6_correct  (=> (and (= $abort_flag@57 $abort_flag@56) (= inline$$Diem_zero_$def$2$$ret0@2 inline$$Diem_Diem_pack$2$$struct@1)) (and (=> (= (ControlFlow 0 327803) 328388) inline$$DiemAccount_add_currency_$def$2$anon49_Then_correct) (=> (= (ControlFlow 0 327803) 328022) inline$$DiemAccount_add_currency_$def$2$anon49_Else_correct)))))
(let ((inline$$Diem_zero_$def$2$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 327801) 327803)) inline$$Diem_zero_$def$2$anon6_correct)))
(let ((inline$$Diem_zero_$def$2$anon9_Then_correct  (=> (= (ControlFlow 0 327811) 327803) inline$$Diem_zero_$def$2$anon6_correct)))
(let ((inline$$Diem_Diem_pack$2$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 327779) 327811) inline$$Diem_zero_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 327779) 327801) inline$$Diem_zero_$def$2$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$2$anon4_Then_correct  (and (=> (= (ControlFlow 0 327785) 327811) inline$$Diem_zero_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 327785) 327801) inline$$Diem_zero_$def$2$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$2$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 327773) 327785) inline$$Diem_Diem_pack$2$anon4_Then_correct) (=> (= (ControlFlow 0 327773) 327779) inline$$Diem_Diem_pack$2$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$2$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 327765) 327811) inline$$Diem_zero_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 327765) 327801) inline$$Diem_zero_$def$2$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$2$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$2$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$2$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$2$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$2$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$2$$t0@1) 1)))) (and (=> (= (ControlFlow 0 327757) 327773) inline$$Diem_Diem_pack$2$anon3_Then_correct) (=> (= (ControlFlow 0 327757) 327765) inline$$Diem_Diem_pack$2$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$2$anon7_Else_correct  (=> (not $abort_flag@56) (=> (and (= inline$$Diem_zero_$def$2$$t0@1 ($Integer 0)) (= (ControlFlow 0 327791) 327757)) inline$$Diem_Diem_pack$2$anon0_correct))))
(let ((inline$$Diem_zero_$def$2$anon0_correct  (=> (and (and (not $abort_flag@55) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@56)) (and (=> $abort_flag@56 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@56 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@66 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 327616) 327815) inline$$Diem_zero_$def$2$anon7_Then_correct) (=> (= (ControlFlow 0 327616) 327791) inline$$Diem_zero_$def$2$anon7_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon47_Then_correct  (=> (and (|b#$Boolean| inline$$Not$4$dst@1) (= (ControlFlow 0 327849) 327616)) inline$$Diem_zero_$def$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon28_correct  (=> (= $abort_code@68 $abort_code@65) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 327411) 327291)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 327409) 327411)) inline$$DiemAccount_add_currency_$def$2$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon48_Then_correct  (=> (= (ControlFlow 0 327419) 327411) inline$$DiemAccount_add_currency_$def$2$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon47_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$4$dst@1)) (= $abort_code@65 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 327403) 327419) inline$$DiemAccount_add_currency_$def$2$anon48_Then_correct) (=> (= (ControlFlow 0 327403) 327409) inline$$DiemAccount_add_currency_$def$2$anon48_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon45_Else_correct  (=> (not $abort_flag@55) (and (=> (= (ControlFlow 0 327391) 327849) inline$$DiemAccount_add_currency_$def$2$anon47_Then_correct) (=> (= (ControlFlow 0 327391) 327403) inline$$DiemAccount_add_currency_$def$2$anon47_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon43_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$2$$t12@1 ($Integer 15)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@55)) (and (=> $abort_flag@55 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@55) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 327385) 328392) inline$$DiemAccount_add_currency_$def$2$anon45_Then_correct) (=> (= (ControlFlow 0 327385) 327391) inline$$DiemAccount_add_currency_$def$2$anon45_Else_correct)))))
(let ((inline$$Not$4$anon0_correct  (=> (and (= inline$$Not$4$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currency_$def$2$$t10@1)))) (= (ControlFlow 0 327373) 327385)) inline$$DiemAccount_add_currency_$def$2$anon43_Else$1_correct)))
(let ((inline$$Not$4$Entry_correct  (and (=> (= (ControlFlow 0 327363) (- 0 357601)) true) (=> (= (ControlFlow 0 327363) 327373) inline$$Not$4$anon0_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon43_Else_correct  (=> (not $abort_flag@54) (=> (and (= inline$$DiemAccount_add_currency_$def$2$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@9)))) (= (ControlFlow 0 327379) 327363)) inline$$Not$4$Entry_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon41_Then_correct  (=> (|b#$Boolean| inline$$Roles_can_hold_balance_$def$2$$ret0@2) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@54) (=> $abort_flag@54 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@54) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 addr)))) ((_ is $Address) call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 327305) 328412) inline$$DiemAccount_add_currency_$def$2$anon43_Then_correct) (=> (= (ControlFlow 0 327305) 327379) inline$$DiemAccount_add_currency_$def$2$anon43_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon16_correct  (=> (= $abort_code@68 $abort_code@63) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 327287) 327291)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 327285) 327287)) inline$$DiemAccount_add_currency_$def$2$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon42_Then_correct  (=> (= (ControlFlow 0 327299) 327287) inline$$DiemAccount_add_currency_$def$2$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_can_hold_balance_$def$2$$ret0@2)) (= $abort_code@63 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 327279) 327299) inline$$DiemAccount_add_currency_$def$2$anon42_Then_correct) (=> (= (ControlFlow 0 327279) 327285) inline$$DiemAccount_add_currency_$def$2$anon42_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon39_Else_correct  (=> (not $abort_flag@53) (and (=> (= (ControlFlow 0 327267) 327305) inline$$DiemAccount_add_currency_$def$2$anon41_Then_correct) (=> (= (ControlFlow 0 327267) 327279) inline$$DiemAccount_add_currency_$def$2$anon41_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon38_Else_correct  (=> (not $abort_flag@52) (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$2$$t8@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@53)) (and (=> $abort_flag@53 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@53) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 327261) 328432) inline$$DiemAccount_add_currency_$def$2$anon39_Then_correct) (=> (= (ControlFlow 0 327261) 327267) inline$$DiemAccount_add_currency_$def$2$anon39_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon38_Then_correct  (=> (and (and $abort_flag@52 (= $abort_code@68 $abort_code@60)) (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 328452) 327291))) inline$$DiemAccount_add_currency_$def$2$Abort_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$Abort_correct  (=> (and (and (= inline$$Roles_can_hold_balance_$def$2$$ret0@1 $Error) (= inline$$Roles_can_hold_balance_$def$2$$ret0@2 inline$$Roles_can_hold_balance_$def$2$$ret0@1)) (and (= $abort_code@60 $abort_code@58) (= $abort_flag@52 true))) (and (=> (= (ControlFlow 0 327099) 328452) inline$$DiemAccount_add_currency_$def$2$anon38_Then_correct) (=> (= (ControlFlow 0 327099) 327261) inline$$DiemAccount_add_currency_$def$2$anon38_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon26_Then_correct  (=> $abort_flag@50 (=> (and (= $abort_code@58 $abort_code@57) (= (ControlFlow 0 327093) 327099)) inline$$Roles_can_hold_balance_$def$2$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon23_Then_correct  (=> $abort_flag@44 (=> (and (= $abort_code@58 $abort_code@51) (= (ControlFlow 0 327163) 327099)) inline$$Roles_can_hold_balance_$def$2$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon20_Then_correct  (=> $abort_flag@39 (=> (and (= $abort_code@58 $abort_code@46) (= (ControlFlow 0 327227) 327099)) inline$$Roles_can_hold_balance_$def$2$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon18_correct  (=> (= inline$$Roles_can_hold_balance_$def$2$$ret0@2 |inline$$Roles_can_hold_balance_$def$2$tmp#$2@1|) (=> (and (= $abort_code@60 $abort_code@59) (= $abort_flag@52 $abort_flag@51)) (and (=> (= (ControlFlow 0 327081) 328452) inline$$DiemAccount_add_currency_$def$2$anon38_Then_correct) (=> (= (ControlFlow 0 327081) 327261) inline$$DiemAccount_add_currency_$def$2$anon38_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 327079) 327081)) inline$$Roles_can_hold_balance_$def$2$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon27_Then_correct  (=> (= (ControlFlow 0 327089) 327081) inline$$Roles_can_hold_balance_$def$2$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon14_correct  (=> (= |inline$$Roles_can_hold_balance_$def$2$tmp#$2@1| inline$$Roles_can_hold_balance_$def$2$$t6@1) (=> (and (= $abort_code@59 $abort_code@52) (= $abort_flag@51 $abort_flag@45)) (and (=> (= (ControlFlow 0 327151) 327089) inline$$Roles_can_hold_balance_$def$2$anon27_Then_correct) (=> (= (ControlFlow 0 327151) 327079) inline$$Roles_can_hold_balance_$def$2$anon27_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 327149) 327151)) inline$$Roles_can_hold_balance_$def$2$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon25_Then_correct  (=> (= (ControlFlow 0 327159) 327151) inline$$Roles_can_hold_balance_$def$2$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon24_Then_correct  (=> (and (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1|) (= inline$$Roles_can_hold_balance_$def$2$$t6@1 ($Boolean true))) (and (=> (= (ControlFlow 0 327141) 327159) inline$$Roles_can_hold_balance_$def$2$anon25_Then_correct) (=> (= (ControlFlow 0 327141) 327149) inline$$Roles_can_hold_balance_$def$2$anon25_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon26_Else_correct  (=> (and (and (not $abort_flag@50) (= |inline$$Roles_can_hold_balance_$def$2$tmp#$2@1| inline$$Roles_has_designated_dealer_role_$def$2$$ret0@2)) (and (= $abort_code@59 $abort_code@57) (= $abort_flag@51 $abort_flag@50))) (and (=> (= (ControlFlow 0 327069) 327089) inline$$Roles_can_hold_balance_$def$2$anon27_Then_correct) (=> (= (ControlFlow 0 327069) 327079) inline$$Roles_can_hold_balance_$def$2$anon27_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon6_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$2$$ret0@2 inline$$Roles_has_role_$def$8$$ret0@2) (= $abort_flag@50 $abort_flag@49)) (and (=> (= (ControlFlow 0 327023) 327093) inline$$Roles_can_hold_balance_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 327023) 327069) inline$$Roles_can_hold_balance_$def$2$anon26_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 327021) 327023)) inline$$Roles_has_designated_dealer_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon9_Then_correct  (=> (= (ControlFlow 0 327031) 327023) inline$$Roles_has_designated_dealer_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon8_Else_correct  (=> (not $abort_flag@49) (and (=> (= (ControlFlow 0 327015) 327031) inline$$Roles_has_designated_dealer_role_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 327015) 327021) inline$$Roles_has_designated_dealer_role_$def$2$anon9_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon8_Then_correct  (=> (and (and $abort_flag@49 (= inline$$Roles_has_designated_dealer_role_$def$2$$ret0@1 $Error)) (and (= inline$$Roles_has_designated_dealer_role_$def$2$$ret0@2 inline$$Roles_has_designated_dealer_role_$def$2$$ret0@1) (= $abort_flag@50 true))) (and (=> (= (ControlFlow 0 327039) 327093) inline$$Roles_can_hold_balance_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 327039) 327069) inline$$Roles_can_hold_balance_$def$2$anon26_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$8$$ret0@1 $Error) (= $abort_flag@49 true)) (and (= $abort_code@57 $abort_code@56) (= inline$$Roles_has_role_$def$8$$ret0@2 inline$$Roles_has_role_$def$8$$ret0@1))) (and (=> (= (ControlFlow 0 326947) 327039) inline$$Roles_has_designated_dealer_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 326947) 327015) inline$$Roles_has_designated_dealer_role_$def$2$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon7_correct  (=> (and (= $abort_code@56 $abort_code@53) (= (ControlFlow 0 326967) 326947)) inline$$Roles_has_role_$def$8$Abort_correct)))
(let ((inline$$Roles_has_role_$def$8$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 326965) 326967)) inline$$Roles_has_role_$def$8$anon7_correct)))
(let ((inline$$Roles_has_role_$def$8$anon24_Then_correct  (=> (= (ControlFlow 0 326975) 326967) inline$$Roles_has_role_$def$8$anon7_correct)))
(let ((inline$$Roles_has_role_$def$8$anon23_Then_correct  (=> $abort_flag@46 (and (=> (= (ControlFlow 0 326959) 326975) inline$$Roles_has_role_$def$8$anon24_Then_correct) (=> (= (ControlFlow 0 326959) 326965) inline$$Roles_has_role_$def$8$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon13_correct  (=> (and (= $abort_code@56 $abort_code@54) (= (ControlFlow 0 326941) 326947)) inline$$Roles_has_role_$def$8$Abort_correct)))
(let ((inline$$Roles_has_role_$def$8$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 326939) 326941)) inline$$Roles_has_role_$def$8$anon13_correct)))
(let ((inline$$Roles_has_role_$def$8$anon27_Then_correct  (=> (= (ControlFlow 0 326955) 326941) inline$$Roles_has_role_$def$8$anon13_correct)))
(let ((inline$$Roles_has_role_$def$8$anon26_Then_correct  (=> $abort_flag@47 (and (=> (= (ControlFlow 0 326933) 326955) inline$$Roles_has_role_$def$8$anon27_Then_correct) (=> (= (ControlFlow 0 326933) 326939) inline$$Roles_has_role_$def$8$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon20_correct  (=> (= $abort_flag@49 $abort_flag@48) (=> (and (= $abort_code@57 $abort_code@55) (= inline$$Roles_has_role_$def$8$$ret0@2 |inline$$Roles_has_role_$def$8$tmp#$3@2|)) (and (=> (= (ControlFlow 0 326654) 327039) inline$$Roles_has_designated_dealer_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 326654) 327015) inline$$Roles_has_designated_dealer_role_$def$2$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$8$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 326652) 326654)) inline$$Roles_has_role_$def$8$anon20_correct)))
(let ((inline$$Roles_has_role_$def$8$anon30_Then_correct  (=> (= (ControlFlow 0 326662) 326654) inline$$Roles_has_role_$def$8$anon20_correct)))
(let ((inline$$Roles_has_role_$def$8$anon16_correct  (=> (= $abort_flag@48 $abort_flag@47) (=> (and (= |inline$$Roles_has_role_$def$8$tmp#$3@2| |inline$$Roles_has_role_$def$8$tmp#$3@1|) (= $abort_code@55 $abort_code@54)) (and (=> (= (ControlFlow 0 326921) 326662) inline$$Roles_has_role_$def$8$anon30_Then_correct) (=> (= (ControlFlow 0 326921) 326652) inline$$Roles_has_role_$def$8$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$8$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 326919) 326921)) inline$$Roles_has_role_$def$8$anon16_correct)))
(let ((inline$$Roles_has_role_$def$8$anon28_Then_correct  (=> (= (ControlFlow 0 326929) 326921) inline$$Roles_has_role_$def$8$anon16_correct)))
(let ((inline$$Roles_has_role_$def$8$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$8$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$8$dst@1 inline$$Roles_has_designated_dealer_role_$def$2$$t2@1))) (and (=> (= (ControlFlow 0 326913) 326929) inline$$Roles_has_role_$def$8$anon28_Then_correct) (=> (= (ControlFlow 0 326913) 326919) inline$$Roles_has_role_$def$8$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$8$anon0_correct  (=> (and (= inline$$GetFieldFromValue$8$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$8$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 326897) 326913)) inline$$Roles_has_role_$def$8$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$8$anon26_Else_correct  (=> (and (not $abort_flag@47) (= (ControlFlow 0 326903) 326897)) inline$$GetFieldFromValue$8$anon0_correct)))
(let ((inline$$GetGlobal$8$anon3_Then$1_correct  (=> (= $abort_code@54 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@47 true) (= inline$$GetGlobal$8$dst@2 inline$$GetGlobal$8$dst@0)) (and (=> (= (ControlFlow 0 326843) 326933) inline$$Roles_has_role_$def$8$anon26_Then_correct) (=> (= (ControlFlow 0 326843) 326903) inline$$Roles_has_role_$def$8$anon26_Else_correct))))))
(let ((inline$$GetGlobal$8$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$8$a@1)) (= (ControlFlow 0 326841) 326843)) inline$$GetGlobal$8$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$8$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$8$a@1) (=> (and (and (= inline$$GetGlobal$8$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@11))) (= $abort_code@54 $abort_code@53)) (and (= $abort_flag@47 $abort_flag@46) (= inline$$GetGlobal$8$dst@2 inline$$GetGlobal$8$dst@1))) (and (=> (= (ControlFlow 0 326789) 326933) inline$$Roles_has_role_$def$8$anon26_Then_correct) (=> (= (ControlFlow 0 326789) 326903) inline$$Roles_has_role_$def$8$anon26_Else_correct))))))
(let ((inline$$GetGlobal$8$anon0_correct  (=> (= inline$$GetGlobal$8$a@1 (|a#$Address| call3formal@$ret0@0@@11)) (and (=> (= (ControlFlow 0 326771) 326841) inline$$GetGlobal$8$anon3_Then_correct) (=> (= (ControlFlow 0 326771) 326789) inline$$GetGlobal$8$anon3_Else_correct)))))
(let ((inline$$GetGlobal$8$Entry_correct  (and (=> (= (ControlFlow 0 326765) (- 0 357008)) true) (=> (= (ControlFlow 0 326765) 326771) inline$$GetGlobal$8$anon0_correct))))
(let ((inline$$Roles_has_role_$def$8$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$8$$t6@1) (= (ControlFlow 0 326849) 326765)) inline$$GetGlobal$8$Entry_correct)))
(let ((inline$$Roles_has_role_$def$8$anon18_correct  (=> (= $abort_flag@48 $abort_flag@46) (=> (and (= |inline$$Roles_has_role_$def$8$tmp#$3@2| inline$$Roles_has_role_$def$8$$t9@1) (= $abort_code@55 $abort_code@53)) (and (=> (= (ControlFlow 0 326642) 326662) inline$$Roles_has_role_$def$8$anon30_Then_correct) (=> (= (ControlFlow 0 326642) 326652) inline$$Roles_has_role_$def$8$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$8$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 326640) 326642)) inline$$Roles_has_role_$def$8$anon18_correct)))
(let ((inline$$Roles_has_role_$def$8$anon29_Then_correct  (=> (= (ControlFlow 0 326670) 326642) inline$$Roles_has_role_$def$8$anon18_correct)))
(let ((inline$$Roles_has_role_$def$8$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$8$$t6@1)) (= inline$$Roles_has_role_$def$8$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 326632) 326670) inline$$Roles_has_role_$def$8$anon29_Then_correct) (=> (= (ControlFlow 0 326632) 326640) inline$$Roles_has_role_$def$8$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon23_Else_correct  (=> (and (not $abort_flag@46) (= inline$$Roles_has_role_$def$8$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@11))))) (and (=> (= (ControlFlow 0 326588) 326849) inline$$Roles_has_role_$def$8$anon25_Then_correct) (=> (= (ControlFlow 0 326588) 326632) inline$$Roles_has_role_$def$8$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@46) (=> $abort_flag@46 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@46) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 addr)))) ((_ is $Address) call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 326574) 326959) inline$$Roles_has_role_$def$8$anon23_Then_correct) (=> (= (ControlFlow 0 326574) 326588) inline$$Roles_has_role_$def$8$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 326504) 326574)) inline$$Roles_has_role_$def$8$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$8$anon22_Then_correct  (=> (= (ControlFlow 0 326983) 326574) inline$$Roles_has_role_$def$8$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$8$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 326496) 326983) inline$$Roles_has_role_$def$8$anon22_Then_correct) (=> (= (ControlFlow 0 326496) 326504) inline$$Roles_has_role_$def$8$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon21_Then_correct  (and (=> (= (ControlFlow 0 326991) 326983) inline$$Roles_has_role_$def$8$anon22_Then_correct) (=> (= (ControlFlow 0 326991) 326504) inline$$Roles_has_role_$def$8$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$8$anon0_correct  (=> (not $abort_flag@45) (and (=> (= (ControlFlow 0 326490) 326991) inline$$Roles_has_role_$def$8$anon21_Then_correct) (=> (= (ControlFlow 0 326490) 326496) inline$$Roles_has_role_$def$8$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$8$anon0_correct  (=> ((_ is $Address) addr) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_designated_dealer_role_$def$2$$t2@1) (>= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$2$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$2$$t2@1) $MAX_U64)) (= (ControlFlow 0 326997) 326490)) inline$$Roles_has_role_$def$8$anon0_correct))))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon2$1_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$2$$t2@1 ($Integer 2)) (= (ControlFlow 0 327005) 326997)) inline$$Roles_has_role$8$anon0_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 326017) 327005)) inline$$Roles_has_designated_dealer_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon7_Then_correct  (=> (= (ControlFlow 0 327047) 327005) inline$$Roles_has_designated_dealer_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon0_correct  (=> (not $abort_flag@45) (and (=> (= (ControlFlow 0 326011) 327047) inline$$Roles_has_designated_dealer_role_$def$2$anon7_Then_correct) (=> (= (ControlFlow 0 326011) 326017) inline$$Roles_has_designated_dealer_role_$def$2$anon7_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role$2$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 327053) 326011)) inline$$Roles_has_designated_dealer_role_$def$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon24_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1|)) (= (ControlFlow 0 327061) 327053)) inline$$Roles_has_designated_dealer_role$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon8_correct  (=> (= |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1| inline$$Roles_can_hold_balance_$def$2$$t5@1) (=> (and (= $abort_flag@45 $abort_flag@39) (= $abort_code@52 $abort_code@46)) (and (=> (= (ControlFlow 0 327215) 327141) inline$$Roles_can_hold_balance_$def$2$anon24_Then_correct) (=> (= (ControlFlow 0 327215) 327061) inline$$Roles_can_hold_balance_$def$2$anon24_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 327213) 327215)) inline$$Roles_can_hold_balance_$def$2$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon22_Then_correct  (=> (= (ControlFlow 0 327223) 327215) inline$$Roles_can_hold_balance_$def$2$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2) (= inline$$Roles_can_hold_balance_$def$2$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 327205) 327223) inline$$Roles_can_hold_balance_$def$2$anon22_Then_correct) (=> (= (ControlFlow 0 327205) 327213) inline$$Roles_can_hold_balance_$def$2$anon22_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon23_Else_correct  (=> (and (and (not $abort_flag@44) (= |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1| inline$$Roles_has_child_VASP_role_$def$2$$ret0@2)) (and (= $abort_flag@45 $abort_flag@44) (= $abort_code@52 $abort_code@51))) (and (=> (= (ControlFlow 0 325809) 327141) inline$$Roles_can_hold_balance_$def$2$anon24_Then_correct) (=> (= (ControlFlow 0 325809) 327061) inline$$Roles_can_hold_balance_$def$2$anon24_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon6_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$2$$ret0@2 inline$$Roles_has_role_$def$7$$ret0@2) (= $abort_flag@44 $abort_flag@43)) (and (=> (= (ControlFlow 0 325763) 327163) inline$$Roles_can_hold_balance_$def$2$anon23_Then_correct) (=> (= (ControlFlow 0 325763) 325809) inline$$Roles_can_hold_balance_$def$2$anon23_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 325761) 325763)) inline$$Roles_has_child_VASP_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon9_Then_correct  (=> (= (ControlFlow 0 325771) 325763) inline$$Roles_has_child_VASP_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon8_Else_correct  (=> (not $abort_flag@43) (and (=> (= (ControlFlow 0 325755) 325771) inline$$Roles_has_child_VASP_role_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 325755) 325761) inline$$Roles_has_child_VASP_role_$def$2$anon9_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon8_Then_correct  (=> (and (and $abort_flag@43 (= inline$$Roles_has_child_VASP_role_$def$2$$ret0@1 $Error)) (and (= inline$$Roles_has_child_VASP_role_$def$2$$ret0@2 inline$$Roles_has_child_VASP_role_$def$2$$ret0@1) (= $abort_flag@44 true))) (and (=> (= (ControlFlow 0 325779) 327163) inline$$Roles_can_hold_balance_$def$2$anon23_Then_correct) (=> (= (ControlFlow 0 325779) 325809) inline$$Roles_can_hold_balance_$def$2$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$7$$ret0@1 $Error) (= $abort_flag@43 true)) (and (= $abort_code@51 $abort_code@50) (= inline$$Roles_has_role_$def$7$$ret0@2 inline$$Roles_has_role_$def$7$$ret0@1))) (and (=> (= (ControlFlow 0 325687) 325779) inline$$Roles_has_child_VASP_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 325687) 325755) inline$$Roles_has_child_VASP_role_$def$2$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon7_correct  (=> (and (= $abort_code@50 $abort_code@47) (= (ControlFlow 0 325707) 325687)) inline$$Roles_has_role_$def$7$Abort_correct)))
(let ((inline$$Roles_has_role_$def$7$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 325705) 325707)) inline$$Roles_has_role_$def$7$anon7_correct)))
(let ((inline$$Roles_has_role_$def$7$anon24_Then_correct  (=> (= (ControlFlow 0 325715) 325707) inline$$Roles_has_role_$def$7$anon7_correct)))
(let ((inline$$Roles_has_role_$def$7$anon23_Then_correct  (=> $abort_flag@40 (and (=> (= (ControlFlow 0 325699) 325715) inline$$Roles_has_role_$def$7$anon24_Then_correct) (=> (= (ControlFlow 0 325699) 325705) inline$$Roles_has_role_$def$7$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon13_correct  (=> (and (= $abort_code@50 $abort_code@48) (= (ControlFlow 0 325681) 325687)) inline$$Roles_has_role_$def$7$Abort_correct)))
(let ((inline$$Roles_has_role_$def$7$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 325679) 325681)) inline$$Roles_has_role_$def$7$anon13_correct)))
(let ((inline$$Roles_has_role_$def$7$anon27_Then_correct  (=> (= (ControlFlow 0 325695) 325681) inline$$Roles_has_role_$def$7$anon13_correct)))
(let ((inline$$Roles_has_role_$def$7$anon26_Then_correct  (=> $abort_flag@41 (and (=> (= (ControlFlow 0 325673) 325695) inline$$Roles_has_role_$def$7$anon27_Then_correct) (=> (= (ControlFlow 0 325673) 325679) inline$$Roles_has_role_$def$7$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon20_correct  (=> (= $abort_flag@43 $abort_flag@42) (=> (and (= $abort_code@51 $abort_code@49) (= inline$$Roles_has_role_$def$7$$ret0@2 |inline$$Roles_has_role_$def$7$tmp#$3@2|)) (and (=> (= (ControlFlow 0 325394) 325779) inline$$Roles_has_child_VASP_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 325394) 325755) inline$$Roles_has_child_VASP_role_$def$2$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$7$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 325392) 325394)) inline$$Roles_has_role_$def$7$anon20_correct)))
(let ((inline$$Roles_has_role_$def$7$anon30_Then_correct  (=> (= (ControlFlow 0 325402) 325394) inline$$Roles_has_role_$def$7$anon20_correct)))
(let ((inline$$Roles_has_role_$def$7$anon16_correct  (=> (= $abort_code@49 $abort_code@48) (=> (and (= |inline$$Roles_has_role_$def$7$tmp#$3@2| |inline$$Roles_has_role_$def$7$tmp#$3@1|) (= $abort_flag@42 $abort_flag@41)) (and (=> (= (ControlFlow 0 325661) 325402) inline$$Roles_has_role_$def$7$anon30_Then_correct) (=> (= (ControlFlow 0 325661) 325392) inline$$Roles_has_role_$def$7$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$7$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 325659) 325661)) inline$$Roles_has_role_$def$7$anon16_correct)))
(let ((inline$$Roles_has_role_$def$7$anon28_Then_correct  (=> (= (ControlFlow 0 325669) 325661) inline$$Roles_has_role_$def$7$anon16_correct)))
(let ((inline$$Roles_has_role_$def$7$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$7$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$7$dst@1 inline$$Roles_has_child_VASP_role_$def$2$$t2@1))) (and (=> (= (ControlFlow 0 325653) 325669) inline$$Roles_has_role_$def$7$anon28_Then_correct) (=> (= (ControlFlow 0 325653) 325659) inline$$Roles_has_role_$def$7$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$7$anon0_correct  (=> (and (= inline$$GetFieldFromValue$7$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$7$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 325637) 325653)) inline$$Roles_has_role_$def$7$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$7$anon26_Else_correct  (=> (and (not $abort_flag@41) (= (ControlFlow 0 325643) 325637)) inline$$GetFieldFromValue$7$anon0_correct)))
(let ((inline$$GetGlobal$7$anon3_Then$1_correct  (=> (= $abort_flag@41 true) (=> (and (= $abort_code@48 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$7$dst@2 inline$$GetGlobal$7$dst@0)) (and (=> (= (ControlFlow 0 325583) 325673) inline$$Roles_has_role_$def$7$anon26_Then_correct) (=> (= (ControlFlow 0 325583) 325643) inline$$Roles_has_role_$def$7$anon26_Else_correct))))))
(let ((inline$$GetGlobal$7$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$7$a@1)) (= (ControlFlow 0 325581) 325583)) inline$$GetGlobal$7$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$7$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$7$a@1) (=> (and (and (= inline$$GetGlobal$7$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@12))) (= $abort_flag@41 $abort_flag@40)) (and (= $abort_code@48 $abort_code@47) (= inline$$GetGlobal$7$dst@2 inline$$GetGlobal$7$dst@1))) (and (=> (= (ControlFlow 0 325529) 325673) inline$$Roles_has_role_$def$7$anon26_Then_correct) (=> (= (ControlFlow 0 325529) 325643) inline$$Roles_has_role_$def$7$anon26_Else_correct))))))
(let ((inline$$GetGlobal$7$anon0_correct  (=> (= inline$$GetGlobal$7$a@1 (|a#$Address| call3formal@$ret0@0@@12)) (and (=> (= (ControlFlow 0 325511) 325581) inline$$GetGlobal$7$anon3_Then_correct) (=> (= (ControlFlow 0 325511) 325529) inline$$GetGlobal$7$anon3_Else_correct)))))
(let ((inline$$GetGlobal$7$Entry_correct  (and (=> (= (ControlFlow 0 325505) (- 0 356365)) true) (=> (= (ControlFlow 0 325505) 325511) inline$$GetGlobal$7$anon0_correct))))
(let ((inline$$Roles_has_role_$def$7$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$7$$t6@1) (= (ControlFlow 0 325589) 325505)) inline$$GetGlobal$7$Entry_correct)))
(let ((inline$$Roles_has_role_$def$7$anon18_correct  (=> (= $abort_code@49 $abort_code@47) (=> (and (= |inline$$Roles_has_role_$def$7$tmp#$3@2| inline$$Roles_has_role_$def$7$$t9@1) (= $abort_flag@42 $abort_flag@40)) (and (=> (= (ControlFlow 0 325382) 325402) inline$$Roles_has_role_$def$7$anon30_Then_correct) (=> (= (ControlFlow 0 325382) 325392) inline$$Roles_has_role_$def$7$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$7$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 325380) 325382)) inline$$Roles_has_role_$def$7$anon18_correct)))
(let ((inline$$Roles_has_role_$def$7$anon29_Then_correct  (=> (= (ControlFlow 0 325410) 325382) inline$$Roles_has_role_$def$7$anon18_correct)))
(let ((inline$$Roles_has_role_$def$7$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$7$$t6@1)) (= inline$$Roles_has_role_$def$7$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 325372) 325410) inline$$Roles_has_role_$def$7$anon29_Then_correct) (=> (= (ControlFlow 0 325372) 325380) inline$$Roles_has_role_$def$7$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon23_Else_correct  (=> (and (not $abort_flag@40) (= inline$$Roles_has_role_$def$7$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@12))))) (and (=> (= (ControlFlow 0 325328) 325589) inline$$Roles_has_role_$def$7$anon25_Then_correct) (=> (= (ControlFlow 0 325328) 325372) inline$$Roles_has_role_$def$7$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@40) (=> $abort_flag@40 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@40) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 addr)))) ((_ is $Address) call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 325314) 325699) inline$$Roles_has_role_$def$7$anon23_Then_correct) (=> (= (ControlFlow 0 325314) 325328) inline$$Roles_has_role_$def$7$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 325244) 325314)) inline$$Roles_has_role_$def$7$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$7$anon22_Then_correct  (=> (= (ControlFlow 0 325723) 325314) inline$$Roles_has_role_$def$7$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$7$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 325236) 325723) inline$$Roles_has_role_$def$7$anon22_Then_correct) (=> (= (ControlFlow 0 325236) 325244) inline$$Roles_has_role_$def$7$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon21_Then_correct  (and (=> (= (ControlFlow 0 325731) 325723) inline$$Roles_has_role_$def$7$anon22_Then_correct) (=> (= (ControlFlow 0 325731) 325244) inline$$Roles_has_role_$def$7$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$7$anon0_correct  (=> (not $abort_flag@39) (and (=> (= (ControlFlow 0 325230) 325731) inline$$Roles_has_role_$def$7$anon21_Then_correct) (=> (= (ControlFlow 0 325230) 325236) inline$$Roles_has_role_$def$7$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$7$anon0_correct  (=> ((_ is $Address) addr) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_child_VASP_role_$def$2$$t2@1) (>= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$2$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$2$$t2@1) $MAX_U64)) (= (ControlFlow 0 325737) 325230)) inline$$Roles_has_role_$def$7$anon0_correct))))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon2$1_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$2$$t2@1 ($Integer 6)) (= (ControlFlow 0 325745) 325737)) inline$$Roles_has_role$7$anon0_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 324757) 325745)) inline$$Roles_has_child_VASP_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon7_Then_correct  (=> (= (ControlFlow 0 325787) 325745) inline$$Roles_has_child_VASP_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon0_correct  (=> (not $abort_flag@39) (and (=> (= (ControlFlow 0 324751) 325787) inline$$Roles_has_child_VASP_role_$def$2$anon7_Then_correct) (=> (= (ControlFlow 0 324751) 324757) inline$$Roles_has_child_VASP_role_$def$2$anon7_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role$2$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 325793) 324751)) inline$$Roles_has_child_VASP_role_$def$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2)) (= (ControlFlow 0 325801) 325793)) inline$$Roles_has_child_VASP_role$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon20_Else_correct  (=> (not $abort_flag@39) (and (=> (= (ControlFlow 0 324551) 327205) inline$$Roles_can_hold_balance_$def$2$anon21_Then_correct) (=> (= (ControlFlow 0 324551) 325801) inline$$Roles_can_hold_balance_$def$2$anon21_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon6_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2 inline$$Roles_has_role_$def$6$$ret0@2) (= $abort_flag@39 $abort_flag@38)) (and (=> (= (ControlFlow 0 324505) 327227) inline$$Roles_can_hold_balance_$def$2$anon20_Then_correct) (=> (= (ControlFlow 0 324505) 324551) inline$$Roles_can_hold_balance_$def$2$anon20_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 324503) 324505)) inline$$Roles_has_parent_VASP_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon9_Then_correct  (=> (= (ControlFlow 0 324513) 324505) inline$$Roles_has_parent_VASP_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon8_Else_correct  (=> (not $abort_flag@38) (and (=> (= (ControlFlow 0 324497) 324513) inline$$Roles_has_parent_VASP_role_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 324497) 324503) inline$$Roles_has_parent_VASP_role_$def$2$anon9_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon8_Then_correct  (=> (and (and $abort_flag@38 (= inline$$Roles_has_parent_VASP_role_$def$2$$ret0@1 $Error)) (and (= inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2 inline$$Roles_has_parent_VASP_role_$def$2$$ret0@1) (= $abort_flag@39 true))) (and (=> (= (ControlFlow 0 324521) 327227) inline$$Roles_can_hold_balance_$def$2$anon20_Then_correct) (=> (= (ControlFlow 0 324521) 324551) inline$$Roles_can_hold_balance_$def$2$anon20_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$6$$ret0@1 $Error) (= $abort_flag@38 true)) (and (= $abort_code@46 $abort_code@45) (= inline$$Roles_has_role_$def$6$$ret0@2 inline$$Roles_has_role_$def$6$$ret0@1))) (and (=> (= (ControlFlow 0 324429) 324521) inline$$Roles_has_parent_VASP_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 324429) 324497) inline$$Roles_has_parent_VASP_role_$def$2$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon7_correct  (=> (and (= $abort_code@45 $abort_code@42) (= (ControlFlow 0 324449) 324429)) inline$$Roles_has_role_$def$6$Abort_correct)))
(let ((inline$$Roles_has_role_$def$6$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 324447) 324449)) inline$$Roles_has_role_$def$6$anon7_correct)))
(let ((inline$$Roles_has_role_$def$6$anon24_Then_correct  (=> (= (ControlFlow 0 324457) 324449) inline$$Roles_has_role_$def$6$anon7_correct)))
(let ((inline$$Roles_has_role_$def$6$anon23_Then_correct  (=> $abort_flag@35 (and (=> (= (ControlFlow 0 324441) 324457) inline$$Roles_has_role_$def$6$anon24_Then_correct) (=> (= (ControlFlow 0 324441) 324447) inline$$Roles_has_role_$def$6$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon13_correct  (=> (and (= $abort_code@45 $abort_code@43) (= (ControlFlow 0 324423) 324429)) inline$$Roles_has_role_$def$6$Abort_correct)))
(let ((inline$$Roles_has_role_$def$6$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 324421) 324423)) inline$$Roles_has_role_$def$6$anon13_correct)))
(let ((inline$$Roles_has_role_$def$6$anon27_Then_correct  (=> (= (ControlFlow 0 324437) 324423) inline$$Roles_has_role_$def$6$anon13_correct)))
(let ((inline$$Roles_has_role_$def$6$anon26_Then_correct  (=> $abort_flag@36 (and (=> (= (ControlFlow 0 324415) 324437) inline$$Roles_has_role_$def$6$anon27_Then_correct) (=> (= (ControlFlow 0 324415) 324421) inline$$Roles_has_role_$def$6$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon20_correct  (=> (= $abort_flag@38 $abort_flag@37) (=> (and (= $abort_code@46 $abort_code@44) (= inline$$Roles_has_role_$def$6$$ret0@2 |inline$$Roles_has_role_$def$6$tmp#$3@2|)) (and (=> (= (ControlFlow 0 324136) 324521) inline$$Roles_has_parent_VASP_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 324136) 324497) inline$$Roles_has_parent_VASP_role_$def$2$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$6$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 324134) 324136)) inline$$Roles_has_role_$def$6$anon20_correct)))
(let ((inline$$Roles_has_role_$def$6$anon30_Then_correct  (=> (= (ControlFlow 0 324144) 324136) inline$$Roles_has_role_$def$6$anon20_correct)))
(let ((inline$$Roles_has_role_$def$6$anon16_correct  (=> (= $abort_flag@37 $abort_flag@36) (=> (and (= |inline$$Roles_has_role_$def$6$tmp#$3@2| |inline$$Roles_has_role_$def$6$tmp#$3@1|) (= $abort_code@44 $abort_code@43)) (and (=> (= (ControlFlow 0 324403) 324144) inline$$Roles_has_role_$def$6$anon30_Then_correct) (=> (= (ControlFlow 0 324403) 324134) inline$$Roles_has_role_$def$6$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$6$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 324401) 324403)) inline$$Roles_has_role_$def$6$anon16_correct)))
(let ((inline$$Roles_has_role_$def$6$anon28_Then_correct  (=> (= (ControlFlow 0 324411) 324403) inline$$Roles_has_role_$def$6$anon16_correct)))
(let ((inline$$Roles_has_role_$def$6$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$6$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$6$dst@1 inline$$Roles_has_parent_VASP_role_$def$2$$t2@1))) (and (=> (= (ControlFlow 0 324395) 324411) inline$$Roles_has_role_$def$6$anon28_Then_correct) (=> (= (ControlFlow 0 324395) 324401) inline$$Roles_has_role_$def$6$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$6$anon0_correct  (=> (and (= inline$$GetFieldFromValue$6$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$6$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 324379) 324395)) inline$$Roles_has_role_$def$6$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$6$anon26_Else_correct  (=> (and (not $abort_flag@36) (= (ControlFlow 0 324385) 324379)) inline$$GetFieldFromValue$6$anon0_correct)))
(let ((inline$$GetGlobal$6$anon3_Then$1_correct  (=> (= $abort_code@43 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@36 true) (= inline$$GetGlobal$6$dst@2 inline$$GetGlobal$6$dst@0)) (and (=> (= (ControlFlow 0 324325) 324415) inline$$Roles_has_role_$def$6$anon26_Then_correct) (=> (= (ControlFlow 0 324325) 324385) inline$$Roles_has_role_$def$6$anon26_Else_correct))))))
(let ((inline$$GetGlobal$6$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$6$a@1)) (= (ControlFlow 0 324323) 324325)) inline$$GetGlobal$6$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$6$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$6$a@1) (=> (and (and (= inline$$GetGlobal$6$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@13))) (= $abort_code@43 $abort_code@42)) (and (= $abort_flag@36 $abort_flag@35) (= inline$$GetGlobal$6$dst@2 inline$$GetGlobal$6$dst@1))) (and (=> (= (ControlFlow 0 324271) 324415) inline$$Roles_has_role_$def$6$anon26_Then_correct) (=> (= (ControlFlow 0 324271) 324385) inline$$Roles_has_role_$def$6$anon26_Else_correct))))))
(let ((inline$$GetGlobal$6$anon0_correct  (=> (= inline$$GetGlobal$6$a@1 (|a#$Address| call3formal@$ret0@0@@13)) (and (=> (= (ControlFlow 0 324253) 324323) inline$$GetGlobal$6$anon3_Then_correct) (=> (= (ControlFlow 0 324253) 324271) inline$$GetGlobal$6$anon3_Else_correct)))))
(let ((inline$$GetGlobal$6$Entry_correct  (and (=> (= (ControlFlow 0 324247) (- 0 355769)) true) (=> (= (ControlFlow 0 324247) 324253) inline$$GetGlobal$6$anon0_correct))))
(let ((inline$$Roles_has_role_$def$6$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$6$$t6@1) (= (ControlFlow 0 324331) 324247)) inline$$GetGlobal$6$Entry_correct)))
(let ((inline$$Roles_has_role_$def$6$anon18_correct  (=> (= $abort_flag@37 $abort_flag@35) (=> (and (= |inline$$Roles_has_role_$def$6$tmp#$3@2| inline$$Roles_has_role_$def$6$$t9@1) (= $abort_code@44 $abort_code@42)) (and (=> (= (ControlFlow 0 324124) 324144) inline$$Roles_has_role_$def$6$anon30_Then_correct) (=> (= (ControlFlow 0 324124) 324134) inline$$Roles_has_role_$def$6$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$6$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 324122) 324124)) inline$$Roles_has_role_$def$6$anon18_correct)))
(let ((inline$$Roles_has_role_$def$6$anon29_Then_correct  (=> (= (ControlFlow 0 324152) 324124) inline$$Roles_has_role_$def$6$anon18_correct)))
(let ((inline$$Roles_has_role_$def$6$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$6$$t6@1)) (= inline$$Roles_has_role_$def$6$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 324114) 324152) inline$$Roles_has_role_$def$6$anon29_Then_correct) (=> (= (ControlFlow 0 324114) 324122) inline$$Roles_has_role_$def$6$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon23_Else_correct  (=> (and (not $abort_flag@35) (= inline$$Roles_has_role_$def$6$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@13))))) (and (=> (= (ControlFlow 0 324070) 324331) inline$$Roles_has_role_$def$6$anon25_Then_correct) (=> (= (ControlFlow 0 324070) 324114) inline$$Roles_has_role_$def$6$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@35) (=> $abort_flag@35 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@35) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 addr)))) ((_ is $Address) call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 324056) 324441) inline$$Roles_has_role_$def$6$anon23_Then_correct) (=> (= (ControlFlow 0 324056) 324070) inline$$Roles_has_role_$def$6$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 323986) 324056)) inline$$Roles_has_role_$def$6$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$6$anon22_Then_correct  (=> (= (ControlFlow 0 324465) 324056) inline$$Roles_has_role_$def$6$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$6$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 323978) 324465) inline$$Roles_has_role_$def$6$anon22_Then_correct) (=> (= (ControlFlow 0 323978) 323986) inline$$Roles_has_role_$def$6$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon21_Then_correct  (and (=> (= (ControlFlow 0 324473) 324465) inline$$Roles_has_role_$def$6$anon22_Then_correct) (=> (= (ControlFlow 0 324473) 323986) inline$$Roles_has_role_$def$6$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$6$anon0_correct  (=> (not $abort_flag@34) (and (=> (= (ControlFlow 0 323972) 324473) inline$$Roles_has_role_$def$6$anon21_Then_correct) (=> (= (ControlFlow 0 323972) 323978) inline$$Roles_has_role_$def$6$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$6$anon0_correct  (=> ((_ is $Address) addr) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_parent_VASP_role_$def$2$$t2@1) (>= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$2$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$2$$t2@1) $MAX_U64)) (= (ControlFlow 0 324479) 323972)) inline$$Roles_has_role_$def$6$anon0_correct))))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon2$1_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$2$$t2@1 ($Integer 5)) (= (ControlFlow 0 324487) 324479)) inline$$Roles_has_role$6$anon0_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 323499) 324487)) inline$$Roles_has_parent_VASP_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon7_Then_correct  (=> (= (ControlFlow 0 324529) 324487) inline$$Roles_has_parent_VASP_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon0_correct  (=> (not $abort_flag@34) (and (=> (= (ControlFlow 0 323493) 324529) inline$$Roles_has_parent_VASP_role_$def$2$anon7_Then_correct) (=> (= (ControlFlow 0 323493) 323499) inline$$Roles_has_parent_VASP_role_$def$2$anon7_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role$2$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 324535) 323493)) inline$$Roles_has_parent_VASP_role_$def$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 323265) 324535)) inline$$Roles_has_parent_VASP_role$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon19_Then_correct  (=> (= (ControlFlow 0 327235) 324535) inline$$Roles_has_parent_VASP_role$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon0_correct  (=> (not $abort_flag@34) (and (=> (= (ControlFlow 0 323259) 327235) inline$$Roles_can_hold_balance_$def$2$anon19_Then_correct) (=> (= (ControlFlow 0 323259) 323265) inline$$Roles_can_hold_balance_$def$2$anon19_Else_correct)))))
(let ((inline$$Roles_can_hold_balance$2$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 327241) 323259)) inline$$Roles_can_hold_balance_$def$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon36_Else_correct  (=> (and (not $abort_flag@34) (= (ControlFlow 0 327249) 327241)) inline$$Roles_can_hold_balance$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@34) (=> (and (=> $abort_flag@34 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@34 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@41 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 322913) 328456) inline$$DiemAccount_add_currency_$def$2$anon36_Then_correct) (=> (= (ControlFlow 0 322913) 327249) inline$$DiemAccount_add_currency_$def$2$anon36_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 322877) 322913)) inline$$DiemAccount_add_currency_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon35_Then_correct  (=> (= (ControlFlow 0 328480) 322913) inline$$DiemAccount_add_currency_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon0_correct  (=> (not $abort_flag@33) (and (=> (= (ControlFlow 0 322871) 328480) inline$$DiemAccount_add_currency_$def$2$anon35_Then_correct) (=> (= (ControlFlow 0 322871) 322877) inline$$DiemAccount_add_currency_$def$2$anon35_Else_correct)))))
(let ((inline$$DiemAccount_add_currency$2$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 328484) 322871)) inline$$DiemAccount_add_currency_$def$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency$2$Entry_correct  (=> (and (= inline$$DiemAccount_add_currency$2$$tv0@0 $XUS_XUS_type_value) (= (ControlFlow 0 322315) 328484)) inline$$DiemAccount_add_currency$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 328490) 322315)) inline$$DiemAccount_add_currency$2$Entry_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon27_Else_correct  (=> (not (|b#$Boolean| inline$$Not$1$dst@1)) (=> (and (and (= $DiemAccount_Balance_$memory@4 $DiemAccount_Balance_$memory@1) (= $abort_flag@60 $abort_flag@33)) (and (= $abort_code@70 $abort_code@40) (= (ControlFlow 0 315934) 316004))) inline$$DiemAccount_add_currencies_for_account_$def$0$L5_correct))))
(let ((inline$$Not$1$anon0_correct  (=> (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currencies_for_account_$def$0$$t5@1)))) (and (=> (= (ControlFlow 0 315918) 328490) inline$$DiemAccount_add_currencies_for_account_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 315918) 315934) inline$$DiemAccount_add_currencies_for_account_$def$0$anon27_Else_correct)))))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 315908) (- 0 355229)) true) (=> (= (ControlFlow 0 315908) 315918) inline$$Not$1$anon0_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon26_Then_correct  (=> (|b#$Boolean| add_all_currencies) (=> (and (= inline$$DiemAccount_add_currencies_for_account_$def$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| call3formal@$ret0@0@@7)))) (= (ControlFlow 0 315924) 315908)) inline$$Not$1$Entry_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon26_Else_correct  (=> (not (|b#$Boolean| add_all_currencies)) (=> (and (and (= $abort_code@101 $abort_code@40) (= $DiemAccount_Balance_$memory@8 $DiemAccount_Balance_$memory@1)) (and (= $abort_flag@88 $abort_flag@33) (= (ControlFlow 0 315848) 315850))) inline$$DiemAccount_add_currencies_for_account_$def$0$L10_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Else_correct  (=> (not $abort_flag@33) (and (=> (= (ControlFlow 0 315840) 315924) inline$$DiemAccount_add_currencies_for_account_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 315840) 315848) inline$$DiemAccount_add_currencies_for_account_$def$0$anon26_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon50_Else_correct  (=> (and (and (not $abort_flag@32) (= $abort_flag@33 $abort_flag@32)) (and (= $abort_code@40 $abort_code@38) (= $DiemAccount_Balance_$memory@1 |inline$$MoveToRaw$0$m'@2|))) (and (=> (= (ControlFlow 0 315706) 328506) inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 315706) 315840) inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$Abort_correct  (=> (= $abort_flag@33 true) (=> (and (= $abort_code@40 $abort_code@39) (= $DiemAccount_Balance_$memory@1 $DiemAccount_Balance_$memory@0)) (and (=> (= (ControlFlow 0 314633) 328506) inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 314633) 315840) inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon5_correct  (=> (= $abort_code@39 $abort_code@12) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 315806) 314633)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 315804) 315806)) inline$$DiemAccount_add_currency_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon37_Then_correct  (=> (= (ControlFlow 0 315814) 315806) inline$$DiemAccount_add_currency_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon36_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 315798) 315814) inline$$DiemAccount_add_currency_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 315798) 315804) inline$$DiemAccount_add_currency_$def$0$anon37_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon11_correct  (=> (= $abort_code@39 $abort_code@32) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 315782) 314633)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 315780) 315782)) inline$$DiemAccount_add_currency_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 315790) 315782) inline$$DiemAccount_add_currency_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon39_Then_correct  (=> $abort_flag@27 (and (=> (= (ControlFlow 0 315774) 315790) inline$$DiemAccount_add_currency_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 315774) 315780) inline$$DiemAccount_add_currency_$def$0$anon40_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon19_correct  (=> (= $abort_code@39 $abort_code@33) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 315762) 314633)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 315760) 315762)) inline$$DiemAccount_add_currency_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 315770) 315762) inline$$DiemAccount_add_currency_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon43_Then_correct  (=> $abort_flag@28 (and (=> (= (ControlFlow 0 315754) 315770) inline$$DiemAccount_add_currency_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 315754) 315760) inline$$DiemAccount_add_currency_$def$0$anon44_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon23_correct  (=> (= $abort_code@39 $abort_code@35) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 315742) 314633)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 315740) 315742)) inline$$DiemAccount_add_currency_$def$0$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 315750) 315742) inline$$DiemAccount_add_currency_$def$0$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon45_Then_correct  (=> $abort_flag@29 (and (=> (= (ControlFlow 0 315734) 315750) inline$$DiemAccount_add_currency_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 315734) 315740) inline$$DiemAccount_add_currency_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon33_correct  (=> (= $abort_code@39 $abort_code@38) (=> (and (= $DiemAccount_Balance_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 315718) 314633)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 315716) 315718)) inline$$DiemAccount_add_currency_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 315726) 315718) inline$$DiemAccount_add_currency_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon50_Then_correct  (=> $abort_flag@32 (and (=> (= (ControlFlow 0 315710) 315726) inline$$DiemAccount_add_currency_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 315710) 315716) inline$$DiemAccount_add_currency_$def$0$anon51_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_code@38 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@32 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 315684) 315710) inline$$DiemAccount_add_currency_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 315684) 315706) inline$$DiemAccount_add_currency_$def$0$anon50_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 315682) 315684)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 inline$$DiemAccount_Balance_pack$0$$struct@1))) (= $abort_code@38 $abort_code@37)) (and (= $abort_flag@32 $abort_flag@31) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 315632) 315710) inline$$DiemAccount_add_currency_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 315632) 315706) inline$$DiemAccount_add_currency_$def$0$anon50_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| addr)) (and (=> (= (ControlFlow 0 315690) 315682) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 315690) 315632) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 315478) (- 0 354923)) true) (=> (= (ControlFlow 0 315478) 315690) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (= (ControlFlow 0 315450) 315478)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 315352) 315450)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 315358) 315450) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 315346) 315358) inline$$DiemAccount_Balance_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 315346) 315352) inline$$DiemAccount_Balance_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemAccount_Balance_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 315338) 315450)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$0$$ret0@2) (let ((va@@20 (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$DiemAccount_Balance_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 315330) 315346) inline$$DiemAccount_Balance_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 315330) 315338) inline$$DiemAccount_Balance_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon49_Else_correct  (=> (and (not $abort_flag@31) (= (ControlFlow 0 315364) 315330)) inline$$DiemAccount_Balance_pack$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon49_Then_correct  (=> (and (and $abort_flag@31 (= $abort_code@39 $abort_code@37)) (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 315730) 314633))) inline$$DiemAccount_add_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_zero_$def$0$anon3_correct  (=> (= inline$$Diem_zero_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@31 true) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_zero_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 315169) 315730) inline$$DiemAccount_add_currency_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 315169) 315364) inline$$DiemAccount_add_currency_$def$0$anon49_Else_correct))))))
(let ((inline$$Diem_zero_$def$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 315163) 315169)) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon8_Then_correct  (=> (= (ControlFlow 0 315177) 315169) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon7_Then_correct  (=> $abort_flag@30 (and (=> (= (ControlFlow 0 315157) 315177) inline$$Diem_zero_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 315157) 315163) inline$$Diem_zero_$def$0$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon6_correct  (=> (and (= $abort_flag@31 $abort_flag@30) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_Diem_pack$0$$struct@1)) (and (=> (= (ControlFlow 0 315145) 315730) inline$$DiemAccount_add_currency_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 315145) 315364) inline$$DiemAccount_add_currency_$def$0$anon49_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 315143) 315145)) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_zero_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 315153) 315145) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 315121) 315153) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 315121) 315143) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 315127) 315153) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 315127) 315143) inline$$Diem_zero_$def$0$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 315115) 315127) inline$$Diem_Diem_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 315115) 315121) inline$$Diem_Diem_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 315107) 315153) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 315107) 315143) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$0$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 315099) 315115) inline$$Diem_Diem_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 315099) 315107) inline$$Diem_Diem_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon7_Else_correct  (=> (not $abort_flag@30) (=> (and (= inline$$Diem_zero_$def$0$$t0@1 ($Integer 0)) (= (ControlFlow 0 315133) 315099)) inline$$Diem_Diem_pack$0$anon0_correct))))
(let ((inline$$Diem_zero_$def$0$anon0_correct  (=> (and (and (not $abort_flag@29) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@30)) (and (=> $abort_flag@30 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@30 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@37 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 314958) 315157) inline$$Diem_zero_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 314958) 315133) inline$$Diem_zero_$def$0$anon7_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon47_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 315191) 314958)) inline$$Diem_zero_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon28_correct  (=> (= $abort_code@39 $abort_code@36) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 314753) 314633)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 314751) 314753)) inline$$DiemAccount_add_currency_$def$0$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 314761) 314753) inline$$DiemAccount_add_currency_$def$0$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon47_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@36 (|i#$Integer| call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 314745) 314761) inline$$DiemAccount_add_currency_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 314745) 314751) inline$$DiemAccount_add_currency_$def$0$anon48_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon45_Else_correct  (=> (not $abort_flag@29) (and (=> (= (ControlFlow 0 314733) 315191) inline$$DiemAccount_add_currency_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 314733) 314745) inline$$DiemAccount_add_currency_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon43_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$0$$t12@1 ($Integer 15)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@29)) (and (=> $abort_flag@29 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@29) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@14) (>= (|i#$Integer| call3formal@$ret0@0@@14) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@14) $MAX_U64))) (and (=> (= (ControlFlow 0 314727) 315734) inline$$DiemAccount_add_currency_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 314727) 314733) inline$$DiemAccount_add_currency_$def$0$anon45_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currency_$def$0$$t10@1)))) (= (ControlFlow 0 314715) 314727)) inline$$DiemAccount_add_currency_$def$0$anon43_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 314705) (- 0 354465)) true) (=> (= (ControlFlow 0 314705) 314715) inline$$Not$0$anon0_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon43_Else_correct  (=> (not $abort_flag@28) (=> (and (= inline$$DiemAccount_add_currency_$def$0$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@15)))) (= (ControlFlow 0 314721) 314705)) inline$$Not$0$Entry_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon41_Then_correct  (=> (|b#$Boolean| inline$$Roles_can_hold_balance_$def$0$$ret0@2) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@28) (=> $abort_flag@28 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@28) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 addr)))) ((_ is $Address) call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 314647) 315754) inline$$DiemAccount_add_currency_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 314647) 314721) inline$$DiemAccount_add_currency_$def$0$anon43_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon16_correct  (=> (= $abort_code@39 $abort_code@34) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 314629) 314633)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 314627) 314629)) inline$$DiemAccount_add_currency_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 314641) 314629) inline$$DiemAccount_add_currency_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_can_hold_balance_$def$0$$ret0@2)) (= $abort_code@34 (|i#$Integer| call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 314621) 314641) inline$$DiemAccount_add_currency_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 314621) 314627) inline$$DiemAccount_add_currency_$def$0$anon42_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon39_Else_correct  (=> (not $abort_flag@27) (and (=> (= (ControlFlow 0 314609) 314647) inline$$DiemAccount_add_currency_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 314609) 314621) inline$$DiemAccount_add_currency_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon38_Else_correct  (=> (not $abort_flag@26) (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$0$$t8@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@27)) (and (=> $abort_flag@27 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@27) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@16) (>= (|i#$Integer| call3formal@$ret0@0@@16) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@16) $MAX_U64))) (and (=> (= (ControlFlow 0 314603) 315774) inline$$DiemAccount_add_currency_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 314603) 314609) inline$$DiemAccount_add_currency_$def$0$anon39_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon38_Then_correct  (=> (and (and $abort_flag@26 (= $abort_code@39 $abort_code@31)) (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 315794) 314633))) inline$$DiemAccount_add_currency_$def$0$Abort_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$Abort_correct  (=> (and (and (= inline$$Roles_can_hold_balance_$def$0$$ret0@1 $Error) (= inline$$Roles_can_hold_balance_$def$0$$ret0@2 inline$$Roles_can_hold_balance_$def$0$$ret0@1)) (and (= $abort_code@31 $abort_code@29) (= $abort_flag@26 true))) (and (=> (= (ControlFlow 0 314441) 315794) inline$$DiemAccount_add_currency_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 314441) 314603) inline$$DiemAccount_add_currency_$def$0$anon38_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon26_Then_correct  (=> $abort_flag@24 (=> (and (= $abort_code@29 $abort_code@28) (= (ControlFlow 0 314435) 314441)) inline$$Roles_can_hold_balance_$def$0$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon23_Then_correct  (=> $abort_flag@18 (=> (and (= $abort_code@29 $abort_code@22) (= (ControlFlow 0 314505) 314441)) inline$$Roles_can_hold_balance_$def$0$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon20_Then_correct  (=> $abort_flag@13 (=> (and (= $abort_code@29 $abort_code@17) (= (ControlFlow 0 314569) 314441)) inline$$Roles_can_hold_balance_$def$0$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon18_correct  (=> (= inline$$Roles_can_hold_balance_$def$0$$ret0@2 |inline$$Roles_can_hold_balance_$def$0$tmp#$2@1|) (=> (and (= $abort_code@31 $abort_code@30) (= $abort_flag@26 $abort_flag@25)) (and (=> (= (ControlFlow 0 314423) 315794) inline$$DiemAccount_add_currency_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 314423) 314603) inline$$DiemAccount_add_currency_$def$0$anon38_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 314421) 314423)) inline$$Roles_can_hold_balance_$def$0$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 314431) 314423) inline$$Roles_can_hold_balance_$def$0$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon14_correct  (=> (= |inline$$Roles_can_hold_balance_$def$0$tmp#$2@1| inline$$Roles_can_hold_balance_$def$0$$t6@1) (=> (and (= $abort_code@30 $abort_code@23) (= $abort_flag@25 $abort_flag@19)) (and (=> (= (ControlFlow 0 314493) 314431) inline$$Roles_can_hold_balance_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 314493) 314421) inline$$Roles_can_hold_balance_$def$0$anon27_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 314491) 314493)) inline$$Roles_can_hold_balance_$def$0$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 314501) 314493) inline$$Roles_can_hold_balance_$def$0$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon24_Then_correct  (=> (and (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1|) (= inline$$Roles_can_hold_balance_$def$0$$t6@1 ($Boolean true))) (and (=> (= (ControlFlow 0 314483) 314501) inline$$Roles_can_hold_balance_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 314483) 314491) inline$$Roles_can_hold_balance_$def$0$anon25_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon26_Else_correct  (=> (and (and (not $abort_flag@24) (= |inline$$Roles_can_hold_balance_$def$0$tmp#$2@1| inline$$Roles_has_designated_dealer_role_$def$0$$ret0@2)) (and (= $abort_code@30 $abort_code@28) (= $abort_flag@25 $abort_flag@24))) (and (=> (= (ControlFlow 0 314411) 314431) inline$$Roles_can_hold_balance_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 314411) 314421) inline$$Roles_can_hold_balance_$def$0$anon27_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon6_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$2$$ret0@2) (= $abort_flag@24 $abort_flag@23)) (and (=> (= (ControlFlow 0 314365) 314435) inline$$Roles_can_hold_balance_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 314365) 314411) inline$$Roles_can_hold_balance_$def$0$anon26_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 314363) 314365)) inline$$Roles_has_designated_dealer_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 314373) 314365) inline$$Roles_has_designated_dealer_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@23) (and (=> (= (ControlFlow 0 314357) 314373) inline$$Roles_has_designated_dealer_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 314357) 314363) inline$$Roles_has_designated_dealer_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon8_Then_correct  (=> (and (and $abort_flag@23 (= inline$$Roles_has_designated_dealer_role_$def$0$$ret0@1 $Error)) (and (= inline$$Roles_has_designated_dealer_role_$def$0$$ret0@2 inline$$Roles_has_designated_dealer_role_$def$0$$ret0@1) (= $abort_flag@24 true))) (and (=> (= (ControlFlow 0 314381) 314435) inline$$Roles_can_hold_balance_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 314381) 314411) inline$$Roles_can_hold_balance_$def$0$anon26_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$2$$ret0@1 $Error) (= $abort_flag@23 true)) (and (= $abort_code@28 $abort_code@27) (= inline$$Roles_has_role_$def$2$$ret0@2 inline$$Roles_has_role_$def$2$$ret0@1))) (and (=> (= (ControlFlow 0 314289) 314381) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 314289) 314357) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon7_correct  (=> (and (= $abort_code@27 $abort_code@24) (= (ControlFlow 0 314309) 314289)) inline$$Roles_has_role_$def$2$Abort_correct)))
(let ((inline$$Roles_has_role_$def$2$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 314307) 314309)) inline$$Roles_has_role_$def$2$anon7_correct)))
(let ((inline$$Roles_has_role_$def$2$anon24_Then_correct  (=> (= (ControlFlow 0 314317) 314309) inline$$Roles_has_role_$def$2$anon7_correct)))
(let ((inline$$Roles_has_role_$def$2$anon23_Then_correct  (=> $abort_flag@20 (and (=> (= (ControlFlow 0 314301) 314317) inline$$Roles_has_role_$def$2$anon24_Then_correct) (=> (= (ControlFlow 0 314301) 314307) inline$$Roles_has_role_$def$2$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon13_correct  (=> (and (= $abort_code@27 $abort_code@25) (= (ControlFlow 0 314283) 314289)) inline$$Roles_has_role_$def$2$Abort_correct)))
(let ((inline$$Roles_has_role_$def$2$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 314281) 314283)) inline$$Roles_has_role_$def$2$anon13_correct)))
(let ((inline$$Roles_has_role_$def$2$anon27_Then_correct  (=> (= (ControlFlow 0 314297) 314283) inline$$Roles_has_role_$def$2$anon13_correct)))
(let ((inline$$Roles_has_role_$def$2$anon26_Then_correct  (=> $abort_flag@21 (and (=> (= (ControlFlow 0 314275) 314297) inline$$Roles_has_role_$def$2$anon27_Then_correct) (=> (= (ControlFlow 0 314275) 314281) inline$$Roles_has_role_$def$2$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon20_correct  (=> (= $abort_flag@23 $abort_flag@22) (=> (and (= $abort_code@28 $abort_code@26) (= inline$$Roles_has_role_$def$2$$ret0@2 |inline$$Roles_has_role_$def$2$tmp#$3@2|)) (and (=> (= (ControlFlow 0 313996) 314381) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 313996) 314357) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$2$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 313994) 313996)) inline$$Roles_has_role_$def$2$anon20_correct)))
(let ((inline$$Roles_has_role_$def$2$anon30_Then_correct  (=> (= (ControlFlow 0 314004) 313996) inline$$Roles_has_role_$def$2$anon20_correct)))
(let ((inline$$Roles_has_role_$def$2$anon16_correct  (=> (= $abort_flag@22 $abort_flag@21) (=> (and (= |inline$$Roles_has_role_$def$2$tmp#$3@2| |inline$$Roles_has_role_$def$2$tmp#$3@1|) (= $abort_code@26 $abort_code@25)) (and (=> (= (ControlFlow 0 314263) 314004) inline$$Roles_has_role_$def$2$anon30_Then_correct) (=> (= (ControlFlow 0 314263) 313994) inline$$Roles_has_role_$def$2$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$2$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 314261) 314263)) inline$$Roles_has_role_$def$2$anon16_correct)))
(let ((inline$$Roles_has_role_$def$2$anon28_Then_correct  (=> (= (ControlFlow 0 314271) 314263) inline$$Roles_has_role_$def$2$anon16_correct)))
(let ((inline$$Roles_has_role_$def$2$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$2$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$2$dst@1 inline$$Roles_has_designated_dealer_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 314255) 314271) inline$$Roles_has_role_$def$2$anon28_Then_correct) (=> (= (ControlFlow 0 314255) 314261) inline$$Roles_has_role_$def$2$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (and (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$2$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 314239) 314255)) inline$$Roles_has_role_$def$2$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$2$anon26_Else_correct  (=> (and (not $abort_flag@21) (= (ControlFlow 0 314245) 314239)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$GetGlobal$2$anon3_Then$1_correct  (=> (= $abort_code@25 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@21 true) (= inline$$GetGlobal$2$dst@2 inline$$GetGlobal$2$dst@0)) (and (=> (= (ControlFlow 0 314185) 314275) inline$$Roles_has_role_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 314185) 314245) inline$$Roles_has_role_$def$2$anon26_Else_correct))))))
(let ((inline$$GetGlobal$2$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$2$a@1)) (= (ControlFlow 0 314183) 314185)) inline$$GetGlobal$2$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$2$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$2$a@1) (=> (and (and (= inline$$GetGlobal$2$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@17))) (= $abort_code@25 $abort_code@24)) (and (= $abort_flag@21 $abort_flag@20) (= inline$$GetGlobal$2$dst@2 inline$$GetGlobal$2$dst@1))) (and (=> (= (ControlFlow 0 314131) 314275) inline$$Roles_has_role_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 314131) 314245) inline$$Roles_has_role_$def$2$anon26_Else_correct))))))
(let ((inline$$GetGlobal$2$anon0_correct  (=> (= inline$$GetGlobal$2$a@1 (|a#$Address| call3formal@$ret0@0@@17)) (and (=> (= (ControlFlow 0 314113) 314183) inline$$GetGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 314113) 314131) inline$$GetGlobal$2$anon3_Else_correct)))))
(let ((inline$$GetGlobal$2$Entry_correct  (and (=> (= (ControlFlow 0 314107) (- 0 353871)) true) (=> (= (ControlFlow 0 314107) 314113) inline$$GetGlobal$2$anon0_correct))))
(let ((inline$$Roles_has_role_$def$2$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$2$$t6@1) (= (ControlFlow 0 314191) 314107)) inline$$GetGlobal$2$Entry_correct)))
(let ((inline$$Roles_has_role_$def$2$anon18_correct  (=> (= $abort_flag@22 $abort_flag@20) (=> (and (= |inline$$Roles_has_role_$def$2$tmp#$3@2| inline$$Roles_has_role_$def$2$$t9@1) (= $abort_code@26 $abort_code@24)) (and (=> (= (ControlFlow 0 313984) 314004) inline$$Roles_has_role_$def$2$anon30_Then_correct) (=> (= (ControlFlow 0 313984) 313994) inline$$Roles_has_role_$def$2$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$2$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 313982) 313984)) inline$$Roles_has_role_$def$2$anon18_correct)))
(let ((inline$$Roles_has_role_$def$2$anon29_Then_correct  (=> (= (ControlFlow 0 314012) 313984) inline$$Roles_has_role_$def$2$anon18_correct)))
(let ((inline$$Roles_has_role_$def$2$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$2$$t6@1)) (= inline$$Roles_has_role_$def$2$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 313974) 314012) inline$$Roles_has_role_$def$2$anon29_Then_correct) (=> (= (ControlFlow 0 313974) 313982) inline$$Roles_has_role_$def$2$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon23_Else_correct  (=> (and (not $abort_flag@20) (= inline$$Roles_has_role_$def$2$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@17))))) (and (=> (= (ControlFlow 0 313930) 314191) inline$$Roles_has_role_$def$2$anon25_Then_correct) (=> (= (ControlFlow 0 313930) 313974) inline$$Roles_has_role_$def$2$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@20) (=> $abort_flag@20 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 addr)))) ((_ is $Address) call3formal@$ret0@0@@17))) (and (=> (= (ControlFlow 0 313916) 314301) inline$$Roles_has_role_$def$2$anon23_Then_correct) (=> (= (ControlFlow 0 313916) 313930) inline$$Roles_has_role_$def$2$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 313846) 313916)) inline$$Roles_has_role_$def$2$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$2$anon22_Then_correct  (=> (= (ControlFlow 0 314325) 313916) inline$$Roles_has_role_$def$2$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$2$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 313838) 314325) inline$$Roles_has_role_$def$2$anon22_Then_correct) (=> (= (ControlFlow 0 313838) 313846) inline$$Roles_has_role_$def$2$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon21_Then_correct  (and (=> (= (ControlFlow 0 314333) 314325) inline$$Roles_has_role_$def$2$anon22_Then_correct) (=> (= (ControlFlow 0 314333) 313846) inline$$Roles_has_role_$def$2$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$2$anon0_correct  (=> (not $abort_flag@19) (and (=> (= (ControlFlow 0 313832) 314333) inline$$Roles_has_role_$def$2$anon21_Then_correct) (=> (= (ControlFlow 0 313832) 313838) inline$$Roles_has_role_$def$2$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$2$anon0_correct  (=> ((_ is $Address) addr) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_designated_dealer_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 314339) 313832)) inline$$Roles_has_role_$def$2$anon0_correct))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$0$$t2@1 ($Integer 2)) (= (ControlFlow 0 314347) 314339)) inline$$Roles_has_role$2$anon0_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 313359) 314347)) inline$$Roles_has_designated_dealer_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 314389) 314347) inline$$Roles_has_designated_dealer_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon0_correct  (=> (not $abort_flag@19) (and (=> (= (ControlFlow 0 313353) 314389) inline$$Roles_has_designated_dealer_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 313353) 313359) inline$$Roles_has_designated_dealer_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role$0$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 314395) 313353)) inline$$Roles_has_designated_dealer_role_$def$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon24_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1|)) (= (ControlFlow 0 314403) 314395)) inline$$Roles_has_designated_dealer_role$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon8_correct  (=> (= |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1| inline$$Roles_can_hold_balance_$def$0$$t5@1) (=> (and (= $abort_flag@19 $abort_flag@13) (= $abort_code@23 $abort_code@17)) (and (=> (= (ControlFlow 0 314557) 314483) inline$$Roles_can_hold_balance_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 314557) 314403) inline$$Roles_can_hold_balance_$def$0$anon24_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 314555) 314557)) inline$$Roles_can_hold_balance_$def$0$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 314565) 314557) inline$$Roles_can_hold_balance_$def$0$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2) (= inline$$Roles_can_hold_balance_$def$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 314547) 314565) inline$$Roles_can_hold_balance_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 314547) 314555) inline$$Roles_can_hold_balance_$def$0$anon22_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon23_Else_correct  (=> (and (and (not $abort_flag@18) (= |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1| inline$$Roles_has_child_VASP_role_$def$0$$ret0@2)) (and (= $abort_flag@19 $abort_flag@18) (= $abort_code@23 $abort_code@22))) (and (=> (= (ControlFlow 0 313151) 314483) inline$$Roles_can_hold_balance_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 313151) 314403) inline$$Roles_can_hold_balance_$def$0$anon24_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon6_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$1$$ret0@2) (= $abort_flag@18 $abort_flag@17)) (and (=> (= (ControlFlow 0 313105) 314505) inline$$Roles_can_hold_balance_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 313105) 313151) inline$$Roles_can_hold_balance_$def$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 313103) 313105)) inline$$Roles_has_child_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 313113) 313105) inline$$Roles_has_child_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@17) (and (=> (= (ControlFlow 0 313097) 313113) inline$$Roles_has_child_VASP_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 313097) 313103) inline$$Roles_has_child_VASP_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon8_Then_correct  (=> (and (and $abort_flag@17 (= inline$$Roles_has_child_VASP_role_$def$0$$ret0@1 $Error)) (and (= inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 inline$$Roles_has_child_VASP_role_$def$0$$ret0@1) (= $abort_flag@18 true))) (and (=> (= (ControlFlow 0 313121) 314505) inline$$Roles_can_hold_balance_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 313121) 313151) inline$$Roles_can_hold_balance_$def$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$1$$ret0@1 $Error) (= $abort_flag@17 true)) (and (= $abort_code@22 $abort_code@21) (= inline$$Roles_has_role_$def$1$$ret0@2 inline$$Roles_has_role_$def$1$$ret0@1))) (and (=> (= (ControlFlow 0 313029) 313121) inline$$Roles_has_child_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 313029) 313097) inline$$Roles_has_child_VASP_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon7_correct  (=> (and (= $abort_code@21 $abort_code@18) (= (ControlFlow 0 313049) 313029)) inline$$Roles_has_role_$def$1$Abort_correct)))
(let ((inline$$Roles_has_role_$def$1$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 313047) 313049)) inline$$Roles_has_role_$def$1$anon7_correct)))
(let ((inline$$Roles_has_role_$def$1$anon24_Then_correct  (=> (= (ControlFlow 0 313057) 313049) inline$$Roles_has_role_$def$1$anon7_correct)))
(let ((inline$$Roles_has_role_$def$1$anon23_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 313041) 313057) inline$$Roles_has_role_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 313041) 313047) inline$$Roles_has_role_$def$1$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon13_correct  (=> (and (= $abort_code@21 $abort_code@19) (= (ControlFlow 0 313023) 313029)) inline$$Roles_has_role_$def$1$Abort_correct)))
(let ((inline$$Roles_has_role_$def$1$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 313021) 313023)) inline$$Roles_has_role_$def$1$anon13_correct)))
(let ((inline$$Roles_has_role_$def$1$anon27_Then_correct  (=> (= (ControlFlow 0 313037) 313023) inline$$Roles_has_role_$def$1$anon13_correct)))
(let ((inline$$Roles_has_role_$def$1$anon26_Then_correct  (=> $abort_flag@15 (and (=> (= (ControlFlow 0 313015) 313037) inline$$Roles_has_role_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 313015) 313021) inline$$Roles_has_role_$def$1$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon20_correct  (=> (= $abort_flag@17 $abort_flag@16) (=> (and (= $abort_code@22 $abort_code@20) (= inline$$Roles_has_role_$def$1$$ret0@2 |inline$$Roles_has_role_$def$1$tmp#$3@2|)) (and (=> (= (ControlFlow 0 312736) 313121) inline$$Roles_has_child_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 312736) 313097) inline$$Roles_has_child_VASP_role_$def$0$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$1$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 312734) 312736)) inline$$Roles_has_role_$def$1$anon20_correct)))
(let ((inline$$Roles_has_role_$def$1$anon30_Then_correct  (=> (= (ControlFlow 0 312744) 312736) inline$$Roles_has_role_$def$1$anon20_correct)))
(let ((inline$$Roles_has_role_$def$1$anon16_correct  (=> (= $abort_code@20 $abort_code@19) (=> (and (= |inline$$Roles_has_role_$def$1$tmp#$3@2| |inline$$Roles_has_role_$def$1$tmp#$3@1|) (= $abort_flag@16 $abort_flag@15)) (and (=> (= (ControlFlow 0 313003) 312744) inline$$Roles_has_role_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 313003) 312734) inline$$Roles_has_role_$def$1$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$1$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 313001) 313003)) inline$$Roles_has_role_$def$1$anon16_correct)))
(let ((inline$$Roles_has_role_$def$1$anon28_Then_correct  (=> (= (ControlFlow 0 313011) 313003) inline$$Roles_has_role_$def$1$anon16_correct)))
(let ((inline$$Roles_has_role_$def$1$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$1$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$1$dst@1 inline$$Roles_has_child_VASP_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 312995) 313011) inline$$Roles_has_role_$def$1$anon28_Then_correct) (=> (= (ControlFlow 0 312995) 313001) inline$$Roles_has_role_$def$1$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$1$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 312979) 312995)) inline$$Roles_has_role_$def$1$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$1$anon26_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 312985) 312979)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$GetGlobal$1$anon3_Then$1_correct  (=> (= $abort_flag@15 true) (=> (and (= $abort_code@19 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 312925) 313015) inline$$Roles_has_role_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 312925) 312985) inline$$Roles_has_role_$def$1$anon26_Else_correct))))))
(let ((inline$$GetGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$1$a@1)) (= (ControlFlow 0 312923) 312925)) inline$$GetGlobal$1$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$1$a@1) (=> (and (and (= inline$$GetGlobal$1$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@18))) (= $abort_flag@15 $abort_flag@14)) (and (= $abort_code@19 $abort_code@18) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 312871) 313015) inline$$Roles_has_role_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 312871) 312985) inline$$Roles_has_role_$def$1$anon26_Else_correct))))))
(let ((inline$$GetGlobal$1$anon0_correct  (=> (= inline$$GetGlobal$1$a@1 (|a#$Address| call3formal@$ret0@0@@18)) (and (=> (= (ControlFlow 0 312853) 312923) inline$$GetGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 312853) 312871) inline$$GetGlobal$1$anon3_Else_correct)))))
(let ((inline$$GetGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 312847) (- 0 353228)) true) (=> (= (ControlFlow 0 312847) 312853) inline$$GetGlobal$1$anon0_correct))))
(let ((inline$$Roles_has_role_$def$1$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$1$$t6@1) (= (ControlFlow 0 312931) 312847)) inline$$GetGlobal$1$Entry_correct)))
(let ((inline$$Roles_has_role_$def$1$anon18_correct  (=> (= $abort_code@20 $abort_code@18) (=> (and (= |inline$$Roles_has_role_$def$1$tmp#$3@2| inline$$Roles_has_role_$def$1$$t9@1) (= $abort_flag@16 $abort_flag@14)) (and (=> (= (ControlFlow 0 312724) 312744) inline$$Roles_has_role_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 312724) 312734) inline$$Roles_has_role_$def$1$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$1$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 312722) 312724)) inline$$Roles_has_role_$def$1$anon18_correct)))
(let ((inline$$Roles_has_role_$def$1$anon29_Then_correct  (=> (= (ControlFlow 0 312752) 312724) inline$$Roles_has_role_$def$1$anon18_correct)))
(let ((inline$$Roles_has_role_$def$1$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$1$$t6@1)) (= inline$$Roles_has_role_$def$1$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 312714) 312752) inline$$Roles_has_role_$def$1$anon29_Then_correct) (=> (= (ControlFlow 0 312714) 312722) inline$$Roles_has_role_$def$1$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon23_Else_correct  (=> (and (not $abort_flag@14) (= inline$$Roles_has_role_$def$1$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@18))))) (and (=> (= (ControlFlow 0 312670) 312931) inline$$Roles_has_role_$def$1$anon25_Then_correct) (=> (= (ControlFlow 0 312670) 312714) inline$$Roles_has_role_$def$1$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@14) (=> $abort_flag@14 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 addr)))) ((_ is $Address) call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 312656) 313041) inline$$Roles_has_role_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 312656) 312670) inline$$Roles_has_role_$def$1$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 312586) 312656)) inline$$Roles_has_role_$def$1$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$1$anon22_Then_correct  (=> (= (ControlFlow 0 313065) 312656) inline$$Roles_has_role_$def$1$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$1$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 312578) 313065) inline$$Roles_has_role_$def$1$anon22_Then_correct) (=> (= (ControlFlow 0 312578) 312586) inline$$Roles_has_role_$def$1$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon21_Then_correct  (and (=> (= (ControlFlow 0 313073) 313065) inline$$Roles_has_role_$def$1$anon22_Then_correct) (=> (= (ControlFlow 0 313073) 312586) inline$$Roles_has_role_$def$1$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$1$anon0_correct  (=> (not $abort_flag@13) (and (=> (= (ControlFlow 0 312572) 313073) inline$$Roles_has_role_$def$1$anon21_Then_correct) (=> (= (ControlFlow 0 312572) 312578) inline$$Roles_has_role_$def$1$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$1$anon0_correct  (=> ((_ is $Address) addr) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_child_VASP_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 313079) 312572)) inline$$Roles_has_role_$def$1$anon0_correct))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$0$$t2@1 ($Integer 6)) (= (ControlFlow 0 313087) 313079)) inline$$Roles_has_role$1$anon0_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 312099) 313087)) inline$$Roles_has_child_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 313129) 313087) inline$$Roles_has_child_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon0_correct  (=> (not $abort_flag@13) (and (=> (= (ControlFlow 0 312093) 313129) inline$$Roles_has_child_VASP_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 312093) 312099) inline$$Roles_has_child_VASP_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role$0$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 313135) 312093)) inline$$Roles_has_child_VASP_role_$def$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2)) (= (ControlFlow 0 313143) 313135)) inline$$Roles_has_child_VASP_role$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon20_Else_correct  (=> (not $abort_flag@13) (and (=> (= (ControlFlow 0 311893) 314547) inline$$Roles_can_hold_balance_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 311893) 313143) inline$$Roles_can_hold_balance_$def$0$anon21_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon6_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$0$$ret0@2) (= $abort_flag@13 $abort_flag@12)) (and (=> (= (ControlFlow 0 311847) 314569) inline$$Roles_can_hold_balance_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 311847) 311893) inline$$Roles_can_hold_balance_$def$0$anon20_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 311845) 311847)) inline$$Roles_has_parent_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 311855) 311847) inline$$Roles_has_parent_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 311839) 311855) inline$$Roles_has_parent_VASP_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 311839) 311845) inline$$Roles_has_parent_VASP_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon8_Then_correct  (=> (and (and $abort_flag@12 (= inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1 $Error)) (and (= inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1) (= $abort_flag@13 true))) (and (=> (= (ControlFlow 0 311863) 314569) inline$$Roles_can_hold_balance_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 311863) 311893) inline$$Roles_can_hold_balance_$def$0$anon20_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$0$$ret0@1 $Error) (= $abort_flag@12 true)) (and (= $abort_code@17 $abort_code@16) (= inline$$Roles_has_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 311771) 311863) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 311771) 311839) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon7_correct  (=> (and (= $abort_code@16 $abort_code@13) (= (ControlFlow 0 311791) 311771)) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 311789) 311791)) inline$$Roles_has_role_$def$0$anon7_correct)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 311799) 311791) inline$$Roles_has_role_$def$0$anon7_correct)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 311783) 311799) inline$$Roles_has_role_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 311783) 311789) inline$$Roles_has_role_$def$0$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon13_correct  (=> (and (= $abort_code@16 $abort_code@14) (= (ControlFlow 0 311765) 311771)) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 311763) 311765)) inline$$Roles_has_role_$def$0$anon13_correct)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 311779) 311765) inline$$Roles_has_role_$def$0$anon13_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 311757) 311779) inline$$Roles_has_role_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 311757) 311763) inline$$Roles_has_role_$def$0$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct  (=> (= $abort_flag@12 $abort_flag@11) (=> (and (= $abort_code@17 $abort_code@15) (= inline$$Roles_has_role_$def$0$$ret0@2 |inline$$Roles_has_role_$def$0$tmp#$3@2|)) (and (=> (= (ControlFlow 0 311478) 311863) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 311478) 311839) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 311476) 311478)) inline$$Roles_has_role_$def$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 311486) 311478) inline$$Roles_has_role_$def$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct  (=> (= $abort_flag@11 $abort_flag@10) (=> (and (= |inline$$Roles_has_role_$def$0$tmp#$3@2| |inline$$Roles_has_role_$def$0$tmp#$3@1|) (= $abort_code@15 $abort_code@14)) (and (=> (= (ControlFlow 0 311745) 311486) inline$$Roles_has_role_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 311745) 311476) inline$$Roles_has_role_$def$0$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 311743) 311745)) inline$$Roles_has_role_$def$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 311753) 311745) inline$$Roles_has_role_$def$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1 inline$$Roles_has_parent_VASP_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 311737) 311753) inline$$Roles_has_role_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 311737) 311743) inline$$Roles_has_role_$def$0$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 311721) 311737)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct  (=> (and (not $abort_flag@10) (= (ControlFlow 0 311727) 311721)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_code@14 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@10 true) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 311667) 311757) inline$$Roles_has_role_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 311667) 311727) inline$$Roles_has_role_$def$0$anon26_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 311665) 311667)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@19))) (= $abort_code@14 $abort_code@13)) (and (= $abort_flag@10 $abort_flag@9) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 311613) 311757) inline$$Roles_has_role_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 311613) 311727) inline$$Roles_has_role_$def$0$anon26_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@19)) (and (=> (= (ControlFlow 0 311595) 311665) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 311595) 311613) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 311589) (- 0 352632)) true) (=> (= (ControlFlow 0 311589) 311595) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1) (= (ControlFlow 0 311673) 311589)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct  (=> (= $abort_flag@11 $abort_flag@9) (=> (and (= |inline$$Roles_has_role_$def$0$tmp#$3@2| inline$$Roles_has_role_$def$0$$t9@1) (= $abort_code@15 $abort_code@13)) (and (=> (= (ControlFlow 0 311466) 311486) inline$$Roles_has_role_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 311466) 311476) inline$$Roles_has_role_$def$0$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 311464) 311466)) inline$$Roles_has_role_$def$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 311494) 311466) inline$$Roles_has_role_$def$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1)) (= inline$$Roles_has_role_$def$0$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 311456) 311494) inline$$Roles_has_role_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 311456) 311464) inline$$Roles_has_role_$def$0$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct  (=> (and (not $abort_flag@9) (= inline$$Roles_has_role_$def$0$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@19))))) (and (=> (= (ControlFlow 0 311412) 311673) inline$$Roles_has_role_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 311412) 311456) inline$$Roles_has_role_$def$0$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9) (=> $abort_flag@9 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 addr)))) ((_ is $Address) call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 311398) 311783) inline$$Roles_has_role_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 311398) 311412) inline$$Roles_has_role_$def$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 311328) 311398)) inline$$Roles_has_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 311807) 311398) inline$$Roles_has_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 311320) 311807) inline$$Roles_has_role_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 311320) 311328) inline$$Roles_has_role_$def$0$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 311815) 311807) inline$$Roles_has_role_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 311815) 311328) inline$$Roles_has_role_$def$0$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct  (=> (not $abort_flag@8) (and (=> (= (ControlFlow 0 311314) 311815) inline$$Roles_has_role_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 311314) 311320) inline$$Roles_has_role_$def$0$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$0$anon0_correct  (=> ((_ is $Address) addr) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_parent_VASP_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 311821) 311314)) inline$$Roles_has_role_$def$0$anon0_correct))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$0$$t2@1 ($Integer 5)) (= (ControlFlow 0 311829) 311821)) inline$$Roles_has_role$0$anon0_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 310841) 311829)) inline$$Roles_has_parent_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 311871) 311829) inline$$Roles_has_parent_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon0_correct  (=> (not $abort_flag@8) (and (=> (= (ControlFlow 0 310835) 311871) inline$$Roles_has_parent_VASP_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 310835) 310841) inline$$Roles_has_parent_VASP_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role$0$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 311877) 310835)) inline$$Roles_has_parent_VASP_role_$def$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 310607) 311877)) inline$$Roles_has_parent_VASP_role$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 314577) 311877) inline$$Roles_has_parent_VASP_role$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon0_correct  (=> (not $abort_flag@8) (and (=> (= (ControlFlow 0 310601) 314577) inline$$Roles_can_hold_balance_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 310601) 310607) inline$$Roles_can_hold_balance_$def$0$anon19_Else_correct)))))
(let ((inline$$Roles_can_hold_balance$0$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 314583) 310601)) inline$$Roles_can_hold_balance_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon36_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 314591) 314583)) inline$$Roles_can_hold_balance$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@8) (=> (and (=> $abort_flag@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@12 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 310255) 315798) inline$$DiemAccount_add_currency_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 310255) 314591) inline$$DiemAccount_add_currency_$def$0$anon36_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 310219) 310255)) inline$$DiemAccount_add_currency_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon35_Then_correct  (=> (= (ControlFlow 0 315822) 310255) inline$$DiemAccount_add_currency_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon0_correct  (=> (not $abort_flag@7) (and (=> (= (ControlFlow 0 310213) 315822) inline$$DiemAccount_add_currency_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 310213) 310219) inline$$DiemAccount_add_currency_$def$0$anon35_Else_correct)))))
(let ((inline$$DiemAccount_add_currency$0$anon0_correct  (=> (and ((_ is $Address) addr) (= (ControlFlow 0 315826) 310213)) inline$$DiemAccount_add_currency_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon23_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 315832) 315826)) inline$$DiemAccount_add_currency$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7) (=> $abort_flag@7 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 addr)))) ((_ is $Address) call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 309603) 328510) inline$$DiemAccount_add_currencies_for_account_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 309603) 315832) inline$$DiemAccount_add_currencies_for_account_$def$0$anon23_Else_correct)))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 309533) 309603)) inline$$DiemAccount_add_currencies_for_account_$def$0$anon4$2_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 328534) 309603) inline$$DiemAccount_add_currencies_for_account_$def$0$anon4$2_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 309525) 328534) inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 309525) 309533) inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Else_correct)))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 328542) 328534) inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 328542) 309533) inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Else_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon0_correct  (=> (not $abort_flag@6) (and (=> (= (ControlFlow 0 309519) 328542) inline$$DiemAccount_add_currencies_for_account_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 309519) 309525) inline$$DiemAccount_add_currencies_for_account_$def$0$anon21_Else_correct)))))
(let ((inline$$DiemAccount_add_currencies_for_account$0$anon0_correct  (=> ((_ is $Address) addr) (=> (and ((_ is $Boolean) add_all_currencies) (= (ControlFlow 0 328546) 309519)) inline$$DiemAccount_add_currencies_for_account_$def$0$anon0_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon43_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 328552) 328546)) inline$$DiemAccount_add_currencies_for_account$0$anon0_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon42_Else_correct  (=> (not $abort_flag@5) (=> (and (= call4formal@$DesignatedDealer_Dealer_$CallerDomain@0 ($ConstMemoryDomain true)) (= call5formal@$DesignatedDealer_TierInfo_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 309083) (- 0 350116)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DesignatedDealer_Dealer_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| addr))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DesignatedDealer_Dealer_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| addr)) (and (=> (= (ControlFlow 0 309083) (- 0 350127)) (|Select_[$TypeValueArray,$int]$bool| call5formal@$DesignatedDealer_TierInfo_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))) (=> (|Select_[$TypeValueArray,$int]$bool| call5formal@$DesignatedDealer_TierInfo_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)) (and (=> (= (ControlFlow 0 309083) (- 0 350149)) (|Select_[$TypeValueArray,$int]$bool| call5formal@$DesignatedDealer_TierInfo_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))) (=> (|Select_[$TypeValueArray,$int]$bool| call5formal@$DesignatedDealer_TierInfo_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@6)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr))))))) $abort_flag@6))) (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $abort_flag@6)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@6 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@6)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@6)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@6)))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) $abort_flag@6))) (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@7 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@7)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@7)))) $Diem_CurrencyInfo_is_synthetic))))))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) $abort_flag@6)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6)))) (and (and (and (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@8 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@8)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@8)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@9 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@9)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@9)))) $Diem_CurrencyInfo_is_synthetic)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@10 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@10 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@10 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr))))))) (= $abort_code@10 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@10 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (= $abort_code@10 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) (= $abort_code@10 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| (let ((addr@@10 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@10)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@10)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@10 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))))))) (= $abort_code@10 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@10 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@10 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) (= $abort_code@10 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| (let ((addr@@11 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@11)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@11)))) $Diem_CurrencyInfo_is_synthetic))))))))) (= $abort_code@10 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))))))) (= $abort_code@10 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@10 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| add_all_currencies)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@10 (|i#$Integer| ($Integer 1))))))) (and (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory@0) $EmptyTypeValueArray (|a#$Address| addr))))) (=> (not $abort_flag@6) (|b#$Boolean| (ite (|b#$Boolean| add_all_currencies) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr)))))))) (and (and (= (|contents#$Memory| $DesignatedDealer_Dealer_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) (= (|domain#$Memory| $DesignatedDealer_Dealer_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory@0) $EmptyTypeValueArray (|a#$Address| addr))))) (and (= (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))) (= (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr))) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_TierInfo_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr)))))))) (and (=> (= (ControlFlow 0 309083) 330931) inline$$DiemAccount_create_designated_dealer_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 309083) 328552) inline$$DiemAccount_create_designated_dealer_$def$0$anon43_Else_correct))))))))))))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$Abort_correct  (=> (= $abort_flag@5 true) (=> (and (= $abort_code@9 $abort_code@8) (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory@1)) (and (=> (= (ControlFlow 0 309021) 330951) inline$$DiemAccount_create_designated_dealer_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 309021) 309083) inline$$DiemAccount_create_designated_dealer_$def$0$anon42_Else_correct))))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon7_correct  (=> (= $Roles_RoleId_$memory@1 $Roles_RoleId_$memory) (=> (and (= $abort_code@8 $abort_code@6) (= (ControlFlow 0 309041) 309021)) inline$$Roles_new_designated_dealer_role_$def$0$Abort_correct))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 309039) 309041)) inline$$Roles_new_designated_dealer_role_$def$0$anon7_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon16_Then_correct  (=> (= (ControlFlow 0 309049) 309041) inline$$Roles_new_designated_dealer_role_$def$0$anon7_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon15_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 309033) 309049) inline$$Roles_new_designated_dealer_role_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 309033) 309039) inline$$Roles_new_designated_dealer_role_$def$0$anon16_Else_correct)))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon11_correct  (=> (= $Roles_RoleId_$memory@1 $Roles_RoleId_$memory@0) (=> (and (= $abort_code@8 $abort_code@7) (= (ControlFlow 0 309017) 309021)) inline$$Roles_new_designated_dealer_role_$def$0$Abort_correct))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 309015) 309017)) inline$$Roles_new_designated_dealer_role_$def$0$anon11_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 309029) 309017) inline$$Roles_new_designated_dealer_role_$def$0$anon11_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon17_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 309009) 309029) inline$$Roles_new_designated_dealer_role_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 309009) 309015) inline$$Roles_new_designated_dealer_role_$def$0$anon18_Else_correct)))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon17_Else_correct  (=> (and (and (not $abort_flag@4) (= $abort_flag@5 $abort_flag@4)) (and (= $abort_code@9 $abort_code@7) (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory@0))) (and (=> (= (ControlFlow 0 309005) 330951) inline$$DiemAccount_create_designated_dealer_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 309005) 309083) inline$$DiemAccount_create_designated_dealer_$def$0$anon42_Else_correct)))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon15_Else_correct  (=> (and (not $abort_flag@3) (= inline$$Roles_new_designated_dealer_role_$def$0$$t4@1 ($Integer 2))) (and (=> (= (ControlFlow 0 308999) (- 0 349836)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_designated_dealer_role_$def$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_designated_dealer_role_$def$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| addr)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $abort_flag@4) (=> (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr))))) (=> $abort_flag@4 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (= $abort_code@7 (|i#$Integer| ($Integer 6)))))) (=> (and (and (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| addr))))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) inline$$Roles_new_designated_dealer_role_$def$0$$t4@1))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))) (= (|domain#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| addr)))))) (and (=> (= (ControlFlow 0 308999) 309009) inline$$Roles_new_designated_dealer_role_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 308999) 309005) inline$$Roles_new_designated_dealer_role_$def$0$anon17_Else_correct))))))))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@3) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@3)) (and (=> $abort_flag@3 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@3 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@6 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@6 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 308989) 309033) inline$$Roles_new_designated_dealer_role_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 308989) 308999) inline$$Roles_new_designated_dealer_role_$def$0$anon15_Else_correct))))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon4_correct  (=> (and (= inline$$Roles_new_designated_dealer_role_$def$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| addr) true)) (= (ControlFlow 0 308953) 308989)) inline$$Roles_new_designated_dealer_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 308903) 308953)) inline$$Roles_new_designated_dealer_role_$def$0$anon4_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon14_Then_correct  (=> (= (ControlFlow 0 309057) 308953) inline$$Roles_new_designated_dealer_role_$def$0$anon4_correct)))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308895) 309057) inline$$Roles_new_designated_dealer_role_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 308895) 308903) inline$$Roles_new_designated_dealer_role_$def$0$anon14_Else_correct)))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 309065) 309057) inline$$Roles_new_designated_dealer_role_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 309065) 308903) inline$$Roles_new_designated_dealer_role_$def$0$anon14_Else_correct))))
(let ((inline$$Roles_new_designated_dealer_role_$def$0$anon0_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 308889) 309065) inline$$Roles_new_designated_dealer_role_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 308889) 308895) inline$$Roles_new_designated_dealer_role_$def$0$anon13_Else_correct)))))
(let ((inline$$Roles_new_designated_dealer_role$0$anon0_correct  (=> ((_ is $Address) tc_account) (=> (and ((_ is $Address) addr) (= (ControlFlow 0 309069) 308889)) inline$$Roles_new_designated_dealer_role_$def$0$anon0_correct))))
(let ((inline$$Roles_new_designated_dealer_role$0$Entry_correct  (=> (= inline$$Roles_new_designated_dealer_role$0$$Roles_RoleId_$CallerDomain@0 ($ConstMemoryDomain true)) (and (=> (= (ControlFlow 0 308623) (- 0 349465)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_designated_dealer_role$0$$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| addr))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_designated_dealer_role$0$$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| addr)) (=> (= (ControlFlow 0 308623) 309069) inline$$Roles_new_designated_dealer_role$0$anon0_correct))))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 309075) 308623)) inline$$Roles_new_designated_dealer_role$0$Entry_correct)))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon38_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 308530) 330955) inline$$DiemAccount_create_designated_dealer_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 308530) 309075) inline$$DiemAccount_create_designated_dealer_$def$0$anon40_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon37_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308299) 330975) inline$$DiemAccount_create_designated_dealer_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 308299) 308530) inline$$DiemAccount_create_designated_dealer_$def$0$anon38_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon37_Then_correct  (and (=> (= (ControlFlow 0 330999) 330975) inline$$DiemAccount_create_designated_dealer_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 330999) 308530) inline$$DiemAccount_create_designated_dealer_$def$0$anon38_Else_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon36_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308291) 330999) inline$$DiemAccount_create_designated_dealer_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 308291) 308299) inline$$DiemAccount_create_designated_dealer_$def$0$anon37_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon36_Then_correct  (and (=> (= (ControlFlow 0 331007) 330999) inline$$DiemAccount_create_designated_dealer_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 331007) 308299) inline$$DiemAccount_create_designated_dealer_$def$0$anon37_Else_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon35_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308283) 331007) inline$$DiemAccount_create_designated_dealer_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 308283) 308291) inline$$DiemAccount_create_designated_dealer_$def$0$anon36_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon35_Then_correct  (and (=> (= (ControlFlow 0 331015) 331007) inline$$DiemAccount_create_designated_dealer_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 331015) 308291) inline$$DiemAccount_create_designated_dealer_$def$0$anon36_Else_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon34_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308275) 331015) inline$$DiemAccount_create_designated_dealer_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 308275) 308283) inline$$DiemAccount_create_designated_dealer_$def$0$anon35_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon34_Then_correct  (and (=> (= (ControlFlow 0 331023) 331015) inline$$DiemAccount_create_designated_dealer_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 331023) 308283) inline$$DiemAccount_create_designated_dealer_$def$0$anon35_Else_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308267) 331023) inline$$DiemAccount_create_designated_dealer_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 308267) 308275) inline$$DiemAccount_create_designated_dealer_$def$0$anon34_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 331031) 331023) inline$$DiemAccount_create_designated_dealer_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 331031) 308275) inline$$DiemAccount_create_designated_dealer_$def$0$anon34_Else_correct))))
(let ((inline$$DiemAccount_create_designated_dealer_$def$0$anon0_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 308261) 331031) inline$$DiemAccount_create_designated_dealer_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 308261) 308267) inline$$DiemAccount_create_designated_dealer_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_create_designated_dealer_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) tc_account) ((_ is $Address) addr)) (=> (and (and ((_ is $Vector) auth_key_prefix@@0) (let ((va@@21 (|v#$Vector| auth_key_prefix@@0)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (forall ((inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0 0) (< inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0))
))) (=> (and (and (and ((_ is $Vector) human_name) (let ((va@@22 (|v#$Vector| human_name)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (forall ((inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0@@0 0) (< inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DiemAccount_create_designated_dealer_$direct_inter$0$$$0@@0))
))) (and ((_ is $Boolean) add_all_currencies) (= (ControlFlow 0 331035) 308261))) inline$$DiemAccount_create_designated_dealer_$def$0$anon0_correct)))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 331041) 331035)) inline$$DiemAccount_create_designated_dealer_$direct_inter$0$anon0_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct  (=> (and (= $abort_flag@2 true) (= $abort_code@5 $abort_code@4)) (and (=> (= (ControlFlow 0 307280) 331061) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 307280) 331041) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon7_correct  (=> (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 307326) 307280)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 307324) 307326)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon7_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 307334) 307326) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon7_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 307318) 307334) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 307318) 307324) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon11_correct  (=> (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 307306) 307280)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 307304) 307306)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon11_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 307314) 307306) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon11_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 307298) 307314) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 307298) 307304) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon16_correct  (=> (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 307276) 307280)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 307274) 307276)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon16_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 307288) 307276) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon16_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1)) (= $abort_code@3 (|i#$Integer| call3formal@$ret0@0@@20))) (and (=> (= (ControlFlow 0 307268) 307288) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 307268) 307274) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Then_correct  (=> (|b#$Boolean| inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1) (=> (and (= $abort_flag@2 $abort_flag@1) (= $abort_code@5 $abort_code@2)) (and (=> (= (ControlFlow 0 307294) 331061) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 307294) 331041) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 307256) 307294) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 307256) 307268) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Else_correct  (=> (and (not $abort_flag@0) (= inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t7@1 ($Integer 0))) (=> (and (and (and (= inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1 ($Boolean ($IsEqual_stratified call5formal@$ret0@0 inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t7@1))) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@20 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@20) (>= (|i#$Integer| call3formal@$ret0@0@@20) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@20) $MAX_U64))) (and (=> (= (ControlFlow 0 307250) 307298) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 307250) 307256) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Else_correct))))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon4$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))))) (and (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@1 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call5formal@$ret0@0 ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce))))))) (and (and ((_ is $Integer) call5formal@$ret0@0) (>= (|i#$Integer| call5formal@$ret0@0) 0)) (<= (|i#$Integer| call5formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 307232) 307318) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 307232) 307250) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 307162) 307232)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon4$2_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 307342) 307232) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon4$2_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 307154) 307342) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 307154) 307162) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 307350) 307342) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 307350) 307162) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Else_correct))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 307148) 307350) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 307148) 307154) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$direct_inter$0$anon0_correct  (=> ((_ is $Address) tc_account) (=> (and (and (and ((_ is $Integer) sliding_nonce) (>= (|i#$Integer| sliding_nonce) 0)) (<= (|i#$Integer| sliding_nonce) $MAX_U64)) (= (ControlFlow 0 307354) 307148)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon0_correct))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 306584) 307354)) inline$$SlidingNonce_record_nonce_or_abort_$direct_inter$0$anon0_correct)))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 331069) 307354) inline$$SlidingNonce_record_nonce_or_abort_$direct_inter$0$anon0_correct)))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306576) 331069) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 306576) 306584) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 331077) 331069) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 331077) 306584) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon22_Else_correct))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306568) 331077) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 306568) 306576) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon20_Then_correct  (and (=> (= (ControlFlow 0 331085) 331077) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 331085) 306576) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon21_Else_correct))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306560) 331085) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 306560) 306568) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 331093) 331085) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 331093) 306568) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon20_Else_correct))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon18_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306552) 331093) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 306552) 306560) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon18_Then_correct  (and (=> (= (ControlFlow 0 331101) 331093) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 331101) 306560) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon19_Else_correct))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306544) 331101) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 306544) 306552) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 331109) 331101) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 331109) 306552) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon18_Else_correct))))
(let ((inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 306538) 331109) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 306538) 306544) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (and (and (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))
))) (and (forall (($inv_addr@@2 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))) $$0@@3))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@5))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@6))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@7))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@38 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@8))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3)) (let ((va@@39 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_Preburn_to_burn)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_Preburn_to_burn))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@3))
)))) (and (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@41 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DesignatedDealer_Dealer_mint_event_handle))) $Event_EventHandle_guid))) $$0@@9))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (forall (($inv_addr@@5 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5)) (let ((va@@44 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_window_inflow)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers))) $$0@@10)) $MAX_U64))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers))) $$0@@10))
))) (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers))))) (|i#$Integer| ($Integer 4))))) (|b#$Boolean| ($Boolean (let (($range_1 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_0 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1)) $i_0) (< $i_0 (|i#$Integer| (|ub#$Range| $range_1)))) (let ((i@@10 ($Integer $i_0)))
(|b#$Boolean| ($Boolean (let (($range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers)))))))
(forall (($i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3)) $i_2) (< $i_2 (|i#$Integer| (|ub#$Range| $range_3)))) (let ((j@@1 ($Integer $i_2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| i@@10) (|i#$Integer| j@@1)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| i@@10))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))) $DesignatedDealer_TierInfo_tiers))) (|i#$Integer| j@@1))))))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DesignatedDealer_TierInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@5))
))) (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@46 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_min_nonce)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_min_nonce)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_min_nonce)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_nonce_mask)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_nonce_mask)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))) $SlidingNonce_SlidingNonce_nonce_mask)) $MAX_U128))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@47 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_human_name)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_human_name))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_human_name))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_human_name))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_human_name))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_human_name))) $$0@@11))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url)) (let ((va@@49 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url))) $$0@@12))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@50 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_public_key))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_public_key))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_public_key))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_public_key))) $$0@@13))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@14))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@53 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@54 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@15))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@7))
))))) (and (and (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@55 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@56 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_authentication_key))) $$0@@16))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@57 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@60 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events)) (let ((va@@61 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@62 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
))))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@17))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@63 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@64 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
))))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@18))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (forall (($inv_addr@@9 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9)) (let ((va@@65 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_limits_cap)) (let ((va@@66 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_limits_cap))))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_limits_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_limits_cap))) $AccountLimits_AccountLimitMutationCapability_dummy_field)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events)) (let ((va@@67 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid)) (let ((va@@68 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
))))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@19))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@9))
))) (and (forall (($inv_addr@@10 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10)) (let ((va@@69 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) $DiemAccount_Balance_coin)) (let ((va@@70 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) $DiemAccount_Balance_coin))))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) $DiemAccount_Balance_coin))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@10))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> (and (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@12 T@$Value) )  (=> ((_ is $Address) addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@13 T@$Value) )  (=> ((_ is $Address) addr@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@14 T@$Value) )  (=> ((_ is $Address) addr@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@14)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@15 T@$Value) )  (=> ((_ is $Address) addr@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@15)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))))))) (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@16 T@$Value) )  (=> ((_ is $Address) addr@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@17 T@$Value) )  (=> ((_ is $Address) addr@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@18 T@$Value) )  (=> ((_ is $Address) addr@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))))))))))) (and (|b#$Boolean| ($Boolean (forall ((token T@$Value) )  (=> ((_ is $Type) token) (|b#$Boolean| ($Boolean (forall ((addr@@19 T@$Value) )  (=> ((_ is $Address) addr@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| token)) 1) (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@20 T@$Value) )  (=> ((_ is $Address) addr@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@21 T@$Value) )  (=> ((_ is $Address) addr@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@22 T@$Value) )  (=> ((_ is $Address) addr@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))))))))))) (and (|b#$Boolean| (let ((addr@@23 tc_account))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (= (ControlFlow 0 331113) 306538)))))) inline$$create_designated_dealer_create_designated_dealer_$def_verify$0$anon0_correct)))))
(let ((anon0_correct  (=> ((_ is $Address) tc_account) (=> (and (and (and (and (and ((_ is $Integer) sliding_nonce) (>= (|i#$Integer| sliding_nonce) 0)) (<= (|i#$Integer| sliding_nonce) $MAX_U64)) ((_ is $Address) addr)) (and (and ((_ is $Vector) auth_key_prefix@@0) (let ((va@@71 (|v#$Vector| auth_key_prefix@@0)))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
)))))) (forall (($$0@@20 Int) ) (!  (=> (and (>= $$0@@20 0) (< $$0@@20 (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) $$0@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) $$0@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) $$0@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) $$0@@20))
)))) (and (and (and ((_ is $Vector) human_name) (let ((va@@72 (|v#$Vector| human_name)))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
)))))) (forall (($$0@@21 Int) ) (!  (=> (and (>= $$0@@21 0) (< $$0@@21 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@21)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@21)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@21)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@21))
))) (and ((_ is $Boolean) add_all_currencies) (= (ControlFlow 0 304554) 331113)))) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 335333) 304554) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
