(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $AccountFreezing_FreezeAccountEvent () T@$TypeName)
(declare-fun $AccountFreezing_FreezeEventsHolder () T@$TypeName)
(declare-fun $AccountFreezing_FreezingBit () T@$TypeName)
(declare-fun $AccountFreezing_UnfreezeAccountEvent () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $ChainId_ChainId () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DesignatedDealer_Dealer () T@$TypeName)
(declare-fun $DesignatedDealer_ReceivedMintEvent () T@$TypeName)
(declare-fun $DesignatedDealer_TierInfo () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $SlidingNonce_SlidingNonce () T@$TypeName)
(declare-fun $DualAttestation_BaseUrlRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_Credential () T@$TypeName)
(declare-fun $DualAttestation_Limit () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $DiemAccount_DiemAccount () T@$TypeName)
(declare-fun $DiemAccount_AccountOperationsCapability () T@$TypeName)
(declare-fun $DiemAccount_AdminTransactionEvent () T@$TypeName)
(declare-fun $DiemAccount_Balance () T@$TypeName)
(declare-fun $DiemAccount_CreateAccountEvent () T@$TypeName)
(declare-fun $DiemAccount_DiemWriteSetManager () T@$TypeName)
(declare-fun $DiemAccount_KeyRotationCapability () T@$TypeName)
(declare-fun $DiemAccount_ReceivedPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_SentPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_WithdrawCapability () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_frozen_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeEventsHolder_freeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezingBit_is_frozen () Int)
(declare-fun $AccountFreezing_FreezingBit_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_unfrozen_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ChainId_ChainId_id () Int)
(declare-fun $ChainId_ChainId_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_Dealer_mint_event_handle () Int)
(declare-fun $DesignatedDealer_Dealer_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_ReceivedMintEvent_currency_code () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_destination_address () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_amount () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_TierInfo_window_start () Int)
(declare-fun $DesignatedDealer_TierInfo_window_inflow () Int)
(declare-fun $DesignatedDealer_TierInfo_tiers () Int)
(declare-fun $DesignatedDealer_TierInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $SlidingNonce_spec_try_record_nonce (T@$Value T@$Value) T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_min_nonce () Int)
(declare-fun $SlidingNonce_SlidingNonce_nonce_mask () Int)
(declare-fun $SlidingNonce_SlidingNonce_type_value () T@$TypeValue)
(declare-fun $DualAttestation_spec_dual_attestation_message (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $DualAttestation_BaseUrlRotationEvent_new_base_url () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Credential_human_name () Int)
(declare-fun $DualAttestation_Credential_base_url () Int)
(declare-fun $DualAttestation_Credential_compliance_public_key () Int)
(declare-fun $DualAttestation_Credential_expiration_date () Int)
(declare-fun $DualAttestation_Credential_compliance_key_rotation_events () Int)
(declare-fun $DualAttestation_Credential_base_url_rotation_events () Int)
(declare-fun $DualAttestation_Credential_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Limit_micro_xdx_limit () Int)
(declare-fun $DualAttestation_Limit_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun $DiemAccount_spec_abstract_create_authentication_key (T@$Value) T@$Value)
(declare-fun $DiemAccount_DiemAccount_authentication_key () Int)
(declare-fun $DiemAccount_DiemAccount_withdraw_capability () Int)
(declare-fun $DiemAccount_DiemAccount_key_rotation_capability () Int)
(declare-fun $DiemAccount_DiemAccount_received_events () Int)
(declare-fun $DiemAccount_DiemAccount_sent_events () Int)
(declare-fun $DiemAccount_DiemAccount_sequence_number () Int)
(declare-fun $DiemAccount_DiemAccount_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AccountOperationsCapability_limits_cap () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_creation_events () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AdminTransactionEvent_committed_timestamp_secs () Int)
(declare-fun $DiemAccount_AdminTransactionEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_Balance_coin () Int)
(declare-fun $DiemAccount_Balance_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemAccount_CreateAccountEvent_created () Int)
(declare-fun $DiemAccount_CreateAccountEvent_role_id () Int)
(declare-fun $DiemAccount_CreateAccountEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_DiemWriteSetManager_upgrade_events () Int)
(declare-fun $DiemAccount_DiemWriteSetManager_type_value () T@$TypeValue)
(declare-fun $DiemAccount_KeyRotationCapability_account_address () Int)
(declare-fun $DiemAccount_KeyRotationCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_ReceivedPaymentEvent_amount () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_payer () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_SentPaymentEvent_amount () Int)
(declare-fun $DiemAccount_SentPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_SentPaymentEvent_payee () Int)
(declare-fun $DiemAccount_SentPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_SentPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_WithdrawCapability_account_address () Int)
(declare-fun $DiemAccount_WithdrawCapability_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $AccountFreezing_FreezeAccountEvent $AccountFreezing_FreezeEventsHolder $AccountFreezing_FreezingBit $AccountFreezing_UnfreezeAccountEvent $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $ChainId_ChainId $FixedPoint32_FixedPoint32 $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $DesignatedDealer_Dealer $DesignatedDealer_ReceivedMintEvent $DesignatedDealer_TierInfo $XDX_XDX $XDX_Reserve $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_Config $ValidatorConfig_ValidatorConfig $VASP_ChildVASP $VASP_ParentVASP $TransactionFee_TransactionFee $SlidingNonce_SlidingNonce $DualAttestation_BaseUrlRotationEvent $DualAttestation_ComplianceKeyRotationEvent $DualAttestation_Credential $DualAttestation_Limit $DiemTransactionPublishingOption_DiemTransactionPublishingOption $DiemAccount_DiemAccount $DiemAccount_AccountOperationsCapability $DiemAccount_AdminTransactionEvent $DiemAccount_Balance $DiemAccount_CreateAccountEvent $DiemAccount_DiemWriteSetManager $DiemAccount_KeyRotationCapability $DiemAccount_ReceivedPaymentEvent $DiemAccount_SentPaymentEvent $DiemAccount_WithdrawCapability)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_FreezeAccountEvent_frozen_address 1))
(assert (= $AccountFreezing_FreezeAccountEvent_type_value ($StructType $AccountFreezing_FreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeEventsHolder_freeze_event_handle 0))
(assert (= $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle 1))
(assert (= $AccountFreezing_FreezeEventsHolder_type_value ($StructType $AccountFreezing_FreezeEventsHolder $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezingBit_is_frozen 0))
(assert (= $AccountFreezing_FreezingBit_type_value ($StructType $AccountFreezing_FreezingBit $EmptyTypeValueArray)))
(assert (= $AccountFreezing_UnfreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_UnfreezeAccountEvent_unfrozen_address 1))
(assert (= $AccountFreezing_UnfreezeAccountEvent_type_value ($StructType $AccountFreezing_UnfreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0@@0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0@@0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@1) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@1))
)))
(assert (= $ChainId_ChainId_id 0))
(assert (= $ChainId_ChainId_type_value ($StructType $ChainId_ChainId $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_Dealer_mint_event_handle 0))
(assert (= $DesignatedDealer_Dealer_type_value ($StructType $DesignatedDealer_Dealer $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_ReceivedMintEvent_currency_code 0))
(assert (= $DesignatedDealer_ReceivedMintEvent_destination_address 1))
(assert (= $DesignatedDealer_ReceivedMintEvent_amount 2))
(assert (= $DesignatedDealer_ReceivedMintEvent_type_value ($StructType $DesignatedDealer_ReceivedMintEvent $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_TierInfo_window_start 0))
(assert (= $DesignatedDealer_TierInfo_window_inflow 1))
(assert (= $DesignatedDealer_TierInfo_tiers 2))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($DesignatedDealer_TierInfo_type_value $tv0@@9) ($StructType $DesignatedDealer_TierInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($DesignatedDealer_TierInfo_type_value $tv0@@9))
)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@10 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@10) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1))) :pattern ( ($Option_Option_type_value $tv0@@10))
)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@11 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@11) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@11))
)))
(assert (forall ((account T@$Value) (seq_nonce T@$Value) )  (and (and ((_ is $Integer) ($SlidingNonce_spec_try_record_nonce account seq_nonce)) (>= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) 0)) (<= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) $MAX_U64))))
(assert (= $SlidingNonce_SlidingNonce_min_nonce 0))
(assert (= $SlidingNonce_SlidingNonce_nonce_mask 1))
(assert (= $SlidingNonce_SlidingNonce_type_value ($StructType $SlidingNonce_SlidingNonce $EmptyTypeValueArray)))
(assert (forall ((payer T@$Value) (metadata T@$Value) (deposit_value T@$Value) )  (and (and ((_ is $Vector) ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value)) (let ((va@@8 (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0))
)))))
(assert (= $DualAttestation_BaseUrlRotationEvent_new_base_url 0))
(assert (= $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_BaseUrlRotationEvent_type_value ($StructType $DualAttestation_BaseUrlRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key 0))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_type_value ($StructType $DualAttestation_ComplianceKeyRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_Credential_human_name 0))
(assert (= $DualAttestation_Credential_base_url 1))
(assert (= $DualAttestation_Credential_compliance_public_key 2))
(assert (= $DualAttestation_Credential_expiration_date 3))
(assert (= $DualAttestation_Credential_compliance_key_rotation_events 4))
(assert (= $DualAttestation_Credential_base_url_rotation_events 5))
(assert (= $DualAttestation_Credential_type_value ($StructType $DualAttestation_Credential $EmptyTypeValueArray)))
(assert (= $DualAttestation_Limit_micro_xdx_limit 0))
(assert (= $DualAttestation_Limit_type_value ($StructType $DualAttestation_Limit $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((auth_key_prefix T@$Value) )  (and (and ((_ is $Vector) ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix)) (let ((va@@9 (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0))
)))))
(assert (= $DiemAccount_DiemAccount_authentication_key 0))
(assert (= $DiemAccount_DiemAccount_withdraw_capability 1))
(assert (= $DiemAccount_DiemAccount_key_rotation_capability 2))
(assert (= $DiemAccount_DiemAccount_received_events 3))
(assert (= $DiemAccount_DiemAccount_sent_events 4))
(assert (= $DiemAccount_DiemAccount_sequence_number 5))
(assert (= $DiemAccount_DiemAccount_type_value ($StructType $DiemAccount_DiemAccount $EmptyTypeValueArray)))
(assert (= $DiemAccount_AccountOperationsCapability_limits_cap 0))
(assert (= $DiemAccount_AccountOperationsCapability_creation_events 1))
(assert (= $DiemAccount_AccountOperationsCapability_type_value ($StructType $DiemAccount_AccountOperationsCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_AdminTransactionEvent_committed_timestamp_secs 0))
(assert (= $DiemAccount_AdminTransactionEvent_type_value ($StructType $DiemAccount_AdminTransactionEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_Balance_coin 0))
(assert (forall (($tv0@@12 T@$TypeValue) ) (! (= ($DiemAccount_Balance_type_value $tv0@@12) ($StructType $DiemAccount_Balance ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1))) :pattern ( ($DiemAccount_Balance_type_value $tv0@@12))
)))
(assert (= $DiemAccount_CreateAccountEvent_created 0))
(assert (= $DiemAccount_CreateAccountEvent_role_id 1))
(assert (= $DiemAccount_CreateAccountEvent_type_value ($StructType $DiemAccount_CreateAccountEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_DiemWriteSetManager_upgrade_events 0))
(assert (= $DiemAccount_DiemWriteSetManager_type_value ($StructType $DiemAccount_DiemWriteSetManager $EmptyTypeValueArray)))
(assert (= $DiemAccount_KeyRotationCapability_account_address 0))
(assert (= $DiemAccount_KeyRotationCapability_type_value ($StructType $DiemAccount_KeyRotationCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_ReceivedPaymentEvent_amount 0))
(assert (= $DiemAccount_ReceivedPaymentEvent_currency_code 1))
(assert (= $DiemAccount_ReceivedPaymentEvent_payer 2))
(assert (= $DiemAccount_ReceivedPaymentEvent_metadata 3))
(assert (= $DiemAccount_ReceivedPaymentEvent_type_value ($StructType $DiemAccount_ReceivedPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_SentPaymentEvent_amount 0))
(assert (= $DiemAccount_SentPaymentEvent_currency_code 1))
(assert (= $DiemAccount_SentPaymentEvent_payee 2))
(assert (= $DiemAccount_SentPaymentEvent_metadata 3))
(assert (= $DiemAccount_SentPaymentEvent_type_value ($StructType $DiemAccount_SentPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_WithdrawCapability_account_address 0))
(assert (= $DiemAccount_WithdrawCapability_type_value ($StructType $DiemAccount_WithdrawCapability $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $SlidingNonce_SlidingNonce_$memory () T@$Memory)
(declare-fun tc_account () T@$Value)
(declare-fun $abort_flag@105 () Bool)
(declare-fun sliding_nonce () T@$Value)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun new_account_address () T@$Value)
(declare-fun $VASP_ParentVASP_$memory () T@$Memory)
(declare-fun $VASP_ChildVASP_$memory () T@$Memory)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $DiemAccount_Balance_$memory () T@$Memory)
(declare-fun $tv0@@13 () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun add_all_currencies () T@$Value)
(declare-fun $AccountFreezing_FreezingBit_$memory () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory () T@$Memory)
(declare-fun auth_key_prefix@@0 () T@$Value)
(declare-fun $abort_code@125 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@4 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@6 () T@$Memory)
(declare-fun $VASP_ParentVASP_$memory@5 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@14 () T@$Memory)
(declare-fun $abort_code@124 () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@4 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@3 () T@$Memory)
(declare-fun $VASP_ParentVASP_$memory@4 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@5 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@3 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@13 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@4 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@3 () T@$Memory)
(declare-fun $abort_flag@104 () Bool)
(declare-fun $DiemAccount_DiemAccount_$memory@2 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@2 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@2 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@12 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@4 () T@$Memory)
(declare-fun $VASP_ParentVASP_$memory@3 () T@$Memory)
(declare-fun $abort_code@123 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $DiemAccount_DiemAccount_$memory () T@$Memory)
(declare-fun $abort_code@5 () Int)
(declare-fun $Roles_RoleId_$memory@3 () T@$Memory)
(declare-fun $VASP_ParentVASP_$memory@2 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@11 () T@$Memory)
(declare-fun $abort_code@122 () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@1 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@1 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@1 () T@$Memory)
(declare-fun $abort_code@19 () Int)
(declare-fun $VASP_ParentVASP_$memory@1 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@2 () T@$Memory)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $AccountFreezing_FreezingBit_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@121 () Int)
(declare-fun $DiemAccount_Balance_$memory@10 () T@$Memory)
(declare-fun $abort_flag@103 () Bool)
(declare-fun $abort_flag@102 () Bool)
(declare-fun $abort_code@120 () Int)
(declare-fun $abort_flag@19 () Bool)
(declare-fun $abort_code@27 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun call2formal@$AccountFreezing_FreezingBit_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call3formal@$DiemAccount_DiemAccount_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call4formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun $abort_code@119 () Int)
(declare-fun $DiemAccount_Balance_$memory@9 () T@$Memory)
(declare-fun $abort_code@28 () Int)
(declare-fun $abort_flag@20 () Bool)
(declare-fun $abort_flag@72 () Bool)
(declare-fun $DiemAccount_Balance_$memory@3 () T@$Memory)
(declare-fun $abort_code@86 () Int)
(declare-fun $abort_flag@99 () Bool)
(declare-fun $DiemAccount_Balance_$memory@6 () T@$Memory)
(declare-fun $abort_code@116 () Int)
(declare-fun $abort_flag@46 () Bool)
(declare-fun $DiemAccount_Balance_$memory@1 () T@$Memory)
(declare-fun $abort_code@57 () Int)
(declare-fun $abort_flag@101 () Bool)
(declare-fun $abort_code@118 () Int)
(declare-fun $DiemAccount_Balance_$memory@8 () T@$Memory)
(declare-fun $abort_code@117 () Int)
(declare-fun $DiemAccount_Balance_$memory@7 () T@$Memory)
(declare-fun $abort_flag@100 () Bool)
(declare-fun $abort_flag@98 () Bool)
(declare-fun |inline$$MoveToRaw$3$m'@2| () T@$Memory)
(declare-fun $abort_code@114 () Int)
(declare-fun $DiemAccount_Balance_$memory@5 () T@$Memory)
(declare-fun $abort_code@115 () Int)
(declare-fun $abort_code@88 () Int)
(declare-fun $DiemAccount_Balance_$memory@4 () T@$Memory)
(declare-fun $abort_flag@74 () Bool)
(declare-fun $abort_code@108 () Int)
(declare-fun $abort_flag@93 () Bool)
(declare-fun $abort_code@109 () Int)
(declare-fun $abort_flag@94 () Bool)
(declare-fun $abort_code@111 () Int)
(declare-fun $abort_flag@95 () Bool)
(declare-fun |inline$$MoveToRaw$3$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$3$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$3$a@1 () Int)
(declare-fun |inline$$MoveToRaw$3$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_Balance_pack$1$$struct@1 () T@$Value)
(declare-fun $abort_code@113 () Int)
(declare-fun $abort_flag@97 () Bool)
(declare-fun inline$$DiemAccount_add_currency$1$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Diem_zero_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_flag@96 () Bool)
(declare-fun inline$$Diem_Diem_pack$1$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$Not$5$dst@1 () T@$Value)
(declare-fun $abort_code@112 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$1$$t12@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$1$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$1$$ret0@2 () T@$Value)
(declare-fun $abort_code@110 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun $abort_flag@92 () Bool)
(declare-fun inline$$DiemAccount_add_currency_$def$1$$t8@1 () T@$Value)
(declare-fun $abort_code@107 () Int)
(declare-fun inline$$Roles_can_hold_balance_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_code@105 () Int)
(declare-fun $abort_flag@90 () Bool)
(declare-fun $abort_code@104 () Int)
(declare-fun $abort_flag@84 () Bool)
(declare-fun $abort_code@98 () Int)
(declare-fun $abort_flag@79 () Bool)
(declare-fun $abort_code@93 () Int)
(declare-fun |inline$$Roles_can_hold_balance_$def$1$tmp#$2@1| () T@$Value)
(declare-fun $abort_code@106 () Int)
(declare-fun $abort_flag@91 () Bool)
(declare-fun inline$$Roles_can_hold_balance_$def$1$$t6@1 () T@$Value)
(declare-fun $abort_code@99 () Int)
(declare-fun $abort_flag@85 () Bool)
(declare-fun |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1| () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$5$$ret0@2 () T@$Value)
(declare-fun $abort_flag@89 () Bool)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$1$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$5$$ret0@1 () T@$Value)
(declare-fun $abort_code@103 () Int)
(declare-fun $abort_code@100 () Int)
(declare-fun $abort_flag@86 () Bool)
(declare-fun $abort_code@101 () Int)
(declare-fun $abort_flag@87 () Bool)
(declare-fun $abort_flag@88 () Bool)
(declare-fun $abort_code@102 () Int)
(declare-fun |inline$$Roles_has_role_$def$5$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$5$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$5$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$1$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$5$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$5$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$5$a@1 () Int)
(declare-fun inline$$GetGlobal$5$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$5$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$5$$t9@1 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$1$$t5@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$1$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$4$$ret0@2 () T@$Value)
(declare-fun $abort_flag@83 () Bool)
(declare-fun inline$$Roles_has_child_VASP_role_$def$1$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$4$$ret0@1 () T@$Value)
(declare-fun $abort_code@97 () Int)
(declare-fun $abort_code@94 () Int)
(declare-fun $abort_flag@80 () Bool)
(declare-fun $abort_code@95 () Int)
(declare-fun $abort_flag@81 () Bool)
(declare-fun $abort_flag@82 () Bool)
(declare-fun $abort_code@96 () Int)
(declare-fun |inline$$Roles_has_role_$def$4$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$4$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$4$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$1$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$4$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$4$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$4$a@1 () Int)
(declare-fun inline$$GetGlobal$4$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$4$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$4$$t9@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$3$$ret0@2 () T@$Value)
(declare-fun $abort_flag@78 () Bool)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$1$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$3$$ret0@1 () T@$Value)
(declare-fun $abort_code@92 () Int)
(declare-fun $abort_code@89 () Int)
(declare-fun $abort_flag@75 () Bool)
(declare-fun $abort_code@90 () Int)
(declare-fun $abort_flag@76 () Bool)
(declare-fun $abort_flag@77 () Bool)
(declare-fun $abort_code@91 () Int)
(declare-fun |inline$$Roles_has_role_$def$3$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$3$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$3$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$1$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$3$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$3$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$3$a@1 () Int)
(declare-fun inline$$GetGlobal$3$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$3$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$3$$t9@1 () T@$Value)
(declare-fun $abort_flag@73 () Bool)
(declare-fun inline$$Not$4$dst@1 () T@$Value)
(declare-fun $abort_code@87 () Int)
(declare-fun inline$$DiemAccount_add_currencies_for_account_$def$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun $abort_flag@71 () Bool)
(declare-fun |inline$$MoveToRaw$4$m'@2| () T@$Memory)
(declare-fun $abort_code@84 () Int)
(declare-fun $DiemAccount_Balance_$memory@2 () T@$Memory)
(declare-fun $abort_code@85 () Int)
(declare-fun $abort_code@58 () Int)
(declare-fun $abort_flag@47 () Bool)
(declare-fun $abort_code@78 () Int)
(declare-fun $abort_flag@66 () Bool)
(declare-fun $abort_code@79 () Int)
(declare-fun $abort_flag@67 () Bool)
(declare-fun $abort_code@81 () Int)
(declare-fun $abort_flag@68 () Bool)
(declare-fun |inline$$MoveToRaw$4$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$4$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$4$a@1 () Int)
(declare-fun |inline$$MoveToRaw$4$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_Balance_pack$2$$struct@1 () T@$Value)
(declare-fun $abort_code@83 () Int)
(declare-fun $abort_flag@70 () Bool)
(declare-fun inline$$DiemAccount_add_currency$2$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Diem_zero_$def$2$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$2$$ret0@1 () T@$Value)
(declare-fun $abort_flag@69 () Bool)
(declare-fun inline$$Diem_Diem_pack$2$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$2$$t0@1 () T@$Value)
(declare-fun inline$$Not$6$dst@1 () T@$Value)
(declare-fun $abort_code@82 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$2$$t12@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$2$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$2$$ret0@2 () T@$Value)
(declare-fun $abort_code@80 () Int)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun $abort_flag@65 () Bool)
(declare-fun inline$$DiemAccount_add_currency_$def$2$$t8@1 () T@$Value)
(declare-fun $abort_code@77 () Int)
(declare-fun inline$$Roles_can_hold_balance_$def$2$$ret0@1 () T@$Value)
(declare-fun $abort_code@75 () Int)
(declare-fun $abort_flag@63 () Bool)
(declare-fun $abort_code@74 () Int)
(declare-fun $abort_flag@57 () Bool)
(declare-fun $abort_code@68 () Int)
(declare-fun $abort_flag@52 () Bool)
(declare-fun $abort_code@63 () Int)
(declare-fun |inline$$Roles_can_hold_balance_$def$2$tmp#$2@1| () T@$Value)
(declare-fun $abort_code@76 () Int)
(declare-fun $abort_flag@64 () Bool)
(declare-fun inline$$Roles_can_hold_balance_$def$2$$t6@1 () T@$Value)
(declare-fun $abort_code@69 () Int)
(declare-fun $abort_flag@58 () Bool)
(declare-fun |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1| () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$2$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$8$$ret0@2 () T@$Value)
(declare-fun $abort_flag@62 () Bool)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$2$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$8$$ret0@1 () T@$Value)
(declare-fun $abort_code@73 () Int)
(declare-fun $abort_code@70 () Int)
(declare-fun $abort_flag@59 () Bool)
(declare-fun $abort_code@71 () Int)
(declare-fun $abort_flag@60 () Bool)
(declare-fun $abort_flag@61 () Bool)
(declare-fun $abort_code@72 () Int)
(declare-fun |inline$$Roles_has_role_$def$8$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$8$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$8$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$2$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$8$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$8$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$8$a@1 () Int)
(declare-fun inline$$GetGlobal$8$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$8$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$8$$t9@1 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$2$$t5@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$2$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$7$$ret0@2 () T@$Value)
(declare-fun $abort_flag@56 () Bool)
(declare-fun inline$$Roles_has_child_VASP_role_$def$2$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$7$$ret0@1 () T@$Value)
(declare-fun $abort_code@67 () Int)
(declare-fun $abort_code@64 () Int)
(declare-fun $abort_flag@53 () Bool)
(declare-fun $abort_code@65 () Int)
(declare-fun $abort_flag@54 () Bool)
(declare-fun $abort_flag@55 () Bool)
(declare-fun $abort_code@66 () Int)
(declare-fun |inline$$Roles_has_role_$def$7$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$7$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$7$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$2$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$7$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$7$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$7$a@1 () Int)
(declare-fun inline$$GetGlobal$7$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$7$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$7$$t9@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$6$$ret0@2 () T@$Value)
(declare-fun $abort_flag@51 () Bool)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$2$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$6$$ret0@1 () T@$Value)
(declare-fun $abort_code@62 () Int)
(declare-fun $abort_code@59 () Int)
(declare-fun $abort_flag@48 () Bool)
(declare-fun $abort_code@60 () Int)
(declare-fun $abort_flag@49 () Bool)
(declare-fun $abort_flag@50 () Bool)
(declare-fun $abort_code@61 () Int)
(declare-fun |inline$$Roles_has_role_$def$6$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$6$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$6$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$2$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$6$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$6$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$6$a@1 () Int)
(declare-fun inline$$GetGlobal$6$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$6$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$6$$t9@1 () T@$Value)
(declare-fun inline$$Not$3$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currencies_for_account_$def$0$$t5@1 () T@$Value)
(declare-fun $abort_flag@45 () Bool)
(declare-fun $abort_code@55 () Int)
(declare-fun |inline$$MoveToRaw$2$m'@2| () T@$Memory)
(declare-fun $abort_code@56 () Int)
(declare-fun $DiemAccount_Balance_$memory@0 () T@$Memory)
(declare-fun $abort_code@29 () Int)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $abort_code@49 () Int)
(declare-fun $abort_flag@40 () Bool)
(declare-fun $abort_code@50 () Int)
(declare-fun $abort_flag@41 () Bool)
(declare-fun $abort_code@52 () Int)
(declare-fun $abort_flag@42 () Bool)
(declare-fun |inline$$MoveToRaw$2$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$2$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$2$a@1 () Int)
(declare-fun |inline$$MoveToRaw$2$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_Balance_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_code@54 () Int)
(declare-fun $abort_flag@44 () Bool)
(declare-fun inline$$Diem_zero_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@43 () Bool)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$Not$2$dst@1 () T@$Value)
(declare-fun $abort_code@53 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$0$$t12@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def$0$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@51 () Int)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun $abort_flag@39 () Bool)
(declare-fun inline$$DiemAccount_add_currency_$def$0$$t8@1 () T@$Value)
(declare-fun $abort_code@48 () Int)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@46 () Int)
(declare-fun $abort_flag@37 () Bool)
(declare-fun $abort_code@45 () Int)
(declare-fun $abort_flag@31 () Bool)
(declare-fun $abort_code@39 () Int)
(declare-fun $abort_flag@26 () Bool)
(declare-fun $abort_code@34 () Int)
(declare-fun $abort_code@47 () Int)
(declare-fun |inline$$Roles_can_hold_balance_$def$0$tmp#$2@1| () T@$Value)
(declare-fun $abort_flag@38 () Bool)
(declare-fun $abort_flag@32 () Bool)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$t6@1 () T@$Value)
(declare-fun $abort_code@40 () Int)
(declare-fun |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$ret0@2 () T@$Value)
(declare-fun $abort_flag@36 () Bool)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$ret0@1 () T@$Value)
(declare-fun $abort_code@44 () Int)
(declare-fun $abort_code@41 () Int)
(declare-fun $abort_flag@33 () Bool)
(declare-fun $abort_code@42 () Int)
(declare-fun $abort_flag@34 () Bool)
(declare-fun $abort_flag@35 () Bool)
(declare-fun $abort_code@43 () Int)
(declare-fun |inline$$Roles_has_role_$def$2$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$2$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$2$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$2$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$2$a@1 () Int)
(declare-fun inline$$GetGlobal$2$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$t9@1 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$t5@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$ret0@2 () T@$Value)
(declare-fun $abort_flag@30 () Bool)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_code@38 () Int)
(declare-fun $abort_code@35 () Int)
(declare-fun $abort_flag@27 () Bool)
(declare-fun $abort_code@36 () Int)
(declare-fun $abort_flag@28 () Bool)
(declare-fun $abort_flag@29 () Bool)
(declare-fun $abort_code@37 () Int)
(declare-fun |inline$$Roles_has_role_$def$1$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$1$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$1$a@1 () Int)
(declare-fun inline$$GetGlobal$1$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$t9@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@25 () Bool)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@33 () Int)
(declare-fun $abort_code@30 () Int)
(declare-fun $abort_flag@22 () Bool)
(declare-fun $abort_code@31 () Int)
(declare-fun $abort_flag@23 () Bool)
(declare-fun $abort_flag@24 () Bool)
(declare-fun $abort_code@32 () Int)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1 () T@$Value)
(declare-fun $abort_flag@18 () Bool)
(declare-fun $abort_code@25 () Int)
(declare-fun $abort_code@26 () Int)
(declare-fun $abort_code@20 () Int)
(declare-fun $abort_flag@14 () Bool)
(declare-fun $abort_code@21 () Int)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $abort_code@22 () Int)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_code@23 () Int)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $DualAttestation_Credential_$memory () T@$Memory)
(declare-fun inline$$MoveTo$1$a@1 () Int)
(declare-fun |inline$$MoveToRaw$1$m'@1| () T@$Memory)
(declare-fun inline$$DualAttestation_Credential_pack$0$$struct@1 () T@$Value)
(declare-fun human_name () T@$Value)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$Vector_empty$1$v@1 () T@$Value)
(declare-fun inline$$DualAttestation_publish_credential_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$1$ta@0 () T@$TypeValue)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun $abort_code@24 () Int)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$DualAttestation_publish_credential_$def$0$$t11@1 () T@$Value)
(declare-fun inline$$DualAttestation_publish_credential_$def$0$$t9@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $abort_code@17 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@18 () Int)
(declare-fun $VASP_ParentVASP_$memory@0 () T@$Memory)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@13 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_code@15 () Int)
(declare-fun $abort_flag@11 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$VASP_ParentVASP_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$VASP_publish_parent_vasp_credential_$def$0$$t11@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@16 () Int)
(declare-fun call3formal@$ret0@0@@20 () T@$Value)
(declare-fun inline$$VASP_publish_parent_vasp_credential_$def$0$$t9@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@21 () T@$Value)
(declare-fun call3formal@$ret0@0@@22 () T@$Value)
(declare-fun $abort_code@8 () Int)
(declare-fun $Roles_RoleId_$memory@1 () T@$Memory)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $Roles_RoleId_$memory@0 () T@$Memory)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun inline$$Roles_new_parent_vasp_role_$def$0$$t4@1 () T@$Value)
(declare-fun inline$$Roles_new_parent_vasp_role_$def$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$Roles_new_parent_vasp_role$0$$Roles_RoleId_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@23 () T@$Value)
(declare-fun inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t7@1 () T@$Value)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun $AccountFreezing_FreezeEventsHolder_$memory () T@$Memory)
(declare-fun $ChainId_ChainId_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(declare-fun $XDX_Reserve_$memory () T@$Memory)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory () T@$Memory)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory () T@$Memory)
(declare-fun $TransactionFee_TransactionFee_$memory () T@$Memory)
(declare-fun $DualAttestation_Limit_$memory () T@$Memory)
(declare-fun $DiemAccount_DiemWriteSetManager_$memory () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 335929) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 331586) (- 0 361903)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 361923)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 361944)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 361956)) (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 361968)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 361983)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362003)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362031)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362048)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address)))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address)))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362072)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362089)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362149)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362209)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 0)))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 0)))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362222)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 1)))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 1)))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362235)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362247)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362277)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362308)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362328)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362356)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@105)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@105) (and (=> (= (ControlFlow 0 331586) (- 0 362373)) (=> $abort_flag@105 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 0))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 1))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))))) (=> (=> $abort_flag@105 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 0))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 1))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (and (=> (= (ControlFlow 0 331586) (- 0 362824)) (=> $abort_flag@105 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0))))) (= $abort_code@125 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (= $abort_code@125 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) (= $abort_code@125 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@125 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@125 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@125 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address)))) (= $abort_code@125 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 0)))) (= $abort_code@125 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 1)))) (= $abort_code@125 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (= $abort_code@125 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) (= $abort_code@125 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@125 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@125 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@105 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce) ($Integer 0))))) (= $abort_code@125 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (= $abort_code@125 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) (= $abort_code@125 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@125 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@125 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@125 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address)))) (= $abort_code@125 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 0)))) (= $abort_code@125 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 1)))) (= $abort_code@125 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (= $abort_code@125 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) (= $abort_code@125 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@125 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@125 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@125 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 331586) (- 0 363495)) (=> $abort_flag@105 (or (or (or (or (= $abort_code@125 (|i#$Integer| ($Integer 7))) (= $abort_code@125 (|i#$Integer| ($Integer 2)))) (= $abort_code@125 (|i#$Integer| ($Integer 5)))) (= $abort_code@125 (|i#$Integer| ($Integer 6)))) (= $abort_code@125 (|i#$Integer| ($Integer 3)))))) (=> (=> $abort_flag@105 (or (or (or (or (= $abort_code@125 (|i#$Integer| ($Integer 7))) (= $abort_code@125 (|i#$Integer| ($Integer 2)))) (= $abort_code@125 (|i#$Integer| ($Integer 5)))) (= $abort_code@125 (|i#$Integer| ($Integer 6)))) (= $abort_code@125 (|i#$Integer| ($Integer 3))))) (and (=> (= (ControlFlow 0 331586) (- 0 363551)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@4) $EmptyTypeValueArray (|a#$Address| new_account_address)))))) (=> (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@4) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (and (=> (= (ControlFlow 0 331586) (- 0 363563)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@6) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@6) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 5))))))))) (=> (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@6) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@6) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 5)))))))) (and (=> (= (ControlFlow 0 331586) (- 0 363575)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory@5) $EmptyTypeValueArray (|a#$Address| new_account_address)))))) (=> (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory@5) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (and (=> (= (ControlFlow 0 331586) (- 0 363587)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory@5) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $VASP_ParentVASP_num_children) ($Integer 0)))))) (=> (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory@5) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $VASP_ParentVASP_num_children) ($Integer 0))))) (and (=> (= (ControlFlow 0 331586) (- 0 363607)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address)))))) (=> (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address))))) (and (=> (= (ControlFlow 0 331586) (- 0 363633)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address)) ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Vector (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Integer 0)) (+ len@@1 1))))) (+ len@@0 1))))))))) (=> (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| new_account_address)) ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Vector (let ((len@@1 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@1 ($Integer 0)) (+ len@@1 1))))) (+ len@@0 1)))))))) (and (=> (= (ControlFlow 0 331586) (- 0 363679)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address))))))))) (=> (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))) (and (=> (= (ControlFlow 0 331586) (- 0 363748)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)) ($Vector (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 ($Vector (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Integer 0)) (+ len@@3 1))))) (+ len@@2 1)))))))))))) (=> (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| new_account_address)) ($Vector (let ((len@@2 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@2 ($Vector (let ((len@@3 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@3 ($Integer 0)) (+ len@@3 1))))) (+ len@@2 1))))))))))) (and (=> (= (ControlFlow 0 331586) (- 0 363837)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address))))))))) (=> (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))) (=> (= (ControlFlow 0 331586) (- 0 363906)) (=> (not $abort_flag@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| add_all_currencies) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@14) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| new_account_address)) ($Vector (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 ($Vector (let ((len@@5 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@5 ($Integer 0)) (+ len@@5 1))))) (+ len@@4 1))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$Abort_correct  (=> (= $abort_flag@105 true) (=> (and (and (and (= $abort_code@125 $abort_code@124) (= $DiemAccount_AccountOperationsCapability_$memory@4 $DiemAccount_AccountOperationsCapability_$memory@3)) (and (= $VASP_ParentVASP_$memory@5 $VASP_ParentVASP_$memory@4) (= $Roles_RoleId_$memory@6 $Roles_RoleId_$memory@5))) (and (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@3) (= $DiemAccount_Balance_$memory@14 $DiemAccount_Balance_$memory@13)) (and (= $AccountFreezing_FreezingBit_$memory@4 $AccountFreezing_FreezingBit_$memory@3) (= (ControlFlow 0 331528) 331586)))) anon0$2_correct))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon24_Then_correct  (=> $abort_flag@104 (=> (and (and (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@2) (= $DiemAccount_AccountOperationsCapability_$memory@3 $DiemAccount_AccountOperationsCapability_$memory@2)) (and (= $AccountFreezing_FreezingBit_$memory@3 $AccountFreezing_FreezingBit_$memory@2) (= $DiemAccount_Balance_$memory@13 $DiemAccount_Balance_$memory@12))) (and (and (= $Roles_RoleId_$memory@5 $Roles_RoleId_$memory@4) (= $VASP_ParentVASP_$memory@4 $VASP_ParentVASP_$memory@3)) (and (= $abort_code@124 $abort_code@123) (= (ControlFlow 0 331524) 331528)))) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$Abort_correct))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon23_Then_correct  (=> $abort_flag@2 (=> (and (and (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory) (= $DiemAccount_AccountOperationsCapability_$memory@3 $DiemAccount_AccountOperationsCapability_$memory)) (and (= $AccountFreezing_FreezingBit_$memory@3 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_Balance_$memory@13 $DiemAccount_Balance_$memory))) (and (and (= $Roles_RoleId_$memory@5 $Roles_RoleId_$memory) (= $VASP_ParentVASP_$memory@4 $VASP_ParentVASP_$memory)) (and (= $abort_code@124 $abort_code@5) (= (ControlFlow 0 331532) 331528)))) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$Abort_correct))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon24_Else_correct  (=> (and (not $abort_flag@104) (= $abort_flag@105 $abort_flag@104)) (=> (and (and (and (= $abort_code@125 $abort_code@123) (= $DiemAccount_AccountOperationsCapability_$memory@4 $DiemAccount_AccountOperationsCapability_$memory@2)) (and (= $VASP_ParentVASP_$memory@5 $VASP_ParentVASP_$memory@3) (= $Roles_RoleId_$memory@6 $Roles_RoleId_$memory@4))) (and (and (= $DiemAccount_DiemAccount_$memory@4 $DiemAccount_DiemAccount_$memory@2) (= $DiemAccount_Balance_$memory@14 $DiemAccount_Balance_$memory@12)) (and (= $AccountFreezing_FreezingBit_$memory@4 $AccountFreezing_FreezingBit_$memory@2) (= (ControlFlow 0 331520) 331586)))) anon0$2_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$Abort_correct  (=> (and (and (and (= $abort_flag@104 true) (= $Roles_RoleId_$memory@4 $Roles_RoleId_$memory@3)) (and (= $VASP_ParentVASP_$memory@3 $VASP_ParentVASP_$memory@2) (= $DiemAccount_Balance_$memory@12 $DiemAccount_Balance_$memory@11))) (and (and (= $abort_code@123 $abort_code@122) (= $DiemAccount_AccountOperationsCapability_$memory@2 $DiemAccount_AccountOperationsCapability_$memory@1)) (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@1) (= $AccountFreezing_FreezingBit_$memory@2 $AccountFreezing_FreezingBit_$memory@1)))) (and (=> (= (ControlFlow 0 331398) 331524) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 331398) 331520) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon13_correct  (=> (and (and (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@122 $abort_code@5))) (and (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory) (= $VASP_ParentVASP_$memory@2 $VASP_ParentVASP_$memory)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory) (= (ControlFlow 0 331454) 331398)))) inline$$DiemAccount_create_parent_vasp_account_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 331452) 331454)) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon13_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon37_Then_correct  (=> (= (ControlFlow 0 331462) 331454) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon13_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon36_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 331446) 331462) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 331446) 331452) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon37_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon21_correct  (=> (and (and (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@122 $abort_code@19))) (and (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory) (= $VASP_ParentVASP_$memory@2 $VASP_ParentVASP_$memory@1)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 331426) 331398)))) inline$$DiemAccount_create_parent_vasp_account_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 331424) 331426)) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 331434) 331426) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon40_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 331418) 331434) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 331418) 331424) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon29_correct  (=> (and (and (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory@0) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory@0)) (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory@0) (= $abort_code@122 $abort_code@121))) (and (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory@10) (= $VASP_ParentVASP_$memory@2 $VASP_ParentVASP_$memory@1)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 331394) 331398)))) inline$$DiemAccount_create_parent_vasp_account_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon45_Else_correct  (=> (and (not true) (= (ControlFlow 0 331392) 331394)) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon29_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon45_Then_correct  (=> (= (ControlFlow 0 331406) 331394) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon29_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon44_Then_correct  (=> $abort_flag@103 (and (=> (= (ControlFlow 0 331386) 331406) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 331386) 331392) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon43_Then_correct  (=> $abort_flag@102 (=> (and (and (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@122 $abort_code@120))) (and (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory@10) (= $VASP_ParentVASP_$memory@2 $VASP_ParentVASP_$memory@1)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 331410) 331398)))) inline$$DiemAccount_create_parent_vasp_account_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon42_Then_correct  (=> $abort_flag@19 (=> (and (and (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@122 $abort_code@27))) (and (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory) (= $VASP_ParentVASP_$memory@2 $VASP_ParentVASP_$memory@1)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 331414) 331398)))) inline$$DiemAccount_create_parent_vasp_account_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon39_Then_correct  (=> $abort_flag@13 (=> (and (and (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@122 $abort_code@19))) (and (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory) (= $VASP_ParentVASP_$memory@2 $VASP_ParentVASP_$memory@1)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 331438) 331398)))) inline$$DiemAccount_create_parent_vasp_account_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon38_Then_correct  (=> $abort_flag@5 (=> (and (and (and (= $AccountFreezing_FreezingBit_$memory@1 $AccountFreezing_FreezingBit_$memory) (= $DiemAccount_DiemAccount_$memory@1 $DiemAccount_DiemAccount_$memory)) (and (= $DiemAccount_AccountOperationsCapability_$memory@1 $DiemAccount_AccountOperationsCapability_$memory) (= $abort_code@122 $abort_code@9))) (and (and (= $DiemAccount_Balance_$memory@11 $DiemAccount_Balance_$memory) (= $VASP_ParentVASP_$memory@2 $VASP_ParentVASP_$memory)) (and (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2) (= (ControlFlow 0 331442) 331398)))) inline$$DiemAccount_create_parent_vasp_account_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon44_Else_correct  (=> (not $abort_flag@103) (=> (and (and (and (= $abort_flag@104 $abort_flag@103) (= $Roles_RoleId_$memory@4 $Roles_RoleId_$memory@2)) (and (= $VASP_ParentVASP_$memory@3 $VASP_ParentVASP_$memory@1) (= $DiemAccount_Balance_$memory@12 $DiemAccount_Balance_$memory@10))) (and (and (= $abort_code@123 $abort_code@121) (= $DiemAccount_AccountOperationsCapability_$memory@2 $DiemAccount_AccountOperationsCapability_$memory@0)) (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= $AccountFreezing_FreezingBit_$memory@2 $AccountFreezing_FreezingBit_$memory@0)))) (and (=> (= (ControlFlow 0 331382) 331524) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 331382) 331520) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon43_Else_correct  (=> (and (and (not $abort_flag@102) (= call2formal@$AccountFreezing_FreezingBit_$CallerDomain@0 ($ConstMemoryDomain true))) (and (= call3formal@$DiemAccount_DiemAccount_$CallerDomain@0 ($ConstMemoryDomain true)) (= call4formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 ($ConstMemoryDomain true)))) (and (=> (= (ControlFlow 0 331376) (- 0 360778)) (|Select_[$TypeValueArray,$int]$bool| call2formal@$AccountFreezing_FreezingBit_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| new_account_address))) (=> (|Select_[$TypeValueArray,$int]$bool| call2formal@$AccountFreezing_FreezingBit_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| new_account_address)) (and (=> (= (ControlFlow 0 331376) (- 0 360788)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| new_account_address))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| new_account_address)) (and (=> (= (ControlFlow 0 331376) (- 0 360798)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemAccount_AccountOperationsCapability_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 0)))) $abort_flag@103) (=> (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 1)))) $abort_flag@103) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $abort_flag@103)) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@103) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) $abort_flag@103)) (and (=> $abort_flag@103 (or (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 1))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))))) (=> $abort_flag@103 (or (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 0)))) (= $abort_code@121 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address ($Address 1)))) (= $abort_code@121 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (= $abort_code@121 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@121 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))))) ($Integer 32))))) (= $abort_code@121 (|i#$Integer| ($Integer 7)))))))) (and (and (=> (not $abort_flag@103) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (=> (not $abort_flag@103) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))))) (and (=> (not $abort_flag@103) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $AccountFreezing_FreezingBit_is_frozen))))))))) (=> (not $abort_flag@103) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_AccountOperationsCapability_creation_events (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_AccountOperationsCapability_creation_events)) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (and (and (and (=> (not $abort_flag@103) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))) (=> (not $abort_flag@103) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified new_account_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))) (and (= (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (= (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))))) (and (and (= (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (= (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (and (= (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 331376) 331386) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 331376) 331382) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon44_Else_correct))))))))))))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct  (=> (= $abort_flag@102 true) (=> (and (= $abort_code@120 $abort_code@119) (= $DiemAccount_Balance_$memory@10 $DiemAccount_Balance_$memory@9)) (and (=> (= (ControlFlow 0 325077) 331410) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 325077) 331376) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon43_Else_correct))))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon7_correct  (=> (= $DiemAccount_Balance_$memory@9 $DiemAccount_Balance_$memory) (=> (and (= $abort_code@119 $abort_code@28) (= (ControlFlow 0 331334) 325077)) inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 331332) 331334)) inline$$DiemAccount_add_currencies_for_account_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 331342) 331334) inline$$DiemAccount_add_currencies_for_account_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon23_Then_correct  (=> $abort_flag@20 (and (=> (= (ControlFlow 0 331326) 331342) inline$$DiemAccount_add_currencies_for_account_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 331326) 331332) inline$$DiemAccount_add_currencies_for_account_$def$0$anon24_Else_correct)))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Then_correct  (=> (and (and $abort_flag@72 (= $DiemAccount_Balance_$memory@9 $DiemAccount_Balance_$memory@3)) (and (= $abort_code@119 $abort_code@86) (= (ControlFlow 0 331318) 325077))) inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Then_correct  (=> (and (and $abort_flag@99 (= $DiemAccount_Balance_$memory@9 $DiemAccount_Balance_$memory@6)) (and (= $abort_code@119 $abort_code@116) (= (ControlFlow 0 325073) 325077))) inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Then_correct  (=> (and (and $abort_flag@46 (= $DiemAccount_Balance_$memory@9 $DiemAccount_Balance_$memory@1)) (and (= $abort_code@119 $abort_code@57) (= (ControlFlow 0 331322) 325077))) inline$$DiemAccount_add_currencies_for_account_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$L10_correct  (=> (= $abort_flag@102 $abort_flag@101) (=> (and (= $abort_code@120 $abort_code@118) (= $DiemAccount_Balance_$memory@10 $DiemAccount_Balance_$memory@8)) (and (=> (= (ControlFlow 0 318666) 331410) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 318666) 331376) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon43_Else_correct))))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$L9_correct  (=> (and (and (= $abort_code@118 $abort_code@117) (= $DiemAccount_Balance_$memory@8 $DiemAccount_Balance_$memory@7)) (and (= $abort_flag@101 $abort_flag@100) (= (ControlFlow 0 318832) 318666))) inline$$DiemAccount_add_currencies_for_account_$def$0$L10_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Else_correct  (=> (not $abort_flag@99) (=> (and (and (= $DiemAccount_Balance_$memory@7 $DiemAccount_Balance_$memory@6) (= $abort_flag@100 $abort_flag@99)) (and (= $abort_code@117 $abort_code@116) (= (ControlFlow 0 325069) 318832))) inline$$DiemAccount_add_currencies_for_account_$def$0$L9_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon50_Else_correct  (=> (and (and (not $abort_flag@98) (= $DiemAccount_Balance_$memory@6 |inline$$MoveToRaw$3$m'@2|)) (and (= $abort_flag@99 $abort_flag@98) (= $abort_code@116 $abort_code@114))) (and (=> (= (ControlFlow 0 324935) 325073) inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 324935) 325069) inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$Abort_correct  (=> (= $DiemAccount_Balance_$memory@6 $DiemAccount_Balance_$memory@5) (=> (and (= $abort_flag@99 true) (= $abort_code@116 $abort_code@115)) (and (=> (= (ControlFlow 0 323862) 325073) inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 323862) 325069) inline$$DiemAccount_add_currencies_for_account_$def$0$anon30_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon5_correct  (=> (= $abort_code@115 $abort_code@88) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 325035) 323862)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 325033) 325035)) inline$$DiemAccount_add_currency_$def$1$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon37_Then_correct  (=> (= (ControlFlow 0 325043) 325035) inline$$DiemAccount_add_currency_$def$1$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon36_Then_correct  (=> $abort_flag@74 (and (=> (= (ControlFlow 0 325027) 325043) inline$$DiemAccount_add_currency_$def$1$anon37_Then_correct) (=> (= (ControlFlow 0 325027) 325033) inline$$DiemAccount_add_currency_$def$1$anon37_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon11_correct  (=> (= $abort_code@115 $abort_code@108) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 325011) 323862)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 325009) 325011)) inline$$DiemAccount_add_currency_$def$1$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon40_Then_correct  (=> (= (ControlFlow 0 325019) 325011) inline$$DiemAccount_add_currency_$def$1$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon39_Then_correct  (=> $abort_flag@93 (and (=> (= (ControlFlow 0 325003) 325019) inline$$DiemAccount_add_currency_$def$1$anon40_Then_correct) (=> (= (ControlFlow 0 325003) 325009) inline$$DiemAccount_add_currency_$def$1$anon40_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon19_correct  (=> (= $abort_code@115 $abort_code@109) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 324991) 323862)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 324989) 324991)) inline$$DiemAccount_add_currency_$def$1$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon44_Then_correct  (=> (= (ControlFlow 0 324999) 324991) inline$$DiemAccount_add_currency_$def$1$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon43_Then_correct  (=> $abort_flag@94 (and (=> (= (ControlFlow 0 324983) 324999) inline$$DiemAccount_add_currency_$def$1$anon44_Then_correct) (=> (= (ControlFlow 0 324983) 324989) inline$$DiemAccount_add_currency_$def$1$anon44_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon23_correct  (=> (= $abort_code@115 $abort_code@111) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 324971) 323862)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 324969) 324971)) inline$$DiemAccount_add_currency_$def$1$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon46_Then_correct  (=> (= (ControlFlow 0 324979) 324971) inline$$DiemAccount_add_currency_$def$1$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon45_Then_correct  (=> $abort_flag@95 (and (=> (= (ControlFlow 0 324963) 324979) inline$$DiemAccount_add_currency_$def$1$anon46_Then_correct) (=> (= (ControlFlow 0 324963) 324969) inline$$DiemAccount_add_currency_$def$1$anon46_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon33_correct  (=> (= $abort_code@115 $abort_code@114) (=> (and (= $DiemAccount_Balance_$memory@5 |inline$$MoveToRaw$3$m'@2|) (= (ControlFlow 0 324947) 323862)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 324945) 324947)) inline$$DiemAccount_add_currency_$def$1$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon51_Then_correct  (=> (= (ControlFlow 0 324955) 324947) inline$$DiemAccount_add_currency_$def$1$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon50_Then_correct  (=> $abort_flag@98 (and (=> (= (ControlFlow 0 324939) 324955) inline$$DiemAccount_add_currency_$def$1$anon51_Then_correct) (=> (= (ControlFlow 0 324939) 324945) inline$$DiemAccount_add_currency_$def$1$anon51_Else_correct)))))
(let ((inline$$MoveToRaw$3$anon3_Then$1_correct  (=> (= $abort_code@114 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@98 true) (= |inline$$MoveToRaw$3$m'@2| |inline$$MoveToRaw$3$m'@0|)) (and (=> (= (ControlFlow 0 324913) 324939) inline$$DiemAccount_add_currency_$def$1$anon50_Then_correct) (=> (= (ControlFlow 0 324913) 324935) inline$$DiemAccount_add_currency_$def$1$anon50_Else_correct))))))
(let ((inline$$MoveToRaw$3$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1) (= (ControlFlow 0 324911) 324913)) inline$$MoveToRaw$3$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$3$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1)) (=> (and (and (= |inline$$MoveToRaw$3$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@4) inline$$MoveTo$3$ta@0 inline$$MoveTo$3$a@1 inline$$DiemAccount_Balance_pack$1$$struct@1))) (= $abort_code@114 $abort_code@113)) (and (= $abort_flag@98 $abort_flag@97) (= |inline$$MoveToRaw$3$m'@2| |inline$$MoveToRaw$3$m'@1|))) (and (=> (= (ControlFlow 0 324861) 324939) inline$$DiemAccount_add_currency_$def$1$anon50_Then_correct) (=> (= (ControlFlow 0 324861) 324935) inline$$DiemAccount_add_currency_$def$1$anon50_Else_correct))))))
(let ((inline$$MoveTo$3$anon0$1_correct  (=> (= inline$$MoveTo$3$a@1 (|a#$Address| new_account_address)) (and (=> (= (ControlFlow 0 324919) 324911) inline$$MoveToRaw$3$anon3_Then_correct) (=> (= (ControlFlow 0 324919) 324861) inline$$MoveToRaw$3$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$3$Entry_correct  (and (=> (= (ControlFlow 0 324707) (- 0 360350)) true) (=> (= (ControlFlow 0 324707) 324919) inline$$MoveTo$3$anon0$1_correct))))
(let ((inline$$MoveTo$3$Entry_correct  (=> (and (= inline$$MoveTo$3$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1)) (= (ControlFlow 0 324679) 324707)) inline$$Signer_borrow_address$3$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$1$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 324581) 324679)) inline$$MoveTo$3$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$1$anon4_Then_correct  (=> (= (ControlFlow 0 324587) 324679) inline$$MoveTo$3$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 324575) 324587) inline$$DiemAccount_Balance_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 324575) 324581) inline$$DiemAccount_Balance_pack$1$anon4_Else_correct)))))
(let ((inline$$DiemAccount_Balance_pack$1$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 324567) 324679)) inline$$MoveTo$3$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$1$$ret0@2) (let ((va@@10 (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$1$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$DiemAccount_Balance_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 324559) 324575) inline$$DiemAccount_Balance_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 324559) 324567) inline$$DiemAccount_Balance_pack$1$anon3_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon49_Else_correct  (=> (and (not $abort_flag@97) (= (ControlFlow 0 324593) 324559)) inline$$DiemAccount_Balance_pack$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon49_Then_correct  (=> (and (and $abort_flag@97 (= $abort_code@115 $abort_code@113)) (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 324959) 323862))) inline$$DiemAccount_add_currency_$def$1$Abort_correct)))
(let ((inline$$Diem_zero_$def$1$anon3_correct  (=> (= inline$$Diem_zero_$def$1$$ret0@1 $Error) (=> (and (= $abort_flag@97 true) (= inline$$Diem_zero_$def$1$$ret0@2 inline$$Diem_zero_$def$1$$ret0@1)) (and (=> (= (ControlFlow 0 324398) 324959) inline$$DiemAccount_add_currency_$def$1$anon49_Then_correct) (=> (= (ControlFlow 0 324398) 324593) inline$$DiemAccount_add_currency_$def$1$anon49_Else_correct))))))
(let ((inline$$Diem_zero_$def$1$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 324392) 324398)) inline$$Diem_zero_$def$1$anon3_correct)))
(let ((inline$$Diem_zero_$def$1$anon8_Then_correct  (=> (= (ControlFlow 0 324406) 324398) inline$$Diem_zero_$def$1$anon3_correct)))
(let ((inline$$Diem_zero_$def$1$anon7_Then_correct  (=> $abort_flag@96 (and (=> (= (ControlFlow 0 324386) 324406) inline$$Diem_zero_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 324386) 324392) inline$$Diem_zero_$def$1$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon6_correct  (=> (and (= $abort_flag@97 $abort_flag@96) (= inline$$Diem_zero_$def$1$$ret0@2 inline$$Diem_Diem_pack$1$$struct@1)) (and (=> (= (ControlFlow 0 324374) 324959) inline$$DiemAccount_add_currency_$def$1$anon49_Then_correct) (=> (= (ControlFlow 0 324374) 324593) inline$$DiemAccount_add_currency_$def$1$anon49_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 324372) 324374)) inline$$Diem_zero_$def$1$anon6_correct)))
(let ((inline$$Diem_zero_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 324382) 324374) inline$$Diem_zero_$def$1$anon6_correct)))
(let ((inline$$Diem_Diem_pack$1$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 324350) 324382) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 324350) 324372) inline$$Diem_zero_$def$1$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon4_Then_correct  (and (=> (= (ControlFlow 0 324356) 324382) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 324356) 324372) inline$$Diem_zero_$def$1$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$1$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 324344) 324356) inline$$Diem_Diem_pack$1$anon4_Then_correct) (=> (= (ControlFlow 0 324344) 324350) inline$$Diem_Diem_pack$1$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 324336) 324382) inline$$Diem_zero_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 324336) 324372) inline$$Diem_zero_$def$1$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$1$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$1$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$1$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$1$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$1$$t0@1) 1)))) (and (=> (= (ControlFlow 0 324328) 324344) inline$$Diem_Diem_pack$1$anon3_Then_correct) (=> (= (ControlFlow 0 324328) 324336) inline$$Diem_Diem_pack$1$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$1$anon7_Else_correct  (=> (not $abort_flag@96) (=> (and (= inline$$Diem_zero_$def$1$$t0@1 ($Integer 0)) (= (ControlFlow 0 324362) 324328)) inline$$Diem_Diem_pack$1$anon0_correct))))
(let ((inline$$Diem_zero_$def$1$anon0_correct  (=> (and (and (not $abort_flag@95) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@96)) (and (=> $abort_flag@96 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@96 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@113 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 324187) 324386) inline$$Diem_zero_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 324187) 324362) inline$$Diem_zero_$def$1$anon7_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon47_Then_correct  (=> (and (|b#$Boolean| inline$$Not$5$dst@1) (= (ControlFlow 0 324420) 324187)) inline$$Diem_zero_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon28_correct  (=> (= $abort_code@115 $abort_code@112) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 323982) 323862)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 323980) 323982)) inline$$DiemAccount_add_currency_$def$1$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon48_Then_correct  (=> (= (ControlFlow 0 323990) 323982) inline$$DiemAccount_add_currency_$def$1$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon47_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$5$dst@1)) (= $abort_code@112 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 323974) 323990) inline$$DiemAccount_add_currency_$def$1$anon48_Then_correct) (=> (= (ControlFlow 0 323974) 323980) inline$$DiemAccount_add_currency_$def$1$anon48_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon45_Else_correct  (=> (not $abort_flag@95) (and (=> (= (ControlFlow 0 323962) 324420) inline$$DiemAccount_add_currency_$def$1$anon47_Then_correct) (=> (= (ControlFlow 0 323962) 323974) inline$$DiemAccount_add_currency_$def$1$anon47_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon43_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$1$$t12@1 ($Integer 15)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@95)) (and (=> $abort_flag@95 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@95) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 323956) 324963) inline$$DiemAccount_add_currency_$def$1$anon45_Then_correct) (=> (= (ControlFlow 0 323956) 323962) inline$$DiemAccount_add_currency_$def$1$anon45_Else_correct)))))
(let ((inline$$Not$5$anon0_correct  (=> (and (= inline$$Not$5$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currency_$def$1$$t10@1)))) (= (ControlFlow 0 323944) 323956)) inline$$DiemAccount_add_currency_$def$1$anon43_Else$1_correct)))
(let ((inline$$Not$5$Entry_correct  (and (=> (= (ControlFlow 0 323934) (- 0 359893)) true) (=> (= (ControlFlow 0 323934) 323944) inline$$Not$5$anon0_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon43_Else_correct  (=> (not $abort_flag@94) (=> (and (= inline$$DiemAccount_add_currency_$def$1$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@0)))) (= (ControlFlow 0 323950) 323934)) inline$$Not$5$Entry_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon41_Then_correct  (=> (|b#$Boolean| inline$$Roles_can_hold_balance_$def$1$$ret0@2) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@94) (=> $abort_flag@94 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@94) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 323876) 324983) inline$$DiemAccount_add_currency_$def$1$anon43_Then_correct) (=> (= (ControlFlow 0 323876) 323950) inline$$DiemAccount_add_currency_$def$1$anon43_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon16_correct  (=> (= $abort_code@115 $abort_code@110) (=> (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 323858) 323862)) inline$$DiemAccount_add_currency_$def$1$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 323856) 323858)) inline$$DiemAccount_add_currency_$def$1$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon42_Then_correct  (=> (= (ControlFlow 0 323870) 323858) inline$$DiemAccount_add_currency_$def$1$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_can_hold_balance_$def$1$$ret0@2)) (= $abort_code@110 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 323850) 323870) inline$$DiemAccount_add_currency_$def$1$anon42_Then_correct) (=> (= (ControlFlow 0 323850) 323856) inline$$DiemAccount_add_currency_$def$1$anon42_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon39_Else_correct  (=> (not $abort_flag@93) (and (=> (= (ControlFlow 0 323838) 323876) inline$$DiemAccount_add_currency_$def$1$anon41_Then_correct) (=> (= (ControlFlow 0 323838) 323850) inline$$DiemAccount_add_currency_$def$1$anon41_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon38_Else_correct  (=> (not $abort_flag@92) (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$1$$t8@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@93)) (and (=> $abort_flag@93 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@93) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 323832) 325003) inline$$DiemAccount_add_currency_$def$1$anon39_Then_correct) (=> (= (ControlFlow 0 323832) 323838) inline$$DiemAccount_add_currency_$def$1$anon39_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon38_Then_correct  (=> (and (and $abort_flag@92 (= $abort_code@115 $abort_code@107)) (and (= $DiemAccount_Balance_$memory@5 $DiemAccount_Balance_$memory@4) (= (ControlFlow 0 325023) 323862))) inline$$DiemAccount_add_currency_$def$1$Abort_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$Abort_correct  (=> (and (and (= inline$$Roles_can_hold_balance_$def$1$$ret0@1 $Error) (= inline$$Roles_can_hold_balance_$def$1$$ret0@2 inline$$Roles_can_hold_balance_$def$1$$ret0@1)) (and (= $abort_code@107 $abort_code@105) (= $abort_flag@92 true))) (and (=> (= (ControlFlow 0 323670) 325023) inline$$DiemAccount_add_currency_$def$1$anon38_Then_correct) (=> (= (ControlFlow 0 323670) 323832) inline$$DiemAccount_add_currency_$def$1$anon38_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon26_Then_correct  (=> $abort_flag@90 (=> (and (= $abort_code@105 $abort_code@104) (= (ControlFlow 0 323664) 323670)) inline$$Roles_can_hold_balance_$def$1$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon23_Then_correct  (=> $abort_flag@84 (=> (and (= $abort_code@105 $abort_code@98) (= (ControlFlow 0 323734) 323670)) inline$$Roles_can_hold_balance_$def$1$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon20_Then_correct  (=> $abort_flag@79 (=> (and (= $abort_code@105 $abort_code@93) (= (ControlFlow 0 323798) 323670)) inline$$Roles_can_hold_balance_$def$1$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon18_correct  (=> (= inline$$Roles_can_hold_balance_$def$1$$ret0@2 |inline$$Roles_can_hold_balance_$def$1$tmp#$2@1|) (=> (and (= $abort_code@107 $abort_code@106) (= $abort_flag@92 $abort_flag@91)) (and (=> (= (ControlFlow 0 323652) 325023) inline$$DiemAccount_add_currency_$def$1$anon38_Then_correct) (=> (= (ControlFlow 0 323652) 323832) inline$$DiemAccount_add_currency_$def$1$anon38_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 323650) 323652)) inline$$Roles_can_hold_balance_$def$1$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon27_Then_correct  (=> (= (ControlFlow 0 323660) 323652) inline$$Roles_can_hold_balance_$def$1$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon14_correct  (=> (= |inline$$Roles_can_hold_balance_$def$1$tmp#$2@1| inline$$Roles_can_hold_balance_$def$1$$t6@1) (=> (and (= $abort_code@106 $abort_code@99) (= $abort_flag@91 $abort_flag@85)) (and (=> (= (ControlFlow 0 323722) 323660) inline$$Roles_can_hold_balance_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 323722) 323650) inline$$Roles_can_hold_balance_$def$1$anon27_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 323720) 323722)) inline$$Roles_can_hold_balance_$def$1$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon25_Then_correct  (=> (= (ControlFlow 0 323730) 323722) inline$$Roles_can_hold_balance_$def$1$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon24_Then_correct  (=> (and (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1|) (= inline$$Roles_can_hold_balance_$def$1$$t6@1 ($Boolean true))) (and (=> (= (ControlFlow 0 323712) 323730) inline$$Roles_can_hold_balance_$def$1$anon25_Then_correct) (=> (= (ControlFlow 0 323712) 323720) inline$$Roles_can_hold_balance_$def$1$anon25_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon26_Else_correct  (=> (and (and (not $abort_flag@90) (= |inline$$Roles_can_hold_balance_$def$1$tmp#$2@1| inline$$Roles_has_designated_dealer_role_$def$1$$ret0@2)) (and (= $abort_code@106 $abort_code@104) (= $abort_flag@91 $abort_flag@90))) (and (=> (= (ControlFlow 0 323640) 323660) inline$$Roles_can_hold_balance_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 323640) 323650) inline$$Roles_can_hold_balance_$def$1$anon27_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon6_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$1$$ret0@2 inline$$Roles_has_role_$def$5$$ret0@2) (= $abort_flag@90 $abort_flag@89)) (and (=> (= (ControlFlow 0 323594) 323664) inline$$Roles_can_hold_balance_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 323594) 323640) inline$$Roles_can_hold_balance_$def$1$anon26_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 323592) 323594)) inline$$Roles_has_designated_dealer_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 323602) 323594) inline$$Roles_has_designated_dealer_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon8_Else_correct  (=> (not $abort_flag@89) (and (=> (= (ControlFlow 0 323586) 323602) inline$$Roles_has_designated_dealer_role_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 323586) 323592) inline$$Roles_has_designated_dealer_role_$def$1$anon9_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon8_Then_correct  (=> (and (and $abort_flag@89 (= inline$$Roles_has_designated_dealer_role_$def$1$$ret0@1 $Error)) (and (= inline$$Roles_has_designated_dealer_role_$def$1$$ret0@2 inline$$Roles_has_designated_dealer_role_$def$1$$ret0@1) (= $abort_flag@90 true))) (and (=> (= (ControlFlow 0 323610) 323664) inline$$Roles_can_hold_balance_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 323610) 323640) inline$$Roles_can_hold_balance_$def$1$anon26_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$5$$ret0@1 $Error) (= $abort_flag@89 true)) (and (= $abort_code@104 $abort_code@103) (= inline$$Roles_has_role_$def$5$$ret0@2 inline$$Roles_has_role_$def$5$$ret0@1))) (and (=> (= (ControlFlow 0 323518) 323610) inline$$Roles_has_designated_dealer_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 323518) 323586) inline$$Roles_has_designated_dealer_role_$def$1$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon7_correct  (=> (and (= $abort_code@103 $abort_code@100) (= (ControlFlow 0 323538) 323518)) inline$$Roles_has_role_$def$5$Abort_correct)))
(let ((inline$$Roles_has_role_$def$5$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 323536) 323538)) inline$$Roles_has_role_$def$5$anon7_correct)))
(let ((inline$$Roles_has_role_$def$5$anon24_Then_correct  (=> (= (ControlFlow 0 323546) 323538) inline$$Roles_has_role_$def$5$anon7_correct)))
(let ((inline$$Roles_has_role_$def$5$anon23_Then_correct  (=> $abort_flag@86 (and (=> (= (ControlFlow 0 323530) 323546) inline$$Roles_has_role_$def$5$anon24_Then_correct) (=> (= (ControlFlow 0 323530) 323536) inline$$Roles_has_role_$def$5$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon13_correct  (=> (and (= $abort_code@103 $abort_code@101) (= (ControlFlow 0 323512) 323518)) inline$$Roles_has_role_$def$5$Abort_correct)))
(let ((inline$$Roles_has_role_$def$5$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 323510) 323512)) inline$$Roles_has_role_$def$5$anon13_correct)))
(let ((inline$$Roles_has_role_$def$5$anon27_Then_correct  (=> (= (ControlFlow 0 323526) 323512) inline$$Roles_has_role_$def$5$anon13_correct)))
(let ((inline$$Roles_has_role_$def$5$anon26_Then_correct  (=> $abort_flag@87 (and (=> (= (ControlFlow 0 323504) 323526) inline$$Roles_has_role_$def$5$anon27_Then_correct) (=> (= (ControlFlow 0 323504) 323510) inline$$Roles_has_role_$def$5$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon20_correct  (=> (= $abort_flag@89 $abort_flag@88) (=> (and (= $abort_code@104 $abort_code@102) (= inline$$Roles_has_role_$def$5$$ret0@2 |inline$$Roles_has_role_$def$5$tmp#$3@2|)) (and (=> (= (ControlFlow 0 323225) 323610) inline$$Roles_has_designated_dealer_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 323225) 323586) inline$$Roles_has_designated_dealer_role_$def$1$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$5$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 323223) 323225)) inline$$Roles_has_role_$def$5$anon20_correct)))
(let ((inline$$Roles_has_role_$def$5$anon30_Then_correct  (=> (= (ControlFlow 0 323233) 323225) inline$$Roles_has_role_$def$5$anon20_correct)))
(let ((inline$$Roles_has_role_$def$5$anon16_correct  (=> (= $abort_flag@88 $abort_flag@87) (=> (and (= |inline$$Roles_has_role_$def$5$tmp#$3@2| |inline$$Roles_has_role_$def$5$tmp#$3@1|) (= $abort_code@102 $abort_code@101)) (and (=> (= (ControlFlow 0 323492) 323233) inline$$Roles_has_role_$def$5$anon30_Then_correct) (=> (= (ControlFlow 0 323492) 323223) inline$$Roles_has_role_$def$5$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$5$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 323490) 323492)) inline$$Roles_has_role_$def$5$anon16_correct)))
(let ((inline$$Roles_has_role_$def$5$anon28_Then_correct  (=> (= (ControlFlow 0 323500) 323492) inline$$Roles_has_role_$def$5$anon16_correct)))
(let ((inline$$Roles_has_role_$def$5$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$5$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$5$dst@1 inline$$Roles_has_designated_dealer_role_$def$1$$t2@1))) (and (=> (= (ControlFlow 0 323484) 323500) inline$$Roles_has_role_$def$5$anon28_Then_correct) (=> (= (ControlFlow 0 323484) 323490) inline$$Roles_has_role_$def$5$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$5$anon0_correct  (=> (and (= inline$$GetFieldFromValue$5$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$5$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 323468) 323484)) inline$$Roles_has_role_$def$5$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$5$anon26_Else_correct  (=> (and (not $abort_flag@87) (= (ControlFlow 0 323474) 323468)) inline$$GetFieldFromValue$5$anon0_correct)))
(let ((inline$$GetGlobal$5$anon3_Then$1_correct  (=> (= $abort_code@101 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@87 true) (= inline$$GetGlobal$5$dst@2 inline$$GetGlobal$5$dst@0)) (and (=> (= (ControlFlow 0 323414) 323504) inline$$Roles_has_role_$def$5$anon26_Then_correct) (=> (= (ControlFlow 0 323414) 323474) inline$$Roles_has_role_$def$5$anon26_Else_correct))))))
(let ((inline$$GetGlobal$5$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$5$a@1)) (= (ControlFlow 0 323412) 323414)) inline$$GetGlobal$5$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$5$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$5$a@1) (=> (and (and (= inline$$GetGlobal$5$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@2))) (= $abort_code@101 $abort_code@100)) (and (= $abort_flag@87 $abort_flag@86) (= inline$$GetGlobal$5$dst@2 inline$$GetGlobal$5$dst@1))) (and (=> (= (ControlFlow 0 323360) 323504) inline$$Roles_has_role_$def$5$anon26_Then_correct) (=> (= (ControlFlow 0 323360) 323474) inline$$Roles_has_role_$def$5$anon26_Else_correct))))))
(let ((inline$$GetGlobal$5$anon0_correct  (=> (= inline$$GetGlobal$5$a@1 (|a#$Address| call3formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 323342) 323412) inline$$GetGlobal$5$anon3_Then_correct) (=> (= (ControlFlow 0 323342) 323360) inline$$GetGlobal$5$anon3_Else_correct)))))
(let ((inline$$GetGlobal$5$Entry_correct  (and (=> (= (ControlFlow 0 323336) (- 0 359300)) true) (=> (= (ControlFlow 0 323336) 323342) inline$$GetGlobal$5$anon0_correct))))
(let ((inline$$Roles_has_role_$def$5$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$5$$t6@1) (= (ControlFlow 0 323420) 323336)) inline$$GetGlobal$5$Entry_correct)))
(let ((inline$$Roles_has_role_$def$5$anon18_correct  (=> (= $abort_flag@88 $abort_flag@86) (=> (and (= |inline$$Roles_has_role_$def$5$tmp#$3@2| inline$$Roles_has_role_$def$5$$t9@1) (= $abort_code@102 $abort_code@100)) (and (=> (= (ControlFlow 0 323213) 323233) inline$$Roles_has_role_$def$5$anon30_Then_correct) (=> (= (ControlFlow 0 323213) 323223) inline$$Roles_has_role_$def$5$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$5$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 323211) 323213)) inline$$Roles_has_role_$def$5$anon18_correct)))
(let ((inline$$Roles_has_role_$def$5$anon29_Then_correct  (=> (= (ControlFlow 0 323241) 323213) inline$$Roles_has_role_$def$5$anon18_correct)))
(let ((inline$$Roles_has_role_$def$5$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$5$$t6@1)) (= inline$$Roles_has_role_$def$5$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 323203) 323241) inline$$Roles_has_role_$def$5$anon29_Then_correct) (=> (= (ControlFlow 0 323203) 323211) inline$$Roles_has_role_$def$5$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon23_Else_correct  (=> (and (not $abort_flag@86) (= inline$$Roles_has_role_$def$5$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@2))))) (and (=> (= (ControlFlow 0 323159) 323420) inline$$Roles_has_role_$def$5$anon25_Then_correct) (=> (= (ControlFlow 0 323159) 323203) inline$$Roles_has_role_$def$5$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@86) (=> $abort_flag@86 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@86) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 323145) 323530) inline$$Roles_has_role_$def$5$anon23_Then_correct) (=> (= (ControlFlow 0 323145) 323159) inline$$Roles_has_role_$def$5$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 323075) 323145)) inline$$Roles_has_role_$def$5$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$5$anon22_Then_correct  (=> (= (ControlFlow 0 323554) 323145) inline$$Roles_has_role_$def$5$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$5$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 323067) 323554) inline$$Roles_has_role_$def$5$anon22_Then_correct) (=> (= (ControlFlow 0 323067) 323075) inline$$Roles_has_role_$def$5$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$5$anon21_Then_correct  (and (=> (= (ControlFlow 0 323562) 323554) inline$$Roles_has_role_$def$5$anon22_Then_correct) (=> (= (ControlFlow 0 323562) 323075) inline$$Roles_has_role_$def$5$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$5$anon0_correct  (=> (not $abort_flag@85) (and (=> (= (ControlFlow 0 323061) 323562) inline$$Roles_has_role_$def$5$anon21_Then_correct) (=> (= (ControlFlow 0 323061) 323067) inline$$Roles_has_role_$def$5$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$5$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_designated_dealer_role_$def$1$$t2@1) (>= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$1$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$1$$t2@1) $MAX_U64)) (= (ControlFlow 0 323568) 323061)) inline$$Roles_has_role_$def$5$anon0_correct))))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon2$1_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$1$$t2@1 ($Integer 2)) (= (ControlFlow 0 323576) 323568)) inline$$Roles_has_role$5$anon0_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 322588) 323576)) inline$$Roles_has_designated_dealer_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon7_Then_correct  (=> (= (ControlFlow 0 323618) 323576) inline$$Roles_has_designated_dealer_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$1$anon0_correct  (=> (not $abort_flag@85) (and (=> (= (ControlFlow 0 322582) 323618) inline$$Roles_has_designated_dealer_role_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 322582) 322588) inline$$Roles_has_designated_dealer_role_$def$1$anon7_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role$1$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 323624) 322582)) inline$$Roles_has_designated_dealer_role_$def$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon24_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1|)) (= (ControlFlow 0 323632) 323624)) inline$$Roles_has_designated_dealer_role$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon8_correct  (=> (= |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1| inline$$Roles_can_hold_balance_$def$1$$t5@1) (=> (and (= $abort_flag@85 $abort_flag@79) (= $abort_code@99 $abort_code@93)) (and (=> (= (ControlFlow 0 323786) 323712) inline$$Roles_can_hold_balance_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 323786) 323632) inline$$Roles_can_hold_balance_$def$1$anon24_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 323784) 323786)) inline$$Roles_can_hold_balance_$def$1$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon22_Then_correct  (=> (= (ControlFlow 0 323794) 323786) inline$$Roles_can_hold_balance_$def$1$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2) (= inline$$Roles_can_hold_balance_$def$1$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 323776) 323794) inline$$Roles_can_hold_balance_$def$1$anon22_Then_correct) (=> (= (ControlFlow 0 323776) 323784) inline$$Roles_can_hold_balance_$def$1$anon22_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$1$anon23_Else_correct  (=> (and (and (not $abort_flag@84) (= |inline$$Roles_can_hold_balance_$def$1$tmp#$1@1| inline$$Roles_has_child_VASP_role_$def$1$$ret0@2)) (and (= $abort_flag@85 $abort_flag@84) (= $abort_code@99 $abort_code@98))) (and (=> (= (ControlFlow 0 322380) 323712) inline$$Roles_can_hold_balance_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 322380) 323632) inline$$Roles_can_hold_balance_$def$1$anon24_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon6_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$1$$ret0@2 inline$$Roles_has_role_$def$4$$ret0@2) (= $abort_flag@84 $abort_flag@83)) (and (=> (= (ControlFlow 0 322334) 323734) inline$$Roles_can_hold_balance_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 322334) 322380) inline$$Roles_can_hold_balance_$def$1$anon23_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 322332) 322334)) inline$$Roles_has_child_VASP_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 322342) 322334) inline$$Roles_has_child_VASP_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon8_Else_correct  (=> (not $abort_flag@83) (and (=> (= (ControlFlow 0 322326) 322342) inline$$Roles_has_child_VASP_role_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 322326) 322332) inline$$Roles_has_child_VASP_role_$def$1$anon9_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon8_Then_correct  (=> (and (and $abort_flag@83 (= inline$$Roles_has_child_VASP_role_$def$1$$ret0@1 $Error)) (and (= inline$$Roles_has_child_VASP_role_$def$1$$ret0@2 inline$$Roles_has_child_VASP_role_$def$1$$ret0@1) (= $abort_flag@84 true))) (and (=> (= (ControlFlow 0 322350) 323734) inline$$Roles_can_hold_balance_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 322350) 322380) inline$$Roles_can_hold_balance_$def$1$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$4$$ret0@1 $Error) (= $abort_flag@83 true)) (and (= $abort_code@98 $abort_code@97) (= inline$$Roles_has_role_$def$4$$ret0@2 inline$$Roles_has_role_$def$4$$ret0@1))) (and (=> (= (ControlFlow 0 322258) 322350) inline$$Roles_has_child_VASP_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 322258) 322326) inline$$Roles_has_child_VASP_role_$def$1$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon7_correct  (=> (and (= $abort_code@97 $abort_code@94) (= (ControlFlow 0 322278) 322258)) inline$$Roles_has_role_$def$4$Abort_correct)))
(let ((inline$$Roles_has_role_$def$4$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 322276) 322278)) inline$$Roles_has_role_$def$4$anon7_correct)))
(let ((inline$$Roles_has_role_$def$4$anon24_Then_correct  (=> (= (ControlFlow 0 322286) 322278) inline$$Roles_has_role_$def$4$anon7_correct)))
(let ((inline$$Roles_has_role_$def$4$anon23_Then_correct  (=> $abort_flag@80 (and (=> (= (ControlFlow 0 322270) 322286) inline$$Roles_has_role_$def$4$anon24_Then_correct) (=> (= (ControlFlow 0 322270) 322276) inline$$Roles_has_role_$def$4$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon13_correct  (=> (and (= $abort_code@97 $abort_code@95) (= (ControlFlow 0 322252) 322258)) inline$$Roles_has_role_$def$4$Abort_correct)))
(let ((inline$$Roles_has_role_$def$4$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 322250) 322252)) inline$$Roles_has_role_$def$4$anon13_correct)))
(let ((inline$$Roles_has_role_$def$4$anon27_Then_correct  (=> (= (ControlFlow 0 322266) 322252) inline$$Roles_has_role_$def$4$anon13_correct)))
(let ((inline$$Roles_has_role_$def$4$anon26_Then_correct  (=> $abort_flag@81 (and (=> (= (ControlFlow 0 322244) 322266) inline$$Roles_has_role_$def$4$anon27_Then_correct) (=> (= (ControlFlow 0 322244) 322250) inline$$Roles_has_role_$def$4$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon20_correct  (=> (= $abort_flag@83 $abort_flag@82) (=> (and (= $abort_code@98 $abort_code@96) (= inline$$Roles_has_role_$def$4$$ret0@2 |inline$$Roles_has_role_$def$4$tmp#$3@2|)) (and (=> (= (ControlFlow 0 321965) 322350) inline$$Roles_has_child_VASP_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 321965) 322326) inline$$Roles_has_child_VASP_role_$def$1$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$4$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 321963) 321965)) inline$$Roles_has_role_$def$4$anon20_correct)))
(let ((inline$$Roles_has_role_$def$4$anon30_Then_correct  (=> (= (ControlFlow 0 321973) 321965) inline$$Roles_has_role_$def$4$anon20_correct)))
(let ((inline$$Roles_has_role_$def$4$anon16_correct  (=> (= $abort_code@96 $abort_code@95) (=> (and (= |inline$$Roles_has_role_$def$4$tmp#$3@2| |inline$$Roles_has_role_$def$4$tmp#$3@1|) (= $abort_flag@82 $abort_flag@81)) (and (=> (= (ControlFlow 0 322232) 321973) inline$$Roles_has_role_$def$4$anon30_Then_correct) (=> (= (ControlFlow 0 322232) 321963) inline$$Roles_has_role_$def$4$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$4$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 322230) 322232)) inline$$Roles_has_role_$def$4$anon16_correct)))
(let ((inline$$Roles_has_role_$def$4$anon28_Then_correct  (=> (= (ControlFlow 0 322240) 322232) inline$$Roles_has_role_$def$4$anon16_correct)))
(let ((inline$$Roles_has_role_$def$4$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$4$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$4$dst@1 inline$$Roles_has_child_VASP_role_$def$1$$t2@1))) (and (=> (= (ControlFlow 0 322224) 322240) inline$$Roles_has_role_$def$4$anon28_Then_correct) (=> (= (ControlFlow 0 322224) 322230) inline$$Roles_has_role_$def$4$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$4$anon0_correct  (=> (and (= inline$$GetFieldFromValue$4$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$4$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 322208) 322224)) inline$$Roles_has_role_$def$4$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$4$anon26_Else_correct  (=> (and (not $abort_flag@81) (= (ControlFlow 0 322214) 322208)) inline$$GetFieldFromValue$4$anon0_correct)))
(let ((inline$$GetGlobal$4$anon3_Then$1_correct  (=> (= $abort_flag@81 true) (=> (and (= $abort_code@95 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$4$dst@2 inline$$GetGlobal$4$dst@0)) (and (=> (= (ControlFlow 0 322154) 322244) inline$$Roles_has_role_$def$4$anon26_Then_correct) (=> (= (ControlFlow 0 322154) 322214) inline$$Roles_has_role_$def$4$anon26_Else_correct))))))
(let ((inline$$GetGlobal$4$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$4$a@1)) (= (ControlFlow 0 322152) 322154)) inline$$GetGlobal$4$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$4$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$4$a@1) (=> (and (and (= inline$$GetGlobal$4$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@3))) (= $abort_flag@81 $abort_flag@80)) (and (= $abort_code@95 $abort_code@94) (= inline$$GetGlobal$4$dst@2 inline$$GetGlobal$4$dst@1))) (and (=> (= (ControlFlow 0 322100) 322244) inline$$Roles_has_role_$def$4$anon26_Then_correct) (=> (= (ControlFlow 0 322100) 322214) inline$$Roles_has_role_$def$4$anon26_Else_correct))))))
(let ((inline$$GetGlobal$4$anon0_correct  (=> (= inline$$GetGlobal$4$a@1 (|a#$Address| call3formal@$ret0@0@@3)) (and (=> (= (ControlFlow 0 322082) 322152) inline$$GetGlobal$4$anon3_Then_correct) (=> (= (ControlFlow 0 322082) 322100) inline$$GetGlobal$4$anon3_Else_correct)))))
(let ((inline$$GetGlobal$4$Entry_correct  (and (=> (= (ControlFlow 0 322076) (- 0 358657)) true) (=> (= (ControlFlow 0 322076) 322082) inline$$GetGlobal$4$anon0_correct))))
(let ((inline$$Roles_has_role_$def$4$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$4$$t6@1) (= (ControlFlow 0 322160) 322076)) inline$$GetGlobal$4$Entry_correct)))
(let ((inline$$Roles_has_role_$def$4$anon18_correct  (=> (= $abort_code@96 $abort_code@94) (=> (and (= |inline$$Roles_has_role_$def$4$tmp#$3@2| inline$$Roles_has_role_$def$4$$t9@1) (= $abort_flag@82 $abort_flag@80)) (and (=> (= (ControlFlow 0 321953) 321973) inline$$Roles_has_role_$def$4$anon30_Then_correct) (=> (= (ControlFlow 0 321953) 321963) inline$$Roles_has_role_$def$4$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$4$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 321951) 321953)) inline$$Roles_has_role_$def$4$anon18_correct)))
(let ((inline$$Roles_has_role_$def$4$anon29_Then_correct  (=> (= (ControlFlow 0 321981) 321953) inline$$Roles_has_role_$def$4$anon18_correct)))
(let ((inline$$Roles_has_role_$def$4$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$4$$t6@1)) (= inline$$Roles_has_role_$def$4$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 321943) 321981) inline$$Roles_has_role_$def$4$anon29_Then_correct) (=> (= (ControlFlow 0 321943) 321951) inline$$Roles_has_role_$def$4$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon23_Else_correct  (=> (and (not $abort_flag@80) (= inline$$Roles_has_role_$def$4$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@3))))) (and (=> (= (ControlFlow 0 321899) 322160) inline$$Roles_has_role_$def$4$anon25_Then_correct) (=> (= (ControlFlow 0 321899) 321943) inline$$Roles_has_role_$def$4$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@80) (=> $abort_flag@80 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@80) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 321885) 322270) inline$$Roles_has_role_$def$4$anon23_Then_correct) (=> (= (ControlFlow 0 321885) 321899) inline$$Roles_has_role_$def$4$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 321815) 321885)) inline$$Roles_has_role_$def$4$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$4$anon22_Then_correct  (=> (= (ControlFlow 0 322294) 321885) inline$$Roles_has_role_$def$4$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$4$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 321807) 322294) inline$$Roles_has_role_$def$4$anon22_Then_correct) (=> (= (ControlFlow 0 321807) 321815) inline$$Roles_has_role_$def$4$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$4$anon21_Then_correct  (and (=> (= (ControlFlow 0 322302) 322294) inline$$Roles_has_role_$def$4$anon22_Then_correct) (=> (= (ControlFlow 0 322302) 321815) inline$$Roles_has_role_$def$4$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$4$anon0_correct  (=> (not $abort_flag@79) (and (=> (= (ControlFlow 0 321801) 322302) inline$$Roles_has_role_$def$4$anon21_Then_correct) (=> (= (ControlFlow 0 321801) 321807) inline$$Roles_has_role_$def$4$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$4$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_child_VASP_role_$def$1$$t2@1) (>= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$1$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$1$$t2@1) $MAX_U64)) (= (ControlFlow 0 322308) 321801)) inline$$Roles_has_role_$def$4$anon0_correct))))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon2$1_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$1$$t2@1 ($Integer 6)) (= (ControlFlow 0 322316) 322308)) inline$$Roles_has_role$4$anon0_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 321328) 322316)) inline$$Roles_has_child_VASP_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon7_Then_correct  (=> (= (ControlFlow 0 322358) 322316) inline$$Roles_has_child_VASP_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$1$anon0_correct  (=> (not $abort_flag@79) (and (=> (= (ControlFlow 0 321322) 322358) inline$$Roles_has_child_VASP_role_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 321322) 321328) inline$$Roles_has_child_VASP_role_$def$1$anon7_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role$1$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 322364) 321322)) inline$$Roles_has_child_VASP_role_$def$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2)) (= (ControlFlow 0 322372) 322364)) inline$$Roles_has_child_VASP_role$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon20_Else_correct  (=> (not $abort_flag@79) (and (=> (= (ControlFlow 0 321122) 323776) inline$$Roles_can_hold_balance_$def$1$anon21_Then_correct) (=> (= (ControlFlow 0 321122) 322372) inline$$Roles_can_hold_balance_$def$1$anon21_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon6_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2 inline$$Roles_has_role_$def$3$$ret0@2) (= $abort_flag@79 $abort_flag@78)) (and (=> (= (ControlFlow 0 321076) 323798) inline$$Roles_can_hold_balance_$def$1$anon20_Then_correct) (=> (= (ControlFlow 0 321076) 321122) inline$$Roles_can_hold_balance_$def$1$anon20_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 321074) 321076)) inline$$Roles_has_parent_VASP_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon9_Then_correct  (=> (= (ControlFlow 0 321084) 321076) inline$$Roles_has_parent_VASP_role_$def$1$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon8_Else_correct  (=> (not $abort_flag@78) (and (=> (= (ControlFlow 0 321068) 321084) inline$$Roles_has_parent_VASP_role_$def$1$anon9_Then_correct) (=> (= (ControlFlow 0 321068) 321074) inline$$Roles_has_parent_VASP_role_$def$1$anon9_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon8_Then_correct  (=> (and (and $abort_flag@78 (= inline$$Roles_has_parent_VASP_role_$def$1$$ret0@1 $Error)) (and (= inline$$Roles_has_parent_VASP_role_$def$1$$ret0@2 inline$$Roles_has_parent_VASP_role_$def$1$$ret0@1) (= $abort_flag@79 true))) (and (=> (= (ControlFlow 0 321092) 323798) inline$$Roles_can_hold_balance_$def$1$anon20_Then_correct) (=> (= (ControlFlow 0 321092) 321122) inline$$Roles_can_hold_balance_$def$1$anon20_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$3$$ret0@1 $Error) (= $abort_flag@78 true)) (and (= $abort_code@93 $abort_code@92) (= inline$$Roles_has_role_$def$3$$ret0@2 inline$$Roles_has_role_$def$3$$ret0@1))) (and (=> (= (ControlFlow 0 321000) 321092) inline$$Roles_has_parent_VASP_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 321000) 321068) inline$$Roles_has_parent_VASP_role_$def$1$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon7_correct  (=> (and (= $abort_code@92 $abort_code@89) (= (ControlFlow 0 321020) 321000)) inline$$Roles_has_role_$def$3$Abort_correct)))
(let ((inline$$Roles_has_role_$def$3$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 321018) 321020)) inline$$Roles_has_role_$def$3$anon7_correct)))
(let ((inline$$Roles_has_role_$def$3$anon24_Then_correct  (=> (= (ControlFlow 0 321028) 321020) inline$$Roles_has_role_$def$3$anon7_correct)))
(let ((inline$$Roles_has_role_$def$3$anon23_Then_correct  (=> $abort_flag@75 (and (=> (= (ControlFlow 0 321012) 321028) inline$$Roles_has_role_$def$3$anon24_Then_correct) (=> (= (ControlFlow 0 321012) 321018) inline$$Roles_has_role_$def$3$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon13_correct  (=> (and (= $abort_code@92 $abort_code@90) (= (ControlFlow 0 320994) 321000)) inline$$Roles_has_role_$def$3$Abort_correct)))
(let ((inline$$Roles_has_role_$def$3$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 320992) 320994)) inline$$Roles_has_role_$def$3$anon13_correct)))
(let ((inline$$Roles_has_role_$def$3$anon27_Then_correct  (=> (= (ControlFlow 0 321008) 320994) inline$$Roles_has_role_$def$3$anon13_correct)))
(let ((inline$$Roles_has_role_$def$3$anon26_Then_correct  (=> $abort_flag@76 (and (=> (= (ControlFlow 0 320986) 321008) inline$$Roles_has_role_$def$3$anon27_Then_correct) (=> (= (ControlFlow 0 320986) 320992) inline$$Roles_has_role_$def$3$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon20_correct  (=> (= $abort_flag@78 $abort_flag@77) (=> (and (= $abort_code@93 $abort_code@91) (= inline$$Roles_has_role_$def$3$$ret0@2 |inline$$Roles_has_role_$def$3$tmp#$3@2|)) (and (=> (= (ControlFlow 0 320707) 321092) inline$$Roles_has_parent_VASP_role_$def$1$anon8_Then_correct) (=> (= (ControlFlow 0 320707) 321068) inline$$Roles_has_parent_VASP_role_$def$1$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$3$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 320705) 320707)) inline$$Roles_has_role_$def$3$anon20_correct)))
(let ((inline$$Roles_has_role_$def$3$anon30_Then_correct  (=> (= (ControlFlow 0 320715) 320707) inline$$Roles_has_role_$def$3$anon20_correct)))
(let ((inline$$Roles_has_role_$def$3$anon16_correct  (=> (= $abort_flag@77 $abort_flag@76) (=> (and (= |inline$$Roles_has_role_$def$3$tmp#$3@2| |inline$$Roles_has_role_$def$3$tmp#$3@1|) (= $abort_code@91 $abort_code@90)) (and (=> (= (ControlFlow 0 320974) 320715) inline$$Roles_has_role_$def$3$anon30_Then_correct) (=> (= (ControlFlow 0 320974) 320705) inline$$Roles_has_role_$def$3$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$3$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 320972) 320974)) inline$$Roles_has_role_$def$3$anon16_correct)))
(let ((inline$$Roles_has_role_$def$3$anon28_Then_correct  (=> (= (ControlFlow 0 320982) 320974) inline$$Roles_has_role_$def$3$anon16_correct)))
(let ((inline$$Roles_has_role_$def$3$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$3$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$3$dst@1 inline$$Roles_has_parent_VASP_role_$def$1$$t2@1))) (and (=> (= (ControlFlow 0 320966) 320982) inline$$Roles_has_role_$def$3$anon28_Then_correct) (=> (= (ControlFlow 0 320966) 320972) inline$$Roles_has_role_$def$3$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$3$anon0_correct  (=> (and (= inline$$GetFieldFromValue$3$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$3$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 320950) 320966)) inline$$Roles_has_role_$def$3$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$3$anon26_Else_correct  (=> (and (not $abort_flag@76) (= (ControlFlow 0 320956) 320950)) inline$$GetFieldFromValue$3$anon0_correct)))
(let ((inline$$GetGlobal$3$anon3_Then$1_correct  (=> (= $abort_code@90 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@76 true) (= inline$$GetGlobal$3$dst@2 inline$$GetGlobal$3$dst@0)) (and (=> (= (ControlFlow 0 320896) 320986) inline$$Roles_has_role_$def$3$anon26_Then_correct) (=> (= (ControlFlow 0 320896) 320956) inline$$Roles_has_role_$def$3$anon26_Else_correct))))))
(let ((inline$$GetGlobal$3$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$3$a@1)) (= (ControlFlow 0 320894) 320896)) inline$$GetGlobal$3$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$3$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$3$a@1) (=> (and (and (= inline$$GetGlobal$3$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4))) (= $abort_code@90 $abort_code@89)) (and (= $abort_flag@76 $abort_flag@75) (= inline$$GetGlobal$3$dst@2 inline$$GetGlobal$3$dst@1))) (and (=> (= (ControlFlow 0 320842) 320986) inline$$Roles_has_role_$def$3$anon26_Then_correct) (=> (= (ControlFlow 0 320842) 320956) inline$$Roles_has_role_$def$3$anon26_Else_correct))))))
(let ((inline$$GetGlobal$3$anon0_correct  (=> (= inline$$GetGlobal$3$a@1 (|a#$Address| call3formal@$ret0@0@@4)) (and (=> (= (ControlFlow 0 320824) 320894) inline$$GetGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 320824) 320842) inline$$GetGlobal$3$anon3_Else_correct)))))
(let ((inline$$GetGlobal$3$Entry_correct  (and (=> (= (ControlFlow 0 320818) (- 0 358061)) true) (=> (= (ControlFlow 0 320818) 320824) inline$$GetGlobal$3$anon0_correct))))
(let ((inline$$Roles_has_role_$def$3$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$3$$t6@1) (= (ControlFlow 0 320902) 320818)) inline$$GetGlobal$3$Entry_correct)))
(let ((inline$$Roles_has_role_$def$3$anon18_correct  (=> (= $abort_flag@77 $abort_flag@75) (=> (and (= |inline$$Roles_has_role_$def$3$tmp#$3@2| inline$$Roles_has_role_$def$3$$t9@1) (= $abort_code@91 $abort_code@89)) (and (=> (= (ControlFlow 0 320695) 320715) inline$$Roles_has_role_$def$3$anon30_Then_correct) (=> (= (ControlFlow 0 320695) 320705) inline$$Roles_has_role_$def$3$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$3$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 320693) 320695)) inline$$Roles_has_role_$def$3$anon18_correct)))
(let ((inline$$Roles_has_role_$def$3$anon29_Then_correct  (=> (= (ControlFlow 0 320723) 320695) inline$$Roles_has_role_$def$3$anon18_correct)))
(let ((inline$$Roles_has_role_$def$3$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$3$$t6@1)) (= inline$$Roles_has_role_$def$3$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 320685) 320723) inline$$Roles_has_role_$def$3$anon29_Then_correct) (=> (= (ControlFlow 0 320685) 320693) inline$$Roles_has_role_$def$3$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon23_Else_correct  (=> (and (not $abort_flag@75) (= inline$$Roles_has_role_$def$3$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4))))) (and (=> (= (ControlFlow 0 320641) 320902) inline$$Roles_has_role_$def$3$anon25_Then_correct) (=> (= (ControlFlow 0 320641) 320685) inline$$Roles_has_role_$def$3$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@75) (=> $abort_flag@75 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@75) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 320627) 321012) inline$$Roles_has_role_$def$3$anon23_Then_correct) (=> (= (ControlFlow 0 320627) 320641) inline$$Roles_has_role_$def$3$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 320557) 320627)) inline$$Roles_has_role_$def$3$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$3$anon22_Then_correct  (=> (= (ControlFlow 0 321036) 320627) inline$$Roles_has_role_$def$3$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$3$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 320549) 321036) inline$$Roles_has_role_$def$3$anon22_Then_correct) (=> (= (ControlFlow 0 320549) 320557) inline$$Roles_has_role_$def$3$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$3$anon21_Then_correct  (and (=> (= (ControlFlow 0 321044) 321036) inline$$Roles_has_role_$def$3$anon22_Then_correct) (=> (= (ControlFlow 0 321044) 320557) inline$$Roles_has_role_$def$3$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$3$anon0_correct  (=> (not $abort_flag@74) (and (=> (= (ControlFlow 0 320543) 321044) inline$$Roles_has_role_$def$3$anon21_Then_correct) (=> (= (ControlFlow 0 320543) 320549) inline$$Roles_has_role_$def$3$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$3$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_parent_VASP_role_$def$1$$t2@1) (>= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$1$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$1$$t2@1) $MAX_U64)) (= (ControlFlow 0 321050) 320543)) inline$$Roles_has_role_$def$3$anon0_correct))))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon2$1_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$1$$t2@1 ($Integer 5)) (= (ControlFlow 0 321058) 321050)) inline$$Roles_has_role$3$anon0_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 320070) 321058)) inline$$Roles_has_parent_VASP_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon7_Then_correct  (=> (= (ControlFlow 0 321100) 321058) inline$$Roles_has_parent_VASP_role_$def$1$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$1$anon0_correct  (=> (not $abort_flag@74) (and (=> (= (ControlFlow 0 320064) 321100) inline$$Roles_has_parent_VASP_role_$def$1$anon7_Then_correct) (=> (= (ControlFlow 0 320064) 320070) inline$$Roles_has_parent_VASP_role_$def$1$anon7_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role$1$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 321106) 320064)) inline$$Roles_has_parent_VASP_role_$def$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 319836) 321106)) inline$$Roles_has_parent_VASP_role$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon19_Then_correct  (=> (= (ControlFlow 0 323806) 321106) inline$$Roles_has_parent_VASP_role$1$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$1$anon0_correct  (=> (not $abort_flag@74) (and (=> (= (ControlFlow 0 319830) 323806) inline$$Roles_can_hold_balance_$def$1$anon19_Then_correct) (=> (= (ControlFlow 0 319830) 319836) inline$$Roles_can_hold_balance_$def$1$anon19_Else_correct)))))
(let ((inline$$Roles_can_hold_balance$1$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 323812) 319830)) inline$$Roles_can_hold_balance_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon36_Else_correct  (=> (and (not $abort_flag@74) (= (ControlFlow 0 323820) 323812)) inline$$Roles_can_hold_balance$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@74) (=> (and (=> $abort_flag@74 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@74 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$1$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@88 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 319484) 325027) inline$$DiemAccount_add_currency_$def$1$anon36_Then_correct) (=> (= (ControlFlow 0 319484) 323820) inline$$DiemAccount_add_currency_$def$1$anon36_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$1$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 319448) 319484)) inline$$DiemAccount_add_currency_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon35_Then_correct  (=> (= (ControlFlow 0 325051) 319484) inline$$DiemAccount_add_currency_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$1$anon0_correct  (=> (not $abort_flag@73) (and (=> (= (ControlFlow 0 319442) 325051) inline$$DiemAccount_add_currency_$def$1$anon35_Then_correct) (=> (= (ControlFlow 0 319442) 319448) inline$$DiemAccount_add_currency_$def$1$anon35_Else_correct)))))
(let ((inline$$DiemAccount_add_currency$1$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 325055) 319442)) inline$$DiemAccount_add_currency_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currency$1$Entry_correct  (=> (and (= inline$$DiemAccount_add_currency$1$$tv0@0 $XDX_XDX_type_value) (= (ControlFlow 0 318886) 325055)) inline$$DiemAccount_add_currency$1$anon0_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon29_Then_correct  (=> (and (|b#$Boolean| inline$$Not$4$dst@1) (= (ControlFlow 0 325061) 318886)) inline$$DiemAccount_add_currency$1$Entry_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon29_Else_correct  (=> (not (|b#$Boolean| inline$$Not$4$dst@1)) (=> (and (and (= $DiemAccount_Balance_$memory@7 $DiemAccount_Balance_$memory@4) (= $abort_flag@100 $abort_flag@73)) (and (= $abort_code@117 $abort_code@87) (= (ControlFlow 0 318830) 318832))) inline$$DiemAccount_add_currencies_for_account_$def$0$L9_correct))))
(let ((inline$$Not$4$anon0_correct  (=> (= inline$$Not$4$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currencies_for_account_$def$0$$t7@1)))) (and (=> (= (ControlFlow 0 318814) 325061) inline$$DiemAccount_add_currencies_for_account_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 318814) 318830) inline$$DiemAccount_add_currencies_for_account_$def$0$anon29_Else_correct)))))
(let ((inline$$Not$4$Entry_correct  (and (=> (= (ControlFlow 0 318804) (- 0 357521)) true) (=> (= (ControlFlow 0 318804) 318814) inline$$Not$4$anon0_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$L5_correct  (=> (and (= inline$$DiemAccount_add_currencies_for_account_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| call3formal@$ret0@0@@5)))) (= (ControlFlow 0 318820) 318804)) inline$$Not$4$Entry_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Else_correct  (=> (not $abort_flag@72) (=> (and (and (= $DiemAccount_Balance_$memory@4 $DiemAccount_Balance_$memory@3) (= $abort_flag@73 $abort_flag@72)) (and (= $abort_code@87 $abort_code@86) (= (ControlFlow 0 331314) 318820))) inline$$DiemAccount_add_currencies_for_account_$def$0$L5_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon50_Else_correct  (=> (and (and (not $abort_flag@71) (= $DiemAccount_Balance_$memory@3 |inline$$MoveToRaw$4$m'@2|)) (and (= $abort_flag@72 $abort_flag@71) (= $abort_code@86 $abort_code@84))) (and (=> (= (ControlFlow 0 331180) 331318) inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 331180) 331314) inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$Abort_correct  (=> (= $DiemAccount_Balance_$memory@3 $DiemAccount_Balance_$memory@2) (=> (and (= $abort_flag@72 true) (= $abort_code@86 $abort_code@85)) (and (=> (= (ControlFlow 0 330107) 331318) inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 330107) 331314) inline$$DiemAccount_add_currencies_for_account_$def$0$anon28_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon5_correct  (=> (= $abort_code@85 $abort_code@58) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 331280) 330107)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 331278) 331280)) inline$$DiemAccount_add_currency_$def$2$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon37_Then_correct  (=> (= (ControlFlow 0 331288) 331280) inline$$DiemAccount_add_currency_$def$2$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon36_Then_correct  (=> $abort_flag@47 (and (=> (= (ControlFlow 0 331272) 331288) inline$$DiemAccount_add_currency_$def$2$anon37_Then_correct) (=> (= (ControlFlow 0 331272) 331278) inline$$DiemAccount_add_currency_$def$2$anon37_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon11_correct  (=> (= $abort_code@85 $abort_code@78) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 331256) 330107)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 331254) 331256)) inline$$DiemAccount_add_currency_$def$2$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon40_Then_correct  (=> (= (ControlFlow 0 331264) 331256) inline$$DiemAccount_add_currency_$def$2$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon39_Then_correct  (=> $abort_flag@66 (and (=> (= (ControlFlow 0 331248) 331264) inline$$DiemAccount_add_currency_$def$2$anon40_Then_correct) (=> (= (ControlFlow 0 331248) 331254) inline$$DiemAccount_add_currency_$def$2$anon40_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon19_correct  (=> (= $abort_code@85 $abort_code@79) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 331236) 330107)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 331234) 331236)) inline$$DiemAccount_add_currency_$def$2$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon44_Then_correct  (=> (= (ControlFlow 0 331244) 331236) inline$$DiemAccount_add_currency_$def$2$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon43_Then_correct  (=> $abort_flag@67 (and (=> (= (ControlFlow 0 331228) 331244) inline$$DiemAccount_add_currency_$def$2$anon44_Then_correct) (=> (= (ControlFlow 0 331228) 331234) inline$$DiemAccount_add_currency_$def$2$anon44_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon23_correct  (=> (= $abort_code@85 $abort_code@81) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 331216) 330107)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 331214) 331216)) inline$$DiemAccount_add_currency_$def$2$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon46_Then_correct  (=> (= (ControlFlow 0 331224) 331216) inline$$DiemAccount_add_currency_$def$2$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon45_Then_correct  (=> $abort_flag@68 (and (=> (= (ControlFlow 0 331208) 331224) inline$$DiemAccount_add_currency_$def$2$anon46_Then_correct) (=> (= (ControlFlow 0 331208) 331214) inline$$DiemAccount_add_currency_$def$2$anon46_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon33_correct  (=> (= $abort_code@85 $abort_code@84) (=> (and (= $DiemAccount_Balance_$memory@2 |inline$$MoveToRaw$4$m'@2|) (= (ControlFlow 0 331192) 330107)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 331190) 331192)) inline$$DiemAccount_add_currency_$def$2$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon51_Then_correct  (=> (= (ControlFlow 0 331200) 331192) inline$$DiemAccount_add_currency_$def$2$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon50_Then_correct  (=> $abort_flag@71 (and (=> (= (ControlFlow 0 331184) 331200) inline$$DiemAccount_add_currency_$def$2$anon51_Then_correct) (=> (= (ControlFlow 0 331184) 331190) inline$$DiemAccount_add_currency_$def$2$anon51_Else_correct)))))
(let ((inline$$MoveToRaw$4$anon3_Then$1_correct  (=> (= $abort_code@84 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@71 true) (= |inline$$MoveToRaw$4$m'@2| |inline$$MoveToRaw$4$m'@0|)) (and (=> (= (ControlFlow 0 331158) 331184) inline$$DiemAccount_add_currency_$def$2$anon50_Then_correct) (=> (= (ControlFlow 0 331158) 331180) inline$$DiemAccount_add_currency_$def$2$anon50_Else_correct))))))
(let ((inline$$MoveToRaw$4$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) inline$$MoveTo$4$ta@0 inline$$MoveTo$4$a@1) (= (ControlFlow 0 331156) 331158)) inline$$MoveToRaw$4$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$4$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) inline$$MoveTo$4$ta@0 inline$$MoveTo$4$a@1)) (=> (and (and (= |inline$$MoveToRaw$4$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) inline$$MoveTo$4$ta@0 inline$$MoveTo$4$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@1) inline$$MoveTo$4$ta@0 inline$$MoveTo$4$a@1 inline$$DiemAccount_Balance_pack$2$$struct@1))) (= $abort_code@84 $abort_code@83)) (and (= $abort_flag@71 $abort_flag@70) (= |inline$$MoveToRaw$4$m'@2| |inline$$MoveToRaw$4$m'@1|))) (and (=> (= (ControlFlow 0 331106) 331184) inline$$DiemAccount_add_currency_$def$2$anon50_Then_correct) (=> (= (ControlFlow 0 331106) 331180) inline$$DiemAccount_add_currency_$def$2$anon50_Else_correct))))))
(let ((inline$$MoveTo$4$anon0$1_correct  (=> (= inline$$MoveTo$4$a@1 (|a#$Address| new_account_address)) (and (=> (= (ControlFlow 0 331164) 331156) inline$$MoveToRaw$4$anon3_Then_correct) (=> (= (ControlFlow 0 331164) 331106) inline$$MoveToRaw$4$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$4$Entry_correct  (and (=> (= (ControlFlow 0 330952) (- 0 357204)) true) (=> (= (ControlFlow 0 330952) 331164) inline$$MoveTo$4$anon0$1_correct))))
(let ((inline$$MoveTo$4$Entry_correct  (=> (and (= inline$$MoveTo$4$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1)) (= (ControlFlow 0 330924) 330952)) inline$$Signer_borrow_address$4$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$2$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 330826) 330924)) inline$$MoveTo$4$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$2$anon4_Then_correct  (=> (= (ControlFlow 0 330832) 330924) inline$$MoveTo$4$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$2$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 330820) 330832) inline$$DiemAccount_Balance_pack$2$anon4_Then_correct) (=> (= (ControlFlow 0 330820) 330826) inline$$DiemAccount_Balance_pack$2$anon4_Else_correct)))))
(let ((inline$$DiemAccount_Balance_pack$2$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 330812) 330924)) inline$$MoveTo$4$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$2$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$2$$ret0@2) (let ((va@@11 (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$2$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$DiemAccount_Balance_pack$2$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$2$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 330804) 330820) inline$$DiemAccount_Balance_pack$2$anon3_Then_correct) (=> (= (ControlFlow 0 330804) 330812) inline$$DiemAccount_Balance_pack$2$anon3_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon49_Else_correct  (=> (and (not $abort_flag@70) (= (ControlFlow 0 330838) 330804)) inline$$DiemAccount_Balance_pack$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon49_Then_correct  (=> (and (and $abort_flag@70 (= $abort_code@85 $abort_code@83)) (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 331204) 330107))) inline$$DiemAccount_add_currency_$def$2$Abort_correct)))
(let ((inline$$Diem_zero_$def$2$anon3_correct  (=> (= inline$$Diem_zero_$def$2$$ret0@1 $Error) (=> (and (= $abort_flag@70 true) (= inline$$Diem_zero_$def$2$$ret0@2 inline$$Diem_zero_$def$2$$ret0@1)) (and (=> (= (ControlFlow 0 330643) 331204) inline$$DiemAccount_add_currency_$def$2$anon49_Then_correct) (=> (= (ControlFlow 0 330643) 330838) inline$$DiemAccount_add_currency_$def$2$anon49_Else_correct))))))
(let ((inline$$Diem_zero_$def$2$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 330637) 330643)) inline$$Diem_zero_$def$2$anon3_correct)))
(let ((inline$$Diem_zero_$def$2$anon8_Then_correct  (=> (= (ControlFlow 0 330651) 330643) inline$$Diem_zero_$def$2$anon3_correct)))
(let ((inline$$Diem_zero_$def$2$anon7_Then_correct  (=> $abort_flag@69 (and (=> (= (ControlFlow 0 330631) 330651) inline$$Diem_zero_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 330631) 330637) inline$$Diem_zero_$def$2$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$2$anon6_correct  (=> (and (= $abort_flag@70 $abort_flag@69) (= inline$$Diem_zero_$def$2$$ret0@2 inline$$Diem_Diem_pack$2$$struct@1)) (and (=> (= (ControlFlow 0 330619) 331204) inline$$DiemAccount_add_currency_$def$2$anon49_Then_correct) (=> (= (ControlFlow 0 330619) 330838) inline$$DiemAccount_add_currency_$def$2$anon49_Else_correct)))))
(let ((inline$$Diem_zero_$def$2$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 330617) 330619)) inline$$Diem_zero_$def$2$anon6_correct)))
(let ((inline$$Diem_zero_$def$2$anon9_Then_correct  (=> (= (ControlFlow 0 330627) 330619) inline$$Diem_zero_$def$2$anon6_correct)))
(let ((inline$$Diem_Diem_pack$2$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 330595) 330627) inline$$Diem_zero_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 330595) 330617) inline$$Diem_zero_$def$2$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$2$anon4_Then_correct  (and (=> (= (ControlFlow 0 330601) 330627) inline$$Diem_zero_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 330601) 330617) inline$$Diem_zero_$def$2$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$2$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 330589) 330601) inline$$Diem_Diem_pack$2$anon4_Then_correct) (=> (= (ControlFlow 0 330589) 330595) inline$$Diem_Diem_pack$2$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$2$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 330581) 330627) inline$$Diem_zero_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 330581) 330617) inline$$Diem_zero_$def$2$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$2$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$2$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$2$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$2$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$2$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$2$$t0@1) 1)))) (and (=> (= (ControlFlow 0 330573) 330589) inline$$Diem_Diem_pack$2$anon3_Then_correct) (=> (= (ControlFlow 0 330573) 330581) inline$$Diem_Diem_pack$2$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$2$anon7_Else_correct  (=> (not $abort_flag@69) (=> (and (= inline$$Diem_zero_$def$2$$t0@1 ($Integer 0)) (= (ControlFlow 0 330607) 330573)) inline$$Diem_Diem_pack$2$anon0_correct))))
(let ((inline$$Diem_zero_$def$2$anon0_correct  (=> (and (and (not $abort_flag@68) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@69)) (and (=> $abort_flag@69 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@69 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@83 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 330432) 330631) inline$$Diem_zero_$def$2$anon7_Then_correct) (=> (= (ControlFlow 0 330432) 330607) inline$$Diem_zero_$def$2$anon7_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon47_Then_correct  (=> (and (|b#$Boolean| inline$$Not$6$dst@1) (= (ControlFlow 0 330665) 330432)) inline$$Diem_zero_$def$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon28_correct  (=> (= $abort_code@85 $abort_code@82) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 330227) 330107)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 330225) 330227)) inline$$DiemAccount_add_currency_$def$2$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon48_Then_correct  (=> (= (ControlFlow 0 330235) 330227) inline$$DiemAccount_add_currency_$def$2$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon47_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$6$dst@1)) (= $abort_code@82 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 330219) 330235) inline$$DiemAccount_add_currency_$def$2$anon48_Then_correct) (=> (= (ControlFlow 0 330219) 330225) inline$$DiemAccount_add_currency_$def$2$anon48_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon45_Else_correct  (=> (not $abort_flag@68) (and (=> (= (ControlFlow 0 330207) 330665) inline$$DiemAccount_add_currency_$def$2$anon47_Then_correct) (=> (= (ControlFlow 0 330207) 330219) inline$$DiemAccount_add_currency_$def$2$anon47_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon43_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$2$$t12@1 ($Integer 15)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@68)) (and (=> $abort_flag@68 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@68) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 330201) 331208) inline$$DiemAccount_add_currency_$def$2$anon45_Then_correct) (=> (= (ControlFlow 0 330201) 330207) inline$$DiemAccount_add_currency_$def$2$anon45_Else_correct)))))
(let ((inline$$Not$6$anon0_correct  (=> (and (= inline$$Not$6$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currency_$def$2$$t10@1)))) (= (ControlFlow 0 330189) 330201)) inline$$DiemAccount_add_currency_$def$2$anon43_Else$1_correct)))
(let ((inline$$Not$6$Entry_correct  (and (=> (= (ControlFlow 0 330179) (- 0 356747)) true) (=> (= (ControlFlow 0 330179) 330189) inline$$Not$6$anon0_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon43_Else_correct  (=> (not $abort_flag@67) (=> (and (= inline$$DiemAccount_add_currency_$def$2$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| call3formal@$ret0@0@@7)))) (= (ControlFlow 0 330195) 330179)) inline$$Not$6$Entry_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon41_Then_correct  (=> (|b#$Boolean| inline$$Roles_can_hold_balance_$def$2$$ret0@2) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@67) (=> $abort_flag@67 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@67) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 330121) 331228) inline$$DiemAccount_add_currency_$def$2$anon43_Then_correct) (=> (= (ControlFlow 0 330121) 330195) inline$$DiemAccount_add_currency_$def$2$anon43_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon16_correct  (=> (= $abort_code@85 $abort_code@80) (=> (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 330103) 330107)) inline$$DiemAccount_add_currency_$def$2$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 330101) 330103)) inline$$DiemAccount_add_currency_$def$2$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon42_Then_correct  (=> (= (ControlFlow 0 330115) 330103) inline$$DiemAccount_add_currency_$def$2$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_can_hold_balance_$def$2$$ret0@2)) (= $abort_code@80 (|i#$Integer| call3formal@$ret0@0@@8))) (and (=> (= (ControlFlow 0 330095) 330115) inline$$DiemAccount_add_currency_$def$2$anon42_Then_correct) (=> (= (ControlFlow 0 330095) 330101) inline$$DiemAccount_add_currency_$def$2$anon42_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon39_Else_correct  (=> (not $abort_flag@66) (and (=> (= (ControlFlow 0 330083) 330121) inline$$DiemAccount_add_currency_$def$2$anon41_Then_correct) (=> (= (ControlFlow 0 330083) 330095) inline$$DiemAccount_add_currency_$def$2$anon41_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon38_Else_correct  (=> (not $abort_flag@65) (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$2$$t8@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@66)) (and (=> $abort_flag@66 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@66) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@8) (>= (|i#$Integer| call3formal@$ret0@0@@8) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@8) $MAX_U64))) (and (=> (= (ControlFlow 0 330077) 331248) inline$$DiemAccount_add_currency_$def$2$anon39_Then_correct) (=> (= (ControlFlow 0 330077) 330083) inline$$DiemAccount_add_currency_$def$2$anon39_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon38_Then_correct  (=> (and (and $abort_flag@65 (= $abort_code@85 $abort_code@77)) (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= (ControlFlow 0 331268) 330107))) inline$$DiemAccount_add_currency_$def$2$Abort_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$Abort_correct  (=> (and (and (= inline$$Roles_can_hold_balance_$def$2$$ret0@1 $Error) (= inline$$Roles_can_hold_balance_$def$2$$ret0@2 inline$$Roles_can_hold_balance_$def$2$$ret0@1)) (and (= $abort_code@77 $abort_code@75) (= $abort_flag@65 true))) (and (=> (= (ControlFlow 0 329915) 331268) inline$$DiemAccount_add_currency_$def$2$anon38_Then_correct) (=> (= (ControlFlow 0 329915) 330077) inline$$DiemAccount_add_currency_$def$2$anon38_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon26_Then_correct  (=> $abort_flag@63 (=> (and (= $abort_code@75 $abort_code@74) (= (ControlFlow 0 329909) 329915)) inline$$Roles_can_hold_balance_$def$2$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon23_Then_correct  (=> $abort_flag@57 (=> (and (= $abort_code@75 $abort_code@68) (= (ControlFlow 0 329979) 329915)) inline$$Roles_can_hold_balance_$def$2$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon20_Then_correct  (=> $abort_flag@52 (=> (and (= $abort_code@75 $abort_code@63) (= (ControlFlow 0 330043) 329915)) inline$$Roles_can_hold_balance_$def$2$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon18_correct  (=> (= inline$$Roles_can_hold_balance_$def$2$$ret0@2 |inline$$Roles_can_hold_balance_$def$2$tmp#$2@1|) (=> (and (= $abort_code@77 $abort_code@76) (= $abort_flag@65 $abort_flag@64)) (and (=> (= (ControlFlow 0 329897) 331268) inline$$DiemAccount_add_currency_$def$2$anon38_Then_correct) (=> (= (ControlFlow 0 329897) 330077) inline$$DiemAccount_add_currency_$def$2$anon38_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 329895) 329897)) inline$$Roles_can_hold_balance_$def$2$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon27_Then_correct  (=> (= (ControlFlow 0 329905) 329897) inline$$Roles_can_hold_balance_$def$2$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon14_correct  (=> (= |inline$$Roles_can_hold_balance_$def$2$tmp#$2@1| inline$$Roles_can_hold_balance_$def$2$$t6@1) (=> (and (= $abort_code@76 $abort_code@69) (= $abort_flag@64 $abort_flag@58)) (and (=> (= (ControlFlow 0 329967) 329905) inline$$Roles_can_hold_balance_$def$2$anon27_Then_correct) (=> (= (ControlFlow 0 329967) 329895) inline$$Roles_can_hold_balance_$def$2$anon27_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 329965) 329967)) inline$$Roles_can_hold_balance_$def$2$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon25_Then_correct  (=> (= (ControlFlow 0 329975) 329967) inline$$Roles_can_hold_balance_$def$2$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon24_Then_correct  (=> (and (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1|) (= inline$$Roles_can_hold_balance_$def$2$$t6@1 ($Boolean true))) (and (=> (= (ControlFlow 0 329957) 329975) inline$$Roles_can_hold_balance_$def$2$anon25_Then_correct) (=> (= (ControlFlow 0 329957) 329965) inline$$Roles_can_hold_balance_$def$2$anon25_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon26_Else_correct  (=> (and (and (not $abort_flag@63) (= |inline$$Roles_can_hold_balance_$def$2$tmp#$2@1| inline$$Roles_has_designated_dealer_role_$def$2$$ret0@2)) (and (= $abort_code@76 $abort_code@74) (= $abort_flag@64 $abort_flag@63))) (and (=> (= (ControlFlow 0 329885) 329905) inline$$Roles_can_hold_balance_$def$2$anon27_Then_correct) (=> (= (ControlFlow 0 329885) 329895) inline$$Roles_can_hold_balance_$def$2$anon27_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon6_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$2$$ret0@2 inline$$Roles_has_role_$def$8$$ret0@2) (= $abort_flag@63 $abort_flag@62)) (and (=> (= (ControlFlow 0 329839) 329909) inline$$Roles_can_hold_balance_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 329839) 329885) inline$$Roles_can_hold_balance_$def$2$anon26_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 329837) 329839)) inline$$Roles_has_designated_dealer_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon9_Then_correct  (=> (= (ControlFlow 0 329847) 329839) inline$$Roles_has_designated_dealer_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon8_Else_correct  (=> (not $abort_flag@62) (and (=> (= (ControlFlow 0 329831) 329847) inline$$Roles_has_designated_dealer_role_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 329831) 329837) inline$$Roles_has_designated_dealer_role_$def$2$anon9_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon8_Then_correct  (=> (and (and $abort_flag@62 (= inline$$Roles_has_designated_dealer_role_$def$2$$ret0@1 $Error)) (and (= inline$$Roles_has_designated_dealer_role_$def$2$$ret0@2 inline$$Roles_has_designated_dealer_role_$def$2$$ret0@1) (= $abort_flag@63 true))) (and (=> (= (ControlFlow 0 329855) 329909) inline$$Roles_can_hold_balance_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 329855) 329885) inline$$Roles_can_hold_balance_$def$2$anon26_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$8$$ret0@1 $Error) (= $abort_flag@62 true)) (and (= $abort_code@74 $abort_code@73) (= inline$$Roles_has_role_$def$8$$ret0@2 inline$$Roles_has_role_$def$8$$ret0@1))) (and (=> (= (ControlFlow 0 329763) 329855) inline$$Roles_has_designated_dealer_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 329763) 329831) inline$$Roles_has_designated_dealer_role_$def$2$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon7_correct  (=> (and (= $abort_code@73 $abort_code@70) (= (ControlFlow 0 329783) 329763)) inline$$Roles_has_role_$def$8$Abort_correct)))
(let ((inline$$Roles_has_role_$def$8$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 329781) 329783)) inline$$Roles_has_role_$def$8$anon7_correct)))
(let ((inline$$Roles_has_role_$def$8$anon24_Then_correct  (=> (= (ControlFlow 0 329791) 329783) inline$$Roles_has_role_$def$8$anon7_correct)))
(let ((inline$$Roles_has_role_$def$8$anon23_Then_correct  (=> $abort_flag@59 (and (=> (= (ControlFlow 0 329775) 329791) inline$$Roles_has_role_$def$8$anon24_Then_correct) (=> (= (ControlFlow 0 329775) 329781) inline$$Roles_has_role_$def$8$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon13_correct  (=> (and (= $abort_code@73 $abort_code@71) (= (ControlFlow 0 329757) 329763)) inline$$Roles_has_role_$def$8$Abort_correct)))
(let ((inline$$Roles_has_role_$def$8$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 329755) 329757)) inline$$Roles_has_role_$def$8$anon13_correct)))
(let ((inline$$Roles_has_role_$def$8$anon27_Then_correct  (=> (= (ControlFlow 0 329771) 329757) inline$$Roles_has_role_$def$8$anon13_correct)))
(let ((inline$$Roles_has_role_$def$8$anon26_Then_correct  (=> $abort_flag@60 (and (=> (= (ControlFlow 0 329749) 329771) inline$$Roles_has_role_$def$8$anon27_Then_correct) (=> (= (ControlFlow 0 329749) 329755) inline$$Roles_has_role_$def$8$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon20_correct  (=> (= $abort_flag@62 $abort_flag@61) (=> (and (= $abort_code@74 $abort_code@72) (= inline$$Roles_has_role_$def$8$$ret0@2 |inline$$Roles_has_role_$def$8$tmp#$3@2|)) (and (=> (= (ControlFlow 0 329470) 329855) inline$$Roles_has_designated_dealer_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 329470) 329831) inline$$Roles_has_designated_dealer_role_$def$2$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$8$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 329468) 329470)) inline$$Roles_has_role_$def$8$anon20_correct)))
(let ((inline$$Roles_has_role_$def$8$anon30_Then_correct  (=> (= (ControlFlow 0 329478) 329470) inline$$Roles_has_role_$def$8$anon20_correct)))
(let ((inline$$Roles_has_role_$def$8$anon16_correct  (=> (= $abort_flag@61 $abort_flag@60) (=> (and (= |inline$$Roles_has_role_$def$8$tmp#$3@2| |inline$$Roles_has_role_$def$8$tmp#$3@1|) (= $abort_code@72 $abort_code@71)) (and (=> (= (ControlFlow 0 329737) 329478) inline$$Roles_has_role_$def$8$anon30_Then_correct) (=> (= (ControlFlow 0 329737) 329468) inline$$Roles_has_role_$def$8$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$8$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 329735) 329737)) inline$$Roles_has_role_$def$8$anon16_correct)))
(let ((inline$$Roles_has_role_$def$8$anon28_Then_correct  (=> (= (ControlFlow 0 329745) 329737) inline$$Roles_has_role_$def$8$anon16_correct)))
(let ((inline$$Roles_has_role_$def$8$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$8$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$8$dst@1 inline$$Roles_has_designated_dealer_role_$def$2$$t2@1))) (and (=> (= (ControlFlow 0 329729) 329745) inline$$Roles_has_role_$def$8$anon28_Then_correct) (=> (= (ControlFlow 0 329729) 329735) inline$$Roles_has_role_$def$8$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$8$anon0_correct  (=> (and (= inline$$GetFieldFromValue$8$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$8$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 329713) 329729)) inline$$Roles_has_role_$def$8$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$8$anon26_Else_correct  (=> (and (not $abort_flag@60) (= (ControlFlow 0 329719) 329713)) inline$$GetFieldFromValue$8$anon0_correct)))
(let ((inline$$GetGlobal$8$anon3_Then$1_correct  (=> (= $abort_code@71 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@60 true) (= inline$$GetGlobal$8$dst@2 inline$$GetGlobal$8$dst@0)) (and (=> (= (ControlFlow 0 329659) 329749) inline$$Roles_has_role_$def$8$anon26_Then_correct) (=> (= (ControlFlow 0 329659) 329719) inline$$Roles_has_role_$def$8$anon26_Else_correct))))))
(let ((inline$$GetGlobal$8$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$8$a@1)) (= (ControlFlow 0 329657) 329659)) inline$$GetGlobal$8$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$8$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$8$a@1) (=> (and (and (= inline$$GetGlobal$8$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@9))) (= $abort_code@71 $abort_code@70)) (and (= $abort_flag@60 $abort_flag@59) (= inline$$GetGlobal$8$dst@2 inline$$GetGlobal$8$dst@1))) (and (=> (= (ControlFlow 0 329605) 329749) inline$$Roles_has_role_$def$8$anon26_Then_correct) (=> (= (ControlFlow 0 329605) 329719) inline$$Roles_has_role_$def$8$anon26_Else_correct))))))
(let ((inline$$GetGlobal$8$anon0_correct  (=> (= inline$$GetGlobal$8$a@1 (|a#$Address| call3formal@$ret0@0@@9)) (and (=> (= (ControlFlow 0 329587) 329657) inline$$GetGlobal$8$anon3_Then_correct) (=> (= (ControlFlow 0 329587) 329605) inline$$GetGlobal$8$anon3_Else_correct)))))
(let ((inline$$GetGlobal$8$Entry_correct  (and (=> (= (ControlFlow 0 329581) (- 0 356154)) true) (=> (= (ControlFlow 0 329581) 329587) inline$$GetGlobal$8$anon0_correct))))
(let ((inline$$Roles_has_role_$def$8$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$8$$t6@1) (= (ControlFlow 0 329665) 329581)) inline$$GetGlobal$8$Entry_correct)))
(let ((inline$$Roles_has_role_$def$8$anon18_correct  (=> (= $abort_flag@61 $abort_flag@59) (=> (and (= |inline$$Roles_has_role_$def$8$tmp#$3@2| inline$$Roles_has_role_$def$8$$t9@1) (= $abort_code@72 $abort_code@70)) (and (=> (= (ControlFlow 0 329458) 329478) inline$$Roles_has_role_$def$8$anon30_Then_correct) (=> (= (ControlFlow 0 329458) 329468) inline$$Roles_has_role_$def$8$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$8$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 329456) 329458)) inline$$Roles_has_role_$def$8$anon18_correct)))
(let ((inline$$Roles_has_role_$def$8$anon29_Then_correct  (=> (= (ControlFlow 0 329486) 329458) inline$$Roles_has_role_$def$8$anon18_correct)))
(let ((inline$$Roles_has_role_$def$8$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$8$$t6@1)) (= inline$$Roles_has_role_$def$8$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 329448) 329486) inline$$Roles_has_role_$def$8$anon29_Then_correct) (=> (= (ControlFlow 0 329448) 329456) inline$$Roles_has_role_$def$8$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon23_Else_correct  (=> (and (not $abort_flag@59) (= inline$$Roles_has_role_$def$8$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@9))))) (and (=> (= (ControlFlow 0 329404) 329665) inline$$Roles_has_role_$def$8$anon25_Then_correct) (=> (= (ControlFlow 0 329404) 329448) inline$$Roles_has_role_$def$8$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@59) (=> $abort_flag@59 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@59) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 329390) 329775) inline$$Roles_has_role_$def$8$anon23_Then_correct) (=> (= (ControlFlow 0 329390) 329404) inline$$Roles_has_role_$def$8$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 329320) 329390)) inline$$Roles_has_role_$def$8$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$8$anon22_Then_correct  (=> (= (ControlFlow 0 329799) 329390) inline$$Roles_has_role_$def$8$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$8$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 329312) 329799) inline$$Roles_has_role_$def$8$anon22_Then_correct) (=> (= (ControlFlow 0 329312) 329320) inline$$Roles_has_role_$def$8$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$8$anon21_Then_correct  (and (=> (= (ControlFlow 0 329807) 329799) inline$$Roles_has_role_$def$8$anon22_Then_correct) (=> (= (ControlFlow 0 329807) 329320) inline$$Roles_has_role_$def$8$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$8$anon0_correct  (=> (not $abort_flag@58) (and (=> (= (ControlFlow 0 329306) 329807) inline$$Roles_has_role_$def$8$anon21_Then_correct) (=> (= (ControlFlow 0 329306) 329312) inline$$Roles_has_role_$def$8$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$8$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_designated_dealer_role_$def$2$$t2@1) (>= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$2$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$2$$t2@1) $MAX_U64)) (= (ControlFlow 0 329813) 329306)) inline$$Roles_has_role_$def$8$anon0_correct))))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon2$1_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$2$$t2@1 ($Integer 2)) (= (ControlFlow 0 329821) 329813)) inline$$Roles_has_role$8$anon0_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 328833) 329821)) inline$$Roles_has_designated_dealer_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon7_Then_correct  (=> (= (ControlFlow 0 329863) 329821) inline$$Roles_has_designated_dealer_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$2$anon0_correct  (=> (not $abort_flag@58) (and (=> (= (ControlFlow 0 328827) 329863) inline$$Roles_has_designated_dealer_role_$def$2$anon7_Then_correct) (=> (= (ControlFlow 0 328827) 328833) inline$$Roles_has_designated_dealer_role_$def$2$anon7_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role$2$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 329869) 328827)) inline$$Roles_has_designated_dealer_role_$def$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon24_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1|)) (= (ControlFlow 0 329877) 329869)) inline$$Roles_has_designated_dealer_role$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon8_correct  (=> (= |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1| inline$$Roles_can_hold_balance_$def$2$$t5@1) (=> (and (= $abort_flag@58 $abort_flag@52) (= $abort_code@69 $abort_code@63)) (and (=> (= (ControlFlow 0 330031) 329957) inline$$Roles_can_hold_balance_$def$2$anon24_Then_correct) (=> (= (ControlFlow 0 330031) 329877) inline$$Roles_can_hold_balance_$def$2$anon24_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 330029) 330031)) inline$$Roles_can_hold_balance_$def$2$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon22_Then_correct  (=> (= (ControlFlow 0 330039) 330031) inline$$Roles_can_hold_balance_$def$2$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2) (= inline$$Roles_can_hold_balance_$def$2$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 330021) 330039) inline$$Roles_can_hold_balance_$def$2$anon22_Then_correct) (=> (= (ControlFlow 0 330021) 330029) inline$$Roles_can_hold_balance_$def$2$anon22_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$2$anon23_Else_correct  (=> (and (and (not $abort_flag@57) (= |inline$$Roles_can_hold_balance_$def$2$tmp#$1@1| inline$$Roles_has_child_VASP_role_$def$2$$ret0@2)) (and (= $abort_flag@58 $abort_flag@57) (= $abort_code@69 $abort_code@68))) (and (=> (= (ControlFlow 0 328625) 329957) inline$$Roles_can_hold_balance_$def$2$anon24_Then_correct) (=> (= (ControlFlow 0 328625) 329877) inline$$Roles_can_hold_balance_$def$2$anon24_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon6_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$2$$ret0@2 inline$$Roles_has_role_$def$7$$ret0@2) (= $abort_flag@57 $abort_flag@56)) (and (=> (= (ControlFlow 0 328579) 329979) inline$$Roles_can_hold_balance_$def$2$anon23_Then_correct) (=> (= (ControlFlow 0 328579) 328625) inline$$Roles_can_hold_balance_$def$2$anon23_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 328577) 328579)) inline$$Roles_has_child_VASP_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon9_Then_correct  (=> (= (ControlFlow 0 328587) 328579) inline$$Roles_has_child_VASP_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon8_Else_correct  (=> (not $abort_flag@56) (and (=> (= (ControlFlow 0 328571) 328587) inline$$Roles_has_child_VASP_role_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 328571) 328577) inline$$Roles_has_child_VASP_role_$def$2$anon9_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon8_Then_correct  (=> (and (and $abort_flag@56 (= inline$$Roles_has_child_VASP_role_$def$2$$ret0@1 $Error)) (and (= inline$$Roles_has_child_VASP_role_$def$2$$ret0@2 inline$$Roles_has_child_VASP_role_$def$2$$ret0@1) (= $abort_flag@57 true))) (and (=> (= (ControlFlow 0 328595) 329979) inline$$Roles_can_hold_balance_$def$2$anon23_Then_correct) (=> (= (ControlFlow 0 328595) 328625) inline$$Roles_can_hold_balance_$def$2$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$7$$ret0@1 $Error) (= $abort_flag@56 true)) (and (= $abort_code@68 $abort_code@67) (= inline$$Roles_has_role_$def$7$$ret0@2 inline$$Roles_has_role_$def$7$$ret0@1))) (and (=> (= (ControlFlow 0 328503) 328595) inline$$Roles_has_child_VASP_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 328503) 328571) inline$$Roles_has_child_VASP_role_$def$2$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon7_correct  (=> (and (= $abort_code@67 $abort_code@64) (= (ControlFlow 0 328523) 328503)) inline$$Roles_has_role_$def$7$Abort_correct)))
(let ((inline$$Roles_has_role_$def$7$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 328521) 328523)) inline$$Roles_has_role_$def$7$anon7_correct)))
(let ((inline$$Roles_has_role_$def$7$anon24_Then_correct  (=> (= (ControlFlow 0 328531) 328523) inline$$Roles_has_role_$def$7$anon7_correct)))
(let ((inline$$Roles_has_role_$def$7$anon23_Then_correct  (=> $abort_flag@53 (and (=> (= (ControlFlow 0 328515) 328531) inline$$Roles_has_role_$def$7$anon24_Then_correct) (=> (= (ControlFlow 0 328515) 328521) inline$$Roles_has_role_$def$7$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon13_correct  (=> (and (= $abort_code@67 $abort_code@65) (= (ControlFlow 0 328497) 328503)) inline$$Roles_has_role_$def$7$Abort_correct)))
(let ((inline$$Roles_has_role_$def$7$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 328495) 328497)) inline$$Roles_has_role_$def$7$anon13_correct)))
(let ((inline$$Roles_has_role_$def$7$anon27_Then_correct  (=> (= (ControlFlow 0 328511) 328497) inline$$Roles_has_role_$def$7$anon13_correct)))
(let ((inline$$Roles_has_role_$def$7$anon26_Then_correct  (=> $abort_flag@54 (and (=> (= (ControlFlow 0 328489) 328511) inline$$Roles_has_role_$def$7$anon27_Then_correct) (=> (= (ControlFlow 0 328489) 328495) inline$$Roles_has_role_$def$7$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon20_correct  (=> (= $abort_flag@56 $abort_flag@55) (=> (and (= $abort_code@68 $abort_code@66) (= inline$$Roles_has_role_$def$7$$ret0@2 |inline$$Roles_has_role_$def$7$tmp#$3@2|)) (and (=> (= (ControlFlow 0 328210) 328595) inline$$Roles_has_child_VASP_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 328210) 328571) inline$$Roles_has_child_VASP_role_$def$2$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$7$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 328208) 328210)) inline$$Roles_has_role_$def$7$anon20_correct)))
(let ((inline$$Roles_has_role_$def$7$anon30_Then_correct  (=> (= (ControlFlow 0 328218) 328210) inline$$Roles_has_role_$def$7$anon20_correct)))
(let ((inline$$Roles_has_role_$def$7$anon16_correct  (=> (= $abort_code@66 $abort_code@65) (=> (and (= |inline$$Roles_has_role_$def$7$tmp#$3@2| |inline$$Roles_has_role_$def$7$tmp#$3@1|) (= $abort_flag@55 $abort_flag@54)) (and (=> (= (ControlFlow 0 328477) 328218) inline$$Roles_has_role_$def$7$anon30_Then_correct) (=> (= (ControlFlow 0 328477) 328208) inline$$Roles_has_role_$def$7$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$7$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 328475) 328477)) inline$$Roles_has_role_$def$7$anon16_correct)))
(let ((inline$$Roles_has_role_$def$7$anon28_Then_correct  (=> (= (ControlFlow 0 328485) 328477) inline$$Roles_has_role_$def$7$anon16_correct)))
(let ((inline$$Roles_has_role_$def$7$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$7$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$7$dst@1 inline$$Roles_has_child_VASP_role_$def$2$$t2@1))) (and (=> (= (ControlFlow 0 328469) 328485) inline$$Roles_has_role_$def$7$anon28_Then_correct) (=> (= (ControlFlow 0 328469) 328475) inline$$Roles_has_role_$def$7$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$7$anon0_correct  (=> (and (= inline$$GetFieldFromValue$7$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$7$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 328453) 328469)) inline$$Roles_has_role_$def$7$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$7$anon26_Else_correct  (=> (and (not $abort_flag@54) (= (ControlFlow 0 328459) 328453)) inline$$GetFieldFromValue$7$anon0_correct)))
(let ((inline$$GetGlobal$7$anon3_Then$1_correct  (=> (= $abort_flag@54 true) (=> (and (= $abort_code@65 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$7$dst@2 inline$$GetGlobal$7$dst@0)) (and (=> (= (ControlFlow 0 328399) 328489) inline$$Roles_has_role_$def$7$anon26_Then_correct) (=> (= (ControlFlow 0 328399) 328459) inline$$Roles_has_role_$def$7$anon26_Else_correct))))))
(let ((inline$$GetGlobal$7$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$7$a@1)) (= (ControlFlow 0 328397) 328399)) inline$$GetGlobal$7$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$7$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$7$a@1) (=> (and (and (= inline$$GetGlobal$7$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@10))) (= $abort_flag@54 $abort_flag@53)) (and (= $abort_code@65 $abort_code@64) (= inline$$GetGlobal$7$dst@2 inline$$GetGlobal$7$dst@1))) (and (=> (= (ControlFlow 0 328345) 328489) inline$$Roles_has_role_$def$7$anon26_Then_correct) (=> (= (ControlFlow 0 328345) 328459) inline$$Roles_has_role_$def$7$anon26_Else_correct))))))
(let ((inline$$GetGlobal$7$anon0_correct  (=> (= inline$$GetGlobal$7$a@1 (|a#$Address| call3formal@$ret0@0@@10)) (and (=> (= (ControlFlow 0 328327) 328397) inline$$GetGlobal$7$anon3_Then_correct) (=> (= (ControlFlow 0 328327) 328345) inline$$GetGlobal$7$anon3_Else_correct)))))
(let ((inline$$GetGlobal$7$Entry_correct  (and (=> (= (ControlFlow 0 328321) (- 0 355511)) true) (=> (= (ControlFlow 0 328321) 328327) inline$$GetGlobal$7$anon0_correct))))
(let ((inline$$Roles_has_role_$def$7$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$7$$t6@1) (= (ControlFlow 0 328405) 328321)) inline$$GetGlobal$7$Entry_correct)))
(let ((inline$$Roles_has_role_$def$7$anon18_correct  (=> (= $abort_code@66 $abort_code@64) (=> (and (= |inline$$Roles_has_role_$def$7$tmp#$3@2| inline$$Roles_has_role_$def$7$$t9@1) (= $abort_flag@55 $abort_flag@53)) (and (=> (= (ControlFlow 0 328198) 328218) inline$$Roles_has_role_$def$7$anon30_Then_correct) (=> (= (ControlFlow 0 328198) 328208) inline$$Roles_has_role_$def$7$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$7$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 328196) 328198)) inline$$Roles_has_role_$def$7$anon18_correct)))
(let ((inline$$Roles_has_role_$def$7$anon29_Then_correct  (=> (= (ControlFlow 0 328226) 328198) inline$$Roles_has_role_$def$7$anon18_correct)))
(let ((inline$$Roles_has_role_$def$7$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$7$$t6@1)) (= inline$$Roles_has_role_$def$7$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 328188) 328226) inline$$Roles_has_role_$def$7$anon29_Then_correct) (=> (= (ControlFlow 0 328188) 328196) inline$$Roles_has_role_$def$7$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon23_Else_correct  (=> (and (not $abort_flag@53) (= inline$$Roles_has_role_$def$7$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@10))))) (and (=> (= (ControlFlow 0 328144) 328405) inline$$Roles_has_role_$def$7$anon25_Then_correct) (=> (= (ControlFlow 0 328144) 328188) inline$$Roles_has_role_$def$7$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@53) (=> $abort_flag@53 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@53) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 328130) 328515) inline$$Roles_has_role_$def$7$anon23_Then_correct) (=> (= (ControlFlow 0 328130) 328144) inline$$Roles_has_role_$def$7$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 328060) 328130)) inline$$Roles_has_role_$def$7$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$7$anon22_Then_correct  (=> (= (ControlFlow 0 328539) 328130) inline$$Roles_has_role_$def$7$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$7$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 328052) 328539) inline$$Roles_has_role_$def$7$anon22_Then_correct) (=> (= (ControlFlow 0 328052) 328060) inline$$Roles_has_role_$def$7$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$7$anon21_Then_correct  (and (=> (= (ControlFlow 0 328547) 328539) inline$$Roles_has_role_$def$7$anon22_Then_correct) (=> (= (ControlFlow 0 328547) 328060) inline$$Roles_has_role_$def$7$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$7$anon0_correct  (=> (not $abort_flag@52) (and (=> (= (ControlFlow 0 328046) 328547) inline$$Roles_has_role_$def$7$anon21_Then_correct) (=> (= (ControlFlow 0 328046) 328052) inline$$Roles_has_role_$def$7$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$7$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_child_VASP_role_$def$2$$t2@1) (>= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$2$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$2$$t2@1) $MAX_U64)) (= (ControlFlow 0 328553) 328046)) inline$$Roles_has_role_$def$7$anon0_correct))))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon2$1_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$2$$t2@1 ($Integer 6)) (= (ControlFlow 0 328561) 328553)) inline$$Roles_has_role$7$anon0_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 327573) 328561)) inline$$Roles_has_child_VASP_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon7_Then_correct  (=> (= (ControlFlow 0 328603) 328561) inline$$Roles_has_child_VASP_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$2$anon0_correct  (=> (not $abort_flag@52) (and (=> (= (ControlFlow 0 327567) 328603) inline$$Roles_has_child_VASP_role_$def$2$anon7_Then_correct) (=> (= (ControlFlow 0 327567) 327573) inline$$Roles_has_child_VASP_role_$def$2$anon7_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role$2$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 328609) 327567)) inline$$Roles_has_child_VASP_role_$def$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2)) (= (ControlFlow 0 328617) 328609)) inline$$Roles_has_child_VASP_role$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon20_Else_correct  (=> (not $abort_flag@52) (and (=> (= (ControlFlow 0 327367) 330021) inline$$Roles_can_hold_balance_$def$2$anon21_Then_correct) (=> (= (ControlFlow 0 327367) 328617) inline$$Roles_can_hold_balance_$def$2$anon21_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon6_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2 inline$$Roles_has_role_$def$6$$ret0@2) (= $abort_flag@52 $abort_flag@51)) (and (=> (= (ControlFlow 0 327321) 330043) inline$$Roles_can_hold_balance_$def$2$anon20_Then_correct) (=> (= (ControlFlow 0 327321) 327367) inline$$Roles_can_hold_balance_$def$2$anon20_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 327319) 327321)) inline$$Roles_has_parent_VASP_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon9_Then_correct  (=> (= (ControlFlow 0 327329) 327321) inline$$Roles_has_parent_VASP_role_$def$2$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon8_Else_correct  (=> (not $abort_flag@51) (and (=> (= (ControlFlow 0 327313) 327329) inline$$Roles_has_parent_VASP_role_$def$2$anon9_Then_correct) (=> (= (ControlFlow 0 327313) 327319) inline$$Roles_has_parent_VASP_role_$def$2$anon9_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon8_Then_correct  (=> (and (and $abort_flag@51 (= inline$$Roles_has_parent_VASP_role_$def$2$$ret0@1 $Error)) (and (= inline$$Roles_has_parent_VASP_role_$def$2$$ret0@2 inline$$Roles_has_parent_VASP_role_$def$2$$ret0@1) (= $abort_flag@52 true))) (and (=> (= (ControlFlow 0 327337) 330043) inline$$Roles_can_hold_balance_$def$2$anon20_Then_correct) (=> (= (ControlFlow 0 327337) 327367) inline$$Roles_can_hold_balance_$def$2$anon20_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$6$$ret0@1 $Error) (= $abort_flag@51 true)) (and (= $abort_code@63 $abort_code@62) (= inline$$Roles_has_role_$def$6$$ret0@2 inline$$Roles_has_role_$def$6$$ret0@1))) (and (=> (= (ControlFlow 0 327245) 327337) inline$$Roles_has_parent_VASP_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 327245) 327313) inline$$Roles_has_parent_VASP_role_$def$2$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon7_correct  (=> (and (= $abort_code@62 $abort_code@59) (= (ControlFlow 0 327265) 327245)) inline$$Roles_has_role_$def$6$Abort_correct)))
(let ((inline$$Roles_has_role_$def$6$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 327263) 327265)) inline$$Roles_has_role_$def$6$anon7_correct)))
(let ((inline$$Roles_has_role_$def$6$anon24_Then_correct  (=> (= (ControlFlow 0 327273) 327265) inline$$Roles_has_role_$def$6$anon7_correct)))
(let ((inline$$Roles_has_role_$def$6$anon23_Then_correct  (=> $abort_flag@48 (and (=> (= (ControlFlow 0 327257) 327273) inline$$Roles_has_role_$def$6$anon24_Then_correct) (=> (= (ControlFlow 0 327257) 327263) inline$$Roles_has_role_$def$6$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon13_correct  (=> (and (= $abort_code@62 $abort_code@60) (= (ControlFlow 0 327239) 327245)) inline$$Roles_has_role_$def$6$Abort_correct)))
(let ((inline$$Roles_has_role_$def$6$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 327237) 327239)) inline$$Roles_has_role_$def$6$anon13_correct)))
(let ((inline$$Roles_has_role_$def$6$anon27_Then_correct  (=> (= (ControlFlow 0 327253) 327239) inline$$Roles_has_role_$def$6$anon13_correct)))
(let ((inline$$Roles_has_role_$def$6$anon26_Then_correct  (=> $abort_flag@49 (and (=> (= (ControlFlow 0 327231) 327253) inline$$Roles_has_role_$def$6$anon27_Then_correct) (=> (= (ControlFlow 0 327231) 327237) inline$$Roles_has_role_$def$6$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon20_correct  (=> (= $abort_flag@51 $abort_flag@50) (=> (and (= $abort_code@63 $abort_code@61) (= inline$$Roles_has_role_$def$6$$ret0@2 |inline$$Roles_has_role_$def$6$tmp#$3@2|)) (and (=> (= (ControlFlow 0 326952) 327337) inline$$Roles_has_parent_VASP_role_$def$2$anon8_Then_correct) (=> (= (ControlFlow 0 326952) 327313) inline$$Roles_has_parent_VASP_role_$def$2$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$6$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 326950) 326952)) inline$$Roles_has_role_$def$6$anon20_correct)))
(let ((inline$$Roles_has_role_$def$6$anon30_Then_correct  (=> (= (ControlFlow 0 326960) 326952) inline$$Roles_has_role_$def$6$anon20_correct)))
(let ((inline$$Roles_has_role_$def$6$anon16_correct  (=> (= $abort_flag@50 $abort_flag@49) (=> (and (= |inline$$Roles_has_role_$def$6$tmp#$3@2| |inline$$Roles_has_role_$def$6$tmp#$3@1|) (= $abort_code@61 $abort_code@60)) (and (=> (= (ControlFlow 0 327219) 326960) inline$$Roles_has_role_$def$6$anon30_Then_correct) (=> (= (ControlFlow 0 327219) 326950) inline$$Roles_has_role_$def$6$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$6$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 327217) 327219)) inline$$Roles_has_role_$def$6$anon16_correct)))
(let ((inline$$Roles_has_role_$def$6$anon28_Then_correct  (=> (= (ControlFlow 0 327227) 327219) inline$$Roles_has_role_$def$6$anon16_correct)))
(let ((inline$$Roles_has_role_$def$6$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$6$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$6$dst@1 inline$$Roles_has_parent_VASP_role_$def$2$$t2@1))) (and (=> (= (ControlFlow 0 327211) 327227) inline$$Roles_has_role_$def$6$anon28_Then_correct) (=> (= (ControlFlow 0 327211) 327217) inline$$Roles_has_role_$def$6$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$6$anon0_correct  (=> (and (= inline$$GetFieldFromValue$6$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$6$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 327195) 327211)) inline$$Roles_has_role_$def$6$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$6$anon26_Else_correct  (=> (and (not $abort_flag@49) (= (ControlFlow 0 327201) 327195)) inline$$GetFieldFromValue$6$anon0_correct)))
(let ((inline$$GetGlobal$6$anon3_Then$1_correct  (=> (= $abort_code@60 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@49 true) (= inline$$GetGlobal$6$dst@2 inline$$GetGlobal$6$dst@0)) (and (=> (= (ControlFlow 0 327141) 327231) inline$$Roles_has_role_$def$6$anon26_Then_correct) (=> (= (ControlFlow 0 327141) 327201) inline$$Roles_has_role_$def$6$anon26_Else_correct))))))
(let ((inline$$GetGlobal$6$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$6$a@1)) (= (ControlFlow 0 327139) 327141)) inline$$GetGlobal$6$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$6$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$6$a@1) (=> (and (and (= inline$$GetGlobal$6$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@11))) (= $abort_code@60 $abort_code@59)) (and (= $abort_flag@49 $abort_flag@48) (= inline$$GetGlobal$6$dst@2 inline$$GetGlobal$6$dst@1))) (and (=> (= (ControlFlow 0 327087) 327231) inline$$Roles_has_role_$def$6$anon26_Then_correct) (=> (= (ControlFlow 0 327087) 327201) inline$$Roles_has_role_$def$6$anon26_Else_correct))))))
(let ((inline$$GetGlobal$6$anon0_correct  (=> (= inline$$GetGlobal$6$a@1 (|a#$Address| call3formal@$ret0@0@@11)) (and (=> (= (ControlFlow 0 327069) 327139) inline$$GetGlobal$6$anon3_Then_correct) (=> (= (ControlFlow 0 327069) 327087) inline$$GetGlobal$6$anon3_Else_correct)))))
(let ((inline$$GetGlobal$6$Entry_correct  (and (=> (= (ControlFlow 0 327063) (- 0 354915)) true) (=> (= (ControlFlow 0 327063) 327069) inline$$GetGlobal$6$anon0_correct))))
(let ((inline$$Roles_has_role_$def$6$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$6$$t6@1) (= (ControlFlow 0 327147) 327063)) inline$$GetGlobal$6$Entry_correct)))
(let ((inline$$Roles_has_role_$def$6$anon18_correct  (=> (= $abort_flag@50 $abort_flag@48) (=> (and (= |inline$$Roles_has_role_$def$6$tmp#$3@2| inline$$Roles_has_role_$def$6$$t9@1) (= $abort_code@61 $abort_code@59)) (and (=> (= (ControlFlow 0 326940) 326960) inline$$Roles_has_role_$def$6$anon30_Then_correct) (=> (= (ControlFlow 0 326940) 326950) inline$$Roles_has_role_$def$6$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$6$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 326938) 326940)) inline$$Roles_has_role_$def$6$anon18_correct)))
(let ((inline$$Roles_has_role_$def$6$anon29_Then_correct  (=> (= (ControlFlow 0 326968) 326940) inline$$Roles_has_role_$def$6$anon18_correct)))
(let ((inline$$Roles_has_role_$def$6$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$6$$t6@1)) (= inline$$Roles_has_role_$def$6$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 326930) 326968) inline$$Roles_has_role_$def$6$anon29_Then_correct) (=> (= (ControlFlow 0 326930) 326938) inline$$Roles_has_role_$def$6$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon23_Else_correct  (=> (and (not $abort_flag@48) (= inline$$Roles_has_role_$def$6$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@11))))) (and (=> (= (ControlFlow 0 326886) 327147) inline$$Roles_has_role_$def$6$anon25_Then_correct) (=> (= (ControlFlow 0 326886) 326930) inline$$Roles_has_role_$def$6$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@48) (=> $abort_flag@48 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@48) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 326872) 327257) inline$$Roles_has_role_$def$6$anon23_Then_correct) (=> (= (ControlFlow 0 326872) 326886) inline$$Roles_has_role_$def$6$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 326802) 326872)) inline$$Roles_has_role_$def$6$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$6$anon22_Then_correct  (=> (= (ControlFlow 0 327281) 326872) inline$$Roles_has_role_$def$6$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$6$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 326794) 327281) inline$$Roles_has_role_$def$6$anon22_Then_correct) (=> (= (ControlFlow 0 326794) 326802) inline$$Roles_has_role_$def$6$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$6$anon21_Then_correct  (and (=> (= (ControlFlow 0 327289) 327281) inline$$Roles_has_role_$def$6$anon22_Then_correct) (=> (= (ControlFlow 0 327289) 326802) inline$$Roles_has_role_$def$6$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$6$anon0_correct  (=> (not $abort_flag@47) (and (=> (= (ControlFlow 0 326788) 327289) inline$$Roles_has_role_$def$6$anon21_Then_correct) (=> (= (ControlFlow 0 326788) 326794) inline$$Roles_has_role_$def$6$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$6$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_parent_VASP_role_$def$2$$t2@1) (>= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$2$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$2$$t2@1) $MAX_U64)) (= (ControlFlow 0 327295) 326788)) inline$$Roles_has_role_$def$6$anon0_correct))))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon2$1_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$2$$t2@1 ($Integer 5)) (= (ControlFlow 0 327303) 327295)) inline$$Roles_has_role$6$anon0_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 326315) 327303)) inline$$Roles_has_parent_VASP_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon7_Then_correct  (=> (= (ControlFlow 0 327345) 327303) inline$$Roles_has_parent_VASP_role_$def$2$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$2$anon0_correct  (=> (not $abort_flag@47) (and (=> (= (ControlFlow 0 326309) 327345) inline$$Roles_has_parent_VASP_role_$def$2$anon7_Then_correct) (=> (= (ControlFlow 0 326309) 326315) inline$$Roles_has_parent_VASP_role_$def$2$anon7_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role$2$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 327351) 326309)) inline$$Roles_has_parent_VASP_role_$def$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 326081) 327351)) inline$$Roles_has_parent_VASP_role$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon19_Then_correct  (=> (= (ControlFlow 0 330051) 327351) inline$$Roles_has_parent_VASP_role$2$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$2$anon0_correct  (=> (not $abort_flag@47) (and (=> (= (ControlFlow 0 326075) 330051) inline$$Roles_can_hold_balance_$def$2$anon19_Then_correct) (=> (= (ControlFlow 0 326075) 326081) inline$$Roles_can_hold_balance_$def$2$anon19_Else_correct)))))
(let ((inline$$Roles_can_hold_balance$2$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 330057) 326075)) inline$$Roles_can_hold_balance_$def$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon36_Else_correct  (=> (and (not $abort_flag@47) (= (ControlFlow 0 330065) 330057)) inline$$Roles_can_hold_balance$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@47) (=> (and (=> $abort_flag@47 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@47 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 inline$$DiemAccount_add_currency$2$$tv0@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@58 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 325729) 331272) inline$$DiemAccount_add_currency_$def$2$anon36_Then_correct) (=> (= (ControlFlow 0 325729) 330065) inline$$DiemAccount_add_currency_$def$2$anon36_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$2$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 325693) 325729)) inline$$DiemAccount_add_currency_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon35_Then_correct  (=> (= (ControlFlow 0 331296) 325729) inline$$DiemAccount_add_currency_$def$2$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$2$anon0_correct  (=> (not $abort_flag@46) (and (=> (= (ControlFlow 0 325687) 331296) inline$$DiemAccount_add_currency_$def$2$anon35_Then_correct) (=> (= (ControlFlow 0 325687) 325693) inline$$DiemAccount_add_currency_$def$2$anon35_Else_correct)))))
(let ((inline$$DiemAccount_add_currency$2$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 331300) 325687)) inline$$DiemAccount_add_currency_$def$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currency$2$Entry_correct  (=> (and (= inline$$DiemAccount_add_currency$2$$tv0@0 $XUS_XUS_type_value) (= (ControlFlow 0 325131) 331300)) inline$$DiemAccount_add_currency$2$anon0_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$Not$3$dst@1) (= (ControlFlow 0 331306) 325131)) inline$$DiemAccount_add_currency$2$Entry_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon27_Else_correct  (=> (not (|b#$Boolean| inline$$Not$3$dst@1)) (=> (and (and (= $DiemAccount_Balance_$memory@4 $DiemAccount_Balance_$memory@1) (= $abort_flag@73 $abort_flag@46)) (and (= $abort_code@87 $abort_code@57) (= (ControlFlow 0 318750) 318820))) inline$$DiemAccount_add_currencies_for_account_$def$0$L5_correct))))
(let ((inline$$Not$3$anon0_correct  (=> (= inline$$Not$3$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currencies_for_account_$def$0$$t5@1)))) (and (=> (= (ControlFlow 0 318734) 331306) inline$$DiemAccount_add_currencies_for_account_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 318734) 318750) inline$$DiemAccount_add_currencies_for_account_$def$0$anon27_Else_correct)))))
(let ((inline$$Not$3$Entry_correct  (and (=> (= (ControlFlow 0 318724) (- 0 354375)) true) (=> (= (ControlFlow 0 318724) 318734) inline$$Not$3$anon0_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon26_Then_correct  (=> (|b#$Boolean| add_all_currencies) (=> (and (= inline$$DiemAccount_add_currencies_for_account_$def$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| call3formal@$ret0@0@@5)))) (= (ControlFlow 0 318740) 318724)) inline$$Not$3$Entry_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon26_Else_correct  (=> (not (|b#$Boolean| add_all_currencies)) (=> (and (and (= $abort_code@118 $abort_code@57) (= $DiemAccount_Balance_$memory@8 $DiemAccount_Balance_$memory@1)) (and (= $abort_flag@101 $abort_flag@46) (= (ControlFlow 0 318664) 318666))) inline$$DiemAccount_add_currencies_for_account_$def$0$L10_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Else_correct  (=> (not $abort_flag@46) (and (=> (= (ControlFlow 0 318656) 318740) inline$$DiemAccount_add_currencies_for_account_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 318656) 318664) inline$$DiemAccount_add_currencies_for_account_$def$0$anon26_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon50_Else_correct  (=> (and (and (not $abort_flag@45) (= $abort_flag@46 $abort_flag@45)) (and (= $abort_code@57 $abort_code@55) (= $DiemAccount_Balance_$memory@1 |inline$$MoveToRaw$2$m'@2|))) (and (=> (= (ControlFlow 0 318522) 331322) inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 318522) 318656) inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$Abort_correct  (=> (= $abort_flag@46 true) (=> (and (= $abort_code@57 $abort_code@56) (= $DiemAccount_Balance_$memory@1 $DiemAccount_Balance_$memory@0)) (and (=> (= (ControlFlow 0 317449) 331322) inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 317449) 318656) inline$$DiemAccount_add_currencies_for_account_$def$0$anon25_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon5_correct  (=> (= $abort_code@56 $abort_code@29) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 318622) 317449)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 318620) 318622)) inline$$DiemAccount_add_currency_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon37_Then_correct  (=> (= (ControlFlow 0 318630) 318622) inline$$DiemAccount_add_currency_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon36_Then_correct  (=> $abort_flag@21 (and (=> (= (ControlFlow 0 318614) 318630) inline$$DiemAccount_add_currency_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 318614) 318620) inline$$DiemAccount_add_currency_$def$0$anon37_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon11_correct  (=> (= $abort_code@56 $abort_code@49) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 318598) 317449)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 318596) 318598)) inline$$DiemAccount_add_currency_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 318606) 318598) inline$$DiemAccount_add_currency_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon39_Then_correct  (=> $abort_flag@40 (and (=> (= (ControlFlow 0 318590) 318606) inline$$DiemAccount_add_currency_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 318590) 318596) inline$$DiemAccount_add_currency_$def$0$anon40_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon19_correct  (=> (= $abort_code@56 $abort_code@50) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 318578) 317449)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 318576) 318578)) inline$$DiemAccount_add_currency_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 318586) 318578) inline$$DiemAccount_add_currency_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon43_Then_correct  (=> $abort_flag@41 (and (=> (= (ControlFlow 0 318570) 318586) inline$$DiemAccount_add_currency_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 318570) 318576) inline$$DiemAccount_add_currency_$def$0$anon44_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon23_correct  (=> (= $abort_code@56 $abort_code@52) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 318558) 317449)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 318556) 318558)) inline$$DiemAccount_add_currency_$def$0$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 318566) 318558) inline$$DiemAccount_add_currency_$def$0$anon23_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon45_Then_correct  (=> $abort_flag@42 (and (=> (= (ControlFlow 0 318550) 318566) inline$$DiemAccount_add_currency_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 318550) 318556) inline$$DiemAccount_add_currency_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon33_correct  (=> (= $abort_code@56 $abort_code@55) (=> (and (= $DiemAccount_Balance_$memory@0 |inline$$MoveToRaw$2$m'@2|) (= (ControlFlow 0 318534) 317449)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 318532) 318534)) inline$$DiemAccount_add_currency_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 318542) 318534) inline$$DiemAccount_add_currency_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon50_Then_correct  (=> $abort_flag@45 (and (=> (= (ControlFlow 0 318526) 318542) inline$$DiemAccount_add_currency_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 318526) 318532) inline$$DiemAccount_add_currency_$def$0$anon51_Else_correct)))))
(let ((inline$$MoveToRaw$2$anon3_Then$1_correct  (=> (= $abort_code@55 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@45 true) (= |inline$$MoveToRaw$2$m'@2| |inline$$MoveToRaw$2$m'@0|)) (and (=> (= (ControlFlow 0 318500) 318526) inline$$DiemAccount_add_currency_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 318500) 318522) inline$$DiemAccount_add_currency_$def$0$anon50_Else_correct))))))
(let ((inline$$MoveToRaw$2$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1) (= (ControlFlow 0 318498) 318500)) inline$$MoveToRaw$2$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$2$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1)) (=> (and (and (= |inline$$MoveToRaw$2$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 inline$$DiemAccount_Balance_pack$0$$struct@1))) (= $abort_code@55 $abort_code@54)) (and (= $abort_flag@45 $abort_flag@44) (= |inline$$MoveToRaw$2$m'@2| |inline$$MoveToRaw$2$m'@1|))) (and (=> (= (ControlFlow 0 318448) 318526) inline$$DiemAccount_add_currency_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 318448) 318522) inline$$DiemAccount_add_currency_$def$0$anon50_Else_correct))))))
(let ((inline$$MoveTo$2$anon0$1_correct  (=> (= inline$$MoveTo$2$a@1 (|a#$Address| new_account_address)) (and (=> (= (ControlFlow 0 318506) 318498) inline$$MoveToRaw$2$anon3_Then_correct) (=> (= (ControlFlow 0 318506) 318448) inline$$MoveToRaw$2$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$2$Entry_correct  (and (=> (= (ControlFlow 0 318294) (- 0 354069)) true) (=> (= (ControlFlow 0 318294) 318506) inline$$MoveTo$2$anon0$1_correct))))
(let ((inline$$MoveTo$2$Entry_correct  (=> (and (= inline$$MoveTo$2$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (= (ControlFlow 0 318266) 318294)) inline$$Signer_borrow_address$2$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 318168) 318266)) inline$$MoveTo$2$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 318174) 318266) inline$$MoveTo$2$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 318162) 318174) inline$$DiemAccount_Balance_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 318162) 318168) inline$$DiemAccount_Balance_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemAccount_Balance_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 318154) 318266)) inline$$MoveTo$2$Entry_correct)))
(let ((inline$$DiemAccount_Balance_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$0$$ret0@2) (let ((va@@12 (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$DiemAccount_Balance_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 318146) 318162) inline$$DiemAccount_Balance_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 318146) 318154) inline$$DiemAccount_Balance_pack$0$anon3_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon49_Else_correct  (=> (and (not $abort_flag@44) (= (ControlFlow 0 318180) 318146)) inline$$DiemAccount_Balance_pack$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon49_Then_correct  (=> (and (and $abort_flag@44 (= $abort_code@56 $abort_code@54)) (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 318546) 317449))) inline$$DiemAccount_add_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_zero_$def$0$anon3_correct  (=> (= inline$$Diem_zero_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@44 true) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_zero_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 317985) 318546) inline$$DiemAccount_add_currency_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 317985) 318180) inline$$DiemAccount_add_currency_$def$0$anon49_Else_correct))))))
(let ((inline$$Diem_zero_$def$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 317979) 317985)) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon8_Then_correct  (=> (= (ControlFlow 0 317993) 317985) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon7_Then_correct  (=> $abort_flag@43 (and (=> (= (ControlFlow 0 317973) 317993) inline$$Diem_zero_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 317973) 317979) inline$$Diem_zero_$def$0$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon6_correct  (=> (and (= $abort_flag@44 $abort_flag@43) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_Diem_pack$0$$struct@1)) (and (=> (= (ControlFlow 0 317961) 318546) inline$$DiemAccount_add_currency_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 317961) 318180) inline$$DiemAccount_add_currency_$def$0$anon49_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 317959) 317961)) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_zero_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 317969) 317961) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 317937) 317969) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 317937) 317959) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 317943) 317969) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 317943) 317959) inline$$Diem_zero_$def$0$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 317931) 317943) inline$$Diem_Diem_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 317931) 317937) inline$$Diem_Diem_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 317923) 317969) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 317923) 317959) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$0$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 317915) 317931) inline$$Diem_Diem_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 317915) 317923) inline$$Diem_Diem_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon7_Else_correct  (=> (not $abort_flag@43) (=> (and (= inline$$Diem_zero_$def$0$$t0@1 ($Integer 0)) (= (ControlFlow 0 317949) 317915)) inline$$Diem_Diem_pack$0$anon0_correct))))
(let ((inline$$Diem_zero_$def$0$anon0_correct  (=> (and (and (not $abort_flag@42) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@43)) (and (=> $abort_flag@43 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@43 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@54 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 317774) 317973) inline$$Diem_zero_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 317774) 317949) inline$$Diem_zero_$def$0$anon7_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon47_Then_correct  (=> (and (|b#$Boolean| inline$$Not$2$dst@1) (= (ControlFlow 0 318007) 317774)) inline$$Diem_zero_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon28_correct  (=> (= $abort_code@56 $abort_code@53) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 317569) 317449)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 317567) 317569)) inline$$DiemAccount_add_currency_$def$0$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 317577) 317569) inline$$DiemAccount_add_currency_$def$0$anon28_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon47_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$2$dst@1)) (= $abort_code@53 (|i#$Integer| call3formal@$ret0@0@@12))) (and (=> (= (ControlFlow 0 317561) 317577) inline$$DiemAccount_add_currency_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 317561) 317567) inline$$DiemAccount_add_currency_$def$0$anon48_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon45_Else_correct  (=> (not $abort_flag@42) (and (=> (= (ControlFlow 0 317549) 318007) inline$$DiemAccount_add_currency_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 317549) 317561) inline$$DiemAccount_add_currency_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon43_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$0$$t12@1 ($Integer 15)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@42)) (and (=> $abort_flag@42 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@42) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 317543) 318550) inline$$DiemAccount_add_currency_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 317543) 317549) inline$$DiemAccount_add_currency_$def$0$anon45_Else_correct)))))
(let ((inline$$Not$2$anon0_correct  (=> (and (= inline$$Not$2$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_add_currency_$def$0$$t10@1)))) (= (ControlFlow 0 317531) 317543)) inline$$DiemAccount_add_currency_$def$0$anon43_Else$1_correct)))
(let ((inline$$Not$2$Entry_correct  (and (=> (= (ControlFlow 0 317521) (- 0 353611)) true) (=> (= (ControlFlow 0 317521) 317531) inline$$Not$2$anon0_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon43_Else_correct  (=> (not $abort_flag@41) (=> (and (= inline$$DiemAccount_add_currency_$def$0$$t10@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@13)))) (= (ControlFlow 0 317537) 317521)) inline$$Not$2$Entry_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon41_Then_correct  (=> (|b#$Boolean| inline$$Roles_can_hold_balance_$def$0$$ret0@2) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@41) (=> $abort_flag@41 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@41) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 317463) 318570) inline$$DiemAccount_add_currency_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 317463) 317537) inline$$DiemAccount_add_currency_$def$0$anon43_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon16_correct  (=> (= $abort_code@56 $abort_code@51) (=> (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 317445) 317449)) inline$$DiemAccount_add_currency_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 317443) 317445)) inline$$DiemAccount_add_currency_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 317457) 317445) inline$$DiemAccount_add_currency_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon41_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_can_hold_balance_$def$0$$ret0@2)) (= $abort_code@51 (|i#$Integer| call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 317437) 317457) inline$$DiemAccount_add_currency_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 317437) 317443) inline$$DiemAccount_add_currency_$def$0$anon42_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon39_Else_correct  (=> (not $abort_flag@40) (and (=> (= (ControlFlow 0 317425) 317463) inline$$DiemAccount_add_currency_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 317425) 317437) inline$$DiemAccount_add_currency_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon38_Else_correct  (=> (not $abort_flag@39) (=> (and (and (and (= inline$$DiemAccount_add_currency_$def$0$$t8@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@40)) (and (=> $abort_flag@40 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@40) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@14) (>= (|i#$Integer| call3formal@$ret0@0@@14) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@14) $MAX_U64))) (and (=> (= (ControlFlow 0 317419) 318590) inline$$DiemAccount_add_currency_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 317419) 317425) inline$$DiemAccount_add_currency_$def$0$anon39_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon38_Then_correct  (=> (and (and $abort_flag@39 (= $abort_code@56 $abort_code@48)) (and (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory) (= (ControlFlow 0 318610) 317449))) inline$$DiemAccount_add_currency_$def$0$Abort_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$Abort_correct  (=> (and (and (= inline$$Roles_can_hold_balance_$def$0$$ret0@1 $Error) (= $abort_code@48 $abort_code@46)) (and (= inline$$Roles_can_hold_balance_$def$0$$ret0@2 inline$$Roles_can_hold_balance_$def$0$$ret0@1) (= $abort_flag@39 true))) (and (=> (= (ControlFlow 0 317257) 318610) inline$$DiemAccount_add_currency_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 317257) 317419) inline$$DiemAccount_add_currency_$def$0$anon38_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon26_Then_correct  (=> $abort_flag@37 (=> (and (= $abort_code@46 $abort_code@45) (= (ControlFlow 0 317251) 317257)) inline$$Roles_can_hold_balance_$def$0$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon23_Then_correct  (=> $abort_flag@31 (=> (and (= $abort_code@46 $abort_code@39) (= (ControlFlow 0 317321) 317257)) inline$$Roles_can_hold_balance_$def$0$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon20_Then_correct  (=> $abort_flag@26 (=> (and (= $abort_code@46 $abort_code@34) (= (ControlFlow 0 317385) 317257)) inline$$Roles_can_hold_balance_$def$0$Abort_correct))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon18_correct  (=> (= $abort_code@48 $abort_code@47) (=> (and (= inline$$Roles_can_hold_balance_$def$0$$ret0@2 |inline$$Roles_can_hold_balance_$def$0$tmp#$2@1|) (= $abort_flag@39 $abort_flag@38)) (and (=> (= (ControlFlow 0 317239) 318610) inline$$DiemAccount_add_currency_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 317239) 317419) inline$$DiemAccount_add_currency_$def$0$anon38_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 317237) 317239)) inline$$Roles_can_hold_balance_$def$0$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 317247) 317239) inline$$Roles_can_hold_balance_$def$0$anon18_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon14_correct  (=> (= $abort_flag@38 $abort_flag@32) (=> (and (= |inline$$Roles_can_hold_balance_$def$0$tmp#$2@1| inline$$Roles_can_hold_balance_$def$0$$t6@1) (= $abort_code@47 $abort_code@40)) (and (=> (= (ControlFlow 0 317309) 317247) inline$$Roles_can_hold_balance_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 317309) 317237) inline$$Roles_can_hold_balance_$def$0$anon27_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 317307) 317309)) inline$$Roles_can_hold_balance_$def$0$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 317317) 317309) inline$$Roles_can_hold_balance_$def$0$anon14_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon24_Then_correct  (=> (and (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1|) (= inline$$Roles_can_hold_balance_$def$0$$t6@1 ($Boolean true))) (and (=> (= (ControlFlow 0 317299) 317317) inline$$Roles_can_hold_balance_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 317299) 317307) inline$$Roles_can_hold_balance_$def$0$anon25_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon26_Else_correct  (=> (and (and (not $abort_flag@37) (= $abort_flag@38 $abort_flag@37)) (and (= |inline$$Roles_can_hold_balance_$def$0$tmp#$2@1| inline$$Roles_has_designated_dealer_role_$def$0$$ret0@2) (= $abort_code@47 $abort_code@45))) (and (=> (= (ControlFlow 0 317227) 317247) inline$$Roles_can_hold_balance_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 317227) 317237) inline$$Roles_can_hold_balance_$def$0$anon27_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon6_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$2$$ret0@2) (= $abort_flag@37 $abort_flag@36)) (and (=> (= (ControlFlow 0 317181) 317251) inline$$Roles_can_hold_balance_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 317181) 317227) inline$$Roles_can_hold_balance_$def$0$anon26_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 317179) 317181)) inline$$Roles_has_designated_dealer_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 317189) 317181) inline$$Roles_has_designated_dealer_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@36) (and (=> (= (ControlFlow 0 317173) 317189) inline$$Roles_has_designated_dealer_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 317173) 317179) inline$$Roles_has_designated_dealer_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon8_Then_correct  (=> (and (and $abort_flag@36 (= inline$$Roles_has_designated_dealer_role_$def$0$$ret0@1 $Error)) (and (= inline$$Roles_has_designated_dealer_role_$def$0$$ret0@2 inline$$Roles_has_designated_dealer_role_$def$0$$ret0@1) (= $abort_flag@37 true))) (and (=> (= (ControlFlow 0 317197) 317251) inline$$Roles_can_hold_balance_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 317197) 317227) inline$$Roles_can_hold_balance_$def$0$anon26_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$2$$ret0@1 $Error) (= $abort_flag@36 true)) (and (= $abort_code@45 $abort_code@44) (= inline$$Roles_has_role_$def$2$$ret0@2 inline$$Roles_has_role_$def$2$$ret0@1))) (and (=> (= (ControlFlow 0 317105) 317197) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 317105) 317173) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon7_correct  (=> (and (= $abort_code@44 $abort_code@41) (= (ControlFlow 0 317125) 317105)) inline$$Roles_has_role_$def$2$Abort_correct)))
(let ((inline$$Roles_has_role_$def$2$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 317123) 317125)) inline$$Roles_has_role_$def$2$anon7_correct)))
(let ((inline$$Roles_has_role_$def$2$anon24_Then_correct  (=> (= (ControlFlow 0 317133) 317125) inline$$Roles_has_role_$def$2$anon7_correct)))
(let ((inline$$Roles_has_role_$def$2$anon23_Then_correct  (=> $abort_flag@33 (and (=> (= (ControlFlow 0 317117) 317133) inline$$Roles_has_role_$def$2$anon24_Then_correct) (=> (= (ControlFlow 0 317117) 317123) inline$$Roles_has_role_$def$2$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon13_correct  (=> (and (= $abort_code@44 $abort_code@42) (= (ControlFlow 0 317099) 317105)) inline$$Roles_has_role_$def$2$Abort_correct)))
(let ((inline$$Roles_has_role_$def$2$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 317097) 317099)) inline$$Roles_has_role_$def$2$anon13_correct)))
(let ((inline$$Roles_has_role_$def$2$anon27_Then_correct  (=> (= (ControlFlow 0 317113) 317099) inline$$Roles_has_role_$def$2$anon13_correct)))
(let ((inline$$Roles_has_role_$def$2$anon26_Then_correct  (=> $abort_flag@34 (and (=> (= (ControlFlow 0 317091) 317113) inline$$Roles_has_role_$def$2$anon27_Then_correct) (=> (= (ControlFlow 0 317091) 317097) inline$$Roles_has_role_$def$2$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon20_correct  (=> (= $abort_flag@36 $abort_flag@35) (=> (and (= $abort_code@45 $abort_code@43) (= inline$$Roles_has_role_$def$2$$ret0@2 |inline$$Roles_has_role_$def$2$tmp#$3@2|)) (and (=> (= (ControlFlow 0 316812) 317197) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 316812) 317173) inline$$Roles_has_designated_dealer_role_$def$0$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$2$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 316810) 316812)) inline$$Roles_has_role_$def$2$anon20_correct)))
(let ((inline$$Roles_has_role_$def$2$anon30_Then_correct  (=> (= (ControlFlow 0 316820) 316812) inline$$Roles_has_role_$def$2$anon20_correct)))
(let ((inline$$Roles_has_role_$def$2$anon16_correct  (=> (= $abort_code@43 $abort_code@42) (=> (and (= |inline$$Roles_has_role_$def$2$tmp#$3@2| |inline$$Roles_has_role_$def$2$tmp#$3@1|) (= $abort_flag@35 $abort_flag@34)) (and (=> (= (ControlFlow 0 317079) 316820) inline$$Roles_has_role_$def$2$anon30_Then_correct) (=> (= (ControlFlow 0 317079) 316810) inline$$Roles_has_role_$def$2$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$2$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 317077) 317079)) inline$$Roles_has_role_$def$2$anon16_correct)))
(let ((inline$$Roles_has_role_$def$2$anon28_Then_correct  (=> (= (ControlFlow 0 317087) 317079) inline$$Roles_has_role_$def$2$anon16_correct)))
(let ((inline$$Roles_has_role_$def$2$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$2$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$2$dst@1 inline$$Roles_has_designated_dealer_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 317071) 317087) inline$$Roles_has_role_$def$2$anon28_Then_correct) (=> (= (ControlFlow 0 317071) 317077) inline$$Roles_has_role_$def$2$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (and (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$2$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 317055) 317071)) inline$$Roles_has_role_$def$2$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$2$anon26_Else_correct  (=> (and (not $abort_flag@34) (= (ControlFlow 0 317061) 317055)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$GetGlobal$2$anon3_Then$1_correct  (=> (= $abort_flag@34 true) (=> (and (= $abort_code@42 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$2$dst@2 inline$$GetGlobal$2$dst@0)) (and (=> (= (ControlFlow 0 317001) 317091) inline$$Roles_has_role_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 317001) 317061) inline$$Roles_has_role_$def$2$anon26_Else_correct))))))
(let ((inline$$GetGlobal$2$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$2$a@1)) (= (ControlFlow 0 316999) 317001)) inline$$GetGlobal$2$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$2$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$2$a@1) (=> (and (and (= inline$$GetGlobal$2$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@15))) (= $abort_flag@34 $abort_flag@33)) (and (= $abort_code@42 $abort_code@41) (= inline$$GetGlobal$2$dst@2 inline$$GetGlobal$2$dst@1))) (and (=> (= (ControlFlow 0 316947) 317091) inline$$Roles_has_role_$def$2$anon26_Then_correct) (=> (= (ControlFlow 0 316947) 317061) inline$$Roles_has_role_$def$2$anon26_Else_correct))))))
(let ((inline$$GetGlobal$2$anon0_correct  (=> (= inline$$GetGlobal$2$a@1 (|a#$Address| call3formal@$ret0@0@@15)) (and (=> (= (ControlFlow 0 316929) 316999) inline$$GetGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 316929) 316947) inline$$GetGlobal$2$anon3_Else_correct)))))
(let ((inline$$GetGlobal$2$Entry_correct  (and (=> (= (ControlFlow 0 316923) (- 0 353017)) true) (=> (= (ControlFlow 0 316923) 316929) inline$$GetGlobal$2$anon0_correct))))
(let ((inline$$Roles_has_role_$def$2$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$2$$t6@1) (= (ControlFlow 0 317007) 316923)) inline$$GetGlobal$2$Entry_correct)))
(let ((inline$$Roles_has_role_$def$2$anon18_correct  (=> (= $abort_code@43 $abort_code@41) (=> (and (= |inline$$Roles_has_role_$def$2$tmp#$3@2| inline$$Roles_has_role_$def$2$$t9@1) (= $abort_flag@35 $abort_flag@33)) (and (=> (= (ControlFlow 0 316800) 316820) inline$$Roles_has_role_$def$2$anon30_Then_correct) (=> (= (ControlFlow 0 316800) 316810) inline$$Roles_has_role_$def$2$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$2$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 316798) 316800)) inline$$Roles_has_role_$def$2$anon18_correct)))
(let ((inline$$Roles_has_role_$def$2$anon29_Then_correct  (=> (= (ControlFlow 0 316828) 316800) inline$$Roles_has_role_$def$2$anon18_correct)))
(let ((inline$$Roles_has_role_$def$2$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$2$$t6@1)) (= inline$$Roles_has_role_$def$2$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 316790) 316828) inline$$Roles_has_role_$def$2$anon29_Then_correct) (=> (= (ControlFlow 0 316790) 316798) inline$$Roles_has_role_$def$2$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon23_Else_correct  (=> (and (not $abort_flag@33) (= inline$$Roles_has_role_$def$2$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@15))))) (and (=> (= (ControlFlow 0 316746) 317007) inline$$Roles_has_role_$def$2$anon25_Then_correct) (=> (= (ControlFlow 0 316746) 316790) inline$$Roles_has_role_$def$2$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@33) (=> $abort_flag@33 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 316732) 317117) inline$$Roles_has_role_$def$2$anon23_Then_correct) (=> (= (ControlFlow 0 316732) 316746) inline$$Roles_has_role_$def$2$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 316662) 316732)) inline$$Roles_has_role_$def$2$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$2$anon22_Then_correct  (=> (= (ControlFlow 0 317141) 316732) inline$$Roles_has_role_$def$2$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$2$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 316654) 317141) inline$$Roles_has_role_$def$2$anon22_Then_correct) (=> (= (ControlFlow 0 316654) 316662) inline$$Roles_has_role_$def$2$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$2$anon21_Then_correct  (and (=> (= (ControlFlow 0 317149) 317141) inline$$Roles_has_role_$def$2$anon22_Then_correct) (=> (= (ControlFlow 0 317149) 316662) inline$$Roles_has_role_$def$2$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$2$anon0_correct  (=> (not $abort_flag@32) (and (=> (= (ControlFlow 0 316648) 317149) inline$$Roles_has_role_$def$2$anon21_Then_correct) (=> (= (ControlFlow 0 316648) 316654) inline$$Roles_has_role_$def$2$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$2$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_designated_dealer_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_designated_dealer_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 317155) 316648)) inline$$Roles_has_role_$def$2$anon0_correct))))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_designated_dealer_role_$def$0$$t2@1 ($Integer 2)) (= (ControlFlow 0 317163) 317155)) inline$$Roles_has_role$2$anon0_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 316175) 317163)) inline$$Roles_has_designated_dealer_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 317205) 317163) inline$$Roles_has_designated_dealer_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_designated_dealer_role_$def$0$anon0_correct  (=> (not $abort_flag@32) (and (=> (= (ControlFlow 0 316169) 317205) inline$$Roles_has_designated_dealer_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 316169) 316175) inline$$Roles_has_designated_dealer_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_designated_dealer_role$0$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 317211) 316169)) inline$$Roles_has_designated_dealer_role_$def$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon24_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1|)) (= (ControlFlow 0 317219) 317211)) inline$$Roles_has_designated_dealer_role$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon8_correct  (=> (= $abort_code@40 $abort_code@34) (=> (and (= |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1| inline$$Roles_can_hold_balance_$def$0$$t5@1) (= $abort_flag@32 $abort_flag@26)) (and (=> (= (ControlFlow 0 317373) 317299) inline$$Roles_can_hold_balance_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 317373) 317219) inline$$Roles_can_hold_balance_$def$0$anon24_Else_correct))))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 317371) 317373)) inline$$Roles_can_hold_balance_$def$0$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 317381) 317373) inline$$Roles_can_hold_balance_$def$0$anon8_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon21_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2) (= inline$$Roles_can_hold_balance_$def$0$$t5@1 ($Boolean true))) (and (=> (= (ControlFlow 0 317363) 317381) inline$$Roles_can_hold_balance_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 317363) 317371) inline$$Roles_can_hold_balance_$def$0$anon22_Else_correct)))))
(let ((inline$$Roles_can_hold_balance_$def$0$anon23_Else_correct  (=> (and (and (not $abort_flag@31) (= $abort_code@40 $abort_code@39)) (and (= |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1| inline$$Roles_has_child_VASP_role_$def$0$$ret0@2) (= $abort_flag@32 $abort_flag@31))) (and (=> (= (ControlFlow 0 315967) 317299) inline$$Roles_can_hold_balance_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 315967) 317219) inline$$Roles_can_hold_balance_$def$0$anon24_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon6_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$1$$ret0@2) (= $abort_flag@31 $abort_flag@30)) (and (=> (= (ControlFlow 0 315921) 317321) inline$$Roles_can_hold_balance_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 315921) 315967) inline$$Roles_can_hold_balance_$def$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 315919) 315921)) inline$$Roles_has_child_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 315929) 315921) inline$$Roles_has_child_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@30) (and (=> (= (ControlFlow 0 315913) 315929) inline$$Roles_has_child_VASP_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 315913) 315919) inline$$Roles_has_child_VASP_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon8_Then_correct  (=> (and (and $abort_flag@30 (= inline$$Roles_has_child_VASP_role_$def$0$$ret0@1 $Error)) (and (= inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 inline$$Roles_has_child_VASP_role_$def$0$$ret0@1) (= $abort_flag@31 true))) (and (=> (= (ControlFlow 0 315937) 317321) inline$$Roles_can_hold_balance_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 315937) 315967) inline$$Roles_can_hold_balance_$def$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$1$$ret0@1 $Error) (= $abort_flag@30 true)) (and (= $abort_code@39 $abort_code@38) (= inline$$Roles_has_role_$def$1$$ret0@2 inline$$Roles_has_role_$def$1$$ret0@1))) (and (=> (= (ControlFlow 0 315845) 315937) inline$$Roles_has_child_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 315845) 315913) inline$$Roles_has_child_VASP_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon7_correct  (=> (and (= $abort_code@38 $abort_code@35) (= (ControlFlow 0 315865) 315845)) inline$$Roles_has_role_$def$1$Abort_correct)))
(let ((inline$$Roles_has_role_$def$1$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 315863) 315865)) inline$$Roles_has_role_$def$1$anon7_correct)))
(let ((inline$$Roles_has_role_$def$1$anon24_Then_correct  (=> (= (ControlFlow 0 315873) 315865) inline$$Roles_has_role_$def$1$anon7_correct)))
(let ((inline$$Roles_has_role_$def$1$anon23_Then_correct  (=> $abort_flag@27 (and (=> (= (ControlFlow 0 315857) 315873) inline$$Roles_has_role_$def$1$anon24_Then_correct) (=> (= (ControlFlow 0 315857) 315863) inline$$Roles_has_role_$def$1$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon13_correct  (=> (and (= $abort_code@38 $abort_code@36) (= (ControlFlow 0 315839) 315845)) inline$$Roles_has_role_$def$1$Abort_correct)))
(let ((inline$$Roles_has_role_$def$1$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 315837) 315839)) inline$$Roles_has_role_$def$1$anon13_correct)))
(let ((inline$$Roles_has_role_$def$1$anon27_Then_correct  (=> (= (ControlFlow 0 315853) 315839) inline$$Roles_has_role_$def$1$anon13_correct)))
(let ((inline$$Roles_has_role_$def$1$anon26_Then_correct  (=> $abort_flag@28 (and (=> (= (ControlFlow 0 315831) 315853) inline$$Roles_has_role_$def$1$anon27_Then_correct) (=> (= (ControlFlow 0 315831) 315837) inline$$Roles_has_role_$def$1$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon20_correct  (=> (= $abort_flag@30 $abort_flag@29) (=> (and (= $abort_code@39 $abort_code@37) (= inline$$Roles_has_role_$def$1$$ret0@2 |inline$$Roles_has_role_$def$1$tmp#$3@2|)) (and (=> (= (ControlFlow 0 315552) 315937) inline$$Roles_has_child_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 315552) 315913) inline$$Roles_has_child_VASP_role_$def$0$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$1$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 315550) 315552)) inline$$Roles_has_role_$def$1$anon20_correct)))
(let ((inline$$Roles_has_role_$def$1$anon30_Then_correct  (=> (= (ControlFlow 0 315560) 315552) inline$$Roles_has_role_$def$1$anon20_correct)))
(let ((inline$$Roles_has_role_$def$1$anon16_correct  (=> (= $abort_flag@29 $abort_flag@28) (=> (and (= |inline$$Roles_has_role_$def$1$tmp#$3@2| |inline$$Roles_has_role_$def$1$tmp#$3@1|) (= $abort_code@37 $abort_code@36)) (and (=> (= (ControlFlow 0 315819) 315560) inline$$Roles_has_role_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 315819) 315550) inline$$Roles_has_role_$def$1$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$1$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 315817) 315819)) inline$$Roles_has_role_$def$1$anon16_correct)))
(let ((inline$$Roles_has_role_$def$1$anon28_Then_correct  (=> (= (ControlFlow 0 315827) 315819) inline$$Roles_has_role_$def$1$anon16_correct)))
(let ((inline$$Roles_has_role_$def$1$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$1$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$1$dst@1 inline$$Roles_has_child_VASP_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 315811) 315827) inline$$Roles_has_role_$def$1$anon28_Then_correct) (=> (= (ControlFlow 0 315811) 315817) inline$$Roles_has_role_$def$1$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (and (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$1$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 315795) 315811)) inline$$Roles_has_role_$def$1$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$1$anon26_Else_correct  (=> (and (not $abort_flag@28) (= (ControlFlow 0 315801) 315795)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$GetGlobal$1$anon3_Then$1_correct  (=> (= $abort_code@36 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@28 true) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 315741) 315831) inline$$Roles_has_role_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 315741) 315801) inline$$Roles_has_role_$def$1$anon26_Else_correct))))))
(let ((inline$$GetGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$1$a@1)) (= (ControlFlow 0 315739) 315741)) inline$$GetGlobal$1$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$1$a@1) (=> (and (and (= inline$$GetGlobal$1$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@16))) (= $abort_code@36 $abort_code@35)) (and (= $abort_flag@28 $abort_flag@27) (= inline$$GetGlobal$1$dst@2 inline$$GetGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 315687) 315831) inline$$Roles_has_role_$def$1$anon26_Then_correct) (=> (= (ControlFlow 0 315687) 315801) inline$$Roles_has_role_$def$1$anon26_Else_correct))))))
(let ((inline$$GetGlobal$1$anon0_correct  (=> (= inline$$GetGlobal$1$a@1 (|a#$Address| call3formal@$ret0@0@@16)) (and (=> (= (ControlFlow 0 315669) 315739) inline$$GetGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 315669) 315687) inline$$GetGlobal$1$anon3_Else_correct)))))
(let ((inline$$GetGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 315663) (- 0 352374)) true) (=> (= (ControlFlow 0 315663) 315669) inline$$GetGlobal$1$anon0_correct))))
(let ((inline$$Roles_has_role_$def$1$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$1$$t6@1) (= (ControlFlow 0 315747) 315663)) inline$$GetGlobal$1$Entry_correct)))
(let ((inline$$Roles_has_role_$def$1$anon18_correct  (=> (= $abort_flag@29 $abort_flag@27) (=> (and (= |inline$$Roles_has_role_$def$1$tmp#$3@2| inline$$Roles_has_role_$def$1$$t9@1) (= $abort_code@37 $abort_code@35)) (and (=> (= (ControlFlow 0 315540) 315560) inline$$Roles_has_role_$def$1$anon30_Then_correct) (=> (= (ControlFlow 0 315540) 315550) inline$$Roles_has_role_$def$1$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$1$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 315538) 315540)) inline$$Roles_has_role_$def$1$anon18_correct)))
(let ((inline$$Roles_has_role_$def$1$anon29_Then_correct  (=> (= (ControlFlow 0 315568) 315540) inline$$Roles_has_role_$def$1$anon18_correct)))
(let ((inline$$Roles_has_role_$def$1$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$1$$t6@1)) (= inline$$Roles_has_role_$def$1$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 315530) 315568) inline$$Roles_has_role_$def$1$anon29_Then_correct) (=> (= (ControlFlow 0 315530) 315538) inline$$Roles_has_role_$def$1$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon23_Else_correct  (=> (and (not $abort_flag@27) (= inline$$Roles_has_role_$def$1$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@16))))) (and (=> (= (ControlFlow 0 315486) 315747) inline$$Roles_has_role_$def$1$anon25_Then_correct) (=> (= (ControlFlow 0 315486) 315530) inline$$Roles_has_role_$def$1$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@27) (=> $abort_flag@27 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@27) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 315472) 315857) inline$$Roles_has_role_$def$1$anon23_Then_correct) (=> (= (ControlFlow 0 315472) 315486) inline$$Roles_has_role_$def$1$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 315402) 315472)) inline$$Roles_has_role_$def$1$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$1$anon22_Then_correct  (=> (= (ControlFlow 0 315881) 315472) inline$$Roles_has_role_$def$1$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$1$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 315394) 315881) inline$$Roles_has_role_$def$1$anon22_Then_correct) (=> (= (ControlFlow 0 315394) 315402) inline$$Roles_has_role_$def$1$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$1$anon21_Then_correct  (and (=> (= (ControlFlow 0 315889) 315881) inline$$Roles_has_role_$def$1$anon22_Then_correct) (=> (= (ControlFlow 0 315889) 315402) inline$$Roles_has_role_$def$1$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$1$anon0_correct  (=> (not $abort_flag@26) (and (=> (= (ControlFlow 0 315388) 315889) inline$$Roles_has_role_$def$1$anon21_Then_correct) (=> (= (ControlFlow 0 315388) 315394) inline$$Roles_has_role_$def$1$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$1$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_child_VASP_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_child_VASP_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 315895) 315388)) inline$$Roles_has_role_$def$1$anon0_correct))))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_child_VASP_role_$def$0$$t2@1 ($Integer 6)) (= (ControlFlow 0 315903) 315895)) inline$$Roles_has_role$1$anon0_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 314915) 315903)) inline$$Roles_has_child_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 315945) 315903) inline$$Roles_has_child_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_child_VASP_role_$def$0$anon0_correct  (=> (not $abort_flag@26) (and (=> (= (ControlFlow 0 314909) 315945) inline$$Roles_has_child_VASP_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 314909) 314915) inline$$Roles_has_child_VASP_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_child_VASP_role$0$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 315951) 314909)) inline$$Roles_has_child_VASP_role_$def$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon21_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2)) (= (ControlFlow 0 315959) 315951)) inline$$Roles_has_child_VASP_role$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon20_Else_correct  (=> (not $abort_flag@26) (and (=> (= (ControlFlow 0 314709) 317363) inline$$Roles_can_hold_balance_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 314709) 315959) inline$$Roles_can_hold_balance_$def$0$anon21_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon6_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$0$$ret0@2) (= $abort_flag@26 $abort_flag@25)) (and (=> (= (ControlFlow 0 314663) 317385) inline$$Roles_can_hold_balance_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 314663) 314709) inline$$Roles_can_hold_balance_$def$0$anon20_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 314661) 314663)) inline$$Roles_has_parent_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 314671) 314663) inline$$Roles_has_parent_VASP_role_$def$0$anon6_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon8_Else_correct  (=> (not $abort_flag@25) (and (=> (= (ControlFlow 0 314655) 314671) inline$$Roles_has_parent_VASP_role_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 314655) 314661) inline$$Roles_has_parent_VASP_role_$def$0$anon9_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon8_Then_correct  (=> (and (and $abort_flag@25 (= inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1 $Error)) (and (= inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1) (= $abort_flag@26 true))) (and (=> (= (ControlFlow 0 314679) 317385) inline$$Roles_can_hold_balance_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 314679) 314709) inline$$Roles_can_hold_balance_$def$0$anon20_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$Abort_correct  (=> (and (and (= inline$$Roles_has_role_$def$0$$ret0@1 $Error) (= $abort_flag@25 true)) (and (= $abort_code@34 $abort_code@33) (= inline$$Roles_has_role_$def$0$$ret0@2 inline$$Roles_has_role_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 314587) 314679) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 314587) 314655) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon7_correct  (=> (and (= $abort_code@33 $abort_code@30) (= (ControlFlow 0 314607) 314587)) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 314605) 314607)) inline$$Roles_has_role_$def$0$anon7_correct)))
(let ((inline$$Roles_has_role_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 314615) 314607) inline$$Roles_has_role_$def$0$anon7_correct)))
(let ((inline$$Roles_has_role_$def$0$anon23_Then_correct  (=> $abort_flag@22 (and (=> (= (ControlFlow 0 314599) 314615) inline$$Roles_has_role_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 314599) 314605) inline$$Roles_has_role_$def$0$anon24_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon13_correct  (=> (and (= $abort_code@33 $abort_code@31) (= (ControlFlow 0 314581) 314587)) inline$$Roles_has_role_$def$0$Abort_correct)))
(let ((inline$$Roles_has_role_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 314579) 314581)) inline$$Roles_has_role_$def$0$anon13_correct)))
(let ((inline$$Roles_has_role_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 314595) 314581) inline$$Roles_has_role_$def$0$anon13_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Then_correct  (=> $abort_flag@23 (and (=> (= (ControlFlow 0 314573) 314595) inline$$Roles_has_role_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 314573) 314579) inline$$Roles_has_role_$def$0$anon27_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon20_correct  (=> (= $abort_flag@25 $abort_flag@24) (=> (and (= $abort_code@34 $abort_code@32) (= inline$$Roles_has_role_$def$0$$ret0@2 |inline$$Roles_has_role_$def$0$tmp#$3@2|)) (and (=> (= (ControlFlow 0 314294) 314679) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 314294) 314655) inline$$Roles_has_parent_VASP_role_$def$0$anon8_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 314292) 314294)) inline$$Roles_has_role_$def$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 314302) 314294) inline$$Roles_has_role_$def$0$anon20_correct)))
(let ((inline$$Roles_has_role_$def$0$anon16_correct  (=> (= $abort_code@32 $abort_code@31) (=> (and (= |inline$$Roles_has_role_$def$0$tmp#$3@2| |inline$$Roles_has_role_$def$0$tmp#$3@1|) (= $abort_flag@24 $abort_flag@23)) (and (=> (= (ControlFlow 0 314561) 314302) inline$$Roles_has_role_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 314561) 314292) inline$$Roles_has_role_$def$0$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 314559) 314561)) inline$$Roles_has_role_$def$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 314569) 314561) inline$$Roles_has_role_$def$0$anon16_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else$1_correct  (=> (= |inline$$Roles_has_role_$def$0$tmp#$3@1| ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$0$dst@1 inline$$Roles_has_parent_VASP_role_$def$0$$t2@1))) (and (=> (= (ControlFlow 0 314553) 314569) inline$$Roles_has_role_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 314553) 314559) inline$$Roles_has_role_$def$0$anon28_Else_correct)))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $Roles_RoleId_role_id)) (= (ControlFlow 0 314537) 314553)) inline$$Roles_has_role_$def$0$anon26_Else$1_correct)))
(let ((inline$$Roles_has_role_$def$0$anon26_Else_correct  (=> (and (not $abort_flag@23) (= (ControlFlow 0 314543) 314537)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@23 true) (=> (and (= $abort_code@31 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 314483) 314573) inline$$Roles_has_role_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 314483) 314543) inline$$Roles_has_role_$def$0$anon26_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 314481) 314483)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@17))) (= $abort_flag@23 $abort_flag@22)) (and (= $abort_code@31 $abort_code@30) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 314429) 314573) inline$$Roles_has_role_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 314429) 314543) inline$$Roles_has_role_$def$0$anon26_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@17)) (and (=> (= (ControlFlow 0 314411) 314481) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 314411) 314429) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 314405) (- 0 351778)) true) (=> (= (ControlFlow 0 314405) 314411) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$Roles_has_role_$def$0$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1) (= (ControlFlow 0 314489) 314405)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$Roles_has_role_$def$0$anon18_correct  (=> (= $abort_code@32 $abort_code@30) (=> (and (= |inline$$Roles_has_role_$def$0$tmp#$3@2| inline$$Roles_has_role_$def$0$$t9@1) (= $abort_flag@24 $abort_flag@22)) (and (=> (= (ControlFlow 0 314282) 314302) inline$$Roles_has_role_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 314282) 314292) inline$$Roles_has_role_$def$0$anon30_Else_correct))))))
(let ((inline$$Roles_has_role_$def$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 314280) 314282)) inline$$Roles_has_role_$def$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def$0$anon29_Then_correct  (=> (= (ControlFlow 0 314310) 314282) inline$$Roles_has_role_$def$0$anon18_correct)))
(let ((inline$$Roles_has_role_$def$0$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Roles_has_role_$def$0$$t6@1)) (= inline$$Roles_has_role_$def$0$$t9@1 ($Boolean false))) (and (=> (= (ControlFlow 0 314272) 314310) inline$$Roles_has_role_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 314272) 314280) inline$$Roles_has_role_$def$0$anon29_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon23_Else_correct  (=> (and (not $abort_flag@22) (= inline$$Roles_has_role_$def$0$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@17))))) (and (=> (= (ControlFlow 0 314228) 314489) inline$$Roles_has_role_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 314228) 314272) inline$$Roles_has_role_$def$0$anon25_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@22) (=> $abort_flag@22 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@17))) (and (=> (= (ControlFlow 0 314214) 314599) inline$$Roles_has_role_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 314214) 314228) inline$$Roles_has_role_$def$0$anon23_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 314144) 314214)) inline$$Roles_has_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 314623) 314214) inline$$Roles_has_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_has_role_$def$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 314136) 314623) inline$$Roles_has_role_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 314136) 314144) inline$$Roles_has_role_$def$0$anon22_Else_correct)))))
(let ((inline$$Roles_has_role_$def$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 314631) 314623) inline$$Roles_has_role_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 314631) 314144) inline$$Roles_has_role_$def$0$anon22_Else_correct))))
(let ((inline$$Roles_has_role_$def$0$anon0_correct  (=> (not $abort_flag@21) (and (=> (= (ControlFlow 0 314130) 314631) inline$$Roles_has_role_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 314130) 314136) inline$$Roles_has_role_$def$0$anon21_Else_correct)))))
(let ((inline$$Roles_has_role$0$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and (and (and ((_ is $Integer) inline$$Roles_has_parent_VASP_role_$def$0$$t2@1) (>= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$0$$t2@1) 0)) (<= (|i#$Integer| inline$$Roles_has_parent_VASP_role_$def$0$$t2@1) $MAX_U64)) (= (ControlFlow 0 314637) 314130)) inline$$Roles_has_role_$def$0$anon0_correct))))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon2$1_correct  (=> (and (= inline$$Roles_has_parent_VASP_role_$def$0$$t2@1 ($Integer 5)) (= (ControlFlow 0 314645) 314637)) inline$$Roles_has_role$0$anon0_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 313657) 314645)) inline$$Roles_has_parent_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon7_Then_correct  (=> (= (ControlFlow 0 314687) 314645) inline$$Roles_has_parent_VASP_role_$def$0$anon2$1_correct)))
(let ((inline$$Roles_has_parent_VASP_role_$def$0$anon0_correct  (=> (not $abort_flag@21) (and (=> (= (ControlFlow 0 313651) 314687) inline$$Roles_has_parent_VASP_role_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 313651) 313657) inline$$Roles_has_parent_VASP_role_$def$0$anon7_Else_correct)))))
(let ((inline$$Roles_has_parent_VASP_role$0$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 314693) 313651)) inline$$Roles_has_parent_VASP_role_$def$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 313423) 314693)) inline$$Roles_has_parent_VASP_role$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 317393) 314693) inline$$Roles_has_parent_VASP_role$0$anon0_correct)))
(let ((inline$$Roles_can_hold_balance_$def$0$anon0_correct  (=> (not $abort_flag@21) (and (=> (= (ControlFlow 0 313417) 317393) inline$$Roles_can_hold_balance_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 313417) 313423) inline$$Roles_can_hold_balance_$def$0$anon19_Else_correct)))))
(let ((inline$$Roles_can_hold_balance$0$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 317399) 313417)) inline$$Roles_can_hold_balance_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon36_Else_correct  (=> (and (not $abort_flag@21) (= (ControlFlow 0 317407) 317399)) inline$$Roles_can_hold_balance$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21) (=> (and (=> $abort_flag@21 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@21 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@29 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 313071) 318614) inline$$DiemAccount_add_currency_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 313071) 317407) inline$$DiemAccount_add_currency_$def$0$anon36_Else_correct))))))
(let ((inline$$DiemAccount_add_currency_$def$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 313035) 313071)) inline$$DiemAccount_add_currency_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon35_Then_correct  (=> (= (ControlFlow 0 318638) 313071) inline$$DiemAccount_add_currency_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_add_currency_$def$0$anon0_correct  (=> (not $abort_flag@20) (and (=> (= (ControlFlow 0 313029) 318638) inline$$DiemAccount_add_currency_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 313029) 313035) inline$$DiemAccount_add_currency_$def$0$anon35_Else_correct)))))
(let ((inline$$DiemAccount_add_currency$0$anon0_correct  (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 318642) 313029)) inline$$DiemAccount_add_currency_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon23_Else_correct  (=> (and (not $abort_flag@20) (= (ControlFlow 0 318648) 318642)) inline$$DiemAccount_add_currency$0$anon0_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@20) (=> $abort_flag@20 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 312419) 331326) inline$$DiemAccount_add_currencies_for_account_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 312419) 318648) inline$$DiemAccount_add_currencies_for_account_$def$0$anon23_Else_correct)))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 312349) 312419)) inline$$DiemAccount_add_currencies_for_account_$def$0$anon4$2_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 331350) 312419) inline$$DiemAccount_add_currencies_for_account_$def$0$anon4$2_correct)))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 312341) 331350) inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 312341) 312349) inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Else_correct)))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 331358) 331350) inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 331358) 312349) inline$$DiemAccount_add_currencies_for_account_$def$0$anon22_Else_correct))))
(let ((inline$$DiemAccount_add_currencies_for_account_$def$0$anon0_correct  (=> (not $abort_flag@19) (and (=> (= (ControlFlow 0 312335) 331358) inline$$DiemAccount_add_currencies_for_account_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 312335) 312341) inline$$DiemAccount_add_currencies_for_account_$def$0$anon21_Else_correct)))))
(let ((inline$$DiemAccount_add_currencies_for_account$0$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and ((_ is $Boolean) add_all_currencies) (= (ControlFlow 0 331362) 312335)) inline$$DiemAccount_add_currencies_for_account_$def$0$anon0_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon42_Else_correct  (=> (and (not $abort_flag@19) (= (ControlFlow 0 331368) 331362)) inline$$DiemAccount_add_currencies_for_account$0$anon0_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon68_Else_correct  (=> (not $abort_flag@18) (=> (and (= $abort_flag@19 $abort_flag@18) (= $abort_code@27 $abort_code@25)) (and (=> (= (ControlFlow 0 311683) 331414) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 311683) 331368) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon42_Else_correct))))))
(let ((inline$$DualAttestation_publish_credential_$def$0$Abort_correct  (=> (and (= $abort_flag@19 true) (= $abort_code@27 $abort_code@26)) (and (=> (= (ControlFlow 0 310665) 331414) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 310665) 331368) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon42_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon9_correct  (=> (and (= $abort_code@26 $abort_code@20) (= (ControlFlow 0 311855) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 311853) 311855)) inline$$DualAttestation_publish_credential_$def$0$anon9_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 311863) 311855) inline$$DualAttestation_publish_credential_$def$0$anon9_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon50_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 311847) 311863) inline$$DualAttestation_publish_credential_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 311847) 311853) inline$$DualAttestation_publish_credential_$def$0$anon51_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon13_correct  (=> (and (= $abort_code@26 $abort_code@21) (= (ControlFlow 0 311835) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 311833) 311835)) inline$$DualAttestation_publish_credential_$def$0$anon13_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 311843) 311835) inline$$DualAttestation_publish_credential_$def$0$anon13_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon52_Then_correct  (=> $abort_flag@15 (and (=> (= (ControlFlow 0 311827) 311843) inline$$DualAttestation_publish_credential_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 311827) 311833) inline$$DualAttestation_publish_credential_$def$0$anon53_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon17_correct  (=> (and (= $abort_code@26 $abort_code@22) (= (ControlFlow 0 311815) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 311813) 311815)) inline$$DualAttestation_publish_credential_$def$0$anon17_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 311823) 311815) inline$$DualAttestation_publish_credential_$def$0$anon17_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon54_Then_correct  (=> $abort_flag@16 (and (=> (= (ControlFlow 0 311807) 311823) inline$$DualAttestation_publish_credential_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 311807) 311813) inline$$DualAttestation_publish_credential_$def$0$anon55_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon21_correct  (=> (and (= $abort_code@26 $abort_code@23) (= (ControlFlow 0 311795) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 311793) 311795)) inline$$DualAttestation_publish_credential_$def$0$anon21_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 311803) 311795) inline$$DualAttestation_publish_credential_$def$0$anon21_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon56_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 311787) 311803) inline$$DualAttestation_publish_credential_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 311787) 311793) inline$$DualAttestation_publish_credential_$def$0$anon57_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon29_correct  (=> (and (= $abort_code@26 $abort_code@23) (= (ControlFlow 0 311775) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 311773) 311775)) inline$$DualAttestation_publish_credential_$def$0$anon29_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon61_Then_correct  (=> (= (ControlFlow 0 311783) 311775) inline$$DualAttestation_publish_credential_$def$0$anon29_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon60_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 311767) 311783) inline$$DualAttestation_publish_credential_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 311767) 311773) inline$$DualAttestation_publish_credential_$def$0$anon61_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon33_correct  (=> (and (= $abort_code@26 $abort_code@23) (= (ControlFlow 0 311755) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 311753) 311755)) inline$$DualAttestation_publish_credential_$def$0$anon33_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon63_Then_correct  (=> (= (ControlFlow 0 311763) 311755) inline$$DualAttestation_publish_credential_$def$0$anon33_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon62_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 311747) 311763) inline$$DualAttestation_publish_credential_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 311747) 311753) inline$$DualAttestation_publish_credential_$def$0$anon63_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon37_correct  (=> (and (= $abort_code@26 $abort_code@23) (= (ControlFlow 0 311735) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 311733) 311735)) inline$$DualAttestation_publish_credential_$def$0$anon37_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon65_Then_correct  (=> (= (ControlFlow 0 311743) 311735) inline$$DualAttestation_publish_credential_$def$0$anon37_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon64_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 311727) 311743) inline$$DualAttestation_publish_credential_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 311727) 311733) inline$$DualAttestation_publish_credential_$def$0$anon65_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon41_correct  (=> (and (= $abort_code@26 $abort_code@23) (= (ControlFlow 0 311715) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon67_Else_correct  (=> (and (not true) (= (ControlFlow 0 311713) 311715)) inline$$DualAttestation_publish_credential_$def$0$anon41_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon67_Then_correct  (=> (= (ControlFlow 0 311723) 311715) inline$$DualAttestation_publish_credential_$def$0$anon41_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon66_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 311707) 311723) inline$$DualAttestation_publish_credential_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 311707) 311713) inline$$DualAttestation_publish_credential_$def$0$anon67_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon45_correct  (=> (and (= $abort_code@26 $abort_code@25) (= (ControlFlow 0 311695) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 311693) 311695)) inline$$DualAttestation_publish_credential_$def$0$anon45_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon69_Then_correct  (=> (= (ControlFlow 0 311703) 311695) inline$$DualAttestation_publish_credential_$def$0$anon45_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon68_Then_correct  (=> $abort_flag@18 (and (=> (= (ControlFlow 0 311687) 311703) inline$$DualAttestation_publish_credential_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 311687) 311693) inline$$DualAttestation_publish_credential_$def$0$anon69_Else_correct)))))
(let ((inline$$MoveToRaw$1$anon3_Then$1_correct  (=> (and (= $abort_code@25 $EXEC_FAILURE_CODE) (= $abort_flag@18 true)) (and (=> (= (ControlFlow 0 311661) 311687) inline$$DualAttestation_publish_credential_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 311661) 311683) inline$$DualAttestation_publish_credential_$def$0$anon68_Else_correct)))))
(let ((inline$$MoveToRaw$1$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$1$a@1) (= (ControlFlow 0 311659) 311661)) inline$$MoveToRaw$1$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$1$anon3_Else_correct  (=> (and (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$1$a@1)) (= |inline$$MoveToRaw$1$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$1$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray inline$$MoveTo$1$a@1 inline$$DualAttestation_Credential_pack$0$$struct@1)))) (and (= $abort_code@25 $abort_code@23) (= $abort_flag@18 $abort_flag@17))) (and (=> (= (ControlFlow 0 311609) 311687) inline$$DualAttestation_publish_credential_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 311609) 311683) inline$$DualAttestation_publish_credential_$def$0$anon68_Else_correct)))))
(let ((inline$$MoveTo$1$anon0$1_correct  (=> (= inline$$MoveTo$1$a@1 (|a#$Address| new_account_address)) (and (=> (= (ControlFlow 0 311667) 311659) inline$$MoveToRaw$1$anon3_Then_correct) (=> (= (ControlFlow 0 311667) 311609) inline$$MoveToRaw$1$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$1$Entry_correct  (and (=> (= (ControlFlow 0 311455) (- 0 350847)) true) (=> (= (ControlFlow 0 311455) 311667) inline$$MoveTo$1$anon0$1_correct))))
(let ((inline$$DualAttestation_Credential_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 311341) 311455)) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$DualAttestation_Credential_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 311347) 311455) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$DualAttestation_Credential_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 311335) 311347) inline$$DualAttestation_Credential_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 311335) 311341) inline$$DualAttestation_Credential_pack$0$anon4_Else_correct)))))
(let ((inline$$DualAttestation_Credential_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 311327) 311455)) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$DualAttestation_Credential_pack$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) human_name) (let ((va@@13 (|v#$Vector| human_name)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (forall ((inline$$DualAttestation_Credential_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DualAttestation_Credential_pack$0$$$0 0) (< inline$$DualAttestation_Credential_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_Credential_pack$0$$$0))
))) (and (and ((_ is $Vector) inline$$Vector_empty$0$v@1) (let ((va@@14 (|v#$Vector| inline$$Vector_empty$0$v@1)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (forall ((inline$$DualAttestation_Credential_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DualAttestation_Credential_pack$0$$$0@@0 0) (< inline$$DualAttestation_Credential_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@0))
)))) (and (and (and ((_ is $Vector) inline$$Vector_empty$1$v@1) (let ((va@@15 (|v#$Vector| inline$$Vector_empty$1$v@1)))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (forall ((inline$$DualAttestation_Credential_pack$0$$$0@@1 Int) ) (!  (=> (and (>= inline$$DualAttestation_Credential_pack$0$$$0@@1 0) (< inline$$DualAttestation_Credential_pack$0$$$0@@1 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$1$v@1)) inline$$DualAttestation_Credential_pack$0$$$0@@1))
))) (and (and ((_ is $Integer) inline$$DualAttestation_publish_credential_$def$0$$t15@1) (>= (|i#$Integer| inline$$DualAttestation_publish_credential_$def$0$$t15@1) 0)) (<= (|i#$Integer| inline$$DualAttestation_publish_credential_$def$0$$t15@1) $MAX_U64)))) (=> (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@16 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@1))
))) true) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$1$res@0) (let ((va@@18 (|v#$Vector| inline$$Event_new_event_handle$1$res@0)))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@2))
))) true) (= inline$$DualAttestation_Credential_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 human_name) 1 inline$$Vector_empty$0$v@1) 2 inline$$Vector_empty$1$v@1) 3 inline$$DualAttestation_publish_credential_$def$0$$t15@1) 4 inline$$Event_new_event_handle$0$res@0) 5 inline$$Event_new_event_handle$1$res@0) 6)))) (and (=> (= (ControlFlow 0 311319) 311335) inline$$DualAttestation_Credential_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 311319) 311327) inline$$DualAttestation_Credential_pack$0$anon3_Else_correct)))))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon66_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 311353) 311319)) inline$$DualAttestation_Credential_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$1$Entry_correct  (=> (= inline$$Event_new_event_handle$1$t@0 $DualAttestation_BaseUrlRotationEvent_type_value) (and (=> (= (ControlFlow 0 310833) 311707) inline$$DualAttestation_publish_credential_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 310833) 311353) inline$$DualAttestation_publish_credential_$def$0$anon66_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon64_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 310841) 310833)) inline$$Event_new_event_handle$1$Entry_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $DualAttestation_ComplianceKeyRotationEvent_type_value) (and (=> (= (ControlFlow 0 310791) 311727) inline$$DualAttestation_publish_credential_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 310791) 310841) inline$$DualAttestation_publish_credential_$def$0$anon64_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon62_Else_correct  (=> (not $abort_flag@17) (=> (and (= inline$$DualAttestation_publish_credential_$def$0$$t15@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 310799) 310791)) inline$$Event_new_event_handle$0$Entry_correct))))
(let ((inline$$Vector_empty$1$anon0_correct  (=> (= inline$$Vector_empty$1$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 310747) 311747) inline$$DualAttestation_publish_credential_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 310747) 310799) inline$$DualAttestation_publish_credential_$def$0$anon62_Else_correct)))))
(let ((inline$$Vector_empty$1$Entry_correct  (=> (and (= inline$$Vector_empty$1$ta@0 $IntegerType) (= (ControlFlow 0 310743) 310747)) inline$$Vector_empty$1$anon0_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon60_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 310753) 310743)) inline$$Vector_empty$1$Entry_correct)))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 310706) 311767) inline$$DualAttestation_publish_credential_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 310706) 310753) inline$$DualAttestation_publish_credential_$def$0$anon60_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 $IntegerType) (= (ControlFlow 0 310702) 310706)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon58_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 310712) 310702)) inline$$Vector_empty$0$Entry_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon26_correct  (=> (and (= $abort_code@26 $abort_code@24) (= (ControlFlow 0 310661) 310665)) inline$$DualAttestation_publish_credential_$def$0$Abort_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 310659) 310661)) inline$$DualAttestation_publish_credential_$def$0$anon26_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon59_Then_correct  (=> (= (ControlFlow 0 310673) 310661) inline$$DualAttestation_publish_credential_$def$0$anon26_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon58_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= $abort_code@24 (|i#$Integer| call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 310653) 310673) inline$$DualAttestation_publish_credential_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 310653) 310659) inline$$DualAttestation_publish_credential_$def$0$anon59_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon56_Else_correct  (=> (not $abort_flag@17) (and (=> (= (ControlFlow 0 310641) 310712) inline$$DualAttestation_publish_credential_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 310641) 310653) inline$$DualAttestation_publish_credential_$def$0$anon58_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon54_Else$1_correct  (=> (and (and (and (= inline$$DualAttestation_publish_credential_$def$0$$t11@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@17)) (and (=> $abort_flag@17 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@18) (>= (|i#$Integer| call3formal@$ret0@0@@18) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@18) $MAX_U64))) (and (=> (= (ControlFlow 0 310635) 311787) inline$$DualAttestation_publish_credential_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 310635) 310641) inline$$DualAttestation_publish_credential_$def$0$anon56_Else_correct)))))
(let ((inline$$Not$1$anon0_correct  (=> (and (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DualAttestation_publish_credential_$def$0$$t9@1)))) (= (ControlFlow 0 310623) 310635)) inline$$DualAttestation_publish_credential_$def$0$anon54_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 310613) (- 0 350394)) true) (=> (= (ControlFlow 0 310613) 310623) inline$$Not$1$anon0_correct))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon54_Else_correct  (=> (not $abort_flag@16) (=> (and (= inline$$DualAttestation_publish_credential_$def$0$$t9@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@19)))) (= (ControlFlow 0 310629) 310613)) inline$$Not$1$Entry_correct))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon52_Else_correct  (=> (not $abort_flag@15) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@16) (=> $abort_flag@16 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@16) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 310567) 311807) inline$$DualAttestation_publish_credential_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 310567) 310629) inline$$DualAttestation_publish_credential_$def$0$anon54_Else_correct))))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon50_Else_correct  (=> (and (not $abort_flag@14) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@15)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@15) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@15)) (and (=> $abort_flag@15 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@15 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@21 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@21 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@21 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 310561) 311827) inline$$DualAttestation_publish_credential_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 310561) 310567) inline$$DualAttestation_publish_credential_$def$0$anon52_Else_correct))))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon6$3_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) $abort_flag@14) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 2)))))))) $abort_flag@14)) (and (=> $abort_flag@14 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 2)))))))))) (=> $abort_flag@14 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) (= $abort_code@20 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 5))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (= $abort_code@20 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 310555) 311847) inline$$DualAttestation_publish_credential_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 310555) 310561) inline$$DualAttestation_publish_credential_$def$0$anon50_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 310451) 310555)) inline$$DualAttestation_publish_credential_$def$0$anon6$3_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon49_Then_correct  (=> (= (ControlFlow 0 311871) 310555) inline$$DualAttestation_publish_credential_$def$0$anon6$3_correct)))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon48_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 310443) 311871) inline$$DualAttestation_publish_credential_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 310443) 310451) inline$$DualAttestation_publish_credential_$def$0$anon49_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon48_Then_correct  (and (=> (= (ControlFlow 0 311879) 311871) inline$$DualAttestation_publish_credential_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 311879) 310451) inline$$DualAttestation_publish_credential_$def$0$anon49_Else_correct))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon47_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 310435) 311879) inline$$DualAttestation_publish_credential_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 310435) 310443) inline$$DualAttestation_publish_credential_$def$0$anon48_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon47_Then_correct  (and (=> (= (ControlFlow 0 311887) 311879) inline$$DualAttestation_publish_credential_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 311887) 310443) inline$$DualAttestation_publish_credential_$def$0$anon48_Else_correct))))
(let ((inline$$DualAttestation_publish_credential_$def$0$anon0_correct  (=> (not $abort_flag@13) (and (=> (= (ControlFlow 0 310429) 311887) inline$$DualAttestation_publish_credential_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 310429) 310435) inline$$DualAttestation_publish_credential_$def$0$anon47_Else_correct)))))
(let ((inline$$DualAttestation_publish_credential$0$anon0_correct  (=> (and ((_ is $Address) new_account_address) ((_ is $Address) tc_account)) (=> (and (and (and ((_ is $Vector) human_name) (let ((va@@20 (|v#$Vector| human_name)))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (forall ((inline$$DualAttestation_publish_credential$0$$$0 Int) ) (!  (=> (and (>= inline$$DualAttestation_publish_credential$0$$$0 0) (< inline$$DualAttestation_publish_credential$0$$$0 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_publish_credential$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_publish_credential$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_publish_credential$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DualAttestation_publish_credential$0$$$0))
))) (= (ControlFlow 0 311891) 310429)) inline$$DualAttestation_publish_credential_$def$0$anon0_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@13) (= (ControlFlow 0 311897) 311891)) inline$$DualAttestation_publish_credential$0$anon0_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon39_Else_correct  (=> (not $abort_flag@13) (and (=> (= (ControlFlow 0 309568) 331418) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 309568) 311897) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon40_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon53_Else_correct  (=> (and (and (not $abort_flag@12) (= $abort_flag@13 $abort_flag@12)) (and (= $abort_code@19 $abort_code@17) (= $VASP_ParentVASP_$memory@1 |inline$$MoveToRaw$0$m'@2|))) (and (=> (= (ControlFlow 0 309375) 331438) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 309375) 309568) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon39_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$Abort_correct  (=> (= $abort_flag@13 true) (=> (and (= $abort_code@19 $abort_code@18) (= $VASP_ParentVASP_$memory@1 $VASP_ParentVASP_$memory@0)) (and (=> (= (ControlFlow 0 308869) 331438) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 308869) 309568) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon39_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon7_correct  (=> (= $abort_code@18 $abort_code@10) (=> (and (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 309507) 308869)) inline$$VASP_publish_parent_vasp_credential_$def$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 309505) 309507)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon7_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 309515) 309507) inline$$VASP_publish_parent_vasp_credential_$def$0$anon7_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon39_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 309499) 309515) inline$$VASP_publish_parent_vasp_credential_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 309499) 309505) inline$$VASP_publish_parent_vasp_credential_$def$0$anon40_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon11_correct  (=> (= $abort_code@18 $abort_code@11) (=> (and (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 309487) 308869)) inline$$VASP_publish_parent_vasp_credential_$def$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 309485) 309487)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon11_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 309495) 309487) inline$$VASP_publish_parent_vasp_credential_$def$0$anon11_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon41_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 309479) 309495) inline$$VASP_publish_parent_vasp_credential_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 309479) 309485) inline$$VASP_publish_parent_vasp_credential_$def$0$anon42_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon15_correct  (=> (= $abort_code@18 $abort_code@12) (=> (and (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 309467) 308869)) inline$$VASP_publish_parent_vasp_credential_$def$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 309465) 309467)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon15_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 309475) 309467) inline$$VASP_publish_parent_vasp_credential_$def$0$anon15_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon43_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 309459) 309475) inline$$VASP_publish_parent_vasp_credential_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 309459) 309465) inline$$VASP_publish_parent_vasp_credential_$def$0$anon44_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon19_correct  (=> (= $abort_code@18 $abort_code@13) (=> (and (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 309447) 308869)) inline$$VASP_publish_parent_vasp_credential_$def$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 309445) 309447)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon19_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 309455) 309447) inline$$VASP_publish_parent_vasp_credential_$def$0$anon19_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon45_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 309439) 309455) inline$$VASP_publish_parent_vasp_credential_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 309439) 309445) inline$$VASP_publish_parent_vasp_credential_$def$0$anon46_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon23_correct  (=> (= $abort_code@18 $abort_code@14) (=> (and (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 309427) 308869)) inline$$VASP_publish_parent_vasp_credential_$def$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 309425) 309427)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon23_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 309435) 309427) inline$$VASP_publish_parent_vasp_credential_$def$0$anon23_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon47_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 309419) 309435) inline$$VASP_publish_parent_vasp_credential_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 309419) 309425) inline$$VASP_publish_parent_vasp_credential_$def$0$anon48_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon27_correct  (=> (= $abort_code@18 $abort_code@15) (=> (and (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 309407) 308869)) inline$$VASP_publish_parent_vasp_credential_$def$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 309405) 309407)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon27_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon50_Then_correct  (=> (= (ControlFlow 0 309415) 309407) inline$$VASP_publish_parent_vasp_credential_$def$0$anon27_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon49_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 309399) 309415) inline$$VASP_publish_parent_vasp_credential_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 309399) 309405) inline$$VASP_publish_parent_vasp_credential_$def$0$anon50_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon35_correct  (=> (= $abort_code@18 $abort_code@17) (=> (and (= $VASP_ParentVASP_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 309387) 308869)) inline$$VASP_publish_parent_vasp_credential_$def$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 309385) 309387)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon35_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon54_Then_correct  (=> (= (ControlFlow 0 309395) 309387) inline$$VASP_publish_parent_vasp_credential_$def$0$anon35_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon53_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 309379) 309395) inline$$VASP_publish_parent_vasp_credential_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 309379) 309385) inline$$VASP_publish_parent_vasp_credential_$def$0$anon54_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_code@17 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@12 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 309353) 309379) inline$$VASP_publish_parent_vasp_credential_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 309353) 309375) inline$$VASP_publish_parent_vasp_credential_$def$0$anon53_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 309351) 309353)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$VASP_ParentVASP_pack$0$$struct@1))) (= $abort_code@17 $abort_code@15)) (and (= $abort_flag@12 $abort_flag@11) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 309301) 309379) inline$$VASP_publish_parent_vasp_credential_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 309301) 309375) inline$$VASP_publish_parent_vasp_credential_$def$0$anon53_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| new_account_address)) (and (=> (= (ControlFlow 0 309359) 309351) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 309359) 309301) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 309147) (- 0 349401)) true) (=> (= (ControlFlow 0 309147) 309359) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$VASP_ParentVASP_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 309033) 309147)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$VASP_ParentVASP_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 309039) 309147) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$VASP_ParentVASP_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 309027) 309039) inline$$VASP_ParentVASP_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 309027) 309033) inline$$VASP_ParentVASP_pack$0$anon4_Else_correct)))))
(let ((inline$$VASP_ParentVASP_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 309019) 309147)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$VASP_ParentVASP_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$VASP_publish_parent_vasp_credential_$def$0$$t11@1) (>= (|i#$Integer| inline$$VASP_publish_parent_vasp_credential_$def$0$$t11@1) 0)) (<= (|i#$Integer| inline$$VASP_publish_parent_vasp_credential_$def$0$$t11@1) $MAX_U64)) (= inline$$VASP_ParentVASP_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$VASP_publish_parent_vasp_credential_$def$0$$t11@1) 1)))) (and (=> (= (ControlFlow 0 309011) 309027) inline$$VASP_ParentVASP_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 309011) 309019) inline$$VASP_ParentVASP_pack$0$anon3_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon51_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (= inline$$VASP_publish_parent_vasp_credential_$def$0$$t11@1 ($Integer 0)) (= (ControlFlow 0 309045) 309011)) inline$$VASP_ParentVASP_pack$0$anon0_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon32_correct  (=> (= $abort_code@18 $abort_code@16) (=> (and (= $VASP_ParentVASP_$memory@0 $VASP_ParentVASP_$memory) (= (ControlFlow 0 308865) 308869)) inline$$VASP_publish_parent_vasp_credential_$def$0$Abort_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 308863) 308865)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon32_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon52_Then_correct  (=> (= (ControlFlow 0 308877) 308865) inline$$VASP_publish_parent_vasp_credential_$def$0$anon32_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon51_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@16 (|i#$Integer| call3formal@$ret0@0@@20))) (and (=> (= (ControlFlow 0 308857) 308877) inline$$VASP_publish_parent_vasp_credential_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 308857) 308863) inline$$VASP_publish_parent_vasp_credential_$def$0$anon52_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon49_Else_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 308845) 309045) inline$$VASP_publish_parent_vasp_credential_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 308845) 308857) inline$$VASP_publish_parent_vasp_credential_$def$0$anon51_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon47_Else$1_correct  (=> (and (and (and (= inline$$VASP_publish_parent_vasp_credential_$def$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11)) (and (=> $abort_flag@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@20 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@20) (>= (|i#$Integer| call3formal@$ret0@0@@20) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@20) $MAX_U64))) (and (=> (= (ControlFlow 0 308839) 309399) inline$$VASP_publish_parent_vasp_credential_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 308839) 308845) inline$$VASP_publish_parent_vasp_credential_$def$0$anon49_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| call3formal@$ret0@0@@21)))) (= (ControlFlow 0 308827) 308839)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon47_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 308817) (- 0 349191)) true) (=> (= (ControlFlow 0 308817) 308827) inline$$Not$0$anon0_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon47_Else_correct  (=> (and (not $abort_flag@10) (= (ControlFlow 0 308833) 308817)) inline$$Not$0$Entry_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon45_Else_correct  (=> (not $abort_flag@9) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@10) (=> $abort_flag@10 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@21 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@22)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@22)))))))))) ((_ is $Boolean) call3formal@$ret0@0@@21))) (and (=> (= (ControlFlow 0 308779) 309419) inline$$VASP_publish_parent_vasp_credential_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 308779) 308833) inline$$VASP_publish_parent_vasp_credential_$def$0$anon47_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon43_Else_correct  (=> (not $abort_flag@8) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9) (=> $abort_flag@9 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@22 new_account_address)))) ((_ is $Address) call3formal@$ret0@0@@22))) (and (=> (= (ControlFlow 0 308773) 309439) inline$$VASP_publish_parent_vasp_credential_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 308773) 308779) inline$$VASP_publish_parent_vasp_credential_$def$0$anon45_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon41_Else_correct  (=> (not $abort_flag@7) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) $abort_flag@8) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 5))))) $abort_flag@8)) (and (=> $abort_flag@8 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 5))))))) (=> $abort_flag@8 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address))))))) (= $abort_code@12 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) ($Integer 5))))) (= $abort_code@12 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 308767) 309459) inline$$VASP_publish_parent_vasp_credential_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 308767) 308773) inline$$VASP_publish_parent_vasp_credential_$def$0$anon43_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon39_Else_correct  (=> (and (not $abort_flag@6) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@7)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@7) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@7)) (and (=> $abort_flag@7 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@7 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@11 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@2) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@11 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@11 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 308761) 309479) inline$$VASP_publish_parent_vasp_credential_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 308761) 308767) inline$$VASP_publish_parent_vasp_credential_$def$0$anon41_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@6) (=> (and (=> $abort_flag@6 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@6 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 308755) 309499) inline$$VASP_publish_parent_vasp_credential_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 308755) 308761) inline$$VASP_publish_parent_vasp_credential_$def$0$anon39_Else_correct))))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 308685) 308755)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon4$2_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 309523) 308755) inline$$VASP_publish_parent_vasp_credential_$def$0$anon4$2_correct)))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon37_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308677) 309523) inline$$VASP_publish_parent_vasp_credential_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 308677) 308685) inline$$VASP_publish_parent_vasp_credential_$def$0$anon38_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon37_Then_correct  (and (=> (= (ControlFlow 0 309531) 309523) inline$$VASP_publish_parent_vasp_credential_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 309531) 308685) inline$$VASP_publish_parent_vasp_credential_$def$0$anon38_Else_correct))))
(let ((inline$$VASP_publish_parent_vasp_credential_$def$0$anon0_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 308671) 309531) inline$$VASP_publish_parent_vasp_credential_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 308671) 308677) inline$$VASP_publish_parent_vasp_credential_$def$0$anon37_Else_correct)))))
(let ((inline$$VASP_publish_parent_vasp_credential$0$anon0_correct  (=> ((_ is $Address) new_account_address) (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 309535) 308671)) inline$$VASP_publish_parent_vasp_credential_$def$0$anon0_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon38_Else_correct  (=> (and (not $abort_flag@5) (= (ControlFlow 0 309541) 309535)) inline$$VASP_publish_parent_vasp_credential$0$anon0_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$Abort_correct  (=> (= $abort_flag@5 true) (=> (and (= $abort_code@9 $abort_code@8) (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory@1)) (and (=> (= (ControlFlow 0 308005) 331442) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 308005) 309541) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon38_Else_correct))))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon7_correct  (=> (= $Roles_RoleId_$memory@1 $Roles_RoleId_$memory) (=> (and (= $abort_code@8 $abort_code@6) (= (ControlFlow 0 308025) 308005)) inline$$Roles_new_parent_vasp_role_$def$0$Abort_correct))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 308023) 308025)) inline$$Roles_new_parent_vasp_role_$def$0$anon7_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon16_Then_correct  (=> (= (ControlFlow 0 308033) 308025) inline$$Roles_new_parent_vasp_role_$def$0$anon7_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon15_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 308017) 308033) inline$$Roles_new_parent_vasp_role_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 308017) 308023) inline$$Roles_new_parent_vasp_role_$def$0$anon16_Else_correct)))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon11_correct  (=> (= $Roles_RoleId_$memory@1 $Roles_RoleId_$memory@0) (=> (and (= $abort_code@8 $abort_code@7) (= (ControlFlow 0 308001) 308005)) inline$$Roles_new_parent_vasp_role_$def$0$Abort_correct))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 307999) 308001)) inline$$Roles_new_parent_vasp_role_$def$0$anon11_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 308013) 308001) inline$$Roles_new_parent_vasp_role_$def$0$anon11_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon17_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 307993) 308013) inline$$Roles_new_parent_vasp_role_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 307993) 307999) inline$$Roles_new_parent_vasp_role_$def$0$anon18_Else_correct)))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon17_Else_correct  (=> (and (and (not $abort_flag@4) (= $abort_flag@5 $abort_flag@4)) (and (= $abort_code@9 $abort_code@7) (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory@0))) (and (=> (= (ControlFlow 0 307989) 331442) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 307989) 309541) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon38_Else_correct)))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon15_Else_correct  (=> (and (not $abort_flag@3) (= inline$$Roles_new_parent_vasp_role_$def$0$$t4@1 ($Integer 5))) (and (=> (= (ControlFlow 0 307983) (- 0 348240)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_parent_vasp_role_$def$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account_address))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_parent_vasp_role_$def$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| new_account_address)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $abort_flag@4) (=> (and (=> $abort_flag@4 (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (=> $abort_flag@4 (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (= $abort_code@7 (|i#$Integer| ($Integer 6)))))) (=> (and (and (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address))))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) $Roles_RoleId_role_id) inline$$Roles_new_parent_vasp_role_$def$0$$t4@1))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))) (= (|domain#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| new_account_address) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| new_account_address)))))) (and (=> (= (ControlFlow 0 307983) 307993) inline$$Roles_new_parent_vasp_role_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 307983) 307989) inline$$Roles_new_parent_vasp_role_$def$0$anon17_Else_correct))))))))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@3) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@3)) (and (=> $abort_flag@3 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@3 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@6 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@6 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 307973) 308017) inline$$Roles_new_parent_vasp_role_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 307973) 307983) inline$$Roles_new_parent_vasp_role_$def$0$anon15_Else_correct))))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon4_correct  (=> (and (= inline$$Roles_new_parent_vasp_role_$def$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| new_account_address) true)) (= (ControlFlow 0 307937) 307973)) inline$$Roles_new_parent_vasp_role_$def$0$anon4$2_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 307887) 307937)) inline$$Roles_new_parent_vasp_role_$def$0$anon4_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon14_Then_correct  (=> (= (ControlFlow 0 308041) 307937) inline$$Roles_new_parent_vasp_role_$def$0$anon4_correct)))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon13_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 307879) 308041) inline$$Roles_new_parent_vasp_role_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 307879) 307887) inline$$Roles_new_parent_vasp_role_$def$0$anon14_Else_correct)))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon13_Then_correct  (and (=> (= (ControlFlow 0 308049) 308041) inline$$Roles_new_parent_vasp_role_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 308049) 307887) inline$$Roles_new_parent_vasp_role_$def$0$anon14_Else_correct))))
(let ((inline$$Roles_new_parent_vasp_role_$def$0$anon0_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 307873) 308049) inline$$Roles_new_parent_vasp_role_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 307873) 307879) inline$$Roles_new_parent_vasp_role_$def$0$anon13_Else_correct)))))
(let ((inline$$Roles_new_parent_vasp_role$0$anon0_correct  (=> ((_ is $Address) tc_account) (=> (and ((_ is $Address) new_account_address) (= (ControlFlow 0 308053) 307873)) inline$$Roles_new_parent_vasp_role_$def$0$anon0_correct))))
(let ((inline$$Roles_new_parent_vasp_role$0$Entry_correct  (=> (= inline$$Roles_new_parent_vasp_role$0$$Roles_RoleId_$CallerDomain@0 ($ConstMemoryDomain true)) (and (=> (= (ControlFlow 0 307607) (- 0 347869)) (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_parent_vasp_role$0$$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| new_account_address))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Roles_new_parent_vasp_role$0$$Roles_RoleId_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| new_account_address)) (=> (= (ControlFlow 0 307607) 308053) inline$$Roles_new_parent_vasp_role$0$anon0_correct))))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon36_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 308059) 307607)) inline$$Roles_new_parent_vasp_role$0$Entry_correct)))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon35_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 307310) 331446) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 307310) 308059) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon36_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon35_Then_correct  (and (=> (= (ControlFlow 0 331470) 331446) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 331470) 308059) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon36_Else_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon34_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 307302) 331470) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 307302) 307310) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon35_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon34_Then_correct  (and (=> (= (ControlFlow 0 331478) 331470) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 331478) 307310) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon35_Else_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon33_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 307294) 331478) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 307294) 307302) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon34_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon33_Then_correct  (and (=> (= (ControlFlow 0 331486) 331478) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 331486) 307302) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon34_Else_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon32_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 307286) 331486) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 307286) 307294) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon32_Then_correct  (and (=> (= (ControlFlow 0 331494) 331486) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 331494) 307294) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon33_Else_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon31_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 307278) 331494) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 307278) 307286) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon32_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon31_Then_correct  (and (=> (= (ControlFlow 0 331502) 331494) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 331502) 307286) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon32_Else_correct))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$def$0$anon0_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 307272) 331502) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 307272) 307278) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon31_Else_correct)))))
(let ((inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) tc_account) ((_ is $Address) new_account_address)) (=> (and (and ((_ is $Vector) auth_key_prefix@@0) (let ((va@@21 (|v#$Vector| auth_key_prefix@@0)))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (forall ((inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0 0) (< inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0))
))) (=> (and (and (and ((_ is $Vector) human_name) (let ((va@@22 (|v#$Vector| human_name)))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (forall ((inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0@@0 0) (< inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$$$0@@0))
))) (and ((_ is $Boolean) add_all_currencies) (= (ControlFlow 0 331506) 307272))) inline$$DiemAccount_create_parent_vasp_account_$def$0$anon0_correct)))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon23_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 331512) 331506)) inline$$DiemAccount_create_parent_vasp_account_$direct_inter$0$anon0_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct  (=> (and (= $abort_flag@2 true) (= $abort_code@5 $abort_code@4)) (and (=> (= (ControlFlow 0 306356) 331532) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 306356) 331512) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon7_correct  (=> (and (= $abort_code@4 $abort_code@1) (= (ControlFlow 0 306402) 306356)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 306400) 306402)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon7_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 306410) 306402) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon7_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 306394) 306410) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 306394) 306400) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon20_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon11_correct  (=> (and (= $abort_code@4 $abort_code@2) (= (ControlFlow 0 306382) 306356)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 306380) 306382)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon11_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 306390) 306382) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon11_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 306374) 306390) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 306374) 306380) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon22_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon16_correct  (=> (and (= $abort_code@4 $abort_code@3) (= (ControlFlow 0 306352) 306356)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$Abort_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 306350) 306352)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon16_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 306364) 306352) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon16_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1)) (= $abort_code@3 (|i#$Integer| call3formal@$ret0@0@@23))) (and (=> (= (ControlFlow 0 306344) 306364) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 306344) 306350) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon24_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Then_correct  (=> (|b#$Boolean| inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1) (=> (and (= $abort_flag@2 $abort_flag@1) (= $abort_code@5 $abort_code@2)) (and (=> (= (ControlFlow 0 306370) 331532) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 306370) 331512) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 306332) 306370) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 306332) 306344) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon23_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Else_correct  (=> (and (not $abort_flag@0) (= inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t7@1 ($Integer 0))) (=> (and (and (and (= inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t8@1 ($Boolean ($IsEqual_stratified call5formal@$ret0@0 inline$$SlidingNonce_record_nonce_or_abort_$def$0$$t7@1))) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@23 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@23) (>= (|i#$Integer| call3formal@$ret0@0@@23) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@23) $MAX_U64))) (and (=> (= (ControlFlow 0 306326) 306374) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 306326) 306332) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon21_Else_correct))))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon4$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))))) (and (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@1 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call5formal@$ret0@0 ($SlidingNonce_spec_try_record_nonce tc_account sliding_nonce))))))) (and (and ((_ is $Integer) call5formal@$ret0@0) (>= (|i#$Integer| call5formal@$ret0@0) 0)) (<= (|i#$Integer| call5formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 306308) 306394) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 306308) 306326) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon19_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 306238) 306308)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon4$2_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 306418) 306308) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon4$2_correct)))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306230) 306418) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 306230) 306238) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 306426) 306418) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 306426) 306238) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon18_Else_correct))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 306224) 306426) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 306224) 306230) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon17_Else_correct)))))
(let ((inline$$SlidingNonce_record_nonce_or_abort_$direct_inter$0$anon0_correct  (=> ((_ is $Address) tc_account) (=> (and (and (and ((_ is $Integer) sliding_nonce) (>= (|i#$Integer| sliding_nonce) 0)) (<= (|i#$Integer| sliding_nonce) $MAX_U64)) (= (ControlFlow 0 306430) 306224)) inline$$SlidingNonce_record_nonce_or_abort_$def$0$anon0_correct))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 305660) 306430)) inline$$SlidingNonce_record_nonce_or_abort_$direct_inter$0$anon0_correct)))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 331540) 306430) inline$$SlidingNonce_record_nonce_or_abort_$direct_inter$0$anon0_correct)))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 305652) 331540) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 305652) 305660) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 331548) 331540) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 331548) 305660) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon22_Else_correct))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 305644) 331548) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 305644) 305652) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon20_Then_correct  (and (=> (= (ControlFlow 0 331556) 331548) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 331556) 305652) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon21_Else_correct))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 305636) 331556) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 305636) 305644) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 331564) 331556) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 331564) 305644) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon20_Else_correct))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon18_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 305628) 331564) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 305628) 305636) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon18_Then_correct  (and (=> (= (ControlFlow 0 331572) 331564) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 331572) 305636) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon19_Else_correct))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 305620) 331572) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 305620) 305628) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 331580) 331572) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 331580) 305628) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon18_Else_correct))))
(let ((inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 305614) 331580) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 305614) 305620) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon17_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@23 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (=> (and (and (and (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))
))) (and (forall (($inv_addr@@2 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2)) (let ((va@@26 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_currency_code))) $$0@@3))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@5))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@6))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@7))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@38 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@8))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@39 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@3))
)))) (and (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@40 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@41 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5))) $SlidingNonce_SlidingNonce_min_nonce)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5))) $SlidingNonce_SlidingNonce_min_nonce)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5))) $SlidingNonce_SlidingNonce_min_nonce)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5))) $SlidingNonce_SlidingNonce_nonce_mask)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5))) $SlidingNonce_SlidingNonce_nonce_mask)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5))) $SlidingNonce_SlidingNonce_nonce_mask)) $MAX_U128))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@5))
))) (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@42 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_human_name))) $$0@@9))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url))) $$0@@10))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_public_key))) $$0@@11))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@46 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@47 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@12))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@49 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@13))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@50 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_authentication_key))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_authentication_key))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_authentication_key))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_authentication_key))) $$0@@14))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@53 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@54 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@55 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events)) (let ((va@@56 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@57 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@15))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@16))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@7))
))))) (and (and (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@60 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_limits_cap)) (let ((va@@61 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_limits_cap))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_limits_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_limits_cap))) $AccountLimits_AccountLimitMutationCapability_dummy_field)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events)) (let ((va@@62 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid)) (let ((va@@63 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
))))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@17))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (forall (($inv_addr@@9 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9)) (let ((va@@64 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))) $DiemAccount_Balance_coin)) (let ((va@@65 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))) $DiemAccount_Balance_coin))))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))) $DiemAccount_Balance_coin))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@9))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> (and (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr T@$Value) )  (=> ((_ is $Address) addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((child_addr T@$Value) )  (=> ((_ is $Address) child_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))))))) (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@3 T@$Value) )  (=> ((_ is $Address) addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@4 T@$Value) )  (=> ((_ is $Address) addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@5 T@$Value) )  (=> ((_ is $Address) addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))))))))))) (and (|b#$Boolean| ($Boolean (forall ((token T@$Value) )  (=> ((_ is $Type) token) (|b#$Boolean| ($Boolean (forall ((addr@@6 T@$Value) )  (=> ((_ is $Address) addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| token)) 1) (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@7 T@$Value) )  (=> ((_ is $Address) addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@8 T@$Value) )  (=> ((_ is $Address) addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) $Roles_RoleId_role_id) ($Integer 5))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@9 T@$Value) )  (=> ((_ is $Address) addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))))))))))) (and (|b#$Boolean| (let ((addr@@10 tc_account))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (= (ControlFlow 0 331584) 305614)))))) inline$$create_parent_vasp_account_create_parent_vasp_account_$def_verify$0$anon0_correct)))))
(let ((anon0_correct  (=> ((_ is $Address) tc_account) (=> (and (and (and (and (and ((_ is $Integer) sliding_nonce) (>= (|i#$Integer| sliding_nonce) 0)) (<= (|i#$Integer| sliding_nonce) $MAX_U64)) ((_ is $Address) new_account_address)) (and (and ((_ is $Vector) auth_key_prefix@@0) (let ((va@@66 (|v#$Vector| auth_key_prefix@@0)))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
)))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| auth_key_prefix@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| auth_key_prefix@@0)) $$0@@18))
)))) (and (and (and ((_ is $Vector) human_name) (let ((va@@67 (|v#$Vector| human_name)))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
)))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| human_name)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| human_name)) $$0@@19))
))) (and ((_ is $Boolean) add_all_currencies) (= (ControlFlow 0 303673) 331584)))) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 335929) 303673) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
