(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $AccountFreezing_FreezeAccountEvent () T@$TypeName)
(declare-fun $AccountFreezing_FreezeEventsHolder () T@$TypeName)
(declare-fun $AccountFreezing_FreezingBit () T@$TypeName)
(declare-fun $AccountFreezing_UnfreezeAccountEvent () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $ChainId_ChainId () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DesignatedDealer_Dealer () T@$TypeName)
(declare-fun $DesignatedDealer_ReceivedMintEvent () T@$TypeName)
(declare-fun $DesignatedDealer_TierInfo () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $SlidingNonce_SlidingNonce () T@$TypeName)
(declare-fun $DualAttestation_BaseUrlRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_Credential () T@$TypeName)
(declare-fun $DualAttestation_Limit () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $DiemAccount_DiemAccount () T@$TypeName)
(declare-fun $DiemAccount_AccountOperationsCapability () T@$TypeName)
(declare-fun $DiemAccount_AdminTransactionEvent () T@$TypeName)
(declare-fun $DiemAccount_Balance () T@$TypeName)
(declare-fun $DiemAccount_CreateAccountEvent () T@$TypeName)
(declare-fun $DiemAccount_DiemWriteSetManager () T@$TypeName)
(declare-fun $DiemAccount_KeyRotationCapability () T@$TypeName)
(declare-fun $DiemAccount_ReceivedPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_SentPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_WithdrawCapability () T@$TypeName)
(declare-fun $RecoveryAddress_RecoveryAddress () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_frozen_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeEventsHolder_freeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezingBit_is_frozen () Int)
(declare-fun $AccountFreezing_FreezingBit_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_unfrozen_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ChainId_ChainId_id () Int)
(declare-fun $ChainId_ChainId_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_Dealer_mint_event_handle () Int)
(declare-fun $DesignatedDealer_Dealer_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_ReceivedMintEvent_currency_code () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_destination_address () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_amount () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_TierInfo_window_start () Int)
(declare-fun $DesignatedDealer_TierInfo_window_inflow () Int)
(declare-fun $DesignatedDealer_TierInfo_tiers () Int)
(declare-fun $DesignatedDealer_TierInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $SlidingNonce_spec_try_record_nonce (T@$Value T@$Value) T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_min_nonce () Int)
(declare-fun $SlidingNonce_SlidingNonce_nonce_mask () Int)
(declare-fun $SlidingNonce_SlidingNonce_type_value () T@$TypeValue)
(declare-fun $DualAttestation_spec_dual_attestation_message (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $DualAttestation_BaseUrlRotationEvent_new_base_url () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Credential_human_name () Int)
(declare-fun $DualAttestation_Credential_base_url () Int)
(declare-fun $DualAttestation_Credential_compliance_public_key () Int)
(declare-fun $DualAttestation_Credential_expiration_date () Int)
(declare-fun $DualAttestation_Credential_compliance_key_rotation_events () Int)
(declare-fun $DualAttestation_Credential_base_url_rotation_events () Int)
(declare-fun $DualAttestation_Credential_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Limit_micro_xdx_limit () Int)
(declare-fun $DualAttestation_Limit_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun $DiemAccount_spec_abstract_create_authentication_key (T@$Value) T@$Value)
(declare-fun $DiemAccount_DiemAccount_authentication_key () Int)
(declare-fun $DiemAccount_DiemAccount_withdraw_capability () Int)
(declare-fun $DiemAccount_DiemAccount_key_rotation_capability () Int)
(declare-fun $DiemAccount_DiemAccount_received_events () Int)
(declare-fun $DiemAccount_DiemAccount_sent_events () Int)
(declare-fun $DiemAccount_DiemAccount_sequence_number () Int)
(declare-fun $DiemAccount_DiemAccount_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AccountOperationsCapability_limits_cap () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_creation_events () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AdminTransactionEvent_committed_timestamp_secs () Int)
(declare-fun $DiemAccount_AdminTransactionEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_Balance_coin () Int)
(declare-fun $DiemAccount_Balance_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemAccount_CreateAccountEvent_created () Int)
(declare-fun $DiemAccount_CreateAccountEvent_role_id () Int)
(declare-fun $DiemAccount_CreateAccountEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_DiemWriteSetManager_upgrade_events () Int)
(declare-fun $DiemAccount_DiemWriteSetManager_type_value () T@$TypeValue)
(declare-fun $DiemAccount_KeyRotationCapability_account_address () Int)
(declare-fun $DiemAccount_KeyRotationCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_ReceivedPaymentEvent_amount () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_payer () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_SentPaymentEvent_amount () Int)
(declare-fun $DiemAccount_SentPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_SentPaymentEvent_payee () Int)
(declare-fun $DiemAccount_SentPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_SentPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_WithdrawCapability_account_address () Int)
(declare-fun $DiemAccount_WithdrawCapability_type_value () T@$TypeValue)
(declare-fun $RecoveryAddress_RecoveryAddress_rotation_caps () Int)
(declare-fun $RecoveryAddress_RecoveryAddress_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $AccountFreezing_FreezeAccountEvent $AccountFreezing_FreezeEventsHolder $AccountFreezing_FreezingBit $AccountFreezing_UnfreezeAccountEvent $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $ChainId_ChainId $FixedPoint32_FixedPoint32 $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $DesignatedDealer_Dealer $DesignatedDealer_ReceivedMintEvent $DesignatedDealer_TierInfo $XDX_XDX $XDX_Reserve $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_Config $ValidatorConfig_ValidatorConfig $VASP_ChildVASP $VASP_ParentVASP $TransactionFee_TransactionFee $SlidingNonce_SlidingNonce $DualAttestation_BaseUrlRotationEvent $DualAttestation_ComplianceKeyRotationEvent $DualAttestation_Credential $DualAttestation_Limit $DiemTransactionPublishingOption_DiemTransactionPublishingOption $DiemAccount_DiemAccount $DiemAccount_AccountOperationsCapability $DiemAccount_AdminTransactionEvent $DiemAccount_Balance $DiemAccount_CreateAccountEvent $DiemAccount_DiemWriteSetManager $DiemAccount_KeyRotationCapability $DiemAccount_ReceivedPaymentEvent $DiemAccount_SentPaymentEvent $DiemAccount_WithdrawCapability $RecoveryAddress_RecoveryAddress)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_FreezeAccountEvent_frozen_address 1))
(assert (= $AccountFreezing_FreezeAccountEvent_type_value ($StructType $AccountFreezing_FreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeEventsHolder_freeze_event_handle 0))
(assert (= $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle 1))
(assert (= $AccountFreezing_FreezeEventsHolder_type_value ($StructType $AccountFreezing_FreezeEventsHolder $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezingBit_is_frozen 0))
(assert (= $AccountFreezing_FreezingBit_type_value ($StructType $AccountFreezing_FreezingBit $EmptyTypeValueArray)))
(assert (= $AccountFreezing_UnfreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_UnfreezeAccountEvent_unfrozen_address 1))
(assert (= $AccountFreezing_UnfreezeAccountEvent_type_value ($StructType $AccountFreezing_UnfreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0@@0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0@@0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@1) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@1))
)))
(assert (= $ChainId_ChainId_id 0))
(assert (= $ChainId_ChainId_type_value ($StructType $ChainId_ChainId $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_Dealer_mint_event_handle 0))
(assert (= $DesignatedDealer_Dealer_type_value ($StructType $DesignatedDealer_Dealer $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_ReceivedMintEvent_currency_code 0))
(assert (= $DesignatedDealer_ReceivedMintEvent_destination_address 1))
(assert (= $DesignatedDealer_ReceivedMintEvent_amount 2))
(assert (= $DesignatedDealer_ReceivedMintEvent_type_value ($StructType $DesignatedDealer_ReceivedMintEvent $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_TierInfo_window_start 0))
(assert (= $DesignatedDealer_TierInfo_window_inflow 1))
(assert (= $DesignatedDealer_TierInfo_tiers 2))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($DesignatedDealer_TierInfo_type_value $tv0@@9) ($StructType $DesignatedDealer_TierInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($DesignatedDealer_TierInfo_type_value $tv0@@9))
)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@10 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@10) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1))) :pattern ( ($Option_Option_type_value $tv0@@10))
)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@11 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@11) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@11))
)))
(assert (forall ((account T@$Value) (seq_nonce T@$Value) )  (and (and ((_ is $Integer) ($SlidingNonce_spec_try_record_nonce account seq_nonce)) (>= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) 0)) (<= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) $MAX_U64))))
(assert (= $SlidingNonce_SlidingNonce_min_nonce 0))
(assert (= $SlidingNonce_SlidingNonce_nonce_mask 1))
(assert (= $SlidingNonce_SlidingNonce_type_value ($StructType $SlidingNonce_SlidingNonce $EmptyTypeValueArray)))
(assert (forall ((payer T@$Value) (metadata T@$Value) (deposit_value T@$Value) )  (and (and ((_ is $Vector) ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value)) (let ((va@@8 (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0))
)))))
(assert (= $DualAttestation_BaseUrlRotationEvent_new_base_url 0))
(assert (= $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_BaseUrlRotationEvent_type_value ($StructType $DualAttestation_BaseUrlRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key 0))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_type_value ($StructType $DualAttestation_ComplianceKeyRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_Credential_human_name 0))
(assert (= $DualAttestation_Credential_base_url 1))
(assert (= $DualAttestation_Credential_compliance_public_key 2))
(assert (= $DualAttestation_Credential_expiration_date 3))
(assert (= $DualAttestation_Credential_compliance_key_rotation_events 4))
(assert (= $DualAttestation_Credential_base_url_rotation_events 5))
(assert (= $DualAttestation_Credential_type_value ($StructType $DualAttestation_Credential $EmptyTypeValueArray)))
(assert (= $DualAttestation_Limit_micro_xdx_limit 0))
(assert (= $DualAttestation_Limit_type_value ($StructType $DualAttestation_Limit $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((auth_key_prefix T@$Value) )  (and (and ((_ is $Vector) ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix)) (let ((va@@9 (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0))
)))))
(assert (= $DiemAccount_DiemAccount_authentication_key 0))
(assert (= $DiemAccount_DiemAccount_withdraw_capability 1))
(assert (= $DiemAccount_DiemAccount_key_rotation_capability 2))
(assert (= $DiemAccount_DiemAccount_received_events 3))
(assert (= $DiemAccount_DiemAccount_sent_events 4))
(assert (= $DiemAccount_DiemAccount_sequence_number 5))
(assert (= $DiemAccount_DiemAccount_type_value ($StructType $DiemAccount_DiemAccount $EmptyTypeValueArray)))
(assert (= $DiemAccount_AccountOperationsCapability_limits_cap 0))
(assert (= $DiemAccount_AccountOperationsCapability_creation_events 1))
(assert (= $DiemAccount_AccountOperationsCapability_type_value ($StructType $DiemAccount_AccountOperationsCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_AdminTransactionEvent_committed_timestamp_secs 0))
(assert (= $DiemAccount_AdminTransactionEvent_type_value ($StructType $DiemAccount_AdminTransactionEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_Balance_coin 0))
(assert (forall (($tv0@@12 T@$TypeValue) ) (! (= ($DiemAccount_Balance_type_value $tv0@@12) ($StructType $DiemAccount_Balance ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1))) :pattern ( ($DiemAccount_Balance_type_value $tv0@@12))
)))
(assert (= $DiemAccount_CreateAccountEvent_created 0))
(assert (= $DiemAccount_CreateAccountEvent_role_id 1))
(assert (= $DiemAccount_CreateAccountEvent_type_value ($StructType $DiemAccount_CreateAccountEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_DiemWriteSetManager_upgrade_events 0))
(assert (= $DiemAccount_DiemWriteSetManager_type_value ($StructType $DiemAccount_DiemWriteSetManager $EmptyTypeValueArray)))
(assert (= $DiemAccount_KeyRotationCapability_account_address 0))
(assert (= $DiemAccount_KeyRotationCapability_type_value ($StructType $DiemAccount_KeyRotationCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_ReceivedPaymentEvent_amount 0))
(assert (= $DiemAccount_ReceivedPaymentEvent_currency_code 1))
(assert (= $DiemAccount_ReceivedPaymentEvent_payer 2))
(assert (= $DiemAccount_ReceivedPaymentEvent_metadata 3))
(assert (= $DiemAccount_ReceivedPaymentEvent_type_value ($StructType $DiemAccount_ReceivedPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_SentPaymentEvent_amount 0))
(assert (= $DiemAccount_SentPaymentEvent_currency_code 1))
(assert (= $DiemAccount_SentPaymentEvent_payee 2))
(assert (= $DiemAccount_SentPaymentEvent_metadata 3))
(assert (= $DiemAccount_SentPaymentEvent_type_value ($StructType $DiemAccount_SentPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_WithdrawCapability_account_address 0))
(assert (= $DiemAccount_WithdrawCapability_type_value ($StructType $DiemAccount_WithdrawCapability $EmptyTypeValueArray)))
(assert (= $RecoveryAddress_RecoveryAddress_rotation_caps 0))
(assert (= $RecoveryAddress_RecoveryAddress_type_value ($StructType $RecoveryAddress_RecoveryAddress $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $DiemAccount_DiemAccount_$memory () T@$Memory)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@18 () Bool)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $VASP_ParentVASP_$memory () T@$Memory)
(declare-fun $VASP_ChildVASP_$memory () T@$Memory)
(declare-fun $RecoveryAddress_RecoveryAddress_$memory () T@$Memory)
(declare-fun $abort_code@28 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@0 () T@$Memory)
(declare-fun $RecoveryAddress_RecoveryAddress_$memory@3 () T@$Memory)
(declare-fun $abort_code@27 () Int)
(declare-fun $RecoveryAddress_RecoveryAddress_$memory@2 () T@$Memory)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $RecoveryAddress_RecoveryAddress_$memory@1 () T@$Memory)
(declare-fun $abort_code@26 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@15 () Int)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $abort_code@24 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@25 () Int)
(declare-fun $RecoveryAddress_RecoveryAddress_$memory@0 () T@$Memory)
(declare-fun $abort_code@16 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_code@17 () Int)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_code@18 () Int)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $abort_code@20 () Int)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_code@22 () Int)
(declare-fun $abort_flag@14 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun inline$$RecoveryAddress_RecoveryAddress_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_flag@15 () Bool)
(declare-fun inline$$Vector_singleton_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Vector_singleton_$def$0$$ret0@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Vector_singleton$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun $abort_code@23 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$RecoveryAddress_publish_$def$0$$t20@1 () T@$Value)
(declare-fun inline$$RecoveryAddress_publish_$def$0$$t18@1 () T@$Value)
(declare-fun inline$$RecoveryAddress_publish_$def$0$$t15@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_code@21 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun inline$$RecoveryAddress_publish_$def$0$$t16@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun $abort_code@19 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$RecoveryAddress_publish_$def$0$$t12@1 () T@$Value)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@13 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$Option_Option_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$Option_Option_$pack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun inline$$Option_Option_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$Option_Option_$unpack_ref$0$$tv0@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$1$$t2@1 () T@$Value)
(declare-fun $abort_code@11 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t13@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@9 () Int)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_code@5 () Int)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$0$$t2@1 () T@$Value)
(declare-fun $abort_code@3 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$t5@1 () T@$Value)
(declare-fun $Option_Option_$memory () T@$Memory)
(declare-fun $DiemAccount_KeyRotationCapability_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory () T@$Memory)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 312399) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 310690) (- 0 317978)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) $abort_flag@18) (and (=> (= (ControlFlow 0 310690) (- 0 317996)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) $abort_flag@18) (and (=> (= (ControlFlow 0 310690) (- 0 318008)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) $abort_flag@18) (and (=> (= (ControlFlow 0 310690) (- 0 318029)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $abort_flag@18) (and (=> (= (ControlFlow 0 310690) (- 0 318041)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address) account@@0)))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address) account@@0)))) $abort_flag@18) (and (=> (= (ControlFlow 0 310690) (- 0 318063)) (=> $abort_flag@18 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address) account@@0))))))) (=> (=> $abort_flag@18 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address) account@@0)))))) (and (=> (= (ControlFlow 0 310690) (- 0 318144)) (=> $abort_flag@18 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@28 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@28 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (= $abort_code@28 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (= $abort_code@28 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address) account@@0)))) (= $abort_code@28 (|i#$Integer| ($Integer 7))))))) (=> (=> $abort_flag@18 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0))))))) (= $abort_code@28 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@28 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))))))))) (= $abort_code@28 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) (= $abort_code@28 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address) account@@0)))) (= $abort_code@28 (|i#$Integer| ($Integer 7)))))) (and (=> (= (ControlFlow 0 310690) (- 0 318280)) (=> $abort_flag@18 (or (or (= $abort_code@28 (|i#$Integer| ($Integer 1))) (= $abort_code@28 (|i#$Integer| ($Integer 7)))) (= $abort_code@28 (|i#$Integer| ($Integer 6)))))) (=> (=> $abort_flag@18 (or (or (= $abort_code@28 (|i#$Integer| ($Integer 1))) (= $abort_code@28 (|i#$Integer| ($Integer 7)))) (= $abort_code@28 (|i#$Integer| ($Integer 6))))) (and (=> (= (ControlFlow 0 310690) (- 0 318314)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))) (and (=> (= (ControlFlow 0 310690) (- 0 318328)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory@3) $EmptyTypeValueArray (|a#$Address| account@@0)))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory@3) $EmptyTypeValueArray (|a#$Address| account@@0))))) (and (=> (= (ControlFlow 0 310690) (- 0 318342)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory@3) $EmptyTypeValueArray (|a#$Address| account@@0)))) $RecoveryAddress_RecoveryAddress_rotation_caps)))) ($Integer 1)))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory@3) $EmptyTypeValueArray (|a#$Address| account@@0)))) $RecoveryAddress_RecoveryAddress_rotation_caps)))) ($Integer 1))))) (=> (= (ControlFlow 0 310690) (- 0 318366)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory@3) $EmptyTypeValueArray (|a#$Address| account@@0)))) $RecoveryAddress_RecoveryAddress_rotation_caps))) (|i#$Integer| ($Integer 0))) ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| account@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))))))))))))))))))))))))))))))
(let ((inline$$create_recovery_address_create_recovery_address_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@28 $abort_code@27) (= $RecoveryAddress_RecoveryAddress_$memory@3 $RecoveryAddress_RecoveryAddress_$memory@2)) (and (= $abort_flag@18 true) (= (ControlFlow 0 310672) 310690))) anon0$2_correct)))
(let ((inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon9_Then_correct  (=> (and (and $abort_flag@17 (= $RecoveryAddress_RecoveryAddress_$memory@2 $RecoveryAddress_RecoveryAddress_$memory@1)) (and (= $abort_code@27 $abort_code@26) (= (ControlFlow 0 310668) 310672))) inline$$create_recovery_address_create_recovery_address_$def_verify$0$Abort_correct)))
(let ((inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon8_Then_correct  (=> (and (and $abort_flag@9 (= $RecoveryAddress_RecoveryAddress_$memory@2 $RecoveryAddress_RecoveryAddress_$memory)) (and (= $abort_code@27 $abort_code@15) (= (ControlFlow 0 310676) 310672))) inline$$create_recovery_address_create_recovery_address_$def_verify$0$Abort_correct)))
(let ((inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon9_Else_correct  (=> (not $abort_flag@17) (=> (and (and (= $abort_code@28 $abort_code@26) (= $RecoveryAddress_RecoveryAddress_$memory@3 $RecoveryAddress_RecoveryAddress_$memory@1)) (and (= $abort_flag@18 $abort_flag@17) (= (ControlFlow 0 310664) 310690))) anon0$2_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon65_Else_correct  (=> (and (and (not $abort_flag@16) (= $abort_flag@17 $abort_flag@16)) (and (= $abort_code@26 $abort_code@24) (= $RecoveryAddress_RecoveryAddress_$memory@1 |inline$$MoveToRaw$0$m'@2|))) (and (=> (= (ControlFlow 0 310502) 310668) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 310502) 310664) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$Abort_correct  (=> (= $abort_flag@17 true) (=> (and (= $abort_code@26 $abort_code@25) (= $RecoveryAddress_RecoveryAddress_$memory@1 $RecoveryAddress_RecoveryAddress_$memory@0)) (and (=> (= (ControlFlow 0 308693) 310668) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 308693) 310664) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon9_Else_correct))))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon7_correct  (=> (= $abort_code@25 $abort_code@16) (=> (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 310622) 308693)) inline$$RecoveryAddress_publish_$def$0$Abort_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 310620) 310622)) inline$$RecoveryAddress_publish_$def$0$anon7_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon48_Then_correct  (=> (= (ControlFlow 0 310630) 310622) inline$$RecoveryAddress_publish_$def$0$anon7_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon47_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 310614) 310630) inline$$RecoveryAddress_publish_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 310614) 310620) inline$$RecoveryAddress_publish_$def$0$anon48_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon11_correct  (=> (= $abort_code@25 $abort_code@17) (=> (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 310602) 308693)) inline$$RecoveryAddress_publish_$def$0$Abort_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon50_Else_correct  (=> (and (not true) (= (ControlFlow 0 310600) 310602)) inline$$RecoveryAddress_publish_$def$0$anon11_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon50_Then_correct  (=> (= (ControlFlow 0 310610) 310602) inline$$RecoveryAddress_publish_$def$0$anon11_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon49_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 310594) 310610) inline$$RecoveryAddress_publish_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 310594) 310600) inline$$RecoveryAddress_publish_$def$0$anon50_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon15_correct  (=> (= $abort_code@25 $abort_code@18) (=> (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 310582) 308693)) inline$$RecoveryAddress_publish_$def$0$Abort_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon52_Else_correct  (=> (and (not true) (= (ControlFlow 0 310580) 310582)) inline$$RecoveryAddress_publish_$def$0$anon15_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon52_Then_correct  (=> (= (ControlFlow 0 310590) 310582) inline$$RecoveryAddress_publish_$def$0$anon15_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon51_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 310574) 310590) inline$$RecoveryAddress_publish_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 310574) 310580) inline$$RecoveryAddress_publish_$def$0$anon52_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon25_correct  (=> (= $abort_code@25 $abort_code@20) (=> (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 310558) 308693)) inline$$RecoveryAddress_publish_$def$0$Abort_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 310556) 310558)) inline$$RecoveryAddress_publish_$def$0$anon25_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 310566) 310558) inline$$RecoveryAddress_publish_$def$0$anon25_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon56_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 310550) 310566) inline$$RecoveryAddress_publish_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 310550) 310556) inline$$RecoveryAddress_publish_$def$0$anon57_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon33_correct  (=> (= $abort_code@25 $abort_code@22) (=> (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 310538) 308693)) inline$$RecoveryAddress_publish_$def$0$Abort_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 310536) 310538)) inline$$RecoveryAddress_publish_$def$0$anon33_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon61_Then_correct  (=> (= (ControlFlow 0 310546) 310538) inline$$RecoveryAddress_publish_$def$0$anon33_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon60_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 310530) 310546) inline$$RecoveryAddress_publish_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 310530) 310536) inline$$RecoveryAddress_publish_$def$0$anon61_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon43_correct  (=> (= $abort_code@25 $abort_code@24) (=> (and (= $RecoveryAddress_RecoveryAddress_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 310514) 308693)) inline$$RecoveryAddress_publish_$def$0$Abort_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 310512) 310514)) inline$$RecoveryAddress_publish_$def$0$anon43_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon66_Then_correct  (=> (= (ControlFlow 0 310522) 310514) inline$$RecoveryAddress_publish_$def$0$anon43_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon65_Then_correct  (=> $abort_flag@16 (and (=> (= (ControlFlow 0 310506) 310522) inline$$RecoveryAddress_publish_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 310506) 310512) inline$$RecoveryAddress_publish_$def$0$anon66_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_code@24 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@16 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 310480) 310506) inline$$RecoveryAddress_publish_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 310480) 310502) inline$$RecoveryAddress_publish_$def$0$anon65_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 310478) 310480)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$RecoveryAddress_RecoveryAddress_pack$0$$struct@1))) (= $abort_code@24 $abort_code@22)) (and (= $abort_flag@16 $abort_flag@15) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 310428) 310506) inline$$RecoveryAddress_publish_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 310428) 310502) inline$$RecoveryAddress_publish_$def$0$anon65_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account@@0)) (and (=> (= (ControlFlow 0 310486) 310478) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 310486) 310428) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 310274) (- 0 317632)) true) (=> (= (ControlFlow 0 310274) 310486) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$RecoveryAddress_RecoveryAddress_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 310160) 310274)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$RecoveryAddress_RecoveryAddress_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 310166) 310274) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$RecoveryAddress_RecoveryAddress_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 310154) 310166) inline$$RecoveryAddress_RecoveryAddress_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 310154) 310160) inline$$RecoveryAddress_RecoveryAddress_pack$0$anon4_Else_correct)))))
(let ((inline$$RecoveryAddress_RecoveryAddress_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 310146) 310274)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$RecoveryAddress_RecoveryAddress_pack$0$anon0_correct  (=> (and (and (and ((_ is $Vector) inline$$Vector_singleton_$def$0$$ret0@2) (let ((va@@10 (|v#$Vector| inline$$Vector_singleton_$def$0$$ret0@2)))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (forall ((inline$$RecoveryAddress_RecoveryAddress_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$RecoveryAddress_RecoveryAddress_pack$0$$$0 0) (< inline$$RecoveryAddress_RecoveryAddress_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$Vector_singleton_$def$0$$ret0@2)))) (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_singleton_$def$0$$ret0@2)) inline$$RecoveryAddress_RecoveryAddress_pack$0$$$0)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_singleton_$def$0$$ret0@2)) inline$$RecoveryAddress_RecoveryAddress_pack$0$$$0))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_singleton_$def$0$$ret0@2)) inline$$RecoveryAddress_RecoveryAddress_pack$0$$$0))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_singleton_$def$0$$ret0@2)) inline$$RecoveryAddress_RecoveryAddress_pack$0$$$0))) $DiemAccount_KeyRotationCapability_account_address))) true)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_singleton_$def$0$$ret0@2)) inline$$RecoveryAddress_RecoveryAddress_pack$0$$$0))
))) (= inline$$RecoveryAddress_RecoveryAddress_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Vector_singleton_$def$0$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 310138) 310154) inline$$RecoveryAddress_RecoveryAddress_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 310138) 310146) inline$$RecoveryAddress_RecoveryAddress_pack$0$anon3_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon64_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 310172) 310138)) inline$$RecoveryAddress_RecoveryAddress_pack$0$anon0_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon64_Then_correct  (=> (and (and $abort_flag@15 (= $abort_code@25 $abort_code@22)) (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 310526) 308693))) inline$$RecoveryAddress_publish_$def$0$Abort_correct)))
(let ((inline$$Vector_singleton_$def$0$Abort_correct  (=> (= inline$$Vector_singleton_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@15 true) (= inline$$Vector_singleton_$def$0$$ret0@2 inline$$Vector_singleton_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 309884) 310526) inline$$RecoveryAddress_publish_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 309884) 310172) inline$$RecoveryAddress_publish_$def$0$anon64_Else_correct))))))
(let ((inline$$Vector_singleton_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 309902) 309884)) inline$$Vector_singleton_$def$0$Abort_correct)))
(let ((inline$$Vector_singleton_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 309912) 309884) inline$$Vector_singleton_$def$0$Abort_correct)))
(let ((inline$$Vector_singleton_$def$0$anon14_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 309896) 309912) inline$$Vector_singleton_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 309896) 309902) inline$$Vector_singleton_$def$0$anon15_Else_correct)))))
(let ((inline$$Vector_singleton_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 309876) 309884)) inline$$Vector_singleton_$def$0$Abort_correct)))
(let ((inline$$Vector_singleton_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 309892) 309884) inline$$Vector_singleton_$def$0$Abort_correct)))
(let ((inline$$Vector_singleton_$def$0$anon16_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 309870) 309892) inline$$Vector_singleton_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 309870) 309876) inline$$Vector_singleton_$def$0$anon17_Else_correct)))))
(let ((inline$$Vector_singleton_$def$0$anon12_correct  (=> (and (= $abort_flag@15 $abort_flag@14) (= inline$$Vector_singleton_$def$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2|)) (and (=> (= (ControlFlow 0 309858) 310526) inline$$RecoveryAddress_publish_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 309858) 310172) inline$$RecoveryAddress_publish_$def$0$anon64_Else_correct)))))
(let ((inline$$Vector_singleton_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 309856) 309858)) inline$$Vector_singleton_$def$0$anon12_correct)))
(let ((inline$$Vector_singleton_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 309866) 309858) inline$$Vector_singleton_$def$0$anon12_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 1))) (= |inline$$WritebackToValue$0$vdst'@2| inline$$Vector_empty$0$v@1)) (and (=> (= (ControlFlow 0 309814) 309866) inline$$Vector_singleton_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 309814) 309856) inline$$Vector_singleton_$def$0$anon18_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$1$to'@1|) ($Local 1)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$1$to'@1|) 0 inline$$Vector_empty$0$v@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1|))) (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|)) (and (=> (= (ControlFlow 0 309840) 309866) inline$$Vector_singleton_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 309840) 309856) inline$$Vector_singleton_$def$0$anon18_Else_correct))))))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|p#$Mutation| inline$$BorrowLoc$0$dst@1) |inline$$Vector_push_back$0$v'@1|)) (and (=> (= (ControlFlow 0 309715) 309840) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 309715) 309814) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$Vector_singleton_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@14) (= (ControlFlow 0 309721) 309715)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$1$v@1) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) len@@0 inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2) (+ len@@0 1)))))) (and (=> (= (ControlFlow 0 309650) 309870) inline$$Vector_singleton_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 309650) 309721) inline$$Vector_singleton_$def$0$anon16_Else_correct)))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowLoc$0$dst@1)) (= (ControlFlow 0 309587) 309650)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 1) $EmptyPath inline$$Vector_empty$0$v@1)) (= (ControlFlow 0 309549) 309587)) inline$$ReadRef$1$anon0_correct)))
(let ((inline$$Vector_singleton_$def$0$anon14_Else_correct  (=> (and (not $abort_flag@14) (= (ControlFlow 0 309555) 309549)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 309487) 309896) inline$$Vector_singleton_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 309487) 309555) inline$$Vector_singleton_$def$0$anon14_Else_correct)))))
(let ((inline$$Vector_singleton_$def$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 309424) 309487)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$Vector_singleton_$def$0$anon13_Then_correct  (=> (= (ControlFlow 0 309920) 309487) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$Vector_singleton_$def$0$anon0_correct  (=> (not $abort_flag@14) (and (=> (= (ControlFlow 0 309418) 309920) inline$$Vector_singleton_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 309418) 309424) inline$$Vector_singleton_$def$0$anon13_Else_correct)))))
(let ((inline$$Vector_singleton$0$Entry_correct  (=> (and (= inline$$Vector_singleton$0$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (= (ControlFlow 0 309180) 309418)) inline$$Vector_singleton_$def$0$anon0_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon62_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 309934) 309180)) inline$$Vector_singleton$0$Entry_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon38_correct  (=> (= $abort_code@25 $abort_code@23) (=> (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 309130) 308693)) inline$$RecoveryAddress_publish_$def$0$Abort_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 309128) 309130)) inline$$RecoveryAddress_publish_$def$0$anon38_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon63_Then_correct  (=> (= (ControlFlow 0 309138) 309130) inline$$RecoveryAddress_publish_$def$0$anon38_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon62_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= $abort_code@23 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 309122) 309138) inline$$RecoveryAddress_publish_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 309122) 309128) inline$$RecoveryAddress_publish_$def$0$anon63_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon60_Else_correct  (=> (not $abort_flag@14) (and (=> (= (ControlFlow 0 309110) 309934) inline$$RecoveryAddress_publish_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 309110) 309122) inline$$RecoveryAddress_publish_$def$0$anon62_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon58_Then$1_correct  (=> (and (and (and (= inline$$RecoveryAddress_publish_$def$0$$t20@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@14)) (and (=> $abort_flag@14 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 309104) 310530) inline$$RecoveryAddress_publish_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 309104) 309110) inline$$RecoveryAddress_publish_$def$0$anon60_Else_correct)))))
(let ((inline$$Not$1$anon0_correct  (=> (and (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$RecoveryAddress_publish_$def$0$$t18@1)))) (= (ControlFlow 0 309092) 309104)) inline$$RecoveryAddress_publish_$def$0$anon58_Then$1_correct)))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 309082) (- 0 317093)) true) (=> (= (ControlFlow 0 309082) 309092) inline$$Not$1$anon0_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon58_Then_correct  (=> (|b#$Boolean| inline$$RecoveryAddress_publish_$def$0$$t15@1) (=> (and (= inline$$RecoveryAddress_publish_$def$0$$t18@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@0)))) (= (ControlFlow 0 309098) 309082)) inline$$Not$1$Entry_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon30_correct  (=> (= $abort_code@25 $abort_code@21) (=> (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 309028) 308693)) inline$$RecoveryAddress_publish_$def$0$Abort_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 309026) 309028)) inline$$RecoveryAddress_publish_$def$0$anon30_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon59_Then_correct  (=> (= (ControlFlow 0 309036) 309028) inline$$RecoveryAddress_publish_$def$0$anon30_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon58_Else_correct  (=> (and (not (|b#$Boolean| inline$$RecoveryAddress_publish_$def$0$$t15@1)) (= $abort_code@21 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 309020) 309036) inline$$RecoveryAddress_publish_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 309020) 309026) inline$$RecoveryAddress_publish_$def$0$anon59_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon56_Else_correct  (=> (not $abort_flag@13) (and (=> (= (ControlFlow 0 309008) 309098) inline$$RecoveryAddress_publish_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 309008) 309020) inline$$RecoveryAddress_publish_$def$0$anon58_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon55_Else_correct  (=> (and (not $abort_flag@12) (= inline$$RecoveryAddress_publish_$def$0$$t15@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$1$dst@1 call3formal@$ret0@0@@0)))) (=> (and (and (and (= inline$$RecoveryAddress_publish_$def$0$$t16@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@13)) (and (=> $abort_flag@13 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 309002) 310550) inline$$RecoveryAddress_publish_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 309002) 309008) inline$$RecoveryAddress_publish_$def$0$anon56_Else_correct))))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon55_Then_correct  (=> (and (and $abort_flag@12 (= $abort_code@25 $abort_code@18)) (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 310570) 308693))) inline$$RecoveryAddress_publish_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_key_rotation_capability_address_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308950) 310570) inline$$RecoveryAddress_publish_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 308950) 309002) inline$$RecoveryAddress_publish_$def$0$anon55_Else_correct)))))
(let ((inline$$DiemAccount_key_rotation_capability_address_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 308960) 310570) inline$$RecoveryAddress_publish_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 308960) 309002) inline$$RecoveryAddress_publish_$def$0$anon55_Else_correct))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address)) (and (=> (= (ControlFlow 0 308934) 308960) inline$$DiemAccount_key_rotation_capability_address_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 308934) 308950) inline$$DiemAccount_key_rotation_capability_address_$def$0$anon6_Else_correct)))))
(let ((inline$$DiemAccount_key_rotation_capability_address_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 308858) 308934)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$DiemAccount_key_rotation_capability_address_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 308968) 308934) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$DiemAccount_key_rotation_capability_address_$def$0$anon0_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 308852) 308968) inline$$DiemAccount_key_rotation_capability_address_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 308852) 308858) inline$$DiemAccount_key_rotation_capability_address_$def$0$anon5_Else_correct)))))
(let ((inline$$DiemAccount_key_rotation_capability_address$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2) (let ((va@@12 (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address))) true) (= (ControlFlow 0 308974) 308852)) inline$$DiemAccount_key_rotation_capability_address_$def$0$anon0_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon53_Then_correct  (=> (and (|b#$Boolean| call3formal@$ret0@0@@2) (= (ControlFlow 0 308982) 308974)) inline$$DiemAccount_key_rotation_capability_address$0$anon0_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon20_correct  (=> (= $abort_code@25 $abort_code@19) (=> (and (= $RecoveryAddress_RecoveryAddress_$memory@0 $RecoveryAddress_RecoveryAddress_$memory) (= (ControlFlow 0 308689) 308693)) inline$$RecoveryAddress_publish_$def$0$Abort_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 308687) 308689)) inline$$RecoveryAddress_publish_$def$0$anon20_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon54_Then_correct  (=> (= (ControlFlow 0 308701) 308689) inline$$RecoveryAddress_publish_$def$0$anon20_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon53_Else_correct  (=> (and (not (|b#$Boolean| call3formal@$ret0@0@@2)) (= $abort_code@19 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 308681) 308701) inline$$RecoveryAddress_publish_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 308681) 308687) inline$$RecoveryAddress_publish_$def$0$anon54_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon51_Else_correct  (=> (not $abort_flag@12) (and (=> (= (ControlFlow 0 308669) 308982) inline$$RecoveryAddress_publish_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 308669) 308681) inline$$RecoveryAddress_publish_$def$0$anon53_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon49_Else_correct  (=> (not $abort_flag@11) (=> (and (and (and (= inline$$RecoveryAddress_publish_$def$0$$t12@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@12)) (and (=> $abort_flag@12 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 308663) 310574) inline$$RecoveryAddress_publish_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 308663) 308669) inline$$RecoveryAddress_publish_$def$0$anon51_Else_correct))))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon47_Else_correct  (=> (not $abort_flag@10) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11) (=> $abort_flag@11 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@0)))))))))) ((_ is $Boolean) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 308653) 310594) inline$$RecoveryAddress_publish_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 308653) 308663) inline$$RecoveryAddress_publish_$def$0$anon49_Else_correct))))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@10) (=> $abort_flag@10 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 308647) 310614) inline$$RecoveryAddress_publish_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 308647) 308653) inline$$RecoveryAddress_publish_$def$0$anon47_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 308577) 308647)) inline$$RecoveryAddress_publish_$def$0$anon4$2_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 310638) 308647) inline$$RecoveryAddress_publish_$def$0$anon4$2_correct)))
(let ((inline$$RecoveryAddress_publish_$def$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308569) 310638) inline$$RecoveryAddress_publish_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 308569) 308577) inline$$RecoveryAddress_publish_$def$0$anon46_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 310646) 310638) inline$$RecoveryAddress_publish_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 310646) 308577) inline$$RecoveryAddress_publish_$def$0$anon46_Else_correct))))
(let ((inline$$RecoveryAddress_publish_$def$0$anon0_correct  (=> (not $abort_flag@9) (and (=> (= (ControlFlow 0 308563) 310646) inline$$RecoveryAddress_publish_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 308563) 308569) inline$$RecoveryAddress_publish_$def$0$anon45_Else_correct)))))
(let ((inline$$RecoveryAddress_publish_$direct_inter$0$anon0_correct  (=> ((_ is $Address) account@@0) (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2) (let ((va@@13 (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2)) $DiemAccount_KeyRotationCapability_account_address))) true) (= (ControlFlow 0 310650) 308563)) inline$$RecoveryAddress_publish_$def$0$anon0_correct))))
(let ((inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon8_Else_correct  (=> (and (not $abort_flag@9) (= (ControlFlow 0 310656) 310650)) inline$$RecoveryAddress_publish_$direct_inter$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct  (=> (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 call4formal@$ret0@0) (= $abort_flag@9 $abort_flag@8)) (and (= $abort_code@15 $abort_code@13) (= $DiemAccount_DiemAccount_$memory@0 |inline$$WritebackToGlobal$0$m'@2|))) (and (=> (= (ControlFlow 0 307663) 310676) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 307663) 310656) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 307661) 307663)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct  (=> (= (ControlFlow 0 307671) 307663) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon38_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (= |inline$$WritebackToGlobal$0$m'@2| $DiemAccount_DiemAccount_$memory)) (and (=> (= (ControlFlow 0 307591) 307671) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 307591) 307661) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1))) (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|))) (and (=> (= (ControlFlow 0 307645) 307671) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 307645) 307661) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon57_Else_correct))))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 307581) 307645) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 307581) 307591) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 307459) 307581)) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 307380) 307459)) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 307436) 307459))) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 307344) 307436) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 307344) 307380) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 307203) (- 0 316129)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$pack_ref$0$$after@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (= (ControlFlow 0 307203) 307344) inline$$WritebackToReference$0$anon0_correct)))))
(let ((inline$$Option_Option_$pack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$pack_ref$0$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WriteRef$0$to'@1|)) (= (ControlFlow 0 307179) 307203)) inline$$Option_Option_$pack_ref$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Else_correct  (=> (and (not true) (= (ControlFlow 0 307133) 307179)) inline$$Option_Option_$pack_ref$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Then_correct  (=> (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 307681) 307179)) inline$$Option_Option_$pack_ref$0$Entry_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) call5formal@$ret1@0)) (and (=> (= (ControlFlow 0 307119) 307681) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 307119) 307133) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon56_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 307125) 307119)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct  (=> (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@2 inline$$DiemAccount_extract_key_rotation_capability_$def$0$$ret0@1) (= $abort_flag@9 true)) (and (= $abort_code@15 $abort_code@14) (= $DiemAccount_DiemAccount_$memory@0 $DiemAccount_DiemAccount_$memory))) (and (=> (= (ControlFlow 0 306318) 310676) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 306318) 310656) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon8_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon5_correct  (=> (and (= $abort_code@14 $abort_code@1) (= (ControlFlow 0 307781) 306318)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 307779) 307781)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Then_correct  (=> (= (ControlFlow 0 307789) 307781) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon5_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 307773) 307789) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 307773) 307779) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon41_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon11_correct  (=> (and (= $abort_code@14 $abort_code@8) (= (ControlFlow 0 307757) 306318)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 307755) 307757)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Then_correct  (=> (= (ControlFlow 0 307765) 307757) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 307749) 307765) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Then_correct) (=> (= (ControlFlow 0 307749) 307755) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon44_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon21_correct  (=> (and (= $abort_code@14 $abort_code@10) (= (ControlFlow 0 307733) 306318)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 307731) 307733)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Then_correct  (=> (= (ControlFlow 0 307741) 307733) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon21_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 307725) 307741) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 307725) 307731) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon49_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon29_correct  (=> (and (= $abort_code@14 $abort_code@12) (= (ControlFlow 0 307713) 306318)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 307711) 307713)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon29_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Then_correct  (=> (= (ControlFlow 0 307721) 307713) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon29_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 307705) 307721) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 307705) 307711) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon53_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon33_correct  (=> (and (= $abort_code@14 $abort_code@13) (= (ControlFlow 0 307693) 306318)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 307691) 307693)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 307701) 307693) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon33_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 307685) 307701) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 307685) 307691) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon55_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else$4_correct  (and (=> (= (ControlFlow 0 307062) (- 0 315965)) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (=> (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (=> (and (= call0formal@$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec)) ($Integer 0)))) $abort_flag@8)) (=> (and (and (=> $abort_flag@8 (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec)) ($Integer 0))))) (=> $abort_flag@8 (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec)) ($Integer 0)))) (= $abort_code@13 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 ($Vector_$borrow call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Option_Option_vec) ($Integer 0)))))) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec)) ($Integer 0))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret1@0) (let ((va@@14 (|v#$Vector| call5formal@$ret1@0)))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 307062) 307685) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 307062) 307125) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon54_Else_correct)))))))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 307050) 307062)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else$4_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$anon0_correct  (=> (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Option_Option_$unpack_ref$0$$before@0)) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (= (ControlFlow 0 307014) 307050)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$Option_Option_$unpack_ref$0$Entry_correct  (=> (= inline$$Option_Option_$unpack_ref$0$$tv0@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (= inline$$Option_Option_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 307008) 307014)) inline$$Option_Option_$unpack_ref$0$anon0_correct))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemAccount_DiemAccount_key_rotation_capability) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemAccount_DiemAccount_key_rotation_capability))) (= (ControlFlow 0 306974) 307008))) inline$$Option_Option_$unpack_ref$0$Entry_correct))))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 306852) 306974)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 306846) 306852)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 306856) 306846)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_code@12 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 306813) 307705) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 306813) 306856) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 306811) 306813)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_code@12 $abort_code@10)) (and (= $abort_flag@7 $abort_flag@6) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 306759) 307705) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 306759) 306856) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon52_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@4)) (and (=> (= (ControlFlow 0 306729) 306811) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 306729) 306759) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 306723) (- 0 315748)) true) (=> (= (ControlFlow 0 306723) 306729) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$1$$t2@1) (= (ControlFlow 0 306819) 306723)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon26_correct  (=> (and (= $abort_code@14 $abort_code@11) (= (ControlFlow 0 306610) 306318)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 306608) 306610)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon26_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 306618) 306610) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon26_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$1$$t2@1)) (= $abort_code@11 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 306602) 306618) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 306602) 306608) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon51_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Else_correct  (=> (not $abort_flag@6) (and (=> (= (ControlFlow 0 306590) 306819) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 306590) 306602) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon50_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct  (=> (not $abort_flag@5) (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t13@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6)) (and (=> $abort_flag@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 306584) 307725) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 306584) 306590) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon48_Else_correct))))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct  (=> $abort_flag@5 (=> (and (= $abort_code@14 $abort_code@8) (= (ControlFlow 0 307745) 306318)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306540) 307745) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 306540) 306584) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon6_Then_correct  (and (=> (= (ControlFlow 0 306550) 307745) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 306550) 306584) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon47_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$1$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4)))) (and (=> (= (ControlFlow 0 306534) 306550) inline$$DiemAccount_exists_at_$def$1$anon6_Then_correct) (=> (= (ControlFlow 0 306534) 306540) inline$$DiemAccount_exists_at_$def$1$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 306488) 306534)) inline$$DiemAccount_exists_at_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$1$anon5_Then_correct  (=> (= (ControlFlow 0 306558) 306534) inline$$DiemAccount_exists_at_$def$1$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$1$anon0_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 306482) 306558) inline$$DiemAccount_exists_at_$def$1$anon5_Then_correct) (=> (= (ControlFlow 0 306482) 306488) inline$$DiemAccount_exists_at_$def$1$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$1$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@4) (= (ControlFlow 0 306564) 306482)) inline$$DiemAccount_exists_at_$def$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 306572) 306564)) inline$$DiemAccount_exists_at$1$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon16_correct  (=> (and (= $abort_code@14 $abort_code@9) (= (ControlFlow 0 306312) 306318)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 306310) 306312)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Then_correct  (=> (= (ControlFlow 0 306326) 306312) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon16_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@9 (|i#$Integer| call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 306304) 306326) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 306304) 306310) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Else_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 306292) 306572) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 306292) 306304) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_extract_key_rotation_capability_$def$0$$t10@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5)) (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@6) (>= (|i#$Integer| call3formal@$ret0@0@@6) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@6) $MAX_U64))) (and (=> (= (ControlFlow 0 306286) 307749) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Then_correct) (=> (= (ControlFlow 0 306286) 306292) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon43_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2)))) (= (ControlFlow 0 306274) 306286)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 306264) (- 0 315445)) true) (=> (= (ControlFlow 0 306264) 306274) inline$$Not$0$anon0_correct))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 306280) 306264)) inline$$Not$0$Entry_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct  (=> $abort_flag@4 (=> (and (= $abort_code@14 $abort_code@7) (= (ControlFlow 0 307769) 306318)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct  (=> (= $abort_code@7 $abort_code@5) (=> (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 call4formal@$ret0@0@@0) (= $abort_flag@4 $abort_flag@3)) (and (=> (= (ControlFlow 0 306130) 307769) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 306130) 306280) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 306128) 306130)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Then_correct  (=> (= (ControlFlow 0 306138) 306130) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon22_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Else_correct  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 306122) 306138) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 306122) 306128) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct  (=> (and (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1 $Error) (= $abort_code@7 $abort_code@6)) (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@2 inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$ret0@1) (= $abort_flag@4 true))) (and (=> (= (ControlFlow 0 305871) 307769) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 305871) 306280) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon42_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon7_correct  (=> (and (= $abort_code@6 $abort_code@2) (= (ControlFlow 0 306190) 305871)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 306188) 306190)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 306198) 306190) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon7_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 306182) 306198) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 306182) 306188) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon26_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon15_correct  (=> (and (= $abort_code@6 $abort_code@4) (= (ControlFlow 0 306170) 305871)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 306168) 306170)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon15_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 306178) 306170) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon15_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 306162) 306178) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 306162) 306168) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon19_correct  (=> (and (= $abort_code@6 $abort_code@5) (= (ControlFlow 0 306150) 305871)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 306148) 306150)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 306158) 306150) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 306142) 306158) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 306142) 306148) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else$1_correct  (=> (= call0formal@$tv0@0@@0 $DiemAccount_KeyRotationCapability_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3) (=> $abort_flag@3 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 ($Boolean ($IsEqual_stratified ($Vector_$length call0formal@$tv0@0@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1)) $Option_Option_vec)) ($Integer 0))))))) ((_ is $Boolean) call4formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 306114) 306142) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 306114) 306122) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon31_Else_correct))))))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (and (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $DiemAccount_DiemAccount_key_rotation_capability)) (= (ControlFlow 0 306106) 306114)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else$1_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct  (=> (and (not $abort_flag@2) (= (ControlFlow 0 306112) 306106)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@2 true) (=> (and (= $abort_code@4 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 306052) 306162) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 306052) 306112) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 306050) 306052)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4))) (= $abort_flag@2 $abort_flag@1)) (and (= $abort_code@4 $abort_code@2) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 305998) 306162) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 305998) 306112) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon29_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| call3formal@$ret0@0@@4)) (and (=> (= (ControlFlow 0 305980) 306050) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 305980) 305998) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 305974) (- 0 315160)) true) (=> (= (ControlFlow 0 305974) 305980) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1) (= (ControlFlow 0 306058) 305974)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon12_correct  (=> (and (= $abort_code@6 $abort_code@3) (= (ControlFlow 0 305865) 305871)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 305863) 305865)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon12_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 305879) 305865) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon12_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1)) (= $abort_code@3 (|i#$Integer| call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 305857) 305879) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 305857) 305863) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon28_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 305845) 306058) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 305845) 305857) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon27_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct  (=> (not $abort_flag@0) (=> (and (and (and (= inline$$DiemAccount_delegated_key_rotation_capability_$def$0$$t5@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 305839) 306182) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 305839) 305845) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon25_Else_correct))))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct  (=> $abort_flag@0 (=> (and (= $abort_code@6 $abort_code@1) (= (ControlFlow 0 306202) 305871)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 305795) 306202) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 305795) 305839) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 305805) 306202) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 305805) 305839) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon24_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@4)))) (and (=> (= (ControlFlow 0 305789) 305805) inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 305789) 305795) inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 305743) 305789)) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 305813) 305789) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon0_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 305737) 305813) inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 305737) 305743) inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@4) (= (ControlFlow 0 305819) 305737)) inline$$DiemAccount_exists_at_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 305551) 305819)) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 306210) 305819) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon0_correct  (=> (not $abort_flag@0) (and (=> (= (ControlFlow 0 305545) 306210) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 305545) 305551) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon23_Else_correct)))))
(let ((inline$$DiemAccount_delegated_key_rotation_capability$0$anon0_correct  (=> (and ((_ is $Address) call3formal@$ret0@0@@4) (= (ControlFlow 0 306216) 305545)) inline$$DiemAccount_delegated_key_rotation_capability_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Else_correct  (=> (and (not $abort_flag@0) (= (ControlFlow 0 306224) 306216)) inline$$DiemAccount_delegated_key_rotation_capability$0$anon0_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0) (=> $abort_flag@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 305135) 307773) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 305135) 306224) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon40_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 305099) 305135)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Then_correct  (=> (= (ControlFlow 0 307797) 305135) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 305093) 307797) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 305093) 305099) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon39_Else_correct)))))
(let ((inline$$DiemAccount_extract_key_rotation_capability_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 307803) 305093)) inline$$DiemAccount_extract_key_rotation_capability_$def$0$anon0_correct)))
(let ((inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon7_Else_correct  (=> (and (not true) (= (ControlFlow 0 304389) 307803)) inline$$DiemAccount_extract_key_rotation_capability_$direct_inter$0$anon0_correct)))
(let ((inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon7_Then_correct  (=> (= (ControlFlow 0 310684) 307803) inline$$DiemAccount_extract_key_rotation_capability_$direct_inter$0$anon0_correct)))
(let ((inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 304383) 310684) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 304383) 304389) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon7_Else_correct)))))
(let ((anon0$1_correct  (=> (forall (($inv_addr Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr)) (let ((va@@16 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $Option_Option_vec)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $Option_Option_vec))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr))
)) (=> (and (and (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@18 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@0))
)) (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@19 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@1))
))) (and (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_authentication_key))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_authentication_key))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_authentication_key))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_authentication_key))) $$0@@1))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@23 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@24 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@2))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@28 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@2))
)) (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@3))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_KeyRotationCapability_account_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_KeyRotationCapability_$memory) $EmptyTypeValueArray $inv_addr@@3))
)))) (=> (and (and (and (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps)) (let ((va@@32 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps))) $$0@@4)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps))) $$0@@4))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps))) $$0@@4))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps))) $$0@@4))) $DiemAccount_KeyRotationCapability_account_address)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps))) $$0@@4))
))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))) $RecoveryAddress_RecoveryAddress_rotation_caps))) $$0@@5))
))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RecoveryAddress_RecoveryAddress_$memory) $EmptyTypeValueArray $inv_addr@@4))
)) (|b#$Boolean| ($Boolean (forall ((child_addr T@$Value) )  (=> ((_ is $Address) child_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr T@$Value) )  (=> ((_ is $Address) addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))))))))))) (and (|b#$Boolean| (let ((addr@@3 account@@0))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (= (ControlFlow 0 310688) 304383)))) inline$$create_recovery_address_create_recovery_address_$def_verify$0$anon0_correct)))))
(let ((anon0_correct  (=> (and ((_ is $Address) account@@0) (= (ControlFlow 0 303838) 310688)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 312399) 303838) anon0_correct)))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
